/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode)
          || GET_MODE (x3) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVM8HFmode))
        return -1;
      return 3;

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM4HFmode))
        return -1;
      return 4;

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM2HFmode))
        return -1;
      return 5;

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM1HFmode))
        return -1;
      return 6;

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF2HFmode))
        return -1;
      return 7;

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF4HFmode))
        return -1;
      return 8;

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM8SFmode))
        return -1;
      return 9;

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 10;

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM2SFmode))
        return -1;
      return 11;

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM1SFmode))
        return -1;
      return 12;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 13;

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 14;

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM4DFmode))
        return -1;
      return 15;

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM2DFmode))
        return -1;
      return 16;

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 17;

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[1], E_V1HFmode))
        return -1;
      return 18;

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode))
        return -1;
      return 19;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 20;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 21;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode))
        return -1;
      return 22;

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode))
        return -1;
      return 23;

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode))
        return -1;
      return 24;

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[1], E_V128HFmode))
        return -1;
      return 25;

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[1], E_V256HFmode))
        return -1;
      return 26;

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[1], E_V512HFmode))
        return -1;
      return 27;

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024HFmode))
        return -1;
      return 28;

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || GET_MODE (x3) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048HFmode))
        return -1;
      return 29;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode))
        return -1;
      return 30;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 31;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 32;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 33;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode))
        return -1;
      return 34;

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode))
        return -1;
      return 35;

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode))
        return -1;
      return 36;

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[1], E_V128SFmode))
        return -1;
      return 37;

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[1], E_V256SFmode))
        return -1;
      return 38;

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[1], E_V512SFmode))
        return -1;
      return 39;

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024SFmode))
        return -1;
      return 40;

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode))
        return -1;
      return 41;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 42;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 43;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode))
        return -1;
      return 44;

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode))
        return -1;
      return 45;

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode))
        return -1;
      return 46;

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode))
        return -1;
      return 47;

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[1], E_V128DFmode))
        return -1;
      return 48;

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[1], E_V256DFmode))
        return -1;
      return 49;

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[1], E_V512DFmode))
        return -1;
      return 50;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1, rtx_code i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 5
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 6
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 7
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x12) != i1)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 10
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 11
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x16) != i1)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 12
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 13
      || GET_MODE (x19) != E_SImode)
    return -1;
  x20 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x20) != i1)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 14
      || GET_MODE (x21) != E_SImode)
    return -1;
  x22 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x22) != i1)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 15
      || GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 16
      || GET_MODE (x25) != E_SImode)
    return -1;
  x26 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x26) != i1)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 17
      || GET_MODE (x27) != E_SImode)
    return -1;
  x28 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 28
      || GET_MODE (x29) != E_SImode)
    return -1;
  x30 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x30) != i1)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 29
      || GET_MODE (x31) != E_SImode)
    return -1;
  x32 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x32) != i1)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 30
      || GET_MODE (x33) != E_SImode)
    return -1;
  x34 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != 31
      || GET_MODE (x35) != E_SImode)
    return -1;
  return 0;
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern0 (x1, 
E_RVVM8QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern0 (x1, 
E_RVVM4QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern0 (x1, 
E_RVVM2QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern0 (x1, 
E_RVVM1QImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern0 (x1, 
E_RVVM8HImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern0 (x1, 
E_RVVM4HImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern0 (x1, 
E_RVVM2HImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern0 (x1, 
E_RVVM1HImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern0 (x1, 
E_RVVM8SImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern0 (x1, 
E_RVVM4SImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern0 (x1, 
E_RVVM2SImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern0 (x1, 
E_RVVM1SImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern0 (x1, 
E_RVVM8DImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern0 (x1, 
E_RVVM4DImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern0 (x1, 
E_RVVM2DImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern0 (x1, 
E_RVVM1DImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern0 (x1, 
E_RVVMF2QImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern0 (x1, 
E_RVVMF4QImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern0 (x1, 
E_RVVMF8QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern0 (x1, 
E_RVVMF2HImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern0 (x1, 
E_RVVMF4HImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern0 (x1, 
E_RVVMF2SImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern0 (x1, 
E_V1QImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern0 (x1, 
E_V32QImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern0 (x1, 
E_V64QImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern0 (x1, 
E_V128QImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern0 (x1, 
E_V256QImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern0 (x1, 
E_V512QImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern0 (x1, 
E_V1024QImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern0 (x1, 
E_V2048QImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern0 (x1, 
E_V4096QImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern0 (x1, 
E_V16HImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern0 (x1, 
E_V32HImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern0 (x1, 
E_V64HImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern0 (x1, 
E_V128HImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern0 (x1, 
E_V256HImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern0 (x1, 
E_V512HImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern0 (x1, 
E_V1024HImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern0 (x1, 
E_V2048HImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern0 (x1, 
E_V8SImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern0 (x1, 
E_V16SImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern0 (x1, 
E_V32SImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern0 (x1, 
E_V64SImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern0 (x1, 
E_V128SImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern0 (x1, 
E_V256SImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern0 (x1, 
E_V512SImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern0 (x1, 
E_V1024SImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern0 (x1, 
E_V4DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern0 (x1, 
E_V8DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern0 (x1, 
E_V16DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern0 (x1, 
E_V32DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern0 (x1, 
E_V64DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern0 (x1, 
E_V128DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern0 (x1, 
E_V256DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern0 (x1, 
E_V512DImode) != 0)
        return -1;
      return 67;

    case E_RVVM8HFmode:
      if (pattern0 (x1, 
E_RVVM8HFmode) != 0)
        return -1;
      return 68;

    case E_RVVM4HFmode:
      if (pattern0 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 69;

    case E_RVVM2HFmode:
      if (pattern0 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 70;

    case E_RVVM1HFmode:
      if (pattern0 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 71;

    case E_RVVMF2HFmode:
      if (pattern0 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 72;

    case E_RVVMF4HFmode:
      if (pattern0 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM8SFmode:
      if (pattern0 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 74;

    case E_RVVM4SFmode:
      if (pattern0 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 75;

    case E_RVVM2SFmode:
      if (pattern0 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 76;

    case E_RVVM1SFmode:
      if (pattern0 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF2SFmode:
      if (pattern0 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8DFmode:
      if (pattern0 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4DFmode:
      if (pattern0 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2DFmode:
      if (pattern0 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1DFmode:
      if (pattern0 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 82;

    case E_V1HFmode:
      if (pattern0 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 83;

    case E_V2HFmode:
      if (pattern0 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 84;

    case E_V4HFmode:
      if (pattern0 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 85;

    case E_V8HFmode:
      if (pattern0 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 86;

    case E_V16HFmode:
      if (pattern0 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 87;

    case E_V32HFmode:
      if (pattern0 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 88;

    case E_V64HFmode:
      if (pattern0 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 89;

    case E_V128HFmode:
      if (pattern0 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 90;

    case E_V256HFmode:
      if (pattern0 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 91;

    case E_V512HFmode:
      if (pattern0 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 92;

    case E_V1024HFmode:
      if (pattern0 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 93;

    case E_V2048HFmode:
      if (pattern0 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 94;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 95;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 96;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 97;

    case E_V8SFmode:
      if (pattern0 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 98;

    case E_V16SFmode:
      if (pattern0 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 99;

    case E_V32SFmode:
      if (pattern0 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 100;

    case E_V64SFmode:
      if (pattern0 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 101;

    case E_V128SFmode:
      if (pattern0 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 102;

    case E_V256SFmode:
      if (pattern0 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 103;

    case E_V512SFmode:
      if (pattern0 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 104;

    case E_V1024SFmode:
      if (pattern0 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 105;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 106;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 107;

    case E_V4DFmode:
      if (pattern0 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 108;

    case E_V8DFmode:
      if (pattern0 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 109;

    case E_V16DFmode:
      if (pattern0 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 110;

    case E_V32DFmode:
      if (pattern0 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 111;

    case E_V64DFmode:
      if (pattern0 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 112;

    case E_V128DFmode:
      if (pattern0 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 113;

    case E_V256DFmode:
      if (pattern0 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 114;

    case E_V512DFmode:
      if (pattern0 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 115;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !csr_operand (operands[2], i3))
    return -1;
  return 0;
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      return pattern153 (x1); /* [-1, 47] */

    case ZERO_EXTEND:
      res = pattern153 (x1);
      if (res >= 0)
        return res + 48; /* [48, 95] */
      return -1;

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4QImode:
          if (pattern154 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_HImode) != 0)
            return -1;
          return 96;

        case E_RVVM2QImode:
          if (pattern154 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_HImode) != 0)
            return -1;
          return 97;

        case E_RVVM1QImode:
          if (pattern154 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_HImode) != 0)
            return -1;
          return 98;

        case E_RVVMF2QImode:
          if (pattern154 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_HImode) != 0)
            return -1;
          return 99;

        case E_RVVMF4QImode:
          if (pattern154 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_HImode) != 0)
            return -1;
          return 100;

        case E_RVVMF8QImode:
          if (pattern154 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_HImode) != 0)
            return -1;
          return 101;

        case E_RVVM4HImode:
          if (pattern154 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_SImode) != 0)
            return -1;
          return 102;

        case E_RVVM2HImode:
          if (pattern154 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_SImode) != 0)
            return -1;
          return 103;

        case E_RVVM1HImode:
          if (pattern154 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_SImode) != 0)
            return -1;
          return 104;

        case E_RVVMF2HImode:
          if (pattern154 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_SImode) != 0)
            return -1;
          return 105;

        case E_RVVMF4HImode:
          if (pattern154 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_SImode) != 0)
            return -1;
          return 106;

        case E_RVVM4SImode:
          if (pattern154 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_DImode) != 0)
            return -1;
          return 107;

        case E_RVVM2SImode:
          if (pattern154 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_DImode) != 0)
            return -1;
          return 108;

        case E_RVVM1SImode:
          if (pattern154 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_DImode) != 0)
            return -1;
          return 109;

        case E_RVVMF2SImode:
          if (pattern154 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_DImode) != 0)
            return -1;
          return 110;

        case E_V1QImode:
          if (pattern154 (x1, 
E_V1HImode, 
E_V1QImode, 
E_HImode) != 0)
            return -1;
          return 111;

        case E_V2QImode:
          if (pattern154 (x1, 
E_V2HImode, 
E_V2QImode, 
E_HImode) != 0)
            return -1;
          return 112;

        case E_V4QImode:
          if (pattern154 (x1, 
E_V4HImode, 
E_V4QImode, 
E_HImode) != 0)
            return -1;
          return 113;

        case E_V8QImode:
          if (pattern154 (x1, 
E_V8HImode, 
E_V8QImode, 
E_HImode) != 0)
            return -1;
          return 114;

        case E_V16QImode:
          if (pattern154 (x1, 
E_V16HImode, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 115;

        case E_V32QImode:
          if (pattern154 (x1, 
E_V32HImode, 
E_V32QImode, 
E_HImode) != 0)
            return -1;
          return 116;

        case E_V64QImode:
          if (pattern154 (x1, 
E_V64HImode, 
E_V64QImode, 
E_HImode) != 0)
            return -1;
          return 117;

        case E_V128QImode:
          if (pattern154 (x1, 
E_V128HImode, 
E_V128QImode, 
E_HImode) != 0)
            return -1;
          return 118;

        case E_V256QImode:
          if (pattern154 (x1, 
E_V256HImode, 
E_V256QImode, 
E_HImode) != 0)
            return -1;
          return 119;

        case E_V512QImode:
          if (pattern154 (x1, 
E_V512HImode, 
E_V512QImode, 
E_HImode) != 0)
            return -1;
          return 120;

        case E_V1024QImode:
          if (pattern154 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_HImode) != 0)
            return -1;
          return 121;

        case E_V2048QImode:
          if (pattern154 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_HImode) != 0)
            return -1;
          return 122;

        case E_V1HImode:
          if (pattern154 (x1, 
E_V1SImode, 
E_V1HImode, 
E_SImode) != 0)
            return -1;
          return 123;

        case E_V2HImode:
          if (pattern154 (x1, 
E_V2SImode, 
E_V2HImode, 
E_SImode) != 0)
            return -1;
          return 124;

        case E_V4HImode:
          if (pattern154 (x1, 
E_V4SImode, 
E_V4HImode, 
E_SImode) != 0)
            return -1;
          return 125;

        case E_V8HImode:
          if (pattern154 (x1, 
E_V8SImode, 
E_V8HImode, 
E_SImode) != 0)
            return -1;
          return 126;

        case E_V16HImode:
          if (pattern154 (x1, 
E_V16SImode, 
E_V16HImode, 
E_SImode) != 0)
            return -1;
          return 127;

        case E_V32HImode:
          if (pattern154 (x1, 
E_V32SImode, 
E_V32HImode, 
E_SImode) != 0)
            return -1;
          return 128;

        case E_V64HImode:
          if (pattern154 (x1, 
E_V64SImode, 
E_V64HImode, 
E_SImode) != 0)
            return -1;
          return 129;

        case E_V128HImode:
          if (pattern154 (x1, 
E_V128SImode, 
E_V128HImode, 
E_SImode) != 0)
            return -1;
          return 130;

        case E_V256HImode:
          if (pattern154 (x1, 
E_V256SImode, 
E_V256HImode, 
E_SImode) != 0)
            return -1;
          return 131;

        case E_V512HImode:
          if (pattern154 (x1, 
E_V512SImode, 
E_V512HImode, 
E_SImode) != 0)
            return -1;
          return 132;

        case E_V1024HImode:
          if (pattern154 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_SImode) != 0)
            return -1;
          return 133;

        case E_V1SImode:
          if (pattern154 (x1, 
E_V1DImode, 
E_V1SImode, 
E_DImode) != 0)
            return -1;
          return 134;

        case E_V2SImode:
          if (pattern154 (x1, 
E_V2DImode, 
E_V2SImode, 
E_DImode) != 0)
            return -1;
          return 135;

        case E_V4SImode:
          if (pattern154 (x1, 
E_V4DImode, 
E_V4SImode, 
E_DImode) != 0)
            return -1;
          return 136;

        case E_V8SImode:
          if (pattern154 (x1, 
E_V8DImode, 
E_V8SImode, 
E_DImode) != 0)
            return -1;
          return 137;

        case E_V16SImode:
          if (pattern154 (x1, 
E_V16DImode, 
E_V16SImode, 
E_DImode) != 0)
            return -1;
          return 138;

        case E_V32SImode:
          if (pattern154 (x1, 
E_V32DImode, 
E_V32SImode, 
E_DImode) != 0)
            return -1;
          return 139;

        case E_V64SImode:
          if (pattern154 (x1, 
E_V64DImode, 
E_V64SImode, 
E_DImode) != 0)
            return -1;
          return 140;

        case E_V128SImode:
          if (pattern154 (x1, 
E_V128DImode, 
E_V128SImode, 
E_DImode) != 0)
            return -1;
          return 141;

        case E_V256SImode:
          if (pattern154 (x1, 
E_V256DImode, 
E_V256SImode, 
E_DImode) != 0)
            return -1;
          return 142;

        case E_V512SImode:
          if (pattern154 (x1, 
E_V512DImode, 
E_V512SImode, 
E_DImode) != 0)
            return -1;
          return 143;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern184 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[3], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[3], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[3], E_RVVM8SImode))
        return -1;
      return 2;

    case E_RVVM4BFmode:
      if (!register_operand (operands[3], E_RVVM4BFmode))
        return -1;
      return 3;

    case E_RVVM4HFmode:
      if (!register_operand (operands[3], E_RVVM4HFmode))
        return -1;
      return 4;

    case E_RVVM8SFmode:
      if (!register_operand (operands[3], E_RVVM8SFmode))
        return -1;
      return 5;

    case E_RVVM2x2QImode:
      if (!register_operand (operands[3], E_RVVM2x2QImode))
        return -1;
      return 6;

    case E_RVVM2x3QImode:
      if (!register_operand (operands[3], E_RVVM2x3QImode))
        return -1;
      return 7;

    case E_RVVM2x4QImode:
      if (!register_operand (operands[3], E_RVVM2x4QImode))
        return -1;
      return 8;

    case E_RVVM4x2HImode:
      if (!register_operand (operands[3], E_RVVM4x2HImode))
        return -1;
      return 9;

    case E_RVVM4x2BFmode:
      if (!register_operand (operands[3], E_RVVM4x2BFmode))
        return -1;
      return 10;

    case E_RVVM4x2HFmode:
      if (!register_operand (operands[3], E_RVVM4x2HFmode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern189 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 7
      || XINT (x3, 1) != 91)
    return -1;
  x4 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 3);
  operands[7] = x10;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 4);
  operands[8] = x11;
  if (!const_int_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 1);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 2);
  operands[3] = x13;
  x14 = XVECEXP (x2, 0, 3);
  operands[4] = x14;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern191 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern191 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern191 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern191 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern191 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern191 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern191 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern191 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern191 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern191 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern191 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern191 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern191 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern191 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern191 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern191 (x2, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern191 (x2, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern191 (x2, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern191 (x2, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern191 (x2, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern191 (x2, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern191 (x2, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern191 (x2, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern191 (x2, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern191 (x2, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern191 (x2, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern191 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern191 (x2, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern191 (x2, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern191 (x2, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern191 (x2, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern191 (x2, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern191 (x2, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern191 (x2, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern191 (x2, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern191 (x2, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern191 (x2, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern191 (x2, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern191 (x2, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern191 (x2, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern191 (x2, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern191 (x2, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern191 (x2, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern191 (x2, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern191 (x2, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern191 (x2, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern191 (x2, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern191 (x2, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      x4 = XEXP (x1, 2);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern201 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern201 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern201 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern201 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVM8HImode:
          if (pattern201 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 4;

        case E_RVVM4HImode:
          if (pattern201 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 5;

        case E_RVVM2HImode:
          if (pattern201 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 6;

        case E_RVVM1HImode:
          if (pattern201 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 7;

        case E_RVVM8SImode:
          if (pattern201 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM4SImode:
          if (pattern201 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (pattern201 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVM1SImode:
          if (pattern201 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVM8DImode:
          if (pattern201 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 12;

        case E_RVVM4DImode:
          if (pattern201 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 13;

        case E_RVVM2DImode:
          if (pattern201 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 14;

        case E_RVVM1DImode:
          if (pattern201 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 15;

        case E_RVVMF2QImode:
          if (pattern201 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF4QImode:
          if (pattern201 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 17;

        case E_RVVMF8QImode:
          if (pattern201 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 18;

        case E_RVVMF2HImode:
          if (pattern201 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 19;

        case E_RVVMF4HImode:
          if (pattern201 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF2SImode:
          if (pattern201 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 21;

        case E_RVVM8BFmode:
          if (pattern201 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 22;

        case E_RVVM4BFmode:
          if (pattern201 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 23;

        case E_RVVM2BFmode:
          if (pattern201 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 24;

        case E_RVVM1BFmode:
          if (pattern201 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 25;

        case E_RVVMF2BFmode:
          if (pattern201 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 26;

        case E_RVVMF4BFmode:
          if (pattern201 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 27;

        case E_RVVM8HFmode:
          if (pattern201 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 28;

        case E_RVVM4HFmode:
          if (pattern201 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 29;

        case E_RVVM2HFmode:
          if (pattern201 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 30;

        case E_RVVM1HFmode:
          if (pattern201 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 31;

        case E_RVVMF2HFmode:
          if (pattern201 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 32;

        case E_RVVMF4HFmode:
          if (pattern201 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 33;

        case E_RVVM8SFmode:
          if (pattern201 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 34;

        case E_RVVM4SFmode:
          if (pattern201 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 35;

        case E_RVVM2SFmode:
          if (pattern201 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 36;

        case E_RVVM1SFmode:
          if (pattern201 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 37;

        case E_RVVMF2SFmode:
          if (pattern201 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 38;

        case E_RVVM8DFmode:
          if (pattern201 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 39;

        case E_RVVM4DFmode:
          if (pattern201 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 40;

        case E_RVVM2DFmode:
          if (pattern201 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 41;

        case E_RVVM1DFmode:
          if (pattern201 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 42;

        case E_V1QImode:
          if (pattern201 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 43;

        case E_V2QImode:
          if (pattern201 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 44;

        case E_V4QImode:
          if (pattern201 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 45;

        case E_V8QImode:
          if (pattern201 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 46;

        case E_V16QImode:
          if (pattern201 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 47;

        case E_V32QImode:
          if (pattern201 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 48;

        case E_V64QImode:
          if (pattern201 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 49;

        case E_V128QImode:
          if (pattern201 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 50;

        case E_V256QImode:
          if (pattern201 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 51;

        case E_V512QImode:
          if (pattern201 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 52;

        case E_V1024QImode:
          if (pattern201 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 53;

        case E_V2048QImode:
          if (pattern201 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 54;

        case E_V4096QImode:
          if (pattern201 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
            return -1;
          return 55;

        case E_V1HImode:
          if (pattern201 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 56;

        case E_V2HImode:
          if (pattern201 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 57;

        case E_V4HImode:
          if (pattern201 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 58;

        case E_V8HImode:
          if (pattern201 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 59;

        case E_V16HImode:
          if (pattern201 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 60;

        case E_V32HImode:
          if (pattern201 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 61;

        case E_V64HImode:
          if (pattern201 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 62;

        case E_V128HImode:
          if (pattern201 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 63;

        case E_V256HImode:
          if (pattern201 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 64;

        case E_V512HImode:
          if (pattern201 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 65;

        case E_V1024HImode:
          if (pattern201 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 66;

        case E_V2048HImode:
          if (pattern201 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
            return -1;
          return 67;

        case E_V1SImode:
          if (pattern201 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 68;

        case E_V2SImode:
          if (pattern201 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 69;

        case E_V4SImode:
          if (pattern201 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 70;

        case E_V8SImode:
          if (pattern201 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 71;

        case E_V16SImode:
          if (pattern201 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 72;

        case E_V32SImode:
          if (pattern201 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 73;

        case E_V64SImode:
          if (pattern201 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 74;

        case E_V128SImode:
          if (pattern201 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 75;

        case E_V256SImode:
          if (pattern201 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 76;

        case E_V512SImode:
          if (pattern201 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 77;

        case E_V1024SImode:
          if (pattern201 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
            return -1;
          return 78;

        case E_V1DImode:
          if (pattern201 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
            return -1;
          return 79;

        case E_V2DImode:
          if (pattern201 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
            return -1;
          return 80;

        case E_V4DImode:
          if (pattern201 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
            return -1;
          return 81;

        case E_V8DImode:
          if (pattern201 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
            return -1;
          return 82;

        case E_V16DImode:
          if (pattern201 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
            return -1;
          return 83;

        case E_V32DImode:
          if (pattern201 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
            return -1;
          return 84;

        case E_V64DImode:
          if (pattern201 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
            return -1;
          return 85;

        case E_V128DImode:
          if (pattern201 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
            return -1;
          return 86;

        case E_V256DImode:
          if (pattern201 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
            return -1;
          return 87;

        case E_V512DImode:
          if (pattern201 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
            return -1;
          return 88;

        case E_V1HFmode:
          if (pattern201 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 89;

        case E_V2HFmode:
          if (pattern201 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 90;

        case E_V4HFmode:
          if (pattern201 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 91;

        case E_V8HFmode:
          if (pattern201 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 92;

        case E_V16HFmode:
          if (pattern201 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 93;

        case E_V32HFmode:
          if (pattern201 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 94;

        case E_V64HFmode:
          if (pattern201 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 95;

        case E_V128HFmode:
          if (pattern201 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 96;

        case E_V256HFmode:
          if (pattern201 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 97;

        case E_V512HFmode:
          if (pattern201 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 98;

        case E_V1024HFmode:
          if (pattern201 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 99;

        case E_V2048HFmode:
          if (pattern201 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 100;

        case E_V1SFmode:
          if (pattern201 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 101;

        case E_V2SFmode:
          if (pattern201 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 102;

        case E_V4SFmode:
          if (pattern201 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 103;

        case E_V8SFmode:
          if (pattern201 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 104;

        case E_V16SFmode:
          if (pattern201 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 105;

        case E_V32SFmode:
          if (pattern201 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 106;

        case E_V64SFmode:
          if (pattern201 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 107;

        case E_V128SFmode:
          if (pattern201 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 108;

        case E_V256SFmode:
          if (pattern201 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 109;

        case E_V512SFmode:
          if (pattern201 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 110;

        case E_V1024SFmode:
          if (pattern201 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 111;

        case E_V1DFmode:
          if (pattern201 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 112;

        case E_V2DFmode:
          if (pattern201 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 113;

        case E_V4DFmode:
          if (pattern201 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 114;

        case E_V8DFmode:
          if (pattern201 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 115;

        case E_V16DFmode:
          if (pattern201 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 116;

        case E_V32DFmode:
          if (pattern201 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 117;

        case E_V64DFmode:
          if (pattern201 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 118;

        case E_V128DFmode:
          if (pattern201 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 119;

        case E_V256DFmode:
          if (pattern201 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 120;

        case E_V512DFmode:
          if (pattern201 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 121;

        default:
          return -1;
        }

    case ABS:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern202 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 122;

        case E_RVVM4HFmode:
          if (pattern202 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 123;

        case E_RVVM2HFmode:
          if (pattern202 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 124;

        case E_RVVM1HFmode:
          if (pattern202 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 125;

        case E_RVVMF2HFmode:
          if (pattern202 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 126;

        case E_RVVMF4HFmode:
          if (pattern202 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 127;

        case E_RVVM8SFmode:
          if (pattern202 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 128;

        case E_RVVM4SFmode:
          if (pattern202 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 129;

        case E_RVVM2SFmode:
          if (pattern202 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 130;

        case E_RVVM1SFmode:
          if (pattern202 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 131;

        case E_RVVMF2SFmode:
          if (pattern202 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 132;

        case E_RVVM8DFmode:
          if (pattern202 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 133;

        case E_RVVM4DFmode:
          if (pattern202 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 134;

        case E_RVVM2DFmode:
          if (pattern202 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 135;

        case E_RVVM1DFmode:
          if (pattern202 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 136;

        case E_V1HFmode:
          if (pattern202 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 137;

        case E_V2HFmode:
          if (pattern202 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 138;

        case E_V4HFmode:
          if (pattern202 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 139;

        case E_V8HFmode:
          if (pattern202 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 140;

        case E_V16HFmode:
          if (pattern202 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 141;

        case E_V32HFmode:
          if (pattern202 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 142;

        case E_V64HFmode:
          if (pattern202 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 143;

        case E_V128HFmode:
          if (pattern202 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 144;

        case E_V256HFmode:
          if (pattern202 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 145;

        case E_V512HFmode:
          if (pattern202 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 146;

        case E_V1024HFmode:
          if (pattern202 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 147;

        case E_V2048HFmode:
          if (pattern202 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 148;

        case E_V1SFmode:
          if (pattern202 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 149;

        case E_V2SFmode:
          if (pattern202 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 150;

        case E_V4SFmode:
          if (pattern202 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 151;

        case E_V8SFmode:
          if (pattern202 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 152;

        case E_V16SFmode:
          if (pattern202 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 153;

        case E_V32SFmode:
          if (pattern202 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 154;

        case E_V64SFmode:
          if (pattern202 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 155;

        case E_V128SFmode:
          if (pattern202 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 156;

        case E_V256SFmode:
          if (pattern202 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 157;

        case E_V512SFmode:
          if (pattern202 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 158;

        case E_V1024SFmode:
          if (pattern202 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 159;

        case E_V1DFmode:
          if (pattern202 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 160;

        case E_V2DFmode:
          if (pattern202 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 161;

        case E_V4DFmode:
          if (pattern202 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 162;

        case E_V8DFmode:
          if (pattern202 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 163;

        case E_V16DFmode:
          if (pattern202 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 164;

        case E_V32DFmode:
          if (pattern202 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 165;

        case E_V64DFmode:
          if (pattern202 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 166;

        case E_V128DFmode:
          if (pattern202 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 167;

        case E_V256DFmode:
          if (pattern202 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 168;

        case E_V512DFmode:
          if (pattern202 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 169;

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern203 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 170;

        case E_RVVM4HFmode:
          if (pattern203 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 171;

        case E_RVVM2HFmode:
          if (pattern203 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 172;

        case E_RVVM1HFmode:
          if (pattern203 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 173;

        case E_RVVMF2HFmode:
          if (pattern203 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 174;

        case E_RVVMF4HFmode:
          if (pattern203 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 175;

        case E_RVVM8SFmode:
          if (pattern203 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 176;

        case E_RVVM4SFmode:
          if (pattern203 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 177;

        case E_RVVM2SFmode:
          if (pattern203 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 178;

        case E_RVVM1SFmode:
          if (pattern203 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 179;

        case E_RVVMF2SFmode:
          if (pattern203 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 180;

        case E_RVVM8DFmode:
          if (pattern203 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 181;

        case E_RVVM4DFmode:
          if (pattern203 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 182;

        case E_RVVM2DFmode:
          if (pattern203 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 183;

        case E_RVVM1DFmode:
          if (pattern203 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 184;

        case E_V1HFmode:
          if (pattern203 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 185;

        case E_V2HFmode:
          if (pattern203 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 186;

        case E_V4HFmode:
          if (pattern203 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 187;

        case E_V8HFmode:
          if (pattern203 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 188;

        case E_V16HFmode:
          if (pattern203 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 189;

        case E_V32HFmode:
          if (pattern203 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 190;

        case E_V64HFmode:
          if (pattern203 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 191;

        case E_V128HFmode:
          if (pattern203 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 192;

        case E_V256HFmode:
          if (pattern203 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 193;

        case E_V512HFmode:
          if (pattern203 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 194;

        case E_V1024HFmode:
          if (pattern203 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 195;

        case E_V2048HFmode:
          if (pattern203 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 196;

        case E_V1SFmode:
          if (pattern203 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 197;

        case E_V2SFmode:
          if (pattern203 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 198;

        case E_V4SFmode:
          if (pattern203 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 199;

        case E_V8SFmode:
          if (pattern203 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 200;

        case E_V16SFmode:
          if (pattern203 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 201;

        case E_V32SFmode:
          if (pattern203 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 202;

        case E_V64SFmode:
          if (pattern203 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 203;

        case E_V128SFmode:
          if (pattern203 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 204;

        case E_V256SFmode:
          if (pattern203 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 205;

        case E_V512SFmode:
          if (pattern203 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 206;

        case E_V1024SFmode:
          if (pattern203 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 207;

        case E_V1DFmode:
          if (pattern203 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 208;

        case E_V2DFmode:
          if (pattern203 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 209;

        case E_V4DFmode:
          if (pattern203 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 210;

        case E_V8DFmode:
          if (pattern203 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 211;

        case E_V16DFmode:
          if (pattern203 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 212;

        case E_V32DFmode:
          if (pattern203 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 213;

        case E_V64DFmode:
          if (pattern203 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 214;

        case E_V128DFmode:
          if (pattern203 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 215;

        case E_V256DFmode:
          if (pattern203 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 216;

        case E_V512DFmode:
          if (pattern203 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 217;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern205 (x1);
      if (res >= 0)
        return res + 218; /* [218, 309] */
      return -1;

    case ZERO_EXTEND:
      res = pattern205 (x1);
      if (res >= 0)
        return res + 310; /* [310, 401] */
      return -1;

    case TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x4 = XEXP (x1, 2);
          operands[3] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM4QImode:
              if (pattern204 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
                return -1;
              return 402;

            case E_RVVM2QImode:
              if (pattern204 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 403;

            case E_RVVM1QImode:
              if (pattern204 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 404;

            case E_RVVMF2QImode:
              if (pattern204 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 405;

            case E_RVVMF4QImode:
              if (pattern204 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 406;

            case E_RVVMF8QImode:
              if (pattern204 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 407;

            case E_RVVM4HImode:
              if (pattern204 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 408;

            case E_RVVM2HImode:
              if (pattern204 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 409;

            case E_RVVM1HImode:
              if (pattern204 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 410;

            case E_RVVMF2HImode:
              if (pattern204 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 411;

            case E_RVVMF4HImode:
              if (pattern204 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 412;

            case E_RVVM4SImode:
              if (pattern204 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 413;

            case E_RVVM2SImode:
              if (pattern204 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 414;

            case E_RVVM1SImode:
              if (pattern204 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 415;

            case E_RVVMF2SImode:
              if (pattern204 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 416;

            case E_V1QImode:
              if (pattern204 (x1, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0)
                return -1;
              return 417;

            case E_V2QImode:
              if (pattern204 (x1, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0)
                return -1;
              return 418;

            case E_V4QImode:
              if (pattern204 (x1, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0)
                return -1;
              return 419;

            case E_V8QImode:
              if (pattern204 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0)
                return -1;
              return 420;

            case E_V16QImode:
              if (pattern204 (x1, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0)
                return -1;
              return 421;

            case E_V32QImode:
              if (pattern204 (x1, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0)
                return -1;
              return 422;

            case E_V64QImode:
              if (pattern204 (x1, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0)
                return -1;
              return 423;

            case E_V128QImode:
              if (pattern204 (x1, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0)
                return -1;
              return 424;

            case E_V256QImode:
              if (pattern204 (x1, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0)
                return -1;
              return 425;

            case E_V512QImode:
              if (pattern204 (x1, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0)
                return -1;
              return 426;

            case E_V1024QImode:
              if (pattern204 (x1, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
                return -1;
              return 427;

            case E_V2048QImode:
              if (pattern204 (x1, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0)
                return -1;
              return 428;

            case E_V1HImode:
              if (pattern204 (x1, 
E_V1HImode, 
E_V1SImode, 
E_V1BImode) != 0)
                return -1;
              return 429;

            case E_V2HImode:
              if (pattern204 (x1, 
E_V2HImode, 
E_V2SImode, 
E_V2BImode) != 0)
                return -1;
              return 430;

            case E_V4HImode:
              if (pattern204 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V4BImode) != 0)
                return -1;
              return 431;

            case E_V8HImode:
              if (pattern204 (x1, 
E_V8HImode, 
E_V8SImode, 
E_V8BImode) != 0)
                return -1;
              return 432;

            case E_V16HImode:
              if (pattern204 (x1, 
E_V16HImode, 
E_V16SImode, 
E_V16BImode) != 0)
                return -1;
              return 433;

            case E_V32HImode:
              if (pattern204 (x1, 
E_V32HImode, 
E_V32SImode, 
E_V32BImode) != 0)
                return -1;
              return 434;

            case E_V64HImode:
              if (pattern204 (x1, 
E_V64HImode, 
E_V64SImode, 
E_V64BImode) != 0)
                return -1;
              return 435;

            case E_V128HImode:
              if (pattern204 (x1, 
E_V128HImode, 
E_V128SImode, 
E_V128BImode) != 0)
                return -1;
              return 436;

            case E_V256HImode:
              if (pattern204 (x1, 
E_V256HImode, 
E_V256SImode, 
E_V256BImode) != 0)
                return -1;
              return 437;

            case E_V512HImode:
              if (pattern204 (x1, 
E_V512HImode, 
E_V512SImode, 
E_V512BImode) != 0)
                return -1;
              return 438;

            case E_V1024HImode:
              if (pattern204 (x1, 
E_V1024HImode, 
E_V1024SImode, 
E_V1024BImode) != 0)
                return -1;
              return 439;

            case E_V1SImode:
              if (pattern204 (x1, 
E_V1SImode, 
E_V1DImode, 
E_V1BImode) != 0)
                return -1;
              return 440;

            case E_V2SImode:
              if (pattern204 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V2BImode) != 0)
                return -1;
              return 441;

            case E_V4SImode:
              if (pattern204 (x1, 
E_V4SImode, 
E_V4DImode, 
E_V4BImode) != 0)
                return -1;
              return 442;

            case E_V8SImode:
              if (pattern204 (x1, 
E_V8SImode, 
E_V8DImode, 
E_V8BImode) != 0)
                return -1;
              return 443;

            case E_V16SImode:
              if (pattern204 (x1, 
E_V16SImode, 
E_V16DImode, 
E_V16BImode) != 0)
                return -1;
              return 444;

            case E_V32SImode:
              if (pattern204 (x1, 
E_V32SImode, 
E_V32DImode, 
E_V32BImode) != 0)
                return -1;
              return 445;

            case E_V64SImode:
              if (pattern204 (x1, 
E_V64SImode, 
E_V64DImode, 
E_V64BImode) != 0)
                return -1;
              return 446;

            case E_V128SImode:
              if (pattern204 (x1, 
E_V128SImode, 
E_V128DImode, 
E_V128BImode) != 0)
                return -1;
              return 447;

            case E_V256SImode:
              if (pattern204 (x1, 
E_V256SImode, 
E_V256DImode, 
E_V256BImode) != 0)
                return -1;
              return 448;

            case E_V512SImode:
              if (pattern204 (x1, 
E_V512SImode, 
E_V512DImode, 
E_V512BImode) != 0)
                return -1;
              return 449;

            default:
              return -1;
            }

        case ASHIFTRT:
          res = pattern209 (x1);
          if (res >= 0)
            return res + 450; /* [450, 593] */
          return -1;

        case LSHIFTRT:
          res = pattern209 (x1);
          if (res >= 0)
            return res + 594; /* [594, 737] */
          return -1;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern204 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 738;

        case E_RVVM4SFmode:
          if (pattern204 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 739;

        case E_RVVM2SFmode:
          if (pattern204 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 740;

        case E_RVVM1SFmode:
          if (pattern204 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 741;

        case E_RVVMF2SFmode:
          if (pattern204 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 742;

        case E_RVVM8DFmode:
          if (pattern204 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 743;

        case E_RVVM4DFmode:
          if (pattern204 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 744;

        case E_RVVM2DFmode:
          if (pattern204 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 745;

        case E_RVVM1DFmode:
          if (pattern204 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 746;

        case E_V1SFmode:
          if (pattern204 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 747;

        case E_V2SFmode:
          if (pattern204 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 748;

        case E_V4SFmode:
          if (pattern204 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 749;

        case E_V8SFmode:
          if (pattern204 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 750;

        case E_V16SFmode:
          if (pattern204 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 751;

        case E_V32SFmode:
          if (pattern204 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 752;

        case E_V64SFmode:
          if (pattern204 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 753;

        case E_V128SFmode:
          if (pattern204 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 754;

        case E_V256SFmode:
          if (pattern204 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 755;

        case E_V512SFmode:
          if (pattern204 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 756;

        case E_V1024SFmode:
          if (pattern204 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 757;

        case E_V1DFmode:
          if (pattern204 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 758;

        case E_V2DFmode:
          if (pattern204 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 759;

        case E_V4DFmode:
          if (pattern204 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 760;

        case E_V8DFmode:
          if (pattern204 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 761;

        case E_V16DFmode:
          if (pattern204 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 762;

        case E_V32DFmode:
          if (pattern204 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 763;

        case E_V64DFmode:
          if (pattern204 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 764;

        case E_V128DFmode:
          if (pattern204 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 765;

        case E_V256DFmode:
          if (pattern204 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 766;

        case E_V512DFmode:
          if (pattern204 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 767;

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HFmode:
          if (pattern204 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 768;

        case E_RVVM2HFmode:
          if (pattern204 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 769;

        case E_RVVM1HFmode:
          if (pattern204 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 770;

        case E_RVVMF2HFmode:
          if (pattern204 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 771;

        case E_RVVMF4HFmode:
          if (pattern204 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 772;

        case E_RVVM4SFmode:
          if (pattern204 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 773;

        case E_RVVM2SFmode:
          if (pattern204 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 774;

        case E_RVVM1SFmode:
          if (pattern204 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 775;

        case E_RVVMF2SFmode:
          if (pattern204 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 776;

        case E_V1HFmode:
          if (pattern204 (x1, 
E_V1HFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 777;

        case E_V2HFmode:
          if (pattern204 (x1, 
E_V2HFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 778;

        case E_V4HFmode:
          if (pattern204 (x1, 
E_V4HFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 779;

        case E_V8HFmode:
          if (pattern204 (x1, 
E_V8HFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 780;

        case E_V16HFmode:
          if (pattern204 (x1, 
E_V16HFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 781;

        case E_V32HFmode:
          if (pattern204 (x1, 
E_V32HFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 782;

        case E_V64HFmode:
          if (pattern204 (x1, 
E_V64HFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 783;

        case E_V128HFmode:
          if (pattern204 (x1, 
E_V128HFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 784;

        case E_V256HFmode:
          if (pattern204 (x1, 
E_V256HFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 785;

        case E_V512HFmode:
          if (pattern204 (x1, 
E_V512HFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 786;

        case E_V1024HFmode:
          if (pattern204 (x1, 
E_V1024HFmode, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 787;

        case E_V1SFmode:
          if (pattern204 (x1, 
E_V1SFmode, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 788;

        case E_V2SFmode:
          if (pattern204 (x1, 
E_V2SFmode, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 789;

        case E_V4SFmode:
          if (pattern204 (x1, 
E_V4SFmode, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 790;

        case E_V8SFmode:
          if (pattern204 (x1, 
E_V8SFmode, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 791;

        case E_V16SFmode:
          if (pattern204 (x1, 
E_V16SFmode, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 792;

        case E_V32SFmode:
          if (pattern204 (x1, 
E_V32SFmode, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 793;

        case E_V64SFmode:
          if (pattern204 (x1, 
E_V64SFmode, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 794;

        case E_V128SFmode:
          if (pattern204 (x1, 
E_V128SFmode, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 795;

        case E_V256SFmode:
          if (pattern204 (x1, 
E_V256SFmode, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 796;

        case E_V512SFmode:
          if (pattern204 (x1, 
E_V512SFmode, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 797;

        default:
          return -1;
        }

    case FIX:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 798; /* [798, 923] */
      return -1;

    case UNSIGNED_FIX:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 924; /* [924, 1049] */
      return -1;

    case FLOAT:
      res = pattern211 (x1);
      if (res >= 0)
        return res + 1050; /* [1050, 1175] */
      return -1;

    case UNSIGNED_FLOAT:
      res = pattern211 (x1);
      if (res >= 0)
        return res + 1176; /* [1176, 1301] */
      return -1;

    case SMUL_HIGHPART:
      res = pattern213 (x1);
      if (res >= 0)
        return res + 1302; /* [1302, 1369] */
      return -1;

    case UMUL_HIGHPART:
      res = pattern213 (x1);
      if (res >= 0)
        return res + 1370; /* [1370, 1437] */
      return -1;

    default:
      return -1;
    }
}

int
pattern432 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!vector_length_operand (operands[4], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[5] = x6;
  x7 = XVECEXP (x2, 0, 0);
  operands[2] = x7;
  if (!pmode_reg_or_0_operand (operands[2], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x2, 0, 1);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern431 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern431 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern431 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern431 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern431 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern431 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern431 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern431 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern431 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern431 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern431 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern431 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern431 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern431 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern431 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern431 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF8QImode:
      if (pattern431 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4HImode:
      if (pattern431 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2SImode:
      if (pattern431 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern451 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!autovec_length_operand (operands[4], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  operands[5] = x8;
  if (!const_0_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x2, 0, 1);
  operands[6] = x9;
  if (!autovec_length_operand (operands[6], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern450 (x1, 
E_SImode); /* [-1, 19] */

    case E_DImode:
      res = pattern450 (x1, 
E_DImode);
      if (res >= 0)
        return res + 20; /* [20, 39] */
      return -1;

    default:
      return -1;
    }
}

int
pattern463 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!vector_move_operand (operands[3], i1))
    return -1;
  x6 = XEXP (x1, 2);
  operands[2] = x6;
  if (!vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern468 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !reg_or_mem_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern472 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern475 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern478 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[6] = x5;
  x6 = XEXP (x1, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x9 = XEXP (x1, 2);
  operands[1] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SImode:
      return pattern477 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode); /* [-1, 0] */

    case E_RVVM4SImode:
      if (pattern477 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2SImode:
      if (pattern477 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1SImode:
      if (pattern477 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SImode:
      if (pattern477 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern481 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_arith_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern482 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[4] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern481 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern481 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern481 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern481 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern481 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern481 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern481 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern481 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern481 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern481 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern481 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern481 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern481 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern481 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern481 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern481 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern481 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern481 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern481 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern481 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern481 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern481 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern481 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern481 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern481 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern481 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern481 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern481 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern481 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern481 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern481 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern481 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern481 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern481 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern481 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern481 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern481 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern481 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern481 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern481 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern481 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern481 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern481 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern481 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern481 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern481 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern481 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern481 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern481 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern481 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern481 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern481 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern481 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern481 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern481 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern481 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern481 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern481 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern481 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern481 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern481 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern481 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern481 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern481 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern481 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern481 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern481 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern481 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern497 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern498 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  x10 = XEXP (x7, 1);
  switch (GET_CODE (x10))
    {
    case REG:
    case SUBREG:
      return pattern493 (x1); /* [-1, 67] */

    case VEC_DUPLICATE:
      x11 = XEXP (x10, 0);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          res = pattern496 (x1);
          if (res >= 0)
            return res + 68; /* [68, 135] */
          return -1;

        case SIGN_EXTEND:
          if (GET_MODE (x11) != E_DImode)
            return -1;
          x12 = XEXP (x11, 0);
          operands[4] = x12;
          if (!reg_or_0_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern497 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 136;

            case E_RVVM4DImode:
              if (pattern497 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 137;

            case E_RVVM2DImode:
              if (pattern497 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 138;

            case E_RVVM1DImode:
              if (pattern497 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 139;

            case E_V1DImode:
              if (pattern497 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
                return -1;
              return 140;

            case E_V2DImode:
              if (pattern497 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
                return -1;
              return 141;

            case E_V4DImode:
              if (pattern497 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
                return -1;
              return 142;

            case E_V8DImode:
              if (pattern497 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
                return -1;
              return 143;

            case E_V16DImode:
              if (pattern497 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
                return -1;
              return 144;

            case E_V32DImode:
              if (pattern497 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
                return -1;
              return 145;

            case E_V64DImode:
              if (pattern497 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
                return -1;
              return 146;

            case E_V128DImode:
              if (pattern497 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
                return -1;
              return 147;

            case E_V256DImode:
              if (pattern497 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
                return -1;
              return 148;

            case E_V512DImode:
              if (pattern497 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
                return -1;
              return 149;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern506 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM4QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM4QImode))
        return -1;
      return 0;

    case E_RVVM8HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern508 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern511 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVMF8QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern514 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V4QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 0;

    case E_V4HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V4SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern517 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V32QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 0;

    case E_V32HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern520 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V256QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V256QImode))
        return -1;
      return 0;

    case E_V256HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 1;

    case E_V256SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern524 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern526 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern530 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[5] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[6] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[7] = x7;
  x8 = XVECEXP (x4, 0, 4);
  operands[8] = x8;
  x9 = XEXP (x2, 0);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  x11 = XEXP (x1, 2);
  operands[2] = x11;
  return pattern529 (x1); /* [-1, 95] */
}

int
pattern533 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern535 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern536 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != i5)
    return -1;
  x9 = XEXP (x7, 0);
  if (GET_CODE (x9) != MEM)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != PLUS)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 2)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 3);
  x14 = XEXP (x13, 1);
  if (GET_CODE (x14) != REG
      || REGNO (x14) != i4)
    return -1;
  x15 = XEXP (x13, 0);
  if (GET_CODE (x15) != MEM)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != PLUS)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 2)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_CODE (x18) != CONST_INT)
    return -1;
  x19 = XVECEXP (x1, 0, 4);
  x20 = XEXP (x19, 1);
  if (GET_CODE (x20) != REG
      || REGNO (x20) != i3)
    return -1;
  x21 = XEXP (x19, 0);
  if (GET_CODE (x21) != MEM)
    return -1;
  x22 = XEXP (x21, 0);
  if (GET_CODE (x22) != PLUS)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 2)
    return -1;
  x24 = XEXP (x22, 1);
  if (GET_CODE (x24) != CONST_INT)
    return -1;
  x25 = XVECEXP (x1, 0, 5);
  x26 = XEXP (x25, 1);
  if (GET_CODE (x26) != REG
      || REGNO (x26) != i2)
    return -1;
  x27 = XEXP (x25, 0);
  if (GET_CODE (x27) != MEM)
    return -1;
  x28 = XEXP (x27, 0);
  if (GET_CODE (x28) != PLUS)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 2)
    return -1;
  x30 = XEXP (x28, 1);
  if (GET_CODE (x30) != CONST_INT)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  return pattern535 (x31, 
i1); /* [-1, 0] */
}

int
pattern540 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  x10 = XEXP (x7, 1);
  x11 = XEXP (x10, 0);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      operands[4] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          return pattern537 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

        case E_RVVM4HImode:
          if (pattern537 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HImode:
          if (pattern537 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HImode:
          if (pattern537 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HImode:
          if (pattern537 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HImode:
          if (pattern537 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 5;

        case E_RVVM8SImode:
          if (pattern537 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 6;

        case E_RVVM4SImode:
          if (pattern537 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 7;

        case E_RVVM2SImode:
          if (pattern537 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 8;

        case E_RVVM1SImode:
          if (pattern537 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SImode:
          if (pattern537 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 10;

        case E_RVVM8DImode:
          if (pattern537 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 11;

        case E_RVVM4DImode:
          if (pattern537 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 12;

        case E_RVVM2DImode:
          if (pattern537 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 13;

        case E_RVVM1DImode:
          if (pattern537 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 14;

        case E_V1HImode:
          if (pattern537 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 15;

        case E_V2HImode:
          if (pattern537 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 16;

        case E_V4HImode:
          if (pattern537 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 17;

        case E_V8HImode:
          if (pattern537 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 18;

        case E_V16HImode:
          if (pattern537 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 19;

        case E_V32HImode:
          if (pattern537 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 20;

        case E_V64HImode:
          if (pattern537 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 21;

        case E_V128HImode:
          if (pattern537 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 22;

        case E_V256HImode:
          if (pattern537 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 23;

        case E_V512HImode:
          if (pattern537 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 24;

        case E_V1024HImode:
          if (pattern537 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 25;

        case E_V2048HImode:
          if (pattern537 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 26;

        case E_V1SImode:
          if (pattern537 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 27;

        case E_V2SImode:
          if (pattern537 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 28;

        case E_V4SImode:
          if (pattern537 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 29;

        case E_V8SImode:
          if (pattern537 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 30;

        case E_V16SImode:
          if (pattern537 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 31;

        case E_V32SImode:
          if (pattern537 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 32;

        case E_V64SImode:
          if (pattern537 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 33;

        case E_V128SImode:
          if (pattern537 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 34;

        case E_V256SImode:
          if (pattern537 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 35;

        case E_V512SImode:
          if (pattern537 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 36;

        case E_V1024SImode:
          if (pattern537 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 37;

        case E_V1DImode:
          if (pattern537 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 38;

        case E_V2DImode:
          if (pattern537 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 39;

        case E_V4DImode:
          if (pattern537 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 40;

        case E_V8DImode:
          if (pattern537 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 41;

        case E_V16DImode:
          if (pattern537 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 42;

        case E_V32DImode:
          if (pattern537 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 43;

        case E_V64DImode:
          if (pattern537 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 44;

        case E_V128DImode:
          if (pattern537 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 45;

        case E_V256DImode:
          if (pattern537 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 46;

        case E_V512DImode:
          if (pattern537 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      res = pattern539 (x1);
      if (res >= 0)
        return res + 48; /* [48, 95] */
      return -1;

    default:
      return -1;
    }
}

int
pattern554 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern549 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern549 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern549 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern549 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern549 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern549 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern549 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern549 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern549 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern549 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern549 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern549 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern549 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern549 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern549 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern549 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern549 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern549 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern549 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern549 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern549 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern549 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern549 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern549 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern549 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern549 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern549 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern549 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern549 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern549 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern549 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern549 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern549 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern549 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern549 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern549 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern549 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern549 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern549 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern549 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern549 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern549 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern549 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern549 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern549 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern549 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern549 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern549 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern572 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case PLUS:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 0;

    case IOR:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 1;

    case XOR:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 2;

    case AND:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 3;

    case NOT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != AND
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern575 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1BImode)
      || GET_MODE (x1) != E_RVVM1BImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_RVVM8QImode
      || !register_operand (operands[1], E_RVVM8QImode)
      || !register_operand (operands[2], E_RVVM8QImode))
    return -1;
  return 0;
}

int
pattern577 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i3)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern578 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          return pattern565 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

        case E_RVVM4HFmode:
          if (pattern565 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HFmode:
          if (pattern565 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HFmode:
          if (pattern565 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HFmode:
          if (pattern565 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HFmode:
          if (pattern565 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 5;

        case E_RVVM8SFmode:
          if (pattern565 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 6;

        case E_RVVM4SFmode:
          if (pattern565 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 7;

        case E_RVVM2SFmode:
          if (pattern565 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 8;

        case E_RVVM1SFmode:
          if (pattern565 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (pattern565 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 10;

        case E_RVVM8DFmode:
          if (pattern565 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 11;

        case E_RVVM4DFmode:
          if (pattern565 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 12;

        case E_RVVM2DFmode:
          if (pattern565 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 13;

        case E_RVVM1DFmode:
          if (pattern565 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 14;

        case E_V1HFmode:
          if (pattern565 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 15;

        case E_V2HFmode:
          if (pattern565 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 16;

        case E_V4HFmode:
          if (pattern565 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 17;

        case E_V8HFmode:
          if (pattern565 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 18;

        case E_V16HFmode:
          if (pattern565 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 19;

        case E_V32HFmode:
          if (pattern565 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 20;

        case E_V64HFmode:
          if (pattern565 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 21;

        case E_V128HFmode:
          if (pattern565 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 22;

        case E_V256HFmode:
          if (pattern565 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 23;

        case E_V512HFmode:
          if (pattern565 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 24;

        case E_V1024HFmode:
          if (pattern565 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 25;

        case E_V2048HFmode:
          if (pattern565 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 26;

        case E_V1SFmode:
          if (pattern565 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 27;

        case E_V2SFmode:
          if (pattern565 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 28;

        case E_V4SFmode:
          if (pattern565 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 29;

        case E_V8SFmode:
          if (pattern565 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 30;

        case E_V16SFmode:
          if (pattern565 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 31;

        case E_V32SFmode:
          if (pattern565 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 32;

        case E_V64SFmode:
          if (pattern565 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 33;

        case E_V128SFmode:
          if (pattern565 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 34;

        case E_V256SFmode:
          if (pattern565 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 35;

        case E_V512SFmode:
          if (pattern565 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 36;

        case E_V1024SFmode:
          if (pattern565 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 37;

        case E_V1DFmode:
          if (pattern565 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 38;

        case E_V2DFmode:
          if (pattern565 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 39;

        case E_V4DFmode:
          if (pattern565 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 40;

        case E_V8DFmode:
          if (pattern565 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 41;

        case E_V16DFmode:
          if (pattern565 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 42;

        case E_V32DFmode:
          if (pattern565 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 43;

        case E_V64DFmode:
          if (pattern565 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 44;

        case E_V128DFmode:
          if (pattern565 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 45;

        case E_V256DFmode:
          if (pattern565 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 46;

        case E_V512DFmode:
          if (pattern565 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x1, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XVECEXP (x5, 0, 5);
      operands[9] = x10;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      x12 = XEXP (x3, 1);
      operands[3] = x12;
      x13 = XEXP (x2, 1);
      operands[4] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern577 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) != 0)
            return -1;
          return 48;

        case E_RVVM4HFmode:
          if (pattern577 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
            return -1;
          return 49;

        case E_RVVM2HFmode:
          if (pattern577 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
            return -1;
          return 50;

        case E_RVVM1HFmode:
          if (pattern577 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
            return -1;
          return 51;

        case E_RVVMF2HFmode:
          if (pattern577 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
            return -1;
          return 52;

        case E_RVVMF4HFmode:
          if (pattern577 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
            return -1;
          return 53;

        case E_RVVM8SFmode:
          if (pattern577 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
            return -1;
          return 54;

        case E_RVVM4SFmode:
          if (pattern577 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
            return -1;
          return 55;

        case E_RVVM2SFmode:
          if (pattern577 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
            return -1;
          return 56;

        case E_RVVM1SFmode:
          if (pattern577 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
            return -1;
          return 57;

        case E_RVVMF2SFmode:
          if (pattern577 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
            return -1;
          return 58;

        case E_RVVM8DFmode:
          if (pattern577 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
            return -1;
          return 59;

        case E_RVVM4DFmode:
          if (pattern577 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
            return -1;
          return 60;

        case E_RVVM2DFmode:
          if (pattern577 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
            return -1;
          return 61;

        case E_RVVM1DFmode:
          if (pattern577 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
            return -1;
          return 62;

        case E_V1HFmode:
          if (pattern577 (x1, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
            return -1;
          return 63;

        case E_V2HFmode:
          if (pattern577 (x1, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
            return -1;
          return 64;

        case E_V4HFmode:
          if (pattern577 (x1, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
            return -1;
          return 65;

        case E_V8HFmode:
          if (pattern577 (x1, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
            return -1;
          return 66;

        case E_V16HFmode:
          if (pattern577 (x1, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
            return -1;
          return 67;

        case E_V32HFmode:
          if (pattern577 (x1, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
            return -1;
          return 68;

        case E_V64HFmode:
          if (pattern577 (x1, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
            return -1;
          return 69;

        case E_V128HFmode:
          if (pattern577 (x1, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
            return -1;
          return 70;

        case E_V256HFmode:
          if (pattern577 (x1, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
            return -1;
          return 71;

        case E_V512HFmode:
          if (pattern577 (x1, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
            return -1;
          return 72;

        case E_V1024HFmode:
          if (pattern577 (x1, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
            return -1;
          return 73;

        case E_V2048HFmode:
          if (pattern577 (x1, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
            return -1;
          return 74;

        case E_V1SFmode:
          if (pattern577 (x1, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
            return -1;
          return 75;

        case E_V2SFmode:
          if (pattern577 (x1, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
            return -1;
          return 76;

        case E_V4SFmode:
          if (pattern577 (x1, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
            return -1;
          return 77;

        case E_V8SFmode:
          if (pattern577 (x1, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
            return -1;
          return 78;

        case E_V16SFmode:
          if (pattern577 (x1, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
            return -1;
          return 79;

        case E_V32SFmode:
          if (pattern577 (x1, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
            return -1;
          return 80;

        case E_V64SFmode:
          if (pattern577 (x1, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
            return -1;
          return 81;

        case E_V128SFmode:
          if (pattern577 (x1, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
            return -1;
          return 82;

        case E_V256SFmode:
          if (pattern577 (x1, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
            return -1;
          return 83;

        case E_V512SFmode:
          if (pattern577 (x1, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
            return -1;
          return 84;

        case E_V1024SFmode:
          if (pattern577 (x1, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0)
            return -1;
          return 85;

        case E_V1DFmode:
          if (pattern577 (x1, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0)
            return -1;
          return 86;

        case E_V2DFmode:
          if (pattern577 (x1, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0)
            return -1;
          return 87;

        case E_V4DFmode:
          if (pattern577 (x1, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0)
            return -1;
          return 88;

        case E_V8DFmode:
          if (pattern577 (x1, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0)
            return -1;
          return 89;

        case E_V16DFmode:
          if (pattern577 (x1, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0)
            return -1;
          return 90;

        case E_V32DFmode:
          if (pattern577 (x1, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0)
            return -1;
          return 91;

        case E_V64DFmode:
          if (pattern577 (x1, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0)
            return -1;
          return 92;

        case E_V128DFmode:
          if (pattern577 (x1, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0)
            return -1;
          return 93;

        case E_V256DFmode:
          if (pattern577 (x1, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0)
            return -1;
          return 94;

        case E_V512DFmode:
          if (pattern577 (x1, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0)
            return -1;
          return 95;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x12 = XEXP (x3, 1);
      if (GET_CODE (x12) != FLOAT_EXTEND)
        return -1;
      x5 = XEXP (x1, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XVECEXP (x5, 0, 5);
      operands[9] = x10;
      x14 = XEXP (x12, 0);
      operands[4] = x14;
      x13 = XEXP (x2, 1);
      operands[2] = x13;
      x15 = XEXP (x1, 2);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x11 = XEXP (x4, 0);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[3] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              return 96;

            case E_RVVM4SFmode:
              return 97;

            case E_RVVM2SFmode:
              return 98;

            case E_RVVM1SFmode:
              return 99;

            case E_RVVMF2SFmode:
              return 100;

            case E_RVVM8DFmode:
              return 101;

            case E_RVVM4DFmode:
              return 102;

            case E_RVVM2DFmode:
              return 103;

            case E_RVVM1DFmode:
              return 104;

            case E_V1SFmode:
              return 105;

            case E_V2SFmode:
              return 106;

            case E_V4SFmode:
              return 107;

            case E_V8SFmode:
              return 108;

            case E_V16SFmode:
              return 109;

            case E_V32SFmode:
              return 110;

            case E_V64SFmode:
              return 111;

            case E_V128SFmode:
              return 112;

            case E_V256SFmode:
              return 113;

            case E_V512SFmode:
              return 114;

            case E_V1024SFmode:
              return 115;

            case E_V1DFmode:
              return 116;

            case E_V2DFmode:
              return 117;

            case E_V4DFmode:
              return 118;

            case E_V8DFmode:
              return 119;

            case E_V16DFmode:
              return 120;

            case E_V32DFmode:
              return 121;

            case E_V64DFmode:
              return 122;

            case E_V128DFmode:
              return 123;

            case E_V256DFmode:
              return 124;

            case E_V512DFmode:
              return 125;

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x16 = XEXP (x11, 0);
          operands[3] = x16;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              return 126;

            case E_RVVM4SFmode:
              return 127;

            case E_RVVM2SFmode:
              return 128;

            case E_RVVM1SFmode:
              return 129;

            case E_RVVMF2SFmode:
              return 130;

            case E_RVVM8DFmode:
              return 131;

            case E_RVVM4DFmode:
              return 132;

            case E_RVVM2DFmode:
              return 133;

            case E_RVVM1DFmode:
              return 134;

            case E_V1SFmode:
              return 135;

            case E_V2SFmode:
              return 136;

            case E_V4SFmode:
              return 137;

            case E_V8SFmode:
              return 138;

            case E_V16SFmode:
              return 139;

            case E_V32SFmode:
              return 140;

            case E_V64SFmode:
              return 141;

            case E_V128SFmode:
              return 142;

            case E_V256SFmode:
              return 143;

            case E_V512SFmode:
              return 144;

            case E_V1024SFmode:
              return 145;

            case E_V1DFmode:
              return 146;

            case E_V2DFmode:
              return 147;

            case E_V4DFmode:
              return 148;

            case E_V8DFmode:
              return 149;

            case E_V16DFmode:
              return 150;

            case E_V32DFmode:
              return 151;

            case E_V64DFmode:
              return 152;

            case E_V128DFmode:
              return 153;

            case E_V256DFmode:
              return 154;

            case E_V512DFmode:
              return 155;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern664 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH
      || !pmode_reg_or_0_operand (operands[3], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern472 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      res = pattern642 (x1, 
E_RVVM4QImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_RVVM2QImode:
      res = pattern643 (x1, 
E_RVVM2QImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_RVVM1QImode:
      res = pattern644 (x1, 
E_RVVM1QImode);
      if (res >= 0)
        return res + 6; /* [6, 9] */
      return -1;

    case E_RVVMF2QImode:
      res = pattern645 (x1, 
E_RVVMF2QImode);
      if (res >= 0)
        return res + 10; /* [10, 13] */
      return -1;

    case E_RVVMF4QImode:
      res = pattern646 (x1, 
E_RVVMF4QImode);
      if (res >= 0)
        return res + 14; /* [14, 17] */
      return -1;

    case E_RVVMF8QImode:
      res = pattern647 (x1, 
E_RVVMF8QImode);
      if (res >= 0)
        return res + 18; /* [18, 21] */
      return -1;

    case E_RVVM8HImode:
      res = pattern648 (x1, 
E_RVVM8HImode);
      if (res >= 0)
        return res + 22; /* [22, 23] */
      return -1;

    case E_RVVM4HImode:
      res = pattern649 (x1, 
E_RVVM4HImode);
      if (res >= 0)
        return res + 24; /* [24, 26] */
      return -1;

    case E_RVVM2HImode:
      res = pattern650 (x1, 
E_RVVM2HImode);
      if (res >= 0)
        return res + 27; /* [27, 30] */
      return -1;

    case E_RVVM1HImode:
      res = pattern651 (x1, 
E_RVVM1HImode);
      if (res >= 0)
        return res + 31; /* [31, 34] */
      return -1;

    case E_RVVMF2HImode:
      res = pattern652 (x1, 
E_RVVMF2HImode);
      if (res >= 0)
        return res + 35; /* [35, 38] */
      return -1;

    case E_RVVMF4HImode:
      res = pattern653 (x1, 
E_RVVMF4HImode);
      if (res >= 0)
        return res + 39; /* [39, 42] */
      return -1;

    case E_RVVM8SImode:
      res = pattern654 (x1, 
E_RVVM8SImode);
      if (res >= 0)
        return res + 43; /* [43, 45] */
      return -1;

    case E_RVVM4SImode:
      res = pattern655 (x1, 
E_RVVM4SImode);
      if (res >= 0)
        return res + 46; /* [46, 49] */
      return -1;

    case E_RVVM2SImode:
      res = pattern656 (x1, 
E_RVVM2SImode);
      if (res >= 0)
        return res + 50; /* [50, 53] */
      return -1;

    case E_RVVM1SImode:
      res = pattern657 (x1, 
E_RVVM1SImode);
      if (res >= 0)
        return res + 54; /* [54, 57] */
      return -1;

    case E_RVVMF2SImode:
      res = pattern658 (x1, 
E_RVVMF2SImode);
      if (res >= 0)
        return res + 58; /* [58, 61] */
      return -1;

    case E_RVVM8DImode:
      res = pattern659 (x1, 
E_RVVM8DImode);
      if (res >= 0)
        return res + 62; /* [62, 65] */
      return -1;

    case E_RVVM4DImode:
      res = pattern660 (x1, 
E_RVVM4DImode);
      if (res >= 0)
        return res + 66; /* [66, 69] */
      return -1;

    case E_RVVM2DImode:
      res = pattern661 (x1, 
E_RVVM2DImode);
      if (res >= 0)
        return res + 70; /* [70, 73] */
      return -1;

    case E_RVVM1DImode:
      res = pattern662 (x1, 
E_RVVM1DImode);
      if (res >= 0)
        return res + 74; /* [74, 77] */
      return -1;

    case E_RVVM8BFmode:
      res = pattern648 (x1, 
E_RVVM8BFmode);
      if (res >= 0)
        return res + 78; /* [78, 79] */
      return -1;

    case E_RVVM4BFmode:
      res = pattern649 (x1, 
E_RVVM4BFmode);
      if (res >= 0)
        return res + 80; /* [80, 82] */
      return -1;

    case E_RVVM2BFmode:
      res = pattern650 (x1, 
E_RVVM2BFmode);
      if (res >= 0)
        return res + 83; /* [83, 86] */
      return -1;

    case E_RVVM1BFmode:
      res = pattern651 (x1, 
E_RVVM1BFmode);
      if (res >= 0)
        return res + 87; /* [87, 90] */
      return -1;

    case E_RVVMF2BFmode:
      res = pattern652 (x1, 
E_RVVMF2BFmode);
      if (res >= 0)
        return res + 91; /* [91, 94] */
      return -1;

    case E_RVVMF4BFmode:
      res = pattern653 (x1, 
E_RVVMF4BFmode);
      if (res >= 0)
        return res + 95; /* [95, 98] */
      return -1;

    case E_RVVM8HFmode:
      res = pattern648 (x1, 
E_RVVM8HFmode);
      if (res >= 0)
        return res + 99; /* [99, 100] */
      return -1;

    case E_RVVM4HFmode:
      res = pattern649 (x1, 
E_RVVM4HFmode);
      if (res >= 0)
        return res + 101; /* [101, 103] */
      return -1;

    case E_RVVM2HFmode:
      res = pattern650 (x1, 
E_RVVM2HFmode);
      if (res >= 0)
        return res + 104; /* [104, 107] */
      return -1;

    case E_RVVM1HFmode:
      res = pattern651 (x1, 
E_RVVM1HFmode);
      if (res >= 0)
        return res + 108; /* [108, 111] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern652 (x1, 
E_RVVMF2HFmode);
      if (res >= 0)
        return res + 112; /* [112, 115] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern653 (x1, 
E_RVVMF4HFmode);
      if (res >= 0)
        return res + 116; /* [116, 119] */
      return -1;

    case E_RVVM8SFmode:
      res = pattern654 (x1, 
E_RVVM8SFmode);
      if (res >= 0)
        return res + 120; /* [120, 122] */
      return -1;

    case E_RVVM4SFmode:
      res = pattern655 (x1, 
E_RVVM4SFmode);
      if (res >= 0)
        return res + 123; /* [123, 126] */
      return -1;

    case E_RVVM2SFmode:
      res = pattern656 (x1, 
E_RVVM2SFmode);
      if (res >= 0)
        return res + 127; /* [127, 130] */
      return -1;

    case E_RVVM1SFmode:
      res = pattern657 (x1, 
E_RVVM1SFmode);
      if (res >= 0)
        return res + 131; /* [131, 134] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern658 (x1, 
E_RVVMF2SFmode);
      if (res >= 0)
        return res + 135; /* [135, 138] */
      return -1;

    case E_RVVM8DFmode:
      res = pattern659 (x1, 
E_RVVM8DFmode);
      if (res >= 0)
        return res + 139; /* [139, 142] */
      return -1;

    case E_RVVM4DFmode:
      res = pattern660 (x1, 
E_RVVM4DFmode);
      if (res >= 0)
        return res + 143; /* [143, 146] */
      return -1;

    case E_RVVM2DFmode:
      res = pattern661 (x1, 
E_RVVM2DFmode);
      if (res >= 0)
        return res + 147; /* [147, 150] */
      return -1;

    case E_RVVM1DFmode:
      res = pattern662 (x1, 
E_RVVM1DFmode);
      if (res >= 0)
        return res + 151; /* [151, 154] */
      return -1;

    case E_V1QImode:
      if (pattern472 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 155;

    case E_V2QImode:
      if (pattern472 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 156;

    case E_V4QImode:
      if (pattern472 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 157;

    case E_V8QImode:
      if (pattern472 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 158;

    case E_V16QImode:
      if (pattern472 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 159;

    case E_V32QImode:
      if (pattern472 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 160;

    case E_V64QImode:
      if (pattern472 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 161;

    case E_V128QImode:
      if (pattern472 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 162;

    case E_V256QImode:
      if (pattern472 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 163;

    case E_V512QImode:
      if (pattern472 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 164;

    case E_V1024QImode:
      if (pattern472 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 165;

    case E_V2048QImode:
      if (pattern472 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 166;

    case E_V4096QImode:
      if (pattern472 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 167;

    case E_V1HImode:
      if (pattern472 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 168;

    case E_V2HImode:
      if (pattern472 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 169;

    case E_V4HImode:
      if (pattern472 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 170;

    case E_V8HImode:
      if (pattern472 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 171;

    case E_V16HImode:
      if (pattern472 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 172;

    case E_V32HImode:
      if (pattern472 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 173;

    case E_V64HImode:
      if (pattern472 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 174;

    case E_V128HImode:
      if (pattern472 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 175;

    case E_V256HImode:
      if (pattern472 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 176;

    case E_V512HImode:
      if (pattern472 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 177;

    case E_V1024HImode:
      if (pattern472 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 178;

    case E_V2048HImode:
      if (pattern472 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 179;

    case E_V1SImode:
      if (pattern472 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 180;

    case E_V2SImode:
      if (pattern472 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 181;

    case E_V4SImode:
      if (pattern472 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 182;

    case E_V8SImode:
      if (pattern472 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 183;

    case E_V16SImode:
      if (pattern472 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 184;

    case E_V32SImode:
      if (pattern472 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 185;

    case E_V64SImode:
      if (pattern472 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 186;

    case E_V128SImode:
      if (pattern472 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 187;

    case E_V256SImode:
      if (pattern472 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 188;

    case E_V512SImode:
      if (pattern472 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 189;

    case E_V1024SImode:
      if (pattern472 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 190;

    case E_V1DImode:
      if (pattern472 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 191;

    case E_V2DImode:
      if (pattern472 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 192;

    case E_V4DImode:
      if (pattern472 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 193;

    case E_V8DImode:
      if (pattern472 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 194;

    case E_V16DImode:
      if (pattern472 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 195;

    case E_V32DImode:
      if (pattern472 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 196;

    case E_V64DImode:
      if (pattern472 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 197;

    case E_V128DImode:
      if (pattern472 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 198;

    case E_V256DImode:
      if (pattern472 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 199;

    case E_V512DImode:
      if (pattern472 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 200;

    case E_V1HFmode:
      if (pattern663 (x1, 
E_V1HFmode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 201;

    case E_V2HFmode:
      if (pattern663 (x1, 
E_V2HFmode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 202;

    case E_V4HFmode:
      if (pattern663 (x1, 
E_V4HFmode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 203;

    case E_V8HFmode:
      if (pattern663 (x1, 
E_V8HFmode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 204;

    case E_V16HFmode:
      if (pattern663 (x1, 
E_V16HFmode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 205;

    case E_V32HFmode:
      if (pattern663 (x1, 
E_V32HFmode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 206;

    case E_V64HFmode:
      if (pattern663 (x1, 
E_V64HFmode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 207;

    case E_V128HFmode:
      if (pattern663 (x1, 
E_V128HFmode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 208;

    case E_V256HFmode:
      if (pattern663 (x1, 
E_V256HFmode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 209;

    case E_V512HFmode:
      if (pattern663 (x1, 
E_V512HFmode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 210;

    case E_V1024HFmode:
      if (pattern663 (x1, 
E_V1024HFmode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 211;

    case E_V2048HFmode:
      if (pattern663 (x1, 
E_V2048HFmode, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 212;

    case E_V1SFmode:
      if (pattern663 (x1, 
E_V1SFmode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 213;

    case E_V2SFmode:
      if (pattern663 (x1, 
E_V2SFmode, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 214;

    case E_V4SFmode:
      if (pattern663 (x1, 
E_V4SFmode, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 215;

    case E_V8SFmode:
      if (pattern663 (x1, 
E_V8SFmode, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 216;

    case E_V16SFmode:
      if (pattern663 (x1, 
E_V16SFmode, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 217;

    case E_V32SFmode:
      if (pattern663 (x1, 
E_V32SFmode, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 218;

    case E_V64SFmode:
      if (pattern663 (x1, 
E_V64SFmode, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 219;

    case E_V128SFmode:
      if (pattern663 (x1, 
E_V128SFmode, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 220;

    case E_V256SFmode:
      if (pattern663 (x1, 
E_V256SFmode, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 221;

    case E_V512SFmode:
      if (pattern663 (x1, 
E_V512SFmode, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 222;

    case E_V1024SFmode:
      if (pattern663 (x1, 
E_V1024SFmode, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 223;

    case E_V1DFmode:
      if (pattern663 (x1, 
E_V1DFmode, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 224;

    case E_V2DFmode:
      if (pattern663 (x1, 
E_V2DFmode, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 225;

    case E_V4DFmode:
      if (pattern663 (x1, 
E_V4DFmode, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 226;

    case E_V8DFmode:
      if (pattern663 (x1, 
E_V8DFmode, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 227;

    case E_V16DFmode:
      if (pattern663 (x1, 
E_V16DFmode, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 228;

    case E_V32DFmode:
      if (pattern663 (x1, 
E_V32DFmode, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 229;

    case E_V64DFmode:
      if (pattern663 (x1, 
E_V64DFmode, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 230;

    case E_V128DFmode:
      if (pattern663 (x1, 
E_V128DFmode, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 231;

    case E_V256DFmode:
      if (pattern663 (x1, 
E_V256DFmode, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 232;

    case E_V512DFmode:
      if (pattern663 (x1, 
E_V512DFmode, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 233;

    case E_RVVMF8x2QImode:
      res = pattern647 (x1, 
E_RVVMF8x2QImode);
      if (res >= 0)
        return res + 234; /* [234, 237] */
      return -1;

    case E_RVVMF8x3QImode:
      res = pattern647 (x1, 
E_RVVMF8x3QImode);
      if (res >= 0)
        return res + 238; /* [238, 241] */
      return -1;

    case E_RVVMF8x4QImode:
      res = pattern647 (x1, 
E_RVVMF8x4QImode);
      if (res >= 0)
        return res + 242; /* [242, 245] */
      return -1;

    case E_RVVMF8x5QImode:
      res = pattern647 (x1, 
E_RVVMF8x5QImode);
      if (res >= 0)
        return res + 246; /* [246, 249] */
      return -1;

    case E_RVVMF8x6QImode:
      res = pattern647 (x1, 
E_RVVMF8x6QImode);
      if (res >= 0)
        return res + 250; /* [250, 253] */
      return -1;

    case E_RVVMF8x7QImode:
      res = pattern647 (x1, 
E_RVVMF8x7QImode);
      if (res >= 0)
        return res + 254; /* [254, 257] */
      return -1;

    case E_RVVMF8x8QImode:
      res = pattern647 (x1, 
E_RVVMF8x8QImode);
      if (res >= 0)
        return res + 258; /* [258, 261] */
      return -1;

    case E_RVVMF4x2HImode:
      res = pattern647 (x1, 
E_RVVMF4x2HImode);
      if (res >= 0)
        return res + 262; /* [262, 265] */
      return -1;

    case E_RVVMF4x3HImode:
      res = pattern647 (x1, 
E_RVVMF4x3HImode);
      if (res >= 0)
        return res + 266; /* [266, 269] */
      return -1;

    case E_RVVMF4x4HImode:
      res = pattern647 (x1, 
E_RVVMF4x4HImode);
      if (res >= 0)
        return res + 270; /* [270, 273] */
      return -1;

    case E_RVVMF4x5HImode:
      res = pattern647 (x1, 
E_RVVMF4x5HImode);
      if (res >= 0)
        return res + 274; /* [274, 277] */
      return -1;

    case E_RVVMF4x6HImode:
      res = pattern647 (x1, 
E_RVVMF4x6HImode);
      if (res >= 0)
        return res + 278; /* [278, 281] */
      return -1;

    case E_RVVMF4x7HImode:
      res = pattern647 (x1, 
E_RVVMF4x7HImode);
      if (res >= 0)
        return res + 282; /* [282, 285] */
      return -1;

    case E_RVVMF4x8HImode:
      res = pattern647 (x1, 
E_RVVMF4x8HImode);
      if (res >= 0)
        return res + 286; /* [286, 289] */
      return -1;

    case E_RVVMF2x2SImode:
      res = pattern647 (x1, 
E_RVVMF2x2SImode);
      if (res >= 0)
        return res + 290; /* [290, 293] */
      return -1;

    case E_RVVMF2x3SImode:
      res = pattern647 (x1, 
E_RVVMF2x3SImode);
      if (res >= 0)
        return res + 294; /* [294, 297] */
      return -1;

    case E_RVVMF2x4SImode:
      res = pattern647 (x1, 
E_RVVMF2x4SImode);
      if (res >= 0)
        return res + 298; /* [298, 301] */
      return -1;

    case E_RVVMF2x5SImode:
      res = pattern647 (x1, 
E_RVVMF2x5SImode);
      if (res >= 0)
        return res + 302; /* [302, 305] */
      return -1;

    case E_RVVMF2x6SImode:
      res = pattern647 (x1, 
E_RVVMF2x6SImode);
      if (res >= 0)
        return res + 306; /* [306, 309] */
      return -1;

    case E_RVVMF2x7SImode:
      res = pattern647 (x1, 
E_RVVMF2x7SImode);
      if (res >= 0)
        return res + 310; /* [310, 313] */
      return -1;

    case E_RVVMF2x8SImode:
      res = pattern647 (x1, 
E_RVVMF2x8SImode);
      if (res >= 0)
        return res + 314; /* [314, 317] */
      return -1;

    case E_RVVM1x2DImode:
      res = pattern647 (x1, 
E_RVVM1x2DImode);
      if (res >= 0)
        return res + 318; /* [318, 321] */
      return -1;

    case E_RVVM1x3DImode:
      res = pattern647 (x1, 
E_RVVM1x3DImode);
      if (res >= 0)
        return res + 322; /* [322, 325] */
      return -1;

    case E_RVVM1x4DImode:
      res = pattern647 (x1, 
E_RVVM1x4DImode);
      if (res >= 0)
        return res + 326; /* [326, 329] */
      return -1;

    case E_RVVM1x5DImode:
      res = pattern647 (x1, 
E_RVVM1x5DImode);
      if (res >= 0)
        return res + 330; /* [330, 333] */
      return -1;

    case E_RVVM1x6DImode:
      res = pattern647 (x1, 
E_RVVM1x6DImode);
      if (res >= 0)
        return res + 334; /* [334, 337] */
      return -1;

    case E_RVVM1x7DImode:
      res = pattern647 (x1, 
E_RVVM1x7DImode);
      if (res >= 0)
        return res + 338; /* [338, 341] */
      return -1;

    case E_RVVM1x8DImode:
      res = pattern647 (x1, 
E_RVVM1x8DImode);
      if (res >= 0)
        return res + 342; /* [342, 345] */
      return -1;

    case E_RVVMF4x2BFmode:
      res = pattern647 (x1, 
E_RVVMF4x2BFmode);
      if (res >= 0)
        return res + 346; /* [346, 349] */
      return -1;

    case E_RVVMF4x3BFmode:
      res = pattern647 (x1, 
E_RVVMF4x3BFmode);
      if (res >= 0)
        return res + 350; /* [350, 353] */
      return -1;

    case E_RVVMF4x4BFmode:
      res = pattern647 (x1, 
E_RVVMF4x4BFmode);
      if (res >= 0)
        return res + 354; /* [354, 357] */
      return -1;

    case E_RVVMF4x5BFmode:
      res = pattern647 (x1, 
E_RVVMF4x5BFmode);
      if (res >= 0)
        return res + 358; /* [358, 361] */
      return -1;

    case E_RVVMF4x6BFmode:
      res = pattern647 (x1, 
E_RVVMF4x6BFmode);
      if (res >= 0)
        return res + 362; /* [362, 365] */
      return -1;

    case E_RVVMF4x7BFmode:
      res = pattern647 (x1, 
E_RVVMF4x7BFmode);
      if (res >= 0)
        return res + 366; /* [366, 369] */
      return -1;

    case E_RVVMF4x8BFmode:
      res = pattern647 (x1, 
E_RVVMF4x8BFmode);
      if (res >= 0)
        return res + 370; /* [370, 373] */
      return -1;

    case E_RVVMF4x2HFmode:
      res = pattern647 (x1, 
E_RVVMF4x2HFmode);
      if (res >= 0)
        return res + 374; /* [374, 377] */
      return -1;

    case E_RVVMF4x3HFmode:
      res = pattern647 (x1, 
E_RVVMF4x3HFmode);
      if (res >= 0)
        return res + 378; /* [378, 381] */
      return -1;

    case E_RVVMF4x4HFmode:
      res = pattern647 (x1, 
E_RVVMF4x4HFmode);
      if (res >= 0)
        return res + 382; /* [382, 385] */
      return -1;

    case E_RVVMF4x5HFmode:
      res = pattern647 (x1, 
E_RVVMF4x5HFmode);
      if (res >= 0)
        return res + 386; /* [386, 389] */
      return -1;

    case E_RVVMF4x6HFmode:
      res = pattern647 (x1, 
E_RVVMF4x6HFmode);
      if (res >= 0)
        return res + 390; /* [390, 393] */
      return -1;

    case E_RVVMF4x7HFmode:
      res = pattern647 (x1, 
E_RVVMF4x7HFmode);
      if (res >= 0)
        return res + 394; /* [394, 397] */
      return -1;

    case E_RVVMF4x8HFmode:
      res = pattern647 (x1, 
E_RVVMF4x8HFmode);
      if (res >= 0)
        return res + 398; /* [398, 401] */
      return -1;

    case E_RVVMF2x2SFmode:
      res = pattern647 (x1, 
E_RVVMF2x2SFmode);
      if (res >= 0)
        return res + 402; /* [402, 405] */
      return -1;

    case E_RVVMF2x3SFmode:
      res = pattern647 (x1, 
E_RVVMF2x3SFmode);
      if (res >= 0)
        return res + 406; /* [406, 409] */
      return -1;

    case E_RVVMF2x4SFmode:
      res = pattern647 (x1, 
E_RVVMF2x4SFmode);
      if (res >= 0)
        return res + 410; /* [410, 413] */
      return -1;

    case E_RVVMF2x5SFmode:
      res = pattern647 (x1, 
E_RVVMF2x5SFmode);
      if (res >= 0)
        return res + 414; /* [414, 417] */
      return -1;

    case E_RVVMF2x6SFmode:
      res = pattern647 (x1, 
E_RVVMF2x6SFmode);
      if (res >= 0)
        return res + 418; /* [418, 421] */
      return -1;

    case E_RVVMF2x7SFmode:
      res = pattern647 (x1, 
E_RVVMF2x7SFmode);
      if (res >= 0)
        return res + 422; /* [422, 425] */
      return -1;

    case E_RVVMF2x8SFmode:
      res = pattern647 (x1, 
E_RVVMF2x8SFmode);
      if (res >= 0)
        return res + 426; /* [426, 429] */
      return -1;

    case E_RVVM1x2DFmode:
      res = pattern647 (x1, 
E_RVVM1x2DFmode);
      if (res >= 0)
        return res + 430; /* [430, 433] */
      return -1;

    case E_RVVM1x3DFmode:
      res = pattern647 (x1, 
E_RVVM1x3DFmode);
      if (res >= 0)
        return res + 434; /* [434, 437] */
      return -1;

    case E_RVVM1x4DFmode:
      res = pattern647 (x1, 
E_RVVM1x4DFmode);
      if (res >= 0)
        return res + 438; /* [438, 441] */
      return -1;

    case E_RVVM1x5DFmode:
      res = pattern647 (x1, 
E_RVVM1x5DFmode);
      if (res >= 0)
        return res + 442; /* [442, 445] */
      return -1;

    case E_RVVM1x6DFmode:
      res = pattern647 (x1, 
E_RVVM1x6DFmode);
      if (res >= 0)
        return res + 446; /* [446, 449] */
      return -1;

    case E_RVVM1x7DFmode:
      res = pattern647 (x1, 
E_RVVM1x7DFmode);
      if (res >= 0)
        return res + 450; /* [450, 453] */
      return -1;

    case E_RVVM1x8DFmode:
      res = pattern647 (x1, 
E_RVVM1x8DFmode);
      if (res >= 0)
        return res + 454; /* [454, 457] */
      return -1;

    case E_RVVMF4x2QImode:
      res = pattern646 (x1, 
E_RVVMF4x2QImode);
      if (res >= 0)
        return res + 458; /* [458, 461] */
      return -1;

    case E_RVVMF4x3QImode:
      res = pattern646 (x1, 
E_RVVMF4x3QImode);
      if (res >= 0)
        return res + 462; /* [462, 465] */
      return -1;

    case E_RVVMF4x4QImode:
      res = pattern646 (x1, 
E_RVVMF4x4QImode);
      if (res >= 0)
        return res + 466; /* [466, 469] */
      return -1;

    case E_RVVMF4x5QImode:
      res = pattern646 (x1, 
E_RVVMF4x5QImode);
      if (res >= 0)
        return res + 470; /* [470, 473] */
      return -1;

    case E_RVVMF4x6QImode:
      res = pattern646 (x1, 
E_RVVMF4x6QImode);
      if (res >= 0)
        return res + 474; /* [474, 477] */
      return -1;

    case E_RVVMF4x7QImode:
      res = pattern646 (x1, 
E_RVVMF4x7QImode);
      if (res >= 0)
        return res + 478; /* [478, 481] */
      return -1;

    case E_RVVMF4x8QImode:
      res = pattern646 (x1, 
E_RVVMF4x8QImode);
      if (res >= 0)
        return res + 482; /* [482, 485] */
      return -1;

    case E_RVVMF2x2HImode:
      res = pattern646 (x1, 
E_RVVMF2x2HImode);
      if (res >= 0)
        return res + 486; /* [486, 489] */
      return -1;

    case E_RVVMF2x3HImode:
      res = pattern646 (x1, 
E_RVVMF2x3HImode);
      if (res >= 0)
        return res + 490; /* [490, 493] */
      return -1;

    case E_RVVMF2x4HImode:
      res = pattern646 (x1, 
E_RVVMF2x4HImode);
      if (res >= 0)
        return res + 494; /* [494, 497] */
      return -1;

    case E_RVVMF2x5HImode:
      res = pattern646 (x1, 
E_RVVMF2x5HImode);
      if (res >= 0)
        return res + 498; /* [498, 501] */
      return -1;

    case E_RVVMF2x6HImode:
      res = pattern646 (x1, 
E_RVVMF2x6HImode);
      if (res >= 0)
        return res + 502; /* [502, 505] */
      return -1;

    case E_RVVMF2x7HImode:
      res = pattern646 (x1, 
E_RVVMF2x7HImode);
      if (res >= 0)
        return res + 506; /* [506, 509] */
      return -1;

    case E_RVVMF2x8HImode:
      res = pattern646 (x1, 
E_RVVMF2x8HImode);
      if (res >= 0)
        return res + 510; /* [510, 513] */
      return -1;

    case E_RVVM1x2SImode:
      res = pattern646 (x1, 
E_RVVM1x2SImode);
      if (res >= 0)
        return res + 514; /* [514, 517] */
      return -1;

    case E_RVVM1x3SImode:
      res = pattern646 (x1, 
E_RVVM1x3SImode);
      if (res >= 0)
        return res + 518; /* [518, 521] */
      return -1;

    case E_RVVM1x4SImode:
      res = pattern646 (x1, 
E_RVVM1x4SImode);
      if (res >= 0)
        return res + 522; /* [522, 525] */
      return -1;

    case E_RVVM1x5SImode:
      res = pattern646 (x1, 
E_RVVM1x5SImode);
      if (res >= 0)
        return res + 526; /* [526, 529] */
      return -1;

    case E_RVVM1x6SImode:
      res = pattern646 (x1, 
E_RVVM1x6SImode);
      if (res >= 0)
        return res + 530; /* [530, 533] */
      return -1;

    case E_RVVM1x7SImode:
      res = pattern646 (x1, 
E_RVVM1x7SImode);
      if (res >= 0)
        return res + 534; /* [534, 537] */
      return -1;

    case E_RVVM1x8SImode:
      res = pattern646 (x1, 
E_RVVM1x8SImode);
      if (res >= 0)
        return res + 538; /* [538, 541] */
      return -1;

    case E_RVVM2x2DImode:
      res = pattern646 (x1, 
E_RVVM2x2DImode);
      if (res >= 0)
        return res + 542; /* [542, 545] */
      return -1;

    case E_RVVM2x3DImode:
      res = pattern646 (x1, 
E_RVVM2x3DImode);
      if (res >= 0)
        return res + 546; /* [546, 549] */
      return -1;

    case E_RVVM2x4DImode:
      res = pattern646 (x1, 
E_RVVM2x4DImode);
      if (res >= 0)
        return res + 550; /* [550, 553] */
      return -1;

    case E_RVVMF2x2BFmode:
      res = pattern646 (x1, 
E_RVVMF2x2BFmode);
      if (res >= 0)
        return res + 554; /* [554, 557] */
      return -1;

    case E_RVVMF2x3BFmode:
      res = pattern646 (x1, 
E_RVVMF2x3BFmode);
      if (res >= 0)
        return res + 558; /* [558, 561] */
      return -1;

    case E_RVVMF2x4BFmode:
      res = pattern646 (x1, 
E_RVVMF2x4BFmode);
      if (res >= 0)
        return res + 562; /* [562, 565] */
      return -1;

    case E_RVVMF2x5BFmode:
      res = pattern646 (x1, 
E_RVVMF2x5BFmode);
      if (res >= 0)
        return res + 566; /* [566, 569] */
      return -1;

    case E_RVVMF2x6BFmode:
      res = pattern646 (x1, 
E_RVVMF2x6BFmode);
      if (res >= 0)
        return res + 570; /* [570, 573] */
      return -1;

    case E_RVVMF2x7BFmode:
      res = pattern646 (x1, 
E_RVVMF2x7BFmode);
      if (res >= 0)
        return res + 574; /* [574, 577] */
      return -1;

    case E_RVVMF2x8BFmode:
      res = pattern646 (x1, 
E_RVVMF2x8BFmode);
      if (res >= 0)
        return res + 578; /* [578, 581] */
      return -1;

    case E_RVVMF2x2HFmode:
      res = pattern646 (x1, 
E_RVVMF2x2HFmode);
      if (res >= 0)
        return res + 582; /* [582, 585] */
      return -1;

    case E_RVVMF2x3HFmode:
      res = pattern646 (x1, 
E_RVVMF2x3HFmode);
      if (res >= 0)
        return res + 586; /* [586, 589] */
      return -1;

    case E_RVVMF2x4HFmode:
      res = pattern646 (x1, 
E_RVVMF2x4HFmode);
      if (res >= 0)
        return res + 590; /* [590, 593] */
      return -1;

    case E_RVVMF2x5HFmode:
      res = pattern646 (x1, 
E_RVVMF2x5HFmode);
      if (res >= 0)
        return res + 594; /* [594, 597] */
      return -1;

    case E_RVVMF2x6HFmode:
      res = pattern646 (x1, 
E_RVVMF2x6HFmode);
      if (res >= 0)
        return res + 598; /* [598, 601] */
      return -1;

    case E_RVVMF2x7HFmode:
      res = pattern646 (x1, 
E_RVVMF2x7HFmode);
      if (res >= 0)
        return res + 602; /* [602, 605] */
      return -1;

    case E_RVVMF2x8HFmode:
      res = pattern646 (x1, 
E_RVVMF2x8HFmode);
      if (res >= 0)
        return res + 606; /* [606, 609] */
      return -1;

    case E_RVVM1x2SFmode:
      res = pattern646 (x1, 
E_RVVM1x2SFmode);
      if (res >= 0)
        return res + 610; /* [610, 613] */
      return -1;

    case E_RVVM1x3SFmode:
      res = pattern646 (x1, 
E_RVVM1x3SFmode);
      if (res >= 0)
        return res + 614; /* [614, 617] */
      return -1;

    case E_RVVM1x4SFmode:
      res = pattern646 (x1, 
E_RVVM1x4SFmode);
      if (res >= 0)
        return res + 618; /* [618, 621] */
      return -1;

    case E_RVVM1x5SFmode:
      res = pattern646 (x1, 
E_RVVM1x5SFmode);
      if (res >= 0)
        return res + 622; /* [622, 625] */
      return -1;

    case E_RVVM1x6SFmode:
      res = pattern646 (x1, 
E_RVVM1x6SFmode);
      if (res >= 0)
        return res + 626; /* [626, 629] */
      return -1;

    case E_RVVM1x7SFmode:
      res = pattern646 (x1, 
E_RVVM1x7SFmode);
      if (res >= 0)
        return res + 630; /* [630, 633] */
      return -1;

    case E_RVVM1x8SFmode:
      res = pattern646 (x1, 
E_RVVM1x8SFmode);
      if (res >= 0)
        return res + 634; /* [634, 637] */
      return -1;

    case E_RVVM2x2DFmode:
      res = pattern646 (x1, 
E_RVVM2x2DFmode);
      if (res >= 0)
        return res + 638; /* [638, 641] */
      return -1;

    case E_RVVM2x3DFmode:
      res = pattern646 (x1, 
E_RVVM2x3DFmode);
      if (res >= 0)
        return res + 642; /* [642, 645] */
      return -1;

    case E_RVVM2x4DFmode:
      res = pattern646 (x1, 
E_RVVM2x4DFmode);
      if (res >= 0)
        return res + 646; /* [646, 649] */
      return -1;

    case E_RVVMF2x2QImode:
      res = pattern645 (x1, 
E_RVVMF2x2QImode);
      if (res >= 0)
        return res + 650; /* [650, 653] */
      return -1;

    case E_RVVMF2x3QImode:
      res = pattern645 (x1, 
E_RVVMF2x3QImode);
      if (res >= 0)
        return res + 654; /* [654, 657] */
      return -1;

    case E_RVVMF2x4QImode:
      res = pattern645 (x1, 
E_RVVMF2x4QImode);
      if (res >= 0)
        return res + 658; /* [658, 661] */
      return -1;

    case E_RVVMF2x5QImode:
      res = pattern645 (x1, 
E_RVVMF2x5QImode);
      if (res >= 0)
        return res + 662; /* [662, 665] */
      return -1;

    case E_RVVMF2x6QImode:
      res = pattern645 (x1, 
E_RVVMF2x6QImode);
      if (res >= 0)
        return res + 666; /* [666, 669] */
      return -1;

    case E_RVVMF2x7QImode:
      res = pattern645 (x1, 
E_RVVMF2x7QImode);
      if (res >= 0)
        return res + 670; /* [670, 673] */
      return -1;

    case E_RVVMF2x8QImode:
      res = pattern645 (x1, 
E_RVVMF2x8QImode);
      if (res >= 0)
        return res + 674; /* [674, 677] */
      return -1;

    case E_RVVM1x2HImode:
      res = pattern645 (x1, 
E_RVVM1x2HImode);
      if (res >= 0)
        return res + 678; /* [678, 681] */
      return -1;

    case E_RVVM1x3HImode:
      res = pattern645 (x1, 
E_RVVM1x3HImode);
      if (res >= 0)
        return res + 682; /* [682, 685] */
      return -1;

    case E_RVVM1x4HImode:
      res = pattern645 (x1, 
E_RVVM1x4HImode);
      if (res >= 0)
        return res + 686; /* [686, 689] */
      return -1;

    case E_RVVM1x5HImode:
      res = pattern645 (x1, 
E_RVVM1x5HImode);
      if (res >= 0)
        return res + 690; /* [690, 693] */
      return -1;

    case E_RVVM1x6HImode:
      res = pattern645 (x1, 
E_RVVM1x6HImode);
      if (res >= 0)
        return res + 694; /* [694, 697] */
      return -1;

    case E_RVVM1x7HImode:
      res = pattern645 (x1, 
E_RVVM1x7HImode);
      if (res >= 0)
        return res + 698; /* [698, 701] */
      return -1;

    case E_RVVM1x8HImode:
      res = pattern645 (x1, 
E_RVVM1x8HImode);
      if (res >= 0)
        return res + 702; /* [702, 705] */
      return -1;

    case E_RVVM2x2SImode:
      res = pattern645 (x1, 
E_RVVM2x2SImode);
      if (res >= 0)
        return res + 706; /* [706, 709] */
      return -1;

    case E_RVVM2x3SImode:
      res = pattern645 (x1, 
E_RVVM2x3SImode);
      if (res >= 0)
        return res + 710; /* [710, 713] */
      return -1;

    case E_RVVM2x4SImode:
      res = pattern645 (x1, 
E_RVVM2x4SImode);
      if (res >= 0)
        return res + 714; /* [714, 717] */
      return -1;

    case E_RVVM4x2DImode:
      res = pattern645 (x1, 
E_RVVM4x2DImode);
      if (res >= 0)
        return res + 718; /* [718, 721] */
      return -1;

    case E_RVVM1x2BFmode:
      res = pattern645 (x1, 
E_RVVM1x2BFmode);
      if (res >= 0)
        return res + 722; /* [722, 725] */
      return -1;

    case E_RVVM1x3BFmode:
      res = pattern645 (x1, 
E_RVVM1x3BFmode);
      if (res >= 0)
        return res + 726; /* [726, 729] */
      return -1;

    case E_RVVM1x4BFmode:
      res = pattern645 (x1, 
E_RVVM1x4BFmode);
      if (res >= 0)
        return res + 730; /* [730, 733] */
      return -1;

    case E_RVVM1x5BFmode:
      res = pattern645 (x1, 
E_RVVM1x5BFmode);
      if (res >= 0)
        return res + 734; /* [734, 737] */
      return -1;

    case E_RVVM1x6BFmode:
      res = pattern645 (x1, 
E_RVVM1x6BFmode);
      if (res >= 0)
        return res + 738; /* [738, 741] */
      return -1;

    case E_RVVM1x7BFmode:
      res = pattern645 (x1, 
E_RVVM1x7BFmode);
      if (res >= 0)
        return res + 742; /* [742, 745] */
      return -1;

    case E_RVVM1x8BFmode:
      res = pattern645 (x1, 
E_RVVM1x8BFmode);
      if (res >= 0)
        return res + 746; /* [746, 749] */
      return -1;

    case E_RVVM1x2HFmode:
      res = pattern645 (x1, 
E_RVVM1x2HFmode);
      if (res >= 0)
        return res + 750; /* [750, 753] */
      return -1;

    case E_RVVM1x3HFmode:
      res = pattern645 (x1, 
E_RVVM1x3HFmode);
      if (res >= 0)
        return res + 754; /* [754, 757] */
      return -1;

    case E_RVVM1x4HFmode:
      res = pattern645 (x1, 
E_RVVM1x4HFmode);
      if (res >= 0)
        return res + 758; /* [758, 761] */
      return -1;

    case E_RVVM1x5HFmode:
      res = pattern645 (x1, 
E_RVVM1x5HFmode);
      if (res >= 0)
        return res + 762; /* [762, 765] */
      return -1;

    case E_RVVM1x6HFmode:
      res = pattern645 (x1, 
E_RVVM1x6HFmode);
      if (res >= 0)
        return res + 766; /* [766, 769] */
      return -1;

    case E_RVVM1x7HFmode:
      res = pattern645 (x1, 
E_RVVM1x7HFmode);
      if (res >= 0)
        return res + 770; /* [770, 773] */
      return -1;

    case E_RVVM1x8HFmode:
      res = pattern645 (x1, 
E_RVVM1x8HFmode);
      if (res >= 0)
        return res + 774; /* [774, 777] */
      return -1;

    case E_RVVM2x2SFmode:
      res = pattern645 (x1, 
E_RVVM2x2SFmode);
      if (res >= 0)
        return res + 778; /* [778, 781] */
      return -1;

    case E_RVVM2x3SFmode:
      res = pattern645 (x1, 
E_RVVM2x3SFmode);
      if (res >= 0)
        return res + 782; /* [782, 785] */
      return -1;

    case E_RVVM2x4SFmode:
      res = pattern645 (x1, 
E_RVVM2x4SFmode);
      if (res >= 0)
        return res + 786; /* [786, 789] */
      return -1;

    case E_RVVM4x2DFmode:
      res = pattern645 (x1, 
E_RVVM4x2DFmode);
      if (res >= 0)
        return res + 790; /* [790, 793] */
      return -1;

    case E_RVVM1x2QImode:
      res = pattern644 (x1, 
E_RVVM1x2QImode);
      if (res >= 0)
        return res + 794; /* [794, 797] */
      return -1;

    case E_RVVM1x3QImode:
      res = pattern644 (x1, 
E_RVVM1x3QImode);
      if (res >= 0)
        return res + 798; /* [798, 801] */
      return -1;

    case E_RVVM1x4QImode:
      res = pattern644 (x1, 
E_RVVM1x4QImode);
      if (res >= 0)
        return res + 802; /* [802, 805] */
      return -1;

    case E_RVVM1x5QImode:
      res = pattern644 (x1, 
E_RVVM1x5QImode);
      if (res >= 0)
        return res + 806; /* [806, 809] */
      return -1;

    case E_RVVM1x6QImode:
      res = pattern644 (x1, 
E_RVVM1x6QImode);
      if (res >= 0)
        return res + 810; /* [810, 813] */
      return -1;

    case E_RVVM1x7QImode:
      res = pattern644 (x1, 
E_RVVM1x7QImode);
      if (res >= 0)
        return res + 814; /* [814, 817] */
      return -1;

    case E_RVVM1x8QImode:
      res = pattern644 (x1, 
E_RVVM1x8QImode);
      if (res >= 0)
        return res + 818; /* [818, 821] */
      return -1;

    case E_RVVM2x2HImode:
      res = pattern644 (x1, 
E_RVVM2x2HImode);
      if (res >= 0)
        return res + 822; /* [822, 825] */
      return -1;

    case E_RVVM2x3HImode:
      res = pattern644 (x1, 
E_RVVM2x3HImode);
      if (res >= 0)
        return res + 826; /* [826, 829] */
      return -1;

    case E_RVVM2x4HImode:
      res = pattern644 (x1, 
E_RVVM2x4HImode);
      if (res >= 0)
        return res + 830; /* [830, 833] */
      return -1;

    case E_RVVM4x2SImode:
      res = pattern644 (x1, 
E_RVVM4x2SImode);
      if (res >= 0)
        return res + 834; /* [834, 837] */
      return -1;

    case E_RVVM2x2BFmode:
      res = pattern644 (x1, 
E_RVVM2x2BFmode);
      if (res >= 0)
        return res + 838; /* [838, 841] */
      return -1;

    case E_RVVM2x3BFmode:
      res = pattern644 (x1, 
E_RVVM2x3BFmode);
      if (res >= 0)
        return res + 842; /* [842, 845] */
      return -1;

    case E_RVVM2x4BFmode:
      res = pattern644 (x1, 
E_RVVM2x4BFmode);
      if (res >= 0)
        return res + 846; /* [846, 849] */
      return -1;

    case E_RVVM2x2HFmode:
      res = pattern644 (x1, 
E_RVVM2x2HFmode);
      if (res >= 0)
        return res + 850; /* [850, 853] */
      return -1;

    case E_RVVM2x3HFmode:
      res = pattern644 (x1, 
E_RVVM2x3HFmode);
      if (res >= 0)
        return res + 854; /* [854, 857] */
      return -1;

    case E_RVVM2x4HFmode:
      res = pattern644 (x1, 
E_RVVM2x4HFmode);
      if (res >= 0)
        return res + 858; /* [858, 861] */
      return -1;

    case E_RVVM4x2SFmode:
      res = pattern644 (x1, 
E_RVVM4x2SFmode);
      if (res >= 0)
        return res + 862; /* [862, 865] */
      return -1;

    case E_RVVM2x2QImode:
      res = pattern643 (x1, 
E_RVVM2x2QImode);
      if (res >= 0)
        return res + 866; /* [866, 868] */
      return -1;

    case E_RVVM2x3QImode:
      res = pattern643 (x1, 
E_RVVM2x3QImode);
      if (res >= 0)
        return res + 869; /* [869, 871] */
      return -1;

    case E_RVVM2x4QImode:
      res = pattern643 (x1, 
E_RVVM2x4QImode);
      if (res >= 0)
        return res + 872; /* [872, 874] */
      return -1;

    case E_RVVM4x2HImode:
      res = pattern643 (x1, 
E_RVVM4x2HImode);
      if (res >= 0)
        return res + 875; /* [875, 877] */
      return -1;

    case E_RVVM4x2BFmode:
      res = pattern643 (x1, 
E_RVVM4x2BFmode);
      if (res >= 0)
        return res + 878; /* [878, 880] */
      return -1;

    case E_RVVM4x2HFmode:
      res = pattern643 (x1, 
E_RVVM4x2HFmode);
      if (res >= 0)
        return res + 881; /* [881, 883] */
      return -1;

    case E_RVVM4x2QImode:
      res = pattern642 (x1, 
E_RVVM4x2QImode);
      if (res >= 0)
        return res + 884; /* [884, 885] */
      return -1;

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!absolute_symbolic_operand (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!
#line 36 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 809; /* *local_pic_load_sqi */

        case E_HImode:
          if (!
#line 36 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 812; /* *local_pic_load_shi */

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!
#line 36 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 810; /* *local_pic_load_sqi */

        case E_HImode:
          if (!
#line 36 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 813; /* *local_pic_load_shi */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!(
#line 36 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 811; /* *local_pic_load_sqi */

        case E_HImode:
          if (!(
#line 36 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 814; /* *local_pic_load_shi */

        case E_SImode:
          if (!(
#line 36 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 817; /* *local_pic_load_ssi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SUBREG:
    case TRUNCATE:
      if (subreg_lowpart_operator (x3, E_SImode)
          && register_operand (operands[0], E_DImode))
        {
          res = recog_10 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_CODE (x3) == TRUNCATE)
        {
          switch (pattern197 (x2))
            {
            case 0:
              if (
#line 636 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
                return 33803; /* riscv_cv_alu_exths */
              break;

            case 1:
              if (
#line 658 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
                return 33805; /* riscv_cv_alu_extbs */
              break;

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode)
          || GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26103; /* extendrvvm4qirvvm8hi2 */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26105; /* extendrvvm2qirvvm4hi2 */

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26107; /* extendrvvm1qirvvm2hi2 */

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26109; /* extendrvvmf2qirvvm1hi2 */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26111; /* extendrvvmf4qirvvmf2hi2 */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 26113; /* extendrvvmf8qirvvmf4hi2 */

    case E_RVVM8SImode:
      switch (pattern291 (x2))
        {
        case 0:
          if (!
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26115; /* extendrvvm4hirvvm8si2 */

        case 1:
          if (!
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26199; /* extendrvvm2qirvvm8si2 */

        default:
          return -1;
        }

    case E_RVVM4SImode:
      switch (pattern292 (x2))
        {
        case 0:
          if (!
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26117; /* extendrvvm2hirvvm4si2 */

        case 1:
          if (!
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26201; /* extendrvvm1qirvvm4si2 */

        default:
          return -1;
        }

    case E_RVVM2SImode:
      switch (pattern293 (x2))
        {
        case 0:
          if (!
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26119; /* extendrvvm1hirvvm2si2 */

        case 1:
          if (!
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26203; /* extendrvvmf2qirvvm2si2 */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      switch (pattern294 (x2))
        {
        case 0:
          if (!
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26121; /* extendrvvmf2hirvvm1si2 */

        case 1:
          if (!
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26205; /* extendrvvmf4qirvvm1si2 */

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      switch (pattern295 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 26123; /* extendrvvmf4hirvvmf2si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 26207; /* extendrvvmf8qirvvmf2si2 */

        default:
          return -1;
        }

    case E_RVVM8DImode:
      switch (pattern296 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26125; /* extendrvvm4sirvvm8di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26209; /* extendrvvm2hirvvm8di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26259; /* extendrvvm1qirvvm8di2 */

        default:
          return -1;
        }

    case E_RVVM4DImode:
      switch (pattern297 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26127; /* extendrvvm2sirvvm4di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26211; /* extendrvvm1hirvvm4di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26261; /* extendrvvmf2qirvvm4di2 */

        default:
          return -1;
        }

    case E_RVVM2DImode:
      switch (pattern298 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26129; /* extendrvvm1sirvvm2di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26213; /* extendrvvmf2hirvvm2di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26263; /* extendrvvmf4qirvvm2di2 */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      switch (pattern299 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26131; /* extendrvvmf2sirvvm1di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26215; /* extendrvvmf4hirvvm1di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26265; /* extendrvvmf8qirvvm1di2 */

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 26133; /* extendv1qiv1hi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 26135; /* extendv2qiv2hi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 26137; /* extendv4qiv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 26139; /* extendv8qiv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 26141; /* extendv16qiv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26143; /* extendv32qiv32hi2 */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26145; /* extendv64qiv64hi2 */

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26147; /* extendv128qiv128hi2 */

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26149; /* extendv256qiv256hi2 */

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26151; /* extendv512qiv512hi2 */

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26153; /* extendv1024qiv1024hi2 */

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode)
          || GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26155; /* extendv2048qiv2048hi2 */

    case E_V1SImode:
      switch (pattern300 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 26157; /* extendv1hiv1si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 26217; /* extendv1qiv1si2 */

        default:
          return -1;
        }

    case E_V2SImode:
      switch (pattern301 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 26159; /* extendv2hiv2si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 26219; /* extendv2qiv2si2 */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern302 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 26161; /* extendv4hiv4si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 26221; /* extendv4qiv4si2 */

        default:
          return -1;
        }

    case E_V8SImode:
      switch (pattern303 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 26163; /* extendv8hiv8si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 26223; /* extendv8qiv8si2 */

        default:
          return -1;
        }

    case E_V16SImode:
      switch (pattern304 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26165; /* extendv16hiv16si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26225; /* extendv16qiv16si2 */

        default:
          return -1;
        }

    case E_V32SImode:
      switch (pattern305 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26167; /* extendv32hiv32si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26227; /* extendv32qiv32si2 */

        default:
          return -1;
        }

    case E_V64SImode:
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26169; /* extendv64hiv64si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26229; /* extendv64qiv64si2 */

        default:
          return -1;
        }

    case E_V128SImode:
      switch (pattern307 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26171; /* extendv128hiv128si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26231; /* extendv128qiv128si2 */

        default:
          return -1;
        }

    case E_V256SImode:
      switch (pattern308 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26173; /* extendv256hiv256si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26233; /* extendv256qiv256si2 */

        default:
          return -1;
        }

    case E_V512SImode:
      switch (pattern309 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26175; /* extendv512hiv512si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26235; /* extendv512qiv512si2 */

        default:
          return -1;
        }

    case E_V1024SImode:
      switch (pattern310 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26177; /* extendv1024hiv1024si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26237; /* extendv1024qiv1024si2 */

        default:
          return -1;
        }

    case E_V1DImode:
      switch (pattern311 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26179; /* extendv1siv1di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26239; /* extendv1hiv1di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26267; /* extendv1qiv1di2 */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern312 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26181; /* extendv2siv2di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26241; /* extendv2hiv2di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26269; /* extendv2qiv2di2 */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern313 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26183; /* extendv4siv4di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26243; /* extendv4hiv4di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26271; /* extendv4qiv4di2 */

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern314 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26185; /* extendv8siv8di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26245; /* extendv8hiv8di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26273; /* extendv8qiv8di2 */

        default:
          return -1;
        }

    case E_V16DImode:
      switch (pattern315 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26187; /* extendv16siv16di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26247; /* extendv16hiv16di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26275; /* extendv16qiv16di2 */

        default:
          return -1;
        }

    case E_V32DImode:
      switch (pattern316 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26189; /* extendv32siv32di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26249; /* extendv32hiv32di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26277; /* extendv32qiv32di2 */

        default:
          return -1;
        }

    case E_V64DImode:
      switch (pattern317 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26191; /* extendv64siv64di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26251; /* extendv64hiv64di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26279; /* extendv64qiv64di2 */

        default:
          return -1;
        }

    case E_V128DImode:
      switch (pattern318 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26193; /* extendv128siv128di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26253; /* extendv128hiv128di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26281; /* extendv128qiv128di2 */

        default:
          return -1;
        }

    case E_V256DImode:
      switch (pattern319 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26195; /* extendv256siv256di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26255; /* extendv256hiv256di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26283; /* extendv256qiv256di2 */

        default:
          return -1;
        }

    case E_V512DImode:
      switch (pattern320 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26197; /* extendv512siv512di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26257; /* extendv512hiv512di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26285; /* extendv512qiv512di2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case MULT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          switch (pattern378 (x2))
            {
            case 0:
              if (!
#line 1307 "../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
                return -1;
              return 30; /* smuldi3_highpart */

            case 1:
              if (!
#line 1368 "../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && !TARGET_64BIT))
                return -1;
              return 33; /* smulsi3_highpart */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case ZERO_EXTEND:
              switch (pattern378 (x2))
                {
                case 0:
                  if (!
#line 1307 "../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
                    return -1;
                  return 31; /* umuldi3_highpart */

                case 1:
                  if (!
#line 1368 "../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && !TARGET_64BIT))
                    return -1;
                  return 34; /* umulsi3_highpart */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern378 (x2))
                {
                case 0:
                  if (!
#line 1338 "../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
                    return -1;
                  return 32; /* usmuldi3_highpart */

                case 1:
                  if (!
#line 1399 "../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && !TARGET_64BIT))
                    return -1;
                  return 35; /* usmulsi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern155 (x2))
        {
        case 0:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29859; /* *narrow_lshrextendrvvm8hi */

        case 1:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29863; /* *narrow_lshrextendrvvm4hi */

        case 2:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29867; /* *narrow_lshrextendrvvm2hi */

        case 3:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29871; /* *narrow_lshrextendrvvm1hi */

        case 4:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29875; /* *narrow_lshrextendrvvmf2hi */

        case 5:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 29879; /* *narrow_lshrextendrvvmf4hi */

        case 6:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29883; /* *narrow_lshrextendrvvm8si */

        case 7:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29887; /* *narrow_lshrextendrvvm4si */

        case 8:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29891; /* *narrow_lshrextendrvvm2si */

        case 9:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29895; /* *narrow_lshrextendrvvm1si */

        case 10:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 29899; /* *narrow_lshrextendrvvmf2si */

        case 11:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29903; /* *narrow_lshrextendrvvm8di */

        case 12:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29907; /* *narrow_lshrextendrvvm4di */

        case 13:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29911; /* *narrow_lshrextendrvvm2di */

        case 14:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29915; /* *narrow_lshrextendrvvm1di */

        case 15:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 29919; /* *narrow_lshrextendv1hi */

        case 16:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 29923; /* *narrow_lshrextendv2hi */

        case 17:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 29927; /* *narrow_lshrextendv4hi */

        case 18:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 29931; /* *narrow_lshrextendv8hi */

        case 19:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 29935; /* *narrow_lshrextendv16hi */

        case 20:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 29939; /* *narrow_lshrextendv32hi */

        case 21:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 29943; /* *narrow_lshrextendv64hi */

        case 22:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 29947; /* *narrow_lshrextendv128hi */

        case 23:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 29951; /* *narrow_lshrextendv256hi */

        case 24:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 29955; /* *narrow_lshrextendv512hi */

        case 25:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 29959; /* *narrow_lshrextendv1024hi */

        case 26:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 29963; /* *narrow_lshrextendv2048hi */

        case 27:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 29967; /* *narrow_lshrextendv1si */

        case 28:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 29971; /* *narrow_lshrextendv2si */

        case 29:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 29975; /* *narrow_lshrextendv4si */

        case 30:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 29979; /* *narrow_lshrextendv8si */

        case 31:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 29983; /* *narrow_lshrextendv16si */

        case 32:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 29987; /* *narrow_lshrextendv32si */

        case 33:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 29991; /* *narrow_lshrextendv64si */

        case 34:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 29995; /* *narrow_lshrextendv128si */

        case 35:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 29999; /* *narrow_lshrextendv256si */

        case 36:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30003; /* *narrow_lshrextendv512si */

        case 37:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30007; /* *narrow_lshrextendv1024si */

        case 38:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30011; /* *narrow_lshrextendv1di */

        case 39:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30015; /* *narrow_lshrextendv2di */

        case 40:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30019; /* *narrow_lshrextendv4di */

        case 41:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30023; /* *narrow_lshrextendv8di */

        case 42:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30027; /* *narrow_lshrextendv16di */

        case 43:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30031; /* *narrow_lshrextendv32di */

        case 44:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30035; /* *narrow_lshrextendv64di */

        case 45:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30039; /* *narrow_lshrextendv128di */

        case 46:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30043; /* *narrow_lshrextendv256di */

        case 47:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30047; /* *narrow_lshrextendv512di */

        case 48:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29861; /* *narrow_lshrzero_extendrvvm8hi */

        case 49:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29865; /* *narrow_lshrzero_extendrvvm4hi */

        case 50:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29869; /* *narrow_lshrzero_extendrvvm2hi */

        case 51:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29873; /* *narrow_lshrzero_extendrvvm1hi */

        case 52:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29877; /* *narrow_lshrzero_extendrvvmf2hi */

        case 53:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 29881; /* *narrow_lshrzero_extendrvvmf4hi */

        case 54:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29885; /* *narrow_lshrzero_extendrvvm8si */

        case 55:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29889; /* *narrow_lshrzero_extendrvvm4si */

        case 56:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29893; /* *narrow_lshrzero_extendrvvm2si */

        case 57:
          if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29897; /* *narrow_lshrzero_extendrvvm1si */

        case 58:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 29901; /* *narrow_lshrzero_extendrvvmf2si */

        case 59:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29905; /* *narrow_lshrzero_extendrvvm8di */

        case 60:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29909; /* *narrow_lshrzero_extendrvvm4di */

        case 61:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29913; /* *narrow_lshrzero_extendrvvm2di */

        case 62:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29917; /* *narrow_lshrzero_extendrvvm1di */

        case 63:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 29921; /* *narrow_lshrzero_extendv1hi */

        case 64:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 29925; /* *narrow_lshrzero_extendv2hi */

        case 65:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 29929; /* *narrow_lshrzero_extendv4hi */

        case 66:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 29933; /* *narrow_lshrzero_extendv8hi */

        case 67:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 29937; /* *narrow_lshrzero_extendv16hi */

        case 68:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 29941; /* *narrow_lshrzero_extendv32hi */

        case 69:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 29945; /* *narrow_lshrzero_extendv64hi */

        case 70:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 29949; /* *narrow_lshrzero_extendv128hi */

        case 71:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 29953; /* *narrow_lshrzero_extendv256hi */

        case 72:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 29957; /* *narrow_lshrzero_extendv512hi */

        case 73:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 29961; /* *narrow_lshrzero_extendv1024hi */

        case 74:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 29965; /* *narrow_lshrzero_extendv2048hi */

        case 75:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 29969; /* *narrow_lshrzero_extendv1si */

        case 76:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 29973; /* *narrow_lshrzero_extendv2si */

        case 77:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 29977; /* *narrow_lshrzero_extendv4si */

        case 78:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 29981; /* *narrow_lshrzero_extendv8si */

        case 79:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 29985; /* *narrow_lshrzero_extendv16si */

        case 80:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 29989; /* *narrow_lshrzero_extendv32si */

        case 81:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 29993; /* *narrow_lshrzero_extendv64si */

        case 82:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 29997; /* *narrow_lshrzero_extendv128si */

        case 83:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30001; /* *narrow_lshrzero_extendv256si */

        case 84:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30005; /* *narrow_lshrzero_extendv512si */

        case 85:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30009; /* *narrow_lshrzero_extendv1024si */

        case 86:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30013; /* *narrow_lshrzero_extendv1di */

        case 87:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30017; /* *narrow_lshrzero_extendv2di */

        case 88:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30021; /* *narrow_lshrzero_extendv4di */

        case 89:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30025; /* *narrow_lshrzero_extendv8di */

        case 90:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30029; /* *narrow_lshrzero_extendv16di */

        case 91:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30033; /* *narrow_lshrzero_extendv32di */

        case 92:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30037; /* *narrow_lshrzero_extendv64di */

        case 93:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30041; /* *narrow_lshrzero_extendv128di */

        case 94:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30045; /* *narrow_lshrzero_extendv256di */

        case 95:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30049; /* *narrow_lshrzero_extendv512di */

        case 96:
          if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30051; /* *narrow_lshrrvvm8hi_scalar */

        case 97:
          if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30053; /* *narrow_lshrrvvm4hi_scalar */

        case 98:
          if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30055; /* *narrow_lshrrvvm2hi_scalar */

        case 99:
          if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30057; /* *narrow_lshrrvvm1hi_scalar */

        case 100:
          if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30059; /* *narrow_lshrrvvmf2hi_scalar */

        case 101:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30061; /* *narrow_lshrrvvmf4hi_scalar */

        case 102:
          if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30063; /* *narrow_lshrrvvm8si_scalar */

        case 103:
          if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30065; /* *narrow_lshrrvvm4si_scalar */

        case 104:
          if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30067; /* *narrow_lshrrvvm2si_scalar */

        case 105:
          if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30069; /* *narrow_lshrrvvm1si_scalar */

        case 106:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30071; /* *narrow_lshrrvvmf2si_scalar */

        case 107:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30073; /* *narrow_lshrrvvm8di_scalar */

        case 108:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30075; /* *narrow_lshrrvvm4di_scalar */

        case 109:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30077; /* *narrow_lshrrvvm2di_scalar */

        case 110:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30079; /* *narrow_lshrrvvm1di_scalar */

        case 111:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 30081; /* *narrow_lshrv1hi_scalar */

        case 112:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 30083; /* *narrow_lshrv2hi_scalar */

        case 113:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 30085; /* *narrow_lshrv4hi_scalar */

        case 114:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 30087; /* *narrow_lshrv8hi_scalar */

        case 115:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 30089; /* *narrow_lshrv16hi_scalar */

        case 116:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30091; /* *narrow_lshrv32hi_scalar */

        case 117:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30093; /* *narrow_lshrv64hi_scalar */

        case 118:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30095; /* *narrow_lshrv128hi_scalar */

        case 119:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30097; /* *narrow_lshrv256hi_scalar */

        case 120:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30099; /* *narrow_lshrv512hi_scalar */

        case 121:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30101; /* *narrow_lshrv1024hi_scalar */

        case 122:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30103; /* *narrow_lshrv2048hi_scalar */

        case 123:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 30105; /* *narrow_lshrv1si_scalar */

        case 124:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 30107; /* *narrow_lshrv2si_scalar */

        case 125:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 30109; /* *narrow_lshrv4si_scalar */

        case 126:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 30111; /* *narrow_lshrv8si_scalar */

        case 127:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30113; /* *narrow_lshrv16si_scalar */

        case 128:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30115; /* *narrow_lshrv32si_scalar */

        case 129:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30117; /* *narrow_lshrv64si_scalar */

        case 130:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30119; /* *narrow_lshrv128si_scalar */

        case 131:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30121; /* *narrow_lshrv256si_scalar */

        case 132:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30123; /* *narrow_lshrv512si_scalar */

        case 133:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30125; /* *narrow_lshrv1024si_scalar */

        case 134:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30127; /* *narrow_lshrv1di_scalar */

        case 135:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30129; /* *narrow_lshrv2di_scalar */

        case 136:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30131; /* *narrow_lshrv4di_scalar */

        case 137:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30133; /* *narrow_lshrv8di_scalar */

        case 138:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30135; /* *narrow_lshrv16di_scalar */

        case 139:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30137; /* *narrow_lshrv32di_scalar */

        case 140:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30139; /* *narrow_lshrv64di_scalar */

        case 141:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30141; /* *narrow_lshrv128di_scalar */

        case 142:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30143; /* *narrow_lshrv256di_scalar */

        case 143:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30145; /* *narrow_lshrv512di_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern236 (x3))
    {
    case 0:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27796; /* fminrvvm8hf3 */

    case 1:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27798; /* fminrvvm4hf3 */

    case 2:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27800; /* fminrvvm2hf3 */

    case 3:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27802; /* fminrvvm1hf3 */

    case 4:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27804; /* fminrvvmf2hf3 */

    case 5:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF4HFmode) && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27806; /* fminrvvmf4hf3 */

    case 6:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27808; /* fminrvvm8sf3 */

    case 7:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27810; /* fminrvvm4sf3 */

    case 8:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27812; /* fminrvvm2sf3 */

    case 9:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27814; /* fminrvvm1sf3 */

    case 10:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27816; /* fminrvvmf2sf3 */

    case 11:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27818; /* fminrvvm8df3 */

    case 12:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27820; /* fminrvvm4df3 */

    case 13:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27822; /* fminrvvm2df3 */

    case 14:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27824; /* fminrvvm1df3 */

    case 15:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1HFmode) && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27826; /* fminv1hf3 */

    case 16:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2HFmode) && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27828; /* fminv2hf3 */

    case 17:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4HFmode) && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27830; /* fminv4hf3 */

    case 18:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8HFmode) && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27832; /* fminv8hf3 */

    case 19:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16HFmode) && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27834; /* fminv16hf3 */

    case 20:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32HFmode) && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27836; /* fminv32hf3 */

    case 21:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64HFmode) && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27838; /* fminv64hf3 */

    case 22:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128HFmode) && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27840; /* fminv128hf3 */

    case 23:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256HFmode) && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27842; /* fminv256hf3 */

    case 24:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512HFmode) && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27844; /* fminv512hf3 */

    case 25:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024HFmode) && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27846; /* fminv1024hf3 */

    case 26:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2048HFmode) && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27848; /* fminv2048hf3 */

    case 27:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1SFmode) && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27850; /* fminv1sf3 */

    case 28:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2SFmode) && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27852; /* fminv2sf3 */

    case 29:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4SFmode) && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27854; /* fminv4sf3 */

    case 30:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8SFmode) && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27856; /* fminv8sf3 */

    case 31:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16SFmode) && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27858; /* fminv16sf3 */

    case 32:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32SFmode) && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27860; /* fminv32sf3 */

    case 33:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64SFmode) && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27862; /* fminv64sf3 */

    case 34:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128SFmode) && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27864; /* fminv128sf3 */

    case 35:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256SFmode) && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27866; /* fminv256sf3 */

    case 36:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512SFmode) && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27868; /* fminv512sf3 */

    case 37:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024SFmode) && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27870; /* fminv1024sf3 */

    case 38:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1DFmode) && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27872; /* fminv1df3 */

    case 39:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2DFmode) && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27874; /* fminv2df3 */

    case 40:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4DFmode) && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27876; /* fminv4df3 */

    case 41:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8DFmode) && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27878; /* fminv8df3 */

    case 42:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16DFmode) && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27880; /* fminv16df3 */

    case 43:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32DFmode) && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27882; /* fminv32df3 */

    case 44:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64DFmode) && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27884; /* fminv64df3 */

    case 45:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128DFmode) && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27886; /* fminv128df3 */

    case 46:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256DFmode) && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27888; /* fminv256df3 */

    case 47:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512DFmode) && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27890; /* fminv512df3 */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_QImode)
      || !
#line 1997 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
    return -1;
  return 33911; /* riscv_cv_simd_shuffle_sci_b_si */
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_int6_operand (operands[2], E_QImode)
      || !
#line 1975 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
    return -1;
  return 33909; /* riscv_cv_simd_shuffle_sci_h_si */
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern383 (x3, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 477; /* stack_protect_test_si */

    case E_DImode:
      if (pattern383 (x3, 
E_DImode) != 0
          || !
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 478; /* stack_protect_test_di */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !(
#line 2333 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 257; /* rintsf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !(
#line 2333 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 258; /* rintdf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode)
          || !(
#line 2333 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 259; /* rinthf2 */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern584 (x2, 
E_RVVMF64BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF8QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF8QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8695; /* pred_madcrvvmf8qi_scalar */

    case E_RVVMF4HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF4HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !(
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8701; /* pred_madcrvvmf4hi_scalar */

    case E_RVVMF2SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF2SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !(
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8706; /* pred_madcrvvmf2si_scalar */

    case E_RVVM1DImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM1DImode)
          || !(
#line 3567 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8800; /* *pred_madcrvvm1di_scalar */

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern584 (x2, 
E_V1024BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_V1024QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1024QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8717; /* pred_madcv1024qi_scalar */

    case E_V1024HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1024HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V1024HImode)
          || !(
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8730; /* pred_madcv1024hi_scalar */

    case E_V1024SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1024SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V1024SImode)
          || !(
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8742; /* pred_madcv1024si_scalar */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern672 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18127; /* pred_redmaxrvvm8qi */

        case 1:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18135; /* pred_redmaxrvvm4qi */

        case 2:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18143; /* pred_redmaxrvvm2qi */

        case 3:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18151; /* pred_redmaxrvvm1qi */

        case 4:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18255; /* pred_redmaxrvvmf2qi */

        case 5:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18263; /* pred_redmaxrvvmf4qi */

        case 6:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18271; /* pred_redmaxrvvmf8qi */

        case 7:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18303; /* pred_redmaxv1qi */

        case 8:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18311; /* pred_redmaxv2qi */

        case 9:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18319; /* pred_redmaxv4qi */

        case 10:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18327; /* pred_redmaxv8qi */

        case 11:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18335; /* pred_redmaxv16qi */

        case 12:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18343; /* pred_redmaxv32qi */

        case 13:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18351; /* pred_redmaxv64qi */

        case 14:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18359; /* pred_redmaxv128qi */

        case 15:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18367; /* pred_redmaxv256qi */

        case 16:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18375; /* pred_redmaxv512qi */

        case 17:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18383; /* pred_redmaxv1024qi */

        case 18:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18391; /* pred_redmaxv2048qi */

        case 19:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18399; /* pred_redmaxv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern673 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18159; /* pred_redmaxrvvm8hi */

        case 1:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18167; /* pred_redmaxrvvm4hi */

        case 2:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18175; /* pred_redmaxrvvm2hi */

        case 3:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18183; /* pred_redmaxrvvm1hi */

        case 4:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18279; /* pred_redmaxrvvmf2hi */

        case 5:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18287; /* pred_redmaxrvvmf4hi */

        case 6:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18407; /* pred_redmaxv1hi */

        case 7:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18415; /* pred_redmaxv2hi */

        case 8:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18423; /* pred_redmaxv4hi */

        case 9:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18431; /* pred_redmaxv8hi */

        case 10:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18439; /* pred_redmaxv16hi */

        case 11:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18447; /* pred_redmaxv32hi */

        case 12:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18455; /* pred_redmaxv64hi */

        case 13:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18463; /* pred_redmaxv128hi */

        case 14:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18471; /* pred_redmaxv256hi */

        case 15:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18479; /* pred_redmaxv512hi */

        case 16:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18487; /* pred_redmaxv1024hi */

        case 17:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18495; /* pred_redmaxv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern674 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18191; /* pred_redmaxrvvm8si */

        case 1:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18199; /* pred_redmaxrvvm4si */

        case 2:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18207; /* pred_redmaxrvvm2si */

        case 3:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18215; /* pred_redmaxrvvm1si */

        case 4:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18295; /* pred_redmaxrvvmf2si */

        case 5:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18503; /* pred_redmaxv1si */

        case 6:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18511; /* pred_redmaxv2si */

        case 7:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18519; /* pred_redmaxv4si */

        case 8:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18527; /* pred_redmaxv8si */

        case 9:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18535; /* pred_redmaxv16si */

        case 10:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18543; /* pred_redmaxv32si */

        case 11:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18551; /* pred_redmaxv64si */

        case 12:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18559; /* pred_redmaxv128si */

        case 13:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18567; /* pred_redmaxv256si */

        case 14:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18575; /* pred_redmaxv512si */

        case 15:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18583; /* pred_redmaxv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18223; /* pred_redmaxrvvm8di */

        case 1:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18231; /* pred_redmaxrvvm4di */

        case 2:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18239; /* pred_redmaxrvvm2di */

        case 3:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18247; /* pred_redmaxrvvm1di */

        case 4:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18591; /* pred_redmaxv1di */

        case 5:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18599; /* pred_redmaxv2di */

        case 6:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18607; /* pred_redmaxv4di */

        case 7:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18615; /* pred_redmaxv8di */

        case 8:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18623; /* pred_redmaxv16di */

        case 9:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18631; /* pred_redmaxv32di */

        case 10:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18639; /* pred_redmaxv64di */

        case 11:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18647; /* pred_redmaxv128di */

        case 12:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18655; /* pred_redmaxv256di */

        case 13:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18663; /* pred_redmaxv512di */

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern676 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19429; /* pred_redmaxrvvm8hf */

        case 1:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19431; /* pred_redmaxrvvm4hf */

        case 2:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19433; /* pred_redmaxrvvm2hf */

        case 3:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19435; /* pred_redmaxrvvm1hf */

        case 4:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19437; /* pred_redmaxrvvmf2hf */

        case 5:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19439; /* pred_redmaxrvvmf4hf */

        case 6:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19459; /* pred_redmaxv1hf */

        case 7:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19461; /* pred_redmaxv2hf */

        case 8:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19463; /* pred_redmaxv4hf */

        case 9:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19465; /* pred_redmaxv8hf */

        case 10:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19467; /* pred_redmaxv16hf */

        case 11:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19469; /* pred_redmaxv32hf */

        case 12:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19471; /* pred_redmaxv64hf */

        case 13:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19473; /* pred_redmaxv128hf */

        case 14:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19475; /* pred_redmaxv256hf */

        case 15:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19477; /* pred_redmaxv512hf */

        case 16:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19479; /* pred_redmaxv1024hf */

        case 17:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19481; /* pred_redmaxv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19441; /* pred_redmaxrvvm8sf */

        case 1:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19443; /* pred_redmaxrvvm4sf */

        case 2:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19445; /* pred_redmaxrvvm2sf */

        case 3:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19447; /* pred_redmaxrvvm1sf */

        case 4:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19449; /* pred_redmaxrvvmf2sf */

        case 5:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19483; /* pred_redmaxv1sf */

        case 6:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19485; /* pred_redmaxv2sf */

        case 7:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19487; /* pred_redmaxv4sf */

        case 8:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19489; /* pred_redmaxv8sf */

        case 9:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19491; /* pred_redmaxv16sf */

        case 10:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19493; /* pred_redmaxv32sf */

        case 11:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19495; /* pred_redmaxv64sf */

        case 12:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19497; /* pred_redmaxv128sf */

        case 13:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19499; /* pred_redmaxv256sf */

        case 14:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19501; /* pred_redmaxv512sf */

        case 15:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19503; /* pred_redmaxv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2))
        {
        case 0:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19451; /* pred_redmaxrvvm8df */

        case 1:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19453; /* pred_redmaxrvvm4df */

        case 2:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19455; /* pred_redmaxrvvm2df */

        case 3:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19457; /* pred_redmaxrvvm1df */

        case 4:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19505; /* pred_redmaxv1df */

        case 5:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19507; /* pred_redmaxv2df */

        case 6:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19509; /* pred_redmaxv4df */

        case 7:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19511; /* pred_redmaxv8df */

        case 8:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19513; /* pred_redmaxv16df */

        case 9:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19515; /* pred_redmaxv32df */

        case 10:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19517; /* pred_redmaxv64df */

        case 11:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19519; /* pred_redmaxv128df */

        case 12:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19521; /* pred_redmaxv256df */

        case 13:
          if (!(
#line 7857 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19523; /* pred_redmaxv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern672 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18130; /* pred_redandrvvm8qi */

        case 1:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18138; /* pred_redandrvvm4qi */

        case 2:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18146; /* pred_redandrvvm2qi */

        case 3:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18154; /* pred_redandrvvm1qi */

        case 4:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18258; /* pred_redandrvvmf2qi */

        case 5:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18266; /* pred_redandrvvmf4qi */

        case 6:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18274; /* pred_redandrvvmf8qi */

        case 7:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18306; /* pred_redandv1qi */

        case 8:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18314; /* pred_redandv2qi */

        case 9:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18322; /* pred_redandv4qi */

        case 10:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18330; /* pred_redandv8qi */

        case 11:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18338; /* pred_redandv16qi */

        case 12:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18346; /* pred_redandv32qi */

        case 13:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18354; /* pred_redandv64qi */

        case 14:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18362; /* pred_redandv128qi */

        case 15:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18370; /* pred_redandv256qi */

        case 16:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18378; /* pred_redandv512qi */

        case 17:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18386; /* pred_redandv1024qi */

        case 18:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18394; /* pred_redandv2048qi */

        case 19:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18402; /* pred_redandv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern673 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18162; /* pred_redandrvvm8hi */

        case 1:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18170; /* pred_redandrvvm4hi */

        case 2:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18178; /* pred_redandrvvm2hi */

        case 3:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18186; /* pred_redandrvvm1hi */

        case 4:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18282; /* pred_redandrvvmf2hi */

        case 5:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18290; /* pred_redandrvvmf4hi */

        case 6:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18410; /* pred_redandv1hi */

        case 7:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18418; /* pred_redandv2hi */

        case 8:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18426; /* pred_redandv4hi */

        case 9:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18434; /* pred_redandv8hi */

        case 10:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18442; /* pred_redandv16hi */

        case 11:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18450; /* pred_redandv32hi */

        case 12:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18458; /* pred_redandv64hi */

        case 13:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18466; /* pred_redandv128hi */

        case 14:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18474; /* pred_redandv256hi */

        case 15:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18482; /* pred_redandv512hi */

        case 16:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18490; /* pred_redandv1024hi */

        case 17:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18498; /* pred_redandv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern674 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18194; /* pred_redandrvvm8si */

        case 1:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18202; /* pred_redandrvvm4si */

        case 2:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18210; /* pred_redandrvvm2si */

        case 3:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18218; /* pred_redandrvvm1si */

        case 4:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18298; /* pred_redandrvvmf2si */

        case 5:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18506; /* pred_redandv1si */

        case 6:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18514; /* pred_redandv2si */

        case 7:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18522; /* pred_redandv4si */

        case 8:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18530; /* pred_redandv8si */

        case 9:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18538; /* pred_redandv16si */

        case 10:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18546; /* pred_redandv32si */

        case 11:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18554; /* pred_redandv64si */

        case 12:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18562; /* pred_redandv128si */

        case 13:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18570; /* pred_redandv256si */

        case 14:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18578; /* pred_redandv512si */

        case 15:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18586; /* pred_redandv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18226; /* pred_redandrvvm8di */

        case 1:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18234; /* pred_redandrvvm4di */

        case 2:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18242; /* pred_redandrvvm2di */

        case 3:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18250; /* pred_redandrvvm1di */

        case 4:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18594; /* pred_redandv1di */

        case 5:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18602; /* pred_redandv2di */

        case 6:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18610; /* pred_redandv4di */

        case 7:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18618; /* pred_redandv8di */

        case 8:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18626; /* pred_redandv16di */

        case 9:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18634; /* pred_redandv32di */

        case 10:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18642; /* pred_redandv64di */

        case 11:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18650; /* pred_redandv128di */

        case 12:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18658; /* pred_redandv256di */

        case 13:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18666; /* pred_redandv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern676 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19621; /* pred_redosumrvvm8hf */

        case 1:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19623; /* pred_redosumrvvm4hf */

        case 2:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19625; /* pred_redosumrvvm2hf */

        case 3:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19627; /* pred_redosumrvvm1hf */

        case 4:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19629; /* pred_redosumrvvmf2hf */

        case 5:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19631; /* pred_redosumrvvmf4hf */

        case 6:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19651; /* pred_redosumv1hf */

        case 7:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19653; /* pred_redosumv2hf */

        case 8:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19655; /* pred_redosumv4hf */

        case 9:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19657; /* pred_redosumv8hf */

        case 10:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19659; /* pred_redosumv16hf */

        case 11:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19661; /* pred_redosumv32hf */

        case 12:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19663; /* pred_redosumv64hf */

        case 13:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19665; /* pred_redosumv128hf */

        case 14:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19667; /* pred_redosumv256hf */

        case 15:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19669; /* pred_redosumv512hf */

        case 16:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19671; /* pred_redosumv1024hf */

        case 17:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19673; /* pred_redosumv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19633; /* pred_redosumrvvm8sf */

        case 1:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19635; /* pred_redosumrvvm4sf */

        case 2:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19637; /* pred_redosumrvvm2sf */

        case 3:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19639; /* pred_redosumrvvm1sf */

        case 4:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19641; /* pred_redosumrvvmf2sf */

        case 5:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19675; /* pred_redosumv1sf */

        case 6:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19677; /* pred_redosumv2sf */

        case 7:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19679; /* pred_redosumv4sf */

        case 8:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19681; /* pred_redosumv8sf */

        case 9:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19683; /* pred_redosumv16sf */

        case 10:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19685; /* pred_redosumv32sf */

        case 11:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19687; /* pred_redosumv64sf */

        case 12:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19689; /* pred_redosumv128sf */

        case 13:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19691; /* pred_redosumv256sf */

        case 14:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19693; /* pred_redosumv512sf */

        case 15:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19695; /* pred_redosumv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2))
        {
        case 0:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19643; /* pred_redosumrvvm8df */

        case 1:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19645; /* pred_redosumrvvm4df */

        case 2:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19647; /* pred_redosumrvvm2df */

        case 3:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19649; /* pred_redosumrvvm1df */

        case 4:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19697; /* pred_redosumv1df */

        case 5:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19699; /* pred_redosumv2df */

        case 6:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19701; /* pred_redosumv4df */

        case 7:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19703; /* pred_redosumv8df */

        case 8:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19705; /* pred_redosumv16df */

        case 9:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19707; /* pred_redosumv32df */

        case 10:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19709; /* pred_redosumv64df */

        case 11:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19711; /* pred_redosumv128df */

        case 12:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19713; /* pred_redosumv256df */

        case 13:
          if (!(
#line 7902 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19715; /* pred_redosumv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[0], E_RVVMF32BImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4x2QImode:
      if (!register_operand (operands[3], E_RVVMF4x2QImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21659; /* pred_strided_storervvmf4x2qi */

    case E_RVVMF4x3QImode:
      if (!register_operand (operands[3], E_RVVMF4x3QImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21660; /* pred_strided_storervvmf4x3qi */

    case E_RVVMF4x4QImode:
      if (!register_operand (operands[3], E_RVVMF4x4QImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21661; /* pred_strided_storervvmf4x4qi */

    case E_RVVMF4x5QImode:
      if (!register_operand (operands[3], E_RVVMF4x5QImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21662; /* pred_strided_storervvmf4x5qi */

    case E_RVVMF4x6QImode:
      if (!register_operand (operands[3], E_RVVMF4x6QImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21663; /* pred_strided_storervvmf4x6qi */

    case E_RVVMF4x7QImode:
      if (!register_operand (operands[3], E_RVVMF4x7QImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21664; /* pred_strided_storervvmf4x7qi */

    case E_RVVMF4x8QImode:
      if (!register_operand (operands[3], E_RVVMF4x8QImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21665; /* pred_strided_storervvmf4x8qi */

    case E_RVVMF2x2HImode:
      if (!register_operand (operands[3], E_RVVMF2x2HImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21666; /* pred_strided_storervvmf2x2hi */

    case E_RVVMF2x3HImode:
      if (!register_operand (operands[3], E_RVVMF2x3HImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21667; /* pred_strided_storervvmf2x3hi */

    case E_RVVMF2x4HImode:
      if (!register_operand (operands[3], E_RVVMF2x4HImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21668; /* pred_strided_storervvmf2x4hi */

    case E_RVVMF2x5HImode:
      if (!register_operand (operands[3], E_RVVMF2x5HImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21669; /* pred_strided_storervvmf2x5hi */

    case E_RVVMF2x6HImode:
      if (!register_operand (operands[3], E_RVVMF2x6HImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21670; /* pred_strided_storervvmf2x6hi */

    case E_RVVMF2x7HImode:
      if (!register_operand (operands[3], E_RVVMF2x7HImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21671; /* pred_strided_storervvmf2x7hi */

    case E_RVVMF2x8HImode:
      if (!register_operand (operands[3], E_RVVMF2x8HImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21672; /* pred_strided_storervvmf2x8hi */

    case E_RVVM1x2SImode:
      if (!register_operand (operands[3], E_RVVM1x2SImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21673; /* pred_strided_storervvm1x2si */

    case E_RVVM1x3SImode:
      if (!register_operand (operands[3], E_RVVM1x3SImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21674; /* pred_strided_storervvm1x3si */

    case E_RVVM1x4SImode:
      if (!register_operand (operands[3], E_RVVM1x4SImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21675; /* pred_strided_storervvm1x4si */

    case E_RVVM1x5SImode:
      if (!register_operand (operands[3], E_RVVM1x5SImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21676; /* pred_strided_storervvm1x5si */

    case E_RVVM1x6SImode:
      if (!register_operand (operands[3], E_RVVM1x6SImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21677; /* pred_strided_storervvm1x6si */

    case E_RVVM1x7SImode:
      if (!register_operand (operands[3], E_RVVM1x7SImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21678; /* pred_strided_storervvm1x7si */

    case E_RVVM1x8SImode:
      if (!register_operand (operands[3], E_RVVM1x8SImode)
          || !
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21679; /* pred_strided_storervvm1x8si */

    case E_RVVM2x2DImode:
      if (!register_operand (operands[3], E_RVVM2x2DImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21680; /* pred_strided_storervvm2x2di */

    case E_RVVM2x3DImode:
      if (!register_operand (operands[3], E_RVVM2x3DImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21681; /* pred_strided_storervvm2x3di */

    case E_RVVM2x4DImode:
      if (!register_operand (operands[3], E_RVVM2x4DImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21682; /* pred_strided_storervvm2x4di */

    case E_RVVMF2x2BFmode:
      if (!register_operand (operands[3], E_RVVMF2x2BFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21683; /* pred_strided_storervvmf2x2bf */

    case E_RVVMF2x3BFmode:
      if (!register_operand (operands[3], E_RVVMF2x3BFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21684; /* pred_strided_storervvmf2x3bf */

    case E_RVVMF2x4BFmode:
      if (!register_operand (operands[3], E_RVVMF2x4BFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21685; /* pred_strided_storervvmf2x4bf */

    case E_RVVMF2x5BFmode:
      if (!register_operand (operands[3], E_RVVMF2x5BFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21686; /* pred_strided_storervvmf2x5bf */

    case E_RVVMF2x6BFmode:
      if (!register_operand (operands[3], E_RVVMF2x6BFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21687; /* pred_strided_storervvmf2x6bf */

    case E_RVVMF2x7BFmode:
      if (!register_operand (operands[3], E_RVVMF2x7BFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21688; /* pred_strided_storervvmf2x7bf */

    case E_RVVMF2x8BFmode:
      if (!register_operand (operands[3], E_RVVMF2x8BFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21689; /* pred_strided_storervvmf2x8bf */

    case E_RVVMF2x2HFmode:
      if (!register_operand (operands[3], E_RVVMF2x2HFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21690; /* pred_strided_storervvmf2x2hf */

    case E_RVVMF2x3HFmode:
      if (!register_operand (operands[3], E_RVVMF2x3HFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21691; /* pred_strided_storervvmf2x3hf */

    case E_RVVMF2x4HFmode:
      if (!register_operand (operands[3], E_RVVMF2x4HFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21692; /* pred_strided_storervvmf2x4hf */

    case E_RVVMF2x5HFmode:
      if (!register_operand (operands[3], E_RVVMF2x5HFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21693; /* pred_strided_storervvmf2x5hf */

    case E_RVVMF2x6HFmode:
      if (!register_operand (operands[3], E_RVVMF2x6HFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21694; /* pred_strided_storervvmf2x6hf */

    case E_RVVMF2x7HFmode:
      if (!register_operand (operands[3], E_RVVMF2x7HFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21695; /* pred_strided_storervvmf2x7hf */

    case E_RVVMF2x8HFmode:
      if (!register_operand (operands[3], E_RVVMF2x8HFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21696; /* pred_strided_storervvmf2x8hf */

    case E_RVVM1x2SFmode:
      if (!register_operand (operands[3], E_RVVM1x2SFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21697; /* pred_strided_storervvm1x2sf */

    case E_RVVM1x3SFmode:
      if (!register_operand (operands[3], E_RVVM1x3SFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21698; /* pred_strided_storervvm1x3sf */

    case E_RVVM1x4SFmode:
      if (!register_operand (operands[3], E_RVVM1x4SFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21699; /* pred_strided_storervvm1x4sf */

    case E_RVVM1x5SFmode:
      if (!register_operand (operands[3], E_RVVM1x5SFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21700; /* pred_strided_storervvm1x5sf */

    case E_RVVM1x6SFmode:
      if (!register_operand (operands[3], E_RVVM1x6SFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21701; /* pred_strided_storervvm1x6sf */

    case E_RVVM1x7SFmode:
      if (!register_operand (operands[3], E_RVVM1x7SFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21702; /* pred_strided_storervvm1x7sf */

    case E_RVVM1x8SFmode:
      if (!register_operand (operands[3], E_RVVM1x8SFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21703; /* pred_strided_storervvm1x8sf */

    case E_RVVM2x2DFmode:
      if (!register_operand (operands[3], E_RVVM2x2DFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21704; /* pred_strided_storervvm2x2df */

    case E_RVVM2x3DFmode:
      if (!register_operand (operands[3], E_RVVM2x3DFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21705; /* pred_strided_storervvm2x3df */

    case E_RVVM2x4DFmode:
      if (!register_operand (operands[3], E_RVVM2x4DFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21706; /* pred_strided_storervvm2x4df */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[0], E_RVVMF64BImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_RVVMF8x2QImode:
      if (!register_operand (operands[2], E_RVVMF8x2QImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21273; /* pred_unit_strided_storervvmf8x2qi */

    case E_RVVMF8x3QImode:
      if (!register_operand (operands[2], E_RVVMF8x3QImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21274; /* pred_unit_strided_storervvmf8x3qi */

    case E_RVVMF8x4QImode:
      if (!register_operand (operands[2], E_RVVMF8x4QImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21275; /* pred_unit_strided_storervvmf8x4qi */

    case E_RVVMF8x5QImode:
      if (!register_operand (operands[2], E_RVVMF8x5QImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21276; /* pred_unit_strided_storervvmf8x5qi */

    case E_RVVMF8x6QImode:
      if (!register_operand (operands[2], E_RVVMF8x6QImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21277; /* pred_unit_strided_storervvmf8x6qi */

    case E_RVVMF8x7QImode:
      if (!register_operand (operands[2], E_RVVMF8x7QImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21278; /* pred_unit_strided_storervvmf8x7qi */

    case E_RVVMF8x8QImode:
      if (!register_operand (operands[2], E_RVVMF8x8QImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21279; /* pred_unit_strided_storervvmf8x8qi */

    case E_RVVMF4x2HImode:
      if (!register_operand (operands[2], E_RVVMF4x2HImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21280; /* pred_unit_strided_storervvmf4x2hi */

    case E_RVVMF4x3HImode:
      if (!register_operand (operands[2], E_RVVMF4x3HImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21281; /* pred_unit_strided_storervvmf4x3hi */

    case E_RVVMF4x4HImode:
      if (!register_operand (operands[2], E_RVVMF4x4HImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21282; /* pred_unit_strided_storervvmf4x4hi */

    case E_RVVMF4x5HImode:
      if (!register_operand (operands[2], E_RVVMF4x5HImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21283; /* pred_unit_strided_storervvmf4x5hi */

    case E_RVVMF4x6HImode:
      if (!register_operand (operands[2], E_RVVMF4x6HImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21284; /* pred_unit_strided_storervvmf4x6hi */

    case E_RVVMF4x7HImode:
      if (!register_operand (operands[2], E_RVVMF4x7HImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21285; /* pred_unit_strided_storervvmf4x7hi */

    case E_RVVMF4x8HImode:
      if (!register_operand (operands[2], E_RVVMF4x8HImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21286; /* pred_unit_strided_storervvmf4x8hi */

    case E_RVVMF2x2SImode:
      if (!register_operand (operands[2], E_RVVMF2x2SImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21287; /* pred_unit_strided_storervvmf2x2si */

    case E_RVVMF2x3SImode:
      if (!register_operand (operands[2], E_RVVMF2x3SImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21288; /* pred_unit_strided_storervvmf2x3si */

    case E_RVVMF2x4SImode:
      if (!register_operand (operands[2], E_RVVMF2x4SImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21289; /* pred_unit_strided_storervvmf2x4si */

    case E_RVVMF2x5SImode:
      if (!register_operand (operands[2], E_RVVMF2x5SImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21290; /* pred_unit_strided_storervvmf2x5si */

    case E_RVVMF2x6SImode:
      if (!register_operand (operands[2], E_RVVMF2x6SImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21291; /* pred_unit_strided_storervvmf2x6si */

    case E_RVVMF2x7SImode:
      if (!register_operand (operands[2], E_RVVMF2x7SImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21292; /* pred_unit_strided_storervvmf2x7si */

    case E_RVVMF2x8SImode:
      if (!register_operand (operands[2], E_RVVMF2x8SImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21293; /* pred_unit_strided_storervvmf2x8si */

    case E_RVVM1x2DImode:
      if (!register_operand (operands[2], E_RVVM1x2DImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21294; /* pred_unit_strided_storervvm1x2di */

    case E_RVVM1x3DImode:
      if (!register_operand (operands[2], E_RVVM1x3DImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21295; /* pred_unit_strided_storervvm1x3di */

    case E_RVVM1x4DImode:
      if (!register_operand (operands[2], E_RVVM1x4DImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21296; /* pred_unit_strided_storervvm1x4di */

    case E_RVVM1x5DImode:
      if (!register_operand (operands[2], E_RVVM1x5DImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21297; /* pred_unit_strided_storervvm1x5di */

    case E_RVVM1x6DImode:
      if (!register_operand (operands[2], E_RVVM1x6DImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21298; /* pred_unit_strided_storervvm1x6di */

    case E_RVVM1x7DImode:
      if (!register_operand (operands[2], E_RVVM1x7DImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21299; /* pred_unit_strided_storervvm1x7di */

    case E_RVVM1x8DImode:
      if (!register_operand (operands[2], E_RVVM1x8DImode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21300; /* pred_unit_strided_storervvm1x8di */

    case E_RVVMF4x2BFmode:
      if (!register_operand (operands[2], E_RVVMF4x2BFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21301; /* pred_unit_strided_storervvmf4x2bf */

    case E_RVVMF4x3BFmode:
      if (!register_operand (operands[2], E_RVVMF4x3BFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21302; /* pred_unit_strided_storervvmf4x3bf */

    case E_RVVMF4x4BFmode:
      if (!register_operand (operands[2], E_RVVMF4x4BFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21303; /* pred_unit_strided_storervvmf4x4bf */

    case E_RVVMF4x5BFmode:
      if (!register_operand (operands[2], E_RVVMF4x5BFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21304; /* pred_unit_strided_storervvmf4x5bf */

    case E_RVVMF4x6BFmode:
      if (!register_operand (operands[2], E_RVVMF4x6BFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21305; /* pred_unit_strided_storervvmf4x6bf */

    case E_RVVMF4x7BFmode:
      if (!register_operand (operands[2], E_RVVMF4x7BFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21306; /* pred_unit_strided_storervvmf4x7bf */

    case E_RVVMF4x8BFmode:
      if (!register_operand (operands[2], E_RVVMF4x8BFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21307; /* pred_unit_strided_storervvmf4x8bf */

    case E_RVVMF4x2HFmode:
      if (!register_operand (operands[2], E_RVVMF4x2HFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21308; /* pred_unit_strided_storervvmf4x2hf */

    case E_RVVMF4x3HFmode:
      if (!register_operand (operands[2], E_RVVMF4x3HFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21309; /* pred_unit_strided_storervvmf4x3hf */

    case E_RVVMF4x4HFmode:
      if (!register_operand (operands[2], E_RVVMF4x4HFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21310; /* pred_unit_strided_storervvmf4x4hf */

    case E_RVVMF4x5HFmode:
      if (!register_operand (operands[2], E_RVVMF4x5HFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21311; /* pred_unit_strided_storervvmf4x5hf */

    case E_RVVMF4x6HFmode:
      if (!register_operand (operands[2], E_RVVMF4x6HFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21312; /* pred_unit_strided_storervvmf4x6hf */

    case E_RVVMF4x7HFmode:
      if (!register_operand (operands[2], E_RVVMF4x7HFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21313; /* pred_unit_strided_storervvmf4x7hf */

    case E_RVVMF4x8HFmode:
      if (!register_operand (operands[2], E_RVVMF4x8HFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21314; /* pred_unit_strided_storervvmf4x8hf */

    case E_RVVMF2x2SFmode:
      if (!register_operand (operands[2], E_RVVMF2x2SFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21315; /* pred_unit_strided_storervvmf2x2sf */

    case E_RVVMF2x3SFmode:
      if (!register_operand (operands[2], E_RVVMF2x3SFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21316; /* pred_unit_strided_storervvmf2x3sf */

    case E_RVVMF2x4SFmode:
      if (!register_operand (operands[2], E_RVVMF2x4SFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21317; /* pred_unit_strided_storervvmf2x4sf */

    case E_RVVMF2x5SFmode:
      if (!register_operand (operands[2], E_RVVMF2x5SFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21318; /* pred_unit_strided_storervvmf2x5sf */

    case E_RVVMF2x6SFmode:
      if (!register_operand (operands[2], E_RVVMF2x6SFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21319; /* pred_unit_strided_storervvmf2x6sf */

    case E_RVVMF2x7SFmode:
      if (!register_operand (operands[2], E_RVVMF2x7SFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21320; /* pred_unit_strided_storervvmf2x7sf */

    case E_RVVMF2x8SFmode:
      if (!register_operand (operands[2], E_RVVMF2x8SFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21321; /* pred_unit_strided_storervvmf2x8sf */

    case E_RVVM1x2DFmode:
      if (!register_operand (operands[2], E_RVVM1x2DFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21322; /* pred_unit_strided_storervvm1x2df */

    case E_RVVM1x3DFmode:
      if (!register_operand (operands[2], E_RVVM1x3DFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21323; /* pred_unit_strided_storervvm1x3df */

    case E_RVVM1x4DFmode:
      if (!register_operand (operands[2], E_RVVM1x4DFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21324; /* pred_unit_strided_storervvm1x4df */

    case E_RVVM1x5DFmode:
      if (!register_operand (operands[2], E_RVVM1x5DFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21325; /* pred_unit_strided_storervvm1x5df */

    case E_RVVM1x6DFmode:
      if (!register_operand (operands[2], E_RVVM1x6DFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21326; /* pred_unit_strided_storervvm1x6df */

    case E_RVVM1x7DFmode:
      if (!register_operand (operands[2], E_RVVM1x7DFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21327; /* pred_unit_strided_storervvm1x7df */

    case E_RVVM1x8DFmode:
      if (!register_operand (operands[2], E_RVVM1x8DFmode)
          || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21328; /* pred_unit_strided_storervvm1x8df */

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern190 (x1))
    {
    case 0:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20324; /* pred_slide1downrvvm8qi */

    case 1:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20326; /* pred_slide1downrvvm4qi */

    case 2:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20328; /* pred_slide1downrvvm2qi */

    case 3:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20330; /* pred_slide1downrvvm1qi */

    case 4:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20332; /* pred_slide1downrvvmf2qi */

    case 5:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20334; /* pred_slide1downrvvmf4qi */

    case 6:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20336; /* pred_slide1downrvvmf8qi */

    case 7:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20338; /* pred_slide1downrvvm8hi */

    case 8:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20340; /* pred_slide1downrvvm4hi */

    case 9:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20342; /* pred_slide1downrvvm2hi */

    case 10:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20344; /* pred_slide1downrvvm1hi */

    case 11:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20346; /* pred_slide1downrvvmf2hi */

    case 12:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20348; /* pred_slide1downrvvmf4hi */

    case 13:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20350; /* pred_slide1downrvvm8si */

    case 14:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20352; /* pred_slide1downrvvm4si */

    case 15:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20354; /* pred_slide1downrvvm2si */

    case 16:
      if (!
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20356; /* pred_slide1downrvvm1si */

    case 17:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20358; /* pred_slide1downrvvmf2si */

    case 18:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 20360; /* pred_slide1downv1qi */

    case 19:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 20362; /* pred_slide1downv2qi */

    case 20:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 20364; /* pred_slide1downv4qi */

    case 21:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 20366; /* pred_slide1downv8qi */

    case 22:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 20368; /* pred_slide1downv16qi */

    case 23:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 20370; /* pred_slide1downv32qi */

    case 24:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20372; /* pred_slide1downv64qi */

    case 25:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20374; /* pred_slide1downv128qi */

    case 26:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20376; /* pred_slide1downv256qi */

    case 27:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20378; /* pred_slide1downv512qi */

    case 28:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20380; /* pred_slide1downv1024qi */

    case 29:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20382; /* pred_slide1downv2048qi */

    case 30:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20384; /* pred_slide1downv4096qi */

    case 31:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 20386; /* pred_slide1downv1hi */

    case 32:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 20388; /* pred_slide1downv2hi */

    case 33:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 20390; /* pred_slide1downv4hi */

    case 34:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 20392; /* pred_slide1downv8hi */

    case 35:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 20394; /* pred_slide1downv16hi */

    case 36:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20396; /* pred_slide1downv32hi */

    case 37:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20398; /* pred_slide1downv64hi */

    case 38:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20400; /* pred_slide1downv128hi */

    case 39:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20402; /* pred_slide1downv256hi */

    case 40:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20404; /* pred_slide1downv512hi */

    case 41:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20406; /* pred_slide1downv1024hi */

    case 42:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20408; /* pred_slide1downv2048hi */

    case 43:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 20410; /* pred_slide1downv1si */

    case 44:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 20412; /* pred_slide1downv2si */

    case 45:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 20414; /* pred_slide1downv4si */

    case 46:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 20416; /* pred_slide1downv8si */

    case 47:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20418; /* pred_slide1downv16si */

    case 48:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20420; /* pred_slide1downv32si */

    case 49:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20422; /* pred_slide1downv64si */

    case 50:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20424; /* pred_slide1downv128si */

    case 51:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20426; /* pred_slide1downv256si */

    case 52:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20428; /* pred_slide1downv512si */

    case 53:
      if (!(
#line 8124 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20430; /* pred_slide1downv1024si */

    case 54:
      if (!(
#line 8168 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20432; /* *pred_slide1downrvvm8di */

    case 55:
      if (!(
#line 8168 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20434; /* *pred_slide1downrvvm4di */

    case 56:
      if (!(
#line 8168 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20436; /* *pred_slide1downrvvm2di */

    case 57:
      if (!(
#line 8168 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20438; /* *pred_slide1downrvvm1di */

    case 58:
      if (!(
#line 8168 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20440; /* *pred_slide1downv1di */

    case 59:
      if (!(
#line 8168 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20442; /* *pred_slide1downv2di */

    case 60:
      if (!(
#line 8168 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20444; /* *pred_slide1downv4di */

    case 61:
      if (!(
#line 8168 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20446; /* *pred_slide1downv8di */

    case 62:
      if (!(
#line 8168 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20448; /* *pred_slide1downv16di */

    case 63:
      if (!(
#line 8168 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20450; /* *pred_slide1downv32di */

    case 64:
      if (!(
#line 8168 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20452; /* *pred_slide1downv64di */

    case 65:
      if (!(
#line 8168 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20454; /* *pred_slide1downv128di */

    case 66:
      if (!(
#line 8168 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20456; /* *pred_slide1downv256di */

    case 67:
      if (!(
#line 8168 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20458; /* *pred_slide1downv512di */

    case 68:
      if (!(
#line 8188 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20460; /* *pred_slide1downrvvm8di_extended */

    case 69:
      if (!(
#line 8188 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20462; /* *pred_slide1downrvvm4di_extended */

    case 70:
      if (!(
#line 8188 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20464; /* *pred_slide1downrvvm2di_extended */

    case 71:
      if (!(
#line 8188 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20466; /* *pred_slide1downrvvm1di_extended */

    case 72:
      if (!(
#line 8188 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20468; /* *pred_slide1downv1di_extended */

    case 73:
      if (!(
#line 8188 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20470; /* *pred_slide1downv2di_extended */

    case 74:
      if (!(
#line 8188 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20472; /* *pred_slide1downv4di_extended */

    case 75:
      if (!(
#line 8188 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20474; /* *pred_slide1downv8di_extended */

    case 76:
      if (!(
#line 8188 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20476; /* *pred_slide1downv16di_extended */

    case 77:
      if (!(
#line 8188 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20478; /* *pred_slide1downv32di_extended */

    case 78:
      if (!(
#line 8188 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20480; /* *pred_slide1downv64di_extended */

    case 79:
      if (!(
#line 8188 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20482; /* *pred_slide1downv128di_extended */

    case 80:
      if (!(
#line 8188 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20484; /* *pred_slide1downv256di_extended */

    case 81:
      if (!(
#line 8188 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20486; /* *pred_slide1downv512di_extended */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (arith_operand (operands[2], E_SImode))
        {
          if (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return 105; /* *andsi3 */
          if (
#line 1771 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return 111; /* *andsi3_internal */
        }
      if (not_single_bit_mask_operand (operands[2], E_SImode)
          && (
#line 838 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 629; /* *bclrisi */
      if (const_nottwobits_not_arith_operand (operands[2], E_SImode)
          && (
#line 847 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !paradoxical_subreg_p (operands[1])) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 631; /* *bclrisi_nottwobits */
      if (!not_uimm_extra_bit_or_nottwobits (operands[2], E_SImode)
          || !(
#line 1039 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 648; /* *andisi_extrabit */

    case E_DImode:
      if (pattern263 (x2) != 0
          || !
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
        return -1;
      return 106; /* *anddi3 */

    case E_RVVM8QImode:
      if (pattern228 (x2, 
E_RVVM8QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24543; /* andrvvm8qi3 */

    case E_RVVM4QImode:
      if (pattern228 (x2, 
E_RVVM4QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24557; /* andrvvm4qi3 */

    case E_RVVM2QImode:
      if (pattern228 (x2, 
E_RVVM2QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24571; /* andrvvm2qi3 */

    case E_RVVM1QImode:
      if (pattern228 (x2, 
E_RVVM1QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24585; /* andrvvm1qi3 */

    case E_RVVM8HImode:
      if (pattern228 (x2, 
E_RVVM8HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24599; /* andrvvm8hi3 */

    case E_RVVM4HImode:
      if (pattern228 (x2, 
E_RVVM4HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24613; /* andrvvm4hi3 */

    case E_RVVM2HImode:
      if (pattern228 (x2, 
E_RVVM2HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24627; /* andrvvm2hi3 */

    case E_RVVM1HImode:
      if (pattern228 (x2, 
E_RVVM1HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24641; /* andrvvm1hi3 */

    case E_RVVM8SImode:
      if (pattern228 (x2, 
E_RVVM8SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24655; /* andrvvm8si3 */

    case E_RVVM4SImode:
      if (pattern228 (x2, 
E_RVVM4SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24669; /* andrvvm4si3 */

    case E_RVVM2SImode:
      if (pattern228 (x2, 
E_RVVM2SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24683; /* andrvvm2si3 */

    case E_RVVM1SImode:
      if (pattern228 (x2, 
E_RVVM1SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24697; /* andrvvm1si3 */

    case E_RVVM8DImode:
      if (pattern228 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24711; /* andrvvm8di3 */

    case E_RVVM4DImode:
      if (pattern228 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24725; /* andrvvm4di3 */

    case E_RVVM2DImode:
      if (pattern228 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24739; /* andrvvm2di3 */

    case E_RVVM1DImode:
      if (pattern228 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24753; /* andrvvm1di3 */

    case E_RVVMF2QImode:
      if (pattern228 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24767; /* andrvvmf2qi3 */

    case E_RVVMF4QImode:
      if (pattern228 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24781; /* andrvvmf4qi3 */

    case E_RVVMF8QImode:
      if (pattern228 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24795; /* andrvvmf8qi3 */

    case E_RVVMF2HImode:
      if (pattern228 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24809; /* andrvvmf2hi3 */

    case E_RVVMF4HImode:
      if (pattern228 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24823; /* andrvvmf4hi3 */

    case E_RVVMF2SImode:
      if (pattern228 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24837; /* andrvvmf2si3 */

    case E_V1QImode:
      if (pattern228 (x2, 
E_V1QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24851; /* andv1qi3 */

    case E_V2QImode:
      if (pattern228 (x2, 
E_V2QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24865; /* andv2qi3 */

    case E_V4QImode:
      if (pattern228 (x2, 
E_V4QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24879; /* andv4qi3 */

    case E_V8QImode:
      if (pattern228 (x2, 
E_V8QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24893; /* andv8qi3 */

    case E_V16QImode:
      if (pattern228 (x2, 
E_V16QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24907; /* andv16qi3 */

    case E_V32QImode:
      if (pattern228 (x2, 
E_V32QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24921; /* andv32qi3 */

    case E_V64QImode:
      if (pattern228 (x2, 
E_V64QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24935; /* andv64qi3 */

    case E_V128QImode:
      if (pattern228 (x2, 
E_V128QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24949; /* andv128qi3 */

    case E_V256QImode:
      if (pattern228 (x2, 
E_V256QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24963; /* andv256qi3 */

    case E_V512QImode:
      if (pattern228 (x2, 
E_V512QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24977; /* andv512qi3 */

    case E_V1024QImode:
      if (pattern228 (x2, 
E_V1024QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24991; /* andv1024qi3 */

    case E_V2048QImode:
      if (pattern228 (x2, 
E_V2048QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25005; /* andv2048qi3 */

    case E_V4096QImode:
      if (pattern228 (x2, 
E_V4096QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25019; /* andv4096qi3 */

    case E_V1HImode:
      if (pattern228 (x2, 
E_V1HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25033; /* andv1hi3 */

    case E_V2HImode:
      if (pattern228 (x2, 
E_V2HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25047; /* andv2hi3 */

    case E_V4HImode:
      if (pattern228 (x2, 
E_V4HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25061; /* andv4hi3 */

    case E_V8HImode:
      if (pattern228 (x2, 
E_V8HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25075; /* andv8hi3 */

    case E_V16HImode:
      if (pattern228 (x2, 
E_V16HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25089; /* andv16hi3 */

    case E_V32HImode:
      if (pattern228 (x2, 
E_V32HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25103; /* andv32hi3 */

    case E_V64HImode:
      if (pattern228 (x2, 
E_V64HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25117; /* andv64hi3 */

    case E_V128HImode:
      if (pattern228 (x2, 
E_V128HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25131; /* andv128hi3 */

    case E_V256HImode:
      if (pattern228 (x2, 
E_V256HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25145; /* andv256hi3 */

    case E_V512HImode:
      if (pattern228 (x2, 
E_V512HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25159; /* andv512hi3 */

    case E_V1024HImode:
      if (pattern228 (x2, 
E_V1024HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25173; /* andv1024hi3 */

    case E_V2048HImode:
      if (pattern228 (x2, 
E_V2048HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25187; /* andv2048hi3 */

    case E_V1SImode:
      if (pattern228 (x2, 
E_V1SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25201; /* andv1si3 */

    case E_V2SImode:
      if (pattern228 (x2, 
E_V2SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25215; /* andv2si3 */

    case E_V4SImode:
      if (pattern228 (x2, 
E_V4SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25229; /* andv4si3 */

    case E_V8SImode:
      if (pattern228 (x2, 
E_V8SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25243; /* andv8si3 */

    case E_V16SImode:
      if (pattern228 (x2, 
E_V16SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25257; /* andv16si3 */

    case E_V32SImode:
      if (pattern228 (x2, 
E_V32SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25271; /* andv32si3 */

    case E_V64SImode:
      if (pattern228 (x2, 
E_V64SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25285; /* andv64si3 */

    case E_V128SImode:
      if (pattern228 (x2, 
E_V128SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25299; /* andv128si3 */

    case E_V256SImode:
      if (pattern228 (x2, 
E_V256SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25313; /* andv256si3 */

    case E_V512SImode:
      if (pattern228 (x2, 
E_V512SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25327; /* andv512si3 */

    case E_V1024SImode:
      if (pattern228 (x2, 
E_V1024SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25341; /* andv1024si3 */

    case E_V1DImode:
      if (pattern228 (x2, 
E_V1DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25355; /* andv1di3 */

    case E_V2DImode:
      if (pattern228 (x2, 
E_V2DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25369; /* andv2di3 */

    case E_V4DImode:
      if (pattern228 (x2, 
E_V4DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25383; /* andv4di3 */

    case E_V8DImode:
      if (pattern228 (x2, 
E_V8DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25397; /* andv8di3 */

    case E_V16DImode:
      if (pattern228 (x2, 
E_V16DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25411; /* andv16di3 */

    case E_V32DImode:
      if (pattern228 (x2, 
E_V32DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25425; /* andv32di3 */

    case E_V64DImode:
      if (pattern228 (x2, 
E_V64DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25439; /* andv64di3 */

    case E_V128DImode:
      if (pattern228 (x2, 
E_V128DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25453; /* andv128di3 */

    case E_V256DImode:
      if (pattern228 (x2, 
E_V256DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25467; /* andv256di3 */

    case E_V512DImode:
      if (pattern228 (x2, 
E_V512DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25481; /* andv512di3 */

    case E_RVVMF64BImode:
      if (pattern0 (x2, 
E_RVVMF64BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 25901; /* andrvvmf64bi3 */

    case E_RVVMF32BImode:
      if (pattern0 (x2, 
E_RVVMF32BImode) != 0
          || !
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25904; /* andrvvmf32bi3 */

    case E_RVVMF16BImode:
      if (pattern0 (x2, 
E_RVVMF16BImode) != 0
          || !
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25907; /* andrvvmf16bi3 */

    case E_RVVMF8BImode:
      if (pattern0 (x2, 
E_RVVMF8BImode) != 0
          || !
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25910; /* andrvvmf8bi3 */

    case E_RVVMF4BImode:
      if (pattern0 (x2, 
E_RVVMF4BImode) != 0
          || !
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25913; /* andrvvmf4bi3 */

    case E_RVVMF2BImode:
      if (pattern0 (x2, 
E_RVVMF2BImode) != 0
          || !
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25916; /* andrvvmf2bi3 */

    case E_RVVM1BImode:
      if (pattern0 (x2, 
E_RVVM1BImode) != 0
          || !
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25919; /* andrvvm1bi3 */

    case E_V1BImode:
      if (pattern0 (x2, 
E_V1BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return -1;
      return 25922; /* andv1bi3 */

    case E_V2BImode:
      if (pattern0 (x2, 
E_V2BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return -1;
      return 25925; /* andv2bi3 */

    case E_V4BImode:
      if (pattern0 (x2, 
E_V4BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return -1;
      return 25928; /* andv4bi3 */

    case E_V8BImode:
      if (pattern0 (x2, 
E_V8BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return -1;
      return 25931; /* andv8bi3 */

    case E_V16BImode:
      if (pattern0 (x2, 
E_V16BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return -1;
      return 25934; /* andv16bi3 */

    case E_V32BImode:
      if (pattern0 (x2, 
E_V32BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return -1;
      return 25937; /* andv32bi3 */

    case E_V64BImode:
      if (pattern0 (x2, 
E_V64BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25940; /* andv64bi3 */

    case E_V128BImode:
      if (pattern0 (x2, 
E_V128BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25943; /* andv128bi3 */

    case E_V256BImode:
      if (pattern0 (x2, 
E_V256BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25946; /* andv256bi3 */

    case E_V512BImode:
      if (pattern0 (x2, 
E_V512BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25949; /* andv512bi3 */

    case E_V1024BImode:
      if (pattern0 (x2, 
E_V1024BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25952; /* andv1024bi3 */

    case E_V2048BImode:
      if (pattern0 (x2, 
E_V2048BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25955; /* andv2048bi3 */

    case E_V4096BImode:
      if (pattern0 (x2, 
E_V4096BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25958; /* andv4096bi3 */

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      x2 = XEXP (x1, 1);
      switch (pattern290 (x2))
        {
        case 0:
          if (
#line 1878 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_ZBA && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX
   && !(REG_P (operands[1]) && VL_REG_P (REGNO (operands[1])))))
            return 121; /* *zero_extendsidi2_internal */
          if (!
#line 25 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA && !TARGET_XTHEADMEMIDX))
            return -1;
          return 508; /* *zero_extendsidi2_bitmanip */

        case 1:
          if ((
#line 1905 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 123; /* *zero_extendhidi2 */
          if (!(
#line 310 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 541; /* *zero_extendhidi2_bitmanip */

        case 2:
          if (!(
#line 1934 "../../gcc/config/riscv/riscv.md"
(!TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 126; /* *zero_extendqidi2_internal */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern281 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 1905 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 122; /* *zero_extendhisi2 */
          if (!
#line 310 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 540; /* *zero_extendhisi2_bitmanip */

        case 1:
          if (!
#line 1934 "../../gcc/config/riscv/riscv.md"
(!TARGET_XTHEADMEMIDX))
            return -1;
          return 125; /* *zero_extendqisi2_internal */

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_HImode
          || !nonimmediate_operand (operands[1], E_QImode)
          || !
#line 1934 "../../gcc/config/riscv/riscv.md"
(!TARGET_XTHEADMEMIDX))
        return -1;
      return 124; /* *zero_extendqihi2_internal */

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26104; /* zero_extendrvvm4qirvvm8hi2 */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26106; /* zero_extendrvvm2qirvvm4hi2 */

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26108; /* zero_extendrvvm1qirvvm2hi2 */

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26110; /* zero_extendrvvmf2qirvvm1hi2 */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26112; /* zero_extendrvvmf4qirvvmf2hi2 */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 26114; /* zero_extendrvvmf8qirvvmf4hi2 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      switch (pattern291 (x2))
        {
        case 0:
          if (!
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26116; /* zero_extendrvvm4hirvvm8si2 */

        case 1:
          if (!
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26200; /* zero_extendrvvm2qirvvm8si2 */

        default:
          return -1;
        }

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      switch (pattern292 (x2))
        {
        case 0:
          if (!
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26118; /* zero_extendrvvm2hirvvm4si2 */

        case 1:
          if (!
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26202; /* zero_extendrvvm1qirvvm4si2 */

        default:
          return -1;
        }

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      switch (pattern293 (x2))
        {
        case 0:
          if (!
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26120; /* zero_extendrvvm1hirvvm2si2 */

        case 1:
          if (!
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26204; /* zero_extendrvvmf2qirvvm2si2 */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern294 (x2))
        {
        case 0:
          if (!
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26122; /* zero_extendrvvmf2hirvvm1si2 */

        case 1:
          if (!
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26206; /* zero_extendrvvmf4qirvvm1si2 */

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      switch (pattern295 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 26124; /* zero_extendrvvmf4hirvvmf2si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 26208; /* zero_extendrvvmf8qirvvmf2si2 */

        default:
          return -1;
        }

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      switch (pattern296 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26126; /* zero_extendrvvm4sirvvm8di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26210; /* zero_extendrvvm2hirvvm8di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26260; /* zero_extendrvvm1qirvvm8di2 */

        default:
          return -1;
        }

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      switch (pattern297 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26128; /* zero_extendrvvm2sirvvm4di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26212; /* zero_extendrvvm1hirvvm4di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26262; /* zero_extendrvvmf2qirvvm4di2 */

        default:
          return -1;
        }

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      switch (pattern298 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26130; /* zero_extendrvvm1sirvvm2di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26214; /* zero_extendrvvmf2hirvvm2di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26264; /* zero_extendrvvmf4qirvvm2di2 */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern299 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26132; /* zero_extendrvvmf2sirvvm1di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26216; /* zero_extendrvvmf4hirvvm1di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26266; /* zero_extendrvvmf8qirvvm1di2 */

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 26134; /* zero_extendv1qiv1hi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 26136; /* zero_extendv2qiv2hi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 26138; /* zero_extendv4qiv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 26140; /* zero_extendv8qiv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 26142; /* zero_extendv16qiv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26144; /* zero_extendv32qiv32hi2 */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26146; /* zero_extendv64qiv64hi2 */

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26148; /* zero_extendv128qiv128hi2 */

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26150; /* zero_extendv256qiv256hi2 */

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26152; /* zero_extendv512qiv512hi2 */

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26154; /* zero_extendv1024qiv1024hi2 */

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048QImode)
          || !(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26156; /* zero_extendv2048qiv2048hi2 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern300 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 26158; /* zero_extendv1hiv1si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 26218; /* zero_extendv1qiv1si2 */

        default:
          return -1;
        }

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      switch (pattern301 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 26160; /* zero_extendv2hiv2si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 26220; /* zero_extendv2qiv2si2 */

        default:
          return -1;
        }

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      switch (pattern302 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 26162; /* zero_extendv4hiv4si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 26222; /* zero_extendv4qiv4si2 */

        default:
          return -1;
        }

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      switch (pattern303 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 26164; /* zero_extendv8hiv8si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 26224; /* zero_extendv8qiv8si2 */

        default:
          return -1;
        }

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      switch (pattern304 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26166; /* zero_extendv16hiv16si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26226; /* zero_extendv16qiv16si2 */

        default:
          return -1;
        }

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      switch (pattern305 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26168; /* zero_extendv32hiv32si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26228; /* zero_extendv32qiv32si2 */

        default:
          return -1;
        }

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26170; /* zero_extendv64hiv64si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26230; /* zero_extendv64qiv64si2 */

        default:
          return -1;
        }

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      switch (pattern307 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26172; /* zero_extendv128hiv128si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26232; /* zero_extendv128qiv128si2 */

        default:
          return -1;
        }

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      switch (pattern308 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26174; /* zero_extendv256hiv256si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26234; /* zero_extendv256qiv256si2 */

        default:
          return -1;
        }

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      switch (pattern309 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26176; /* zero_extendv512hiv512si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26236; /* zero_extendv512qiv512si2 */

        default:
          return -1;
        }

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      switch (pattern310 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26178; /* zero_extendv1024hiv1024si2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26238; /* zero_extendv1024qiv1024si2 */

        default:
          return -1;
        }

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern311 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26180; /* zero_extendv1siv1di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26240; /* zero_extendv1hiv1di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26268; /* zero_extendv1qiv1di2 */

        default:
          return -1;
        }

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      switch (pattern312 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26182; /* zero_extendv2siv2di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26242; /* zero_extendv2hiv2di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26270; /* zero_extendv2qiv2di2 */

        default:
          return -1;
        }

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      switch (pattern313 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26184; /* zero_extendv4siv4di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26244; /* zero_extendv4hiv4di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26272; /* zero_extendv4qiv4di2 */

        default:
          return -1;
        }

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      switch (pattern314 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26186; /* zero_extendv8siv8di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26246; /* zero_extendv8hiv8di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26274; /* zero_extendv8qiv8di2 */

        default:
          return -1;
        }

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      switch (pattern315 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26188; /* zero_extendv16siv16di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26248; /* zero_extendv16hiv16di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26276; /* zero_extendv16qiv16di2 */

        default:
          return -1;
        }

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      switch (pattern316 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26190; /* zero_extendv32siv32di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26250; /* zero_extendv32hiv32di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26278; /* zero_extendv32qiv32di2 */

        default:
          return -1;
        }

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      switch (pattern317 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26192; /* zero_extendv64siv64di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26252; /* zero_extendv64hiv64di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26280; /* zero_extendv64qiv64di2 */

        default:
          return -1;
        }

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      switch (pattern318 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26194; /* zero_extendv128siv128di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26254; /* zero_extendv128hiv128di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26282; /* zero_extendv128qiv128di2 */

        default:
          return -1;
        }

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26196; /* zero_extendv256siv256di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26256; /* zero_extendv256hiv256di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26284; /* zero_extendv256qiv256di2 */

        default:
          return -1;
        }

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      switch (pattern320 (x2))
        {
        case 0:
          if (!(
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26198; /* zero_extendv512siv512di2 */

        case 1:
          if (!(
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26258; /* zero_extendv512hiv512di2 */

        case 2:
          if (!(
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26286; /* zero_extendv512qiv512di2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_261 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3118; /* *movrvvm1x8bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3119; /* *movrvvm1x8bf_di */
}

 int
recog_269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x4SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x4SImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3102; /* *movrvvm2x4si_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3103; /* *movrvvm2x4si_di */
}

 int
recog_273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x7HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x7HImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3094; /* *movrvvm1x7hi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3095; /* *movrvvm1x7hi_di */
}

 int
recog_281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3078; /* *movrvvmf2x6qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3079; /* *movrvvmf2x6qi_di */
}

 int
recog_289 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8SFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3062; /* *movrvvm1x8sf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3063; /* *movrvvm1x8sf_di */
}

 int
recog_297 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x7HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x7HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3046; /* *movrvvmf2x7hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3047; /* *movrvvmf2x7hf_di */
}

 int
recog_305 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3030; /* *movrvvmf2x6bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3031; /* *movrvvmf2x6bf_di */
}

 int
recog_313 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8SImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3014; /* *movrvvm1x8si_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3015; /* *movrvvm1x8si_di */
}

 int
recog_321 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x7HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x7HImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2998; /* *movrvvmf2x7hi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2999; /* *movrvvmf2x7hi_di */
}

 int
recog_329 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x6QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x6QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2982; /* *movrvvmf4x6qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2983; /* *movrvvmf4x6qi_di */
}

 int
recog_337 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5DFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2966; /* *movrvvm1x5df_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2967; /* *movrvvm1x5df_di */
}

 int
recog_345 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4SFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2950; /* *movrvvmf2x4sf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2951; /* *movrvvmf2x4sf_di */
}

 int
recog_353 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x3HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x3HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2934; /* *movrvvmf4x3hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2935; /* *movrvvmf4x3hf_di */
}

 int
recog_361 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x2BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x2BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2918; /* *movrvvmf4x2bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2919; /* *movrvvmf4x2bf_di */
}

 int
recog_370 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x7SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x7SImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2900; /* *movrvvmf2x7si_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2901; /* *movrvvmf2x7si_di */
}

 int
recog_378 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern200 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[2], E_RVVM4QImode)
          && 
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32119; /* *vwsll_zext1_rvvm8hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32215; /* *vwsll_zext1_scalar_rvvm8hi */

    case 1:
      if (vector_shift_operand (operands[2], E_RVVM2QImode)
          && 
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32120; /* *vwsll_zext1_rvvm4hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32216; /* *vwsll_zext1_scalar_rvvm4hi */

    case 2:
      if (vector_shift_operand (operands[2], E_RVVM1QImode)
          && 
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32121; /* *vwsll_zext1_rvvm2hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32217; /* *vwsll_zext1_scalar_rvvm2hi */

    case 3:
      if (vector_shift_operand (operands[2], E_RVVMF2QImode)
          && 
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32122; /* *vwsll_zext1_rvvm1hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32218; /* *vwsll_zext1_scalar_rvvm1hi */

    case 4:
      if (vector_shift_operand (operands[2], E_RVVMF4QImode)
          && 
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32123; /* *vwsll_zext1_rvvmf2hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32219; /* *vwsll_zext1_scalar_rvvmf2hi */

    case 5:
      if (vector_shift_operand (operands[2], E_RVVMF8QImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32124; /* *vwsll_zext1_rvvmf4hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32220; /* *vwsll_zext1_scalar_rvvmf4hi */

    case 6:
      if (vector_shift_operand (operands[2], E_RVVM4HImode)
          && 
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32125; /* *vwsll_zext1_rvvm8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32221; /* *vwsll_zext1_scalar_rvvm8si */

    case 7:
      if (vector_shift_operand (operands[2], E_RVVM2HImode)
          && 
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32126; /* *vwsll_zext1_rvvm4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32222; /* *vwsll_zext1_scalar_rvvm4si */

    case 8:
      if (vector_shift_operand (operands[2], E_RVVM1HImode)
          && 
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32127; /* *vwsll_zext1_rvvm2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32223; /* *vwsll_zext1_scalar_rvvm2si */

    case 9:
      if (vector_shift_operand (operands[2], E_RVVMF2HImode)
          && 
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32128; /* *vwsll_zext1_rvvm1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32224; /* *vwsll_zext1_scalar_rvvm1si */

    case 10:
      if (vector_shift_operand (operands[2], E_RVVMF4HImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32129; /* *vwsll_zext1_rvvmf2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32225; /* *vwsll_zext1_scalar_rvvmf2si */

    case 11:
      if (vector_shift_operand (operands[2], E_RVVM4SImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32130; /* *vwsll_zext1_rvvm8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32226; /* *vwsll_zext1_scalar_rvvm8di */

    case 12:
      if (vector_shift_operand (operands[2], E_RVVM2SImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32131; /* *vwsll_zext1_rvvm4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32227; /* *vwsll_zext1_scalar_rvvm4di */

    case 13:
      if (vector_shift_operand (operands[2], E_RVVM1SImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32132; /* *vwsll_zext1_rvvm2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32228; /* *vwsll_zext1_scalar_rvvm2di */

    case 14:
      if (vector_shift_operand (operands[2], E_RVVMF2SImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32133; /* *vwsll_zext1_rvvm1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32229; /* *vwsll_zext1_scalar_rvvm1di */

    case 15:
      if (vector_shift_operand (operands[2], E_V1QImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 32134; /* *vwsll_zext1_v1hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 32230; /* *vwsll_zext1_scalar_v1hi */

    case 16:
      if (vector_shift_operand (operands[2], E_V2QImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 32135; /* *vwsll_zext1_v2hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 32231; /* *vwsll_zext1_scalar_v2hi */

    case 17:
      if (vector_shift_operand (operands[2], E_V4QImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 32136; /* *vwsll_zext1_v4hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 32232; /* *vwsll_zext1_scalar_v4hi */

    case 18:
      if (vector_shift_operand (operands[2], E_V8QImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 32137; /* *vwsll_zext1_v8hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 32233; /* *vwsll_zext1_scalar_v8hi */

    case 19:
      if (vector_shift_operand (operands[2], E_V16QImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 32138; /* *vwsll_zext1_v16hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 32234; /* *vwsll_zext1_scalar_v16hi */

    case 20:
      if (vector_shift_operand (operands[2], E_V32QImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 32139; /* *vwsll_zext1_v32hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32235; /* *vwsll_zext1_scalar_v32hi */

    case 21:
      if (vector_shift_operand (operands[2], E_V64QImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 32140; /* *vwsll_zext1_v64hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32236; /* *vwsll_zext1_scalar_v64hi */

    case 22:
      if (vector_shift_operand (operands[2], E_V128QImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 32141; /* *vwsll_zext1_v128hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32237; /* *vwsll_zext1_scalar_v128hi */

    case 23:
      if (vector_shift_operand (operands[2], E_V256QImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 32142; /* *vwsll_zext1_v256hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32238; /* *vwsll_zext1_scalar_v256hi */

    case 24:
      if (vector_shift_operand (operands[2], E_V512QImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 32143; /* *vwsll_zext1_v512hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32239; /* *vwsll_zext1_scalar_v512hi */

    case 25:
      if (vector_shift_operand (operands[2], E_V1024QImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 32144; /* *vwsll_zext1_v1024hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32240; /* *vwsll_zext1_scalar_v1024hi */

    case 26:
      if (vector_shift_operand (operands[2], E_V2048QImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 32145; /* *vwsll_zext1_v2048hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32241; /* *vwsll_zext1_scalar_v2048hi */

    case 27:
      if (vector_shift_operand (operands[2], E_V1HImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 32146; /* *vwsll_zext1_v1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32242; /* *vwsll_zext1_scalar_v1si */

    case 28:
      if (vector_shift_operand (operands[2], E_V2HImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 32147; /* *vwsll_zext1_v2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32243; /* *vwsll_zext1_scalar_v2si */

    case 29:
      if (vector_shift_operand (operands[2], E_V4HImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 32148; /* *vwsll_zext1_v4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32244; /* *vwsll_zext1_scalar_v4si */

    case 30:
      if (vector_shift_operand (operands[2], E_V8HImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 32149; /* *vwsll_zext1_v8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32245; /* *vwsll_zext1_scalar_v8si */

    case 31:
      if (vector_shift_operand (operands[2], E_V16HImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 32150; /* *vwsll_zext1_v16si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32246; /* *vwsll_zext1_scalar_v16si */

    case 32:
      if (vector_shift_operand (operands[2], E_V32HImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 32151; /* *vwsll_zext1_v32si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32247; /* *vwsll_zext1_scalar_v32si */

    case 33:
      if (vector_shift_operand (operands[2], E_V64HImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 32152; /* *vwsll_zext1_v64si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32248; /* *vwsll_zext1_scalar_v64si */

    case 34:
      if (vector_shift_operand (operands[2], E_V128HImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 32153; /* *vwsll_zext1_v128si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32249; /* *vwsll_zext1_scalar_v128si */

    case 35:
      if (vector_shift_operand (operands[2], E_V256HImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 32154; /* *vwsll_zext1_v256si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32250; /* *vwsll_zext1_scalar_v256si */

    case 36:
      if (vector_shift_operand (operands[2], E_V512HImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 32155; /* *vwsll_zext1_v512si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32251; /* *vwsll_zext1_scalar_v512si */

    case 37:
      if (vector_shift_operand (operands[2], E_V1024HImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 32156; /* *vwsll_zext1_v1024si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32252; /* *vwsll_zext1_scalar_v1024si */

    case 38:
      if (vector_shift_operand (operands[2], E_V1SImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 32157; /* *vwsll_zext1_v1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32253; /* *vwsll_zext1_scalar_v1di */

    case 39:
      if (vector_shift_operand (operands[2], E_V2SImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 32158; /* *vwsll_zext1_v2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32254; /* *vwsll_zext1_scalar_v2di */

    case 40:
      if (vector_shift_operand (operands[2], E_V4SImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 32159; /* *vwsll_zext1_v4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32255; /* *vwsll_zext1_scalar_v4di */

    case 41:
      if (vector_shift_operand (operands[2], E_V8SImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 32160; /* *vwsll_zext1_v8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32256; /* *vwsll_zext1_scalar_v8di */

    case 42:
      if (vector_shift_operand (operands[2], E_V16SImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 32161; /* *vwsll_zext1_v16di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32257; /* *vwsll_zext1_scalar_v16di */

    case 43:
      if (vector_shift_operand (operands[2], E_V32SImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 32162; /* *vwsll_zext1_v32di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32258; /* *vwsll_zext1_scalar_v32di */

    case 44:
      if (vector_shift_operand (operands[2], E_V64SImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 32163; /* *vwsll_zext1_v64di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32259; /* *vwsll_zext1_scalar_v64di */

    case 45:
      if (vector_shift_operand (operands[2], E_V128SImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 32164; /* *vwsll_zext1_v128di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32260; /* *vwsll_zext1_scalar_v128di */

    case 46:
      if (vector_shift_operand (operands[2], E_V256SImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 32165; /* *vwsll_zext1_v256di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32261; /* *vwsll_zext1_scalar_v256di */

    case 47:
      if (vector_shift_operand (operands[2], E_V512SImode)
          && (
#line 1487 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 32166; /* *vwsll_zext1_v512di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32262; /* *vwsll_zext1_scalar_v512di */

    case 48:
      if (!
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32167; /* *vwsll_zext2_rvvm8hi */

    case 49:
      if (!
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32168; /* *vwsll_zext2_rvvm4hi */

    case 50:
      if (!
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32169; /* *vwsll_zext2_rvvm2hi */

    case 51:
      if (!
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32170; /* *vwsll_zext2_rvvm1hi */

    case 52:
      if (!
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32171; /* *vwsll_zext2_rvvmf2hi */

    case 53:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32172; /* *vwsll_zext2_rvvmf4hi */

    case 54:
      if (!
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32173; /* *vwsll_zext2_rvvm8si */

    case 55:
      if (!
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32174; /* *vwsll_zext2_rvvm4si */

    case 56:
      if (!
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32175; /* *vwsll_zext2_rvvm2si */

    case 57:
      if (!
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32176; /* *vwsll_zext2_rvvm1si */

    case 58:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32177; /* *vwsll_zext2_rvvmf2si */

    case 59:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32178; /* *vwsll_zext2_rvvm8di */

    case 60:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32179; /* *vwsll_zext2_rvvm4di */

    case 61:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32180; /* *vwsll_zext2_rvvm2di */

    case 62:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32181; /* *vwsll_zext2_rvvm1di */

    case 63:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 32182; /* *vwsll_zext2_v1hi */

    case 64:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 32183; /* *vwsll_zext2_v2hi */

    case 65:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 32184; /* *vwsll_zext2_v4hi */

    case 66:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 32185; /* *vwsll_zext2_v8hi */

    case 67:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 32186; /* *vwsll_zext2_v16hi */

    case 68:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32187; /* *vwsll_zext2_v32hi */

    case 69:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32188; /* *vwsll_zext2_v64hi */

    case 70:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32189; /* *vwsll_zext2_v128hi */

    case 71:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32190; /* *vwsll_zext2_v256hi */

    case 72:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32191; /* *vwsll_zext2_v512hi */

    case 73:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32192; /* *vwsll_zext2_v1024hi */

    case 74:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32193; /* *vwsll_zext2_v2048hi */

    case 75:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32194; /* *vwsll_zext2_v1si */

    case 76:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32195; /* *vwsll_zext2_v2si */

    case 77:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32196; /* *vwsll_zext2_v4si */

    case 78:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32197; /* *vwsll_zext2_v8si */

    case 79:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32198; /* *vwsll_zext2_v16si */

    case 80:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32199; /* *vwsll_zext2_v32si */

    case 81:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32200; /* *vwsll_zext2_v64si */

    case 82:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32201; /* *vwsll_zext2_v128si */

    case 83:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32202; /* *vwsll_zext2_v256si */

    case 84:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32203; /* *vwsll_zext2_v512si */

    case 85:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32204; /* *vwsll_zext2_v1024si */

    case 86:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32205; /* *vwsll_zext2_v1di */

    case 87:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32206; /* *vwsll_zext2_v2di */

    case 88:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32207; /* *vwsll_zext2_v4di */

    case 89:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32208; /* *vwsll_zext2_v8di */

    case 90:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32209; /* *vwsll_zext2_v16di */

    case 91:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32210; /* *vwsll_zext2_v32di */

    case 92:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32211; /* *vwsll_zext2_v64di */

    case 93:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32212; /* *vwsll_zext2_v128di */

    case 94:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32213; /* *vwsll_zext2_v256di */

    case 95:
      if (!(
#line 1505 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32214; /* *vwsll_zext2_v512di */

    default:
      return -1;
    }
}

 int
recog_402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern476 (x2))
    {
    case 0:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33380; /* pred_crypto_vvaeszvsrvvm8si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33440; /* pred_crypto_vvaeszvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33500; /* pred_crypto_vvaeszvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33548; /* pred_crypto_vvaeszvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33584; /* pred_crypto_vvaeszvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4419 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33608; /* pred_crypto_vvaeszvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33392; /* pred_crypto_vvaeszvsrvvm4si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33452; /* pred_crypto_vvaeszvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33512; /* pred_crypto_vvaeszvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33560; /* pred_crypto_vvaeszvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4415 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33596; /* pred_crypto_vvaeszvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33404; /* pred_crypto_vvaeszvsrvvm2si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33464; /* pred_crypto_vvaeszvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33524; /* pred_crypto_vvaeszvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4411 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33572; /* pred_crypto_vvaeszvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33416; /* pred_crypto_vvaeszvsrvvm1si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33476; /* pred_crypto_vvaeszvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4407 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33536; /* pred_crypto_vvaeszvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4403 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 33428; /* pred_crypto_vvaeszvsrvvmf2si */
      if (!(
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4403 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33488; /* pred_crypto_vvaeszvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_405 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[6] = x6;
  x7 = XEXP (x2, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  x9 = XVECEXP (x7, 0, 1);
  operands[2] = x9;
  x10 = XVECEXP (x7, 0, 2);
  operands[3] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (XINT (x7, 1))
    {
    case 199:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SImode:
          if (pattern641 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33251; /* pred_vghshrvvm8si */

        case E_RVVM4SImode:
          if (pattern641 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33255; /* pred_vghshrvvm4si */

        case E_RVVM2SImode:
          if (pattern641 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33259; /* pred_vghshrvvm2si */

        case E_RVVM1SImode:
          if (pattern641 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33263; /* pred_vghshrvvm1si */

        case E_RVVMF2SImode:
          if (pattern641 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 33267; /* pred_vghshrvvmf2si */

        case E_RVVM8DImode:
          if (pattern641 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33271; /* pred_vghshrvvm8di */

        case E_RVVM4DImode:
          if (pattern641 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33275; /* pred_vghshrvvm4di */

        case E_RVVM2DImode:
          if (pattern641 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33279; /* pred_vghshrvvm2di */

        case E_RVVM1DImode:
          if (pattern641 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33283; /* pred_vghshrvvm1di */

        case E_V1SImode:
          if (pattern641 (x2, 
E_V1SImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 33287; /* pred_vghshv1si */

        case E_V2SImode:
          if (pattern641 (x2, 
E_V2SImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 33291; /* pred_vghshv2si */

        case E_V4SImode:
          if (pattern641 (x2, 
E_V4SImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 33295; /* pred_vghshv4si */

        case E_V8SImode:
          if (pattern641 (x2, 
E_V8SImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 33299; /* pred_vghshv8si */

        case E_V16SImode:
          if (pattern641 (x2, 
E_V16SImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33303; /* pred_vghshv16si */

        case E_V32SImode:
          if (pattern641 (x2, 
E_V32SImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33307; /* pred_vghshv32si */

        case E_V64SImode:
          if (pattern641 (x2, 
E_V64SImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33311; /* pred_vghshv64si */

        case E_V128SImode:
          if (pattern641 (x2, 
E_V128SImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33315; /* pred_vghshv128si */

        case E_V256SImode:
          if (pattern641 (x2, 
E_V256SImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33319; /* pred_vghshv256si */

        case E_V512SImode:
          if (pattern641 (x2, 
E_V512SImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33323; /* pred_vghshv512si */

        case E_V1024SImode:
          if (pattern641 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33327; /* pred_vghshv1024si */

        case E_V1DImode:
          if (pattern641 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33331; /* pred_vghshv1di */

        case E_V2DImode:
          if (pattern641 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33335; /* pred_vghshv2di */

        case E_V4DImode:
          if (pattern641 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33339; /* pred_vghshv4di */

        case E_V8DImode:
          if (pattern641 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33343; /* pred_vghshv8di */

        case E_V16DImode:
          if (pattern641 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33347; /* pred_vghshv16di */

        case E_V32DImode:
          if (pattern641 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33351; /* pred_vghshv32di */

        case E_V64DImode:
          if (pattern641 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33355; /* pred_vghshv64di */

        case E_V128DImode:
          if (pattern641 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33359; /* pred_vghshv128di */

        case E_V256DImode:
          if (pattern641 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33363; /* pred_vghshv256di */

        case E_V512DImode:
          if (pattern641 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33367; /* pred_vghshv512di */

        default:
          return -1;
        }

    case 218:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SImode:
          if (pattern641 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33252; /* pred_vsha2msrvvm8si */

        case E_RVVM4SImode:
          if (pattern641 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33256; /* pred_vsha2msrvvm4si */

        case E_RVVM2SImode:
          if (pattern641 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33260; /* pred_vsha2msrvvm2si */

        case E_RVVM1SImode:
          if (pattern641 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33264; /* pred_vsha2msrvvm1si */

        case E_RVVMF2SImode:
          if (pattern641 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 33268; /* pred_vsha2msrvvmf2si */

        case E_RVVM8DImode:
          if (pattern641 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33272; /* pred_vsha2msrvvm8di */

        case E_RVVM4DImode:
          if (pattern641 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33276; /* pred_vsha2msrvvm4di */

        case E_RVVM2DImode:
          if (pattern641 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33280; /* pred_vsha2msrvvm2di */

        case E_RVVM1DImode:
          if (pattern641 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33284; /* pred_vsha2msrvvm1di */

        case E_V1SImode:
          if (pattern641 (x2, 
E_V1SImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 33288; /* pred_vsha2msv1si */

        case E_V2SImode:
          if (pattern641 (x2, 
E_V2SImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 33292; /* pred_vsha2msv2si */

        case E_V4SImode:
          if (pattern641 (x2, 
E_V4SImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 33296; /* pred_vsha2msv4si */

        case E_V8SImode:
          if (pattern641 (x2, 
E_V8SImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 33300; /* pred_vsha2msv8si */

        case E_V16SImode:
          if (pattern641 (x2, 
E_V16SImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33304; /* pred_vsha2msv16si */

        case E_V32SImode:
          if (pattern641 (x2, 
E_V32SImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33308; /* pred_vsha2msv32si */

        case E_V64SImode:
          if (pattern641 (x2, 
E_V64SImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33312; /* pred_vsha2msv64si */

        case E_V128SImode:
          if (pattern641 (x2, 
E_V128SImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33316; /* pred_vsha2msv128si */

        case E_V256SImode:
          if (pattern641 (x2, 
E_V256SImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33320; /* pred_vsha2msv256si */

        case E_V512SImode:
          if (pattern641 (x2, 
E_V512SImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33324; /* pred_vsha2msv512si */

        case E_V1024SImode:
          if (pattern641 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33328; /* pred_vsha2msv1024si */

        case E_V1DImode:
          if (pattern641 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33332; /* pred_vsha2msv1di */

        case E_V2DImode:
          if (pattern641 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33336; /* pred_vsha2msv2di */

        case E_V4DImode:
          if (pattern641 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33340; /* pred_vsha2msv4di */

        case E_V8DImode:
          if (pattern641 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33344; /* pred_vsha2msv8di */

        case E_V16DImode:
          if (pattern641 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33348; /* pred_vsha2msv16di */

        case E_V32DImode:
          if (pattern641 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33352; /* pred_vsha2msv32di */

        case E_V64DImode:
          if (pattern641 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33356; /* pred_vsha2msv64di */

        case E_V128DImode:
          if (pattern641 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33360; /* pred_vsha2msv128di */

        case E_V256DImode:
          if (pattern641 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33364; /* pred_vsha2msv256di */

        case E_V512DImode:
          if (pattern641 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33368; /* pred_vsha2msv512di */

        default:
          return -1;
        }

    case 219:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SImode:
          if (pattern641 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33253; /* pred_vsha2chrvvm8si */

        case E_RVVM4SImode:
          if (pattern641 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33257; /* pred_vsha2chrvvm4si */

        case E_RVVM2SImode:
          if (pattern641 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33261; /* pred_vsha2chrvvm2si */

        case E_RVVM1SImode:
          if (pattern641 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33265; /* pred_vsha2chrvvm1si */

        case E_RVVMF2SImode:
          if (pattern641 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 33269; /* pred_vsha2chrvvmf2si */

        case E_RVVM8DImode:
          if (pattern641 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33273; /* pred_vsha2chrvvm8di */

        case E_RVVM4DImode:
          if (pattern641 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33277; /* pred_vsha2chrvvm4di */

        case E_RVVM2DImode:
          if (pattern641 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33281; /* pred_vsha2chrvvm2di */

        case E_RVVM1DImode:
          if (pattern641 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33285; /* pred_vsha2chrvvm1di */

        case E_V1SImode:
          if (pattern641 (x2, 
E_V1SImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 33289; /* pred_vsha2chv1si */

        case E_V2SImode:
          if (pattern641 (x2, 
E_V2SImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 33293; /* pred_vsha2chv2si */

        case E_V4SImode:
          if (pattern641 (x2, 
E_V4SImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 33297; /* pred_vsha2chv4si */

        case E_V8SImode:
          if (pattern641 (x2, 
E_V8SImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 33301; /* pred_vsha2chv8si */

        case E_V16SImode:
          if (pattern641 (x2, 
E_V16SImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33305; /* pred_vsha2chv16si */

        case E_V32SImode:
          if (pattern641 (x2, 
E_V32SImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33309; /* pred_vsha2chv32si */

        case E_V64SImode:
          if (pattern641 (x2, 
E_V64SImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33313; /* pred_vsha2chv64si */

        case E_V128SImode:
          if (pattern641 (x2, 
E_V128SImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33317; /* pred_vsha2chv128si */

        case E_V256SImode:
          if (pattern641 (x2, 
E_V256SImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33321; /* pred_vsha2chv256si */

        case E_V512SImode:
          if (pattern641 (x2, 
E_V512SImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33325; /* pred_vsha2chv512si */

        case E_V1024SImode:
          if (pattern641 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33329; /* pred_vsha2chv1024si */

        case E_V1DImode:
          if (pattern641 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33333; /* pred_vsha2chv1di */

        case E_V2DImode:
          if (pattern641 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33337; /* pred_vsha2chv2di */

        case E_V4DImode:
          if (pattern641 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33341; /* pred_vsha2chv4di */

        case E_V8DImode:
          if (pattern641 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33345; /* pred_vsha2chv8di */

        case E_V16DImode:
          if (pattern641 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33349; /* pred_vsha2chv16di */

        case E_V32DImode:
          if (pattern641 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33353; /* pred_vsha2chv32di */

        case E_V64DImode:
          if (pattern641 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33357; /* pred_vsha2chv64di */

        case E_V128DImode:
          if (pattern641 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33361; /* pred_vsha2chv128di */

        case E_V256DImode:
          if (pattern641 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33365; /* pred_vsha2chv256di */

        case E_V512DImode:
          if (pattern641 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33369; /* pred_vsha2chv512di */

        default:
          return -1;
        }

    case 220:
      return recog_404 (x1, insn, pnum_clobbers);

    case 217:
      switch (pattern595 (x2))
        {
        case 0:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33621; /* pred_viaeskf2rvvm8si_nomaskedoff_scalar */

        case 1:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33623; /* pred_viaeskf2rvvm4si_nomaskedoff_scalar */

        case 2:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33625; /* pred_viaeskf2rvvm2si_nomaskedoff_scalar */

        case 3:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33627; /* pred_viaeskf2rvvm1si_nomaskedoff_scalar */

        case 4:
          if (!(
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH) && 
#line 4403 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 33629; /* pred_viaeskf2rvvmf2si_nomaskedoff_scalar */

        default:
          return -1;
        }

    case 226:
      switch (pattern595 (x2))
        {
        case 0:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33622; /* pred_vism3crvvm8si_nomaskedoff_scalar */

        case 1:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33624; /* pred_vism3crvvm4si_nomaskedoff_scalar */

        case 2:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33626; /* pred_vism3crvvm2si_nomaskedoff_scalar */

        case 3:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33628; /* pred_vism3crvvm1si_nomaskedoff_scalar */

        case 4:
          if (!(
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH) && 
#line 4403 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 33630; /* pred_vism3crvvmf2si_nomaskedoff_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_422 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V1DFmode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1DFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 4343; /* *pred_broadcastv1df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1DFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4465; /* *pred_broadcastv1df_imm */
}

 int
recog_426 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V128SFmode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 4339; /* *pred_broadcastv128sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4461; /* *pred_broadcastv128sf_imm */
}

 int
recog_430 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V8SFmode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 4335; /* *pred_broadcastv8sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4457; /* *pred_broadcastv8sf_imm */
}

 int
recog_433 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V1SFmode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 4332; /* *pred_broadcastv1sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4454; /* *pred_broadcastv1sf_imm */
}

 int
recog_437 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V256HFmode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256HFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return 4328; /* *pred_broadcastv256hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256HFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4450; /* *pred_broadcastv256hf_imm */
}

 int
recog_441 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V16HFmode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16HFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 4324; /* *pred_broadcastv16hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16HFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4446; /* *pred_broadcastv16hf_imm */
}

 int
recog_445 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V1HFmode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1HFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 4320; /* *pred_broadcastv1hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1HFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4442; /* *pred_broadcastv1hf_imm */
}

 int
recog_450 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32DImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 4315; /* *pred_broadcastv32di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32DImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4437; /* *pred_broadcastv32di_imm */
}

 int
recog_455 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1DImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 4310; /* *pred_broadcastv1di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1DImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 4432; /* *pred_broadcastv1di_imm */
}

 int
recog_461 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32SImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 4304; /* *pred_broadcastv32si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32SImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4426; /* *pred_broadcastv32si_imm */
}

 int
recog_467 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2048BImode)
      && vector_const_0_operand (operands[3], E_V2048HImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 4298; /* *pred_broadcastv2048hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2048BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2048HImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4420; /* *pred_broadcastv2048hi_imm */
}

 int
recog_474 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16HImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 4291; /* *pred_broadcastv16hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16HImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 4413; /* *pred_broadcastv16hi_imm */
}

 int
recog_481 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024QImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return 4284; /* *pred_broadcastv1024qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024QImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4406; /* *pred_broadcastv1024qi_imm */
}

 int
recog_488 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8QImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return 4277; /* *pred_broadcastv8qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8QImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return -1;
  return 4399; /* *pred_broadcastv8qi_imm */
}

 int
recog_496 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
      && vector_const_0_operand (operands[3], E_RVVMF2SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return 4269; /* *pred_broadcastrvvmf2sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF2SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 4391; /* *pred_broadcastrvvmf2sf_imm */
}

 int
recog_504 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
      && vector_const_0_operand (operands[3], E_RVVM2HFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 4261; /* *pred_broadcastrvvm2hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2HFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4383; /* *pred_broadcastrvvm2hf_imm */
}

 int
recog_512 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V128DFmode, 
E_V128BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V128DImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return 20702; /* pred_gatherv128df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20824; /* pred_gatherv128df_scalar */
}

 int
recog_517 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V4DFmode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4DImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 20697; /* pred_gatherv4df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20819; /* pred_gatherv4df_scalar */
}

 int
recog_522 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V256SFmode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256SImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return 20692; /* pred_gatherv256sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20814; /* pred_gatherv256sf_scalar */
}

 int
recog_527 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V8SFmode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8SImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 20687; /* pred_gatherv8sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 20809; /* pred_gatherv8sf_scalar */
}

 int
recog_532 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1024HImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
    return 20682; /* pred_gatherv1024hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20804; /* pred_gatherv1024hf_scalar */
}

 int
recog_537 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V32HFmode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32HImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
    return 20677; /* pred_gatherv32hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20799; /* pred_gatherv32hf_scalar */
}

 int
recog_544 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256DImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 20670; /* pred_gatherv256di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20792; /* pred_gatherv256di_scalar */
}

 int
recog_549 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8DImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 20665; /* pred_gatherv8di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20787; /* pred_gatherv8di_scalar */
}

 int
recog_554 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512SImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 20660; /* pred_gatherv512si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20782; /* pred_gatherv512si_scalar */
}

 int
recog_558 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32SImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 20656; /* pred_gatherv32si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 20778; /* pred_gatherv32si_scalar */
}

 int
recog_563 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1SImode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1SImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return 20651; /* pred_gatherv1si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return -1;
  return 20773; /* pred_gatherv1si_scalar */
}

 int
recog_568 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V128HImode, 
E_V128BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V128HImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return 20646; /* pred_gatherv128hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20768; /* pred_gatherv128hi_scalar */
}

 int
recog_573 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4HImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 20641; /* pred_gatherv4hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 20763; /* pred_gatherv4hi_scalar */
}

 int
recog_578 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1024QImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return 20636; /* pred_gatherv1024qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20758; /* pred_gatherv1024qi_scalar */
}

 int
recog_583 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V32QImode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32QImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return 20631; /* pred_gatherv32qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return -1;
  return 20753; /* pred_gatherv32qi_scalar */
}

 int
recog_588 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1QImode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1QImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return 20626; /* pred_gatherv1qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return -1;
  return 20748; /* pred_gatherv1qi_scalar */
}

 int
recog_593 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20827; /* pred_gatherei16rvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20828; /* pred_gatherei16rvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20829; /* pred_gatherei16rvvm1qi */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20830; /* pred_gatherei16rvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20831; /* pred_gatherei16rvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 402 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20832; /* pred_gatherei16rvvmf8qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20833; /* pred_gatherei16rvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20834; /* pred_gatherei16rvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20835; /* pred_gatherei16rvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20836; /* pred_gatherei16rvvm1hi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20837; /* pred_gatherei16rvvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 404 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20838; /* pred_gatherei16rvvmf4hi */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM8HFmode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 406 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20839; /* pred_gatherei16rvvm8hf */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM4HFmode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 406 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20840; /* pred_gatherei16rvvm4hf */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM2HFmode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 406 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20841; /* pred_gatherei16rvvm2hf */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM1HFmode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 407 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20842; /* pred_gatherei16rvvm1hf */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVMF2HFmode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 407 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20843; /* pred_gatherei16rvvmf2hf */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVMF4HFmode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 408 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 20844; /* pred_gatherei16rvvmf4hf */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20845; /* pred_gatherei16rvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20846; /* pred_gatherei16rvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20847; /* pred_gatherei16rvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20848; /* pred_gatherei16rvvm1si */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 410 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20849; /* pred_gatherei16rvvmf2si */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM8SFmode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 412 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20850; /* pred_gatherei16rvvm8sf */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM4SFmode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 412 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20851; /* pred_gatherei16rvvm4sf */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM2SFmode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 412 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20852; /* pred_gatherei16rvvm2sf */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM1SFmode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 413 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20853; /* pred_gatherei16rvvm1sf */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVMF2SFmode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 413 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 20854; /* pred_gatherei16rvvmf2sf */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM8DImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 415 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20855; /* pred_gatherei16rvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM4DImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 415 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20856; /* pred_gatherei16rvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM2DImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 416 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20857; /* pred_gatherei16rvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM1DImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 416 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20858; /* pred_gatherei16rvvm1di */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM8DFmode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 418 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20859; /* pred_gatherei16rvvm8df */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM4DFmode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 418 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20860; /* pred_gatherei16rvvm4df */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM2DFmode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 419 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20861; /* pred_gatherei16rvvm2df */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_RVVM1DFmode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 419 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20862; /* pred_gatherei16rvvm1df */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 421 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 20863; /* pred_gatherei16v1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 422 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 20864; /* pred_gatherei16v2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 423 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 20865; /* pred_gatherei16v4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 424 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 20866; /* pred_gatherei16v8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 425 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 20867; /* pred_gatherei16v16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 426 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20868; /* pred_gatherei16v32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 427 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20869; /* pred_gatherei16v64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 428 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20870; /* pred_gatherei16v128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 429 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20871; /* pred_gatherei16v256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 430 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20872; /* pred_gatherei16v512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 431 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20873; /* pred_gatherei16v1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 432 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20874; /* pred_gatherei16v2048qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 433 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 20875; /* pred_gatherei16v1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 434 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 20876; /* pred_gatherei16v2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 435 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 20877; /* pred_gatherei16v4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 436 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 20878; /* pred_gatherei16v8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 437 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 20879; /* pred_gatherei16v16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 438 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20880; /* pred_gatherei16v32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 439 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20881; /* pred_gatherei16v64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 440 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20882; /* pred_gatherei16v128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 441 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20883; /* pred_gatherei16v256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 442 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20884; /* pred_gatherei16v512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 443 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20885; /* pred_gatherei16v1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 444 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20886; /* pred_gatherei16v2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 445 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 20887; /* pred_gatherei16v1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 446 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 20888; /* pred_gatherei16v2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 447 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 20889; /* pred_gatherei16v4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 448 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 20890; /* pred_gatherei16v8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 449 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20891; /* pred_gatherei16v16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 450 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20892; /* pred_gatherei16v32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 451 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20893; /* pred_gatherei16v64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 452 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20894; /* pred_gatherei16v128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 453 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20895; /* pred_gatherei16v256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 454 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20896; /* pred_gatherei16v512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 455 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20897; /* pred_gatherei16v1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V1DImode, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 456 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20898; /* pred_gatherei16v1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V2DImode, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 457 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20899; /* pred_gatherei16v2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V4DImode, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 458 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20900; /* pred_gatherei16v4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V8DImode, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 459 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20901; /* pred_gatherei16v8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V16DImode, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 460 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20902; /* pred_gatherei16v16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V32DImode, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 461 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20903; /* pred_gatherei16v32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V64DImode, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 462 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20904; /* pred_gatherei16v64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V128DImode, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 463 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20905; /* pred_gatherei16v128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V256DImode, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 464 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20906; /* pred_gatherei16v256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V512DImode, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 465 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20907; /* pred_gatherei16v512di */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V1HFmode, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 466 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20908; /* pred_gatherei16v1hf */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V2HFmode, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 467 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20909; /* pred_gatherei16v2hf */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V4HFmode, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 468 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20910; /* pred_gatherei16v4hf */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V8HFmode, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 469 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20911; /* pred_gatherei16v8hf */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern549 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 470 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20912; /* pred_gatherei16v16hf */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V32HFmode, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 471 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20913; /* pred_gatherei16v32hf */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V64HFmode, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 472 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20914; /* pred_gatherei16v64hf */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V128HFmode, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 473 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20915; /* pred_gatherei16v128hf */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V256HFmode, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 474 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20916; /* pred_gatherei16v256hf */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V512HFmode, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 475 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20917; /* pred_gatherei16v512hf */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V1024HFmode, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 476 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20918; /* pred_gatherei16v1024hf */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V2048HFmode, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 477 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20919; /* pred_gatherei16v2048hf */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V1SFmode, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 478 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20920; /* pred_gatherei16v1sf */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V2SFmode, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 479 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20921; /* pred_gatherei16v2sf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V4SFmode, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 480 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20922; /* pred_gatherei16v4sf */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V8SFmode, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 481 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20923; /* pred_gatherei16v8sf */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V16SFmode, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 482 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20924; /* pred_gatherei16v16sf */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V32SFmode, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 483 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20925; /* pred_gatherei16v32sf */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V64SFmode, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 484 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20926; /* pred_gatherei16v64sf */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V128SFmode, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 485 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20927; /* pred_gatherei16v128sf */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V256SFmode, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 486 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20928; /* pred_gatherei16v256sf */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V512SFmode, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 487 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20929; /* pred_gatherei16v512sf */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V1024SFmode, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 488 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20930; /* pred_gatherei16v1024sf */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V1DFmode, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 489 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20931; /* pred_gatherei16v1df */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V2DFmode, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 490 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20932; /* pred_gatherei16v2df */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V4DFmode, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 491 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20933; /* pred_gatherei16v4df */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V8DFmode, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 492 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20934; /* pred_gatherei16v8df */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V16DFmode, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 493 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20935; /* pred_gatherei16v16df */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V32DFmode, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 494 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20936; /* pred_gatherei16v32df */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V64DFmode, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 495 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20937; /* pred_gatherei16v64df */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V128DFmode, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 496 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20938; /* pred_gatherei16v128df */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V256DFmode, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 497 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20939; /* pred_gatherei16v256df */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern683 (x2, 
E_V512DFmode, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 8270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 498 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20940; /* pred_gatherei16v512df */

    default:
      return -1;
    }
}

 int
recog_607 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM8QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM8QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM8QImode)
      || !
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13081; /* *pred_mul_plusrvvm8qi_undef */
}

 int
recog_608 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM4QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM4QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM4QImode)
      || !
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13082; /* *pred_mul_plusrvvm4qi_undef */
}

 int
recog_609 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM2QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM2QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM2QImode)
      || !
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13083; /* *pred_mul_plusrvvm2qi_undef */
}

 int
recog_610 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM1QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM1QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM1QImode)
      || !
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13084; /* *pred_mul_plusrvvm1qi_undef */
}

 int
recog_611 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM8HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM8HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM8HImode)
      || !
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13085; /* *pred_mul_plusrvvm8hi_undef */
}

 int
recog_612 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM4HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM4HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM4HImode)
      || !
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13086; /* *pred_mul_plusrvvm4hi_undef */
}

 int
recog_613 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM2HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM2HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM2HImode)
      || !
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13087; /* *pred_mul_plusrvvm2hi_undef */
}

 int
recog_614 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM1HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM1HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM1HImode)
      || !
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13088; /* *pred_mul_plusrvvm1hi_undef */
}

 int
recog_616 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM4SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM4SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM4SImode)
      || !
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13090; /* *pred_mul_plusrvvm4si_undef */
}

 int
recog_620 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM4DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM4DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM4DImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13094; /* *pred_mul_plusrvvm4di_undef */
}

 int
recog_624 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVMF4QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVMF4QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVMF4QImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return -1;
  return 13098; /* *pred_mul_plusrvvmf4qi_undef */
}

 int
recog_628 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVMF2SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVMF2SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVMF2SImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return -1;
  return 13102; /* *pred_mul_plusrvvmf2si_undef */
}

 int
recog_632 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V8QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V8QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V8QImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return -1;
  return 13106; /* *pred_mul_plusv8qi_undef */
}

 int
recog_636 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V128QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V128QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V128QImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13110; /* *pred_mul_plusv128qi_undef */
}

 int
recog_641 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V4096QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V4096QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V4096QImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13115; /* *pred_mul_plusv4096qi_undef */
}

 int
recog_647 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V32HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V32HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V32HImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13121; /* *pred_mul_plusv32hi_undef */
}

 int
recog_652 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1024HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1024HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1024HImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13126; /* *pred_mul_plusv1024hi_undef */
}

 int
recog_657 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V8SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V8SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V8SImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 13131; /* *pred_mul_plusv8si_undef */
}

 int
recog_663 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V512SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V512SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V512SImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13137; /* *pred_mul_plusv512si_undef */
}

 int
recog_669 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V16DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V16DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V16DImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13143; /* *pred_mul_plusv16di_undef */
}

 int
recog_675 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_674 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V512DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 13216; /* *pred_maddv512di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13284; /* *pred_maccv512di */
}

 int
recog_681 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_668 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V8DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 13210; /* *pred_maddv8di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13278; /* *pred_maccv8di */
}

 int
recog_687 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_662 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V256SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 13204; /* *pred_maddv256si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13272; /* *pred_maccv256si */
}

 int
recog_694 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_655 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V2SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13197; /* *pred_maddv2si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13265; /* *pred_maccv2si */
}

 int
recog_701 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_648 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V64HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 13190; /* *pred_maddv64hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13258; /* *pred_maccv64hi */
}

 int
recog_709 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_640 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V2048QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2048QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return 13182; /* *pred_maddv2048qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13250; /* *pred_maccv2048qi */
}

 int
recog_716 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 13351; /* *pred_maddv256di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13419; /* *pred_maccv256di_scalar */
}

 int
recog_723 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 13344; /* *pred_maddv2di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13412; /* *pred_maccv2di_scalar */
}

 int
recog_729 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13338; /* *pred_maddv64si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13406; /* *pred_maccv64si_scalar */
}

 int
recog_736 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 13331; /* *pred_maddv2048hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13399; /* *pred_maccv2048hi_scalar */
}

 int
recog_743 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 13324; /* *pred_maddv16hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 13392; /* *pred_maccv16hi_scalar */
}

 int
recog_750 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      return recog_746 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          return recog_744 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x13, 0);
          operands[2] = x14;
          if (!reg_or_0_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern715 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13421; /* *pred_maddrvvm8di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13435; /* *pred_maccrvvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern715 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13422; /* *pred_maddrvvm4di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13436; /* *pred_maccrvvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern715 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13423; /* *pred_maddrvvm2di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13437; /* *pred_maccrvvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern715 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13424; /* *pred_maddrvvm1di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13438; /* *pred_maccrvvm1di_extended_scalar */

            case E_V1DImode:
              if (pattern715 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return 13425; /* *pred_maddv1di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13439; /* *pred_maccv1di_extended_scalar */

            case E_V2DImode:
              if (pattern715 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return 13426; /* *pred_maddv2di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13440; /* *pred_maccv2di_extended_scalar */

            case E_V4DImode:
              if (pattern715 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return 13427; /* *pred_maddv4di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13441; /* *pred_maccv4di_extended_scalar */

            case E_V8DImode:
              if (pattern715 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return 13428; /* *pred_maddv8di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13442; /* *pred_maccv8di_extended_scalar */

            case E_V16DImode:
              if (pattern715 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return 13429; /* *pred_maddv16di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13443; /* *pred_maccv16di_extended_scalar */

            case E_V32DImode:
              if (pattern715 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return 13430; /* *pred_maddv32di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13444; /* *pred_maccv32di_extended_scalar */

            case E_V64DImode:
              if (pattern715 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return 13431; /* *pred_maddv64di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13445; /* *pred_maccv64di_extended_scalar */

            case E_V128DImode:
              if (pattern715 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return 13432; /* *pred_maddv128di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13446; /* *pred_maccv128di_extended_scalar */

            case E_V256DImode:
              if (pattern715 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return 13433; /* *pred_maddv256di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13447; /* *pred_maccv256di_extended_scalar */

            case E_V512DImode:
              if (pattern715 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return 13434; /* *pred_maddv512di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13448; /* *pred_maccv512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x12 = XEXP (x3, 1);
      operands[2] = x12;
      x15 = XEXP (x2, 2);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
          return recog_745 (x1, insn, pnum_clobbers);

        case VEC_DUPLICATE:
          x14 = XEXP (x13, 0);
          operands[3] = x14;
          x11 = XEXP (x4, 1);
          switch (GET_CODE (x11))
            {
            case SIGN_EXTEND:
              switch (pattern700 (x2))
                {
                case 0:
                  if (!
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13913; /* pred_widen_mul_plussrvvm8hi_scalar */

                case 1:
                  if (!
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13915; /* pred_widen_mul_plussrvvm4hi_scalar */

                case 2:
                  if (!
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13917; /* pred_widen_mul_plussrvvm2hi_scalar */

                case 3:
                  if (!
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13919; /* pred_widen_mul_plussrvvm1hi_scalar */

                case 4:
                  if (!
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13921; /* pred_widen_mul_plussrvvmf2hi_scalar */

                case 5:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 13923; /* pred_widen_mul_plussrvvmf4hi_scalar */

                case 6:
                  if (!
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13925; /* pred_widen_mul_plussrvvm8si_scalar */

                case 7:
                  if (!
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13927; /* pred_widen_mul_plussrvvm4si_scalar */

                case 8:
                  if (!
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13929; /* pred_widen_mul_plussrvvm2si_scalar */

                case 9:
                  if (!
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13931; /* pred_widen_mul_plussrvvm1si_scalar */

                case 10:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 13933; /* pred_widen_mul_plussrvvmf2si_scalar */

                case 11:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13935; /* pred_widen_mul_plussrvvm8di_scalar */

                case 12:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13937; /* pred_widen_mul_plussrvvm4di_scalar */

                case 13:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13939; /* pred_widen_mul_plussrvvm2di_scalar */

                case 14:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13941; /* pred_widen_mul_plussrvvm1di_scalar */

                case 15:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                    return -1;
                  return 13943; /* pred_widen_mul_plussv1hi_scalar */

                case 16:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                    return -1;
                  return 13945; /* pred_widen_mul_plussv2hi_scalar */

                case 17:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                    return -1;
                  return 13947; /* pred_widen_mul_plussv4hi_scalar */

                case 18:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                    return -1;
                  return 13949; /* pred_widen_mul_plussv8hi_scalar */

                case 19:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                    return -1;
                  return 13951; /* pred_widen_mul_plussv16hi_scalar */

                case 20:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13953; /* pred_widen_mul_plussv32hi_scalar */

                case 21:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13955; /* pred_widen_mul_plussv64hi_scalar */

                case 22:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13957; /* pred_widen_mul_plussv128hi_scalar */

                case 23:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 13959; /* pred_widen_mul_plussv256hi_scalar */

                case 24:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 13961; /* pred_widen_mul_plussv512hi_scalar */

                case 25:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 13963; /* pred_widen_mul_plussv1024hi_scalar */

                case 26:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 13965; /* pred_widen_mul_plussv2048hi_scalar */

                case 27:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                    return -1;
                  return 13967; /* pred_widen_mul_plussv1si_scalar */

                case 28:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                    return -1;
                  return 13969; /* pred_widen_mul_plussv2si_scalar */

                case 29:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                    return -1;
                  return 13971; /* pred_widen_mul_plussv4si_scalar */

                case 30:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                    return -1;
                  return 13973; /* pred_widen_mul_plussv8si_scalar */

                case 31:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13975; /* pred_widen_mul_plussv16si_scalar */

                case 32:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13977; /* pred_widen_mul_plussv32si_scalar */

                case 33:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13979; /* pred_widen_mul_plussv64si_scalar */

                case 34:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 13981; /* pred_widen_mul_plussv128si_scalar */

                case 35:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 13983; /* pred_widen_mul_plussv256si_scalar */

                case 36:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 13985; /* pred_widen_mul_plussv512si_scalar */

                case 37:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 13987; /* pred_widen_mul_plussv1024si_scalar */

                case 38:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13989; /* pred_widen_mul_plussv1di_scalar */

                case 39:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13991; /* pred_widen_mul_plussv2di_scalar */

                case 40:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13993; /* pred_widen_mul_plussv4di_scalar */

                case 41:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13995; /* pred_widen_mul_plussv8di_scalar */

                case 42:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13997; /* pred_widen_mul_plussv16di_scalar */

                case 43:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13999; /* pred_widen_mul_plussv32di_scalar */

                case 44:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14001; /* pred_widen_mul_plussv64di_scalar */

                case 45:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14003; /* pred_widen_mul_plussv128di_scalar */

                case 46:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14005; /* pred_widen_mul_plussv256di_scalar */

                case 47:
                  if (!(
#line 5899 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14007; /* pred_widen_mul_plussv512di_scalar */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern700 (x2))
                {
                case 0:
                  if (!
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14057; /* pred_widen_mul_plussurvvm8hi_scalar */

                case 1:
                  if (!
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14058; /* pred_widen_mul_plussurvvm4hi_scalar */

                case 2:
                  if (!
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14059; /* pred_widen_mul_plussurvvm2hi_scalar */

                case 3:
                  if (!
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14060; /* pred_widen_mul_plussurvvm1hi_scalar */

                case 4:
                  if (!
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14061; /* pred_widen_mul_plussurvvmf2hi_scalar */

                case 5:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 14062; /* pred_widen_mul_plussurvvmf4hi_scalar */

                case 6:
                  if (!
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14063; /* pred_widen_mul_plussurvvm8si_scalar */

                case 7:
                  if (!
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14064; /* pred_widen_mul_plussurvvm4si_scalar */

                case 8:
                  if (!
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14065; /* pred_widen_mul_plussurvvm2si_scalar */

                case 9:
                  if (!
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14066; /* pred_widen_mul_plussurvvm1si_scalar */

                case 10:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 14067; /* pred_widen_mul_plussurvvmf2si_scalar */

                case 11:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14068; /* pred_widen_mul_plussurvvm8di_scalar */

                case 12:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14069; /* pred_widen_mul_plussurvvm4di_scalar */

                case 13:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14070; /* pred_widen_mul_plussurvvm2di_scalar */

                case 14:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14071; /* pred_widen_mul_plussurvvm1di_scalar */

                case 15:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                    return -1;
                  return 14072; /* pred_widen_mul_plussuv1hi_scalar */

                case 16:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                    return -1;
                  return 14073; /* pred_widen_mul_plussuv2hi_scalar */

                case 17:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                    return -1;
                  return 14074; /* pred_widen_mul_plussuv4hi_scalar */

                case 18:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                    return -1;
                  return 14075; /* pred_widen_mul_plussuv8hi_scalar */

                case 19:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                    return -1;
                  return 14076; /* pred_widen_mul_plussuv16hi_scalar */

                case 20:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 14077; /* pred_widen_mul_plussuv32hi_scalar */

                case 21:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 14078; /* pred_widen_mul_plussuv64hi_scalar */

                case 22:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 14079; /* pred_widen_mul_plussuv128hi_scalar */

                case 23:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14080; /* pred_widen_mul_plussuv256hi_scalar */

                case 24:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14081; /* pred_widen_mul_plussuv512hi_scalar */

                case 25:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14082; /* pred_widen_mul_plussuv1024hi_scalar */

                case 26:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14083; /* pred_widen_mul_plussuv2048hi_scalar */

                case 27:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                    return -1;
                  return 14084; /* pred_widen_mul_plussuv1si_scalar */

                case 28:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                    return -1;
                  return 14085; /* pred_widen_mul_plussuv2si_scalar */

                case 29:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                    return -1;
                  return 14086; /* pred_widen_mul_plussuv4si_scalar */

                case 30:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                    return -1;
                  return 14087; /* pred_widen_mul_plussuv8si_scalar */

                case 31:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 14088; /* pred_widen_mul_plussuv16si_scalar */

                case 32:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 14089; /* pred_widen_mul_plussuv32si_scalar */

                case 33:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 14090; /* pred_widen_mul_plussuv64si_scalar */

                case 34:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14091; /* pred_widen_mul_plussuv128si_scalar */

                case 35:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14092; /* pred_widen_mul_plussuv256si_scalar */

                case 36:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14093; /* pred_widen_mul_plussuv512si_scalar */

                case 37:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14094; /* pred_widen_mul_plussuv1024si_scalar */

                case 38:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14095; /* pred_widen_mul_plussuv1di_scalar */

                case 39:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14096; /* pred_widen_mul_plussuv2di_scalar */

                case 40:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14097; /* pred_widen_mul_plussuv4di_scalar */

                case 41:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 14098; /* pred_widen_mul_plussuv8di_scalar */

                case 42:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 14099; /* pred_widen_mul_plussuv16di_scalar */

                case 43:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 14100; /* pred_widen_mul_plussuv32di_scalar */

                case 44:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14101; /* pred_widen_mul_plussuv64di_scalar */

                case 45:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14102; /* pred_widen_mul_plussuv128di_scalar */

                case 46:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14103; /* pred_widen_mul_plussuv256di_scalar */

                case 47:
                  if (!(
#line 5948 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14104; /* pred_widen_mul_plussuv512di_scalar */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_747 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_765 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V256SImode) == 0
      && (
#line 5603 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 13504; /* *pred_minus_mulv256si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V256SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V256SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 13572; /* *pred_nmsubv256si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13640; /* *pred_nmsacv256si */
}

 int
recog_768 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V32SImode) == 0
      && (
#line 5603 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 13501; /* *pred_minus_mulv32si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V32SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V32SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 13569; /* *pred_nmsubv32si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13637; /* *pred_nmsacv32si */
}

 int
recog_772 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V2SImode) == 0
      && (
#line 5603 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13497; /* *pred_minus_mulv2si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13565; /* *pred_nmsubv2si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13633; /* *pred_nmsacv2si */
}

 int
recog_778 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V128HImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V128HImode) == 0
      && (
#line 5603 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return 13491; /* *pred_minus_mulv128hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V128HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V128HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return 13559; /* *pred_nmsubv128hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13627; /* *pred_nmsacv128hi */
}

 int
recog_784 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V2HImode) == 0
      && (
#line 5603 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 13485; /* *pred_minus_mulv2hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 13553; /* *pred_nmsubv2hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 13621; /* *pred_nmsacv2hi */
}

 int
recog_792 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V64QImode) == 0
      && (
#line 5603 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 13477; /* *pred_minus_mulv64qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V64QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V64QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 13545; /* *pred_nmsubv64qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13613; /* *pred_nmsacv64qi */
}

 int
recog_801 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_RVVMF2HImode) == 0
      && (
#line 5603 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return 13468; /* *pred_minus_mulrvvmf2hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_RVVMF2HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_RVVMF2HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return 13536; /* *pred_nmsubrvvmf2hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return -1;
  return 13604; /* *pred_nmsacrvvmf2hi */
}

 int
recog_812 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 13710; /* *pred_nmsubv1024si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13778; /* *pred_nmsacv1024si_scalar */
}

 int
recog_820 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13702; /* *pred_nmsubv4si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 13770; /* *pred_nmsacv4si_scalar */
}

 int
recog_828 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 13694; /* *pred_nmsubv64hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13762; /* *pred_nmsacv64hi_scalar */
}

 int
recog_836 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      return recog_834 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_833 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_835 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      switch (pattern540 (x2))
        {
        case 0:
          if (!
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9878; /* pred_single_widen_suburvvm8hi */

        case 1:
          if (!
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9880; /* pred_single_widen_suburvvm4hi */

        case 2:
          if (!
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9882; /* pred_single_widen_suburvvm2hi */

        case 3:
          if (!
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9884; /* pred_single_widen_suburvvm1hi */

        case 4:
          if (!
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9886; /* pred_single_widen_suburvvmf2hi */

        case 5:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9888; /* pred_single_widen_suburvvmf4hi */

        case 6:
          if (!
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9890; /* pred_single_widen_suburvvm8si */

        case 7:
          if (!
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9892; /* pred_single_widen_suburvvm4si */

        case 8:
          if (!
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9894; /* pred_single_widen_suburvvm2si */

        case 9:
          if (!
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9896; /* pred_single_widen_suburvvm1si */

        case 10:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9898; /* pred_single_widen_suburvvmf2si */

        case 11:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9900; /* pred_single_widen_suburvvm8di */

        case 12:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9902; /* pred_single_widen_suburvvm4di */

        case 13:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9904; /* pred_single_widen_suburvvm2di */

        case 14:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9906; /* pred_single_widen_suburvvm1di */

        case 15:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9908; /* pred_single_widen_subuv1hi */

        case 16:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9910; /* pred_single_widen_subuv2hi */

        case 17:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9912; /* pred_single_widen_subuv4hi */

        case 18:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9914; /* pred_single_widen_subuv8hi */

        case 19:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9916; /* pred_single_widen_subuv16hi */

        case 20:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9918; /* pred_single_widen_subuv32hi */

        case 21:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9920; /* pred_single_widen_subuv64hi */

        case 22:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9922; /* pred_single_widen_subuv128hi */

        case 23:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9924; /* pred_single_widen_subuv256hi */

        case 24:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9926; /* pred_single_widen_subuv512hi */

        case 25:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9928; /* pred_single_widen_subuv1024hi */

        case 26:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9930; /* pred_single_widen_subuv2048hi */

        case 27:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9932; /* pred_single_widen_subuv1si */

        case 28:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9934; /* pred_single_widen_subuv2si */

        case 29:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9936; /* pred_single_widen_subuv4si */

        case 30:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9938; /* pred_single_widen_subuv8si */

        case 31:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9940; /* pred_single_widen_subuv16si */

        case 32:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9942; /* pred_single_widen_subuv32si */

        case 33:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9944; /* pred_single_widen_subuv64si */

        case 34:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9946; /* pred_single_widen_subuv128si */

        case 35:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9948; /* pred_single_widen_subuv256si */

        case 36:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9950; /* pred_single_widen_subuv512si */

        case 37:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9952; /* pred_single_widen_subuv1024si */

        case 38:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9954; /* pred_single_widen_subuv1di */

        case 39:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9956; /* pred_single_widen_subuv2di */

        case 40:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9958; /* pred_single_widen_subuv4di */

        case 41:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9960; /* pred_single_widen_subuv8di */

        case 42:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9962; /* pred_single_widen_subuv16di */

        case 43:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9964; /* pred_single_widen_subuv32di */

        case 44:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9966; /* pred_single_widen_subuv64di */

        case 45:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9968; /* pred_single_widen_subuv128di */

        case 46:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9970; /* pred_single_widen_subuv256di */

        case 47:
          if (!(
#line 4046 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9972; /* pred_single_widen_subuv512di */

        case 48:
          if (!
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10072; /* pred_single_widen_suburvvm8hi_scalar */

        case 49:
          if (!
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10076; /* pred_single_widen_suburvvm4hi_scalar */

        case 50:
          if (!
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10080; /* pred_single_widen_suburvvm2hi_scalar */

        case 51:
          if (!
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10084; /* pred_single_widen_suburvvm1hi_scalar */

        case 52:
          if (!
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10088; /* pred_single_widen_suburvvmf2hi_scalar */

        case 53:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10092; /* pred_single_widen_suburvvmf4hi_scalar */

        case 54:
          if (!
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10096; /* pred_single_widen_suburvvm8si_scalar */

        case 55:
          if (!
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10100; /* pred_single_widen_suburvvm4si_scalar */

        case 56:
          if (!
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10104; /* pred_single_widen_suburvvm2si_scalar */

        case 57:
          if (!
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10108; /* pred_single_widen_suburvvm1si_scalar */

        case 58:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10112; /* pred_single_widen_suburvvmf2si_scalar */

        case 59:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10116; /* pred_single_widen_suburvvm8di_scalar */

        case 60:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10120; /* pred_single_widen_suburvvm4di_scalar */

        case 61:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10124; /* pred_single_widen_suburvvm2di_scalar */

        case 62:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10128; /* pred_single_widen_suburvvm1di_scalar */

        case 63:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10132; /* pred_single_widen_subuv1hi_scalar */

        case 64:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10136; /* pred_single_widen_subuv2hi_scalar */

        case 65:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10140; /* pred_single_widen_subuv4hi_scalar */

        case 66:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10144; /* pred_single_widen_subuv8hi_scalar */

        case 67:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10148; /* pred_single_widen_subuv16hi_scalar */

        case 68:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10152; /* pred_single_widen_subuv32hi_scalar */

        case 69:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10156; /* pred_single_widen_subuv64hi_scalar */

        case 70:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10160; /* pred_single_widen_subuv128hi_scalar */

        case 71:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10164; /* pred_single_widen_subuv256hi_scalar */

        case 72:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10168; /* pred_single_widen_subuv512hi_scalar */

        case 73:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10172; /* pred_single_widen_subuv1024hi_scalar */

        case 74:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10176; /* pred_single_widen_subuv2048hi_scalar */

        case 75:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10180; /* pred_single_widen_subuv1si_scalar */

        case 76:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10184; /* pred_single_widen_subuv2si_scalar */

        case 77:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10188; /* pred_single_widen_subuv4si_scalar */

        case 78:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10192; /* pred_single_widen_subuv8si_scalar */

        case 79:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10196; /* pred_single_widen_subuv16si_scalar */

        case 80:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10200; /* pred_single_widen_subuv32si_scalar */

        case 81:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10204; /* pred_single_widen_subuv64si_scalar */

        case 82:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10208; /* pred_single_widen_subuv128si_scalar */

        case 83:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10212; /* pred_single_widen_subuv256si_scalar */

        case 84:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10216; /* pred_single_widen_subuv512si_scalar */

        case 85:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10220; /* pred_single_widen_subuv1024si_scalar */

        case 86:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10224; /* pred_single_widen_subuv1di_scalar */

        case 87:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10228; /* pred_single_widen_subuv2di_scalar */

        case 88:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10232; /* pred_single_widen_subuv4di_scalar */

        case 89:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10236; /* pred_single_widen_subuv8di_scalar */

        case 90:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10240; /* pred_single_widen_subuv16di_scalar */

        case 91:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10244; /* pred_single_widen_subuv32di_scalar */

        case 92:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10248; /* pred_single_widen_subuv64di_scalar */

        case 93:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10252; /* pred_single_widen_subuv128di_scalar */

        case 94:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10256; /* pred_single_widen_subuv256di_scalar */

        case 95:
          if (!(
#line 4089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10260; /* pred_single_widen_subuv512di_scalar */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          return recog_832 (x1, insn, pnum_clobbers);

        case VEC_DUPLICATE:
          x6 = XEXP (x2, 0);
          x7 = XVECEXP (x6, 0, 1);
          operands[5] = x7;
          x8 = XVECEXP (x6, 0, 2);
          operands[6] = x8;
          x9 = XVECEXP (x6, 0, 3);
          operands[7] = x9;
          x10 = XVECEXP (x6, 0, 4);
          operands[8] = x10;
          x11 = XEXP (x3, 0);
          operands[4] = x11;
          x12 = XEXP (x4, 1);
          operands[3] = x12;
          x13 = XEXP (x5, 0);
          switch (GET_CODE (x13))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
              return recog_831 (x1, insn, pnum_clobbers);

            case SIGN_EXTEND:
              if (GET_MODE (x13) != E_DImode)
                return -1;
              x14 = XEXP (x13, 0);
              operands[2] = x14;
              if (!reg_or_0_operand (operands[2], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_RVVM8DImode:
                  if (pattern727 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return 13789; /* *pred_nmsubrvvm8di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13803; /* *pred_nmsacrvvm8di_extended_scalar */

                case E_RVVM4DImode:
                  if (pattern727 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return 13790; /* *pred_nmsubrvvm4di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13804; /* *pred_nmsacrvvm4di_extended_scalar */

                case E_RVVM2DImode:
                  if (pattern727 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return 13791; /* *pred_nmsubrvvm2di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13805; /* *pred_nmsacrvvm2di_extended_scalar */

                case E_RVVM1DImode:
                  if (pattern727 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return 13792; /* *pred_nmsubrvvm1di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13806; /* *pred_nmsacrvvm1di_extended_scalar */

                case E_V1DImode:
                  if (pattern727 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                    return 13793; /* *pred_nmsubv1di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13807; /* *pred_nmsacv1di_extended_scalar */

                case E_V2DImode:
                  if (pattern727 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                    return 13794; /* *pred_nmsubv2di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13808; /* *pred_nmsacv2di_extended_scalar */

                case E_V4DImode:
                  if (pattern727 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                    return 13795; /* *pred_nmsubv4di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13809; /* *pred_nmsacv4di_extended_scalar */

                case E_V8DImode:
                  if (pattern727 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                    return 13796; /* *pred_nmsubv8di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13810; /* *pred_nmsacv8di_extended_scalar */

                case E_V16DImode:
                  if (pattern727 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                    return 13797; /* *pred_nmsubv16di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13811; /* *pred_nmsacv16di_extended_scalar */

                case E_V32DImode:
                  if (pattern727 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                    return 13798; /* *pred_nmsubv32di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13812; /* *pred_nmsacv32di_extended_scalar */

                case E_V64DImode:
                  if (pattern727 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                    return 13799; /* *pred_nmsubv64di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 13813; /* *pred_nmsacv64di_extended_scalar */

                case E_V128DImode:
                  if (pattern727 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                    return 13800; /* *pred_nmsubv128di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 13814; /* *pred_nmsacv128di_extended_scalar */

                case E_V256DImode:
                  if (pattern727 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                    return 13801; /* *pred_nmsubv256di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 13815; /* *pred_nmsacv256di_extended_scalar */

                case E_V512DImode:
                  if (pattern727 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                    return 13802; /* *pred_nmsubv512di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 13816; /* *pred_nmsacv512di_extended_scalar */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_884 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern668 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10886; /* pred_sssubrvvm8qi */

    case E_RVVM4QImode:
      if (pattern668 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10890; /* pred_sssubrvvm4qi */

    case E_RVVM2QImode:
      if (pattern668 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10894; /* pred_sssubrvvm2qi */

    case E_RVVM1QImode:
      if (pattern668 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10898; /* pred_sssubrvvm1qi */

    case E_RVVM8HImode:
      if (pattern668 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10902; /* pred_sssubrvvm8hi */

    case E_RVVM4HImode:
      if (pattern668 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10906; /* pred_sssubrvvm4hi */

    case E_RVVM2HImode:
      if (pattern668 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10910; /* pred_sssubrvvm2hi */

    case E_RVVM1HImode:
      if (pattern668 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10914; /* pred_sssubrvvm1hi */

    case E_RVVM8SImode:
      if (pattern668 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10918; /* pred_sssubrvvm8si */

    case E_RVVM4SImode:
      if (pattern668 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10922; /* pred_sssubrvvm4si */

    case E_RVVM2SImode:
      if (pattern668 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10926; /* pred_sssubrvvm2si */

    case E_RVVM1SImode:
      if (pattern668 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10930; /* pred_sssubrvvm1si */

    case E_RVVM8DImode:
      if (pattern668 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10934; /* pred_sssubrvvm8di */

    case E_RVVM4DImode:
      if (pattern668 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10938; /* pred_sssubrvvm4di */

    case E_RVVM2DImode:
      if (pattern668 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10942; /* pred_sssubrvvm2di */

    case E_RVVM1DImode:
      if (pattern668 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10946; /* pred_sssubrvvm1di */

    case E_RVVMF2QImode:
      if (pattern668 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10950; /* pred_sssubrvvmf2qi */

    case E_RVVMF4QImode:
      if (pattern668 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10954; /* pred_sssubrvvmf4qi */

    case E_RVVMF8QImode:
      if (pattern668 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10958; /* pred_sssubrvvmf8qi */

    case E_RVVMF2HImode:
      if (pattern668 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10962; /* pred_sssubrvvmf2hi */

    case E_RVVMF4HImode:
      if (pattern668 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10966; /* pred_sssubrvvmf4hi */

    case E_RVVMF2SImode:
      if (pattern668 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10970; /* pred_sssubrvvmf2si */

    case E_V1QImode:
      if (pattern668 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 10974; /* pred_sssubv1qi */

    case E_V2QImode:
      if (pattern668 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 10978; /* pred_sssubv2qi */

    case E_V4QImode:
      if (pattern668 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 10982; /* pred_sssubv4qi */

    case E_V8QImode:
      if (pattern668 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 10986; /* pred_sssubv8qi */

    case E_V16QImode:
      if (pattern668 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 10990; /* pred_sssubv16qi */

    case E_V32QImode:
      if (pattern668 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 10994; /* pred_sssubv32qi */

    case E_V64QImode:
      if (pattern668 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10998; /* pred_sssubv64qi */

    case E_V128QImode:
      if (pattern668 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11002; /* pred_sssubv128qi */

    case E_V256QImode:
      if (pattern668 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11006; /* pred_sssubv256qi */

    case E_V512QImode:
      if (pattern668 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11010; /* pred_sssubv512qi */

    case E_V1024QImode:
      if (pattern668 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11014; /* pred_sssubv1024qi */

    case E_V2048QImode:
      if (pattern668 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11018; /* pred_sssubv2048qi */

    case E_V4096QImode:
      if (pattern668 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11022; /* pred_sssubv4096qi */

    case E_V1HImode:
      if (pattern668 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 11026; /* pred_sssubv1hi */

    case E_V2HImode:
      if (pattern668 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 11030; /* pred_sssubv2hi */

    case E_V4HImode:
      if (pattern668 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 11034; /* pred_sssubv4hi */

    case E_V8HImode:
      if (pattern668 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 11038; /* pred_sssubv8hi */

    case E_V16HImode:
      if (pattern668 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 11042; /* pred_sssubv16hi */

    case E_V32HImode:
      if (pattern668 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11046; /* pred_sssubv32hi */

    case E_V64HImode:
      if (pattern668 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11050; /* pred_sssubv64hi */

    case E_V128HImode:
      if (pattern668 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11054; /* pred_sssubv128hi */

    case E_V256HImode:
      if (pattern668 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11058; /* pred_sssubv256hi */

    case E_V512HImode:
      if (pattern668 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11062; /* pred_sssubv512hi */

    case E_V1024HImode:
      if (pattern668 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11066; /* pred_sssubv1024hi */

    case E_V2048HImode:
      if (pattern668 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11070; /* pred_sssubv2048hi */

    case E_V1SImode:
      if (pattern668 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 11074; /* pred_sssubv1si */

    case E_V2SImode:
      if (pattern668 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 11078; /* pred_sssubv2si */

    case E_V4SImode:
      if (pattern668 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 11082; /* pred_sssubv4si */

    case E_V8SImode:
      if (pattern668 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 11086; /* pred_sssubv8si */

    case E_V16SImode:
      if (pattern668 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11090; /* pred_sssubv16si */

    case E_V32SImode:
      if (pattern668 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11094; /* pred_sssubv32si */

    case E_V64SImode:
      if (pattern668 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11098; /* pred_sssubv64si */

    case E_V128SImode:
      if (pattern668 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11102; /* pred_sssubv128si */

    case E_V256SImode:
      if (pattern668 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11106; /* pred_sssubv256si */

    case E_V512SImode:
      if (pattern668 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11110; /* pred_sssubv512si */

    case E_V1024SImode:
      if (pattern668 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11114; /* pred_sssubv1024si */

    case E_V1DImode:
      if (pattern668 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11118; /* pred_sssubv1di */

    case E_V2DImode:
      if (pattern668 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11122; /* pred_sssubv2di */

    case E_V4DImode:
      if (pattern668 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11126; /* pred_sssubv4di */

    case E_V8DImode:
      if (pattern668 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11130; /* pred_sssubv8di */

    case E_V16DImode:
      if (pattern668 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11134; /* pred_sssubv16di */

    case E_V32DImode:
      if (pattern668 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11138; /* pred_sssubv32di */

    case E_V64DImode:
      if (pattern668 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11142; /* pred_sssubv64di */

    case E_V128DImode:
      if (pattern668 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11146; /* pred_sssubv128di */

    case E_V256DImode:
      if (pattern668 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11150; /* pred_sssubv256di */

    case E_V512DImode:
      if (pattern668 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11154; /* pred_sssubv512di */

    default:
      return -1;
    }
}

 int
recog_888 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern492 (x2))
    {
    case 0:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5507; /* pred_sminrvvm8qi */

    case 1:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5524; /* pred_sminrvvm4qi */

    case 2:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5541; /* pred_sminrvvm2qi */

    case 3:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5558; /* pred_sminrvvm1qi */

    case 4:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5575; /* pred_sminrvvm8hi */

    case 5:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5592; /* pred_sminrvvm4hi */

    case 6:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5609; /* pred_sminrvvm2hi */

    case 7:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5626; /* pred_sminrvvm1hi */

    case 8:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5643; /* pred_sminrvvm8si */

    case 9:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5660; /* pred_sminrvvm4si */

    case 10:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5677; /* pred_sminrvvm2si */

    case 11:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5694; /* pred_sminrvvm1si */

    case 12:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5711; /* pred_sminrvvm8di */

    case 13:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5728; /* pred_sminrvvm4di */

    case 14:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5745; /* pred_sminrvvm2di */

    case 15:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5762; /* pred_sminrvvm1di */

    case 16:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5779; /* pred_sminrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5796; /* pred_sminrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5813; /* pred_sminrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5830; /* pred_sminrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5847; /* pred_sminrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5864; /* pred_sminrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5881; /* pred_sminv1qi */

    case 23:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5898; /* pred_sminv2qi */

    case 24:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5915; /* pred_sminv4qi */

    case 25:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5932; /* pred_sminv8qi */

    case 26:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5949; /* pred_sminv16qi */

    case 27:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5966; /* pred_sminv32qi */

    case 28:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5983; /* pred_sminv64qi */

    case 29:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6000; /* pred_sminv128qi */

    case 30:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6017; /* pred_sminv256qi */

    case 31:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6034; /* pred_sminv512qi */

    case 32:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6051; /* pred_sminv1024qi */

    case 33:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6068; /* pred_sminv2048qi */

    case 34:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6085; /* pred_sminv4096qi */

    case 35:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6102; /* pred_sminv1hi */

    case 36:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6119; /* pred_sminv2hi */

    case 37:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6136; /* pred_sminv4hi */

    case 38:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6153; /* pred_sminv8hi */

    case 39:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6170; /* pred_sminv16hi */

    case 40:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6187; /* pred_sminv32hi */

    case 41:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6204; /* pred_sminv64hi */

    case 42:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6221; /* pred_sminv128hi */

    case 43:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6238; /* pred_sminv256hi */

    case 44:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6255; /* pred_sminv512hi */

    case 45:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6272; /* pred_sminv1024hi */

    case 46:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6289; /* pred_sminv2048hi */

    case 47:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6306; /* pred_sminv1si */

    case 48:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6323; /* pred_sminv2si */

    case 49:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6340; /* pred_sminv4si */

    case 50:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6357; /* pred_sminv8si */

    case 51:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6374; /* pred_sminv16si */

    case 52:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6391; /* pred_sminv32si */

    case 53:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6408; /* pred_sminv64si */

    case 54:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6425; /* pred_sminv128si */

    case 55:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6442; /* pred_sminv256si */

    case 56:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6459; /* pred_sminv512si */

    case 57:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6476; /* pred_sminv1024si */

    case 58:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6493; /* pred_sminv1di */

    case 59:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6510; /* pred_sminv2di */

    case 60:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6527; /* pred_sminv4di */

    case 61:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6544; /* pred_sminv8di */

    case 62:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6561; /* pred_sminv16di */

    case 63:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6578; /* pred_sminv32di */

    case 64:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6595; /* pred_sminv64di */

    case 65:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6612; /* pred_sminv128di */

    case 66:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6629; /* pred_sminv256di */

    case 67:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6646; /* pred_sminv512di */

    case 68:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14691; /* pred_sminrvvm8hf */

    case 69:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14693; /* pred_sminrvvm4hf */

    case 70:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14695; /* pred_sminrvvm2hf */

    case 71:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14697; /* pred_sminrvvm1hf */

    case 72:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14699; /* pred_sminrvvmf2hf */

    case 73:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14701; /* pred_sminrvvmf4hf */

    case 74:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14703; /* pred_sminrvvm8sf */

    case 75:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14705; /* pred_sminrvvm4sf */

    case 76:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14707; /* pred_sminrvvm2sf */

    case 77:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14709; /* pred_sminrvvm1sf */

    case 78:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14711; /* pred_sminrvvmf2sf */

    case 79:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14713; /* pred_sminrvvm8df */

    case 80:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14715; /* pred_sminrvvm4df */

    case 81:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14717; /* pred_sminrvvm2df */

    case 82:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14719; /* pred_sminrvvm1df */

    case 83:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 14721; /* pred_sminv1hf */

    case 84:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 14723; /* pred_sminv2hf */

    case 85:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 14725; /* pred_sminv4hf */

    case 86:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 14727; /* pred_sminv8hf */

    case 87:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 14729; /* pred_sminv16hf */

    case 88:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14731; /* pred_sminv32hf */

    case 89:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14733; /* pred_sminv64hf */

    case 90:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14735; /* pred_sminv128hf */

    case 91:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14737; /* pred_sminv256hf */

    case 92:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14739; /* pred_sminv512hf */

    case 93:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14741; /* pred_sminv1024hf */

    case 94:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14743; /* pred_sminv2048hf */

    case 95:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14745; /* pred_sminv1sf */

    case 96:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14747; /* pred_sminv2sf */

    case 97:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14749; /* pred_sminv4sf */

    case 98:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14751; /* pred_sminv8sf */

    case 99:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14753; /* pred_sminv16sf */

    case 100:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14755; /* pred_sminv32sf */

    case 101:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14757; /* pred_sminv64sf */

    case 102:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14759; /* pred_sminv128sf */

    case 103:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14761; /* pred_sminv256sf */

    case 104:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14763; /* pred_sminv512sf */

    case 105:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14765; /* pred_sminv1024sf */

    case 106:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14767; /* pred_sminv1df */

    case 107:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14769; /* pred_sminv2df */

    case 108:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14771; /* pred_sminv4df */

    case 109:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14773; /* pred_sminv8df */

    case 110:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14775; /* pred_sminv16df */

    case 111:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14777; /* pred_sminv32df */

    case 112:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14779; /* pred_sminv64df */

    case 113:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14781; /* pred_sminv128df */

    case 114:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14783; /* pred_sminv256df */

    case 115:
      if (!(
#line 6214 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14785; /* pred_sminv512df */

    case 116:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6863; /* pred_sminrvvm8qi_scalar */

    case 117:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6872; /* pred_sminrvvm4qi_scalar */

    case 118:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6881; /* pred_sminrvvm2qi_scalar */

    case 119:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6890; /* pred_sminrvvm1qi_scalar */

    case 120:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6899; /* pred_sminrvvmf2qi_scalar */

    case 121:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6908; /* pred_sminrvvmf4qi_scalar */

    case 122:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6917; /* pred_sminrvvmf8qi_scalar */

    case 123:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6926; /* pred_sminrvvm8hi_scalar */

    case 124:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6935; /* pred_sminrvvm4hi_scalar */

    case 125:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6944; /* pred_sminrvvm2hi_scalar */

    case 126:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6953; /* pred_sminrvvm1hi_scalar */

    case 127:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6962; /* pred_sminrvvmf2hi_scalar */

    case 128:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6971; /* pred_sminrvvmf4hi_scalar */

    case 129:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6980; /* pred_sminrvvm8si_scalar */

    case 130:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6989; /* pred_sminrvvm4si_scalar */

    case 131:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6998; /* pred_sminrvvm2si_scalar */

    case 132:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7007; /* pred_sminrvvm1si_scalar */

    case 133:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7016; /* pred_sminrvvmf2si_scalar */

    case 134:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7025; /* pred_sminv1qi_scalar */

    case 135:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7034; /* pred_sminv2qi_scalar */

    case 136:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7043; /* pred_sminv4qi_scalar */

    case 137:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7052; /* pred_sminv8qi_scalar */

    case 138:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7061; /* pred_sminv16qi_scalar */

    case 139:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7070; /* pred_sminv32qi_scalar */

    case 140:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7079; /* pred_sminv64qi_scalar */

    case 141:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7088; /* pred_sminv128qi_scalar */

    case 142:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7097; /* pred_sminv256qi_scalar */

    case 143:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7106; /* pred_sminv512qi_scalar */

    case 144:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7115; /* pred_sminv1024qi_scalar */

    case 145:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7124; /* pred_sminv2048qi_scalar */

    case 146:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7133; /* pred_sminv4096qi_scalar */

    case 147:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7142; /* pred_sminv1hi_scalar */

    case 148:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7151; /* pred_sminv2hi_scalar */

    case 149:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7160; /* pred_sminv4hi_scalar */

    case 150:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7169; /* pred_sminv8hi_scalar */

    case 151:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7178; /* pred_sminv16hi_scalar */

    case 152:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7187; /* pred_sminv32hi_scalar */

    case 153:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7196; /* pred_sminv64hi_scalar */

    case 154:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7205; /* pred_sminv128hi_scalar */

    case 155:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7214; /* pred_sminv256hi_scalar */

    case 156:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7223; /* pred_sminv512hi_scalar */

    case 157:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7232; /* pred_sminv1024hi_scalar */

    case 158:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7241; /* pred_sminv2048hi_scalar */

    case 159:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7250; /* pred_sminv1si_scalar */

    case 160:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7259; /* pred_sminv2si_scalar */

    case 161:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7268; /* pred_sminv4si_scalar */

    case 162:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7277; /* pred_sminv8si_scalar */

    case 163:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7286; /* pred_sminv16si_scalar */

    case 164:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7295; /* pred_sminv32si_scalar */

    case 165:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7304; /* pred_sminv64si_scalar */

    case 166:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7313; /* pred_sminv128si_scalar */

    case 167:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7322; /* pred_sminv256si_scalar */

    case 168:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7331; /* pred_sminv512si_scalar */

    case 169:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7340; /* pred_sminv1024si_scalar */

    case 170:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7673; /* *pred_sminrvvm8di_scalar */

    case 171:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7682; /* *pred_sminrvvm4di_scalar */

    case 172:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7691; /* *pred_sminrvvm2di_scalar */

    case 173:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7700; /* *pred_sminrvvm1di_scalar */

    case 174:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7709; /* *pred_sminv1di_scalar */

    case 175:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7718; /* *pred_sminv2di_scalar */

    case 176:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7727; /* *pred_sminv4di_scalar */

    case 177:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7736; /* *pred_sminv8di_scalar */

    case 178:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7745; /* *pred_sminv16di_scalar */

    case 179:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7754; /* *pred_sminv32di_scalar */

    case 180:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7763; /* *pred_sminv64di_scalar */

    case 181:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7772; /* *pred_sminv128di_scalar */

    case 182:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7781; /* *pred_sminv256di_scalar */

    case 183:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7790; /* *pred_sminv512di_scalar */

    case 184:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14913; /* pred_sminrvvm8hf_scalar */

    case 185:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14915; /* pred_sminrvvm4hf_scalar */

    case 186:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14917; /* pred_sminrvvm2hf_scalar */

    case 187:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14919; /* pred_sminrvvm1hf_scalar */

    case 188:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14921; /* pred_sminrvvmf2hf_scalar */

    case 189:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14923; /* pred_sminrvvmf4hf_scalar */

    case 190:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14925; /* pred_sminrvvm8sf_scalar */

    case 191:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14927; /* pred_sminrvvm4sf_scalar */

    case 192:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14929; /* pred_sminrvvm2sf_scalar */

    case 193:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14931; /* pred_sminrvvm1sf_scalar */

    case 194:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14933; /* pred_sminrvvmf2sf_scalar */

    case 195:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14935; /* pred_sminrvvm8df_scalar */

    case 196:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14937; /* pred_sminrvvm4df_scalar */

    case 197:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14939; /* pred_sminrvvm2df_scalar */

    case 198:
      if (!(
#line 6281 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14941; /* pred_sminrvvm1df_scalar */

    case 199:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7799; /* *pred_sminrvvm8di_extended_scalar */

    case 200:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7808; /* *pred_sminrvvm4di_extended_scalar */

    case 201:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7817; /* *pred_sminrvvm2di_extended_scalar */

    case 202:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7826; /* *pred_sminrvvm1di_extended_scalar */

    case 203:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7835; /* *pred_sminv1di_extended_scalar */

    case 204:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7844; /* *pred_sminv2di_extended_scalar */

    case 205:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7853; /* *pred_sminv4di_extended_scalar */

    case 206:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7862; /* *pred_sminv8di_extended_scalar */

    case 207:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7871; /* *pred_sminv16di_extended_scalar */

    case 208:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7880; /* *pred_sminv32di_extended_scalar */

    case 209:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7889; /* *pred_sminv64di_extended_scalar */

    case 210:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7898; /* *pred_sminv128di_extended_scalar */

    case 211:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7907; /* *pred_sminv256di_extended_scalar */

    case 212:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7916; /* *pred_sminv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_901 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern494 (x2))
    {
    case 0:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5508; /* pred_uminrvvm8qi */

    case 1:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5525; /* pred_uminrvvm4qi */

    case 2:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5542; /* pred_uminrvvm2qi */

    case 3:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5559; /* pred_uminrvvm1qi */

    case 4:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5576; /* pred_uminrvvm8hi */

    case 5:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5593; /* pred_uminrvvm4hi */

    case 6:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5610; /* pred_uminrvvm2hi */

    case 7:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5627; /* pred_uminrvvm1hi */

    case 8:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5644; /* pred_uminrvvm8si */

    case 9:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5661; /* pred_uminrvvm4si */

    case 10:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5678; /* pred_uminrvvm2si */

    case 11:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5695; /* pred_uminrvvm1si */

    case 12:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5712; /* pred_uminrvvm8di */

    case 13:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5729; /* pred_uminrvvm4di */

    case 14:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5746; /* pred_uminrvvm2di */

    case 15:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5763; /* pred_uminrvvm1di */

    case 16:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5780; /* pred_uminrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5797; /* pred_uminrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5814; /* pred_uminrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5831; /* pred_uminrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5848; /* pred_uminrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5865; /* pred_uminrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5882; /* pred_uminv1qi */

    case 23:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5899; /* pred_uminv2qi */

    case 24:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5916; /* pred_uminv4qi */

    case 25:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5933; /* pred_uminv8qi */

    case 26:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5950; /* pred_uminv16qi */

    case 27:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5967; /* pred_uminv32qi */

    case 28:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5984; /* pred_uminv64qi */

    case 29:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6001; /* pred_uminv128qi */

    case 30:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6018; /* pred_uminv256qi */

    case 31:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6035; /* pred_uminv512qi */

    case 32:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6052; /* pred_uminv1024qi */

    case 33:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6069; /* pred_uminv2048qi */

    case 34:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6086; /* pred_uminv4096qi */

    case 35:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6103; /* pred_uminv1hi */

    case 36:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6120; /* pred_uminv2hi */

    case 37:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6137; /* pred_uminv4hi */

    case 38:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6154; /* pred_uminv8hi */

    case 39:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6171; /* pred_uminv16hi */

    case 40:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6188; /* pred_uminv32hi */

    case 41:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6205; /* pred_uminv64hi */

    case 42:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6222; /* pred_uminv128hi */

    case 43:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6239; /* pred_uminv256hi */

    case 44:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6256; /* pred_uminv512hi */

    case 45:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6273; /* pred_uminv1024hi */

    case 46:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6290; /* pred_uminv2048hi */

    case 47:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6307; /* pred_uminv1si */

    case 48:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6324; /* pred_uminv2si */

    case 49:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6341; /* pred_uminv4si */

    case 50:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6358; /* pred_uminv8si */

    case 51:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6375; /* pred_uminv16si */

    case 52:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6392; /* pred_uminv32si */

    case 53:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6409; /* pred_uminv64si */

    case 54:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6426; /* pred_uminv128si */

    case 55:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6443; /* pred_uminv256si */

    case 56:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6460; /* pred_uminv512si */

    case 57:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6477; /* pred_uminv1024si */

    case 58:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6494; /* pred_uminv1di */

    case 59:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6511; /* pred_uminv2di */

    case 60:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6528; /* pred_uminv4di */

    case 61:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6545; /* pred_uminv8di */

    case 62:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6562; /* pred_uminv16di */

    case 63:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6579; /* pred_uminv32di */

    case 64:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6596; /* pred_uminv64di */

    case 65:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6613; /* pred_uminv128di */

    case 66:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6630; /* pred_uminv256di */

    case 67:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6647; /* pred_uminv512di */

    case 68:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6864; /* pred_uminrvvm8qi_scalar */

    case 69:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6873; /* pred_uminrvvm4qi_scalar */

    case 70:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6882; /* pred_uminrvvm2qi_scalar */

    case 71:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6891; /* pred_uminrvvm1qi_scalar */

    case 72:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6900; /* pred_uminrvvmf2qi_scalar */

    case 73:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6909; /* pred_uminrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6918; /* pred_uminrvvmf8qi_scalar */

    case 75:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6927; /* pred_uminrvvm8hi_scalar */

    case 76:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6936; /* pred_uminrvvm4hi_scalar */

    case 77:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6945; /* pred_uminrvvm2hi_scalar */

    case 78:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6954; /* pred_uminrvvm1hi_scalar */

    case 79:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6963; /* pred_uminrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6972; /* pred_uminrvvmf4hi_scalar */

    case 81:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6981; /* pred_uminrvvm8si_scalar */

    case 82:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6990; /* pred_uminrvvm4si_scalar */

    case 83:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6999; /* pred_uminrvvm2si_scalar */

    case 84:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7008; /* pred_uminrvvm1si_scalar */

    case 85:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7017; /* pred_uminrvvmf2si_scalar */

    case 86:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7026; /* pred_uminv1qi_scalar */

    case 87:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7035; /* pred_uminv2qi_scalar */

    case 88:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7044; /* pred_uminv4qi_scalar */

    case 89:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7053; /* pred_uminv8qi_scalar */

    case 90:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7062; /* pred_uminv16qi_scalar */

    case 91:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7071; /* pred_uminv32qi_scalar */

    case 92:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7080; /* pred_uminv64qi_scalar */

    case 93:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7089; /* pred_uminv128qi_scalar */

    case 94:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7098; /* pred_uminv256qi_scalar */

    case 95:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7107; /* pred_uminv512qi_scalar */

    case 96:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7116; /* pred_uminv1024qi_scalar */

    case 97:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7125; /* pred_uminv2048qi_scalar */

    case 98:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7134; /* pred_uminv4096qi_scalar */

    case 99:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7143; /* pred_uminv1hi_scalar */

    case 100:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7152; /* pred_uminv2hi_scalar */

    case 101:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7161; /* pred_uminv4hi_scalar */

    case 102:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7170; /* pred_uminv8hi_scalar */

    case 103:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7179; /* pred_uminv16hi_scalar */

    case 104:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7188; /* pred_uminv32hi_scalar */

    case 105:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7197; /* pred_uminv64hi_scalar */

    case 106:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7206; /* pred_uminv128hi_scalar */

    case 107:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7215; /* pred_uminv256hi_scalar */

    case 108:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7224; /* pred_uminv512hi_scalar */

    case 109:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7233; /* pred_uminv1024hi_scalar */

    case 110:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7242; /* pred_uminv2048hi_scalar */

    case 111:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7251; /* pred_uminv1si_scalar */

    case 112:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7260; /* pred_uminv2si_scalar */

    case 113:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7269; /* pred_uminv4si_scalar */

    case 114:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7278; /* pred_uminv8si_scalar */

    case 115:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7287; /* pred_uminv16si_scalar */

    case 116:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7296; /* pred_uminv32si_scalar */

    case 117:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7305; /* pred_uminv64si_scalar */

    case 118:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7314; /* pred_uminv128si_scalar */

    case 119:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7323; /* pred_uminv256si_scalar */

    case 120:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7332; /* pred_uminv512si_scalar */

    case 121:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7341; /* pred_uminv1024si_scalar */

    case 122:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7674; /* *pred_uminrvvm8di_scalar */

    case 123:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7683; /* *pred_uminrvvm4di_scalar */

    case 124:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7692; /* *pred_uminrvvm2di_scalar */

    case 125:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7701; /* *pred_uminrvvm1di_scalar */

    case 126:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7710; /* *pred_uminv1di_scalar */

    case 127:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7719; /* *pred_uminv2di_scalar */

    case 128:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7728; /* *pred_uminv4di_scalar */

    case 129:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7737; /* *pred_uminv8di_scalar */

    case 130:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7746; /* *pred_uminv16di_scalar */

    case 131:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7755; /* *pred_uminv32di_scalar */

    case 132:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7764; /* *pred_uminv64di_scalar */

    case 133:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7773; /* *pred_uminv128di_scalar */

    case 134:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7782; /* *pred_uminv256di_scalar */

    case 135:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7791; /* *pred_uminv512di_scalar */

    case 136:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7800; /* *pred_uminrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7809; /* *pred_uminrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7818; /* *pred_uminrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7827; /* *pred_uminrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7836; /* *pred_uminv1di_extended_scalar */

    case 141:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7845; /* *pred_uminv2di_extended_scalar */

    case 142:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7854; /* *pred_uminv4di_extended_scalar */

    case 143:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7863; /* *pred_uminv8di_extended_scalar */

    case 144:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7872; /* *pred_uminv16di_extended_scalar */

    case 145:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7881; /* *pred_uminv32di_extended_scalar */

    case 146:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7890; /* *pred_uminv64di_extended_scalar */

    case 147:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7899; /* *pred_uminv128di_extended_scalar */

    case 148:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7908; /* *pred_uminv256di_extended_scalar */

    case 149:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7917; /* *pred_uminv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_911 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern502 (x2))
    {
    case 0:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17376; /* pred_fixuns_truncrvvm8hf */

    case 1:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17378; /* pred_fixuns_truncrvvm4hf */

    case 2:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17922; /* pred_narrow_fixuns_truncrvvm8sf */

    case 3:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17380; /* pred_fixuns_truncrvvm2hf */

    case 4:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17924; /* pred_narrow_fixuns_truncrvvm4sf */

    case 5:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17382; /* pred_fixuns_truncrvvm1hf */

    case 6:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17926; /* pred_narrow_fixuns_truncrvvm2sf */

    case 7:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17384; /* pred_fixuns_truncrvvmf2hf */

    case 8:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17928; /* pred_narrow_fixuns_truncrvvm1sf */

    case 9:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17386; /* pred_fixuns_truncrvvmf4hf */

    case 10:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17930; /* pred_narrow_fixuns_truncrvvmf2sf */

    case 11:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17388; /* pred_fixuns_truncrvvm8sf */

    case 12:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17628; /* pred_widen_fixuns_truncrvvm8si */

    case 13:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17390; /* pred_fixuns_truncrvvm4sf */

    case 14:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17630; /* pred_widen_fixuns_truncrvvm4si */

    case 15:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17932; /* pred_narrow_fixuns_truncrvvm8df */

    case 16:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17392; /* pred_fixuns_truncrvvm2sf */

    case 17:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17632; /* pred_widen_fixuns_truncrvvm2si */

    case 18:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17934; /* pred_narrow_fixuns_truncrvvm4df */

    case 19:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17394; /* pred_fixuns_truncrvvm1sf */

    case 20:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17634; /* pred_widen_fixuns_truncrvvm1si */

    case 21:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17936; /* pred_narrow_fixuns_truncrvvm2df */

    case 22:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17396; /* pred_fixuns_truncrvvmf2sf */

    case 23:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17636; /* pred_widen_fixuns_truncrvvmf2si */

    case 24:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17938; /* pred_narrow_fixuns_truncrvvm1df */

    case 25:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17398; /* pred_fixuns_truncrvvm8df */

    case 26:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17638; /* pred_widen_fixuns_truncrvvm8di */

    case 27:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17400; /* pred_fixuns_truncrvvm4df */

    case 28:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17640; /* pred_widen_fixuns_truncrvvm4di */

    case 29:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17402; /* pred_fixuns_truncrvvm2df */

    case 30:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17642; /* pred_widen_fixuns_truncrvvm2di */

    case 31:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17404; /* pred_fixuns_truncrvvm1df */

    case 32:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17644; /* pred_widen_fixuns_truncrvvm1di */

    case 33:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17406; /* pred_fixuns_truncv1hf */

    case 34:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17964; /* pred_narrow_fixuns_truncv1sf */

    case 35:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17408; /* pred_fixuns_truncv2hf */

    case 36:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17966; /* pred_narrow_fixuns_truncv2sf */

    case 37:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17410; /* pred_fixuns_truncv4hf */

    case 38:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17968; /* pred_narrow_fixuns_truncv4sf */

    case 39:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17412; /* pred_fixuns_truncv8hf */

    case 40:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17970; /* pred_narrow_fixuns_truncv8sf */

    case 41:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17414; /* pred_fixuns_truncv16hf */

    case 42:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17972; /* pred_narrow_fixuns_truncv16sf */

    case 43:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17416; /* pred_fixuns_truncv32hf */

    case 44:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17974; /* pred_narrow_fixuns_truncv32sf */

    case 45:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17418; /* pred_fixuns_truncv64hf */

    case 46:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17976; /* pred_narrow_fixuns_truncv64sf */

    case 47:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17420; /* pred_fixuns_truncv128hf */

    case 48:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17978; /* pred_narrow_fixuns_truncv128sf */

    case 49:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17422; /* pred_fixuns_truncv256hf */

    case 50:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17980; /* pred_narrow_fixuns_truncv256sf */

    case 51:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17424; /* pred_fixuns_truncv512hf */

    case 52:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17982; /* pred_narrow_fixuns_truncv512sf */

    case 53:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17426; /* pred_fixuns_truncv1024hf */

    case 54:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17984; /* pred_narrow_fixuns_truncv1024sf */

    case 55:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17428; /* pred_fixuns_truncv2048hf */

    case 56:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17430; /* pred_fixuns_truncv1sf */

    case 57:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 17646; /* pred_widen_fixuns_truncv1si */

    case 58:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17986; /* pred_narrow_fixuns_truncv1df */

    case 59:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17432; /* pred_fixuns_truncv2sf */

    case 60:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 17648; /* pred_widen_fixuns_truncv2si */

    case 61:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17988; /* pred_narrow_fixuns_truncv2df */

    case 62:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17434; /* pred_fixuns_truncv4sf */

    case 63:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 17650; /* pred_widen_fixuns_truncv4si */

    case 64:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17990; /* pred_narrow_fixuns_truncv4df */

    case 65:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17436; /* pred_fixuns_truncv8sf */

    case 66:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 17652; /* pred_widen_fixuns_truncv8si */

    case 67:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17992; /* pred_narrow_fixuns_truncv8df */

    case 68:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17438; /* pred_fixuns_truncv16sf */

    case 69:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17654; /* pred_widen_fixuns_truncv16si */

    case 70:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17994; /* pred_narrow_fixuns_truncv16df */

    case 71:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17440; /* pred_fixuns_truncv32sf */

    case 72:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17656; /* pred_widen_fixuns_truncv32si */

    case 73:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17996; /* pred_narrow_fixuns_truncv32df */

    case 74:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17442; /* pred_fixuns_truncv64sf */

    case 75:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17658; /* pred_widen_fixuns_truncv64si */

    case 76:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17998; /* pred_narrow_fixuns_truncv64df */

    case 77:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17444; /* pred_fixuns_truncv128sf */

    case 78:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1071 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17660; /* pred_widen_fixuns_truncv128si */

    case 79:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 18000; /* pred_narrow_fixuns_truncv128df */

    case 80:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17446; /* pred_fixuns_truncv256sf */

    case 81:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1072 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17662; /* pred_widen_fixuns_truncv256si */

    case 82:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 18002; /* pred_narrow_fixuns_truncv256df */

    case 83:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17448; /* pred_fixuns_truncv512sf */

    case 84:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1073 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17664; /* pred_widen_fixuns_truncv512si */

    case 85:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 18004; /* pred_narrow_fixuns_truncv512df */

    case 86:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17450; /* pred_fixuns_truncv1024sf */

    case 87:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1074 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17666; /* pred_widen_fixuns_truncv1024si */

    case 88:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17452; /* pred_fixuns_truncv1df */

    case 89:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1075 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17668; /* pred_widen_fixuns_truncv1di */

    case 90:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17454; /* pred_fixuns_truncv2df */

    case 91:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1076 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17670; /* pred_widen_fixuns_truncv2di */

    case 92:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17456; /* pred_fixuns_truncv4df */

    case 93:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1077 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17672; /* pred_widen_fixuns_truncv4di */

    case 94:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17458; /* pred_fixuns_truncv8df */

    case 95:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1078 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17674; /* pred_widen_fixuns_truncv8di */

    case 96:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17460; /* pred_fixuns_truncv16df */

    case 97:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1079 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17676; /* pred_widen_fixuns_truncv16di */

    case 98:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17462; /* pred_fixuns_truncv32df */

    case 99:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1080 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17678; /* pred_widen_fixuns_truncv32di */

    case 100:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17464; /* pred_fixuns_truncv64df */

    case 101:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1081 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17680; /* pred_widen_fixuns_truncv64di */

    case 102:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17466; /* pred_fixuns_truncv128df */

    case 103:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1082 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17682; /* pred_widen_fixuns_truncv128di */

    case 104:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17468; /* pred_fixuns_truncv256df */

    case 105:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1083 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17684; /* pred_widen_fixuns_truncv256di */

    case 106:
      if (!(
#line 7507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17470; /* pred_fixuns_truncv512df */

    case 107:
      if (!(
#line 7579 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1084 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17686; /* pred_widen_fixuns_truncv512di */

    case 108:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17910; /* pred_narrow_fixuns_truncrvvm8hf */

    case 109:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17912; /* pred_narrow_fixuns_truncrvvm4hf */

    case 110:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17914; /* pred_narrow_fixuns_truncrvvm2hf */

    case 111:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17916; /* pred_narrow_fixuns_truncrvvm1hf */

    case 112:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17918; /* pred_narrow_fixuns_truncrvvmf2hf */

    case 113:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17920; /* pred_narrow_fixuns_truncrvvmf4hf */

    case 114:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17940; /* pred_narrow_fixuns_truncv1hf */

    case 115:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17942; /* pred_narrow_fixuns_truncv2hf */

    case 116:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17944; /* pred_narrow_fixuns_truncv4hf */

    case 117:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17946; /* pred_narrow_fixuns_truncv8hf */

    case 118:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17948; /* pred_narrow_fixuns_truncv16hf */

    case 119:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17950; /* pred_narrow_fixuns_truncv32hf */

    case 120:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17952; /* pred_narrow_fixuns_truncv64hf */

    case 121:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17954; /* pred_narrow_fixuns_truncv128hf */

    case 122:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17956; /* pred_narrow_fixuns_truncv256hf */

    case 123:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17958; /* pred_narrow_fixuns_truncv512hf */

    case 124:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17960; /* pred_narrow_fixuns_truncv1024hf */

    case 125:
      if (!(
#line 7667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17962; /* pred_narrow_fixuns_truncv2048hf */

    default:
      return -1;
    }
}

 int
recog_928 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern473 (x2, 
187))
    {
    case 0:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2214; /* pred_indexed_load_widthhurvvm8qi */

    case 1:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2220; /* pred_indexed_load_widthhurvvm4qi */

    case 2:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2226; /* pred_indexed_load_widthhurvvm2qi */

    case 3:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2232; /* pred_indexed_load_widthhurvvm1qi */

    case 4:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2238; /* pred_indexed_load_widthhurvvm8hi */

    case 5:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2244; /* pred_indexed_load_widthhurvvm4hi */

    case 6:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2250; /* pred_indexed_load_widthhurvvm2hi */

    case 7:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2256; /* pred_indexed_load_widthhurvvm1hi */

    case 8:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2262; /* pred_indexed_load_widthhurvvm8si */

    case 9:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2268; /* pred_indexed_load_widthhurvvm4si */

    case 10:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2274; /* pred_indexed_load_widthhurvvm2si */

    case 11:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2280; /* pred_indexed_load_widthhurvvm1si */

    case 12:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2286; /* pred_indexed_load_widthhurvvm8di */

    case 13:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2292; /* pred_indexed_load_widthhurvvm4di */

    case 14:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2298; /* pred_indexed_load_widthhurvvm2di */

    case 15:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2304; /* pred_indexed_load_widthhurvvm1di */

    case 16:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2310; /* pred_indexed_load_widthhurvvmf8qi */

    case 17:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2316; /* pred_indexed_load_widthhurvvmf4hi */

    case 18:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2322; /* pred_indexed_load_widthhurvvmf2si */

    default:
      return -1;
    }
}

 int
recog_931 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern717 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11407; /* pred_asuburvvm8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11883; /* pred_asuburvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11414; /* pred_asuburvvm4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11888; /* pred_asuburvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11421; /* pred_asuburvvm2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11893; /* pred_asuburvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11428; /* pred_asuburvvm1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11898; /* pred_asuburvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11435; /* pred_asuburvvm8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11918; /* pred_asuburvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11442; /* pred_asuburvvm4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11923; /* pred_asuburvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11449; /* pred_asuburvvm2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11928; /* pred_asuburvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11456; /* pred_asuburvvm1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11933; /* pred_asuburvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11463; /* pred_asuburvvm8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11948; /* pred_asuburvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11470; /* pred_asuburvvm4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11953; /* pred_asuburvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11477; /* pred_asuburvvm2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11958; /* pred_asuburvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11484; /* pred_asuburvvm1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11963; /* pred_asuburvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11491; /* pred_asuburvvm8di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12197; /* *pred_asuburvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11498; /* pred_asuburvvm4di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12202; /* *pred_asuburvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11505; /* pred_asuburvvm2di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12207; /* *pred_asuburvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11512; /* pred_asuburvvm1di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12212; /* *pred_asuburvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11519; /* pred_asuburvvmf2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11903; /* pred_asuburvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11526; /* pred_asuburvvmf4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11908; /* pred_asuburvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11533; /* pred_asuburvvmf8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11913; /* pred_asuburvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11540; /* pred_asuburvvmf2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11938; /* pred_asuburvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11547; /* pred_asuburvvmf4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11943; /* pred_asuburvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11554; /* pred_asuburvvmf2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11968; /* pred_asuburvvmf2si_scalar */

    case 22:
      if (register_operand (operands[4], E_V1QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 11561; /* pred_asubuv1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11973; /* pred_asubuv1qi_scalar */

    case 23:
      if (register_operand (operands[4], E_V2QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 11568; /* pred_asubuv2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11978; /* pred_asubuv2qi_scalar */

    case 24:
      if (register_operand (operands[4], E_V4QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 11575; /* pred_asubuv4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11983; /* pred_asubuv4qi_scalar */

    case 25:
      if (register_operand (operands[4], E_V8QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 11582; /* pred_asubuv8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11988; /* pred_asubuv8qi_scalar */

    case 26:
      if (register_operand (operands[4], E_V16QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 11589; /* pred_asubuv16qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11993; /* pred_asubuv16qi_scalar */

    case 27:
      if (register_operand (operands[4], E_V32QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 11596; /* pred_asubuv32qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 11998; /* pred_asubuv32qi_scalar */

    case 28:
      if (register_operand (operands[4], E_V64QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 11603; /* pred_asubuv64qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12003; /* pred_asubuv64qi_scalar */

    case 29:
      if (register_operand (operands[4], E_V128QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 11610; /* pred_asubuv128qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12008; /* pred_asubuv128qi_scalar */

    case 30:
      if (register_operand (operands[4], E_V256QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 11617; /* pred_asubuv256qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12013; /* pred_asubuv256qi_scalar */

    case 31:
      if (register_operand (operands[4], E_V512QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 11624; /* pred_asubuv512qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12018; /* pred_asubuv512qi_scalar */

    case 32:
      if (register_operand (operands[4], E_V1024QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 11631; /* pred_asubuv1024qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12023; /* pred_asubuv1024qi_scalar */

    case 33:
      if (register_operand (operands[4], E_V2048QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 11638; /* pred_asubuv2048qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12028; /* pred_asubuv2048qi_scalar */

    case 34:
      if (register_operand (operands[4], E_V4096QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 11645; /* pred_asubuv4096qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12033; /* pred_asubuv4096qi_scalar */

    case 35:
      if (register_operand (operands[4], E_V1HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 11652; /* pred_asubuv1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12038; /* pred_asubuv1hi_scalar */

    case 36:
      if (register_operand (operands[4], E_V2HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 11659; /* pred_asubuv2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12043; /* pred_asubuv2hi_scalar */

    case 37:
      if (register_operand (operands[4], E_V4HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 11666; /* pred_asubuv4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12048; /* pred_asubuv4hi_scalar */

    case 38:
      if (register_operand (operands[4], E_V8HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 11673; /* pred_asubuv8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12053; /* pred_asubuv8hi_scalar */

    case 39:
      if (register_operand (operands[4], E_V16HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 11680; /* pred_asubuv16hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12058; /* pred_asubuv16hi_scalar */

    case 40:
      if (register_operand (operands[4], E_V32HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 11687; /* pred_asubuv32hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12063; /* pred_asubuv32hi_scalar */

    case 41:
      if (register_operand (operands[4], E_V64HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 11694; /* pred_asubuv64hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12068; /* pred_asubuv64hi_scalar */

    case 42:
      if (register_operand (operands[4], E_V128HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 11701; /* pred_asubuv128hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12073; /* pred_asubuv128hi_scalar */

    case 43:
      if (register_operand (operands[4], E_V256HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 11708; /* pred_asubuv256hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12078; /* pred_asubuv256hi_scalar */

    case 44:
      if (register_operand (operands[4], E_V512HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 11715; /* pred_asubuv512hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12083; /* pred_asubuv512hi_scalar */

    case 45:
      if (register_operand (operands[4], E_V1024HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 11722; /* pred_asubuv1024hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12088; /* pred_asubuv1024hi_scalar */

    case 46:
      if (register_operand (operands[4], E_V2048HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 11729; /* pred_asubuv2048hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12093; /* pred_asubuv2048hi_scalar */

    case 47:
      if (register_operand (operands[4], E_V1SImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 11736; /* pred_asubuv1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12098; /* pred_asubuv1si_scalar */

    case 48:
      if (register_operand (operands[4], E_V2SImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 11743; /* pred_asubuv2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12103; /* pred_asubuv2si_scalar */

    case 49:
      if (register_operand (operands[4], E_V4SImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 11750; /* pred_asubuv4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12108; /* pred_asubuv4si_scalar */

    case 50:
      if (register_operand (operands[4], E_V8SImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 11757; /* pred_asubuv8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12113; /* pred_asubuv8si_scalar */

    case 51:
      if (register_operand (operands[4], E_V16SImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 11764; /* pred_asubuv16si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12118; /* pred_asubuv16si_scalar */

    case 52:
      if (register_operand (operands[4], E_V32SImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 11771; /* pred_asubuv32si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12123; /* pred_asubuv32si_scalar */

    case 53:
      if (register_operand (operands[4], E_V64SImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 11778; /* pred_asubuv64si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12128; /* pred_asubuv64si_scalar */

    case 54:
      if (register_operand (operands[4], E_V128SImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 11785; /* pred_asubuv128si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12133; /* pred_asubuv128si_scalar */

    case 55:
      if (register_operand (operands[4], E_V256SImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 11792; /* pred_asubuv256si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12138; /* pred_asubuv256si_scalar */

    case 56:
      if (register_operand (operands[4], E_V512SImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 11799; /* pred_asubuv512si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12143; /* pred_asubuv512si_scalar */

    case 57:
      if (register_operand (operands[4], E_V1024SImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 11806; /* pred_asubuv1024si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12148; /* pred_asubuv1024si_scalar */

    case 58:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11813; /* pred_asubuv1di */

    case 59:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11820; /* pred_asubuv2di */

    case 60:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11827; /* pred_asubuv4di */

    case 61:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11834; /* pred_asubuv8di */

    case 62:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11841; /* pred_asubuv16di */

    case 63:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11848; /* pred_asubuv32di */

    case 64:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11855; /* pred_asubuv64di */

    case 65:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11862; /* pred_asubuv128di */

    case 66:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11869; /* pred_asubuv256di */

    case 67:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11876; /* pred_asubuv512di */

    case 68:
      if (!(
#line 4669 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12217; /* *pred_asuburvvm8di_extended_scalar */

    case 69:
      if (!(
#line 4669 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12222; /* *pred_asuburvvm4di_extended_scalar */

    case 70:
      if (!(
#line 4669 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12227; /* *pred_asuburvvm2di_extended_scalar */

    case 71:
      if (!(
#line 4669 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12232; /* *pred_asuburvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_938 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4HFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15256; /* *pred_mul_addrvvm4hf_undef */
}

 int
recog_940 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1HFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15260; /* *pred_mul_addrvvm1hf_undef */
}

 int
recog_943 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8SFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15266; /* *pred_mul_addrvvm8sf_undef */
}

 int
recog_948 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8DFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15276; /* *pred_mul_addrvvm8df_undef */
}

 int
recog_953 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2HFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15286; /* *pred_mul_addv2hf_undef */
}

 int
recog_958 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64HFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15296; /* *pred_mul_addv64hf_undef */
}

 int
recog_963 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2048HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2048HFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15306; /* *pred_mul_addv2048hf_undef */
}

 int
recog_968 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15316; /* *pred_mul_addv16sf_undef */
}

 int
recog_973 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512SFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15326; /* *pred_mul_addv512sf_undef */
}

 int
recog_978 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V8DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V8DFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15336; /* *pred_mul_addv8df_undef */
}

 int
recog_983 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256DFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15346; /* *pred_mul_addv256df_undef */
}

 int
recog_988 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern726 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_HFmode)
          || !register_operand (operands[4], E_RVVM2HFmode)
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16765; /* pred_widen_mul_addrvvm4sf_scalar */

    case E_RVVM2BFmode:
      if (!register_operand (operands[3], E_BFmode)
          || !register_operand (operands[4], E_RVVM2BFmode)
          || !(
#line 130 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 22 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 33652; /* pred_widen_bf16_mul_rvvm4sf_scalar */

    default:
      return -1;
    }
}

 int
recog_993 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern726 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_RVVM2HFmode)
          || !register_operand (operands[4], E_RVVM2HFmode)
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16705; /* pred_widen_mul_addrvvm4sf */

    case E_RVVM2BFmode:
      if (!register_operand (operands[3], E_RVVM2BFmode)
          || !register_operand (operands[4], E_RVVM2BFmode)
          || !(
#line 101 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 22 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 33647; /* pred_widen_bf16_mul_rvvm4sf */

    default:
      return -1;
    }
}

 int
recog_998 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_981 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15438; /* *pred_maddv64df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15534; /* *pred_maccv64df */
}

 int
recog_1003 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_976 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15428; /* *pred_maddv2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15524; /* *pred_maccv2df */
}

 int
recog_1008 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_971 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 15418; /* *pred_maddv128sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15514; /* *pred_maccv128sf */
}

 int
recog_1013 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_966 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15408; /* *pred_maddv4sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15504; /* *pred_maccv4sf */
}

 int
recog_1018 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_961 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return 15398; /* *pred_maddv512hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15494; /* *pred_maccv512hf */
}

 int
recog_1024 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_955 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return 15386; /* *pred_maddv8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15482; /* *pred_maccv8hf */
}

 int
recog_1030 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_949 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15374; /* *pred_maddrvvm4df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15470; /* *pred_maccrvvm4df */
}

 int
recog_1036 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_943 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15362; /* *pred_maddrvvm8sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15458; /* *pred_maccrvvm8sf */
}

 int
recog_1042 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_937 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15350; /* *pred_maddrvvm8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15446; /* *pred_maccrvvm8hf */
}

 int
recog_1053 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF2SFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15754; /* *pred_mul_neg_addrvvmf2sf_undef */
}

 int
recog_1062 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16HFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15772; /* *pred_mul_neg_addv16hf_undef */
}

 int
recog_1072 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4SFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15792; /* *pred_mul_neg_addv4sf_undef */
}

 int
recog_1082 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2DFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15812; /* *pred_mul_neg_addv2df_undef */
}

 int
recog_1092 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1089 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return 15922; /* *pred_nmsubv256df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 16018; /* *pred_nmsacv256df */
}

 int
recog_1102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1079 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 15902; /* *pred_nmsubv512sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15998; /* *pred_nmsacv512sf */
}

 int
recog_1112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1069 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2048HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return 15882; /* *pred_nmsubv2048hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15978; /* *pred_nmsacv2048hf */
}

 int
recog_1122 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1059 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return 15862; /* *pred_nmsubv2hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15958; /* *pred_nmsacv2hf */
}

 int
recog_1132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1049 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15842; /* *pred_nmsubrvvm8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15938; /* *pred_nmsacrvvm8sf */
}

 int
recog_1142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8HFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15255; /* *pred_mul_subrvvm8hf_undef */
}

 int
recog_1149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4SFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15269; /* *pred_mul_subrvvm4sf_undef */
}

 int
recog_1156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1DFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15283; /* *pred_mul_subrvvm1df_undef */
}

 int
recog_1163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64HFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15297; /* *pred_mul_subv64hf_undef */
}

 int
recog_1170 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2SFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15311; /* *pred_mul_subv2sf_undef */
}

 int
recog_1177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256SFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15325; /* *pred_mul_subv256sf_undef */
}

 int
recog_1184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16DFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15339; /* *pred_mul_subv16df_undef */
}

 int
recog_1191 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1188 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return 15443; /* *pred_msubv256df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15539; /* *pred_msacv256df */
}

 int
recog_1198 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1181 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15429; /* *pred_msubv2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15525; /* *pred_msacv2df */
}

 int
recog_1205 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1174 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V32SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return 15415; /* *pred_msubv32sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15511; /* *pred_msacv32sf */
}

 int
recog_1212 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1167 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1024HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1024HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return 15401; /* *pred_msubv1024hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15497; /* *pred_msacv1024hf */
}

 int
recog_1219 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1160 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return 15387; /* *pred_msubv8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15483; /* *pred_msacv8hf */
}

 int
recog_1226 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1153 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15373; /* *pred_msubrvvm8df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15469; /* *pred_msacrvvm8df */
}

 int
recog_1233 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1146 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15359; /* *pred_msubrvvmf2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15455; /* *pred_msacrvvmf2hf */
}

 int
recog_1240 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2HFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15739; /* *pred_mul_neg_subrvvm2hf_undef */
}

 int
recog_1247 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM1SFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15753; /* *pred_mul_neg_subrvvm1sf_undef */
}

 int
recog_1254 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2HFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15767; /* *pred_mul_neg_subv2hf_undef */
}

 int
recog_1261 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V256HFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15781; /* *pred_mul_neg_subv256hf_undef */
}

 int
recog_1268 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8SFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15795; /* *pred_mul_neg_subv8sf_undef */
}

 int
recog_1275 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1024SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1024SFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15809; /* *pred_mul_neg_subv1024sf_undef */
}

 int
recog_1282 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V64DFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15823; /* *pred_mul_neg_subv64df_undef */
}

 int
recog_1289 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1282 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15919; /* *pred_nmaddv64df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 16015; /* *pred_nmaccv64df */
}

 int
recog_1296 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1275 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1024SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 15905; /* *pred_nmaddv1024sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 16001; /* *pred_nmaccv1024sf */
}

 int
recog_1303 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1268 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15891; /* *pred_nmaddv8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15987; /* *pred_nmaccv8sf */
}

 int
recog_1310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1261 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return 15877; /* *pred_nmaddv256hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15973; /* *pred_nmaccv256hf */
}

 int
recog_1318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1253 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return 15861; /* *pred_nmaddv1hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15957; /* *pred_nmaccv1hf */
}

 int
recog_1326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1245 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM4SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15845; /* *pred_nmaddrvvm4sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15941; /* *pred_nmaccrvvm4sf */
}

 int
recog_1334 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern578 (x2))
    {
    case 0:
      return recog_1237 (x1, insn, pnum_clobbers);

    case 1:
      return recog_1236 (x1, insn, pnum_clobbers);

    case 2:
      return recog_1235 (x1, insn, pnum_clobbers);

    case 3:
      return recog_1234 (x1, insn, pnum_clobbers);

    case 4:
      return recog_1233 (x1, insn, pnum_clobbers);

    case 5:
      return recog_1232 (x1, insn, pnum_clobbers);

    case 6:
      return recog_1231 (x1, insn, pnum_clobbers);

    case 7:
      return recog_1230 (x1, insn, pnum_clobbers);

    case 8:
      return recog_1229 (x1, insn, pnum_clobbers);

    case 9:
      return recog_1228 (x1, insn, pnum_clobbers);

    case 10:
      return recog_1227 (x1, insn, pnum_clobbers);

    case 11:
      return recog_1226 (x1, insn, pnum_clobbers);

    case 12:
      return recog_1225 (x1, insn, pnum_clobbers);

    case 13:
      return recog_1224 (x1, insn, pnum_clobbers);

    case 14:
      return recog_1223 (x1, insn, pnum_clobbers);

    case 15:
      return recog_1222 (x1, insn, pnum_clobbers);

    case 16:
      return recog_1221 (x1, insn, pnum_clobbers);

    case 17:
      return recog_1220 (x1, insn, pnum_clobbers);

    case 18:
      return recog_1219 (x1, insn, pnum_clobbers);

    case 19:
      return recog_1218 (x1, insn, pnum_clobbers);

    case 20:
      return recog_1217 (x1, insn, pnum_clobbers);

    case 21:
      return recog_1216 (x1, insn, pnum_clobbers);

    case 22:
      return recog_1215 (x1, insn, pnum_clobbers);

    case 23:
      return recog_1214 (x1, insn, pnum_clobbers);

    case 24:
      return recog_1213 (x1, insn, pnum_clobbers);

    case 25:
      return recog_1212 (x1, insn, pnum_clobbers);

    case 26:
      return recog_1211 (x1, insn, pnum_clobbers);

    case 27:
      return recog_1210 (x1, insn, pnum_clobbers);

    case 28:
      return recog_1209 (x1, insn, pnum_clobbers);

    case 29:
      return recog_1208 (x1, insn, pnum_clobbers);

    case 30:
      return recog_1207 (x1, insn, pnum_clobbers);

    case 31:
      return recog_1206 (x1, insn, pnum_clobbers);

    case 32:
      return recog_1205 (x1, insn, pnum_clobbers);

    case 33:
      return recog_1204 (x1, insn, pnum_clobbers);

    case 34:
      return recog_1203 (x1, insn, pnum_clobbers);

    case 35:
      return recog_1202 (x1, insn, pnum_clobbers);

    case 36:
      return recog_1201 (x1, insn, pnum_clobbers);

    case 37:
      return recog_1200 (x1, insn, pnum_clobbers);

    case 38:
      return recog_1199 (x1, insn, pnum_clobbers);

    case 39:
      return recog_1198 (x1, insn, pnum_clobbers);

    case 40:
      return recog_1197 (x1, insn, pnum_clobbers);

    case 41:
      return recog_1196 (x1, insn, pnum_clobbers);

    case 42:
      return recog_1195 (x1, insn, pnum_clobbers);

    case 43:
      return recog_1194 (x1, insn, pnum_clobbers);

    case 44:
      return recog_1193 (x1, insn, pnum_clobbers);

    case 45:
      return recog_1192 (x1, insn, pnum_clobbers);

    case 46:
      return recog_1191 (x1, insn, pnum_clobbers);

    case 47:
      return recog_1190 (x1, insn, pnum_clobbers);

    case 48:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15543; /* *pred_msubrvvm8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15639; /* *pred_msacrvvm8hf_scalar */

    case 49:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15545; /* *pred_msubrvvm4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15641; /* *pred_msacrvvm4hf_scalar */

    case 50:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15547; /* *pred_msubrvvm2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15643; /* *pred_msacrvvm2hf_scalar */

    case 51:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15549; /* *pred_msubrvvm1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15645; /* *pred_msacrvvm1hf_scalar */

    case 52:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15551; /* *pred_msubrvvmf2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15647; /* *pred_msacrvvmf2hf_scalar */

    case 53:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return 15553; /* *pred_msubrvvmf4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15649; /* *pred_msacrvvmf4hf_scalar */

    case 54:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15555; /* *pred_msubrvvm8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15651; /* *pred_msacrvvm8sf_scalar */

    case 55:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15557; /* *pred_msubrvvm4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15653; /* *pred_msacrvvm4sf_scalar */

    case 56:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15559; /* *pred_msubrvvm2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15655; /* *pred_msacrvvm2sf_scalar */

    case 57:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15561; /* *pred_msubrvvm1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15657; /* *pred_msacrvvm1sf_scalar */

    case 58:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return 15563; /* *pred_msubrvvmf2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15659; /* *pred_msacrvvmf2sf_scalar */

    case 59:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15565; /* *pred_msubrvvm8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15661; /* *pred_msacrvvm8df_scalar */

    case 60:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15567; /* *pred_msubrvvm4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15663; /* *pred_msacrvvm4df_scalar */

    case 61:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15569; /* *pred_msubrvvm2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15665; /* *pred_msacrvvm2df_scalar */

    case 62:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15571; /* *pred_msubrvvm1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15667; /* *pred_msacrvvm1df_scalar */

    case 63:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return 15573; /* *pred_msubv1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15669; /* *pred_msacv1hf_scalar */

    case 64:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return 15575; /* *pred_msubv2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15671; /* *pred_msacv2hf_scalar */

    case 65:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return 15577; /* *pred_msubv4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15673; /* *pred_msacv4hf_scalar */

    case 66:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 15579; /* *pred_msubv8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15675; /* *pred_msacv8hf_scalar */

    case 67:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 15581; /* *pred_msubv16hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15677; /* *pred_msacv16hf_scalar */

    case 68:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 15583; /* *pred_msubv32hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15679; /* *pred_msacv32hf_scalar */

    case 69:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return 15585; /* *pred_msubv64hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15681; /* *pred_msacv64hf_scalar */

    case 70:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return 15587; /* *pred_msubv128hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15683; /* *pred_msacv128hf_scalar */

    case 71:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return 15589; /* *pred_msubv256hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15685; /* *pred_msacv256hf_scalar */

    case 72:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 15591; /* *pred_msubv512hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15687; /* *pred_msacv512hf_scalar */

    case 73:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return 15593; /* *pred_msubv1024hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15689; /* *pred_msacv1024hf_scalar */

    case 74:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 15595; /* *pred_msubv2048hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15691; /* *pred_msacv2048hf_scalar */

    case 75:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15597; /* *pred_msubv1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15693; /* *pred_msacv1sf_scalar */

    case 76:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15599; /* *pred_msubv2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15695; /* *pred_msacv2sf_scalar */

    case 77:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15601; /* *pred_msubv4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15697; /* *pred_msacv4sf_scalar */

    case 78:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15603; /* *pred_msubv8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15699; /* *pred_msacv8sf_scalar */

    case 79:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return 15605; /* *pred_msubv16sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15701; /* *pred_msacv16sf_scalar */

    case 80:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return 15607; /* *pred_msubv32sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15703; /* *pred_msacv32sf_scalar */

    case 81:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return 15609; /* *pred_msubv64sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15705; /* *pred_msacv64sf_scalar */

    case 82:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return 15611; /* *pred_msubv128sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15707; /* *pred_msacv128sf_scalar */

    case 83:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return 15613; /* *pred_msubv256sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15709; /* *pred_msacv256sf_scalar */

    case 84:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 15615; /* *pred_msubv512sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15711; /* *pred_msacv512sf_scalar */

    case 85:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return 15617; /* *pred_msubv1024sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15713; /* *pred_msacv1024sf_scalar */

    case 86:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15619; /* *pred_msubv1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15715; /* *pred_msacv1df_scalar */

    case 87:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15621; /* *pred_msubv2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15717; /* *pred_msacv2df_scalar */

    case 88:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15623; /* *pred_msubv4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15719; /* *pred_msacv4df_scalar */

    case 89:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return 15625; /* *pred_msubv8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15721; /* *pred_msacv8df_scalar */

    case 90:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return 15627; /* *pred_msubv16df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15723; /* *pred_msacv16df_scalar */

    case 91:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return 15629; /* *pred_msubv32df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15725; /* *pred_msacv32df_scalar */

    case 92:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return 15631; /* *pred_msubv64df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15727; /* *pred_msacv64df_scalar */

    case 93:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return 15633; /* *pred_msubv128df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15729; /* *pred_msacv128df_scalar */

    case 94:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return 15635; /* *pred_msubv256df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15731; /* *pred_msacv256df_scalar */

    case 95:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6612 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 15637; /* *pred_msubv512df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6646 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15733; /* *pred_msacv512df_scalar */

    case 96:
      if (pattern697 (x2, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16704; /* pred_widen_mul_subrvvm8sf */

    case 97:
      if (pattern697 (x2, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16706; /* pred_widen_mul_subrvvm4sf */

    case 98:
      if (pattern697 (x2, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16708; /* pred_widen_mul_subrvvm2sf */

    case 99:
      if (pattern697 (x2, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16710; /* pred_widen_mul_subrvvm1sf */

    case 100:
      if (pattern697 (x2, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16712; /* pred_widen_mul_subrvvmf2sf */

    case 101:
      if (pattern697 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16714; /* pred_widen_mul_subrvvm8df */

    case 102:
      if (pattern697 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16716; /* pred_widen_mul_subrvvm4df */

    case 103:
      if (pattern697 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16718; /* pred_widen_mul_subrvvm2df */

    case 104:
      if (pattern697 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16720; /* pred_widen_mul_subrvvm1df */

    case 105:
      if (pattern697 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16722; /* pred_widen_mul_subv1sf */

    case 106:
      if (pattern697 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16724; /* pred_widen_mul_subv2sf */

    case 107:
      if (pattern697 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16726; /* pred_widen_mul_subv4sf */

    case 108:
      if (pattern697 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16728; /* pred_widen_mul_subv8sf */

    case 109:
      if (pattern697 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16730; /* pred_widen_mul_subv16sf */

    case 110:
      if (pattern697 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16732; /* pred_widen_mul_subv32sf */

    case 111:
      if (pattern697 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16734; /* pred_widen_mul_subv64sf */

    case 112:
      if (pattern697 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16736; /* pred_widen_mul_subv128sf */

    case 113:
      if (pattern697 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16738; /* pred_widen_mul_subv256sf */

    case 114:
      if (pattern697 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16740; /* pred_widen_mul_subv512sf */

    case 115:
      if (pattern697 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16742; /* pred_widen_mul_subv1024sf */

    case 116:
      if (pattern697 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16744; /* pred_widen_mul_subv1df */

    case 117:
      if (pattern697 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16746; /* pred_widen_mul_subv2df */

    case 118:
      if (pattern697 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16748; /* pred_widen_mul_subv4df */

    case 119:
      if (pattern697 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16750; /* pred_widen_mul_subv8df */

    case 120:
      if (pattern697 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16752; /* pred_widen_mul_subv16df */

    case 121:
      if (pattern697 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16754; /* pred_widen_mul_subv32df */

    case 122:
      if (pattern697 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16756; /* pred_widen_mul_subv64df */

    case 123:
      if (pattern697 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16758; /* pred_widen_mul_subv128df */

    case 124:
      if (pattern697 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16760; /* pred_widen_mul_subv256df */

    case 125:
      if (pattern697 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 7166 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16762; /* pred_widen_mul_subv512df */

    case 126:
      if (pattern699 (x2, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16764; /* pred_widen_mul_subrvvm8sf_scalar */

    case 127:
      if (pattern699 (x2, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16766; /* pred_widen_mul_subrvvm4sf_scalar */

    case 128:
      if (pattern699 (x2, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16768; /* pred_widen_mul_subrvvm2sf_scalar */

    case 129:
      if (pattern699 (x2, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16770; /* pred_widen_mul_subrvvm1sf_scalar */

    case 130:
      if (pattern699 (x2, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16772; /* pred_widen_mul_subrvvmf2sf_scalar */

    case 131:
      if (pattern699 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16774; /* pred_widen_mul_subrvvm8df_scalar */

    case 132:
      if (pattern699 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16776; /* pred_widen_mul_subrvvm4df_scalar */

    case 133:
      if (pattern699 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16778; /* pred_widen_mul_subrvvm2df_scalar */

    case 134:
      if (pattern699 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16780; /* pred_widen_mul_subrvvm1df_scalar */

    case 135:
      if (pattern699 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16782; /* pred_widen_mul_subv1sf_scalar */

    case 136:
      if (pattern699 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16784; /* pred_widen_mul_subv2sf_scalar */

    case 137:
      if (pattern699 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16786; /* pred_widen_mul_subv4sf_scalar */

    case 138:
      if (pattern699 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16788; /* pred_widen_mul_subv8sf_scalar */

    case 139:
      if (pattern699 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16790; /* pred_widen_mul_subv16sf_scalar */

    case 140:
      if (pattern699 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16792; /* pred_widen_mul_subv32sf_scalar */

    case 141:
      if (pattern699 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16794; /* pred_widen_mul_subv64sf_scalar */

    case 142:
      if (pattern699 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16796; /* pred_widen_mul_subv128sf_scalar */

    case 143:
      if (pattern699 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16798; /* pred_widen_mul_subv256sf_scalar */

    case 144:
      if (pattern699 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16800; /* pred_widen_mul_subv512sf_scalar */

    case 145:
      if (pattern699 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16802; /* pred_widen_mul_subv1024sf_scalar */

    case 146:
      if (pattern699 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16804; /* pred_widen_mul_subv1df_scalar */

    case 147:
      if (pattern699 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16806; /* pred_widen_mul_subv2df_scalar */

    case 148:
      if (pattern699 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16808; /* pred_widen_mul_subv4df_scalar */

    case 149:
      if (pattern699 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16810; /* pred_widen_mul_subv8df_scalar */

    case 150:
      if (pattern699 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16812; /* pred_widen_mul_subv16df_scalar */

    case 151:
      if (pattern699 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16814; /* pred_widen_mul_subv32df_scalar */

    case 152:
      if (pattern699 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16816; /* pred_widen_mul_subv64df_scalar */

    case 153:
      if (pattern699 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16818; /* pred_widen_mul_subv128df_scalar */

    case 154:
      if (pattern699 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16820; /* pred_widen_mul_subv256df_scalar */

    case 155:
      if (pattern699 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0
          || !(
#line 7195 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16822; /* pred_widen_mul_subv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_1397 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern532 (x2, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V4BImode))
    {
      res = recog_1380 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V4BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4QImode:
      if (!register_operand (operands[4], E_V4QImode)
          || !vector_neg_arith_operand (operands[5], E_V4QImode))
        return -1;
      if ((
#line 4865 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4QImode)) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 12723; /* *pred_ltgev4qi */
      if (!(
#line 4886 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4QImode)) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12791; /* *pred_ltgev4qi_narrow */

    case E_V4HImode:
      if (!register_operand (operands[4], E_V4HImode)
          || !vector_neg_arith_operand (operands[5], E_V4HImode))
        return -1;
      if ((
#line 4865 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HImode)) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12736; /* *pred_ltgev4hi */
      if (!(
#line 4886 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HImode)) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12804; /* *pred_ltgev4hi_narrow */

    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode)
          || !vector_neg_arith_operand (operands[5], E_V4SImode))
        return -1;
      if ((
#line 4865 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SImode)) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12748; /* *pred_ltgev4si */
      if (!(
#line 4886 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SImode)) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12816; /* *pred_ltgev4si_narrow */

    case E_V4DImode:
      if (!register_operand (operands[4], E_V4DImode)
          || !vector_neg_arith_operand (operands[5], E_V4DImode))
        return -1;
      if ((
#line 4865 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DImode)) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 12759; /* *pred_ltgev4di */
      if (!(
#line 4886 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DImode)) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12827; /* *pred_ltgev4di_narrow */

    default:
      return -1;
    }
}

 int
recog_1407 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4QImode:
      if (!register_operand (operands[3], E_V4QImode)
          || GET_MODE (x9) != E_V4QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4925 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12855; /* *pred_cmpv4qi_scalar_merge_tie_mask */

    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode)
          || GET_MODE (x9) != E_V4HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4925 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12868; /* *pred_cmpv4hi_scalar_merge_tie_mask */

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode)
          || GET_MODE (x9) != E_V4SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4925 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12880; /* *pred_cmpv4si_scalar_merge_tie_mask */

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || GET_MODE (x9) != E_V4DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5035 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13003; /* *pred_cmpv4di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1414 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512QImode:
      if (!register_operand (operands[3], E_V512QImode)
          || GET_MODE (x9) != E_V512QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4925 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12862; /* *pred_cmpv512qi_scalar_merge_tie_mask */

    case E_V512HImode:
      if (!register_operand (operands[3], E_V512HImode)
          || GET_MODE (x9) != E_V512HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4925 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12875; /* *pred_cmpv512hi_scalar_merge_tie_mask */

    case E_V512SImode:
      if (!register_operand (operands[3], E_V512SImode)
          || GET_MODE (x9) != E_V512SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4925 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12887; /* *pred_cmpv512si_scalar_merge_tie_mask */

    case E_V512DImode:
      if (!register_operand (operands[3], E_V512DImode)
          || GET_MODE (x9) != E_V512DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5035 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 13010; /* *pred_cmpv512di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1423 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V8BImode))
    {
      res = recog_1408 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8QImode:
      if (!register_operand (operands[4], E_V8QImode)
          || GET_MODE (x9) != E_V8QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4950 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8QImode)) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 12910; /* *pred_cmpv8qi_scalar */
      if (!(
#line 4972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8QImode)) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 12964; /* *pred_cmpv8qi_scalar_narrow */

    case E_V8HImode:
      if (!register_operand (operands[4], E_V8HImode)
          || GET_MODE (x9) != E_V8HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4950 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8HImode)) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12923; /* *pred_cmpv8hi_scalar */
      if (!(
#line 4972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8HImode)) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12977; /* *pred_cmpv8hi_scalar_narrow */

    case E_V8SImode:
      if (!register_operand (operands[4], E_V8SImode)
          || GET_MODE (x9) != E_V8SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4950 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8SImode)) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12935; /* *pred_cmpv8si_scalar */
      if (!(
#line 4972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8SImode)) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12989; /* *pred_cmpv8si_scalar_narrow */

    case E_V8DImode:
      if (!register_operand (operands[4], E_V8DImode)
          || GET_MODE (x9) != E_V8DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DImode)) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 13018; /* *pred_cmpv8di_scalar */
      if (!(
#line 5082 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DImode)) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 13032; /* *pred_cmpv8di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1430 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_RVVM2HFmode)
          || !register_operand (operands[4], E_RVVM2HFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16993; /* *pred_cmprvvm2hf_narrow_merge_tie_mask */

    case E_RVVM4SFmode:
      if (!register_operand (operands[3], E_RVVM4SFmode)
          || !register_operand (operands[4], E_RVVM4SFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16998; /* *pred_cmprvvm4sf_narrow_merge_tie_mask */

    case E_RVVM8DFmode:
      if (!register_operand (operands[3], E_RVVM8DFmode)
          || !register_operand (operands[4], E_RVVM8DFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17002; /* *pred_cmprvvm8df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1432 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[3], E_RVVMF2HFmode)
          || !register_operand (operands[4], E_RVVMF2HFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16995; /* *pred_cmprvvmf2hf_narrow_merge_tie_mask */

    case E_RVVM1SFmode:
      if (!register_operand (operands[3], E_RVVM1SFmode)
          || !register_operand (operands[4], E_RVVM1SFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17000; /* *pred_cmprvvm1sf_narrow_merge_tie_mask */

    case E_RVVM2DFmode:
      if (!register_operand (operands[3], E_RVVM2DFmode)
          || !register_operand (operands[4], E_RVVM2DFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17004; /* *pred_cmprvvm2df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1437 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[3], E_V8HFmode)
          || !register_operand (operands[4], E_V8HFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17009; /* *pred_cmpv8hf_narrow_merge_tie_mask */

    case E_V8SFmode:
      if (!register_operand (operands[3], E_V8SFmode)
          || !register_operand (operands[4], E_V8SFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17021; /* *pred_cmpv8sf_narrow_merge_tie_mask */

    case E_V8DFmode:
      if (!register_operand (operands[3], E_V8DFmode)
          || !register_operand (operands[4], E_V8DFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17032; /* *pred_cmpv8df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1442 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V256HFmode:
      if (!register_operand (operands[3], E_V256HFmode)
          || !register_operand (operands[4], E_V256HFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17014; /* *pred_cmpv256hf_narrow_merge_tie_mask */

    case E_V256SFmode:
      if (!register_operand (operands[3], E_V256SFmode)
          || !register_operand (operands[4], E_V256SFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17026; /* *pred_cmpv256sf_narrow_merge_tie_mask */

    case E_V256DFmode:
      if (!register_operand (operands[3], E_V256DFmode)
          || !register_operand (operands[4], E_V256DFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17037; /* *pred_cmpv256df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1447 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1HFmode:
      if (!register_operand (operands[3], E_RVVM1HFmode)
          || GET_MODE (x9) != E_RVVM1HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17090; /* *pred_cmprvvm1hf_scalar_merge_tie_mask */

    case E_RVVM2SFmode:
      if (!register_operand (operands[3], E_RVVM2SFmode)
          || GET_MODE (x9) != E_RVVM2SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17095; /* *pred_cmprvvm2sf_scalar_merge_tie_mask */

    case E_RVVM4DFmode:
      if (!register_operand (operands[3], E_RVVM4DFmode)
          || GET_MODE (x9) != E_RVVM4DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17099; /* *pred_cmprvvm4df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1453 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[3], E_V8HFmode)
          || GET_MODE (x9) != E_V8HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17105; /* *pred_cmpv8hf_scalar_merge_tie_mask */

    case E_V8SFmode:
      if (!register_operand (operands[3], E_V8SFmode)
          || GET_MODE (x9) != E_V8SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17117; /* *pred_cmpv8sf_scalar_merge_tie_mask */

    case E_V8DFmode:
      if (!register_operand (operands[3], E_V8DFmode)
          || GET_MODE (x9) != E_V8DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17128; /* *pred_cmpv8df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1459 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512HFmode:
      if (!register_operand (operands[3], E_V512HFmode)
          || GET_MODE (x9) != E_V512HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17111; /* *pred_cmpv512hf_scalar_merge_tie_mask */

    case E_V512SFmode:
      if (!register_operand (operands[3], E_V512SFmode)
          || GET_MODE (x9) != E_V512SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17123; /* *pred_cmpv512sf_scalar_merge_tie_mask */

    case E_V512DFmode:
      if (!register_operand (operands[3], E_V512DFmode)
          || GET_MODE (x9) != E_V512DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17134; /* *pred_cmpv512df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1467 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern543 (x2, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V8BImode))
    {
      res = recog_1453 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[4], E_V8HFmode)
          || GET_MODE (x9) != E_V8HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7408 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8HFmode)) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 17153; /* *pred_cmpv8hf_scalar */
      if (!(
#line 7430 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8HFmode)) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17201; /* *pred_cmpv8hf_scalar_narrow */

    case E_V8SFmode:
      if (!register_operand (operands[4], E_V8SFmode)
          || GET_MODE (x9) != E_V8SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7408 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8SFmode)) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 17165; /* *pred_cmpv8sf_scalar */
      if (!(
#line 7430 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8SFmode)) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17213; /* *pred_cmpv8sf_scalar_narrow */

    case E_V8DFmode:
      if (!register_operand (operands[4], E_V8DFmode)
          || GET_MODE (x9) != E_V8DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7408 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DFmode)) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return 17176; /* *pred_cmpv8df_scalar */
      if (!(
#line 7430 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DFmode)) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17224; /* *pred_cmpv8df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1472 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern214 (x2))
    {
    case 0:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25981; /* vcond_mask_rvvm8qirvvm1bi */

    case 1:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25982; /* vcond_mask_rvvm4qirvvmf2bi */

    case 2:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25983; /* vcond_mask_rvvm2qirvvmf4bi */

    case 3:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25984; /* vcond_mask_rvvm1qirvvmf8bi */

    case 4:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25985; /* vcond_mask_rvvm8hirvvmf2bi */

    case 5:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25986; /* vcond_mask_rvvm4hirvvmf4bi */

    case 6:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25987; /* vcond_mask_rvvm2hirvvmf8bi */

    case 7:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25988; /* vcond_mask_rvvm1hirvvmf16bi */

    case 8:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25989; /* vcond_mask_rvvm8sirvvmf4bi */

    case 9:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25990; /* vcond_mask_rvvm4sirvvmf8bi */

    case 10:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25991; /* vcond_mask_rvvm2sirvvmf16bi */

    case 11:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25992; /* vcond_mask_rvvm1sirvvmf32bi */

    case 12:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25993; /* vcond_mask_rvvm8dirvvmf8bi */

    case 13:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25994; /* vcond_mask_rvvm4dirvvmf16bi */

    case 14:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25995; /* vcond_mask_rvvm2dirvvmf32bi */

    case 15:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25996; /* vcond_mask_rvvm1dirvvmf64bi */

    case 16:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25997; /* vcond_mask_rvvmf2qirvvmf16bi */

    case 17:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25998; /* vcond_mask_rvvmf4qirvvmf32bi */

    case 18:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25999; /* vcond_mask_rvvmf8qirvvmf64bi */

    case 19:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26000; /* vcond_mask_rvvmf2hirvvmf32bi */

    case 20:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26001; /* vcond_mask_rvvmf4hirvvmf64bi */

    case 21:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26002; /* vcond_mask_rvvmf2sirvvmf64bi */

    case 22:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 26003; /* vcond_mask_rvvm8bfrvvmf2bi */

    case 23:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 26004; /* vcond_mask_rvvm4bfrvvmf4bi */

    case 24:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 26005; /* vcond_mask_rvvm2bfrvvmf8bi */

    case 25:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 26006; /* vcond_mask_rvvm1bfrvvmf16bi */

    case 26:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 26007; /* vcond_mask_rvvmf2bfrvvmf32bi */

    case 27:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26008; /* vcond_mask_rvvmf4bfrvvmf64bi */

    case 28:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26009; /* vcond_mask_rvvm8hfrvvmf2bi */

    case 29:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26010; /* vcond_mask_rvvm4hfrvvmf4bi */

    case 30:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26011; /* vcond_mask_rvvm2hfrvvmf8bi */

    case 31:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26012; /* vcond_mask_rvvm1hfrvvmf16bi */

    case 32:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26013; /* vcond_mask_rvvmf2hfrvvmf32bi */

    case 33:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26014; /* vcond_mask_rvvmf4hfrvvmf64bi */

    case 34:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26015; /* vcond_mask_rvvm8sfrvvmf4bi */

    case 35:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26016; /* vcond_mask_rvvm4sfrvvmf8bi */

    case 36:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26017; /* vcond_mask_rvvm2sfrvvmf16bi */

    case 37:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26018; /* vcond_mask_rvvm1sfrvvmf32bi */

    case 38:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26019; /* vcond_mask_rvvmf2sfrvvmf64bi */

    case 39:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26020; /* vcond_mask_rvvm8dfrvvmf8bi */

    case 40:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26021; /* vcond_mask_rvvm4dfrvvmf16bi */

    case 41:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26022; /* vcond_mask_rvvm2dfrvvmf32bi */

    case 42:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26023; /* vcond_mask_rvvm1dfrvvmf64bi */

    case 43:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 26024; /* vcond_mask_v1qiv1bi */

    case 44:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 26025; /* vcond_mask_v2qiv2bi */

    case 45:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 26026; /* vcond_mask_v4qiv4bi */

    case 46:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 26027; /* vcond_mask_v8qiv8bi */

    case 47:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 26028; /* vcond_mask_v16qiv16bi */

    case 48:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 26029; /* vcond_mask_v32qiv32bi */

    case 49:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26030; /* vcond_mask_v64qiv64bi */

    case 50:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26031; /* vcond_mask_v128qiv128bi */

    case 51:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26032; /* vcond_mask_v256qiv256bi */

    case 52:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26033; /* vcond_mask_v512qiv512bi */

    case 53:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26034; /* vcond_mask_v1024qiv1024bi */

    case 54:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26035; /* vcond_mask_v2048qiv2048bi */

    case 55:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26036; /* vcond_mask_v4096qiv4096bi */

    case 56:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 26037; /* vcond_mask_v1hiv1bi */

    case 57:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 26038; /* vcond_mask_v2hiv2bi */

    case 58:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 26039; /* vcond_mask_v4hiv4bi */

    case 59:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 26040; /* vcond_mask_v8hiv8bi */

    case 60:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 26041; /* vcond_mask_v16hiv16bi */

    case 61:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26042; /* vcond_mask_v32hiv32bi */

    case 62:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26043; /* vcond_mask_v64hiv64bi */

    case 63:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26044; /* vcond_mask_v128hiv128bi */

    case 64:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26045; /* vcond_mask_v256hiv256bi */

    case 65:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26046; /* vcond_mask_v512hiv512bi */

    case 66:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26047; /* vcond_mask_v1024hiv1024bi */

    case 67:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26048; /* vcond_mask_v2048hiv2048bi */

    case 68:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 26049; /* vcond_mask_v1siv1bi */

    case 69:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 26050; /* vcond_mask_v2siv2bi */

    case 70:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 26051; /* vcond_mask_v4siv4bi */

    case 71:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 26052; /* vcond_mask_v8siv8bi */

    case 72:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26053; /* vcond_mask_v16siv16bi */

    case 73:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26054; /* vcond_mask_v32siv32bi */

    case 74:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26055; /* vcond_mask_v64siv64bi */

    case 75:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26056; /* vcond_mask_v128siv128bi */

    case 76:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26057; /* vcond_mask_v256siv256bi */

    case 77:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26058; /* vcond_mask_v512siv512bi */

    case 78:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26059; /* vcond_mask_v1024siv1024bi */

    case 79:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26060; /* vcond_mask_v1div1bi */

    case 80:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26061; /* vcond_mask_v2div2bi */

    case 81:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26062; /* vcond_mask_v4div4bi */

    case 82:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26063; /* vcond_mask_v8div8bi */

    case 83:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26064; /* vcond_mask_v16div16bi */

    case 84:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26065; /* vcond_mask_v32div32bi */

    case 85:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26066; /* vcond_mask_v64div64bi */

    case 86:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26067; /* vcond_mask_v128div128bi */

    case 87:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26068; /* vcond_mask_v256div256bi */

    case 88:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26069; /* vcond_mask_v512div512bi */

    case 89:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26070; /* vcond_mask_v1hfv1bi */

    case 90:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26071; /* vcond_mask_v2hfv2bi */

    case 91:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26072; /* vcond_mask_v4hfv4bi */

    case 92:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26073; /* vcond_mask_v8hfv8bi */

    case 93:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 26074; /* vcond_mask_v16hfv16bi */

    case 94:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26075; /* vcond_mask_v32hfv32bi */

    case 95:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26076; /* vcond_mask_v64hfv64bi */

    case 96:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26077; /* vcond_mask_v128hfv128bi */

    case 97:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26078; /* vcond_mask_v256hfv256bi */

    case 98:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26079; /* vcond_mask_v512hfv512bi */

    case 99:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26080; /* vcond_mask_v1024hfv1024bi */

    case 100:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26081; /* vcond_mask_v2048hfv2048bi */

    case 101:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26082; /* vcond_mask_v1sfv1bi */

    case 102:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26083; /* vcond_mask_v2sfv2bi */

    case 103:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26084; /* vcond_mask_v4sfv4bi */

    case 104:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26085; /* vcond_mask_v8sfv8bi */

    case 105:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26086; /* vcond_mask_v16sfv16bi */

    case 106:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26087; /* vcond_mask_v32sfv32bi */

    case 107:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26088; /* vcond_mask_v64sfv64bi */

    case 108:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26089; /* vcond_mask_v128sfv128bi */

    case 109:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26090; /* vcond_mask_v256sfv256bi */

    case 110:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26091; /* vcond_mask_v512sfv512bi */

    case 111:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26092; /* vcond_mask_v1024sfv1024bi */

    case 112:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26093; /* vcond_mask_v1dfv1bi */

    case 113:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26094; /* vcond_mask_v2dfv2bi */

    case 114:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26095; /* vcond_mask_v4dfv4bi */

    case 115:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26096; /* vcond_mask_v8dfv8bi */

    case 116:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26097; /* vcond_mask_v16dfv16bi */

    case 117:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26098; /* vcond_mask_v32dfv32bi */

    case 118:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26099; /* vcond_mask_v64dfv64bi */

    case 119:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26100; /* vcond_mask_v128dfv128bi */

    case 120:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26101; /* vcond_mask_v256dfv256bi */

    case 121:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26102; /* vcond_mask_v512dfv512bi */

    case 122:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28328; /* *cond_absrvvm8hf */

    case 123:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28329; /* *cond_absrvvm4hf */

    case 124:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28330; /* *cond_absrvvm2hf */

    case 125:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28331; /* *cond_absrvvm1hf */

    case 126:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28332; /* *cond_absrvvmf2hf */

    case 127:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28333; /* *cond_absrvvmf4hf */

    case 128:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28334; /* *cond_absrvvm8sf */

    case 129:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28335; /* *cond_absrvvm4sf */

    case 130:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28336; /* *cond_absrvvm2sf */

    case 131:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28337; /* *cond_absrvvm1sf */

    case 132:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28338; /* *cond_absrvvmf2sf */

    case 133:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28339; /* *cond_absrvvm8df */

    case 134:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28340; /* *cond_absrvvm4df */

    case 135:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28341; /* *cond_absrvvm2df */

    case 136:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28342; /* *cond_absrvvm1df */

    case 137:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28343; /* *cond_absv1hf */

    case 138:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28344; /* *cond_absv2hf */

    case 139:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28345; /* *cond_absv4hf */

    case 140:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28346; /* *cond_absv8hf */

    case 141:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28347; /* *cond_absv16hf */

    case 142:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28348; /* *cond_absv32hf */

    case 143:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28349; /* *cond_absv64hf */

    case 144:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28350; /* *cond_absv128hf */

    case 145:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28351; /* *cond_absv256hf */

    case 146:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28352; /* *cond_absv512hf */

    case 147:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28353; /* *cond_absv1024hf */

    case 148:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28354; /* *cond_absv2048hf */

    case 149:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28355; /* *cond_absv1sf */

    case 150:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28356; /* *cond_absv2sf */

    case 151:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28357; /* *cond_absv4sf */

    case 152:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28358; /* *cond_absv8sf */

    case 153:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28359; /* *cond_absv16sf */

    case 154:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28360; /* *cond_absv32sf */

    case 155:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28361; /* *cond_absv64sf */

    case 156:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28362; /* *cond_absv128sf */

    case 157:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28363; /* *cond_absv256sf */

    case 158:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28364; /* *cond_absv512sf */

    case 159:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28365; /* *cond_absv1024sf */

    case 160:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28366; /* *cond_absv1df */

    case 161:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28367; /* *cond_absv2df */

    case 162:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28368; /* *cond_absv4df */

    case 163:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28369; /* *cond_absv8df */

    case 164:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28370; /* *cond_absv16df */

    case 165:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28371; /* *cond_absv32df */

    case 166:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28372; /* *cond_absv64df */

    case 167:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28373; /* *cond_absv128df */

    case 168:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28374; /* *cond_absv256df */

    case 169:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28375; /* *cond_absv512df */

    case 170:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28376; /* *cond_sqrtrvvm8hf */

    case 171:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28377; /* *cond_sqrtrvvm4hf */

    case 172:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28378; /* *cond_sqrtrvvm2hf */

    case 173:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28379; /* *cond_sqrtrvvm1hf */

    case 174:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28380; /* *cond_sqrtrvvmf2hf */

    case 175:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28381; /* *cond_sqrtrvvmf4hf */

    case 176:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28382; /* *cond_sqrtrvvm8sf */

    case 177:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28383; /* *cond_sqrtrvvm4sf */

    case 178:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28384; /* *cond_sqrtrvvm2sf */

    case 179:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28385; /* *cond_sqrtrvvm1sf */

    case 180:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28386; /* *cond_sqrtrvvmf2sf */

    case 181:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28387; /* *cond_sqrtrvvm8df */

    case 182:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28388; /* *cond_sqrtrvvm4df */

    case 183:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28389; /* *cond_sqrtrvvm2df */

    case 184:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28390; /* *cond_sqrtrvvm1df */

    case 185:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28391; /* *cond_sqrtv1hf */

    case 186:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28392; /* *cond_sqrtv2hf */

    case 187:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28393; /* *cond_sqrtv4hf */

    case 188:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28394; /* *cond_sqrtv8hf */

    case 189:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28395; /* *cond_sqrtv16hf */

    case 190:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28396; /* *cond_sqrtv32hf */

    case 191:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28397; /* *cond_sqrtv64hf */

    case 192:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28398; /* *cond_sqrtv128hf */

    case 193:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28399; /* *cond_sqrtv256hf */

    case 194:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28400; /* *cond_sqrtv512hf */

    case 195:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28401; /* *cond_sqrtv1024hf */

    case 196:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28402; /* *cond_sqrtv2048hf */

    case 197:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28403; /* *cond_sqrtv1sf */

    case 198:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28404; /* *cond_sqrtv2sf */

    case 199:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28405; /* *cond_sqrtv4sf */

    case 200:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28406; /* *cond_sqrtv8sf */

    case 201:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28407; /* *cond_sqrtv16sf */

    case 202:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28408; /* *cond_sqrtv32sf */

    case 203:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28409; /* *cond_sqrtv64sf */

    case 204:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28410; /* *cond_sqrtv128sf */

    case 205:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28411; /* *cond_sqrtv256sf */

    case 206:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28412; /* *cond_sqrtv512sf */

    case 207:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28413; /* *cond_sqrtv1024sf */

    case 208:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28414; /* *cond_sqrtv1df */

    case 209:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28415; /* *cond_sqrtv2df */

    case 210:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28416; /* *cond_sqrtv4df */

    case 211:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28417; /* *cond_sqrtv8df */

    case 212:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28418; /* *cond_sqrtv16df */

    case 213:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28419; /* *cond_sqrtv32df */

    case 214:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28420; /* *cond_sqrtv64df */

    case 215:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28421; /* *cond_sqrtv128df */

    case 216:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28422; /* *cond_sqrtv256df */

    case 217:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28423; /* *cond_sqrtv512df */

    case 218:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28424; /* *cond_extendrvvm4qirvvm8hi */

    case 219:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28426; /* *cond_extendrvvm2qirvvm4hi */

    case 220:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28428; /* *cond_extendrvvm1qirvvm2hi */

    case 221:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28430; /* *cond_extendrvvmf2qirvvm1hi */

    case 222:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28432; /* *cond_extendrvvmf4qirvvmf2hi */

    case 223:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28434; /* *cond_extendrvvmf8qirvvmf4hi */

    case 224:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28436; /* *cond_extendrvvm4hirvvm8si */

    case 225:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28520; /* *cond_extendrvvm2qirvvm8si */

    case 226:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28438; /* *cond_extendrvvm2hirvvm4si */

    case 227:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28522; /* *cond_extendrvvm1qirvvm4si */

    case 228:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28440; /* *cond_extendrvvm1hirvvm2si */

    case 229:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28524; /* *cond_extendrvvmf2qirvvm2si */

    case 230:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28442; /* *cond_extendrvvmf2hirvvm1si */

    case 231:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28526; /* *cond_extendrvvmf4qirvvm1si */

    case 232:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28444; /* *cond_extendrvvmf4hirvvmf2si */

    case 233:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28528; /* *cond_extendrvvmf8qirvvmf2si */

    case 234:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28446; /* *cond_extendrvvm4sirvvm8di */

    case 235:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28530; /* *cond_extendrvvm2hirvvm8di */

    case 236:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28580; /* *cond_extendrvvm1qirvvm8di */

    case 237:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28448; /* *cond_extendrvvm2sirvvm4di */

    case 238:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28532; /* *cond_extendrvvm1hirvvm4di */

    case 239:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28582; /* *cond_extendrvvmf2qirvvm4di */

    case 240:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28450; /* *cond_extendrvvm1sirvvm2di */

    case 241:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28534; /* *cond_extendrvvmf2hirvvm2di */

    case 242:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28584; /* *cond_extendrvvmf4qirvvm2di */

    case 243:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28452; /* *cond_extendrvvmf2sirvvm1di */

    case 244:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28536; /* *cond_extendrvvmf4hirvvm1di */

    case 245:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28586; /* *cond_extendrvvmf8qirvvm1di */

    case 246:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28454; /* *cond_extendv1qiv1hi */

    case 247:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28456; /* *cond_extendv2qiv2hi */

    case 248:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28458; /* *cond_extendv4qiv4hi */

    case 249:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28460; /* *cond_extendv8qiv8hi */

    case 250:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28462; /* *cond_extendv16qiv16hi */

    case 251:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28464; /* *cond_extendv32qiv32hi */

    case 252:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28466; /* *cond_extendv64qiv64hi */

    case 253:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28468; /* *cond_extendv128qiv128hi */

    case 254:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28470; /* *cond_extendv256qiv256hi */

    case 255:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28472; /* *cond_extendv512qiv512hi */

    case 256:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28474; /* *cond_extendv1024qiv1024hi */

    case 257:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28476; /* *cond_extendv2048qiv2048hi */

    case 258:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28478; /* *cond_extendv1hiv1si */

    case 259:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28538; /* *cond_extendv1qiv1si */

    case 260:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28480; /* *cond_extendv2hiv2si */

    case 261:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28540; /* *cond_extendv2qiv2si */

    case 262:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28482; /* *cond_extendv4hiv4si */

    case 263:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28542; /* *cond_extendv4qiv4si */

    case 264:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28484; /* *cond_extendv8hiv8si */

    case 265:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28544; /* *cond_extendv8qiv8si */

    case 266:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28486; /* *cond_extendv16hiv16si */

    case 267:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28546; /* *cond_extendv16qiv16si */

    case 268:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28488; /* *cond_extendv32hiv32si */

    case 269:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28548; /* *cond_extendv32qiv32si */

    case 270:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28490; /* *cond_extendv64hiv64si */

    case 271:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28550; /* *cond_extendv64qiv64si */

    case 272:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28492; /* *cond_extendv128hiv128si */

    case 273:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28552; /* *cond_extendv128qiv128si */

    case 274:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28494; /* *cond_extendv256hiv256si */

    case 275:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28554; /* *cond_extendv256qiv256si */

    case 276:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28496; /* *cond_extendv512hiv512si */

    case 277:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28556; /* *cond_extendv512qiv512si */

    case 278:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28498; /* *cond_extendv1024hiv1024si */

    case 279:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28558; /* *cond_extendv1024qiv1024si */

    case 280:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28500; /* *cond_extendv1siv1di */

    case 281:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28560; /* *cond_extendv1hiv1di */

    case 282:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28588; /* *cond_extendv1qiv1di */

    case 283:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28502; /* *cond_extendv2siv2di */

    case 284:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28562; /* *cond_extendv2hiv2di */

    case 285:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28590; /* *cond_extendv2qiv2di */

    case 286:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28504; /* *cond_extendv4siv4di */

    case 287:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28564; /* *cond_extendv4hiv4di */

    case 288:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28592; /* *cond_extendv4qiv4di */

    case 289:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28506; /* *cond_extendv8siv8di */

    case 290:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28566; /* *cond_extendv8hiv8di */

    case 291:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28594; /* *cond_extendv8qiv8di */

    case 292:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28508; /* *cond_extendv16siv16di */

    case 293:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28568; /* *cond_extendv16hiv16di */

    case 294:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28596; /* *cond_extendv16qiv16di */

    case 295:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28510; /* *cond_extendv32siv32di */

    case 296:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28570; /* *cond_extendv32hiv32di */

    case 297:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28598; /* *cond_extendv32qiv32di */

    case 298:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28512; /* *cond_extendv64siv64di */

    case 299:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28572; /* *cond_extendv64hiv64di */

    case 300:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28600; /* *cond_extendv64qiv64di */

    case 301:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28514; /* *cond_extendv128siv128di */

    case 302:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28574; /* *cond_extendv128hiv128di */

    case 303:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28602; /* *cond_extendv128qiv128di */

    case 304:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28516; /* *cond_extendv256siv256di */

    case 305:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28576; /* *cond_extendv256hiv256di */

    case 306:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28604; /* *cond_extendv256qiv256di */

    case 307:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28518; /* *cond_extendv512siv512di */

    case 308:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28578; /* *cond_extendv512hiv512di */

    case 309:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28606; /* *cond_extendv512qiv512di */

    case 310:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28425; /* *cond_zero_extendrvvm4qirvvm8hi */

    case 311:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28427; /* *cond_zero_extendrvvm2qirvvm4hi */

    case 312:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28429; /* *cond_zero_extendrvvm1qirvvm2hi */

    case 313:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28431; /* *cond_zero_extendrvvmf2qirvvm1hi */

    case 314:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28433; /* *cond_zero_extendrvvmf4qirvvmf2hi */

    case 315:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28435; /* *cond_zero_extendrvvmf8qirvvmf4hi */

    case 316:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28437; /* *cond_zero_extendrvvm4hirvvm8si */

    case 317:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28521; /* *cond_zero_extendrvvm2qirvvm8si */

    case 318:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28439; /* *cond_zero_extendrvvm2hirvvm4si */

    case 319:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28523; /* *cond_zero_extendrvvm1qirvvm4si */

    case 320:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28441; /* *cond_zero_extendrvvm1hirvvm2si */

    case 321:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28525; /* *cond_zero_extendrvvmf2qirvvm2si */

    case 322:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28443; /* *cond_zero_extendrvvmf2hirvvm1si */

    case 323:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28527; /* *cond_zero_extendrvvmf4qirvvm1si */

    case 324:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28445; /* *cond_zero_extendrvvmf4hirvvmf2si */

    case 325:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28529; /* *cond_zero_extendrvvmf8qirvvmf2si */

    case 326:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28447; /* *cond_zero_extendrvvm4sirvvm8di */

    case 327:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28531; /* *cond_zero_extendrvvm2hirvvm8di */

    case 328:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28581; /* *cond_zero_extendrvvm1qirvvm8di */

    case 329:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28449; /* *cond_zero_extendrvvm2sirvvm4di */

    case 330:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28533; /* *cond_zero_extendrvvm1hirvvm4di */

    case 331:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28583; /* *cond_zero_extendrvvmf2qirvvm4di */

    case 332:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28451; /* *cond_zero_extendrvvm1sirvvm2di */

    case 333:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28535; /* *cond_zero_extendrvvmf2hirvvm2di */

    case 334:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28585; /* *cond_zero_extendrvvmf4qirvvm2di */

    case 335:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28453; /* *cond_zero_extendrvvmf2sirvvm1di */

    case 336:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28537; /* *cond_zero_extendrvvmf4hirvvm1di */

    case 337:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28587; /* *cond_zero_extendrvvmf8qirvvm1di */

    case 338:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28455; /* *cond_zero_extendv1qiv1hi */

    case 339:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28457; /* *cond_zero_extendv2qiv2hi */

    case 340:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28459; /* *cond_zero_extendv4qiv4hi */

    case 341:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28461; /* *cond_zero_extendv8qiv8hi */

    case 342:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28463; /* *cond_zero_extendv16qiv16hi */

    case 343:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28465; /* *cond_zero_extendv32qiv32hi */

    case 344:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28467; /* *cond_zero_extendv64qiv64hi */

    case 345:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28469; /* *cond_zero_extendv128qiv128hi */

    case 346:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28471; /* *cond_zero_extendv256qiv256hi */

    case 347:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28473; /* *cond_zero_extendv512qiv512hi */

    case 348:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28475; /* *cond_zero_extendv1024qiv1024hi */

    case 349:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28477; /* *cond_zero_extendv2048qiv2048hi */

    case 350:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28479; /* *cond_zero_extendv1hiv1si */

    case 351:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28539; /* *cond_zero_extendv1qiv1si */

    case 352:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28481; /* *cond_zero_extendv2hiv2si */

    case 353:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28541; /* *cond_zero_extendv2qiv2si */

    case 354:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28483; /* *cond_zero_extendv4hiv4si */

    case 355:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28543; /* *cond_zero_extendv4qiv4si */

    case 356:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28485; /* *cond_zero_extendv8hiv8si */

    case 357:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28545; /* *cond_zero_extendv8qiv8si */

    case 358:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28487; /* *cond_zero_extendv16hiv16si */

    case 359:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28547; /* *cond_zero_extendv16qiv16si */

    case 360:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28489; /* *cond_zero_extendv32hiv32si */

    case 361:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28549; /* *cond_zero_extendv32qiv32si */

    case 362:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28491; /* *cond_zero_extendv64hiv64si */

    case 363:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28551; /* *cond_zero_extendv64qiv64si */

    case 364:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28493; /* *cond_zero_extendv128hiv128si */

    case 365:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28553; /* *cond_zero_extendv128qiv128si */

    case 366:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28495; /* *cond_zero_extendv256hiv256si */

    case 367:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28555; /* *cond_zero_extendv256qiv256si */

    case 368:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28497; /* *cond_zero_extendv512hiv512si */

    case 369:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28557; /* *cond_zero_extendv512qiv512si */

    case 370:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28499; /* *cond_zero_extendv1024hiv1024si */

    case 371:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28559; /* *cond_zero_extendv1024qiv1024si */

    case 372:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28501; /* *cond_zero_extendv1siv1di */

    case 373:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28561; /* *cond_zero_extendv1hiv1di */

    case 374:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28589; /* *cond_zero_extendv1qiv1di */

    case 375:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28503; /* *cond_zero_extendv2siv2di */

    case 376:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28563; /* *cond_zero_extendv2hiv2di */

    case 377:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28591; /* *cond_zero_extendv2qiv2di */

    case 378:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28505; /* *cond_zero_extendv4siv4di */

    case 379:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28565; /* *cond_zero_extendv4hiv4di */

    case 380:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28593; /* *cond_zero_extendv4qiv4di */

    case 381:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28507; /* *cond_zero_extendv8siv8di */

    case 382:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28567; /* *cond_zero_extendv8hiv8di */

    case 383:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28595; /* *cond_zero_extendv8qiv8di */

    case 384:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28509; /* *cond_zero_extendv16siv16di */

    case 385:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28569; /* *cond_zero_extendv16hiv16di */

    case 386:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28597; /* *cond_zero_extendv16qiv16di */

    case 387:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28511; /* *cond_zero_extendv32siv32di */

    case 388:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28571; /* *cond_zero_extendv32hiv32di */

    case 389:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28599; /* *cond_zero_extendv32qiv32di */

    case 390:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28513; /* *cond_zero_extendv64siv64di */

    case 391:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28573; /* *cond_zero_extendv64hiv64di */

    case 392:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28601; /* *cond_zero_extendv64qiv64di */

    case 393:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28515; /* *cond_zero_extendv128siv128di */

    case 394:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28575; /* *cond_zero_extendv128hiv128di */

    case 395:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28603; /* *cond_zero_extendv128qiv128di */

    case 396:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28517; /* *cond_zero_extendv256siv256di */

    case 397:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28577; /* *cond_zero_extendv256hiv256di */

    case 398:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28605; /* *cond_zero_extendv256qiv256di */

    case 399:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28519; /* *cond_zero_extendv512siv512di */

    case 400:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28579; /* *cond_zero_extendv512hiv512di */

    case 401:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28607; /* *cond_zero_extendv512qiv512di */

    case 402:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28792; /* *cond_truncrvvm8hirvvm4qi */

    case 403:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28793; /* *cond_truncrvvm4hirvvm2qi */

    case 404:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28794; /* *cond_truncrvvm2hirvvm1qi */

    case 405:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28795; /* *cond_truncrvvm1hirvvmf2qi */

    case 406:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28796; /* *cond_truncrvvmf2hirvvmf4qi */

    case 407:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28797; /* *cond_truncrvvmf4hirvvmf8qi */

    case 408:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28798; /* *cond_truncrvvm8sirvvm4hi */

    case 409:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28799; /* *cond_truncrvvm4sirvvm2hi */

    case 410:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28800; /* *cond_truncrvvm2sirvvm1hi */

    case 411:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28801; /* *cond_truncrvvm1sirvvmf2hi */

    case 412:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28802; /* *cond_truncrvvmf2sirvvmf4hi */

    case 413:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28803; /* *cond_truncrvvm8dirvvm4si */

    case 414:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28804; /* *cond_truncrvvm4dirvvm2si */

    case 415:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28805; /* *cond_truncrvvm2dirvvm1si */

    case 416:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28806; /* *cond_truncrvvm1dirvvmf2si */

    case 417:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28807; /* *cond_truncv1hiv1qi */

    case 418:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28808; /* *cond_truncv2hiv2qi */

    case 419:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28809; /* *cond_truncv4hiv4qi */

    case 420:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28810; /* *cond_truncv8hiv8qi */

    case 421:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28811; /* *cond_truncv16hiv16qi */

    case 422:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28812; /* *cond_truncv32hiv32qi */

    case 423:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28813; /* *cond_truncv64hiv64qi */

    case 424:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28814; /* *cond_truncv128hiv128qi */

    case 425:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28815; /* *cond_truncv256hiv256qi */

    case 426:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28816; /* *cond_truncv512hiv512qi */

    case 427:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28817; /* *cond_truncv1024hiv1024qi */

    case 428:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28818; /* *cond_truncv2048hiv2048qi */

    case 429:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28819; /* *cond_truncv1siv1hi */

    case 430:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28820; /* *cond_truncv2siv2hi */

    case 431:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28821; /* *cond_truncv4siv4hi */

    case 432:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28822; /* *cond_truncv8siv8hi */

    case 433:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28823; /* *cond_truncv16siv16hi */

    case 434:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28824; /* *cond_truncv32siv32hi */

    case 435:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28825; /* *cond_truncv64siv64hi */

    case 436:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28826; /* *cond_truncv128siv128hi */

    case 437:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28827; /* *cond_truncv256siv256hi */

    case 438:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28828; /* *cond_truncv512siv512hi */

    case 439:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28829; /* *cond_truncv1024siv1024hi */

    case 440:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28830; /* *cond_truncv1div1si */

    case 441:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28831; /* *cond_truncv2div2si */

    case 442:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28832; /* *cond_truncv4div4si */

    case 443:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28833; /* *cond_truncv8div8si */

    case 444:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28834; /* *cond_truncv16div16si */

    case 445:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28835; /* *cond_truncv32div32si */

    case 446:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28836; /* *cond_truncv64div64si */

    case 447:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28837; /* *cond_truncv128div128si */

    case 448:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28838; /* *cond_truncv256div256si */

    case 449:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28839; /* *cond_truncv512div512si */

    case 450:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29434; /* *cond_vashrextendtruncrvvm8hi */

    case 451:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29438; /* *cond_vashrextendtruncrvvm4hi */

    case 452:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29442; /* *cond_vashrextendtruncrvvm2hi */

    case 453:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29446; /* *cond_vashrextendtruncrvvm1hi */

    case 454:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29450; /* *cond_vashrextendtruncrvvmf2hi */

    case 455:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29454; /* *cond_vashrextendtruncrvvmf4hi */

    case 456:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29458; /* *cond_vashrextendtruncrvvm8si */

    case 457:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29462; /* *cond_vashrextendtruncrvvm4si */

    case 458:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29466; /* *cond_vashrextendtruncrvvm2si */

    case 459:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29470; /* *cond_vashrextendtruncrvvm1si */

    case 460:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29474; /* *cond_vashrextendtruncrvvmf2si */

    case 461:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29478; /* *cond_vashrextendtruncrvvm8di */

    case 462:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29482; /* *cond_vashrextendtruncrvvm4di */

    case 463:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29486; /* *cond_vashrextendtruncrvvm2di */

    case 464:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29490; /* *cond_vashrextendtruncrvvm1di */

    case 465:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29494; /* *cond_vashrextendtruncv1hi */

    case 466:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29498; /* *cond_vashrextendtruncv2hi */

    case 467:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29502; /* *cond_vashrextendtruncv4hi */

    case 468:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29506; /* *cond_vashrextendtruncv8hi */

    case 469:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29510; /* *cond_vashrextendtruncv16hi */

    case 470:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29514; /* *cond_vashrextendtruncv32hi */

    case 471:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29518; /* *cond_vashrextendtruncv64hi */

    case 472:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29522; /* *cond_vashrextendtruncv128hi */

    case 473:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29526; /* *cond_vashrextendtruncv256hi */

    case 474:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29530; /* *cond_vashrextendtruncv512hi */

    case 475:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29534; /* *cond_vashrextendtruncv1024hi */

    case 476:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29538; /* *cond_vashrextendtruncv2048hi */

    case 477:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29542; /* *cond_vashrextendtruncv1si */

    case 478:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29546; /* *cond_vashrextendtruncv2si */

    case 479:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29550; /* *cond_vashrextendtruncv4si */

    case 480:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29554; /* *cond_vashrextendtruncv8si */

    case 481:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29558; /* *cond_vashrextendtruncv16si */

    case 482:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29562; /* *cond_vashrextendtruncv32si */

    case 483:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29566; /* *cond_vashrextendtruncv64si */

    case 484:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29570; /* *cond_vashrextendtruncv128si */

    case 485:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29574; /* *cond_vashrextendtruncv256si */

    case 486:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29578; /* *cond_vashrextendtruncv512si */

    case 487:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29582; /* *cond_vashrextendtruncv1024si */

    case 488:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29586; /* *cond_vashrextendtruncv1di */

    case 489:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29590; /* *cond_vashrextendtruncv2di */

    case 490:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29594; /* *cond_vashrextendtruncv4di */

    case 491:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29598; /* *cond_vashrextendtruncv8di */

    case 492:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29602; /* *cond_vashrextendtruncv16di */

    case 493:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29606; /* *cond_vashrextendtruncv32di */

    case 494:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29610; /* *cond_vashrextendtruncv64di */

    case 495:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29614; /* *cond_vashrextendtruncv128di */

    case 496:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29618; /* *cond_vashrextendtruncv256di */

    case 497:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29622; /* *cond_vashrextendtruncv512di */

    case 498:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29436; /* *cond_vashrzero_extendtruncrvvm8hi */

    case 499:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29440; /* *cond_vashrzero_extendtruncrvvm4hi */

    case 500:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29444; /* *cond_vashrzero_extendtruncrvvm2hi */

    case 501:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29448; /* *cond_vashrzero_extendtruncrvvm1hi */

    case 502:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29452; /* *cond_vashrzero_extendtruncrvvmf2hi */

    case 503:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29456; /* *cond_vashrzero_extendtruncrvvmf4hi */

    case 504:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29460; /* *cond_vashrzero_extendtruncrvvm8si */

    case 505:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29464; /* *cond_vashrzero_extendtruncrvvm4si */

    case 506:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29468; /* *cond_vashrzero_extendtruncrvvm2si */

    case 507:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29472; /* *cond_vashrzero_extendtruncrvvm1si */

    case 508:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29476; /* *cond_vashrzero_extendtruncrvvmf2si */

    case 509:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29480; /* *cond_vashrzero_extendtruncrvvm8di */

    case 510:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29484; /* *cond_vashrzero_extendtruncrvvm4di */

    case 511:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29488; /* *cond_vashrzero_extendtruncrvvm2di */

    case 512:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29492; /* *cond_vashrzero_extendtruncrvvm1di */

    case 513:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29496; /* *cond_vashrzero_extendtruncv1hi */

    case 514:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29500; /* *cond_vashrzero_extendtruncv2hi */

    case 515:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29504; /* *cond_vashrzero_extendtruncv4hi */

    case 516:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29508; /* *cond_vashrzero_extendtruncv8hi */

    case 517:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29512; /* *cond_vashrzero_extendtruncv16hi */

    case 518:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29516; /* *cond_vashrzero_extendtruncv32hi */

    case 519:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29520; /* *cond_vashrzero_extendtruncv64hi */

    case 520:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29524; /* *cond_vashrzero_extendtruncv128hi */

    case 521:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29528; /* *cond_vashrzero_extendtruncv256hi */

    case 522:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29532; /* *cond_vashrzero_extendtruncv512hi */

    case 523:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29536; /* *cond_vashrzero_extendtruncv1024hi */

    case 524:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29540; /* *cond_vashrzero_extendtruncv2048hi */

    case 525:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29544; /* *cond_vashrzero_extendtruncv1si */

    case 526:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29548; /* *cond_vashrzero_extendtruncv2si */

    case 527:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29552; /* *cond_vashrzero_extendtruncv4si */

    case 528:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29556; /* *cond_vashrzero_extendtruncv8si */

    case 529:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29560; /* *cond_vashrzero_extendtruncv16si */

    case 530:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29564; /* *cond_vashrzero_extendtruncv32si */

    case 531:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29568; /* *cond_vashrzero_extendtruncv64si */

    case 532:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29572; /* *cond_vashrzero_extendtruncv128si */

    case 533:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29576; /* *cond_vashrzero_extendtruncv256si */

    case 534:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29580; /* *cond_vashrzero_extendtruncv512si */

    case 535:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29584; /* *cond_vashrzero_extendtruncv1024si */

    case 536:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29588; /* *cond_vashrzero_extendtruncv1di */

    case 537:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29592; /* *cond_vashrzero_extendtruncv2di */

    case 538:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29596; /* *cond_vashrzero_extendtruncv4di */

    case 539:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29600; /* *cond_vashrzero_extendtruncv8di */

    case 540:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29604; /* *cond_vashrzero_extendtruncv16di */

    case 541:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29608; /* *cond_vashrzero_extendtruncv32di */

    case 542:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29612; /* *cond_vashrzero_extendtruncv64di */

    case 543:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29616; /* *cond_vashrzero_extendtruncv128di */

    case 544:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29620; /* *cond_vashrzero_extendtruncv256di */

    case 545:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29624; /* *cond_vashrzero_extendtruncv512di */

    case 546:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29626; /* *cond_ashrtruncrvvm8hi */

    case 547:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29628; /* *cond_ashrtruncrvvm4hi */

    case 548:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29630; /* *cond_ashrtruncrvvm2hi */

    case 549:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29632; /* *cond_ashrtruncrvvm1hi */

    case 550:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29634; /* *cond_ashrtruncrvvmf2hi */

    case 551:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29636; /* *cond_ashrtruncrvvmf4hi */

    case 552:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29638; /* *cond_ashrtruncrvvm8si */

    case 553:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29640; /* *cond_ashrtruncrvvm4si */

    case 554:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29642; /* *cond_ashrtruncrvvm2si */

    case 555:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29644; /* *cond_ashrtruncrvvm1si */

    case 556:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29646; /* *cond_ashrtruncrvvmf2si */

    case 557:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29648; /* *cond_ashrtruncrvvm8di */

    case 558:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29650; /* *cond_ashrtruncrvvm4di */

    case 559:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29652; /* *cond_ashrtruncrvvm2di */

    case 560:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29654; /* *cond_ashrtruncrvvm1di */

    case 561:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29656; /* *cond_ashrtruncv1hi */

    case 562:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29658; /* *cond_ashrtruncv2hi */

    case 563:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29660; /* *cond_ashrtruncv4hi */

    case 564:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29662; /* *cond_ashrtruncv8hi */

    case 565:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29664; /* *cond_ashrtruncv16hi */

    case 566:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29666; /* *cond_ashrtruncv32hi */

    case 567:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29668; /* *cond_ashrtruncv64hi */

    case 568:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29670; /* *cond_ashrtruncv128hi */

    case 569:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29672; /* *cond_ashrtruncv256hi */

    case 570:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29674; /* *cond_ashrtruncv512hi */

    case 571:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29676; /* *cond_ashrtruncv1024hi */

    case 572:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29678; /* *cond_ashrtruncv2048hi */

    case 573:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29680; /* *cond_ashrtruncv1si */

    case 574:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29682; /* *cond_ashrtruncv2si */

    case 575:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29684; /* *cond_ashrtruncv4si */

    case 576:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29686; /* *cond_ashrtruncv8si */

    case 577:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29688; /* *cond_ashrtruncv16si */

    case 578:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29690; /* *cond_ashrtruncv32si */

    case 579:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29692; /* *cond_ashrtruncv64si */

    case 580:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29694; /* *cond_ashrtruncv128si */

    case 581:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29696; /* *cond_ashrtruncv256si */

    case 582:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29698; /* *cond_ashrtruncv512si */

    case 583:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29700; /* *cond_ashrtruncv1024si */

    case 584:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29702; /* *cond_ashrtruncv1di */

    case 585:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29704; /* *cond_ashrtruncv2di */

    case 586:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29706; /* *cond_ashrtruncv4di */

    case 587:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29708; /* *cond_ashrtruncv8di */

    case 588:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29710; /* *cond_ashrtruncv16di */

    case 589:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29712; /* *cond_ashrtruncv32di */

    case 590:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29714; /* *cond_ashrtruncv64di */

    case 591:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29716; /* *cond_ashrtruncv128di */

    case 592:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29718; /* *cond_ashrtruncv256di */

    case 593:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29720; /* *cond_ashrtruncv512di */

    case 594:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29435; /* *cond_vlshrextendtruncrvvm8hi */

    case 595:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29439; /* *cond_vlshrextendtruncrvvm4hi */

    case 596:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29443; /* *cond_vlshrextendtruncrvvm2hi */

    case 597:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29447; /* *cond_vlshrextendtruncrvvm1hi */

    case 598:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29451; /* *cond_vlshrextendtruncrvvmf2hi */

    case 599:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29455; /* *cond_vlshrextendtruncrvvmf4hi */

    case 600:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29459; /* *cond_vlshrextendtruncrvvm8si */

    case 601:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29463; /* *cond_vlshrextendtruncrvvm4si */

    case 602:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29467; /* *cond_vlshrextendtruncrvvm2si */

    case 603:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29471; /* *cond_vlshrextendtruncrvvm1si */

    case 604:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29475; /* *cond_vlshrextendtruncrvvmf2si */

    case 605:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29479; /* *cond_vlshrextendtruncrvvm8di */

    case 606:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29483; /* *cond_vlshrextendtruncrvvm4di */

    case 607:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29487; /* *cond_vlshrextendtruncrvvm2di */

    case 608:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29491; /* *cond_vlshrextendtruncrvvm1di */

    case 609:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29495; /* *cond_vlshrextendtruncv1hi */

    case 610:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29499; /* *cond_vlshrextendtruncv2hi */

    case 611:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29503; /* *cond_vlshrextendtruncv4hi */

    case 612:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29507; /* *cond_vlshrextendtruncv8hi */

    case 613:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29511; /* *cond_vlshrextendtruncv16hi */

    case 614:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29515; /* *cond_vlshrextendtruncv32hi */

    case 615:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29519; /* *cond_vlshrextendtruncv64hi */

    case 616:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29523; /* *cond_vlshrextendtruncv128hi */

    case 617:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29527; /* *cond_vlshrextendtruncv256hi */

    case 618:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29531; /* *cond_vlshrextendtruncv512hi */

    case 619:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29535; /* *cond_vlshrextendtruncv1024hi */

    case 620:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29539; /* *cond_vlshrextendtruncv2048hi */

    case 621:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29543; /* *cond_vlshrextendtruncv1si */

    case 622:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29547; /* *cond_vlshrextendtruncv2si */

    case 623:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29551; /* *cond_vlshrextendtruncv4si */

    case 624:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29555; /* *cond_vlshrextendtruncv8si */

    case 625:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29559; /* *cond_vlshrextendtruncv16si */

    case 626:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29563; /* *cond_vlshrextendtruncv32si */

    case 627:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29567; /* *cond_vlshrextendtruncv64si */

    case 628:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29571; /* *cond_vlshrextendtruncv128si */

    case 629:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29575; /* *cond_vlshrextendtruncv256si */

    case 630:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29579; /* *cond_vlshrextendtruncv512si */

    case 631:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29583; /* *cond_vlshrextendtruncv1024si */

    case 632:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29587; /* *cond_vlshrextendtruncv1di */

    case 633:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29591; /* *cond_vlshrextendtruncv2di */

    case 634:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29595; /* *cond_vlshrextendtruncv4di */

    case 635:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29599; /* *cond_vlshrextendtruncv8di */

    case 636:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29603; /* *cond_vlshrextendtruncv16di */

    case 637:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29607; /* *cond_vlshrextendtruncv32di */

    case 638:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29611; /* *cond_vlshrextendtruncv64di */

    case 639:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29615; /* *cond_vlshrextendtruncv128di */

    case 640:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29619; /* *cond_vlshrextendtruncv256di */

    case 641:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29623; /* *cond_vlshrextendtruncv512di */

    case 642:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29437; /* *cond_vlshrzero_extendtruncrvvm8hi */

    case 643:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29441; /* *cond_vlshrzero_extendtruncrvvm4hi */

    case 644:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29445; /* *cond_vlshrzero_extendtruncrvvm2hi */

    case 645:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29449; /* *cond_vlshrzero_extendtruncrvvm1hi */

    case 646:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29453; /* *cond_vlshrzero_extendtruncrvvmf2hi */

    case 647:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29457; /* *cond_vlshrzero_extendtruncrvvmf4hi */

    case 648:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29461; /* *cond_vlshrzero_extendtruncrvvm8si */

    case 649:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29465; /* *cond_vlshrzero_extendtruncrvvm4si */

    case 650:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29469; /* *cond_vlshrzero_extendtruncrvvm2si */

    case 651:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29473; /* *cond_vlshrzero_extendtruncrvvm1si */

    case 652:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29477; /* *cond_vlshrzero_extendtruncrvvmf2si */

    case 653:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29481; /* *cond_vlshrzero_extendtruncrvvm8di */

    case 654:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29485; /* *cond_vlshrzero_extendtruncrvvm4di */

    case 655:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29489; /* *cond_vlshrzero_extendtruncrvvm2di */

    case 656:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29493; /* *cond_vlshrzero_extendtruncrvvm1di */

    case 657:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29497; /* *cond_vlshrzero_extendtruncv1hi */

    case 658:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29501; /* *cond_vlshrzero_extendtruncv2hi */

    case 659:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29505; /* *cond_vlshrzero_extendtruncv4hi */

    case 660:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29509; /* *cond_vlshrzero_extendtruncv8hi */

    case 661:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29513; /* *cond_vlshrzero_extendtruncv16hi */

    case 662:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29517; /* *cond_vlshrzero_extendtruncv32hi */

    case 663:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29521; /* *cond_vlshrzero_extendtruncv64hi */

    case 664:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29525; /* *cond_vlshrzero_extendtruncv128hi */

    case 665:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29529; /* *cond_vlshrzero_extendtruncv256hi */

    case 666:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29533; /* *cond_vlshrzero_extendtruncv512hi */

    case 667:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29537; /* *cond_vlshrzero_extendtruncv1024hi */

    case 668:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29541; /* *cond_vlshrzero_extendtruncv2048hi */

    case 669:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29545; /* *cond_vlshrzero_extendtruncv1si */

    case 670:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29549; /* *cond_vlshrzero_extendtruncv2si */

    case 671:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29553; /* *cond_vlshrzero_extendtruncv4si */

    case 672:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29557; /* *cond_vlshrzero_extendtruncv8si */

    case 673:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29561; /* *cond_vlshrzero_extendtruncv16si */

    case 674:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29565; /* *cond_vlshrzero_extendtruncv32si */

    case 675:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29569; /* *cond_vlshrzero_extendtruncv64si */

    case 676:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29573; /* *cond_vlshrzero_extendtruncv128si */

    case 677:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29577; /* *cond_vlshrzero_extendtruncv256si */

    case 678:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29581; /* *cond_vlshrzero_extendtruncv512si */

    case 679:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29585; /* *cond_vlshrzero_extendtruncv1024si */

    case 680:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29589; /* *cond_vlshrzero_extendtruncv1di */

    case 681:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29593; /* *cond_vlshrzero_extendtruncv2di */

    case 682:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29597; /* *cond_vlshrzero_extendtruncv4di */

    case 683:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29601; /* *cond_vlshrzero_extendtruncv8di */

    case 684:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29605; /* *cond_vlshrzero_extendtruncv16di */

    case 685:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29609; /* *cond_vlshrzero_extendtruncv32di */

    case 686:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29613; /* *cond_vlshrzero_extendtruncv64di */

    case 687:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29617; /* *cond_vlshrzero_extendtruncv128di */

    case 688:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29621; /* *cond_vlshrzero_extendtruncv256di */

    case 689:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29625; /* *cond_vlshrzero_extendtruncv512di */

    case 690:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29627; /* *cond_lshrtruncrvvm8hi */

    case 691:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29629; /* *cond_lshrtruncrvvm4hi */

    case 692:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29631; /* *cond_lshrtruncrvvm2hi */

    case 693:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29633; /* *cond_lshrtruncrvvm1hi */

    case 694:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29635; /* *cond_lshrtruncrvvmf2hi */

    case 695:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29637; /* *cond_lshrtruncrvvmf4hi */

    case 696:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29639; /* *cond_lshrtruncrvvm8si */

    case 697:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29641; /* *cond_lshrtruncrvvm4si */

    case 698:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29643; /* *cond_lshrtruncrvvm2si */

    case 699:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29645; /* *cond_lshrtruncrvvm1si */

    case 700:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29647; /* *cond_lshrtruncrvvmf2si */

    case 701:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29649; /* *cond_lshrtruncrvvm8di */

    case 702:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29651; /* *cond_lshrtruncrvvm4di */

    case 703:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29653; /* *cond_lshrtruncrvvm2di */

    case 704:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29655; /* *cond_lshrtruncrvvm1di */

    case 705:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29657; /* *cond_lshrtruncv1hi */

    case 706:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29659; /* *cond_lshrtruncv2hi */

    case 707:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29661; /* *cond_lshrtruncv4hi */

    case 708:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29663; /* *cond_lshrtruncv8hi */

    case 709:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29665; /* *cond_lshrtruncv16hi */

    case 710:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29667; /* *cond_lshrtruncv32hi */

    case 711:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29669; /* *cond_lshrtruncv64hi */

    case 712:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29671; /* *cond_lshrtruncv128hi */

    case 713:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29673; /* *cond_lshrtruncv256hi */

    case 714:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29675; /* *cond_lshrtruncv512hi */

    case 715:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29677; /* *cond_lshrtruncv1024hi */

    case 716:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29679; /* *cond_lshrtruncv2048hi */

    case 717:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29681; /* *cond_lshrtruncv1si */

    case 718:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29683; /* *cond_lshrtruncv2si */

    case 719:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29685; /* *cond_lshrtruncv4si */

    case 720:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29687; /* *cond_lshrtruncv8si */

    case 721:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29689; /* *cond_lshrtruncv16si */

    case 722:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29691; /* *cond_lshrtruncv32si */

    case 723:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29693; /* *cond_lshrtruncv64si */

    case 724:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29695; /* *cond_lshrtruncv128si */

    case 725:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29697; /* *cond_lshrtruncv256si */

    case 726:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29699; /* *cond_lshrtruncv512si */

    case 727:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29701; /* *cond_lshrtruncv1024si */

    case 728:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29703; /* *cond_lshrtruncv1di */

    case 729:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29705; /* *cond_lshrtruncv2di */

    case 730:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29707; /* *cond_lshrtruncv4di */

    case 731:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29709; /* *cond_lshrtruncv8di */

    case 732:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29711; /* *cond_lshrtruncv16di */

    case 733:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29713; /* *cond_lshrtruncv32di */

    case 734:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29715; /* *cond_lshrtruncv64di */

    case 735:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29717; /* *cond_lshrtruncv128di */

    case 736:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29719; /* *cond_lshrtruncv256di */

    case 737:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29721; /* *cond_lshrtruncv512di */

    case 738:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28840; /* *cond_extendrvvm4hfrvvm8sf */

    case 739:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28841; /* *cond_extendrvvm2hfrvvm4sf */

    case 740:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28842; /* *cond_extendrvvm1hfrvvm2sf */

    case 741:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28843; /* *cond_extendrvvmf2hfrvvm1sf */

    case 742:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28844; /* *cond_extendrvvmf4hfrvvmf2sf */

    case 743:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28845; /* *cond_extendrvvm4sfrvvm8df */

    case 744:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28846; /* *cond_extendrvvm2sfrvvm4df */

    case 745:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28847; /* *cond_extendrvvm1sfrvvm2df */

    case 746:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28848; /* *cond_extendrvvmf2sfrvvm1df */

    case 747:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28849; /* *cond_extendv1hfv1sf */

    case 748:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28850; /* *cond_extendv2hfv2sf */

    case 749:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28851; /* *cond_extendv4hfv4sf */

    case 750:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28852; /* *cond_extendv8hfv8sf */

    case 751:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28853; /* *cond_extendv16hfv16sf */

    case 752:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28854; /* *cond_extendv32hfv32sf */

    case 753:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28855; /* *cond_extendv64hfv64sf */

    case 754:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28856; /* *cond_extendv128hfv128sf */

    case 755:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28857; /* *cond_extendv256hfv256sf */

    case 756:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28858; /* *cond_extendv512hfv512sf */

    case 757:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28859; /* *cond_extendv1024hfv1024sf */

    case 758:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28860; /* *cond_extendv1sfv1df */

    case 759:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28861; /* *cond_extendv2sfv2df */

    case 760:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28862; /* *cond_extendv4sfv4df */

    case 761:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28863; /* *cond_extendv8sfv8df */

    case 762:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28864; /* *cond_extendv16sfv16df */

    case 763:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28865; /* *cond_extendv32sfv32df */

    case 764:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28866; /* *cond_extendv64sfv64df */

    case 765:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28867; /* *cond_extendv128sfv128df */

    case 766:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28868; /* *cond_extendv256sfv256df */

    case 767:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28869; /* *cond_extendv512sfv512df */

    case 768:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28900; /* *cond_truncrvvm8sfrvvm4hf */

    case 769:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28901; /* *cond_truncrvvm4sfrvvm2hf */

    case 770:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28902; /* *cond_truncrvvm2sfrvvm1hf */

    case 771:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28903; /* *cond_truncrvvm1sfrvvmf2hf */

    case 772:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28904; /* *cond_truncrvvmf2sfrvvmf4hf */

    case 773:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28905; /* *cond_truncrvvm8dfrvvm4sf */

    case 774:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28906; /* *cond_truncrvvm4dfrvvm2sf */

    case 775:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28907; /* *cond_truncrvvm2dfrvvm1sf */

    case 776:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28908; /* *cond_truncrvvm1dfrvvmf2sf */

    case 777:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28909; /* *cond_truncv1sfv1hf */

    case 778:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28910; /* *cond_truncv2sfv2hf */

    case 779:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28911; /* *cond_truncv4sfv4hf */

    case 780:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28912; /* *cond_truncv8sfv8hf */

    case 781:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28913; /* *cond_truncv16sfv16hf */

    case 782:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28914; /* *cond_truncv32sfv32hf */

    case 783:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28915; /* *cond_truncv64sfv64hf */

    case 784:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28916; /* *cond_truncv128sfv128hf */

    case 785:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28917; /* *cond_truncv256sfv256hf */

    case 786:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28918; /* *cond_truncv512sfv512hf */

    case 787:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28919; /* *cond_truncv1024sfv1024hf */

    case 788:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28920; /* *cond_truncv1dfv1sf */

    case 789:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28921; /* *cond_truncv2dfv2sf */

    case 790:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28922; /* *cond_truncv4dfv4sf */

    case 791:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28923; /* *cond_truncv8dfv8sf */

    case 792:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28924; /* *cond_truncv16dfv16sf */

    case 793:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28925; /* *cond_truncv32dfv32sf */

    case 794:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28926; /* *cond_truncv64dfv64sf */

    case 795:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28927; /* *cond_truncv128dfv128sf */

    case 796:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28928; /* *cond_truncv256dfv256sf */

    case 797:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28929; /* *cond_truncv512dfv512sf */

    case 798:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28930; /* *cond_fix_truncrvvm8hfrvvm8hi */

    case 799:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28932; /* *cond_fix_truncrvvm4hfrvvm4hi */

    case 800:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29290; /* *cond_fix_truncrvvm8sfrvvm4hi */

    case 801:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28934; /* *cond_fix_truncrvvm2hfrvvm2hi */

    case 802:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29292; /* *cond_fix_truncrvvm4sfrvvm2hi */

    case 803:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28936; /* *cond_fix_truncrvvm1hfrvvm1hi */

    case 804:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29294; /* *cond_fix_truncrvvm2sfrvvm1hi */

    case 805:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28938; /* *cond_fix_truncrvvmf2hfrvvmf2hi */

    case 806:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29296; /* *cond_fix_truncrvvm1sfrvvmf2hi */

    case 807:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28940; /* *cond_fix_truncrvvmf4hfrvvmf4hi */

    case 808:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29298; /* *cond_fix_truncrvvmf2sfrvvmf4hi */

    case 809:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28942; /* *cond_fix_truncrvvm8sfrvvm8si */

    case 810:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29122; /* *cond_fix_truncrvvm4hfrvvm8si */

    case 811:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28944; /* *cond_fix_truncrvvm4sfrvvm4si */

    case 812:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29124; /* *cond_fix_truncrvvm2hfrvvm4si */

    case 813:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29300; /* *cond_fix_truncrvvm8dfrvvm4si */

    case 814:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28946; /* *cond_fix_truncrvvm2sfrvvm2si */

    case 815:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29126; /* *cond_fix_truncrvvm1hfrvvm2si */

    case 816:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29302; /* *cond_fix_truncrvvm4dfrvvm2si */

    case 817:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28948; /* *cond_fix_truncrvvm1sfrvvm1si */

    case 818:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29128; /* *cond_fix_truncrvvmf2hfrvvm1si */

    case 819:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29304; /* *cond_fix_truncrvvm2dfrvvm1si */

    case 820:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28950; /* *cond_fix_truncrvvmf2sfrvvmf2si */

    case 821:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29130; /* *cond_fix_truncrvvmf4hfrvvmf2si */

    case 822:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29306; /* *cond_fix_truncrvvm1dfrvvmf2si */

    case 823:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28952; /* *cond_fix_truncrvvm8dfrvvm8di */

    case 824:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29132; /* *cond_fix_truncrvvm4sfrvvm8di */

    case 825:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28954; /* *cond_fix_truncrvvm4dfrvvm4di */

    case 826:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29134; /* *cond_fix_truncrvvm2sfrvvm4di */

    case 827:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28956; /* *cond_fix_truncrvvm2dfrvvm2di */

    case 828:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29136; /* *cond_fix_truncrvvm1sfrvvm2di */

    case 829:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28958; /* *cond_fix_truncrvvm1dfrvvm1di */

    case 830:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29138; /* *cond_fix_truncrvvmf2sfrvvm1di */

    case 831:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28960; /* *cond_fix_truncv1hfv1hi */

    case 832:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29332; /* *cond_fix_truncv1sfv1hi */

    case 833:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28962; /* *cond_fix_truncv2hfv2hi */

    case 834:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29334; /* *cond_fix_truncv2sfv2hi */

    case 835:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28964; /* *cond_fix_truncv4hfv4hi */

    case 836:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29336; /* *cond_fix_truncv4sfv4hi */

    case 837:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28966; /* *cond_fix_truncv8hfv8hi */

    case 838:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29338; /* *cond_fix_truncv8sfv8hi */

    case 839:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28968; /* *cond_fix_truncv16hfv16hi */

    case 840:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29340; /* *cond_fix_truncv16sfv16hi */

    case 841:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28970; /* *cond_fix_truncv32hfv32hi */

    case 842:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29342; /* *cond_fix_truncv32sfv32hi */

    case 843:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28972; /* *cond_fix_truncv64hfv64hi */

    case 844:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29344; /* *cond_fix_truncv64sfv64hi */

    case 845:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28974; /* *cond_fix_truncv128hfv128hi */

    case 846:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29346; /* *cond_fix_truncv128sfv128hi */

    case 847:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28976; /* *cond_fix_truncv256hfv256hi */

    case 848:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29348; /* *cond_fix_truncv256sfv256hi */

    case 849:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28978; /* *cond_fix_truncv512hfv512hi */

    case 850:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29350; /* *cond_fix_truncv512sfv512hi */

    case 851:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28980; /* *cond_fix_truncv1024hfv1024hi */

    case 852:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29352; /* *cond_fix_truncv1024sfv1024hi */

    case 853:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28982; /* *cond_fix_truncv2048hfv2048hi */

    case 854:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28984; /* *cond_fix_truncv1sfv1si */

    case 855:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 29140; /* *cond_fix_truncv1hfv1si */

    case 856:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29354; /* *cond_fix_truncv1dfv1si */

    case 857:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28986; /* *cond_fix_truncv2sfv2si */

    case 858:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 29142; /* *cond_fix_truncv2hfv2si */

    case 859:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29356; /* *cond_fix_truncv2dfv2si */

    case 860:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28988; /* *cond_fix_truncv4sfv4si */

    case 861:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 29144; /* *cond_fix_truncv4hfv4si */

    case 862:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29358; /* *cond_fix_truncv4dfv4si */

    case 863:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28990; /* *cond_fix_truncv8sfv8si */

    case 864:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 29146; /* *cond_fix_truncv8hfv8si */

    case 865:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29360; /* *cond_fix_truncv8dfv8si */

    case 866:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28992; /* *cond_fix_truncv16sfv16si */

    case 867:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29148; /* *cond_fix_truncv16hfv16si */

    case 868:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29362; /* *cond_fix_truncv16dfv16si */

    case 869:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28994; /* *cond_fix_truncv32sfv32si */

    case 870:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29150; /* *cond_fix_truncv32hfv32si */

    case 871:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29364; /* *cond_fix_truncv32dfv32si */

    case 872:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28996; /* *cond_fix_truncv64sfv64si */

    case 873:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29152; /* *cond_fix_truncv64hfv64si */

    case 874:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29366; /* *cond_fix_truncv64dfv64si */

    case 875:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28998; /* *cond_fix_truncv128sfv128si */

    case 876:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29154; /* *cond_fix_truncv128hfv128si */

    case 877:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29368; /* *cond_fix_truncv128dfv128si */

    case 878:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29000; /* *cond_fix_truncv256sfv256si */

    case 879:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29156; /* *cond_fix_truncv256hfv256si */

    case 880:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29370; /* *cond_fix_truncv256dfv256si */

    case 881:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29002; /* *cond_fix_truncv512sfv512si */

    case 882:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29158; /* *cond_fix_truncv512hfv512si */

    case 883:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29372; /* *cond_fix_truncv512dfv512si */

    case 884:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29004; /* *cond_fix_truncv1024sfv1024si */

    case 885:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29160; /* *cond_fix_truncv1024hfv1024si */

    case 886:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29006; /* *cond_fix_truncv1dfv1di */

    case 887:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29162; /* *cond_fix_truncv1sfv1di */

    case 888:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29008; /* *cond_fix_truncv2dfv2di */

    case 889:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29164; /* *cond_fix_truncv2sfv2di */

    case 890:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29010; /* *cond_fix_truncv4dfv4di */

    case 891:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29166; /* *cond_fix_truncv4sfv4di */

    case 892:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29012; /* *cond_fix_truncv8dfv8di */

    case 893:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29168; /* *cond_fix_truncv8sfv8di */

    case 894:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29014; /* *cond_fix_truncv16dfv16di */

    case 895:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29170; /* *cond_fix_truncv16sfv16di */

    case 896:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29016; /* *cond_fix_truncv32dfv32di */

    case 897:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29172; /* *cond_fix_truncv32sfv32di */

    case 898:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29018; /* *cond_fix_truncv64dfv64di */

    case 899:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29174; /* *cond_fix_truncv64sfv64di */

    case 900:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29020; /* *cond_fix_truncv128dfv128di */

    case 901:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29176; /* *cond_fix_truncv128sfv128di */

    case 902:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29022; /* *cond_fix_truncv256dfv256di */

    case 903:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29178; /* *cond_fix_truncv256sfv256di */

    case 904:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29024; /* *cond_fix_truncv512dfv512di */

    case 905:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29180; /* *cond_fix_truncv512sfv512di */

    case 906:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29278; /* *cond_fix_truncrvvm8hfrvvm4qi */

    case 907:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29280; /* *cond_fix_truncrvvm4hfrvvm2qi */

    case 908:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29282; /* *cond_fix_truncrvvm2hfrvvm1qi */

    case 909:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29284; /* *cond_fix_truncrvvm1hfrvvmf2qi */

    case 910:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29286; /* *cond_fix_truncrvvmf2hfrvvmf4qi */

    case 911:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29288; /* *cond_fix_truncrvvmf4hfrvvmf8qi */

    case 912:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 29308; /* *cond_fix_truncv1hfv1qi */

    case 913:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 29310; /* *cond_fix_truncv2hfv2qi */

    case 914:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 29312; /* *cond_fix_truncv4hfv4qi */

    case 915:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 29314; /* *cond_fix_truncv8hfv8qi */

    case 916:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 29316; /* *cond_fix_truncv16hfv16qi */

    case 917:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29318; /* *cond_fix_truncv32hfv32qi */

    case 918:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29320; /* *cond_fix_truncv64hfv64qi */

    case 919:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29322; /* *cond_fix_truncv128hfv128qi */

    case 920:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29324; /* *cond_fix_truncv256hfv256qi */

    case 921:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29326; /* *cond_fix_truncv512hfv512qi */

    case 922:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29328; /* *cond_fix_truncv1024hfv1024qi */

    case 923:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29330; /* *cond_fix_truncv2048hfv2048qi */

    case 924:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28931; /* *cond_fixuns_truncrvvm8hfrvvm8hi */

    case 925:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28933; /* *cond_fixuns_truncrvvm4hfrvvm4hi */

    case 926:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29291; /* *cond_fixuns_truncrvvm8sfrvvm4hi */

    case 927:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28935; /* *cond_fixuns_truncrvvm2hfrvvm2hi */

    case 928:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29293; /* *cond_fixuns_truncrvvm4sfrvvm2hi */

    case 929:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28937; /* *cond_fixuns_truncrvvm1hfrvvm1hi */

    case 930:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29295; /* *cond_fixuns_truncrvvm2sfrvvm1hi */

    case 931:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28939; /* *cond_fixuns_truncrvvmf2hfrvvmf2hi */

    case 932:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29297; /* *cond_fixuns_truncrvvm1sfrvvmf2hi */

    case 933:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28941; /* *cond_fixuns_truncrvvmf4hfrvvmf4hi */

    case 934:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29299; /* *cond_fixuns_truncrvvmf2sfrvvmf4hi */

    case 935:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28943; /* *cond_fixuns_truncrvvm8sfrvvm8si */

    case 936:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29123; /* *cond_fixuns_truncrvvm4hfrvvm8si */

    case 937:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28945; /* *cond_fixuns_truncrvvm4sfrvvm4si */

    case 938:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29125; /* *cond_fixuns_truncrvvm2hfrvvm4si */

    case 939:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29301; /* *cond_fixuns_truncrvvm8dfrvvm4si */

    case 940:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28947; /* *cond_fixuns_truncrvvm2sfrvvm2si */

    case 941:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29127; /* *cond_fixuns_truncrvvm1hfrvvm2si */

    case 942:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29303; /* *cond_fixuns_truncrvvm4dfrvvm2si */

    case 943:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28949; /* *cond_fixuns_truncrvvm1sfrvvm1si */

    case 944:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29129; /* *cond_fixuns_truncrvvmf2hfrvvm1si */

    case 945:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29305; /* *cond_fixuns_truncrvvm2dfrvvm1si */

    case 946:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28951; /* *cond_fixuns_truncrvvmf2sfrvvmf2si */

    case 947:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29131; /* *cond_fixuns_truncrvvmf4hfrvvmf2si */

    case 948:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29307; /* *cond_fixuns_truncrvvm1dfrvvmf2si */

    case 949:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28953; /* *cond_fixuns_truncrvvm8dfrvvm8di */

    case 950:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29133; /* *cond_fixuns_truncrvvm4sfrvvm8di */

    case 951:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28955; /* *cond_fixuns_truncrvvm4dfrvvm4di */

    case 952:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29135; /* *cond_fixuns_truncrvvm2sfrvvm4di */

    case 953:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28957; /* *cond_fixuns_truncrvvm2dfrvvm2di */

    case 954:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29137; /* *cond_fixuns_truncrvvm1sfrvvm2di */

    case 955:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28959; /* *cond_fixuns_truncrvvm1dfrvvm1di */

    case 956:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29139; /* *cond_fixuns_truncrvvmf2sfrvvm1di */

    case 957:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28961; /* *cond_fixuns_truncv1hfv1hi */

    case 958:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29333; /* *cond_fixuns_truncv1sfv1hi */

    case 959:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28963; /* *cond_fixuns_truncv2hfv2hi */

    case 960:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29335; /* *cond_fixuns_truncv2sfv2hi */

    case 961:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28965; /* *cond_fixuns_truncv4hfv4hi */

    case 962:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29337; /* *cond_fixuns_truncv4sfv4hi */

    case 963:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28967; /* *cond_fixuns_truncv8hfv8hi */

    case 964:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29339; /* *cond_fixuns_truncv8sfv8hi */

    case 965:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28969; /* *cond_fixuns_truncv16hfv16hi */

    case 966:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29341; /* *cond_fixuns_truncv16sfv16hi */

    case 967:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28971; /* *cond_fixuns_truncv32hfv32hi */

    case 968:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29343; /* *cond_fixuns_truncv32sfv32hi */

    case 969:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28973; /* *cond_fixuns_truncv64hfv64hi */

    case 970:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29345; /* *cond_fixuns_truncv64sfv64hi */

    case 971:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28975; /* *cond_fixuns_truncv128hfv128hi */

    case 972:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29347; /* *cond_fixuns_truncv128sfv128hi */

    case 973:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28977; /* *cond_fixuns_truncv256hfv256hi */

    case 974:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29349; /* *cond_fixuns_truncv256sfv256hi */

    case 975:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28979; /* *cond_fixuns_truncv512hfv512hi */

    case 976:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29351; /* *cond_fixuns_truncv512sfv512hi */

    case 977:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28981; /* *cond_fixuns_truncv1024hfv1024hi */

    case 978:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29353; /* *cond_fixuns_truncv1024sfv1024hi */

    case 979:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28983; /* *cond_fixuns_truncv2048hfv2048hi */

    case 980:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28985; /* *cond_fixuns_truncv1sfv1si */

    case 981:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 29141; /* *cond_fixuns_truncv1hfv1si */

    case 982:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29355; /* *cond_fixuns_truncv1dfv1si */

    case 983:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28987; /* *cond_fixuns_truncv2sfv2si */

    case 984:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 29143; /* *cond_fixuns_truncv2hfv2si */

    case 985:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29357; /* *cond_fixuns_truncv2dfv2si */

    case 986:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28989; /* *cond_fixuns_truncv4sfv4si */

    case 987:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 29145; /* *cond_fixuns_truncv4hfv4si */

    case 988:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29359; /* *cond_fixuns_truncv4dfv4si */

    case 989:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28991; /* *cond_fixuns_truncv8sfv8si */

    case 990:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 29147; /* *cond_fixuns_truncv8hfv8si */

    case 991:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29361; /* *cond_fixuns_truncv8dfv8si */

    case 992:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28993; /* *cond_fixuns_truncv16sfv16si */

    case 993:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29149; /* *cond_fixuns_truncv16hfv16si */

    case 994:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29363; /* *cond_fixuns_truncv16dfv16si */

    case 995:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28995; /* *cond_fixuns_truncv32sfv32si */

    case 996:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29151; /* *cond_fixuns_truncv32hfv32si */

    case 997:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29365; /* *cond_fixuns_truncv32dfv32si */

    case 998:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28997; /* *cond_fixuns_truncv64sfv64si */

    case 999:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29153; /* *cond_fixuns_truncv64hfv64si */

    case 1000:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29367; /* *cond_fixuns_truncv64dfv64si */

    case 1001:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28999; /* *cond_fixuns_truncv128sfv128si */

    case 1002:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29155; /* *cond_fixuns_truncv128hfv128si */

    case 1003:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29369; /* *cond_fixuns_truncv128dfv128si */

    case 1004:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29001; /* *cond_fixuns_truncv256sfv256si */

    case 1005:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29157; /* *cond_fixuns_truncv256hfv256si */

    case 1006:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29371; /* *cond_fixuns_truncv256dfv256si */

    case 1007:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29003; /* *cond_fixuns_truncv512sfv512si */

    case 1008:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29159; /* *cond_fixuns_truncv512hfv512si */

    case 1009:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29373; /* *cond_fixuns_truncv512dfv512si */

    case 1010:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29005; /* *cond_fixuns_truncv1024sfv1024si */

    case 1011:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29161; /* *cond_fixuns_truncv1024hfv1024si */

    case 1012:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29007; /* *cond_fixuns_truncv1dfv1di */

    case 1013:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29163; /* *cond_fixuns_truncv1sfv1di */

    case 1014:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29009; /* *cond_fixuns_truncv2dfv2di */

    case 1015:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29165; /* *cond_fixuns_truncv2sfv2di */

    case 1016:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29011; /* *cond_fixuns_truncv4dfv4di */

    case 1017:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29167; /* *cond_fixuns_truncv4sfv4di */

    case 1018:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29013; /* *cond_fixuns_truncv8dfv8di */

    case 1019:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29169; /* *cond_fixuns_truncv8sfv8di */

    case 1020:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29015; /* *cond_fixuns_truncv16dfv16di */

    case 1021:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29171; /* *cond_fixuns_truncv16sfv16di */

    case 1022:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29017; /* *cond_fixuns_truncv32dfv32di */

    case 1023:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29173; /* *cond_fixuns_truncv32sfv32di */

    case 1024:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29019; /* *cond_fixuns_truncv64dfv64di */

    case 1025:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29175; /* *cond_fixuns_truncv64sfv64di */

    case 1026:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29021; /* *cond_fixuns_truncv128dfv128di */

    case 1027:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29177; /* *cond_fixuns_truncv128sfv128di */

    case 1028:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29023; /* *cond_fixuns_truncv256dfv256di */

    case 1029:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29179; /* *cond_fixuns_truncv256sfv256di */

    case 1030:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29025; /* *cond_fixuns_truncv512dfv512di */

    case 1031:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29181; /* *cond_fixuns_truncv512sfv512di */

    case 1032:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29279; /* *cond_fixuns_truncrvvm8hfrvvm4qi */

    case 1033:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29281; /* *cond_fixuns_truncrvvm4hfrvvm2qi */

    case 1034:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29283; /* *cond_fixuns_truncrvvm2hfrvvm1qi */

    case 1035:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29285; /* *cond_fixuns_truncrvvm1hfrvvmf2qi */

    case 1036:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29287; /* *cond_fixuns_truncrvvmf2hfrvvmf4qi */

    case 1037:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29289; /* *cond_fixuns_truncrvvmf4hfrvvmf8qi */

    case 1038:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 29309; /* *cond_fixuns_truncv1hfv1qi */

    case 1039:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 29311; /* *cond_fixuns_truncv2hfv2qi */

    case 1040:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 29313; /* *cond_fixuns_truncv4hfv4qi */

    case 1041:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 29315; /* *cond_fixuns_truncv8hfv8qi */

    case 1042:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 29317; /* *cond_fixuns_truncv16hfv16qi */

    case 1043:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29319; /* *cond_fixuns_truncv32hfv32qi */

    case 1044:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29321; /* *cond_fixuns_truncv64hfv64qi */

    case 1045:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29323; /* *cond_fixuns_truncv128hfv128qi */

    case 1046:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29325; /* *cond_fixuns_truncv256hfv256qi */

    case 1047:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29327; /* *cond_fixuns_truncv512hfv512qi */

    case 1048:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29329; /* *cond_fixuns_truncv1024hfv1024qi */

    case 1049:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29331; /* *cond_fixuns_truncv2048hfv2048qi */

    case 1050:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29026; /* *cond_floatrvvm8hirvvm8hf */

    case 1051:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29182; /* *cond_floatrvvm4qirvvm8hf */

    case 1052:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29028; /* *cond_floatrvvm4hirvvm4hf */

    case 1053:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29184; /* *cond_floatrvvm2qirvvm4hf */

    case 1054:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29374; /* *cond_floatrvvm8sirvvm4hf2 */

    case 1055:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29030; /* *cond_floatrvvm2hirvvm2hf */

    case 1056:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29186; /* *cond_floatrvvm1qirvvm2hf */

    case 1057:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29376; /* *cond_floatrvvm4sirvvm2hf2 */

    case 1058:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29032; /* *cond_floatrvvm1hirvvm1hf */

    case 1059:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29188; /* *cond_floatrvvmf2qirvvm1hf */

    case 1060:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29378; /* *cond_floatrvvm2sirvvm1hf2 */

    case 1061:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29034; /* *cond_floatrvvmf2hirvvmf2hf */

    case 1062:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29190; /* *cond_floatrvvmf4qirvvmf2hf */

    case 1063:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29380; /* *cond_floatrvvm1sirvvmf2hf2 */

    case 1064:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29036; /* *cond_floatrvvmf4hirvvmf4hf */

    case 1065:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29192; /* *cond_floatrvvmf8qirvvmf4hf */

    case 1066:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29382; /* *cond_floatrvvmf2sirvvmf4hf2 */

    case 1067:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29038; /* *cond_floatrvvm8sirvvm8sf */

    case 1068:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29194; /* *cond_floatrvvm4hirvvm8sf */

    case 1069:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29040; /* *cond_floatrvvm4sirvvm4sf */

    case 1070:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29196; /* *cond_floatrvvm2hirvvm4sf */

    case 1071:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29384; /* *cond_floatrvvm8dirvvm4sf2 */

    case 1072:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29042; /* *cond_floatrvvm2sirvvm2sf */

    case 1073:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29198; /* *cond_floatrvvm1hirvvm2sf */

    case 1074:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29386; /* *cond_floatrvvm4dirvvm2sf2 */

    case 1075:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29044; /* *cond_floatrvvm1sirvvm1sf */

    case 1076:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29200; /* *cond_floatrvvmf2hirvvm1sf */

    case 1077:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29388; /* *cond_floatrvvm2dirvvm1sf2 */

    case 1078:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29046; /* *cond_floatrvvmf2sirvvmf2sf */

    case 1079:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29202; /* *cond_floatrvvmf4hirvvmf2sf */

    case 1080:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29390; /* *cond_floatrvvm1dirvvmf2sf2 */

    case 1081:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29048; /* *cond_floatrvvm8dirvvm8df */

    case 1082:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29204; /* *cond_floatrvvm4sirvvm8df */

    case 1083:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29050; /* *cond_floatrvvm4dirvvm4df */

    case 1084:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29206; /* *cond_floatrvvm2sirvvm4df */

    case 1085:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29052; /* *cond_floatrvvm2dirvvm2df */

    case 1086:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29208; /* *cond_floatrvvm1sirvvm2df */

    case 1087:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29054; /* *cond_floatrvvm1dirvvm1df */

    case 1088:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29210; /* *cond_floatrvvmf2sirvvm1df */

    case 1089:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 29056; /* *cond_floatv1hiv1hf */

    case 1090:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 29212; /* *cond_floatv1qiv1hf */

    case 1091:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 29392; /* *cond_floatv1siv1hf2 */

    case 1092:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 29058; /* *cond_floatv2hiv2hf */

    case 1093:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 29214; /* *cond_floatv2qiv2hf */

    case 1094:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 29394; /* *cond_floatv2siv2hf2 */

    case 1095:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 29060; /* *cond_floatv4hiv4hf */

    case 1096:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 29216; /* *cond_floatv4qiv4hf */

    case 1097:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 29396; /* *cond_floatv4siv4hf2 */

    case 1098:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 29062; /* *cond_floatv8hiv8hf */

    case 1099:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 29218; /* *cond_floatv8qiv8hf */

    case 1100:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 29398; /* *cond_floatv8siv8hf2 */

    case 1101:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 29064; /* *cond_floatv16hiv16hf */

    case 1102:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 29220; /* *cond_floatv16qiv16hf */

    case 1103:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29400; /* *cond_floatv16siv16hf2 */

    case 1104:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29066; /* *cond_floatv32hiv32hf */

    case 1105:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29222; /* *cond_floatv32qiv32hf */

    case 1106:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29402; /* *cond_floatv32siv32hf2 */

    case 1107:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29068; /* *cond_floatv64hiv64hf */

    case 1108:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29224; /* *cond_floatv64qiv64hf */

    case 1109:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29404; /* *cond_floatv64siv64hf2 */

    case 1110:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29070; /* *cond_floatv128hiv128hf */

    case 1111:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29226; /* *cond_floatv128qiv128hf */

    case 1112:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29406; /* *cond_floatv128siv128hf2 */

    case 1113:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29072; /* *cond_floatv256hiv256hf */

    case 1114:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29228; /* *cond_floatv256qiv256hf */

    case 1115:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29408; /* *cond_floatv256siv256hf2 */

    case 1116:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29074; /* *cond_floatv512hiv512hf */

    case 1117:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29230; /* *cond_floatv512qiv512hf */

    case 1118:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29410; /* *cond_floatv512siv512hf2 */

    case 1119:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29076; /* *cond_floatv1024hiv1024hf */

    case 1120:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29232; /* *cond_floatv1024qiv1024hf */

    case 1121:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29412; /* *cond_floatv1024siv1024hf2 */

    case 1122:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29078; /* *cond_floatv2048hiv2048hf */

    case 1123:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29234; /* *cond_floatv2048qiv2048hf */

    case 1124:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29080; /* *cond_floatv1siv1sf */

    case 1125:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29236; /* *cond_floatv1hiv1sf */

    case 1126:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29414; /* *cond_floatv1div1sf2 */

    case 1127:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29082; /* *cond_floatv2siv2sf */

    case 1128:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29238; /* *cond_floatv2hiv2sf */

    case 1129:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29416; /* *cond_floatv2div2sf2 */

    case 1130:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29084; /* *cond_floatv4siv4sf */

    case 1131:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29240; /* *cond_floatv4hiv4sf */

    case 1132:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29418; /* *cond_floatv4div4sf2 */

    case 1133:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29086; /* *cond_floatv8siv8sf */

    case 1134:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29242; /* *cond_floatv8hiv8sf */

    case 1135:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29420; /* *cond_floatv8div8sf2 */

    case 1136:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29088; /* *cond_floatv16siv16sf */

    case 1137:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29244; /* *cond_floatv16hiv16sf */

    case 1138:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29422; /* *cond_floatv16div16sf2 */

    case 1139:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29090; /* *cond_floatv32siv32sf */

    case 1140:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29246; /* *cond_floatv32hiv32sf */

    case 1141:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29424; /* *cond_floatv32div32sf2 */

    case 1142:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29092; /* *cond_floatv64siv64sf */

    case 1143:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29248; /* *cond_floatv64hiv64sf */

    case 1144:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29426; /* *cond_floatv64div64sf2 */

    case 1145:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29094; /* *cond_floatv128siv128sf */

    case 1146:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29250; /* *cond_floatv128hiv128sf */

    case 1147:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29428; /* *cond_floatv128div128sf2 */

    case 1148:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29096; /* *cond_floatv256siv256sf */

    case 1149:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29252; /* *cond_floatv256hiv256sf */

    case 1150:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29430; /* *cond_floatv256div256sf2 */

    case 1151:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29098; /* *cond_floatv512siv512sf */

    case 1152:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29254; /* *cond_floatv512hiv512sf */

    case 1153:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29432; /* *cond_floatv512div512sf2 */

    case 1154:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29100; /* *cond_floatv1024siv1024sf */

    case 1155:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29256; /* *cond_floatv1024hiv1024sf */

    case 1156:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29102; /* *cond_floatv1div1df */

    case 1157:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29258; /* *cond_floatv1siv1df */

    case 1158:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29104; /* *cond_floatv2div2df */

    case 1159:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29260; /* *cond_floatv2siv2df */

    case 1160:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29106; /* *cond_floatv4div4df */

    case 1161:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29262; /* *cond_floatv4siv4df */

    case 1162:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29108; /* *cond_floatv8div8df */

    case 1163:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29264; /* *cond_floatv8siv8df */

    case 1164:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29110; /* *cond_floatv16div16df */

    case 1165:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29266; /* *cond_floatv16siv16df */

    case 1166:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29112; /* *cond_floatv32div32df */

    case 1167:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29268; /* *cond_floatv32siv32df */

    case 1168:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29114; /* *cond_floatv64div64df */

    case 1169:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29270; /* *cond_floatv64siv64df */

    case 1170:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29116; /* *cond_floatv128div128df */

    case 1171:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29272; /* *cond_floatv128siv128df */

    case 1172:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29118; /* *cond_floatv256div256df */

    case 1173:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29274; /* *cond_floatv256siv256df */

    case 1174:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29120; /* *cond_floatv512div512df */

    case 1175:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29276; /* *cond_floatv512siv512df */

    case 1176:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29027; /* *cond_floatunsrvvm8hirvvm8hf */

    case 1177:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29183; /* *cond_floatunsrvvm4qirvvm8hf */

    case 1178:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29029; /* *cond_floatunsrvvm4hirvvm4hf */

    case 1179:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29185; /* *cond_floatunsrvvm2qirvvm4hf */

    case 1180:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29375; /* *cond_floatunsrvvm8sirvvm4hf2 */

    case 1181:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29031; /* *cond_floatunsrvvm2hirvvm2hf */

    case 1182:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29187; /* *cond_floatunsrvvm1qirvvm2hf */

    case 1183:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29377; /* *cond_floatunsrvvm4sirvvm2hf2 */

    case 1184:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29033; /* *cond_floatunsrvvm1hirvvm1hf */

    case 1185:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29189; /* *cond_floatunsrvvmf2qirvvm1hf */

    case 1186:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29379; /* *cond_floatunsrvvm2sirvvm1hf2 */

    case 1187:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29035; /* *cond_floatunsrvvmf2hirvvmf2hf */

    case 1188:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29191; /* *cond_floatunsrvvmf4qirvvmf2hf */

    case 1189:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29381; /* *cond_floatunsrvvm1sirvvmf2hf2 */

    case 1190:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29037; /* *cond_floatunsrvvmf4hirvvmf4hf */

    case 1191:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29193; /* *cond_floatunsrvvmf8qirvvmf4hf */

    case 1192:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 29383; /* *cond_floatunsrvvmf2sirvvmf4hf2 */

    case 1193:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29039; /* *cond_floatunsrvvm8sirvvm8sf */

    case 1194:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29195; /* *cond_floatunsrvvm4hirvvm8sf */

    case 1195:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29041; /* *cond_floatunsrvvm4sirvvm4sf */

    case 1196:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29197; /* *cond_floatunsrvvm2hirvvm4sf */

    case 1197:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29385; /* *cond_floatunsrvvm8dirvvm4sf2 */

    case 1198:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29043; /* *cond_floatunsrvvm2sirvvm2sf */

    case 1199:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29199; /* *cond_floatunsrvvm1hirvvm2sf */

    case 1200:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29387; /* *cond_floatunsrvvm4dirvvm2sf2 */

    case 1201:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29045; /* *cond_floatunsrvvm1sirvvm1sf */

    case 1202:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29201; /* *cond_floatunsrvvmf2hirvvm1sf */

    case 1203:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29389; /* *cond_floatunsrvvm2dirvvm1sf2 */

    case 1204:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29047; /* *cond_floatunsrvvmf2sirvvmf2sf */

    case 1205:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 29203; /* *cond_floatunsrvvmf4hirvvmf2sf */

    case 1206:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29391; /* *cond_floatunsrvvm1dirvvmf2sf2 */

    case 1207:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29049; /* *cond_floatunsrvvm8dirvvm8df */

    case 1208:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29205; /* *cond_floatunsrvvm4sirvvm8df */

    case 1209:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29051; /* *cond_floatunsrvvm4dirvvm4df */

    case 1210:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29207; /* *cond_floatunsrvvm2sirvvm4df */

    case 1211:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29053; /* *cond_floatunsrvvm2dirvvm2df */

    case 1212:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29209; /* *cond_floatunsrvvm1sirvvm2df */

    case 1213:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29055; /* *cond_floatunsrvvm1dirvvm1df */

    case 1214:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29211; /* *cond_floatunsrvvmf2sirvvm1df */

    case 1215:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 29057; /* *cond_floatunsv1hiv1hf */

    case 1216:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 29213; /* *cond_floatunsv1qiv1hf */

    case 1217:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 29393; /* *cond_floatunsv1siv1hf2 */

    case 1218:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 29059; /* *cond_floatunsv2hiv2hf */

    case 1219:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 29215; /* *cond_floatunsv2qiv2hf */

    case 1220:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 29395; /* *cond_floatunsv2siv2hf2 */

    case 1221:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 29061; /* *cond_floatunsv4hiv4hf */

    case 1222:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 29217; /* *cond_floatunsv4qiv4hf */

    case 1223:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 29397; /* *cond_floatunsv4siv4hf2 */

    case 1224:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 29063; /* *cond_floatunsv8hiv8hf */

    case 1225:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 29219; /* *cond_floatunsv8qiv8hf */

    case 1226:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 29399; /* *cond_floatunsv8siv8hf2 */

    case 1227:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 29065; /* *cond_floatunsv16hiv16hf */

    case 1228:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 29221; /* *cond_floatunsv16qiv16hf */

    case 1229:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29401; /* *cond_floatunsv16siv16hf2 */

    case 1230:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29067; /* *cond_floatunsv32hiv32hf */

    case 1231:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29223; /* *cond_floatunsv32qiv32hf */

    case 1232:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29403; /* *cond_floatunsv32siv32hf2 */

    case 1233:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29069; /* *cond_floatunsv64hiv64hf */

    case 1234:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29225; /* *cond_floatunsv64qiv64hf */

    case 1235:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29405; /* *cond_floatunsv64siv64hf2 */

    case 1236:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29071; /* *cond_floatunsv128hiv128hf */

    case 1237:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29227; /* *cond_floatunsv128qiv128hf */

    case 1238:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29407; /* *cond_floatunsv128siv128hf2 */

    case 1239:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29073; /* *cond_floatunsv256hiv256hf */

    case 1240:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29229; /* *cond_floatunsv256qiv256hf */

    case 1241:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29409; /* *cond_floatunsv256siv256hf2 */

    case 1242:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29075; /* *cond_floatunsv512hiv512hf */

    case 1243:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29231; /* *cond_floatunsv512qiv512hf */

    case 1244:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29411; /* *cond_floatunsv512siv512hf2 */

    case 1245:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29077; /* *cond_floatunsv1024hiv1024hf */

    case 1246:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29233; /* *cond_floatunsv1024qiv1024hf */

    case 1247:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29413; /* *cond_floatunsv1024siv1024hf2 */

    case 1248:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29079; /* *cond_floatunsv2048hiv2048hf */

    case 1249:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29235; /* *cond_floatunsv2048qiv2048hf */

    case 1250:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29081; /* *cond_floatunsv1siv1sf */

    case 1251:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29237; /* *cond_floatunsv1hiv1sf */

    case 1252:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29415; /* *cond_floatunsv1div1sf2 */

    case 1253:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29083; /* *cond_floatunsv2siv2sf */

    case 1254:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29239; /* *cond_floatunsv2hiv2sf */

    case 1255:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29417; /* *cond_floatunsv2div2sf2 */

    case 1256:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29085; /* *cond_floatunsv4siv4sf */

    case 1257:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29241; /* *cond_floatunsv4hiv4sf */

    case 1258:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29419; /* *cond_floatunsv4div4sf2 */

    case 1259:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29087; /* *cond_floatunsv8siv8sf */

    case 1260:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 29243; /* *cond_floatunsv8hiv8sf */

    case 1261:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29421; /* *cond_floatunsv8div8sf2 */

    case 1262:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29089; /* *cond_floatunsv16siv16sf */

    case 1263:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29245; /* *cond_floatunsv16hiv16sf */

    case 1264:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29423; /* *cond_floatunsv16div16sf2 */

    case 1265:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29091; /* *cond_floatunsv32siv32sf */

    case 1266:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29247; /* *cond_floatunsv32hiv32sf */

    case 1267:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29425; /* *cond_floatunsv32div32sf2 */

    case 1268:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29093; /* *cond_floatunsv64siv64sf */

    case 1269:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29249; /* *cond_floatunsv64hiv64sf */

    case 1270:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29427; /* *cond_floatunsv64div64sf2 */

    case 1271:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29095; /* *cond_floatunsv128siv128sf */

    case 1272:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29251; /* *cond_floatunsv128hiv128sf */

    case 1273:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29429; /* *cond_floatunsv128div128sf2 */

    case 1274:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29097; /* *cond_floatunsv256siv256sf */

    case 1275:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29253; /* *cond_floatunsv256hiv256sf */

    case 1276:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29431; /* *cond_floatunsv256div256sf2 */

    case 1277:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29099; /* *cond_floatunsv512siv512sf */

    case 1278:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29255; /* *cond_floatunsv512hiv512sf */

    case 1279:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29433; /* *cond_floatunsv512div512sf2 */

    case 1280:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29101; /* *cond_floatunsv1024siv1024sf */

    case 1281:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29257; /* *cond_floatunsv1024hiv1024sf */

    case 1282:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29103; /* *cond_floatunsv1div1df */

    case 1283:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29259; /* *cond_floatunsv1siv1df */

    case 1284:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29105; /* *cond_floatunsv2div2df */

    case 1285:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29261; /* *cond_floatunsv2siv2df */

    case 1286:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29107; /* *cond_floatunsv4div4df */

    case 1287:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 29263; /* *cond_floatunsv4siv4df */

    case 1288:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29109; /* *cond_floatunsv8div8df */

    case 1289:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29265; /* *cond_floatunsv8siv8df */

    case 1290:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29111; /* *cond_floatunsv16div16df */

    case 1291:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29267; /* *cond_floatunsv16siv16df */

    case 1292:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29113; /* *cond_floatunsv32div32df */

    case 1293:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29269; /* *cond_floatunsv32siv32df */

    case 1294:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29115; /* *cond_floatunsv64div64df */

    case 1295:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29271; /* *cond_floatunsv64siv64df */

    case 1296:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29117; /* *cond_floatunsv128div128df */

    case 1297:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29273; /* *cond_floatunsv128siv128df */

    case 1298:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29119; /* *cond_floatunsv256div256df */

    case 1299:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29275; /* *cond_floatunsv256siv256df */

    case 1300:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29121; /* *cond_floatunsv512div512df */

    case 1301:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29277; /* *cond_floatunsv512siv512df */

    case 1302:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29722; /* *cond_smulrvvm8qi3_highpart */

    case 1303:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29724; /* *cond_smulrvvm4qi3_highpart */

    case 1304:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29726; /* *cond_smulrvvm2qi3_highpart */

    case 1305:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29728; /* *cond_smulrvvm1qi3_highpart */

    case 1306:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29730; /* *cond_smulrvvmf2qi3_highpart */

    case 1307:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29732; /* *cond_smulrvvmf4qi3_highpart */

    case 1308:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29734; /* *cond_smulrvvmf8qi3_highpart */

    case 1309:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29736; /* *cond_smulrvvm8hi3_highpart */

    case 1310:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29738; /* *cond_smulrvvm4hi3_highpart */

    case 1311:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29740; /* *cond_smulrvvm2hi3_highpart */

    case 1312:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29742; /* *cond_smulrvvm1hi3_highpart */

    case 1313:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29744; /* *cond_smulrvvmf2hi3_highpart */

    case 1314:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29746; /* *cond_smulrvvmf4hi3_highpart */

    case 1315:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29748; /* *cond_smulrvvm8si3_highpart */

    case 1316:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29750; /* *cond_smulrvvm4si3_highpart */

    case 1317:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29752; /* *cond_smulrvvm2si3_highpart */

    case 1318:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29754; /* *cond_smulrvvm1si3_highpart */

    case 1319:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29756; /* *cond_smulrvvmf2si3_highpart */

    case 1320:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29758; /* *cond_smulrvvm8di3_highpart */

    case 1321:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29760; /* *cond_smulrvvm4di3_highpart */

    case 1322:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29762; /* *cond_smulrvvm2di3_highpart */

    case 1323:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29764; /* *cond_smulrvvm1di3_highpart */

    case 1324:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 29766; /* *cond_smulv1qi3_highpart */

    case 1325:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 29768; /* *cond_smulv2qi3_highpart */

    case 1326:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 29770; /* *cond_smulv4qi3_highpart */

    case 1327:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 29772; /* *cond_smulv8qi3_highpart */

    case 1328:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 29774; /* *cond_smulv16qi3_highpart */

    case 1329:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 29776; /* *cond_smulv32qi3_highpart */

    case 1330:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29778; /* *cond_smulv64qi3_highpart */

    case 1331:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29780; /* *cond_smulv128qi3_highpart */

    case 1332:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29782; /* *cond_smulv256qi3_highpart */

    case 1333:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29784; /* *cond_smulv512qi3_highpart */

    case 1334:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29786; /* *cond_smulv1024qi3_highpart */

    case 1335:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29788; /* *cond_smulv2048qi3_highpart */

    case 1336:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29790; /* *cond_smulv4096qi3_highpart */

    case 1337:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29792; /* *cond_smulv1hi3_highpart */

    case 1338:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29794; /* *cond_smulv2hi3_highpart */

    case 1339:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29796; /* *cond_smulv4hi3_highpart */

    case 1340:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29798; /* *cond_smulv8hi3_highpart */

    case 1341:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29800; /* *cond_smulv16hi3_highpart */

    case 1342:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29802; /* *cond_smulv32hi3_highpart */

    case 1343:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29804; /* *cond_smulv64hi3_highpart */

    case 1344:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29806; /* *cond_smulv128hi3_highpart */

    case 1345:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29808; /* *cond_smulv256hi3_highpart */

    case 1346:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29810; /* *cond_smulv512hi3_highpart */

    case 1347:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29812; /* *cond_smulv1024hi3_highpart */

    case 1348:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29814; /* *cond_smulv2048hi3_highpart */

    case 1349:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29816; /* *cond_smulv1si3_highpart */

    case 1350:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29818; /* *cond_smulv2si3_highpart */

    case 1351:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29820; /* *cond_smulv4si3_highpart */

    case 1352:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29822; /* *cond_smulv8si3_highpart */

    case 1353:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29824; /* *cond_smulv16si3_highpart */

    case 1354:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29826; /* *cond_smulv32si3_highpart */

    case 1355:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29828; /* *cond_smulv64si3_highpart */

    case 1356:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 542 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29830; /* *cond_smulv128si3_highpart */

    case 1357:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 543 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29832; /* *cond_smulv256si3_highpart */

    case 1358:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 544 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29834; /* *cond_smulv512si3_highpart */

    case 1359:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 545 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29836; /* *cond_smulv1024si3_highpart */

    case 1360:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 29838; /* *cond_smulv1di3_highpart */

    case 1361:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 547 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 29840; /* *cond_smulv2di3_highpart */

    case 1362:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 548 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 29842; /* *cond_smulv4di3_highpart */

    case 1363:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 549 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29844; /* *cond_smulv8di3_highpart */

    case 1364:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 550 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29846; /* *cond_smulv16di3_highpart */

    case 1365:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 551 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29848; /* *cond_smulv32di3_highpart */

    case 1366:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 552 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29850; /* *cond_smulv64di3_highpart */

    case 1367:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 553 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29852; /* *cond_smulv128di3_highpart */

    case 1368:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 554 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29854; /* *cond_smulv256di3_highpart */

    case 1369:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 555 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29856; /* *cond_smulv512di3_highpart */

    case 1370:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29723; /* *cond_umulrvvm8qi3_highpart */

    case 1371:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29725; /* *cond_umulrvvm4qi3_highpart */

    case 1372:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29727; /* *cond_umulrvvm2qi3_highpart */

    case 1373:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29729; /* *cond_umulrvvm1qi3_highpart */

    case 1374:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29731; /* *cond_umulrvvmf2qi3_highpart */

    case 1375:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29733; /* *cond_umulrvvmf4qi3_highpart */

    case 1376:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29735; /* *cond_umulrvvmf8qi3_highpart */

    case 1377:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29737; /* *cond_umulrvvm8hi3_highpart */

    case 1378:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29739; /* *cond_umulrvvm4hi3_highpart */

    case 1379:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29741; /* *cond_umulrvvm2hi3_highpart */

    case 1380:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29743; /* *cond_umulrvvm1hi3_highpart */

    case 1381:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29745; /* *cond_umulrvvmf2hi3_highpart */

    case 1382:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29747; /* *cond_umulrvvmf4hi3_highpart */

    case 1383:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29749; /* *cond_umulrvvm8si3_highpart */

    case 1384:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29751; /* *cond_umulrvvm4si3_highpart */

    case 1385:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29753; /* *cond_umulrvvm2si3_highpart */

    case 1386:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29755; /* *cond_umulrvvm1si3_highpart */

    case 1387:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29757; /* *cond_umulrvvmf2si3_highpart */

    case 1388:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29759; /* *cond_umulrvvm8di3_highpart */

    case 1389:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29761; /* *cond_umulrvvm4di3_highpart */

    case 1390:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29763; /* *cond_umulrvvm2di3_highpart */

    case 1391:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 29765; /* *cond_umulrvvm1di3_highpart */

    case 1392:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 29767; /* *cond_umulv1qi3_highpart */

    case 1393:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 29769; /* *cond_umulv2qi3_highpart */

    case 1394:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 29771; /* *cond_umulv4qi3_highpart */

    case 1395:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 29773; /* *cond_umulv8qi3_highpart */

    case 1396:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 29775; /* *cond_umulv16qi3_highpart */

    case 1397:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 29777; /* *cond_umulv32qi3_highpart */

    case 1398:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29779; /* *cond_umulv64qi3_highpart */

    case 1399:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29781; /* *cond_umulv128qi3_highpart */

    case 1400:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29783; /* *cond_umulv256qi3_highpart */

    case 1401:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29785; /* *cond_umulv512qi3_highpart */

    case 1402:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29787; /* *cond_umulv1024qi3_highpart */

    case 1403:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29789; /* *cond_umulv2048qi3_highpart */

    case 1404:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29791; /* *cond_umulv4096qi3_highpart */

    case 1405:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29793; /* *cond_umulv1hi3_highpart */

    case 1406:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29795; /* *cond_umulv2hi3_highpart */

    case 1407:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29797; /* *cond_umulv4hi3_highpart */

    case 1408:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29799; /* *cond_umulv8hi3_highpart */

    case 1409:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29801; /* *cond_umulv16hi3_highpart */

    case 1410:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29803; /* *cond_umulv32hi3_highpart */

    case 1411:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29805; /* *cond_umulv64hi3_highpart */

    case 1412:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29807; /* *cond_umulv128hi3_highpart */

    case 1413:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29809; /* *cond_umulv256hi3_highpart */

    case 1414:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29811; /* *cond_umulv512hi3_highpart */

    case 1415:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29813; /* *cond_umulv1024hi3_highpart */

    case 1416:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29815; /* *cond_umulv2048hi3_highpart */

    case 1417:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29817; /* *cond_umulv1si3_highpart */

    case 1418:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29819; /* *cond_umulv2si3_highpart */

    case 1419:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29821; /* *cond_umulv4si3_highpart */

    case 1420:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29823; /* *cond_umulv8si3_highpart */

    case 1421:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29825; /* *cond_umulv16si3_highpart */

    case 1422:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29827; /* *cond_umulv32si3_highpart */

    case 1423:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29829; /* *cond_umulv64si3_highpart */

    case 1424:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 542 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29831; /* *cond_umulv128si3_highpart */

    case 1425:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 543 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29833; /* *cond_umulv256si3_highpart */

    case 1426:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 544 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29835; /* *cond_umulv512si3_highpart */

    case 1427:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 545 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29837; /* *cond_umulv1024si3_highpart */

    case 1428:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 29839; /* *cond_umulv1di3_highpart */

    case 1429:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 547 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 29841; /* *cond_umulv2di3_highpart */

    case 1430:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 548 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 29843; /* *cond_umulv4di3_highpart */

    case 1431:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 549 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29845; /* *cond_umulv8di3_highpart */

    case 1432:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 550 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29847; /* *cond_umulv16di3_highpart */

    case 1433:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 551 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29849; /* *cond_umulv32di3_highpart */

    case 1434:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 552 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29851; /* *cond_umulv64di3_highpart */

    case 1435:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 553 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29853; /* *cond_umulv128di3_highpart */

    case 1436:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 554 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29855; /* *cond_umulv256di3_highpart */

    case 1437:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 555 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29857; /* *cond_umulv512di3_highpart */

    default:
      return -1;
    }
}

 rtx_insn *
split_143 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (pattern151 (x2))
        {
        case 0:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4333 (insn, operands);

        case 1:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4334 (insn, operands);

        case 2:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4335 (insn, operands);

        case 3:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4336 (insn, operands);

        case 4:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4337 (insn, operands);

        case 5:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4338 (insn, operands);

        case 6:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4339 (insn, operands);

        case 7:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4340 (insn, operands);

        case 8:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4341 (insn, operands);

        case 9:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4342 (insn, operands);

        case 10:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4343 (insn, operands);

        case 11:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4344 (insn, operands);

        case 12:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4345 (insn, operands);

        case 13:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4346 (insn, operands);

        case 14:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4347 (insn, operands);

        case 15:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4348 (insn, operands);

        case 16:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4349 (insn, operands);

        case 17:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4350 (insn, operands);

        case 18:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4351 (insn, operands);

        case 19:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4352 (insn, operands);

        case 20:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4353 (insn, operands);

        case 21:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4354 (insn, operands);

        case 22:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4355 (insn, operands);

        case 23:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4356 (insn, operands);

        case 24:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4357 (insn, operands);

        case 25:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4358 (insn, operands);

        case 26:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4359 (insn, operands);

        case 27:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4360 (insn, operands);

        case 28:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4361 (insn, operands);

        case 29:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4362 (insn, operands);

        case 30:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4363 (insn, operands);

        case 31:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4364 (insn, operands);

        case 32:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4365 (insn, operands);

        case 33:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4366 (insn, operands);

        case 34:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4367 (insn, operands);

        case 35:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4368 (insn, operands);

        case 36:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4369 (insn, operands);

        case 37:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4370 (insn, operands);

        case 38:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4371 (insn, operands);

        case 39:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4372 (insn, operands);

        case 40:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4373 (insn, operands);

        case 41:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4374 (insn, operands);

        case 42:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4375 (insn, operands);

        case 43:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4376 (insn, operands);

        case 44:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4377 (insn, operands);

        case 45:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4378 (insn, operands);

        case 46:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4379 (insn, operands);

        case 47:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4380 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern155 (x2))
        {
        case 0:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7844 (insn, operands);

        case 1:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7848 (insn, operands);

        case 2:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7852 (insn, operands);

        case 3:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7856 (insn, operands);

        case 4:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7860 (insn, operands);

        case 5:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7864 (insn, operands);

        case 6:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7868 (insn, operands);

        case 7:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7872 (insn, operands);

        case 8:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7876 (insn, operands);

        case 9:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7880 (insn, operands);

        case 10:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7884 (insn, operands);

        case 11:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7888 (insn, operands);

        case 12:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7892 (insn, operands);

        case 13:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7896 (insn, operands);

        case 14:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7900 (insn, operands);

        case 15:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7904 (insn, operands);

        case 16:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7908 (insn, operands);

        case 17:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7912 (insn, operands);

        case 18:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7916 (insn, operands);

        case 19:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7920 (insn, operands);

        case 20:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7924 (insn, operands);

        case 21:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7928 (insn, operands);

        case 22:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7932 (insn, operands);

        case 23:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7936 (insn, operands);

        case 24:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7940 (insn, operands);

        case 25:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7944 (insn, operands);

        case 26:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7948 (insn, operands);

        case 27:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7952 (insn, operands);

        case 28:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7956 (insn, operands);

        case 29:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7960 (insn, operands);

        case 30:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7964 (insn, operands);

        case 31:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7968 (insn, operands);

        case 32:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7972 (insn, operands);

        case 33:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7976 (insn, operands);

        case 34:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7980 (insn, operands);

        case 35:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7984 (insn, operands);

        case 36:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7988 (insn, operands);

        case 37:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7992 (insn, operands);

        case 38:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7996 (insn, operands);

        case 39:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8000 (insn, operands);

        case 40:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8004 (insn, operands);

        case 41:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8008 (insn, operands);

        case 42:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8012 (insn, operands);

        case 43:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8016 (insn, operands);

        case 44:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8020 (insn, operands);

        case 45:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8024 (insn, operands);

        case 46:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8028 (insn, operands);

        case 47:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8032 (insn, operands);

        case 48:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7846 (insn, operands);

        case 49:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7850 (insn, operands);

        case 50:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7854 (insn, operands);

        case 51:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7858 (insn, operands);

        case 52:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7862 (insn, operands);

        case 53:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7866 (insn, operands);

        case 54:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7870 (insn, operands);

        case 55:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7874 (insn, operands);

        case 56:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7878 (insn, operands);

        case 57:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7882 (insn, operands);

        case 58:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7886 (insn, operands);

        case 59:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7890 (insn, operands);

        case 60:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7894 (insn, operands);

        case 61:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7898 (insn, operands);

        case 62:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7902 (insn, operands);

        case 63:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7906 (insn, operands);

        case 64:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7910 (insn, operands);

        case 65:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7914 (insn, operands);

        case 66:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7918 (insn, operands);

        case 67:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7922 (insn, operands);

        case 68:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7926 (insn, operands);

        case 69:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7930 (insn, operands);

        case 70:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7934 (insn, operands);

        case 71:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7938 (insn, operands);

        case 72:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7942 (insn, operands);

        case 73:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7946 (insn, operands);

        case 74:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7950 (insn, operands);

        case 75:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7954 (insn, operands);

        case 76:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7958 (insn, operands);

        case 77:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7962 (insn, operands);

        case 78:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7966 (insn, operands);

        case 79:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7970 (insn, operands);

        case 80:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7974 (insn, operands);

        case 81:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7978 (insn, operands);

        case 82:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7982 (insn, operands);

        case 83:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7986 (insn, operands);

        case 84:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7990 (insn, operands);

        case 85:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7994 (insn, operands);

        case 86:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7998 (insn, operands);

        case 87:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8002 (insn, operands);

        case 88:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8006 (insn, operands);

        case 89:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8010 (insn, operands);

        case 90:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8014 (insn, operands);

        case 91:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8018 (insn, operands);

        case 92:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8022 (insn, operands);

        case 93:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8026 (insn, operands);

        case 94:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8030 (insn, operands);

        case 95:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8034 (insn, operands);

        case 96:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8036 (insn, operands);

        case 97:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8038 (insn, operands);

        case 98:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8040 (insn, operands);

        case 99:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8042 (insn, operands);

        case 100:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8044 (insn, operands);

        case 101:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8046 (insn, operands);

        case 102:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8048 (insn, operands);

        case 103:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8050 (insn, operands);

        case 104:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8052 (insn, operands);

        case 105:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8054 (insn, operands);

        case 106:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8056 (insn, operands);

        case 107:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8058 (insn, operands);

        case 108:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8060 (insn, operands);

        case 109:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8062 (insn, operands);

        case 110:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8064 (insn, operands);

        case 111:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8066 (insn, operands);

        case 112:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8068 (insn, operands);

        case 113:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8070 (insn, operands);

        case 114:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8072 (insn, operands);

        case 115:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8074 (insn, operands);

        case 116:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8076 (insn, operands);

        case 117:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8078 (insn, operands);

        case 118:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8080 (insn, operands);

        case 119:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8082 (insn, operands);

        case 120:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8084 (insn, operands);

        case 121:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8086 (insn, operands);

        case 122:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8088 (insn, operands);

        case 123:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8090 (insn, operands);

        case 124:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8092 (insn, operands);

        case 125:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8094 (insn, operands);

        case 126:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8096 (insn, operands);

        case 127:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8098 (insn, operands);

        case 128:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8100 (insn, operands);

        case 129:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8102 (insn, operands);

        case 130:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8104 (insn, operands);

        case 131:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8106 (insn, operands);

        case 132:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8108 (insn, operands);

        case 133:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8110 (insn, operands);

        case 134:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8112 (insn, operands);

        case 135:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8114 (insn, operands);

        case 136:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8116 (insn, operands);

        case 137:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8118 (insn, operands);

        case 138:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8120 (insn, operands);

        case 139:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8122 (insn, operands);

        case 140:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8124 (insn, operands);

        case 141:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8126 (insn, operands);

        case 142:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8128 (insn, operands);

        case 143:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8130 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      return split_142 (x1, insn);

    case ASHIFT:
      return split_141 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_154 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x2) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM8SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4411 (insn, operands);

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x2) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4412 (insn, operands);

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x2) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4413 (insn, operands);

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x2) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4414 (insn, operands);

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x2) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4415 (insn, operands);

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x2) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM8DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4416 (insn, operands);

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x2) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM4DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4417 (insn, operands);

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x2) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM2DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4418 (insn, operands);

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x2) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVM1DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4419 (insn, operands);

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x2) != E_V1HFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4420 (insn, operands);

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x2) != E_V2HFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4421 (insn, operands);

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4422 (insn, operands);

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4423 (insn, operands);

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x2) != E_V16HFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4424 (insn, operands);

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4425 (insn, operands);

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x2) != E_V64HFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4426 (insn, operands);

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x2) != E_V128HFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4427 (insn, operands);

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x2) != E_V256HFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4428 (insn, operands);

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x2) != E_V512HFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4429 (insn, operands);

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x2) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4430 (insn, operands);

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4431 (insn, operands);

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4432 (insn, operands);

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4433 (insn, operands);

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !register_operand (operands[1], E_V8DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4434 (insn, operands);

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4435 (insn, operands);

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x2) != E_V32SFmode
          || !register_operand (operands[1], E_V32DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4436 (insn, operands);

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x2) != E_V64SFmode
          || !register_operand (operands[1], E_V64DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4437 (insn, operands);

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x2) != E_V128SFmode
          || !register_operand (operands[1], E_V128DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4438 (insn, operands);

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x2) != E_V256SFmode
          || !register_operand (operands[1], E_V256DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4439 (insn, operands);

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x2) != E_V512SFmode
          || !register_operand (operands[1], E_V512DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4440 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_159 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 5:
          if (XINT (x3, 1) != 91
              || pattern260 (x3) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case CONST_VECTOR:
              operands[1] = x4;
              x5 = XVECEXP (x3, 0, 1);
              operands[4] = x5;
              if (!vector_length_operand (operands[4], E_VOIDmode))
                return NULL;
              x6 = XVECEXP (x3, 0, 2);
              operands[5] = x6;
              x7 = XEXP (x2, 1);
              operands[3] = x7;
              x8 = XEXP (x2, 2);
              operands[2] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_RVVMF64BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF64BImode)
                      || pattern573 (x2, 
E_RVVMF64BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_779 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF64BImode, 5))))
                    return NULL;
                  return gen_split_2431 (insn, operands);

                case E_RVVMF32BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF32BImode)
                      || pattern573 (x2, 
E_RVVMF32BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_780 (insn, operands);
                  if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF32BImode, 5))))
                    return NULL;
                  return gen_split_2432 (insn, operands);

                case E_RVVMF16BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF16BImode)
                      || pattern573 (x2, 
E_RVVMF16BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_781 (insn, operands);
                  if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF16BImode, 5))))
                    return NULL;
                  return gen_split_2433 (insn, operands);

                case E_RVVMF8BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF8BImode)
                      || pattern573 (x2, 
E_RVVMF8BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_782 (insn, operands);
                  if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8BImode, 5))))
                    return NULL;
                  return gen_split_2434 (insn, operands);

                case E_RVVMF4BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF4BImode)
                      || pattern573 (x2, 
E_RVVMF4BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_783 (insn, operands);
                  if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BImode, 5))))
                    return NULL;
                  return gen_split_2435 (insn, operands);

                case E_RVVMF2BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF2BImode)
                      || pattern573 (x2, 
E_RVVMF2BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_784 (insn, operands);
                  if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BImode, 5))))
                    return NULL;
                  return gen_split_2436 (insn, operands);

                case E_RVVM1BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVM1BImode)
                      || pattern573 (x2, 
E_RVVM1BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_785 (insn, operands);
                  if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BImode, 5))))
                    return NULL;
                  return gen_split_2437 (insn, operands);

                case E_V1BImode:
                  if (!nonimmediate_operand (operands[0], E_V1BImode)
                      || pattern573 (x2, 
E_V1BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_786 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1BImode, 5))))
                    return NULL;
                  return gen_split_2438 (insn, operands);

                case E_V2BImode:
                  if (!nonimmediate_operand (operands[0], E_V2BImode)
                      || pattern573 (x2, 
E_V2BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_787 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2BImode, 5))))
                    return NULL;
                  return gen_split_2439 (insn, operands);

                case E_V4BImode:
                  if (!nonimmediate_operand (operands[0], E_V4BImode)
                      || pattern573 (x2, 
E_V4BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_788 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4BImode, 5))))
                    return NULL;
                  return gen_split_2440 (insn, operands);

                case E_V8BImode:
                  if (!nonimmediate_operand (operands[0], E_V8BImode)
                      || pattern573 (x2, 
E_V8BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_789 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8BImode, 5))))
                    return NULL;
                  return gen_split_2441 (insn, operands);

                case E_V16BImode:
                  if (!nonimmediate_operand (operands[0], E_V16BImode)
                      || pattern573 (x2, 
E_V16BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_790 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16BImode, 5))))
                    return NULL;
                  return gen_split_2442 (insn, operands);

                case E_V32BImode:
                  if (!nonimmediate_operand (operands[0], E_V32BImode)
                      || pattern573 (x2, 
E_V32BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_791 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32BImode, 5))))
                    return NULL;
                  return gen_split_2443 (insn, operands);

                case E_V64BImode:
                  if (!nonimmediate_operand (operands[0], E_V64BImode)
                      || pattern573 (x2, 
E_V64BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_792 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64BImode, 5))))
                    return NULL;
                  return gen_split_2444 (insn, operands);

                case E_V128BImode:
                  if (!nonimmediate_operand (operands[0], E_V128BImode)
                      || pattern573 (x2, 
E_V128BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_793 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128BImode, 5))))
                    return NULL;
                  return gen_split_2445 (insn, operands);

                case E_V256BImode:
                  if (!nonimmediate_operand (operands[0], E_V256BImode)
                      || pattern573 (x2, 
E_V256BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_794 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256BImode, 5))))
                    return NULL;
                  return gen_split_2446 (insn, operands);

                case E_V512BImode:
                  if (!nonimmediate_operand (operands[0], E_V512BImode)
                      || pattern573 (x2, 
E_V512BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_795 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512BImode, 5))))
                    return NULL;
                  return gen_split_2447 (insn, operands);

                case E_V1024BImode:
                  if (!nonimmediate_operand (operands[0], E_V1024BImode)
                      || pattern573 (x2, 
E_V1024BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_796 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024BImode, 5))))
                    return NULL;
                  return gen_split_2448 (insn, operands);

                case E_V2048BImode:
                  if (!nonimmediate_operand (operands[0], E_V2048BImode)
                      || pattern573 (x2, 
E_V2048BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_797 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048BImode, 5))))
                    return NULL;
                  return gen_split_2449 (insn, operands);

                case E_V4096BImode:
                  if (!nonimmediate_operand (operands[0], E_V4096BImode)
                      || pattern573 (x2, 
E_V4096BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_798 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096BImode, 5))))
                    return NULL;
                  return gen_split_2450 (insn, operands);

                default:
                  return NULL;
                }

            case CONST_INT:
            case REG:
            case SUBREG:
              return split_124 (x1, insn);

            default:
              return NULL;
            }

        case 7:
          return split_132 (x1, insn);

        case 6:
          if (pattern262 (x3) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x3, 0, 1);
          operands[4] = x5;
          if (!vector_length_operand (operands[4], E_VOIDmode))
            return NULL;
          x6 = XVECEXP (x3, 0, 2);
          operands[5] = x6;
          if (!const_int_operand (operands[5], E_VOIDmode))
            return NULL;
          x9 = XVECEXP (x3, 0, 3);
          operands[6] = x9;
          if (!const_int_operand (operands[6], E_VOIDmode))
            return NULL;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          x8 = XEXP (x2, 2);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVMF64BImode:
              if (!register_operand (operands[0], E_RVVMF64BImode)
                  || pattern573 (x2, 
E_RVVMF64BImode) != 0
                  || !(
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return NULL;
              return gen_split_6307 (insn, operands);

            case E_RVVMF32BImode:
              if (!register_operand (operands[0], E_RVVMF32BImode)
                  || pattern573 (x2, 
E_RVVMF32BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6308 (insn, operands);

            case E_RVVMF16BImode:
              if (!register_operand (operands[0], E_RVVMF16BImode)
                  || pattern573 (x2, 
E_RVVMF16BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6309 (insn, operands);

            case E_RVVMF8BImode:
              if (!register_operand (operands[0], E_RVVMF8BImode)
                  || pattern573 (x2, 
E_RVVMF8BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6310 (insn, operands);

            case E_RVVMF4BImode:
              if (!register_operand (operands[0], E_RVVMF4BImode)
                  || pattern573 (x2, 
E_RVVMF4BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6311 (insn, operands);

            case E_RVVMF2BImode:
              if (!register_operand (operands[0], E_RVVMF2BImode)
                  || pattern573 (x2, 
E_RVVMF2BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6312 (insn, operands);

            case E_RVVM1BImode:
              if (!register_operand (operands[0], E_RVVM1BImode)
                  || pattern573 (x2, 
E_RVVM1BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6313 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      return split_133 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_165 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern124 (x2))
    {
    case 0:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2598 (insn, operands);

    case 1:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2612 (insn, operands);

    case 2:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2626 (insn, operands);

    case 3:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2640 (insn, operands);

    case 4:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2654 (insn, operands);

    case 5:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2668 (insn, operands);

    case 6:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2682 (insn, operands);

    case 7:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2696 (insn, operands);

    case 8:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2710 (insn, operands);

    case 9:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2724 (insn, operands);

    case 10:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2738 (insn, operands);

    case 11:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2752 (insn, operands);

    case 12:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2766 (insn, operands);

    case 13:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2780 (insn, operands);

    case 14:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2794 (insn, operands);

    case 15:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2808 (insn, operands);

    case 16:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2822 (insn, operands);

    case 17:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2836 (insn, operands);

    case 18:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2850 (insn, operands);

    case 19:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2864 (insn, operands);

    case 20:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2878 (insn, operands);

    case 21:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2892 (insn, operands);

    case 22:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2906 (insn, operands);

    case 23:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2920 (insn, operands);

    case 24:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2934 (insn, operands);

    case 25:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2948 (insn, operands);

    case 26:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2962 (insn, operands);

    case 27:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2976 (insn, operands);

    case 28:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2990 (insn, operands);

    case 29:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3004 (insn, operands);

    case 30:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3018 (insn, operands);

    case 31:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3032 (insn, operands);

    case 32:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3046 (insn, operands);

    case 33:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3060 (insn, operands);

    case 34:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3074 (insn, operands);

    case 35:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3088 (insn, operands);

    case 36:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3102 (insn, operands);

    case 37:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3116 (insn, operands);

    case 38:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3130 (insn, operands);

    case 39:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3144 (insn, operands);

    case 40:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3158 (insn, operands);

    case 41:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3172 (insn, operands);

    case 42:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3186 (insn, operands);

    case 43:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3200 (insn, operands);

    case 44:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3214 (insn, operands);

    case 45:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3228 (insn, operands);

    case 46:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3242 (insn, operands);

    case 47:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3256 (insn, operands);

    case 48:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3270 (insn, operands);

    case 49:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3284 (insn, operands);

    case 50:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3298 (insn, operands);

    case 51:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3312 (insn, operands);

    case 52:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3326 (insn, operands);

    case 53:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3340 (insn, operands);

    case 54:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3354 (insn, operands);

    case 55:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3368 (insn, operands);

    case 56:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3382 (insn, operands);

    case 57:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3396 (insn, operands);

    case 58:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3410 (insn, operands);

    case 59:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3424 (insn, operands);

    case 60:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3438 (insn, operands);

    case 61:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3452 (insn, operands);

    case 62:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3466 (insn, operands);

    case 63:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3480 (insn, operands);

    case 64:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3494 (insn, operands);

    case 65:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3508 (insn, operands);

    case 66:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3522 (insn, operands);

    case 67:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3536 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_174 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NOT
      || GET_MODE (x4) != E_DImode)
    return NULL;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return NULL;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != E_DImode)
    return NULL;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return NULL;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_SImode))
    return NULL;
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      x10 = XEXP (x6, 0);
      switch (pattern462 (x10))
        {
        case 0:
          if (!((
#line 734 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 739 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_155 (insn, operands);

        case 1:
          if (!((
#line 762 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 766 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_159 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x10 = XEXP (x6, 0);
      switch (pattern462 (x10))
        {
        case 0:
          if (!((
#line 734 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 739 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_156 (insn, operands);

        case 1:
          if (!((
#line 762 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 766 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_160 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_176 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  switch (pattern342 (x6))
    {
    case 0:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1581 (insn, operands);

    case 1:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1592 (insn, operands);

    case 2:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1582 (insn, operands);

    case 3:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1593 (insn, operands);

    case 4:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1583 (insn, operands);

    case 5:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1594 (insn, operands);

    case 6:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1584 (insn, operands);

    case 7:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1595 (insn, operands);

    case 8:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1585 (insn, operands);

    case 9:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1596 (insn, operands);

    case 10:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1586 (insn, operands);

    case 11:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1597 (insn, operands);

    case 12:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1587 (insn, operands);

    case 13:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1598 (insn, operands);

    case 14:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1588 (insn, operands);

    case 15:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1599 (insn, operands);

    case 16:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1589 (insn, operands);

    case 17:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1600 (insn, operands);

    case 18:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1590 (insn, operands);

    case 19:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1601 (insn, operands);

    case 20:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1591 (insn, operands);

    case 21:
      if (!((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1334 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1602 (insn, operands);

    case 22:
      if (!((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1356 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1603 (insn, operands);

    case 23:
      if (!((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1356 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1604 (insn, operands);

    case 24:
      if (!((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1356 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1605 (insn, operands);

    case 25:
      if (!((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1356 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1606 (insn, operands);

    case 26:
      if (!((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1356 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1607 (insn, operands);

    case 27:
      if (!((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1356 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1608 (insn, operands);

    case 28:
      if (!((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1356 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1609 (insn, operands);

    case 29:
      if (!((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1356 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1610 (insn, operands);

    case 30:
      if (!((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1356 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1611 (insn, operands);

    case 31:
      if (!((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1356 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1612 (insn, operands);

    case 32:
      if (!((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1356 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1613 (insn, operands);

    case 33:
      if (!((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1356 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1614 (insn, operands);

    case 34:
      if (!((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1356 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1615 (insn, operands);

    case 35:
      if (!((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1356 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1616 (insn, operands);

    case 36:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))) && (
#line 4348 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1987 (insn, operands);

    case 37:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))) && (
#line 4348 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1988 (insn, operands);

    case 38:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1989 (insn, operands);

    case 39:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1990 (insn, operands);

    case 40:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128QImode)
       || register_operand (operands[1], V128QImode))) && (
#line 4350 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1991 (insn, operands);

    case 41:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128QImode)
       || register_operand (operands[1], V128QImode))) && (
#line 4350 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1992 (insn, operands);

    case 42:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256QImode)
       || register_operand (operands[1], V256QImode))) && (
#line 4351 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1993 (insn, operands);

    case 43:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256QImode)
       || register_operand (operands[1], V256QImode))) && (
#line 4351 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1994 (insn, operands);

    case 44:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512QImode)
       || register_operand (operands[1], V512QImode))) && (
#line 4352 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1995 (insn, operands);

    case 45:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512QImode)
       || register_operand (operands[1], V512QImode))) && (
#line 4352 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1996 (insn, operands);

    case 46:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024QImode)
       || register_operand (operands[1], V1024QImode))) && (
#line 4353 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1997 (insn, operands);

    case 47:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024QImode)
       || register_operand (operands[1], V1024QImode))) && (
#line 4353 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1998 (insn, operands);

    case 48:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048QImode)
       || register_operand (operands[1], V2048QImode))) && (
#line 4354 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1999 (insn, operands);

    case 49:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048QImode)
       || register_operand (operands[1], V2048QImode))) && (
#line 4354 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2000 (insn, operands);

    case 50:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2001 (insn, operands);

    case 51:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2002 (insn, operands);

    case 52:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))) && (
#line 4356 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2003 (insn, operands);

    case 53:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))) && (
#line 4356 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2004 (insn, operands);

    case 54:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HImode)
       || register_operand (operands[1], V64HImode))) && (
#line 4357 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2005 (insn, operands);

    case 55:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HImode)
       || register_operand (operands[1], V64HImode))) && (
#line 4357 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2006 (insn, operands);

    case 56:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HImode)
       || register_operand (operands[1], V128HImode))) && (
#line 4358 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2007 (insn, operands);

    case 57:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HImode)
       || register_operand (operands[1], V128HImode))) && (
#line 4358 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2008 (insn, operands);

    case 58:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HImode)
       || register_operand (operands[1], V256HImode))) && (
#line 4359 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2009 (insn, operands);

    case 59:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HImode)
       || register_operand (operands[1], V256HImode))) && (
#line 4359 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2010 (insn, operands);

    case 60:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HImode)
       || register_operand (operands[1], V512HImode))) && (
#line 4360 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2011 (insn, operands);

    case 61:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HImode)
       || register_operand (operands[1], V512HImode))) && (
#line 4360 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2012 (insn, operands);

    case 62:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2013 (insn, operands);

    case 63:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2014 (insn, operands);

    case 64:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HImode)
       || register_operand (operands[1], V2048HImode))) && (
#line 4362 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2015 (insn, operands);

    case 65:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HImode)
       || register_operand (operands[1], V2048HImode))) && (
#line 4362 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2016 (insn, operands);

    case 66:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SImode)
       || register_operand (operands[1], V32SImode))) && (
#line 4363 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2017 (insn, operands);

    case 67:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SImode)
       || register_operand (operands[1], V32SImode))) && (
#line 4363 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2018 (insn, operands);

    case 68:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SImode)
       || register_operand (operands[1], V64SImode))) && (
#line 4364 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2019 (insn, operands);

    case 69:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SImode)
       || register_operand (operands[1], V64SImode))) && (
#line 4364 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2020 (insn, operands);

    case 70:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SImode)
       || register_operand (operands[1], V128SImode))) && (
#line 4365 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2021 (insn, operands);

    case 71:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SImode)
       || register_operand (operands[1], V128SImode))) && (
#line 4365 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2022 (insn, operands);

    case 72:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SImode)
       || register_operand (operands[1], V256SImode))) && (
#line 4366 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2023 (insn, operands);

    case 73:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SImode)
       || register_operand (operands[1], V256SImode))) && (
#line 4366 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2024 (insn, operands);

    case 74:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2025 (insn, operands);

    case 75:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2026 (insn, operands);

    case 76:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SImode)
       || register_operand (operands[1], V1024SImode))) && (
#line 4368 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2027 (insn, operands);

    case 77:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SImode)
       || register_operand (operands[1], V1024SImode))) && (
#line 4368 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2028 (insn, operands);

    case 78:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4369 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2029 (insn, operands);

    case 79:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4369 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2030 (insn, operands);

    case 80:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DImode)
       || register_operand (operands[1], V64DImode))) && (
#line 4370 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2031 (insn, operands);

    case 81:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DImode)
       || register_operand (operands[1], V64DImode))) && (
#line 4370 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2032 (insn, operands);

    case 82:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DImode)
       || register_operand (operands[1], V128DImode))) && (
#line 4371 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2033 (insn, operands);

    case 83:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DImode)
       || register_operand (operands[1], V128DImode))) && (
#line 4371 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2034 (insn, operands);

    case 84:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DImode)
       || register_operand (operands[1], V256DImode))) && (
#line 4372 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2035 (insn, operands);

    case 85:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DImode)
       || register_operand (operands[1], V256DImode))) && (
#line 4372 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2036 (insn, operands);

    case 86:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2037 (insn, operands);

    case 87:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2038 (insn, operands);

    case 88:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))) && (
#line 4374 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2039 (insn, operands);

    case 89:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))) && (
#line 4374 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2040 (insn, operands);

    case 90:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4375 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2041 (insn, operands);

    case 91:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4375 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2042 (insn, operands);

    case 92:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HFmode)
       || register_operand (operands[1], V128HFmode))) && (
#line 4376 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2043 (insn, operands);

    case 93:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HFmode)
       || register_operand (operands[1], V128HFmode))) && (
#line 4376 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2044 (insn, operands);

    case 94:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HFmode)
       || register_operand (operands[1], V256HFmode))) && (
#line 4377 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2045 (insn, operands);

    case 95:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HFmode)
       || register_operand (operands[1], V256HFmode))) && (
#line 4377 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2046 (insn, operands);

    case 96:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HFmode)
       || register_operand (operands[1], V512HFmode))) && (
#line 4378 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2047 (insn, operands);

    case 97:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HFmode)
       || register_operand (operands[1], V512HFmode))) && (
#line 4378 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2048 (insn, operands);

    case 98:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2049 (insn, operands);

    case 99:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2050 (insn, operands);

    case 100:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HFmode)
       || register_operand (operands[1], V2048HFmode))) && (
#line 4380 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2051 (insn, operands);

    case 101:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HFmode)
       || register_operand (operands[1], V2048HFmode))) && (
#line 4380 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2052 (insn, operands);

    case 102:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SFmode)
       || register_operand (operands[1], V32SFmode))) && (
#line 4381 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2053 (insn, operands);

    case 103:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SFmode)
       || register_operand (operands[1], V32SFmode))) && (
#line 4381 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2054 (insn, operands);

    case 104:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SFmode)
       || register_operand (operands[1], V64SFmode))) && (
#line 4382 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2055 (insn, operands);

    case 105:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SFmode)
       || register_operand (operands[1], V64SFmode))) && (
#line 4382 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2056 (insn, operands);

    case 106:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SFmode)
       || register_operand (operands[1], V128SFmode))) && (
#line 4383 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2057 (insn, operands);

    case 107:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SFmode)
       || register_operand (operands[1], V128SFmode))) && (
#line 4383 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2058 (insn, operands);

    case 108:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SFmode)
       || register_operand (operands[1], V256SFmode))) && (
#line 4384 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2059 (insn, operands);

    case 109:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SFmode)
       || register_operand (operands[1], V256SFmode))) && (
#line 4384 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2060 (insn, operands);

    case 110:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4385 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2061 (insn, operands);

    case 111:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4385 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2062 (insn, operands);

    case 112:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SFmode)
       || register_operand (operands[1], V1024SFmode))) && (
#line 4386 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2063 (insn, operands);

    case 113:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SFmode)
       || register_operand (operands[1], V1024SFmode))) && (
#line 4386 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2064 (insn, operands);

    case 114:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DFmode)
       || register_operand (operands[1], V32DFmode))) && (
#line 4387 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2065 (insn, operands);

    case 115:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DFmode)
       || register_operand (operands[1], V32DFmode))) && (
#line 4387 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2066 (insn, operands);

    case 116:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DFmode)
       || register_operand (operands[1], V64DFmode))) && (
#line 4388 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2067 (insn, operands);

    case 117:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DFmode)
       || register_operand (operands[1], V64DFmode))) && (
#line 4388 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2068 (insn, operands);

    case 118:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DFmode)
       || register_operand (operands[1], V128DFmode))) && (
#line 4389 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2069 (insn, operands);

    case 119:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DFmode)
       || register_operand (operands[1], V128DFmode))) && (
#line 4389 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2070 (insn, operands);

    case 120:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4390 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2071 (insn, operands);

    case 121:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4390 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2072 (insn, operands);

    case 122:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DFmode)
       || register_operand (operands[1], V512DFmode))) && (
#line 4391 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2073 (insn, operands);

    case 123:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DFmode)
       || register_operand (operands[1], V512DFmode))) && (
#line 4391 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2074 (insn, operands);

    case 124:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4393 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2075 (insn, operands);

    case 125:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4393 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2076 (insn, operands);

    case 126:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64BImode)
       || register_operand (operands[1], V64BImode))) && (
#line 4394 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2077 (insn, operands);

    case 127:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64BImode)
       || register_operand (operands[1], V64BImode))) && (
#line 4394 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2078 (insn, operands);

    case 128:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4395 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2079 (insn, operands);

    case 129:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4395 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2080 (insn, operands);

    case 130:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256BImode)
       || register_operand (operands[1], V256BImode))) && (
#line 4396 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2081 (insn, operands);

    case 131:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256BImode)
       || register_operand (operands[1], V256BImode))) && (
#line 4396 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2082 (insn, operands);

    case 132:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512BImode)
       || register_operand (operands[1], V512BImode))) && (
#line 4397 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2083 (insn, operands);

    case 133:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512BImode)
       || register_operand (operands[1], V512BImode))) && (
#line 4397 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2084 (insn, operands);

    case 134:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024BImode)
       || register_operand (operands[1], V1024BImode))) && (
#line 4398 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2085 (insn, operands);

    case 135:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024BImode)
       || register_operand (operands[1], V1024BImode))) && (
#line 4398 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2086 (insn, operands);

    case 136:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4399 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2087 (insn, operands);

    case 137:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4399 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2088 (insn, operands);

    case 138:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096BImode)
       || register_operand (operands[1], V4096BImode))) && (
#line 4400 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2089 (insn, operands);

    case 139:
      if (!((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096BImode)
       || register_operand (operands[1], V4096BImode))) && (
#line 4400 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1482 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2090 (insn, operands);

    default:
      return NULL;
    }
}
