/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_HFmode:
      if (pattern0 (x3, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 4;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 5;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 6;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 7;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 8;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 9;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 10;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 11;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 16;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 17;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 18;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 19;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 22;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 23;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 24;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 26;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 27;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 28;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 29;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 30;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 31;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 32;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 33;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 34;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 35;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 36;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 37;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 38;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 39;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 40;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 41;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 42;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 43;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 44;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 45;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 46;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 47;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 48;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 49;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 50;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 51;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 52;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 53;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 54;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 55;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 56;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 57;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 58;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 59;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 60;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 61;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 62;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 63;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 64;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 65;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 66;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 67;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 68;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 69;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 70;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 71;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 72;

    case E_RVVM8HFmode:
      if (pattern0 (x3, 
E_RVVM8HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM4HFmode:
      if (pattern0 (x3, 
E_RVVM4HFmode) != 0)
        return -1;
      return 74;

    case E_RVVM2HFmode:
      if (pattern0 (x3, 
E_RVVM2HFmode) != 0)
        return -1;
      return 75;

    case E_RVVM1HFmode:
      if (pattern0 (x3, 
E_RVVM1HFmode) != 0)
        return -1;
      return 76;

    case E_RVVMF2HFmode:
      if (pattern0 (x3, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF4HFmode:
      if (pattern0 (x3, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8SFmode:
      if (pattern0 (x3, 
E_RVVM8SFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4SFmode:
      if (pattern0 (x3, 
E_RVVM4SFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2SFmode:
      if (pattern0 (x3, 
E_RVVM2SFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1SFmode:
      if (pattern0 (x3, 
E_RVVM1SFmode) != 0)
        return -1;
      return 82;

    case E_RVVMF2SFmode:
      if (pattern0 (x3, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 83;

    case E_RVVM8DFmode:
      if (pattern0 (x3, 
E_RVVM8DFmode) != 0)
        return -1;
      return 84;

    case E_RVVM4DFmode:
      if (pattern0 (x3, 
E_RVVM4DFmode) != 0)
        return -1;
      return 85;

    case E_RVVM2DFmode:
      if (pattern0 (x3, 
E_RVVM2DFmode) != 0)
        return -1;
      return 86;

    case E_RVVM1DFmode:
      if (pattern0 (x3, 
E_RVVM1DFmode) != 0)
        return -1;
      return 87;

    case E_V1HFmode:
      if (pattern0 (x3, 
E_V1HFmode) != 0)
        return -1;
      return 88;

    case E_V2HFmode:
      if (pattern0 (x3, 
E_V2HFmode) != 0)
        return -1;
      return 89;

    case E_V4HFmode:
      if (pattern0 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 90;

    case E_V8HFmode:
      if (pattern0 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 91;

    case E_V16HFmode:
      if (pattern0 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 92;

    case E_V32HFmode:
      if (pattern0 (x3, 
E_V32HFmode) != 0)
        return -1;
      return 93;

    case E_V64HFmode:
      if (pattern0 (x3, 
E_V64HFmode) != 0)
        return -1;
      return 94;

    case E_V128HFmode:
      if (pattern0 (x3, 
E_V128HFmode) != 0)
        return -1;
      return 95;

    case E_V256HFmode:
      if (pattern0 (x3, 
E_V256HFmode) != 0)
        return -1;
      return 96;

    case E_V512HFmode:
      if (pattern0 (x3, 
E_V512HFmode) != 0)
        return -1;
      return 97;

    case E_V1024HFmode:
      if (pattern0 (x3, 
E_V1024HFmode) != 0)
        return -1;
      return 98;

    case E_V2048HFmode:
      if (pattern0 (x3, 
E_V2048HFmode) != 0)
        return -1;
      return 99;

    case E_V1SFmode:
      if (pattern0 (x3, 
E_V1SFmode) != 0)
        return -1;
      return 100;

    case E_V2SFmode:
      if (pattern0 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 101;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 102;

    case E_V8SFmode:
      if (pattern0 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 103;

    case E_V16SFmode:
      if (pattern0 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 104;

    case E_V32SFmode:
      if (pattern0 (x3, 
E_V32SFmode) != 0)
        return -1;
      return 105;

    case E_V64SFmode:
      if (pattern0 (x3, 
E_V64SFmode) != 0)
        return -1;
      return 106;

    case E_V128SFmode:
      if (pattern0 (x3, 
E_V128SFmode) != 0)
        return -1;
      return 107;

    case E_V256SFmode:
      if (pattern0 (x3, 
E_V256SFmode) != 0)
        return -1;
      return 108;

    case E_V512SFmode:
      if (pattern0 (x3, 
E_V512SFmode) != 0)
        return -1;
      return 109;

    case E_V1024SFmode:
      if (pattern0 (x3, 
E_V1024SFmode) != 0)
        return -1;
      return 110;

    case E_V1DFmode:
      if (pattern0 (x3, 
E_V1DFmode) != 0)
        return -1;
      return 111;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 112;

    case E_V4DFmode:
      if (pattern0 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 113;

    case E_V8DFmode:
      if (pattern0 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 114;

    case E_V16DFmode:
      if (pattern0 (x3, 
E_V16DFmode) != 0)
        return -1;
      return 115;

    case E_V32DFmode:
      if (pattern0 (x3, 
E_V32DFmode) != 0)
        return -1;
      return 116;

    case E_V64DFmode:
      if (pattern0 (x3, 
E_V64DFmode) != 0)
        return -1;
      return 117;

    case E_V128DFmode:
      if (pattern0 (x3, 
E_V128DFmode) != 0)
        return -1;
      return 118;

    case E_V256DFmode:
      if (pattern0 (x3, 
E_V256DFmode) != 0)
        return -1;
      return 119;

    case E_V512DFmode:
      if (pattern0 (x3, 
E_V512DFmode) != 0)
        return -1;
      return 120;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 2)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XEXP (x6, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i5)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 2)
    return -1;
  x16 = XEXP (x14, 1);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XEXP (x12, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != i4)
    return -1;
  x18 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x18) != SET)
    return -1;
  x19 = XEXP (x18, 1);
  if (GET_CODE (x19) != MEM)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != PLUS)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 2)
    return -1;
  x22 = XEXP (x20, 1);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XEXP (x18, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != i3)
    return -1;
  x24 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x24) != SET)
    return -1;
  x25 = XEXP (x24, 1);
  if (GET_CODE (x25) != MEM)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != PLUS)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XEXP (x24, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != i2)
    return -1;
  x30 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x30) != SET)
    return -1;
  x31 = XEXP (x30, 1);
  if (GET_CODE (x31) != MEM)
    return -1;
  x32 = XEXP (x31, 0);
  if (GET_CODE (x32) != PLUS)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 2)
    return -1;
  x34 = XEXP (x32, 1);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XEXP (x30, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != i1)
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern53 (x1); /* [-1, 1] */

    case E_RVVM4HFmode:
      res = pattern54 (x1);
      if (res >= 0)
        return res + 2; /* [2, 4] */
      return -1;

    case E_RVVM2HFmode:
      res = pattern55 (x1);
      if (res >= 0)
        return res + 5; /* [5, 7] */
      return -1;

    case E_RVVM1HFmode:
      res = pattern56 (x1);
      if (res >= 0)
        return res + 8; /* [8, 10] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern57 (x1);
      if (res >= 0)
        return res + 11; /* [11, 13] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern58 (x1);
      if (res >= 0)
        return res + 14; /* [14, 16] */
      return -1;

    case E_RVVM8SFmode:
      res = pattern59 (x1);
      if (res >= 0)
        return res + 17; /* [17, 18] */
      return -1;

    case E_RVVM4SFmode:
      res = pattern60 (x1);
      if (res >= 0)
        return res + 19; /* [19, 21] */
      return -1;

    case E_RVVM2SFmode:
      res = pattern61 (x1);
      if (res >= 0)
        return res + 22; /* [22, 24] */
      return -1;

    case E_RVVM1SFmode:
      res = pattern62 (x1);
      if (res >= 0)
        return res + 25; /* [25, 27] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern63 (x1);
      if (res >= 0)
        return res + 28; /* [28, 30] */
      return -1;

    case E_RVVM8DFmode:
      res = pattern64 (x1);
      if (res >= 0)
        return res + 31; /* [31, 32] */
      return -1;

    case E_RVVM4DFmode:
      res = pattern65 (x1);
      if (res >= 0)
        return res + 33; /* [33, 34] */
      return -1;

    case E_RVVM2DFmode:
      res = pattern66 (x1);
      if (res >= 0)
        return res + 35; /* [35, 36] */
      return -1;

    case E_RVVM1DFmode:
      res = pattern67 (x1);
      if (res >= 0)
        return res + 37; /* [37, 38] */
      return -1;

    case E_V1HFmode:
      res = pattern68 (x1);
      if (res >= 0)
        return res + 39; /* [39, 41] */
      return -1;

    case E_V2HFmode:
      res = pattern69 (x1);
      if (res >= 0)
        return res + 42; /* [42, 44] */
      return -1;

    case E_V4HFmode:
      res = pattern70 (x1);
      if (res >= 0)
        return res + 45; /* [45, 47] */
      return -1;

    case E_V8HFmode:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 48; /* [48, 50] */
      return -1;

    case E_V16HFmode:
      res = pattern72 (x1);
      if (res >= 0)
        return res + 51; /* [51, 53] */
      return -1;

    case E_V32HFmode:
      res = pattern73 (x1);
      if (res >= 0)
        return res + 54; /* [54, 56] */
      return -1;

    case E_V64HFmode:
      res = pattern74 (x1);
      if (res >= 0)
        return res + 57; /* [57, 59] */
      return -1;

    case E_V128HFmode:
      res = pattern75 (x1);
      if (res >= 0)
        return res + 60; /* [60, 62] */
      return -1;

    case E_V256HFmode:
      res = pattern76 (x1);
      if (res >= 0)
        return res + 63; /* [63, 65] */
      return -1;

    case E_V512HFmode:
      res = pattern77 (x1);
      if (res >= 0)
        return res + 66; /* [66, 68] */
      return -1;

    case E_V1024HFmode:
      res = pattern78 (x1);
      if (res >= 0)
        return res + 69; /* [69, 71] */
      return -1;

    case E_V2048HFmode:
      res = pattern79 (x1);
      if (res >= 0)
        return res + 72; /* [72, 73] */
      return -1;

    case E_V1SFmode:
      res = pattern80 (x1);
      if (res >= 0)
        return res + 74; /* [74, 76] */
      return -1;

    case E_V2SFmode:
      res = pattern81 (x1);
      if (res >= 0)
        return res + 77; /* [77, 79] */
      return -1;

    case E_V4SFmode:
      res = pattern82 (x1);
      if (res >= 0)
        return res + 80; /* [80, 82] */
      return -1;

    case E_V8SFmode:
      res = pattern83 (x1);
      if (res >= 0)
        return res + 83; /* [83, 85] */
      return -1;

    case E_V16SFmode:
      res = pattern84 (x1);
      if (res >= 0)
        return res + 86; /* [86, 88] */
      return -1;

    case E_V32SFmode:
      res = pattern85 (x1);
      if (res >= 0)
        return res + 89; /* [89, 91] */
      return -1;

    case E_V64SFmode:
      res = pattern86 (x1);
      if (res >= 0)
        return res + 92; /* [92, 94] */
      return -1;

    case E_V128SFmode:
      res = pattern87 (x1);
      if (res >= 0)
        return res + 95; /* [95, 97] */
      return -1;

    case E_V256SFmode:
      res = pattern88 (x1);
      if (res >= 0)
        return res + 98; /* [98, 100] */
      return -1;

    case E_V512SFmode:
      res = pattern89 (x1);
      if (res >= 0)
        return res + 101; /* [101, 103] */
      return -1;

    case E_V1024SFmode:
      res = pattern90 (x1);
      if (res >= 0)
        return res + 104; /* [104, 105] */
      return -1;

    case E_V1DFmode:
      res = pattern91 (x1);
      if (res >= 0)
        return res + 106; /* [106, 107] */
      return -1;

    case E_V2DFmode:
      res = pattern92 (x1);
      if (res >= 0)
        return res + 108; /* [108, 109] */
      return -1;

    case E_V4DFmode:
      res = pattern93 (x1);
      if (res >= 0)
        return res + 110; /* [110, 111] */
      return -1;

    case E_V8DFmode:
      res = pattern94 (x1);
      if (res >= 0)
        return res + 112; /* [112, 113] */
      return -1;

    case E_V16DFmode:
      res = pattern95 (x1);
      if (res >= 0)
        return res + 114; /* [114, 115] */
      return -1;

    case E_V32DFmode:
      res = pattern96 (x1);
      if (res >= 0)
        return res + 116; /* [116, 117] */
      return -1;

    case E_V64DFmode:
      res = pattern97 (x1);
      if (res >= 0)
        return res + 118; /* [118, 119] */
      return -1;

    case E_V128DFmode:
      res = pattern98 (x1);
      if (res >= 0)
        return res + 120; /* [120, 121] */
      return -1;

    case E_V256DFmode:
      res = pattern99 (x1);
      if (res >= 0)
        return res + 122; /* [122, 123] */
      return -1;

    case E_V512DFmode:
      res = pattern100 (x1);
      if (res >= 0)
        return res + 124; /* [124, 125] */
      return -1;

    default:
      return -1;
    }
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern143 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern143 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern143 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern143 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern143 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern143 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern143 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern143 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern143 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern143 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern143 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern143 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern143 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern143 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern143 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern143 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern143 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern143 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern143 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern143 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern143 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern143 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern143 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern143 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern143 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern143 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern143 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern143 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern143 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern143 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern143 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern143 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern143 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern143 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern143 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern143 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern143 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern143 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern143 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern143 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern143 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern143 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern143 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern143 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern143 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern143 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern143 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern143 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern157 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !vector_shift_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTEND)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HImode:
          return pattern156 (x1, 
E_RVVM2QImode, 
E_RVVM8SImode, 
E_RVVM4HImode); /* [-1, 0] */

        case E_RVVM2HImode:
          if (pattern156 (x1, 
E_RVVM1QImode, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 1;

        case E_RVVM1HImode:
          if (pattern156 (x1, 
E_RVVMF2QImode, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 2;

        case E_RVVMF2HImode:
          if (pattern156 (x1, 
E_RVVMF4QImode, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 3;

        case E_RVVMF4HImode:
          if (pattern156 (x1, 
E_RVVMF8QImode, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 4;

        case E_RVVM4SImode:
          if (pattern156 (x1, 
E_RVVM2HImode, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 5;

        case E_RVVM2SImode:
          if (pattern156 (x1, 
E_RVVM1HImode, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 6;

        case E_RVVM1SImode:
          if (pattern156 (x1, 
E_RVVMF2HImode, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 7;

        case E_RVVMF2SImode:
          if (pattern156 (x1, 
E_RVVMF4HImode, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 8;

        case E_V1HImode:
          if (pattern156 (x1, 
E_V1QImode, 
E_V1SImode, 
E_V1HImode) != 0)
            return -1;
          return 9;

        case E_V2HImode:
          if (pattern156 (x1, 
E_V2QImode, 
E_V2SImode, 
E_V2HImode) != 0)
            return -1;
          return 10;

        case E_V4HImode:
          if (pattern156 (x1, 
E_V4QImode, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 11;

        case E_V8HImode:
          if (pattern156 (x1, 
E_V8QImode, 
E_V8SImode, 
E_V8HImode) != 0)
            return -1;
          return 12;

        case E_V16HImode:
          if (pattern156 (x1, 
E_V16QImode, 
E_V16SImode, 
E_V16HImode) != 0)
            return -1;
          return 13;

        case E_V32HImode:
          if (pattern156 (x1, 
E_V32QImode, 
E_V32SImode, 
E_V32HImode) != 0)
            return -1;
          return 14;

        case E_V64HImode:
          if (pattern156 (x1, 
E_V64QImode, 
E_V64SImode, 
E_V64HImode) != 0)
            return -1;
          return 15;

        case E_V128HImode:
          if (pattern156 (x1, 
E_V128QImode, 
E_V128SImode, 
E_V128HImode) != 0)
            return -1;
          return 16;

        case E_V256HImode:
          if (pattern156 (x1, 
E_V256QImode, 
E_V256SImode, 
E_V256HImode) != 0)
            return -1;
          return 17;

        case E_V512HImode:
          if (pattern156 (x1, 
E_V512QImode, 
E_V512SImode, 
E_V512HImode) != 0)
            return -1;
          return 18;

        case E_V1024HImode:
          if (pattern156 (x1, 
E_V1024QImode, 
E_V1024SImode, 
E_V1024HImode) != 0)
            return -1;
          return 19;

        case E_V1SImode:
          if (pattern156 (x1, 
E_V1HImode, 
E_V1DImode, 
E_V1SImode) != 0)
            return -1;
          return 20;

        case E_V2SImode:
          if (pattern156 (x1, 
E_V2HImode, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 21;

        case E_V4SImode:
          if (pattern156 (x1, 
E_V4HImode, 
E_V4DImode, 
E_V4SImode) != 0)
            return -1;
          return 22;

        case E_V8SImode:
          if (pattern156 (x1, 
E_V8HImode, 
E_V8DImode, 
E_V8SImode) != 0)
            return -1;
          return 23;

        case E_V16SImode:
          if (pattern156 (x1, 
E_V16HImode, 
E_V16DImode, 
E_V16SImode) != 0)
            return -1;
          return 24;

        case E_V32SImode:
          if (pattern156 (x1, 
E_V32HImode, 
E_V32DImode, 
E_V32SImode) != 0)
            return -1;
          return 25;

        case E_V64SImode:
          if (pattern156 (x1, 
E_V64HImode, 
E_V64DImode, 
E_V64SImode) != 0)
            return -1;
          return 26;

        case E_V128SImode:
          if (pattern156 (x1, 
E_V128HImode, 
E_V128DImode, 
E_V128SImode) != 0)
            return -1;
          return 27;

        case E_V256SImode:
          if (pattern156 (x1, 
E_V256HImode, 
E_V256DImode, 
E_V256SImode) != 0)
            return -1;
          return 28;

        case E_V512SImode:
          if (pattern156 (x1, 
E_V512HImode, 
E_V512DImode, 
E_V512SImode) != 0)
            return -1;
          return 29;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HImode:
          if (pattern157 (x1, 
E_RVVM2QImode, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0)
            return -1;
          return 30;

        case E_RVVM2HImode:
          if (pattern157 (x1, 
E_RVVM1QImode, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 31;

        case E_RVVM1HImode:
          if (pattern157 (x1, 
E_RVVMF2QImode, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 32;

        case E_RVVMF2HImode:
          if (pattern157 (x1, 
E_RVVMF4QImode, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 33;

        case E_RVVMF4HImode:
          if (pattern157 (x1, 
E_RVVMF8QImode, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 34;

        case E_RVVM4SImode:
          if (pattern157 (x1, 
E_RVVM2HImode, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 35;

        case E_RVVM2SImode:
          if (pattern157 (x1, 
E_RVVM1HImode, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 36;

        case E_RVVM1SImode:
          if (pattern157 (x1, 
E_RVVMF2HImode, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 37;

        case E_RVVMF2SImode:
          if (pattern157 (x1, 
E_RVVMF4HImode, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 38;

        case E_V1HImode:
          if (pattern157 (x1, 
E_V1QImode, 
E_V1SImode, 
E_V1HImode) != 0)
            return -1;
          return 39;

        case E_V2HImode:
          if (pattern157 (x1, 
E_V2QImode, 
E_V2SImode, 
E_V2HImode) != 0)
            return -1;
          return 40;

        case E_V4HImode:
          if (pattern157 (x1, 
E_V4QImode, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 41;

        case E_V8HImode:
          if (pattern157 (x1, 
E_V8QImode, 
E_V8SImode, 
E_V8HImode) != 0)
            return -1;
          return 42;

        case E_V16HImode:
          if (pattern157 (x1, 
E_V16QImode, 
E_V16SImode, 
E_V16HImode) != 0)
            return -1;
          return 43;

        case E_V32HImode:
          if (pattern157 (x1, 
E_V32QImode, 
E_V32SImode, 
E_V32HImode) != 0)
            return -1;
          return 44;

        case E_V64HImode:
          if (pattern157 (x1, 
E_V64QImode, 
E_V64SImode, 
E_V64HImode) != 0)
            return -1;
          return 45;

        case E_V128HImode:
          if (pattern157 (x1, 
E_V128QImode, 
E_V128SImode, 
E_V128HImode) != 0)
            return -1;
          return 46;

        case E_V256HImode:
          if (pattern157 (x1, 
E_V256QImode, 
E_V256SImode, 
E_V256HImode) != 0)
            return -1;
          return 47;

        case E_V512HImode:
          if (pattern157 (x1, 
E_V512QImode, 
E_V512SImode, 
E_V512HImode) != 0)
            return -1;
          return 48;

        case E_V1024HImode:
          if (pattern157 (x1, 
E_V1024QImode, 
E_V1024SImode, 
E_V1024HImode) != 0)
            return -1;
          return 49;

        case E_V1SImode:
          if (pattern157 (x1, 
E_V1HImode, 
E_V1DImode, 
E_V1SImode) != 0)
            return -1;
          return 50;

        case E_V2SImode:
          if (pattern157 (x1, 
E_V2HImode, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 51;

        case E_V4SImode:
          if (pattern157 (x1, 
E_V4HImode, 
E_V4DImode, 
E_V4SImode) != 0)
            return -1;
          return 52;

        case E_V8SImode:
          if (pattern157 (x1, 
E_V8HImode, 
E_V8DImode, 
E_V8SImode) != 0)
            return -1;
          return 53;

        case E_V16SImode:
          if (pattern157 (x1, 
E_V16HImode, 
E_V16DImode, 
E_V16SImode) != 0)
            return -1;
          return 54;

        case E_V32SImode:
          if (pattern157 (x1, 
E_V32HImode, 
E_V32DImode, 
E_V32SImode) != 0)
            return -1;
          return 55;

        case E_V64SImode:
          if (pattern157 (x1, 
E_V64HImode, 
E_V64DImode, 
E_V64SImode) != 0)
            return -1;
          return 56;

        case E_V128SImode:
          if (pattern157 (x1, 
E_V128HImode, 
E_V128DImode, 
E_V128SImode) != 0)
            return -1;
          return 57;

        case E_V256SImode:
          if (pattern157 (x1, 
E_V256HImode, 
E_V256DImode, 
E_V256SImode) != 0)
            return -1;
          return 58;

        case E_V512SImode:
          if (pattern157 (x1, 
E_V512HImode, 
E_V512DImode, 
E_V512SImode) != 0)
            return -1;
          return 59;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  if (!const_int2_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern198 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern199 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !vector_shift_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern203 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2
      || !vector_shift_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern204 (x1, 
E_RVVM8HImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM4HImode
          || !register_operand (operands[3], E_RVVM4HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[2], E_RVVM4HFmode))
            return -1;
          return 1;

        case E_RVVM8SFmode:
          if (!register_operand (operands[2], E_RVVM8SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM2HImode
          || !register_operand (operands[3], E_RVVM2HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[2], E_RVVM2HFmode))
            return -1;
          return 3;

        case E_RVVM4SFmode:
          if (!register_operand (operands[2], E_RVVM4SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM1HImode
          || !register_operand (operands[3], E_RVVM1HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[2], E_RVVM1HFmode))
            return -1;
          return 5;

        case E_RVVM2SFmode:
          if (!register_operand (operands[2], E_RVVM2SFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVMF2HImode
          || !register_operand (operands[3], E_RVVMF2HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[2], E_RVVMF2HFmode))
            return -1;
          return 7;

        case E_RVVM1SFmode:
          if (!register_operand (operands[2], E_RVVM1SFmode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF4HImode
          || !register_operand (operands[3], E_RVVMF4HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[2], E_RVVMF4HFmode))
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[2], E_RVVMF2SFmode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM8SImode
          || !register_operand (operands[3], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8SFmode:
          if (!register_operand (operands[2], E_RVVM8SFmode))
            return -1;
          return 11;

        case E_RVVM4HFmode:
          if (!register_operand (operands[2], E_RVVM4HFmode))
            return -1;
          return 12;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM4SImode
          || !register_operand (operands[3], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4SFmode:
          if (!register_operand (operands[2], E_RVVM4SFmode))
            return -1;
          return 13;

        case E_RVVM2HFmode:
          if (!register_operand (operands[2], E_RVVM2HFmode))
            return -1;
          return 14;

        case E_RVVM8DFmode:
          if (!register_operand (operands[2], E_RVVM8DFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM2SImode
          || !register_operand (operands[3], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2SFmode:
          if (!register_operand (operands[2], E_RVVM2SFmode))
            return -1;
          return 16;

        case E_RVVM1HFmode:
          if (!register_operand (operands[2], E_RVVM1HFmode))
            return -1;
          return 17;

        case E_RVVM4DFmode:
          if (!register_operand (operands[2], E_RVVM4DFmode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM1SImode
          || !register_operand (operands[3], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1SFmode:
          if (!register_operand (operands[2], E_RVVM1SFmode))
            return -1;
          return 19;

        case E_RVVMF2HFmode:
          if (!register_operand (operands[2], E_RVVMF2HFmode))
            return -1;
          return 20;

        case E_RVVM2DFmode:
          if (!register_operand (operands[2], E_RVVM2DFmode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF2SImode
          || !register_operand (operands[3], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2SFmode:
          if (!register_operand (operands[2], E_RVVMF2SFmode))
            return -1;
          return 22;

        case E_RVVMF4HFmode:
          if (!register_operand (operands[2], E_RVVMF4HFmode))
            return -1;
          return 23;

        case E_RVVM1DFmode:
          if (!register_operand (operands[2], E_RVVM1DFmode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM8DImode
          || !register_operand (operands[3], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8DFmode:
          if (!register_operand (operands[2], E_RVVM8DFmode))
            return -1;
          return 25;

        case E_RVVM4SFmode:
          if (!register_operand (operands[2], E_RVVM4SFmode))
            return -1;
          return 26;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM4DImode
          || !register_operand (operands[3], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4DFmode:
          if (!register_operand (operands[2], E_RVVM4DFmode))
            return -1;
          return 27;

        case E_RVVM2SFmode:
          if (!register_operand (operands[2], E_RVVM2SFmode))
            return -1;
          return 28;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM2DImode
          || !register_operand (operands[3], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2DFmode:
          if (!register_operand (operands[2], E_RVVM2DFmode))
            return -1;
          return 29;

        case E_RVVM1SFmode:
          if (!register_operand (operands[2], E_RVVM1SFmode))
            return -1;
          return 30;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVM1DImode
          || !register_operand (operands[3], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1DFmode:
          if (!register_operand (operands[2], E_RVVM1DFmode))
            return -1;
          return 31;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[2], E_RVVMF2SFmode))
            return -1;
          return 32;

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1HImode
          || !register_operand (operands[3], E_V1HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1HFmode:
          if (!register_operand (operands[2], E_V1HFmode))
            return -1;
          return 33;

        case E_V1SFmode:
          if (!register_operand (operands[2], E_V1SFmode))
            return -1;
          return 34;

        default:
          return -1;
        }

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[3], E_V2HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[2], E_V2HFmode))
            return -1;
          return 35;

        case E_V2SFmode:
          if (!register_operand (operands[2], E_V2SFmode))
            return -1;
          return 36;

        default:
          return -1;
        }

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[3], E_V4HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[2], E_V4HFmode))
            return -1;
          return 37;

        case E_V4SFmode:
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          return 38;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[3], E_V8HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[2], E_V8HFmode))
            return -1;
          return 39;

        case E_V8SFmode:
          if (!register_operand (operands[2], E_V8SFmode))
            return -1;
          return 40;

        default:
          return -1;
        }

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16HImode
          || !register_operand (operands[3], E_V16HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16HFmode:
          if (!register_operand (operands[2], E_V16HFmode))
            return -1;
          return 41;

        case E_V16SFmode:
          if (!register_operand (operands[2], E_V16SFmode))
            return -1;
          return 42;

        default:
          return -1;
        }

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32HImode
          || !register_operand (operands[3], E_V32HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[2], E_V32HFmode))
            return -1;
          return 43;

        case E_V32SFmode:
          if (!register_operand (operands[2], E_V32SFmode))
            return -1;
          return 44;

        default:
          return -1;
        }

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64HImode
          || !register_operand (operands[3], E_V64HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64HFmode:
          if (!register_operand (operands[2], E_V64HFmode))
            return -1;
          return 45;

        case E_V64SFmode:
          if (!register_operand (operands[2], E_V64SFmode))
            return -1;
          return 46;

        default:
          return -1;
        }

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128HImode
          || !register_operand (operands[3], E_V128HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128HFmode:
          if (!register_operand (operands[2], E_V128HFmode))
            return -1;
          return 47;

        case E_V128SFmode:
          if (!register_operand (operands[2], E_V128SFmode))
            return -1;
          return 48;

        default:
          return -1;
        }

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256HImode
          || !register_operand (operands[3], E_V256HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256HFmode:
          if (!register_operand (operands[2], E_V256HFmode))
            return -1;
          return 49;

        case E_V256SFmode:
          if (!register_operand (operands[2], E_V256SFmode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512HImode
          || !register_operand (operands[3], E_V512HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512HFmode:
          if (!register_operand (operands[2], E_V512HFmode))
            return -1;
          return 51;

        case E_V512SFmode:
          if (!register_operand (operands[2], E_V512SFmode))
            return -1;
          return 52;

        default:
          return -1;
        }

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024HImode
          || !register_operand (operands[3], E_V1024HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024HFmode:
          if (!register_operand (operands[2], E_V1024HFmode))
            return -1;
          return 53;

        case E_V1024SFmode:
          if (!register_operand (operands[2], E_V1024SFmode))
            return -1;
          return 54;

        default:
          return -1;
        }

    case E_V2048HImode:
      if (pattern204 (x1, 
E_V2048HImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 55;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1SImode
          || !register_operand (operands[3], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1SFmode:
          if (!register_operand (operands[2], E_V1SFmode))
            return -1;
          return 56;

        case E_V1HFmode:
          if (!register_operand (operands[2], E_V1HFmode))
            return -1;
          return 57;

        case E_V1DFmode:
          if (!register_operand (operands[2], E_V1DFmode))
            return -1;
          return 58;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[3], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[2], E_V2SFmode))
            return -1;
          return 59;

        case E_V2HFmode:
          if (!register_operand (operands[2], E_V2HFmode))
            return -1;
          return 60;

        case E_V2DFmode:
          if (!register_operand (operands[2], E_V2DFmode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[3], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          return 62;

        case E_V4HFmode:
          if (!register_operand (operands[2], E_V4HFmode))
            return -1;
          return 63;

        case E_V4DFmode:
          if (!register_operand (operands[2], E_V4DFmode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8SImode
          || !register_operand (operands[3], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[2], E_V8SFmode))
            return -1;
          return 65;

        case E_V8HFmode:
          if (!register_operand (operands[2], E_V8HFmode))
            return -1;
          return 66;

        case E_V8DFmode:
          if (!register_operand (operands[2], E_V8DFmode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16SImode
          || !register_operand (operands[3], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16SFmode:
          if (!register_operand (operands[2], E_V16SFmode))
            return -1;
          return 68;

        case E_V16HFmode:
          if (!register_operand (operands[2], E_V16HFmode))
            return -1;
          return 69;

        case E_V16DFmode:
          if (!register_operand (operands[2], E_V16DFmode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32SImode
          || !register_operand (operands[3], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32SFmode:
          if (!register_operand (operands[2], E_V32SFmode))
            return -1;
          return 71;

        case E_V32HFmode:
          if (!register_operand (operands[2], E_V32HFmode))
            return -1;
          return 72;

        case E_V32DFmode:
          if (!register_operand (operands[2], E_V32DFmode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64SImode
          || !register_operand (operands[3], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64SFmode:
          if (!register_operand (operands[2], E_V64SFmode))
            return -1;
          return 74;

        case E_V64HFmode:
          if (!register_operand (operands[2], E_V64HFmode))
            return -1;
          return 75;

        case E_V64DFmode:
          if (!register_operand (operands[2], E_V64DFmode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128SImode
          || !register_operand (operands[3], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128SFmode:
          if (!register_operand (operands[2], E_V128SFmode))
            return -1;
          return 77;

        case E_V128HFmode:
          if (!register_operand (operands[2], E_V128HFmode))
            return -1;
          return 78;

        case E_V128DFmode:
          if (!register_operand (operands[2], E_V128DFmode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256SImode
          || !register_operand (operands[3], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256SFmode:
          if (!register_operand (operands[2], E_V256SFmode))
            return -1;
          return 80;

        case E_V256HFmode:
          if (!register_operand (operands[2], E_V256HFmode))
            return -1;
          return 81;

        case E_V256DFmode:
          if (!register_operand (operands[2], E_V256DFmode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512SImode
          || !register_operand (operands[3], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512SFmode:
          if (!register_operand (operands[2], E_V512SFmode))
            return -1;
          return 83;

        case E_V512HFmode:
          if (!register_operand (operands[2], E_V512HFmode))
            return -1;
          return 84;

        case E_V512DFmode:
          if (!register_operand (operands[2], E_V512DFmode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024SImode
          || !register_operand (operands[3], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024SFmode:
          if (!register_operand (operands[2], E_V1024SFmode))
            return -1;
          return 86;

        case E_V1024HFmode:
          if (!register_operand (operands[2], E_V1024HFmode))
            return -1;
          return 87;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[3], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1DFmode:
          if (!register_operand (operands[2], E_V1DFmode))
            return -1;
          return 88;

        case E_V1SFmode:
          if (!register_operand (operands[2], E_V1SFmode))
            return -1;
          return 89;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[3], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[2], E_V2DFmode))
            return -1;
          return 90;

        case E_V2SFmode:
          if (!register_operand (operands[2], E_V2SFmode))
            return -1;
          return 91;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4DImode
          || !register_operand (operands[3], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4DFmode:
          if (!register_operand (operands[2], E_V4DFmode))
            return -1;
          return 92;

        case E_V4SFmode:
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          return 93;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8DImode
          || !register_operand (operands[3], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[2], E_V8DFmode))
            return -1;
          return 94;

        case E_V8SFmode:
          if (!register_operand (operands[2], E_V8SFmode))
            return -1;
          return 95;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16DImode
          || !register_operand (operands[3], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16DFmode:
          if (!register_operand (operands[2], E_V16DFmode))
            return -1;
          return 96;

        case E_V16SFmode:
          if (!register_operand (operands[2], E_V16SFmode))
            return -1;
          return 97;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32DImode
          || !register_operand (operands[3], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32DFmode:
          if (!register_operand (operands[2], E_V32DFmode))
            return -1;
          return 98;

        case E_V32SFmode:
          if (!register_operand (operands[2], E_V32SFmode))
            return -1;
          return 99;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64DImode
          || !register_operand (operands[3], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64DFmode:
          if (!register_operand (operands[2], E_V64DFmode))
            return -1;
          return 100;

        case E_V64SFmode:
          if (!register_operand (operands[2], E_V64SFmode))
            return -1;
          return 101;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128DImode
          || !register_operand (operands[3], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128DFmode:
          if (!register_operand (operands[2], E_V128DFmode))
            return -1;
          return 102;

        case E_V128SFmode:
          if (!register_operand (operands[2], E_V128SFmode))
            return -1;
          return 103;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256DImode
          || !register_operand (operands[3], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256DFmode:
          if (!register_operand (operands[2], E_V256DFmode))
            return -1;
          return 104;

        case E_V256SFmode:
          if (!register_operand (operands[2], E_V256SFmode))
            return -1;
          return 105;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512DImode
          || !register_operand (operands[3], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512DFmode:
          if (!register_operand (operands[2], E_V512DFmode))
            return -1;
          return 106;

        case E_V512SFmode:
          if (!register_operand (operands[2], E_V512SFmode))
            return -1;
          return 107;

        default:
          return -1;
        }

    case E_RVVM4QImode:
      if (pattern204 (x1, 
E_RVVM4QImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 108;

    case E_RVVM2QImode:
      if (pattern204 (x1, 
E_RVVM2QImode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 109;

    case E_RVVM1QImode:
      if (pattern204 (x1, 
E_RVVM1QImode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 110;

    case E_RVVMF2QImode:
      if (pattern204 (x1, 
E_RVVMF2QImode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 111;

    case E_RVVMF4QImode:
      if (pattern204 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 112;

    case E_RVVMF8QImode:
      if (pattern204 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 113;

    case E_V1QImode:
      if (pattern204 (x1, 
E_V1QImode, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 114;

    case E_V2QImode:
      if (pattern204 (x1, 
E_V2QImode, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 115;

    case E_V4QImode:
      if (pattern204 (x1, 
E_V4QImode, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 116;

    case E_V8QImode:
      if (pattern204 (x1, 
E_V8QImode, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 117;

    case E_V16QImode:
      if (pattern204 (x1, 
E_V16QImode, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 118;

    case E_V32QImode:
      if (pattern204 (x1, 
E_V32QImode, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 119;

    case E_V64QImode:
      if (pattern204 (x1, 
E_V64QImode, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 120;

    case E_V128QImode:
      if (pattern204 (x1, 
E_V128QImode, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 121;

    case E_V256QImode:
      if (pattern204 (x1, 
E_V256QImode, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 122;

    case E_V512QImode:
      if (pattern204 (x1, 
E_V512QImode, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 123;

    case E_V1024QImode:
      if (pattern204 (x1, 
E_V1024QImode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 124;

    case E_V2048QImode:
      if (pattern204 (x1, 
E_V2048QImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 125;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM4SImode)
      || GET_MODE (x1) != E_RVVM4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 0;

    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM4DImode)
      || GET_MODE (x1) != E_RVVM4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 0;

    case E_RVVM1HImode:
      if (!register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 1;

    case E_RVVMF2QImode:
      if (!register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 0;

    case E_V4QImode:
      if (!register_operand (operands[1], E_V4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V128SImode)
      || GET_MODE (x1) != E_V128SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V128HImode:
      if (!register_operand (operands[1], E_V128HImode))
        return -1;
      return 0;

    case E_V128QImode:
      if (!register_operand (operands[1], E_V128QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern312 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2QImode:
      if (!register_operand (operands[1], E_V2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64DImode)
      || GET_MODE (x1) != E_V64DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      return 0;

    case E_V64HImode:
      if (!register_operand (operands[1], E_V64HImode))
        return -1;
      return 1;

    case E_V64QImode:
      if (!register_operand (operands[1], E_V64QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern322 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern322 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode)
          || GET_MODE (x1) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode))
        return -1;
      return 2;

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode)
          || GET_MODE (x1) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode))
        return -1;
      return 3;

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode)
          || GET_MODE (x1) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode))
        return -1;
      return 4;

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode)
          || GET_MODE (x1) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 5;

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode)
          || GET_MODE (x1) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 6;

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 7;

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 8;

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 9;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 13;

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 14;

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 15;

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 16;

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 17;

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode)
          || GET_MODE (x1) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 18;

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode)
          || GET_MODE (x1) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode))
        return -1;
      return 19;

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode)
          || GET_MODE (x1) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 20;

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 21;

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 22;

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 23;

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 24;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 25;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 26;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 27;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 28;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 29;

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x1) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode))
        return -1;
      return 30;

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode)
          || GET_MODE (x1) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode))
        return -1;
      return 31;

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode)
          || GET_MODE (x1) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode))
        return -1;
      return 32;

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode)
          || GET_MODE (x1) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode))
        return -1;
      return 33;

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode)
          || GET_MODE (x1) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode))
        return -1;
      return 34;

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode)
          || GET_MODE (x1) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode))
        return -1;
      return 35;

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode)
          || GET_MODE (x1) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode))
        return -1;
      return 36;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 37;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 38;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 39;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 40;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 41;

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 42;

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode))
        return -1;
      return 43;

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode))
        return -1;
      return 44;

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 45;

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode))
        return -1;
      return 46;

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode))
        return -1;
      return 47;

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode)
          || GET_MODE (x1) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode))
        return -1;
      return 48;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 49;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 50;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 51;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 52;

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 53;

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 54;

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode))
        return -1;
      return 55;

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode))
        return -1;
      return 56;

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 57;

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode))
        return -1;
      return 58;

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode))
        return -1;
      return 59;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 60;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 61;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 62;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode))
        return -1;
      return 63;

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode))
        return -1;
      return 64;

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode))
        return -1;
      return 65;

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode))
        return -1;
      return 66;

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode))
        return -1;
      return 67;

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode))
        return -1;
      return 68;

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode))
        return -1;
      return 69;

    default:
      return -1;
    }
}

int
pattern435 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern440 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8HImode:
      if (!register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (!register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (!register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 5;

    case E_V1HImode:
      if (!register_operand (operands[1], E_V1HImode))
        return -1;
      return 6;

    case E_V2HImode:
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      return 7;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 8;

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 9;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 10;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode))
        return -1;
      return 11;

    case E_V64HImode:
      if (!register_operand (operands[1], E_V64HImode))
        return -1;
      return 12;

    case E_V128HImode:
      if (!register_operand (operands[1], E_V128HImode))
        return -1;
      return 13;

    case E_V256HImode:
      if (!register_operand (operands[1], E_V256HImode))
        return -1;
      return 14;

    case E_V512HImode:
      if (!register_operand (operands[1], E_V512HImode))
        return -1;
      return 15;

    case E_V1024HImode:
      if (!register_operand (operands[1], E_V1024HImode))
        return -1;
      return 16;

    case E_V2048HImode:
      if (!register_operand (operands[1], E_V2048HImode))
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern452 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern457 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern461 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!branch_on_bit_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern459 (x1); /* [-1, 1] */
}

int
pattern465 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i3)
      || !vector_merge_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern469 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  x8 = XEXP (x1, 2);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern468 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern468 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern468 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern468 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern468 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern468 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern468 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern468 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern468 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern468 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern468 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern468 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern468 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern468 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern468 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern468 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern468 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern468 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern468 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern468 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern468 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern468 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_RVVM8BFmode:
      if (pattern468 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 22;

    case E_RVVM4BFmode:
      if (pattern468 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 23;

    case E_RVVM2BFmode:
      if (pattern468 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 24;

    case E_RVVM1BFmode:
      if (pattern468 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2BFmode:
      if (pattern468 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 26;

    case E_RVVMF4BFmode:
      if (pattern468 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 27;

    case E_RVVM8HFmode:
      if (pattern468 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 28;

    case E_RVVM4HFmode:
      if (pattern468 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 29;

    case E_RVVM2HFmode:
      if (pattern468 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 30;

    case E_RVVM1HFmode:
      if (pattern468 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 31;

    case E_RVVMF2HFmode:
      if (pattern468 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 32;

    case E_RVVMF4HFmode:
      if (pattern468 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 33;

    case E_RVVM8SFmode:
      if (pattern468 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 34;

    case E_RVVM4SFmode:
      if (pattern468 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 35;

    case E_RVVM2SFmode:
      if (pattern468 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 36;

    case E_RVVM1SFmode:
      if (pattern468 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 37;

    case E_RVVMF2SFmode:
      if (pattern468 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 38;

    case E_RVVM8DFmode:
      if (pattern468 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 39;

    case E_RVVM4DFmode:
      if (pattern468 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 40;

    case E_RVVM2DFmode:
      if (pattern468 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 41;

    case E_RVVM1DFmode:
      if (pattern468 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 42;

    case E_V1QImode:
      if (pattern468 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 43;

    case E_V2QImode:
      if (pattern468 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 44;

    case E_V4QImode:
      if (pattern468 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 45;

    case E_V8QImode:
      if (pattern468 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 46;

    case E_V16QImode:
      if (pattern468 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 47;

    case E_V32QImode:
      if (pattern468 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 48;

    case E_V64QImode:
      if (pattern468 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 49;

    case E_V128QImode:
      if (pattern468 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 50;

    case E_V256QImode:
      if (pattern468 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 51;

    case E_V512QImode:
      if (pattern468 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 52;

    case E_V1024QImode:
      if (pattern468 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 53;

    case E_V2048QImode:
      if (pattern468 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 54;

    case E_V4096QImode:
      if (pattern468 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 55;

    case E_V1HImode:
      if (pattern468 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 56;

    case E_V2HImode:
      if (pattern468 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 57;

    case E_V4HImode:
      if (pattern468 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 58;

    case E_V8HImode:
      if (pattern468 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 59;

    case E_V16HImode:
      if (pattern468 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 60;

    case E_V32HImode:
      if (pattern468 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 61;

    case E_V64HImode:
      if (pattern468 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 62;

    case E_V128HImode:
      if (pattern468 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 63;

    case E_V256HImode:
      if (pattern468 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 64;

    case E_V512HImode:
      if (pattern468 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 65;

    case E_V1024HImode:
      if (pattern468 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 66;

    case E_V2048HImode:
      if (pattern468 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 67;

    case E_V1SImode:
      if (pattern468 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 68;

    case E_V2SImode:
      if (pattern468 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 69;

    case E_V4SImode:
      if (pattern468 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 70;

    case E_V8SImode:
      if (pattern468 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 71;

    case E_V16SImode:
      if (pattern468 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 72;

    case E_V32SImode:
      if (pattern468 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 73;

    case E_V64SImode:
      if (pattern468 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 74;

    case E_V128SImode:
      if (pattern468 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 75;

    case E_V256SImode:
      if (pattern468 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 76;

    case E_V512SImode:
      if (pattern468 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 77;

    case E_V1024SImode:
      if (pattern468 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 78;

    case E_V1DImode:
      if (pattern468 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 79;

    case E_V2DImode:
      if (pattern468 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 80;

    case E_V4DImode:
      if (pattern468 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 81;

    case E_V8DImode:
      if (pattern468 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 82;

    case E_V16DImode:
      if (pattern468 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 83;

    case E_V32DImode:
      if (pattern468 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 84;

    case E_V64DImode:
      if (pattern468 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 85;

    case E_V128DImode:
      if (pattern468 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 86;

    case E_V256DImode:
      if (pattern468 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 87;

    case E_V512DImode:
      if (pattern468 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 88;

    case E_V1HFmode:
      if (pattern468 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 89;

    case E_V2HFmode:
      if (pattern468 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 90;

    case E_V4HFmode:
      if (pattern468 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 91;

    case E_V8HFmode:
      if (pattern468 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 92;

    case E_V16HFmode:
      if (pattern468 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 93;

    case E_V32HFmode:
      if (pattern468 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 94;

    case E_V64HFmode:
      if (pattern468 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 95;

    case E_V128HFmode:
      if (pattern468 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 96;

    case E_V256HFmode:
      if (pattern468 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 97;

    case E_V512HFmode:
      if (pattern468 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 98;

    case E_V1024HFmode:
      if (pattern468 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 99;

    case E_V2048HFmode:
      if (pattern468 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 100;

    case E_V1SFmode:
      if (pattern468 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 101;

    case E_V2SFmode:
      if (pattern468 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 102;

    case E_V4SFmode:
      if (pattern468 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 103;

    case E_V8SFmode:
      if (pattern468 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 104;

    case E_V16SFmode:
      if (pattern468 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 105;

    case E_V32SFmode:
      if (pattern468 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 106;

    case E_V64SFmode:
      if (pattern468 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 107;

    case E_V128SFmode:
      if (pattern468 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 108;

    case E_V256SFmode:
      if (pattern468 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 109;

    case E_V512SFmode:
      if (pattern468 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 110;

    case E_V1024SFmode:
      if (pattern468 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 111;

    case E_V1DFmode:
      if (pattern468 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 112;

    case E_V2DFmode:
      if (pattern468 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 113;

    case E_V4DFmode:
      if (pattern468 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 114;

    case E_V8DFmode:
      if (pattern468 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 115;

    case E_V16DFmode:
      if (pattern468 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 116;

    case E_V32DFmode:
      if (pattern468 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 117;

    case E_V64DFmode:
      if (pattern468 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 118;

    case E_V128DFmode:
      if (pattern468 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 119;

    case E_V256DFmode:
      if (pattern468 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 120;

    case E_V512DFmode:
      if (pattern468 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 121;

    default:
      return -1;
    }
}

int
pattern504 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ZERO_EXTEND
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern505 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !reg_or_0_operand (operands[2], E_QImode)
      || !register_operand (operands[1], i2))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern507 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM2QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern509 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVMF2QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 0;

    case E_RVVM1HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 1;

    case E_RVVM2SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 2;

    case E_RVVM4DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern512 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V1QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 0;

    case E_V1HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 1;

    case E_V1SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern515 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V8QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V8SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern518 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V64QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V64QImode))
        return -1;
      return 0;

    case E_V64HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V64HImode))
        return -1;
      return 1;

    case E_V64SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V64SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern521 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V512QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V512QImode))
        return -1;
      return 0;

    case E_V512HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V512HImode))
        return -1;
      return 1;

    case E_V512SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V512SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern525 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1BImode:
          return 0;

        case E_RVVMF2BImode:
          return 1;

        case E_RVVMF4BImode:
          return 2;

        case E_RVVMF8BImode:
          return 3;

        case E_RVVMF16BImode:
          return 4;

        case E_RVVMF32BImode:
          return 5;

        case E_RVVMF64BImode:
          return 6;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1BImode:
              if (pattern505 (x1, 
E_RVVM1BImode, 
E_RVVM8QImode) != 0)
                return -1;
              return 7;

            case E_RVVMF2BImode:
              if (!register_operand (operands[0], E_RVVMF2BImode)
                  || GET_MODE (x1) != E_RVVMF2BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_RVVMF2BImode)
                return -1;
              res = pattern506 (x2);
              if (res >= 0)
                return res + 8; /* [8, 9] */
              return -1;

            case E_RVVMF4BImode:
              if (!register_operand (operands[0], E_RVVMF4BImode)
                  || GET_MODE (x1) != E_RVVMF4BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_RVVMF4BImode)
                return -1;
              res = pattern507 (x2);
              if (res >= 0)
                return res + 10; /* [10, 12] */
              return -1;

            case E_RVVMF8BImode:
              if (!register_operand (operands[0], E_RVVMF8BImode)
                  || GET_MODE (x1) != E_RVVMF8BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_RVVMF8BImode)
                return -1;
              res = pattern508 (x2);
              if (res >= 0)
                return res + 13; /* [13, 16] */
              return -1;

            case E_RVVMF16BImode:
              if (!register_operand (operands[0], E_RVVMF16BImode)
                  || GET_MODE (x1) != E_RVVMF16BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_RVVMF16BImode)
                return -1;
              res = pattern509 (x2);
              if (res >= 0)
                return res + 17; /* [17, 20] */
              return -1;

            case E_RVVMF32BImode:
              if (!register_operand (operands[0], E_RVVMF32BImode)
                  || GET_MODE (x1) != E_RVVMF32BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_RVVMF32BImode)
                return -1;
              res = pattern510 (x2);
              if (res >= 0)
                return res + 21; /* [21, 24] */
              return -1;

            case E_RVVMF64BImode:
              if (!register_operand (operands[0], E_RVVMF64BImode)
                  || GET_MODE (x1) != E_RVVMF64BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_RVVMF64BImode)
                return -1;
              res = pattern511 (x2);
              if (res >= 0)
                return res + 25; /* [25, 28] */
              return -1;

            case E_V1BImode:
              if (!register_operand (operands[0], E_V1BImode)
                  || GET_MODE (x1) != E_V1BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V1BImode)
                return -1;
              res = pattern512 (x2);
              if (res >= 0)
                return res + 29; /* [29, 31] */
              return -1;

            case E_V2BImode:
              if (!register_operand (operands[0], E_V2BImode)
                  || GET_MODE (x1) != E_V2BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V2BImode)
                return -1;
              res = pattern513 (x2);
              if (res >= 0)
                return res + 32; /* [32, 34] */
              return -1;

            case E_V4BImode:
              if (!register_operand (operands[0], E_V4BImode)
                  || GET_MODE (x1) != E_V4BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V4BImode)
                return -1;
              res = pattern514 (x2);
              if (res >= 0)
                return res + 35; /* [35, 37] */
              return -1;

            case E_V8BImode:
              if (!register_operand (operands[0], E_V8BImode)
                  || GET_MODE (x1) != E_V8BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V8BImode)
                return -1;
              res = pattern515 (x2);
              if (res >= 0)
                return res + 38; /* [38, 40] */
              return -1;

            case E_V16BImode:
              if (!register_operand (operands[0], E_V16BImode)
                  || GET_MODE (x1) != E_V16BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V16BImode)
                return -1;
              res = pattern516 (x2);
              if (res >= 0)
                return res + 41; /* [41, 43] */
              return -1;

            case E_V32BImode:
              if (!register_operand (operands[0], E_V32BImode)
                  || GET_MODE (x1) != E_V32BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V32BImode)
                return -1;
              res = pattern517 (x2);
              if (res >= 0)
                return res + 44; /* [44, 46] */
              return -1;

            case E_V64BImode:
              if (!register_operand (operands[0], E_V64BImode)
                  || GET_MODE (x1) != E_V64BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V64BImode)
                return -1;
              res = pattern518 (x2);
              if (res >= 0)
                return res + 47; /* [47, 49] */
              return -1;

            case E_V128BImode:
              if (!register_operand (operands[0], E_V128BImode)
                  || GET_MODE (x1) != E_V128BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V128BImode)
                return -1;
              res = pattern519 (x2);
              if (res >= 0)
                return res + 50; /* [50, 52] */
              return -1;

            case E_V256BImode:
              if (!register_operand (operands[0], E_V256BImode)
                  || GET_MODE (x1) != E_V256BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V256BImode)
                return -1;
              res = pattern520 (x2);
              if (res >= 0)
                return res + 53; /* [53, 55] */
              return -1;

            case E_V512BImode:
              if (!register_operand (operands[0], E_V512BImode)
                  || GET_MODE (x1) != E_V512BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V512BImode)
                return -1;
              res = pattern521 (x2);
              if (res >= 0)
                return res + 56; /* [56, 58] */
              return -1;

            case E_V1024BImode:
              if (!register_operand (operands[0], E_V1024BImode)
                  || GET_MODE (x1) != E_V1024BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V1024BImode)
                return -1;
              res = pattern522 (x2);
              if (res >= 0)
                return res + 59; /* [59, 61] */
              return -1;

            case E_V2048BImode:
              if (!register_operand (operands[0], E_V2048BImode)
                  || GET_MODE (x1) != E_V2048BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V2048BImode)
                return -1;
              res = pattern523 (x2);
              if (res >= 0)
                return res + 62; /* [62, 63] */
              return -1;

            case E_V4096BImode:
              if (pattern505 (x1, 
E_V4096BImode, 
E_V4096QImode) != 0)
                return -1;
              return 64;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!reg_or_0_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVMF8BImode:
              if (pattern524 (x1, 
E_RVVMF8BImode, 
E_RVVM8DImode) != 0)
                return -1;
              return 65;

            case E_RVVMF16BImode:
              if (pattern524 (x1, 
E_RVVMF16BImode, 
E_RVVM4DImode) != 0)
                return -1;
              return 66;

            case E_RVVMF32BImode:
              if (pattern524 (x1, 
E_RVVMF32BImode, 
E_RVVM2DImode) != 0)
                return -1;
              return 67;

            case E_RVVMF64BImode:
              if (pattern524 (x1, 
E_RVVMF64BImode, 
E_RVVM1DImode) != 0)
                return -1;
              return 68;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern545 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern546 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern547 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !scratch_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern548 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern550 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1
      || !reg_or_0_operand (operands[4], i3)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern552 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!reg_or_0_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8DImode:
      return pattern551 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode); /* [-1, 0] */

    case E_RVVM4DImode:
      if (pattern551 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2DImode:
      if (pattern551 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (pattern551 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern555 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i3)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern557 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[3] = x8;
  x9 = XVECEXP (x7, 0, 1);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      return pattern554 (x1); /* [-1, 47] */

    case VEC_DUPLICATE:
      x10 = XEXP (x9, 0);
      operands[4] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern555 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) != 0)
            return -1;
          return 48;

        case E_RVVM4HFmode:
          if (pattern555 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
            return -1;
          return 49;

        case E_RVVM2HFmode:
          if (pattern555 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
            return -1;
          return 50;

        case E_RVVM1HFmode:
          if (pattern555 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
            return -1;
          return 51;

        case E_RVVMF2HFmode:
          if (pattern555 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
            return -1;
          return 52;

        case E_RVVMF4HFmode:
          if (pattern555 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
            return -1;
          return 53;

        case E_RVVM8SFmode:
          if (pattern555 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
            return -1;
          return 54;

        case E_RVVM4SFmode:
          if (pattern555 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
            return -1;
          return 55;

        case E_RVVM2SFmode:
          if (pattern555 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
            return -1;
          return 56;

        case E_RVVM1SFmode:
          if (pattern555 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
            return -1;
          return 57;

        case E_RVVMF2SFmode:
          if (pattern555 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
            return -1;
          return 58;

        case E_RVVM8DFmode:
          if (pattern555 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
            return -1;
          return 59;

        case E_RVVM4DFmode:
          if (pattern555 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
            return -1;
          return 60;

        case E_RVVM2DFmode:
          if (pattern555 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
            return -1;
          return 61;

        case E_RVVM1DFmode:
          if (pattern555 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
            return -1;
          return 62;

        case E_V1HFmode:
          if (pattern555 (x1, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
            return -1;
          return 63;

        case E_V2HFmode:
          if (pattern555 (x1, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
            return -1;
          return 64;

        case E_V4HFmode:
          if (pattern555 (x1, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
            return -1;
          return 65;

        case E_V8HFmode:
          if (pattern555 (x1, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
            return -1;
          return 66;

        case E_V16HFmode:
          if (pattern555 (x1, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
            return -1;
          return 67;

        case E_V32HFmode:
          if (pattern555 (x1, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
            return -1;
          return 68;

        case E_V64HFmode:
          if (pattern555 (x1, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
            return -1;
          return 69;

        case E_V128HFmode:
          if (pattern555 (x1, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
            return -1;
          return 70;

        case E_V256HFmode:
          if (pattern555 (x1, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
            return -1;
          return 71;

        case E_V512HFmode:
          if (pattern555 (x1, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
            return -1;
          return 72;

        case E_V1024HFmode:
          if (pattern555 (x1, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
            return -1;
          return 73;

        case E_V2048HFmode:
          if (pattern555 (x1, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
            return -1;
          return 74;

        case E_V1SFmode:
          if (pattern555 (x1, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
            return -1;
          return 75;

        case E_V2SFmode:
          if (pattern555 (x1, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
            return -1;
          return 76;

        case E_V4SFmode:
          if (pattern555 (x1, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
            return -1;
          return 77;

        case E_V8SFmode:
          if (pattern555 (x1, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
            return -1;
          return 78;

        case E_V16SFmode:
          if (pattern555 (x1, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
            return -1;
          return 79;

        case E_V32SFmode:
          if (pattern555 (x1, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
            return -1;
          return 80;

        case E_V64SFmode:
          if (pattern555 (x1, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
            return -1;
          return 81;

        case E_V128SFmode:
          if (pattern555 (x1, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
            return -1;
          return 82;

        case E_V256SFmode:
          if (pattern555 (x1, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
            return -1;
          return 83;

        case E_V512SFmode:
          if (pattern555 (x1, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
            return -1;
          return 84;

        case E_V1024SFmode:
          if (pattern555 (x1, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0)
            return -1;
          return 85;

        case E_V1DFmode:
          if (pattern555 (x1, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0)
            return -1;
          return 86;

        case E_V2DFmode:
          if (pattern555 (x1, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0)
            return -1;
          return 87;

        case E_V4DFmode:
          if (pattern555 (x1, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0)
            return -1;
          return 88;

        case E_V8DFmode:
          if (pattern555 (x1, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0)
            return -1;
          return 89;

        case E_V16DFmode:
          if (pattern555 (x1, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0)
            return -1;
          return 90;

        case E_V32DFmode:
          if (pattern555 (x1, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0)
            return -1;
          return 91;

        case E_V64DFmode:
          if (pattern555 (x1, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0)
            return -1;
          return 92;

        case E_V128DFmode:
          if (pattern555 (x1, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0)
            return -1;
          return 93;

        case E_V256DFmode:
          if (pattern555 (x1, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0)
            return -1;
          return 94;

        case E_V512DFmode:
          if (pattern555 (x1, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0)
            return -1;
          return 95;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern579 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (!register_operand (x6, i1))
    return -1;
  return 0;
}

int
pattern580 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i3)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern583 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          return pattern579 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

        case E_RVVM4HFmode:
          if (pattern579 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HFmode:
          if (pattern579 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HFmode:
          if (pattern579 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HFmode:
          if (pattern579 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HFmode:
          if (pattern579 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 5;

        case E_RVVM8SFmode:
          if (pattern579 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 6;

        case E_RVVM4SFmode:
          if (pattern579 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 7;

        case E_RVVM2SFmode:
          if (pattern579 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 8;

        case E_RVVM1SFmode:
          if (pattern579 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (pattern579 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 10;

        case E_RVVM8DFmode:
          if (pattern579 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 11;

        case E_RVVM4DFmode:
          if (pattern579 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 12;

        case E_RVVM2DFmode:
          if (pattern579 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 13;

        case E_RVVM1DFmode:
          if (pattern579 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 14;

        case E_V1HFmode:
          if (pattern579 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 15;

        case E_V2HFmode:
          if (pattern579 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 16;

        case E_V4HFmode:
          if (pattern579 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 17;

        case E_V8HFmode:
          if (pattern579 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 18;

        case E_V16HFmode:
          if (pattern579 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 19;

        case E_V32HFmode:
          if (pattern579 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 20;

        case E_V64HFmode:
          if (pattern579 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 21;

        case E_V128HFmode:
          if (pattern579 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 22;

        case E_V256HFmode:
          if (pattern579 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 23;

        case E_V512HFmode:
          if (pattern579 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 24;

        case E_V1024HFmode:
          if (pattern579 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 25;

        case E_V2048HFmode:
          if (pattern579 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 26;

        case E_V1SFmode:
          if (pattern579 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 27;

        case E_V2SFmode:
          if (pattern579 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 28;

        case E_V4SFmode:
          if (pattern579 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 29;

        case E_V8SFmode:
          if (pattern579 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 30;

        case E_V16SFmode:
          if (pattern579 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 31;

        case E_V32SFmode:
          if (pattern579 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 32;

        case E_V64SFmode:
          if (pattern579 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 33;

        case E_V128SFmode:
          if (pattern579 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 34;

        case E_V256SFmode:
          if (pattern579 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 35;

        case E_V512SFmode:
          if (pattern579 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 36;

        case E_V1024SFmode:
          if (pattern579 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 37;

        case E_V1DFmode:
          if (pattern579 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 38;

        case E_V2DFmode:
          if (pattern579 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 39;

        case E_V4DFmode:
          if (pattern579 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 40;

        case E_V8DFmode:
          if (pattern579 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 41;

        case E_V16DFmode:
          if (pattern579 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 42;

        case E_V32DFmode:
          if (pattern579 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 43;

        case E_V64DFmode:
          if (pattern579 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 44;

        case E_V128DFmode:
          if (pattern579 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 45;

        case E_V256DFmode:
          if (pattern579 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 46;

        case E_V512DFmode:
          if (pattern579 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x6 = XEXP (x1, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XVECEXP (x6, 0, 5);
      operands[9] = x11;
      x12 = XEXP (x5, 0);
      operands[2] = x12;
      x13 = XEXP (x4, 1);
      operands[3] = x13;
      x14 = XEXP (x2, 1);
      operands[4] = x14;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern580 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) != 0)
            return -1;
          return 48;

        case E_RVVM4HFmode:
          if (pattern580 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
            return -1;
          return 49;

        case E_RVVM2HFmode:
          if (pattern580 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
            return -1;
          return 50;

        case E_RVVM1HFmode:
          if (pattern580 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
            return -1;
          return 51;

        case E_RVVMF2HFmode:
          if (pattern580 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
            return -1;
          return 52;

        case E_RVVMF4HFmode:
          if (pattern580 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
            return -1;
          return 53;

        case E_RVVM8SFmode:
          if (pattern580 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
            return -1;
          return 54;

        case E_RVVM4SFmode:
          if (pattern580 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
            return -1;
          return 55;

        case E_RVVM2SFmode:
          if (pattern580 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
            return -1;
          return 56;

        case E_RVVM1SFmode:
          if (pattern580 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
            return -1;
          return 57;

        case E_RVVMF2SFmode:
          if (pattern580 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
            return -1;
          return 58;

        case E_RVVM8DFmode:
          if (pattern580 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
            return -1;
          return 59;

        case E_RVVM4DFmode:
          if (pattern580 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
            return -1;
          return 60;

        case E_RVVM2DFmode:
          if (pattern580 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
            return -1;
          return 61;

        case E_RVVM1DFmode:
          if (pattern580 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
            return -1;
          return 62;

        case E_V1HFmode:
          if (pattern580 (x1, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
            return -1;
          return 63;

        case E_V2HFmode:
          if (pattern580 (x1, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
            return -1;
          return 64;

        case E_V4HFmode:
          if (pattern580 (x1, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
            return -1;
          return 65;

        case E_V8HFmode:
          if (pattern580 (x1, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
            return -1;
          return 66;

        case E_V16HFmode:
          if (pattern580 (x1, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
            return -1;
          return 67;

        case E_V32HFmode:
          if (pattern580 (x1, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
            return -1;
          return 68;

        case E_V64HFmode:
          if (pattern580 (x1, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
            return -1;
          return 69;

        case E_V128HFmode:
          if (pattern580 (x1, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
            return -1;
          return 70;

        case E_V256HFmode:
          if (pattern580 (x1, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
            return -1;
          return 71;

        case E_V512HFmode:
          if (pattern580 (x1, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
            return -1;
          return 72;

        case E_V1024HFmode:
          if (pattern580 (x1, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
            return -1;
          return 73;

        case E_V2048HFmode:
          if (pattern580 (x1, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
            return -1;
          return 74;

        case E_V1SFmode:
          if (pattern580 (x1, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
            return -1;
          return 75;

        case E_V2SFmode:
          if (pattern580 (x1, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
            return -1;
          return 76;

        case E_V4SFmode:
          if (pattern580 (x1, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
            return -1;
          return 77;

        case E_V8SFmode:
          if (pattern580 (x1, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
            return -1;
          return 78;

        case E_V16SFmode:
          if (pattern580 (x1, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
            return -1;
          return 79;

        case E_V32SFmode:
          if (pattern580 (x1, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
            return -1;
          return 80;

        case E_V64SFmode:
          if (pattern580 (x1, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
            return -1;
          return 81;

        case E_V128SFmode:
          if (pattern580 (x1, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
            return -1;
          return 82;

        case E_V256SFmode:
          if (pattern580 (x1, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
            return -1;
          return 83;

        case E_V512SFmode:
          if (pattern580 (x1, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
            return -1;
          return 84;

        case E_V1024SFmode:
          if (pattern580 (x1, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0)
            return -1;
          return 85;

        case E_V1DFmode:
          if (pattern580 (x1, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0)
            return -1;
          return 86;

        case E_V2DFmode:
          if (pattern580 (x1, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0)
            return -1;
          return 87;

        case E_V4DFmode:
          if (pattern580 (x1, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0)
            return -1;
          return 88;

        case E_V8DFmode:
          if (pattern580 (x1, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0)
            return -1;
          return 89;

        case E_V16DFmode:
          if (pattern580 (x1, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0)
            return -1;
          return 90;

        case E_V32DFmode:
          if (pattern580 (x1, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0)
            return -1;
          return 91;

        case E_V64DFmode:
          if (pattern580 (x1, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0)
            return -1;
          return 92;

        case E_V128DFmode:
          if (pattern580 (x1, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0)
            return -1;
          return 93;

        case E_V256DFmode:
          if (pattern580 (x1, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0)
            return -1;
          return 94;

        case E_V512DFmode:
          if (pattern580 (x1, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0)
            return -1;
          return 95;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x13 = XEXP (x4, 1);
      if (GET_CODE (x13) != FLOAT_EXTEND)
        return -1;
      x6 = XEXP (x1, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XVECEXP (x6, 0, 5);
      operands[9] = x11;
      x15 = XEXP (x13, 0);
      operands[4] = x15;
      x14 = XEXP (x2, 1);
      operands[2] = x14;
      x16 = XEXP (x1, 2);
      if (!rtx_equal_p (x16, operands[2]))
        return -1;
      x12 = XEXP (x5, 0);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[3] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern581 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 96;

            case E_RVVM4SFmode:
              if (pattern581 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 97;

            case E_RVVM2SFmode:
              if (pattern581 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 98;

            case E_RVVM1SFmode:
              if (pattern581 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 99;

            case E_RVVMF2SFmode:
              if (pattern581 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 100;

            case E_RVVM8DFmode:
              if (pattern581 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 101;

            case E_RVVM4DFmode:
              if (pattern581 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 102;

            case E_RVVM2DFmode:
              if (pattern581 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 103;

            case E_RVVM1DFmode:
              if (pattern581 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 104;

            case E_V1SFmode:
              if (pattern581 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0)
                return -1;
              return 105;

            case E_V2SFmode:
              if (pattern581 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0)
                return -1;
              return 106;

            case E_V4SFmode:
              if (pattern581 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0)
                return -1;
              return 107;

            case E_V8SFmode:
              if (pattern581 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0)
                return -1;
              return 108;

            case E_V16SFmode:
              if (pattern581 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0)
                return -1;
              return 109;

            case E_V32SFmode:
              if (pattern581 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0)
                return -1;
              return 110;

            case E_V64SFmode:
              if (pattern581 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0)
                return -1;
              return 111;

            case E_V128SFmode:
              if (pattern581 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0)
                return -1;
              return 112;

            case E_V256SFmode:
              if (pattern581 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0)
                return -1;
              return 113;

            case E_V512SFmode:
              if (pattern581 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0)
                return -1;
              return 114;

            case E_V1024SFmode:
              if (pattern581 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
                return -1;
              return 115;

            case E_V1DFmode:
              if (pattern581 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
                return -1;
              return 116;

            case E_V2DFmode:
              if (pattern581 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
                return -1;
              return 117;

            case E_V4DFmode:
              if (pattern581 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
                return -1;
              return 118;

            case E_V8DFmode:
              if (pattern581 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
                return -1;
              return 119;

            case E_V16DFmode:
              if (pattern581 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
                return -1;
              return 120;

            case E_V32DFmode:
              if (pattern581 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
                return -1;
              return 121;

            case E_V64DFmode:
              if (pattern581 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
                return -1;
              return 122;

            case E_V128DFmode:
              if (pattern581 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
                return -1;
              return 123;

            case E_V256DFmode:
              if (pattern581 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
                return -1;
              return 124;

            case E_V512DFmode:
              if (pattern581 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
                return -1;
              return 125;

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x17 = XEXP (x12, 0);
          operands[3] = x17;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern582 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
                return -1;
              return 126;

            case E_RVVM4SFmode:
              if (pattern582 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
                return -1;
              return 127;

            case E_RVVM2SFmode:
              if (pattern582 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
                return -1;
              return 128;

            case E_RVVM1SFmode:
              if (pattern582 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
                return -1;
              return 129;

            case E_RVVMF2SFmode:
              if (pattern582 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
                return -1;
              return 130;

            case E_RVVM8DFmode:
              if (pattern582 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
                return -1;
              return 131;

            case E_RVVM4DFmode:
              if (pattern582 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
                return -1;
              return 132;

            case E_RVVM2DFmode:
              if (pattern582 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
                return -1;
              return 133;

            case E_RVVM1DFmode:
              if (pattern582 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
                return -1;
              return 134;

            case E_V1SFmode:
              if (pattern582 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
                return -1;
              return 135;

            case E_V2SFmode:
              if (pattern582 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
                return -1;
              return 136;

            case E_V4SFmode:
              if (pattern582 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
                return -1;
              return 137;

            case E_V8SFmode:
              if (pattern582 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
                return -1;
              return 138;

            case E_V16SFmode:
              if (pattern582 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
                return -1;
              return 139;

            case E_V32SFmode:
              if (pattern582 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
                return -1;
              return 140;

            case E_V64SFmode:
              if (pattern582 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
                return -1;
              return 141;

            case E_V128SFmode:
              if (pattern582 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
                return -1;
              return 142;

            case E_V256SFmode:
              if (pattern582 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
                return -1;
              return 143;

            case E_V512SFmode:
              if (pattern582 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
                return -1;
              return 144;

            case E_V1024SFmode:
              if (pattern582 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
                return -1;
              return 145;

            case E_V1DFmode:
              if (pattern582 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
                return -1;
              return 146;

            case E_V2DFmode:
              if (pattern582 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
                return -1;
              return 147;

            case E_V4DFmode:
              if (pattern582 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
                return -1;
              return 148;

            case E_V8DFmode:
              if (pattern582 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
                return -1;
              return 149;

            case E_V16DFmode:
              if (pattern582 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
                return -1;
              return 150;

            case E_V32DFmode:
              if (pattern582 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
                return -1;
              return 151;

            case E_V64DFmode:
              if (pattern582 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
                return -1;
              return 152;

            case E_V128DFmode:
              if (pattern582 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
                return -1;
              return 153;

            case E_V256DFmode:
              if (pattern582 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
                return -1;
              return 154;

            case E_V512DFmode:
              if (pattern582 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
                return -1;
              return 155;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern715 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern720 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[4], i3)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern722 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          return pattern526 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode); /* [-1, 0] */

        case E_RVVM4SFmode:
          if (pattern526 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2SFmode:
          if (pattern526 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1SFmode:
          if (pattern526 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2SFmode:
          if (pattern526 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 4;

        case E_RVVM8DFmode:
          if (pattern526 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 5;

        case E_RVVM4DFmode:
          if (pattern526 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 6;

        case E_RVVM2DFmode:
          if (pattern526 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 7;

        case E_RVVM1DFmode:
          if (pattern526 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 8;

        case E_V1SFmode:
          if (pattern526 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 9;

        case E_V2SFmode:
          if (pattern526 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 10;

        case E_V4SFmode:
          if (pattern526 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 11;

        case E_V8SFmode:
          if (pattern526 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 12;

        case E_V16SFmode:
          if (pattern526 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 13;

        case E_V32SFmode:
          if (pattern526 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 14;

        case E_V64SFmode:
          if (pattern526 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 15;

        case E_V128SFmode:
          if (pattern526 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 16;

        case E_V256SFmode:
          if (pattern526 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 17;

        case E_V512SFmode:
          if (pattern526 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 18;

        case E_V1024SFmode:
          if (pattern526 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 19;

        case E_V1DFmode:
          if (pattern526 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 20;

        case E_V2DFmode:
          if (pattern526 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 21;

        case E_V4DFmode:
          if (pattern526 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 22;

        case E_V8DFmode:
          if (pattern526 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 23;

        case E_V16DFmode:
          if (pattern526 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 24;

        case E_V32DFmode:
          if (pattern526 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 25;

        case E_V64DFmode:
          if (pattern526 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 26;

        case E_V128DFmode:
          if (pattern526 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 27;

        case E_V256DFmode:
          if (pattern526 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 28;

        case E_V512DFmode:
          if (pattern526 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 29;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern721 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
            return -1;
          return 30;

        case E_RVVM4SFmode:
          if (pattern721 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
            return -1;
          return 31;

        case E_RVVM2SFmode:
          if (pattern721 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
            return -1;
          return 32;

        case E_RVVM1SFmode:
          if (pattern721 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
            return -1;
          return 33;

        case E_RVVMF2SFmode:
          if (pattern721 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
            return -1;
          return 34;

        case E_RVVM8DFmode:
          if (pattern721 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
            return -1;
          return 35;

        case E_RVVM4DFmode:
          if (pattern721 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
            return -1;
          return 36;

        case E_RVVM2DFmode:
          if (pattern721 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
            return -1;
          return 37;

        case E_RVVM1DFmode:
          if (pattern721 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
            return -1;
          return 38;

        case E_V1SFmode:
          if (pattern721 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
            return -1;
          return 39;

        case E_V2SFmode:
          if (pattern721 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
            return -1;
          return 40;

        case E_V4SFmode:
          if (pattern721 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
            return -1;
          return 41;

        case E_V8SFmode:
          if (pattern721 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
            return -1;
          return 42;

        case E_V16SFmode:
          if (pattern721 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
            return -1;
          return 43;

        case E_V32SFmode:
          if (pattern721 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
            return -1;
          return 44;

        case E_V64SFmode:
          if (pattern721 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
            return -1;
          return 45;

        case E_V128SFmode:
          if (pattern721 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
            return -1;
          return 46;

        case E_V256SFmode:
          if (pattern721 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
            return -1;
          return 47;

        case E_V512SFmode:
          if (pattern721 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
            return -1;
          return 48;

        case E_V1024SFmode:
          if (pattern721 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
            return -1;
          return 49;

        case E_V1DFmode:
          if (pattern721 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
            return -1;
          return 50;

        case E_V2DFmode:
          if (pattern721 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
            return -1;
          return 51;

        case E_V4DFmode:
          if (pattern721 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
            return -1;
          return 52;

        case E_V8DFmode:
          if (pattern721 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
            return -1;
          return 53;

        case E_V16DFmode:
          if (pattern721 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
            return -1;
          return 54;

        case E_V32DFmode:
          if (pattern721 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
            return -1;
          return 55;

        case E_V64DFmode:
          if (pattern721 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
            return -1;
          return 56;

        case E_V128DFmode:
          if (pattern721 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
            return -1;
          return 57;

        case E_V256DFmode:
          if (pattern721 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
            return -1;
          return 58;

        case E_V512DFmode:
          if (pattern721 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
            return -1;
          return 59;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern742 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 6);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern745 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vector_merge_operand (operands[2], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern746 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !memory_operand (operands[3], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XVECEXP (x7, 0, 0);
  return pattern745 (x8, 
i1, 
i2); /* [-1, 0] */
}

int
pattern748 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 7);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern750 (rtx x1, int i1, machine_mode i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i2)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i2)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i2)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i2)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i2)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i2)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i2)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i2)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i2)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i2)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i2)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i2)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i2)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i2)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i2)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i2)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i2)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i2)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i2)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i2)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i2)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i2)
    return -1;
  switch (REGNO (x7))
    {
    case 24:
      if (REGNO (x12) != 23
          || REGNO (x17) != 22
          || REGNO (x22) != 21
          || REGNO (x27) != 20
          || REGNO (x32) != 19)
        return -1;
      x38 = XEXP (x36, 1);
      if (GET_CODE (x38) != MEM
          || GET_MODE (x38) != i2)
        return -1;
      x39 = XEXP (x38, 0);
      if (GET_CODE (x39) != PLUS
          || GET_MODE (x39) != i2)
        return -1;
      x40 = XEXP (x39, 0);
      if (GET_CODE (x40) != REG
          || REGNO (x40) != 2
          || GET_MODE (x40) != i2)
        return -1;
      x41 = XEXP (x39, 1);
      if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
          || REGNO (x37) != 18)
        return -1;
      return 0;

    case 22:
      if (REGNO (x12) != 21
          || REGNO (x17) != 20
          || REGNO (x22) != 19
          || REGNO (x27) != 18
          || REGNO (x32) != 9)
        return -1;
      x38 = XEXP (x36, 1);
      if (GET_CODE (x38) != MEM
          || GET_MODE (x38) != i2)
        return -1;
      x39 = XEXP (x38, 0);
      if (GET_CODE (x39) != PLUS
          || GET_MODE (x39) != i2)
        return -1;
      x40 = XEXP (x39, 0);
      if (GET_CODE (x40) != REG
          || REGNO (x40) != 2
          || GET_MODE (x40) != i2)
        return -1;
      x41 = XEXP (x39, 1);
      if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
          || REGNO (x37) != 8)
        return -1;
      x42 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x42) != SET)
        return -1;
      x43 = XEXP (x42, 1);
      if (GET_CODE (x43) != MEM
          || GET_MODE (x43) != i2)
        return -1;
      x44 = XEXP (x43, 0);
      if (GET_CODE (x44) != PLUS
          || GET_MODE (x44) != i2)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 2
          || GET_MODE (x45) != i2)
        return -1;
      x46 = XEXP (x44, 1);
      if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x47 = XEXP (x42, 0);
      if (GET_CODE (x47) != REG
          || REGNO (x47) != 1
          || GET_MODE (x47) != i2)
        return -1;
      x48 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x48) != RETURN)
        return -1;
      x49 = XVECEXP (x1, 0, 10);
      if (pattern749 (x49, 
E_SImode, 
1) != 0)
        return -1;
      return 1;

    case 20:
      if (REGNO (x12) != 19
          || REGNO (x17) != 18
          || REGNO (x22) != 9
          || REGNO (x27) != 8
          || REGNO (x32) != 1)
        return -1;
      x38 = XEXP (x36, 1);
      if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x37) != 10)
        return -1;
      x42 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x42) != USE)
        return -1;
      x47 = XEXP (x42, 0);
      if (GET_CODE (x47) != REG
          || REGNO (x47) != 10
          || GET_MODE (x47) != i2)
        return -1;
      x48 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x48) != RETURN)
        return -1;
      x49 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x49) != USE)
        return -1;
      x50 = XEXP (x49, 0);
      if (GET_CODE (x50) != REG
          || REGNO (x50) != 1
          || GET_MODE (x50) != E_SImode
          || !stack_pop_up_to_s4_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern768 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  x43 = XEXP (x41, 1);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XVECEXP (x1, 0, 9);
  x47 = XEXP (x46, 0);
  if (GET_MODE (x47) != i1)
    return -1;
  x48 = XEXP (x46, 1);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XVECEXP (x1, 0, 10);
  x52 = XEXP (x51, 0);
  if (GET_MODE (x52) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 27:
      return pattern767 (x1, 
23, 
24, 
25, 
26); /* [-1, 0] */

    case 25:
      if (pattern767 (x1, 
21, 
22, 
23, 
24) != 0)
        return -1;
      return 1;

    case 23:
      if (REGNO (x12) != 22
          || REGNO (x17) != 21
          || REGNO (x22) != 20
          || REGNO (x27) != 19
          || REGNO (x32) != 18
          || REGNO (x37) != 9
          || REGNO (x42) != 8
          || REGNO (x47) != 1)
        return -1;
      x53 = XEXP (x51, 1);
      if (x53 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x52) != 10)
        return -1;
      x54 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x54) != USE)
        return -1;
      x55 = XEXP (x54, 0);
      if (GET_CODE (x55) != REG
          || REGNO (x55) != 10
          || GET_MODE (x55) != i1)
        return -1;
      x56 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x56) != RETURN)
        return -1;
      x57 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x57) != USE)
        return -1;
      x58 = XEXP (x57, 0);
      if (GET_CODE (x58) != REG
          || REGNO (x58) != 1
          || GET_MODE (x58) != E_SImode
          || !stack_pop_up_to_s7_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern788 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XEXP (x27, 1);
  if (GET_MODE (x31) != i1)
    return -1;
  x32 = XVECEXP (x1, 0, 6);
  x33 = XEXP (x32, 0);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XEXP (x32, 1);
  if (GET_MODE (x36) != i1)
    return -1;
  x37 = XVECEXP (x1, 0, 7);
  x38 = XEXP (x37, 0);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XEXP (x37, 1);
  if (GET_MODE (x41) != i1)
    return -1;
  x42 = XVECEXP (x1, 0, 8);
  x43 = XEXP (x42, 0);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XEXP (x42, 1);
  if (GET_MODE (x46) != i1)
    return -1;
  x47 = XVECEXP (x1, 0, 9);
  x48 = XEXP (x47, 0);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XEXP (x47, 1);
  if (GET_MODE (x51) != i1)
    return -1;
  x52 = XVECEXP (x1, 0, 10);
  x53 = XEXP (x52, 0);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x53, 0);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  x56 = XEXP (x52, 1);
  if (GET_MODE (x56) != i1)
    return -1;
  x57 = XVECEXP (x1, 0, 11);
  x58 = XEXP (x57, 0);
  if (GET_MODE (x58) != i1)
    return -1;
  x59 = XEXP (x58, 0);
  if (GET_MODE (x59) != i1)
    return -1;
  x60 = XEXP (x59, 0);
  if (GET_MODE (x60) != i1)
    return -1;
  x61 = XEXP (x57, 1);
  if (GET_MODE (x61) != i1)
    return -1;
  x62 = XVECEXP (x1, 0, 12);
  x63 = XEXP (x62, 0);
  if (GET_MODE (x63) != i1)
    return -1;
  x64 = XEXP (x63, 0);
  if (GET_MODE (x64) != i1)
    return -1;
  x65 = XEXP (x64, 0);
  if (GET_MODE (x65) != i1)
    return -1;
  x66 = XEXP (x62, 1);
  if (GET_MODE (x66) != i1)
    return -1;
  x67 = XVECEXP (x1, 0, 13);
  x68 = XEXP (x67, 0);
  if (GET_MODE (x68) != i1)
    return -1;
  x69 = XEXP (x67, 1);
  if (GET_MODE (x69) != i1)
    return -1;
  x70 = XEXP (x69, 0);
  if (GET_MODE (x70) != i1)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern147 (x2))
        {
        case 0:
          if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30146; /* *dual_widen_addsrvvm8hi */

        case 1:
          if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30152; /* *dual_widen_addsrvvm4hi */

        case 2:
          if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30158; /* *dual_widen_addsrvvm2hi */

        case 3:
          if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30164; /* *dual_widen_addsrvvm1hi */

        case 4:
          if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30170; /* *dual_widen_addsrvvmf2hi */

        case 5:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30176; /* *dual_widen_addsrvvmf4hi */

        case 6:
          if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30182; /* *dual_widen_addsrvvm8si */

        case 7:
          if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30188; /* *dual_widen_addsrvvm4si */

        case 8:
          if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30194; /* *dual_widen_addsrvvm2si */

        case 9:
          if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30200; /* *dual_widen_addsrvvm1si */

        case 10:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30206; /* *dual_widen_addsrvvmf2si */

        case 11:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30212; /* *dual_widen_addsrvvm8di */

        case 12:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30218; /* *dual_widen_addsrvvm4di */

        case 13:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30224; /* *dual_widen_addsrvvm2di */

        case 14:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30230; /* *dual_widen_addsrvvm1di */

        case 15:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 30236; /* *dual_widen_addsv1hi */

        case 16:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 30242; /* *dual_widen_addsv2hi */

        case 17:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 30248; /* *dual_widen_addsv4hi */

        case 18:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 30254; /* *dual_widen_addsv8hi */

        case 19:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 30260; /* *dual_widen_addsv16hi */

        case 20:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30266; /* *dual_widen_addsv32hi */

        case 21:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30272; /* *dual_widen_addsv64hi */

        case 22:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30278; /* *dual_widen_addsv128hi */

        case 23:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30284; /* *dual_widen_addsv256hi */

        case 24:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30290; /* *dual_widen_addsv512hi */

        case 25:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30296; /* *dual_widen_addsv1024hi */

        case 26:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30302; /* *dual_widen_addsv2048hi */

        case 27:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 30308; /* *dual_widen_addsv1si */

        case 28:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 30314; /* *dual_widen_addsv2si */

        case 29:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 30320; /* *dual_widen_addsv4si */

        case 30:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 30326; /* *dual_widen_addsv8si */

        case 31:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30332; /* *dual_widen_addsv16si */

        case 32:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30338; /* *dual_widen_addsv32si */

        case 33:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30344; /* *dual_widen_addsv64si */

        case 34:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30350; /* *dual_widen_addsv128si */

        case 35:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30356; /* *dual_widen_addsv256si */

        case 36:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30362; /* *dual_widen_addsv512si */

        case 37:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30368; /* *dual_widen_addsv1024si */

        case 38:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30374; /* *dual_widen_addsv1di */

        case 39:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30380; /* *dual_widen_addsv2di */

        case 40:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30386; /* *dual_widen_addsv4di */

        case 41:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30392; /* *dual_widen_addsv8di */

        case 42:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30398; /* *dual_widen_addsv16di */

        case 43:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30404; /* *dual_widen_addsv32di */

        case 44:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30410; /* *dual_widen_addsv64di */

        case 45:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30416; /* *dual_widen_addsv128di */

        case 46:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30422; /* *dual_widen_addsv256di */

        case 47:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30428; /* *dual_widen_addsv512di */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern148 (x2))
        {
        case 0:
          if (!
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30530; /* *single_widen_addsrvvm8hi */

        case 1:
          if (!
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30532; /* *single_widen_addsrvvm4hi */

        case 2:
          if (!
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30534; /* *single_widen_addsrvvm2hi */

        case 3:
          if (!
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30536; /* *single_widen_addsrvvm1hi */

        case 4:
          if (!
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30538; /* *single_widen_addsrvvmf2hi */

        case 5:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30540; /* *single_widen_addsrvvmf4hi */

        case 6:
          if (!
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30542; /* *single_widen_addsrvvm8si */

        case 7:
          if (!
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30544; /* *single_widen_addsrvvm4si */

        case 8:
          if (!
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30546; /* *single_widen_addsrvvm2si */

        case 9:
          if (!
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30548; /* *single_widen_addsrvvm1si */

        case 10:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30550; /* *single_widen_addsrvvmf2si */

        case 11:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30552; /* *single_widen_addsrvvm8di */

        case 12:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30554; /* *single_widen_addsrvvm4di */

        case 13:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30556; /* *single_widen_addsrvvm2di */

        case 14:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30558; /* *single_widen_addsrvvm1di */

        case 15:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 30560; /* *single_widen_addsv1hi */

        case 16:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 30562; /* *single_widen_addsv2hi */

        case 17:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 30564; /* *single_widen_addsv4hi */

        case 18:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 30566; /* *single_widen_addsv8hi */

        case 19:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 30568; /* *single_widen_addsv16hi */

        case 20:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30570; /* *single_widen_addsv32hi */

        case 21:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30572; /* *single_widen_addsv64hi */

        case 22:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30574; /* *single_widen_addsv128hi */

        case 23:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30576; /* *single_widen_addsv256hi */

        case 24:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30578; /* *single_widen_addsv512hi */

        case 25:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30580; /* *single_widen_addsv1024hi */

        case 26:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30582; /* *single_widen_addsv2048hi */

        case 27:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 30584; /* *single_widen_addsv1si */

        case 28:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 30586; /* *single_widen_addsv2si */

        case 29:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 30588; /* *single_widen_addsv4si */

        case 30:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 30590; /* *single_widen_addsv8si */

        case 31:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30592; /* *single_widen_addsv16si */

        case 32:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30594; /* *single_widen_addsv32si */

        case 33:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30596; /* *single_widen_addsv64si */

        case 34:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30598; /* *single_widen_addsv128si */

        case 35:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30600; /* *single_widen_addsv256si */

        case 36:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30602; /* *single_widen_addsv512si */

        case 37:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30604; /* *single_widen_addsv1024si */

        case 38:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30606; /* *single_widen_addsv1di */

        case 39:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30608; /* *single_widen_addsv2di */

        case 40:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30610; /* *single_widen_addsv4di */

        case 41:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30612; /* *single_widen_addsv8di */

        case 42:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30614; /* *single_widen_addsv16di */

        case 43:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30616; /* *single_widen_addsv32di */

        case 44:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30618; /* *single_widen_addsv64di */

        case 45:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30620; /* *single_widen_addsv128di */

        case 46:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30622; /* *single_widen_addsv256di */

        case 47:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30624; /* *single_widen_addsv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      return recog_18 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_HImode)
          || !
#line 384 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC))
        return -1;
      return 911; /* *th_msubhisi4 */

    case FLOAT_EXTEND:
      switch (pattern284 (x2))
        {
        case 0:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31532; /* *dual_widen_fnmarvvm8sf */

        case 1:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31533; /* *dual_widen_fnmarvvm4sf */

        case 2:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31534; /* *dual_widen_fnmarvvm2sf */

        case 3:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31535; /* *dual_widen_fnmarvvm1sf */

        case 4:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 31536; /* *dual_widen_fnmarvvmf2sf */

        case 5:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31537; /* *dual_widen_fnmarvvm8df */

        case 6:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31538; /* *dual_widen_fnmarvvm4df */

        case 7:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31539; /* *dual_widen_fnmarvvm2df */

        case 8:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31540; /* *dual_widen_fnmarvvm1df */

        case 9:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31541; /* *dual_widen_fnmav1sf */

        case 10:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31542; /* *dual_widen_fnmav2sf */

        case 11:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31543; /* *dual_widen_fnmav4sf */

        case 12:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31544; /* *dual_widen_fnmav8sf */

        case 13:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31545; /* *dual_widen_fnmav16sf */

        case 14:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31546; /* *dual_widen_fnmav32sf */

        case 15:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31547; /* *dual_widen_fnmav64sf */

        case 16:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31548; /* *dual_widen_fnmav128sf */

        case 17:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31549; /* *dual_widen_fnmav256sf */

        case 18:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31550; /* *dual_widen_fnmav512sf */

        case 19:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31551; /* *dual_widen_fnmav1024sf */

        case 20:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31552; /* *dual_widen_fnmav1df */

        case 21:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31553; /* *dual_widen_fnmav2df */

        case 22:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31554; /* *dual_widen_fnmav4df */

        case 23:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31555; /* *dual_widen_fnmav8df */

        case 24:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31556; /* *dual_widen_fnmav16df */

        case 25:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31557; /* *dual_widen_fnmav32df */

        case 26:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31558; /* *dual_widen_fnmav64df */

        case 27:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31559; /* *dual_widen_fnmav128df */

        case 28:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31560; /* *dual_widen_fnmav256df */

        case 29:
          if (!(
#line 1056 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31561; /* *dual_widen_fnmav512df */

        case 30:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31562; /* *single_widen_fnmarvvm8sf */

        case 31:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31563; /* *single_widen_fnmarvvm4sf */

        case 32:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31564; /* *single_widen_fnmarvvm2sf */

        case 33:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31565; /* *single_widen_fnmarvvm1sf */

        case 34:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 31566; /* *single_widen_fnmarvvmf2sf */

        case 35:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31567; /* *single_widen_fnmarvvm8df */

        case 36:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31568; /* *single_widen_fnmarvvm4df */

        case 37:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31569; /* *single_widen_fnmarvvm2df */

        case 38:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31570; /* *single_widen_fnmarvvm1df */

        case 39:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31571; /* *single_widen_fnmav1sf */

        case 40:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31572; /* *single_widen_fnmav2sf */

        case 41:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31573; /* *single_widen_fnmav4sf */

        case 42:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31574; /* *single_widen_fnmav8sf */

        case 43:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31575; /* *single_widen_fnmav16sf */

        case 44:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31576; /* *single_widen_fnmav32sf */

        case 45:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31577; /* *single_widen_fnmav64sf */

        case 46:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31578; /* *single_widen_fnmav128sf */

        case 47:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31579; /* *single_widen_fnmav256sf */

        case 48:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31580; /* *single_widen_fnmav512sf */

        case 49:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31581; /* *single_widen_fnmav1024sf */

        case 50:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31582; /* *single_widen_fnmav1df */

        case 51:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31583; /* *single_widen_fnmav2df */

        case 52:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31584; /* *single_widen_fnmav4df */

        case 53:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31585; /* *single_widen_fnmav8df */

        case 54:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31586; /* *single_widen_fnmav16df */

        case 55:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31587; /* *single_widen_fnmav32df */

        case 56:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31588; /* *single_widen_fnmav64df */

        case 57:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31589; /* *single_widen_fnmav128df */

        case 58:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31590; /* *single_widen_fnmav256df */

        case 59:
          if (!(
#line 1080 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31591; /* *single_widen_fnmav512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern158 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[2], E_RVVM8SImode)
          && 
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32263; /* *vwsll_zext1_trunc_rvvm8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32323; /* *vwsll_zext1_trunc_scalar_rvvm8si */

    case 1:
      if (vector_shift_operand (operands[2], E_RVVM4SImode)
          && 
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32264; /* *vwsll_zext1_trunc_rvvm4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32324; /* *vwsll_zext1_trunc_scalar_rvvm4si */

    case 2:
      if (vector_shift_operand (operands[2], E_RVVM2SImode)
          && 
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32265; /* *vwsll_zext1_trunc_rvvm2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32325; /* *vwsll_zext1_trunc_scalar_rvvm2si */

    case 3:
      if (vector_shift_operand (operands[2], E_RVVM1SImode)
          && 
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32266; /* *vwsll_zext1_trunc_rvvm1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32326; /* *vwsll_zext1_trunc_scalar_rvvm1si */

    case 4:
      if (vector_shift_operand (operands[2], E_RVVMF2SImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32267; /* *vwsll_zext1_trunc_rvvmf2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32327; /* *vwsll_zext1_trunc_scalar_rvvmf2si */

    case 5:
      if (vector_shift_operand (operands[2], E_RVVM8DImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32268; /* *vwsll_zext1_trunc_rvvm8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32328; /* *vwsll_zext1_trunc_scalar_rvvm8di */

    case 6:
      if (vector_shift_operand (operands[2], E_RVVM4DImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32269; /* *vwsll_zext1_trunc_rvvm4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32329; /* *vwsll_zext1_trunc_scalar_rvvm4di */

    case 7:
      if (vector_shift_operand (operands[2], E_RVVM2DImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32270; /* *vwsll_zext1_trunc_rvvm2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32330; /* *vwsll_zext1_trunc_scalar_rvvm2di */

    case 8:
      if (vector_shift_operand (operands[2], E_RVVM1DImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32271; /* *vwsll_zext1_trunc_rvvm1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32331; /* *vwsll_zext1_trunc_scalar_rvvm1di */

    case 9:
      if (vector_shift_operand (operands[2], E_V1SImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 32272; /* *vwsll_zext1_trunc_v1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32332; /* *vwsll_zext1_trunc_scalar_v1si */

    case 10:
      if (vector_shift_operand (operands[2], E_V2SImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 32273; /* *vwsll_zext1_trunc_v2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32333; /* *vwsll_zext1_trunc_scalar_v2si */

    case 11:
      if (vector_shift_operand (operands[2], E_V4SImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 32274; /* *vwsll_zext1_trunc_v4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32334; /* *vwsll_zext1_trunc_scalar_v4si */

    case 12:
      if (vector_shift_operand (operands[2], E_V8SImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 32275; /* *vwsll_zext1_trunc_v8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32335; /* *vwsll_zext1_trunc_scalar_v8si */

    case 13:
      if (vector_shift_operand (operands[2], E_V16SImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 32276; /* *vwsll_zext1_trunc_v16si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32336; /* *vwsll_zext1_trunc_scalar_v16si */

    case 14:
      if (vector_shift_operand (operands[2], E_V32SImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 32277; /* *vwsll_zext1_trunc_v32si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32337; /* *vwsll_zext1_trunc_scalar_v32si */

    case 15:
      if (vector_shift_operand (operands[2], E_V64SImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 32278; /* *vwsll_zext1_trunc_v64si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32338; /* *vwsll_zext1_trunc_scalar_v64si */

    case 16:
      if (vector_shift_operand (operands[2], E_V128SImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 32279; /* *vwsll_zext1_trunc_v128si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32339; /* *vwsll_zext1_trunc_scalar_v128si */

    case 17:
      if (vector_shift_operand (operands[2], E_V256SImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 32280; /* *vwsll_zext1_trunc_v256si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32340; /* *vwsll_zext1_trunc_scalar_v256si */

    case 18:
      if (vector_shift_operand (operands[2], E_V512SImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 32281; /* *vwsll_zext1_trunc_v512si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32341; /* *vwsll_zext1_trunc_scalar_v512si */

    case 19:
      if (vector_shift_operand (operands[2], E_V1024SImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 32282; /* *vwsll_zext1_trunc_v1024si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32342; /* *vwsll_zext1_trunc_scalar_v1024si */

    case 20:
      if (vector_shift_operand (operands[2], E_V1DImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 32283; /* *vwsll_zext1_trunc_v1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32343; /* *vwsll_zext1_trunc_scalar_v1di */

    case 21:
      if (vector_shift_operand (operands[2], E_V2DImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 32284; /* *vwsll_zext1_trunc_v2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32344; /* *vwsll_zext1_trunc_scalar_v2di */

    case 22:
      if (vector_shift_operand (operands[2], E_V4DImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 32285; /* *vwsll_zext1_trunc_v4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32345; /* *vwsll_zext1_trunc_scalar_v4di */

    case 23:
      if (vector_shift_operand (operands[2], E_V8DImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 32286; /* *vwsll_zext1_trunc_v8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32346; /* *vwsll_zext1_trunc_scalar_v8di */

    case 24:
      if (vector_shift_operand (operands[2], E_V16DImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 32287; /* *vwsll_zext1_trunc_v16di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32347; /* *vwsll_zext1_trunc_scalar_v16di */

    case 25:
      if (vector_shift_operand (operands[2], E_V32DImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 32288; /* *vwsll_zext1_trunc_v32di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32348; /* *vwsll_zext1_trunc_scalar_v32di */

    case 26:
      if (vector_shift_operand (operands[2], E_V64DImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 32289; /* *vwsll_zext1_trunc_v64di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32349; /* *vwsll_zext1_trunc_scalar_v64di */

    case 27:
      if (vector_shift_operand (operands[2], E_V128DImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 32290; /* *vwsll_zext1_trunc_v128di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32350; /* *vwsll_zext1_trunc_scalar_v128di */

    case 28:
      if (vector_shift_operand (operands[2], E_V256DImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 32291; /* *vwsll_zext1_trunc_v256di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32351; /* *vwsll_zext1_trunc_scalar_v256di */

    case 29:
      if (vector_shift_operand (operands[2], E_V512DImode)
          && (
#line 1552 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 32292; /* *vwsll_zext1_trunc_v512di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32352; /* *vwsll_zext1_trunc_scalar_v512di */

    case 30:
      if (!
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32293; /* *vwsll_zext2_trunc_rvvm8si */

    case 31:
      if (!
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32294; /* *vwsll_zext2_trunc_rvvm4si */

    case 32:
      if (!
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32295; /* *vwsll_zext2_trunc_rvvm2si */

    case 33:
      if (!
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32296; /* *vwsll_zext2_trunc_rvvm1si */

    case 34:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32297; /* *vwsll_zext2_trunc_rvvmf2si */

    case 35:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32298; /* *vwsll_zext2_trunc_rvvm8di */

    case 36:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32299; /* *vwsll_zext2_trunc_rvvm4di */

    case 37:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32300; /* *vwsll_zext2_trunc_rvvm2di */

    case 38:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32301; /* *vwsll_zext2_trunc_rvvm1di */

    case 39:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32302; /* *vwsll_zext2_trunc_v1si */

    case 40:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32303; /* *vwsll_zext2_trunc_v2si */

    case 41:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32304; /* *vwsll_zext2_trunc_v4si */

    case 42:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32305; /* *vwsll_zext2_trunc_v8si */

    case 43:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32306; /* *vwsll_zext2_trunc_v16si */

    case 44:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32307; /* *vwsll_zext2_trunc_v32si */

    case 45:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32308; /* *vwsll_zext2_trunc_v64si */

    case 46:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32309; /* *vwsll_zext2_trunc_v128si */

    case 47:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32310; /* *vwsll_zext2_trunc_v256si */

    case 48:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32311; /* *vwsll_zext2_trunc_v512si */

    case 49:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32312; /* *vwsll_zext2_trunc_v1024si */

    case 50:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32313; /* *vwsll_zext2_trunc_v1di */

    case 51:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32314; /* *vwsll_zext2_trunc_v2di */

    case 52:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32315; /* *vwsll_zext2_trunc_v4di */

    case 53:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32316; /* *vwsll_zext2_trunc_v8di */

    case 54:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32317; /* *vwsll_zext2_trunc_v16di */

    case 55:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32318; /* *vwsll_zext2_trunc_v32di */

    case 56:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32319; /* *vwsll_zext2_trunc_v64di */

    case 57:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32320; /* *vwsll_zext2_trunc_v128di */

    case 58:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32321; /* *vwsll_zext2_trunc_v256di */

    case 59:
      if (!(
#line 1575 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32322; /* *vwsll_zext2_trunc_v512di */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern525 (x2))
    {
    case 0:
      if (pattern575 (x2) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVM1BImode
          || !
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8835; /* pred_msbcrvvm8qi_overflow */

    case 1:
      if (!register_operand (operands[0], E_RVVMF2BImode)
          || GET_MODE (x2) != E_RVVMF2BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF2BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern630 (x4))
        {
        case 0:
          if (!
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8836; /* pred_msbcrvvm4qi_overflow */

        case 1:
          if (!
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8839; /* pred_msbcrvvm8hi_overflow */

        default:
          return -1;
        }

    case 2:
      if (!register_operand (operands[0], E_RVVMF4BImode)
          || GET_MODE (x2) != E_RVVMF4BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF4BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern631 (x4))
        {
        case 0:
          if (!
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8837; /* pred_msbcrvvm2qi_overflow */

        case 1:
          if (!
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8840; /* pred_msbcrvvm4hi_overflow */

        case 2:
          if (!
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8843; /* pred_msbcrvvm8si_overflow */

        default:
          return -1;
        }

    case 3:
      if (!register_operand (operands[0], E_RVVMF8BImode)
          || GET_MODE (x2) != E_RVVMF8BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF8BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern632 (x4))
        {
        case 0:
          if (!
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8838; /* pred_msbcrvvm1qi_overflow */

        case 1:
          if (!
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8841; /* pred_msbcrvvm2hi_overflow */

        case 2:
          if (!
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8844; /* pred_msbcrvvm4si_overflow */

        case 3:
          if (!(
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8847; /* pred_msbcrvvm8di_overflow */

        default:
          return -1;
        }

    case 4:
      if (!register_operand (operands[0], E_RVVMF16BImode)
          || GET_MODE (x2) != E_RVVMF16BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF16BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern633 (x4))
        {
        case 0:
          if (!
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8842; /* pred_msbcrvvm1hi_overflow */

        case 1:
          if (!
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8845; /* pred_msbcrvvm2si_overflow */

        case 2:
          if (!(
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8848; /* pred_msbcrvvm4di_overflow */

        case 3:
          if (!(
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8851; /* pred_msbcrvvmf2qi_overflow */

        default:
          return -1;
        }

    case 5:
      if (!register_operand (operands[0], E_RVVMF32BImode)
          || GET_MODE (x2) != E_RVVMF32BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF32BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern634 (x4))
        {
        case 0:
          if (!
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8846; /* pred_msbcrvvm1si_overflow */

        case 1:
          if (!(
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8849; /* pred_msbcrvvm2di_overflow */

        case 2:
          if (!(
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8852; /* pred_msbcrvvmf4qi_overflow */

        case 3:
          if (!(
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8854; /* pred_msbcrvvmf2hi_overflow */

        default:
          return -1;
        }

    case 6:
      if (!register_operand (operands[0], E_RVVMF64BImode)
          || GET_MODE (x2) != E_RVVMF64BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF64BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern635 (x4))
        {
        case 0:
          if (!(
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8850; /* pred_msbcrvvm1di_overflow */

        case 1:
          if (!(
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8853; /* pred_msbcrvvmf8qi_overflow */

        case 2:
          if (!(
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8855; /* pred_msbcrvvmf4hi_overflow */

        case 3:
          if (!(
#line 3699 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8856; /* pred_msbcrvvmf2si_overflow */

        default:
          return -1;
        }

    case 7:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8911; /* pred_msbcrvvm8qi_overflow_scalar */

    case 8:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8912; /* pred_msbcrvvm4qi_overflow_scalar */

    case 9:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8918; /* pred_msbcrvvm8hi_overflow_scalar */

    case 10:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8913; /* pred_msbcrvvm2qi_overflow_scalar */

    case 11:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8919; /* pred_msbcrvvm4hi_overflow_scalar */

    case 12:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8924; /* pred_msbcrvvm8si_overflow_scalar */

    case 13:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8914; /* pred_msbcrvvm1qi_overflow_scalar */

    case 14:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8920; /* pred_msbcrvvm2hi_overflow_scalar */

    case 15:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8925; /* pred_msbcrvvm4si_overflow_scalar */

    case 16:
      if (!(
#line 3856 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8973; /* *pred_msbcrvvm8di_overflow_scalar */

    case 17:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8915; /* pred_msbcrvvmf2qi_overflow_scalar */

    case 18:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8921; /* pred_msbcrvvm1hi_overflow_scalar */

    case 19:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8926; /* pred_msbcrvvm2si_overflow_scalar */

    case 20:
      if (!(
#line 3856 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8974; /* *pred_msbcrvvm4di_overflow_scalar */

    case 21:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8916; /* pred_msbcrvvmf4qi_overflow_scalar */

    case 22:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8922; /* pred_msbcrvvmf2hi_overflow_scalar */

    case 23:
      if (!
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8927; /* pred_msbcrvvm1si_overflow_scalar */

    case 24:
      if (!(
#line 3856 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8975; /* *pred_msbcrvvm2di_overflow_scalar */

    case 25:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8917; /* pred_msbcrvvmf8qi_overflow_scalar */

    case 26:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8923; /* pred_msbcrvvmf4hi_overflow_scalar */

    case 27:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8928; /* pred_msbcrvvmf2si_overflow_scalar */

    case 28:
      if (!(
#line 3856 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8976; /* *pred_msbcrvvm1di_overflow_scalar */

    case 29:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8929; /* pred_msbcv1qi_overflow_scalar */

    case 30:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8942; /* pred_msbcv1hi_overflow_scalar */

    case 31:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8954; /* pred_msbcv1si_overflow_scalar */

    case 32:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8930; /* pred_msbcv2qi_overflow_scalar */

    case 33:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8943; /* pred_msbcv2hi_overflow_scalar */

    case 34:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8955; /* pred_msbcv2si_overflow_scalar */

    case 35:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8931; /* pred_msbcv4qi_overflow_scalar */

    case 36:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8944; /* pred_msbcv4hi_overflow_scalar */

    case 37:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8956; /* pred_msbcv4si_overflow_scalar */

    case 38:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8932; /* pred_msbcv8qi_overflow_scalar */

    case 39:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8945; /* pred_msbcv8hi_overflow_scalar */

    case 40:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8957; /* pred_msbcv8si_overflow_scalar */

    case 41:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8933; /* pred_msbcv16qi_overflow_scalar */

    case 42:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8946; /* pred_msbcv16hi_overflow_scalar */

    case 43:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8958; /* pred_msbcv16si_overflow_scalar */

    case 44:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8934; /* pred_msbcv32qi_overflow_scalar */

    case 45:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8947; /* pred_msbcv32hi_overflow_scalar */

    case 46:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8959; /* pred_msbcv32si_overflow_scalar */

    case 47:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8935; /* pred_msbcv64qi_overflow_scalar */

    case 48:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8948; /* pred_msbcv64hi_overflow_scalar */

    case 49:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8960; /* pred_msbcv64si_overflow_scalar */

    case 50:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8936; /* pred_msbcv128qi_overflow_scalar */

    case 51:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8949; /* pred_msbcv128hi_overflow_scalar */

    case 52:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8961; /* pred_msbcv128si_overflow_scalar */

    case 53:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8937; /* pred_msbcv256qi_overflow_scalar */

    case 54:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8950; /* pred_msbcv256hi_overflow_scalar */

    case 55:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8962; /* pred_msbcv256si_overflow_scalar */

    case 56:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8938; /* pred_msbcv512qi_overflow_scalar */

    case 57:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8951; /* pred_msbcv512hi_overflow_scalar */

    case 58:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8963; /* pred_msbcv512si_overflow_scalar */

    case 59:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8939; /* pred_msbcv1024qi_overflow_scalar */

    case 60:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8952; /* pred_msbcv1024hi_overflow_scalar */

    case 61:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8964; /* pred_msbcv1024si_overflow_scalar */

    case 62:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8940; /* pred_msbcv2048qi_overflow_scalar */

    case 63:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8953; /* pred_msbcv2048hi_overflow_scalar */

    case 64:
      if (!(
#line 3739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8941; /* pred_msbcv4096qi_overflow_scalar */

    case 65:
      if (!(
#line 3877 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8977; /* *pred_msbcrvvm8di_overflow_extended_scalar */

    case 66:
      if (!(
#line 3877 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8978; /* *pred_msbcrvvm4di_overflow_extended_scalar */

    case 67:
      if (!(
#line 3877 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8979; /* *pred_msbcrvvm2di_overflow_extended_scalar */

    case 68:
      if (!(
#line 3877 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8980; /* *pred_msbcrvvm1di_overflow_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (pattern163 (x3, 
E_SFmode) != 0
          || !
#line 1620 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 81; /* copysignsf3 */

    case E_DFmode:
      if (pattern163 (x3, 
E_DFmode) != 0
          || !(
#line 1620 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 82; /* copysigndf3 */

    case E_HFmode:
      if (pattern163 (x3, 
E_HFmode) != 0
          || !(
#line 1620 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 83; /* copysignhf3 */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (pattern333 (x3))
    {
    case 0:
      if (!(
#line 125 "../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 671; /* riscv_packh_si */

    case 1:
      if (!(
#line 125 "../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 672; /* riscv_packh_di */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern245 (x2))
    {
    case 0:
      if (!
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28075; /* reduc_plus_scal_rvvm8qi */

    case 1:
      if (!
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28076; /* reduc_plus_scal_rvvm4qi */

    case 2:
      if (!
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28077; /* reduc_plus_scal_rvvm2qi */

    case 3:
      if (!
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28078; /* reduc_plus_scal_rvvm1qi */

    case 4:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 28091; /* reduc_plus_scal_rvvmf2qi */

    case 5:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 28092; /* reduc_plus_scal_rvvmf4qi */

    case 6:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 28093; /* reduc_plus_scal_rvvmf8qi */

    case 7:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 28097; /* reduc_plus_scal_v1qi */

    case 8:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 28098; /* reduc_plus_scal_v2qi */

    case 9:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 28099; /* reduc_plus_scal_v4qi */

    case 10:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 28100; /* reduc_plus_scal_v8qi */

    case 11:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 28101; /* reduc_plus_scal_v16qi */

    case 12:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 28102; /* reduc_plus_scal_v32qi */

    case 13:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28103; /* reduc_plus_scal_v64qi */

    case 14:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28104; /* reduc_plus_scal_v128qi */

    case 15:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28105; /* reduc_plus_scal_v256qi */

    case 16:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28106; /* reduc_plus_scal_v512qi */

    case 17:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28107; /* reduc_plus_scal_v1024qi */

    case 18:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28108; /* reduc_plus_scal_v2048qi */

    case 19:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28109; /* reduc_plus_scal_v4096qi */

    case 20:
      if (!
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28079; /* reduc_plus_scal_rvvm8hi */

    case 21:
      if (!
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28080; /* reduc_plus_scal_rvvm4hi */

    case 22:
      if (!
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28081; /* reduc_plus_scal_rvvm2hi */

    case 23:
      if (!
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28082; /* reduc_plus_scal_rvvm1hi */

    case 24:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 28094; /* reduc_plus_scal_rvvmf2hi */

    case 25:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 28095; /* reduc_plus_scal_rvvmf4hi */

    case 26:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28110; /* reduc_plus_scal_v1hi */

    case 27:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28111; /* reduc_plus_scal_v2hi */

    case 28:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28112; /* reduc_plus_scal_v4hi */

    case 29:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28113; /* reduc_plus_scal_v8hi */

    case 30:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28114; /* reduc_plus_scal_v16hi */

    case 31:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28115; /* reduc_plus_scal_v32hi */

    case 32:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28116; /* reduc_plus_scal_v64hi */

    case 33:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28117; /* reduc_plus_scal_v128hi */

    case 34:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28118; /* reduc_plus_scal_v256hi */

    case 35:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28119; /* reduc_plus_scal_v512hi */

    case 36:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28120; /* reduc_plus_scal_v1024hi */

    case 37:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28121; /* reduc_plus_scal_v2048hi */

    case 38:
      if (!
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28083; /* reduc_plus_scal_rvvm8si */

    case 39:
      if (!
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28084; /* reduc_plus_scal_rvvm4si */

    case 40:
      if (!
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28085; /* reduc_plus_scal_rvvm2si */

    case 41:
      if (!
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28086; /* reduc_plus_scal_rvvm1si */

    case 42:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 28096; /* reduc_plus_scal_rvvmf2si */

    case 43:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28122; /* reduc_plus_scal_v1si */

    case 44:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28123; /* reduc_plus_scal_v2si */

    case 45:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28124; /* reduc_plus_scal_v4si */

    case 46:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28125; /* reduc_plus_scal_v8si */

    case 47:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28126; /* reduc_plus_scal_v16si */

    case 48:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28127; /* reduc_plus_scal_v32si */

    case 49:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28128; /* reduc_plus_scal_v64si */

    case 50:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28129; /* reduc_plus_scal_v128si */

    case 51:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28130; /* reduc_plus_scal_v256si */

    case 52:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28131; /* reduc_plus_scal_v512si */

    case 53:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28132; /* reduc_plus_scal_v1024si */

    case 54:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28087; /* reduc_plus_scal_rvvm8di */

    case 55:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28088; /* reduc_plus_scal_rvvm4di */

    case 56:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28089; /* reduc_plus_scal_rvvm2di */

    case 57:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28090; /* reduc_plus_scal_rvvm1di */

    case 58:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28133; /* reduc_plus_scal_v1di */

    case 59:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28134; /* reduc_plus_scal_v2di */

    case 60:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28135; /* reduc_plus_scal_v4di */

    case 61:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28136; /* reduc_plus_scal_v8di */

    case 62:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28137; /* reduc_plus_scal_v16di */

    case 63:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28138; /* reduc_plus_scal_v32di */

    case 64:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28139; /* reduc_plus_scal_v64di */

    case 65:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28140; /* reduc_plus_scal_v128di */

    case 66:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28141; /* reduc_plus_scal_v256di */

    case 67:
      if (!(
#line 2183 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28142; /* reduc_plus_scal_v512di */

    case 68:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30998; /* *widen_reduc_plus_scal_rvvm4qi */

    case 69:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31000; /* *widen_reduc_plus_scal_rvvm2qi */

    case 70:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31002; /* *widen_reduc_plus_scal_rvvm1qi */

    case 71:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31004; /* *widen_reduc_plus_scal_rvvmf2qi */

    case 72:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31006; /* *widen_reduc_plus_scal_rvvmf4qi */

    case 73:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31008; /* *widen_reduc_plus_scal_rvvmf8qi */

    case 74:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 31028; /* *widen_reduc_plus_scal_v1qi */

    case 75:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 31030; /* *widen_reduc_plus_scal_v2qi */

    case 76:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 31032; /* *widen_reduc_plus_scal_v4qi */

    case 77:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 31034; /* *widen_reduc_plus_scal_v8qi */

    case 78:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 31036; /* *widen_reduc_plus_scal_v16qi */

    case 79:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 31038; /* *widen_reduc_plus_scal_v32qi */

    case 80:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31040; /* *widen_reduc_plus_scal_v64qi */

    case 81:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31042; /* *widen_reduc_plus_scal_v128qi */

    case 82:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31044; /* *widen_reduc_plus_scal_v256qi */

    case 83:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31046; /* *widen_reduc_plus_scal_v512qi */

    case 84:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31048; /* *widen_reduc_plus_scal_v1024qi */

    case 85:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31050; /* *widen_reduc_plus_scal_v2048qi */

    case 86:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31010; /* *widen_reduc_plus_scal_rvvm4hi */

    case 87:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31012; /* *widen_reduc_plus_scal_rvvm2hi */

    case 88:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31014; /* *widen_reduc_plus_scal_rvvm1hi */

    case 89:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31016; /* *widen_reduc_plus_scal_rvvmf2hi */

    case 90:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31018; /* *widen_reduc_plus_scal_rvvmf4hi */

    case 91:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31052; /* *widen_reduc_plus_scal_v1hi */

    case 92:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31074; /* *widen_reduc_plus_scal_v1si */

    case 93:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31054; /* *widen_reduc_plus_scal_v2hi */

    case 94:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31076; /* *widen_reduc_plus_scal_v2si */

    case 95:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31056; /* *widen_reduc_plus_scal_v4hi */

    case 96:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31078; /* *widen_reduc_plus_scal_v4si */

    case 97:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31058; /* *widen_reduc_plus_scal_v8hi */

    case 98:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31080; /* *widen_reduc_plus_scal_v8si */

    case 99:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31060; /* *widen_reduc_plus_scal_v16hi */

    case 100:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31082; /* *widen_reduc_plus_scal_v16si */

    case 101:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31062; /* *widen_reduc_plus_scal_v32hi */

    case 102:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31084; /* *widen_reduc_plus_scal_v32si */

    case 103:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31064; /* *widen_reduc_plus_scal_v64hi */

    case 104:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31086; /* *widen_reduc_plus_scal_v64si */

    case 105:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31066; /* *widen_reduc_plus_scal_v128hi */

    case 106:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31088; /* *widen_reduc_plus_scal_v128si */

    case 107:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31068; /* *widen_reduc_plus_scal_v256hi */

    case 108:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31090; /* *widen_reduc_plus_scal_v256si */

    case 109:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31070; /* *widen_reduc_plus_scal_v512hi */

    case 110:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31092; /* *widen_reduc_plus_scal_v512si */

    case 111:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31072; /* *widen_reduc_plus_scal_v1024hi */

    case 112:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31020; /* *widen_reduc_plus_scal_rvvm4si */

    case 113:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31022; /* *widen_reduc_plus_scal_rvvm2si */

    case 114:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31024; /* *widen_reduc_plus_scal_rvvm1si */

    case 115:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31026; /* *widen_reduc_plus_scal_rvvmf2si */

    case 116:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30999; /* *widen_reduc_plus_scal_rvvm4qi */

    case 117:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31001; /* *widen_reduc_plus_scal_rvvm2qi */

    case 118:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31003; /* *widen_reduc_plus_scal_rvvm1qi */

    case 119:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31005; /* *widen_reduc_plus_scal_rvvmf2qi */

    case 120:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31007; /* *widen_reduc_plus_scal_rvvmf4qi */

    case 121:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31009; /* *widen_reduc_plus_scal_rvvmf8qi */

    case 122:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 31029; /* *widen_reduc_plus_scal_v1qi */

    case 123:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 31031; /* *widen_reduc_plus_scal_v2qi */

    case 124:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 31033; /* *widen_reduc_plus_scal_v4qi */

    case 125:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 31035; /* *widen_reduc_plus_scal_v8qi */

    case 126:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 31037; /* *widen_reduc_plus_scal_v16qi */

    case 127:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 31039; /* *widen_reduc_plus_scal_v32qi */

    case 128:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31041; /* *widen_reduc_plus_scal_v64qi */

    case 129:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31043; /* *widen_reduc_plus_scal_v128qi */

    case 130:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31045; /* *widen_reduc_plus_scal_v256qi */

    case 131:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31047; /* *widen_reduc_plus_scal_v512qi */

    case 132:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31049; /* *widen_reduc_plus_scal_v1024qi */

    case 133:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31051; /* *widen_reduc_plus_scal_v2048qi */

    case 134:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31011; /* *widen_reduc_plus_scal_rvvm4hi */

    case 135:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31013; /* *widen_reduc_plus_scal_rvvm2hi */

    case 136:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31015; /* *widen_reduc_plus_scal_rvvm1hi */

    case 137:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31017; /* *widen_reduc_plus_scal_rvvmf2hi */

    case 138:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31019; /* *widen_reduc_plus_scal_rvvmf4hi */

    case 139:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31053; /* *widen_reduc_plus_scal_v1hi */

    case 140:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31075; /* *widen_reduc_plus_scal_v1si */

    case 141:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31055; /* *widen_reduc_plus_scal_v2hi */

    case 142:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31077; /* *widen_reduc_plus_scal_v2si */

    case 143:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31057; /* *widen_reduc_plus_scal_v4hi */

    case 144:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31079; /* *widen_reduc_plus_scal_v4si */

    case 145:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31059; /* *widen_reduc_plus_scal_v8hi */

    case 146:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31081; /* *widen_reduc_plus_scal_v8si */

    case 147:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31061; /* *widen_reduc_plus_scal_v16hi */

    case 148:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31083; /* *widen_reduc_plus_scal_v16si */

    case 149:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31063; /* *widen_reduc_plus_scal_v32hi */

    case 150:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31085; /* *widen_reduc_plus_scal_v32si */

    case 151:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31065; /* *widen_reduc_plus_scal_v64hi */

    case 152:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31087; /* *widen_reduc_plus_scal_v64si */

    case 153:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31067; /* *widen_reduc_plus_scal_v128hi */

    case 154:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31089; /* *widen_reduc_plus_scal_v128si */

    case 155:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31069; /* *widen_reduc_plus_scal_v256hi */

    case 156:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31091; /* *widen_reduc_plus_scal_v256si */

    case 157:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31071; /* *widen_reduc_plus_scal_v512hi */

    case 158:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31093; /* *widen_reduc_plus_scal_v512si */

    case 159:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31073; /* *widen_reduc_plus_scal_v1024hi */

    case 160:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31021; /* *widen_reduc_plus_scal_rvvm4si */

    case 161:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31023; /* *widen_reduc_plus_scal_rvvm2si */

    case 162:
      if (!
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31025; /* *widen_reduc_plus_scal_rvvm1si */

    case 163:
      if (!(
#line 808 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31027; /* *widen_reduc_plus_scal_rvvmf2si */

    case 164:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31712; /* *cond_widen_reduc_plus_scal_rvvm4qi */

    case 165:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31714; /* *cond_widen_reduc_plus_scal_rvvm2qi */

    case 166:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31716; /* *cond_widen_reduc_plus_scal_rvvm1qi */

    case 167:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31718; /* *cond_widen_reduc_plus_scal_rvvmf2qi */

    case 168:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31720; /* *cond_widen_reduc_plus_scal_rvvmf4qi */

    case 169:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31722; /* *cond_widen_reduc_plus_scal_rvvmf8qi */

    case 170:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 31742; /* *cond_widen_reduc_plus_scal_v1qi */

    case 171:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 31744; /* *cond_widen_reduc_plus_scal_v2qi */

    case 172:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 31746; /* *cond_widen_reduc_plus_scal_v4qi */

    case 173:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 31748; /* *cond_widen_reduc_plus_scal_v8qi */

    case 174:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 31750; /* *cond_widen_reduc_plus_scal_v16qi */

    case 175:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 31752; /* *cond_widen_reduc_plus_scal_v32qi */

    case 176:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31754; /* *cond_widen_reduc_plus_scal_v64qi */

    case 177:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31756; /* *cond_widen_reduc_plus_scal_v128qi */

    case 178:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31758; /* *cond_widen_reduc_plus_scal_v256qi */

    case 179:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31760; /* *cond_widen_reduc_plus_scal_v512qi */

    case 180:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31762; /* *cond_widen_reduc_plus_scal_v1024qi */

    case 181:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31764; /* *cond_widen_reduc_plus_scal_v2048qi */

    case 182:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31724; /* *cond_widen_reduc_plus_scal_rvvm4hi */

    case 183:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31726; /* *cond_widen_reduc_plus_scal_rvvm2hi */

    case 184:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31728; /* *cond_widen_reduc_plus_scal_rvvm1hi */

    case 185:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31730; /* *cond_widen_reduc_plus_scal_rvvmf2hi */

    case 186:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31732; /* *cond_widen_reduc_plus_scal_rvvmf4hi */

    case 187:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31766; /* *cond_widen_reduc_plus_scal_v1hi */

    case 188:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31788; /* *cond_widen_reduc_plus_scal_v1si */

    case 189:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31768; /* *cond_widen_reduc_plus_scal_v2hi */

    case 190:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31790; /* *cond_widen_reduc_plus_scal_v2si */

    case 191:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31770; /* *cond_widen_reduc_plus_scal_v4hi */

    case 192:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31792; /* *cond_widen_reduc_plus_scal_v4si */

    case 193:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31772; /* *cond_widen_reduc_plus_scal_v8hi */

    case 194:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31794; /* *cond_widen_reduc_plus_scal_v8si */

    case 195:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31774; /* *cond_widen_reduc_plus_scal_v16hi */

    case 196:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31796; /* *cond_widen_reduc_plus_scal_v16si */

    case 197:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31776; /* *cond_widen_reduc_plus_scal_v32hi */

    case 198:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31798; /* *cond_widen_reduc_plus_scal_v32si */

    case 199:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31778; /* *cond_widen_reduc_plus_scal_v64hi */

    case 200:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31800; /* *cond_widen_reduc_plus_scal_v64si */

    case 201:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31780; /* *cond_widen_reduc_plus_scal_v128hi */

    case 202:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31802; /* *cond_widen_reduc_plus_scal_v128si */

    case 203:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31782; /* *cond_widen_reduc_plus_scal_v256hi */

    case 204:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31804; /* *cond_widen_reduc_plus_scal_v256si */

    case 205:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31784; /* *cond_widen_reduc_plus_scal_v512hi */

    case 206:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31806; /* *cond_widen_reduc_plus_scal_v512si */

    case 207:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31786; /* *cond_widen_reduc_plus_scal_v1024hi */

    case 208:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31734; /* *cond_widen_reduc_plus_scal_rvvm4si */

    case 209:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31736; /* *cond_widen_reduc_plus_scal_rvvm2si */

    case 210:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31738; /* *cond_widen_reduc_plus_scal_rvvm1si */

    case 211:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31740; /* *cond_widen_reduc_plus_scal_rvvmf2si */

    case 212:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31713; /* *cond_widen_reduc_plus_scal_rvvm4qi */

    case 213:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31715; /* *cond_widen_reduc_plus_scal_rvvm2qi */

    case 214:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31717; /* *cond_widen_reduc_plus_scal_rvvm1qi */

    case 215:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31719; /* *cond_widen_reduc_plus_scal_rvvmf2qi */

    case 216:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31721; /* *cond_widen_reduc_plus_scal_rvvmf4qi */

    case 217:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31723; /* *cond_widen_reduc_plus_scal_rvvmf8qi */

    case 218:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 31743; /* *cond_widen_reduc_plus_scal_v1qi */

    case 219:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 31745; /* *cond_widen_reduc_plus_scal_v2qi */

    case 220:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 31747; /* *cond_widen_reduc_plus_scal_v4qi */

    case 221:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 31749; /* *cond_widen_reduc_plus_scal_v8qi */

    case 222:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 31751; /* *cond_widen_reduc_plus_scal_v16qi */

    case 223:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 31753; /* *cond_widen_reduc_plus_scal_v32qi */

    case 224:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31755; /* *cond_widen_reduc_plus_scal_v64qi */

    case 225:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31757; /* *cond_widen_reduc_plus_scal_v128qi */

    case 226:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31759; /* *cond_widen_reduc_plus_scal_v256qi */

    case 227:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31761; /* *cond_widen_reduc_plus_scal_v512qi */

    case 228:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31763; /* *cond_widen_reduc_plus_scal_v1024qi */

    case 229:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31765; /* *cond_widen_reduc_plus_scal_v2048qi */

    case 230:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31725; /* *cond_widen_reduc_plus_scal_rvvm4hi */

    case 231:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31727; /* *cond_widen_reduc_plus_scal_rvvm2hi */

    case 232:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31729; /* *cond_widen_reduc_plus_scal_rvvm1hi */

    case 233:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31731; /* *cond_widen_reduc_plus_scal_rvvmf2hi */

    case 234:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31733; /* *cond_widen_reduc_plus_scal_rvvmf4hi */

    case 235:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31767; /* *cond_widen_reduc_plus_scal_v1hi */

    case 236:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31789; /* *cond_widen_reduc_plus_scal_v1si */

    case 237:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31769; /* *cond_widen_reduc_plus_scal_v2hi */

    case 238:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31791; /* *cond_widen_reduc_plus_scal_v2si */

    case 239:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31771; /* *cond_widen_reduc_plus_scal_v4hi */

    case 240:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31793; /* *cond_widen_reduc_plus_scal_v4si */

    case 241:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31773; /* *cond_widen_reduc_plus_scal_v8hi */

    case 242:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31795; /* *cond_widen_reduc_plus_scal_v8si */

    case 243:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31775; /* *cond_widen_reduc_plus_scal_v16hi */

    case 244:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31797; /* *cond_widen_reduc_plus_scal_v16si */

    case 245:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31777; /* *cond_widen_reduc_plus_scal_v32hi */

    case 246:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31799; /* *cond_widen_reduc_plus_scal_v32si */

    case 247:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31779; /* *cond_widen_reduc_plus_scal_v64hi */

    case 248:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31801; /* *cond_widen_reduc_plus_scal_v64si */

    case 249:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31781; /* *cond_widen_reduc_plus_scal_v128hi */

    case 250:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31803; /* *cond_widen_reduc_plus_scal_v128si */

    case 251:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31783; /* *cond_widen_reduc_plus_scal_v256hi */

    case 252:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31805; /* *cond_widen_reduc_plus_scal_v256si */

    case 253:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31785; /* *cond_widen_reduc_plus_scal_v512hi */

    case 254:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31807; /* *cond_widen_reduc_plus_scal_v512si */

    case 255:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31787; /* *cond_widen_reduc_plus_scal_v1024hi */

    case 256:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31735; /* *cond_widen_reduc_plus_scal_rvvm4si */

    case 257:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31737; /* *cond_widen_reduc_plus_scal_rvvm2si */

    case 258:
      if (!
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31739; /* *cond_widen_reduc_plus_scal_rvvm1si */

    case 259:
      if (!(
#line 1226 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31741; /* *cond_widen_reduc_plus_scal_rvvmf2si */

    case 260:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31808; /* *cond_len_widen_reduc_plus_scal_rvvm4qi */

    case 261:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31810; /* *cond_len_widen_reduc_plus_scal_rvvm2qi */

    case 262:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31812; /* *cond_len_widen_reduc_plus_scal_rvvm1qi */

    case 263:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31814; /* *cond_len_widen_reduc_plus_scal_rvvmf2qi */

    case 264:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31816; /* *cond_len_widen_reduc_plus_scal_rvvmf4qi */

    case 265:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31818; /* *cond_len_widen_reduc_plus_scal_rvvmf8qi */

    case 266:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 31838; /* *cond_len_widen_reduc_plus_scal_v1qi */

    case 267:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 31840; /* *cond_len_widen_reduc_plus_scal_v2qi */

    case 268:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 31842; /* *cond_len_widen_reduc_plus_scal_v4qi */

    case 269:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 31844; /* *cond_len_widen_reduc_plus_scal_v8qi */

    case 270:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 31846; /* *cond_len_widen_reduc_plus_scal_v16qi */

    case 271:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 31848; /* *cond_len_widen_reduc_plus_scal_v32qi */

    case 272:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31850; /* *cond_len_widen_reduc_plus_scal_v64qi */

    case 273:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31852; /* *cond_len_widen_reduc_plus_scal_v128qi */

    case 274:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31854; /* *cond_len_widen_reduc_plus_scal_v256qi */

    case 275:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31856; /* *cond_len_widen_reduc_plus_scal_v512qi */

    case 276:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31858; /* *cond_len_widen_reduc_plus_scal_v1024qi */

    case 277:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31860; /* *cond_len_widen_reduc_plus_scal_v2048qi */

    case 278:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31820; /* *cond_len_widen_reduc_plus_scal_rvvm4hi */

    case 279:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31822; /* *cond_len_widen_reduc_plus_scal_rvvm2hi */

    case 280:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31824; /* *cond_len_widen_reduc_plus_scal_rvvm1hi */

    case 281:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31826; /* *cond_len_widen_reduc_plus_scal_rvvmf2hi */

    case 282:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31828; /* *cond_len_widen_reduc_plus_scal_rvvmf4hi */

    case 283:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31862; /* *cond_len_widen_reduc_plus_scal_v1hi */

    case 284:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31884; /* *cond_len_widen_reduc_plus_scal_v1si */

    case 285:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31864; /* *cond_len_widen_reduc_plus_scal_v2hi */

    case 286:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31886; /* *cond_len_widen_reduc_plus_scal_v2si */

    case 287:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31866; /* *cond_len_widen_reduc_plus_scal_v4hi */

    case 288:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31888; /* *cond_len_widen_reduc_plus_scal_v4si */

    case 289:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31868; /* *cond_len_widen_reduc_plus_scal_v8hi */

    case 290:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31890; /* *cond_len_widen_reduc_plus_scal_v8si */

    case 291:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31870; /* *cond_len_widen_reduc_plus_scal_v16hi */

    case 292:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31892; /* *cond_len_widen_reduc_plus_scal_v16si */

    case 293:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31872; /* *cond_len_widen_reduc_plus_scal_v32hi */

    case 294:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31894; /* *cond_len_widen_reduc_plus_scal_v32si */

    case 295:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31874; /* *cond_len_widen_reduc_plus_scal_v64hi */

    case 296:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31896; /* *cond_len_widen_reduc_plus_scal_v64si */

    case 297:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31876; /* *cond_len_widen_reduc_plus_scal_v128hi */

    case 298:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31898; /* *cond_len_widen_reduc_plus_scal_v128si */

    case 299:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31878; /* *cond_len_widen_reduc_plus_scal_v256hi */

    case 300:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31900; /* *cond_len_widen_reduc_plus_scal_v256si */

    case 301:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31880; /* *cond_len_widen_reduc_plus_scal_v512hi */

    case 302:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31902; /* *cond_len_widen_reduc_plus_scal_v512si */

    case 303:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31882; /* *cond_len_widen_reduc_plus_scal_v1024hi */

    case 304:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31830; /* *cond_len_widen_reduc_plus_scal_rvvm4si */

    case 305:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31832; /* *cond_len_widen_reduc_plus_scal_rvvm2si */

    case 306:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31834; /* *cond_len_widen_reduc_plus_scal_rvvm1si */

    case 307:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31836; /* *cond_len_widen_reduc_plus_scal_rvvmf2si */

    case 308:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31809; /* *cond_len_widen_reduc_plus_scal_rvvm4qi */

    case 309:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31811; /* *cond_len_widen_reduc_plus_scal_rvvm2qi */

    case 310:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31813; /* *cond_len_widen_reduc_plus_scal_rvvm1qi */

    case 311:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31815; /* *cond_len_widen_reduc_plus_scal_rvvmf2qi */

    case 312:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31817; /* *cond_len_widen_reduc_plus_scal_rvvmf4qi */

    case 313:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31819; /* *cond_len_widen_reduc_plus_scal_rvvmf8qi */

    case 314:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 31839; /* *cond_len_widen_reduc_plus_scal_v1qi */

    case 315:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 31841; /* *cond_len_widen_reduc_plus_scal_v2qi */

    case 316:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 31843; /* *cond_len_widen_reduc_plus_scal_v4qi */

    case 317:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 31845; /* *cond_len_widen_reduc_plus_scal_v8qi */

    case 318:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 31847; /* *cond_len_widen_reduc_plus_scal_v16qi */

    case 319:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 31849; /* *cond_len_widen_reduc_plus_scal_v32qi */

    case 320:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31851; /* *cond_len_widen_reduc_plus_scal_v64qi */

    case 321:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31853; /* *cond_len_widen_reduc_plus_scal_v128qi */

    case 322:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31855; /* *cond_len_widen_reduc_plus_scal_v256qi */

    case 323:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31857; /* *cond_len_widen_reduc_plus_scal_v512qi */

    case 324:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31859; /* *cond_len_widen_reduc_plus_scal_v1024qi */

    case 325:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31861; /* *cond_len_widen_reduc_plus_scal_v2048qi */

    case 326:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31821; /* *cond_len_widen_reduc_plus_scal_rvvm4hi */

    case 327:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31823; /* *cond_len_widen_reduc_plus_scal_rvvm2hi */

    case 328:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31825; /* *cond_len_widen_reduc_plus_scal_rvvm1hi */

    case 329:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31827; /* *cond_len_widen_reduc_plus_scal_rvvmf2hi */

    case 330:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31829; /* *cond_len_widen_reduc_plus_scal_rvvmf4hi */

    case 331:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31863; /* *cond_len_widen_reduc_plus_scal_v1hi */

    case 332:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31885; /* *cond_len_widen_reduc_plus_scal_v1si */

    case 333:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31865; /* *cond_len_widen_reduc_plus_scal_v2hi */

    case 334:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31887; /* *cond_len_widen_reduc_plus_scal_v2si */

    case 335:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31867; /* *cond_len_widen_reduc_plus_scal_v4hi */

    case 336:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31889; /* *cond_len_widen_reduc_plus_scal_v4si */

    case 337:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31869; /* *cond_len_widen_reduc_plus_scal_v8hi */

    case 338:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31891; /* *cond_len_widen_reduc_plus_scal_v8si */

    case 339:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31871; /* *cond_len_widen_reduc_plus_scal_v16hi */

    case 340:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31893; /* *cond_len_widen_reduc_plus_scal_v16si */

    case 341:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31873; /* *cond_len_widen_reduc_plus_scal_v32hi */

    case 342:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31895; /* *cond_len_widen_reduc_plus_scal_v32si */

    case 343:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31875; /* *cond_len_widen_reduc_plus_scal_v64hi */

    case 344:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31897; /* *cond_len_widen_reduc_plus_scal_v64si */

    case 345:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31877; /* *cond_len_widen_reduc_plus_scal_v128hi */

    case 346:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31899; /* *cond_len_widen_reduc_plus_scal_v128si */

    case 347:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31879; /* *cond_len_widen_reduc_plus_scal_v256hi */

    case 348:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31901; /* *cond_len_widen_reduc_plus_scal_v256si */

    case 349:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31881; /* *cond_len_widen_reduc_plus_scal_v512hi */

    case 350:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31903; /* *cond_len_widen_reduc_plus_scal_v512si */

    case 351:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31883; /* *cond_len_widen_reduc_plus_scal_v1024hi */

    case 352:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31831; /* *cond_len_widen_reduc_plus_scal_rvvm4si */

    case 353:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31833; /* *cond_len_widen_reduc_plus_scal_rvvm2si */

    case 354:
      if (!
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31835; /* *cond_len_widen_reduc_plus_scal_rvvm1si */

    case 355:
      if (!(
#line 1283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31837; /* *cond_len_widen_reduc_plus_scal_rvvmf2si */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern177 (x2) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != SCRATCH)
    return -1;
  x7 = XVECEXP (x2, 0, 0);
  x8 = XVECEXP (x7, 0, 0);
  operands[0] = x8;
  x9 = XVECEXP (x7, 0, 1);
  operands[3] = x9;
  if (!vector_length_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x7, 0, 2);
  operands[4] = x10;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x2, 0, 1);
  operands[1] = x11;
  if (!pmode_reg_or_0_operand (operands[1], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 2);
  operands[2] = x12;
  switch (GET_MODE (x7))
    {
    case E_RVVMF64BImode:
      return recog_92 (x1, insn, pnum_clobbers);

    case E_RVVMF32BImode:
      return recog_93 (x1, insn, pnum_clobbers);

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2x2QImode:
          if (!register_operand (operands[2], E_RVVMF2x2QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21377; /* pred_unit_strided_storervvmf2x2qi */

        case E_RVVMF2x3QImode:
          if (!register_operand (operands[2], E_RVVMF2x3QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21378; /* pred_unit_strided_storervvmf2x3qi */

        case E_RVVMF2x4QImode:
          if (!register_operand (operands[2], E_RVVMF2x4QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21379; /* pred_unit_strided_storervvmf2x4qi */

        case E_RVVMF2x5QImode:
          if (!register_operand (operands[2], E_RVVMF2x5QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21380; /* pred_unit_strided_storervvmf2x5qi */

        case E_RVVMF2x6QImode:
          if (!register_operand (operands[2], E_RVVMF2x6QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21381; /* pred_unit_strided_storervvmf2x6qi */

        case E_RVVMF2x7QImode:
          if (!register_operand (operands[2], E_RVVMF2x7QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21382; /* pred_unit_strided_storervvmf2x7qi */

        case E_RVVMF2x8QImode:
          if (!register_operand (operands[2], E_RVVMF2x8QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21383; /* pred_unit_strided_storervvmf2x8qi */

        case E_RVVM1x2HImode:
          if (!register_operand (operands[2], E_RVVM1x2HImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21384; /* pred_unit_strided_storervvm1x2hi */

        case E_RVVM1x3HImode:
          if (!register_operand (operands[2], E_RVVM1x3HImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21385; /* pred_unit_strided_storervvm1x3hi */

        case E_RVVM1x4HImode:
          if (!register_operand (operands[2], E_RVVM1x4HImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21386; /* pred_unit_strided_storervvm1x4hi */

        case E_RVVM1x5HImode:
          if (!register_operand (operands[2], E_RVVM1x5HImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21387; /* pred_unit_strided_storervvm1x5hi */

        case E_RVVM1x6HImode:
          if (!register_operand (operands[2], E_RVVM1x6HImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21388; /* pred_unit_strided_storervvm1x6hi */

        case E_RVVM1x7HImode:
          if (!register_operand (operands[2], E_RVVM1x7HImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21389; /* pred_unit_strided_storervvm1x7hi */

        case E_RVVM1x8HImode:
          if (!register_operand (operands[2], E_RVVM1x8HImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21390; /* pred_unit_strided_storervvm1x8hi */

        case E_RVVM2x2SImode:
          if (!register_operand (operands[2], E_RVVM2x2SImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21391; /* pred_unit_strided_storervvm2x2si */

        case E_RVVM2x3SImode:
          if (!register_operand (operands[2], E_RVVM2x3SImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21392; /* pred_unit_strided_storervvm2x3si */

        case E_RVVM2x4SImode:
          if (!register_operand (operands[2], E_RVVM2x4SImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21393; /* pred_unit_strided_storervvm2x4si */

        case E_RVVM4x2DImode:
          if (!register_operand (operands[2], E_RVVM4x2DImode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 21394; /* pred_unit_strided_storervvm4x2di */

        case E_RVVM1x2BFmode:
          if (!register_operand (operands[2], E_RVVM1x2BFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21395; /* pred_unit_strided_storervvm1x2bf */

        case E_RVVM1x3BFmode:
          if (!register_operand (operands[2], E_RVVM1x3BFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21396; /* pred_unit_strided_storervvm1x3bf */

        case E_RVVM1x4BFmode:
          if (!register_operand (operands[2], E_RVVM1x4BFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21397; /* pred_unit_strided_storervvm1x4bf */

        case E_RVVM1x5BFmode:
          if (!register_operand (operands[2], E_RVVM1x5BFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21398; /* pred_unit_strided_storervvm1x5bf */

        case E_RVVM1x6BFmode:
          if (!register_operand (operands[2], E_RVVM1x6BFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21399; /* pred_unit_strided_storervvm1x6bf */

        case E_RVVM1x7BFmode:
          if (!register_operand (operands[2], E_RVVM1x7BFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21400; /* pred_unit_strided_storervvm1x7bf */

        case E_RVVM1x8BFmode:
          if (!register_operand (operands[2], E_RVVM1x8BFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21401; /* pred_unit_strided_storervvm1x8bf */

        case E_RVVM1x2HFmode:
          if (!register_operand (operands[2], E_RVVM1x2HFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21402; /* pred_unit_strided_storervvm1x2hf */

        case E_RVVM1x3HFmode:
          if (!register_operand (operands[2], E_RVVM1x3HFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21403; /* pred_unit_strided_storervvm1x3hf */

        case E_RVVM1x4HFmode:
          if (!register_operand (operands[2], E_RVVM1x4HFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21404; /* pred_unit_strided_storervvm1x4hf */

        case E_RVVM1x5HFmode:
          if (!register_operand (operands[2], E_RVVM1x5HFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21405; /* pred_unit_strided_storervvm1x5hf */

        case E_RVVM1x6HFmode:
          if (!register_operand (operands[2], E_RVVM1x6HFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21406; /* pred_unit_strided_storervvm1x6hf */

        case E_RVVM1x7HFmode:
          if (!register_operand (operands[2], E_RVVM1x7HFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21407; /* pred_unit_strided_storervvm1x7hf */

        case E_RVVM1x8HFmode:
          if (!register_operand (operands[2], E_RVVM1x8HFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21408; /* pred_unit_strided_storervvm1x8hf */

        case E_RVVM2x2SFmode:
          if (!register_operand (operands[2], E_RVVM2x2SFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 21409; /* pred_unit_strided_storervvm2x2sf */

        case E_RVVM2x3SFmode:
          if (!register_operand (operands[2], E_RVVM2x3SFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 21410; /* pred_unit_strided_storervvm2x3sf */

        case E_RVVM2x4SFmode:
          if (!register_operand (operands[2], E_RVVM2x4SFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 21411; /* pred_unit_strided_storervvm2x4sf */

        case E_RVVM4x2DFmode:
          if (!register_operand (operands[2], E_RVVM4x2DFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 21412; /* pred_unit_strided_storervvm4x2df */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1x2QImode:
          if (!register_operand (operands[2], E_RVVM1x2QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21413; /* pred_unit_strided_storervvm1x2qi */

        case E_RVVM1x3QImode:
          if (!register_operand (operands[2], E_RVVM1x3QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21414; /* pred_unit_strided_storervvm1x3qi */

        case E_RVVM1x4QImode:
          if (!register_operand (operands[2], E_RVVM1x4QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21415; /* pred_unit_strided_storervvm1x4qi */

        case E_RVVM1x5QImode:
          if (!register_operand (operands[2], E_RVVM1x5QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21416; /* pred_unit_strided_storervvm1x5qi */

        case E_RVVM1x6QImode:
          if (!register_operand (operands[2], E_RVVM1x6QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21417; /* pred_unit_strided_storervvm1x6qi */

        case E_RVVM1x7QImode:
          if (!register_operand (operands[2], E_RVVM1x7QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21418; /* pred_unit_strided_storervvm1x7qi */

        case E_RVVM1x8QImode:
          if (!register_operand (operands[2], E_RVVM1x8QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21419; /* pred_unit_strided_storervvm1x8qi */

        case E_RVVM2x2HImode:
          if (!register_operand (operands[2], E_RVVM2x2HImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21420; /* pred_unit_strided_storervvm2x2hi */

        case E_RVVM2x3HImode:
          if (!register_operand (operands[2], E_RVVM2x3HImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21421; /* pred_unit_strided_storervvm2x3hi */

        case E_RVVM2x4HImode:
          if (!register_operand (operands[2], E_RVVM2x4HImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21422; /* pred_unit_strided_storervvm2x4hi */

        case E_RVVM4x2SImode:
          if (!register_operand (operands[2], E_RVVM4x2SImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21423; /* pred_unit_strided_storervvm4x2si */

        case E_RVVM2x2BFmode:
          if (!register_operand (operands[2], E_RVVM2x2BFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21424; /* pred_unit_strided_storervvm2x2bf */

        case E_RVVM2x3BFmode:
          if (!register_operand (operands[2], E_RVVM2x3BFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21425; /* pred_unit_strided_storervvm2x3bf */

        case E_RVVM2x4BFmode:
          if (!register_operand (operands[2], E_RVVM2x4BFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21426; /* pred_unit_strided_storervvm2x4bf */

        case E_RVVM2x2HFmode:
          if (!register_operand (operands[2], E_RVVM2x2HFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21427; /* pred_unit_strided_storervvm2x2hf */

        case E_RVVM2x3HFmode:
          if (!register_operand (operands[2], E_RVVM2x3HFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21428; /* pred_unit_strided_storervvm2x3hf */

        case E_RVVM2x4HFmode:
          if (!register_operand (operands[2], E_RVVM2x4HFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21429; /* pred_unit_strided_storervvm2x4hf */

        case E_RVVM4x2SFmode:
          if (!register_operand (operands[2], E_RVVM4x2SFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 21430; /* pred_unit_strided_storervvm4x2sf */

        default:
          return -1;
        }

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2x2QImode:
          if (!register_operand (operands[2], E_RVVM2x2QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21431; /* pred_unit_strided_storervvm2x2qi */

        case E_RVVM2x3QImode:
          if (!register_operand (operands[2], E_RVVM2x3QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21432; /* pred_unit_strided_storervvm2x3qi */

        case E_RVVM2x4QImode:
          if (!register_operand (operands[2], E_RVVM2x4QImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21433; /* pred_unit_strided_storervvm2x4qi */

        case E_RVVM4x2HImode:
          if (!register_operand (operands[2], E_RVVM4x2HImode)
              || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21434; /* pred_unit_strided_storervvm4x2hi */

        case E_RVVM4x2BFmode:
          if (!register_operand (operands[2], E_RVVM4x2BFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21435; /* pred_unit_strided_storervvm4x2bf */

        case E_RVVM4x2HFmode:
          if (!register_operand (operands[2], E_RVVM4x2HFmode)
              || !(
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21436; /* pred_unit_strided_storervvm4x2hf */

        default:
          return -1;
        }

    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF2BImode)
          || !register_operand (operands[2], E_RVVM4x2QImode)
          || !
#line 8386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21437; /* pred_unit_strided_storervvm4x2qi */

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 13:
      return recog_42 (x1, insn, pnum_clobbers);

    case 26:
      switch (pattern160 (x1))
        {
        case 0:
          if (!(
#line 1645 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 87; /* fminmsf3 */

        case 1:
          if (!(
#line 1645 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 88; /* fminmdf3 */

        case 2:
          if (!(
#line 1645 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 89; /* fminmhf3 */

        default:
          return -1;
        }

    case 27:
      switch (pattern160 (x1))
        {
        case 0:
          if (!(
#line 1655 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 90; /* fmaxmsf3 */

        case 1:
          if (!(
#line 1655 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 91; /* fmaxmdf3 */

        case 2:
          if (!(
#line 1655 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 92; /* fmaxmhf3 */

        default:
          return -1;
        }

    case 24:
      switch (pattern160 (x1))
        {
        case 0:
          if (!(
#line 1665 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SNANS (SFmode)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 93; /* fminsf3 */

        case 1:
          if (!(
#line 1665 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SNANS (DFmode)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 94; /* fmindf3 */

        case 2:
          if (!(
#line 1665 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SNANS (HFmode)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 95; /* fminhf3 */

        default:
          return -1;
        }

    case 25:
      switch (pattern160 (x1))
        {
        case 0:
          if (!(
#line 1675 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SNANS (SFmode)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 96; /* fmaxsf3 */

        case 1:
          if (!(
#line 1675 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SNANS (DFmode)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 97; /* fmaxdf3 */

        case 2:
          if (!(
#line 1675 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SNANS (HFmode)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 98; /* fmaxhf3 */

        default:
          return -1;
        }

    case 11:
      return recog_41 (x1, insn, pnum_clobbers);

    case 12:
      return recog_40 (x1, insn, pnum_clobbers);

    case 29:
      return recog_38 (x1, insn, pnum_clobbers);

    case 14:
      return recog_47 (x1, insn, pnum_clobbers);

    case 31:
      switch (pattern164 (x1))
        {
        case 0:
          if (!
#line 1161 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBKC || TARGET_ZBC))
            return -1;
          return 655; /* riscv_clmul_si */

        case 1:
          if (!(
#line 1161 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBKC || TARGET_ZBC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 656; /* riscv_clmul_di */

        default:
          return -1;
        }

    case 32:
      switch (pattern164 (x1))
        {
        case 0:
          if (!(
#line 1170 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBKC || TARGET_ZBC) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 657; /* riscv_clmulh_si */

        case 1:
          if (!(
#line 1170 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBKC || TARGET_ZBC) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 658; /* riscv_clmulh_di */

        default:
          return -1;
        }

    case 33:
      switch (pattern164 (x1))
        {
        case 0:
          if (!(
#line 1180 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBC) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 659; /* riscv_clmulr_si */

        case 1:
          if (!(
#line 1180 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBC) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 660; /* riscv_clmulr_di */

        default:
          return -1;
        }

    case 44:
      return recog_39 (x1, insn, pnum_clobbers);

    case 45:
      return recog_45 (x1, insn, pnum_clobbers);

    case 46:
      if (pattern165 (x1, 
E_HImode) != 0
          || !
#line 157 "../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB && TARGET_64BIT))
        return -1;
      return 677; /* riscv_packw */

    case 48:
      switch (pattern164 (x1))
        {
        case 0:
          if (!(
#line 195 "../../gcc/config/riscv/crypto.md"
(TARGET_ZBKX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 679; /* riscv_xperm4_si */

        case 1:
          if (!(
#line 195 "../../gcc/config/riscv/crypto.md"
(TARGET_ZBKX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 680; /* riscv_xperm4_di */

        default:
          return -1;
        }

    case 47:
      switch (pattern164 (x1))
        {
        case 0:
          if (!(
#line 204 "../../gcc/config/riscv/crypto.md"
(TARGET_ZBKX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 681; /* riscv_xperm8_si */

        case 1:
          if (!(
#line 204 "../../gcc/config/riscv/crypto.md"
(TARGET_ZBKX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 682; /* riscv_xperm8_di */

        default:
          return -1;
        }

    case 51:
      if (pattern165 (x1, 
E_DImode) != 0
          || !
#line 235 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKND && TARGET_64BIT))
        return -1;
      return 685; /* riscv_aes64ds */

    case 52:
      if (pattern165 (x1, 
E_DImode) != 0
          || !
#line 244 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKND && TARGET_64BIT))
        return -1;
      return 686; /* riscv_aes64dsm */

    case 54:
      return recog_46 (x1, insn, pnum_clobbers);

    case 55:
      if (pattern165 (x1, 
E_DImode) != 0
          || !
#line 270 "../../gcc/config/riscv/crypto.md"
((TARGET_ZKND || TARGET_ZKNE) && TARGET_64BIT))
        return -1;
      return 689; /* riscv_aes64ks2 */

    case 56:
      if (pattern165 (x1, 
E_DImode) != 0
          || !
#line 301 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNE && TARGET_64BIT))
        return -1;
      return 692; /* riscv_aes64es */

    case 57:
      if (pattern165 (x1, 
E_DImode) != 0
          || !
#line 310 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNE && TARGET_64BIT))
        return -1;
      return 693; /* riscv_aes64esm */

    case 65:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 366 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 702; /* riscv_sha512sig0h */

    case 66:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 375 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 703; /* riscv_sha512sig0l */

    case 68:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 384 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 704; /* riscv_sha512sig1h */

    case 69:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 393 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 705; /* riscv_sha512sig1l */

    case 71:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 402 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 706; /* riscv_sha512sum0r */

    case 73:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 411 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 707; /* riscv_sha512sum1r */

    case 37:
      if (pattern166 (x1, 
E_DFmode) != 0
          || !
#line 189 "../../gcc/config/riscv/thead.md"
(!TARGET_64BIT && TARGET_XTHEADFMV))
        return -1;
      return 896; /* th_fmv_hw_w_x */

    case 91:
      return recog_33 (x1, insn, pnum_clobbers);

    case 104:
      return recog_32 (x1, insn, pnum_clobbers);

    case 138:
      return recog_37 (x1, insn, pnum_clobbers);

    case 139:
      return recog_36 (x1, insn, pnum_clobbers);

    case 121:
      return recog_35 (x1, insn, pnum_clobbers);

    case 143:
      return recog_34 (x1, insn, pnum_clobbers);

    case 227:
      if (pattern167 (x1) != 0
          || !
#line 680 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 33807; /* riscv_cv_alu_clip */

    case 229:
      if (pattern167 (x1) != 0
          || !
#line 693 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 33808; /* riscv_cv_alu_clipu */

    case 233:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 891 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33819; /* riscv_cv_simd_add_b_si */

    case 234:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 902 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33820; /* riscv_cv_simd_add_sc_h_si */

    case 235:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 915 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33821; /* riscv_cv_simd_add_sc_b_si */

    case 237:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 944 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33823; /* riscv_cv_simd_sub_b_si */

    case 238:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 955 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33824; /* riscv_cv_simd_sub_sc_h_si */

    case 239:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 968 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33825; /* riscv_cv_simd_sub_sc_b_si */

    case 240:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 981 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33826; /* riscv_cv_simd_avg_h_si */

    case 241:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 992 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33827; /* riscv_cv_simd_avg_b_si */

    case 242:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1003 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33828; /* riscv_cv_simd_avg_sc_h_si */

    case 243:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1016 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33829; /* riscv_cv_simd_avg_sc_b_si */

    case 244:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1029 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33830; /* riscv_cv_simd_avgu_h_si */

    case 245:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1040 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33831; /* riscv_cv_simd_avgu_b_si */

    case 246:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 1051 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33832; /* riscv_cv_simd_avgu_sc_h_si */

    case 247:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 1064 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33833; /* riscv_cv_simd_avgu_sc_b_si */

    case 248:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1077 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33834; /* riscv_cv_simd_min_h_si */

    case 249:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1088 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33835; /* riscv_cv_simd_min_b_si */

    case 250:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1099 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33836; /* riscv_cv_simd_min_sc_h_si */

    case 251:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1112 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33837; /* riscv_cv_simd_min_sc_b_si */

    case 252:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1125 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33838; /* riscv_cv_simd_minu_h_si */

    case 253:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1136 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33839; /* riscv_cv_simd_minu_b_si */

    case 254:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 1147 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33840; /* riscv_cv_simd_minu_sc_h_si */

    case 255:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 1160 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33841; /* riscv_cv_simd_minu_sc_b_si */

    case 256:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1173 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33842; /* riscv_cv_simd_max_h_si */

    case 257:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1184 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33843; /* riscv_cv_simd_max_b_si */

    case 258:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1195 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33844; /* riscv_cv_simd_max_sc_h_si */

    case 259:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1208 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33845; /* riscv_cv_simd_max_sc_b_si */

    case 260:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1221 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33846; /* riscv_cv_simd_maxu_h_si */

    case 261:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1232 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33847; /* riscv_cv_simd_maxu_b_si */

    case 262:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 1243 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33848; /* riscv_cv_simd_maxu_sc_h_si */

    case 263:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 1256 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33849; /* riscv_cv_simd_maxu_sc_b_si */

    case 264:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1269 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33850; /* riscv_cv_simd_srl_h_si */

    case 265:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1280 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33851; /* riscv_cv_simd_srl_b_si */

    case 266:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 1291 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33852; /* riscv_cv_simd_srl_sc_h_si */

    case 267:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 1304 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33853; /* riscv_cv_simd_srl_sc_b_si */

    case 268:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1317 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33854; /* riscv_cv_simd_sra_h_si */

    case 269:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1328 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33855; /* riscv_cv_simd_sra_b_si */

    case 270:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 1339 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33856; /* riscv_cv_simd_sra_sc_h_si */

    case 271:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 1352 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33857; /* riscv_cv_simd_sra_sc_b_si */

    case 272:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1365 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33858; /* riscv_cv_simd_sll_h_si */

    case 273:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1376 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33859; /* riscv_cv_simd_sll_b_si */

    case 274:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 1387 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33860; /* riscv_cv_simd_sll_sc_h_si */

    case 275:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 1400 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33861; /* riscv_cv_simd_sll_sc_b_si */

    case 276:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1413 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33862; /* riscv_cv_simd_or_h_si */

    case 277:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1424 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33863; /* riscv_cv_simd_or_b_si */

    case 278:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1435 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33864; /* riscv_cv_simd_or_sc_h_si */

    case 279:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1448 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33865; /* riscv_cv_simd_or_sc_b_si */

    case 280:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1461 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33866; /* riscv_cv_simd_xor_h_si */

    case 281:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1472 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33867; /* riscv_cv_simd_xor_b_si */

    case 282:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1483 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33868; /* riscv_cv_simd_xor_sc_h_si */

    case 283:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1496 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33869; /* riscv_cv_simd_xor_sc_b_si */

    case 284:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1509 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33870; /* riscv_cv_simd_and_h_si */

    case 285:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1520 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33871; /* riscv_cv_simd_and_b_si */

    case 286:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1531 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33872; /* riscv_cv_simd_and_sc_h_si */

    case 287:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1544 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33873; /* riscv_cv_simd_and_sc_b_si */

    case 292:
      if (pattern170 (x1) != 0
          || !
#line 1594 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33878; /* riscv_cv_simd_extract_h_si */

    case 293:
      if (pattern170 (x1) != 0
          || !
#line 1605 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33879; /* riscv_cv_simd_extract_b_si */

    case 294:
      if (pattern170 (x1) != 0
          || !
#line 1616 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33880; /* riscv_cv_simd_extractu_h_si */

    case 295:
      if (pattern170 (x1) != 0
          || !
#line 1627 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33881; /* riscv_cv_simd_extractu_b_si */

    case 298:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1663 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33884; /* riscv_cv_simd_dotup_h_si */

    case 299:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1674 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33885; /* riscv_cv_simd_dotup_b_si */

    case 300:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 1685 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33886; /* riscv_cv_simd_dotup_sc_h_si */

    case 301:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 1698 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33887; /* riscv_cv_simd_dotup_sc_b_si */

    case 302:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1711 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33888; /* riscv_cv_simd_dotusp_h_si */

    case 303:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1722 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33889; /* riscv_cv_simd_dotusp_b_si */

    case 304:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1733 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33890; /* riscv_cv_simd_dotusp_sc_h_si */

    case 305:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1746 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33891; /* riscv_cv_simd_dotusp_sc_b_si */

    case 306:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1759 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33892; /* riscv_cv_simd_dotsp_h_si */

    case 307:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1770 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33893; /* riscv_cv_simd_dotsp_b_si */

    case 308:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1781 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33894; /* riscv_cv_simd_dotsp_sc_h_si */

    case 309:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1794 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33895; /* riscv_cv_simd_dotsp_sc_b_si */

    case 322:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1964 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33908; /* riscv_cv_simd_shuffle_h_si */

    case 323:
      return recog_44 (x1, insn, pnum_clobbers);

    case 324:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1986 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33910; /* riscv_cv_simd_shuffle_b_si */

    case 325:
      return recog_43 (x1, insn, pnum_clobbers);

    case 328:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2036 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33914; /* riscv_cv_simd_packhi_h_si */

    case 329:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2047 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33915; /* riscv_cv_simd_packlo_h_si */

    case 332:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2083 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33918; /* riscv_cv_simd_cmpeq_h_si */

    case 333:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2094 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33919; /* riscv_cv_simd_cmpeq_b_si */

    case 334:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 2105 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33920; /* riscv_cv_simd_cmpeq_sc_h_si */

    case 335:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 2118 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33921; /* riscv_cv_simd_cmpeq_sc_b_si */

    case 336:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2131 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33922; /* riscv_cv_simd_cmpne_h_si */

    case 337:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2142 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33923; /* riscv_cv_simd_cmpne_b_si */

    case 338:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 2153 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33924; /* riscv_cv_simd_cmpne_sc_h_si */

    case 339:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 2166 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33925; /* riscv_cv_simd_cmpne_sc_b_si */

    case 340:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2179 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33926; /* riscv_cv_simd_cmpgt_h_si */

    case 341:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2190 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33927; /* riscv_cv_simd_cmpgt_b_si */

    case 342:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 2201 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33928; /* riscv_cv_simd_cmpgt_sc_h_si */

    case 343:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 2214 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33929; /* riscv_cv_simd_cmpgt_sc_b_si */

    case 344:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2227 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33930; /* riscv_cv_simd_cmpge_h_si */

    case 345:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2238 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33931; /* riscv_cv_simd_cmpge_b_si */

    case 346:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 2249 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33932; /* riscv_cv_simd_cmpge_sc_h_si */

    case 347:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 2262 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33933; /* riscv_cv_simd_cmpge_sc_b_si */

    case 348:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2275 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33934; /* riscv_cv_simd_cmplt_h_si */

    case 349:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2286 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33935; /* riscv_cv_simd_cmplt_b_si */

    case 350:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 2297 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33936; /* riscv_cv_simd_cmplt_sc_h_si */

    case 351:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 2310 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33937; /* riscv_cv_simd_cmplt_sc_b_si */

    case 352:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2323 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33938; /* riscv_cv_simd_cmple_h_si */

    case 353:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2334 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33939; /* riscv_cv_simd_cmple_b_si */

    case 354:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 2345 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33940; /* riscv_cv_simd_cmple_sc_h_si */

    case 355:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 2358 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33941; /* riscv_cv_simd_cmple_sc_b_si */

    case 356:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2371 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33942; /* riscv_cv_simd_cmpgtu_h_si */

    case 357:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2382 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33943; /* riscv_cv_simd_cmpgtu_b_si */

    case 358:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 2393 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33944; /* riscv_cv_simd_cmpgtu_sc_h_si */

    case 359:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 2406 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33945; /* riscv_cv_simd_cmpgtu_sc_b_si */

    case 360:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2419 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33946; /* riscv_cv_simd_cmpgeu_h_si */

    case 361:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2430 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33947; /* riscv_cv_simd_cmpgeu_b_si */

    case 362:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 2441 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33948; /* riscv_cv_simd_cmpgeu_sc_h_si */

    case 363:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 2454 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33949; /* riscv_cv_simd_cmpgeu_sc_b_si */

    case 364:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2467 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33950; /* riscv_cv_simd_cmpltu_h_si */

    case 365:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2478 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33951; /* riscv_cv_simd_cmpltu_b_si */

    case 366:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 2489 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33952; /* riscv_cv_simd_cmpltu_sc_h_si */

    case 367:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 2502 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33953; /* riscv_cv_simd_cmpltu_sc_b_si */

    case 368:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2515 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33954; /* riscv_cv_simd_cmpleu_h_si */

    case 369:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2526 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33955; /* riscv_cv_simd_cmpleu_b_si */

    case 370:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 2537 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33956; /* riscv_cv_simd_cmpleu_sc_h_si */

    case 371:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 2550 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33957; /* riscv_cv_simd_cmpleu_sc_b_si */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!absolute_symbolic_operand (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 818; /* *local_pic_load_uqi */

        case E_HImode:
          if (!
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 821; /* *local_pic_load_uhi */

        case E_SImode:
          if (!(
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 63 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 824; /* *local_pic_load_usi */

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 819; /* *local_pic_load_uqi */

        case E_HImode:
          if (!
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 822; /* *local_pic_load_uhi */

        case E_SImode:
          if (!(
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 63 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 825; /* *local_pic_load_usi */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!(
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 820; /* *local_pic_load_uqi */

        case E_HImode:
          if (!(
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 823; /* *local_pic_load_uhi */

        case E_SImode:
          if (!(
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 826; /* *local_pic_load_usi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V2048BImode)
      && reg_or_mem_operand (operands[1], E_V2048BImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4399 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3332; /* *movv2048bisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4399 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3333; /* *movv2048bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V2048BImode)
      || !register_operand (operands[1], E_V2048BImode)
      || !(
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3505; /* *movv2048bi_vls */
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512BImode)
      && reg_or_mem_operand (operands[1], E_V512BImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512BImode)
       || register_operand (operands[1], V512BImode))) && (
#line 4397 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3328; /* *movv512bisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512BImode)
       || register_operand (operands[1], V512BImode))) && (
#line 4397 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3329; /* *movv512bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512BImode)
      || !register_operand (operands[1], E_V512BImode)
      || !(
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 3503; /* *movv512bi_vls */
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V128BImode)
      && reg_or_mem_operand (operands[1], E_V128BImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4395 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3324; /* *movv128bisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4395 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3325; /* *movv128bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V128BImode)
      || !register_operand (operands[1], E_V128BImode)
      || !(
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3501; /* *movv128bi_vls */
}

 int
recog_120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32BImode)
      && reg_or_mem_operand (operands[1], E_V32BImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4393 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3320; /* *movv32bisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4393 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3321; /* *movv32bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32BImode)
      || !register_operand (operands[1], E_V32BImode)
      || !(
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
    return -1;
  return 3499; /* *movv32bi_vls */
}

 int
recog_122 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V256DFmode)
      && reg_or_mem_operand (operands[1], E_V256DFmode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4390 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3316; /* *movv256dfsi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4390 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3317; /* *movv256dfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V256DFmode)
      || !register_operand (operands[1], E_V256DFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3413; /* *movv256df_vls */
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512SFmode)
      && reg_or_mem_operand (operands[1], E_V512SFmode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4385 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3306; /* *movv512sfsi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4385 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3307; /* *movv512sfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512SFmode)
      || !register_operand (operands[1], E_V512SFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3403; /* *movv512sf_vls */
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024HFmode)
      && reg_or_mem_operand (operands[1], E_V1024HFmode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3294; /* *movv1024hfsi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3295; /* *movv1024hfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024HFmode)
      || !register_operand (operands[1], E_V1024HFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3392; /* *movv1024hf_vls */
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512DImode)
      && reg_or_mem_operand (operands[1], E_V512DImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3282; /* *movv512disi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3283; /* *movv512didi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512DImode)
      || !register_operand (operands[1], E_V512DImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3381; /* *movv512di_vls */
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512SImode)
      && reg_or_mem_operand (operands[1], E_V512SImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3270; /* *movv512sisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3271; /* *movv512sidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512SImode)
      || !register_operand (operands[1], E_V512SImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3370; /* *movv512si_vls */
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024HImode)
      && reg_or_mem_operand (operands[1], E_V1024HImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3258; /* *movv1024hisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3259; /* *movv1024hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024HImode)
      || !register_operand (operands[1], E_V1024HImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3359; /* *movv1024hi_vls */
}

 int
recog_157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V4096QImode)
      && reg_or_mem_operand (operands[1], E_V4096QImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3246; /* *movv4096qisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3247; /* *movv4096qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V4096QImode)
      || !register_operand (operands[1], E_V4096QImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3348; /* *movv4096qi_vls */
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64QImode)
      && reg_or_mem_operand (operands[1], E_V64QImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3234; /* *movv64qisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3235; /* *movv64qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64QImode)
      || !register_operand (operands[1], E_V64QImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3342; /* *movv64qi_vls */
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2SFmode)
      && register_operand (operands[1], E_RVVMF2SFmode)
      && (
#line 1257 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return 2800; /* *movrvvmf2sf_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2SFmode))
    return -1;
  if ((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2836; /* *movrvvmf2sfsi_lra */
    }
  if (!(
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2847; /* *movrvvmf2sfdi_lra */
}

 int
recog_178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF4HImode)
      && register_operand (operands[1], E_RVVMF4HImode)
      && (
#line 1257 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
    return 2794; /* *movrvvmf4hi_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4HImode))
    return -1;
  if ((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2830; /* *movrvvmf4hisi_lra */
    }
  if (!(
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2841; /* *movrvvmf4hidi_lra */
}

 int
recog_185 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8BImode)
      && reg_or_mem_operand (operands[1], E_V8BImode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode))) && 
#line 4343 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
    return 3230; /* *movv8bi */
  if (!register_operand (operands[0], E_V8BImode)
      || !register_operand (operands[1], E_V8BImode)
      || !(
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
    return -1;
  return 3497; /* *movv8bi_vls */
}

 int
recog_190 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8DFmode)
      && reg_or_mem_operand (operands[1], E_V8DFmode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8DFmode)
       || register_operand (operands[1], V8DFmode))) && 
#line 4337 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 3225; /* *movv8df */
  if (!register_operand (operands[0], E_V8DFmode)
      || !register_operand (operands[1], E_V8DFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3408; /* *movv8df_vls */
}

 int
recog_196 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4SFmode)
      && reg_or_mem_operand (operands[1], E_V4SFmode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[1], V4SFmode))) && 
#line 4331 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 3219; /* *movv4sf */
  if (!register_operand (operands[0], E_V4SFmode)
      || !register_operand (operands[1], E_V4SFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 3396; /* *movv4sf_vls */
}

 int
recog_202 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2HFmode)
      && reg_or_mem_operand (operands[1], E_V2HFmode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2HFmode)
       || register_operand (operands[1], V2HFmode))) && 
#line 4325 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 3213; /* *movv2hf */
  if (!register_operand (operands[0], E_V2HFmode)
      || !register_operand (operands[1], E_V2HFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 3383; /* *movv2hf_vls */
}

 int
recog_208 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1DImode)
      && reg_or_mem_operand (operands[1], E_V1DImode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1DImode)
       || register_operand (operands[1], V1DImode))) && 
#line 4319 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 3207; /* *movv1di */
  if (!register_operand (operands[0], E_V1DImode)
      || !register_operand (operands[1], E_V1DImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 3372; /* *movv1di_vls */
}

 int
recog_215 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8HImode)
      && reg_or_mem_operand (operands[1], E_V8HImode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[1], V8HImode))) && 
#line 4312 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return 3200; /* *movv8hi */
  if (!register_operand (operands[0], E_V8HImode)
      || !register_operand (operands[1], E_V8HImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return -1;
  return 3352; /* *movv8hi_vls */
}

 int
recog_222 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2QImode)
      && reg_or_mem_operand (operands[1], E_V2QImode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode))) && 
#line 4305 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return 3193; /* *movv2qi */
  if (!register_operand (operands[0], E_V2QImode)
      || !register_operand (operands[1], E_V2QImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return -1;
  return 3337; /* *movv2qi_vls */
}

 int
recog_229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x4QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3182; /* *movrvvm2x4qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3183; /* *movrvvm2x4qi_di */
}

 int
recog_234 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3172; /* *movrvvm2x3hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3173; /* *movrvvm2x3hf_di */
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3HImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3158; /* *movrvvm2x3hi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3159; /* *movrvvm2x3hi_di */
}

 int
recog_248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3144; /* *movrvvm1x3qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3145; /* *movrvvm1x3qi_di */
}

 int
recog_255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x7HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x7HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3130; /* *movrvvm1x7hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3131; /* *movrvvm1x7hf_di */
}

 int
recog_263 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3114; /* *movrvvm1x6bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3115; /* *movrvvm1x6bf_di */
}

 int
recog_271 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2SImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3098; /* *movrvvm2x2si_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3099; /* *movrvvm2x2si_di */
}

 int
recog_277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3HImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3086; /* *movrvvm1x3hi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3087; /* *movrvvm1x3hi_di */
}

 int
recog_285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x2QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3070; /* *movrvvmf2x2qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3071; /* *movrvvmf2x2qi_di */
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4SFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3054; /* *movrvvm1x4sf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3055; /* *movrvvm1x4sf_di */
}

 int
recog_301 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3038; /* *movrvvmf2x3hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3039; /* *movrvvmf2x3hf_di */
}

 int
recog_309 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x2BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x2BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3022; /* *movrvvmf2x2bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3023; /* *movrvvmf2x2bf_di */
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4SImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3006; /* *movrvvm1x4si_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3007; /* *movrvvm1x4si_di */
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3HImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2990; /* *movrvvmf2x3hi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2991; /* *movrvvmf2x3hi_di */
}

 int
recog_333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x2QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2974; /* *movrvvmf4x2qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2975; /* *movrvvmf4x2qi_di */
}

 int
recog_341 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8SFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2958; /* *movrvvmf2x8sf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2959; /* *movrvvmf2x8sf_di */
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x7HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x7HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2942; /* *movrvvmf4x7hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2943; /* *movrvvmf4x7hf_di */
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x6BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x6BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2926; /* *movrvvmf4x6bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2927; /* *movrvvmf4x6bf_di */
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5DImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2910; /* *movrvvm1x5di_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2911; /* *movrvvm1x5di_di */
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4SImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2894; /* *movrvvmf2x4si_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2895; /* *movrvvmf2x4si_di */
}

 int
recog_381 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 2);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if (
#line 3029 "../../gcc/config/riscv/riscv.md"
((TARGET_64BIT && (INTVAL (operands[3]) > 0)
    && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))))
        return 331; /* *lshrsi3_extend_2 */
      if (pnum_clobbers == NULL
          || !(
#line 3064 "../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 336; /* *zero_extractdi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !
#line 3064 "../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))))
        return -1;
      *pnum_clobbers = 1;
      return 334; /* *zero_extractsi3 */

    default:
      return -1;
    }
}

 int
recog_383 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      operands[1] = x3;
      x9 = XEXP (x5, 0);
      operands[2] = x9;
      x10 = XEXP (x5, 1);
      operands[3] = x10;
      if (!shifted_const_arith_operand (operands[3], E_VOIDmode))
        return -1;
      switch (pattern447 (x2))
        {
        case 0:
          if ((
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 338; /* *branchqi_shiftedarith_equals_zero */
            }
          if (!(
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 341; /* *branchqi_shiftedarith_equals_zero */

        case 1:
          if ((
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 339; /* *branchhi_shiftedarith_equals_zero */
            }
          if (!(
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 342; /* *branchhi_shiftedarith_equals_zero */

        case 2:
          if ((
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 340; /* *branchsi_shiftedarith_equals_zero */
            }
          if (!(
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 343; /* *branchsi_shiftedarith_equals_zero */

        case 3:
          if (!(
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 344; /* *branchdi_shiftedarith_equals_zero */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x5, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XEXP (x5, 0);
      operands[2] = x9;
      if (XWINT (x10, 0) == 1L)
        {
          res = recog_382 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x11 = XEXP (x5, 2);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x3;
      operands[3] = x10;
      if (!branch_on_bit_operand (operands[3], E_VOIDmode))
        return -1;
      x12 = XEXP (x6, 0);
      operands[1] = x12;
      switch (GET_MODE (x5))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 385; /* *branch_on_bit_rangesi */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || !
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 386; /* *branch_on_bit_rangedi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x5;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      operands[4] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      x7 = XEXP (x2, 2);
      operands[3] = x7;
      switch (pattern333 (x2))
        {
        case 0:
          if (!reg_or_0_operand (operands[2], E_SImode)
              || !reg_or_0_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !(
#line 165 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 893; /* *th_cond_movsi */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !(
#line 165 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 894; /* *th_cond_movsi */

            default:
              return -1;
            }

        case 1:
          if (!register_operand (operands[1], E_DImode)
              || !reg_or_0_operand (operands[2], E_DImode)
              || !reg_or_0_operand (operands[3], E_DImode)
              || !(
#line 165 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADCONDMOV) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 895; /* *th_cond_movdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_385 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!shifted_const_arith_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!shifted_const_arith_operand (operands[3], E_VOIDmode))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  switch (GET_CODE (x3))
    {
    case EQ:
      switch (pattern448 (x4))
        {
        case 0:
          if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 345; /* *branchqi_shiftedarith_eq_shifted */
            }
          if (!(
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 353; /* *branchqi_shiftedarith_eq_shifted */

        case 1:
          if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 347; /* *branchhi_shiftedarith_eq_shifted */
            }
          if (!(
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 355; /* *branchhi_shiftedarith_eq_shifted */

        case 2:
          if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 349; /* *branchsi_shiftedarith_eq_shifted */
            }
          if (!(
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 357; /* *branchsi_shiftedarith_eq_shifted */

        case 3:
          if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && ((((
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            {
              *pnum_clobbers = 2;
              return 351; /* *branchdi_shiftedarith_eq_shifted */
            }
          if (!(
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 359; /* *branchdi_shiftedarith_eq_shifted */

        default:
          return -1;
        }

    case NE:
      switch (pattern448 (x4))
        {
        case 0:
          if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 346; /* *branchqi_shiftedarith_ne_shifted */
            }
          if (!(
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 354; /* *branchqi_shiftedarith_ne_shifted */

        case 1:
          if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 348; /* *branchhi_shiftedarith_ne_shifted */
            }
          if (!(
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 356; /* *branchhi_shiftedarith_ne_shifted */

        case 2:
          if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 350; /* *branchsi_shiftedarith_ne_shifted */
            }
          if (!(
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 358; /* *branchsi_shiftedarith_ne_shifted */

        case 3:
          if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && ((((
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            {
              *pnum_clobbers = 2;
              return 352; /* *branchdi_shiftedarith_ne_shifted */
            }
          if (!(
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 360; /* *branchdi_shiftedarith_ne_shifted */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_396 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3965; /* pred_mergervvm8qi_scalar */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3966; /* pred_mergervvm4qi_scalar */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3967; /* pred_mergervvm2qi_scalar */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3968; /* pred_mergervvm1qi_scalar */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3969; /* pred_mergervvmf2qi_scalar */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3970; /* pred_mergervvmf4qi_scalar */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 3971; /* pred_mergervvmf8qi_scalar */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3972; /* pred_mergervvm8hi_scalar */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3973; /* pred_mergervvm4hi_scalar */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3974; /* pred_mergervvm2hi_scalar */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3975; /* pred_mergervvm1hi_scalar */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3976; /* pred_mergervvmf2hi_scalar */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 3977; /* pred_mergervvmf4hi_scalar */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3978; /* pred_mergervvm8si_scalar */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3979; /* pred_mergervvm4si_scalar */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3980; /* pred_mergervvm2si_scalar */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0
          || !
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3981; /* pred_mergervvm1si_scalar */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 3982; /* pred_mergervvmf2si_scalar */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 3983; /* pred_mergev1qi_scalar */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 3984; /* pred_mergev2qi_scalar */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 3985; /* pred_mergev4qi_scalar */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 3986; /* pred_mergev8qi_scalar */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 3987; /* pred_mergev16qi_scalar */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 3988; /* pred_mergev32qi_scalar */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3989; /* pred_mergev64qi_scalar */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3990; /* pred_mergev128qi_scalar */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3991; /* pred_mergev256qi_scalar */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3992; /* pred_mergev512qi_scalar */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3993; /* pred_mergev1024qi_scalar */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3994; /* pred_mergev2048qi_scalar */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3995; /* pred_mergev4096qi_scalar */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 3996; /* pred_mergev1hi_scalar */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 3997; /* pred_mergev2hi_scalar */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 3998; /* pred_mergev4hi_scalar */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 3999; /* pred_mergev8hi_scalar */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 4000; /* pred_mergev16hi_scalar */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4001; /* pred_mergev32hi_scalar */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4002; /* pred_mergev64hi_scalar */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4003; /* pred_mergev128hi_scalar */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4004; /* pred_mergev256hi_scalar */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4005; /* pred_mergev512hi_scalar */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4006; /* pred_mergev1024hi_scalar */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4007; /* pred_mergev2048hi_scalar */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 4008; /* pred_mergev1si_scalar */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 4009; /* pred_mergev2si_scalar */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 4010; /* pred_mergev4si_scalar */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 4011; /* pred_mergev8si_scalar */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4012; /* pred_mergev16si_scalar */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4013; /* pred_mergev32si_scalar */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4014; /* pred_mergev64si_scalar */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4015; /* pred_mergev128si_scalar */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4016; /* pred_mergev256si_scalar */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4017; /* pred_mergev512si_scalar */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4018; /* pred_mergev1024si_scalar */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4019; /* *pred_mergervvm8di_scalar */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4020; /* *pred_mergervvm4di_scalar */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4021; /* *pred_mergervvm2di_scalar */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4022; /* *pred_mergervvm1di_scalar */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4023; /* *pred_mergev1di_scalar */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4024; /* *pred_mergev2di_scalar */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4025; /* *pred_mergev4di_scalar */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4026; /* *pred_mergev8di_scalar */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4027; /* *pred_mergev16di_scalar */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4028; /* *pred_mergev32di_scalar */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4029; /* *pred_mergev64di_scalar */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4030; /* *pred_mergev128di_scalar */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4031; /* *pred_mergev256di_scalar */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4032; /* *pred_mergev512di_scalar */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17231; /* pred_mergervvm8hf_scalar */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17232; /* pred_mergervvm4hf_scalar */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17233; /* pred_mergervvm2hf_scalar */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17234; /* pred_mergervvm1hf_scalar */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17235; /* pred_mergervvmf2hf_scalar */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17236; /* pred_mergervvmf4hf_scalar */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17237; /* pred_mergervvm8sf_scalar */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17238; /* pred_mergervvm4sf_scalar */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17239; /* pred_mergervvm2sf_scalar */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17240; /* pred_mergervvm1sf_scalar */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17241; /* pred_mergervvmf2sf_scalar */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17242; /* pred_mergervvm8df_scalar */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17243; /* pred_mergervvm4df_scalar */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17244; /* pred_mergervvm2df_scalar */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17245; /* pred_mergervvm1df_scalar */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17246; /* pred_mergev1hf_scalar */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17247; /* pred_mergev2hf_scalar */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17248; /* pred_mergev4hf_scalar */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17249; /* pred_mergev8hf_scalar */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17250; /* pred_mergev16hf_scalar */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17251; /* pred_mergev32hf_scalar */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17252; /* pred_mergev64hf_scalar */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17253; /* pred_mergev128hf_scalar */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17254; /* pred_mergev256hf_scalar */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17255; /* pred_mergev512hf_scalar */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17256; /* pred_mergev1024hf_scalar */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17257; /* pred_mergev2048hf_scalar */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17258; /* pred_mergev1sf_scalar */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17259; /* pred_mergev2sf_scalar */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17260; /* pred_mergev4sf_scalar */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17261; /* pred_mergev8sf_scalar */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17262; /* pred_mergev16sf_scalar */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17263; /* pred_mergev32sf_scalar */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17264; /* pred_mergev64sf_scalar */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17265; /* pred_mergev128sf_scalar */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17266; /* pred_mergev256sf_scalar */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17267; /* pred_mergev512sf_scalar */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17268; /* pred_mergev1024sf_scalar */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17269; /* pred_mergev1df_scalar */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17270; /* pred_mergev2df_scalar */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17271; /* pred_mergev4df_scalar */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17272; /* pred_mergev8df_scalar */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17273; /* pred_mergev16df_scalar */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17274; /* pred_mergev32df_scalar */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17275; /* pred_mergev64df_scalar */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17276; /* pred_mergev128df_scalar */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17277; /* pred_mergev256df_scalar */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17278; /* pred_mergev512df_scalar */

    default:
      return -1;
    }
}

 int
recog_408 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  if (!vector_length_operand (x5, E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF64BImode:
      if (GET_MODE (x2) != E_RVVMF64BImode
          || GET_MODE (x3) != E_RVVMF64BImode
          || !vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_RVVMF64BImode))
        {
          res = recog_388 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!memory_operand (operands[0], E_RVVMF64BImode))
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_RVVMF64BImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !(
#line 1990 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 3836; /* pred_storervvmf64bi */

    case E_RVVMF32BImode:
      if (GET_MODE (x2) != E_RVVMF32BImode
          || GET_MODE (x3) != E_RVVMF32BImode
          || !vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_RVVMF32BImode))
        {
          res = recog_389 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!memory_operand (operands[0], E_RVVMF32BImode))
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_RVVMF32BImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !
#line 1990 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3837; /* pred_storervvmf32bi */

    case E_RVVMF16BImode:
      if (GET_MODE (x2) != E_RVVMF16BImode
          || GET_MODE (x3) != E_RVVMF16BImode
          || !vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_RVVMF16BImode))
        {
          res = recog_390 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!memory_operand (operands[0], E_RVVMF16BImode))
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_RVVMF16BImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !
#line 1990 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3838; /* pred_storervvmf16bi */

    case E_RVVMF8BImode:
      if (GET_MODE (x2) != E_RVVMF8BImode
          || GET_MODE (x3) != E_RVVMF8BImode
          || !vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_RVVMF8BImode))
        {
          res = recog_391 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!memory_operand (operands[0], E_RVVMF8BImode))
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_RVVMF8BImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !
#line 1990 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3839; /* pred_storervvmf8bi */

    case E_RVVMF4BImode:
      if (GET_MODE (x2) != E_RVVMF4BImode
          || GET_MODE (x3) != E_RVVMF4BImode
          || !vector_all_trues_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_RVVMF4BImode))
        {
          res = recog_392 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!memory_operand (operands[0], E_RVVMF4BImode))
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_RVVMF4BImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !
#line 1990 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3840; /* pred_storervvmf4bi */

    case E_RVVMF2BImode:
      if (GET_MODE (x2) != E_RVVMF2BImode
          || GET_MODE (x3) != E_RVVMF2BImode
          || !vector_all_trues_mask_operand (operands[1], E_RVVMF2BImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_RVVMF2BImode))
        {
          res = recog_393 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!memory_operand (operands[0], E_RVVMF2BImode))
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_RVVMF2BImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !
#line 1990 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3841; /* pred_storervvmf2bi */

    case E_RVVM1BImode:
      if (GET_MODE (x2) != E_RVVM1BImode
          || GET_MODE (x3) != E_RVVM1BImode
          || !vector_all_trues_mask_operand (operands[1], E_RVVM1BImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_RVVM1BImode))
        {
          res = recog_394 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!memory_operand (operands[0], E_RVVM1BImode))
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_RVVM1BImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !
#line 1990 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3842; /* pred_storervvm1bi */

    case E_V1BImode:
      if (pattern463 (x2, 
E_V1BImode) != 0)
        return -1;
      if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return 1238; /* *pred_th_movv1bi */
      if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return -1;
      return 3823; /* pred_movv1bi */

    case E_V2BImode:
      if (pattern463 (x2, 
E_V2BImode) != 0)
        return -1;
      if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return 1239; /* *pred_th_movv2bi */
      if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return -1;
      return 3824; /* pred_movv2bi */

    case E_V4BImode:
      if (pattern463 (x2, 
E_V4BImode) != 0)
        return -1;
      if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return 1240; /* *pred_th_movv4bi */
      if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return -1;
      return 3825; /* pred_movv4bi */

    case E_V8BImode:
      if (pattern463 (x2, 
E_V8BImode) != 0)
        return -1;
      if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return 1241; /* *pred_th_movv8bi */
      if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return -1;
      return 3826; /* pred_movv8bi */

    case E_V16BImode:
      if (pattern463 (x2, 
E_V16BImode) != 0)
        return -1;
      if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return 1242; /* *pred_th_movv16bi */
      if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return -1;
      return 3827; /* pred_movv16bi */

    case E_V32BImode:
      if (pattern463 (x2, 
E_V32BImode) != 0)
        return -1;
      if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return 1243; /* *pred_th_movv32bi */
      if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return -1;
      return 3828; /* pred_movv32bi */

    case E_V64BImode:
      if (pattern463 (x2, 
E_V64BImode) != 0)
        return -1;
      if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return 1244; /* *pred_th_movv64bi */
      if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3829; /* pred_movv64bi */

    case E_V128BImode:
      if (pattern463 (x2, 
E_V128BImode) != 0)
        return -1;
      if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return 1245; /* *pred_th_movv128bi */
      if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3830; /* pred_movv128bi */

    case E_V256BImode:
      if (pattern463 (x2, 
E_V256BImode) != 0)
        return -1;
      if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return 1246; /* *pred_th_movv256bi */
      if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3831; /* pred_movv256bi */

    case E_V512BImode:
      if (pattern463 (x2, 
E_V512BImode) != 0)
        return -1;
      if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return 1247; /* *pred_th_movv512bi */
      if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3832; /* pred_movv512bi */

    case E_V1024BImode:
      if (pattern463 (x2, 
E_V1024BImode) != 0)
        return -1;
      if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return 1248; /* *pred_th_movv1024bi */
      if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3833; /* pred_movv1024bi */

    case E_V2048BImode:
      if (pattern463 (x2, 
E_V2048BImode) != 0)
        return -1;
      if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return 1249; /* *pred_th_movv2048bi */
      if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3834; /* pred_movv2048bi */

    case E_V4096BImode:
      if (pattern463 (x2, 
E_V4096BImode) != 0)
        return -1;
      if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return 1250; /* *pred_th_movv4096bi */
      if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3835; /* pred_movv4096bi */

    case E_RVVM8QImode:
      if (pattern464 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3773; /* pred_storervvm8qi */

    case E_RVVM4QImode:
      if (pattern464 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3774; /* pred_storervvm4qi */

    case E_RVVM2QImode:
      if (pattern464 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3775; /* pred_storervvm2qi */

    case E_RVVM1QImode:
      if (pattern464 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3776; /* pred_storervvm1qi */

    case E_RVVM8HImode:
      if (pattern464 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3777; /* pred_storervvm8hi */

    case E_RVVM4HImode:
      if (pattern464 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3778; /* pred_storervvm4hi */

    case E_RVVM2HImode:
      if (pattern464 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3779; /* pred_storervvm2hi */

    case E_RVVM1HImode:
      if (pattern464 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3780; /* pred_storervvm1hi */

    case E_RVVM8SImode:
      if (pattern464 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3781; /* pred_storervvm8si */

    case E_RVVM4SImode:
      if (pattern464 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3782; /* pred_storervvm4si */

    case E_RVVM2SImode:
      if (pattern464 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3783; /* pred_storervvm2si */

    case E_RVVM1SImode:
      if (pattern464 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3784; /* pred_storervvm1si */

    case E_RVVM8DImode:
      if (pattern464 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3785; /* pred_storervvm8di */

    case E_RVVM4DImode:
      if (pattern464 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3786; /* pred_storervvm4di */

    case E_RVVM2DImode:
      if (pattern464 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3787; /* pred_storervvm2di */

    case E_RVVM1DImode:
      if (pattern464 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3788; /* pred_storervvm1di */

    case E_RVVMF2QImode:
      if (pattern464 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3789; /* pred_storervvmf2qi */

    case E_RVVMF4QImode:
      if (pattern464 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3790; /* pred_storervvmf4qi */

    case E_RVVMF8QImode:
      if (pattern464 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3791; /* pred_storervvmf8qi */

    case E_RVVMF2HImode:
      if (pattern464 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3792; /* pred_storervvmf2hi */

    case E_RVVMF4HImode:
      if (pattern464 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3793; /* pred_storervvmf4hi */

    case E_RVVMF2SImode:
      if (pattern464 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3794; /* pred_storervvmf2si */

    case E_RVVM8BFmode:
      if (pattern464 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3795; /* pred_storervvm8bf */

    case E_RVVM4BFmode:
      if (pattern464 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3796; /* pred_storervvm4bf */

    case E_RVVM2BFmode:
      if (pattern464 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3797; /* pred_storervvm2bf */

    case E_RVVM1BFmode:
      if (pattern464 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3798; /* pred_storervvm1bf */

    case E_RVVMF2BFmode:
      if (pattern464 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3799; /* pred_storervvmf2bf */

    case E_RVVMF4BFmode:
      if (pattern464 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3800; /* pred_storervvmf4bf */

    case E_RVVM8HFmode:
      if (pattern464 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3801; /* pred_storervvm8hf */

    case E_RVVM4HFmode:
      if (pattern464 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3802; /* pred_storervvm4hf */

    case E_RVVM2HFmode:
      if (pattern464 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3803; /* pred_storervvm2hf */

    case E_RVVM1HFmode:
      if (pattern464 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3804; /* pred_storervvm1hf */

    case E_RVVMF2HFmode:
      if (pattern464 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3805; /* pred_storervvmf2hf */

    case E_RVVMF4HFmode:
      if (pattern464 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3806; /* pred_storervvmf4hf */

    case E_RVVM8SFmode:
      if (pattern464 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3807; /* pred_storervvm8sf */

    case E_RVVM4SFmode:
      if (pattern464 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3808; /* pred_storervvm4sf */

    case E_RVVM2SFmode:
      if (pattern464 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3809; /* pred_storervvm2sf */

    case E_RVVM1SFmode:
      if (pattern464 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3810; /* pred_storervvm1sf */

    case E_RVVMF2SFmode:
      if (pattern464 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3811; /* pred_storervvmf2sf */

    case E_RVVM8DFmode:
      if (pattern464 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3812; /* pred_storervvm8df */

    case E_RVVM4DFmode:
      if (pattern464 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3813; /* pred_storervvm4df */

    case E_RVVM2DFmode:
      if (pattern464 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3814; /* pred_storervvm2df */

    case E_RVVM1DFmode:
      if (pattern464 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3815; /* pred_storervvm1df */

    default:
      return -1;
    }
}

 int
recog_418 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V16DFmode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16DFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return 4347; /* *pred_broadcastv16df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16DFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4469; /* *pred_broadcastv16df_imm */
}

 int
recog_421 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V2DFmode, 
E_V2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2BImode)
      && vector_const_0_operand (operands[3], E_V2DFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 4344; /* *pred_broadcastv2df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2DFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4466; /* *pred_broadcastv2df_imm */
}

 int
recog_425 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V256SFmode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return 4340; /* *pred_broadcastv256sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4462; /* *pred_broadcastv256sf_imm */
}

 int
recog_429 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V16SFmode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 4336; /* *pred_broadcastv16sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4458; /* *pred_broadcastv16sf_imm */
}

 int
recog_434 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2048BImode)
      && vector_const_0_operand (operands[3], E_V2048HFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
    return 4331; /* *pred_broadcastv2048hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2048BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2048HFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4453; /* *pred_broadcastv2048hf_imm */
}

 int
recog_438 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V128HFmode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128HFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return 4327; /* *pred_broadcastv128hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128HFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4449; /* *pred_broadcastv128hf_imm */
}

 int
recog_442 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V8HFmode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8HFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 4323; /* *pred_broadcastv8hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8HFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4445; /* *pred_broadcastv8hf_imm */
}

 int
recog_447 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256DImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 4318; /* *pred_broadcastv256di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256DImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4440; /* *pred_broadcastv256di_imm */
}

 int
recog_452 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8DImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 4313; /* *pred_broadcastv8di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8DImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4435; /* *pred_broadcastv8di_imm */
}

 int
recog_457 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512SImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 4308; /* *pred_broadcastv512si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512SImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4430; /* *pred_broadcastv512si_imm */
}

 int
recog_463 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8SImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 4302; /* *pred_broadcastv8si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8SImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 4424; /* *pred_broadcastv8si_imm */
}

 int
recog_468 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024HImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 4297; /* *pred_broadcastv1024hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024HImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4419; /* *pred_broadcastv1024hi_imm */
}

 int
recog_475 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8HImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return 4290; /* *pred_broadcastv8hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8HImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return -1;
  return 4412; /* *pred_broadcastv8hi_imm */
}

 int
recog_482 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512QImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return 4283; /* *pred_broadcastv512qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512QImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4405; /* *pred_broadcastv512qi_imm */
}

 int
recog_489 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V4QImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4QImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return 4276; /* *pred_broadcastv4qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4QImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return -1;
  return 4398; /* *pred_broadcastv4qi_imm */
}

 int
recog_497 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
      && vector_const_0_operand (operands[3], E_RVVM1SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 4268; /* *pred_broadcastrvvm1sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4390; /* *pred_broadcastrvvm1sf_imm */
}

 int
recog_505 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF4BImode)
      && vector_const_0_operand (operands[3], E_RVVM4HFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 4260; /* *pred_broadcastrvvm4hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4HFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4382; /* *pred_broadcastrvvm4hf_imm */
}

 int
recog_513 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V64DFmode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64DImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 20701; /* pred_gatherv64df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 20823; /* pred_gatherv64df_scalar */
}

 int
recog_518 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V2DFmode, 
E_V2BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2DImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 20696; /* pred_gatherv2df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20818; /* pred_gatherv2df_scalar */
}

 int
recog_523 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V128SFmode, 
E_V128BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V128SImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 20691; /* pred_gatherv128sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 20813; /* pred_gatherv128sf_scalar */
}

 int
recog_529 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V2SFmode, 
E_V2BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2SImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 20685; /* pred_gatherv2sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 20807; /* pred_gatherv2sf_scalar */
}

 int
recog_534 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V256HFmode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256HImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return 20680; /* pred_gatherv256hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 20802; /* pred_gatherv256hf_scalar */
}

 int
recog_539 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V8HFmode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8HImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 20675; /* pred_gatherv8hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 20797; /* pred_gatherv8hf_scalar */
}

 int
recog_542 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1HFmode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1HImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 20672; /* pred_gatherv1hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 20794; /* pred_gatherv1hf_scalar */
}

 int
recog_547 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32DImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 20667; /* pred_gatherv32di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20789; /* pred_gatherv32di_scalar */
}

 int
recog_552 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1DImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 20662; /* pred_gatherv1di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 20784; /* pred_gatherv1di_scalar */
}

 int
recog_557 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64SImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 20657; /* pred_gatherv64si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20779; /* pred_gatherv64si_scalar */
}

 int
recog_562 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2SImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 20652; /* pred_gatherv2si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 20774; /* pred_gatherv2si_scalar */
}

 int
recog_567 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256HImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 20647; /* pred_gatherv256hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 20769; /* pred_gatherv256hi_scalar */
}

 int
recog_572 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8HImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return 20642; /* pred_gatherv8hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return -1;
  return 20764; /* pred_gatherv8hi_scalar */
}

 int
recog_577 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2048QImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return 20637; /* pred_gatherv2048qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20759; /* pred_gatherv2048qi_scalar */
}

 int
recog_582 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64QImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 20632; /* pred_gatherv64qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20754; /* pred_gatherv64qi_scalar */
}

 int
recog_587 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2QImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return 20627; /* pred_gatherv2qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return -1;
  return 20749; /* pred_gatherv2qi_scalar */
}

 int
recog_592 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_RVVM8DImode)
      && (
#line 8229 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 20622; /* pred_gatherrvvm8df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20744; /* pred_gatherrvvm8df_scalar */
}

 int
recog_597 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern553 (x2))
    {
    case 0:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8088; /* pred_mulhurvvm8qi */

    case 1:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8091; /* pred_mulhurvvm4qi */

    case 2:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8094; /* pred_mulhurvvm2qi */

    case 3:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8097; /* pred_mulhurvvm1qi */

    case 4:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8100; /* pred_mulhurvvmf2qi */

    case 5:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8103; /* pred_mulhurvvmf4qi */

    case 6:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 502 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8106; /* pred_mulhurvvmf8qi */

    case 7:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8109; /* pred_mulhurvvm8hi */

    case 8:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8112; /* pred_mulhurvvm4hi */

    case 9:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8115; /* pred_mulhurvvm2hi */

    case 10:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8118; /* pred_mulhurvvm1hi */

    case 11:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8121; /* pred_mulhurvvmf2hi */

    case 12:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 504 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8124; /* pred_mulhurvvmf4hi */

    case 13:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8127; /* pred_mulhurvvm8si */

    case 14:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8130; /* pred_mulhurvvm4si */

    case 15:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8133; /* pred_mulhurvvm2si */

    case 16:
      if (!
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8136; /* pred_mulhurvvm1si */

    case 17:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 506 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8139; /* pred_mulhurvvmf2si */

    case 18:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8142; /* pred_mulhurvvm8di */

    case 19:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8145; /* pred_mulhurvvm4di */

    case 20:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8148; /* pred_mulhurvvm2di */

    case 21:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8151; /* pred_mulhurvvm1di */

    case 22:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8154; /* pred_mulhuv1qi */

    case 23:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8157; /* pred_mulhuv2qi */

    case 24:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8160; /* pred_mulhuv4qi */

    case 25:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8163; /* pred_mulhuv8qi */

    case 26:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8166; /* pred_mulhuv16qi */

    case 27:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8169; /* pred_mulhuv32qi */

    case 28:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8172; /* pred_mulhuv64qi */

    case 29:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 517 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8175; /* pred_mulhuv128qi */

    case 30:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8178; /* pred_mulhuv256qi */

    case 31:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8181; /* pred_mulhuv512qi */

    case 32:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8184; /* pred_mulhuv1024qi */

    case 33:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8187; /* pred_mulhuv2048qi */

    case 34:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8190; /* pred_mulhuv4096qi */

    case 35:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8193; /* pred_mulhuv1hi */

    case 36:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8196; /* pred_mulhuv2hi */

    case 37:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8199; /* pred_mulhuv4hi */

    case 38:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8202; /* pred_mulhuv8hi */

    case 39:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8205; /* pred_mulhuv16hi */

    case 40:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8208; /* pred_mulhuv32hi */

    case 41:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8211; /* pred_mulhuv64hi */

    case 42:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8214; /* pred_mulhuv128hi */

    case 43:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 531 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8217; /* pred_mulhuv256hi */

    case 44:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 532 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8220; /* pred_mulhuv512hi */

    case 45:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 533 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8223; /* pred_mulhuv1024hi */

    case 46:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 534 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8226; /* pred_mulhuv2048hi */

    case 47:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 535 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8229; /* pred_mulhuv1si */

    case 48:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 536 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8232; /* pred_mulhuv2si */

    case 49:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 537 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8235; /* pred_mulhuv4si */

    case 50:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 538 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8238; /* pred_mulhuv8si */

    case 51:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 539 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8241; /* pred_mulhuv16si */

    case 52:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 540 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8244; /* pred_mulhuv32si */

    case 53:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 541 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8247; /* pred_mulhuv64si */

    case 54:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 542 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8250; /* pred_mulhuv128si */

    case 55:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 543 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8253; /* pred_mulhuv256si */

    case 56:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 544 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8256; /* pred_mulhuv512si */

    case 57:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 545 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8259; /* pred_mulhuv1024si */

    case 58:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 546 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 8262; /* pred_mulhuv1di */

    case 59:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 547 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 8265; /* pred_mulhuv2di */

    case 60:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 548 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 8268; /* pred_mulhuv4di */

    case 61:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 549 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8271; /* pred_mulhuv8di */

    case 62:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 550 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8274; /* pred_mulhuv16di */

    case 63:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 551 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8277; /* pred_mulhuv32di */

    case 64:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 552 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8280; /* pred_mulhuv64di */

    case 65:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 553 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8283; /* pred_mulhuv128di */

    case 66:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 554 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8286; /* pred_mulhuv256di */

    case 67:
      if (!(
#line 3074 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 555 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8289; /* pred_mulhuv512di */

    case 68:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8292; /* pred_mulhurvvm8qi_scalar */

    case 69:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8295; /* pred_mulhurvvm4qi_scalar */

    case 70:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8298; /* pred_mulhurvvm2qi_scalar */

    case 71:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8301; /* pred_mulhurvvm1qi_scalar */

    case 72:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8304; /* pred_mulhurvvmf2qi_scalar */

    case 73:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8307; /* pred_mulhurvvmf4qi_scalar */

    case 74:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8310; /* pred_mulhurvvmf8qi_scalar */

    case 75:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8313; /* pred_mulhurvvm8hi_scalar */

    case 76:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8316; /* pred_mulhurvvm4hi_scalar */

    case 77:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8319; /* pred_mulhurvvm2hi_scalar */

    case 78:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8322; /* pred_mulhurvvm1hi_scalar */

    case 79:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8325; /* pred_mulhurvvmf2hi_scalar */

    case 80:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8328; /* pred_mulhurvvmf4hi_scalar */

    case 81:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8331; /* pred_mulhurvvm8si_scalar */

    case 82:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8334; /* pred_mulhurvvm4si_scalar */

    case 83:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8337; /* pred_mulhurvvm2si_scalar */

    case 84:
      if (!
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8340; /* pred_mulhurvvm1si_scalar */

    case 85:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8343; /* pred_mulhurvvmf2si_scalar */

    case 86:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8346; /* pred_mulhuv1qi_scalar */

    case 87:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8349; /* pred_mulhuv2qi_scalar */

    case 88:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8352; /* pred_mulhuv4qi_scalar */

    case 89:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8355; /* pred_mulhuv8qi_scalar */

    case 90:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8358; /* pred_mulhuv16qi_scalar */

    case 91:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8361; /* pred_mulhuv32qi_scalar */

    case 92:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8364; /* pred_mulhuv64qi_scalar */

    case 93:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8367; /* pred_mulhuv128qi_scalar */

    case 94:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8370; /* pred_mulhuv256qi_scalar */

    case 95:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8373; /* pred_mulhuv512qi_scalar */

    case 96:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8376; /* pred_mulhuv1024qi_scalar */

    case 97:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8379; /* pred_mulhuv2048qi_scalar */

    case 98:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8382; /* pred_mulhuv4096qi_scalar */

    case 99:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8385; /* pred_mulhuv1hi_scalar */

    case 100:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8388; /* pred_mulhuv2hi_scalar */

    case 101:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8391; /* pred_mulhuv4hi_scalar */

    case 102:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8394; /* pred_mulhuv8hi_scalar */

    case 103:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8397; /* pred_mulhuv16hi_scalar */

    case 104:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8400; /* pred_mulhuv32hi_scalar */

    case 105:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8403; /* pred_mulhuv64hi_scalar */

    case 106:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8406; /* pred_mulhuv128hi_scalar */

    case 107:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8409; /* pred_mulhuv256hi_scalar */

    case 108:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8412; /* pred_mulhuv512hi_scalar */

    case 109:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8415; /* pred_mulhuv1024hi_scalar */

    case 110:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8418; /* pred_mulhuv2048hi_scalar */

    case 111:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8421; /* pred_mulhuv1si_scalar */

    case 112:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8424; /* pred_mulhuv2si_scalar */

    case 113:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8427; /* pred_mulhuv4si_scalar */

    case 114:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8430; /* pred_mulhuv8si_scalar */

    case 115:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8433; /* pred_mulhuv16si_scalar */

    case 116:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8436; /* pred_mulhuv32si_scalar */

    case 117:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8439; /* pred_mulhuv64si_scalar */

    case 118:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8442; /* pred_mulhuv128si_scalar */

    case 119:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8445; /* pred_mulhuv256si_scalar */

    case 120:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8448; /* pred_mulhuv512si_scalar */

    case 121:
      if (!(
#line 3095 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8451; /* pred_mulhuv1024si_scalar */

    case 122:
      if (!(
#line 3149 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 790 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8454; /* *pred_mulhurvvm8di_scalar */

    case 123:
      if (!(
#line 3149 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 790 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8457; /* *pred_mulhurvvm4di_scalar */

    case 124:
      if (!(
#line 3149 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 791 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8460; /* *pred_mulhurvvm2di_scalar */

    case 125:
      if (!(
#line 3149 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 791 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8463; /* *pred_mulhurvvm1di_scalar */

    case 126:
      if (!(
#line 3171 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 790 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8466; /* *pred_mulhurvvm8di_extended_scalar */

    case 127:
      if (!(
#line 3171 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 790 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8469; /* *pred_mulhurvvm4di_extended_scalar */

    case 128:
      if (!(
#line 3171 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 791 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8472; /* *pred_mulhurvvm2di_extended_scalar */

    case 129:
      if (!(
#line 3171 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 791 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8475; /* *pred_mulhurvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_603 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern599 (x2))
    {
    case 0:
      if (!
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32819; /* pred_vbrevrvvm8qi */

    case 1:
      if (!
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32822; /* pred_vbrevrvvm4qi */

    case 2:
      if (!
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32825; /* pred_vbrevrvvm2qi */

    case 3:
      if (!
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32828; /* pred_vbrevrvvm1qi */

    case 4:
      if (!
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32831; /* pred_vbrevrvvm8hi */

    case 5:
      if (!
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32834; /* pred_vbrevrvvm4hi */

    case 6:
      if (!
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32837; /* pred_vbrevrvvm2hi */

    case 7:
      if (!
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32840; /* pred_vbrevrvvm1hi */

    case 8:
      if (!
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32843; /* pred_vbrevrvvm8si */

    case 9:
      if (!
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32846; /* pred_vbrevrvvm4si */

    case 10:
      if (!
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32849; /* pred_vbrevrvvm2si */

    case 11:
      if (!
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32852; /* pred_vbrevrvvm1si */

    case 12:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32855; /* pred_vbrevrvvm8di */

    case 13:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32858; /* pred_vbrevrvvm4di */

    case 14:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32861; /* pred_vbrevrvvm2di */

    case 15:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32864; /* pred_vbrevrvvm1di */

    case 16:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32867; /* pred_vbrevrvvmf2qi */

    case 17:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32870; /* pred_vbrevrvvmf4qi */

    case 18:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 32873; /* pred_vbrevrvvmf8qi */

    case 19:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32876; /* pred_vbrevrvvmf2hi */

    case 20:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 32879; /* pred_vbrevrvvmf4hi */

    case 21:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 32882; /* pred_vbrevrvvmf2si */

    case 22:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 32885; /* pred_vbrevv1qi */

    case 23:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 32888; /* pred_vbrevv2qi */

    case 24:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 32891; /* pred_vbrevv4qi */

    case 25:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 32894; /* pred_vbrevv8qi */

    case 26:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 32897; /* pred_vbrevv16qi */

    case 27:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 32900; /* pred_vbrevv32qi */

    case 28:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32903; /* pred_vbrevv64qi */

    case 29:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32906; /* pred_vbrevv128qi */

    case 30:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32909; /* pred_vbrevv256qi */

    case 31:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32912; /* pred_vbrevv512qi */

    case 32:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32915; /* pred_vbrevv1024qi */

    case 33:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32918; /* pred_vbrevv2048qi */

    case 34:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32921; /* pred_vbrevv4096qi */

    case 35:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 32924; /* pred_vbrevv1hi */

    case 36:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 32927; /* pred_vbrevv2hi */

    case 37:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 32930; /* pred_vbrevv4hi */

    case 38:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 32933; /* pred_vbrevv8hi */

    case 39:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 32936; /* pred_vbrevv16hi */

    case 40:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32939; /* pred_vbrevv32hi */

    case 41:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32942; /* pred_vbrevv64hi */

    case 42:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32945; /* pred_vbrevv128hi */

    case 43:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32948; /* pred_vbrevv256hi */

    case 44:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32951; /* pred_vbrevv512hi */

    case 45:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32954; /* pred_vbrevv1024hi */

    case 46:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32957; /* pred_vbrevv2048hi */

    case 47:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32960; /* pred_vbrevv1si */

    case 48:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32963; /* pred_vbrevv2si */

    case 49:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32966; /* pred_vbrevv4si */

    case 50:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32969; /* pred_vbrevv8si */

    case 51:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32972; /* pred_vbrevv16si */

    case 52:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32975; /* pred_vbrevv32si */

    case 53:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32978; /* pred_vbrevv64si */

    case 54:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32981; /* pred_vbrevv128si */

    case 55:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32984; /* pred_vbrevv256si */

    case 56:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32987; /* pred_vbrevv512si */

    case 57:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32990; /* pred_vbrevv1024si */

    case 58:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32993; /* pred_vbrevv1di */

    case 59:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32996; /* pred_vbrevv2di */

    case 60:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32999; /* pred_vbrevv4di */

    case 61:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33002; /* pred_vbrevv8di */

    case 62:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33005; /* pred_vbrevv16di */

    case 63:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33008; /* pred_vbrevv32di */

    case 64:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33011; /* pred_vbrevv64di */

    case 65:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33014; /* pred_vbrevv128di */

    case 66:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33017; /* pred_vbrevv256di */

    case 67:
      if (!(
#line 342 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33020; /* pred_vbrevv512di */

    default:
      return -1;
    }
}

 int
recog_617 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM2SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM2SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM2SImode)
      || !
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13091; /* *pred_mul_plusrvvm2si_undef */
}

 int
recog_621 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM2DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM2DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM2DImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13095; /* *pred_mul_plusrvvm2di_undef */
}

 int
recog_625 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVMF8QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVMF8QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVMF8QImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return -1;
  return 13099; /* *pred_mul_plusrvvmf8qi_undef */
}

 int
recog_630 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2QImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return -1;
  return 13104; /* *pred_mul_plusv2qi_undef */
}

 int
recog_634 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V32QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V32QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V32QImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return -1;
  return 13108; /* *pred_mul_plusv32qi_undef */
}

 int
recog_639 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1024QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1024QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1024QImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13113; /* *pred_mul_plusv1024qi_undef */
}

 int
recog_644 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V4HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V4HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V4HImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 13118; /* *pred_mul_plusv4hi_undef */
}

 int
recog_649 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V128HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V128HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V128HImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13123; /* *pred_mul_plusv128hi_undef */
}

 int
recog_654 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1SImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return -1;
  return 13128; /* *pred_mul_plusv1si_undef */
}

 int
recog_659 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V32SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V32SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V32SImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13133; /* *pred_mul_plusv32si_undef */
}

 int
recog_665 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1DImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13139; /* *pred_mul_plusv1di_undef */
}

 int
recog_671 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V64DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V64DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V64DImode)
      || !(
#line 5321 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13145; /* *pred_mul_plusv64di_undef */
}

 int
recog_677 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_672 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V128DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 13214; /* *pred_maddv128di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13282; /* *pred_maccv128di */
}

 int
recog_683 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_666 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V2DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 13208; /* *pred_maddv2di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13276; /* *pred_maccv2di */
}

 int
recog_690 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_659 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V32SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 13201; /* *pred_maddv32si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13269; /* *pred_maccv32si */
}

 int
recog_697 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_652 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V1024HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 13194; /* *pred_maddv1024hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13262; /* *pred_maccv1024hi */
}

 int
recog_704 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_645 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V8HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return 13187; /* *pred_maddv8hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return -1;
  return 13255; /* *pred_maccv8hi */
}

 int
recog_711 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_638 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V512QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return 13180; /* *pred_maddv512qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13248; /* *pred_maccv512qi */
}

 int
recog_718 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13349; /* *pred_maddv64di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13417; /* *pred_maccv64di_scalar */
}

 int
recog_725 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 13342; /* *pred_maddv1024si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13410; /* *pred_maccv1024si_scalar */
}

 int
recog_732 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 13335; /* *pred_maddv8si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 13403; /* *pred_maccv8si_scalar */
}

 int
recog_735 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return 13332; /* *pred_maddv1si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return -1;
  return 13400; /* *pred_maccv1si_scalar */
}

 int
recog_742 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 13325; /* *pred_maddv32hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13393; /* *pred_maccv32hi_scalar */
}

 int
recog_749 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      switch (pattern561 (x2))
        {
        case 0:
          if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9301; /* pred_dual_widen_addsrvvm8hi */

        case 1:
          if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9307; /* pred_dual_widen_addsrvvm4hi */

        case 2:
          if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9313; /* pred_dual_widen_addsrvvm2hi */

        case 3:
          if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9319; /* pred_dual_widen_addsrvvm1hi */

        case 4:
          if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9325; /* pred_dual_widen_addsrvvmf2hi */

        case 5:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9331; /* pred_dual_widen_addsrvvmf4hi */

        case 6:
          if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9337; /* pred_dual_widen_addsrvvm8si */

        case 7:
          if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9343; /* pred_dual_widen_addsrvvm4si */

        case 8:
          if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9349; /* pred_dual_widen_addsrvvm2si */

        case 9:
          if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9355; /* pred_dual_widen_addsrvvm1si */

        case 10:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9361; /* pred_dual_widen_addsrvvmf2si */

        case 11:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9367; /* pred_dual_widen_addsrvvm8di */

        case 12:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9373; /* pred_dual_widen_addsrvvm4di */

        case 13:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9379; /* pred_dual_widen_addsrvvm2di */

        case 14:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9385; /* pred_dual_widen_addsrvvm1di */

        case 15:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9391; /* pred_dual_widen_addsv1hi */

        case 16:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9397; /* pred_dual_widen_addsv2hi */

        case 17:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9403; /* pred_dual_widen_addsv4hi */

        case 18:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9409; /* pred_dual_widen_addsv8hi */

        case 19:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9415; /* pred_dual_widen_addsv16hi */

        case 20:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9421; /* pred_dual_widen_addsv32hi */

        case 21:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9427; /* pred_dual_widen_addsv64hi */

        case 22:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9433; /* pred_dual_widen_addsv128hi */

        case 23:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9439; /* pred_dual_widen_addsv256hi */

        case 24:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9445; /* pred_dual_widen_addsv512hi */

        case 25:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9451; /* pred_dual_widen_addsv1024hi */

        case 26:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9457; /* pred_dual_widen_addsv2048hi */

        case 27:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9463; /* pred_dual_widen_addsv1si */

        case 28:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9469; /* pred_dual_widen_addsv2si */

        case 29:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9475; /* pred_dual_widen_addsv4si */

        case 30:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9481; /* pred_dual_widen_addsv8si */

        case 31:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9487; /* pred_dual_widen_addsv16si */

        case 32:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9493; /* pred_dual_widen_addsv32si */

        case 33:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9499; /* pred_dual_widen_addsv64si */

        case 34:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9505; /* pred_dual_widen_addsv128si */

        case 35:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9511; /* pred_dual_widen_addsv256si */

        case 36:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9517; /* pred_dual_widen_addsv512si */

        case 37:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9523; /* pred_dual_widen_addsv1024si */

        case 38:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9529; /* pred_dual_widen_addsv1di */

        case 39:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9535; /* pred_dual_widen_addsv2di */

        case 40:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9541; /* pred_dual_widen_addsv4di */

        case 41:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9547; /* pred_dual_widen_addsv8di */

        case 42:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9553; /* pred_dual_widen_addsv16di */

        case 43:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9559; /* pred_dual_widen_addsv32di */

        case 44:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9565; /* pred_dual_widen_addsv64di */

        case 45:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9571; /* pred_dual_widen_addsv128di */

        case 46:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9577; /* pred_dual_widen_addsv256di */

        case 47:
          if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9583; /* pred_dual_widen_addsv512di */

        case 48:
          if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9589; /* pred_dual_widen_addsrvvm8hi_scalar */

        case 49:
          if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9595; /* pred_dual_widen_addsrvvm4hi_scalar */

        case 50:
          if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9601; /* pred_dual_widen_addsrvvm2hi_scalar */

        case 51:
          if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9607; /* pred_dual_widen_addsrvvm1hi_scalar */

        case 52:
          if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9613; /* pred_dual_widen_addsrvvmf2hi_scalar */

        case 53:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9619; /* pred_dual_widen_addsrvvmf4hi_scalar */

        case 54:
          if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9625; /* pred_dual_widen_addsrvvm8si_scalar */

        case 55:
          if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9631; /* pred_dual_widen_addsrvvm4si_scalar */

        case 56:
          if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9637; /* pred_dual_widen_addsrvvm2si_scalar */

        case 57:
          if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9643; /* pred_dual_widen_addsrvvm1si_scalar */

        case 58:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9649; /* pred_dual_widen_addsrvvmf2si_scalar */

        case 59:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9655; /* pred_dual_widen_addsrvvm8di_scalar */

        case 60:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9661; /* pred_dual_widen_addsrvvm4di_scalar */

        case 61:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9667; /* pred_dual_widen_addsrvvm2di_scalar */

        case 62:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9673; /* pred_dual_widen_addsrvvm1di_scalar */

        case 63:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9679; /* pred_dual_widen_addsv1hi_scalar */

        case 64:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9685; /* pred_dual_widen_addsv2hi_scalar */

        case 65:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9691; /* pred_dual_widen_addsv4hi_scalar */

        case 66:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9697; /* pred_dual_widen_addsv8hi_scalar */

        case 67:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9703; /* pred_dual_widen_addsv16hi_scalar */

        case 68:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9709; /* pred_dual_widen_addsv32hi_scalar */

        case 69:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9715; /* pred_dual_widen_addsv64hi_scalar */

        case 70:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9721; /* pred_dual_widen_addsv128hi_scalar */

        case 71:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9727; /* pred_dual_widen_addsv256hi_scalar */

        case 72:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9733; /* pred_dual_widen_addsv512hi_scalar */

        case 73:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9739; /* pred_dual_widen_addsv1024hi_scalar */

        case 74:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9745; /* pred_dual_widen_addsv2048hi_scalar */

        case 75:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9751; /* pred_dual_widen_addsv1si_scalar */

        case 76:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9757; /* pred_dual_widen_addsv2si_scalar */

        case 77:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9763; /* pred_dual_widen_addsv4si_scalar */

        case 78:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9769; /* pred_dual_widen_addsv8si_scalar */

        case 79:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9775; /* pred_dual_widen_addsv16si_scalar */

        case 80:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9781; /* pred_dual_widen_addsv32si_scalar */

        case 81:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9787; /* pred_dual_widen_addsv64si_scalar */

        case 82:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9793; /* pred_dual_widen_addsv128si_scalar */

        case 83:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9799; /* pred_dual_widen_addsv256si_scalar */

        case 84:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9805; /* pred_dual_widen_addsv512si_scalar */

        case 85:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9811; /* pred_dual_widen_addsv1024si_scalar */

        case 86:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9817; /* pred_dual_widen_addsv1di_scalar */

        case 87:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9823; /* pred_dual_widen_addsv2di_scalar */

        case 88:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9829; /* pred_dual_widen_addsv4di_scalar */

        case 89:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9835; /* pred_dual_widen_addsv8di_scalar */

        case 90:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9841; /* pred_dual_widen_addsv16di_scalar */

        case 91:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9847; /* pred_dual_widen_addsv32di_scalar */

        case 92:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9853; /* pred_dual_widen_addsv64di_scalar */

        case 93:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9859; /* pred_dual_widen_addsv128di_scalar */

        case 94:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9865; /* pred_dual_widen_addsv256di_scalar */

        case 95:
          if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9871; /* pred_dual_widen_addsv512di_scalar */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern562 (x2))
        {
        case 0:
          if (!
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9973; /* pred_single_widen_addsrvvm8hi */

        case 1:
          if (!
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9975; /* pred_single_widen_addsrvvm4hi */

        case 2:
          if (!
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9977; /* pred_single_widen_addsrvvm2hi */

        case 3:
          if (!
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9979; /* pred_single_widen_addsrvvm1hi */

        case 4:
          if (!
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9981; /* pred_single_widen_addsrvvmf2hi */

        case 5:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9983; /* pred_single_widen_addsrvvmf4hi */

        case 6:
          if (!
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9985; /* pred_single_widen_addsrvvm8si */

        case 7:
          if (!
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9987; /* pred_single_widen_addsrvvm4si */

        case 8:
          if (!
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9989; /* pred_single_widen_addsrvvm2si */

        case 9:
          if (!
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9991; /* pred_single_widen_addsrvvm1si */

        case 10:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9993; /* pred_single_widen_addsrvvmf2si */

        case 11:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9995; /* pred_single_widen_addsrvvm8di */

        case 12:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9997; /* pred_single_widen_addsrvvm4di */

        case 13:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9999; /* pred_single_widen_addsrvvm2di */

        case 14:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10001; /* pred_single_widen_addsrvvm1di */

        case 15:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10003; /* pred_single_widen_addsv1hi */

        case 16:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10005; /* pred_single_widen_addsv2hi */

        case 17:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10007; /* pred_single_widen_addsv4hi */

        case 18:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10009; /* pred_single_widen_addsv8hi */

        case 19:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10011; /* pred_single_widen_addsv16hi */

        case 20:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10013; /* pred_single_widen_addsv32hi */

        case 21:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10015; /* pred_single_widen_addsv64hi */

        case 22:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10017; /* pred_single_widen_addsv128hi */

        case 23:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10019; /* pred_single_widen_addsv256hi */

        case 24:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10021; /* pred_single_widen_addsv512hi */

        case 25:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10023; /* pred_single_widen_addsv1024hi */

        case 26:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10025; /* pred_single_widen_addsv2048hi */

        case 27:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10027; /* pred_single_widen_addsv1si */

        case 28:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10029; /* pred_single_widen_addsv2si */

        case 29:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10031; /* pred_single_widen_addsv4si */

        case 30:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10033; /* pred_single_widen_addsv8si */

        case 31:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10035; /* pred_single_widen_addsv16si */

        case 32:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10037; /* pred_single_widen_addsv32si */

        case 33:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10039; /* pred_single_widen_addsv64si */

        case 34:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10041; /* pred_single_widen_addsv128si */

        case 35:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10043; /* pred_single_widen_addsv256si */

        case 36:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10045; /* pred_single_widen_addsv512si */

        case 37:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10047; /* pred_single_widen_addsv1024si */

        case 38:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10049; /* pred_single_widen_addsv1di */

        case 39:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10051; /* pred_single_widen_addsv2di */

        case 40:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10053; /* pred_single_widen_addsv4di */

        case 41:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10055; /* pred_single_widen_addsv8di */

        case 42:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10057; /* pred_single_widen_addsv16di */

        case 43:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10059; /* pred_single_widen_addsv32di */

        case 44:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10061; /* pred_single_widen_addsv64di */

        case 45:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10063; /* pred_single_widen_addsv128di */

        case 46:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10065; /* pred_single_widen_addsv256di */

        case 47:
          if (!(
#line 4067 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10067; /* pred_single_widen_addsv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern564 (x2))
        {
        case 0:
          if (!
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10549; /* pred_extendrvvm8hi */

        case 1:
          if (!
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10551; /* pred_extendrvvm4hi */

        case 2:
          if (!
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10553; /* pred_extendrvvm2hi */

        case 3:
          if (!
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10555; /* pred_extendrvvm1hi */

        case 4:
          if (!
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10557; /* pred_extendrvvmf2hi */

        case 5:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10559; /* pred_extendrvvmf4hi */

        case 6:
          if (!
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10561; /* pred_extendrvvm8si */

        case 7:
          if (!
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10563; /* pred_extendrvvm4si */

        case 8:
          if (!
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10565; /* pred_extendrvvm2si */

        case 9:
          if (!
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10567; /* pred_extendrvvm1si */

        case 10:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10569; /* pred_extendrvvmf2si */

        case 11:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10571; /* pred_extendrvvm8di */

        case 12:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10573; /* pred_extendrvvm4di */

        case 13:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10575; /* pred_extendrvvm2di */

        case 14:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10577; /* pred_extendrvvm1di */

        case 15:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10579; /* pred_extendv1hi */

        case 16:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10581; /* pred_extendv2hi */

        case 17:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10583; /* pred_extendv4hi */

        case 18:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10585; /* pred_extendv8hi */

        case 19:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10587; /* pred_extendv16hi */

        case 20:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10589; /* pred_extendv32hi */

        case 21:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10591; /* pred_extendv64hi */

        case 22:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10593; /* pred_extendv128hi */

        case 23:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10595; /* pred_extendv256hi */

        case 24:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10597; /* pred_extendv512hi */

        case 25:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10599; /* pred_extendv1024hi */

        case 26:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10601; /* pred_extendv2048hi */

        case 27:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10603; /* pred_extendv1si */

        case 28:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10605; /* pred_extendv2si */

        case 29:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10607; /* pred_extendv4si */

        case 30:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10609; /* pred_extendv8si */

        case 31:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10611; /* pred_extendv16si */

        case 32:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10613; /* pred_extendv32si */

        case 33:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10615; /* pred_extendv64si */

        case 34:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10617; /* pred_extendv128si */

        case 35:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10619; /* pred_extendv256si */

        case 36:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10621; /* pred_extendv512si */

        case 37:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10623; /* pred_extendv1024si */

        case 38:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10625; /* pred_extendv1di */

        case 39:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10627; /* pred_extendv2di */

        case 40:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10629; /* pred_extendv4di */

        case 41:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10631; /* pred_extendv8di */

        case 42:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10633; /* pred_extendv16di */

        case 43:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10635; /* pred_extendv32di */

        case 44:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10637; /* pred_extendv64di */

        case 45:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10639; /* pred_extendv128di */

        case 46:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10641; /* pred_extendv256di */

        case 47:
          if (!(
#line 4203 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10643; /* pred_extendv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_790 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V256QImode) == 0
      && (
#line 5603 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return 13479; /* *pred_minus_mulv256qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V256QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V256QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return 13547; /* *pred_nmsubv256qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13615; /* *pred_nmsacv256qi */
}

 int
recog_798 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V1QImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V1QImode) == 0
      && (
#line 5603 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return 13471; /* *pred_minus_mulv1qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V1QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V1QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return 13539; /* *pred_nmsubv1qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return -1;
  return 13607; /* *pred_nmsacv1qi */
}

 int
recog_806 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 13716; /* *pred_nmsubv32di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13784; /* *pred_nmsacv32di_scalar */
}

 int
recog_813 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13709; /* *pred_nmsubv512si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13777; /* *pred_nmsacv512si_scalar */
}

 int
recog_821 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13701; /* *pred_nmsubv2si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13769; /* *pred_nmsacv2si_scalar */
}

 int
recog_829 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 13693; /* *pred_nmsubv32hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13761; /* *pred_nmsacv32hi_scalar */
}

 int
recog_837 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern530 (x2, 
SIGN_EXTEND))
    {
    case 0:
      if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9303; /* pred_dual_widen_subsrvvm8hi */

    case 1:
      if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9309; /* pred_dual_widen_subsrvvm4hi */

    case 2:
      if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9315; /* pred_dual_widen_subsrvvm2hi */

    case 3:
      if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9321; /* pred_dual_widen_subsrvvm1hi */

    case 4:
      if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9327; /* pred_dual_widen_subsrvvmf2hi */

    case 5:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9333; /* pred_dual_widen_subsrvvmf4hi */

    case 6:
      if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9339; /* pred_dual_widen_subsrvvm8si */

    case 7:
      if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9345; /* pred_dual_widen_subsrvvm4si */

    case 8:
      if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9351; /* pred_dual_widen_subsrvvm2si */

    case 9:
      if (!
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9357; /* pred_dual_widen_subsrvvm1si */

    case 10:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9363; /* pred_dual_widen_subsrvvmf2si */

    case 11:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9369; /* pred_dual_widen_subsrvvm8di */

    case 12:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9375; /* pred_dual_widen_subsrvvm4di */

    case 13:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9381; /* pred_dual_widen_subsrvvm2di */

    case 14:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9387; /* pred_dual_widen_subsrvvm1di */

    case 15:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9393; /* pred_dual_widen_subsv1hi */

    case 16:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9399; /* pred_dual_widen_subsv2hi */

    case 17:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9405; /* pred_dual_widen_subsv4hi */

    case 18:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9411; /* pred_dual_widen_subsv8hi */

    case 19:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9417; /* pred_dual_widen_subsv16hi */

    case 20:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9423; /* pred_dual_widen_subsv32hi */

    case 21:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9429; /* pred_dual_widen_subsv64hi */

    case 22:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9435; /* pred_dual_widen_subsv128hi */

    case 23:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9441; /* pred_dual_widen_subsv256hi */

    case 24:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9447; /* pred_dual_widen_subsv512hi */

    case 25:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9453; /* pred_dual_widen_subsv1024hi */

    case 26:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9459; /* pred_dual_widen_subsv2048hi */

    case 27:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9465; /* pred_dual_widen_subsv1si */

    case 28:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9471; /* pred_dual_widen_subsv2si */

    case 29:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9477; /* pred_dual_widen_subsv4si */

    case 30:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9483; /* pred_dual_widen_subsv8si */

    case 31:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9489; /* pred_dual_widen_subsv16si */

    case 32:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9495; /* pred_dual_widen_subsv32si */

    case 33:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9501; /* pred_dual_widen_subsv64si */

    case 34:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9507; /* pred_dual_widen_subsv128si */

    case 35:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9513; /* pred_dual_widen_subsv256si */

    case 36:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9519; /* pred_dual_widen_subsv512si */

    case 37:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9525; /* pred_dual_widen_subsv1024si */

    case 38:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9531; /* pred_dual_widen_subsv1di */

    case 39:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9537; /* pred_dual_widen_subsv2di */

    case 40:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9543; /* pred_dual_widen_subsv4di */

    case 41:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9549; /* pred_dual_widen_subsv8di */

    case 42:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9555; /* pred_dual_widen_subsv16di */

    case 43:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9561; /* pred_dual_widen_subsv32di */

    case 44:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9567; /* pred_dual_widen_subsv64di */

    case 45:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9573; /* pred_dual_widen_subsv128di */

    case 46:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9579; /* pred_dual_widen_subsv256di */

    case 47:
      if (!(
#line 4002 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9585; /* pred_dual_widen_subsv512di */

    case 48:
      if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9591; /* pred_dual_widen_subsrvvm8hi_scalar */

    case 49:
      if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9597; /* pred_dual_widen_subsrvvm4hi_scalar */

    case 50:
      if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9603; /* pred_dual_widen_subsrvvm2hi_scalar */

    case 51:
      if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9609; /* pred_dual_widen_subsrvvm1hi_scalar */

    case 52:
      if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9615; /* pred_dual_widen_subsrvvmf2hi_scalar */

    case 53:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9621; /* pred_dual_widen_subsrvvmf4hi_scalar */

    case 54:
      if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9627; /* pred_dual_widen_subsrvvm8si_scalar */

    case 55:
      if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9633; /* pred_dual_widen_subsrvvm4si_scalar */

    case 56:
      if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9639; /* pred_dual_widen_subsrvvm2si_scalar */

    case 57:
      if (!
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9645; /* pred_dual_widen_subsrvvm1si_scalar */

    case 58:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9651; /* pred_dual_widen_subsrvvmf2si_scalar */

    case 59:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9657; /* pred_dual_widen_subsrvvm8di_scalar */

    case 60:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9663; /* pred_dual_widen_subsrvvm4di_scalar */

    case 61:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9669; /* pred_dual_widen_subsrvvm2di_scalar */

    case 62:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9675; /* pred_dual_widen_subsrvvm1di_scalar */

    case 63:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9681; /* pred_dual_widen_subsv1hi_scalar */

    case 64:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9687; /* pred_dual_widen_subsv2hi_scalar */

    case 65:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9693; /* pred_dual_widen_subsv4hi_scalar */

    case 66:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9699; /* pred_dual_widen_subsv8hi_scalar */

    case 67:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9705; /* pred_dual_widen_subsv16hi_scalar */

    case 68:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9711; /* pred_dual_widen_subsv32hi_scalar */

    case 69:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9717; /* pred_dual_widen_subsv64hi_scalar */

    case 70:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9723; /* pred_dual_widen_subsv128hi_scalar */

    case 71:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9729; /* pred_dual_widen_subsv256hi_scalar */

    case 72:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9735; /* pred_dual_widen_subsv512hi_scalar */

    case 73:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9741; /* pred_dual_widen_subsv1024hi_scalar */

    case 74:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9747; /* pred_dual_widen_subsv2048hi_scalar */

    case 75:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9753; /* pred_dual_widen_subsv1si_scalar */

    case 76:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9759; /* pred_dual_widen_subsv2si_scalar */

    case 77:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9765; /* pred_dual_widen_subsv4si_scalar */

    case 78:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9771; /* pred_dual_widen_subsv8si_scalar */

    case 79:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9777; /* pred_dual_widen_subsv16si_scalar */

    case 80:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9783; /* pred_dual_widen_subsv32si_scalar */

    case 81:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9789; /* pred_dual_widen_subsv64si_scalar */

    case 82:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9795; /* pred_dual_widen_subsv128si_scalar */

    case 83:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9801; /* pred_dual_widen_subsv256si_scalar */

    case 84:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9807; /* pred_dual_widen_subsv512si_scalar */

    case 85:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9813; /* pred_dual_widen_subsv1024si_scalar */

    case 86:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9819; /* pred_dual_widen_subsv1di_scalar */

    case 87:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9825; /* pred_dual_widen_subsv2di_scalar */

    case 88:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9831; /* pred_dual_widen_subsv4di_scalar */

    case 89:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9837; /* pred_dual_widen_subsv8di_scalar */

    case 90:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9843; /* pred_dual_widen_subsv16di_scalar */

    case 91:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9849; /* pred_dual_widen_subsv32di_scalar */

    case 92:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9855; /* pred_dual_widen_subsv64di_scalar */

    case 93:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9861; /* pred_dual_widen_subsv128di_scalar */

    case 94:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9867; /* pred_dual_widen_subsv256di_scalar */

    case 95:
      if (!(
#line 4025 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9873; /* pred_dual_widen_subsv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_840 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V512DImode)
      && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 6641; /* pred_ashlv512di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 6854; /* pred_ashlv512di_scalar */
}

 int
recog_842 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V128DImode)
      && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 6607; /* pred_ashlv128di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 6848; /* pred_ashlv128di_scalar */
}

 int
recog_844 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V32DImode)
      && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 6573; /* pred_ashlv32di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 6842; /* pred_ashlv32di_scalar */
}

 int
recog_847 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V4DImode)
      && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 6522; /* pred_ashlv4di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 6833; /* pred_ashlv4di_scalar */
}

 int
recog_850 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V1024SImode)
      && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 6471; /* pred_ashlv1024si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 6824; /* pred_ashlv1024si_scalar */
}

 int
recog_853 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V128SImode, 
E_V128BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V128SImode)
      && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return 6420; /* pred_ashlv128si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 6815; /* pred_ashlv128si_scalar */
}

 int
recog_856 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V16SImode)
      && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 6369; /* pred_ashlv16si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 6806; /* pred_ashlv16si_scalar */
}

 int
recog_862 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V1024HImode)
      && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 6267; /* pred_ashlv1024hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 6788; /* pred_ashlv1024hi_scalar */
}

 int
recog_867 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V32HImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V32HImode)
      && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 6182; /* pred_ashlv32hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 6773; /* pred_ashlv32hi_scalar */
}

 int
recog_872 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern667 (x2, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V64SImode)
      && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 32767; /* pred_vwsllv64di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 32815; /* pred_vwsllv64di_scalar */
}

 int
recog_877 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern667 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V2SImode)
      && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 32762; /* pred_vwsllv2di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 32810; /* pred_vwsllv2di_scalar */
}

 int
recog_882 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern542 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[4], E_RVVM4QImode)
          && 
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10646; /* pred_narrow_lshrrvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10742; /* pred_narrow_lshrrvvm8hi_scalar */

    case 1:
      if (vector_shift_operand (operands[4], E_RVVM2QImode)
          && 
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10648; /* pred_narrow_lshrrvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10744; /* pred_narrow_lshrrvvm4hi_scalar */

    case 2:
      if (vector_shift_operand (operands[4], E_RVVM1QImode)
          && 
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10650; /* pred_narrow_lshrrvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10746; /* pred_narrow_lshrrvvm2hi_scalar */

    case 3:
      if (vector_shift_operand (operands[4], E_RVVMF2QImode)
          && 
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10652; /* pred_narrow_lshrrvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10748; /* pred_narrow_lshrrvvm1hi_scalar */

    case 4:
      if (vector_shift_operand (operands[4], E_RVVMF4QImode)
          && 
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10654; /* pred_narrow_lshrrvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10750; /* pred_narrow_lshrrvvmf2hi_scalar */

    case 5:
      if (vector_shift_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 10656; /* pred_narrow_lshrrvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 10752; /* pred_narrow_lshrrvvmf4hi_scalar */

    case 6:
      if (vector_shift_operand (operands[4], E_RVVM4HImode)
          && 
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10658; /* pred_narrow_lshrrvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10754; /* pred_narrow_lshrrvvm8si_scalar */

    case 7:
      if (vector_shift_operand (operands[4], E_RVVM2HImode)
          && 
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10660; /* pred_narrow_lshrrvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10756; /* pred_narrow_lshrrvvm4si_scalar */

    case 8:
      if (vector_shift_operand (operands[4], E_RVVM1HImode)
          && 
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10662; /* pred_narrow_lshrrvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10758; /* pred_narrow_lshrrvvm2si_scalar */

    case 9:
      if (vector_shift_operand (operands[4], E_RVVMF2HImode)
          && 
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10664; /* pred_narrow_lshrrvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10760; /* pred_narrow_lshrrvvm1si_scalar */

    case 10:
      if (vector_shift_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 10666; /* pred_narrow_lshrrvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 10762; /* pred_narrow_lshrrvvmf2si_scalar */

    case 11:
      if (vector_shift_operand (operands[4], E_RVVM4SImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 10668; /* pred_narrow_lshrrvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10764; /* pred_narrow_lshrrvvm8di_scalar */

    case 12:
      if (vector_shift_operand (operands[4], E_RVVM2SImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 10670; /* pred_narrow_lshrrvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10766; /* pred_narrow_lshrrvvm4di_scalar */

    case 13:
      if (vector_shift_operand (operands[4], E_RVVM1SImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 10672; /* pred_narrow_lshrrvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10768; /* pred_narrow_lshrrvvm2di_scalar */

    case 14:
      if (vector_shift_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 10674; /* pred_narrow_lshrrvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10770; /* pred_narrow_lshrrvvm1di_scalar */

    case 15:
      if (vector_shift_operand (operands[4], E_V1QImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 10676; /* pred_narrow_lshrv1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 10772; /* pred_narrow_lshrv1hi_scalar */

    case 16:
      if (vector_shift_operand (operands[4], E_V2QImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 10678; /* pred_narrow_lshrv2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 10774; /* pred_narrow_lshrv2hi_scalar */

    case 17:
      if (vector_shift_operand (operands[4], E_V4QImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 10680; /* pred_narrow_lshrv4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 10776; /* pred_narrow_lshrv4hi_scalar */

    case 18:
      if (vector_shift_operand (operands[4], E_V8QImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 10682; /* pred_narrow_lshrv8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 10778; /* pred_narrow_lshrv8hi_scalar */

    case 19:
      if (vector_shift_operand (operands[4], E_V16QImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 10684; /* pred_narrow_lshrv16hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 10780; /* pred_narrow_lshrv16hi_scalar */

    case 20:
      if (vector_shift_operand (operands[4], E_V32QImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 10686; /* pred_narrow_lshrv32hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10782; /* pred_narrow_lshrv32hi_scalar */

    case 21:
      if (vector_shift_operand (operands[4], E_V64QImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 10688; /* pred_narrow_lshrv64hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10784; /* pred_narrow_lshrv64hi_scalar */

    case 22:
      if (vector_shift_operand (operands[4], E_V128QImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 10690; /* pred_narrow_lshrv128hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10786; /* pred_narrow_lshrv128hi_scalar */

    case 23:
      if (vector_shift_operand (operands[4], E_V256QImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 10692; /* pred_narrow_lshrv256hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10788; /* pred_narrow_lshrv256hi_scalar */

    case 24:
      if (vector_shift_operand (operands[4], E_V512QImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 10694; /* pred_narrow_lshrv512hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10790; /* pred_narrow_lshrv512hi_scalar */

    case 25:
      if (vector_shift_operand (operands[4], E_V1024QImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 10696; /* pred_narrow_lshrv1024hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10792; /* pred_narrow_lshrv1024hi_scalar */

    case 26:
      if (vector_shift_operand (operands[4], E_V2048QImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 10698; /* pred_narrow_lshrv2048hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10794; /* pred_narrow_lshrv2048hi_scalar */

    case 27:
      if (vector_shift_operand (operands[4], E_V1HImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 10700; /* pred_narrow_lshrv1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 10796; /* pred_narrow_lshrv1si_scalar */

    case 28:
      if (vector_shift_operand (operands[4], E_V2HImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 10702; /* pred_narrow_lshrv2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 10798; /* pred_narrow_lshrv2si_scalar */

    case 29:
      if (vector_shift_operand (operands[4], E_V4HImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 10704; /* pred_narrow_lshrv4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 10800; /* pred_narrow_lshrv4si_scalar */

    case 30:
      if (vector_shift_operand (operands[4], E_V8HImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 10706; /* pred_narrow_lshrv8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 10802; /* pred_narrow_lshrv8si_scalar */

    case 31:
      if (vector_shift_operand (operands[4], E_V16HImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 10708; /* pred_narrow_lshrv16si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10804; /* pred_narrow_lshrv16si_scalar */

    case 32:
      if (vector_shift_operand (operands[4], E_V32HImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 10710; /* pred_narrow_lshrv32si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10806; /* pred_narrow_lshrv32si_scalar */

    case 33:
      if (vector_shift_operand (operands[4], E_V64HImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 10712; /* pred_narrow_lshrv64si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10808; /* pred_narrow_lshrv64si_scalar */

    case 34:
      if (vector_shift_operand (operands[4], E_V128HImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 10714; /* pred_narrow_lshrv128si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10810; /* pred_narrow_lshrv128si_scalar */

    case 35:
      if (vector_shift_operand (operands[4], E_V256HImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 10716; /* pred_narrow_lshrv256si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10812; /* pred_narrow_lshrv256si_scalar */

    case 36:
      if (vector_shift_operand (operands[4], E_V512HImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 10718; /* pred_narrow_lshrv512si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10814; /* pred_narrow_lshrv512si_scalar */

    case 37:
      if (vector_shift_operand (operands[4], E_V1024HImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 10720; /* pred_narrow_lshrv1024si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10816; /* pred_narrow_lshrv1024si_scalar */

    case 38:
      if (vector_shift_operand (operands[4], E_V1SImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 10722; /* pred_narrow_lshrv1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10818; /* pred_narrow_lshrv1di_scalar */

    case 39:
      if (vector_shift_operand (operands[4], E_V2SImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 10724; /* pred_narrow_lshrv2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10820; /* pred_narrow_lshrv2di_scalar */

    case 40:
      if (vector_shift_operand (operands[4], E_V4SImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 10726; /* pred_narrow_lshrv4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10822; /* pred_narrow_lshrv4di_scalar */

    case 41:
      if (vector_shift_operand (operands[4], E_V8SImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 10728; /* pred_narrow_lshrv8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10824; /* pred_narrow_lshrv8di_scalar */

    case 42:
      if (vector_shift_operand (operands[4], E_V16SImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 10730; /* pred_narrow_lshrv16di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10826; /* pred_narrow_lshrv16di_scalar */

    case 43:
      if (vector_shift_operand (operands[4], E_V32SImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 10732; /* pred_narrow_lshrv32di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10828; /* pred_narrow_lshrv32di_scalar */

    case 44:
      if (vector_shift_operand (operands[4], E_V64SImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 10734; /* pred_narrow_lshrv64di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10830; /* pred_narrow_lshrv64di_scalar */

    case 45:
      if (vector_shift_operand (operands[4], E_V128SImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 10736; /* pred_narrow_lshrv128di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10832; /* pred_narrow_lshrv128di_scalar */

    case 46:
      if (vector_shift_operand (operands[4], E_V256SImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 10738; /* pred_narrow_lshrv256di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10834; /* pred_narrow_lshrv256di_scalar */

    case 47:
      if (vector_shift_operand (operands[4], E_V512SImode)
          && (
#line 4238 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 10740; /* pred_narrow_lshrv512di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4260 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10836; /* pred_narrow_lshrv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_889 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  x11 = XEXP (x8, 0);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      operands[3] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern488 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM8QImode)
              && 
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return 5502; /* pred_ashlrvvm8qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 6653; /* pred_ashlrvvm8qi_scalar */

        case E_RVVM4QImode:
          if (pattern488 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM4QImode)
              && 
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return 5519; /* pred_ashlrvvm4qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 6656; /* pred_ashlrvvm4qi_scalar */

        case E_RVVM2QImode:
          if (pattern488 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM2QImode)
              && 
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return 5536; /* pred_ashlrvvm2qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 6659; /* pred_ashlrvvm2qi_scalar */

        case E_RVVM1QImode:
          if (pattern488 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM1QImode)
              && 
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return 5553; /* pred_ashlrvvm1qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 6662; /* pred_ashlrvvm1qi_scalar */

        case E_RVVM8HImode:
          if (pattern488 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM8HImode)
              && 
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return 5570; /* pred_ashlrvvm8hi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 6665; /* pred_ashlrvvm8hi_scalar */

        case E_RVVM4HImode:
          if (pattern488 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM4HImode)
              && 
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return 5587; /* pred_ashlrvvm4hi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 6668; /* pred_ashlrvvm4hi_scalar */

        case E_RVVM2HImode:
          if (pattern488 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM2HImode)
              && 
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return 5604; /* pred_ashlrvvm2hi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 6671; /* pred_ashlrvvm2hi_scalar */

        case E_RVVM1HImode:
          if (pattern488 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM1HImode)
              && 
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return 5621; /* pred_ashlrvvm1hi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 6674; /* pred_ashlrvvm1hi_scalar */

        case E_RVVM8SImode:
          if (pattern488 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM8SImode)
              && 
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return 5638; /* pred_ashlrvvm8si */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 6677; /* pred_ashlrvvm8si_scalar */

        case E_RVVM4SImode:
          if (pattern488 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM4SImode)
              && 
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return 5655; /* pred_ashlrvvm4si */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 6680; /* pred_ashlrvvm4si_scalar */

        case E_RVVM2SImode:
          if (pattern488 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM2SImode)
              && 
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return 5672; /* pred_ashlrvvm2si */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 6683; /* pred_ashlrvvm2si_scalar */

        case E_RVVM1SImode:
          if (pattern488 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM1SImode)
              && 
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return 5689; /* pred_ashlrvvm1si */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 6686; /* pred_ashlrvvm1si_scalar */

        case E_RVVM8DImode:
          if (pattern488 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM8DImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 5706; /* pred_ashlrvvm8di */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 6689; /* pred_ashlrvvm8di_scalar */

        case E_RVVM4DImode:
          if (pattern488 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM4DImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 5723; /* pred_ashlrvvm4di */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 6692; /* pred_ashlrvvm4di_scalar */

        case E_RVVM2DImode:
          if (pattern488 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM2DImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 5740; /* pred_ashlrvvm2di */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 6695; /* pred_ashlrvvm2di_scalar */

        case E_RVVM1DImode:
          if (pattern488 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVM1DImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 5757; /* pred_ashlrvvm1di */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 6698; /* pred_ashlrvvm1di_scalar */

        case E_RVVMF2QImode:
          if (pattern488 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVMF2QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 5774; /* pred_ashlrvvmf2qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 6701; /* pred_ashlrvvmf2qi_scalar */

        case E_RVVMF4QImode:
          if (pattern488 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVMF4QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 5791; /* pred_ashlrvvmf4qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 6704; /* pred_ashlrvvmf4qi_scalar */

        case E_RVVMF8QImode:
          if (pattern488 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVMF8QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 5808; /* pred_ashlrvvmf8qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 6707; /* pred_ashlrvvmf8qi_scalar */

        case E_RVVMF2HImode:
          if (pattern488 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVMF2HImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 5825; /* pred_ashlrvvmf2hi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 6710; /* pred_ashlrvvmf2hi_scalar */

        case E_RVVMF4HImode:
          if (pattern488 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVMF4HImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 5842; /* pred_ashlrvvmf4hi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 6713; /* pred_ashlrvvmf4hi_scalar */

        case E_RVVMF2SImode:
          if (pattern488 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_RVVMF2SImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 5859; /* pred_ashlrvvmf2si */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 6716; /* pred_ashlrvvmf2si_scalar */

        case E_V1QImode:
          if (pattern488 (x2, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V1QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return 5876; /* pred_ashlv1qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 6719; /* pred_ashlv1qi_scalar */

        case E_V2QImode:
          if (pattern488 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V2QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return 5893; /* pred_ashlv2qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 6722; /* pred_ashlv2qi_scalar */

        case E_V4QImode:
          if (pattern488 (x2, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V4QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return 5910; /* pred_ashlv4qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 6725; /* pred_ashlv4qi_scalar */

        case E_V8QImode:
          if (pattern488 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V8QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return 5927; /* pred_ashlv8qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 6728; /* pred_ashlv8qi_scalar */

        case E_V16QImode:
          if (pattern488 (x2, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V16QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return 5944; /* pred_ashlv16qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 6731; /* pred_ashlv16qi_scalar */

        case E_V32QImode:
          if (pattern488 (x2, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V32QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return 5961; /* pred_ashlv32qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 6734; /* pred_ashlv32qi_scalar */

        case E_V64QImode:
          if (pattern488 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V64QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return 5978; /* pred_ashlv64qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 6737; /* pred_ashlv64qi_scalar */

        case E_V128QImode:
          if (pattern488 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V128QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return 5995; /* pred_ashlv128qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 6740; /* pred_ashlv128qi_scalar */

        case E_V256QImode:
          if (pattern488 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V256QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return 6012; /* pred_ashlv256qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 6743; /* pred_ashlv256qi_scalar */

        case E_V512QImode:
          if (pattern488 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V512QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return 6029; /* pred_ashlv512qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 6746; /* pred_ashlv512qi_scalar */

        case E_V1024QImode:
          if (pattern488 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V1024QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return 6046; /* pred_ashlv1024qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 6749; /* pred_ashlv1024qi_scalar */

        case E_V2048QImode:
          if (pattern488 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V2048QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return 6063; /* pred_ashlv2048qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 6752; /* pred_ashlv2048qi_scalar */

        case E_V4096QImode:
          if (pattern488 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V4096QImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return 6080; /* pred_ashlv4096qi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 6755; /* pred_ashlv4096qi_scalar */

        case E_V1HImode:
          if (pattern488 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V1HImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return 6097; /* pred_ashlv1hi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 6758; /* pred_ashlv1hi_scalar */

        case E_V2HImode:
          if (pattern488 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V2HImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return 6114; /* pred_ashlv2hi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 6761; /* pred_ashlv2hi_scalar */

        case E_V4HImode:
          if (pattern488 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V4HImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return 6131; /* pred_ashlv4hi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 6764; /* pred_ashlv4hi_scalar */

        case E_V8HImode:
          if (pattern488 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          if (vector_shift_operand (operands[4], E_V8HImode)
              && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return 6148; /* pred_ashlv8hi */
          if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
              || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 6767; /* pred_ashlv8hi_scalar */

        case E_V16HImode:
          return recog_868 (x1, insn, pnum_clobbers);

        case E_V32HImode:
          return recog_867 (x1, insn, pnum_clobbers);

        case E_V64HImode:
          return recog_866 (x1, insn, pnum_clobbers);

        case E_V128HImode:
          return recog_865 (x1, insn, pnum_clobbers);

        case E_V256HImode:
          return recog_864 (x1, insn, pnum_clobbers);

        case E_V512HImode:
          return recog_863 (x1, insn, pnum_clobbers);

        case E_V1024HImode:
          return recog_862 (x1, insn, pnum_clobbers);

        case E_V2048HImode:
          return recog_861 (x1, insn, pnum_clobbers);

        case E_V1SImode:
          return recog_860 (x1, insn, pnum_clobbers);

        case E_V2SImode:
          return recog_859 (x1, insn, pnum_clobbers);

        case E_V4SImode:
          return recog_858 (x1, insn, pnum_clobbers);

        case E_V8SImode:
          return recog_857 (x1, insn, pnum_clobbers);

        case E_V16SImode:
          return recog_856 (x1, insn, pnum_clobbers);

        case E_V32SImode:
          return recog_855 (x1, insn, pnum_clobbers);

        case E_V64SImode:
          return recog_854 (x1, insn, pnum_clobbers);

        case E_V128SImode:
          return recog_853 (x1, insn, pnum_clobbers);

        case E_V256SImode:
          return recog_852 (x1, insn, pnum_clobbers);

        case E_V512SImode:
          return recog_851 (x1, insn, pnum_clobbers);

        case E_V1024SImode:
          return recog_850 (x1, insn, pnum_clobbers);

        case E_V1DImode:
          return recog_849 (x1, insn, pnum_clobbers);

        case E_V2DImode:
          return recog_848 (x1, insn, pnum_clobbers);

        case E_V4DImode:
          return recog_847 (x1, insn, pnum_clobbers);

        case E_V8DImode:
          return recog_846 (x1, insn, pnum_clobbers);

        case E_V16DImode:
          return recog_845 (x1, insn, pnum_clobbers);

        case E_V32DImode:
          return recog_844 (x1, insn, pnum_clobbers);

        case E_V64DImode:
          return recog_843 (x1, insn, pnum_clobbers);

        case E_V128DImode:
          return recog_842 (x1, insn, pnum_clobbers);

        case E_V256DImode:
          return recog_841 (x1, insn, pnum_clobbers);

        case E_V512DImode:
          return recog_840 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_878 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_894 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x8, 1);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern488 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM8QImode)
              && 
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return 32614; /* pred_vrotrrvvm8qi */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32658; /* pred_vrotrrvvm8qi_scalar */

        case E_RVVM4QImode:
          if (pattern488 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM4QImode)
              && 
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return 32616; /* pred_vrotrrvvm4qi */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32660; /* pred_vrotrrvvm4qi_scalar */

        case E_RVVM2QImode:
          if (pattern488 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM2QImode)
              && 
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return 32618; /* pred_vrotrrvvm2qi */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32662; /* pred_vrotrrvvm2qi_scalar */

        case E_RVVM1QImode:
          if (pattern488 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM1QImode)
              && 
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return 32620; /* pred_vrotrrvvm1qi */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32664; /* pred_vrotrrvvm1qi_scalar */

        case E_RVVM8HImode:
          if (pattern488 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM8HImode)
              && 
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return 32622; /* pred_vrotrrvvm8hi */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32666; /* pred_vrotrrvvm8hi_scalar */

        case E_RVVM4HImode:
          if (pattern488 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM4HImode)
              && 
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return 32624; /* pred_vrotrrvvm4hi */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32668; /* pred_vrotrrvvm4hi_scalar */

        case E_RVVM2HImode:
          if (pattern488 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM2HImode)
              && 
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return 32626; /* pred_vrotrrvvm2hi */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32670; /* pred_vrotrrvvm2hi_scalar */

        case E_RVVM1HImode:
          if (pattern488 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM1HImode)
              && 
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return 32628; /* pred_vrotrrvvm1hi */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32672; /* pred_vrotrrvvm1hi_scalar */

        case E_RVVM8SImode:
          if (pattern488 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM8SImode)
              && 
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return 32630; /* pred_vrotrrvvm8si */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32674; /* pred_vrotrrvvm8si_scalar */

        case E_RVVM4SImode:
          if (pattern488 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM4SImode)
              && 
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return 32632; /* pred_vrotrrvvm4si */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32676; /* pred_vrotrrvvm4si_scalar */

        case E_RVVM2SImode:
          if (pattern488 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM2SImode)
              && 
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return 32634; /* pred_vrotrrvvm2si */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32678; /* pred_vrotrrvvm2si_scalar */

        case E_RVVM1SImode:
          if (pattern488 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM1SImode)
              && 
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return 32636; /* pred_vrotrrvvm1si */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32680; /* pred_vrotrrvvm1si_scalar */

        case E_RVVM8DImode:
          if (pattern488 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM8DImode)
              && (
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 32638; /* pred_vrotrrvvm8di */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !(
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32682; /* pred_vrotrrvvm8di_scalar */

        case E_RVVM4DImode:
          if (pattern488 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM4DImode)
              && (
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 32640; /* pred_vrotrrvvm4di */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !(
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32684; /* pred_vrotrrvvm4di_scalar */

        case E_RVVM2DImode:
          if (pattern488 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM2DImode)
              && (
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 32642; /* pred_vrotrrvvm2di */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !(
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32686; /* pred_vrotrrvvm2di_scalar */

        case E_RVVM1DImode:
          if (pattern488 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVM1DImode)
              && (
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 32644; /* pred_vrotrrvvm1di */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !(
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32688; /* pred_vrotrrvvm1di_scalar */

        case E_RVVMF2QImode:
          if (pattern488 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVMF2QImode)
              && (
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 32646; /* pred_vrotrrvvmf2qi */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !(
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32690; /* pred_vrotrrvvmf2qi_scalar */

        case E_RVVMF4QImode:
          if (pattern488 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVMF4QImode)
              && (
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 32648; /* pred_vrotrrvvmf4qi */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !(
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32692; /* pred_vrotrrvvmf4qi_scalar */

        case E_RVVMF8QImode:
          if (pattern488 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVMF8QImode)
              && (
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 32650; /* pred_vrotrrvvmf8qi */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !(
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32694; /* pred_vrotrrvvmf8qi_scalar */

        case E_RVVMF2HImode:
          if (pattern488 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVMF2HImode)
              && (
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 32652; /* pred_vrotrrvvmf2hi */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !(
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32696; /* pred_vrotrrvvmf2hi_scalar */

        case E_RVVMF4HImode:
          if (pattern488 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVMF4HImode)
              && (
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 32654; /* pred_vrotrrvvmf4hi */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !(
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32698; /* pred_vrotrrvvmf4hi_scalar */

        case E_RVVMF2SImode:
          if (pattern488 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          if (register_operand (operands[4], E_RVVMF2SImode)
              && (
#line 240 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 32656; /* pred_vrotrrvvmf2si */
          if (!pmode_register_operand (operands[4], E_VOIDmode)
              || !(
#line 260 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32700; /* pred_vrotrrvvmf2si_scalar */

        default:
          return -1;
        }

    case CONST_INT:
      if (!const_csr_operand (operands[4], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern488 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
              || !
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32701; /* *pred_vrorrvvm8qi_scalar */

        case E_RVVM4QImode:
          if (pattern488 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
              || !
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32702; /* *pred_vrorrvvm4qi_scalar */

        case E_RVVM2QImode:
          if (pattern488 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
              || !
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32703; /* *pred_vrorrvvm2qi_scalar */

        case E_RVVM1QImode:
          if (pattern488 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
              || !
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32704; /* *pred_vrorrvvm1qi_scalar */

        case E_RVVM8HImode:
          if (pattern488 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
              || !
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32705; /* *pred_vrorrvvm8hi_scalar */

        case E_RVVM4HImode:
          if (pattern488 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
              || !
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32706; /* *pred_vrorrvvm4hi_scalar */

        case E_RVVM2HImode:
          if (pattern488 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
              || !
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32707; /* *pred_vrorrvvm2hi_scalar */

        case E_RVVM1HImode:
          if (pattern488 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
              || !
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32708; /* *pred_vrorrvvm1hi_scalar */

        case E_RVVM8SImode:
          if (pattern488 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32709; /* *pred_vrorrvvm8si_scalar */

        case E_RVVM4SImode:
          if (pattern488 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32710; /* *pred_vrorrvvm4si_scalar */

        case E_RVVM2SImode:
          if (pattern488 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32711; /* *pred_vrorrvvm2si_scalar */

        case E_RVVM1SImode:
          if (pattern488 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32712; /* *pred_vrorrvvm1si_scalar */

        case E_RVVM8DImode:
          if (pattern488 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32713; /* *pred_vrorrvvm8di_scalar */

        case E_RVVM4DImode:
          if (pattern488 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32714; /* *pred_vrorrvvm4di_scalar */

        case E_RVVM2DImode:
          if (pattern488 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32715; /* *pred_vrorrvvm2di_scalar */

        case E_RVVM1DImode:
          if (pattern488 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32716; /* *pred_vrorrvvm1di_scalar */

        case E_RVVMF2QImode:
          if (pattern488 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
              || !(
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32717; /* *pred_vrorrvvmf2qi_scalar */

        case E_RVVMF4QImode:
          if (pattern488 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
              || !(
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32718; /* *pred_vrorrvvmf4qi_scalar */

        case E_RVVMF8QImode:
          if (pattern488 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
              || !(
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32719; /* *pred_vrorrvvmf8qi_scalar */

        case E_RVVMF2HImode:
          if (pattern488 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
              || !(
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32720; /* *pred_vrorrvvmf2hi_scalar */

        case E_RVVMF4HImode:
          if (pattern488 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
              || !(
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32721; /* *pred_vrorrvvmf4hi_scalar */

        case E_RVVMF2SImode:
          if (pattern488 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 280 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32722; /* *pred_vrorrvvmf2si_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_899 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern498 (x2))
    {
    case 0:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5510; /* pred_divrvvm8qi */

    case 1:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5527; /* pred_divrvvm4qi */

    case 2:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5544; /* pred_divrvvm2qi */

    case 3:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5561; /* pred_divrvvm1qi */

    case 4:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5578; /* pred_divrvvm8hi */

    case 5:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5595; /* pred_divrvvm4hi */

    case 6:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5612; /* pred_divrvvm2hi */

    case 7:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5629; /* pred_divrvvm1hi */

    case 8:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5646; /* pred_divrvvm8si */

    case 9:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5663; /* pred_divrvvm4si */

    case 10:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5680; /* pred_divrvvm2si */

    case 11:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5697; /* pred_divrvvm1si */

    case 12:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5714; /* pred_divrvvm8di */

    case 13:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5731; /* pred_divrvvm4di */

    case 14:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5748; /* pred_divrvvm2di */

    case 15:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5765; /* pred_divrvvm1di */

    case 16:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5782; /* pred_divrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5799; /* pred_divrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5816; /* pred_divrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5833; /* pred_divrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5850; /* pred_divrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5867; /* pred_divrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5884; /* pred_divv1qi */

    case 23:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5901; /* pred_divv2qi */

    case 24:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5918; /* pred_divv4qi */

    case 25:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5935; /* pred_divv8qi */

    case 26:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5952; /* pred_divv16qi */

    case 27:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5969; /* pred_divv32qi */

    case 28:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5986; /* pred_divv64qi */

    case 29:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6003; /* pred_divv128qi */

    case 30:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6020; /* pred_divv256qi */

    case 31:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6037; /* pred_divv512qi */

    case 32:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6054; /* pred_divv1024qi */

    case 33:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6071; /* pred_divv2048qi */

    case 34:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6088; /* pred_divv4096qi */

    case 35:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6105; /* pred_divv1hi */

    case 36:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6122; /* pred_divv2hi */

    case 37:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6139; /* pred_divv4hi */

    case 38:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6156; /* pred_divv8hi */

    case 39:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6173; /* pred_divv16hi */

    case 40:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6190; /* pred_divv32hi */

    case 41:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6207; /* pred_divv64hi */

    case 42:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6224; /* pred_divv128hi */

    case 43:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6241; /* pred_divv256hi */

    case 44:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6258; /* pred_divv512hi */

    case 45:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6275; /* pred_divv1024hi */

    case 46:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6292; /* pred_divv2048hi */

    case 47:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6309; /* pred_divv1si */

    case 48:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6326; /* pred_divv2si */

    case 49:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6343; /* pred_divv4si */

    case 50:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6360; /* pred_divv8si */

    case 51:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6377; /* pred_divv16si */

    case 52:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6394; /* pred_divv32si */

    case 53:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6411; /* pred_divv64si */

    case 54:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6428; /* pred_divv128si */

    case 55:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6445; /* pred_divv256si */

    case 56:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6462; /* pred_divv512si */

    case 57:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6479; /* pred_divv1024si */

    case 58:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6496; /* pred_divv1di */

    case 59:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6513; /* pred_divv2di */

    case 60:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6530; /* pred_divv4di */

    case 61:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6547; /* pred_divv8di */

    case 62:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6564; /* pred_divv16di */

    case 63:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6581; /* pred_divv32di */

    case 64:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6598; /* pred_divv64di */

    case 65:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6615; /* pred_divv128di */

    case 66:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6632; /* pred_divv256di */

    case 67:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6649; /* pred_divv512di */

    case 68:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7344; /* pred_divrvvm8qi_scalar */

    case 69:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7349; /* pred_divrvvm4qi_scalar */

    case 70:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7354; /* pred_divrvvm2qi_scalar */

    case 71:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7359; /* pred_divrvvm1qi_scalar */

    case 72:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7364; /* pred_divrvvmf2qi_scalar */

    case 73:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7369; /* pred_divrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7374; /* pred_divrvvmf8qi_scalar */

    case 75:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7379; /* pred_divrvvm8hi_scalar */

    case 76:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7384; /* pred_divrvvm4hi_scalar */

    case 77:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7389; /* pred_divrvvm2hi_scalar */

    case 78:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7394; /* pred_divrvvm1hi_scalar */

    case 79:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7399; /* pred_divrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7404; /* pred_divrvvmf4hi_scalar */

    case 81:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7409; /* pred_divrvvm8si_scalar */

    case 82:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7414; /* pred_divrvvm4si_scalar */

    case 83:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7419; /* pred_divrvvm2si_scalar */

    case 84:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7424; /* pred_divrvvm1si_scalar */

    case 85:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7429; /* pred_divrvvmf2si_scalar */

    case 86:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7434; /* pred_divv1qi_scalar */

    case 87:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7439; /* pred_divv2qi_scalar */

    case 88:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7444; /* pred_divv4qi_scalar */

    case 89:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7449; /* pred_divv8qi_scalar */

    case 90:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7454; /* pred_divv16qi_scalar */

    case 91:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7459; /* pred_divv32qi_scalar */

    case 92:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7464; /* pred_divv64qi_scalar */

    case 93:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7469; /* pred_divv128qi_scalar */

    case 94:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7474; /* pred_divv256qi_scalar */

    case 95:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7479; /* pred_divv512qi_scalar */

    case 96:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7484; /* pred_divv1024qi_scalar */

    case 97:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7489; /* pred_divv2048qi_scalar */

    case 98:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7494; /* pred_divv4096qi_scalar */

    case 99:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7499; /* pred_divv1hi_scalar */

    case 100:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7504; /* pred_divv2hi_scalar */

    case 101:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7509; /* pred_divv4hi_scalar */

    case 102:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7514; /* pred_divv8hi_scalar */

    case 103:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7519; /* pred_divv16hi_scalar */

    case 104:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7524; /* pred_divv32hi_scalar */

    case 105:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7529; /* pred_divv64hi_scalar */

    case 106:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7534; /* pred_divv128hi_scalar */

    case 107:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7539; /* pred_divv256hi_scalar */

    case 108:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7544; /* pred_divv512hi_scalar */

    case 109:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7549; /* pred_divv1024hi_scalar */

    case 110:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7554; /* pred_divv2048hi_scalar */

    case 111:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7559; /* pred_divv1si_scalar */

    case 112:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7564; /* pred_divv2si_scalar */

    case 113:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7569; /* pred_divv4si_scalar */

    case 114:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7574; /* pred_divv8si_scalar */

    case 115:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7579; /* pred_divv16si_scalar */

    case 116:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7584; /* pred_divv32si_scalar */

    case 117:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7589; /* pred_divv64si_scalar */

    case 118:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7594; /* pred_divv128si_scalar */

    case 119:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7599; /* pred_divv256si_scalar */

    case 120:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7604; /* pred_divv512si_scalar */

    case 121:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7609; /* pred_divv1024si_scalar */

    case 122:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7920; /* *pred_divrvvm8di_scalar */

    case 123:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7925; /* *pred_divrvvm4di_scalar */

    case 124:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7930; /* *pred_divrvvm2di_scalar */

    case 125:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7935; /* *pred_divrvvm1di_scalar */

    case 126:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7940; /* *pred_divv1di_scalar */

    case 127:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7945; /* *pred_divv2di_scalar */

    case 128:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7950; /* *pred_divv4di_scalar */

    case 129:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7955; /* *pred_divv8di_scalar */

    case 130:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7960; /* *pred_divv16di_scalar */

    case 131:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7965; /* *pred_divv32di_scalar */

    case 132:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7970; /* *pred_divv64di_scalar */

    case 133:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7975; /* *pred_divv128di_scalar */

    case 134:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7980; /* *pred_divv256di_scalar */

    case 135:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7985; /* *pred_divv512di_scalar */

    case 136:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7990; /* *pred_divrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7995; /* *pred_divrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8000; /* *pred_divrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8005; /* *pred_divrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8010; /* *pred_divv1di_extended_scalar */

    case 141:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8015; /* *pred_divv2di_extended_scalar */

    case 142:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8020; /* *pred_divv4di_extended_scalar */

    case 143:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8025; /* *pred_divv8di_extended_scalar */

    case 144:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8030; /* *pred_divv16di_extended_scalar */

    case 145:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8035; /* *pred_divv32di_extended_scalar */

    case 146:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8040; /* *pred_divv64di_extended_scalar */

    case 147:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8045; /* *pred_divv128di_extended_scalar */

    case 148:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8050; /* *pred_divv256di_extended_scalar */

    case 149:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8055; /* *pred_divv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_909 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern501 (x2))
    {
    case 0:
      if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10885; /* pred_ssaddrvvm8qi */

    case 1:
      if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10889; /* pred_ssaddrvvm4qi */

    case 2:
      if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10893; /* pred_ssaddrvvm2qi */

    case 3:
      if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10897; /* pred_ssaddrvvm1qi */

    case 4:
      if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10901; /* pred_ssaddrvvm8hi */

    case 5:
      if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10905; /* pred_ssaddrvvm4hi */

    case 6:
      if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10909; /* pred_ssaddrvvm2hi */

    case 7:
      if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10913; /* pred_ssaddrvvm1hi */

    case 8:
      if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10917; /* pred_ssaddrvvm8si */

    case 9:
      if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10921; /* pred_ssaddrvvm4si */

    case 10:
      if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10925; /* pred_ssaddrvvm2si */

    case 11:
      if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10929; /* pred_ssaddrvvm1si */

    case 12:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10933; /* pred_ssaddrvvm8di */

    case 13:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10937; /* pred_ssaddrvvm4di */

    case 14:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10941; /* pred_ssaddrvvm2di */

    case 15:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10945; /* pred_ssaddrvvm1di */

    case 16:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10949; /* pred_ssaddrvvmf2qi */

    case 17:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10953; /* pred_ssaddrvvmf4qi */

    case 18:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10957; /* pred_ssaddrvvmf8qi */

    case 19:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10961; /* pred_ssaddrvvmf2hi */

    case 20:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10965; /* pred_ssaddrvvmf4hi */

    case 21:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10969; /* pred_ssaddrvvmf2si */

    case 22:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 10973; /* pred_ssaddv1qi */

    case 23:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 10977; /* pred_ssaddv2qi */

    case 24:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 10981; /* pred_ssaddv4qi */

    case 25:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 10985; /* pred_ssaddv8qi */

    case 26:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 10989; /* pred_ssaddv16qi */

    case 27:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 10993; /* pred_ssaddv32qi */

    case 28:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10997; /* pred_ssaddv64qi */

    case 29:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11001; /* pred_ssaddv128qi */

    case 30:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11005; /* pred_ssaddv256qi */

    case 31:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11009; /* pred_ssaddv512qi */

    case 32:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11013; /* pred_ssaddv1024qi */

    case 33:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11017; /* pred_ssaddv2048qi */

    case 34:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11021; /* pred_ssaddv4096qi */

    case 35:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 11025; /* pred_ssaddv1hi */

    case 36:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 11029; /* pred_ssaddv2hi */

    case 37:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 11033; /* pred_ssaddv4hi */

    case 38:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 11037; /* pred_ssaddv8hi */

    case 39:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 11041; /* pred_ssaddv16hi */

    case 40:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11045; /* pred_ssaddv32hi */

    case 41:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11049; /* pred_ssaddv64hi */

    case 42:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11053; /* pred_ssaddv128hi */

    case 43:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11057; /* pred_ssaddv256hi */

    case 44:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11061; /* pred_ssaddv512hi */

    case 45:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11065; /* pred_ssaddv1024hi */

    case 46:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11069; /* pred_ssaddv2048hi */

    case 47:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 11073; /* pred_ssaddv1si */

    case 48:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 11077; /* pred_ssaddv2si */

    case 49:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 11081; /* pred_ssaddv4si */

    case 50:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 11085; /* pred_ssaddv8si */

    case 51:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11089; /* pred_ssaddv16si */

    case 52:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11093; /* pred_ssaddv32si */

    case 53:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11097; /* pred_ssaddv64si */

    case 54:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11101; /* pred_ssaddv128si */

    case 55:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11105; /* pred_ssaddv256si */

    case 56:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11109; /* pred_ssaddv512si */

    case 57:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11113; /* pred_ssaddv1024si */

    case 58:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11117; /* pred_ssaddv1di */

    case 59:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11121; /* pred_ssaddv2di */

    case 60:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11125; /* pred_ssaddv4di */

    case 61:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11129; /* pred_ssaddv8di */

    case 62:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11133; /* pred_ssaddv16di */

    case 63:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11137; /* pred_ssaddv32di */

    case 64:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11141; /* pred_ssaddv64di */

    case 65:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11145; /* pred_ssaddv128di */

    case 66:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11149; /* pred_ssaddv256di */

    case 67:
      if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11153; /* pred_ssaddv512di */

    case 68:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11157; /* pred_ssaddrvvm8qi_scalar */

    case 69:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11159; /* pred_ssaddrvvm4qi_scalar */

    case 70:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11161; /* pred_ssaddrvvm2qi_scalar */

    case 71:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11163; /* pred_ssaddrvvm1qi_scalar */

    case 72:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11165; /* pred_ssaddrvvmf2qi_scalar */

    case 73:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11167; /* pred_ssaddrvvmf4qi_scalar */

    case 74:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11169; /* pred_ssaddrvvmf8qi_scalar */

    case 75:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11171; /* pred_ssaddrvvm8hi_scalar */

    case 76:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11173; /* pred_ssaddrvvm4hi_scalar */

    case 77:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11175; /* pred_ssaddrvvm2hi_scalar */

    case 78:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11177; /* pred_ssaddrvvm1hi_scalar */

    case 79:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11179; /* pred_ssaddrvvmf2hi_scalar */

    case 80:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11181; /* pred_ssaddrvvmf4hi_scalar */

    case 81:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11183; /* pred_ssaddrvvm8si_scalar */

    case 82:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11185; /* pred_ssaddrvvm4si_scalar */

    case 83:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11187; /* pred_ssaddrvvm2si_scalar */

    case 84:
      if (!
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11189; /* pred_ssaddrvvm1si_scalar */

    case 85:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11191; /* pred_ssaddrvvmf2si_scalar */

    case 86:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11193; /* pred_ssaddv1qi_scalar */

    case 87:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11195; /* pred_ssaddv2qi_scalar */

    case 88:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11197; /* pred_ssaddv4qi_scalar */

    case 89:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11199; /* pred_ssaddv8qi_scalar */

    case 90:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11201; /* pred_ssaddv16qi_scalar */

    case 91:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 11203; /* pred_ssaddv32qi_scalar */

    case 92:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11205; /* pred_ssaddv64qi_scalar */

    case 93:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11207; /* pred_ssaddv128qi_scalar */

    case 94:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11209; /* pred_ssaddv256qi_scalar */

    case 95:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11211; /* pred_ssaddv512qi_scalar */

    case 96:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11213; /* pred_ssaddv1024qi_scalar */

    case 97:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11215; /* pred_ssaddv2048qi_scalar */

    case 98:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11217; /* pred_ssaddv4096qi_scalar */

    case 99:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 11219; /* pred_ssaddv1hi_scalar */

    case 100:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 11221; /* pred_ssaddv2hi_scalar */

    case 101:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 11223; /* pred_ssaddv4hi_scalar */

    case 102:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 11225; /* pred_ssaddv8hi_scalar */

    case 103:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 11227; /* pred_ssaddv16hi_scalar */

    case 104:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11229; /* pred_ssaddv32hi_scalar */

    case 105:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11231; /* pred_ssaddv64hi_scalar */

    case 106:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11233; /* pred_ssaddv128hi_scalar */

    case 107:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11235; /* pred_ssaddv256hi_scalar */

    case 108:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11237; /* pred_ssaddv512hi_scalar */

    case 109:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11239; /* pred_ssaddv1024hi_scalar */

    case 110:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11241; /* pred_ssaddv2048hi_scalar */

    case 111:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 11243; /* pred_ssaddv1si_scalar */

    case 112:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 11245; /* pred_ssaddv2si_scalar */

    case 113:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 11247; /* pred_ssaddv4si_scalar */

    case 114:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 11249; /* pred_ssaddv8si_scalar */

    case 115:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11251; /* pred_ssaddv16si_scalar */

    case 116:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11253; /* pred_ssaddv32si_scalar */

    case 117:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11255; /* pred_ssaddv64si_scalar */

    case 118:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11257; /* pred_ssaddv128si_scalar */

    case 119:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11259; /* pred_ssaddv256si_scalar */

    case 120:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11261; /* pred_ssaddv512si_scalar */

    case 121:
      if (!(
#line 4348 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11263; /* pred_ssaddv1024si_scalar */

    case 122:
      if (!(
#line 4423 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11373; /* *pred_ssaddrvvm8di_scalar */

    case 123:
      if (!(
#line 4423 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11375; /* *pred_ssaddrvvm4di_scalar */

    case 124:
      if (!(
#line 4423 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11377; /* *pred_ssaddrvvm2di_scalar */

    case 125:
      if (!(
#line 4423 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11379; /* *pred_ssaddrvvm1di_scalar */

    case 126:
      if (!(
#line 4445 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11381; /* *pred_ssaddrvvm8di_extended_scalar */

    case 127:
      if (!(
#line 4445 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11383; /* *pred_ssaddrvvm4di_extended_scalar */

    case 128:
      if (!(
#line 4445 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11385; /* *pred_ssaddrvvm2di_extended_scalar */

    case 129:
      if (!(
#line 4445 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11387; /* *pred_ssaddrvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_922 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern469 (x2))
    {
    case 0:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 1254; /* *pred_mov_widthhurvvm8qi */

    case 1:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 1260; /* *pred_mov_widthhurvvm4qi */

    case 2:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 1266; /* *pred_mov_widthhurvvm2qi */

    case 3:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 1272; /* *pred_mov_widthhurvvm1qi */

    case 4:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 1278; /* *pred_mov_widthhurvvm8hi */

    case 5:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 1284; /* *pred_mov_widthhurvvm4hi */

    case 6:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 1290; /* *pred_mov_widthhurvvm2hi */

    case 7:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 1296; /* *pred_mov_widthhurvvm1hi */

    case 8:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 1302; /* *pred_mov_widthhurvvm8si */

    case 9:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 1308; /* *pred_mov_widthhurvvm4si */

    case 10:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 1314; /* *pred_mov_widthhurvvm2si */

    case 11:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 1320; /* *pred_mov_widthhurvvm1si */

    case 12:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1326; /* *pred_mov_widthhurvvm8di */

    case 13:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1332; /* *pred_mov_widthhurvvm4di */

    case 14:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1338; /* *pred_mov_widthhurvvm2di */

    case 15:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1344; /* *pred_mov_widthhurvvm1di */

    case 16:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1350; /* *pred_mov_widthhurvvmf2qi */

    case 17:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1356; /* *pred_mov_widthhurvvmf4qi */

    case 18:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1362; /* *pred_mov_widthhurvvmf8qi */

    case 19:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1368; /* *pred_mov_widthhurvvmf2hi */

    case 20:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1374; /* *pred_mov_widthhurvvmf4hi */

    case 21:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1380; /* *pred_mov_widthhurvvmf2si */

    case 22:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1386; /* *pred_mov_widthhurvvm8bf */

    case 23:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1392; /* *pred_mov_widthhurvvm4bf */

    case 24:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1398; /* *pred_mov_widthhurvvm2bf */

    case 25:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1404; /* *pred_mov_widthhurvvm1bf */

    case 26:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1410; /* *pred_mov_widthhurvvmf2bf */

    case 27:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1416; /* *pred_mov_widthhurvvmf4bf */

    case 28:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1422; /* *pred_mov_widthhurvvm8hf */

    case 29:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1428; /* *pred_mov_widthhurvvm4hf */

    case 30:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1434; /* *pred_mov_widthhurvvm2hf */

    case 31:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1440; /* *pred_mov_widthhurvvm1hf */

    case 32:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1446; /* *pred_mov_widthhurvvmf2hf */

    case 33:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1452; /* *pred_mov_widthhurvvmf4hf */

    case 34:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1458; /* *pred_mov_widthhurvvm8sf */

    case 35:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1464; /* *pred_mov_widthhurvvm4sf */

    case 36:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1470; /* *pred_mov_widthhurvvm2sf */

    case 37:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1476; /* *pred_mov_widthhurvvm1sf */

    case 38:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1482; /* *pred_mov_widthhurvvmf2sf */

    case 39:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1488; /* *pred_mov_widthhurvvm8df */

    case 40:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1494; /* *pred_mov_widthhurvvm4df */

    case 41:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1500; /* *pred_mov_widthhurvvm2df */

    case 42:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1506; /* *pred_mov_widthhurvvm1df */

    case 43:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 1512; /* *pred_mov_widthhuv1qi */

    case 44:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 1518; /* *pred_mov_widthhuv2qi */

    case 45:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 1524; /* *pred_mov_widthhuv4qi */

    case 46:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 1530; /* *pred_mov_widthhuv8qi */

    case 47:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 1536; /* *pred_mov_widthhuv16qi */

    case 48:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 1542; /* *pred_mov_widthhuv32qi */

    case 49:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1548; /* *pred_mov_widthhuv64qi */

    case 50:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1554; /* *pred_mov_widthhuv128qi */

    case 51:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1560; /* *pred_mov_widthhuv256qi */

    case 52:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1566; /* *pred_mov_widthhuv512qi */

    case 53:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1572; /* *pred_mov_widthhuv1024qi */

    case 54:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1578; /* *pred_mov_widthhuv2048qi */

    case 55:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1584; /* *pred_mov_widthhuv4096qi */

    case 56:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 1590; /* *pred_mov_widthhuv1hi */

    case 57:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 1596; /* *pred_mov_widthhuv2hi */

    case 58:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 1602; /* *pred_mov_widthhuv4hi */

    case 59:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 1608; /* *pred_mov_widthhuv8hi */

    case 60:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 1614; /* *pred_mov_widthhuv16hi */

    case 61:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1620; /* *pred_mov_widthhuv32hi */

    case 62:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1626; /* *pred_mov_widthhuv64hi */

    case 63:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1632; /* *pred_mov_widthhuv128hi */

    case 64:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1638; /* *pred_mov_widthhuv256hi */

    case 65:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1644; /* *pred_mov_widthhuv512hi */

    case 66:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1650; /* *pred_mov_widthhuv1024hi */

    case 67:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1656; /* *pred_mov_widthhuv2048hi */

    case 68:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1662; /* *pred_mov_widthhuv1si */

    case 69:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1668; /* *pred_mov_widthhuv2si */

    case 70:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1674; /* *pred_mov_widthhuv4si */

    case 71:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1680; /* *pred_mov_widthhuv8si */

    case 72:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1686; /* *pred_mov_widthhuv16si */

    case 73:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1692; /* *pred_mov_widthhuv32si */

    case 74:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1698; /* *pred_mov_widthhuv64si */

    case 75:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1704; /* *pred_mov_widthhuv128si */

    case 76:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1710; /* *pred_mov_widthhuv256si */

    case 77:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1716; /* *pred_mov_widthhuv512si */

    case 78:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1722; /* *pred_mov_widthhuv1024si */

    case 79:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1728; /* *pred_mov_widthhuv1di */

    case 80:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1734; /* *pred_mov_widthhuv2di */

    case 81:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1740; /* *pred_mov_widthhuv4di */

    case 82:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1746; /* *pred_mov_widthhuv8di */

    case 83:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1752; /* *pred_mov_widthhuv16di */

    case 84:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1758; /* *pred_mov_widthhuv32di */

    case 85:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1764; /* *pred_mov_widthhuv64di */

    case 86:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1770; /* *pred_mov_widthhuv128di */

    case 87:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1776; /* *pred_mov_widthhuv256di */

    case 88:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1782; /* *pred_mov_widthhuv512di */

    case 89:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1788; /* *pred_mov_widthhuv1hf */

    case 90:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1794; /* *pred_mov_widthhuv2hf */

    case 91:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1800; /* *pred_mov_widthhuv4hf */

    case 92:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1806; /* *pred_mov_widthhuv8hf */

    case 93:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1812; /* *pred_mov_widthhuv16hf */

    case 94:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1818; /* *pred_mov_widthhuv32hf */

    case 95:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1824; /* *pred_mov_widthhuv64hf */

    case 96:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1830; /* *pred_mov_widthhuv128hf */

    case 97:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1836; /* *pred_mov_widthhuv256hf */

    case 98:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1842; /* *pred_mov_widthhuv512hf */

    case 99:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1848; /* *pred_mov_widthhuv1024hf */

    case 100:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1854; /* *pred_mov_widthhuv2048hf */

    case 101:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1860; /* *pred_mov_widthhuv1sf */

    case 102:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1866; /* *pred_mov_widthhuv2sf */

    case 103:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1872; /* *pred_mov_widthhuv4sf */

    case 104:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1878; /* *pred_mov_widthhuv8sf */

    case 105:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1884; /* *pred_mov_widthhuv16sf */

    case 106:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1890; /* *pred_mov_widthhuv32sf */

    case 107:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1896; /* *pred_mov_widthhuv64sf */

    case 108:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1902; /* *pred_mov_widthhuv128sf */

    case 109:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1908; /* *pred_mov_widthhuv256sf */

    case 110:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1914; /* *pred_mov_widthhuv512sf */

    case 111:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1920; /* *pred_mov_widthhuv1024sf */

    case 112:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1926; /* *pred_mov_widthhuv1df */

    case 113:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1932; /* *pred_mov_widthhuv2df */

    case 114:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1938; /* *pred_mov_widthhuv4df */

    case 115:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1944; /* *pred_mov_widthhuv8df */

    case 116:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1950; /* *pred_mov_widthhuv16df */

    case 117:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1956; /* *pred_mov_widthhuv32df */

    case 118:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1962; /* *pred_mov_widthhuv64df */

    case 119:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1968; /* *pred_mov_widthhuv128df */

    case 120:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1974; /* *pred_mov_widthhuv256df */

    case 121:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1980; /* *pred_mov_widthhuv512df */

    default:
      return -1;
    }
}

 int
recog_936 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern718 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11411; /* pred_ssrarvvm8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12152; /* pred_ssrarvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11418; /* pred_ssrarvvm4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12154; /* pred_ssrarvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11425; /* pred_ssrarvvm2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12156; /* pred_ssrarvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11432; /* pred_ssrarvvm1qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12158; /* pred_ssrarvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11439; /* pred_ssrarvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12160; /* pred_ssrarvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11446; /* pred_ssrarvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12162; /* pred_ssrarvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11453; /* pred_ssrarvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12164; /* pred_ssrarvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11460; /* pred_ssrarvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12166; /* pred_ssrarvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11467; /* pred_ssrarvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12168; /* pred_ssrarvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11474; /* pred_ssrarvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12170; /* pred_ssrarvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11481; /* pred_ssrarvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12172; /* pred_ssrarvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11488; /* pred_ssrarvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12174; /* pred_ssrarvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11495; /* pred_ssrarvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12176; /* pred_ssrarvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11502; /* pred_ssrarvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12178; /* pred_ssrarvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11509; /* pred_ssrarvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12180; /* pred_ssrarvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11516; /* pred_ssrarvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12182; /* pred_ssrarvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11523; /* pred_ssrarvvmf2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12184; /* pred_ssrarvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11530; /* pred_ssrarvvmf4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12186; /* pred_ssrarvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11537; /* pred_ssrarvvmf8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12188; /* pred_ssrarvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11544; /* pred_ssrarvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12190; /* pred_ssrarvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11551; /* pred_ssrarvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12192; /* pred_ssrarvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11558; /* pred_ssrarvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12194; /* pred_ssrarvvmf2si_scalar */

    case 22:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11565; /* pred_ssrav1qi */

    case 23:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11572; /* pred_ssrav2qi */

    case 24:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11579; /* pred_ssrav4qi */

    case 25:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11586; /* pred_ssrav8qi */

    case 26:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11593; /* pred_ssrav16qi */

    case 27:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 11600; /* pred_ssrav32qi */

    case 28:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11607; /* pred_ssrav64qi */

    case 29:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11614; /* pred_ssrav128qi */

    case 30:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11621; /* pred_ssrav256qi */

    case 31:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11628; /* pred_ssrav512qi */

    case 32:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11635; /* pred_ssrav1024qi */

    case 33:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11642; /* pred_ssrav2048qi */

    case 34:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11649; /* pred_ssrav4096qi */

    case 35:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 11656; /* pred_ssrav1hi */

    case 36:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 11663; /* pred_ssrav2hi */

    case 37:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 11670; /* pred_ssrav4hi */

    case 38:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 11677; /* pred_ssrav8hi */

    case 39:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 11684; /* pred_ssrav16hi */

    case 40:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11691; /* pred_ssrav32hi */

    case 41:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11698; /* pred_ssrav64hi */

    case 42:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11705; /* pred_ssrav128hi */

    case 43:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11712; /* pred_ssrav256hi */

    case 44:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11719; /* pred_ssrav512hi */

    case 45:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11726; /* pred_ssrav1024hi */

    case 46:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11733; /* pred_ssrav2048hi */

    case 47:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 11740; /* pred_ssrav1si */

    case 48:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 11747; /* pred_ssrav2si */

    case 49:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 11754; /* pred_ssrav4si */

    case 50:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 11761; /* pred_ssrav8si */

    case 51:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11768; /* pred_ssrav16si */

    case 52:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11775; /* pred_ssrav32si */

    case 53:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11782; /* pred_ssrav64si */

    case 54:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11789; /* pred_ssrav128si */

    case 55:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11796; /* pred_ssrav256si */

    case 56:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11803; /* pred_ssrav512si */

    case 57:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11810; /* pred_ssrav1024si */

    case 58:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11817; /* pred_ssrav1di */

    case 59:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11824; /* pred_ssrav2di */

    case 60:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11831; /* pred_ssrav4di */

    case 61:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11838; /* pred_ssrav8di */

    case 62:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11845; /* pred_ssrav16di */

    case 63:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11852; /* pred_ssrav32di */

    case 64:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11859; /* pred_ssrav64di */

    case 65:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11866; /* pred_ssrav128di */

    case 66:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11873; /* pred_ssrav256di */

    case 67:
      if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11880; /* pred_ssrav512di */

    default:
      return -1;
    }
}

 int
recog_1023 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_956 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return 15388; /* *pred_maddv16hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15484; /* *pred_maccv16hf */
}

 int
recog_1029 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_950 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15376; /* *pred_maddrvvm2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15472; /* *pred_maccrvvm2df */
}

 int
recog_1035 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_944 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15364; /* *pred_maddrvvm4sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15460; /* *pred_maccrvvm4sf */
}

 int
recog_1041 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_938 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15352; /* *pred_maddrvvm4hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15448; /* *pred_maccrvvm4hf */
}

 int
recog_1052 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM1SFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15752; /* *pred_mul_neg_addrvvm1sf_undef */
}

 int
recog_1061 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8HFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15770; /* *pred_mul_neg_addv8hf_undef */
}

 int
recog_1071 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2SFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15790; /* *pred_mul_neg_addv2sf_undef */
}

 int
recog_1081 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1DFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15810; /* *pred_mul_neg_addv1df_undef */
}

 int
recog_1091 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1090 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return 15924; /* *pred_nmsubv512df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 16020; /* *pred_nmsacv512df */
}

 int
recog_1101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1080 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1024SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 15904; /* *pred_nmsubv1024sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 16000; /* *pred_nmsacv1024sf */
}

 int
recog_1111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1070 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15884; /* *pred_nmsubv1sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15980; /* *pred_nmsacv1sf */
}

 int
recog_1121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1060 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return 15864; /* *pred_nmsubv4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15960; /* *pred_nmsacv4hf */
}

 int
recog_1131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1050 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM4SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15844; /* *pred_nmsubrvvm4sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15940; /* *pred_nmsacrvvm4sf */
}

 int
recog_1141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[9] = x8;
  x9 = XEXP (x2, 2);
  operands[2] = x9;
  x10 = XEXP (x2, 1);
  x11 = XEXP (x10, 1);
  switch (GET_CODE (x11))
    {
    case FLOAT_EXTEND:
      x12 = XEXP (x10, 0);
      x13 = XEXP (x12, 0);
      operands[3] = x13;
      switch (pattern722 (x2))
        {
        case 0:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16403; /* pred_dual_widen_addrvvm8sf */

        case 1:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16406; /* pred_dual_widen_addrvvm4sf */

        case 2:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16409; /* pred_dual_widen_addrvvm2sf */

        case 3:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16412; /* pred_dual_widen_addrvvm1sf */

        case 4:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16415; /* pred_dual_widen_addrvvmf2sf */

        case 5:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16418; /* pred_dual_widen_addrvvm8df */

        case 6:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16421; /* pred_dual_widen_addrvvm4df */

        case 7:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16424; /* pred_dual_widen_addrvvm2df */

        case 8:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16427; /* pred_dual_widen_addrvvm1df */

        case 9:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16430; /* pred_dual_widen_addv1sf */

        case 10:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16433; /* pred_dual_widen_addv2sf */

        case 11:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16436; /* pred_dual_widen_addv4sf */

        case 12:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16439; /* pred_dual_widen_addv8sf */

        case 13:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16442; /* pred_dual_widen_addv16sf */

        case 14:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16445; /* pred_dual_widen_addv32sf */

        case 15:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16448; /* pred_dual_widen_addv64sf */

        case 16:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16451; /* pred_dual_widen_addv128sf */

        case 17:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16454; /* pred_dual_widen_addv256sf */

        case 18:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16457; /* pred_dual_widen_addv512sf */

        case 19:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16460; /* pred_dual_widen_addv1024sf */

        case 20:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16463; /* pred_dual_widen_addv1df */

        case 21:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16466; /* pred_dual_widen_addv2df */

        case 22:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16469; /* pred_dual_widen_addv4df */

        case 23:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16472; /* pred_dual_widen_addv8df */

        case 24:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16475; /* pred_dual_widen_addv16df */

        case 25:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16478; /* pred_dual_widen_addv32df */

        case 26:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16481; /* pred_dual_widen_addv64df */

        case 27:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16484; /* pred_dual_widen_addv128df */

        case 28:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16487; /* pred_dual_widen_addv256df */

        case 29:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16490; /* pred_dual_widen_addv512df */

        case 30:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16493; /* pred_dual_widen_addrvvm8sf_scalar */

        case 31:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16496; /* pred_dual_widen_addrvvm4sf_scalar */

        case 32:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16499; /* pred_dual_widen_addrvvm2sf_scalar */

        case 33:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16502; /* pred_dual_widen_addrvvm1sf_scalar */

        case 34:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16505; /* pred_dual_widen_addrvvmf2sf_scalar */

        case 35:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16508; /* pred_dual_widen_addrvvm8df_scalar */

        case 36:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16511; /* pred_dual_widen_addrvvm4df_scalar */

        case 37:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16514; /* pred_dual_widen_addrvvm2df_scalar */

        case 38:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16517; /* pred_dual_widen_addrvvm1df_scalar */

        case 39:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16520; /* pred_dual_widen_addv1sf_scalar */

        case 40:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16523; /* pred_dual_widen_addv2sf_scalar */

        case 41:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16526; /* pred_dual_widen_addv4sf_scalar */

        case 42:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16529; /* pred_dual_widen_addv8sf_scalar */

        case 43:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16532; /* pred_dual_widen_addv16sf_scalar */

        case 44:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16535; /* pred_dual_widen_addv32sf_scalar */

        case 45:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16538; /* pred_dual_widen_addv64sf_scalar */

        case 46:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16541; /* pred_dual_widen_addv128sf_scalar */

        case 47:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16544; /* pred_dual_widen_addv256sf_scalar */

        case 48:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16547; /* pred_dual_widen_addv512sf_scalar */

        case 49:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16550; /* pred_dual_widen_addv1024sf_scalar */

        case 50:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16553; /* pred_dual_widen_addv1df_scalar */

        case 51:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16556; /* pred_dual_widen_addv2df_scalar */

        case 52:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16559; /* pred_dual_widen_addv4df_scalar */

        case 53:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16562; /* pred_dual_widen_addv8df_scalar */

        case 54:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16565; /* pred_dual_widen_addv16df_scalar */

        case 55:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16568; /* pred_dual_widen_addv32df_scalar */

        case 56:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16571; /* pred_dual_widen_addv64df_scalar */

        case 57:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16574; /* pred_dual_widen_addv128df_scalar */

        case 58:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16577; /* pred_dual_widen_addv256df_scalar */

        case 59:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16580; /* pred_dual_widen_addv512df_scalar */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[3] = x11;
      x12 = XEXP (x10, 0);
      x13 = XEXP (x12, 0);
      operands[4] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern491 (x2, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16583; /* pred_single_widen_addrvvm8sf */

        case E_RVVM4SFmode:
          if (pattern491 (x2, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16584; /* pred_single_widen_addrvvm4sf */

        case E_RVVM2SFmode:
          if (pattern491 (x2, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16585; /* pred_single_widen_addrvvm2sf */

        case E_RVVM1SFmode:
          if (pattern491 (x2, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16586; /* pred_single_widen_addrvvm1sf */

        case E_RVVMF2SFmode:
          if (pattern491 (x2, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16587; /* pred_single_widen_addrvvmf2sf */

        case E_RVVM8DFmode:
          if (pattern491 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16588; /* pred_single_widen_addrvvm8df */

        case E_RVVM4DFmode:
          if (pattern491 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16589; /* pred_single_widen_addrvvm4df */

        case E_RVVM2DFmode:
          if (pattern491 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16590; /* pred_single_widen_addrvvm2df */

        case E_RVVM1DFmode:
          if (pattern491 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16591; /* pred_single_widen_addrvvm1df */

        case E_V1SFmode:
          if (pattern491 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16592; /* pred_single_widen_addv1sf */

        case E_V2SFmode:
          if (pattern491 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16593; /* pred_single_widen_addv2sf */

        case E_V4SFmode:
          if (pattern491 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16594; /* pred_single_widen_addv4sf */

        case E_V8SFmode:
          if (pattern491 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16595; /* pred_single_widen_addv8sf */

        case E_V16SFmode:
          if (pattern491 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16596; /* pred_single_widen_addv16sf */

        case E_V32SFmode:
          if (pattern491 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16597; /* pred_single_widen_addv32sf */

        case E_V64SFmode:
          if (pattern491 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16598; /* pred_single_widen_addv64sf */

        case E_V128SFmode:
          if (pattern491 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16599; /* pred_single_widen_addv128sf */

        case E_V256SFmode:
          if (pattern491 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16600; /* pred_single_widen_addv256sf */

        case E_V512SFmode:
          if (pattern491 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16601; /* pred_single_widen_addv512sf */

        case E_V1024SFmode:
          if (pattern491 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16602; /* pred_single_widen_addv1024sf */

        case E_V1DFmode:
          if (pattern491 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16603; /* pred_single_widen_addv1df */

        case E_V2DFmode:
          if (pattern491 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16604; /* pred_single_widen_addv2df */

        case E_V4DFmode:
          if (pattern491 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16605; /* pred_single_widen_addv4df */

        case E_V8DFmode:
          if (pattern491 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16606; /* pred_single_widen_addv8df */

        case E_V16DFmode:
          if (pattern491 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16607; /* pred_single_widen_addv16df */

        case E_V32DFmode:
          if (pattern491 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16608; /* pred_single_widen_addv32df */

        case E_V64DFmode:
          if (pattern491 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16609; /* pred_single_widen_addv64df */

        case E_V128DFmode:
          if (pattern491 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16610; /* pred_single_widen_addv128df */

        case E_V256DFmode:
          if (pattern491 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16611; /* pred_single_widen_addv256df */

        case E_V512DFmode:
          if (pattern491 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0
              || !(
#line 7080 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16612; /* pred_single_widen_addv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1311 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1260 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return 15875; /* *pred_nmaddv128hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15971; /* *pred_nmaccv128hf */
}

 int
recog_1319 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1252 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM1DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15859; /* *pred_nmaddrvvm1df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15955; /* *pred_nmaccrvvm1df */
}

 int
recog_1327 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1244 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15843; /* *pred_nmaddrvvm8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15939; /* *pred_nmaccrvvm8sf */
}

 int
recog_1336 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XVECEXP (x5, 0, 5);
  operands[9] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  x12 = XEXP (x3, 1);
  switch (GET_CODE (x12))
    {
    case REG:
    case SUBREG:
      switch (pattern708 (x2))
        {
        case 0:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14500; /* pred_subrvvm8hf */

        case 1:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14504; /* pred_subrvvm4hf */

        case 2:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14508; /* pred_subrvvm2hf */

        case 3:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14512; /* pred_subrvvm1hf */

        case 4:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14516; /* pred_subrvvmf2hf */

        case 5:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14520; /* pred_subrvvmf4hf */

        case 6:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14524; /* pred_subrvvm8sf */

        case 7:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14528; /* pred_subrvvm4sf */

        case 8:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14532; /* pred_subrvvm2sf */

        case 9:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14536; /* pred_subrvvm1sf */

        case 10:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14540; /* pred_subrvvmf2sf */

        case 11:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14544; /* pred_subrvvm8df */

        case 12:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14548; /* pred_subrvvm4df */

        case 13:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14552; /* pred_subrvvm2df */

        case 14:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14556; /* pred_subrvvm1df */

        case 15:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 14560; /* pred_subv1hf */

        case 16:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 14564; /* pred_subv2hf */

        case 17:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 14568; /* pred_subv4hf */

        case 18:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 14572; /* pred_subv8hf */

        case 19:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 14576; /* pred_subv16hf */

        case 20:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14580; /* pred_subv32hf */

        case 21:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14584; /* pred_subv64hf */

        case 22:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14588; /* pred_subv128hf */

        case 23:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14592; /* pred_subv256hf */

        case 24:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14596; /* pred_subv512hf */

        case 25:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14600; /* pred_subv1024hf */

        case 26:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14604; /* pred_subv2048hf */

        case 27:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14608; /* pred_subv1sf */

        case 28:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14612; /* pred_subv2sf */

        case 29:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14616; /* pred_subv4sf */

        case 30:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14620; /* pred_subv8sf */

        case 31:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14624; /* pred_subv16sf */

        case 32:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14628; /* pred_subv32sf */

        case 33:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14632; /* pred_subv64sf */

        case 34:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14636; /* pred_subv128sf */

        case 35:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14640; /* pred_subv256sf */

        case 36:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14644; /* pred_subv512sf */

        case 37:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14648; /* pred_subv1024sf */

        case 38:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14652; /* pred_subv1df */

        case 39:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14656; /* pred_subv2df */

        case 40:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14660; /* pred_subv4df */

        case 41:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14664; /* pred_subv8df */

        case 42:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14668; /* pred_subv16df */

        case 43:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14672; /* pred_subv32df */

        case 44:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14676; /* pred_subv64df */

        case 45:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14680; /* pred_subv128df */

        case 46:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14684; /* pred_subv256df */

        case 47:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14688; /* pred_subv512df */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern723 (x2))
        {
        case 0:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14972; /* pred_subrvvm8hf_scalar */

        case 1:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14974; /* pred_subrvvm4hf_scalar */

        case 2:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14976; /* pred_subrvvm2hf_scalar */

        case 3:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14978; /* pred_subrvvm1hf_scalar */

        case 4:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14980; /* pred_subrvvmf2hf_scalar */

        case 5:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14982; /* pred_subrvvmf4hf_scalar */

        case 6:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14984; /* pred_subrvvm8sf_scalar */

        case 7:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14986; /* pred_subrvvm4sf_scalar */

        case 8:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14988; /* pred_subrvvm2sf_scalar */

        case 9:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14990; /* pred_subrvvm1sf_scalar */

        case 10:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14992; /* pred_subrvvmf2sf_scalar */

        case 11:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14994; /* pred_subrvvm8df_scalar */

        case 12:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14996; /* pred_subrvvm4df_scalar */

        case 13:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14998; /* pred_subrvvm2df_scalar */

        case 14:
          if (!(
#line 6326 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 15000; /* pred_subrvvm1df_scalar */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x13 = XEXP (x12, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern537 (x2, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16613; /* pred_single_widen_subrvvm8sf */

            case E_RVVM4SFmode:
              if (pattern537 (x2, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16614; /* pred_single_widen_subrvvm4sf */

            case E_RVVM2SFmode:
              if (pattern537 (x2, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16615; /* pred_single_widen_subrvvm2sf */

            case E_RVVM1SFmode:
              if (pattern537 (x2, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16616; /* pred_single_widen_subrvvm1sf */

            case E_RVVMF2SFmode:
              if (pattern537 (x2, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 16617; /* pred_single_widen_subrvvmf2sf */

            case E_RVVM8DFmode:
              if (pattern537 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16618; /* pred_single_widen_subrvvm8df */

            case E_RVVM4DFmode:
              if (pattern537 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16619; /* pred_single_widen_subrvvm4df */

            case E_RVVM2DFmode:
              if (pattern537 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16620; /* pred_single_widen_subrvvm2df */

            case E_RVVM1DFmode:
              if (pattern537 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16621; /* pred_single_widen_subrvvm1df */

            case E_V1SFmode:
              if (pattern537 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16622; /* pred_single_widen_subv1sf */

            case E_V2SFmode:
              if (pattern537 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16623; /* pred_single_widen_subv2sf */

            case E_V4SFmode:
              if (pattern537 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16624; /* pred_single_widen_subv4sf */

            case E_V8SFmode:
              if (pattern537 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16625; /* pred_single_widen_subv8sf */

            case E_V16SFmode:
              if (pattern537 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16626; /* pred_single_widen_subv16sf */

            case E_V32SFmode:
              if (pattern537 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16627; /* pred_single_widen_subv32sf */

            case E_V64SFmode:
              if (pattern537 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16628; /* pred_single_widen_subv64sf */

            case E_V128SFmode:
              if (pattern537 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16629; /* pred_single_widen_subv128sf */

            case E_V256SFmode:
              if (pattern537 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16630; /* pred_single_widen_subv256sf */

            case E_V512SFmode:
              if (pattern537 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16631; /* pred_single_widen_subv512sf */

            case E_V1024SFmode:
              if (pattern537 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16632; /* pred_single_widen_subv1024sf */

            case E_V1DFmode:
              if (pattern537 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16633; /* pred_single_widen_subv1df */

            case E_V2DFmode:
              if (pattern537 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16634; /* pred_single_widen_subv2df */

            case E_V4DFmode:
              if (pattern537 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16635; /* pred_single_widen_subv4df */

            case E_V8DFmode:
              if (pattern537 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16636; /* pred_single_widen_subv8df */

            case E_V16DFmode:
              if (pattern537 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16637; /* pred_single_widen_subv16df */

            case E_V32DFmode:
              if (pattern537 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16638; /* pred_single_widen_subv32df */

            case E_V64DFmode:
              if (pattern537 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16639; /* pred_single_widen_subv64df */

            case E_V128DFmode:
              if (pattern537 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16640; /* pred_single_widen_subv128df */

            case E_V256DFmode:
              if (pattern537 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16641; /* pred_single_widen_subv256df */

            case E_V512DFmode:
              if (pattern537 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0
                  || !(
#line 7105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16642; /* pred_single_widen_subv512df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          switch (pattern729 (x2))
            {
            case 0:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16644; /* pred_single_widen_subrvvm8sf_scalar */

            case 1:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16646; /* pred_single_widen_subrvvm4sf_scalar */

            case 2:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16648; /* pred_single_widen_subrvvm2sf_scalar */

            case 3:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16650; /* pred_single_widen_subrvvm1sf_scalar */

            case 4:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 16652; /* pred_single_widen_subrvvmf2sf_scalar */

            case 5:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16654; /* pred_single_widen_subrvvm8df_scalar */

            case 6:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16656; /* pred_single_widen_subrvvm4df_scalar */

            case 7:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16658; /* pred_single_widen_subrvvm2df_scalar */

            case 8:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16660; /* pred_single_widen_subrvvm1df_scalar */

            case 9:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16662; /* pred_single_widen_subv1sf_scalar */

            case 10:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16664; /* pred_single_widen_subv2sf_scalar */

            case 11:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16666; /* pred_single_widen_subv4sf_scalar */

            case 12:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16668; /* pred_single_widen_subv8sf_scalar */

            case 13:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16670; /* pred_single_widen_subv16sf_scalar */

            case 14:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16672; /* pred_single_widen_subv32sf_scalar */

            case 15:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16674; /* pred_single_widen_subv64sf_scalar */

            case 16:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16676; /* pred_single_widen_subv128sf_scalar */

            case 17:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16678; /* pred_single_widen_subv256sf_scalar */

            case 18:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16680; /* pred_single_widen_subv512sf_scalar */

            case 19:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16682; /* pred_single_widen_subv1024sf_scalar */

            case 20:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16684; /* pred_single_widen_subv1df_scalar */

            case 21:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16686; /* pred_single_widen_subv2df_scalar */

            case 22:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16688; /* pred_single_widen_subv4df_scalar */

            case 23:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16690; /* pred_single_widen_subv8df_scalar */

            case 24:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16692; /* pred_single_widen_subv16df_scalar */

            case 25:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16694; /* pred_single_widen_subv32df_scalar */

            case 26:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16696; /* pred_single_widen_subv64df_scalar */

            case 27:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16698; /* pred_single_widen_subv128df_scalar */

            case 28:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16700; /* pred_single_widen_subv256df_scalar */

            case 29:
              if (!(
#line 7131 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16702; /* pred_single_widen_subv512df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1361 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V1024QImode:
      if (!register_operand (operands[3], E_V1024QImode)
          || !vector_arith_operand (operands[4], E_V1024QImode)
          || !(
#line 4759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12459; /* *pred_cmpv1024qi_merge_tie_mask */

    case E_V1024HImode:
      if (!register_operand (operands[3], E_V1024HImode)
          || !vector_arith_operand (operands[4], E_V1024HImode)
          || !(
#line 4759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12472; /* *pred_cmpv1024hi_merge_tie_mask */

    case E_V1024SImode:
      if (!register_operand (operands[3], E_V1024SImode)
          || !vector_arith_operand (operands[4], E_V1024SImode)
          || !(
#line 4759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12484; /* *pred_cmpv1024si_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1368 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern531 (x2, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V16BImode))
    {
      res = recog_1355 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16QImode:
      if (!register_operand (operands[4], E_V16QImode)
          || !vector_arith_operand (operands[5], E_V16QImode))
        return -1;
      if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16QImode)) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 12521; /* *pred_cmpv16qi */
      if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16QImode)) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 12589; /* *pred_cmpv16qi_narrow */

    case E_V16HImode:
      if (!register_operand (operands[4], E_V16HImode)
          || !vector_arith_operand (operands[5], E_V16HImode))
        return -1;
      if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16HImode)) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 12534; /* *pred_cmpv16hi */
      if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16HImode)) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12602; /* *pred_cmpv16hi_narrow */

    case E_V16SImode:
      if (!register_operand (operands[4], E_V16SImode)
          || !vector_arith_operand (operands[5], E_V16SImode))
        return -1;
      if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16SImode)) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 12546; /* *pred_cmpv16si */
      if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16SImode)) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12614; /* *pred_cmpv16si_narrow */

    case E_V16DImode:
      if (!register_operand (operands[4], E_V16DImode)
          || !vector_arith_operand (operands[5], E_V16DImode))
        return -1;
      if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16DImode)) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 12557; /* *pred_cmpv16di */
      if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16DImode)) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12625; /* *pred_cmpv16di_narrow */

    default:
      return -1;
    }
}

 int
recog_1375 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1HImode:
      if (!register_operand (operands[3], E_RVVM1HImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM1HImode)
          || !
#line 4841 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12638; /* *pred_ltgervvm1hi_merge_tie_mask */

    case E_RVVM2SImode:
      if (!register_operand (operands[3], E_RVVM2SImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM2SImode)
          || !
#line 4841 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12641; /* *pred_ltgervvm2si_merge_tie_mask */

    case E_RVVM4DImode:
      if (!register_operand (operands[3], E_RVVM4DImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM4DImode)
          || !(
#line 4841 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12644; /* *pred_ltgervvm4di_merge_tie_mask */

    case E_RVVMF2QImode:
      if (!register_operand (operands[3], E_RVVMF2QImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF2QImode)
          || !(
#line 4841 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12647; /* *pred_ltgervvmf2qi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1380 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4QImode:
      if (!register_operand (operands[3], E_V4QImode)
          || !vector_neg_arith_operand (operands[4], E_V4QImode)
          || !(
#line 4841 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12655; /* *pred_ltgev4qi_merge_tie_mask */

    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode)
          || !vector_neg_arith_operand (operands[4], E_V4HImode)
          || !(
#line 4841 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12668; /* *pred_ltgev4hi_merge_tie_mask */

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode)
          || !vector_neg_arith_operand (operands[4], E_V4SImode)
          || !(
#line 4841 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12680; /* *pred_ltgev4si_merge_tie_mask */

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || !vector_neg_arith_operand (operands[4], E_V4DImode)
          || !(
#line 4841 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12691; /* *pred_ltgev4di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1386 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V256QImode:
      if (!register_operand (operands[3], E_V256QImode)
          || !vector_neg_arith_operand (operands[4], E_V256QImode)
          || !(
#line 4841 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12661; /* *pred_ltgev256qi_merge_tie_mask */

    case E_V256HImode:
      if (!register_operand (operands[3], E_V256HImode)
          || !vector_neg_arith_operand (operands[4], E_V256HImode)
          || !(
#line 4841 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12674; /* *pred_ltgev256hi_merge_tie_mask */

    case E_V256SImode:
      if (!register_operand (operands[3], E_V256SImode)
          || !vector_neg_arith_operand (operands[4], E_V256SImode)
          || !(
#line 4841 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12686; /* *pred_ltgev256si_merge_tie_mask */

    case E_V256DImode:
      if (!register_operand (operands[3], E_V256DImode)
          || !vector_neg_arith_operand (operands[4], E_V256DImode)
          || !(
#line 4841 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12697; /* *pred_ltgev256di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1395 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern532 (x2, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V16BImode))
    {
      res = recog_1382 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16QImode:
      if (!register_operand (operands[4], E_V16QImode)
          || !vector_neg_arith_operand (operands[5], E_V16QImode))
        return -1;
      if ((
#line 4865 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16QImode)) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 12725; /* *pred_ltgev16qi */
      if (!(
#line 4886 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16QImode)) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 12793; /* *pred_ltgev16qi_narrow */

    case E_V16HImode:
      if (!register_operand (operands[4], E_V16HImode)
          || !vector_neg_arith_operand (operands[5], E_V16HImode))
        return -1;
      if ((
#line 4865 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16HImode)) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 12738; /* *pred_ltgev16hi */
      if (!(
#line 4886 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16HImode)) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12806; /* *pred_ltgev16hi_narrow */

    case E_V16SImode:
      if (!register_operand (operands[4], E_V16SImode)
          || !vector_neg_arith_operand (operands[5], E_V16SImode))
        return -1;
      if ((
#line 4865 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16SImode)) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 12750; /* *pred_ltgev16si */
      if (!(
#line 4886 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16SImode)) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12818; /* *pred_ltgev16si_narrow */

    case E_V16DImode:
      if (!register_operand (operands[4], E_V16DImode)
          || !vector_neg_arith_operand (operands[5], E_V16DImode))
        return -1;
      if ((
#line 4865 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16DImode)) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 12761; /* *pred_ltgev16di */
      if (!(
#line 4886 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16DImode)) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12829; /* *pred_ltgev16di_narrow */

    default:
      return -1;
    }
}

 int
recog_1403 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4QImode:
      if (!register_operand (operands[3], E_RVVMF4QImode)
          || GET_MODE (x9) != E_RVVMF4QImode
          || !register_operand (operands[4], E_QImode)
          || !
#line 4925 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12840; /* *pred_cmprvvmf4qi_scalar_merge_tie_mask */

    case E_RVVMF2HImode:
      if (!register_operand (operands[3], E_RVVMF2HImode)
          || GET_MODE (x9) != E_RVVMF2HImode
          || !register_operand (operands[4], E_HImode)
          || !
#line 4925 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12846; /* *pred_cmprvvmf2hi_scalar_merge_tie_mask */

    case E_RVVM1SImode:
      if (!register_operand (operands[3], E_RVVM1SImode)
          || GET_MODE (x9) != E_RVVM1SImode
          || !register_operand (operands[4], E_SImode)
          || !
#line 4925 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12851; /* *pred_cmprvvm1si_scalar_merge_tie_mask */

    case E_RVVM2DImode:
      if (!register_operand (operands[3], E_RVVM2DImode)
          || GET_MODE (x9) != E_RVVM2DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5035 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12999; /* *pred_cmprvvm2di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1410 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V32QImode:
      if (!register_operand (operands[3], E_V32QImode)
          || GET_MODE (x9) != E_V32QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4925 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12858; /* *pred_cmpv32qi_scalar_merge_tie_mask */

    case E_V32HImode:
      if (!register_operand (operands[3], E_V32HImode)
          || GET_MODE (x9) != E_V32HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4925 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12871; /* *pred_cmpv32hi_scalar_merge_tie_mask */

    case E_V32SImode:
      if (!register_operand (operands[3], E_V32SImode)
          || GET_MODE (x9) != E_V32SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4925 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12883; /* *pred_cmpv32si_scalar_merge_tie_mask */

    case E_V32DImode:
      if (!register_operand (operands[3], E_V32DImode)
          || GET_MODE (x9) != E_V32DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5035 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 13006; /* *pred_cmpv32di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1417 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V512BImode))
    {
      res = recog_1414 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V512BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V512BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V512QImode:
      if (!register_operand (operands[4], E_V512QImode)
          || GET_MODE (x9) != E_V512QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4950 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512QImode)) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 12916; /* *pred_cmpv512qi_scalar */
      if (!(
#line 4972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512QImode)) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12970; /* *pred_cmpv512qi_scalar_narrow */

    case E_V512HImode:
      if (!register_operand (operands[4], E_V512HImode)
          || GET_MODE (x9) != E_V512HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4950 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HImode)) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12929; /* *pred_cmpv512hi_scalar */
      if (!(
#line 4972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HImode)) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12983; /* *pred_cmpv512hi_scalar_narrow */

    case E_V512SImode:
      if (!register_operand (operands[4], E_V512SImode)
          || GET_MODE (x9) != E_V512SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4950 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SImode)) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12941; /* *pred_cmpv512si_scalar */
      if (!(
#line 4972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SImode)) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12995; /* *pred_cmpv512si_scalar_narrow */

    case E_V512DImode:
      if (!register_operand (operands[4], E_V512DImode)
          || GET_MODE (x9) != E_V512DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DImode)) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 13024; /* *pred_cmpv512di_scalar */
      if (!(
#line 5082 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DImode)) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 13038; /* *pred_cmpv512di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1424 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V4BImode))
    {
      res = recog_1407 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V4BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4QImode:
      if (!register_operand (operands[4], E_V4QImode)
          || GET_MODE (x9) != E_V4QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4950 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4QImode)) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 12909; /* *pred_cmpv4qi_scalar */
      if (!(
#line 4972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4QImode)) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12963; /* *pred_cmpv4qi_scalar_narrow */

    case E_V4HImode:
      if (!register_operand (operands[4], E_V4HImode)
          || GET_MODE (x9) != E_V4HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4950 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HImode)) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12922; /* *pred_cmpv4hi_scalar */
      if (!(
#line 4972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HImode)) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12976; /* *pred_cmpv4hi_scalar_narrow */

    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode)
          || GET_MODE (x9) != E_V4SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4950 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SImode)) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12934; /* *pred_cmpv4si_scalar */
      if (!(
#line 4972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SImode)) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12988; /* *pred_cmpv4si_scalar_narrow */

    case E_V4DImode:
      if (!register_operand (operands[4], E_V4DImode)
          || GET_MODE (x9) != E_V4DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DImode)) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 13017; /* *pred_cmpv4di_scalar */
      if (!(
#line 5082 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DImode)) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13031; /* *pred_cmpv4di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1433 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4HFmode:
      if (!register_operand (operands[3], E_RVVMF4HFmode)
          || !register_operand (operands[4], E_RVVMF4HFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16996; /* *pred_cmprvvmf4hf_narrow_merge_tie_mask */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[3], E_RVVMF2SFmode)
          || !register_operand (operands[4], E_RVVMF2SFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17001; /* *pred_cmprvvmf2sf_narrow_merge_tie_mask */

    case E_RVVM1DFmode:
      if (!register_operand (operands[3], E_RVVM1DFmode)
          || !register_operand (operands[4], E_RVVM1DFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17005; /* *pred_cmprvvm1df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1438 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[3], E_V16HFmode)
          || !register_operand (operands[4], E_V16HFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17010; /* *pred_cmpv16hf_narrow_merge_tie_mask */

    case E_V16SFmode:
      if (!register_operand (operands[3], E_V16SFmode)
          || !register_operand (operands[4], E_V16SFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17022; /* *pred_cmpv16sf_narrow_merge_tie_mask */

    case E_V16DFmode:
      if (!register_operand (operands[3], E_V16DFmode)
          || !register_operand (operands[4], E_V16DFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17033; /* *pred_cmpv16df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1443 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512HFmode:
      if (!register_operand (operands[3], E_V512HFmode)
          || !register_operand (operands[4], E_V512HFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17015; /* *pred_cmpv512hf_narrow_merge_tie_mask */

    case E_V512SFmode:
      if (!register_operand (operands[3], E_V512SFmode)
          || !register_operand (operands[4], E_V512SFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17027; /* *pred_cmpv512sf_narrow_merge_tie_mask */

    case E_V512DFmode:
      if (!register_operand (operands[3], E_V512DFmode)
          || !register_operand (operands[4], E_V512DFmode)
          || !(
#line 7320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17038; /* *pred_cmpv512df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1448 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[3], E_RVVMF2HFmode)
          || GET_MODE (x9) != E_RVVMF2HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17091; /* *pred_cmprvvmf2hf_scalar_merge_tie_mask */

    case E_RVVM1SFmode:
      if (!register_operand (operands[3], E_RVVM1SFmode)
          || GET_MODE (x9) != E_RVVM1SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17096; /* *pred_cmprvvm1sf_scalar_merge_tie_mask */

    case E_RVVM2DFmode:
      if (!register_operand (operands[3], E_RVVM2DFmode)
          || GET_MODE (x9) != E_RVVM2DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17100; /* *pred_cmprvvm2df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1454 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[3], E_V16HFmode)
          || GET_MODE (x9) != E_V16HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17106; /* *pred_cmpv16hf_scalar_merge_tie_mask */

    case E_V16SFmode:
      if (!register_operand (operands[3], E_V16SFmode)
          || GET_MODE (x9) != E_V16SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17118; /* *pred_cmpv16sf_scalar_merge_tie_mask */

    case E_V16DFmode:
      if (!register_operand (operands[3], E_V16DFmode)
          || GET_MODE (x9) != E_V16DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17129; /* *pred_cmpv16df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1460 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V1024HFmode:
      if (!register_operand (operands[3], E_V1024HFmode)
          || GET_MODE (x9) != E_V1024HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17112; /* *pred_cmpv1024hf_scalar_merge_tie_mask */

    case E_V1024SFmode:
      if (!register_operand (operands[3], E_V1024SFmode)
          || GET_MODE (x9) != E_V1024SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17124; /* *pred_cmpv1024sf_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1465 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern543 (x2, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V32BImode))
    {
      res = recog_1455 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V32BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[4], E_V32HFmode)
          || GET_MODE (x9) != E_V32HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7408 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32HFmode)) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 17155; /* *pred_cmpv32hf_scalar */
      if (!(
#line 7430 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32HFmode)) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17203; /* *pred_cmpv32hf_scalar_narrow */

    case E_V32SFmode:
      if (!register_operand (operands[4], E_V32SFmode)
          || GET_MODE (x9) != E_V32SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7408 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32SFmode)) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return 17167; /* *pred_cmpv32sf_scalar */
      if (!(
#line 7430 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32SFmode)) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17215; /* *pred_cmpv32sf_scalar_narrow */

    case E_V32DFmode:
      if (!register_operand (operands[4], E_V32DFmode)
          || GET_MODE (x9) != E_V32DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7408 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32DFmode)) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return 17178; /* *pred_cmpv32df_scalar */
      if (!(
#line 7430 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32DFmode)) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17226; /* *pred_cmpv32df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1474 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
          res = recog_384 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL)
        {
          res = recog_386 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (ordered_comparison_operator (x3, E_VOIDmode))
        {
          res = recog_387 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != LABEL_REF)
        return -1;
      x5 = XEXP (x2, 2);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      operands[1] = x3;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      if (equality_operator (operands[1], E_VOIDmode))
        {
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (register_operand (operands[2], E_SImode)
                  && const_int5s_operand (operands[3], E_SImode)
                  && (
#line 2627 "../../gcc/config/riscv/corev.md"
(TARGET_XCVBI) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 33962; /* *cv_branchsi */
              break;

            case E_DImode:
              if (register_operand (operands[2], E_DImode)
                  && const_int5s_operand (operands[3], E_DImode)
                  && (
#line 2627 "../../gcc/config/riscv/corev.md"
(TARGET_XCVBI) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 33963; /* *cv_branchdi */
              break;

            default:
              break;
            }
        }
      if (!ordered_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      switch (pattern409 ())
        {
        case 0:
          if (!(
#line 2645 "../../gcc/config/riscv/corev.md"
(TARGET_XCVBI) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33964; /* *branchsi */

        case 1:
          if (!(
#line 2645 "../../gcc/config/riscv/corev.md"
(TARGET_XCVBI) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33965; /* *branchdi */

        default:
          return -1;
        }

    case UNSPEC:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      switch (XVECLEN (x3, 0))
        {
        case 5:
          if (pattern260 (x3) != 0)
            return -1;
          switch (XINT (x3, 1))
            {
            case 91:
              return recog_410 (x1, insn, pnum_clobbers);

            case 172:
              switch (pattern430 (x2))
                {
                case 0:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1983; /* pred_store_widthbrvvm8qi */

                case 1:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1986; /* pred_store_widthbrvvm4qi */

                case 2:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1989; /* pred_store_widthbrvvm2qi */

                case 3:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1992; /* pred_store_widthbrvvm1qi */

                case 4:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1995; /* pred_store_widthbrvvm8hi */

                case 5:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1998; /* pred_store_widthbrvvm4hi */

                case 6:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2001; /* pred_store_widthbrvvm2hi */

                case 7:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2004; /* pred_store_widthbrvvm1hi */

                case 8:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2007; /* pred_store_widthbrvvm8si */

                case 9:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2010; /* pred_store_widthbrvvm4si */

                case 10:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2013; /* pred_store_widthbrvvm2si */

                case 11:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2016; /* pred_store_widthbrvvm1si */

                case 12:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2019; /* pred_store_widthbrvvm8di */

                case 13:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2022; /* pred_store_widthbrvvm4di */

                case 14:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2025; /* pred_store_widthbrvvm2di */

                case 15:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2028; /* pred_store_widthbrvvm1di */

                case 16:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2031; /* pred_store_widthbrvvmf8qi */

                case 17:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2034; /* pred_store_widthbrvvmf4hi */

                case 18:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2037; /* pred_store_widthbrvvmf2si */

                default:
                  return -1;
                }

            case 174:
              switch (pattern430 (x2))
                {
                case 0:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1984; /* pred_store_widthhrvvm8qi */

                case 1:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1987; /* pred_store_widthhrvvm4qi */

                case 2:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1990; /* pred_store_widthhrvvm2qi */

                case 3:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1993; /* pred_store_widthhrvvm1qi */

                case 4:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1996; /* pred_store_widthhrvvm8hi */

                case 5:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1999; /* pred_store_widthhrvvm4hi */

                case 6:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2002; /* pred_store_widthhrvvm2hi */

                case 7:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2005; /* pred_store_widthhrvvm1hi */

                case 8:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2008; /* pred_store_widthhrvvm8si */

                case 9:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2011; /* pred_store_widthhrvvm4si */

                case 10:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2014; /* pred_store_widthhrvvm2si */

                case 11:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2017; /* pred_store_widthhrvvm1si */

                case 12:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2020; /* pred_store_widthhrvvm8di */

                case 13:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2023; /* pred_store_widthhrvvm4di */

                case 14:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2026; /* pred_store_widthhrvvm2di */

                case 15:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2029; /* pred_store_widthhrvvm1di */

                case 16:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2032; /* pred_store_widthhrvvmf8qi */

                case 17:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2035; /* pred_store_widthhrvvmf4hi */

                case 18:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2038; /* pred_store_widthhrvvmf2si */

                default:
                  return -1;
                }

            case 176:
              switch (pattern430 (x2))
                {
                case 0:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1985; /* pred_store_widthwrvvm8qi */

                case 1:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1988; /* pred_store_widthwrvvm4qi */

                case 2:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1991; /* pred_store_widthwrvvm2qi */

                case 3:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1994; /* pred_store_widthwrvvm1qi */

                case 4:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1997; /* pred_store_widthwrvvm8hi */

                case 5:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2000; /* pred_store_widthwrvvm4hi */

                case 6:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2003; /* pred_store_widthwrvvm2hi */

                case 7:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2006; /* pred_store_widthwrvvm1hi */

                case 8:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2009; /* pred_store_widthwrvvm8si */

                case 9:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2012; /* pred_store_widthwrvvm4si */

                case 10:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2015; /* pred_store_widthwrvvm2si */

                case 11:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2018; /* pred_store_widthwrvvm1si */

                case 12:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2021; /* pred_store_widthwrvvm8di */

                case 13:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2024; /* pred_store_widthwrvvm4di */

                case 14:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2027; /* pred_store_widthwrvvm2di */

                case 15:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2030; /* pred_store_widthwrvvm1di */

                case 16:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2033; /* pred_store_widthwrvvmf8qi */

                case 17:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2036; /* pred_store_widthwrvvmf4hi */

                case 18:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2039; /* pred_store_widthwrvvmf2si */

                default:
                  return -1;
                }

            case 178:
              switch (pattern432 (x2, 
178))
                {
                case 0:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2154; /* pred_strided_store_widthbrvvm8qi */

                case 1:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2157; /* pred_strided_store_widthbrvvm4qi */

                case 2:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2160; /* pred_strided_store_widthbrvvm2qi */

                case 3:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2163; /* pred_strided_store_widthbrvvm1qi */

                case 4:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2166; /* pred_strided_store_widthbrvvm8hi */

                case 5:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2169; /* pred_strided_store_widthbrvvm4hi */

                case 6:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2172; /* pred_strided_store_widthbrvvm2hi */

                case 7:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2175; /* pred_strided_store_widthbrvvm1hi */

                case 8:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2178; /* pred_strided_store_widthbrvvm8si */

                case 9:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2181; /* pred_strided_store_widthbrvvm4si */

                case 10:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2184; /* pred_strided_store_widthbrvvm2si */

                case 11:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2187; /* pred_strided_store_widthbrvvm1si */

                case 12:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2190; /* pred_strided_store_widthbrvvm8di */

                case 13:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2193; /* pred_strided_store_widthbrvvm4di */

                case 14:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2196; /* pred_strided_store_widthbrvvm2di */

                case 15:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2199; /* pred_strided_store_widthbrvvm1di */

                case 16:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2202; /* pred_strided_store_widthbrvvmf8qi */

                case 17:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2205; /* pred_strided_store_widthbrvvmf4hi */

                case 18:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2208; /* pred_strided_store_widthbrvvmf2si */

                default:
                  return -1;
                }

            case 180:
              switch (pattern432 (x2, 
180))
                {
                case 0:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2155; /* pred_strided_store_widthhrvvm8qi */

                case 1:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2158; /* pred_strided_store_widthhrvvm4qi */

                case 2:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2161; /* pred_strided_store_widthhrvvm2qi */

                case 3:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2164; /* pred_strided_store_widthhrvvm1qi */

                case 4:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2167; /* pred_strided_store_widthhrvvm8hi */

                case 5:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2170; /* pred_strided_store_widthhrvvm4hi */

                case 6:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2173; /* pred_strided_store_widthhrvvm2hi */

                case 7:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2176; /* pred_strided_store_widthhrvvm1hi */

                case 8:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2179; /* pred_strided_store_widthhrvvm8si */

                case 9:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2182; /* pred_strided_store_widthhrvvm4si */

                case 10:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2185; /* pred_strided_store_widthhrvvm2si */

                case 11:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2188; /* pred_strided_store_widthhrvvm1si */

                case 12:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2191; /* pred_strided_store_widthhrvvm8di */

                case 13:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2194; /* pred_strided_store_widthhrvvm4di */

                case 14:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2197; /* pred_strided_store_widthhrvvm2di */

                case 15:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2200; /* pred_strided_store_widthhrvvm1di */

                case 16:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2203; /* pred_strided_store_widthhrvvmf8qi */

                case 17:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2206; /* pred_strided_store_widthhrvvmf4hi */

                case 18:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2209; /* pred_strided_store_widthhrvvmf2si */

                default:
                  return -1;
                }

            case 182:
              switch (pattern432 (x2, 
182))
                {
                case 0:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2156; /* pred_strided_store_widthwrvvm8qi */

                case 1:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2159; /* pred_strided_store_widthwrvvm4qi */

                case 2:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2162; /* pred_strided_store_widthwrvvm2qi */

                case 3:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2165; /* pred_strided_store_widthwrvvm1qi */

                case 4:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2168; /* pred_strided_store_widthwrvvm8hi */

                case 5:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2171; /* pred_strided_store_widthwrvvm4hi */

                case 6:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2174; /* pred_strided_store_widthwrvvm2hi */

                case 7:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2177; /* pred_strided_store_widthwrvvm1hi */

                case 8:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2180; /* pred_strided_store_widthwrvvm8si */

                case 9:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2183; /* pred_strided_store_widthwrvvm4si */

                case 10:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2186; /* pred_strided_store_widthwrvvm2si */

                case 11:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2189; /* pred_strided_store_widthwrvvm1si */

                case 12:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2192; /* pred_strided_store_widthwrvvm8di */

                case 13:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2195; /* pred_strided_store_widthwrvvm4di */

                case 14:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2198; /* pred_strided_store_widthwrvvm2di */

                case 15:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2201; /* pred_strided_store_widthwrvvm1di */

                case 16:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2204; /* pred_strided_store_widthwrvvmf8qi */

                case 17:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2207; /* pred_strided_store_widthwrvvmf4hi */

                case 18:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2210; /* pred_strided_store_widthwrvvmf2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 7:
          return recog_1470 (x1, insn, pnum_clobbers);

        case 9:
          return recog_1471 (x1, insn, pnum_clobbers);

        case 6:
          if (pattern262 (x3) != 0)
            return -1;
          x10 = XVECEXP (x3, 0, 0);
          operands[1] = x10;
          x11 = XVECEXP (x3, 0, 1);
          if (!vector_length_operand (x11, E_VOIDmode))
            return -1;
          x12 = XVECEXP (x3, 0, 2);
          if (!const_int_operand (x12, E_VOIDmode))
            return -1;
          x13 = XVECEXP (x3, 0, 3);
          if (!const_int_operand (x13, E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
              return recog_1469 (x1, insn, pnum_clobbers);

            case UNSPEC:
              if (XVECLEN (x4, 0) != 1)
                return -1;
              operands[4] = x11;
              operands[5] = x12;
              operands[6] = x13;
              x14 = XVECEXP (x4, 0, 0);
              operands[3] = x14;
              x5 = XEXP (x2, 2);
              operands[2] = x5;
              switch (XINT (x4, 1))
                {
                case 114:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_RVVMF64BImode:
                      if (pattern622 (x2, 
E_RVVMF64BImode) != 0
                          || !(
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                        return -1;
                      return 14387; /* pred_sbfrvvmf64bi */

                    case E_RVVMF32BImode:
                      if (pattern622 (x2, 
E_RVVMF32BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14390; /* pred_sbfrvvmf32bi */

                    case E_RVVMF16BImode:
                      if (pattern622 (x2, 
E_RVVMF16BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14393; /* pred_sbfrvvmf16bi */

                    case E_RVVMF8BImode:
                      if (pattern622 (x2, 
E_RVVMF8BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14396; /* pred_sbfrvvmf8bi */

                    case E_RVVMF4BImode:
                      if (pattern622 (x2, 
E_RVVMF4BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14399; /* pred_sbfrvvmf4bi */

                    case E_RVVMF2BImode:
                      if (pattern622 (x2, 
E_RVVMF2BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14402; /* pred_sbfrvvmf2bi */

                    case E_RVVM1BImode:
                      if (pattern622 (x2, 
E_RVVM1BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14405; /* pred_sbfrvvm1bi */

                    default:
                      return -1;
                    }

                case 115:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_RVVMF64BImode:
                      if (pattern622 (x2, 
E_RVVMF64BImode) != 0
                          || !(
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                        return -1;
                      return 14388; /* pred_sifrvvmf64bi */

                    case E_RVVMF32BImode:
                      if (pattern622 (x2, 
E_RVVMF32BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14391; /* pred_sifrvvmf32bi */

                    case E_RVVMF16BImode:
                      if (pattern622 (x2, 
E_RVVMF16BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14394; /* pred_sifrvvmf16bi */

                    case E_RVVMF8BImode:
                      if (pattern622 (x2, 
E_RVVMF8BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14397; /* pred_sifrvvmf8bi */

                    case E_RVVMF4BImode:
                      if (pattern622 (x2, 
E_RVVMF4BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14400; /* pred_sifrvvmf4bi */

                    case E_RVVMF2BImode:
                      if (pattern622 (x2, 
E_RVVMF2BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14403; /* pred_sifrvvmf2bi */

                    case E_RVVM1BImode:
                      if (pattern622 (x2, 
E_RVVM1BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14406; /* pred_sifrvvm1bi */

                    default:
                      return -1;
                    }

                case 116:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_RVVMF64BImode:
                      if (pattern622 (x2, 
E_RVVMF64BImode) != 0
                          || !(
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                        return -1;
                      return 14389; /* pred_sofrvvmf64bi */

                    case E_RVVMF32BImode:
                      if (pattern622 (x2, 
E_RVVMF32BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14392; /* pred_sofrvvmf32bi */

                    case E_RVVMF16BImode:
                      if (pattern622 (x2, 
E_RVVMF16BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14395; /* pred_sofrvvmf16bi */

                    case E_RVVMF8BImode:
                      if (pattern622 (x2, 
E_RVVMF8BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14398; /* pred_sofrvvmf8bi */

                    case E_RVVMF4BImode:
                      if (pattern622 (x2, 
E_RVVMF4BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14401; /* pred_sofrvvmf4bi */

                    case E_RVVMF2BImode:
                      if (pattern622 (x2, 
E_RVVMF2BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14404; /* pred_sofrvvmf2bi */

                    case E_RVVM1BImode:
                      if (pattern622 (x2, 
E_RVVM1BImode) != 0
                          || !
#line 6123 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14407; /* pred_sofrvvm1bi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      return recog_1472 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1482 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      return recog_102 (x1, insn, pnum_clobbers);

    case 1:
      return recog_104 (x1, insn, pnum_clobbers);

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 6:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern384 (x2, 
E_SImode) != 0
                  || !
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))
                return -1;
              return 262; /* tls_add_tp_lesi */

            case E_DImode:
              if (pattern384 (x2, 
E_DImode) != 0
                  || !
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))
                return -1;
              return 263; /* tls_add_tp_ledi */

            default:
              return -1;
            }

        case 10:
          x6 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x6) != PC)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern385 (x2, 
E_SImode) != 0
                  || !
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))
                return -1;
              return 270; /* auipcsi */

            case E_DImode:
              if (pattern385 (x2, 
E_DImode) != 0
                  || !
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))
                return -1;
              return 271; /* auipcdi */

            default:
              return -1;
            }

        case 49:
          if (pattern247 (x2) != 0
              || !
#line 216 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKND && !TARGET_64BIT))
            return -1;
          return 683; /* riscv_aes32dsi */

        case 50:
          if (pattern247 (x2) != 0
              || !
#line 226 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKND && !TARGET_64BIT))
            return -1;
          return 684; /* riscv_aes32dsmi */

        case 58:
          if (pattern247 (x2) != 0
              || !
#line 282 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNE && !TARGET_64BIT))
            return -1;
          return 690; /* riscv_aes32esi */

        case 59:
          if (pattern247 (x2) != 0
              || !
#line 292 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNE && !TARGET_64BIT))
            return -1;
          return 691; /* riscv_aes32esmi */

        case 76:
          if (pattern247 (x2) != 0
              || !
#line 499 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKSED && !TARGET_64BIT))
            return -1;
          return 716; /* *riscv_sm4ed_si */

        case 77:
          if (pattern247 (x2) != 0
              || !
#line 499 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKSED && !TARGET_64BIT))
            return -1;
          return 717; /* *riscv_sm4ks_si */

        case 102:
          return recog_84 (x1, insn, pnum_clobbers);

        case 103:
          return recog_86 (x1, insn, pnum_clobbers);

        case 140:
          return recog_85 (x1, insn, pnum_clobbers);

        case 134:
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != UNSPEC
              || XVECLEN (x4, 0) != 6
              || XINT (x4, 1) != 91
              || pattern356 (x4) != 0)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          operands[3] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[4] = x8;
          if (!vector_length_operand (operands[4], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x4, 0, 2);
          operands[5] = x9;
          if (!const_int_operand (operands[5], E_VOIDmode))
            return -1;
          x10 = XVECEXP (x4, 0, 3);
          operands[6] = x10;
          if (!const_int_operand (operands[6], E_VOIDmode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[1] = x6;
          return recog_83 (x1, insn, pnum_clobbers);

        case 232:
          if (pattern250 (x2) != 0
              || !
#line 876 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33818; /* riscv_cv_simd_add_h_si */

        case 236:
          if (pattern250 (x2) != 0
              || !
#line 929 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33822; /* riscv_cv_simd_sub_h_si */

        case 296:
          if (pattern251 (x2) != 0
              || !
#line 1639 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33882; /* riscv_cv_simd_insert_h_si */

        case 297:
          if (pattern251 (x2) != 0
              || !
#line 1651 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33883; /* riscv_cv_simd_insert_b_si */

        case 310:
          if (pattern252 (x2) != 0
              || !
#line 1808 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33896; /* riscv_cv_simd_sdotup_h_si */

        case 311:
          if (pattern252 (x2) != 0
              || !
#line 1820 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33897; /* riscv_cv_simd_sdotup_b_si */

        case 312:
          if (pattern253 (x2, 
E_HImode) != 0
              || !
#line 1832 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33898; /* riscv_cv_simd_sdotup_sc_h_si */

        case 313:
          if (pattern253 (x2, 
E_QImode) != 0
              || !
#line 1846 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33899; /* riscv_cv_simd_sdotup_sc_b_si */

        case 314:
          if (pattern252 (x2) != 0
              || !
#line 1860 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33900; /* riscv_cv_simd_sdotusp_h_si */

        case 315:
          if (pattern252 (x2) != 0
              || !
#line 1872 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33901; /* riscv_cv_simd_sdotusp_b_si */

        case 316:
          if (pattern254 (x2, 
E_HImode) != 0
              || !
#line 1884 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33902; /* riscv_cv_simd_sdotusp_sc_h_si */

        case 317:
          if (pattern254 (x2, 
E_QImode) != 0
              || !
#line 1898 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33903; /* riscv_cv_simd_sdotusp_sc_b_si */

        case 318:
          if (pattern252 (x2) != 0
              || !
#line 1912 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33904; /* riscv_cv_simd_sdotsp_h_si */

        case 319:
          if (pattern252 (x2) != 0
              || !
#line 1924 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33905; /* riscv_cv_simd_sdotsp_b_si */

        case 320:
          if (pattern254 (x2, 
E_HImode) != 0
              || !
#line 1936 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33906; /* riscv_cv_simd_sdotsp_sc_h_si */

        case 321:
          if (pattern254 (x2, 
E_QImode) != 0
              || !
#line 1950 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33907; /* riscv_cv_simd_sdotsp_sc_b_si */

        case 326:
          if (pattern252 (x2) != 0
              || !
#line 2013 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33912; /* riscv_cv_simd_shuffle2_h_si */

        case 327:
          if (pattern252 (x2) != 0
              || !
#line 2025 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33913; /* riscv_cv_simd_shuffle2_b_si */

        case 330:
          if (pattern252 (x2) != 0
              || !
#line 2059 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33916; /* riscv_cv_simd_packhi_b_si */

        case 331:
          if (pattern252 (x2) != 0
              || !
#line 2071 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33917; /* riscv_cv_simd_packlo_b_si */

        case 375:
          if (pattern250 (x2) != 0
              || !
#line 2609 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33961; /* riscv_cv_simd_subrotmj_si */

        default:
          return -1;
        }

    case 5:
      switch (XINT (x2, 1))
        {
        case 193:
          if (pattern176 (x2) != 0)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!vector_length_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          return recog_87 (x1, insn, pnum_clobbers);

        case 89:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (pattern386 (x2))
            {
            case 0:
              if (!(
#line 1784 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 3647; /* vsetvlsi_no_side_effects */

            case 1:
              if (!(
#line 1784 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 3648; /* vsetvldi_no_side_effects */

            default:
              return -1;
            }

        case 94:
          return recog_90 (x1, insn, pnum_clobbers);

        case 143:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x5 = XVECEXP (x2, 0, 1);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (pattern330 (x2))
            {
            case 0:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28239; /* mask_len_fold_left_plus_rvvm8hf */

            case 1:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28240; /* mask_len_fold_left_plus_rvvm4hf */

            case 2:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28241; /* mask_len_fold_left_plus_rvvm2hf */

            case 3:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28242; /* mask_len_fold_left_plus_rvvm1hf */

            case 4:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28243; /* mask_len_fold_left_plus_rvvmf2hf */

            case 5:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 28244; /* mask_len_fold_left_plus_rvvmf4hf */

            case 6:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 28245; /* mask_len_fold_left_plus_rvvm8sf */

            case 7:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 28246; /* mask_len_fold_left_plus_rvvm4sf */

            case 8:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 28247; /* mask_len_fold_left_plus_rvvm2sf */

            case 9:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 28248; /* mask_len_fold_left_plus_rvvm1sf */

            case 10:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 28249; /* mask_len_fold_left_plus_rvvmf2sf */

            case 11:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 28250; /* mask_len_fold_left_plus_rvvm8df */

            case 12:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 28251; /* mask_len_fold_left_plus_rvvm4df */

            case 13:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 28252; /* mask_len_fold_left_plus_rvvm2df */

            case 14:
              if (!(
#line 2411 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 28253; /* mask_len_fold_left_plus_rvvm1df */

            case 15:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 31154; /* *mask_len_fold_left_widen_plus_rvvm4hf */

            case 16:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 31155; /* *mask_len_fold_left_widen_plus_rvvm2hf */

            case 17:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 31156; /* *mask_len_fold_left_widen_plus_rvvm1hf */

            case 18:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 31157; /* *mask_len_fold_left_widen_plus_rvvmf2hf */

            case 19:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 31158; /* *mask_len_fold_left_widen_plus_rvvmf4hf */

            case 20:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                return -1;
              return 31163; /* *mask_len_fold_left_widen_plus_v1hf */

            case 21:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                return -1;
              return 31164; /* *mask_len_fold_left_widen_plus_v2hf */

            case 22:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                return -1;
              return 31165; /* *mask_len_fold_left_widen_plus_v4hf */

            case 23:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                return -1;
              return 31166; /* *mask_len_fold_left_widen_plus_v8hf */

            case 24:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                return -1;
              return 31167; /* *mask_len_fold_left_widen_plus_v16hf */

            case 25:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 31168; /* *mask_len_fold_left_widen_plus_v32hf */

            case 26:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 31169; /* *mask_len_fold_left_widen_plus_v64hf */

            case 27:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 31170; /* *mask_len_fold_left_widen_plus_v128hf */

            case 28:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 31171; /* *mask_len_fold_left_widen_plus_v256hf */

            case 29:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 31172; /* *mask_len_fold_left_widen_plus_v512hf */

            case 30:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 31173; /* *mask_len_fold_left_widen_plus_v1024hf */

            case 31:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31159; /* *mask_len_fold_left_widen_plus_rvvm4sf */

            case 32:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31160; /* *mask_len_fold_left_widen_plus_rvvm2sf */

            case 33:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31161; /* *mask_len_fold_left_widen_plus_rvvm1sf */

            case 34:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 31162; /* *mask_len_fold_left_widen_plus_rvvmf2sf */

            case 35:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31174; /* *mask_len_fold_left_widen_plus_v1sf */

            case 36:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31175; /* *mask_len_fold_left_widen_plus_v2sf */

            case 37:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31176; /* *mask_len_fold_left_widen_plus_v4sf */

            case 38:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31177; /* *mask_len_fold_left_widen_plus_v8sf */

            case 39:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 31178; /* *mask_len_fold_left_widen_plus_v16sf */

            case 40:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 31179; /* *mask_len_fold_left_widen_plus_v32sf */

            case 41:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 31180; /* *mask_len_fold_left_widen_plus_v64sf */

            case 42:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 31181; /* *mask_len_fold_left_widen_plus_v128sf */

            case 43:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 31182; /* *mask_len_fold_left_widen_plus_v256sf */

            case 44:
              if (!(
#line 874 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 31183; /* *mask_len_fold_left_widen_plus_v512sf */

            default:
              return -1;
            }

        case 169:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (pattern358 (x2))
            {
            case 0:
              if (!(
#line 2866 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 28254; /* vcond_mask_len_rvvmf64bi */

            case 1:
              if (!
#line 2866 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()))
                return -1;
              return 28255; /* vcond_mask_len_rvvmf32bi */

            case 2:
              if (!
#line 2866 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()))
                return -1;
              return 28256; /* vcond_mask_len_rvvmf16bi */

            case 3:
              if (!
#line 2866 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()))
                return -1;
              return 28257; /* vcond_mask_len_rvvmf8bi */

            case 4:
              if (!
#line 2866 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()))
                return -1;
              return 28258; /* vcond_mask_len_rvvmf4bi */

            case 5:
              if (!
#line 2866 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()))
                return -1;
              return 28259; /* vcond_mask_len_rvvmf2bi */

            case 6:
              if (!
#line 2866 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()))
                return -1;
              return 28260; /* vcond_mask_len_rvvm1bi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      return recog_103 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1490 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return recog_110 (x1, insn, pnum_clobbers);

    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern195 (x3, 
E_SImode) != 0
              || !(
#line 266 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 523; /* *xor_notsi */

        case E_DImode:
          if (pattern195 (x3, 
E_DImode) != 0
              || !(
#line 266 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 524; /* *xor_notdi */

        case E_RVVMF64BImode:
          if (pattern195 (x3, 
E_RVVMF64BImode) != 0
              || !(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 32021; /* *nxorrvvmf64bi */

        case E_RVVMF32BImode:
          if (pattern195 (x3, 
E_RVVMF32BImode) != 0
              || !
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32024; /* *nxorrvvmf32bi */

        case E_RVVMF16BImode:
          if (pattern195 (x3, 
E_RVVMF16BImode) != 0
              || !
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32027; /* *nxorrvvmf16bi */

        case E_RVVMF8BImode:
          if (pattern195 (x3, 
E_RVVMF8BImode) != 0
              || !
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32030; /* *nxorrvvmf8bi */

        case E_RVVMF4BImode:
          if (pattern195 (x3, 
E_RVVMF4BImode) != 0
              || !
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32033; /* *nxorrvvmf4bi */

        case E_RVVMF2BImode:
          if (pattern195 (x3, 
E_RVVMF2BImode) != 0
              || !
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32036; /* *nxorrvvmf2bi */

        case E_RVVM1BImode:
          if (pattern195 (x3, 
E_RVVM1BImode) != 0
              || !
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32039; /* *nxorrvvm1bi */

        case E_V1BImode:
          if (pattern195 (x3, 
E_V1BImode) != 0
              || !(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 32042; /* *nxorv1bi */

        case E_V2BImode:
          if (pattern195 (x3, 
E_V2BImode) != 0
              || !(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 32045; /* *nxorv2bi */

        case E_V4BImode:
          if (pattern195 (x3, 
E_V4BImode) != 0
              || !(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 32048; /* *nxorv4bi */

        case E_V8BImode:
          if (pattern195 (x3, 
E_V8BImode) != 0
              || !(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 32051; /* *nxorv8bi */

        case E_V16BImode:
          if (pattern195 (x3, 
E_V16BImode) != 0
              || !(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 32054; /* *nxorv16bi */

        case E_V32BImode:
          if (pattern195 (x3, 
E_V32BImode) != 0
              || !(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 32057; /* *nxorv32bi */

        case E_V64BImode:
          if (pattern195 (x3, 
E_V64BImode) != 0
              || !(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32060; /* *nxorv64bi */

        case E_V128BImode:
          if (pattern195 (x3, 
E_V128BImode) != 0
              || !(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32063; /* *nxorv128bi */

        case E_V256BImode:
          if (pattern195 (x3, 
E_V256BImode) != 0
              || !(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32066; /* *nxorv256bi */

        case E_V512BImode:
          if (pattern195 (x3, 
E_V512BImode) != 0
              || !(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32069; /* *nxorv512bi */

        case E_V1024BImode:
          if (pattern195 (x3, 
E_V1024BImode) != 0
              || !(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32072; /* *nxorv1024bi */

        case E_V2048BImode:
          if (pattern195 (x3, 
E_V2048BImode) != 0
              || !(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32075; /* *nxorv2048bi */

        case E_V4096BImode:
          if (pattern195 (x3, 
E_V4096BImode) != 0
              || !(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32078; /* *nxorv4096bi */

        default:
          return -1;
        }

    case AND:
      switch (pattern196 (x3))
        {
        case 0:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 32019; /* *nandrvvmf64bi */

        case 1:
          if (!
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32022; /* *nandrvvmf32bi */

        case 2:
          if (!
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32025; /* *nandrvvmf16bi */

        case 3:
          if (!
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32028; /* *nandrvvmf8bi */

        case 4:
          if (!
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32031; /* *nandrvvmf4bi */

        case 5:
          if (!
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32034; /* *nandrvvmf2bi */

        case 6:
          if (!
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32037; /* *nandrvvm1bi */

        case 7:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 32040; /* *nandv1bi */

        case 8:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 32043; /* *nandv2bi */

        case 9:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 32046; /* *nandv4bi */

        case 10:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 32049; /* *nandv8bi */

        case 11:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 32052; /* *nandv16bi */

        case 12:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 32055; /* *nandv32bi */

        case 13:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32058; /* *nandv64bi */

        case 14:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32061; /* *nandv128bi */

        case 15:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32064; /* *nandv256bi */

        case 16:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32067; /* *nandv512bi */

        case 17:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32070; /* *nandv1024bi */

        case 18:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32073; /* *nandv2048bi */

        case 19:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32076; /* *nandv4096bi */

        default:
          return -1;
        }

    case IOR:
      switch (pattern196 (x3))
        {
        case 0:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 32020; /* *niorrvvmf64bi */

        case 1:
          if (!
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32023; /* *niorrvvmf32bi */

        case 2:
          if (!
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32026; /* *niorrvvmf16bi */

        case 3:
          if (!
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32029; /* *niorrvvmf8bi */

        case 4:
          if (!
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32032; /* *niorrvvmf4bi */

        case 5:
          if (!
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32035; /* *niorrvvmf2bi */

        case 6:
          if (!
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32038; /* *niorrvvm1bi */

        case 7:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 32041; /* *niorv1bi */

        case 8:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 32044; /* *niorv2bi */

        case 9:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 32047; /* *niorv4bi */

        case 10:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 32050; /* *niorv8bi */

        case 11:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 32053; /* *niorv16bi */

        case 12:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 32056; /* *niorv32bi */

        case 13:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32059; /* *niorv64bi */

        case 14:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32062; /* *niorv128bi */

        case 15:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32065; /* *niorv256bi */

        case 16:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32068; /* *niorv512bi */

        case 17:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32071; /* *niorv1024bi */

        case 18:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32074; /* *niorv2048bi */

        case 19:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32077; /* *niorv4096bi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1498 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern1 (x1))
    {
    case 0:
      if (!
#line 1416 "../../gcc/config/riscv/riscv.md"
(TARGET_DIV))
        return -1;
      return 37; /* *udivsi3 */

    case 1:
      if (!
#line 1443 "../../gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 41; /* udivdi3 */

    case 2:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24552; /* udivrvvm8qi3 */

    case 3:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24566; /* udivrvvm4qi3 */

    case 4:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24580; /* udivrvvm2qi3 */

    case 5:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24594; /* udivrvvm1qi3 */

    case 6:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24608; /* udivrvvm8hi3 */

    case 7:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24622; /* udivrvvm4hi3 */

    case 8:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24636; /* udivrvvm2hi3 */

    case 9:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24650; /* udivrvvm1hi3 */

    case 10:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24664; /* udivrvvm8si3 */

    case 11:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24678; /* udivrvvm4si3 */

    case 12:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24692; /* udivrvvm2si3 */

    case 13:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24706; /* udivrvvm1si3 */

    case 14:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24720; /* udivrvvm8di3 */

    case 15:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24734; /* udivrvvm4di3 */

    case 16:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24748; /* udivrvvm2di3 */

    case 17:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24762; /* udivrvvm1di3 */

    case 18:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24776; /* udivrvvmf2qi3 */

    case 19:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24790; /* udivrvvmf4qi3 */

    case 20:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24804; /* udivrvvmf8qi3 */

    case 21:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24818; /* udivrvvmf2hi3 */

    case 22:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24832; /* udivrvvmf4hi3 */

    case 23:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24846; /* udivrvvmf2si3 */

    case 24:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24860; /* udivv1qi3 */

    case 25:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24874; /* udivv2qi3 */

    case 26:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24888; /* udivv4qi3 */

    case 27:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24902; /* udivv8qi3 */

    case 28:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24916; /* udivv16qi3 */

    case 29:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24930; /* udivv32qi3 */

    case 30:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24944; /* udivv64qi3 */

    case 31:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24958; /* udivv128qi3 */

    case 32:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24972; /* udivv256qi3 */

    case 33:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24986; /* udivv512qi3 */

    case 34:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25000; /* udivv1024qi3 */

    case 35:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25014; /* udivv2048qi3 */

    case 36:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25028; /* udivv4096qi3 */

    case 37:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25042; /* udivv1hi3 */

    case 38:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25056; /* udivv2hi3 */

    case 39:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25070; /* udivv4hi3 */

    case 40:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25084; /* udivv8hi3 */

    case 41:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25098; /* udivv16hi3 */

    case 42:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25112; /* udivv32hi3 */

    case 43:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25126; /* udivv64hi3 */

    case 44:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25140; /* udivv128hi3 */

    case 45:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25154; /* udivv256hi3 */

    case 46:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25168; /* udivv512hi3 */

    case 47:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25182; /* udivv1024hi3 */

    case 48:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25196; /* udivv2048hi3 */

    case 49:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25210; /* udivv1si3 */

    case 50:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25224; /* udivv2si3 */

    case 51:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25238; /* udivv4si3 */

    case 52:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25252; /* udivv8si3 */

    case 53:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25266; /* udivv16si3 */

    case 54:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25280; /* udivv32si3 */

    case 55:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25294; /* udivv64si3 */

    case 56:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25308; /* udivv128si3 */

    case 57:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25322; /* udivv256si3 */

    case 58:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25336; /* udivv512si3 */

    case 59:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25350; /* udivv1024si3 */

    case 60:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25364; /* udivv1di3 */

    case 61:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25378; /* udivv2di3 */

    case 62:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25392; /* udivv4di3 */

    case 63:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25406; /* udivv8di3 */

    case 64:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25420; /* udivv16di3 */

    case 65:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25434; /* udivv32di3 */

    case 66:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25448; /* udivv64di3 */

    case 67:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25462; /* udivv128di3 */

    case 68:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25476; /* udivv256di3 */

    case 69:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25490; /* udivv512di3 */

    default:
      return -1;
    }
}

 int
recog_1508 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (x3))
    {
    case LT:
      if (GET_MODE (x3) == E_DImode)
        {
          x5 = XEXP (x3, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
              && register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_SImode)
              && 
#line 3043 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return 332; /* *lshrsi3_zero_extend_3 */
        }
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern264 (x3))
        {
        case 0:
          if (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return 429; /* slt_sisi3 */
          break;

        case 1:
          if (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 431; /* slt_disi3 */
          break;

        case 2:
          if (
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 433; /* slt_didi3 */
          break;

        default:
          break;
        }
      break;

    case EQ:
      x5 = XEXP (x3, 1);
      if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          switch (pattern105 (x3))
            {
            case 0:
              if (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
                return 411; /* *seq_zero_sisi */
              break;

            case 1:
              if (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return 412; /* *seq_zero_disi */
              break;

            case 2:
              if (
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return 413; /* *seq_zero_didi */
              break;

            default:
              break;
            }
        }
      break;

    case GT:
      switch (pattern215 (x3))
        {
        case 0:
          if (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return 417; /* *sgt_sisi */
          break;

        case 1:
          if (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 419; /* *sgt_disi */
          break;

        case 2:
          if (
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 421; /* *sgt_didi */
          break;

        default:
          break;
        }
      break;

    case GE:
      x5 = XEXP (x3, 1);
      if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
        {
          switch (pattern105 (x3))
            {
            case 0:
              if (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
                return 423; /* *sge_sisi */
              break;

            case 1:
              if (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return 425; /* *sge_disi */
              break;

            case 2:
              if (
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return 427; /* *sge_didi */
              break;

            default:
              break;
            }
        }
      break;

    case LE:
      switch (pattern216 (x3))
        {
        case 0:
          if (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return 435; /* *sle_sisi */
          break;

        case 1:
          if (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 437; /* *sle_disi */
          break;

        case 2:
          if (
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return 439; /* *sle_didi */
          break;

        case 3:
          if (
#line 570 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return 33797; /* riscv_cv_alu_slet */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern334 (
E_SImode))
        {
        case 0:
          if (!(
#line 3518 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 387; /* *cstoresfsi4 */

        case 1:
          if (!(
#line 3518 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 389; /* *cstoredfsi4 */

        case 2:
          if (!(
#line 3518 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 391; /* *cstorehfsi4 */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern334 (
E_DImode))
        {
        case 0:
          if (!(
#line 3518 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 388; /* *cstoresfdi4 */

        case 1:
          if (!(
#line 3518 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 390; /* *cstoredfdi4 */

        case 2:
          if (!(
#line 3518 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 392; /* *cstorehfdi4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1510 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (equality_operator (x4, E_VOIDmode))
    {
      switch (pattern414 (x3))
        {
        case 0:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && (
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 338; /* *branchqi_shiftedarith_equals_zero */
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && (
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 341; /* *branchqi_shiftedarith_equals_zero */
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && (
#line 3225 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 361; /* *branchqi_shiftedmask_equals_zero */
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && (
#line 3225 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 365; /* *branchqi_shiftedmask_equals_zero */
                  break;

                default:
                  break;
                }
            }
          break;

        case 1:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && (
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 339; /* *branchhi_shiftedarith_equals_zero */
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && (
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 342; /* *branchhi_shiftedarith_equals_zero */
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && (
#line 3225 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 362; /* *branchhi_shiftedmask_equals_zero */
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && (
#line 3225 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 366; /* *branchhi_shiftedmask_equals_zero */
                  break;

                default:
                  break;
                }
            }
          break;

        case 2:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && (
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 340; /* *branchsi_shiftedarith_equals_zero */
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && (
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 343; /* *branchsi_shiftedarith_equals_zero */
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && (
#line 3225 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 363; /* *branchsi_shiftedmask_equals_zero */
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && (
#line 3225 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 367; /* *branchsi_shiftedmask_equals_zero */
                  break;

                default:
                  break;
                }
            }
          break;

        case 3:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode)
              && scratch_operand (operands[4], E_DImode)
              && (
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 344; /* *branchdi_shiftedarith_equals_zero */
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && (
#line 3225 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && ((((
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
                    return 364; /* *branchdi_shiftedmask_equals_zero */
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && (
#line 3225 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 368; /* *branchdi_shiftedmask_equals_zero */
                  break;

                default:
                  break;
                }
            }
          break;

        case 4:
          x5 = XEXP (x4, 0);
          x6 = XEXP (x5, 1);
          if (XWINT (x6, 0) == 1L)
            {
              switch (pattern460 (x3))
                {
                case 0:
                  if (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
                    return 383; /* *branch_on_bitsi */
                  break;

                case 1:
                  if (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                    return 384; /* *branch_on_bitdi */
                  break;

                case 2:
                  if ((
#line 1143 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 653; /* *branchsi_bext */
                  break;

                case 3:
                  if ((
#line 1143 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 654; /* *branchdi_bext */
                  break;

                default:
                  break;
                }
            }
          x7 = XEXP (x5, 2);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (pattern461 (x3))
                {
                case 0:
                  if (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
                    return 385; /* *branch_on_bit_rangesi */
                  break;

                case 1:
                  if (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                    return 386; /* *branch_on_bit_rangedi */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
    }
  if (!ne_operator (x4, E_VOIDmode))
    return -1;
  switch (pattern406 (x3))
    {
    case 0:
      if (!(
#line 3398 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
        return -1;
      return 377; /* *cbranchsf4 */

    case 1:
      if (!(
#line 3398 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 378; /* *cbranchsf4 */

    case 2:
      if (!(
#line 3398 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
        return -1;
      return 379; /* *cbranchdf4 */

    case 3:
      if (!(
#line 3398 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 380; /* *cbranchdf4 */

    case 4:
      if (!(
#line 3398 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
        return -1;
      return 381; /* *cbranchhf4 */

    case 5:
      if (!(
#line 3398 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 382; /* *cbranchhf4 */

    default:
      return -1;
    }
}

 int
recog_1524 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_1523 (x1, insn, pnum_clobbers);

    case SIMPLE_RETURN:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != USE)
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (!pmode_register_operand (operands[0], E_VOIDmode))
        return -1;
      return 450; /* simple_return_internal */

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[0] = x5;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !scratch_operand (operands[1], E_SImode)
              || !
#line 3876 "../../gcc/config/riscv/riscv.md"
(! TARGET_64BIT))
            return -1;
          return 451; /* eh_set_lr_si */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !scratch_operand (operands[1], E_DImode)
              || !
#line 3883 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 452; /* eh_set_lr_di */

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (pattern267 (x3) != 0)
        return -1;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!call_insn_operand (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[1] = x8;
      x4 = XEXP (x3, 0);
      x9 = XVECEXP (x4, 0, 0);
      operands[2] = x9;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      if (
#line 3932 "../../gcc/config/riscv/riscv.md"
(SIBLING_CALL_P (insn)))
        return 454; /* sibcall_internal */
      if (pnum_clobbers == NULL)
        return -1;
      *pnum_clobbers = 1;
      return 456; /* call_internal */

    case RETURN:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != UNSPEC_VOLATILE
          || XVECLEN (x3, 0) != 1)
        return -1;
      x10 = XVECEXP (x3, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x3, 1))
        {
        case 7:
          return 470; /* riscv_mret */

        case 8:
          return 471; /* riscv_sret */

        case 9:
          return 472; /* riscv_uret */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1525 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case IF_THEN_ELSE:
          if (pattern220 (x2) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x3, 0);
          x7 = XEXP (x6, 0);
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          switch (pattern424 (x1))
            {
            case 0:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 345; /* *branchqi_shiftedarith_eq_shifted */
              break;

            case 1:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 353; /* *branchqi_shiftedarith_eq_shifted */
              break;

            case 2:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 347; /* *branchhi_shiftedarith_eq_shifted */
              break;

            case 3:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 355; /* *branchhi_shiftedarith_eq_shifted */
              break;

            case 4:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 349; /* *branchsi_shiftedarith_eq_shifted */
              break;

            case 5:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 357; /* *branchsi_shiftedarith_eq_shifted */
              break;

            case 6:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && ((((
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
                return 351; /* *branchdi_shiftedarith_eq_shifted */
              break;

            case 7:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 359; /* *branchdi_shiftedarith_eq_shifted */
              break;

            case 8:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 346; /* *branchqi_shiftedarith_ne_shifted */
              break;

            case 9:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 354; /* *branchqi_shiftedarith_ne_shifted */
              break;

            case 10:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 348; /* *branchhi_shiftedarith_ne_shifted */
              break;

            case 11:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 356; /* *branchhi_shiftedarith_ne_shifted */
              break;

            case 12:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 350; /* *branchsi_shiftedarith_ne_shifted */
              break;

            case 13:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 358; /* *branchsi_shiftedarith_ne_shifted */
              break;

            case 14:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && ((((
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
                return 352; /* *branchdi_shiftedarith_ne_shifted */
              break;

            case 15:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 360; /* *branchdi_shiftedarith_ne_shifted */
              break;

            default:
              break;
            }
          operands[1] = x6;
          switch (pattern426 (x1))
            {
            case 0:
              if (!(
#line 1099 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 651; /* *branchsi_mask_twobits_equals_singlebit */

            case 1:
              if (!(
#line 1099 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 652; /* *branchdi_mask_twobits_equals_singlebit */

            default:
              return -1;
            }

        case CALL:
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_SImode
              || pattern268 (x1) != 0)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!call_insn_operand (operands[1], E_VOIDmode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          x4 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x4, 0);
          x12 = XVECEXP (x11, 0, 0);
          operands[3] = x12;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          return 457; /* call_value_internal */

        case SUBREG:
        case MEM:
          operands[1] = x3;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x13 = XEXP (x4, 1);
          if (GET_CODE (x13) != UNSPEC_VOLATILE)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          switch (pattern369 (x4))
            {
            case 0:
              switch (XINT (x13, 1))
                {
                case 80:
                  x5 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x5) != CLOBBER)
                    return -1;
                  x14 = XEXP (x5, 0);
                  operands[4] = x14;
                  x15 = XVECEXP (x13, 0, 0);
                  switch (GET_CODE (x15))
                    {
                    case PLUS:
                      switch (pattern456 (x13))
                        {
                        case 0:
                          if (!
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                            return -1;
                          return 752; /* lrsc_atomic_fetch_addsi */

                        case 1:
                          if (!(
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                            return -1;
                          return 756; /* lrsc_atomic_fetch_adddi */

                        default:
                          return -1;
                        }

                    case IOR:
                      switch (pattern456 (x13))
                        {
                        case 0:
                          if (!
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                            return -1;
                          return 753; /* lrsc_atomic_fetch_orsi */

                        case 1:
                          if (!(
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                            return -1;
                          return 757; /* lrsc_atomic_fetch_ordi */

                        default:
                          return -1;
                        }

                    case XOR:
                      switch (pattern456 (x13))
                        {
                        case 0:
                          if (!
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                            return -1;
                          return 754; /* lrsc_atomic_fetch_xorsi */

                        case 1:
                          if (!(
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                            return -1;
                          return 758; /* lrsc_atomic_fetch_xordi */

                        default:
                          return -1;
                        }

                    case AND:
                      switch (pattern456 (x13))
                        {
                        case 0:
                          if (!
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                            return -1;
                          return 755; /* lrsc_atomic_fetch_andsi */

                        case 1:
                          if (!(
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                            return -1;
                          return 759; /* lrsc_atomic_fetch_anddi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 84:
                  if (pnum_clobbers == NULL
                      || GET_MODE (x13) != E_SImode
                      || !register_operand (operands[0], E_SImode)
                      || !memory_operand (operands[1], E_SImode))
                    return -1;
                  x15 = XVECEXP (x13, 0, 0);
                  operands[2] = x15;
                  if (!reg_or_0_operand (operands[2], E_SImode))
                    return -1;
                  x5 = XVECEXP (x1, 0, 2);
                  operands[4] = x5;
                  if (!reg_or_0_operand (operands[4], E_SImode)
                      || !
#line 493 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 779; /* subword_atomic_exchange_strong */

                default:
                  return -1;
                }

            case 1:
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x15 = XVECEXP (x13, 0, 0);
              operands[2] = x15;
              x16 = XVECEXP (x13, 0, 1);
              operands[3] = x16;
              x17 = XVECEXP (x13, 0, 2);
              operands[4] = x17;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x18 = XVECEXP (x13, 0, 3);
              operands[5] = x18;
              if (!const_int_operand (operands[5], E_SImode))
                return -1;
              x14 = XEXP (x5, 0);
              operands[6] = x14;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern547 (x13, 
E_SImode) != 0
                      || !
#line 517 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC))
                    return -1;
                  return 780; /* zalrsc_atomic_cas_value_strongsi */

                case E_DImode:
                  if (pattern547 (x13, 
E_DImode) != 0
                      || !(
#line 517 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 781; /* zalrsc_atomic_cas_value_strongdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x3, 0) != 2
              || XINT (x3, 1) != 83)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x19 = XVECEXP (x3, 0, 0);
          operands[1] = x19;
          x20 = XVECEXP (x3, 0, 1);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x13 = XEXP (x4, 1);
          operands[2] = x13;
          x14 = XEXP (x5, 0);
          operands[4] = x14;
          x11 = XEXP (x4, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern457 (x3, 
E_SImode) != 0
                  || !
#line 410 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                return -1;
              return 775; /* lrsc_atomic_exchangesi */

            case E_DImode:
              if (pattern457 (x3, 
E_DImode) != 0
                  || !(
#line 410 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 776; /* lrsc_atomic_exchangedi */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 5
              || XINT (x3, 1) != 89)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x13 = XEXP (x4, 1);
          if (GET_CODE (x13) != UNSPEC
              || XVECLEN (x13, 0) != 3
              || XINT (x13, 1) != 89
              || GET_MODE (x13) != E_SImode)
            return -1;
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 66
              || GET_MODE (x11) != E_SImode)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != SET)
            return -1;
          x21 = XEXP (x5, 1);
          if (GET_CODE (x21) != UNSPEC
              || XVECLEN (x21, 0) != 4
              || XINT (x21, 1) != 89
              || GET_MODE (x21) != E_SImode)
            return -1;
          x14 = XEXP (x5, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 67
              || GET_MODE (x14) != E_SImode)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x19 = XVECEXP (x3, 0, 0);
          operands[1] = x19;
          x20 = XVECEXP (x3, 0, 1);
          operands[2] = x20;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x22 = XVECEXP (x3, 0, 2);
          operands[3] = x22;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x23 = XVECEXP (x3, 0, 3);
          operands[4] = x23;
          if (!const_int_operand (operands[4], E_VOIDmode))
            return -1;
          x24 = XVECEXP (x3, 0, 4);
          operands[5] = x24;
          if (!const_int_operand (operands[5], E_VOIDmode))
            return -1;
          x15 = XVECEXP (x13, 0, 0);
          if (!rtx_equal_p (x15, operands[1]))
            return -1;
          x16 = XVECEXP (x13, 0, 1);
          if (!rtx_equal_p (x16, operands[2]))
            return -1;
          x17 = XVECEXP (x13, 0, 2);
          if (!rtx_equal_p (x17, operands[3]))
            return -1;
          x25 = XVECEXP (x21, 0, 0);
          if (!rtx_equal_p (x25, operands[2]))
            return -1;
          x26 = XVECEXP (x21, 0, 1);
          if (!rtx_equal_p (x26, operands[3]))
            return -1;
          x27 = XVECEXP (x21, 0, 2);
          if (!rtx_equal_p (x27, operands[4]))
            return -1;
          x28 = XVECEXP (x21, 0, 3);
          if (!rtx_equal_p (x28, operands[5]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !vector_length_operand (operands[1], E_SImode)
                  || !(
#line 1725 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 3642; /* vsetvlsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !vector_length_operand (operands[1], E_DImode)
                  || !(
#line 1725 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 3643; /* vsetvldi */

            default:
              return -1;
            }

        case PLUS:
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != REG
              || pattern266 (x1, 
8) != 0)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != SET)
            return -1;
          x21 = XEXP (x5, 1);
          if (GET_CODE (x21) != MEM)
            return -1;
          x29 = XEXP (x21, 0);
          if (GET_CODE (x29) != PLUS)
            return -1;
          x30 = XEXP (x29, 0);
          if (GET_CODE (x30) != REG
              || REGNO (x30) != 2)
            return -1;
          x31 = XEXP (x29, 1);
          if (GET_CODE (x31) != CONST_INT)
            return -1;
          x14 = XEXP (x5, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 1)
            return -1;
          x10 = XEXP (x3, 1);
          operands[0] = x10;
          if (!stack_pop_up_to_s0_operand (operands[0], E_VOIDmode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          x13 = XEXP (x4, 1);
          x32 = XEXP (x13, 0);
          x33 = XEXP (x32, 1);
          switch (XWINT (x33, 0))
            {
            case -4L:
              if (XWINT (x31, 0) != -8L
                  || pattern690 (x1, 
E_SImode) != 0
                  || !(
#line 42 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33681; /* gpr_multi_pop_up_to_s0_si */

            case -8L:
              if (XWINT (x31, 0) != -16L
                  || pattern690 (x1, 
E_DImode) != 0
                  || !(
#line 42 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33682; /* gpr_multi_pop_up_to_s0_di */

            default:
              return -1;
            }

        case REG:
          if (pattern221 (x1, 
8) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (pattern413 (x4, 
1) != 0)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != SET)
            return -1;
          x21 = XEXP (x5, 1);
          if (GET_CODE (x21) != PLUS)
            return -1;
          x29 = XEXP (x21, 0);
          if (GET_CODE (x29) != REG
              || REGNO (x29) != 2)
            return -1;
          x14 = XEXP (x5, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 2)
            return -1;
          x34 = XEXP (x21, 1);
          operands[0] = x34;
          if (!stack_push_up_to_s0_operand (operands[0], E_VOIDmode))
            return -1;
          x9 = XEXP (x2, 0);
          x35 = XEXP (x9, 0);
          x36 = XEXP (x35, 1);
          switch (XWINT (x36, 0))
            {
            case -4L:
              x11 = XEXP (x4, 0);
              x37 = XEXP (x11, 0);
              x38 = XEXP (x37, 1);
              if (XWINT (x38, 0) != -8L
                  || pattern691 (x1, 
E_SImode) != 0
                  || !(
#line 1125 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33753; /* gpr_multi_push_up_to_s0_si */

            case -8L:
              x11 = XEXP (x4, 0);
              x37 = XEXP (x11, 0);
              x38 = XEXP (x37, 1);
              if (XWINT (x38, 0) != -16L
                  || pattern691 (x1, 
E_DImode) != 0
                  || !(
#line 1125 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33754; /* gpr_multi_push_up_to_s0_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x9 = XEXP (x2, 0);
      if (GET_CODE (x9) != MEM
          || GET_MODE (x9) != E_SImode
          || pattern268 (x1) != 0)
        return -1;
      x35 = XEXP (x9, 0);
      operands[0] = x35;
      if (!call_insn_operand (operands[0], E_VOIDmode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x4 = XVECEXP (x1, 0, 1);
      x11 = XEXP (x4, 0);
      x12 = XVECEXP (x11, 0, 0);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      return 456; /* call_internal */

    case RETURN:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XEXP (x4, 0);
      operands[0] = x11;
      if (!pmode_register_operand (operands[0], E_VOIDmode))
        return -1;
      return 462; /* gpr_restore_return */

    default:
      return -1;
    }
}

 int
recog_1538 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74, x75, x76;
  int res ATTRIBUTE_UNUSED;
  if (pattern115 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case PLUS:
      if (pattern427 (x1) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 8);
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != MEM)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 2)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != REG
          || pattern754 (x2) != 0)
        return -1;
      x12 = XEXP (x3, 0);
      if (GET_CODE (x12) != REG)
        return -1;
      x13 = XEXP (x5, 1);
      operands[0] = x13;
      switch (pattern761 (x1))
        {
        case 0:
          switch (pattern768 (x1, 
E_SImode))
            {
            case 0:
              if (pattern790 (x1, 
18, 
19, 
20, 
21, 
22) != 0
                  || pattern795 (x1, 
E_SImode, 
SET, 
9) != 0)
                return -1;
              x14 = XVECEXP (x1, 0, 12);
              x15 = XEXP (x14, 1);
              if (pattern797 (x15) != 0)
                return -1;
              x16 = XEXP (x14, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 8
                  || GET_MODE (x16) != E_SImode)
                return -1;
              x17 = XVECEXP (x1, 0, 13);
              if (pattern800 (x17) != 0
                  || !(
#line 350 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33701; /* gpr_multi_pop_up_to_s11_si */

            case 1:
              if (pattern790 (x1, 
8, 
9, 
18, 
19, 
20) != 0
                  || pattern796 (x1, 
E_SImode) != 0
                  || !(
#line 658 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33723; /* gpr_multi_popret_up_to_s9_si */

            case 2:
              if (!(
#line 959 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33743; /* gpr_multi_popretz_up_to_s7_si */

            default:
              return -1;
            }

        case 1:
          switch (pattern768 (x1, 
E_DImode))
            {
            case 0:
              if (pattern792 (x1, 
18, 
19, 
20, 
21, 
22) != 0
                  || pattern795 (x1, 
E_DImode, 
SET, 
9) != 0)
                return -1;
              x14 = XVECEXP (x1, 0, 12);
              x15 = XEXP (x14, 1);
              if (pattern798 (x15) != 0)
                return -1;
              x16 = XEXP (x14, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 8
                  || GET_MODE (x16) != E_DImode)
                return -1;
              x17 = XVECEXP (x1, 0, 13);
              if (pattern801 (x17) != 0
                  || !(
#line 350 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33702; /* gpr_multi_pop_up_to_s11_di */

            case 1:
              if (pattern792 (x1, 
8, 
9, 
18, 
19, 
20) != 0
                  || pattern796 (x1, 
E_DImode) != 0
                  || !(
#line 658 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33724; /* gpr_multi_popret_up_to_s9_di */

            case 2:
              if (!(
#line 959 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33744; /* gpr_multi_popretz_up_to_s7_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x5) != 27)
        return -1;
      x18 = XEXP (x4, 0);
      if (GET_CODE (x18) != MEM)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != PLUS)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 2)
        return -1;
      x21 = XEXP (x19, 1);
      if (GET_CODE (x21) != CONST_INT)
        return -1;
      x22 = XVECEXP (x1, 0, 1);
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != REG
          || REGNO (x23) != 26)
        return -1;
      x24 = XEXP (x22, 0);
      if (GET_CODE (x24) != MEM)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != PLUS)
        return -1;
      x26 = XEXP (x25, 0);
      if (GET_CODE (x26) != REG
          || REGNO (x26) != 2)
        return -1;
      x27 = XEXP (x25, 1);
      if (GET_CODE (x27) != CONST_INT)
        return -1;
      x28 = XVECEXP (x1, 0, 2);
      x29 = XEXP (x28, 1);
      if (GET_CODE (x29) != REG
          || REGNO (x29) != 25)
        return -1;
      x30 = XEXP (x28, 0);
      if (GET_CODE (x30) != MEM)
        return -1;
      x31 = XEXP (x30, 0);
      if (GET_CODE (x31) != PLUS)
        return -1;
      x32 = XEXP (x31, 0);
      if (GET_CODE (x32) != REG
          || REGNO (x32) != 2)
        return -1;
      x33 = XEXP (x31, 1);
      if (GET_CODE (x33) != CONST_INT)
        return -1;
      x34 = XVECEXP (x1, 0, 3);
      x35 = XEXP (x34, 1);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 24)
        return -1;
      x36 = XEXP (x34, 0);
      if (GET_CODE (x36) != MEM)
        return -1;
      x37 = XEXP (x36, 0);
      if (GET_CODE (x37) != PLUS)
        return -1;
      x38 = XEXP (x37, 0);
      if (GET_CODE (x38) != REG
          || REGNO (x38) != 2)
        return -1;
      x39 = XEXP (x37, 1);
      if (GET_CODE (x39) != CONST_INT)
        return -1;
      x40 = XVECEXP (x1, 0, 4);
      x41 = XEXP (x40, 1);
      if (GET_CODE (x41) != REG
          || REGNO (x41) != 23)
        return -1;
      x42 = XEXP (x40, 0);
      if (GET_CODE (x42) != MEM)
        return -1;
      x43 = XEXP (x42, 0);
      if (GET_CODE (x43) != PLUS)
        return -1;
      x44 = XEXP (x43, 0);
      if (GET_CODE (x44) != REG
          || REGNO (x44) != 2)
        return -1;
      x45 = XEXP (x43, 1);
      if (GET_CODE (x45) != CONST_INT)
        return -1;
      x46 = XVECEXP (x1, 0, 5);
      x47 = XEXP (x46, 1);
      if (GET_CODE (x47) != REG
          || REGNO (x47) != 22)
        return -1;
      x48 = XEXP (x46, 0);
      if (GET_CODE (x48) != MEM)
        return -1;
      x49 = XEXP (x48, 0);
      if (GET_CODE (x49) != PLUS)
        return -1;
      x50 = XEXP (x49, 0);
      if (GET_CODE (x50) != REG
          || REGNO (x50) != 2)
        return -1;
      x51 = XEXP (x49, 1);
      if (GET_CODE (x51) != CONST_INT)
        return -1;
      x52 = XVECEXP (x1, 0, 6);
      x53 = XEXP (x52, 1);
      if (GET_CODE (x53) != REG
          || REGNO (x53) != 21)
        return -1;
      x54 = XEXP (x52, 0);
      if (GET_CODE (x54) != MEM)
        return -1;
      x55 = XEXP (x54, 0);
      if (GET_CODE (x55) != PLUS)
        return -1;
      x56 = XEXP (x55, 0);
      if (GET_CODE (x56) != REG
          || REGNO (x56) != 2)
        return -1;
      x57 = XEXP (x55, 1);
      if (GET_CODE (x57) != CONST_INT)
        return -1;
      x58 = XVECEXP (x1, 0, 7);
      x59 = XEXP (x58, 1);
      if (GET_CODE (x59) != REG
          || REGNO (x59) != 20)
        return -1;
      x60 = XEXP (x58, 0);
      if (GET_CODE (x60) != MEM)
        return -1;
      x61 = XEXP (x60, 0);
      if (GET_CODE (x61) != PLUS)
        return -1;
      x62 = XEXP (x61, 0);
      if (GET_CODE (x62) != REG
          || REGNO (x62) != 2)
        return -1;
      x63 = XEXP (x61, 1);
      if (GET_CODE (x63) != CONST_INT)
        return -1;
      x6 = XVECEXP (x1, 0, 8);
      if (pattern756 (x6, 
19) != 0
          || pattern757 (x2, 
18) != 0
          || pattern766 (x3, 
9) != 0)
        return -1;
      x64 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x64) != SET)
        return -1;
      x65 = XEXP (x64, 1);
      if (GET_CODE (x65) != REG
          || REGNO (x65) != 8)
        return -1;
      x66 = XEXP (x64, 0);
      if (GET_CODE (x66) != MEM)
        return -1;
      x67 = XEXP (x66, 0);
      if (GET_CODE (x67) != PLUS)
        return -1;
      x68 = XEXP (x67, 0);
      if (GET_CODE (x68) != REG
          || REGNO (x68) != 2)
        return -1;
      x69 = XEXP (x67, 1);
      if (GET_CODE (x69) != CONST_INT)
        return -1;
      x14 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x14) != SET)
        return -1;
      x15 = XEXP (x14, 1);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 1)
        return -1;
      x16 = XEXP (x14, 0);
      if (GET_CODE (x16) != MEM)
        return -1;
      x70 = XEXP (x16, 0);
      if (GET_CODE (x70) != PLUS)
        return -1;
      x71 = XEXP (x70, 0);
      if (GET_CODE (x71) != REG
          || REGNO (x71) != 2)
        return -1;
      x72 = XEXP (x70, 1);
      if (GET_CODE (x72) != CONST_INT)
        return -1;
      x17 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x17) != SET)
        return -1;
      x73 = XEXP (x17, 1);
      if (GET_CODE (x73) != PLUS)
        return -1;
      x74 = XEXP (x73, 0);
      if (GET_CODE (x74) != REG
          || REGNO (x74) != 2)
        return -1;
      x75 = XEXP (x17, 0);
      if (GET_CODE (x75) != REG
          || REGNO (x75) != 2)
        return -1;
      x76 = XEXP (x73, 1);
      operands[0] = x76;
      if (!stack_push_up_to_s11_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern771 (x1))
        {
        case 0:
          if (XWINT (x69, 0) != -48L
              || XWINT (x72, 0) != -52L
              || pattern788 (x1, 
E_SImode) != 0
              || !(
#line 1433 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33773; /* gpr_multi_push_up_to_s11_si */

        case 1:
          if (XWINT (x69, 0) != -96L
              || XWINT (x72, 0) != -104L
              || pattern788 (x1, 
E_DImode) != 0
              || !(
#line 1433 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33774; /* gpr_multi_push_up_to_s11_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern231 (x2))
    {
    case 0:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9171 (insn, operands);

    case 1:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9173 (insn, operands);

    case 2:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9175 (insn, operands);

    case 3:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9177 (insn, operands);

    case 4:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9179 (insn, operands);

    case 5:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9181 (insn, operands);

    case 6:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9183 (insn, operands);

    case 7:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9185 (insn, operands);

    case 8:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9187 (insn, operands);

    case 9:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9189 (insn, operands);

    case 10:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9191 (insn, operands);

    case 11:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9193 (insn, operands);

    case 12:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9195 (insn, operands);

    case 13:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9197 (insn, operands);

    case 14:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9199 (insn, operands);

    case 15:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9201 (insn, operands);

    case 16:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9203 (insn, operands);

    case 17:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9205 (insn, operands);

    case 18:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9207 (insn, operands);

    case 19:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9209 (insn, operands);

    case 20:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9211 (insn, operands);

    case 21:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9213 (insn, operands);

    case 22:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9215 (insn, operands);

    case 23:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9217 (insn, operands);

    case 24:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9219 (insn, operands);

    case 25:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9221 (insn, operands);

    case 26:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9223 (insn, operands);

    case 27:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9225 (insn, operands);

    case 28:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9227 (insn, operands);

    case 29:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9229 (insn, operands);

    case 30:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9231 (insn, operands);

    case 31:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9233 (insn, operands);

    case 32:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9235 (insn, operands);

    case 33:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9237 (insn, operands);

    case 34:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9239 (insn, operands);

    case 35:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9241 (insn, operands);

    case 36:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9243 (insn, operands);

    case 37:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9245 (insn, operands);

    case 38:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9247 (insn, operands);

    case 39:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9249 (insn, operands);

    case 40:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9251 (insn, operands);

    case 41:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9253 (insn, operands);

    case 42:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9255 (insn, operands);

    case 43:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9257 (insn, operands);

    case 44:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9259 (insn, operands);

    case 45:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9261 (insn, operands);

    case 46:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9263 (insn, operands);

    case 47:
      if (!((
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 909 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9265 (insn, operands);

    case 48:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9314 (insn, operands);

    case 49:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9315 (insn, operands);

    case 50:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9316 (insn, operands);

    case 51:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9317 (insn, operands);

    case 52:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9318 (insn, operands);

    case 53:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9319 (insn, operands);

    case 54:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9320 (insn, operands);

    case 55:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9321 (insn, operands);

    case 56:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9322 (insn, operands);

    case 57:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9323 (insn, operands);

    case 58:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9324 (insn, operands);

    case 59:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9325 (insn, operands);

    case 60:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9326 (insn, operands);

    case 61:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9327 (insn, operands);

    case 62:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9328 (insn, operands);

    case 63:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9329 (insn, operands);

    case 64:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9330 (insn, operands);

    case 65:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9331 (insn, operands);

    case 66:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9332 (insn, operands);

    case 67:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9333 (insn, operands);

    case 68:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9334 (insn, operands);

    case 69:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9335 (insn, operands);

    case 70:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9336 (insn, operands);

    case 71:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9337 (insn, operands);

    case 72:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9338 (insn, operands);

    case 73:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9339 (insn, operands);

    case 74:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9340 (insn, operands);

    case 75:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9341 (insn, operands);

    case 76:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9342 (insn, operands);

    case 77:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9343 (insn, operands);

    case 78:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9344 (insn, operands);

    case 79:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9345 (insn, operands);

    case 80:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9346 (insn, operands);

    case 81:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9347 (insn, operands);

    case 82:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9348 (insn, operands);

    case 83:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9349 (insn, operands);

    case 84:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9350 (insn, operands);

    case 85:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9351 (insn, operands);

    case 86:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9352 (insn, operands);

    case 87:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9353 (insn, operands);

    case 88:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9354 (insn, operands);

    case 89:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9355 (insn, operands);

    case 90:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9356 (insn, operands);

    case 91:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9357 (insn, operands);

    case 92:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9358 (insn, operands);

    case 93:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9359 (insn, operands);

    case 94:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9360 (insn, operands);

    case 95:
      if (!((
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 953 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9361 (insn, operands);

    case 96:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9363 (insn, operands);

    case 97:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9365 (insn, operands);

    case 98:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9367 (insn, operands);

    case 99:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9369 (insn, operands);

    case 100:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9371 (insn, operands);

    case 101:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9373 (insn, operands);

    case 102:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9375 (insn, operands);

    case 103:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9377 (insn, operands);

    case 104:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9379 (insn, operands);

    case 105:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9381 (insn, operands);

    case 106:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9383 (insn, operands);

    case 107:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9385 (insn, operands);

    case 108:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9387 (insn, operands);

    case 109:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9389 (insn, operands);

    case 110:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9391 (insn, operands);

    case 111:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9393 (insn, operands);

    case 112:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9395 (insn, operands);

    case 113:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9397 (insn, operands);

    case 114:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9399 (insn, operands);

    case 115:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9401 (insn, operands);

    case 116:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9403 (insn, operands);

    case 117:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9405 (insn, operands);

    case 118:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9407 (insn, operands);

    case 119:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9409 (insn, operands);

    case 120:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9411 (insn, operands);

    case 121:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9413 (insn, operands);

    case 122:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9415 (insn, operands);

    case 123:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9417 (insn, operands);

    case 124:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9419 (insn, operands);

    case 125:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9421 (insn, operands);

    case 126:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9423 (insn, operands);

    case 127:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9425 (insn, operands);

    case 128:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9427 (insn, operands);

    case 129:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9429 (insn, operands);

    case 130:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9431 (insn, operands);

    case 131:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9433 (insn, operands);

    case 132:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9435 (insn, operands);

    case 133:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9437 (insn, operands);

    case 134:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9439 (insn, operands);

    case 135:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9441 (insn, operands);

    case 136:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9443 (insn, operands);

    case 137:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9445 (insn, operands);

    case 138:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9447 (insn, operands);

    case 139:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9449 (insn, operands);

    case 140:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9451 (insn, operands);

    case 141:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9453 (insn, operands);

    case 142:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9455 (insn, operands);

    case 143:
      if (!((
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 977 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9457 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_25 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16DImode)
      && reg_or_mem_operand (operands[1], E_V16DImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return gen_split_284 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16DImode)
       || register_operand (operands[1], V16DImode))) && 
#line 4323 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16DImode)
       || !register_operand (operands[1], V16DImode)))))
        return gen_split_1966 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16DImode)
      || !register_operand (operands[1], E_V16DImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2131 (insn, operands);
}

 rtx_insn *
split_30 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16SImode)
      && reg_or_mem_operand (operands[1], E_V16SImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return gen_split_273 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16SImode)
       || register_operand (operands[1], V16SImode))) && 
#line 4318 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16SImode)
       || !register_operand (operands[1], V16SImode)))))
        return gen_split_1961 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16SImode)
      || !register_operand (operands[1], E_V16SImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2120 (insn, operands);
}

 rtx_insn *
split_38 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2HImode)
      && reg_or_mem_operand (operands[1], E_V2HImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return gen_split_258 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2HImode)
       || register_operand (operands[1], V2HImode))) && 
#line 4310 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2HImode)
       || !register_operand (operands[1], V2HImode)))))
        return gen_split_1953 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2HImode)
      || !register_operand (operands[1], E_V2HImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2105 (insn, operands);
}

 rtx_insn *
split_44 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1QImode)
      && reg_or_mem_operand (operands[1], E_V1QImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return gen_split_244 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1QImode)
       || register_operand (operands[1], V1QImode))) && 
#line 4304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1QImode)
       || !register_operand (operands[1], V1QImode)))))
        return gen_split_1947 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1QImode)
      || !register_operand (operands[1], E_V1QImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2091 (insn, operands);
}

 rtx_insn *
split_50 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V512DFmode)
      && reg_or_mem_operand (operands[1], E_V512DFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return gen_split_322 (insn, operands);
  if (!register_operand (operands[0], E_V512DFmode)
      || !register_operand (operands[1], E_V512DFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2169 (insn, operands);
}

 rtx_insn *
split_54 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32DFmode)
      && reg_or_mem_operand (operands[1], E_V32DFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return gen_split_318 (insn, operands);
  if (!register_operand (operands[0], E_V32DFmode)
      || !register_operand (operands[1], E_V32DFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2165 (insn, operands);
}

 rtx_insn *
split_60 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32SFmode)
      && reg_or_mem_operand (operands[1], E_V32SFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return gen_split_307 (insn, operands);
  if (!register_operand (operands[0], E_V32SFmode)
      || !register_operand (operands[1], E_V32SFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2154 (insn, operands);
}

 rtx_insn *
split_66 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64HFmode)
      && reg_or_mem_operand (operands[1], E_V64HFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
    return gen_split_296 (insn, operands);
  if (!register_operand (operands[0], E_V64HFmode)
      || !register_operand (operands[1], E_V64HFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2143 (insn, operands);
}

 rtx_insn *
split_72 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32DImode)
      && reg_or_mem_operand (operands[1], E_V32DImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return gen_split_285 (insn, operands);
  if (!register_operand (operands[0], E_V32DImode)
      || !register_operand (operands[1], E_V32DImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2132 (insn, operands);
}

 rtx_insn *
split_79 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2048HImode)
      && reg_or_mem_operand (operands[1], E_V2048HImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return gen_split_268 (insn, operands);
  if (!register_operand (operands[0], E_V2048HImode)
      || !register_operand (operands[1], E_V2048HImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2115 (insn, operands);
}

 rtx_insn *
split_86 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4096QImode)
      && reg_or_mem_operand (operands[1], E_V4096QImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return gen_split_256 (insn, operands);
  if (!register_operand (operands[0], E_V4096QImode)
      || !register_operand (operands[1], E_V4096QImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2103 (insn, operands);
}

 rtx_insn *
split_93 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32QImode)
      && reg_or_mem_operand (operands[1], E_V32QImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return gen_split_249 (insn, operands);
  if (!register_operand (operands[0], E_V32QImode)
      || !register_operand (operands[1], E_V32QImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2096 (insn, operands);
}

 rtx_insn *
split_102 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF4HFmode)
      && reg_or_mem_operand (operands[1], E_RVVMF4HFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
    return gen_split_227 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF4HFmode)
      || !register_operand (operands[1], E_RVVMF4HFmode)
      || !((
#line 1257 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 938 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 1259 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1571 (insn, operands);
}

 rtx_insn *
split_110 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !splittable_const_int_operand (operands[1], E_SImode)
          || !(
#line 2471 "../../gcc/config/riscv/riscv.md"
(!ira_in_progress
   && !(p2m1_shift_operand (operands[1], SImode)
	|| high_mask_shift_operand (operands[1], SImode)
	|| exact_log2 (INTVAL (operands[1])) >= 0)) && 
#line 2476 "../../gcc/config/riscv/riscv.md"
( 1)))
        return NULL;
      return gen_split_18 (insn, operands);

    case E_DImode:
      return split_109 (x1, insn);

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !move_operand (operands[1], E_DFmode)
          || !
#line 2733 "../../gcc/config/riscv/riscv.md"
(reload_completed
   && riscv_split_64bit_move_p (operands[0], operands[1])))
        return NULL;
      return gen_split_21 (insn, operands);

    case E_RVVM8QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM8QImode))
        return NULL;
      if (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_197 (insn, operands);
      if (!(
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8QImode)
   && !memory_operand (operands[1], RVVM8QImode))))
        return NULL;
      return gen_split_1531 (insn, operands);

    case E_RVVM4QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4QImode))
        return NULL;
      if (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_198 (insn, operands);
      if (!(
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4QImode)
   && !memory_operand (operands[1], RVVM4QImode))))
        return NULL;
      return gen_split_1532 (insn, operands);

    case E_RVVM2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2QImode))
        return NULL;
      if (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_199 (insn, operands);
      if (!(
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2QImode)
   && !memory_operand (operands[1], RVVM2QImode))))
        return NULL;
      return gen_split_1533 (insn, operands);

    case E_RVVM1QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1QImode))
        return NULL;
      if (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_200 (insn, operands);
      if (!(
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1QImode)
   && !memory_operand (operands[1], RVVM1QImode))))
        return NULL;
      return gen_split_1534 (insn, operands);

    case E_RVVM8HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM8HImode))
        return NULL;
      if (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_201 (insn, operands);
      if (!(
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8HImode)
   && !memory_operand (operands[1], RVVM8HImode))))
        return NULL;
      return gen_split_1535 (insn, operands);

    case E_RVVM4HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4HImode))
        return NULL;
      if (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_202 (insn, operands);
      if (!(
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4HImode)
   && !memory_operand (operands[1], RVVM4HImode))))
        return NULL;
      return gen_split_1536 (insn, operands);

    case E_RVVM2HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2HImode))
        return NULL;
      if (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_203 (insn, operands);
      if (!(
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2HImode)
   && !memory_operand (operands[1], RVVM2HImode))))
        return NULL;
      return gen_split_1537 (insn, operands);

    case E_RVVM1HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1HImode))
        return NULL;
      if (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_204 (insn, operands);
      if (!(
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1HImode)
   && !memory_operand (operands[1], RVVM1HImode))))
        return NULL;
      return gen_split_1538 (insn, operands);

    case E_RVVM8SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM8SImode))
        return NULL;
      if (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_205 (insn, operands);
      if (!(
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8SImode)
   && !memory_operand (operands[1], RVVM8SImode))))
        return NULL;
      return gen_split_1547 (insn, operands);

    case E_RVVM4SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4SImode))
        return NULL;
      if (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_206 (insn, operands);
      if (!(
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4SImode)
   && !memory_operand (operands[1], RVVM4SImode))))
        return NULL;
      return gen_split_1548 (insn, operands);

    case E_RVVM2SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2SImode))
        return NULL;
      if (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_207 (insn, operands);
      if (!(
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2SImode)
   && !memory_operand (operands[1], RVVM2SImode))))
        return NULL;
      return gen_split_1549 (insn, operands);

    case E_RVVM1SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1SImode))
        return NULL;
      if (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return gen_split_208 (insn, operands);
      if (!(
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1SImode)
   && !memory_operand (operands[1], RVVM1SImode))))
        return NULL;
      return gen_split_1550 (insn, operands);

    case E_RVVM8DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM8DImode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return gen_split_209 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 924 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8DImode)
   && !memory_operand (operands[1], RVVM8DImode))))
        return NULL;
      return gen_split_1555 (insn, operands);

    case E_RVVM4DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4DImode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return gen_split_210 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 924 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4DImode)
   && !memory_operand (operands[1], RVVM4DImode))))
        return NULL;
      return gen_split_1556 (insn, operands);

    case E_RVVM2DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2DImode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return gen_split_211 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 925 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2DImode)
   && !memory_operand (operands[1], RVVM2DImode))))
        return NULL;
      return gen_split_1557 (insn, operands);

    case E_RVVM1DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1DImode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return gen_split_212 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 925 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1DImode)
   && !memory_operand (operands[1], RVVM1DImode))))
        return NULL;
      return gen_split_1558 (insn, operands);

    case E_RVVMF8QImode:
      return split_108 (x1, insn);

    case E_RVVMF4HImode:
      return split_107 (x1, insn);

    case E_RVVMF2SImode:
      return split_106 (x1, insn);

    case E_RVVM8BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM8BFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return gen_split_216 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 913 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8BFmode)
   && !memory_operand (operands[1], RVVM8BFmode))))
        return NULL;
      return gen_split_1539 (insn, operands);

    case E_RVVM4BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4BFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return gen_split_217 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 913 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4BFmode)
   && !memory_operand (operands[1], RVVM4BFmode))))
        return NULL;
      return gen_split_1540 (insn, operands);

    case E_RVVM2BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2BFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return gen_split_218 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 914 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2BFmode)
   && !memory_operand (operands[1], RVVM2BFmode))))
        return NULL;
      return gen_split_1541 (insn, operands);

    case E_RVVM1BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1BFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return gen_split_219 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 914 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1BFmode)
   && !memory_operand (operands[1], RVVM1BFmode))))
        return NULL;
      return gen_split_1542 (insn, operands);

    case E_RVVMF2BFmode:
      return split_105 (x1, insn);

    case E_RVVMF4BFmode:
      return split_104 (x1, insn);

    case E_RVVM8HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM8HFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_222 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 916 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8HFmode)
   && !memory_operand (operands[1], RVVM8HFmode))))
        return NULL;
      return gen_split_1543 (insn, operands);

    case E_RVVM4HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4HFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_223 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 916 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4HFmode)
   && !memory_operand (operands[1], RVVM4HFmode))))
        return NULL;
      return gen_split_1544 (insn, operands);

    case E_RVVM2HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2HFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_224 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 917 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2HFmode)
   && !memory_operand (operands[1], RVVM2HFmode))))
        return NULL;
      return gen_split_1545 (insn, operands);

    case E_RVVM1HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1HFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_225 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 917 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1HFmode)
   && !memory_operand (operands[1], RVVM1HFmode))))
        return NULL;
      return gen_split_1546 (insn, operands);

    case E_RVVMF2HFmode:
      return split_103 (x1, insn);

    case E_RVVMF4HFmode:
      return split_102 (x1, insn);

    case E_RVVM8SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM8SFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_228 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 921 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8SFmode)
   && !memory_operand (operands[1], RVVM8SFmode))))
        return NULL;
      return gen_split_1551 (insn, operands);

    case E_RVVM4SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4SFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_229 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 921 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4SFmode)
   && !memory_operand (operands[1], RVVM4SFmode))))
        return NULL;
      return gen_split_1552 (insn, operands);

    case E_RVVM2SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2SFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_230 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 922 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2SFmode)
   && !memory_operand (operands[1], RVVM2SFmode))))
        return NULL;
      return gen_split_1553 (insn, operands);

    case E_RVVM1SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1SFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_231 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 922 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1SFmode)
   && !memory_operand (operands[1], RVVM1SFmode))))
        return NULL;
      return gen_split_1554 (insn, operands);

    case E_RVVMF2SFmode:
      return split_101 (x1, insn);

    case E_RVVM8DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM8DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM8DFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_233 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 927 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM8DFmode)
   && !memory_operand (operands[1], RVVM8DFmode))))
        return NULL;
      return gen_split_1559 (insn, operands);

    case E_RVVM4DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4DFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_234 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 927 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM4DFmode)
   && !memory_operand (operands[1], RVVM4DFmode))))
        return NULL;
      return gen_split_1560 (insn, operands);

    case E_RVVM2DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2DFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_235 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 928 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM2DFmode)
   && !memory_operand (operands[1], RVVM2DFmode))))
        return NULL;
      return gen_split_1561 (insn, operands);

    case E_RVVM1DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1DFmode))
        return NULL;
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_236 (insn, operands);
      if (!((
#line 1222 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 928 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1227 "../../gcc/config/riscv/vector.md"
( !memory_operand (operands[0], RVVM1DFmode)
   && !memory_operand (operands[1], RVVM1DFmode))))
        return NULL;
      return gen_split_1562 (insn, operands);

    case E_RVVMF64BImode:
      return split_100 (x1, insn);

    case E_RVVMF32BImode:
      return split_99 (x1, insn);

    case E_RVVMF16BImode:
      return split_98 (x1, insn);

    case E_RVVMF8BImode:
      return split_97 (x1, insn);

    case E_RVVMF4BImode:
      return split_96 (x1, insn);

    case E_RVVMF2BImode:
      return split_95 (x1, insn);

    case E_RVVM1BImode:
      return split_94 (x1, insn);

    case E_V1QImode:
      return split_44 (x1, insn);

    case E_V2QImode:
      return split_43 (x1, insn);

    case E_V4QImode:
      return split_42 (x1, insn);

    case E_V8QImode:
      return split_41 (x1, insn);

    case E_V16QImode:
      return split_40 (x1, insn);

    case E_V32QImode:
      return split_93 (x1, insn);

    case E_V64QImode:
      return split_92 (x1, insn);

    case E_V128QImode:
      return split_91 (x1, insn);

    case E_V256QImode:
      return split_90 (x1, insn);

    case E_V512QImode:
      return split_89 (x1, insn);

    case E_V1024QImode:
      return split_88 (x1, insn);

    case E_V2048QImode:
      return split_87 (x1, insn);

    case E_V4096QImode:
      return split_86 (x1, insn);

    case E_V1HImode:
      return split_39 (x1, insn);

    case E_V2HImode:
      return split_38 (x1, insn);

    case E_V4HImode:
      return split_37 (x1, insn);

    case E_V8HImode:
      return split_36 (x1, insn);

    case E_V16HImode:
      return split_35 (x1, insn);

    case E_V32HImode:
      return split_85 (x1, insn);

    case E_V64HImode:
      return split_84 (x1, insn);

    case E_V128HImode:
      return split_83 (x1, insn);

    case E_V256HImode:
      return split_82 (x1, insn);

    case E_V512HImode:
      return split_81 (x1, insn);

    case E_V1024HImode:
      return split_80 (x1, insn);

    case E_V2048HImode:
      return split_79 (x1, insn);

    case E_V1SImode:
      return split_34 (x1, insn);

    case E_V2SImode:
      return split_33 (x1, insn);

    case E_V4SImode:
      return split_32 (x1, insn);

    case E_V8SImode:
      return split_31 (x1, insn);

    case E_V16SImode:
      return split_30 (x1, insn);

    case E_V32SImode:
      return split_78 (x1, insn);

    case E_V64SImode:
      return split_77 (x1, insn);

    case E_V128SImode:
      return split_76 (x1, insn);

    case E_V256SImode:
      return split_75 (x1, insn);

    case E_V512SImode:
      return split_74 (x1, insn);

    case E_V1024SImode:
      return split_73 (x1, insn);

    case E_V1DImode:
      return split_29 (x1, insn);

    case E_V2DImode:
      return split_28 (x1, insn);

    case E_V4DImode:
      return split_27 (x1, insn);

    case E_V8DImode:
      return split_26 (x1, insn);

    case E_V16DImode:
      return split_25 (x1, insn);

    case E_V32DImode:
      return split_72 (x1, insn);

    case E_V64DImode:
      return split_71 (x1, insn);

    case E_V128DImode:
      return split_70 (x1, insn);

    case E_V256DImode:
      return split_69 (x1, insn);

    case E_V512DImode:
      return split_68 (x1, insn);

    case E_V1HFmode:
      return split_24 (x1, insn);

    case E_V2HFmode:
      return split_23 (x1, insn);

    case E_V4HFmode:
      return split_22 (x1, insn);

    case E_V8HFmode:
      return split_21 (x1, insn);

    case E_V16HFmode:
      return split_20 (x1, insn);

    case E_V32HFmode:
      return split_67 (x1, insn);

    case E_V64HFmode:
      return split_66 (x1, insn);

    case E_V128HFmode:
      return split_65 (x1, insn);

    case E_V256HFmode:
      return split_64 (x1, insn);

    case E_V512HFmode:
      return split_63 (x1, insn);

    case E_V1024HFmode:
      return split_62 (x1, insn);

    case E_V2048HFmode:
      return split_61 (x1, insn);

    case E_V1SFmode:
      return split_19 (x1, insn);

    case E_V2SFmode:
      return split_18 (x1, insn);

    case E_V4SFmode:
      return split_17 (x1, insn);

    case E_V8SFmode:
      return split_16 (x1, insn);

    case E_V16SFmode:
      return split_15 (x1, insn);

    case E_V32SFmode:
      return split_60 (x1, insn);

    case E_V64SFmode:
      return split_59 (x1, insn);

    case E_V128SFmode:
      return split_58 (x1, insn);

    case E_V256SFmode:
      return split_57 (x1, insn);

    case E_V512SFmode:
      return split_56 (x1, insn);

    case E_V1024SFmode:
      return split_55 (x1, insn);

    case E_V1DFmode:
      return split_14 (x1, insn);

    case E_V2DFmode:
      return split_13 (x1, insn);

    case E_V4DFmode:
      return split_12 (x1, insn);

    case E_V8DFmode:
      return split_11 (x1, insn);

    case E_V16DFmode:
      return split_10 (x1, insn);

    case E_V32DFmode:
      return split_54 (x1, insn);

    case E_V64DFmode:
      return split_53 (x1, insn);

    case E_V128DFmode:
      return split_52 (x1, insn);

    case E_V256DFmode:
      return split_51 (x1, insn);

    case E_V512DFmode:
      return split_50 (x1, insn);

    case E_RVVMF8x2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF8x2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x2QImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_323 (insn, operands);

    case E_RVVMF8x3QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF8x3QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x3QImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_324 (insn, operands);

    case E_RVVMF8x4QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF8x4QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x4QImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_325 (insn, operands);

    case E_RVVMF8x5QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF8x5QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x5QImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_326 (insn, operands);

    case E_RVVMF8x6QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF8x6QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x6QImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_327 (insn, operands);

    case E_RVVMF8x7QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF8x7QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x7QImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_328 (insn, operands);

    case E_RVVMF8x8QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF8x8QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF8x8QImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_329 (insn, operands);

    case E_RVVMF4x2HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x2HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x2HImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_330 (insn, operands);

    case E_RVVMF4x3HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x3HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x3HImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_331 (insn, operands);

    case E_RVVMF4x4HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x4HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x4HImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_332 (insn, operands);

    case E_RVVMF4x5HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x5HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x5HImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_333 (insn, operands);

    case E_RVVMF4x6HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x6HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x6HImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_334 (insn, operands);

    case E_RVVMF4x7HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x7HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x7HImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_335 (insn, operands);

    case E_RVVMF4x8HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x8HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x8HImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_336 (insn, operands);

    case E_RVVMF2x2SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x2SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x2SImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_337 (insn, operands);

    case E_RVVMF2x3SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x3SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x3SImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_338 (insn, operands);

    case E_RVVMF2x4SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x4SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x4SImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_339 (insn, operands);

    case E_RVVMF2x5SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x5SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x5SImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_340 (insn, operands);

    case E_RVVMF2x6SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x6SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x6SImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_341 (insn, operands);

    case E_RVVMF2x7SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x7SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x7SImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_342 (insn, operands);

    case E_RVVMF2x8SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x8SImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x8SImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return NULL;
      return gen_split_343 (insn, operands);

    case E_RVVM1x2DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2DImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_344 (insn, operands);

    case E_RVVM1x3DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3DImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_345 (insn, operands);

    case E_RVVM1x4DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4DImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_346 (insn, operands);

    case E_RVVM1x5DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5DImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_347 (insn, operands);

    case E_RVVM1x6DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6DImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_348 (insn, operands);

    case E_RVVM1x7DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7DImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_349 (insn, operands);

    case E_RVVM1x8DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8DImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_350 (insn, operands);

    case E_RVVMF4x2BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x2BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x2BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_351 (insn, operands);

    case E_RVVMF4x3BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x3BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x3BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_352 (insn, operands);

    case E_RVVMF4x4BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x4BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x4BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_353 (insn, operands);

    case E_RVVMF4x5BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x5BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x5BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_354 (insn, operands);

    case E_RVVMF4x6BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x6BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x6BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_355 (insn, operands);

    case E_RVVMF4x7BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x7BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x7BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_356 (insn, operands);

    case E_RVVMF4x8BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x8BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x8BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_357 (insn, operands);

    case E_RVVMF4x2HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x2HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x2HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_358 (insn, operands);

    case E_RVVMF4x3HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x3HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x3HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_359 (insn, operands);

    case E_RVVMF4x4HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x4HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x4HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_360 (insn, operands);

    case E_RVVMF4x5HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x5HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x5HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_361 (insn, operands);

    case E_RVVMF4x6HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x6HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x6HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_362 (insn, operands);

    case E_RVVMF4x7HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x7HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x7HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_363 (insn, operands);

    case E_RVVMF4x8HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x8HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x8HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_364 (insn, operands);

    case E_RVVMF2x2SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x2SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x2SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_365 (insn, operands);

    case E_RVVMF2x3SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x3SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x3SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_366 (insn, operands);

    case E_RVVMF2x4SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x4SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x4SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_367 (insn, operands);

    case E_RVVMF2x5SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x5SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x5SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_368 (insn, operands);

    case E_RVVMF2x6SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x6SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x6SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_369 (insn, operands);

    case E_RVVMF2x7SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x7SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x7SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_370 (insn, operands);

    case E_RVVMF2x8SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x8SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x8SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_371 (insn, operands);

    case E_RVVM1x2DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2DFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_372 (insn, operands);

    case E_RVVM1x3DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3DFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_373 (insn, operands);

    case E_RVVM1x4DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4DFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_374 (insn, operands);

    case E_RVVM1x5DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5DFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_375 (insn, operands);

    case E_RVVM1x6DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6DFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_376 (insn, operands);

    case E_RVVM1x7DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7DFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_377 (insn, operands);

    case E_RVVM1x8DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8DFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_378 (insn, operands);

    case E_RVVMF4x2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x2QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_379 (insn, operands);

    case E_RVVMF4x3QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x3QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x3QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_380 (insn, operands);

    case E_RVVMF4x4QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x4QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x4QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_381 (insn, operands);

    case E_RVVMF4x5QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x5QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x5QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_382 (insn, operands);

    case E_RVVMF4x6QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x6QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x6QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_383 (insn, operands);

    case E_RVVMF4x7QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x7QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x7QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_384 (insn, operands);

    case E_RVVMF4x8QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF4x8QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF4x8QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_385 (insn, operands);

    case E_RVVMF2x2HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x2HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x2HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_386 (insn, operands);

    case E_RVVMF2x3HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x3HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x3HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_387 (insn, operands);

    case E_RVVMF2x4HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x4HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x4HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_388 (insn, operands);

    case E_RVVMF2x5HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x5HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x5HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_389 (insn, operands);

    case E_RVVMF2x6HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x6HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x6HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_390 (insn, operands);

    case E_RVVMF2x7HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x7HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x7HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_391 (insn, operands);

    case E_RVVMF2x8HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x8HImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x8HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_392 (insn, operands);

    case E_RVVM1x2SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2SImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_393 (insn, operands);

    case E_RVVM1x3SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3SImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_394 (insn, operands);

    case E_RVVM1x4SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4SImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_395 (insn, operands);

    case E_RVVM1x5SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5SImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_396 (insn, operands);

    case E_RVVM1x6SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6SImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_397 (insn, operands);

    case E_RVVM1x7SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7SImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_398 (insn, operands);

    case E_RVVM1x8SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8SImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_399 (insn, operands);

    case E_RVVM2x2DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2DImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_400 (insn, operands);

    case E_RVVM2x3DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3DImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_401 (insn, operands);

    case E_RVVM2x4DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4DImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_402 (insn, operands);

    case E_RVVMF2x2BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x2BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x2BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_403 (insn, operands);

    case E_RVVMF2x3BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x3BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x3BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_404 (insn, operands);

    case E_RVVMF2x4BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x4BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x4BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_405 (insn, operands);

    case E_RVVMF2x5BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x5BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x5BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_406 (insn, operands);

    case E_RVVMF2x6BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x6BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x6BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_407 (insn, operands);

    case E_RVVMF2x7BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x7BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x7BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_408 (insn, operands);

    case E_RVVMF2x8BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x8BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x8BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_409 (insn, operands);

    case E_RVVMF2x2HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x2HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x2HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_410 (insn, operands);

    case E_RVVMF2x3HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x3HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x3HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_411 (insn, operands);

    case E_RVVMF2x4HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x4HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x4HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_412 (insn, operands);

    case E_RVVMF2x5HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x5HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x5HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_413 (insn, operands);

    case E_RVVMF2x6HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x6HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x6HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_414 (insn, operands);

    case E_RVVMF2x7HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x7HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x7HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_415 (insn, operands);

    case E_RVVMF2x8HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x8HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x8HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_416 (insn, operands);

    case E_RVVM1x2SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_417 (insn, operands);

    case E_RVVM1x3SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_418 (insn, operands);

    case E_RVVM1x4SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_419 (insn, operands);

    case E_RVVM1x5SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_420 (insn, operands);

    case E_RVVM1x6SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_421 (insn, operands);

    case E_RVVM1x7SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_422 (insn, operands);

    case E_RVVM1x8SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_423 (insn, operands);

    case E_RVVM2x2DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2DFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_424 (insn, operands);

    case E_RVVM2x3DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3DFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_425 (insn, operands);

    case E_RVVM2x4DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4DFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_426 (insn, operands);

    case E_RVVMF2x2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x2QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_427 (insn, operands);

    case E_RVVMF2x3QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x3QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x3QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_428 (insn, operands);

    case E_RVVMF2x4QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x4QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x4QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_429 (insn, operands);

    case E_RVVMF2x5QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x5QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x5QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_430 (insn, operands);

    case E_RVVMF2x6QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x6QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x6QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_431 (insn, operands);

    case E_RVVMF2x7QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x7QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x7QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_432 (insn, operands);

    case E_RVVMF2x8QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVMF2x8QImode)
          || !reg_or_mem_operand (operands[1], E_RVVMF2x8QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_433 (insn, operands);

    case E_RVVM1x2HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_434 (insn, operands);

    case E_RVVM1x3HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_435 (insn, operands);

    case E_RVVM1x4HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_436 (insn, operands);

    case E_RVVM1x5HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_437 (insn, operands);

    case E_RVVM1x6HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_438 (insn, operands);

    case E_RVVM1x7HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_439 (insn, operands);

    case E_RVVM1x8HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_440 (insn, operands);

    case E_RVVM2x2SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2SImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_441 (insn, operands);

    case E_RVVM2x3SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3SImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_442 (insn, operands);

    case E_RVVM2x4SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4SImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_443 (insn, operands);

    case E_RVVM4x2DImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2DImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2DImode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return NULL;
      return gen_split_444 (insn, operands);

    case E_RVVM1x2BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_445 (insn, operands);

    case E_RVVM1x3BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_446 (insn, operands);

    case E_RVVM1x4BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_447 (insn, operands);

    case E_RVVM1x5BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_448 (insn, operands);

    case E_RVVM1x6BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_449 (insn, operands);

    case E_RVVM1x7BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_450 (insn, operands);

    case E_RVVM1x8BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_451 (insn, operands);

    case E_RVVM1x2HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_452 (insn, operands);

    case E_RVVM1x3HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_453 (insn, operands);

    case E_RVVM1x4HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_454 (insn, operands);

    case E_RVVM1x5HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_455 (insn, operands);

    case E_RVVM1x6HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_456 (insn, operands);

    case E_RVVM1x7HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_457 (insn, operands);

    case E_RVVM1x8HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_458 (insn, operands);

    case E_RVVM2x2SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_459 (insn, operands);

    case E_RVVM2x3SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_460 (insn, operands);

    case E_RVVM2x4SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_461 (insn, operands);

    case E_RVVM4x2DFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2DFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2DFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return NULL;
      return gen_split_462 (insn, operands);

    case E_RVVM1x2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x2QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_463 (insn, operands);

    case E_RVVM1x3QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x3QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x3QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_464 (insn, operands);

    case E_RVVM1x4QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x4QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x4QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_465 (insn, operands);

    case E_RVVM1x5QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x5QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x5QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_466 (insn, operands);

    case E_RVVM1x6QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x6QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x6QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_467 (insn, operands);

    case E_RVVM1x7QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x7QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x7QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_468 (insn, operands);

    case E_RVVM1x8QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM1x8QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM1x8QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_469 (insn, operands);

    case E_RVVM2x2HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_470 (insn, operands);

    case E_RVVM2x3HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_471 (insn, operands);

    case E_RVVM2x4HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_472 (insn, operands);

    case E_RVVM4x2SImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2SImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2SImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_473 (insn, operands);

    case E_RVVM2x2BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_474 (insn, operands);

    case E_RVVM2x3BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_475 (insn, operands);

    case E_RVVM2x4BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_476 (insn, operands);

    case E_RVVM2x2HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_477 (insn, operands);

    case E_RVVM2x3HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_478 (insn, operands);

    case E_RVVM2x4HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_479 (insn, operands);

    case E_RVVM4x2SFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2SFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2SFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return NULL;
      return gen_split_480 (insn, operands);

    case E_RVVM2x2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x2QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_481 (insn, operands);

    case E_RVVM2x3QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x3QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x3QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_482 (insn, operands);

    case E_RVVM2x4QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM2x4QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM2x4QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_483 (insn, operands);

    case E_RVVM4x2HImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2HImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2HImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_484 (insn, operands);

    case E_RVVM4x2BFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2BFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2BFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1341 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return NULL;
      return gen_split_485 (insn, operands);

    case E_RVVM4x2HFmode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2HFmode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2HFmode)
          || !(
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1342 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return NULL;
      return gen_split_486 (insn, operands);

    case E_RVVM4x2QImode:
      if (!reg_or_mem_operand (operands[0], E_RVVM4x2QImode)
          || !reg_or_mem_operand (operands[1], E_RVVM4x2QImode)
          || !
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return NULL;
      return gen_split_487 (insn, operands);

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode)
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !(
#line 1257 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_1563 (insn, operands);

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode)
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !(
#line 1257 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_1564 (insn, operands);

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !(
#line 1257 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_1566 (insn, operands);

    case E_V1BImode:
      return split_49 (x1, insn);

    case E_V2BImode:
      return split_48 (x1, insn);

    case E_V4BImode:
      return split_47 (x1, insn);

    case E_V8BImode:
      return split_46 (x1, insn);

    case E_V16BImode:
      return split_45 (x1, insn);

    case E_V32BImode:
      if (!register_operand (operands[0], E_V32BImode)
          || !register_operand (operands[1], E_V32BImode)
          || !((
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1532 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2175 (insn, operands);

    case E_V64BImode:
      if (!register_operand (operands[0], E_V64BImode)
          || !register_operand (operands[1], E_V64BImode)
          || !((
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1532 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2176 (insn, operands);

    case E_V128BImode:
      if (!register_operand (operands[0], E_V128BImode)
          || !register_operand (operands[1], E_V128BImode)
          || !((
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1532 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2177 (insn, operands);

    case E_V256BImode:
      if (!register_operand (operands[0], E_V256BImode)
          || !register_operand (operands[1], E_V256BImode)
          || !((
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1532 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2178 (insn, operands);

    case E_V512BImode:
      if (!register_operand (operands[0], E_V512BImode)
          || !register_operand (operands[1], E_V512BImode)
          || !((
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1532 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2179 (insn, operands);

    case E_V1024BImode:
      if (!register_operand (operands[0], E_V1024BImode)
          || !register_operand (operands[1], E_V1024BImode)
          || !((
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1532 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2180 (insn, operands);

    case E_V2048BImode:
      if (!register_operand (operands[0], E_V2048BImode)
          || !register_operand (operands[1], E_V2048BImode)
          || !((
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1532 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2181 (insn, operands);

    case E_V4096BImode:
      if (!register_operand (operands[0], E_V4096BImode)
          || !register_operand (operands[1], E_V4096BImode)
          || !((
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1532 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2182 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_128 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_802 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_808 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_814 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_820 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_826 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_832 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_838 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_844 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_850 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_856 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_862 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_868 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_874 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_880 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_886 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_892 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_898 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_904 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_910 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_916 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_922 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_928 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_934 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_940 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_946 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_952 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_958 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_964 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_970 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_976 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_982 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_988 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_994 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_1000 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_1006 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_1012 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_1018 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_1024 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_1030 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_1036 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_1042 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_1048 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_1054 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_1060 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_1066 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_1072 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_1078 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_1084 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_1090 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_1096 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_1102 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_1108 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_1114 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_1120 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_1126 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_1132 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_1138 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_1144 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_1150 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_1156 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_1162 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_1168 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_1174 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_1180 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_1186 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_1192 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_1198 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_1204 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_1210 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_1216 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_1222 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_1228 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_1234 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_1240 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_1246 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_1252 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_1258 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_1264 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_1270 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_1276 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_1282 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_1288 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_1294 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_1300 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_1306 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_1312 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_1318 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_1324 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_1330 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_1336 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_1342 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_1348 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_1354 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_1360 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_1366 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_1372 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_1378 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_1384 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_1390 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_1396 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_1402 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_1408 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_1414 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_1420 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_1426 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_1432 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_1438 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_1444 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_1450 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_1456 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_1462 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_1468 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_1474 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_1480 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_1486 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_1492 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_1498 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_1504 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_1510 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_1516 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_1522 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_1528 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_137 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern142 (x2))
    {
    case 0:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5457 (insn, operands);

    case 1:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5458 (insn, operands);

    case 2:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5459 (insn, operands);

    case 3:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5460 (insn, operands);

    case 4:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5461 (insn, operands);

    case 5:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5462 (insn, operands);

    case 6:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5463 (insn, operands);

    case 7:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5464 (insn, operands);

    case 8:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5465 (insn, operands);

    case 9:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5466 (insn, operands);

    case 10:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5467 (insn, operands);

    case 11:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5468 (insn, operands);

    case 12:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5469 (insn, operands);

    case 13:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5470 (insn, operands);

    case 14:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5471 (insn, operands);

    case 15:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5472 (insn, operands);

    case 16:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5473 (insn, operands);

    case 17:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5474 (insn, operands);

    case 18:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5475 (insn, operands);

    case 19:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5476 (insn, operands);

    case 20:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5477 (insn, operands);

    case 21:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5478 (insn, operands);

    case 22:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5479 (insn, operands);

    case 23:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5480 (insn, operands);

    case 24:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5481 (insn, operands);

    case 25:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5482 (insn, operands);

    case 26:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5483 (insn, operands);

    case 27:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5484 (insn, operands);

    case 28:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5485 (insn, operands);

    case 29:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5486 (insn, operands);

    case 30:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5487 (insn, operands);

    case 31:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5488 (insn, operands);

    case 32:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5489 (insn, operands);

    case 33:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5490 (insn, operands);

    case 34:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5491 (insn, operands);

    case 35:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5492 (insn, operands);

    case 36:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5493 (insn, operands);

    case 37:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5494 (insn, operands);

    case 38:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5495 (insn, operands);

    case 39:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5496 (insn, operands);

    case 40:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5497 (insn, operands);

    case 41:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5498 (insn, operands);

    case 42:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5499 (insn, operands);

    case 43:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5500 (insn, operands);

    case 44:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5501 (insn, operands);

    case 45:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5502 (insn, operands);

    case 46:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5503 (insn, operands);

    case 47:
      if (!((
#line 1272 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1274 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5504 (insn, operands);

    case 48:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9578 (insn, operands);

    case 49:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9579 (insn, operands);

    case 50:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9580 (insn, operands);

    case 51:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9581 (insn, operands);

    case 52:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9582 (insn, operands);

    case 53:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9583 (insn, operands);

    case 54:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9584 (insn, operands);

    case 55:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9585 (insn, operands);

    case 56:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9586 (insn, operands);

    case 57:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9587 (insn, operands);

    case 58:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9588 (insn, operands);

    case 59:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9589 (insn, operands);

    case 60:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9590 (insn, operands);

    case 61:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9591 (insn, operands);

    case 62:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9592 (insn, operands);

    case 63:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9593 (insn, operands);

    case 64:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9594 (insn, operands);

    case 65:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9595 (insn, operands);

    case 66:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9596 (insn, operands);

    case 67:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9597 (insn, operands);

    case 68:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9598 (insn, operands);

    case 69:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9599 (insn, operands);

    case 70:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9600 (insn, operands);

    case 71:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9601 (insn, operands);

    case 72:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9602 (insn, operands);

    case 73:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9603 (insn, operands);

    case 74:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9604 (insn, operands);

    case 75:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9605 (insn, operands);

    case 76:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9606 (insn, operands);

    case 77:
      if (!((
#line 1108 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1110 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9607 (insn, operands);

    case 78:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9608 (insn, operands);

    case 79:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9609 (insn, operands);

    case 80:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9610 (insn, operands);

    case 81:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9611 (insn, operands);

    case 82:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9612 (insn, operands);

    case 83:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9613 (insn, operands);

    case 84:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9614 (insn, operands);

    case 85:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9615 (insn, operands);

    case 86:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9616 (insn, operands);

    case 87:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9617 (insn, operands);

    case 88:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9618 (insn, operands);

    case 89:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9619 (insn, operands);

    case 90:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9620 (insn, operands);

    case 91:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9621 (insn, operands);

    case 92:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9622 (insn, operands);

    case 93:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9623 (insn, operands);

    case 94:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9624 (insn, operands);

    case 95:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9625 (insn, operands);

    case 96:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9626 (insn, operands);

    case 97:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9627 (insn, operands);

    case 98:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9628 (insn, operands);

    case 99:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9629 (insn, operands);

    case 100:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9630 (insn, operands);

    case 101:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9631 (insn, operands);

    case 102:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9632 (insn, operands);

    case 103:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9633 (insn, operands);

    case 104:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9634 (insn, operands);

    case 105:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9635 (insn, operands);

    case 106:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9636 (insn, operands);

    case 107:
      if (!((
#line 1132 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1134 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9637 (insn, operands);

    case 108:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9638 (insn, operands);

    case 109:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9639 (insn, operands);

    case 110:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9640 (insn, operands);

    case 111:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9641 (insn, operands);

    case 112:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9642 (insn, operands);

    case 113:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9643 (insn, operands);

    case 114:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9644 (insn, operands);

    case 115:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9645 (insn, operands);

    case 116:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9646 (insn, operands);

    case 117:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9647 (insn, operands);

    case 118:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9648 (insn, operands);

    case 119:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9649 (insn, operands);

    case 120:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9650 (insn, operands);

    case 121:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9651 (insn, operands);

    case 122:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9652 (insn, operands);

    case 123:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9653 (insn, operands);

    case 124:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9654 (insn, operands);

    case 125:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9655 (insn, operands);

    case 126:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9656 (insn, operands);

    case 127:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9657 (insn, operands);

    case 128:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9658 (insn, operands);

    case 129:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9659 (insn, operands);

    case 130:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9660 (insn, operands);

    case 131:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9661 (insn, operands);

    case 132:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9662 (insn, operands);

    case 133:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9663 (insn, operands);

    case 134:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9664 (insn, operands);

    case 135:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9665 (insn, operands);

    case 136:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9666 (insn, operands);

    case 137:
      if (!((
#line 1161 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1163 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9667 (insn, operands);

    case 138:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9668 (insn, operands);

    case 139:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9669 (insn, operands);

    case 140:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9670 (insn, operands);

    case 141:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9671 (insn, operands);

    case 142:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9672 (insn, operands);

    case 143:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9673 (insn, operands);

    case 144:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9674 (insn, operands);

    case 145:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9675 (insn, operands);

    case 146:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9676 (insn, operands);

    case 147:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9677 (insn, operands);

    case 148:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9678 (insn, operands);

    case 149:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9679 (insn, operands);

    case 150:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9680 (insn, operands);

    case 151:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9681 (insn, operands);

    case 152:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9682 (insn, operands);

    case 153:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9683 (insn, operands);

    case 154:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9684 (insn, operands);

    case 155:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9685 (insn, operands);

    case 156:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9686 (insn, operands);

    case 157:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9687 (insn, operands);

    case 158:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9688 (insn, operands);

    case 159:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9689 (insn, operands);

    case 160:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9690 (insn, operands);

    case 161:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9691 (insn, operands);

    case 162:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9692 (insn, operands);

    case 163:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9693 (insn, operands);

    case 164:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9694 (insn, operands);

    case 165:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9695 (insn, operands);

    case 166:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9696 (insn, operands);

    case 167:
      if (!((
#line 1186 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1188 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9697 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_149 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern126 (x2))
    {
    case 0:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4538 (insn, operands);

    case 1:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4694 (insn, operands);

    case 2:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4540 (insn, operands);

    case 3:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4696 (insn, operands);

    case 4:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4886 (insn, operands);

    case 5:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4542 (insn, operands);

    case 6:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4698 (insn, operands);

    case 7:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4888 (insn, operands);

    case 8:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4544 (insn, operands);

    case 9:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4700 (insn, operands);

    case 10:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4890 (insn, operands);

    case 11:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4546 (insn, operands);

    case 12:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4702 (insn, operands);

    case 13:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4892 (insn, operands);

    case 14:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4548 (insn, operands);

    case 15:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4704 (insn, operands);

    case 16:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4894 (insn, operands);

    case 17:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4550 (insn, operands);

    case 18:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4706 (insn, operands);

    case 19:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4552 (insn, operands);

    case 20:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4708 (insn, operands);

    case 21:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4896 (insn, operands);

    case 22:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4554 (insn, operands);

    case 23:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4710 (insn, operands);

    case 24:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4898 (insn, operands);

    case 25:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4556 (insn, operands);

    case 26:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4712 (insn, operands);

    case 27:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4900 (insn, operands);

    case 28:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4558 (insn, operands);

    case 29:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4714 (insn, operands);

    case 30:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4902 (insn, operands);

    case 31:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4560 (insn, operands);

    case 32:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4716 (insn, operands);

    case 33:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4562 (insn, operands);

    case 34:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4718 (insn, operands);

    case 35:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4564 (insn, operands);

    case 36:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4720 (insn, operands);

    case 37:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4566 (insn, operands);

    case 38:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4722 (insn, operands);

    case 39:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4568 (insn, operands);

    case 40:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4724 (insn, operands);

    case 41:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4904 (insn, operands);

    case 42:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4570 (insn, operands);

    case 43:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4726 (insn, operands);

    case 44:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4906 (insn, operands);

    case 45:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4572 (insn, operands);

    case 46:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4728 (insn, operands);

    case 47:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4908 (insn, operands);

    case 48:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4574 (insn, operands);

    case 49:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4730 (insn, operands);

    case 50:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4910 (insn, operands);

    case 51:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4576 (insn, operands);

    case 52:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4732 (insn, operands);

    case 53:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4912 (insn, operands);

    case 54:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4578 (insn, operands);

    case 55:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4734 (insn, operands);

    case 56:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4914 (insn, operands);

    case 57:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4580 (insn, operands);

    case 58:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4736 (insn, operands);

    case 59:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4916 (insn, operands);

    case 60:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4582 (insn, operands);

    case 61:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4738 (insn, operands);

    case 62:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4918 (insn, operands);

    case 63:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4584 (insn, operands);

    case 64:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4740 (insn, operands);

    case 65:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4920 (insn, operands);

    case 66:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4586 (insn, operands);

    case 67:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4742 (insn, operands);

    case 68:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4922 (insn, operands);

    case 69:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4588 (insn, operands);

    case 70:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4744 (insn, operands);

    case 71:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4924 (insn, operands);

    case 72:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4590 (insn, operands);

    case 73:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4746 (insn, operands);

    case 74:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4592 (insn, operands);

    case 75:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4748 (insn, operands);

    case 76:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4926 (insn, operands);

    case 77:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4594 (insn, operands);

    case 78:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4750 (insn, operands);

    case 79:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4928 (insn, operands);

    case 80:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4596 (insn, operands);

    case 81:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4752 (insn, operands);

    case 82:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4930 (insn, operands);

    case 83:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4598 (insn, operands);

    case 84:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4754 (insn, operands);

    case 85:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4932 (insn, operands);

    case 86:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4600 (insn, operands);

    case 87:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4756 (insn, operands);

    case 88:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4934 (insn, operands);

    case 89:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4602 (insn, operands);

    case 90:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4758 (insn, operands);

    case 91:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4936 (insn, operands);

    case 92:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4604 (insn, operands);

    case 93:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4760 (insn, operands);

    case 94:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4938 (insn, operands);

    case 95:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4606 (insn, operands);

    case 96:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4762 (insn, operands);

    case 97:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4940 (insn, operands);

    case 98:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4608 (insn, operands);

    case 99:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4764 (insn, operands);

    case 100:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4942 (insn, operands);

    case 101:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4610 (insn, operands);

    case 102:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4766 (insn, operands);

    case 103:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4944 (insn, operands);

    case 104:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4612 (insn, operands);

    case 105:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4768 (insn, operands);

    case 106:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4614 (insn, operands);

    case 107:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4770 (insn, operands);

    case 108:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4616 (insn, operands);

    case 109:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4772 (insn, operands);

    case 110:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4618 (insn, operands);

    case 111:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4774 (insn, operands);

    case 112:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4620 (insn, operands);

    case 113:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4776 (insn, operands);

    case 114:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4622 (insn, operands);

    case 115:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4778 (insn, operands);

    case 116:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4624 (insn, operands);

    case 117:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4780 (insn, operands);

    case 118:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4626 (insn, operands);

    case 119:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4782 (insn, operands);

    case 120:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4628 (insn, operands);

    case 121:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4784 (insn, operands);

    case 122:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4630 (insn, operands);

    case 123:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4786 (insn, operands);

    case 124:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4632 (insn, operands);

    case 125:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4788 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_155 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x2) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM4HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4381 (insn, operands);

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x2) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM2HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4382 (insn, operands);

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x2) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM1HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4383 (insn, operands);

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x2) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVMF2HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4384 (insn, operands);

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x2) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF4HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4385 (insn, operands);

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x2) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4386 (insn, operands);

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x2) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4387 (insn, operands);

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x2) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4388 (insn, operands);

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x2) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4389 (insn, operands);

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4390 (insn, operands);

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4391 (insn, operands);

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4392 (insn, operands);

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4393 (insn, operands);

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4394 (insn, operands);

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x2) != E_V32SFmode
          || !register_operand (operands[1], E_V32HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4395 (insn, operands);

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x2) != E_V64SFmode
          || !register_operand (operands[1], E_V64HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4396 (insn, operands);

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x2) != E_V128SFmode
          || !register_operand (operands[1], E_V128HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4397 (insn, operands);

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x2) != E_V256SFmode
          || !register_operand (operands[1], E_V256HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4398 (insn, operands);

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x2) != E_V512SFmode
          || !register_operand (operands[1], E_V512HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4399 (insn, operands);

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x2) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024HFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4400 (insn, operands);

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x2) != E_V1DFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4401 (insn, operands);

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4402 (insn, operands);

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4403 (insn, operands);

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x2) != E_V8DFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4404 (insn, operands);

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x2) != E_V16DFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4405 (insn, operands);

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x2) != E_V32DFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4406 (insn, operands);

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x2) != E_V64DFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4407 (insn, operands);

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x2) != E_V128DFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4408 (insn, operands);

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x2) != E_V256DFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4409 (insn, operands);

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x2) != E_V512DFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !((
#line 830 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 832 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4410 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_163 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern124 (x2))
    {
    case 0:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2599 (insn, operands);

    case 1:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2613 (insn, operands);

    case 2:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2627 (insn, operands);

    case 3:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2641 (insn, operands);

    case 4:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2655 (insn, operands);

    case 5:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2669 (insn, operands);

    case 6:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2683 (insn, operands);

    case 7:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2697 (insn, operands);

    case 8:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2711 (insn, operands);

    case 9:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2725 (insn, operands);

    case 10:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2739 (insn, operands);

    case 11:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2753 (insn, operands);

    case 12:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2767 (insn, operands);

    case 13:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2781 (insn, operands);

    case 14:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2795 (insn, operands);

    case 15:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2809 (insn, operands);

    case 16:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2823 (insn, operands);

    case 17:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2837 (insn, operands);

    case 18:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2851 (insn, operands);

    case 19:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2865 (insn, operands);

    case 20:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2879 (insn, operands);

    case 21:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2893 (insn, operands);

    case 22:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2907 (insn, operands);

    case 23:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2921 (insn, operands);

    case 24:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2935 (insn, operands);

    case 25:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2949 (insn, operands);

    case 26:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2963 (insn, operands);

    case 27:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2977 (insn, operands);

    case 28:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2991 (insn, operands);

    case 29:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3005 (insn, operands);

    case 30:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3019 (insn, operands);

    case 31:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3033 (insn, operands);

    case 32:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3047 (insn, operands);

    case 33:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3061 (insn, operands);

    case 34:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3075 (insn, operands);

    case 35:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3089 (insn, operands);

    case 36:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3103 (insn, operands);

    case 37:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3117 (insn, operands);

    case 38:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3131 (insn, operands);

    case 39:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3145 (insn, operands);

    case 40:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3159 (insn, operands);

    case 41:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3173 (insn, operands);

    case 42:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3187 (insn, operands);

    case 43:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3201 (insn, operands);

    case 44:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3215 (insn, operands);

    case 45:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3229 (insn, operands);

    case 46:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3243 (insn, operands);

    case 47:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3257 (insn, operands);

    case 48:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3271 (insn, operands);

    case 49:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3285 (insn, operands);

    case 50:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3299 (insn, operands);

    case 51:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3313 (insn, operands);

    case 52:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3327 (insn, operands);

    case 53:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3341 (insn, operands);

    case 54:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3355 (insn, operands);

    case 55:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3369 (insn, operands);

    case 56:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3383 (insn, operands);

    case 57:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3397 (insn, operands);

    case 58:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3411 (insn, operands);

    case 59:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3425 (insn, operands);

    case 60:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3439 (insn, operands);

    case 61:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3453 (insn, operands);

    case 62:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3467 (insn, operands);

    case 63:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3481 (insn, operands);

    case 64:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3495 (insn, operands);

    case 65:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3509 (insn, operands);

    case 66:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3523 (insn, operands);

    case 67:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3537 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_168 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      return split_140 (x1, insn);

    case AND:
      switch (pattern196 (x2))
        {
        case 0:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10005 (insn, operands);

        case 1:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10008 (insn, operands);

        case 2:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10011 (insn, operands);

        case 3:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10014 (insn, operands);

        case 4:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10017 (insn, operands);

        case 5:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10020 (insn, operands);

        case 6:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10023 (insn, operands);

        case 7:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10026 (insn, operands);

        case 8:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10029 (insn, operands);

        case 9:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10032 (insn, operands);

        case 10:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10035 (insn, operands);

        case 11:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10038 (insn, operands);

        case 12:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10041 (insn, operands);

        case 13:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10044 (insn, operands);

        case 14:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10047 (insn, operands);

        case 15:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10050 (insn, operands);

        case 16:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10053 (insn, operands);

        case 17:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10056 (insn, operands);

        case 18:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10059 (insn, operands);

        case 19:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10062 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern196 (x2))
        {
        case 0:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10006 (insn, operands);

        case 1:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10009 (insn, operands);

        case 2:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10012 (insn, operands);

        case 3:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10015 (insn, operands);

        case 4:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10018 (insn, operands);

        case 5:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10021 (insn, operands);

        case 6:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10024 (insn, operands);

        case 7:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10027 (insn, operands);

        case 8:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10030 (insn, operands);

        case 9:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10033 (insn, operands);

        case 10:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10036 (insn, operands);

        case 11:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10039 (insn, operands);

        case 12:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10042 (insn, operands);

        case 13:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10045 (insn, operands);

        case 14:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10048 (insn, operands);

        case 15:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10051 (insn, operands);

        case 16:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10054 (insn, operands);

        case 17:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10057 (insn, operands);

        case 18:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10060 (insn, operands);

        case 19:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10063 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern196 (x2))
        {
        case 0:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10007 (insn, operands);

        case 1:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10010 (insn, operands);

        case 2:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10013 (insn, operands);

        case 3:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10016 (insn, operands);

        case 4:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10019 (insn, operands);

        case 5:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10022 (insn, operands);

        case 6:
          if (!(
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10025 (insn, operands);

        case 7:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10028 (insn, operands);

        case 8:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10031 (insn, operands);

        case 9:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10034 (insn, operands);

        case 10:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10037 (insn, operands);

        case 11:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10040 (insn, operands);

        case 12:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10043 (insn, operands);

        case 13:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10046 (insn, operands);

        case 14:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10049 (insn, operands);

        case 15:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10052 (insn, operands);

        case 16:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10055 (insn, operands);

        case 17:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10058 (insn, operands);

        case 18:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10061 (insn, operands);

        case 19:
          if (!((
#line 1437 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1439 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10064 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != SET)
    return NULL;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
      if (peep2_current_count < 3
          || GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return NULL;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != LSHIFTRT
          || GET_MODE (x7) != E_DImode)
        return NULL;
      x8 = XEXP (x3, 0);
      operands[3] = x8;
      if (!register_operand (operands[3], E_DImode))
        return NULL;
      x9 = XEXP (x7, 0);
      if (!rtx_equal_p (x9, operands[0]))
        return NULL;
      x10 = XEXP (x7, 1);
      if (!rtx_equal_p (x10, operands[2]))
        return NULL;
      x11 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x11) != SET)
        return NULL;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != ASHIFT
          || GET_MODE (x12) != E_DImode)
        return NULL;
      x13 = XEXP (x11, 0);
      operands[4] = x13;
      if (!register_operand (operands[4], E_DImode))
        return NULL;
      x14 = XEXP (x12, 1);
      operands[5] = x14;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return NULL;
      x15 = XEXP (x12, 0);
      if (!rtx_equal_p (x15, operands[3])
          || !
#line 30 "../../gcc/config/riscv/peephole.md"
(TARGET_64BIT
   && INTVAL (operands[5]) < INTVAL (operands[2])
   && (REGNO (operands[3]) == REGNO (operands[4])
       || peep2_reg_dead_p (3, operands[3]))))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_1 (insn, operands);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x8 = XEXP (x3, 0);
      operands[2] = x8;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (GET_CODE (operands[1]))
        {
        case REG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (a0a1_reg_operand (operands[0], E_SImode)
                  && zcmp_mv_sreg_operand (operands[1], E_SImode)
                  && a0a1_reg_operand (operands[2], E_SImode)
                  && zcmp_mv_sreg_operand (operands[3], E_SImode)
                  && (
#line 48 "../../gcc/config/riscv/peephole.md"
(TARGET_ZCMP
   && (REGNO (operands[2]) != REGNO (operands[0]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_2 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (zcmp_mv_sreg_operand (operands[0], E_SImode)
                  && a0a1_reg_operand (operands[1], E_SImode)
                  && zcmp_mv_sreg_operand (operands[2], E_SImode)
                  && a0a1_reg_operand (operands[3], E_SImode)
                  && (
#line 61 "../../gcc/config/riscv/peephole.md"
(TARGET_ZCMP
   && (REGNO (operands[0]) != REGNO (operands[2]))
   && (REGNO (operands[1]) != REGNO (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_4 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case E_DImode:
              if (a0a1_reg_operand (operands[0], E_DImode)
                  && zcmp_mv_sreg_operand (operands[1], E_DImode)
                  && a0a1_reg_operand (operands[2], E_DImode)
                  && zcmp_mv_sreg_operand (operands[3], E_DImode)
                  && (
#line 48 "../../gcc/config/riscv/peephole.md"
(TARGET_ZCMP
   && (REGNO (operands[2]) != REGNO (operands[0]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_3 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (zcmp_mv_sreg_operand (operands[0], E_DImode)
                  && a0a1_reg_operand (operands[1], E_DImode)
                  && zcmp_mv_sreg_operand (operands[2], E_DImode)
                  && a0a1_reg_operand (operands[3], E_DImode)
                  && (
#line 61 "../../gcc/config/riscv/peephole.md"
(TARGET_ZCMP
   && (REGNO (operands[0]) != REGNO (operands[2]))
   && (REGNO (operands[1]) != REGNO (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_5 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          break;

        case SUBREG:
        case MEM:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern407 (
E_SImode) == 0
                  && 
#line 26 "../../gcc/config/riscv/thead-peephole.md"
(TARGET_XTHEADMEMPAIR
  && th_mempair_operands_p (operands, true, SImode)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_6 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case E_DImode:
              if (pattern407 (
E_DImode) == 0
                  && (
#line 26 "../../gcc/config/riscv/thead-peephole.md"
(TARGET_XTHEADMEMPAIR
  && th_mempair_operands_p (operands, true, DImode)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_7 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern393 (
E_SImode) != 0
              || !
#line 40 "../../gcc/config/riscv/thead-peephole.md"
(TARGET_XTHEADMEMPAIR
  && th_mempair_operands_p (operands, false, SImode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_8 (insn, operands);

        case E_DImode:
          if (pattern393 (
E_DImode) != 0
              || !(
#line 40 "../../gcc/config/riscv/thead-peephole.md"
(TARGET_XTHEADMEMPAIR
  && th_mempair_operands_p (operands, false, DImode)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_9 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (pattern277 (x4, 
SIGN_EXTEND) != 0
          || !
#line 54 "../../gcc/config/riscv/thead-peephole.md"
(TARGET_XTHEADMEMPAIR && TARGET_64BIT
  && th_mempair_operands_p (operands, true, SImode)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_10 (insn, operands);

    case ZERO_EXTEND:
      if (pattern277 (x4, 
ZERO_EXTEND) != 0
          || !
#line 68 "../../gcc/config/riscv/thead-peephole.md"
(TARGET_XTHEADMEMPAIR && TARGET_64BIT
  && th_mempair_operands_p (operands, true, SImode)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_11 (insn, operands);

    default:
      return NULL;
    }
}
