/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8DImode)
      || GET_MODE (x1) != E_RVVM8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DFmode:
      if (!register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM1DFmode:
      if (!register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 0;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64HImode)
      || GET_MODE (x1) != E_V64HImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[1], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!register_operand (operands[1], E_V64SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V4HFmode:
      if (!register_operand (operands[1], E_V4HFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512SImode)
      || GET_MODE (x1) != E_V512SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 0;

    case E_V512HFmode:
      if (!register_operand (operands[1], E_V512HFmode))
        return -1;
      return 1;

    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512DImode)
      || GET_MODE (x1) != E_V512DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512DFmode))
        return -1;
      return 0;

    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF4HFmode)
      || GET_MODE (x1) != E_RVVMF4HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8DFmode)
      || GET_MODE (x1) != E_RVVM8DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM2DFmode)
      || GET_MODE (x1) != E_RVVM2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 0;

    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1024HFmode)
      || GET_MODE (x1) != E_V1024HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1024HImode:
      if (!register_operand (operands[1], E_V1024HImode))
        return -1;
      return 0;

    case E_V1024QImode:
      if (!register_operand (operands[1], E_V1024QImode))
        return -1;
      return 1;

    case E_V1024SImode:
      if (!register_operand (operands[1], E_V1024SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V32SFmode)
      || GET_MODE (x1) != E_V32SFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      return 0;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32DImode:
      if (!register_operand (operands[1], E_V32DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V256DFmode)
      || GET_MODE (x1) != E_V256DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V256DImode:
      if (!register_operand (operands[1], E_V256DImode))
        return -1;
      return 0;

    case E_V256SImode:
      if (!register_operand (operands[1], E_V256SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern106 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  return pattern105 (x2); /* [-1, 2] */
}

int
pattern108 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[2], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !vector_mask_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 1;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 2;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 3;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 4;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 5;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 6;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 7;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 8;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 9;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 13;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 14;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 15;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 16;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 19;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 22;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 23;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 24;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 25;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 26;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 27;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 28;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 29;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 30;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 31;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 32;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 33;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 34;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 35;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 36;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 37;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 38;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 39;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 40;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 41;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 42;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 43;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 44;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 45;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 46;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 47;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 48;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 49;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 50;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 51;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 52;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 53;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 54;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 55;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 56;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 57;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 58;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 59;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 60;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 61;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 62;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 63;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 64;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 65;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 66;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 67;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 68;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 69;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SFmode:
      return pattern128 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode); /* [-1, 0] */

    case E_RVVM4SFmode:
      if (pattern128 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2SFmode:
      if (pattern128 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1SFmode:
      if (pattern128 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SFmode:
      if (pattern128 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 4;

    case E_RVVM8DFmode:
      if (pattern128 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode) != 0)
        return -1;
      return 5;

    case E_RVVM4DFmode:
      if (pattern128 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode) != 0)
        return -1;
      return 6;

    case E_RVVM2DFmode:
      if (pattern128 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode) != 0)
        return -1;
      return 7;

    case E_RVVM1DFmode:
      if (pattern128 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode) != 0)
        return -1;
      return 8;

    case E_V1SFmode:
      if (pattern128 (x1, 
E_V1HFmode, 
E_V1SFmode) != 0)
        return -1;
      return 9;

    case E_V2SFmode:
      if (pattern128 (x1, 
E_V2HFmode, 
E_V2SFmode) != 0)
        return -1;
      return 10;

    case E_V4SFmode:
      if (pattern128 (x1, 
E_V4HFmode, 
E_V4SFmode) != 0)
        return -1;
      return 11;

    case E_V8SFmode:
      if (pattern128 (x1, 
E_V8HFmode, 
E_V8SFmode) != 0)
        return -1;
      return 12;

    case E_V16SFmode:
      if (pattern128 (x1, 
E_V16HFmode, 
E_V16SFmode) != 0)
        return -1;
      return 13;

    case E_V32SFmode:
      if (pattern128 (x1, 
E_V32HFmode, 
E_V32SFmode) != 0)
        return -1;
      return 14;

    case E_V64SFmode:
      if (pattern128 (x1, 
E_V64HFmode, 
E_V64SFmode) != 0)
        return -1;
      return 15;

    case E_V128SFmode:
      if (pattern128 (x1, 
E_V128HFmode, 
E_V128SFmode) != 0)
        return -1;
      return 16;

    case E_V256SFmode:
      if (pattern128 (x1, 
E_V256HFmode, 
E_V256SFmode) != 0)
        return -1;
      return 17;

    case E_V512SFmode:
      if (pattern128 (x1, 
E_V512HFmode, 
E_V512SFmode) != 0)
        return -1;
      return 18;

    case E_V1024SFmode:
      if (pattern128 (x1, 
E_V1024HFmode, 
E_V1024SFmode) != 0)
        return -1;
      return 19;

    case E_V1DFmode:
      if (pattern128 (x1, 
E_V1SFmode, 
E_V1DFmode) != 0)
        return -1;
      return 20;

    case E_V2DFmode:
      if (pattern128 (x1, 
E_V2SFmode, 
E_V2DFmode) != 0)
        return -1;
      return 21;

    case E_V4DFmode:
      if (pattern128 (x1, 
E_V4SFmode, 
E_V4DFmode) != 0)
        return -1;
      return 22;

    case E_V8DFmode:
      if (pattern128 (x1, 
E_V8SFmode, 
E_V8DFmode) != 0)
        return -1;
      return 23;

    case E_V16DFmode:
      if (pattern128 (x1, 
E_V16SFmode, 
E_V16DFmode) != 0)
        return -1;
      return 24;

    case E_V32DFmode:
      if (pattern128 (x1, 
E_V32SFmode, 
E_V32DFmode) != 0)
        return -1;
      return 25;

    case E_V64DFmode:
      if (pattern128 (x1, 
E_V64SFmode, 
E_V64DFmode) != 0)
        return -1;
      return 26;

    case E_V128DFmode:
      if (pattern128 (x1, 
E_V128SFmode, 
E_V128DFmode) != 0)
        return -1;
      return 27;

    case E_V256DFmode:
      if (pattern128 (x1, 
E_V256SFmode, 
E_V256DFmode) != 0)
        return -1;
      return 28;

    case E_V512DFmode:
      if (pattern128 (x1, 
E_V512SFmode, 
E_V512DFmode) != 0)
        return -1;
      return 29;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          return pattern136 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

        case E_RVVM4HFmode:
          if (pattern136 (x1, 
E_RVVM4HFmode) != 0)
            return -1;
          return 1;

        case E_RVVM2HFmode:
          if (pattern136 (x1, 
E_RVVM2HFmode) != 0)
            return -1;
          return 2;

        case E_RVVM1HFmode:
          if (pattern136 (x1, 
E_RVVM1HFmode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HFmode:
          if (pattern136 (x1, 
E_RVVMF2HFmode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HFmode:
          if (pattern136 (x1, 
E_RVVMF4HFmode) != 0)
            return -1;
          return 5;

        case E_RVVM8SFmode:
          if (pattern136 (x1, 
E_RVVM8SFmode) != 0)
            return -1;
          return 6;

        case E_RVVM4SFmode:
          if (pattern136 (x1, 
E_RVVM4SFmode) != 0)
            return -1;
          return 7;

        case E_RVVM2SFmode:
          if (pattern136 (x1, 
E_RVVM2SFmode) != 0)
            return -1;
          return 8;

        case E_RVVM1SFmode:
          if (pattern136 (x1, 
E_RVVM1SFmode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (pattern136 (x1, 
E_RVVMF2SFmode) != 0)
            return -1;
          return 10;

        case E_RVVM8DFmode:
          if (pattern136 (x1, 
E_RVVM8DFmode) != 0)
            return -1;
          return 11;

        case E_RVVM4DFmode:
          if (pattern136 (x1, 
E_RVVM4DFmode) != 0)
            return -1;
          return 12;

        case E_RVVM2DFmode:
          if (pattern136 (x1, 
E_RVVM2DFmode) != 0)
            return -1;
          return 13;

        case E_RVVM1DFmode:
          if (pattern136 (x1, 
E_RVVM1DFmode) != 0)
            return -1;
          return 14;

        case E_V1HFmode:
          if (pattern136 (x1, 
E_V1HFmode) != 0)
            return -1;
          return 15;

        case E_V2HFmode:
          if (pattern136 (x1, 
E_V2HFmode) != 0)
            return -1;
          return 16;

        case E_V4HFmode:
          if (pattern136 (x1, 
E_V4HFmode) != 0)
            return -1;
          return 17;

        case E_V8HFmode:
          if (pattern136 (x1, 
E_V8HFmode) != 0)
            return -1;
          return 18;

        case E_V16HFmode:
          if (pattern136 (x1, 
E_V16HFmode) != 0)
            return -1;
          return 19;

        case E_V32HFmode:
          if (pattern136 (x1, 
E_V32HFmode) != 0)
            return -1;
          return 20;

        case E_V64HFmode:
          if (pattern136 (x1, 
E_V64HFmode) != 0)
            return -1;
          return 21;

        case E_V128HFmode:
          if (pattern136 (x1, 
E_V128HFmode) != 0)
            return -1;
          return 22;

        case E_V256HFmode:
          if (pattern136 (x1, 
E_V256HFmode) != 0)
            return -1;
          return 23;

        case E_V512HFmode:
          if (pattern136 (x1, 
E_V512HFmode) != 0)
            return -1;
          return 24;

        case E_V1024HFmode:
          if (pattern136 (x1, 
E_V1024HFmode) != 0)
            return -1;
          return 25;

        case E_V2048HFmode:
          if (pattern136 (x1, 
E_V2048HFmode) != 0)
            return -1;
          return 26;

        case E_V1SFmode:
          if (pattern136 (x1, 
E_V1SFmode) != 0)
            return -1;
          return 27;

        case E_V2SFmode:
          if (pattern136 (x1, 
E_V2SFmode) != 0)
            return -1;
          return 28;

        case E_V4SFmode:
          if (pattern136 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 29;

        case E_V8SFmode:
          if (pattern136 (x1, 
E_V8SFmode) != 0)
            return -1;
          return 30;

        case E_V16SFmode:
          if (pattern136 (x1, 
E_V16SFmode) != 0)
            return -1;
          return 31;

        case E_V32SFmode:
          if (pattern136 (x1, 
E_V32SFmode) != 0)
            return -1;
          return 32;

        case E_V64SFmode:
          if (pattern136 (x1, 
E_V64SFmode) != 0)
            return -1;
          return 33;

        case E_V128SFmode:
          if (pattern136 (x1, 
E_V128SFmode) != 0)
            return -1;
          return 34;

        case E_V256SFmode:
          if (pattern136 (x1, 
E_V256SFmode) != 0)
            return -1;
          return 35;

        case E_V512SFmode:
          if (pattern136 (x1, 
E_V512SFmode) != 0)
            return -1;
          return 36;

        case E_V1024SFmode:
          if (pattern136 (x1, 
E_V1024SFmode) != 0)
            return -1;
          return 37;

        case E_V1DFmode:
          if (pattern136 (x1, 
E_V1DFmode) != 0)
            return -1;
          return 38;

        case E_V2DFmode:
          if (pattern136 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 39;

        case E_V4DFmode:
          if (pattern136 (x1, 
E_V4DFmode) != 0)
            return -1;
          return 40;

        case E_V8DFmode:
          if (pattern136 (x1, 
E_V8DFmode) != 0)
            return -1;
          return 41;

        case E_V16DFmode:
          if (pattern136 (x1, 
E_V16DFmode) != 0)
            return -1;
          return 42;

        case E_V32DFmode:
          if (pattern136 (x1, 
E_V32DFmode) != 0)
            return -1;
          return 43;

        case E_V64DFmode:
          if (pattern136 (x1, 
E_V64DFmode) != 0)
            return -1;
          return 44;

        case E_V128DFmode:
          if (pattern136 (x1, 
E_V128DFmode) != 0)
            return -1;
          return 45;

        case E_V256DFmode:
          if (pattern136 (x1, 
E_V256DFmode) != 0)
            return -1;
          return 46;

        case E_V512DFmode:
          if (pattern136 (x1, 
E_V512DFmode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      res = pattern139 (x1);
      if (res >= 0)
        return res + 48; /* [48, 107] */
      return -1;

    case NEG:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != FLOAT_EXTEND)
        return -1;
      x5 = XEXP (x1, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case FLOAT_EXTEND:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x8 = XEXP (x4, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern140 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0)
                return -1;
              return 108;

            case E_RVVM4SFmode:
              if (pattern140 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0)
                return -1;
              return 109;

            case E_RVVM2SFmode:
              if (pattern140 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0)
                return -1;
              return 110;

            case E_RVVM1SFmode:
              if (pattern140 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0)
                return -1;
              return 111;

            case E_RVVMF2SFmode:
              if (pattern140 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0)
                return -1;
              return 112;

            case E_RVVM8DFmode:
              if (pattern140 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0)
                return -1;
              return 113;

            case E_RVVM4DFmode:
              if (pattern140 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0)
                return -1;
              return 114;

            case E_RVVM2DFmode:
              if (pattern140 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0)
                return -1;
              return 115;

            case E_RVVM1DFmode:
              if (pattern140 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0)
                return -1;
              return 116;

            case E_V1SFmode:
              if (pattern140 (x1, 
E_V1SFmode, 
E_V1HFmode) != 0)
                return -1;
              return 117;

            case E_V2SFmode:
              if (pattern140 (x1, 
E_V2SFmode, 
E_V2HFmode) != 0)
                return -1;
              return 118;

            case E_V4SFmode:
              if (pattern140 (x1, 
E_V4SFmode, 
E_V4HFmode) != 0)
                return -1;
              return 119;

            case E_V8SFmode:
              if (pattern140 (x1, 
E_V8SFmode, 
E_V8HFmode) != 0)
                return -1;
              return 120;

            case E_V16SFmode:
              if (pattern140 (x1, 
E_V16SFmode, 
E_V16HFmode) != 0)
                return -1;
              return 121;

            case E_V32SFmode:
              if (pattern140 (x1, 
E_V32SFmode, 
E_V32HFmode) != 0)
                return -1;
              return 122;

            case E_V64SFmode:
              if (pattern140 (x1, 
E_V64SFmode, 
E_V64HFmode) != 0)
                return -1;
              return 123;

            case E_V128SFmode:
              if (pattern140 (x1, 
E_V128SFmode, 
E_V128HFmode) != 0)
                return -1;
              return 124;

            case E_V256SFmode:
              if (pattern140 (x1, 
E_V256SFmode, 
E_V256HFmode) != 0)
                return -1;
              return 125;

            case E_V512SFmode:
              if (pattern140 (x1, 
E_V512SFmode, 
E_V512HFmode) != 0)
                return -1;
              return 126;

            case E_V1024SFmode:
              if (pattern140 (x1, 
E_V1024SFmode, 
E_V1024HFmode) != 0)
                return -1;
              return 127;

            case E_V1DFmode:
              if (pattern140 (x1, 
E_V1DFmode, 
E_V1SFmode) != 0)
                return -1;
              return 128;

            case E_V2DFmode:
              if (pattern140 (x1, 
E_V2DFmode, 
E_V2SFmode) != 0)
                return -1;
              return 129;

            case E_V4DFmode:
              if (pattern140 (x1, 
E_V4DFmode, 
E_V4SFmode) != 0)
                return -1;
              return 130;

            case E_V8DFmode:
              if (pattern140 (x1, 
E_V8DFmode, 
E_V8SFmode) != 0)
                return -1;
              return 131;

            case E_V16DFmode:
              if (pattern140 (x1, 
E_V16DFmode, 
E_V16SFmode) != 0)
                return -1;
              return 132;

            case E_V32DFmode:
              if (pattern140 (x1, 
E_V32DFmode, 
E_V32SFmode) != 0)
                return -1;
              return 133;

            case E_V64DFmode:
              if (pattern140 (x1, 
E_V64DFmode, 
E_V64SFmode) != 0)
                return -1;
              return 134;

            case E_V128DFmode:
              if (pattern140 (x1, 
E_V128DFmode, 
E_V128SFmode) != 0)
                return -1;
              return 135;

            case E_V256DFmode:
              if (pattern140 (x1, 
E_V256DFmode, 
E_V256SFmode) != 0)
                return -1;
              return 136;

            case E_V512DFmode:
              if (pattern140 (x1, 
E_V512DFmode, 
E_V512SFmode) != 0)
                return -1;
              return 137;

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x6;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern141 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0)
                return -1;
              return 138;

            case E_RVVM4SFmode:
              if (pattern141 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0)
                return -1;
              return 139;

            case E_RVVM2SFmode:
              if (pattern141 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0)
                return -1;
              return 140;

            case E_RVVM1SFmode:
              if (pattern141 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0)
                return -1;
              return 141;

            case E_RVVMF2SFmode:
              if (pattern141 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0)
                return -1;
              return 142;

            case E_RVVM8DFmode:
              if (pattern141 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0)
                return -1;
              return 143;

            case E_RVVM4DFmode:
              if (pattern141 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0)
                return -1;
              return 144;

            case E_RVVM2DFmode:
              if (pattern141 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0)
                return -1;
              return 145;

            case E_RVVM1DFmode:
              if (pattern141 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0)
                return -1;
              return 146;

            case E_V1SFmode:
              if (pattern141 (x1, 
E_V1SFmode, 
E_V1HFmode) != 0)
                return -1;
              return 147;

            case E_V2SFmode:
              if (pattern141 (x1, 
E_V2SFmode, 
E_V2HFmode) != 0)
                return -1;
              return 148;

            case E_V4SFmode:
              if (pattern141 (x1, 
E_V4SFmode, 
E_V4HFmode) != 0)
                return -1;
              return 149;

            case E_V8SFmode:
              if (pattern141 (x1, 
E_V8SFmode, 
E_V8HFmode) != 0)
                return -1;
              return 150;

            case E_V16SFmode:
              if (pattern141 (x1, 
E_V16SFmode, 
E_V16HFmode) != 0)
                return -1;
              return 151;

            case E_V32SFmode:
              if (pattern141 (x1, 
E_V32SFmode, 
E_V32HFmode) != 0)
                return -1;
              return 152;

            case E_V64SFmode:
              if (pattern141 (x1, 
E_V64SFmode, 
E_V64HFmode) != 0)
                return -1;
              return 153;

            case E_V128SFmode:
              if (pattern141 (x1, 
E_V128SFmode, 
E_V128HFmode) != 0)
                return -1;
              return 154;

            case E_V256SFmode:
              if (pattern141 (x1, 
E_V256SFmode, 
E_V256HFmode) != 0)
                return -1;
              return 155;

            case E_V512SFmode:
              if (pattern141 (x1, 
E_V512SFmode, 
E_V512HFmode) != 0)
                return -1;
              return 156;

            case E_V1024SFmode:
              if (pattern141 (x1, 
E_V1024SFmode, 
E_V1024HFmode) != 0)
                return -1;
              return 157;

            case E_V1DFmode:
              if (pattern141 (x1, 
E_V1DFmode, 
E_V1SFmode) != 0)
                return -1;
              return 158;

            case E_V2DFmode:
              if (pattern141 (x1, 
E_V2DFmode, 
E_V2SFmode) != 0)
                return -1;
              return 159;

            case E_V4DFmode:
              if (pattern141 (x1, 
E_V4DFmode, 
E_V4SFmode) != 0)
                return -1;
              return 160;

            case E_V8DFmode:
              if (pattern141 (x1, 
E_V8DFmode, 
E_V8SFmode) != 0)
                return -1;
              return 161;

            case E_V16DFmode:
              if (pattern141 (x1, 
E_V16DFmode, 
E_V16SFmode) != 0)
                return -1;
              return 162;

            case E_V32DFmode:
              if (pattern141 (x1, 
E_V32DFmode, 
E_V32SFmode) != 0)
                return -1;
              return 163;

            case E_V64DFmode:
              if (pattern141 (x1, 
E_V64DFmode, 
E_V64SFmode) != 0)
                return -1;
              return 164;

            case E_V128DFmode:
              if (pattern141 (x1, 
E_V128DFmode, 
E_V128SFmode) != 0)
                return -1;
              return 165;

            case E_V256DFmode:
              if (pattern141 (x1, 
E_V256DFmode, 
E_V256SFmode) != 0)
                return -1;
              return 166;

            case E_V512DFmode:
              if (pattern141 (x1, 
E_V512DFmode, 
E_V512SFmode) != 0)
                return -1;
              return 167;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern191 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern194 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != AND
      || GET_MODE (x6) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x8 = XEXP (x1, 1);
  operands[3] = x8;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x9 = XEXP (x6, 0);
  switch (GET_CODE (x9))
    {
    case NOT:
      if (GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern201 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !nonmemory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern204 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i2)
      || !csr_operand (operands[3], i4)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern211 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode)
          || GET_MODE (x1) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVMF2BImode)
          || GET_MODE (x3) != E_RVVM8HFmode
          || !register_operand (operands[3], E_RVVM8HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8HImode:
          if (!register_operand (operands[2], E_RVVM8HImode))
            return -1;
          return 0;

        case E_RVVM4QImode:
          if (!register_operand (operands[2], E_RVVM4QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x1) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[3], E_RVVM4HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[2], E_RVVM4HImode))
            return -1;
          return 2;

        case E_RVVM2QImode:
          if (!register_operand (operands[2], E_RVVM2QImode))
            return -1;
          return 3;

        case E_RVVM8SImode:
          if (!register_operand (operands[2], E_RVVM8SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x1) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[3], E_RVVM2HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[2], E_RVVM2HImode))
            return -1;
          return 5;

        case E_RVVM1QImode:
          if (!register_operand (operands[2], E_RVVM1QImode))
            return -1;
          return 6;

        case E_RVVM4SImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x1) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[3], E_RVVM1HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[2], E_RVVM1HImode))
            return -1;
          return 8;

        case E_RVVMF2QImode:
          if (!register_operand (operands[2], E_RVVMF2QImode))
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x1) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[3], E_RVVMF2HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[2], E_RVVMF2HImode))
            return -1;
          return 11;

        case E_RVVMF4QImode:
          if (!register_operand (operands[2], E_RVVMF4QImode))
            return -1;
          return 12;

        case E_RVVM1SImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x1) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[3], E_RVVMF4HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[2], E_RVVMF4HImode))
            return -1;
          return 14;

        case E_RVVMF8QImode:
          if (!register_operand (operands[2], E_RVVMF8QImode))
            return -1;
          return 15;

        case E_RVVMF2SImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 16;

        default:
          return -1;
        }

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x1) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[3], E_RVVM8SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8SImode:
          if (!register_operand (operands[2], E_RVVM8SImode))
            return -1;
          return 17;

        case E_RVVM4HImode:
          if (!register_operand (operands[2], E_RVVM4HImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x1) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[3], E_RVVM4SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 19;

        case E_RVVM2HImode:
          if (!register_operand (operands[2], E_RVVM2HImode))
            return -1;
          return 20;

        case E_RVVM8DImode:
          if (!register_operand (operands[2], E_RVVM8DImode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x1) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[3], E_RVVM2SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 22;

        case E_RVVM1HImode:
          if (!register_operand (operands[2], E_RVVM1HImode))
            return -1;
          return 23;

        case E_RVVM4DImode:
          if (!register_operand (operands[2], E_RVVM4DImode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x1) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[3], E_RVVM1SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 25;

        case E_RVVMF2HImode:
          if (!register_operand (operands[2], E_RVVMF2HImode))
            return -1;
          return 26;

        case E_RVVM2DImode:
          if (!register_operand (operands[2], E_RVVM2DImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x1) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[3], E_RVVMF2SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 28;

        case E_RVVMF4HImode:
          if (!register_operand (operands[2], E_RVVMF4HImode))
            return -1;
          return 29;

        case E_RVVM1DImode:
          if (!register_operand (operands[2], E_RVVM1DImode))
            return -1;
          return 30;

        default:
          return -1;
        }

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x1) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[3], E_RVVM8DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8DImode:
          if (!register_operand (operands[2], E_RVVM8DImode))
            return -1;
          return 31;

        case E_RVVM4SImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 32;

        default:
          return -1;
        }

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x1) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[3], E_RVVM4DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4DImode:
          if (!register_operand (operands[2], E_RVVM4DImode))
            return -1;
          return 33;

        case E_RVVM2SImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 34;

        default:
          return -1;
        }

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x1) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[3], E_RVVM2DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2DImode:
          if (!register_operand (operands[2], E_RVVM2DImode))
            return -1;
          return 35;

        case E_RVVM1SImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 36;

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x1) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[3], E_RVVM1DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1DImode:
          if (!register_operand (operands[2], E_RVVM1DImode))
            return -1;
          return 37;

        case E_RVVMF2SImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 38;

        default:
          return -1;
        }

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x1) != E_V1HFmode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[3], E_V1HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1HImode:
          if (!register_operand (operands[2], E_V1HImode))
            return -1;
          return 39;

        case E_V1QImode:
          if (!register_operand (operands[2], E_V1QImode))
            return -1;
          return 40;

        case E_V1SImode:
          if (!register_operand (operands[2], E_V1SImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x1) != E_V2HFmode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[3], E_V2HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2HImode:
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          return 42;

        case E_V2QImode:
          if (!register_operand (operands[2], E_V2QImode))
            return -1;
          return 43;

        case E_V2SImode:
          if (!register_operand (operands[2], E_V2SImode))
            return -1;
          return 44;

        default:
          return -1;
        }

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[3], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4HImode:
          if (!register_operand (operands[2], E_V4HImode))
            return -1;
          return 45;

        case E_V4QImode:
          if (!register_operand (operands[2], E_V4QImode))
            return -1;
          return 46;

        case E_V4SImode:
          if (!register_operand (operands[2], E_V4SImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[3], E_V8HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8HImode:
          if (!register_operand (operands[2], E_V8HImode))
            return -1;
          return 48;

        case E_V8QImode:
          if (!register_operand (operands[2], E_V8QImode))
            return -1;
          return 49;

        case E_V8SImode:
          if (!register_operand (operands[2], E_V8SImode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x1) != E_V16HFmode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[3], E_V16HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16HImode:
          if (!register_operand (operands[2], E_V16HImode))
            return -1;
          return 51;

        case E_V16QImode:
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          return 52;

        case E_V16SImode:
          if (!register_operand (operands[2], E_V16SImode))
            return -1;
          return 53;

        default:
          return -1;
        }

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x1) != E_V32HFmode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[3], E_V32HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32HImode:
          if (!register_operand (operands[2], E_V32HImode))
            return -1;
          return 54;

        case E_V32QImode:
          if (!register_operand (operands[2], E_V32QImode))
            return -1;
          return 55;

        case E_V32SImode:
          if (!register_operand (operands[2], E_V32SImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x1) != E_V64HFmode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[3], E_V64HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64HImode:
          if (!register_operand (operands[2], E_V64HImode))
            return -1;
          return 57;

        case E_V64QImode:
          if (!register_operand (operands[2], E_V64QImode))
            return -1;
          return 58;

        case E_V64SImode:
          if (!register_operand (operands[2], E_V64SImode))
            return -1;
          return 59;

        default:
          return -1;
        }

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x1) != E_V128HFmode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[3], E_V128HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128HImode:
          if (!register_operand (operands[2], E_V128HImode))
            return -1;
          return 60;

        case E_V128QImode:
          if (!register_operand (operands[2], E_V128QImode))
            return -1;
          return 61;

        case E_V128SImode:
          if (!register_operand (operands[2], E_V128SImode))
            return -1;
          return 62;

        default:
          return -1;
        }

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x1) != E_V256HFmode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[3], E_V256HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256HImode:
          if (!register_operand (operands[2], E_V256HImode))
            return -1;
          return 63;

        case E_V256QImode:
          if (!register_operand (operands[2], E_V256QImode))
            return -1;
          return 64;

        case E_V256SImode:
          if (!register_operand (operands[2], E_V256SImode))
            return -1;
          return 65;

        default:
          return -1;
        }

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x1) != E_V512HFmode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[3], E_V512HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512HImode:
          if (!register_operand (operands[2], E_V512HImode))
            return -1;
          return 66;

        case E_V512QImode:
          if (!register_operand (operands[2], E_V512QImode))
            return -1;
          return 67;

        case E_V512SImode:
          if (!register_operand (operands[2], E_V512SImode))
            return -1;
          return 68;

        default:
          return -1;
        }

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x1) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[3], E_V1024HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[2], E_V1024HImode))
            return -1;
          return 69;

        case E_V1024QImode:
          if (!register_operand (operands[2], E_V1024QImode))
            return -1;
          return 70;

        case E_V1024SImode:
          if (!register_operand (operands[2], E_V1024SImode))
            return -1;
          return 71;

        default:
          return -1;
        }

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || GET_MODE (x1) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048BImode)
          || GET_MODE (x3) != E_V2048HFmode
          || !register_operand (operands[3], E_V2048HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2048HImode:
          if (!register_operand (operands[2], E_V2048HImode))
            return -1;
          return 72;

        case E_V2048QImode:
          if (!register_operand (operands[2], E_V2048QImode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x1) != E_V1SFmode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[3], E_V1SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1SImode:
          if (!register_operand (operands[2], E_V1SImode))
            return -1;
          return 74;

        case E_V1HImode:
          if (!register_operand (operands[2], E_V1HImode))
            return -1;
          return 75;

        case E_V1DImode:
          if (!register_operand (operands[2], E_V1DImode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[3], E_V2SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2SImode:
          if (!register_operand (operands[2], E_V2SImode))
            return -1;
          return 77;

        case E_V2HImode:
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          return 78;

        case E_V2DImode:
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[3], E_V4SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4SImode:
          if (!register_operand (operands[2], E_V4SImode))
            return -1;
          return 80;

        case E_V4HImode:
          if (!register_operand (operands[2], E_V4HImode))
            return -1;
          return 81;

        case E_V4DImode:
          if (!register_operand (operands[2], E_V4DImode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[3], E_V8SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8SImode:
          if (!register_operand (operands[2], E_V8SImode))
            return -1;
          return 83;

        case E_V8HImode:
          if (!register_operand (operands[2], E_V8HImode))
            return -1;
          return 84;

        case E_V8DImode:
          if (!register_operand (operands[2], E_V8DImode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x1) != E_V16SFmode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[3], E_V16SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16SImode:
          if (!register_operand (operands[2], E_V16SImode))
            return -1;
          return 86;

        case E_V16HImode:
          if (!register_operand (operands[2], E_V16HImode))
            return -1;
          return 87;

        case E_V16DImode:
          if (!register_operand (operands[2], E_V16DImode))
            return -1;
          return 88;

        default:
          return -1;
        }

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x1) != E_V32SFmode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[3], E_V32SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32SImode:
          if (!register_operand (operands[2], E_V32SImode))
            return -1;
          return 89;

        case E_V32HImode:
          if (!register_operand (operands[2], E_V32HImode))
            return -1;
          return 90;

        case E_V32DImode:
          if (!register_operand (operands[2], E_V32DImode))
            return -1;
          return 91;

        default:
          return -1;
        }

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x1) != E_V64SFmode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[3], E_V64SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64SImode:
          if (!register_operand (operands[2], E_V64SImode))
            return -1;
          return 92;

        case E_V64HImode:
          if (!register_operand (operands[2], E_V64HImode))
            return -1;
          return 93;

        case E_V64DImode:
          if (!register_operand (operands[2], E_V64DImode))
            return -1;
          return 94;

        default:
          return -1;
        }

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x1) != E_V128SFmode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[3], E_V128SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128SImode:
          if (!register_operand (operands[2], E_V128SImode))
            return -1;
          return 95;

        case E_V128HImode:
          if (!register_operand (operands[2], E_V128HImode))
            return -1;
          return 96;

        case E_V128DImode:
          if (!register_operand (operands[2], E_V128DImode))
            return -1;
          return 97;

        default:
          return -1;
        }

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x1) != E_V256SFmode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[3], E_V256SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256SImode:
          if (!register_operand (operands[2], E_V256SImode))
            return -1;
          return 98;

        case E_V256HImode:
          if (!register_operand (operands[2], E_V256HImode))
            return -1;
          return 99;

        case E_V256DImode:
          if (!register_operand (operands[2], E_V256DImode))
            return -1;
          return 100;

        default:
          return -1;
        }

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x1) != E_V512SFmode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[3], E_V512SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512SImode:
          if (!register_operand (operands[2], E_V512SImode))
            return -1;
          return 101;

        case E_V512HImode:
          if (!register_operand (operands[2], E_V512HImode))
            return -1;
          return 102;

        case E_V512DImode:
          if (!register_operand (operands[2], E_V512DImode))
            return -1;
          return 103;

        default:
          return -1;
        }

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x1) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[3], E_V1024SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024SImode:
          if (!register_operand (operands[2], E_V1024SImode))
            return -1;
          return 104;

        case E_V1024HImode:
          if (!register_operand (operands[2], E_V1024HImode))
            return -1;
          return 105;

        default:
          return -1;
        }

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x1) != E_V1DFmode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[3], E_V1DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1DImode:
          if (!register_operand (operands[2], E_V1DImode))
            return -1;
          return 106;

        case E_V1SImode:
          if (!register_operand (operands[2], E_V1SImode))
            return -1;
          return 107;

        default:
          return -1;
        }

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[3], E_V2DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2DImode:
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          return 108;

        case E_V2SImode:
          if (!register_operand (operands[2], E_V2SImode))
            return -1;
          return 109;

        default:
          return -1;
        }

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x1) != E_V4DFmode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[3], E_V4DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4DImode:
          if (!register_operand (operands[2], E_V4DImode))
            return -1;
          return 110;

        case E_V4SImode:
          if (!register_operand (operands[2], E_V4SImode))
            return -1;
          return 111;

        default:
          return -1;
        }

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x1) != E_V8DFmode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[3], E_V8DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8DImode:
          if (!register_operand (operands[2], E_V8DImode))
            return -1;
          return 112;

        case E_V8SImode:
          if (!register_operand (operands[2], E_V8SImode))
            return -1;
          return 113;

        default:
          return -1;
        }

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x1) != E_V16DFmode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[3], E_V16DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16DImode:
          if (!register_operand (operands[2], E_V16DImode))
            return -1;
          return 114;

        case E_V16SImode:
          if (!register_operand (operands[2], E_V16SImode))
            return -1;
          return 115;

        default:
          return -1;
        }

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x1) != E_V32DFmode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[3], E_V32DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32DImode:
          if (!register_operand (operands[2], E_V32DImode))
            return -1;
          return 116;

        case E_V32SImode:
          if (!register_operand (operands[2], E_V32SImode))
            return -1;
          return 117;

        default:
          return -1;
        }

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x1) != E_V64DFmode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[3], E_V64DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64DImode:
          if (!register_operand (operands[2], E_V64DImode))
            return -1;
          return 118;

        case E_V64SImode:
          if (!register_operand (operands[2], E_V64SImode))
            return -1;
          return 119;

        default:
          return -1;
        }

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x1) != E_V128DFmode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[3], E_V128DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128DImode:
          if (!register_operand (operands[2], E_V128DImode))
            return -1;
          return 120;

        case E_V128SImode:
          if (!register_operand (operands[2], E_V128SImode))
            return -1;
          return 121;

        default:
          return -1;
        }

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x1) != E_V256DFmode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[3], E_V256DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256DImode:
          if (!register_operand (operands[2], E_V256DImode))
            return -1;
          return 122;

        case E_V256SImode:
          if (!register_operand (operands[2], E_V256SImode))
            return -1;
          return 123;

        default:
          return -1;
        }

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x1) != E_V512DFmode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[3], E_V512DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512DImode:
          if (!register_operand (operands[2], E_V512DImode))
            return -1;
          return 124;

        case E_V512SImode:
          if (!register_operand (operands[2], E_V512SImode))
            return -1;
          return 125;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern287 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern286 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern286 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8SImode)
      || GET_MODE (x1) != E_RVVM8SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM4HImode:
      if (!register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[1], E_RVVM2QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern295 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF2SImode)
      || GET_MODE (x1) != E_RVVMF2SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern300 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1SImode)
      || GET_MODE (x1) != E_V1SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1HImode:
      if (!register_operand (operands[1], E_V1HImode))
        return -1;
      return 0;

    case E_V1QImode:
      if (!register_operand (operands[1], E_V1QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V32SImode)
      || GET_MODE (x1) != E_V32SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode))
        return -1;
      return 0;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1024SImode)
      || GET_MODE (x1) != E_V1024SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1024HImode:
      if (!register_operand (operands[1], E_V1024HImode))
        return -1;
      return 0;

    case E_V1024QImode:
      if (!register_operand (operands[1], E_V1024QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern315 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16DImode)
      || GET_MODE (x1) != E_V16DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 0;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern321 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern324 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 66
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 67
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern329 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern333 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!immediate_operand (operands[2], E_QImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!immediate_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern339 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF2QImode:
      return pattern341 (
E_RVVMF2QImode); /* [-1, 1] */

    case E_RVVMF4QImode:
      res = pattern341 (
E_RVVMF4QImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_RVVMF8QImode:
      res = pattern341 (
E_RVVMF8QImode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case E_RVVMF2HImode:
      res = pattern341 (
E_RVVMF2HImode);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    case E_RVVMF4HImode:
      res = pattern341 (
E_RVVMF4HImode);
      if (res >= 0)
        return res + 8; /* [8, 9] */
      return -1;

    case E_RVVMF2BFmode:
      res = pattern341 (
E_RVVMF2BFmode);
      if (res >= 0)
        return res + 10; /* [10, 11] */
      return -1;

    case E_RVVMF4BFmode:
      res = pattern341 (
E_RVVMF4BFmode);
      if (res >= 0)
        return res + 12; /* [12, 13] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern341 (
E_RVVMF2HFmode);
      if (res >= 0)
        return res + 14; /* [14, 15] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern341 (
E_RVVMF4HFmode);
      if (res >= 0)
        return res + 16; /* [16, 17] */
      return -1;

    case E_RVVMF2SImode:
      res = pattern341 (
E_RVVMF2SImode);
      if (res >= 0)
        return res + 18; /* [18, 19] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern341 (
E_RVVMF2SFmode);
      if (res >= 0)
        return res + 20; /* [20, 21] */
      return -1;

    case E_RVVMF64BImode:
      res = pattern341 (
E_RVVMF64BImode);
      if (res >= 0)
        return res + 22; /* [22, 23] */
      return -1;

    case E_RVVMF32BImode:
      res = pattern341 (
E_RVVMF32BImode);
      if (res >= 0)
        return res + 24; /* [24, 25] */
      return -1;

    case E_RVVMF16BImode:
      res = pattern341 (
E_RVVMF16BImode);
      if (res >= 0)
        return res + 26; /* [26, 27] */
      return -1;

    case E_RVVMF8BImode:
      res = pattern341 (
E_RVVMF8BImode);
      if (res >= 0)
        return res + 28; /* [28, 29] */
      return -1;

    case E_RVVMF4BImode:
      res = pattern341 (
E_RVVMF4BImode);
      if (res >= 0)
        return res + 30; /* [30, 31] */
      return -1;

    case E_RVVMF2BImode:
      res = pattern341 (
E_RVVMF2BImode);
      if (res >= 0)
        return res + 32; /* [32, 33] */
      return -1;

    case E_RVVM1BImode:
      res = pattern341 (
E_RVVM1BImode);
      if (res >= 0)
        return res + 34; /* [34, 35] */
      return -1;

    case E_V32QImode:
      res = pattern341 (
E_V32QImode);
      if (res >= 0)
        return res + 36; /* [36, 37] */
      return -1;

    case E_V64QImode:
      res = pattern341 (
E_V64QImode);
      if (res >= 0)
        return res + 38; /* [38, 39] */
      return -1;

    case E_V128QImode:
      res = pattern341 (
E_V128QImode);
      if (res >= 0)
        return res + 40; /* [40, 41] */
      return -1;

    case E_V256QImode:
      res = pattern341 (
E_V256QImode);
      if (res >= 0)
        return res + 42; /* [42, 43] */
      return -1;

    case E_V512QImode:
      res = pattern341 (
E_V512QImode);
      if (res >= 0)
        return res + 44; /* [44, 45] */
      return -1;

    case E_V1024QImode:
      res = pattern341 (
E_V1024QImode);
      if (res >= 0)
        return res + 46; /* [46, 47] */
      return -1;

    case E_V2048QImode:
      res = pattern341 (
E_V2048QImode);
      if (res >= 0)
        return res + 48; /* [48, 49] */
      return -1;

    case E_V4096QImode:
      res = pattern341 (
E_V4096QImode);
      if (res >= 0)
        return res + 50; /* [50, 51] */
      return -1;

    case E_V32HImode:
      res = pattern341 (
E_V32HImode);
      if (res >= 0)
        return res + 52; /* [52, 53] */
      return -1;

    case E_V64HImode:
      res = pattern341 (
E_V64HImode);
      if (res >= 0)
        return res + 54; /* [54, 55] */
      return -1;

    case E_V128HImode:
      res = pattern341 (
E_V128HImode);
      if (res >= 0)
        return res + 56; /* [56, 57] */
      return -1;

    case E_V256HImode:
      res = pattern341 (
E_V256HImode);
      if (res >= 0)
        return res + 58; /* [58, 59] */
      return -1;

    case E_V512HImode:
      res = pattern341 (
E_V512HImode);
      if (res >= 0)
        return res + 60; /* [60, 61] */
      return -1;

    case E_V1024HImode:
      res = pattern341 (
E_V1024HImode);
      if (res >= 0)
        return res + 62; /* [62, 63] */
      return -1;

    case E_V2048HImode:
      res = pattern341 (
E_V2048HImode);
      if (res >= 0)
        return res + 64; /* [64, 65] */
      return -1;

    case E_V32SImode:
      res = pattern341 (
E_V32SImode);
      if (res >= 0)
        return res + 66; /* [66, 67] */
      return -1;

    case E_V64SImode:
      res = pattern341 (
E_V64SImode);
      if (res >= 0)
        return res + 68; /* [68, 69] */
      return -1;

    case E_V128SImode:
      res = pattern341 (
E_V128SImode);
      if (res >= 0)
        return res + 70; /* [70, 71] */
      return -1;

    case E_V256SImode:
      res = pattern341 (
E_V256SImode);
      if (res >= 0)
        return res + 72; /* [72, 73] */
      return -1;

    case E_V512SImode:
      res = pattern341 (
E_V512SImode);
      if (res >= 0)
        return res + 74; /* [74, 75] */
      return -1;

    case E_V1024SImode:
      res = pattern341 (
E_V1024SImode);
      if (res >= 0)
        return res + 76; /* [76, 77] */
      return -1;

    case E_V32DImode:
      res = pattern341 (
E_V32DImode);
      if (res >= 0)
        return res + 78; /* [78, 79] */
      return -1;

    case E_V64DImode:
      res = pattern341 (
E_V64DImode);
      if (res >= 0)
        return res + 80; /* [80, 81] */
      return -1;

    case E_V128DImode:
      res = pattern341 (
E_V128DImode);
      if (res >= 0)
        return res + 82; /* [82, 83] */
      return -1;

    case E_V256DImode:
      res = pattern341 (
E_V256DImode);
      if (res >= 0)
        return res + 84; /* [84, 85] */
      return -1;

    case E_V512DImode:
      res = pattern341 (
E_V512DImode);
      if (res >= 0)
        return res + 86; /* [86, 87] */
      return -1;

    case E_V32HFmode:
      res = pattern341 (
E_V32HFmode);
      if (res >= 0)
        return res + 88; /* [88, 89] */
      return -1;

    case E_V64HFmode:
      res = pattern341 (
E_V64HFmode);
      if (res >= 0)
        return res + 90; /* [90, 91] */
      return -1;

    case E_V128HFmode:
      res = pattern341 (
E_V128HFmode);
      if (res >= 0)
        return res + 92; /* [92, 93] */
      return -1;

    case E_V256HFmode:
      res = pattern341 (
E_V256HFmode);
      if (res >= 0)
        return res + 94; /* [94, 95] */
      return -1;

    case E_V512HFmode:
      res = pattern341 (
E_V512HFmode);
      if (res >= 0)
        return res + 96; /* [96, 97] */
      return -1;

    case E_V1024HFmode:
      res = pattern341 (
E_V1024HFmode);
      if (res >= 0)
        return res + 98; /* [98, 99] */
      return -1;

    case E_V2048HFmode:
      res = pattern341 (
E_V2048HFmode);
      if (res >= 0)
        return res + 100; /* [100, 101] */
      return -1;

    case E_V32SFmode:
      res = pattern341 (
E_V32SFmode);
      if (res >= 0)
        return res + 102; /* [102, 103] */
      return -1;

    case E_V64SFmode:
      res = pattern341 (
E_V64SFmode);
      if (res >= 0)
        return res + 104; /* [104, 105] */
      return -1;

    case E_V128SFmode:
      res = pattern341 (
E_V128SFmode);
      if (res >= 0)
        return res + 106; /* [106, 107] */
      return -1;

    case E_V256SFmode:
      res = pattern341 (
E_V256SFmode);
      if (res >= 0)
        return res + 108; /* [108, 109] */
      return -1;

    case E_V512SFmode:
      res = pattern341 (
E_V512SFmode);
      if (res >= 0)
        return res + 110; /* [110, 111] */
      return -1;

    case E_V1024SFmode:
      res = pattern341 (
E_V1024SFmode);
      if (res >= 0)
        return res + 112; /* [112, 113] */
      return -1;

    case E_V32DFmode:
      res = pattern341 (
E_V32DFmode);
      if (res >= 0)
        return res + 114; /* [114, 115] */
      return -1;

    case E_V64DFmode:
      res = pattern341 (
E_V64DFmode);
      if (res >= 0)
        return res + 116; /* [116, 117] */
      return -1;

    case E_V128DFmode:
      res = pattern341 (
E_V128DFmode);
      if (res >= 0)
        return res + 118; /* [118, 119] */
      return -1;

    case E_V256DFmode:
      res = pattern341 (
E_V256DFmode);
      if (res >= 0)
        return res + 120; /* [120, 121] */
      return -1;

    case E_V512DFmode:
      res = pattern341 (
E_V512DFmode);
      if (res >= 0)
        return res + 122; /* [122, 123] */
      return -1;

    case E_V32BImode:
      res = pattern341 (
E_V32BImode);
      if (res >= 0)
        return res + 124; /* [124, 125] */
      return -1;

    case E_V64BImode:
      res = pattern341 (
E_V64BImode);
      if (res >= 0)
        return res + 126; /* [126, 127] */
      return -1;

    case E_V128BImode:
      res = pattern341 (
E_V128BImode);
      if (res >= 0)
        return res + 128; /* [128, 129] */
      return -1;

    case E_V256BImode:
      res = pattern341 (
E_V256BImode);
      if (res >= 0)
        return res + 130; /* [130, 131] */
      return -1;

    case E_V512BImode:
      res = pattern341 (
E_V512BImode);
      if (res >= 0)
        return res + 132; /* [132, 133] */
      return -1;

    case E_V1024BImode:
      res = pattern341 (
E_V1024BImode);
      if (res >= 0)
        return res + 134; /* [134, 135] */
      return -1;

    case E_V2048BImode:
      res = pattern341 (
E_V2048BImode);
      if (res >= 0)
        return res + 136; /* [136, 137] */
      return -1;

    case E_V4096BImode:
      res = pattern341 (
E_V4096BImode);
      if (res >= 0)
        return res + 138; /* [138, 139] */
      return -1;

    default:
      return -1;
    }
}

int
pattern407 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !memory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern411 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern415 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != AND
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ASHIFT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern420 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern427 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 2)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XEXP (x6, 0);
  if (GET_CODE (x11) != REG)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 2)
    return -1;
  x16 = XEXP (x14, 1);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XEXP (x12, 0);
  if (GET_CODE (x17) != REG)
    return -1;
  x18 = XVECEXP (x1, 0, 3);
  x19 = XEXP (x18, 1);
  if (GET_CODE (x19) != MEM)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != PLUS)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 2)
    return -1;
  x22 = XEXP (x20, 1);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XEXP (x18, 0);
  if (GET_CODE (x23) != REG)
    return -1;
  x24 = XVECEXP (x1, 0, 4);
  x25 = XEXP (x24, 1);
  if (GET_CODE (x25) != MEM)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != PLUS)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XEXP (x24, 0);
  if (GET_CODE (x29) != REG)
    return -1;
  x30 = XVECEXP (x1, 0, 5);
  x31 = XEXP (x30, 1);
  if (GET_CODE (x31) != MEM)
    return -1;
  x32 = XEXP (x31, 0);
  if (GET_CODE (x32) != PLUS)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 2)
    return -1;
  x34 = XEXP (x32, 1);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XEXP (x30, 0);
  if (GET_CODE (x35) != REG)
    return -1;
  x36 = XVECEXP (x1, 0, 6);
  x37 = XEXP (x36, 1);
  if (GET_CODE (x37) != MEM)
    return -1;
  x38 = XEXP (x37, 0);
  if (GET_CODE (x38) != PLUS)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_CODE (x39) != REG
      || REGNO (x39) != 2)
    return -1;
  x40 = XEXP (x38, 1);
  if (GET_CODE (x40) != CONST_INT)
    return -1;
  x41 = XEXP (x36, 0);
  if (GET_CODE (x41) != REG)
    return -1;
  x42 = XVECEXP (x1, 0, 7);
  x43 = XEXP (x42, 1);
  if (GET_CODE (x43) != MEM)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_CODE (x44) != PLUS)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_CODE (x45) != REG
      || REGNO (x45) != 2)
    return -1;
  x46 = XEXP (x44, 1);
  if (GET_CODE (x46) != CONST_INT)
    return -1;
  x47 = XEXP (x42, 0);
  if (GET_CODE (x47) != REG)
    return -1;
  return 0;
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_MODE (x5))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern456 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern455 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern455 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern462 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ASHIFT
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 0);
  return pattern373 (x6); /* [-1, 1] */
}

int
pattern467 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[6] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  x9 = XEXP (x6, 1);
  operands[1] = x9;
  x10 = XEXP (x6, 2);
  operands[3] = x10;
  x11 = XEXP (x1, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  return pattern466 (x1); /* [-1, 91] */
}

int
pattern473 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XEXP (x1, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XVECEXP (x2, 0, 0);
  operands[3] = x10;
  if (!pmode_reg_or_0_operand (operands[3], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x2, 0, 2);
  operands[4] = x11;
  x12 = XEXP (x1, 2);
  operands[2] = x12;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern472 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern472 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern472 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern472 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern472 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern472 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern472 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern472 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern472 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern472 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern472 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern472 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern472 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern472 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern472 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern472 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF8QImode:
      if (pattern472 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4HImode:
      if (pattern472 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2SImode:
      if (pattern472 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern485 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern487 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 2);
  operands[2] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[3] = x9;
      return pattern482 (x1); /* [-1, 67] */

    case VEC_DUPLICATE:
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      x11 = XEXP (x9, 0);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          res = pattern484 (x1);
          if (res >= 0)
            return res + 68; /* [68, 135] */
          return -1;

        case SIGN_EXTEND:
          res = pattern486 (x1);
          if (res >= 0)
            return res + 136; /* [136, 149] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern491 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern494 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 2);
  operands[2] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[3] = x9;
      return pattern493 (x1); /* [-1, 67] */

    case VEC_DUPLICATE:
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      x11 = XEXP (x9, 0);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          res = pattern484 (x1);
          if (res >= 0)
            return res + 68; /* [68, 135] */
          return -1;

        case SIGN_EXTEND:
          res = pattern486 (x1);
          if (res >= 0)
            return res + 136; /* [136, 149] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern495 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !reg_or_0_operand (operands[4], i3)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern496 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern495 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern495 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern495 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern495 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2QImode:
      if (pattern495 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4QImode:
      if (pattern495 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_RVVMF8QImode:
      if (pattern495 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      return 6;

    case E_RVVM8HImode:
      if (pattern495 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_RVVM4HImode:
      if (pattern495 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_RVVM2HImode:
      if (pattern495 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      return 9;

    case E_RVVM1HImode:
      if (pattern495 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      return 10;

    case E_RVVMF2HImode:
      if (pattern495 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      return 11;

    case E_RVVMF4HImode:
      if (pattern495 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern495 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern495 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern495 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern495 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      return 16;

    case E_RVVMF2SImode:
      if (pattern495 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      return 17;

    case E_V1QImode:
      if (pattern495 (x1, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      return 18;

    case E_V2QImode:
      if (pattern495 (x1, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V4QImode:
      if (pattern495 (x1, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V8QImode:
      if (pattern495 (x1, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V16QImode:
      if (pattern495 (x1, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V32QImode:
      if (pattern495 (x1, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      return 23;

    case E_V64QImode:
      if (pattern495 (x1, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      return 24;

    case E_V128QImode:
      if (pattern495 (x1, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      return 25;

    case E_V256QImode:
      if (pattern495 (x1, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      return 26;

    case E_V512QImode:
      if (pattern495 (x1, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      return 27;

    case E_V1024QImode:
      if (pattern495 (x1, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      return 28;

    case E_V2048QImode:
      if (pattern495 (x1, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      return 29;

    case E_V4096QImode:
      if (pattern495 (x1, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
        return -1;
      return 30;

    case E_V1HImode:
      if (pattern495 (x1, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      return 31;

    case E_V2HImode:
      if (pattern495 (x1, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      return 32;

    case E_V4HImode:
      if (pattern495 (x1, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      return 33;

    case E_V8HImode:
      if (pattern495 (x1, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      return 34;

    case E_V16HImode:
      if (pattern495 (x1, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
        return -1;
      return 35;

    case E_V32HImode:
      if (pattern495 (x1, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
        return -1;
      return 36;

    case E_V64HImode:
      if (pattern495 (x1, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
        return -1;
      return 37;

    case E_V128HImode:
      if (pattern495 (x1, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
        return -1;
      return 38;

    case E_V256HImode:
      if (pattern495 (x1, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
        return -1;
      return 39;

    case E_V512HImode:
      if (pattern495 (x1, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
        return -1;
      return 40;

    case E_V1024HImode:
      if (pattern495 (x1, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
        return -1;
      return 41;

    case E_V2048HImode:
      if (pattern495 (x1, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
        return -1;
      return 42;

    case E_V1SImode:
      if (pattern495 (x1, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
        return -1;
      return 43;

    case E_V2SImode:
      if (pattern495 (x1, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
        return -1;
      return 44;

    case E_V4SImode:
      if (pattern495 (x1, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
        return -1;
      return 45;

    case E_V8SImode:
      if (pattern495 (x1, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
        return -1;
      return 46;

    case E_V16SImode:
      if (pattern495 (x1, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
        return -1;
      return 47;

    case E_V32SImode:
      if (pattern495 (x1, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
        return -1;
      return 48;

    case E_V64SImode:
      if (pattern495 (x1, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
        return -1;
      return 49;

    case E_V128SImode:
      if (pattern495 (x1, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
        return -1;
      return 50;

    case E_V256SImode:
      if (pattern495 (x1, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
        return -1;
      return 51;

    case E_V512SImode:
      if (pattern495 (x1, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
        return -1;
      return 52;

    case E_V1024SImode:
      if (pattern495 (x1, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
        return -1;
      return 53;

    case E_RVVM8DImode:
      if (pattern495 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
        return -1;
      return 54;

    case E_RVVM4DImode:
      if (pattern495 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
        return -1;
      return 55;

    case E_RVVM2DImode:
      if (pattern495 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
        return -1;
      return 56;

    case E_RVVM1DImode:
      if (pattern495 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern495 (x1, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern495 (x1, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern495 (x1, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern495 (x1, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern495 (x1, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern495 (x1, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern495 (x1, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern495 (x1, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern495 (x1, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern495 (x1, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern510 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVMF4QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF4QImode))
        return -1;
      return 0;

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 1;

    case E_RVVM1SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 2;

    case E_RVVM2DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern513 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V2QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 0;

    case E_V2HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern516 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V16QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V16HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 1;

    case E_V16SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern519 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V128QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V128QImode))
        return -1;
      return 0;

    case E_V128HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V128HImode))
        return -1;
      return 1;

    case E_V128SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V128SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V1024QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V1024QImode))
        return -1;
      return 0;

    case E_V1024HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V1024HImode))
        return -1;
      return 1;

    case E_V1024SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V1024SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern528 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  return pattern527 (x5, 
i1, 
i2, 
i4); /* [-1, 0] */
}

int
pattern531 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (!comparison_except_ltge_operator (x3, i1))
    return -1;
  return 0;
}

int
pattern532 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (!ltge_operator (x3, i1))
    return -1;
  return 0;
}

int
pattern534 (rtx x1, machine_mode i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 19:
      x13 = XEXP (x11, 1);
      if (GET_CODE (x13) != MEM
          || GET_MODE (x13) != i1)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS
          || GET_MODE (x14) != i1)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 2
          || GET_MODE (x15) != i1)
        return -1;
      x16 = XEXP (x14, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + i5]
          || REGNO (x12) != 18)
        return -1;
      x17 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x17) != SET)
        return -1;
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != MEM
          || GET_MODE (x18) != i1)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != PLUS
          || GET_MODE (x19) != i1)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 2
          || GET_MODE (x20) != i1)
        return -1;
      x21 = XEXP (x19, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
        return -1;
      x22 = XEXP (x17, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 9
          || GET_MODE (x22) != i1)
        return -1;
      x23 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x23) != SET)
        return -1;
      x24 = XEXP (x23, 1);
      if (GET_CODE (x24) != MEM
          || GET_MODE (x24) != i1)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != PLUS
          || GET_MODE (x25) != i1)
        return -1;
      x26 = XEXP (x25, 0);
      if (GET_CODE (x26) != REG
          || REGNO (x26) != 2
          || GET_MODE (x26) != i1)
        return -1;
      x27 = XEXP (x25, 1);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x28 = XEXP (x23, 0);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 8
          || GET_MODE (x28) != i1)
        return -1;
      x29 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x29) != SET)
        return -1;
      x30 = XEXP (x29, 1);
      if (GET_CODE (x30) != MEM
          || GET_MODE (x30) != i1)
        return -1;
      x31 = XEXP (x30, 0);
      if (GET_CODE (x31) != PLUS
          || GET_MODE (x31) != i1)
        return -1;
      x32 = XEXP (x31, 0);
      if (GET_CODE (x32) != REG
          || REGNO (x32) != 2
          || GET_MODE (x32) != i1)
        return -1;
      x33 = XEXP (x31, 1);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
        return -1;
      x34 = XEXP (x29, 0);
      if (GET_CODE (x34) != REG
          || REGNO (x34) != 1
          || GET_MODE (x34) != i1
          || !stack_pop_up_to_s3_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case 9:
      x13 = XEXP (x11, 1);
      if (GET_CODE (x13) != MEM
          || GET_MODE (x13) != i1)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS
          || GET_MODE (x14) != i1)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 2
          || GET_MODE (x15) != i1)
        return -1;
      x16 = XEXP (x14, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + i5]
          || REGNO (x12) != 8)
        return -1;
      x17 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x17) != SET)
        return -1;
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != MEM
          || GET_MODE (x18) != i1)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != PLUS
          || GET_MODE (x19) != i1)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 2
          || GET_MODE (x20) != i1)
        return -1;
      x21 = XEXP (x19, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
        return -1;
      x22 = XEXP (x17, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 1
          || GET_MODE (x22) != i1)
        return -1;
      x23 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x23) != RETURN)
        return -1;
      x29 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x29) != USE)
        return -1;
      x34 = XEXP (x29, 0);
      if (GET_CODE (x34) != REG
          || REGNO (x34) != 1
          || GET_MODE (x34) != E_SImode
          || !stack_pop_up_to_s1_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    case 1:
      x13 = XEXP (x11, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x12) != 10)
        return -1;
      x17 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x17) != USE)
        return -1;
      x22 = XEXP (x17, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 10
          || GET_MODE (x22) != i1)
        return -1;
      x23 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x23) != RETURN)
        return -1;
      x29 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x29) != USE)
        return -1;
      x34 = XEXP (x29, 0);
      if (GET_CODE (x34) != REG
          || REGNO (x34) != 1
          || GET_MODE (x34) != E_SImode
          || !stack_pop_up_to_ra_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern541 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern543 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (!signed_order_operator (x3, i1))
    return -1;
  return 0;
}

int
pattern544 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_RVVMF64BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[2], E_RVVMF64BImode))
        return -1;
      return 0;

    case E_RVVMF32BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[2], E_RVVMF32BImode))
        return -1;
      return 1;

    case E_RVVMF16BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[2], E_RVVMF16BImode))
        return -1;
      return 2;

    case E_RVVMF8BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[2], E_RVVMF8BImode))
        return -1;
      return 3;

    case E_RVVMF4BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[2], E_RVVMF4BImode))
        return -1;
      return 4;

    case E_RVVMF2BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_RVVMF2BImode
          || !vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[2], E_RVVMF2BImode))
        return -1;
      return 5;

    case E_RVVM1BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_RVVM1BImode
          || !vector_mask_operand (operands[1], E_RVVM1BImode)
          || !register_operand (operands[2], E_RVVM1BImode))
        return -1;
      return 6;

    case E_V1BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[2], E_V1BImode))
        return -1;
      return 7;

    case E_V2BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[2], E_V2BImode))
        return -1;
      return 8;

    case E_V4BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[2], E_V4BImode))
        return -1;
      return 9;

    case E_V8BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[2], E_V8BImode))
        return -1;
      return 10;

    case E_V16BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[2], E_V16BImode))
        return -1;
      return 11;

    case E_V32BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[2], E_V32BImode))
        return -1;
      return 12;

    case E_V64BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[2], E_V64BImode))
        return -1;
      return 13;

    case E_V128BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[2], E_V128BImode))
        return -1;
      return 14;

    case E_V256BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[2], E_V256BImode))
        return -1;
      return 15;

    case E_V512BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[2], E_V512BImode))
        return -1;
      return 16;

    case E_V1024BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[2], E_V1024BImode))
        return -1;
      return 17;

    case E_V2048BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V2048BImode
          || !vector_mask_operand (operands[1], E_V2048BImode)
          || !register_operand (operands[2], E_V2048BImode))
        return -1;
      return 18;

    case E_V4096BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V4096BImode
          || !vector_mask_operand (operands[1], E_V4096BImode)
          || !register_operand (operands[2], E_V4096BImode))
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern556 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[3] = x8;
  x9 = XVECEXP (x7, 0, 1);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      return pattern554 (x1); /* [-1, 47] */

    case VEC_DUPLICATE:
      x10 = XEXP (x9, 0);
      operands[4] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern555 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) != 0)
            return -1;
          return 48;

        case E_RVVM4HFmode:
          if (pattern555 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
            return -1;
          return 49;

        case E_RVVM2HFmode:
          if (pattern555 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
            return -1;
          return 50;

        case E_RVVM1HFmode:
          if (pattern555 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
            return -1;
          return 51;

        case E_RVVMF2HFmode:
          if (pattern555 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
            return -1;
          return 52;

        case E_RVVMF4HFmode:
          if (pattern555 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
            return -1;
          return 53;

        case E_RVVM8SFmode:
          if (pattern555 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
            return -1;
          return 54;

        case E_RVVM4SFmode:
          if (pattern555 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
            return -1;
          return 55;

        case E_RVVM2SFmode:
          if (pattern555 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
            return -1;
          return 56;

        case E_RVVM1SFmode:
          if (pattern555 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
            return -1;
          return 57;

        case E_RVVMF2SFmode:
          if (pattern555 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
            return -1;
          return 58;

        case E_RVVM8DFmode:
          if (pattern555 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
            return -1;
          return 59;

        case E_RVVM4DFmode:
          if (pattern555 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
            return -1;
          return 60;

        case E_RVVM2DFmode:
          if (pattern555 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
            return -1;
          return 61;

        case E_RVVM1DFmode:
          if (pattern555 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
            return -1;
          return 62;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern564 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 0)
    return -1;
  x5 = XEXP (x1, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[5] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[6] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[7] = x9;
  x10 = XEXP (x2, 0);
  x11 = XEXP (x10, 0);
  operands[3] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern563 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_HImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern563 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern563 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern563 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern563 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern563 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (pattern563 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SImode:
      if (pattern563 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SImode:
      if (pattern563 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SImode:
      if (pattern563 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SImode:
      if (pattern563 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DImode:
      if (pattern563 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DImode:
      if (pattern563 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DImode:
      if (pattern563 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DImode:
      if (pattern563 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
        return -1;
      return 14;

    case E_V1HImode:
      if (pattern563 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      return 15;

    case E_V2HImode:
      if (pattern563 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      return 16;

    case E_V4HImode:
      if (pattern563 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      return 17;

    case E_V8HImode:
      if (pattern563 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      return 18;

    case E_V16HImode:
      if (pattern563 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode, 
E_HImode) != 0)
        return -1;
      return 19;

    case E_V32HImode:
      if (pattern563 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode, 
E_HImode) != 0)
        return -1;
      return 20;

    case E_V64HImode:
      if (pattern563 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode, 
E_HImode) != 0)
        return -1;
      return 21;

    case E_V128HImode:
      if (pattern563 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode, 
E_HImode) != 0)
        return -1;
      return 22;

    case E_V256HImode:
      if (pattern563 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode, 
E_HImode) != 0)
        return -1;
      return 23;

    case E_V512HImode:
      if (pattern563 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode, 
E_HImode) != 0)
        return -1;
      return 24;

    case E_V1024HImode:
      if (pattern563 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode, 
E_HImode) != 0)
        return -1;
      return 25;

    case E_V2048HImode:
      if (pattern563 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode, 
E_HImode) != 0)
        return -1;
      return 26;

    case E_V1SImode:
      if (pattern563 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode, 
E_SImode) != 0)
        return -1;
      return 27;

    case E_V2SImode:
      if (pattern563 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode, 
E_SImode) != 0)
        return -1;
      return 28;

    case E_V4SImode:
      if (pattern563 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode, 
E_SImode) != 0)
        return -1;
      return 29;

    case E_V8SImode:
      if (pattern563 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode, 
E_SImode) != 0)
        return -1;
      return 30;

    case E_V16SImode:
      if (pattern563 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode, 
E_SImode) != 0)
        return -1;
      return 31;

    case E_V32SImode:
      if (pattern563 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode, 
E_SImode) != 0)
        return -1;
      return 32;

    case E_V64SImode:
      if (pattern563 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode, 
E_SImode) != 0)
        return -1;
      return 33;

    case E_V128SImode:
      if (pattern563 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode, 
E_SImode) != 0)
        return -1;
      return 34;

    case E_V256SImode:
      if (pattern563 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode, 
E_SImode) != 0)
        return -1;
      return 35;

    case E_V512SImode:
      if (pattern563 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode, 
E_SImode) != 0)
        return -1;
      return 36;

    case E_V1024SImode:
      if (pattern563 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode, 
E_SImode) != 0)
        return -1;
      return 37;

    case E_V1DImode:
      if (pattern563 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode, 
E_DImode) != 0)
        return -1;
      return 38;

    case E_V2DImode:
      if (pattern563 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode, 
E_DImode) != 0)
        return -1;
      return 39;

    case E_V4DImode:
      if (pattern563 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode, 
E_DImode) != 0)
        return -1;
      return 40;

    case E_V8DImode:
      if (pattern563 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode, 
E_DImode) != 0)
        return -1;
      return 41;

    case E_V16DImode:
      if (pattern563 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode, 
E_DImode) != 0)
        return -1;
      return 42;

    case E_V32DImode:
      if (pattern563 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode, 
E_DImode) != 0)
        return -1;
      return 43;

    case E_V64DImode:
      if (pattern563 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode, 
E_DImode) != 0)
        return -1;
      return 44;

    case E_V128DImode:
      if (pattern563 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode, 
E_DImode) != 0)
        return -1;
      return 45;

    case E_V256DImode:
      if (pattern563 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode, 
E_DImode) != 0)
        return -1;
      return 46;

    case E_V512DImode:
      if (pattern563 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode, 
E_DImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern588 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!vector_neg_arith_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern591 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], E_QImode)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern595 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SImode:
      return pattern475 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode); /* [-1, 0] */

    case E_RVVM4SImode:
      if (pattern475 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2SImode:
      if (pattern475 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1SImode:
      if (pattern475 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SImode:
      if (pattern475 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern602 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  if (!register_operand (operands[5], i2))
    return -1;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern604 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[4], E_RVVM4HFmode)
          || !register_operand (operands[5], E_RVVM4HFmode))
        return -1;
      return 0;

    case E_RVVM8SFmode:
      if (!register_operand (operands[4], E_RVVM8SFmode)
          || !register_operand (operands[5], E_RVVM8SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern606 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM1HFmode:
      if (!register_operand (operands[4], E_RVVM1HFmode)
          || !register_operand (operands[5], E_RVVM1HFmode))
        return -1;
      return 0;

    case E_RVVM2SFmode:
      if (!register_operand (operands[4], E_RVVM2SFmode)
          || !register_operand (operands[5], E_RVVM2SFmode))
        return -1;
      return 1;

    case E_RVVM4DFmode:
      if (!register_operand (operands[4], E_RVVM4DFmode)
          || !register_operand (operands[5], E_RVVM4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern609 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V1BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V1BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V1HFmode:
      if (!register_operand (operands[4], E_V1HFmode)
          || !register_operand (operands[5], E_V1HFmode))
        return -1;
      return 0;

    case E_V1SFmode:
      if (!register_operand (operands[4], E_V1SFmode)
          || !register_operand (operands[5], E_V1SFmode))
        return -1;
      return 1;

    case E_V1DFmode:
      if (!register_operand (operands[4], E_V1DFmode)
          || !register_operand (operands[5], E_V1DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern612 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[4], E_V8HFmode)
          || !register_operand (operands[5], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!register_operand (operands[4], E_V8SFmode)
          || !register_operand (operands[5], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!register_operand (operands[4], E_V8DFmode)
          || !register_operand (operands[5], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern615 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V64BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V64BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[4], E_V64HFmode)
          || !register_operand (operands[5], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!register_operand (operands[4], E_V64SFmode)
          || !register_operand (operands[5], E_V64SFmode))
        return -1;
      return 1;

    case E_V64DFmode:
      if (!register_operand (operands[4], E_V64DFmode)
          || !register_operand (operands[5], E_V64DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern619 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V1024BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V1024BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V1024HFmode:
      if (!register_operand (operands[4], E_V1024HFmode)
          || !register_operand (operands[5], E_V1024HFmode))
        return -1;
      return 0;

    case E_V1024SFmode:
      if (!register_operand (operands[4], E_V1024SFmode)
          || !register_operand (operands[5], E_V1024SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern623 (rtx x1, machine_mode i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 18:
      if (REGNO (x12) != 9)
        return -1;
      x16 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x16) != SET)
        return -1;
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != MEM
          || GET_MODE (x17) != i1)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != PLUS
          || GET_MODE (x18) != i1)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != REG
          || REGNO (x19) != 2
          || GET_MODE (x19) != i1)
        return -1;
      x20 = XEXP (x18, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x21 = XEXP (x16, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 8
          || GET_MODE (x21) != i1)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != SET)
        return -1;
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != MEM
          || GET_MODE (x23) != i1)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != PLUS
          || GET_MODE (x24) != i1)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2
          || GET_MODE (x25) != i1)
        return -1;
      x26 = XEXP (x24, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 1
          || GET_MODE (x27) != i1
          || !stack_pop_up_to_s2_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case 8:
      if (REGNO (x12) != 1)
        return -1;
      x16 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x16) != RETURN)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != USE)
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 1
          || GET_MODE (x27) != E_SImode
          || !stack_pop_up_to_s0_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern644 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern650 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2HImode:
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      return 0;

    case E_RVVM1QImode:
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern656 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF16BImode
      || !vector_mask_operand (operands[1], E_RVVMF16BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2SImode:
      if (!register_operand (operands[4], E_RVVM2SImode))
        return -1;
      return 0;

    case E_RVVM1HImode:
      if (!register_operand (operands[4], E_RVVM1HImode))
        return -1;
      return 1;

    case E_RVVMF2QImode:
      if (!register_operand (operands[4], E_RVVMF2QImode))
        return -1;
      return 2;

    case E_RVVM4DImode:
      if (!register_operand (operands[4], E_RVVM4DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern662 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF64BImode
      || !vector_mask_operand (operands[1], E_RVVMF64BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM1DImode:
      if (!register_operand (operands[4], E_RVVM1DImode))
        return -1;
      return 0;

    case E_RVVMF2SImode:
      if (!register_operand (operands[4], E_RVVMF2SImode))
        return -1;
      return 1;

    case E_RVVMF4HImode:
      if (!register_operand (operands[4], E_RVVMF4HImode))
        return -1;
      return 2;

    case E_RVVMF8QImode:
      if (!register_operand (operands[4], E_RVVMF8QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern673 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[3], E_RVVM8HImode))
        return -1;
      return 0;

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[3], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM2HImode))
        return -1;
      return 2;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM1HImode))
        return -1;
      return 3;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVMF2HImode))
        return -1;
      return 4;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVMF4HImode))
        return -1;
      return 5;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1HImode))
        return -1;
      return 6;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2HImode))
        return -1;
      return 7;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4HImode))
        return -1;
      return 8;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8HImode))
        return -1;
      return 9;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16HImode))
        return -1;
      return 10;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32HImode))
        return -1;
      return 11;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64HImode))
        return -1;
      return 12;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128HImode))
        return -1;
      return 13;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256HImode))
        return -1;
      return 14;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512HImode))
        return -1;
      return 15;

    case E_V1024BImode:
      if (!vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[3], E_V1024HImode))
        return -1;
      return 16;

    case E_V2048BImode:
      if (!vector_mask_operand (operands[1], E_V2048BImode)
          || !register_operand (operands[3], E_V2048HImode))
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern681 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern688 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x1, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  return 0;
}

int
pattern695 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!pmode_reg_or_0_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF8x2QImode:
      return pattern601 (x1, 
E_RVVMF8x2QImode, 
E_RVVMF64BImode); /* [-1, 0] */

    case E_RVVMF8x3QImode:
      if (pattern601 (x1, 
E_RVVMF8x3QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 1;

    case E_RVVMF8x4QImode:
      if (pattern601 (x1, 
E_RVVMF8x4QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF8x5QImode:
      if (pattern601 (x1, 
E_RVVMF8x5QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF8x6QImode:
      if (pattern601 (x1, 
E_RVVMF8x6QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF8x7QImode:
      if (pattern601 (x1, 
E_RVVMF8x7QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVMF8x8QImode:
      if (pattern601 (x1, 
E_RVVMF8x8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 6;

    case E_RVVMF4x2HImode:
      if (pattern601 (x1, 
E_RVVMF4x2HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 7;

    case E_RVVMF4x3HImode:
      if (pattern601 (x1, 
E_RVVMF4x3HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 8;

    case E_RVVMF4x4HImode:
      if (pattern601 (x1, 
E_RVVMF4x4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF4x5HImode:
      if (pattern601 (x1, 
E_RVVMF4x5HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVMF4x6HImode:
      if (pattern601 (x1, 
E_RVVMF4x6HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 11;

    case E_RVVMF4x7HImode:
      if (pattern601 (x1, 
E_RVVMF4x7HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 12;

    case E_RVVMF4x8HImode:
      if (pattern601 (x1, 
E_RVVMF4x8HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 13;

    case E_RVVMF2x2SImode:
      if (pattern601 (x1, 
E_RVVMF2x2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    case E_RVVMF2x3SImode:
      if (pattern601 (x1, 
E_RVVMF2x3SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2x4SImode:
      if (pattern601 (x1, 
E_RVVMF2x4SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF2x5SImode:
      if (pattern601 (x1, 
E_RVVMF2x5SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2x6SImode:
      if (pattern601 (x1, 
E_RVVMF2x6SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2x7SImode:
      if (pattern601 (x1, 
E_RVVMF2x7SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF2x8SImode:
      if (pattern601 (x1, 
E_RVVMF2x8SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVM1x2DImode:
      if (pattern601 (x1, 
E_RVVM1x2DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_RVVM1x3DImode:
      if (pattern601 (x1, 
E_RVVM1x3DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 22;

    case E_RVVM1x4DImode:
      if (pattern601 (x1, 
E_RVVM1x4DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 23;

    case E_RVVM1x5DImode:
      if (pattern601 (x1, 
E_RVVM1x5DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 24;

    case E_RVVM1x6DImode:
      if (pattern601 (x1, 
E_RVVM1x6DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 25;

    case E_RVVM1x7DImode:
      if (pattern601 (x1, 
E_RVVM1x7DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 26;

    case E_RVVM1x8DImode:
      if (pattern601 (x1, 
E_RVVM1x8DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 27;

    case E_RVVMF4x2BFmode:
      if (pattern601 (x1, 
E_RVVMF4x2BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 28;

    case E_RVVMF4x3BFmode:
      if (pattern601 (x1, 
E_RVVMF4x3BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 29;

    case E_RVVMF4x4BFmode:
      if (pattern601 (x1, 
E_RVVMF4x4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 30;

    case E_RVVMF4x5BFmode:
      if (pattern601 (x1, 
E_RVVMF4x5BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 31;

    case E_RVVMF4x6BFmode:
      if (pattern601 (x1, 
E_RVVMF4x6BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 32;

    case E_RVVMF4x7BFmode:
      if (pattern601 (x1, 
E_RVVMF4x7BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 33;

    case E_RVVMF4x8BFmode:
      if (pattern601 (x1, 
E_RVVMF4x8BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 34;

    case E_RVVMF4x2HFmode:
      if (pattern601 (x1, 
E_RVVMF4x2HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 35;

    case E_RVVMF4x3HFmode:
      if (pattern601 (x1, 
E_RVVMF4x3HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 36;

    case E_RVVMF4x4HFmode:
      if (pattern601 (x1, 
E_RVVMF4x4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 37;

    case E_RVVMF4x5HFmode:
      if (pattern601 (x1, 
E_RVVMF4x5HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 38;

    case E_RVVMF4x6HFmode:
      if (pattern601 (x1, 
E_RVVMF4x6HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 39;

    case E_RVVMF4x7HFmode:
      if (pattern601 (x1, 
E_RVVMF4x7HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 40;

    case E_RVVMF4x8HFmode:
      if (pattern601 (x1, 
E_RVVMF4x8HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 41;

    case E_RVVMF2x2SFmode:
      if (pattern601 (x1, 
E_RVVMF2x2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 42;

    case E_RVVMF2x3SFmode:
      if (pattern601 (x1, 
E_RVVMF2x3SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 43;

    case E_RVVMF2x4SFmode:
      if (pattern601 (x1, 
E_RVVMF2x4SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 44;

    case E_RVVMF2x5SFmode:
      if (pattern601 (x1, 
E_RVVMF2x5SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 45;

    case E_RVVMF2x6SFmode:
      if (pattern601 (x1, 
E_RVVMF2x6SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 46;

    case E_RVVMF2x7SFmode:
      if (pattern601 (x1, 
E_RVVMF2x7SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 47;

    case E_RVVMF2x8SFmode:
      if (pattern601 (x1, 
E_RVVMF2x8SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 48;

    case E_RVVM1x2DFmode:
      if (pattern601 (x1, 
E_RVVM1x2DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 49;

    case E_RVVM1x3DFmode:
      if (pattern601 (x1, 
E_RVVM1x3DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 50;

    case E_RVVM1x4DFmode:
      if (pattern601 (x1, 
E_RVVM1x4DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 51;

    case E_RVVM1x5DFmode:
      if (pattern601 (x1, 
E_RVVM1x5DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 52;

    case E_RVVM1x6DFmode:
      if (pattern601 (x1, 
E_RVVM1x6DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 53;

    case E_RVVM1x7DFmode:
      if (pattern601 (x1, 
E_RVVM1x7DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 54;

    case E_RVVM1x8DFmode:
      if (pattern601 (x1, 
E_RVVM1x8DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 55;

    case E_RVVMF4x2QImode:
      if (pattern601 (x1, 
E_RVVMF4x2QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 56;

    case E_RVVMF4x3QImode:
      if (pattern601 (x1, 
E_RVVMF4x3QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 57;

    case E_RVVMF4x4QImode:
      if (pattern601 (x1, 
E_RVVMF4x4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 58;

    case E_RVVMF4x5QImode:
      if (pattern601 (x1, 
E_RVVMF4x5QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 59;

    case E_RVVMF4x6QImode:
      if (pattern601 (x1, 
E_RVVMF4x6QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 60;

    case E_RVVMF4x7QImode:
      if (pattern601 (x1, 
E_RVVMF4x7QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 61;

    case E_RVVMF4x8QImode:
      if (pattern601 (x1, 
E_RVVMF4x8QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 62;

    case E_RVVMF2x2HImode:
      if (pattern601 (x1, 
E_RVVMF2x2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 63;

    case E_RVVMF2x3HImode:
      if (pattern601 (x1, 
E_RVVMF2x3HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 64;

    case E_RVVMF2x4HImode:
      if (pattern601 (x1, 
E_RVVMF2x4HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 65;

    case E_RVVMF2x5HImode:
      if (pattern601 (x1, 
E_RVVMF2x5HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 66;

    case E_RVVMF2x6HImode:
      if (pattern601 (x1, 
E_RVVMF2x6HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 67;

    case E_RVVMF2x7HImode:
      if (pattern601 (x1, 
E_RVVMF2x7HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 68;

    case E_RVVMF2x8HImode:
      if (pattern601 (x1, 
E_RVVMF2x8HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 69;

    case E_RVVM1x2SImode:
      if (pattern601 (x1, 
E_RVVM1x2SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 70;

    case E_RVVM1x3SImode:
      if (pattern601 (x1, 
E_RVVM1x3SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 71;

    case E_RVVM1x4SImode:
      if (pattern601 (x1, 
E_RVVM1x4SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 72;

    case E_RVVM1x5SImode:
      if (pattern601 (x1, 
E_RVVM1x5SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 73;

    case E_RVVM1x6SImode:
      if (pattern601 (x1, 
E_RVVM1x6SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 74;

    case E_RVVM1x7SImode:
      if (pattern601 (x1, 
E_RVVM1x7SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 75;

    case E_RVVM1x8SImode:
      if (pattern601 (x1, 
E_RVVM1x8SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 76;

    case E_RVVM2x2DImode:
      if (pattern601 (x1, 
E_RVVM2x2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 77;

    case E_RVVM2x3DImode:
      if (pattern601 (x1, 
E_RVVM2x3DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 78;

    case E_RVVM2x4DImode:
      if (pattern601 (x1, 
E_RVVM2x4DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 79;

    case E_RVVMF2x2BFmode:
      if (pattern601 (x1, 
E_RVVMF2x2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 80;

    case E_RVVMF2x3BFmode:
      if (pattern601 (x1, 
E_RVVMF2x3BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 81;

    case E_RVVMF2x4BFmode:
      if (pattern601 (x1, 
E_RVVMF2x4BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 82;

    case E_RVVMF2x5BFmode:
      if (pattern601 (x1, 
E_RVVMF2x5BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 83;

    case E_RVVMF2x6BFmode:
      if (pattern601 (x1, 
E_RVVMF2x6BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 84;

    case E_RVVMF2x7BFmode:
      if (pattern601 (x1, 
E_RVVMF2x7BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 85;

    case E_RVVMF2x8BFmode:
      if (pattern601 (x1, 
E_RVVMF2x8BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 86;

    case E_RVVMF2x2HFmode:
      if (pattern601 (x1, 
E_RVVMF2x2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 87;

    case E_RVVMF2x3HFmode:
      if (pattern601 (x1, 
E_RVVMF2x3HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 88;

    case E_RVVMF2x4HFmode:
      if (pattern601 (x1, 
E_RVVMF2x4HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 89;

    case E_RVVMF2x5HFmode:
      if (pattern601 (x1, 
E_RVVMF2x5HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 90;

    case E_RVVMF2x6HFmode:
      if (pattern601 (x1, 
E_RVVMF2x6HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 91;

    case E_RVVMF2x7HFmode:
      if (pattern601 (x1, 
E_RVVMF2x7HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 92;

    case E_RVVMF2x8HFmode:
      if (pattern601 (x1, 
E_RVVMF2x8HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 93;

    case E_RVVM1x2SFmode:
      if (pattern601 (x1, 
E_RVVM1x2SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 94;

    case E_RVVM1x3SFmode:
      if (pattern601 (x1, 
E_RVVM1x3SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 95;

    case E_RVVM1x4SFmode:
      if (pattern601 (x1, 
E_RVVM1x4SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 96;

    case E_RVVM1x5SFmode:
      if (pattern601 (x1, 
E_RVVM1x5SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 97;

    case E_RVVM1x6SFmode:
      if (pattern601 (x1, 
E_RVVM1x6SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 98;

    case E_RVVM1x7SFmode:
      if (pattern601 (x1, 
E_RVVM1x7SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 99;

    case E_RVVM1x8SFmode:
      if (pattern601 (x1, 
E_RVVM1x8SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 100;

    case E_RVVM2x2DFmode:
      if (pattern601 (x1, 
E_RVVM2x2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 101;

    case E_RVVM2x3DFmode:
      if (pattern601 (x1, 
E_RVVM2x3DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 102;

    case E_RVVM2x4DFmode:
      if (pattern601 (x1, 
E_RVVM2x4DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 103;

    case E_RVVMF2x2QImode:
      if (pattern601 (x1, 
E_RVVMF2x2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 104;

    case E_RVVMF2x3QImode:
      if (pattern601 (x1, 
E_RVVMF2x3QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 105;

    case E_RVVMF2x4QImode:
      if (pattern601 (x1, 
E_RVVMF2x4QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 106;

    case E_RVVMF2x5QImode:
      if (pattern601 (x1, 
E_RVVMF2x5QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 107;

    case E_RVVMF2x6QImode:
      if (pattern601 (x1, 
E_RVVMF2x6QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 108;

    case E_RVVMF2x7QImode:
      if (pattern601 (x1, 
E_RVVMF2x7QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 109;

    case E_RVVMF2x8QImode:
      if (pattern601 (x1, 
E_RVVMF2x8QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 110;

    case E_RVVM1x2HImode:
      if (pattern601 (x1, 
E_RVVM1x2HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 111;

    case E_RVVM1x3HImode:
      if (pattern601 (x1, 
E_RVVM1x3HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 112;

    case E_RVVM1x4HImode:
      if (pattern601 (x1, 
E_RVVM1x4HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 113;

    case E_RVVM1x5HImode:
      if (pattern601 (x1, 
E_RVVM1x5HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 114;

    case E_RVVM1x6HImode:
      if (pattern601 (x1, 
E_RVVM1x6HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 115;

    case E_RVVM1x7HImode:
      if (pattern601 (x1, 
E_RVVM1x7HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 116;

    case E_RVVM1x8HImode:
      if (pattern601 (x1, 
E_RVVM1x8HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 117;

    case E_RVVM2x2SImode:
      if (pattern601 (x1, 
E_RVVM2x2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 118;

    case E_RVVM2x3SImode:
      if (pattern601 (x1, 
E_RVVM2x3SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 119;

    case E_RVVM2x4SImode:
      if (pattern601 (x1, 
E_RVVM2x4SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 120;

    case E_RVVM4x2DImode:
      if (pattern601 (x1, 
E_RVVM4x2DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 121;

    case E_RVVM1x2BFmode:
      if (pattern601 (x1, 
E_RVVM1x2BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 122;

    case E_RVVM1x3BFmode:
      if (pattern601 (x1, 
E_RVVM1x3BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 123;

    case E_RVVM1x4BFmode:
      if (pattern601 (x1, 
E_RVVM1x4BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 124;

    case E_RVVM1x5BFmode:
      if (pattern601 (x1, 
E_RVVM1x5BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 125;

    case E_RVVM1x6BFmode:
      if (pattern601 (x1, 
E_RVVM1x6BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 126;

    case E_RVVM1x7BFmode:
      if (pattern601 (x1, 
E_RVVM1x7BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 127;

    case E_RVVM1x8BFmode:
      if (pattern601 (x1, 
E_RVVM1x8BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 128;

    case E_RVVM1x2HFmode:
      if (pattern601 (x1, 
E_RVVM1x2HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 129;

    case E_RVVM1x3HFmode:
      if (pattern601 (x1, 
E_RVVM1x3HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 130;

    case E_RVVM1x4HFmode:
      if (pattern601 (x1, 
E_RVVM1x4HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 131;

    case E_RVVM1x5HFmode:
      if (pattern601 (x1, 
E_RVVM1x5HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 132;

    case E_RVVM1x6HFmode:
      if (pattern601 (x1, 
E_RVVM1x6HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 133;

    case E_RVVM1x7HFmode:
      if (pattern601 (x1, 
E_RVVM1x7HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 134;

    case E_RVVM1x8HFmode:
      if (pattern601 (x1, 
E_RVVM1x8HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 135;

    case E_RVVM2x2SFmode:
      if (pattern601 (x1, 
E_RVVM2x2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 136;

    case E_RVVM2x3SFmode:
      if (pattern601 (x1, 
E_RVVM2x3SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 137;

    case E_RVVM2x4SFmode:
      if (pattern601 (x1, 
E_RVVM2x4SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 138;

    case E_RVVM4x2DFmode:
      if (pattern601 (x1, 
E_RVVM4x2DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 139;

    case E_RVVM1x2QImode:
      if (pattern601 (x1, 
E_RVVM1x2QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 140;

    case E_RVVM1x3QImode:
      if (pattern601 (x1, 
E_RVVM1x3QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 141;

    case E_RVVM1x4QImode:
      if (pattern601 (x1, 
E_RVVM1x4QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 142;

    case E_RVVM1x5QImode:
      if (pattern601 (x1, 
E_RVVM1x5QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 143;

    case E_RVVM1x6QImode:
      if (pattern601 (x1, 
E_RVVM1x6QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 144;

    case E_RVVM1x7QImode:
      if (pattern601 (x1, 
E_RVVM1x7QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 145;

    case E_RVVM1x8QImode:
      if (pattern601 (x1, 
E_RVVM1x8QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 146;

    case E_RVVM2x2HImode:
      if (pattern601 (x1, 
E_RVVM2x2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 147;

    case E_RVVM2x3HImode:
      if (pattern601 (x1, 
E_RVVM2x3HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 148;

    case E_RVVM2x4HImode:
      if (pattern601 (x1, 
E_RVVM2x4HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 149;

    case E_RVVM4x2SImode:
      if (pattern601 (x1, 
E_RVVM4x2SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 150;

    case E_RVVM2x2BFmode:
      if (pattern601 (x1, 
E_RVVM2x2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 151;

    case E_RVVM2x3BFmode:
      if (pattern601 (x1, 
E_RVVM2x3BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 152;

    case E_RVVM2x4BFmode:
      if (pattern601 (x1, 
E_RVVM2x4BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 153;

    case E_RVVM2x2HFmode:
      if (pattern601 (x1, 
E_RVVM2x2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 154;

    case E_RVVM2x3HFmode:
      if (pattern601 (x1, 
E_RVVM2x3HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 155;

    case E_RVVM2x4HFmode:
      if (pattern601 (x1, 
E_RVVM2x4HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 156;

    case E_RVVM4x2SFmode:
      if (pattern601 (x1, 
E_RVVM4x2SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 157;

    case E_RVVM2x2QImode:
      if (pattern601 (x1, 
E_RVVM2x2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 158;

    case E_RVVM2x3QImode:
      if (pattern601 (x1, 
E_RVVM2x3QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 159;

    case E_RVVM2x4QImode:
      if (pattern601 (x1, 
E_RVVM2x4QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 160;

    case E_RVVM4x2HImode:
      if (pattern601 (x1, 
E_RVVM4x2HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 161;

    case E_RVVM4x2BFmode:
      if (pattern601 (x1, 
E_RVVM4x2BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 162;

    case E_RVVM4x2HFmode:
      if (pattern601 (x1, 
E_RVVM4x2HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 163;

    case E_RVVM4x2QImode:
      if (pattern601 (x1, 
E_RVVM4x2QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 164;

    default:
      return -1;
    }
}

int
pattern767 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i4)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i3)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i1)
    return -1;
  return 0;
}

int
pattern770 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case -4L:
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -8L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -12L)
        return -1;
      x14 = XVECEXP (x1, 0, 4);
      x15 = XEXP (x14, 1);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -16L)
        return -1;
      x18 = XVECEXP (x1, 0, 5);
      x19 = XEXP (x18, 1);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -20L)
        return -1;
      x22 = XVECEXP (x1, 0, 6);
      x23 = XEXP (x22, 1);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -24L)
        return -1;
      x26 = XVECEXP (x1, 0, 7);
      x27 = XEXP (x26, 1);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -28L)
        return -1;
      x30 = XVECEXP (x1, 0, 8);
      x31 = XEXP (x30, 1);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -32L)
        return -1;
      x34 = XVECEXP (x1, 0, 9);
      x35 = XEXP (x34, 1);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -36L)
        return -1;
      x38 = XVECEXP (x1, 0, 10);
      x39 = XEXP (x38, 1);
      x40 = XEXP (x39, 0);
      x41 = XEXP (x40, 1);
      if (XWINT (x41, 0) != -40L)
        return -1;
      x42 = XVECEXP (x1, 0, 11);
      x43 = XEXP (x42, 1);
      x44 = XEXP (x43, 0);
      x45 = XEXP (x44, 1);
      if (XWINT (x45, 0) != -44L)
        return -1;
      return 0;

    case -8L:
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -16L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -24L)
        return -1;
      x14 = XVECEXP (x1, 0, 4);
      x15 = XEXP (x14, 1);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -32L)
        return -1;
      x18 = XVECEXP (x1, 0, 5);
      x19 = XEXP (x18, 1);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -40L)
        return -1;
      x22 = XVECEXP (x1, 0, 6);
      x23 = XEXP (x22, 1);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -48L)
        return -1;
      x26 = XVECEXP (x1, 0, 7);
      x27 = XEXP (x26, 1);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -56L)
        return -1;
      x30 = XVECEXP (x1, 0, 8);
      x31 = XEXP (x30, 1);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -64L)
        return -1;
      x34 = XVECEXP (x1, 0, 9);
      x35 = XEXP (x34, 1);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -72L)
        return -1;
      x38 = XVECEXP (x1, 0, 10);
      x39 = XEXP (x38, 1);
      x40 = XEXP (x39, 0);
      x41 = XEXP (x40, 1);
      if (XWINT (x41, 0) != -80L)
        return -1;
      x42 = XVECEXP (x1, 0, 11);
      x43 = XEXP (x42, 1);
      x44 = XEXP (x43, 0);
      x45 = XEXP (x44, 1);
      if (XWINT (x45, 0) != -88L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern784 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x4) != RETURN)
    return -1;
  x5 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1
      || GET_MODE (x6) != E_SImode
      || !stack_pop_up_to_s7_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern790 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 6);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i5)
    return -1;
  x4 = XVECEXP (x1, 0, 7);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4)
    return -1;
  x6 = XVECEXP (x1, 0, 8);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i3)
    return -1;
  x8 = XVECEXP (x1, 0, 9);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 10);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != PLUS
      || GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 2
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XEXP (x12, 1);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -40])
    return -1;
  x15 = XEXP (x10, 0);
  if (REGNO (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 11);
  return pattern789 (x16); /* [-1, 0] */
}

int
pattern795 (rtx x1, machine_mode i1, rtx_code i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 11);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x4) != i2)
    return -1;
  return 0;
}

int
pattern798 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != CONST_INT
      || XWINT (x4, 0) != -96L)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  if (arith_operand (operands[2], E_SImode))
    return 4; /* *addsi3 */
  if (!const_two_s12 (operands[2], E_SImode)
      || !(
#line 747 "../../gcc/config/riscv/riscv.md"
(!riscv_reg_frame_related (operands[0])) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    return -1;
  return 6; /* *addsi3_const_sum_of_two_s12 */
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern231 (x2))
    {
    case 0:
      if (!
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31185; /* *dual_widen_fmaurvvm8hi */

    case 1:
      if (!
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31187; /* *dual_widen_fmaurvvm4hi */

    case 2:
      if (!
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31189; /* *dual_widen_fmaurvvm2hi */

    case 3:
      if (!
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31191; /* *dual_widen_fmaurvvm1hi */

    case 4:
      if (!
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31193; /* *dual_widen_fmaurvvmf2hi */

    case 5:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31195; /* *dual_widen_fmaurvvmf4hi */

    case 6:
      if (!
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31197; /* *dual_widen_fmaurvvm8si */

    case 7:
      if (!
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31199; /* *dual_widen_fmaurvvm4si */

    case 8:
      if (!
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31201; /* *dual_widen_fmaurvvm2si */

    case 9:
      if (!
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31203; /* *dual_widen_fmaurvvm1si */

    case 10:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31205; /* *dual_widen_fmaurvvmf2si */

    case 11:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31207; /* *dual_widen_fmaurvvm8di */

    case 12:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31209; /* *dual_widen_fmaurvvm4di */

    case 13:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31211; /* *dual_widen_fmaurvvm2di */

    case 14:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31213; /* *dual_widen_fmaurvvm1di */

    case 15:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31215; /* *dual_widen_fmauv1hi */

    case 16:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31217; /* *dual_widen_fmauv2hi */

    case 17:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31219; /* *dual_widen_fmauv4hi */

    case 18:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31221; /* *dual_widen_fmauv8hi */

    case 19:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31223; /* *dual_widen_fmauv16hi */

    case 20:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31225; /* *dual_widen_fmauv32hi */

    case 21:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31227; /* *dual_widen_fmauv64hi */

    case 22:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31229; /* *dual_widen_fmauv128hi */

    case 23:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31231; /* *dual_widen_fmauv256hi */

    case 24:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31233; /* *dual_widen_fmauv512hi */

    case 25:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31235; /* *dual_widen_fmauv1024hi */

    case 26:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31237; /* *dual_widen_fmauv2048hi */

    case 27:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31239; /* *dual_widen_fmauv1si */

    case 28:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31241; /* *dual_widen_fmauv2si */

    case 29:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31243; /* *dual_widen_fmauv4si */

    case 30:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31245; /* *dual_widen_fmauv8si */

    case 31:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31247; /* *dual_widen_fmauv16si */

    case 32:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31249; /* *dual_widen_fmauv32si */

    case 33:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31251; /* *dual_widen_fmauv64si */

    case 34:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31253; /* *dual_widen_fmauv128si */

    case 35:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31255; /* *dual_widen_fmauv256si */

    case 36:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31257; /* *dual_widen_fmauv512si */

    case 37:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31259; /* *dual_widen_fmauv1024si */

    case 38:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31261; /* *dual_widen_fmauv1di */

    case 39:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31263; /* *dual_widen_fmauv2di */

    case 40:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31265; /* *dual_widen_fmauv4di */

    case 41:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31267; /* *dual_widen_fmauv8di */

    case 42:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31269; /* *dual_widen_fmauv16di */

    case 43:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31271; /* *dual_widen_fmauv32di */

    case 44:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31273; /* *dual_widen_fmauv64di */

    case 45:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31275; /* *dual_widen_fmauv128di */

    case 46:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31277; /* *dual_widen_fmauv256di */

    case 47:
      if (!(
#line 907 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31279; /* *dual_widen_fmauv512di */

    case 48:
      if (!
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31328; /* *dual_widen_fmausrvvm8hi */

    case 49:
      if (!
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31329; /* *dual_widen_fmausrvvm4hi */

    case 50:
      if (!
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31330; /* *dual_widen_fmausrvvm2hi */

    case 51:
      if (!
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31331; /* *dual_widen_fmausrvvm1hi */

    case 52:
      if (!
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31332; /* *dual_widen_fmausrvvmf2hi */

    case 53:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31333; /* *dual_widen_fmausrvvmf4hi */

    case 54:
      if (!
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31334; /* *dual_widen_fmausrvvm8si */

    case 55:
      if (!
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31335; /* *dual_widen_fmausrvvm4si */

    case 56:
      if (!
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31336; /* *dual_widen_fmausrvvm2si */

    case 57:
      if (!
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31337; /* *dual_widen_fmausrvvm1si */

    case 58:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31338; /* *dual_widen_fmausrvvmf2si */

    case 59:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31339; /* *dual_widen_fmausrvvm8di */

    case 60:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31340; /* *dual_widen_fmausrvvm4di */

    case 61:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31341; /* *dual_widen_fmausrvvm2di */

    case 62:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31342; /* *dual_widen_fmausrvvm1di */

    case 63:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31343; /* *dual_widen_fmausv1hi */

    case 64:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31344; /* *dual_widen_fmausv2hi */

    case 65:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31345; /* *dual_widen_fmausv4hi */

    case 66:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31346; /* *dual_widen_fmausv8hi */

    case 67:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31347; /* *dual_widen_fmausv16hi */

    case 68:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31348; /* *dual_widen_fmausv32hi */

    case 69:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31349; /* *dual_widen_fmausv64hi */

    case 70:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31350; /* *dual_widen_fmausv128hi */

    case 71:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31351; /* *dual_widen_fmausv256hi */

    case 72:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31352; /* *dual_widen_fmausv512hi */

    case 73:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31353; /* *dual_widen_fmausv1024hi */

    case 74:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31354; /* *dual_widen_fmausv2048hi */

    case 75:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31355; /* *dual_widen_fmausv1si */

    case 76:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31356; /* *dual_widen_fmausv2si */

    case 77:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31357; /* *dual_widen_fmausv4si */

    case 78:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31358; /* *dual_widen_fmausv8si */

    case 79:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31359; /* *dual_widen_fmausv16si */

    case 80:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31360; /* *dual_widen_fmausv32si */

    case 81:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31361; /* *dual_widen_fmausv64si */

    case 82:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31362; /* *dual_widen_fmausv128si */

    case 83:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31363; /* *dual_widen_fmausv256si */

    case 84:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31364; /* *dual_widen_fmausv512si */

    case 85:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31365; /* *dual_widen_fmausv1024si */

    case 86:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31366; /* *dual_widen_fmausv1di */

    case 87:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31367; /* *dual_widen_fmausv2di */

    case 88:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31368; /* *dual_widen_fmausv4di */

    case 89:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31369; /* *dual_widen_fmausv8di */

    case 90:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31370; /* *dual_widen_fmausv16di */

    case 91:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31371; /* *dual_widen_fmausv32di */

    case 92:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31372; /* *dual_widen_fmausv64di */

    case 93:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31373; /* *dual_widen_fmausv128di */

    case 94:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31374; /* *dual_widen_fmausv256di */

    case 95:
      if (!(
#line 951 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31375; /* *dual_widen_fmausv512di */

    case 96:
      if (!
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31377; /* *single_widen_fmaurvvm8hi */

    case 97:
      if (!
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31379; /* *single_widen_fmaurvvm4hi */

    case 98:
      if (!
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31381; /* *single_widen_fmaurvvm2hi */

    case 99:
      if (!
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31383; /* *single_widen_fmaurvvm1hi */

    case 100:
      if (!
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31385; /* *single_widen_fmaurvvmf2hi */

    case 101:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31387; /* *single_widen_fmaurvvmf4hi */

    case 102:
      if (!
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31389; /* *single_widen_fmaurvvm8si */

    case 103:
      if (!
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31391; /* *single_widen_fmaurvvm4si */

    case 104:
      if (!
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31393; /* *single_widen_fmaurvvm2si */

    case 105:
      if (!
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31395; /* *single_widen_fmaurvvm1si */

    case 106:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31397; /* *single_widen_fmaurvvmf2si */

    case 107:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31399; /* *single_widen_fmaurvvm8di */

    case 108:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31401; /* *single_widen_fmaurvvm4di */

    case 109:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31403; /* *single_widen_fmaurvvm2di */

    case 110:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31405; /* *single_widen_fmaurvvm1di */

    case 111:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31407; /* *single_widen_fmauv1hi */

    case 112:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31409; /* *single_widen_fmauv2hi */

    case 113:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31411; /* *single_widen_fmauv4hi */

    case 114:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31413; /* *single_widen_fmauv8hi */

    case 115:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31415; /* *single_widen_fmauv16hi */

    case 116:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31417; /* *single_widen_fmauv32hi */

    case 117:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31419; /* *single_widen_fmauv64hi */

    case 118:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31421; /* *single_widen_fmauv128hi */

    case 119:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31423; /* *single_widen_fmauv256hi */

    case 120:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31425; /* *single_widen_fmauv512hi */

    case 121:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31427; /* *single_widen_fmauv1024hi */

    case 122:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31429; /* *single_widen_fmauv2048hi */

    case 123:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31431; /* *single_widen_fmauv1si */

    case 124:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31433; /* *single_widen_fmauv2si */

    case 125:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31435; /* *single_widen_fmauv4si */

    case 126:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31437; /* *single_widen_fmauv8si */

    case 127:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31439; /* *single_widen_fmauv16si */

    case 128:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31441; /* *single_widen_fmauv32si */

    case 129:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31443; /* *single_widen_fmauv64si */

    case 130:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31445; /* *single_widen_fmauv128si */

    case 131:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31447; /* *single_widen_fmauv256si */

    case 132:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31449; /* *single_widen_fmauv512si */

    case 133:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31451; /* *single_widen_fmauv1024si */

    case 134:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31453; /* *single_widen_fmauv1di */

    case 135:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31455; /* *single_widen_fmauv2di */

    case 136:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31457; /* *single_widen_fmauv4di */

    case 137:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31459; /* *single_widen_fmauv8di */

    case 138:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31461; /* *single_widen_fmauv16di */

    case 139:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31463; /* *single_widen_fmauv32di */

    case 140:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31465; /* *single_widen_fmauv64di */

    case 141:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31467; /* *single_widen_fmauv128di */

    case 142:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31469; /* *single_widen_fmauv256di */

    case 143:
      if (!(
#line 975 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31471; /* *single_widen_fmauv512di */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SFmode) != 0
          || !(
#line 1119 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 23; /* mulsf3 */

    case E_DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DFmode) != 0
          || !(
#line 1119 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 24; /* muldf3 */

    case E_HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_HFmode) != 0
          || !(
#line 1119 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 25; /* mulhf3 */

    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SImode) != 0
          || !
#line 1128 "../../gcc/config/riscv/riscv.md"
(TARGET_ZMMUL || TARGET_MUL))
        return -1;
      return 26; /* *mulsi3 */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DImode) != 0
          || !
#line 1155 "../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
        return -1;
      return 27; /* muldi3 */

    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24550; /* mulrvvm8qi3 */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24564; /* mulrvvm4qi3 */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24578; /* mulrvvm2qi3 */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24592; /* mulrvvm1qi3 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24606; /* mulrvvm8hi3 */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24620; /* mulrvvm4hi3 */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24634; /* mulrvvm2hi3 */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24648; /* mulrvvm1hi3 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24662; /* mulrvvm8si3 */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24676; /* mulrvvm4si3 */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24690; /* mulrvvm2si3 */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24704; /* mulrvvm1si3 */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24718; /* mulrvvm8di3 */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24732; /* mulrvvm4di3 */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24746; /* mulrvvm2di3 */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24760; /* mulrvvm1di3 */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24774; /* mulrvvmf2qi3 */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24788; /* mulrvvmf4qi3 */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24802; /* mulrvvmf8qi3 */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24816; /* mulrvvmf2hi3 */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24830; /* mulrvvmf4hi3 */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24844; /* mulrvvmf2si3 */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24858; /* mulv1qi3 */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24872; /* mulv2qi3 */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24886; /* mulv4qi3 */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24900; /* mulv8qi3 */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24914; /* mulv16qi3 */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24928; /* mulv32qi3 */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24942; /* mulv64qi3 */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24956; /* mulv128qi3 */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24970; /* mulv256qi3 */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24984; /* mulv512qi3 */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24998; /* mulv1024qi3 */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25012; /* mulv2048qi3 */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4096QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25026; /* mulv4096qi3 */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25040; /* mulv1hi3 */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25054; /* mulv2hi3 */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25068; /* mulv4hi3 */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25082; /* mulv8hi3 */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25096; /* mulv16hi3 */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25110; /* mulv32hi3 */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25124; /* mulv64hi3 */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25138; /* mulv128hi3 */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25152; /* mulv256hi3 */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25166; /* mulv512hi3 */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25180; /* mulv1024hi3 */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25194; /* mulv2048hi3 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25208; /* mulv1si3 */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25222; /* mulv2si3 */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25236; /* mulv4si3 */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25250; /* mulv8si3 */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25264; /* mulv16si3 */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25278; /* mulv32si3 */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25292; /* mulv64si3 */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25306; /* mulv128si3 */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25320; /* mulv256si3 */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25334; /* mulv512si3 */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25348; /* mulv1024si3 */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25362; /* mulv1di3 */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25376; /* mulv2di3 */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25390; /* mulv4di3 */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25404; /* mulv8di3 */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25418; /* mulv16di3 */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25432; /* mulv32di3 */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25446; /* mulv64di3 */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25460; /* mulv128di3 */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25474; /* mulv256di3 */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25488; /* mulv512di3 */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27508; /* mulrvvm8hf3 */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27512; /* mulrvvm4hf3 */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27516; /* mulrvvm2hf3 */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27520; /* mulrvvm1hf3 */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27524; /* mulrvvmf2hf3 */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27528; /* mulrvvmf4hf3 */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27532; /* mulrvvm8sf3 */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27536; /* mulrvvm4sf3 */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27540; /* mulrvvm2sf3 */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27544; /* mulrvvm1sf3 */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27548; /* mulrvvmf2sf3 */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27552; /* mulrvvm8df3 */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27556; /* mulrvvm4df3 */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27560; /* mulrvvm2df3 */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27564; /* mulrvvm1df3 */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27568; /* mulv1hf3 */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27572; /* mulv2hf3 */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27576; /* mulv4hf3 */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27580; /* mulv8hf3 */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27584; /* mulv16hf3 */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27588; /* mulv32hf3 */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27592; /* mulv64hf3 */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27596; /* mulv128hf3 */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27600; /* mulv256hf3 */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27604; /* mulv512hf3 */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27608; /* mulv1024hf3 */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27612; /* mulv2048hf3 */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27616; /* mulv1sf3 */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27620; /* mulv2sf3 */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27624; /* mulv4sf3 */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27628; /* mulv8sf3 */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27632; /* mulv16sf3 */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27636; /* mulv32sf3 */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27640; /* mulv64sf3 */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27644; /* mulv128sf3 */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27648; /* mulv256sf3 */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27652; /* mulv512sf3 */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27656; /* mulv1024sf3 */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27660; /* mulv1df3 */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27664; /* mulv2df3 */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27668; /* mulv4df3 */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27672; /* mulv8df3 */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27676; /* mulv16df3 */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27680; /* mulv32df3 */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27684; /* mulv64df3 */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27688; /* mulv128df3 */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27692; /* mulv256df3 */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27696; /* mulv512df3 */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  x8 = XVECEXP (x4, 0, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[2] = x8;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2439; /* *pred_th_extractrvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2440; /* *pred_th_extractrvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2441; /* *pred_th_extractrvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2442; /* *pred_th_extractrvvm1qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 2455; /* *pred_th_extractrvvmf8qi */

            case E_V1QImode:
              if (!register_operand (operands[1], E_V1QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 2458; /* *pred_th_extractv1qi */

            case E_V2QImode:
              if (!register_operand (operands[1], E_V2QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 2459; /* *pred_th_extractv2qi */

            case E_V4QImode:
              if (!register_operand (operands[1], E_V4QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 2460; /* *pred_th_extractv4qi */

            case E_V8QImode:
              if (!register_operand (operands[1], E_V8QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 2461; /* *pred_th_extractv8qi */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 2462; /* *pred_th_extractv16qi */

            case E_V32QImode:
              if (!register_operand (operands[1], E_V32QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 2463; /* *pred_th_extractv32qi */

            case E_V64QImode:
              if (!register_operand (operands[1], E_V64QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2464; /* *pred_th_extractv64qi */

            case E_V128QImode:
              if (!register_operand (operands[1], E_V128QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2465; /* *pred_th_extractv128qi */

            case E_V256QImode:
              if (!register_operand (operands[1], E_V256QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2466; /* *pred_th_extractv256qi */

            case E_V512QImode:
              if (!register_operand (operands[1], E_V512QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2467; /* *pred_th_extractv512qi */

            case E_V1024QImode:
              if (!register_operand (operands[1], E_V1024QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2468; /* *pred_th_extractv1024qi */

            case E_V2048QImode:
              if (!register_operand (operands[1], E_V2048QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2469; /* *pred_th_extractv2048qi */

            case E_V4096QImode:
              if (!register_operand (operands[1], E_V4096QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2470; /* *pred_th_extractv4096qi */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2443; /* *pred_th_extractrvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2444; /* *pred_th_extractrvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2445; /* *pred_th_extractrvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2446; /* *pred_th_extractrvvm1hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 2456; /* *pred_th_extractrvvmf4hi */

            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 2471; /* *pred_th_extractv1hi */

            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 2472; /* *pred_th_extractv2hi */

            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 2473; /* *pred_th_extractv4hi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 2474; /* *pred_th_extractv8hi */

            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 2475; /* *pred_th_extractv16hi */

            case E_V32HImode:
              if (!register_operand (operands[1], E_V32HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2476; /* *pred_th_extractv32hi */

            case E_V64HImode:
              if (!register_operand (operands[1], E_V64HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2477; /* *pred_th_extractv64hi */

            case E_V128HImode:
              if (!register_operand (operands[1], E_V128HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2478; /* *pred_th_extractv128hi */

            case E_V256HImode:
              if (!register_operand (operands[1], E_V256HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2479; /* *pred_th_extractv256hi */

            case E_V512HImode:
              if (!register_operand (operands[1], E_V512HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2480; /* *pred_th_extractv512hi */

            case E_V1024HImode:
              if (!register_operand (operands[1], E_V1024HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2481; /* *pred_th_extractv1024hi */

            case E_V2048HImode:
              if (!register_operand (operands[1], E_V2048HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2482; /* *pred_th_extractv2048hi */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern441 (x2))
            {
            case 0:
              if (!
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2447; /* *pred_th_extractrvvm8si */

            case 1:
              if (!
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2448; /* *pred_th_extractrvvm4si */

            case 2:
              if (!
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2449; /* *pred_th_extractrvvm2si */

            case 3:
              if (!
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2450; /* *pred_th_extractrvvm1si */

            case 4:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 2457; /* *pred_th_extractrvvmf2si */

            case 5:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 2483; /* *pred_th_extractv1si */

            case 6:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 2484; /* *pred_th_extractv2si */

            case 7:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 2485; /* *pred_th_extractv4si */

            case 8:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 2486; /* *pred_th_extractv8si */

            case 9:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2487; /* *pred_th_extractv16si */

            case 10:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2488; /* *pred_th_extractv32si */

            case 11:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2489; /* *pred_th_extractv64si */

            case 12:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2490; /* *pred_th_extractv128si */

            case 13:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2491; /* *pred_th_extractv256si */

            case 14:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2492; /* *pred_th_extractv512si */

            case 15:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2493; /* *pred_th_extractv1024si */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern442 (x2))
            {
            case 0:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2451; /* *pred_th_extractrvvm8di */

            case 1:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2452; /* *pred_th_extractrvvm4di */

            case 2:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2453; /* *pred_th_extractrvvm2di */

            case 3:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2454; /* *pred_th_extractrvvm1di */

            case 4:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2494; /* *pred_th_extractv1di */

            case 5:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2495; /* *pred_th_extractv2di */

            case 6:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2496; /* *pred_th_extractv4di */

            case 7:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2497; /* *pred_th_extractv8di */

            case 8:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2498; /* *pred_th_extractv16di */

            case 9:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2499; /* *pred_th_extractv32di */

            case 10:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2500; /* *pred_th_extractv64di */

            case 11:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2501; /* *pred_th_extractv128di */

            case 12:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2502; /* *pred_th_extractv256di */

            case 13:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2503; /* *pred_th_extractv512di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      return recog_30 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern171 ())
        {
        case 0:
          if (!(
#line 3585 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 405; /* fclasssfsi */

        case 1:
          if (!(
#line 3585 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 407; /* fclassdfsi */

        case 2:
          if (!(
#line 3585 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 409; /* fclasshfsi */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      switch (pattern171 ())
        {
        case 0:
          if (!(
#line 3585 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 406; /* fclasssfdi */

        case 1:
          if (!(
#line 3585 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 408; /* fclassdfdi */

        case 2:
          if (!(
#line 3585 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 410; /* fclasshfdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern584 (x2, 
E_RVVMF16BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF2QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF2QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8693; /* pred_madcrvvmf2qi_scalar */

    case E_RVVM1HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM1HImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8699; /* pred_madcrvvm1hi_scalar */

    case E_RVVM2SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM2SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM2SImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8704; /* pred_madcrvvm2si_scalar */

    case E_RVVM4DImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM4DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM4DImode)
          || !(
#line 3567 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8798; /* *pred_madcrvvm4di_scalar */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern672 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18673; /* pred_redmin_vl0srvvm8qi */

        case 1:
          if (!
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18681; /* pred_redmin_vl0srvvm4qi */

        case 2:
          if (!
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18689; /* pred_redmin_vl0srvvm2qi */

        case 3:
          if (!
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18697; /* pred_redmin_vl0srvvm1qi */

        case 4:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18801; /* pred_redmin_vl0srvvmf2qi */

        case 5:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18809; /* pred_redmin_vl0srvvmf4qi */

        case 6:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18817; /* pred_redmin_vl0srvvmf8qi */

        case 7:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18849; /* pred_redmin_vl0sv1qi */

        case 8:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18857; /* pred_redmin_vl0sv2qi */

        case 9:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18865; /* pred_redmin_vl0sv4qi */

        case 10:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18873; /* pred_redmin_vl0sv8qi */

        case 11:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18881; /* pred_redmin_vl0sv16qi */

        case 12:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18889; /* pred_redmin_vl0sv32qi */

        case 13:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18897; /* pred_redmin_vl0sv64qi */

        case 14:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18905; /* pred_redmin_vl0sv128qi */

        case 15:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18913; /* pred_redmin_vl0sv256qi */

        case 16:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18921; /* pred_redmin_vl0sv512qi */

        case 17:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18929; /* pred_redmin_vl0sv1024qi */

        case 18:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18937; /* pred_redmin_vl0sv2048qi */

        case 19:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18945; /* pred_redmin_vl0sv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern673 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18705; /* pred_redmin_vl0srvvm8hi */

        case 1:
          if (!
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18713; /* pred_redmin_vl0srvvm4hi */

        case 2:
          if (!
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18721; /* pred_redmin_vl0srvvm2hi */

        case 3:
          if (!
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18729; /* pred_redmin_vl0srvvm1hi */

        case 4:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18825; /* pred_redmin_vl0srvvmf2hi */

        case 5:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18833; /* pred_redmin_vl0srvvmf4hi */

        case 6:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18953; /* pred_redmin_vl0sv1hi */

        case 7:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18961; /* pred_redmin_vl0sv2hi */

        case 8:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18969; /* pred_redmin_vl0sv4hi */

        case 9:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18977; /* pred_redmin_vl0sv8hi */

        case 10:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18985; /* pred_redmin_vl0sv16hi */

        case 11:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18993; /* pred_redmin_vl0sv32hi */

        case 12:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19001; /* pred_redmin_vl0sv64hi */

        case 13:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19009; /* pred_redmin_vl0sv128hi */

        case 14:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19017; /* pred_redmin_vl0sv256hi */

        case 15:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19025; /* pred_redmin_vl0sv512hi */

        case 16:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19033; /* pred_redmin_vl0sv1024hi */

        case 17:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19041; /* pred_redmin_vl0sv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern674 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18737; /* pred_redmin_vl0srvvm8si */

        case 1:
          if (!
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18745; /* pred_redmin_vl0srvvm4si */

        case 2:
          if (!
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18753; /* pred_redmin_vl0srvvm2si */

        case 3:
          if (!
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18761; /* pred_redmin_vl0srvvm1si */

        case 4:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18841; /* pred_redmin_vl0srvvmf2si */

        case 5:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 19049; /* pred_redmin_vl0sv1si */

        case 6:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 19057; /* pred_redmin_vl0sv2si */

        case 7:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 19065; /* pred_redmin_vl0sv4si */

        case 8:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 19073; /* pred_redmin_vl0sv8si */

        case 9:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19081; /* pred_redmin_vl0sv16si */

        case 10:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19089; /* pred_redmin_vl0sv32si */

        case 11:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19097; /* pred_redmin_vl0sv64si */

        case 12:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19105; /* pred_redmin_vl0sv128si */

        case 13:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19113; /* pred_redmin_vl0sv256si */

        case 14:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19121; /* pred_redmin_vl0sv512si */

        case 15:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19129; /* pred_redmin_vl0sv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18769; /* pred_redmin_vl0srvvm8di */

        case 1:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18777; /* pred_redmin_vl0srvvm4di */

        case 2:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18785; /* pred_redmin_vl0srvvm2di */

        case 3:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18793; /* pred_redmin_vl0srvvm1di */

        case 4:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19137; /* pred_redmin_vl0sv1di */

        case 5:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19145; /* pred_redmin_vl0sv2di */

        case 6:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19153; /* pred_redmin_vl0sv4di */

        case 7:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19161; /* pred_redmin_vl0sv8di */

        case 8:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19169; /* pred_redmin_vl0sv16di */

        case 9:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19177; /* pred_redmin_vl0sv32di */

        case 10:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19185; /* pred_redmin_vl0sv64di */

        case 11:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19193; /* pred_redmin_vl0sv128di */

        case 12:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19201; /* pred_redmin_vl0sv256di */

        case 13:
          if (!(
#line 7793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19209; /* pred_redmin_vl0sv512di */

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern676 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19526; /* pred_redmin_vl0srvvm8hf */

        case 1:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19528; /* pred_redmin_vl0srvvm4hf */

        case 2:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19530; /* pred_redmin_vl0srvvm2hf */

        case 3:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19532; /* pred_redmin_vl0srvvm1hf */

        case 4:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19534; /* pred_redmin_vl0srvvmf2hf */

        case 5:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19536; /* pred_redmin_vl0srvvmf4hf */

        case 6:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19556; /* pred_redmin_vl0sv1hf */

        case 7:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19558; /* pred_redmin_vl0sv2hf */

        case 8:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19560; /* pred_redmin_vl0sv4hf */

        case 9:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19562; /* pred_redmin_vl0sv8hf */

        case 10:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19564; /* pred_redmin_vl0sv16hf */

        case 11:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19566; /* pred_redmin_vl0sv32hf */

        case 12:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19568; /* pred_redmin_vl0sv64hf */

        case 13:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19570; /* pred_redmin_vl0sv128hf */

        case 14:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19572; /* pred_redmin_vl0sv256hf */

        case 15:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19574; /* pred_redmin_vl0sv512hf */

        case 16:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19576; /* pred_redmin_vl0sv1024hf */

        case 17:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19578; /* pred_redmin_vl0sv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19538; /* pred_redmin_vl0srvvm8sf */

        case 1:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19540; /* pred_redmin_vl0srvvm4sf */

        case 2:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19542; /* pred_redmin_vl0srvvm2sf */

        case 3:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19544; /* pred_redmin_vl0srvvm1sf */

        case 4:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19546; /* pred_redmin_vl0srvvmf2sf */

        case 5:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19580; /* pred_redmin_vl0sv1sf */

        case 6:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19582; /* pred_redmin_vl0sv2sf */

        case 7:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19584; /* pred_redmin_vl0sv4sf */

        case 8:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19586; /* pred_redmin_vl0sv8sf */

        case 9:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19588; /* pred_redmin_vl0sv16sf */

        case 10:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19590; /* pred_redmin_vl0sv32sf */

        case 11:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19592; /* pred_redmin_vl0sv64sf */

        case 12:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19594; /* pred_redmin_vl0sv128sf */

        case 13:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19596; /* pred_redmin_vl0sv256sf */

        case 14:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19598; /* pred_redmin_vl0sv512sf */

        case 15:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19600; /* pred_redmin_vl0sv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2))
        {
        case 0:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19548; /* pred_redmin_vl0srvvm8df */

        case 1:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19550; /* pred_redmin_vl0srvvm4df */

        case 2:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19552; /* pred_redmin_vl0srvvm2df */

        case 3:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19554; /* pred_redmin_vl0srvvm1df */

        case 4:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19602; /* pred_redmin_vl0sv1df */

        case 5:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19604; /* pred_redmin_vl0sv2df */

        case 6:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19606; /* pred_redmin_vl0sv4df */

        case 7:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19608; /* pred_redmin_vl0sv8df */

        case 8:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19610; /* pred_redmin_vl0sv16df */

        case 9:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19612; /* pred_redmin_vl0sv32df */

        case 10:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19614; /* pred_redmin_vl0sv64df */

        case 11:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19616; /* pred_redmin_vl0sv128df */

        case 12:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19618; /* pred_redmin_vl0sv256df */

        case 13:
          if (!(
#line 7879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19620; /* pred_redmin_vl0sv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern672 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18131; /* pred_redorrvvm8qi */

        case 1:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18139; /* pred_redorrvvm4qi */

        case 2:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18147; /* pred_redorrvvm2qi */

        case 3:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18155; /* pred_redorrvvm1qi */

        case 4:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18259; /* pred_redorrvvmf2qi */

        case 5:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18267; /* pred_redorrvvmf4qi */

        case 6:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18275; /* pred_redorrvvmf8qi */

        case 7:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18307; /* pred_redorv1qi */

        case 8:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18315; /* pred_redorv2qi */

        case 9:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18323; /* pred_redorv4qi */

        case 10:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18331; /* pred_redorv8qi */

        case 11:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18339; /* pred_redorv16qi */

        case 12:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18347; /* pred_redorv32qi */

        case 13:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18355; /* pred_redorv64qi */

        case 14:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18363; /* pred_redorv128qi */

        case 15:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18371; /* pred_redorv256qi */

        case 16:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18379; /* pred_redorv512qi */

        case 17:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18387; /* pred_redorv1024qi */

        case 18:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18395; /* pred_redorv2048qi */

        case 19:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18403; /* pred_redorv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern673 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18163; /* pred_redorrvvm8hi */

        case 1:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18171; /* pred_redorrvvm4hi */

        case 2:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18179; /* pred_redorrvvm2hi */

        case 3:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18187; /* pred_redorrvvm1hi */

        case 4:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18283; /* pred_redorrvvmf2hi */

        case 5:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18291; /* pred_redorrvvmf4hi */

        case 6:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18411; /* pred_redorv1hi */

        case 7:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18419; /* pred_redorv2hi */

        case 8:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18427; /* pred_redorv4hi */

        case 9:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18435; /* pred_redorv8hi */

        case 10:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18443; /* pred_redorv16hi */

        case 11:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18451; /* pred_redorv32hi */

        case 12:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18459; /* pred_redorv64hi */

        case 13:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18467; /* pred_redorv128hi */

        case 14:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18475; /* pred_redorv256hi */

        case 15:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18483; /* pred_redorv512hi */

        case 16:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18491; /* pred_redorv1024hi */

        case 17:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18499; /* pred_redorv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern674 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18195; /* pred_redorrvvm8si */

        case 1:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18203; /* pred_redorrvvm4si */

        case 2:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18211; /* pred_redorrvvm2si */

        case 3:
          if (!
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18219; /* pred_redorrvvm1si */

        case 4:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18299; /* pred_redorrvvmf2si */

        case 5:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18507; /* pred_redorv1si */

        case 6:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18515; /* pred_redorv2si */

        case 7:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18523; /* pred_redorv4si */

        case 8:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18531; /* pred_redorv8si */

        case 9:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18539; /* pred_redorv16si */

        case 10:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18547; /* pred_redorv32si */

        case 11:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18555; /* pred_redorv64si */

        case 12:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18563; /* pred_redorv128si */

        case 13:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18571; /* pred_redorv256si */

        case 14:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18579; /* pred_redorv512si */

        case 15:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18587; /* pred_redorv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18227; /* pred_redorrvvm8di */

        case 1:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18235; /* pred_redorrvvm4di */

        case 2:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18243; /* pred_redorrvvm2di */

        case 3:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18251; /* pred_redorrvvm1di */

        case 4:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18595; /* pred_redorv1di */

        case 5:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18603; /* pred_redorv2di */

        case 6:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18611; /* pred_redorv4di */

        case 7:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18619; /* pred_redorv8di */

        case 8:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18627; /* pred_redorv16di */

        case 9:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18635; /* pred_redorv32di */

        case 10:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18643; /* pred_redorv64di */

        case 11:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18651; /* pred_redorv128di */

        case 12:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18659; /* pred_redorv256di */

        case 13:
          if (!(
#line 7771 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18667; /* pred_redorv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern676 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19717; /* pred_redosum_vl0srvvm8hf */

        case 1:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19719; /* pred_redosum_vl0srvvm4hf */

        case 2:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19721; /* pred_redosum_vl0srvvm2hf */

        case 3:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19723; /* pred_redosum_vl0srvvm1hf */

        case 4:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19725; /* pred_redosum_vl0srvvmf2hf */

        case 5:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19727; /* pred_redosum_vl0srvvmf4hf */

        case 6:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19747; /* pred_redosum_vl0sv1hf */

        case 7:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19749; /* pred_redosum_vl0sv2hf */

        case 8:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19751; /* pred_redosum_vl0sv4hf */

        case 9:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19753; /* pred_redosum_vl0sv8hf */

        case 10:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19755; /* pred_redosum_vl0sv16hf */

        case 11:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19757; /* pred_redosum_vl0sv32hf */

        case 12:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19759; /* pred_redosum_vl0sv64hf */

        case 13:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19761; /* pred_redosum_vl0sv128hf */

        case 14:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19763; /* pred_redosum_vl0sv256hf */

        case 15:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19765; /* pred_redosum_vl0sv512hf */

        case 16:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19767; /* pred_redosum_vl0sv1024hf */

        case 17:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19769; /* pred_redosum_vl0sv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19729; /* pred_redosum_vl0srvvm8sf */

        case 1:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19731; /* pred_redosum_vl0srvvm4sf */

        case 2:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19733; /* pred_redosum_vl0srvvm2sf */

        case 3:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19735; /* pred_redosum_vl0srvvm1sf */

        case 4:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19737; /* pred_redosum_vl0srvvmf2sf */

        case 5:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19771; /* pred_redosum_vl0sv1sf */

        case 6:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19773; /* pred_redosum_vl0sv2sf */

        case 7:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19775; /* pred_redosum_vl0sv4sf */

        case 8:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19777; /* pred_redosum_vl0sv8sf */

        case 9:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19779; /* pred_redosum_vl0sv16sf */

        case 10:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19781; /* pred_redosum_vl0sv32sf */

        case 11:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19783; /* pred_redosum_vl0sv64sf */

        case 12:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19785; /* pred_redosum_vl0sv128sf */

        case 13:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19787; /* pred_redosum_vl0sv256sf */

        case 14:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19789; /* pred_redosum_vl0sv512sf */

        case 15:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19791; /* pred_redosum_vl0sv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2))
        {
        case 0:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19739; /* pred_redosum_vl0srvvm8df */

        case 1:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19741; /* pred_redosum_vl0srvvm4df */

        case 2:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19743; /* pred_redosum_vl0srvvm2df */

        case 3:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19745; /* pred_redosum_vl0srvvm1df */

        case 4:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19793; /* pred_redosum_vl0sv1df */

        case 5:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19795; /* pred_redosum_vl0sv2df */

        case 6:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19797; /* pred_redosum_vl0sv4df */

        case 7:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19799; /* pred_redosum_vl0sv8df */

        case 8:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19801; /* pred_redosum_vl0sv16df */

        case 9:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19803; /* pred_redosum_vl0sv32df */

        case 10:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19805; /* pred_redosum_vl0sv64df */

        case 11:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19807; /* pred_redosum_vl0sv128df */

        case 12:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19809; /* pred_redosum_vl0sv256df */

        case 13:
          if (!(
#line 7928 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19811; /* pred_redosum_vl0sv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[0], E_RVVMF64BImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF8x2QImode:
      if (!register_operand (operands[3], E_RVVMF8x2QImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21603; /* pred_strided_storervvmf8x2qi */

    case E_RVVMF8x3QImode:
      if (!register_operand (operands[3], E_RVVMF8x3QImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21604; /* pred_strided_storervvmf8x3qi */

    case E_RVVMF8x4QImode:
      if (!register_operand (operands[3], E_RVVMF8x4QImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21605; /* pred_strided_storervvmf8x4qi */

    case E_RVVMF8x5QImode:
      if (!register_operand (operands[3], E_RVVMF8x5QImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21606; /* pred_strided_storervvmf8x5qi */

    case E_RVVMF8x6QImode:
      if (!register_operand (operands[3], E_RVVMF8x6QImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21607; /* pred_strided_storervvmf8x6qi */

    case E_RVVMF8x7QImode:
      if (!register_operand (operands[3], E_RVVMF8x7QImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21608; /* pred_strided_storervvmf8x7qi */

    case E_RVVMF8x8QImode:
      if (!register_operand (operands[3], E_RVVMF8x8QImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21609; /* pred_strided_storervvmf8x8qi */

    case E_RVVMF4x2HImode:
      if (!register_operand (operands[3], E_RVVMF4x2HImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21610; /* pred_strided_storervvmf4x2hi */

    case E_RVVMF4x3HImode:
      if (!register_operand (operands[3], E_RVVMF4x3HImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21611; /* pred_strided_storervvmf4x3hi */

    case E_RVVMF4x4HImode:
      if (!register_operand (operands[3], E_RVVMF4x4HImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21612; /* pred_strided_storervvmf4x4hi */

    case E_RVVMF4x5HImode:
      if (!register_operand (operands[3], E_RVVMF4x5HImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21613; /* pred_strided_storervvmf4x5hi */

    case E_RVVMF4x6HImode:
      if (!register_operand (operands[3], E_RVVMF4x6HImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21614; /* pred_strided_storervvmf4x6hi */

    case E_RVVMF4x7HImode:
      if (!register_operand (operands[3], E_RVVMF4x7HImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21615; /* pred_strided_storervvmf4x7hi */

    case E_RVVMF4x8HImode:
      if (!register_operand (operands[3], E_RVVMF4x8HImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21616; /* pred_strided_storervvmf4x8hi */

    case E_RVVMF2x2SImode:
      if (!register_operand (operands[3], E_RVVMF2x2SImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21617; /* pred_strided_storervvmf2x2si */

    case E_RVVMF2x3SImode:
      if (!register_operand (operands[3], E_RVVMF2x3SImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21618; /* pred_strided_storervvmf2x3si */

    case E_RVVMF2x4SImode:
      if (!register_operand (operands[3], E_RVVMF2x4SImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21619; /* pred_strided_storervvmf2x4si */

    case E_RVVMF2x5SImode:
      if (!register_operand (operands[3], E_RVVMF2x5SImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21620; /* pred_strided_storervvmf2x5si */

    case E_RVVMF2x6SImode:
      if (!register_operand (operands[3], E_RVVMF2x6SImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21621; /* pred_strided_storervvmf2x6si */

    case E_RVVMF2x7SImode:
      if (!register_operand (operands[3], E_RVVMF2x7SImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21622; /* pred_strided_storervvmf2x7si */

    case E_RVVMF2x8SImode:
      if (!register_operand (operands[3], E_RVVMF2x8SImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21623; /* pred_strided_storervvmf2x8si */

    case E_RVVM1x2DImode:
      if (!register_operand (operands[3], E_RVVM1x2DImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21624; /* pred_strided_storervvm1x2di */

    case E_RVVM1x3DImode:
      if (!register_operand (operands[3], E_RVVM1x3DImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21625; /* pred_strided_storervvm1x3di */

    case E_RVVM1x4DImode:
      if (!register_operand (operands[3], E_RVVM1x4DImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21626; /* pred_strided_storervvm1x4di */

    case E_RVVM1x5DImode:
      if (!register_operand (operands[3], E_RVVM1x5DImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21627; /* pred_strided_storervvm1x5di */

    case E_RVVM1x6DImode:
      if (!register_operand (operands[3], E_RVVM1x6DImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21628; /* pred_strided_storervvm1x6di */

    case E_RVVM1x7DImode:
      if (!register_operand (operands[3], E_RVVM1x7DImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21629; /* pred_strided_storervvm1x7di */

    case E_RVVM1x8DImode:
      if (!register_operand (operands[3], E_RVVM1x8DImode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21630; /* pred_strided_storervvm1x8di */

    case E_RVVMF4x2BFmode:
      if (!register_operand (operands[3], E_RVVMF4x2BFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21631; /* pred_strided_storervvmf4x2bf */

    case E_RVVMF4x3BFmode:
      if (!register_operand (operands[3], E_RVVMF4x3BFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21632; /* pred_strided_storervvmf4x3bf */

    case E_RVVMF4x4BFmode:
      if (!register_operand (operands[3], E_RVVMF4x4BFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21633; /* pred_strided_storervvmf4x4bf */

    case E_RVVMF4x5BFmode:
      if (!register_operand (operands[3], E_RVVMF4x5BFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21634; /* pred_strided_storervvmf4x5bf */

    case E_RVVMF4x6BFmode:
      if (!register_operand (operands[3], E_RVVMF4x6BFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21635; /* pred_strided_storervvmf4x6bf */

    case E_RVVMF4x7BFmode:
      if (!register_operand (operands[3], E_RVVMF4x7BFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21636; /* pred_strided_storervvmf4x7bf */

    case E_RVVMF4x8BFmode:
      if (!register_operand (operands[3], E_RVVMF4x8BFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21637; /* pred_strided_storervvmf4x8bf */

    case E_RVVMF4x2HFmode:
      if (!register_operand (operands[3], E_RVVMF4x2HFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21638; /* pred_strided_storervvmf4x2hf */

    case E_RVVMF4x3HFmode:
      if (!register_operand (operands[3], E_RVVMF4x3HFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21639; /* pred_strided_storervvmf4x3hf */

    case E_RVVMF4x4HFmode:
      if (!register_operand (operands[3], E_RVVMF4x4HFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21640; /* pred_strided_storervvmf4x4hf */

    case E_RVVMF4x5HFmode:
      if (!register_operand (operands[3], E_RVVMF4x5HFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21641; /* pred_strided_storervvmf4x5hf */

    case E_RVVMF4x6HFmode:
      if (!register_operand (operands[3], E_RVVMF4x6HFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21642; /* pred_strided_storervvmf4x6hf */

    case E_RVVMF4x7HFmode:
      if (!register_operand (operands[3], E_RVVMF4x7HFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21643; /* pred_strided_storervvmf4x7hf */

    case E_RVVMF4x8HFmode:
      if (!register_operand (operands[3], E_RVVMF4x8HFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21644; /* pred_strided_storervvmf4x8hf */

    case E_RVVMF2x2SFmode:
      if (!register_operand (operands[3], E_RVVMF2x2SFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21645; /* pred_strided_storervvmf2x2sf */

    case E_RVVMF2x3SFmode:
      if (!register_operand (operands[3], E_RVVMF2x3SFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21646; /* pred_strided_storervvmf2x3sf */

    case E_RVVMF2x4SFmode:
      if (!register_operand (operands[3], E_RVVMF2x4SFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21647; /* pred_strided_storervvmf2x4sf */

    case E_RVVMF2x5SFmode:
      if (!register_operand (operands[3], E_RVVMF2x5SFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21648; /* pred_strided_storervvmf2x5sf */

    case E_RVVMF2x6SFmode:
      if (!register_operand (operands[3], E_RVVMF2x6SFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21649; /* pred_strided_storervvmf2x6sf */

    case E_RVVMF2x7SFmode:
      if (!register_operand (operands[3], E_RVVMF2x7SFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21650; /* pred_strided_storervvmf2x7sf */

    case E_RVVMF2x8SFmode:
      if (!register_operand (operands[3], E_RVVMF2x8SFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21651; /* pred_strided_storervvmf2x8sf */

    case E_RVVM1x2DFmode:
      if (!register_operand (operands[3], E_RVVM1x2DFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21652; /* pred_strided_storervvm1x2df */

    case E_RVVM1x3DFmode:
      if (!register_operand (operands[3], E_RVVM1x3DFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21653; /* pred_strided_storervvm1x3df */

    case E_RVVM1x4DFmode:
      if (!register_operand (operands[3], E_RVVM1x4DFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21654; /* pred_strided_storervvm1x4df */

    case E_RVVM1x5DFmode:
      if (!register_operand (operands[3], E_RVVM1x5DFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21655; /* pred_strided_storervvm1x5df */

    case E_RVVM1x6DFmode:
      if (!register_operand (operands[3], E_RVVM1x6DFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21656; /* pred_strided_storervvm1x6df */

    case E_RVVM1x7DFmode:
      if (!register_operand (operands[3], E_RVVM1x7DFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21657; /* pred_strided_storervvm1x7df */

    case E_RVVM1x8DFmode:
      if (!register_operand (operands[3], E_RVVM1x8DFmode)
          || !(
#line 8425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21658; /* pred_strided_storervvm1x8df */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern186 (x1))
    {
    case 0:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5188; /* pred_indexed_ustorervvmf8qirvvmf8qi */

    case 1:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5190; /* pred_indexed_ustorervvmf4hirvvmf8qi */

    case 2:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5192; /* pred_indexed_ustorervvmf2sirvvmf8qi */

    case 3:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 809 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5194; /* pred_indexed_ustorervvm1dirvvmf8qi */

    case 4:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 810 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5196; /* pred_indexed_ustorervvmf4bfrvvmf8qi */

    case 5:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 811 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5198; /* pred_indexed_ustorervvmf4hfrvvmf8qi */

    case 6:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 812 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5200; /* pred_indexed_ustorervvmf2sfrvvmf8qi */

    case 7:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 813 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5202; /* pred_indexed_ustorervvm1dfrvvmf8qi */

    case 8:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23238; /* pred_indexed_ustorervvmf8x2qirvvmf8qi */

    case 9:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23246; /* pred_indexed_ustorervvmf8x3qirvvmf8qi */

    case 10:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23254; /* pred_indexed_ustorervvmf8x4qirvvmf8qi */

    case 11:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23262; /* pred_indexed_ustorervvmf8x5qirvvmf8qi */

    case 12:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23270; /* pred_indexed_ustorervvmf8x6qirvvmf8qi */

    case 13:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23278; /* pred_indexed_ustorervvmf8x7qirvvmf8qi */

    case 14:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23286; /* pred_indexed_ustorervvmf8x8qirvvmf8qi */

    case 15:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23294; /* pred_indexed_ustorervvmf4x2hirvvmf8qi */

    case 16:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23302; /* pred_indexed_ustorervvmf4x3hirvvmf8qi */

    case 17:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23310; /* pred_indexed_ustorervvmf4x4hirvvmf8qi */

    case 18:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23318; /* pred_indexed_ustorervvmf4x5hirvvmf8qi */

    case 19:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23326; /* pred_indexed_ustorervvmf4x6hirvvmf8qi */

    case 20:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23334; /* pred_indexed_ustorervvmf4x7hirvvmf8qi */

    case 21:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23342; /* pred_indexed_ustorervvmf4x8hirvvmf8qi */

    case 22:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23350; /* pred_indexed_ustorervvmf2x2sirvvmf8qi */

    case 23:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23358; /* pred_indexed_ustorervvmf2x3sirvvmf8qi */

    case 24:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23366; /* pred_indexed_ustorervvmf2x4sirvvmf8qi */

    case 25:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23374; /* pred_indexed_ustorervvmf2x5sirvvmf8qi */

    case 26:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23382; /* pred_indexed_ustorervvmf2x6sirvvmf8qi */

    case 27:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23390; /* pred_indexed_ustorervvmf2x7sirvvmf8qi */

    case 28:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23398; /* pred_indexed_ustorervvmf2x8sirvvmf8qi */

    case 29:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23406; /* pred_indexed_ustorervvm1x2dirvvmf8qi */

    case 30:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23414; /* pred_indexed_ustorervvm1x3dirvvmf8qi */

    case 31:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23422; /* pred_indexed_ustorervvm1x4dirvvmf8qi */

    case 32:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23430; /* pred_indexed_ustorervvm1x5dirvvmf8qi */

    case 33:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23438; /* pred_indexed_ustorervvm1x6dirvvmf8qi */

    case 34:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23446; /* pred_indexed_ustorervvm1x7dirvvmf8qi */

    case 35:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23454; /* pred_indexed_ustorervvm1x8dirvvmf8qi */

    case 36:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23462; /* pred_indexed_ustorervvmf4x2bfrvvmf8qi */

    case 37:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23470; /* pred_indexed_ustorervvmf4x3bfrvvmf8qi */

    case 38:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23478; /* pred_indexed_ustorervvmf4x4bfrvvmf8qi */

    case 39:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23486; /* pred_indexed_ustorervvmf4x5bfrvvmf8qi */

    case 40:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23494; /* pred_indexed_ustorervvmf4x6bfrvvmf8qi */

    case 41:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23502; /* pred_indexed_ustorervvmf4x7bfrvvmf8qi */

    case 42:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23510; /* pred_indexed_ustorervvmf4x8bfrvvmf8qi */

    case 43:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23518; /* pred_indexed_ustorervvmf4x2hfrvvmf8qi */

    case 44:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23526; /* pred_indexed_ustorervvmf4x3hfrvvmf8qi */

    case 45:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23534; /* pred_indexed_ustorervvmf4x4hfrvvmf8qi */

    case 46:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23542; /* pred_indexed_ustorervvmf4x5hfrvvmf8qi */

    case 47:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23550; /* pred_indexed_ustorervvmf4x6hfrvvmf8qi */

    case 48:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23558; /* pred_indexed_ustorervvmf4x7hfrvvmf8qi */

    case 49:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23566; /* pred_indexed_ustorervvmf4x8hfrvvmf8qi */

    case 50:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23574; /* pred_indexed_ustorervvmf2x2sfrvvmf8qi */

    case 51:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23582; /* pred_indexed_ustorervvmf2x3sfrvvmf8qi */

    case 52:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23590; /* pred_indexed_ustorervvmf2x4sfrvvmf8qi */

    case 53:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23598; /* pred_indexed_ustorervvmf2x5sfrvvmf8qi */

    case 54:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23606; /* pred_indexed_ustorervvmf2x6sfrvvmf8qi */

    case 55:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23614; /* pred_indexed_ustorervvmf2x7sfrvvmf8qi */

    case 56:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23622; /* pred_indexed_ustorervvmf2x8sfrvvmf8qi */

    case 57:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23630; /* pred_indexed_ustorervvm1x2dfrvvmf8qi */

    case 58:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23638; /* pred_indexed_ustorervvm1x3dfrvvmf8qi */

    case 59:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23646; /* pred_indexed_ustorervvm1x4dfrvvmf8qi */

    case 60:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23654; /* pred_indexed_ustorervvm1x5dfrvvmf8qi */

    case 61:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23662; /* pred_indexed_ustorervvm1x6dfrvvmf8qi */

    case 62:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23670; /* pred_indexed_ustorervvm1x7dfrvvmf8qi */

    case 63:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23678; /* pred_indexed_ustorervvm1x8dfrvvmf8qi */

    case 64:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5204; /* pred_indexed_ustorervvmf8qirvvmf4hi */

    case 65:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5206; /* pred_indexed_ustorervvmf4hirvvmf4hi */

    case 66:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5208; /* pred_indexed_ustorervvmf2sirvvmf4hi */

    case 67:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 809 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5210; /* pred_indexed_ustorervvm1dirvvmf4hi */

    case 68:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 810 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5212; /* pred_indexed_ustorervvmf4bfrvvmf4hi */

    case 69:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 811 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5214; /* pred_indexed_ustorervvmf4hfrvvmf4hi */

    case 70:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 812 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5216; /* pred_indexed_ustorervvmf2sfrvvmf4hi */

    case 71:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 813 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5218; /* pred_indexed_ustorervvm1dfrvvmf4hi */

    case 72:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23240; /* pred_indexed_ustorervvmf8x2qirvvmf4hi */

    case 73:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23248; /* pred_indexed_ustorervvmf8x3qirvvmf4hi */

    case 74:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23256; /* pred_indexed_ustorervvmf8x4qirvvmf4hi */

    case 75:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23264; /* pred_indexed_ustorervvmf8x5qirvvmf4hi */

    case 76:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23272; /* pred_indexed_ustorervvmf8x6qirvvmf4hi */

    case 77:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23280; /* pred_indexed_ustorervvmf8x7qirvvmf4hi */

    case 78:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23288; /* pred_indexed_ustorervvmf8x8qirvvmf4hi */

    case 79:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23296; /* pred_indexed_ustorervvmf4x2hirvvmf4hi */

    case 80:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23304; /* pred_indexed_ustorervvmf4x3hirvvmf4hi */

    case 81:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23312; /* pred_indexed_ustorervvmf4x4hirvvmf4hi */

    case 82:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23320; /* pred_indexed_ustorervvmf4x5hirvvmf4hi */

    case 83:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23328; /* pred_indexed_ustorervvmf4x6hirvvmf4hi */

    case 84:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23336; /* pred_indexed_ustorervvmf4x7hirvvmf4hi */

    case 85:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23344; /* pred_indexed_ustorervvmf4x8hirvvmf4hi */

    case 86:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23352; /* pred_indexed_ustorervvmf2x2sirvvmf4hi */

    case 87:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23360; /* pred_indexed_ustorervvmf2x3sirvvmf4hi */

    case 88:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23368; /* pred_indexed_ustorervvmf2x4sirvvmf4hi */

    case 89:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23376; /* pred_indexed_ustorervvmf2x5sirvvmf4hi */

    case 90:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23384; /* pred_indexed_ustorervvmf2x6sirvvmf4hi */

    case 91:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23392; /* pred_indexed_ustorervvmf2x7sirvvmf4hi */

    case 92:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23400; /* pred_indexed_ustorervvmf2x8sirvvmf4hi */

    case 93:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23408; /* pred_indexed_ustorervvm1x2dirvvmf4hi */

    case 94:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23416; /* pred_indexed_ustorervvm1x3dirvvmf4hi */

    case 95:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23424; /* pred_indexed_ustorervvm1x4dirvvmf4hi */

    case 96:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23432; /* pred_indexed_ustorervvm1x5dirvvmf4hi */

    case 97:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23440; /* pred_indexed_ustorervvm1x6dirvvmf4hi */

    case 98:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23448; /* pred_indexed_ustorervvm1x7dirvvmf4hi */

    case 99:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23456; /* pred_indexed_ustorervvm1x8dirvvmf4hi */

    case 100:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23464; /* pred_indexed_ustorervvmf4x2bfrvvmf4hi */

    case 101:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23472; /* pred_indexed_ustorervvmf4x3bfrvvmf4hi */

    case 102:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23480; /* pred_indexed_ustorervvmf4x4bfrvvmf4hi */

    case 103:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23488; /* pred_indexed_ustorervvmf4x5bfrvvmf4hi */

    case 104:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23496; /* pred_indexed_ustorervvmf4x6bfrvvmf4hi */

    case 105:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23504; /* pred_indexed_ustorervvmf4x7bfrvvmf4hi */

    case 106:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23512; /* pred_indexed_ustorervvmf4x8bfrvvmf4hi */

    case 107:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23520; /* pred_indexed_ustorervvmf4x2hfrvvmf4hi */

    case 108:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23528; /* pred_indexed_ustorervvmf4x3hfrvvmf4hi */

    case 109:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23536; /* pred_indexed_ustorervvmf4x4hfrvvmf4hi */

    case 110:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23544; /* pred_indexed_ustorervvmf4x5hfrvvmf4hi */

    case 111:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23552; /* pred_indexed_ustorervvmf4x6hfrvvmf4hi */

    case 112:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23560; /* pred_indexed_ustorervvmf4x7hfrvvmf4hi */

    case 113:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23568; /* pred_indexed_ustorervvmf4x8hfrvvmf4hi */

    case 114:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23576; /* pred_indexed_ustorervvmf2x2sfrvvmf4hi */

    case 115:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23584; /* pred_indexed_ustorervvmf2x3sfrvvmf4hi */

    case 116:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23592; /* pred_indexed_ustorervvmf2x4sfrvvmf4hi */

    case 117:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23600; /* pred_indexed_ustorervvmf2x5sfrvvmf4hi */

    case 118:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23608; /* pred_indexed_ustorervvmf2x6sfrvvmf4hi */

    case 119:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23616; /* pred_indexed_ustorervvmf2x7sfrvvmf4hi */

    case 120:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23624; /* pred_indexed_ustorervvmf2x8sfrvvmf4hi */

    case 121:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23632; /* pred_indexed_ustorervvm1x2dfrvvmf4hi */

    case 122:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23640; /* pred_indexed_ustorervvm1x3dfrvvmf4hi */

    case 123:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23648; /* pred_indexed_ustorervvm1x4dfrvvmf4hi */

    case 124:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23656; /* pred_indexed_ustorervvm1x5dfrvvmf4hi */

    case 125:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23664; /* pred_indexed_ustorervvm1x6dfrvvmf4hi */

    case 126:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23672; /* pred_indexed_ustorervvm1x7dfrvvmf4hi */

    case 127:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23680; /* pred_indexed_ustorervvm1x8dfrvvmf4hi */

    case 128:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5220; /* pred_indexed_ustorervvmf8qirvvmf2si */

    case 129:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5222; /* pred_indexed_ustorervvmf4hirvvmf2si */

    case 130:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5224; /* pred_indexed_ustorervvmf2sirvvmf2si */

    case 131:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 809 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5226; /* pred_indexed_ustorervvm1dirvvmf2si */

    case 132:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 810 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5228; /* pred_indexed_ustorervvmf4bfrvvmf2si */

    case 133:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 811 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5230; /* pred_indexed_ustorervvmf4hfrvvmf2si */

    case 134:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 812 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5232; /* pred_indexed_ustorervvmf2sfrvvmf2si */

    case 135:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 813 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5234; /* pred_indexed_ustorervvm1dfrvvmf2si */

    case 136:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23242; /* pred_indexed_ustorervvmf8x2qirvvmf2si */

    case 137:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23250; /* pred_indexed_ustorervvmf8x3qirvvmf2si */

    case 138:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23258; /* pred_indexed_ustorervvmf8x4qirvvmf2si */

    case 139:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23266; /* pred_indexed_ustorervvmf8x5qirvvmf2si */

    case 140:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23274; /* pred_indexed_ustorervvmf8x6qirvvmf2si */

    case 141:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23282; /* pred_indexed_ustorervvmf8x7qirvvmf2si */

    case 142:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23290; /* pred_indexed_ustorervvmf8x8qirvvmf2si */

    case 143:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23298; /* pred_indexed_ustorervvmf4x2hirvvmf2si */

    case 144:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23306; /* pred_indexed_ustorervvmf4x3hirvvmf2si */

    case 145:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23314; /* pred_indexed_ustorervvmf4x4hirvvmf2si */

    case 146:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23322; /* pred_indexed_ustorervvmf4x5hirvvmf2si */

    case 147:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23330; /* pred_indexed_ustorervvmf4x6hirvvmf2si */

    case 148:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23338; /* pred_indexed_ustorervvmf4x7hirvvmf2si */

    case 149:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23346; /* pred_indexed_ustorervvmf4x8hirvvmf2si */

    case 150:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23354; /* pred_indexed_ustorervvmf2x2sirvvmf2si */

    case 151:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23362; /* pred_indexed_ustorervvmf2x3sirvvmf2si */

    case 152:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23370; /* pred_indexed_ustorervvmf2x4sirvvmf2si */

    case 153:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23378; /* pred_indexed_ustorervvmf2x5sirvvmf2si */

    case 154:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23386; /* pred_indexed_ustorervvmf2x6sirvvmf2si */

    case 155:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23394; /* pred_indexed_ustorervvmf2x7sirvvmf2si */

    case 156:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 23402; /* pred_indexed_ustorervvmf2x8sirvvmf2si */

    case 157:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23410; /* pred_indexed_ustorervvm1x2dirvvmf2si */

    case 158:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23418; /* pred_indexed_ustorervvm1x3dirvvmf2si */

    case 159:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23426; /* pred_indexed_ustorervvm1x4dirvvmf2si */

    case 160:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23434; /* pred_indexed_ustorervvm1x5dirvvmf2si */

    case 161:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23442; /* pred_indexed_ustorervvm1x6dirvvmf2si */

    case 162:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23450; /* pred_indexed_ustorervvm1x7dirvvmf2si */

    case 163:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23458; /* pred_indexed_ustorervvm1x8dirvvmf2si */

    case 164:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23466; /* pred_indexed_ustorervvmf4x2bfrvvmf2si */

    case 165:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23474; /* pred_indexed_ustorervvmf4x3bfrvvmf2si */

    case 166:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23482; /* pred_indexed_ustorervvmf4x4bfrvvmf2si */

    case 167:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23490; /* pred_indexed_ustorervvmf4x5bfrvvmf2si */

    case 168:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23498; /* pred_indexed_ustorervvmf4x6bfrvvmf2si */

    case 169:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23506; /* pred_indexed_ustorervvmf4x7bfrvvmf2si */

    case 170:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23514; /* pred_indexed_ustorervvmf4x8bfrvvmf2si */

    case 171:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23522; /* pred_indexed_ustorervvmf4x2hfrvvmf2si */

    case 172:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23530; /* pred_indexed_ustorervvmf4x3hfrvvmf2si */

    case 173:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23538; /* pred_indexed_ustorervvmf4x4hfrvvmf2si */

    case 174:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23546; /* pred_indexed_ustorervvmf4x5hfrvvmf2si */

    case 175:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23554; /* pred_indexed_ustorervvmf4x6hfrvvmf2si */

    case 176:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23562; /* pred_indexed_ustorervvmf4x7hfrvvmf2si */

    case 177:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23570; /* pred_indexed_ustorervvmf4x8hfrvvmf2si */

    case 178:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23578; /* pred_indexed_ustorervvmf2x2sfrvvmf2si */

    case 179:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23586; /* pred_indexed_ustorervvmf2x3sfrvvmf2si */

    case 180:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23594; /* pred_indexed_ustorervvmf2x4sfrvvmf2si */

    case 181:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23602; /* pred_indexed_ustorervvmf2x5sfrvvmf2si */

    case 182:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23610; /* pred_indexed_ustorervvmf2x6sfrvvmf2si */

    case 183:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23618; /* pred_indexed_ustorervvmf2x7sfrvvmf2si */

    case 184:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23626; /* pred_indexed_ustorervvmf2x8sfrvvmf2si */

    case 185:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23634; /* pred_indexed_ustorervvm1x2dfrvvmf2si */

    case 186:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23642; /* pred_indexed_ustorervvm1x3dfrvvmf2si */

    case 187:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23650; /* pred_indexed_ustorervvm1x4dfrvvmf2si */

    case 188:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23658; /* pred_indexed_ustorervvm1x5dfrvvmf2si */

    case 189:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23666; /* pred_indexed_ustorervvm1x6dfrvvmf2si */

    case 190:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23674; /* pred_indexed_ustorervvm1x7dfrvvmf2si */

    case 191:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23682; /* pred_indexed_ustorervvm1x8dfrvvmf2si */

    case 192:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 806 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 5236; /* pred_indexed_ustorervvmf8qirvvm1di */

    case 193:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 807 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 5238; /* pred_indexed_ustorervvmf4hirvvm1di */

    case 194:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 808 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 5240; /* pred_indexed_ustorervvmf2sirvvm1di */

    case 195:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 809 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5242; /* pred_indexed_ustorervvm1dirvvm1di */

    case 196:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 810 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5244; /* pred_indexed_ustorervvmf4bfrvvm1di */

    case 197:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 811 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5246; /* pred_indexed_ustorervvmf4hfrvvm1di */

    case 198:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 812 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32))))
        return -1;
      return 5248; /* pred_indexed_ustorervvmf2sfrvvm1di */

    case 199:
      if (!(
#line 2588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 813 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5250; /* pred_indexed_ustorervvm1dfrvvm1di */

    case 200:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23244; /* pred_indexed_ustorervvmf8x2qirvvm1di */

    case 201:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23252; /* pred_indexed_ustorervvmf8x3qirvvm1di */

    case 202:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23260; /* pred_indexed_ustorervvmf8x4qirvvm1di */

    case 203:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23268; /* pred_indexed_ustorervvmf8x5qirvvm1di */

    case 204:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23276; /* pred_indexed_ustorervvmf8x6qirvvm1di */

    case 205:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23284; /* pred_indexed_ustorervvmf8x7qirvvm1di */

    case 206:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23292; /* pred_indexed_ustorervvmf8x8qirvvm1di */

    case 207:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23300; /* pred_indexed_ustorervvmf4x2hirvvm1di */

    case 208:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23308; /* pred_indexed_ustorervvmf4x3hirvvm1di */

    case 209:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23316; /* pred_indexed_ustorervvmf4x4hirvvm1di */

    case 210:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23324; /* pred_indexed_ustorervvmf4x5hirvvm1di */

    case 211:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23332; /* pred_indexed_ustorervvmf4x6hirvvm1di */

    case 212:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23340; /* pred_indexed_ustorervvmf4x7hirvvm1di */

    case 213:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23348; /* pred_indexed_ustorervvmf4x8hirvvm1di */

    case 214:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23356; /* pred_indexed_ustorervvmf2x2sirvvm1di */

    case 215:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23364; /* pred_indexed_ustorervvmf2x3sirvvm1di */

    case 216:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23372; /* pred_indexed_ustorervvmf2x4sirvvm1di */

    case 217:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23380; /* pred_indexed_ustorervvmf2x5sirvvm1di */

    case 218:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23388; /* pred_indexed_ustorervvmf2x6sirvvm1di */

    case 219:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23396; /* pred_indexed_ustorervvmf2x7sirvvm1di */

    case 220:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 23404; /* pred_indexed_ustorervvmf2x8sirvvm1di */

    case 221:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23412; /* pred_indexed_ustorervvm1x2dirvvm1di */

    case 222:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23420; /* pred_indexed_ustorervvm1x3dirvvm1di */

    case 223:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23428; /* pred_indexed_ustorervvm1x4dirvvm1di */

    case 224:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23436; /* pred_indexed_ustorervvm1x5dirvvm1di */

    case 225:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23444; /* pred_indexed_ustorervvm1x6dirvvm1di */

    case 226:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23452; /* pred_indexed_ustorervvm1x7dirvvm1di */

    case 227:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23460; /* pred_indexed_ustorervvm1x8dirvvm1di */

    case 228:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23468; /* pred_indexed_ustorervvmf4x2bfrvvm1di */

    case 229:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23476; /* pred_indexed_ustorervvmf4x3bfrvvm1di */

    case 230:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23484; /* pred_indexed_ustorervvmf4x4bfrvvm1di */

    case 231:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23492; /* pred_indexed_ustorervvmf4x5bfrvvm1di */

    case 232:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23500; /* pred_indexed_ustorervvmf4x6bfrvvm1di */

    case 233:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23508; /* pred_indexed_ustorervvmf4x7bfrvvm1di */

    case 234:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23516; /* pred_indexed_ustorervvmf4x8bfrvvm1di */

    case 235:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23524; /* pred_indexed_ustorervvmf4x2hfrvvm1di */

    case 236:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23532; /* pred_indexed_ustorervvmf4x3hfrvvm1di */

    case 237:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23540; /* pred_indexed_ustorervvmf4x4hfrvvm1di */

    case 238:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23548; /* pred_indexed_ustorervvmf4x5hfrvvm1di */

    case 239:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23556; /* pred_indexed_ustorervvmf4x6hfrvvm1di */

    case 240:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23564; /* pred_indexed_ustorervvmf4x7hfrvvm1di */

    case 241:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23572; /* pred_indexed_ustorervvmf4x8hfrvvm1di */

    case 242:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23580; /* pred_indexed_ustorervvmf2x2sfrvvm1di */

    case 243:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23588; /* pred_indexed_ustorervvmf2x3sfrvvm1di */

    case 244:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23596; /* pred_indexed_ustorervvmf2x4sfrvvm1di */

    case 245:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23604; /* pred_indexed_ustorervvmf2x5sfrvvm1di */

    case 246:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23612; /* pred_indexed_ustorervvmf2x6sfrvvm1di */

    case 247:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23620; /* pred_indexed_ustorervvmf2x7sfrvvm1di */

    case 248:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23628; /* pred_indexed_ustorervvmf2x8sfrvvm1di */

    case 249:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23636; /* pred_indexed_ustorervvm1x2dfrvvm1di */

    case 250:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23644; /* pred_indexed_ustorervvm1x3dfrvvm1di */

    case 251:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23652; /* pred_indexed_ustorervvm1x4dfrvvm1di */

    case 252:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23660; /* pred_indexed_ustorervvm1x5dfrvvm1di */

    case 253:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23668; /* pred_indexed_ustorervvm1x6dfrvvm1di */

    case 254:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23676; /* pred_indexed_ustorervvm1x7dfrvvm1di */

    case 255:
      if (!(
#line 8599 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23684; /* pred_indexed_ustorervvm1x8dfrvvm1di */

    case 256:
      if (!
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5252; /* pred_indexed_ustorervvmf4qirvvmf4qi */

    case 257:
      if (!
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5260; /* pred_indexed_ustorervvmf2hirvvmf4qi */

    case 258:
      if (!
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5268; /* pred_indexed_ustorervvm1sirvvmf4qi */

    case 259:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 820 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5276; /* pred_indexed_ustorervvm2dirvvmf4qi */

    case 260:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 821 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5284; /* pred_indexed_ustorervvmf2bfrvvmf4qi */

    case 261:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 822 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5292; /* pred_indexed_ustorervvmf2hfrvvmf4qi */

    case 262:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 823 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5300; /* pred_indexed_ustorervvm1sfrvvmf4qi */

    case 263:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 824 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5308; /* pred_indexed_ustorervvm2dfrvvmf4qi */

    case 264:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23686; /* pred_indexed_ustorervvmf4x2qirvvmf4qi */

    case 265:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23688; /* pred_indexed_ustorervvmf4x3qirvvmf4qi */

    case 266:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23690; /* pred_indexed_ustorervvmf4x4qirvvmf4qi */

    case 267:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23692; /* pred_indexed_ustorervvmf4x5qirvvmf4qi */

    case 268:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23694; /* pred_indexed_ustorervvmf4x6qirvvmf4qi */

    case 269:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23696; /* pred_indexed_ustorervvmf4x7qirvvmf4qi */

    case 270:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23698; /* pred_indexed_ustorervvmf4x8qirvvmf4qi */

    case 271:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23700; /* pred_indexed_ustorervvmf2x2hirvvmf4qi */

    case 272:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23702; /* pred_indexed_ustorervvmf2x3hirvvmf4qi */

    case 273:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23704; /* pred_indexed_ustorervvmf2x4hirvvmf4qi */

    case 274:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23706; /* pred_indexed_ustorervvmf2x5hirvvmf4qi */

    case 275:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23708; /* pred_indexed_ustorervvmf2x6hirvvmf4qi */

    case 276:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23710; /* pred_indexed_ustorervvmf2x7hirvvmf4qi */

    case 277:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23712; /* pred_indexed_ustorervvmf2x8hirvvmf4qi */

    case 278:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23714; /* pred_indexed_ustorervvm1x2sirvvmf4qi */

    case 279:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23716; /* pred_indexed_ustorervvm1x3sirvvmf4qi */

    case 280:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23718; /* pred_indexed_ustorervvm1x4sirvvmf4qi */

    case 281:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23720; /* pred_indexed_ustorervvm1x5sirvvmf4qi */

    case 282:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23722; /* pred_indexed_ustorervvm1x6sirvvmf4qi */

    case 283:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23724; /* pred_indexed_ustorervvm1x7sirvvmf4qi */

    case 284:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23726; /* pred_indexed_ustorervvm1x8sirvvmf4qi */

    case 285:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23728; /* pred_indexed_ustorervvm2x2dirvvmf4qi */

    case 286:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23730; /* pred_indexed_ustorervvm2x3dirvvmf4qi */

    case 287:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23732; /* pred_indexed_ustorervvm2x4dirvvmf4qi */

    case 288:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23734; /* pred_indexed_ustorervvmf2x2bfrvvmf4qi */

    case 289:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23736; /* pred_indexed_ustorervvmf2x3bfrvvmf4qi */

    case 290:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23738; /* pred_indexed_ustorervvmf2x4bfrvvmf4qi */

    case 291:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23740; /* pred_indexed_ustorervvmf2x5bfrvvmf4qi */

    case 292:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23742; /* pred_indexed_ustorervvmf2x6bfrvvmf4qi */

    case 293:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23744; /* pred_indexed_ustorervvmf2x7bfrvvmf4qi */

    case 294:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23746; /* pred_indexed_ustorervvmf2x8bfrvvmf4qi */

    case 295:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23748; /* pred_indexed_ustorervvmf2x2hfrvvmf4qi */

    case 296:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23750; /* pred_indexed_ustorervvmf2x3hfrvvmf4qi */

    case 297:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23752; /* pred_indexed_ustorervvmf2x4hfrvvmf4qi */

    case 298:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23754; /* pred_indexed_ustorervvmf2x5hfrvvmf4qi */

    case 299:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23756; /* pred_indexed_ustorervvmf2x6hfrvvmf4qi */

    case 300:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23758; /* pred_indexed_ustorervvmf2x7hfrvvmf4qi */

    case 301:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23760; /* pred_indexed_ustorervvmf2x8hfrvvmf4qi */

    case 302:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23762; /* pred_indexed_ustorervvm1x2sfrvvmf4qi */

    case 303:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23764; /* pred_indexed_ustorervvm1x3sfrvvmf4qi */

    case 304:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23766; /* pred_indexed_ustorervvm1x4sfrvvmf4qi */

    case 305:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23768; /* pred_indexed_ustorervvm1x5sfrvvmf4qi */

    case 306:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23770; /* pred_indexed_ustorervvm1x6sfrvvmf4qi */

    case 307:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23772; /* pred_indexed_ustorervvm1x7sfrvvmf4qi */

    case 308:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23774; /* pred_indexed_ustorervvm1x8sfrvvmf4qi */

    case 309:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23776; /* pred_indexed_ustorervvm2x2dfrvvmf4qi */

    case 310:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23778; /* pred_indexed_ustorervvm2x3dfrvvmf4qi */

    case 311:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23780; /* pred_indexed_ustorervvm2x4dfrvvmf4qi */

    case 312:
      if (!
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5254; /* pred_indexed_ustorervvmf4qirvvmf2hi */

    case 313:
      if (!
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5262; /* pred_indexed_ustorervvmf2hirvvmf2hi */

    case 314:
      if (!
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5270; /* pred_indexed_ustorervvm1sirvvmf2hi */

    case 315:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 820 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5278; /* pred_indexed_ustorervvm2dirvvmf2hi */

    case 316:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 821 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5286; /* pred_indexed_ustorervvmf2bfrvvmf2hi */

    case 317:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 822 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5294; /* pred_indexed_ustorervvmf2hfrvvmf2hi */

    case 318:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 823 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5302; /* pred_indexed_ustorervvm1sfrvvmf2hi */

    case 319:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 824 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5310; /* pred_indexed_ustorervvm2dfrvvmf2hi */

    case 320:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23782; /* pred_indexed_ustorervvmf4x2qirvvmf2hi */

    case 321:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23784; /* pred_indexed_ustorervvmf4x3qirvvmf2hi */

    case 322:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23786; /* pred_indexed_ustorervvmf4x4qirvvmf2hi */

    case 323:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23788; /* pred_indexed_ustorervvmf4x5qirvvmf2hi */

    case 324:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23790; /* pred_indexed_ustorervvmf4x6qirvvmf2hi */

    case 325:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23792; /* pred_indexed_ustorervvmf4x7qirvvmf2hi */

    case 326:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23794; /* pred_indexed_ustorervvmf4x8qirvvmf2hi */

    case 327:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23796; /* pred_indexed_ustorervvmf2x2hirvvmf2hi */

    case 328:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23798; /* pred_indexed_ustorervvmf2x3hirvvmf2hi */

    case 329:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23800; /* pred_indexed_ustorervvmf2x4hirvvmf2hi */

    case 330:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23802; /* pred_indexed_ustorervvmf2x5hirvvmf2hi */

    case 331:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23804; /* pred_indexed_ustorervvmf2x6hirvvmf2hi */

    case 332:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23806; /* pred_indexed_ustorervvmf2x7hirvvmf2hi */

    case 333:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23808; /* pred_indexed_ustorervvmf2x8hirvvmf2hi */

    case 334:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23810; /* pred_indexed_ustorervvm1x2sirvvmf2hi */

    case 335:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23812; /* pred_indexed_ustorervvm1x3sirvvmf2hi */

    case 336:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23814; /* pred_indexed_ustorervvm1x4sirvvmf2hi */

    case 337:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23816; /* pred_indexed_ustorervvm1x5sirvvmf2hi */

    case 338:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23818; /* pred_indexed_ustorervvm1x6sirvvmf2hi */

    case 339:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23820; /* pred_indexed_ustorervvm1x7sirvvmf2hi */

    case 340:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23822; /* pred_indexed_ustorervvm1x8sirvvmf2hi */

    case 341:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23824; /* pred_indexed_ustorervvm2x2dirvvmf2hi */

    case 342:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23826; /* pred_indexed_ustorervvm2x3dirvvmf2hi */

    case 343:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23828; /* pred_indexed_ustorervvm2x4dirvvmf2hi */

    case 344:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23830; /* pred_indexed_ustorervvmf2x2bfrvvmf2hi */

    case 345:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23832; /* pred_indexed_ustorervvmf2x3bfrvvmf2hi */

    case 346:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23834; /* pred_indexed_ustorervvmf2x4bfrvvmf2hi */

    case 347:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23836; /* pred_indexed_ustorervvmf2x5bfrvvmf2hi */

    case 348:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23838; /* pred_indexed_ustorervvmf2x6bfrvvmf2hi */

    case 349:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23840; /* pred_indexed_ustorervvmf2x7bfrvvmf2hi */

    case 350:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23842; /* pred_indexed_ustorervvmf2x8bfrvvmf2hi */

    case 351:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23844; /* pred_indexed_ustorervvmf2x2hfrvvmf2hi */

    case 352:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23846; /* pred_indexed_ustorervvmf2x3hfrvvmf2hi */

    case 353:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23848; /* pred_indexed_ustorervvmf2x4hfrvvmf2hi */

    case 354:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23850; /* pred_indexed_ustorervvmf2x5hfrvvmf2hi */

    case 355:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23852; /* pred_indexed_ustorervvmf2x6hfrvvmf2hi */

    case 356:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23854; /* pred_indexed_ustorervvmf2x7hfrvvmf2hi */

    case 357:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23856; /* pred_indexed_ustorervvmf2x8hfrvvmf2hi */

    case 358:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23858; /* pred_indexed_ustorervvm1x2sfrvvmf2hi */

    case 359:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23860; /* pred_indexed_ustorervvm1x3sfrvvmf2hi */

    case 360:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23862; /* pred_indexed_ustorervvm1x4sfrvvmf2hi */

    case 361:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23864; /* pred_indexed_ustorervvm1x5sfrvvmf2hi */

    case 362:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23866; /* pred_indexed_ustorervvm1x6sfrvvmf2hi */

    case 363:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23868; /* pred_indexed_ustorervvm1x7sfrvvmf2hi */

    case 364:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23870; /* pred_indexed_ustorervvm1x8sfrvvmf2hi */

    case 365:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23872; /* pred_indexed_ustorervvm2x2dfrvvmf2hi */

    case 366:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23874; /* pred_indexed_ustorervvm2x3dfrvvmf2hi */

    case 367:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23876; /* pred_indexed_ustorervvm2x4dfrvvmf2hi */

    case 368:
      if (!
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5256; /* pred_indexed_ustorervvmf4qirvvm1si */

    case 369:
      if (!
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5264; /* pred_indexed_ustorervvmf2hirvvm1si */

    case 370:
      if (!
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5272; /* pred_indexed_ustorervvm1sirvvm1si */

    case 371:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 820 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5280; /* pred_indexed_ustorervvm2dirvvm1si */

    case 372:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 821 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5288; /* pred_indexed_ustorervvmf2bfrvvm1si */

    case 373:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 822 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5296; /* pred_indexed_ustorervvmf2hfrvvm1si */

    case 374:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 823 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5304; /* pred_indexed_ustorervvm1sfrvvm1si */

    case 375:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 824 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5312; /* pred_indexed_ustorervvm2dfrvvm1si */

    case 376:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23878; /* pred_indexed_ustorervvmf4x2qirvvm1si */

    case 377:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23880; /* pred_indexed_ustorervvmf4x3qirvvm1si */

    case 378:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23882; /* pred_indexed_ustorervvmf4x4qirvvm1si */

    case 379:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23884; /* pred_indexed_ustorervvmf4x5qirvvm1si */

    case 380:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23886; /* pred_indexed_ustorervvmf4x6qirvvm1si */

    case 381:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23888; /* pred_indexed_ustorervvmf4x7qirvvm1si */

    case 382:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23890; /* pred_indexed_ustorervvmf4x8qirvvm1si */

    case 383:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23892; /* pred_indexed_ustorervvmf2x2hirvvm1si */

    case 384:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23894; /* pred_indexed_ustorervvmf2x3hirvvm1si */

    case 385:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23896; /* pred_indexed_ustorervvmf2x4hirvvm1si */

    case 386:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23898; /* pred_indexed_ustorervvmf2x5hirvvm1si */

    case 387:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23900; /* pred_indexed_ustorervvmf2x6hirvvm1si */

    case 388:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23902; /* pred_indexed_ustorervvmf2x7hirvvm1si */

    case 389:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23904; /* pred_indexed_ustorervvmf2x8hirvvm1si */

    case 390:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23906; /* pred_indexed_ustorervvm1x2sirvvm1si */

    case 391:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23908; /* pred_indexed_ustorervvm1x3sirvvm1si */

    case 392:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23910; /* pred_indexed_ustorervvm1x4sirvvm1si */

    case 393:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23912; /* pred_indexed_ustorervvm1x5sirvvm1si */

    case 394:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23914; /* pred_indexed_ustorervvm1x6sirvvm1si */

    case 395:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23916; /* pred_indexed_ustorervvm1x7sirvvm1si */

    case 396:
      if (!
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23918; /* pred_indexed_ustorervvm1x8sirvvm1si */

    case 397:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23920; /* pred_indexed_ustorervvm2x2dirvvm1si */

    case 398:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23922; /* pred_indexed_ustorervvm2x3dirvvm1si */

    case 399:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23924; /* pred_indexed_ustorervvm2x4dirvvm1si */

    case 400:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23926; /* pred_indexed_ustorervvmf2x2bfrvvm1si */

    case 401:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23928; /* pred_indexed_ustorervvmf2x3bfrvvm1si */

    case 402:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23930; /* pred_indexed_ustorervvmf2x4bfrvvm1si */

    case 403:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23932; /* pred_indexed_ustorervvmf2x5bfrvvm1si */

    case 404:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23934; /* pred_indexed_ustorervvmf2x6bfrvvm1si */

    case 405:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23936; /* pred_indexed_ustorervvmf2x7bfrvvm1si */

    case 406:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23938; /* pred_indexed_ustorervvmf2x8bfrvvm1si */

    case 407:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23940; /* pred_indexed_ustorervvmf2x2hfrvvm1si */

    case 408:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23942; /* pred_indexed_ustorervvmf2x3hfrvvm1si */

    case 409:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23944; /* pred_indexed_ustorervvmf2x4hfrvvm1si */

    case 410:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23946; /* pred_indexed_ustorervvmf2x5hfrvvm1si */

    case 411:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23948; /* pred_indexed_ustorervvmf2x6hfrvvm1si */

    case 412:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23950; /* pred_indexed_ustorervvmf2x7hfrvvm1si */

    case 413:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23952; /* pred_indexed_ustorervvmf2x8hfrvvm1si */

    case 414:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23954; /* pred_indexed_ustorervvm1x2sfrvvm1si */

    case 415:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23956; /* pred_indexed_ustorervvm1x3sfrvvm1si */

    case 416:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23958; /* pred_indexed_ustorervvm1x4sfrvvm1si */

    case 417:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23960; /* pred_indexed_ustorervvm1x5sfrvvm1si */

    case 418:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23962; /* pred_indexed_ustorervvm1x6sfrvvm1si */

    case 419:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23964; /* pred_indexed_ustorervvm1x7sfrvvm1si */

    case 420:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23966; /* pred_indexed_ustorervvm1x8sfrvvm1si */

    case 421:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23968; /* pred_indexed_ustorervvm2x2dfrvvm1si */

    case 422:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23970; /* pred_indexed_ustorervvm2x3dfrvvm1si */

    case 423:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 23972; /* pred_indexed_ustorervvm2x4dfrvvm1si */

    case 424:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5258; /* pred_indexed_ustorervvmf4qirvvm2di */

    case 425:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5266; /* pred_indexed_ustorervvmf2hirvvm2di */

    case 426:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5274; /* pred_indexed_ustorervvm1sirvvm2di */

    case 427:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 820 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5282; /* pred_indexed_ustorervvm2dirvvm2di */

    case 428:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 821 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 5290; /* pred_indexed_ustorervvmf2bfrvvm2di */

    case 429:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 822 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 5298; /* pred_indexed_ustorervvmf2hfrvvm2di */

    case 430:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 823 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 5306; /* pred_indexed_ustorervvm1sfrvvm2di */

    case 431:
      if (!(
#line 2605 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 824 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5314; /* pred_indexed_ustorervvm2dfrvvm2di */

    case 432:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23974; /* pred_indexed_ustorervvmf4x2qirvvm2di */

    case 433:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23976; /* pred_indexed_ustorervvmf4x3qirvvm2di */

    case 434:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23978; /* pred_indexed_ustorervvmf4x4qirvvm2di */

    case 435:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23980; /* pred_indexed_ustorervvmf4x5qirvvm2di */

    case 436:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23982; /* pred_indexed_ustorervvmf4x6qirvvm2di */

    case 437:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23984; /* pred_indexed_ustorervvmf4x7qirvvm2di */

    case 438:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23986; /* pred_indexed_ustorervvmf4x8qirvvm2di */

    case 439:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23988; /* pred_indexed_ustorervvmf2x2hirvvm2di */

    case 440:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23990; /* pred_indexed_ustorervvmf2x3hirvvm2di */

    case 441:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23992; /* pred_indexed_ustorervvmf2x4hirvvm2di */

    case 442:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23994; /* pred_indexed_ustorervvmf2x5hirvvm2di */

    case 443:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23996; /* pred_indexed_ustorervvmf2x6hirvvm2di */

    case 444:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23998; /* pred_indexed_ustorervvmf2x7hirvvm2di */

    case 445:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24000; /* pred_indexed_ustorervvmf2x8hirvvm2di */

    case 446:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24002; /* pred_indexed_ustorervvm1x2sirvvm2di */

    case 447:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24004; /* pred_indexed_ustorervvm1x3sirvvm2di */

    case 448:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24006; /* pred_indexed_ustorervvm1x4sirvvm2di */

    case 449:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24008; /* pred_indexed_ustorervvm1x5sirvvm2di */

    case 450:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24010; /* pred_indexed_ustorervvm1x6sirvvm2di */

    case 451:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24012; /* pred_indexed_ustorervvm1x7sirvvm2di */

    case 452:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24014; /* pred_indexed_ustorervvm1x8sirvvm2di */

    case 453:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 24016; /* pred_indexed_ustorervvm2x2dirvvm2di */

    case 454:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 24018; /* pred_indexed_ustorervvm2x3dirvvm2di */

    case 455:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 24020; /* pred_indexed_ustorervvm2x4dirvvm2di */

    case 456:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24022; /* pred_indexed_ustorervvmf2x2bfrvvm2di */

    case 457:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24024; /* pred_indexed_ustorervvmf2x3bfrvvm2di */

    case 458:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24026; /* pred_indexed_ustorervvmf2x4bfrvvm2di */

    case 459:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24028; /* pred_indexed_ustorervvmf2x5bfrvvm2di */

    case 460:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24030; /* pred_indexed_ustorervvmf2x6bfrvvm2di */

    case 461:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24032; /* pred_indexed_ustorervvmf2x7bfrvvm2di */

    case 462:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24034; /* pred_indexed_ustorervvmf2x8bfrvvm2di */

    case 463:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24036; /* pred_indexed_ustorervvmf2x2hfrvvm2di */

    case 464:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24038; /* pred_indexed_ustorervvmf2x3hfrvvm2di */

    case 465:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24040; /* pred_indexed_ustorervvmf2x4hfrvvm2di */

    case 466:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24042; /* pred_indexed_ustorervvmf2x5hfrvvm2di */

    case 467:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24044; /* pred_indexed_ustorervvmf2x6hfrvvm2di */

    case 468:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24046; /* pred_indexed_ustorervvmf2x7hfrvvm2di */

    case 469:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24048; /* pred_indexed_ustorervvmf2x8hfrvvm2di */

    case 470:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24050; /* pred_indexed_ustorervvm1x2sfrvvm2di */

    case 471:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24052; /* pred_indexed_ustorervvm1x3sfrvvm2di */

    case 472:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24054; /* pred_indexed_ustorervvm1x4sfrvvm2di */

    case 473:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24056; /* pred_indexed_ustorervvm1x5sfrvvm2di */

    case 474:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24058; /* pred_indexed_ustorervvm1x6sfrvvm2di */

    case 475:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24060; /* pred_indexed_ustorervvm1x7sfrvvm2di */

    case 476:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24062; /* pred_indexed_ustorervvm1x8sfrvvm2di */

    case 477:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 24064; /* pred_indexed_ustorervvm2x2dfrvvm2di */

    case 478:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 24066; /* pred_indexed_ustorervvm2x3dfrvvm2di */

    case 479:
      if (!(
#line 8616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 24068; /* pred_indexed_ustorervvm2x4dfrvvm2di */

    case 480:
      if (!
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5316; /* pred_indexed_ustorervvmf2qirvvmf2qi */

    case 481:
      if (!
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5318; /* pred_indexed_ustorervvm1hirvvmf2qi */

    case 482:
      if (!
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5320; /* pred_indexed_ustorervvm2sirvvmf2qi */

    case 483:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 831 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5322; /* pred_indexed_ustorervvm4dirvvmf2qi */

    case 484:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 832 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5324; /* pred_indexed_ustorervvm1bfrvvmf2qi */

    case 485:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 833 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5326; /* pred_indexed_ustorervvm1hfrvvmf2qi */

    case 486:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 834 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5328; /* pred_indexed_ustorervvm2sfrvvmf2qi */

    case 487:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 835 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5330; /* pred_indexed_ustorervvm4dfrvvmf2qi */

    case 488:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24070; /* pred_indexed_ustorervvmf2x2qirvvmf2qi */

    case 489:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24072; /* pred_indexed_ustorervvmf2x3qirvvmf2qi */

    case 490:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24074; /* pred_indexed_ustorervvmf2x4qirvvmf2qi */

    case 491:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24076; /* pred_indexed_ustorervvmf2x5qirvvmf2qi */

    case 492:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24078; /* pred_indexed_ustorervvmf2x6qirvvmf2qi */

    case 493:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24080; /* pred_indexed_ustorervvmf2x7qirvvmf2qi */

    case 494:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24082; /* pred_indexed_ustorervvmf2x8qirvvmf2qi */

    case 495:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24084; /* pred_indexed_ustorervvm1x2hirvvmf2qi */

    case 496:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24086; /* pred_indexed_ustorervvm1x3hirvvmf2qi */

    case 497:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24088; /* pred_indexed_ustorervvm1x4hirvvmf2qi */

    case 498:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24090; /* pred_indexed_ustorervvm1x5hirvvmf2qi */

    case 499:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24092; /* pred_indexed_ustorervvm1x6hirvvmf2qi */

    case 500:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24094; /* pred_indexed_ustorervvm1x7hirvvmf2qi */

    case 501:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24096; /* pred_indexed_ustorervvm1x8hirvvmf2qi */

    case 502:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24098; /* pred_indexed_ustorervvm2x2sirvvmf2qi */

    case 503:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24100; /* pred_indexed_ustorervvm2x3sirvvmf2qi */

    case 504:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24102; /* pred_indexed_ustorervvm2x4sirvvmf2qi */

    case 505:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24104; /* pred_indexed_ustorervvm4x2dirvvmf2qi */

    case 506:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24106; /* pred_indexed_ustorervvm1x2bfrvvmf2qi */

    case 507:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24108; /* pred_indexed_ustorervvm1x3bfrvvmf2qi */

    case 508:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24110; /* pred_indexed_ustorervvm1x4bfrvvmf2qi */

    case 509:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24112; /* pred_indexed_ustorervvm1x5bfrvvmf2qi */

    case 510:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24114; /* pred_indexed_ustorervvm1x6bfrvvmf2qi */

    case 511:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24116; /* pred_indexed_ustorervvm1x7bfrvvmf2qi */

    case 512:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24118; /* pred_indexed_ustorervvm1x8bfrvvmf2qi */

    case 513:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24120; /* pred_indexed_ustorervvm1x2hfrvvmf2qi */

    case 514:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24122; /* pred_indexed_ustorervvm1x3hfrvvmf2qi */

    case 515:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24124; /* pred_indexed_ustorervvm1x4hfrvvmf2qi */

    case 516:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24126; /* pred_indexed_ustorervvm1x5hfrvvmf2qi */

    case 517:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24128; /* pred_indexed_ustorervvm1x6hfrvvmf2qi */

    case 518:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24130; /* pred_indexed_ustorervvm1x7hfrvvmf2qi */

    case 519:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24132; /* pred_indexed_ustorervvm1x8hfrvvmf2qi */

    case 520:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24134; /* pred_indexed_ustorervvm2x2sfrvvmf2qi */

    case 521:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24136; /* pred_indexed_ustorervvm2x3sfrvvmf2qi */

    case 522:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24138; /* pred_indexed_ustorervvm2x4sfrvvmf2qi */

    case 523:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 24140; /* pred_indexed_ustorervvm4x2dfrvvmf2qi */

    case 524:
      if (!
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5332; /* pred_indexed_ustorervvmf2qirvvm1hi */

    case 525:
      if (!
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5334; /* pred_indexed_ustorervvm1hirvvm1hi */

    case 526:
      if (!
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5336; /* pred_indexed_ustorervvm2sirvvm1hi */

    case 527:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 831 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5338; /* pred_indexed_ustorervvm4dirvvm1hi */

    case 528:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 832 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5340; /* pred_indexed_ustorervvm1bfrvvm1hi */

    case 529:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 833 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5342; /* pred_indexed_ustorervvm1hfrvvm1hi */

    case 530:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 834 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5344; /* pred_indexed_ustorervvm2sfrvvm1hi */

    case 531:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 835 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5346; /* pred_indexed_ustorervvm4dfrvvm1hi */

    case 532:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24142; /* pred_indexed_ustorervvmf2x2qirvvm1hi */

    case 533:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24144; /* pred_indexed_ustorervvmf2x3qirvvm1hi */

    case 534:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24146; /* pred_indexed_ustorervvmf2x4qirvvm1hi */

    case 535:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24148; /* pred_indexed_ustorervvmf2x5qirvvm1hi */

    case 536:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24150; /* pred_indexed_ustorervvmf2x6qirvvm1hi */

    case 537:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24152; /* pred_indexed_ustorervvmf2x7qirvvm1hi */

    case 538:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24154; /* pred_indexed_ustorervvmf2x8qirvvm1hi */

    case 539:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24156; /* pred_indexed_ustorervvm1x2hirvvm1hi */

    case 540:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24158; /* pred_indexed_ustorervvm1x3hirvvm1hi */

    case 541:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24160; /* pred_indexed_ustorervvm1x4hirvvm1hi */

    case 542:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24162; /* pred_indexed_ustorervvm1x5hirvvm1hi */

    case 543:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24164; /* pred_indexed_ustorervvm1x6hirvvm1hi */

    case 544:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24166; /* pred_indexed_ustorervvm1x7hirvvm1hi */

    case 545:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24168; /* pred_indexed_ustorervvm1x8hirvvm1hi */

    case 546:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24170; /* pred_indexed_ustorervvm2x2sirvvm1hi */

    case 547:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24172; /* pred_indexed_ustorervvm2x3sirvvm1hi */

    case 548:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24174; /* pred_indexed_ustorervvm2x4sirvvm1hi */

    case 549:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24176; /* pred_indexed_ustorervvm4x2dirvvm1hi */

    case 550:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24178; /* pred_indexed_ustorervvm1x2bfrvvm1hi */

    case 551:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24180; /* pred_indexed_ustorervvm1x3bfrvvm1hi */

    case 552:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24182; /* pred_indexed_ustorervvm1x4bfrvvm1hi */

    case 553:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24184; /* pred_indexed_ustorervvm1x5bfrvvm1hi */

    case 554:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24186; /* pred_indexed_ustorervvm1x6bfrvvm1hi */

    case 555:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24188; /* pred_indexed_ustorervvm1x7bfrvvm1hi */

    case 556:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24190; /* pred_indexed_ustorervvm1x8bfrvvm1hi */

    case 557:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24192; /* pred_indexed_ustorervvm1x2hfrvvm1hi */

    case 558:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24194; /* pred_indexed_ustorervvm1x3hfrvvm1hi */

    case 559:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24196; /* pred_indexed_ustorervvm1x4hfrvvm1hi */

    case 560:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24198; /* pred_indexed_ustorervvm1x5hfrvvm1hi */

    case 561:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24200; /* pred_indexed_ustorervvm1x6hfrvvm1hi */

    case 562:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24202; /* pred_indexed_ustorervvm1x7hfrvvm1hi */

    case 563:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24204; /* pred_indexed_ustorervvm1x8hfrvvm1hi */

    case 564:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24206; /* pred_indexed_ustorervvm2x2sfrvvm1hi */

    case 565:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24208; /* pred_indexed_ustorervvm2x3sfrvvm1hi */

    case 566:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24210; /* pred_indexed_ustorervvm2x4sfrvvm1hi */

    case 567:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 24212; /* pred_indexed_ustorervvm4x2dfrvvm1hi */

    case 568:
      if (!
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5348; /* pred_indexed_ustorervvmf2qirvvm2si */

    case 569:
      if (!
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5350; /* pred_indexed_ustorervvm1hirvvm2si */

    case 570:
      if (!
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5352; /* pred_indexed_ustorervvm2sirvvm2si */

    case 571:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 831 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5354; /* pred_indexed_ustorervvm4dirvvm2si */

    case 572:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 832 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5356; /* pred_indexed_ustorervvm1bfrvvm2si */

    case 573:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 833 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5358; /* pred_indexed_ustorervvm1hfrvvm2si */

    case 574:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 834 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5360; /* pred_indexed_ustorervvm2sfrvvm2si */

    case 575:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 835 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5362; /* pred_indexed_ustorervvm4dfrvvm2si */

    case 576:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24214; /* pred_indexed_ustorervvmf2x2qirvvm2si */

    case 577:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24216; /* pred_indexed_ustorervvmf2x3qirvvm2si */

    case 578:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24218; /* pred_indexed_ustorervvmf2x4qirvvm2si */

    case 579:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24220; /* pred_indexed_ustorervvmf2x5qirvvm2si */

    case 580:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24222; /* pred_indexed_ustorervvmf2x6qirvvm2si */

    case 581:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24224; /* pred_indexed_ustorervvmf2x7qirvvm2si */

    case 582:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24226; /* pred_indexed_ustorervvmf2x8qirvvm2si */

    case 583:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24228; /* pred_indexed_ustorervvm1x2hirvvm2si */

    case 584:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24230; /* pred_indexed_ustorervvm1x3hirvvm2si */

    case 585:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24232; /* pred_indexed_ustorervvm1x4hirvvm2si */

    case 586:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24234; /* pred_indexed_ustorervvm1x5hirvvm2si */

    case 587:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24236; /* pred_indexed_ustorervvm1x6hirvvm2si */

    case 588:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24238; /* pred_indexed_ustorervvm1x7hirvvm2si */

    case 589:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24240; /* pred_indexed_ustorervvm1x8hirvvm2si */

    case 590:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24242; /* pred_indexed_ustorervvm2x2sirvvm2si */

    case 591:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24244; /* pred_indexed_ustorervvm2x3sirvvm2si */

    case 592:
      if (!
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24246; /* pred_indexed_ustorervvm2x4sirvvm2si */

    case 593:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24248; /* pred_indexed_ustorervvm4x2dirvvm2si */

    case 594:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24250; /* pred_indexed_ustorervvm1x2bfrvvm2si */

    case 595:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24252; /* pred_indexed_ustorervvm1x3bfrvvm2si */

    case 596:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24254; /* pred_indexed_ustorervvm1x4bfrvvm2si */

    case 597:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24256; /* pred_indexed_ustorervvm1x5bfrvvm2si */

    case 598:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24258; /* pred_indexed_ustorervvm1x6bfrvvm2si */

    case 599:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24260; /* pred_indexed_ustorervvm1x7bfrvvm2si */

    case 600:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24262; /* pred_indexed_ustorervvm1x8bfrvvm2si */

    case 601:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24264; /* pred_indexed_ustorervvm1x2hfrvvm2si */

    case 602:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24266; /* pred_indexed_ustorervvm1x3hfrvvm2si */

    case 603:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24268; /* pred_indexed_ustorervvm1x4hfrvvm2si */

    case 604:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24270; /* pred_indexed_ustorervvm1x5hfrvvm2si */

    case 605:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24272; /* pred_indexed_ustorervvm1x6hfrvvm2si */

    case 606:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24274; /* pred_indexed_ustorervvm1x7hfrvvm2si */

    case 607:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24276; /* pred_indexed_ustorervvm1x8hfrvvm2si */

    case 608:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24278; /* pred_indexed_ustorervvm2x2sfrvvm2si */

    case 609:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24280; /* pred_indexed_ustorervvm2x3sfrvvm2si */

    case 610:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24282; /* pred_indexed_ustorervvm2x4sfrvvm2si */

    case 611:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 24284; /* pred_indexed_ustorervvm4x2dfrvvm2si */

    case 612:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5364; /* pred_indexed_ustorervvmf2qirvvm4di */

    case 613:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5366; /* pred_indexed_ustorervvm1hirvvm4di */

    case 614:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5368; /* pred_indexed_ustorervvm2sirvvm4di */

    case 615:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 831 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5370; /* pred_indexed_ustorervvm4dirvvm4di */

    case 616:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 832 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 5372; /* pred_indexed_ustorervvm1bfrvvm4di */

    case 617:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 833 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 5374; /* pred_indexed_ustorervvm1hfrvvm4di */

    case 618:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 834 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 5376; /* pred_indexed_ustorervvm2sfrvvm4di */

    case 619:
      if (!(
#line 2622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 835 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5378; /* pred_indexed_ustorervvm4dfrvvm4di */

    case 620:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24286; /* pred_indexed_ustorervvmf2x2qirvvm4di */

    case 621:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24288; /* pred_indexed_ustorervvmf2x3qirvvm4di */

    case 622:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24290; /* pred_indexed_ustorervvmf2x4qirvvm4di */

    case 623:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24292; /* pred_indexed_ustorervvmf2x5qirvvm4di */

    case 624:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24294; /* pred_indexed_ustorervvmf2x6qirvvm4di */

    case 625:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24296; /* pred_indexed_ustorervvmf2x7qirvvm4di */

    case 626:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24298; /* pred_indexed_ustorervvmf2x8qirvvm4di */

    case 627:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24300; /* pred_indexed_ustorervvm1x2hirvvm4di */

    case 628:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24302; /* pred_indexed_ustorervvm1x3hirvvm4di */

    case 629:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24304; /* pred_indexed_ustorervvm1x4hirvvm4di */

    case 630:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24306; /* pred_indexed_ustorervvm1x5hirvvm4di */

    case 631:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24308; /* pred_indexed_ustorervvm1x6hirvvm4di */

    case 632:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24310; /* pred_indexed_ustorervvm1x7hirvvm4di */

    case 633:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24312; /* pred_indexed_ustorervvm1x8hirvvm4di */

    case 634:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24314; /* pred_indexed_ustorervvm2x2sirvvm4di */

    case 635:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24316; /* pred_indexed_ustorervvm2x3sirvvm4di */

    case 636:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24318; /* pred_indexed_ustorervvm2x4sirvvm4di */

    case 637:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 24320; /* pred_indexed_ustorervvm4x2dirvvm4di */

    case 638:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24322; /* pred_indexed_ustorervvm1x2bfrvvm4di */

    case 639:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24324; /* pred_indexed_ustorervvm1x3bfrvvm4di */

    case 640:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24326; /* pred_indexed_ustorervvm1x4bfrvvm4di */

    case 641:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24328; /* pred_indexed_ustorervvm1x5bfrvvm4di */

    case 642:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24330; /* pred_indexed_ustorervvm1x6bfrvvm4di */

    case 643:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24332; /* pred_indexed_ustorervvm1x7bfrvvm4di */

    case 644:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24334; /* pred_indexed_ustorervvm1x8bfrvvm4di */

    case 645:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24336; /* pred_indexed_ustorervvm1x2hfrvvm4di */

    case 646:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24338; /* pred_indexed_ustorervvm1x3hfrvvm4di */

    case 647:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24340; /* pred_indexed_ustorervvm1x4hfrvvm4di */

    case 648:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24342; /* pred_indexed_ustorervvm1x5hfrvvm4di */

    case 649:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24344; /* pred_indexed_ustorervvm1x6hfrvvm4di */

    case 650:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24346; /* pred_indexed_ustorervvm1x7hfrvvm4di */

    case 651:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24348; /* pred_indexed_ustorervvm1x8hfrvvm4di */

    case 652:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24350; /* pred_indexed_ustorervvm2x2sfrvvm4di */

    case 653:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24352; /* pred_indexed_ustorervvm2x3sfrvvm4di */

    case 654:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24354; /* pred_indexed_ustorervvm2x4sfrvvm4di */

    case 655:
      if (!(
#line 8633 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 24356; /* pred_indexed_ustorervvm4x2dfrvvm4di */

    case 656:
      if (!
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5380; /* pred_indexed_ustorervvm1qirvvm1qi */

    case 657:
      if (!
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5382; /* pred_indexed_ustorervvm2hirvvm1qi */

    case 658:
      if (!
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5384; /* pred_indexed_ustorervvm4sirvvm1qi */

    case 659:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 842 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5386; /* pred_indexed_ustorervvm8dirvvm1qi */

    case 660:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 843 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5388; /* pred_indexed_ustorervvm2bfrvvm1qi */

    case 661:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 844 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5390; /* pred_indexed_ustorervvm2hfrvvm1qi */

    case 662:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 845 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5392; /* pred_indexed_ustorervvm4sfrvvm1qi */

    case 663:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 846 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5394; /* pred_indexed_ustorervvm8dfrvvm1qi */

    case 664:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24358; /* pred_indexed_ustorervvm1x2qirvvm1qi */

    case 665:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24366; /* pred_indexed_ustorervvm1x3qirvvm1qi */

    case 666:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24374; /* pred_indexed_ustorervvm1x4qirvvm1qi */

    case 667:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24382; /* pred_indexed_ustorervvm1x5qirvvm1qi */

    case 668:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24390; /* pred_indexed_ustorervvm1x6qirvvm1qi */

    case 669:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24398; /* pred_indexed_ustorervvm1x7qirvvm1qi */

    case 670:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24406; /* pred_indexed_ustorervvm1x8qirvvm1qi */

    case 671:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24414; /* pred_indexed_ustorervvm2x2hirvvm1qi */

    case 672:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24422; /* pred_indexed_ustorervvm2x3hirvvm1qi */

    case 673:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24430; /* pred_indexed_ustorervvm2x4hirvvm1qi */

    case 674:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24438; /* pred_indexed_ustorervvm4x2sirvvm1qi */

    case 675:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24446; /* pred_indexed_ustorervvm2x2bfrvvm1qi */

    case 676:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24454; /* pred_indexed_ustorervvm2x3bfrvvm1qi */

    case 677:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24462; /* pred_indexed_ustorervvm2x4bfrvvm1qi */

    case 678:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24470; /* pred_indexed_ustorervvm2x2hfrvvm1qi */

    case 679:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24478; /* pred_indexed_ustorervvm2x3hfrvvm1qi */

    case 680:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24486; /* pred_indexed_ustorervvm2x4hfrvvm1qi */

    case 681:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24494; /* pred_indexed_ustorervvm4x2sfrvvm1qi */

    case 682:
      if (!
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5396; /* pred_indexed_ustorervvm1qirvvm2hi */

    case 683:
      if (!
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5398; /* pred_indexed_ustorervvm2hirvvm2hi */

    case 684:
      if (!
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5400; /* pred_indexed_ustorervvm4sirvvm2hi */

    case 685:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 842 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5402; /* pred_indexed_ustorervvm8dirvvm2hi */

    case 686:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 843 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5404; /* pred_indexed_ustorervvm2bfrvvm2hi */

    case 687:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 844 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5406; /* pred_indexed_ustorervvm2hfrvvm2hi */

    case 688:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 845 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5408; /* pred_indexed_ustorervvm4sfrvvm2hi */

    case 689:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 846 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5410; /* pred_indexed_ustorervvm8dfrvvm2hi */

    case 690:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24360; /* pred_indexed_ustorervvm1x2qirvvm2hi */

    case 691:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24368; /* pred_indexed_ustorervvm1x3qirvvm2hi */

    case 692:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24376; /* pred_indexed_ustorervvm1x4qirvvm2hi */

    case 693:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24384; /* pred_indexed_ustorervvm1x5qirvvm2hi */

    case 694:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24392; /* pred_indexed_ustorervvm1x6qirvvm2hi */

    case 695:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24400; /* pred_indexed_ustorervvm1x7qirvvm2hi */

    case 696:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24408; /* pred_indexed_ustorervvm1x8qirvvm2hi */

    case 697:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24416; /* pred_indexed_ustorervvm2x2hirvvm2hi */

    case 698:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24424; /* pred_indexed_ustorervvm2x3hirvvm2hi */

    case 699:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24432; /* pred_indexed_ustorervvm2x4hirvvm2hi */

    case 700:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24440; /* pred_indexed_ustorervvm4x2sirvvm2hi */

    case 701:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24448; /* pred_indexed_ustorervvm2x2bfrvvm2hi */

    case 702:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24456; /* pred_indexed_ustorervvm2x3bfrvvm2hi */

    case 703:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24464; /* pred_indexed_ustorervvm2x4bfrvvm2hi */

    case 704:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24472; /* pred_indexed_ustorervvm2x2hfrvvm2hi */

    case 705:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24480; /* pred_indexed_ustorervvm2x3hfrvvm2hi */

    case 706:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24488; /* pred_indexed_ustorervvm2x4hfrvvm2hi */

    case 707:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24496; /* pred_indexed_ustorervvm4x2sfrvvm2hi */

    case 708:
      if (!
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5412; /* pred_indexed_ustorervvm1qirvvm4si */

    case 709:
      if (!
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5414; /* pred_indexed_ustorervvm2hirvvm4si */

    case 710:
      if (!
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5416; /* pred_indexed_ustorervvm4sirvvm4si */

    case 711:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 842 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5418; /* pred_indexed_ustorervvm8dirvvm4si */

    case 712:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 843 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5420; /* pred_indexed_ustorervvm2bfrvvm4si */

    case 713:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 844 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5422; /* pred_indexed_ustorervvm2hfrvvm4si */

    case 714:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 845 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5424; /* pred_indexed_ustorervvm4sfrvvm4si */

    case 715:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 846 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5426; /* pred_indexed_ustorervvm8dfrvvm4si */

    case 716:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24362; /* pred_indexed_ustorervvm1x2qirvvm4si */

    case 717:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24370; /* pred_indexed_ustorervvm1x3qirvvm4si */

    case 718:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24378; /* pred_indexed_ustorervvm1x4qirvvm4si */

    case 719:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24386; /* pred_indexed_ustorervvm1x5qirvvm4si */

    case 720:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24394; /* pred_indexed_ustorervvm1x6qirvvm4si */

    case 721:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24402; /* pred_indexed_ustorervvm1x7qirvvm4si */

    case 722:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24410; /* pred_indexed_ustorervvm1x8qirvvm4si */

    case 723:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24418; /* pred_indexed_ustorervvm2x2hirvvm4si */

    case 724:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24426; /* pred_indexed_ustorervvm2x3hirvvm4si */

    case 725:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24434; /* pred_indexed_ustorervvm2x4hirvvm4si */

    case 726:
      if (!
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24442; /* pred_indexed_ustorervvm4x2sirvvm4si */

    case 727:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24450; /* pred_indexed_ustorervvm2x2bfrvvm4si */

    case 728:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24458; /* pred_indexed_ustorervvm2x3bfrvvm4si */

    case 729:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24466; /* pred_indexed_ustorervvm2x4bfrvvm4si */

    case 730:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24474; /* pred_indexed_ustorervvm2x2hfrvvm4si */

    case 731:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24482; /* pred_indexed_ustorervvm2x3hfrvvm4si */

    case 732:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24490; /* pred_indexed_ustorervvm2x4hfrvvm4si */

    case 733:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 24498; /* pred_indexed_ustorervvm4x2sfrvvm4si */

    case 734:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5428; /* pred_indexed_ustorervvm1qirvvm8di */

    case 735:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5430; /* pred_indexed_ustorervvm2hirvvm8di */

    case 736:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5432; /* pred_indexed_ustorervvm4sirvvm8di */

    case 737:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 842 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 5434; /* pred_indexed_ustorervvm8dirvvm8di */

    case 738:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 843 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 5436; /* pred_indexed_ustorervvm2bfrvvm8di */

    case 739:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 844 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 5438; /* pred_indexed_ustorervvm2hfrvvm8di */

    case 740:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 845 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 5440; /* pred_indexed_ustorervvm4sfrvvm8di */

    case 741:
      if (!(
#line 2639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 846 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 5442; /* pred_indexed_ustorervvm8dfrvvm8di */

    case 742:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24364; /* pred_indexed_ustorervvm1x2qirvvm8di */

    case 743:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24372; /* pred_indexed_ustorervvm1x3qirvvm8di */

    case 744:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24380; /* pred_indexed_ustorervvm1x4qirvvm8di */

    case 745:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24388; /* pred_indexed_ustorervvm1x5qirvvm8di */

    case 746:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24396; /* pred_indexed_ustorervvm1x6qirvvm8di */

    case 747:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24404; /* pred_indexed_ustorervvm1x7qirvvm8di */

    case 748:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24412; /* pred_indexed_ustorervvm1x8qirvvm8di */

    case 749:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24420; /* pred_indexed_ustorervvm2x2hirvvm8di */

    case 750:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24428; /* pred_indexed_ustorervvm2x3hirvvm8di */

    case 751:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24436; /* pred_indexed_ustorervvm2x4hirvvm8di */

    case 752:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 24444; /* pred_indexed_ustorervvm4x2sirvvm8di */

    case 753:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24452; /* pred_indexed_ustorervvm2x2bfrvvm8di */

    case 754:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24460; /* pred_indexed_ustorervvm2x3bfrvvm8di */

    case 755:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 24468; /* pred_indexed_ustorervvm2x4bfrvvm8di */

    case 756:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24476; /* pred_indexed_ustorervvm2x2hfrvvm8di */

    case 757:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24484; /* pred_indexed_ustorervvm2x3hfrvvm8di */

    case 758:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 24492; /* pred_indexed_ustorervvm2x4hfrvvm8di */

    case 759:
      if (!(
#line 8650 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 24500; /* pred_indexed_ustorervvm4x2sfrvvm8di */

    case 760:
      if (!
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5444; /* pred_indexed_ustorervvm2qirvvm2qi */

    case 761:
      if (!
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5446; /* pred_indexed_ustorervvm4hirvvm2qi */

    case 762:
      if (!
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5448; /* pred_indexed_ustorervvm8sirvvm2qi */

    case 763:
      if (!(
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 853 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5450; /* pred_indexed_ustorervvm4bfrvvm2qi */

    case 764:
      if (!(
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 854 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5452; /* pred_indexed_ustorervvm4hfrvvm2qi */

    case 765:
      if (!(
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 855 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5454; /* pred_indexed_ustorervvm8sfrvvm2qi */

    case 766:
      if (!
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24502; /* pred_indexed_ustorervvm2x2qirvvm2qi */

    case 767:
      if (!
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24508; /* pred_indexed_ustorervvm2x3qirvvm2qi */

    case 768:
      if (!
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24514; /* pred_indexed_ustorervvm2x4qirvvm2qi */

    case 769:
      if (!
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24520; /* pred_indexed_ustorervvm4x2hirvvm2qi */

    case 770:
      if (!(
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24526; /* pred_indexed_ustorervvm4x2bfrvvm2qi */

    case 771:
      if (!(
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24532; /* pred_indexed_ustorervvm4x2hfrvvm2qi */

    case 772:
      if (!
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5456; /* pred_indexed_ustorervvm2qirvvm4hi */

    case 773:
      if (!
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5458; /* pred_indexed_ustorervvm4hirvvm4hi */

    case 774:
      if (!
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5460; /* pred_indexed_ustorervvm8sirvvm4hi */

    case 775:
      if (!(
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 853 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5462; /* pred_indexed_ustorervvm4bfrvvm4hi */

    case 776:
      if (!(
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 854 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5464; /* pred_indexed_ustorervvm4hfrvvm4hi */

    case 777:
      if (!(
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 855 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5466; /* pred_indexed_ustorervvm8sfrvvm4hi */

    case 778:
      if (!
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24504; /* pred_indexed_ustorervvm2x2qirvvm4hi */

    case 779:
      if (!
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24510; /* pred_indexed_ustorervvm2x3qirvvm4hi */

    case 780:
      if (!
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24516; /* pred_indexed_ustorervvm2x4qirvvm4hi */

    case 781:
      if (!
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24522; /* pred_indexed_ustorervvm4x2hirvvm4hi */

    case 782:
      if (!(
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24528; /* pred_indexed_ustorervvm4x2bfrvvm4hi */

    case 783:
      if (!(
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24534; /* pred_indexed_ustorervvm4x2hfrvvm4hi */

    case 784:
      if (!
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5468; /* pred_indexed_ustorervvm2qirvvm8si */

    case 785:
      if (!
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5470; /* pred_indexed_ustorervvm4hirvvm8si */

    case 786:
      if (!
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5472; /* pred_indexed_ustorervvm8sirvvm8si */

    case 787:
      if (!(
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 853 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5474; /* pred_indexed_ustorervvm4bfrvvm8si */

    case 788:
      if (!(
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 854 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5476; /* pred_indexed_ustorervvm4hfrvvm8si */

    case 789:
      if (!(
#line 2656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 855 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5478; /* pred_indexed_ustorervvm8sfrvvm8si */

    case 790:
      if (!
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24506; /* pred_indexed_ustorervvm2x2qirvvm8si */

    case 791:
      if (!
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24512; /* pred_indexed_ustorervvm2x3qirvvm8si */

    case 792:
      if (!
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24518; /* pred_indexed_ustorervvm2x4qirvvm8si */

    case 793:
      if (!
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24524; /* pred_indexed_ustorervvm4x2hirvvm8si */

    case 794:
      if (!(
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 24530; /* pred_indexed_ustorervvm4x2bfrvvm8si */

    case 795:
      if (!(
#line 8667 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 24536; /* pred_indexed_ustorervvm4x2hfrvvm8si */

    case 796:
      if (!
#line 2673 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5480; /* pred_indexed_ustorervvm4qirvvm4qi */

    case 797:
      if (!
#line 2673 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5482; /* pred_indexed_ustorervvm8hirvvm4qi */

    case 798:
      if (!(
#line 2673 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 861 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5484; /* pred_indexed_ustorervvm8bfrvvm4qi */

    case 799:
      if (!(
#line 2673 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 862 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5486; /* pred_indexed_ustorervvm8hfrvvm4qi */

    case 800:
      if (!
#line 8684 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24538; /* pred_indexed_ustorervvm4x2qirvvm4qi */

    case 801:
      if (!
#line 2673 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5488; /* pred_indexed_ustorervvm4qirvvm8hi */

    case 802:
      if (!
#line 2673 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5490; /* pred_indexed_ustorervvm8hirvvm8hi */

    case 803:
      if (!(
#line 2673 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 861 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5492; /* pred_indexed_ustorervvm8bfrvvm8hi */

    case 804:
      if (!(
#line 2673 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 862 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5494; /* pred_indexed_ustorervvm8hfrvvm8hi */

    case 805:
      if (!
#line 8684 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 24540; /* pred_indexed_ustorervvm4x2qirvvm8hi */

    case 806:
      if (!
#line 2690 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5496; /* pred_indexed_ustorervvm8qirvvm8qi */

    default:
      return -1;
    }
}

 int
recog_443 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V4HFmode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4HFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 4322; /* *pred_broadcastv4hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4HFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4444; /* *pred_broadcastv4hf_imm */
}

 int
recog_448 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128DImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 4317; /* *pred_broadcastv128di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128DImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4439; /* *pred_broadcastv128di_imm */
}

 int
recog_453 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4DImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 4312; /* *pred_broadcastv4di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4DImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 4434; /* *pred_broadcastv4di_imm */
}

 int
recog_459 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V128SImode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128SImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return 4306; /* *pred_broadcastv128si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128SImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4428; /* *pred_broadcastv128si_imm */
}

 int
recog_465 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2BImode)
      && vector_const_0_operand (operands[3], E_V2SImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 4300; /* *pred_broadcastv2si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2SImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 4422; /* *pred_broadcastv2si_imm */
}

 int
recog_471 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V128HImode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128HImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return 4294; /* *pred_broadcastv128hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128HImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4416; /* *pred_broadcastv128hi_imm */
}

 int
recog_478 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1HImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 4287; /* *pred_broadcastv1hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1HImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 4409; /* *pred_broadcastv1hi_imm */
}

 int
recog_485 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64QImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 4280; /* *pred_broadcastv64qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64QImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4402; /* *pred_broadcastv64qi_imm */
}

 int
recog_493 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
      && vector_const_0_operand (operands[3], E_RVVM2DFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 4272; /* *pred_broadcastrvvm2df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2DFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4394; /* *pred_broadcastrvvm2df_imm */
}

 int
recog_501 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
      && vector_const_0_operand (operands[3], E_RVVMF4HFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
    return 4264; /* *pred_broadcastrvvmf4hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF4HFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 4386; /* *pred_broadcastrvvmf4hf_imm */
}

 int
recog_509 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern664 (x2))
    {
    case 0:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4719; /* pred_indexed_oloadrvvm8qi_same_eew */

    case 1:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4721; /* pred_indexed_oloadrvvm4qi_same_eew */

    case 2:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5087; /* pred_indexed_oloadrvvm4qi_x2_smaller_eew */

    case 3:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4723; /* pred_indexed_oloadrvvm2qi_same_eew */

    case 4:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5089; /* pred_indexed_oloadrvvm2qi_x2_smaller_eew */

    case 5:
      if (!
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5145; /* pred_indexed_oloadrvvm2qi_x4_smaller_eew */

    case 6:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4725; /* pred_indexed_oloadrvvm1qi_same_eew */

    case 7:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5091; /* pred_indexed_oloadrvvm1qi_x2_smaller_eew */

    case 8:
      if (!
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5147; /* pred_indexed_oloadrvvm1qi_x4_smaller_eew */

    case 9:
      if (!(
#line 2571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 395 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5179; /* pred_indexed_oloadrvvm1qi_x8_smaller_eew */

    case 10:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4727; /* pred_indexed_oloadrvvmf2qi_same_eew */

    case 11:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5093; /* pred_indexed_oloadrvvmf2qi_x2_smaller_eew */

    case 12:
      if (!
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5149; /* pred_indexed_oloadrvvmf2qi_x4_smaller_eew */

    case 13:
      if (!(
#line 2571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 396 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5181; /* pred_indexed_oloadrvvmf2qi_x8_smaller_eew */

    case 14:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4729; /* pred_indexed_oloadrvvmf4qi_same_eew */

    case 15:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5095; /* pred_indexed_oloadrvvmf4qi_x2_smaller_eew */

    case 16:
      if (!
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5151; /* pred_indexed_oloadrvvmf4qi_x4_smaller_eew */

    case 17:
      if (!(
#line 2571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 397 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5183; /* pred_indexed_oloadrvvmf4qi_x8_smaller_eew */

    case 18:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1542 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4731; /* pred_indexed_oloadrvvmf8qi_same_eew */

    case 19:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 352 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5097; /* pred_indexed_oloadrvvmf8qi_x2_smaller_eew */

    case 20:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 376 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5153; /* pred_indexed_oloadrvvmf8qi_x4_smaller_eew */

    case 21:
      if (!(
#line 2571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 398 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5185; /* pred_indexed_oloadrvvmf8qi_x8_smaller_eew */

    case 22:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4733; /* pred_indexed_oloadrvvm8hi_same_eew */

    case 23:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4963; /* pred_indexed_oloadrvvm8hi_x2_greater_eew */

    case 24:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4735; /* pred_indexed_oloadrvvm4hi_same_eew */

    case 25:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4965; /* pred_indexed_oloadrvvm4hi_x2_greater_eew */

    case 26:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5099; /* pred_indexed_oloadrvvm4hi_x2_smaller_eew */

    case 27:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4737; /* pred_indexed_oloadrvvm2hi_same_eew */

    case 28:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4967; /* pred_indexed_oloadrvvm2hi_x2_greater_eew */

    case 29:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5101; /* pred_indexed_oloadrvvm2hi_x2_smaller_eew */

    case 30:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 378 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5155; /* pred_indexed_oloadrvvm2hi_x4_smaller_eew */

    case 31:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4739; /* pred_indexed_oloadrvvm1hi_same_eew */

    case 32:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4969; /* pred_indexed_oloadrvvm1hi_x2_greater_eew */

    case 33:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5103; /* pred_indexed_oloadrvvm1hi_x2_smaller_eew */

    case 34:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 379 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5157; /* pred_indexed_oloadrvvm1hi_x4_smaller_eew */

    case 35:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4741; /* pred_indexed_oloadrvvmf2hi_same_eew */

    case 36:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4971; /* pred_indexed_oloadrvvmf2hi_x2_greater_eew */

    case 37:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5105; /* pred_indexed_oloadrvvmf2hi_x2_smaller_eew */

    case 38:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 380 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5159; /* pred_indexed_oloadrvvmf2hi_x4_smaller_eew */

    case 39:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1544 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4743; /* pred_indexed_oloadrvvmf4hi_same_eew */

    case 40:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4973; /* pred_indexed_oloadrvvmf4hi_x2_greater_eew */

    case 41:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 354 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5107; /* pred_indexed_oloadrvvmf4hi_x2_smaller_eew */

    case 42:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 381 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5161; /* pred_indexed_oloadrvvmf4hi_x4_smaller_eew */

    case 43:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4745; /* pred_indexed_oloadrvvm8si_same_eew */

    case 44:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4999; /* pred_indexed_oloadrvvm8si_x2_greater_eew */

    case 45:
      if (!
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5035; /* pred_indexed_oloadrvvm8si_x4_greater_eew */

    case 46:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4747; /* pred_indexed_oloadrvvm4si_same_eew */

    case 47:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5001; /* pred_indexed_oloadrvvm4si_x2_greater_eew */

    case 48:
      if (!
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5037; /* pred_indexed_oloadrvvm4si_x4_greater_eew */

    case 49:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 364 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5129; /* pred_indexed_oloadrvvm4si_x2_smaller_eew */

    case 50:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4749; /* pred_indexed_oloadrvvm2si_same_eew */

    case 51:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5003; /* pred_indexed_oloadrvvm2si_x2_greater_eew */

    case 52:
      if (!
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5039; /* pred_indexed_oloadrvvm2si_x4_greater_eew */

    case 53:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 365 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5131; /* pred_indexed_oloadrvvm2si_x2_smaller_eew */

    case 54:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4751; /* pred_indexed_oloadrvvm1si_same_eew */

    case 55:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5005; /* pred_indexed_oloadrvvm1si_x2_greater_eew */

    case 56:
      if (!
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5041; /* pred_indexed_oloadrvvm1si_x4_greater_eew */

    case 57:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 366 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5133; /* pred_indexed_oloadrvvm1si_x2_smaller_eew */

    case 58:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1546 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4753; /* pred_indexed_oloadrvvmf2si_same_eew */

    case 59:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 318 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5007; /* pred_indexed_oloadrvvmf2si_x2_greater_eew */

    case 60:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5043; /* pred_indexed_oloadrvvmf2si_x4_greater_eew */

    case 61:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 367 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5135; /* pred_indexed_oloadrvvmf2si_x2_smaller_eew */

    case 62:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1548 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4755; /* pred_indexed_oloadrvvm8di_same_eew */

    case 63:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 323 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5019; /* pred_indexed_oloadrvvm8di_x2_greater_eew */

    case 64:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 336 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5055; /* pred_indexed_oloadrvvm8di_x4_greater_eew */

    case 65:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 344 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5071; /* pred_indexed_oloadrvvm8di_x8_greater_eew */

    case 66:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1549 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4757; /* pred_indexed_oloadrvvm4di_same_eew */

    case 67:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 323 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5021; /* pred_indexed_oloadrvvm4di_x2_greater_eew */

    case 68:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 336 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5057; /* pred_indexed_oloadrvvm4di_x4_greater_eew */

    case 69:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 344 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5073; /* pred_indexed_oloadrvvm4di_x8_greater_eew */

    case 70:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1550 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4759; /* pred_indexed_oloadrvvm2di_same_eew */

    case 71:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 324 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5023; /* pred_indexed_oloadrvvm2di_x2_greater_eew */

    case 72:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 337 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5059; /* pred_indexed_oloadrvvm2di_x4_greater_eew */

    case 73:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 345 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5075; /* pred_indexed_oloadrvvm2di_x8_greater_eew */

    case 74:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1551 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4761; /* pred_indexed_oloadrvvm1di_same_eew */

    case 75:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 324 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5025; /* pred_indexed_oloadrvvm1di_x2_greater_eew */

    case 76:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 337 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5061; /* pred_indexed_oloadrvvm1di_x4_greater_eew */

    case 77:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 345 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5077; /* pred_indexed_oloadrvvm1di_x8_greater_eew */

    case 78:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1553 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4763; /* pred_indexed_oloadrvvm8bf_same_eew */

    case 79:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4975; /* pred_indexed_oloadrvvm8bf_x2_greater_eew */

    case 80:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1554 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4765; /* pred_indexed_oloadrvvm4bf_same_eew */

    case 81:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4977; /* pred_indexed_oloadrvvm4bf_x2_greater_eew */

    case 82:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 356 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5109; /* pred_indexed_oloadrvvm4bf_x2_smaller_eew */

    case 83:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1555 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4767; /* pred_indexed_oloadrvvm2bf_same_eew */

    case 84:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4979; /* pred_indexed_oloadrvvm2bf_x2_greater_eew */

    case 85:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 356 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5111; /* pred_indexed_oloadrvvm2bf_x2_smaller_eew */

    case 86:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 383 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5163; /* pred_indexed_oloadrvvm2bf_x4_smaller_eew */

    case 87:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1556 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4769; /* pred_indexed_oloadrvvm1bf_same_eew */

    case 88:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4981; /* pred_indexed_oloadrvvm1bf_x2_greater_eew */

    case 89:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 357 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5113; /* pred_indexed_oloadrvvm1bf_x2_smaller_eew */

    case 90:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 384 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5165; /* pred_indexed_oloadrvvm1bf_x4_smaller_eew */

    case 91:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1557 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4771; /* pred_indexed_oloadrvvmf2bf_same_eew */

    case 92:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4983; /* pred_indexed_oloadrvvmf2bf_x2_greater_eew */

    case 93:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 357 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5115; /* pred_indexed_oloadrvvmf2bf_x2_smaller_eew */

    case 94:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 385 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5167; /* pred_indexed_oloadrvvmf2bf_x4_smaller_eew */

    case 95:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1558 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4773; /* pred_indexed_oloadrvvmf4bf_same_eew */

    case 96:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4985; /* pred_indexed_oloadrvvmf4bf_x2_greater_eew */

    case 97:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 358 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5117; /* pred_indexed_oloadrvvmf4bf_x2_smaller_eew */

    case 98:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 386 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5169; /* pred_indexed_oloadrvvmf4bf_x4_smaller_eew */

    case 99:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1560 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4775; /* pred_indexed_oloadrvvm8hf_same_eew */

    case 100:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4987; /* pred_indexed_oloadrvvm8hf_x2_greater_eew */

    case 101:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1560 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4777; /* pred_indexed_oloadrvvm4hf_same_eew */

    case 102:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4989; /* pred_indexed_oloadrvvm4hf_x2_greater_eew */

    case 103:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 360 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5119; /* pred_indexed_oloadrvvm4hf_x2_smaller_eew */

    case 104:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1560 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4779; /* pred_indexed_oloadrvvm2hf_same_eew */

    case 105:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4991; /* pred_indexed_oloadrvvm2hf_x2_greater_eew */

    case 106:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 360 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5121; /* pred_indexed_oloadrvvm2hf_x2_smaller_eew */

    case 107:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 388 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5171; /* pred_indexed_oloadrvvm2hf_x4_smaller_eew */

    case 108:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1561 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4781; /* pred_indexed_oloadrvvm1hf_same_eew */

    case 109:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4993; /* pred_indexed_oloadrvvm1hf_x2_greater_eew */

    case 110:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 361 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5123; /* pred_indexed_oloadrvvm1hf_x2_smaller_eew */

    case 111:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 389 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5173; /* pred_indexed_oloadrvvm1hf_x4_smaller_eew */

    case 112:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1561 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4783; /* pred_indexed_oloadrvvmf2hf_same_eew */

    case 113:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4995; /* pred_indexed_oloadrvvmf2hf_x2_greater_eew */

    case 114:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 361 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5125; /* pred_indexed_oloadrvvmf2hf_x2_smaller_eew */

    case 115:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 390 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5175; /* pred_indexed_oloadrvvmf2hf_x4_smaller_eew */

    case 116:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1562 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4785; /* pred_indexed_oloadrvvmf4hf_same_eew */

    case 117:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4997; /* pred_indexed_oloadrvvmf4hf_x2_greater_eew */

    case 118:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 362 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5127; /* pred_indexed_oloadrvvmf4hf_x2_smaller_eew */

    case 119:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 391 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5177; /* pred_indexed_oloadrvvmf4hf_x4_smaller_eew */

    case 120:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1564 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4787; /* pred_indexed_oloadrvvm8sf_same_eew */

    case 121:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5009; /* pred_indexed_oloadrvvm8sf_x2_greater_eew */

    case 122:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5045; /* pred_indexed_oloadrvvm8sf_x4_greater_eew */

    case 123:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1564 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4789; /* pred_indexed_oloadrvvm4sf_same_eew */

    case 124:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5011; /* pred_indexed_oloadrvvm4sf_x2_greater_eew */

    case 125:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5047; /* pred_indexed_oloadrvvm4sf_x4_greater_eew */

    case 126:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 369 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5137; /* pred_indexed_oloadrvvm4sf_x2_smaller_eew */

    case 127:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4791; /* pred_indexed_oloadrvvm2sf_same_eew */

    case 128:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5013; /* pred_indexed_oloadrvvm2sf_x2_greater_eew */

    case 129:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5049; /* pred_indexed_oloadrvvm2sf_x4_greater_eew */

    case 130:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 370 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5139; /* pred_indexed_oloadrvvm2sf_x2_smaller_eew */

    case 131:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4793; /* pred_indexed_oloadrvvm1sf_same_eew */

    case 132:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 321 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5015; /* pred_indexed_oloadrvvm1sf_x2_greater_eew */

    case 133:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 334 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5051; /* pred_indexed_oloadrvvm1sf_x4_greater_eew */

    case 134:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 371 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5141; /* pred_indexed_oloadrvvm1sf_x2_smaller_eew */

    case 135:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1566 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4795; /* pred_indexed_oloadrvvmf2sf_same_eew */

    case 136:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 321 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5017; /* pred_indexed_oloadrvvmf2sf_x2_greater_eew */

    case 137:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 334 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5053; /* pred_indexed_oloadrvvmf2sf_x4_greater_eew */

    case 138:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 372 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5143; /* pred_indexed_oloadrvvmf2sf_x2_smaller_eew */

    case 139:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1568 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4797; /* pred_indexed_oloadrvvm8df_same_eew */

    case 140:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 326 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5027; /* pred_indexed_oloadrvvm8df_x2_greater_eew */

    case 141:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 339 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5063; /* pred_indexed_oloadrvvm8df_x4_greater_eew */

    case 142:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 347 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5079; /* pred_indexed_oloadrvvm8df_x8_greater_eew */

    case 143:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4799; /* pred_indexed_oloadrvvm4df_same_eew */

    case 144:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 326 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5029; /* pred_indexed_oloadrvvm4df_x2_greater_eew */

    case 145:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 339 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5065; /* pred_indexed_oloadrvvm4df_x4_greater_eew */

    case 146:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 347 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5081; /* pred_indexed_oloadrvvm4df_x8_greater_eew */

    case 147:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1570 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4801; /* pred_indexed_oloadrvvm2df_same_eew */

    case 148:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5031; /* pred_indexed_oloadrvvm2df_x2_greater_eew */

    case 149:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 340 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5067; /* pred_indexed_oloadrvvm2df_x4_greater_eew */

    case 150:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 348 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5083; /* pred_indexed_oloadrvvm2df_x8_greater_eew */

    case 151:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1571 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4803; /* pred_indexed_oloadrvvm1df_same_eew */

    case 152:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5033; /* pred_indexed_oloadrvvm1df_x2_greater_eew */

    case 153:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 340 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5069; /* pred_indexed_oloadrvvm1df_x4_greater_eew */

    case 154:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 348 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5085; /* pred_indexed_oloadrvvm1df_x8_greater_eew */

    case 155:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 4805; /* pred_indexed_oloadv1qi_same_eew */

    case 156:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 4807; /* pred_indexed_oloadv2qi_same_eew */

    case 157:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 4809; /* pred_indexed_oloadv4qi_same_eew */

    case 158:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 4811; /* pred_indexed_oloadv8qi_same_eew */

    case 159:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 4813; /* pred_indexed_oloadv16qi_same_eew */

    case 160:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 4815; /* pred_indexed_oloadv32qi_same_eew */

    case 161:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4817; /* pred_indexed_oloadv64qi_same_eew */

    case 162:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4819; /* pred_indexed_oloadv128qi_same_eew */

    case 163:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4821; /* pred_indexed_oloadv256qi_same_eew */

    case 164:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4823; /* pred_indexed_oloadv512qi_same_eew */

    case 165:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4825; /* pred_indexed_oloadv1024qi_same_eew */

    case 166:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4827; /* pred_indexed_oloadv2048qi_same_eew */

    case 167:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4829; /* pred_indexed_oloadv4096qi_same_eew */

    case 168:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 4831; /* pred_indexed_oloadv1hi_same_eew */

    case 169:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 4833; /* pred_indexed_oloadv2hi_same_eew */

    case 170:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 4835; /* pred_indexed_oloadv4hi_same_eew */

    case 171:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 4837; /* pred_indexed_oloadv8hi_same_eew */

    case 172:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 4839; /* pred_indexed_oloadv16hi_same_eew */

    case 173:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4841; /* pred_indexed_oloadv32hi_same_eew */

    case 174:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4843; /* pred_indexed_oloadv64hi_same_eew */

    case 175:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4845; /* pred_indexed_oloadv128hi_same_eew */

    case 176:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4847; /* pred_indexed_oloadv256hi_same_eew */

    case 177:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4849; /* pred_indexed_oloadv512hi_same_eew */

    case 178:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4851; /* pred_indexed_oloadv1024hi_same_eew */

    case 179:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4853; /* pred_indexed_oloadv2048hi_same_eew */

    case 180:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 4855; /* pred_indexed_oloadv1si_same_eew */

    case 181:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 4857; /* pred_indexed_oloadv2si_same_eew */

    case 182:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 4859; /* pred_indexed_oloadv4si_same_eew */

    case 183:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 4861; /* pred_indexed_oloadv8si_same_eew */

    case 184:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4863; /* pred_indexed_oloadv16si_same_eew */

    case 185:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4865; /* pred_indexed_oloadv32si_same_eew */

    case 186:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4867; /* pred_indexed_oloadv64si_same_eew */

    case 187:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4869; /* pred_indexed_oloadv128si_same_eew */

    case 188:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4871; /* pred_indexed_oloadv256si_same_eew */

    case 189:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1607 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4873; /* pred_indexed_oloadv512si_same_eew */

    case 190:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1608 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4875; /* pred_indexed_oloadv1024si_same_eew */

    case 191:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1609 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4877; /* pred_indexed_oloadv1di_same_eew */

    case 192:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1610 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4879; /* pred_indexed_oloadv2di_same_eew */

    case 193:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1611 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4881; /* pred_indexed_oloadv4di_same_eew */

    case 194:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1612 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64 && TARGET_64BIT)))
        return -1;
      return 4883; /* pred_indexed_oloadv8di_same_eew */

    case 195:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1613 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128 && TARGET_64BIT)))
        return -1;
      return 4885; /* pred_indexed_oloadv16di_same_eew */

    case 196:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1614 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256 && TARGET_64BIT)))
        return -1;
      return 4887; /* pred_indexed_oloadv32di_same_eew */

    case 197:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1615 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512 && TARGET_64BIT)))
        return -1;
      return 4889; /* pred_indexed_oloadv64di_same_eew */

    case 198:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1616 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024 && TARGET_64BIT)))
        return -1;
      return 4891; /* pred_indexed_oloadv128di_same_eew */

    case 199:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1617 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048 && TARGET_64BIT)))
        return -1;
      return 4893; /* pred_indexed_oloadv256di_same_eew */

    case 200:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1618 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096 && TARGET_64BIT)))
        return -1;
      return 4895; /* pred_indexed_oloadv512di_same_eew */

    case 201:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1620 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 4897; /* pred_indexed_oloadv1hf_same_eew */

    case 202:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1621 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 4899; /* pred_indexed_oloadv2hf_same_eew */

    case 203:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1622 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 4901; /* pred_indexed_oloadv4hf_same_eew */

    case 204:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1623 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 4903; /* pred_indexed_oloadv8hf_same_eew */

    case 205:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1624 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 4905; /* pred_indexed_oloadv16hf_same_eew */

    case 206:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1625 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4907; /* pred_indexed_oloadv32hf_same_eew */

    case 207:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1626 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4909; /* pred_indexed_oloadv64hf_same_eew */

    case 208:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1627 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4911; /* pred_indexed_oloadv128hf_same_eew */

    case 209:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1628 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4913; /* pred_indexed_oloadv256hf_same_eew */

    case 210:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1629 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4915; /* pred_indexed_oloadv512hf_same_eew */

    case 211:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1630 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4917; /* pred_indexed_oloadv1024hf_same_eew */

    case 212:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1631 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4919; /* pred_indexed_oloadv2048hf_same_eew */

    case 213:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1632 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4921; /* pred_indexed_oloadv1sf_same_eew */

    case 214:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1633 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4923; /* pred_indexed_oloadv2sf_same_eew */

    case 215:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1634 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4925; /* pred_indexed_oloadv4sf_same_eew */

    case 216:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1635 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4927; /* pred_indexed_oloadv8sf_same_eew */

    case 217:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1636 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4929; /* pred_indexed_oloadv16sf_same_eew */

    case 218:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1637 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4931; /* pred_indexed_oloadv32sf_same_eew */

    case 219:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1638 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4933; /* pred_indexed_oloadv64sf_same_eew */

    case 220:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1639 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4935; /* pred_indexed_oloadv128sf_same_eew */

    case 221:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1640 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4937; /* pred_indexed_oloadv256sf_same_eew */

    case 222:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1641 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4939; /* pred_indexed_oloadv512sf_same_eew */

    case 223:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1642 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4941; /* pred_indexed_oloadv1024sf_same_eew */

    case 224:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1643 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4943; /* pred_indexed_oloadv1df_same_eew */

    case 225:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1644 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4945; /* pred_indexed_oloadv2df_same_eew */

    case 226:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1645 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4947; /* pred_indexed_oloadv4df_same_eew */

    case 227:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1646 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64 && TARGET_64BIT)))
        return -1;
      return 4949; /* pred_indexed_oloadv8df_same_eew */

    case 228:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1647 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128 && TARGET_64BIT)))
        return -1;
      return 4951; /* pred_indexed_oloadv16df_same_eew */

    case 229:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1648 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256 && TARGET_64BIT)))
        return -1;
      return 4953; /* pred_indexed_oloadv32df_same_eew */

    case 230:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1649 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512 && TARGET_64BIT)))
        return -1;
      return 4955; /* pred_indexed_oloadv64df_same_eew */

    case 231:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1650 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024 && TARGET_64BIT)))
        return -1;
      return 4957; /* pred_indexed_oloadv128df_same_eew */

    case 232:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1651 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048 && TARGET_64BIT)))
        return -1;
      return 4959; /* pred_indexed_oloadv256df_same_eew */

    case 233:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1652 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096 && TARGET_64BIT)))
        return -1;
      return 4961; /* pred_indexed_oloadv512df_same_eew */

    case 234:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21933; /* pred_indexed_oloadrvvmf8x2qirvvmf8qi */

    case 235:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21935; /* pred_indexed_oloadrvvmf8x2qirvvmf4hi */

    case 236:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21937; /* pred_indexed_oloadrvvmf8x2qirvvmf2si */

    case 237:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21939; /* pred_indexed_oloadrvvmf8x2qirvvm1di */

    case 238:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21941; /* pred_indexed_oloadrvvmf8x3qirvvmf8qi */

    case 239:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21943; /* pred_indexed_oloadrvvmf8x3qirvvmf4hi */

    case 240:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21945; /* pred_indexed_oloadrvvmf8x3qirvvmf2si */

    case 241:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21947; /* pred_indexed_oloadrvvmf8x3qirvvm1di */

    case 242:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21949; /* pred_indexed_oloadrvvmf8x4qirvvmf8qi */

    case 243:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21951; /* pred_indexed_oloadrvvmf8x4qirvvmf4hi */

    case 244:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21953; /* pred_indexed_oloadrvvmf8x4qirvvmf2si */

    case 245:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21955; /* pred_indexed_oloadrvvmf8x4qirvvm1di */

    case 246:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21957; /* pred_indexed_oloadrvvmf8x5qirvvmf8qi */

    case 247:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21959; /* pred_indexed_oloadrvvmf8x5qirvvmf4hi */

    case 248:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21961; /* pred_indexed_oloadrvvmf8x5qirvvmf2si */

    case 249:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21963; /* pred_indexed_oloadrvvmf8x5qirvvm1di */

    case 250:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21965; /* pred_indexed_oloadrvvmf8x6qirvvmf8qi */

    case 251:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21967; /* pred_indexed_oloadrvvmf8x6qirvvmf4hi */

    case 252:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21969; /* pred_indexed_oloadrvvmf8x6qirvvmf2si */

    case 253:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21971; /* pred_indexed_oloadrvvmf8x6qirvvm1di */

    case 254:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21973; /* pred_indexed_oloadrvvmf8x7qirvvmf8qi */

    case 255:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21975; /* pred_indexed_oloadrvvmf8x7qirvvmf4hi */

    case 256:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21977; /* pred_indexed_oloadrvvmf8x7qirvvmf2si */

    case 257:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21979; /* pred_indexed_oloadrvvmf8x7qirvvm1di */

    case 258:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21981; /* pred_indexed_oloadrvvmf8x8qirvvmf8qi */

    case 259:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21983; /* pred_indexed_oloadrvvmf8x8qirvvmf4hi */

    case 260:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21985; /* pred_indexed_oloadrvvmf8x8qirvvmf2si */

    case 261:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21987; /* pred_indexed_oloadrvvmf8x8qirvvm1di */

    case 262:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21989; /* pred_indexed_oloadrvvmf4x2hirvvmf8qi */

    case 263:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21991; /* pred_indexed_oloadrvvmf4x2hirvvmf4hi */

    case 264:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21993; /* pred_indexed_oloadrvvmf4x2hirvvmf2si */

    case 265:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21995; /* pred_indexed_oloadrvvmf4x2hirvvm1di */

    case 266:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21997; /* pred_indexed_oloadrvvmf4x3hirvvmf8qi */

    case 267:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21999; /* pred_indexed_oloadrvvmf4x3hirvvmf4hi */

    case 268:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22001; /* pred_indexed_oloadrvvmf4x3hirvvmf2si */

    case 269:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22003; /* pred_indexed_oloadrvvmf4x3hirvvm1di */

    case 270:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22005; /* pred_indexed_oloadrvvmf4x4hirvvmf8qi */

    case 271:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22007; /* pred_indexed_oloadrvvmf4x4hirvvmf4hi */

    case 272:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22009; /* pred_indexed_oloadrvvmf4x4hirvvmf2si */

    case 273:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22011; /* pred_indexed_oloadrvvmf4x4hirvvm1di */

    case 274:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22013; /* pred_indexed_oloadrvvmf4x5hirvvmf8qi */

    case 275:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22015; /* pred_indexed_oloadrvvmf4x5hirvvmf4hi */

    case 276:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22017; /* pred_indexed_oloadrvvmf4x5hirvvmf2si */

    case 277:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22019; /* pred_indexed_oloadrvvmf4x5hirvvm1di */

    case 278:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22021; /* pred_indexed_oloadrvvmf4x6hirvvmf8qi */

    case 279:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22023; /* pred_indexed_oloadrvvmf4x6hirvvmf4hi */

    case 280:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22025; /* pred_indexed_oloadrvvmf4x6hirvvmf2si */

    case 281:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22027; /* pred_indexed_oloadrvvmf4x6hirvvm1di */

    case 282:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22029; /* pred_indexed_oloadrvvmf4x7hirvvmf8qi */

    case 283:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22031; /* pred_indexed_oloadrvvmf4x7hirvvmf4hi */

    case 284:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22033; /* pred_indexed_oloadrvvmf4x7hirvvmf2si */

    case 285:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22035; /* pred_indexed_oloadrvvmf4x7hirvvm1di */

    case 286:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22037; /* pred_indexed_oloadrvvmf4x8hirvvmf8qi */

    case 287:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22039; /* pred_indexed_oloadrvvmf4x8hirvvmf4hi */

    case 288:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22041; /* pred_indexed_oloadrvvmf4x8hirvvmf2si */

    case 289:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22043; /* pred_indexed_oloadrvvmf4x8hirvvm1di */

    case 290:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22045; /* pred_indexed_oloadrvvmf2x2sirvvmf8qi */

    case 291:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22047; /* pred_indexed_oloadrvvmf2x2sirvvmf4hi */

    case 292:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22049; /* pred_indexed_oloadrvvmf2x2sirvvmf2si */

    case 293:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22051; /* pred_indexed_oloadrvvmf2x2sirvvm1di */

    case 294:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22053; /* pred_indexed_oloadrvvmf2x3sirvvmf8qi */

    case 295:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22055; /* pred_indexed_oloadrvvmf2x3sirvvmf4hi */

    case 296:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22057; /* pred_indexed_oloadrvvmf2x3sirvvmf2si */

    case 297:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22059; /* pred_indexed_oloadrvvmf2x3sirvvm1di */

    case 298:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22061; /* pred_indexed_oloadrvvmf2x4sirvvmf8qi */

    case 299:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22063; /* pred_indexed_oloadrvvmf2x4sirvvmf4hi */

    case 300:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22065; /* pred_indexed_oloadrvvmf2x4sirvvmf2si */

    case 301:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22067; /* pred_indexed_oloadrvvmf2x4sirvvm1di */

    case 302:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22069; /* pred_indexed_oloadrvvmf2x5sirvvmf8qi */

    case 303:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22071; /* pred_indexed_oloadrvvmf2x5sirvvmf4hi */

    case 304:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22073; /* pred_indexed_oloadrvvmf2x5sirvvmf2si */

    case 305:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22075; /* pred_indexed_oloadrvvmf2x5sirvvm1di */

    case 306:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22077; /* pred_indexed_oloadrvvmf2x6sirvvmf8qi */

    case 307:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22079; /* pred_indexed_oloadrvvmf2x6sirvvmf4hi */

    case 308:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22081; /* pred_indexed_oloadrvvmf2x6sirvvmf2si */

    case 309:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22083; /* pred_indexed_oloadrvvmf2x6sirvvm1di */

    case 310:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22085; /* pred_indexed_oloadrvvmf2x7sirvvmf8qi */

    case 311:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22087; /* pred_indexed_oloadrvvmf2x7sirvvmf4hi */

    case 312:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22089; /* pred_indexed_oloadrvvmf2x7sirvvmf2si */

    case 313:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22091; /* pred_indexed_oloadrvvmf2x7sirvvm1di */

    case 314:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22093; /* pred_indexed_oloadrvvmf2x8sirvvmf8qi */

    case 315:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22095; /* pred_indexed_oloadrvvmf2x8sirvvmf4hi */

    case 316:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 22097; /* pred_indexed_oloadrvvmf2x8sirvvmf2si */

    case 317:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 22099; /* pred_indexed_oloadrvvmf2x8sirvvm1di */

    case 318:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22101; /* pred_indexed_oloadrvvm1x2dirvvmf8qi */

    case 319:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22103; /* pred_indexed_oloadrvvm1x2dirvvmf4hi */

    case 320:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22105; /* pred_indexed_oloadrvvm1x2dirvvmf2si */

    case 321:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22107; /* pred_indexed_oloadrvvm1x2dirvvm1di */

    case 322:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22109; /* pred_indexed_oloadrvvm1x3dirvvmf8qi */

    case 323:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22111; /* pred_indexed_oloadrvvm1x3dirvvmf4hi */

    case 324:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22113; /* pred_indexed_oloadrvvm1x3dirvvmf2si */

    case 325:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22115; /* pred_indexed_oloadrvvm1x3dirvvm1di */

    case 326:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22117; /* pred_indexed_oloadrvvm1x4dirvvmf8qi */

    case 327:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22119; /* pred_indexed_oloadrvvm1x4dirvvmf4hi */

    case 328:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22121; /* pred_indexed_oloadrvvm1x4dirvvmf2si */

    case 329:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22123; /* pred_indexed_oloadrvvm1x4dirvvm1di */

    case 330:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22125; /* pred_indexed_oloadrvvm1x5dirvvmf8qi */

    case 331:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22127; /* pred_indexed_oloadrvvm1x5dirvvmf4hi */

    case 332:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22129; /* pred_indexed_oloadrvvm1x5dirvvmf2si */

    case 333:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22131; /* pred_indexed_oloadrvvm1x5dirvvm1di */

    case 334:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22133; /* pred_indexed_oloadrvvm1x6dirvvmf8qi */

    case 335:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22135; /* pred_indexed_oloadrvvm1x6dirvvmf4hi */

    case 336:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22137; /* pred_indexed_oloadrvvm1x6dirvvmf2si */

    case 337:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22139; /* pred_indexed_oloadrvvm1x6dirvvm1di */

    case 338:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22141; /* pred_indexed_oloadrvvm1x7dirvvmf8qi */

    case 339:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22143; /* pred_indexed_oloadrvvm1x7dirvvmf4hi */

    case 340:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22145; /* pred_indexed_oloadrvvm1x7dirvvmf2si */

    case 341:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22147; /* pred_indexed_oloadrvvm1x7dirvvm1di */

    case 342:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22149; /* pred_indexed_oloadrvvm1x8dirvvmf8qi */

    case 343:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22151; /* pred_indexed_oloadrvvm1x8dirvvmf4hi */

    case 344:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22153; /* pred_indexed_oloadrvvm1x8dirvvmf2si */

    case 345:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22155; /* pred_indexed_oloadrvvm1x8dirvvm1di */

    case 346:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22157; /* pred_indexed_oloadrvvmf4x2bfrvvmf8qi */

    case 347:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22159; /* pred_indexed_oloadrvvmf4x2bfrvvmf4hi */

    case 348:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22161; /* pred_indexed_oloadrvvmf4x2bfrvvmf2si */

    case 349:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22163; /* pred_indexed_oloadrvvmf4x2bfrvvm1di */

    case 350:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22165; /* pred_indexed_oloadrvvmf4x3bfrvvmf8qi */

    case 351:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22167; /* pred_indexed_oloadrvvmf4x3bfrvvmf4hi */

    case 352:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22169; /* pred_indexed_oloadrvvmf4x3bfrvvmf2si */

    case 353:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22171; /* pred_indexed_oloadrvvmf4x3bfrvvm1di */

    case 354:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22173; /* pred_indexed_oloadrvvmf4x4bfrvvmf8qi */

    case 355:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22175; /* pred_indexed_oloadrvvmf4x4bfrvvmf4hi */

    case 356:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22177; /* pred_indexed_oloadrvvmf4x4bfrvvmf2si */

    case 357:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22179; /* pred_indexed_oloadrvvmf4x4bfrvvm1di */

    case 358:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22181; /* pred_indexed_oloadrvvmf4x5bfrvvmf8qi */

    case 359:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22183; /* pred_indexed_oloadrvvmf4x5bfrvvmf4hi */

    case 360:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22185; /* pred_indexed_oloadrvvmf4x5bfrvvmf2si */

    case 361:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22187; /* pred_indexed_oloadrvvmf4x5bfrvvm1di */

    case 362:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22189; /* pred_indexed_oloadrvvmf4x6bfrvvmf8qi */

    case 363:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22191; /* pred_indexed_oloadrvvmf4x6bfrvvmf4hi */

    case 364:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22193; /* pred_indexed_oloadrvvmf4x6bfrvvmf2si */

    case 365:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22195; /* pred_indexed_oloadrvvmf4x6bfrvvm1di */

    case 366:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22197; /* pred_indexed_oloadrvvmf4x7bfrvvmf8qi */

    case 367:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22199; /* pred_indexed_oloadrvvmf4x7bfrvvmf4hi */

    case 368:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22201; /* pred_indexed_oloadrvvmf4x7bfrvvmf2si */

    case 369:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22203; /* pred_indexed_oloadrvvmf4x7bfrvvm1di */

    case 370:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22205; /* pred_indexed_oloadrvvmf4x8bfrvvmf8qi */

    case 371:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22207; /* pred_indexed_oloadrvvmf4x8bfrvvmf4hi */

    case 372:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22209; /* pred_indexed_oloadrvvmf4x8bfrvvmf2si */

    case 373:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22211; /* pred_indexed_oloadrvvmf4x8bfrvvm1di */

    case 374:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22213; /* pred_indexed_oloadrvvmf4x2hfrvvmf8qi */

    case 375:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22215; /* pred_indexed_oloadrvvmf4x2hfrvvmf4hi */

    case 376:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22217; /* pred_indexed_oloadrvvmf4x2hfrvvmf2si */

    case 377:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22219; /* pred_indexed_oloadrvvmf4x2hfrvvm1di */

    case 378:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22221; /* pred_indexed_oloadrvvmf4x3hfrvvmf8qi */

    case 379:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22223; /* pred_indexed_oloadrvvmf4x3hfrvvmf4hi */

    case 380:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22225; /* pred_indexed_oloadrvvmf4x3hfrvvmf2si */

    case 381:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22227; /* pred_indexed_oloadrvvmf4x3hfrvvm1di */

    case 382:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22229; /* pred_indexed_oloadrvvmf4x4hfrvvmf8qi */

    case 383:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22231; /* pred_indexed_oloadrvvmf4x4hfrvvmf4hi */

    case 384:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22233; /* pred_indexed_oloadrvvmf4x4hfrvvmf2si */

    case 385:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22235; /* pred_indexed_oloadrvvmf4x4hfrvvm1di */

    case 386:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22237; /* pred_indexed_oloadrvvmf4x5hfrvvmf8qi */

    case 387:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22239; /* pred_indexed_oloadrvvmf4x5hfrvvmf4hi */

    case 388:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22241; /* pred_indexed_oloadrvvmf4x5hfrvvmf2si */

    case 389:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22243; /* pred_indexed_oloadrvvmf4x5hfrvvm1di */

    case 390:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22245; /* pred_indexed_oloadrvvmf4x6hfrvvmf8qi */

    case 391:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22247; /* pred_indexed_oloadrvvmf4x6hfrvvmf4hi */

    case 392:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22249; /* pred_indexed_oloadrvvmf4x6hfrvvmf2si */

    case 393:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22251; /* pred_indexed_oloadrvvmf4x6hfrvvm1di */

    case 394:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22253; /* pred_indexed_oloadrvvmf4x7hfrvvmf8qi */

    case 395:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22255; /* pred_indexed_oloadrvvmf4x7hfrvvmf4hi */

    case 396:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22257; /* pred_indexed_oloadrvvmf4x7hfrvvmf2si */

    case 397:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22259; /* pred_indexed_oloadrvvmf4x7hfrvvm1di */

    case 398:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22261; /* pred_indexed_oloadrvvmf4x8hfrvvmf8qi */

    case 399:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22263; /* pred_indexed_oloadrvvmf4x8hfrvvmf4hi */

    case 400:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22265; /* pred_indexed_oloadrvvmf4x8hfrvvmf2si */

    case 401:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22267; /* pred_indexed_oloadrvvmf4x8hfrvvm1di */

    case 402:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22269; /* pred_indexed_oloadrvvmf2x2sfrvvmf8qi */

    case 403:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22271; /* pred_indexed_oloadrvvmf2x2sfrvvmf4hi */

    case 404:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22273; /* pred_indexed_oloadrvvmf2x2sfrvvmf2si */

    case 405:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22275; /* pred_indexed_oloadrvvmf2x2sfrvvm1di */

    case 406:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22277; /* pred_indexed_oloadrvvmf2x3sfrvvmf8qi */

    case 407:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22279; /* pred_indexed_oloadrvvmf2x3sfrvvmf4hi */

    case 408:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22281; /* pred_indexed_oloadrvvmf2x3sfrvvmf2si */

    case 409:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22283; /* pred_indexed_oloadrvvmf2x3sfrvvm1di */

    case 410:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22285; /* pred_indexed_oloadrvvmf2x4sfrvvmf8qi */

    case 411:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22287; /* pred_indexed_oloadrvvmf2x4sfrvvmf4hi */

    case 412:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22289; /* pred_indexed_oloadrvvmf2x4sfrvvmf2si */

    case 413:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22291; /* pred_indexed_oloadrvvmf2x4sfrvvm1di */

    case 414:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22293; /* pred_indexed_oloadrvvmf2x5sfrvvmf8qi */

    case 415:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22295; /* pred_indexed_oloadrvvmf2x5sfrvvmf4hi */

    case 416:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22297; /* pred_indexed_oloadrvvmf2x5sfrvvmf2si */

    case 417:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22299; /* pred_indexed_oloadrvvmf2x5sfrvvm1di */

    case 418:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22301; /* pred_indexed_oloadrvvmf2x6sfrvvmf8qi */

    case 419:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22303; /* pred_indexed_oloadrvvmf2x6sfrvvmf4hi */

    case 420:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22305; /* pred_indexed_oloadrvvmf2x6sfrvvmf2si */

    case 421:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22307; /* pred_indexed_oloadrvvmf2x6sfrvvm1di */

    case 422:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22309; /* pred_indexed_oloadrvvmf2x7sfrvvmf8qi */

    case 423:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22311; /* pred_indexed_oloadrvvmf2x7sfrvvmf4hi */

    case 424:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22313; /* pred_indexed_oloadrvvmf2x7sfrvvmf2si */

    case 425:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22315; /* pred_indexed_oloadrvvmf2x7sfrvvm1di */

    case 426:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22317; /* pred_indexed_oloadrvvmf2x8sfrvvmf8qi */

    case 427:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22319; /* pred_indexed_oloadrvvmf2x8sfrvvmf4hi */

    case 428:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22321; /* pred_indexed_oloadrvvmf2x8sfrvvmf2si */

    case 429:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22323; /* pred_indexed_oloadrvvmf2x8sfrvvm1di */

    case 430:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22325; /* pred_indexed_oloadrvvm1x2dfrvvmf8qi */

    case 431:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22327; /* pred_indexed_oloadrvvm1x2dfrvvmf4hi */

    case 432:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22329; /* pred_indexed_oloadrvvm1x2dfrvvmf2si */

    case 433:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22331; /* pred_indexed_oloadrvvm1x2dfrvvm1di */

    case 434:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22333; /* pred_indexed_oloadrvvm1x3dfrvvmf8qi */

    case 435:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22335; /* pred_indexed_oloadrvvm1x3dfrvvmf4hi */

    case 436:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22337; /* pred_indexed_oloadrvvm1x3dfrvvmf2si */

    case 437:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22339; /* pred_indexed_oloadrvvm1x3dfrvvm1di */

    case 438:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22341; /* pred_indexed_oloadrvvm1x4dfrvvmf8qi */

    case 439:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22343; /* pred_indexed_oloadrvvm1x4dfrvvmf4hi */

    case 440:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22345; /* pred_indexed_oloadrvvm1x4dfrvvmf2si */

    case 441:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22347; /* pred_indexed_oloadrvvm1x4dfrvvm1di */

    case 442:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22349; /* pred_indexed_oloadrvvm1x5dfrvvmf8qi */

    case 443:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22351; /* pred_indexed_oloadrvvm1x5dfrvvmf4hi */

    case 444:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22353; /* pred_indexed_oloadrvvm1x5dfrvvmf2si */

    case 445:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22355; /* pred_indexed_oloadrvvm1x5dfrvvm1di */

    case 446:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22357; /* pred_indexed_oloadrvvm1x6dfrvvmf8qi */

    case 447:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22359; /* pred_indexed_oloadrvvm1x6dfrvvmf4hi */

    case 448:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22361; /* pred_indexed_oloadrvvm1x6dfrvvmf2si */

    case 449:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22363; /* pred_indexed_oloadrvvm1x6dfrvvm1di */

    case 450:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22365; /* pred_indexed_oloadrvvm1x7dfrvvmf8qi */

    case 451:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22367; /* pred_indexed_oloadrvvm1x7dfrvvmf4hi */

    case 452:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22369; /* pred_indexed_oloadrvvm1x7dfrvvmf2si */

    case 453:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22371; /* pred_indexed_oloadrvvm1x7dfrvvm1di */

    case 454:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22373; /* pred_indexed_oloadrvvm1x8dfrvvmf8qi */

    case 455:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22375; /* pred_indexed_oloadrvvm1x8dfrvvmf4hi */

    case 456:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22377; /* pred_indexed_oloadrvvm1x8dfrvvmf2si */

    case 457:
      if (!(
#line 8477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22379; /* pred_indexed_oloadrvvm1x8dfrvvm1di */

    case 458:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22381; /* pred_indexed_oloadrvvmf4x2qirvvmf4qi */

    case 459:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22477; /* pred_indexed_oloadrvvmf4x2qirvvmf2hi */

    case 460:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22573; /* pred_indexed_oloadrvvmf4x2qirvvm1si */

    case 461:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22669; /* pred_indexed_oloadrvvmf4x2qirvvm2di */

    case 462:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22383; /* pred_indexed_oloadrvvmf4x3qirvvmf4qi */

    case 463:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22479; /* pred_indexed_oloadrvvmf4x3qirvvmf2hi */

    case 464:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22575; /* pred_indexed_oloadrvvmf4x3qirvvm1si */

    case 465:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22671; /* pred_indexed_oloadrvvmf4x3qirvvm2di */

    case 466:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22385; /* pred_indexed_oloadrvvmf4x4qirvvmf4qi */

    case 467:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22481; /* pred_indexed_oloadrvvmf4x4qirvvmf2hi */

    case 468:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22577; /* pred_indexed_oloadrvvmf4x4qirvvm1si */

    case 469:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22673; /* pred_indexed_oloadrvvmf4x4qirvvm2di */

    case 470:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22387; /* pred_indexed_oloadrvvmf4x5qirvvmf4qi */

    case 471:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22483; /* pred_indexed_oloadrvvmf4x5qirvvmf2hi */

    case 472:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22579; /* pred_indexed_oloadrvvmf4x5qirvvm1si */

    case 473:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22675; /* pred_indexed_oloadrvvmf4x5qirvvm2di */

    case 474:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22389; /* pred_indexed_oloadrvvmf4x6qirvvmf4qi */

    case 475:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22485; /* pred_indexed_oloadrvvmf4x6qirvvmf2hi */

    case 476:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22581; /* pred_indexed_oloadrvvmf4x6qirvvm1si */

    case 477:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22677; /* pred_indexed_oloadrvvmf4x6qirvvm2di */

    case 478:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22391; /* pred_indexed_oloadrvvmf4x7qirvvmf4qi */

    case 479:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22487; /* pred_indexed_oloadrvvmf4x7qirvvmf2hi */

    case 480:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22583; /* pred_indexed_oloadrvvmf4x7qirvvm1si */

    case 481:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22679; /* pred_indexed_oloadrvvmf4x7qirvvm2di */

    case 482:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22393; /* pred_indexed_oloadrvvmf4x8qirvvmf4qi */

    case 483:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22489; /* pred_indexed_oloadrvvmf4x8qirvvmf2hi */

    case 484:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22585; /* pred_indexed_oloadrvvmf4x8qirvvm1si */

    case 485:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22681; /* pred_indexed_oloadrvvmf4x8qirvvm2di */

    case 486:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22395; /* pred_indexed_oloadrvvmf2x2hirvvmf4qi */

    case 487:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22491; /* pred_indexed_oloadrvvmf2x2hirvvmf2hi */

    case 488:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22587; /* pred_indexed_oloadrvvmf2x2hirvvm1si */

    case 489:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22683; /* pred_indexed_oloadrvvmf2x2hirvvm2di */

    case 490:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22397; /* pred_indexed_oloadrvvmf2x3hirvvmf4qi */

    case 491:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22493; /* pred_indexed_oloadrvvmf2x3hirvvmf2hi */

    case 492:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22589; /* pred_indexed_oloadrvvmf2x3hirvvm1si */

    case 493:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22685; /* pred_indexed_oloadrvvmf2x3hirvvm2di */

    case 494:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22399; /* pred_indexed_oloadrvvmf2x4hirvvmf4qi */

    case 495:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22495; /* pred_indexed_oloadrvvmf2x4hirvvmf2hi */

    case 496:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22591; /* pred_indexed_oloadrvvmf2x4hirvvm1si */

    case 497:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22687; /* pred_indexed_oloadrvvmf2x4hirvvm2di */

    case 498:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22401; /* pred_indexed_oloadrvvmf2x5hirvvmf4qi */

    case 499:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22497; /* pred_indexed_oloadrvvmf2x5hirvvmf2hi */

    case 500:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22593; /* pred_indexed_oloadrvvmf2x5hirvvm1si */

    case 501:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22689; /* pred_indexed_oloadrvvmf2x5hirvvm2di */

    case 502:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22403; /* pred_indexed_oloadrvvmf2x6hirvvmf4qi */

    case 503:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22499; /* pred_indexed_oloadrvvmf2x6hirvvmf2hi */

    case 504:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22595; /* pred_indexed_oloadrvvmf2x6hirvvm1si */

    case 505:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22691; /* pred_indexed_oloadrvvmf2x6hirvvm2di */

    case 506:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22405; /* pred_indexed_oloadrvvmf2x7hirvvmf4qi */

    case 507:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22501; /* pred_indexed_oloadrvvmf2x7hirvvmf2hi */

    case 508:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22597; /* pred_indexed_oloadrvvmf2x7hirvvm1si */

    case 509:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22693; /* pred_indexed_oloadrvvmf2x7hirvvm2di */

    case 510:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22407; /* pred_indexed_oloadrvvmf2x8hirvvmf4qi */

    case 511:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22503; /* pred_indexed_oloadrvvmf2x8hirvvmf2hi */

    case 512:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22599; /* pred_indexed_oloadrvvmf2x8hirvvm1si */

    case 513:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22695; /* pred_indexed_oloadrvvmf2x8hirvvm2di */

    case 514:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22409; /* pred_indexed_oloadrvvm1x2sirvvmf4qi */

    case 515:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22505; /* pred_indexed_oloadrvvm1x2sirvvmf2hi */

    case 516:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22601; /* pred_indexed_oloadrvvm1x2sirvvm1si */

    case 517:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22697; /* pred_indexed_oloadrvvm1x2sirvvm2di */

    case 518:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22411; /* pred_indexed_oloadrvvm1x3sirvvmf4qi */

    case 519:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22507; /* pred_indexed_oloadrvvm1x3sirvvmf2hi */

    case 520:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22603; /* pred_indexed_oloadrvvm1x3sirvvm1si */

    case 521:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22699; /* pred_indexed_oloadrvvm1x3sirvvm2di */

    case 522:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22413; /* pred_indexed_oloadrvvm1x4sirvvmf4qi */

    case 523:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22509; /* pred_indexed_oloadrvvm1x4sirvvmf2hi */

    case 524:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22605; /* pred_indexed_oloadrvvm1x4sirvvm1si */

    case 525:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22701; /* pred_indexed_oloadrvvm1x4sirvvm2di */

    case 526:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22415; /* pred_indexed_oloadrvvm1x5sirvvmf4qi */

    case 527:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22511; /* pred_indexed_oloadrvvm1x5sirvvmf2hi */

    case 528:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22607; /* pred_indexed_oloadrvvm1x5sirvvm1si */

    case 529:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22703; /* pred_indexed_oloadrvvm1x5sirvvm2di */

    case 530:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22417; /* pred_indexed_oloadrvvm1x6sirvvmf4qi */

    case 531:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22513; /* pred_indexed_oloadrvvm1x6sirvvmf2hi */

    case 532:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22609; /* pred_indexed_oloadrvvm1x6sirvvm1si */

    case 533:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22705; /* pred_indexed_oloadrvvm1x6sirvvm2di */

    case 534:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22419; /* pred_indexed_oloadrvvm1x7sirvvmf4qi */

    case 535:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22515; /* pred_indexed_oloadrvvm1x7sirvvmf2hi */

    case 536:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22611; /* pred_indexed_oloadrvvm1x7sirvvm1si */

    case 537:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22707; /* pred_indexed_oloadrvvm1x7sirvvm2di */

    case 538:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22421; /* pred_indexed_oloadrvvm1x8sirvvmf4qi */

    case 539:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22517; /* pred_indexed_oloadrvvm1x8sirvvmf2hi */

    case 540:
      if (!
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22613; /* pred_indexed_oloadrvvm1x8sirvvm1si */

    case 541:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22709; /* pred_indexed_oloadrvvm1x8sirvvm2di */

    case 542:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22423; /* pred_indexed_oloadrvvm2x2dirvvmf4qi */

    case 543:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22519; /* pred_indexed_oloadrvvm2x2dirvvmf2hi */

    case 544:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22615; /* pred_indexed_oloadrvvm2x2dirvvm1si */

    case 545:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22711; /* pred_indexed_oloadrvvm2x2dirvvm2di */

    case 546:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22425; /* pred_indexed_oloadrvvm2x3dirvvmf4qi */

    case 547:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22521; /* pred_indexed_oloadrvvm2x3dirvvmf2hi */

    case 548:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22617; /* pred_indexed_oloadrvvm2x3dirvvm1si */

    case 549:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22713; /* pred_indexed_oloadrvvm2x3dirvvm2di */

    case 550:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22427; /* pred_indexed_oloadrvvm2x4dirvvmf4qi */

    case 551:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22523; /* pred_indexed_oloadrvvm2x4dirvvmf2hi */

    case 552:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22619; /* pred_indexed_oloadrvvm2x4dirvvm1si */

    case 553:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22715; /* pred_indexed_oloadrvvm2x4dirvvm2di */

    case 554:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22429; /* pred_indexed_oloadrvvmf2x2bfrvvmf4qi */

    case 555:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22525; /* pred_indexed_oloadrvvmf2x2bfrvvmf2hi */

    case 556:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22621; /* pred_indexed_oloadrvvmf2x2bfrvvm1si */

    case 557:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22717; /* pred_indexed_oloadrvvmf2x2bfrvvm2di */

    case 558:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22431; /* pred_indexed_oloadrvvmf2x3bfrvvmf4qi */

    case 559:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22527; /* pred_indexed_oloadrvvmf2x3bfrvvmf2hi */

    case 560:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22623; /* pred_indexed_oloadrvvmf2x3bfrvvm1si */

    case 561:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22719; /* pred_indexed_oloadrvvmf2x3bfrvvm2di */

    case 562:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22433; /* pred_indexed_oloadrvvmf2x4bfrvvmf4qi */

    case 563:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22529; /* pred_indexed_oloadrvvmf2x4bfrvvmf2hi */

    case 564:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22625; /* pred_indexed_oloadrvvmf2x4bfrvvm1si */

    case 565:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22721; /* pred_indexed_oloadrvvmf2x4bfrvvm2di */

    case 566:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22435; /* pred_indexed_oloadrvvmf2x5bfrvvmf4qi */

    case 567:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22531; /* pred_indexed_oloadrvvmf2x5bfrvvmf2hi */

    case 568:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22627; /* pred_indexed_oloadrvvmf2x5bfrvvm1si */

    case 569:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22723; /* pred_indexed_oloadrvvmf2x5bfrvvm2di */

    case 570:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22437; /* pred_indexed_oloadrvvmf2x6bfrvvmf4qi */

    case 571:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22533; /* pred_indexed_oloadrvvmf2x6bfrvvmf2hi */

    case 572:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22629; /* pred_indexed_oloadrvvmf2x6bfrvvm1si */

    case 573:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22725; /* pred_indexed_oloadrvvmf2x6bfrvvm2di */

    case 574:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22439; /* pred_indexed_oloadrvvmf2x7bfrvvmf4qi */

    case 575:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22535; /* pred_indexed_oloadrvvmf2x7bfrvvmf2hi */

    case 576:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22631; /* pred_indexed_oloadrvvmf2x7bfrvvm1si */

    case 577:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22727; /* pred_indexed_oloadrvvmf2x7bfrvvm2di */

    case 578:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22441; /* pred_indexed_oloadrvvmf2x8bfrvvmf4qi */

    case 579:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22537; /* pred_indexed_oloadrvvmf2x8bfrvvmf2hi */

    case 580:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22633; /* pred_indexed_oloadrvvmf2x8bfrvvm1si */

    case 581:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22729; /* pred_indexed_oloadrvvmf2x8bfrvvm2di */

    case 582:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22443; /* pred_indexed_oloadrvvmf2x2hfrvvmf4qi */

    case 583:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22539; /* pred_indexed_oloadrvvmf2x2hfrvvmf2hi */

    case 584:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22635; /* pred_indexed_oloadrvvmf2x2hfrvvm1si */

    case 585:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22731; /* pred_indexed_oloadrvvmf2x2hfrvvm2di */

    case 586:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22445; /* pred_indexed_oloadrvvmf2x3hfrvvmf4qi */

    case 587:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22541; /* pred_indexed_oloadrvvmf2x3hfrvvmf2hi */

    case 588:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22637; /* pred_indexed_oloadrvvmf2x3hfrvvm1si */

    case 589:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22733; /* pred_indexed_oloadrvvmf2x3hfrvvm2di */

    case 590:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22447; /* pred_indexed_oloadrvvmf2x4hfrvvmf4qi */

    case 591:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22543; /* pred_indexed_oloadrvvmf2x4hfrvvmf2hi */

    case 592:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22639; /* pred_indexed_oloadrvvmf2x4hfrvvm1si */

    case 593:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22735; /* pred_indexed_oloadrvvmf2x4hfrvvm2di */

    case 594:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22449; /* pred_indexed_oloadrvvmf2x5hfrvvmf4qi */

    case 595:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22545; /* pred_indexed_oloadrvvmf2x5hfrvvmf2hi */

    case 596:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22641; /* pred_indexed_oloadrvvmf2x5hfrvvm1si */

    case 597:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22737; /* pred_indexed_oloadrvvmf2x5hfrvvm2di */

    case 598:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22451; /* pred_indexed_oloadrvvmf2x6hfrvvmf4qi */

    case 599:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22547; /* pred_indexed_oloadrvvmf2x6hfrvvmf2hi */

    case 600:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22643; /* pred_indexed_oloadrvvmf2x6hfrvvm1si */

    case 601:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22739; /* pred_indexed_oloadrvvmf2x6hfrvvm2di */

    case 602:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22453; /* pred_indexed_oloadrvvmf2x7hfrvvmf4qi */

    case 603:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22549; /* pred_indexed_oloadrvvmf2x7hfrvvmf2hi */

    case 604:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22645; /* pred_indexed_oloadrvvmf2x7hfrvvm1si */

    case 605:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22741; /* pred_indexed_oloadrvvmf2x7hfrvvm2di */

    case 606:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22455; /* pred_indexed_oloadrvvmf2x8hfrvvmf4qi */

    case 607:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22551; /* pred_indexed_oloadrvvmf2x8hfrvvmf2hi */

    case 608:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22647; /* pred_indexed_oloadrvvmf2x8hfrvvm1si */

    case 609:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22743; /* pred_indexed_oloadrvvmf2x8hfrvvm2di */

    case 610:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22457; /* pred_indexed_oloadrvvm1x2sfrvvmf4qi */

    case 611:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22553; /* pred_indexed_oloadrvvm1x2sfrvvmf2hi */

    case 612:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22649; /* pred_indexed_oloadrvvm1x2sfrvvm1si */

    case 613:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22745; /* pred_indexed_oloadrvvm1x2sfrvvm2di */

    case 614:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22459; /* pred_indexed_oloadrvvm1x3sfrvvmf4qi */

    case 615:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22555; /* pred_indexed_oloadrvvm1x3sfrvvmf2hi */

    case 616:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22651; /* pred_indexed_oloadrvvm1x3sfrvvm1si */

    case 617:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22747; /* pred_indexed_oloadrvvm1x3sfrvvm2di */

    case 618:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22461; /* pred_indexed_oloadrvvm1x4sfrvvmf4qi */

    case 619:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22557; /* pred_indexed_oloadrvvm1x4sfrvvmf2hi */

    case 620:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22653; /* pred_indexed_oloadrvvm1x4sfrvvm1si */

    case 621:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22749; /* pred_indexed_oloadrvvm1x4sfrvvm2di */

    case 622:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22463; /* pred_indexed_oloadrvvm1x5sfrvvmf4qi */

    case 623:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22559; /* pred_indexed_oloadrvvm1x5sfrvvmf2hi */

    case 624:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22655; /* pred_indexed_oloadrvvm1x5sfrvvm1si */

    case 625:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22751; /* pred_indexed_oloadrvvm1x5sfrvvm2di */

    case 626:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22465; /* pred_indexed_oloadrvvm1x6sfrvvmf4qi */

    case 627:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22561; /* pred_indexed_oloadrvvm1x6sfrvvmf2hi */

    case 628:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22657; /* pred_indexed_oloadrvvm1x6sfrvvm1si */

    case 629:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22753; /* pred_indexed_oloadrvvm1x6sfrvvm2di */

    case 630:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22467; /* pred_indexed_oloadrvvm1x7sfrvvmf4qi */

    case 631:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22563; /* pred_indexed_oloadrvvm1x7sfrvvmf2hi */

    case 632:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22659; /* pred_indexed_oloadrvvm1x7sfrvvm1si */

    case 633:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22755; /* pred_indexed_oloadrvvm1x7sfrvvm2di */

    case 634:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22469; /* pred_indexed_oloadrvvm1x8sfrvvmf4qi */

    case 635:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22565; /* pred_indexed_oloadrvvm1x8sfrvvmf2hi */

    case 636:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22661; /* pred_indexed_oloadrvvm1x8sfrvvm1si */

    case 637:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22757; /* pred_indexed_oloadrvvm1x8sfrvvm2di */

    case 638:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22471; /* pred_indexed_oloadrvvm2x2dfrvvmf4qi */

    case 639:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22567; /* pred_indexed_oloadrvvm2x2dfrvvmf2hi */

    case 640:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22663; /* pred_indexed_oloadrvvm2x2dfrvvm1si */

    case 641:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22759; /* pred_indexed_oloadrvvm2x2dfrvvm2di */

    case 642:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22473; /* pred_indexed_oloadrvvm2x3dfrvvmf4qi */

    case 643:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22569; /* pred_indexed_oloadrvvm2x3dfrvvmf2hi */

    case 644:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22665; /* pred_indexed_oloadrvvm2x3dfrvvm1si */

    case 645:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22761; /* pred_indexed_oloadrvvm2x3dfrvvm2di */

    case 646:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22475; /* pred_indexed_oloadrvvm2x4dfrvvmf4qi */

    case 647:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22571; /* pred_indexed_oloadrvvm2x4dfrvvmf2hi */

    case 648:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22667; /* pred_indexed_oloadrvvm2x4dfrvvm1si */

    case 649:
      if (!(
#line 8498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22763; /* pred_indexed_oloadrvvm2x4dfrvvm2di */

    case 650:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22765; /* pred_indexed_oloadrvvmf2x2qirvvmf2qi */

    case 651:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22837; /* pred_indexed_oloadrvvmf2x2qirvvm1hi */

    case 652:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22909; /* pred_indexed_oloadrvvmf2x2qirvvm2si */

    case 653:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22981; /* pred_indexed_oloadrvvmf2x2qirvvm4di */

    case 654:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22767; /* pred_indexed_oloadrvvmf2x3qirvvmf2qi */

    case 655:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22839; /* pred_indexed_oloadrvvmf2x3qirvvm1hi */

    case 656:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22911; /* pred_indexed_oloadrvvmf2x3qirvvm2si */

    case 657:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22983; /* pred_indexed_oloadrvvmf2x3qirvvm4di */

    case 658:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22769; /* pred_indexed_oloadrvvmf2x4qirvvmf2qi */

    case 659:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22841; /* pred_indexed_oloadrvvmf2x4qirvvm1hi */

    case 660:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22913; /* pred_indexed_oloadrvvmf2x4qirvvm2si */

    case 661:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22985; /* pred_indexed_oloadrvvmf2x4qirvvm4di */

    case 662:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22771; /* pred_indexed_oloadrvvmf2x5qirvvmf2qi */

    case 663:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22843; /* pred_indexed_oloadrvvmf2x5qirvvm1hi */

    case 664:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22915; /* pred_indexed_oloadrvvmf2x5qirvvm2si */

    case 665:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22987; /* pred_indexed_oloadrvvmf2x5qirvvm4di */

    case 666:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22773; /* pred_indexed_oloadrvvmf2x6qirvvmf2qi */

    case 667:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22845; /* pred_indexed_oloadrvvmf2x6qirvvm1hi */

    case 668:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22917; /* pred_indexed_oloadrvvmf2x6qirvvm2si */

    case 669:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22989; /* pred_indexed_oloadrvvmf2x6qirvvm4di */

    case 670:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22775; /* pred_indexed_oloadrvvmf2x7qirvvmf2qi */

    case 671:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22847; /* pred_indexed_oloadrvvmf2x7qirvvm1hi */

    case 672:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22919; /* pred_indexed_oloadrvvmf2x7qirvvm2si */

    case 673:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22991; /* pred_indexed_oloadrvvmf2x7qirvvm4di */

    case 674:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22777; /* pred_indexed_oloadrvvmf2x8qirvvmf2qi */

    case 675:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22849; /* pred_indexed_oloadrvvmf2x8qirvvm1hi */

    case 676:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22921; /* pred_indexed_oloadrvvmf2x8qirvvm2si */

    case 677:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22993; /* pred_indexed_oloadrvvmf2x8qirvvm4di */

    case 678:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22779; /* pred_indexed_oloadrvvm1x2hirvvmf2qi */

    case 679:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22851; /* pred_indexed_oloadrvvm1x2hirvvm1hi */

    case 680:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22923; /* pred_indexed_oloadrvvm1x2hirvvm2si */

    case 681:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22995; /* pred_indexed_oloadrvvm1x2hirvvm4di */

    case 682:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22781; /* pred_indexed_oloadrvvm1x3hirvvmf2qi */

    case 683:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22853; /* pred_indexed_oloadrvvm1x3hirvvm1hi */

    case 684:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22925; /* pred_indexed_oloadrvvm1x3hirvvm2si */

    case 685:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22997; /* pred_indexed_oloadrvvm1x3hirvvm4di */

    case 686:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22783; /* pred_indexed_oloadrvvm1x4hirvvmf2qi */

    case 687:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22855; /* pred_indexed_oloadrvvm1x4hirvvm1hi */

    case 688:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22927; /* pred_indexed_oloadrvvm1x4hirvvm2si */

    case 689:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22999; /* pred_indexed_oloadrvvm1x4hirvvm4di */

    case 690:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22785; /* pred_indexed_oloadrvvm1x5hirvvmf2qi */

    case 691:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22857; /* pred_indexed_oloadrvvm1x5hirvvm1hi */

    case 692:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22929; /* pred_indexed_oloadrvvm1x5hirvvm2si */

    case 693:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23001; /* pred_indexed_oloadrvvm1x5hirvvm4di */

    case 694:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22787; /* pred_indexed_oloadrvvm1x6hirvvmf2qi */

    case 695:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22859; /* pred_indexed_oloadrvvm1x6hirvvm1hi */

    case 696:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22931; /* pred_indexed_oloadrvvm1x6hirvvm2si */

    case 697:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23003; /* pred_indexed_oloadrvvm1x6hirvvm4di */

    case 698:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22789; /* pred_indexed_oloadrvvm1x7hirvvmf2qi */

    case 699:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22861; /* pred_indexed_oloadrvvm1x7hirvvm1hi */

    case 700:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22933; /* pred_indexed_oloadrvvm1x7hirvvm2si */

    case 701:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23005; /* pred_indexed_oloadrvvm1x7hirvvm4di */

    case 702:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22791; /* pred_indexed_oloadrvvm1x8hirvvmf2qi */

    case 703:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22863; /* pred_indexed_oloadrvvm1x8hirvvm1hi */

    case 704:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22935; /* pred_indexed_oloadrvvm1x8hirvvm2si */

    case 705:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23007; /* pred_indexed_oloadrvvm1x8hirvvm4di */

    case 706:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22793; /* pred_indexed_oloadrvvm2x2sirvvmf2qi */

    case 707:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22865; /* pred_indexed_oloadrvvm2x2sirvvm1hi */

    case 708:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22937; /* pred_indexed_oloadrvvm2x2sirvvm2si */

    case 709:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23009; /* pred_indexed_oloadrvvm2x2sirvvm4di */

    case 710:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22795; /* pred_indexed_oloadrvvm2x3sirvvmf2qi */

    case 711:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22867; /* pred_indexed_oloadrvvm2x3sirvvm1hi */

    case 712:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22939; /* pred_indexed_oloadrvvm2x3sirvvm2si */

    case 713:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23011; /* pred_indexed_oloadrvvm2x3sirvvm4di */

    case 714:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22797; /* pred_indexed_oloadrvvm2x4sirvvmf2qi */

    case 715:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22869; /* pred_indexed_oloadrvvm2x4sirvvm1hi */

    case 716:
      if (!
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22941; /* pred_indexed_oloadrvvm2x4sirvvm2si */

    case 717:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23013; /* pred_indexed_oloadrvvm2x4sirvvm4di */

    case 718:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22799; /* pred_indexed_oloadrvvm4x2dirvvmf2qi */

    case 719:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22871; /* pred_indexed_oloadrvvm4x2dirvvm1hi */

    case 720:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22943; /* pred_indexed_oloadrvvm4x2dirvvm2si */

    case 721:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23015; /* pred_indexed_oloadrvvm4x2dirvvm4di */

    case 722:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22801; /* pred_indexed_oloadrvvm1x2bfrvvmf2qi */

    case 723:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22873; /* pred_indexed_oloadrvvm1x2bfrvvm1hi */

    case 724:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22945; /* pred_indexed_oloadrvvm1x2bfrvvm2si */

    case 725:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23017; /* pred_indexed_oloadrvvm1x2bfrvvm4di */

    case 726:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22803; /* pred_indexed_oloadrvvm1x3bfrvvmf2qi */

    case 727:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22875; /* pred_indexed_oloadrvvm1x3bfrvvm1hi */

    case 728:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22947; /* pred_indexed_oloadrvvm1x3bfrvvm2si */

    case 729:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23019; /* pred_indexed_oloadrvvm1x3bfrvvm4di */

    case 730:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22805; /* pred_indexed_oloadrvvm1x4bfrvvmf2qi */

    case 731:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22877; /* pred_indexed_oloadrvvm1x4bfrvvm1hi */

    case 732:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22949; /* pred_indexed_oloadrvvm1x4bfrvvm2si */

    case 733:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23021; /* pred_indexed_oloadrvvm1x4bfrvvm4di */

    case 734:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22807; /* pred_indexed_oloadrvvm1x5bfrvvmf2qi */

    case 735:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22879; /* pred_indexed_oloadrvvm1x5bfrvvm1hi */

    case 736:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22951; /* pred_indexed_oloadrvvm1x5bfrvvm2si */

    case 737:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23023; /* pred_indexed_oloadrvvm1x5bfrvvm4di */

    case 738:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22809; /* pred_indexed_oloadrvvm1x6bfrvvmf2qi */

    case 739:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22881; /* pred_indexed_oloadrvvm1x6bfrvvm1hi */

    case 740:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22953; /* pred_indexed_oloadrvvm1x6bfrvvm2si */

    case 741:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23025; /* pred_indexed_oloadrvvm1x6bfrvvm4di */

    case 742:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22811; /* pred_indexed_oloadrvvm1x7bfrvvmf2qi */

    case 743:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22883; /* pred_indexed_oloadrvvm1x7bfrvvm1hi */

    case 744:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22955; /* pred_indexed_oloadrvvm1x7bfrvvm2si */

    case 745:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23027; /* pred_indexed_oloadrvvm1x7bfrvvm4di */

    case 746:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22813; /* pred_indexed_oloadrvvm1x8bfrvvmf2qi */

    case 747:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22885; /* pred_indexed_oloadrvvm1x8bfrvvm1hi */

    case 748:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22957; /* pred_indexed_oloadrvvm1x8bfrvvm2si */

    case 749:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23029; /* pred_indexed_oloadrvvm1x8bfrvvm4di */

    case 750:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22815; /* pred_indexed_oloadrvvm1x2hfrvvmf2qi */

    case 751:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22887; /* pred_indexed_oloadrvvm1x2hfrvvm1hi */

    case 752:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22959; /* pred_indexed_oloadrvvm1x2hfrvvm2si */

    case 753:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23031; /* pred_indexed_oloadrvvm1x2hfrvvm4di */

    case 754:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22817; /* pred_indexed_oloadrvvm1x3hfrvvmf2qi */

    case 755:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22889; /* pred_indexed_oloadrvvm1x3hfrvvm1hi */

    case 756:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22961; /* pred_indexed_oloadrvvm1x3hfrvvm2si */

    case 757:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23033; /* pred_indexed_oloadrvvm1x3hfrvvm4di */

    case 758:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22819; /* pred_indexed_oloadrvvm1x4hfrvvmf2qi */

    case 759:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22891; /* pred_indexed_oloadrvvm1x4hfrvvm1hi */

    case 760:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22963; /* pred_indexed_oloadrvvm1x4hfrvvm2si */

    case 761:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23035; /* pred_indexed_oloadrvvm1x4hfrvvm4di */

    case 762:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22821; /* pred_indexed_oloadrvvm1x5hfrvvmf2qi */

    case 763:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22893; /* pred_indexed_oloadrvvm1x5hfrvvm1hi */

    case 764:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22965; /* pred_indexed_oloadrvvm1x5hfrvvm2si */

    case 765:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23037; /* pred_indexed_oloadrvvm1x5hfrvvm4di */

    case 766:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22823; /* pred_indexed_oloadrvvm1x6hfrvvmf2qi */

    case 767:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22895; /* pred_indexed_oloadrvvm1x6hfrvvm1hi */

    case 768:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22967; /* pred_indexed_oloadrvvm1x6hfrvvm2si */

    case 769:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23039; /* pred_indexed_oloadrvvm1x6hfrvvm4di */

    case 770:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22825; /* pred_indexed_oloadrvvm1x7hfrvvmf2qi */

    case 771:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22897; /* pred_indexed_oloadrvvm1x7hfrvvm1hi */

    case 772:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22969; /* pred_indexed_oloadrvvm1x7hfrvvm2si */

    case 773:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23041; /* pred_indexed_oloadrvvm1x7hfrvvm4di */

    case 774:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22827; /* pred_indexed_oloadrvvm1x8hfrvvmf2qi */

    case 775:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22899; /* pred_indexed_oloadrvvm1x8hfrvvm1hi */

    case 776:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22971; /* pred_indexed_oloadrvvm1x8hfrvvm2si */

    case 777:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23043; /* pred_indexed_oloadrvvm1x8hfrvvm4di */

    case 778:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22829; /* pred_indexed_oloadrvvm2x2sfrvvmf2qi */

    case 779:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22901; /* pred_indexed_oloadrvvm2x2sfrvvm1hi */

    case 780:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22973; /* pred_indexed_oloadrvvm2x2sfrvvm2si */

    case 781:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23045; /* pred_indexed_oloadrvvm2x2sfrvvm4di */

    case 782:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22831; /* pred_indexed_oloadrvvm2x3sfrvvmf2qi */

    case 783:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22903; /* pred_indexed_oloadrvvm2x3sfrvvm1hi */

    case 784:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22975; /* pred_indexed_oloadrvvm2x3sfrvvm2si */

    case 785:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23047; /* pred_indexed_oloadrvvm2x3sfrvvm4di */

    case 786:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22833; /* pred_indexed_oloadrvvm2x4sfrvvmf2qi */

    case 787:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22905; /* pred_indexed_oloadrvvm2x4sfrvvm1hi */

    case 788:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22977; /* pred_indexed_oloadrvvm2x4sfrvvm2si */

    case 789:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23049; /* pred_indexed_oloadrvvm2x4sfrvvm4di */

    case 790:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22835; /* pred_indexed_oloadrvvm4x2dfrvvmf2qi */

    case 791:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22907; /* pred_indexed_oloadrvvm4x2dfrvvm1hi */

    case 792:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22979; /* pred_indexed_oloadrvvm4x2dfrvvm2si */

    case 793:
      if (!(
#line 8519 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23051; /* pred_indexed_oloadrvvm4x2dfrvvm4di */

    case 794:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23053; /* pred_indexed_oloadrvvm1x2qirvvm1qi */

    case 795:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23055; /* pred_indexed_oloadrvvm1x2qirvvm2hi */

    case 796:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23057; /* pred_indexed_oloadrvvm1x2qirvvm4si */

    case 797:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23059; /* pred_indexed_oloadrvvm1x2qirvvm8di */

    case 798:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23061; /* pred_indexed_oloadrvvm1x3qirvvm1qi */

    case 799:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23063; /* pred_indexed_oloadrvvm1x3qirvvm2hi */

    case 800:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23065; /* pred_indexed_oloadrvvm1x3qirvvm4si */

    case 801:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23067; /* pred_indexed_oloadrvvm1x3qirvvm8di */

    case 802:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23069; /* pred_indexed_oloadrvvm1x4qirvvm1qi */

    case 803:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23071; /* pred_indexed_oloadrvvm1x4qirvvm2hi */

    case 804:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23073; /* pred_indexed_oloadrvvm1x4qirvvm4si */

    case 805:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23075; /* pred_indexed_oloadrvvm1x4qirvvm8di */

    case 806:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23077; /* pred_indexed_oloadrvvm1x5qirvvm1qi */

    case 807:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23079; /* pred_indexed_oloadrvvm1x5qirvvm2hi */

    case 808:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23081; /* pred_indexed_oloadrvvm1x5qirvvm4si */

    case 809:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23083; /* pred_indexed_oloadrvvm1x5qirvvm8di */

    case 810:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23085; /* pred_indexed_oloadrvvm1x6qirvvm1qi */

    case 811:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23087; /* pred_indexed_oloadrvvm1x6qirvvm2hi */

    case 812:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23089; /* pred_indexed_oloadrvvm1x6qirvvm4si */

    case 813:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23091; /* pred_indexed_oloadrvvm1x6qirvvm8di */

    case 814:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23093; /* pred_indexed_oloadrvvm1x7qirvvm1qi */

    case 815:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23095; /* pred_indexed_oloadrvvm1x7qirvvm2hi */

    case 816:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23097; /* pred_indexed_oloadrvvm1x7qirvvm4si */

    case 817:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23099; /* pred_indexed_oloadrvvm1x7qirvvm8di */

    case 818:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23101; /* pred_indexed_oloadrvvm1x8qirvvm1qi */

    case 819:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23103; /* pred_indexed_oloadrvvm1x8qirvvm2hi */

    case 820:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23105; /* pred_indexed_oloadrvvm1x8qirvvm4si */

    case 821:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23107; /* pred_indexed_oloadrvvm1x8qirvvm8di */

    case 822:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23109; /* pred_indexed_oloadrvvm2x2hirvvm1qi */

    case 823:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23111; /* pred_indexed_oloadrvvm2x2hirvvm2hi */

    case 824:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23113; /* pred_indexed_oloadrvvm2x2hirvvm4si */

    case 825:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23115; /* pred_indexed_oloadrvvm2x2hirvvm8di */

    case 826:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23117; /* pred_indexed_oloadrvvm2x3hirvvm1qi */

    case 827:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23119; /* pred_indexed_oloadrvvm2x3hirvvm2hi */

    case 828:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23121; /* pred_indexed_oloadrvvm2x3hirvvm4si */

    case 829:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23123; /* pred_indexed_oloadrvvm2x3hirvvm8di */

    case 830:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23125; /* pred_indexed_oloadrvvm2x4hirvvm1qi */

    case 831:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23127; /* pred_indexed_oloadrvvm2x4hirvvm2hi */

    case 832:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23129; /* pred_indexed_oloadrvvm2x4hirvvm4si */

    case 833:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23131; /* pred_indexed_oloadrvvm2x4hirvvm8di */

    case 834:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23133; /* pred_indexed_oloadrvvm4x2sirvvm1qi */

    case 835:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23135; /* pred_indexed_oloadrvvm4x2sirvvm2hi */

    case 836:
      if (!
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23137; /* pred_indexed_oloadrvvm4x2sirvvm4si */

    case 837:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23139; /* pred_indexed_oloadrvvm4x2sirvvm8di */

    case 838:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23141; /* pred_indexed_oloadrvvm2x2bfrvvm1qi */

    case 839:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23143; /* pred_indexed_oloadrvvm2x2bfrvvm2hi */

    case 840:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23145; /* pred_indexed_oloadrvvm2x2bfrvvm4si */

    case 841:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23147; /* pred_indexed_oloadrvvm2x2bfrvvm8di */

    case 842:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23149; /* pred_indexed_oloadrvvm2x3bfrvvm1qi */

    case 843:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23151; /* pred_indexed_oloadrvvm2x3bfrvvm2hi */

    case 844:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23153; /* pred_indexed_oloadrvvm2x3bfrvvm4si */

    case 845:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23155; /* pred_indexed_oloadrvvm2x3bfrvvm8di */

    case 846:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23157; /* pred_indexed_oloadrvvm2x4bfrvvm1qi */

    case 847:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23159; /* pred_indexed_oloadrvvm2x4bfrvvm2hi */

    case 848:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23161; /* pred_indexed_oloadrvvm2x4bfrvvm4si */

    case 849:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23163; /* pred_indexed_oloadrvvm2x4bfrvvm8di */

    case 850:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23165; /* pred_indexed_oloadrvvm2x2hfrvvm1qi */

    case 851:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23167; /* pred_indexed_oloadrvvm2x2hfrvvm2hi */

    case 852:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23169; /* pred_indexed_oloadrvvm2x2hfrvvm4si */

    case 853:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23171; /* pred_indexed_oloadrvvm2x2hfrvvm8di */

    case 854:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23173; /* pred_indexed_oloadrvvm2x3hfrvvm1qi */

    case 855:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23175; /* pred_indexed_oloadrvvm2x3hfrvvm2hi */

    case 856:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23177; /* pred_indexed_oloadrvvm2x3hfrvvm4si */

    case 857:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23179; /* pred_indexed_oloadrvvm2x3hfrvvm8di */

    case 858:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23181; /* pred_indexed_oloadrvvm2x4hfrvvm1qi */

    case 859:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23183; /* pred_indexed_oloadrvvm2x4hfrvvm2hi */

    case 860:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23185; /* pred_indexed_oloadrvvm2x4hfrvvm4si */

    case 861:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23187; /* pred_indexed_oloadrvvm2x4hfrvvm8di */

    case 862:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23189; /* pred_indexed_oloadrvvm4x2sfrvvm1qi */

    case 863:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23191; /* pred_indexed_oloadrvvm4x2sfrvvm2hi */

    case 864:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23193; /* pred_indexed_oloadrvvm4x2sfrvvm4si */

    case 865:
      if (!(
#line 8540 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23195; /* pred_indexed_oloadrvvm4x2sfrvvm8di */

    case 866:
      if (!
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23197; /* pred_indexed_oloadrvvm2x2qirvvm2qi */

    case 867:
      if (!
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23199; /* pred_indexed_oloadrvvm2x2qirvvm4hi */

    case 868:
      if (!
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23201; /* pred_indexed_oloadrvvm2x2qirvvm8si */

    case 869:
      if (!
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23203; /* pred_indexed_oloadrvvm2x3qirvvm2qi */

    case 870:
      if (!
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23205; /* pred_indexed_oloadrvvm2x3qirvvm4hi */

    case 871:
      if (!
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23207; /* pred_indexed_oloadrvvm2x3qirvvm8si */

    case 872:
      if (!
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23209; /* pred_indexed_oloadrvvm2x4qirvvm2qi */

    case 873:
      if (!
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23211; /* pred_indexed_oloadrvvm2x4qirvvm4hi */

    case 874:
      if (!
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23213; /* pred_indexed_oloadrvvm2x4qirvvm8si */

    case 875:
      if (!
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23215; /* pred_indexed_oloadrvvm4x2hirvvm2qi */

    case 876:
      if (!
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23217; /* pred_indexed_oloadrvvm4x2hirvvm4hi */

    case 877:
      if (!
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23219; /* pred_indexed_oloadrvvm4x2hirvvm8si */

    case 878:
      if (!(
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23221; /* pred_indexed_oloadrvvm4x2bfrvvm2qi */

    case 879:
      if (!(
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23223; /* pred_indexed_oloadrvvm4x2bfrvvm4hi */

    case 880:
      if (!(
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23225; /* pred_indexed_oloadrvvm4x2bfrvvm8si */

    case 881:
      if (!(
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23227; /* pred_indexed_oloadrvvm4x2hfrvvm2qi */

    case 882:
      if (!(
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23229; /* pred_indexed_oloadrvvm4x2hfrvvm4hi */

    case 883:
      if (!(
#line 8561 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23231; /* pred_indexed_oloadrvvm4x2hfrvvm8si */

    case 884:
      if (!
#line 8582 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23233; /* pred_indexed_oloadrvvm4x2qirvvm4qi */

    case 885:
      if (!
#line 8582 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23235; /* pred_indexed_oloadrvvm4x2qirvvm8hi */

    default:
      return -1;
    }
}

 int
recog_898 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern498 (x2))
    {
    case 0:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5511; /* pred_udivrvvm8qi */

    case 1:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5528; /* pred_udivrvvm4qi */

    case 2:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5545; /* pred_udivrvvm2qi */

    case 3:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5562; /* pred_udivrvvm1qi */

    case 4:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5579; /* pred_udivrvvm8hi */

    case 5:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5596; /* pred_udivrvvm4hi */

    case 6:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5613; /* pred_udivrvvm2hi */

    case 7:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5630; /* pred_udivrvvm1hi */

    case 8:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5647; /* pred_udivrvvm8si */

    case 9:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5664; /* pred_udivrvvm4si */

    case 10:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5681; /* pred_udivrvvm2si */

    case 11:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5698; /* pred_udivrvvm1si */

    case 12:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5715; /* pred_udivrvvm8di */

    case 13:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5732; /* pred_udivrvvm4di */

    case 14:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5749; /* pred_udivrvvm2di */

    case 15:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5766; /* pred_udivrvvm1di */

    case 16:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5783; /* pred_udivrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5800; /* pred_udivrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5817; /* pred_udivrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5834; /* pred_udivrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5851; /* pred_udivrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5868; /* pred_udivrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5885; /* pred_udivv1qi */

    case 23:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5902; /* pred_udivv2qi */

    case 24:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5919; /* pred_udivv4qi */

    case 25:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5936; /* pred_udivv8qi */

    case 26:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5953; /* pred_udivv16qi */

    case 27:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5970; /* pred_udivv32qi */

    case 28:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5987; /* pred_udivv64qi */

    case 29:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6004; /* pred_udivv128qi */

    case 30:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6021; /* pred_udivv256qi */

    case 31:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6038; /* pred_udivv512qi */

    case 32:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6055; /* pred_udivv1024qi */

    case 33:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6072; /* pred_udivv2048qi */

    case 34:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6089; /* pred_udivv4096qi */

    case 35:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6106; /* pred_udivv1hi */

    case 36:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6123; /* pred_udivv2hi */

    case 37:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6140; /* pred_udivv4hi */

    case 38:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6157; /* pred_udivv8hi */

    case 39:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6174; /* pred_udivv16hi */

    case 40:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6191; /* pred_udivv32hi */

    case 41:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6208; /* pred_udivv64hi */

    case 42:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6225; /* pred_udivv128hi */

    case 43:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6242; /* pred_udivv256hi */

    case 44:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6259; /* pred_udivv512hi */

    case 45:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6276; /* pred_udivv1024hi */

    case 46:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6293; /* pred_udivv2048hi */

    case 47:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6310; /* pred_udivv1si */

    case 48:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6327; /* pred_udivv2si */

    case 49:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6344; /* pred_udivv4si */

    case 50:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6361; /* pred_udivv8si */

    case 51:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6378; /* pred_udivv16si */

    case 52:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6395; /* pred_udivv32si */

    case 53:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6412; /* pred_udivv64si */

    case 54:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6429; /* pred_udivv128si */

    case 55:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6446; /* pred_udivv256si */

    case 56:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6463; /* pred_udivv512si */

    case 57:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6480; /* pred_udivv1024si */

    case 58:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6497; /* pred_udivv1di */

    case 59:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6514; /* pred_udivv2di */

    case 60:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6531; /* pred_udivv4di */

    case 61:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6548; /* pred_udivv8di */

    case 62:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6565; /* pred_udivv16di */

    case 63:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6582; /* pred_udivv32di */

    case 64:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6599; /* pred_udivv64di */

    case 65:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6616; /* pred_udivv128di */

    case 66:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6633; /* pred_udivv256di */

    case 67:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6650; /* pred_udivv512di */

    case 68:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7345; /* pred_udivrvvm8qi_scalar */

    case 69:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7350; /* pred_udivrvvm4qi_scalar */

    case 70:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7355; /* pred_udivrvvm2qi_scalar */

    case 71:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7360; /* pred_udivrvvm1qi_scalar */

    case 72:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7365; /* pred_udivrvvmf2qi_scalar */

    case 73:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7370; /* pred_udivrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7375; /* pred_udivrvvmf8qi_scalar */

    case 75:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7380; /* pred_udivrvvm8hi_scalar */

    case 76:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7385; /* pred_udivrvvm4hi_scalar */

    case 77:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7390; /* pred_udivrvvm2hi_scalar */

    case 78:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7395; /* pred_udivrvvm1hi_scalar */

    case 79:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7400; /* pred_udivrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7405; /* pred_udivrvvmf4hi_scalar */

    case 81:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7410; /* pred_udivrvvm8si_scalar */

    case 82:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7415; /* pred_udivrvvm4si_scalar */

    case 83:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7420; /* pred_udivrvvm2si_scalar */

    case 84:
      if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7425; /* pred_udivrvvm1si_scalar */

    case 85:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7430; /* pred_udivrvvmf2si_scalar */

    case 86:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7435; /* pred_udivv1qi_scalar */

    case 87:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7440; /* pred_udivv2qi_scalar */

    case 88:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7445; /* pred_udivv4qi_scalar */

    case 89:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7450; /* pred_udivv8qi_scalar */

    case 90:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7455; /* pred_udivv16qi_scalar */

    case 91:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7460; /* pred_udivv32qi_scalar */

    case 92:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7465; /* pred_udivv64qi_scalar */

    case 93:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7470; /* pred_udivv128qi_scalar */

    case 94:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7475; /* pred_udivv256qi_scalar */

    case 95:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7480; /* pred_udivv512qi_scalar */

    case 96:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7485; /* pred_udivv1024qi_scalar */

    case 97:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7490; /* pred_udivv2048qi_scalar */

    case 98:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7495; /* pred_udivv4096qi_scalar */

    case 99:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7500; /* pred_udivv1hi_scalar */

    case 100:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7505; /* pred_udivv2hi_scalar */

    case 101:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7510; /* pred_udivv4hi_scalar */

    case 102:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7515; /* pred_udivv8hi_scalar */

    case 103:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7520; /* pred_udivv16hi_scalar */

    case 104:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7525; /* pred_udivv32hi_scalar */

    case 105:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7530; /* pred_udivv64hi_scalar */

    case 106:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7535; /* pred_udivv128hi_scalar */

    case 107:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7540; /* pred_udivv256hi_scalar */

    case 108:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7545; /* pred_udivv512hi_scalar */

    case 109:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7550; /* pred_udivv1024hi_scalar */

    case 110:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7555; /* pred_udivv2048hi_scalar */

    case 111:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7560; /* pred_udivv1si_scalar */

    case 112:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7565; /* pred_udivv2si_scalar */

    case 113:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7570; /* pred_udivv4si_scalar */

    case 114:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7575; /* pred_udivv8si_scalar */

    case 115:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7580; /* pred_udivv16si_scalar */

    case 116:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7585; /* pred_udivv32si_scalar */

    case 117:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7590; /* pred_udivv64si_scalar */

    case 118:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7595; /* pred_udivv128si_scalar */

    case 119:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7600; /* pred_udivv256si_scalar */

    case 120:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7605; /* pred_udivv512si_scalar */

    case 121:
      if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7610; /* pred_udivv1024si_scalar */

    case 122:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7921; /* *pred_udivrvvm8di_scalar */

    case 123:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7926; /* *pred_udivrvvm4di_scalar */

    case 124:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7931; /* *pred_udivrvvm2di_scalar */

    case 125:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7936; /* *pred_udivrvvm1di_scalar */

    case 126:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7941; /* *pred_udivv1di_scalar */

    case 127:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7946; /* *pred_udivv2di_scalar */

    case 128:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7951; /* *pred_udivv4di_scalar */

    case 129:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7956; /* *pred_udivv8di_scalar */

    case 130:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7961; /* *pred_udivv16di_scalar */

    case 131:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7966; /* *pred_udivv32di_scalar */

    case 132:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7971; /* *pred_udivv64di_scalar */

    case 133:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7976; /* *pred_udivv128di_scalar */

    case 134:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7981; /* *pred_udivv256di_scalar */

    case 135:
      if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7986; /* *pred_udivv512di_scalar */

    case 136:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7991; /* *pred_udivrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7996; /* *pred_udivrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8001; /* *pred_udivrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8006; /* *pred_udivrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8011; /* *pred_udivv1di_extended_scalar */

    case 141:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8016; /* *pred_udivv2di_extended_scalar */

    case 142:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8021; /* *pred_udivv4di_extended_scalar */

    case 143:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8026; /* *pred_udivv8di_extended_scalar */

    case 144:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8031; /* *pred_udivv16di_extended_scalar */

    case 145:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8036; /* *pred_udivv32di_extended_scalar */

    case 146:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8041; /* *pred_udivv64di_extended_scalar */

    case 147:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8046; /* *pred_udivv128di_extended_scalar */

    case 148:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8051; /* *pred_udivv256di_extended_scalar */

    case 149:
      if (!(
#line 2977 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8056; /* *pred_udivv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_907 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  x11 = XEXP (x8, 1);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      switch (pattern493 (x2))
        {
        case 0:
          if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10888; /* pred_ussubrvvm8qi */

        case 1:
          if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10892; /* pred_ussubrvvm4qi */

        case 2:
          if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10896; /* pred_ussubrvvm2qi */

        case 3:
          if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10900; /* pred_ussubrvvm1qi */

        case 4:
          if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10904; /* pred_ussubrvvm8hi */

        case 5:
          if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10908; /* pred_ussubrvvm4hi */

        case 6:
          if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10912; /* pred_ussubrvvm2hi */

        case 7:
          if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10916; /* pred_ussubrvvm1hi */

        case 8:
          if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10920; /* pred_ussubrvvm8si */

        case 9:
          if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10924; /* pred_ussubrvvm4si */

        case 10:
          if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10928; /* pred_ussubrvvm2si */

        case 11:
          if (!
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10932; /* pred_ussubrvvm1si */

        case 12:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10936; /* pred_ussubrvvm8di */

        case 13:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10940; /* pred_ussubrvvm4di */

        case 14:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10944; /* pred_ussubrvvm2di */

        case 15:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10948; /* pred_ussubrvvm1di */

        case 16:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10952; /* pred_ussubrvvmf2qi */

        case 17:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10956; /* pred_ussubrvvmf4qi */

        case 18:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10960; /* pred_ussubrvvmf8qi */

        case 19:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10964; /* pred_ussubrvvmf2hi */

        case 20:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10968; /* pred_ussubrvvmf4hi */

        case 21:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10972; /* pred_ussubrvvmf2si */

        case 22:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 10976; /* pred_ussubv1qi */

        case 23:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 10980; /* pred_ussubv2qi */

        case 24:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 10984; /* pred_ussubv4qi */

        case 25:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 10988; /* pred_ussubv8qi */

        case 26:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 10992; /* pred_ussubv16qi */

        case 27:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 10996; /* pred_ussubv32qi */

        case 28:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11000; /* pred_ussubv64qi */

        case 29:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11004; /* pred_ussubv128qi */

        case 30:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11008; /* pred_ussubv256qi */

        case 31:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11012; /* pred_ussubv512qi */

        case 32:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11016; /* pred_ussubv1024qi */

        case 33:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11020; /* pred_ussubv2048qi */

        case 34:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11024; /* pred_ussubv4096qi */

        case 35:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 11028; /* pred_ussubv1hi */

        case 36:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 11032; /* pred_ussubv2hi */

        case 37:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 11036; /* pred_ussubv4hi */

        case 38:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 11040; /* pred_ussubv8hi */

        case 39:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 11044; /* pred_ussubv16hi */

        case 40:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11048; /* pred_ussubv32hi */

        case 41:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11052; /* pred_ussubv64hi */

        case 42:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11056; /* pred_ussubv128hi */

        case 43:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11060; /* pred_ussubv256hi */

        case 44:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11064; /* pred_ussubv512hi */

        case 45:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11068; /* pred_ussubv1024hi */

        case 46:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11072; /* pred_ussubv2048hi */

        case 47:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 11076; /* pred_ussubv1si */

        case 48:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 11080; /* pred_ussubv2si */

        case 49:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 11084; /* pred_ussubv4si */

        case 50:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 11088; /* pred_ussubv8si */

        case 51:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11092; /* pred_ussubv16si */

        case 52:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11096; /* pred_ussubv32si */

        case 53:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11100; /* pred_ussubv64si */

        case 54:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11104; /* pred_ussubv128si */

        case 55:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11108; /* pred_ussubv256si */

        case 56:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11112; /* pred_ussubv512si */

        case 57:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11116; /* pred_ussubv1024si */

        case 58:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11120; /* pred_ussubv1di */

        case 59:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11124; /* pred_ussubv2di */

        case 60:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11128; /* pred_ussubv4di */

        case 61:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11132; /* pred_ussubv8di */

        case 62:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11136; /* pred_ussubv16di */

        case 63:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11140; /* pred_ussubv32di */

        case 64:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11144; /* pred_ussubv64di */

        case 65:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11148; /* pred_ussubv128di */

        case 66:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11152; /* pred_ussubv256di */

        case 67:
          if (!(
#line 4318 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11156; /* pred_ussubv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern600 (x2))
        {
        case 0:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11266; /* pred_ussubrvvm8qi_scalar */

        case 1:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11268; /* pred_ussubrvvm4qi_scalar */

        case 2:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11270; /* pred_ussubrvvm2qi_scalar */

        case 3:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11272; /* pred_ussubrvvm1qi_scalar */

        case 4:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11274; /* pred_ussubrvvmf2qi_scalar */

        case 5:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11276; /* pred_ussubrvvmf4qi_scalar */

        case 6:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11278; /* pred_ussubrvvmf8qi_scalar */

        case 7:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11280; /* pred_ussubrvvm8hi_scalar */

        case 8:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11282; /* pred_ussubrvvm4hi_scalar */

        case 9:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11284; /* pred_ussubrvvm2hi_scalar */

        case 10:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11286; /* pred_ussubrvvm1hi_scalar */

        case 11:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11288; /* pred_ussubrvvmf2hi_scalar */

        case 12:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11290; /* pred_ussubrvvmf4hi_scalar */

        case 13:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11292; /* pred_ussubrvvm8si_scalar */

        case 14:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11294; /* pred_ussubrvvm4si_scalar */

        case 15:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11296; /* pred_ussubrvvm2si_scalar */

        case 16:
          if (!
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11298; /* pred_ussubrvvm1si_scalar */

        case 17:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11300; /* pred_ussubrvvmf2si_scalar */

        case 18:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 11302; /* pred_ussubv1qi_scalar */

        case 19:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 11304; /* pred_ussubv2qi_scalar */

        case 20:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 11306; /* pred_ussubv4qi_scalar */

        case 21:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 11308; /* pred_ussubv8qi_scalar */

        case 22:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 11310; /* pred_ussubv16qi_scalar */

        case 23:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 11312; /* pred_ussubv32qi_scalar */

        case 24:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11314; /* pred_ussubv64qi_scalar */

        case 25:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11316; /* pred_ussubv128qi_scalar */

        case 26:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11318; /* pred_ussubv256qi_scalar */

        case 27:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11320; /* pred_ussubv512qi_scalar */

        case 28:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11322; /* pred_ussubv1024qi_scalar */

        case 29:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11324; /* pred_ussubv2048qi_scalar */

        case 30:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11326; /* pred_ussubv4096qi_scalar */

        case 31:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 11328; /* pred_ussubv1hi_scalar */

        case 32:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 11330; /* pred_ussubv2hi_scalar */

        case 33:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 11332; /* pred_ussubv4hi_scalar */

        case 34:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 11334; /* pred_ussubv8hi_scalar */

        case 35:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 11336; /* pred_ussubv16hi_scalar */

        case 36:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11338; /* pred_ussubv32hi_scalar */

        case 37:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11340; /* pred_ussubv64hi_scalar */

        case 38:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11342; /* pred_ussubv128hi_scalar */

        case 39:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11344; /* pred_ussubv256hi_scalar */

        case 40:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11346; /* pred_ussubv512hi_scalar */

        case 41:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11348; /* pred_ussubv1024hi_scalar */

        case 42:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11350; /* pred_ussubv2048hi_scalar */

        case 43:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 11352; /* pred_ussubv1si_scalar */

        case 44:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 11354; /* pred_ussubv2si_scalar */

        case 45:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 11356; /* pred_ussubv4si_scalar */

        case 46:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 11358; /* pred_ussubv8si_scalar */

        case 47:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11360; /* pred_ussubv16si_scalar */

        case 48:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11362; /* pred_ussubv32si_scalar */

        case 49:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11364; /* pred_ussubv64si_scalar */

        case 50:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11366; /* pred_ussubv128si_scalar */

        case 51:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11368; /* pred_ussubv256si_scalar */

        case 52:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11370; /* pred_ussubv512si_scalar */

        case 53:
          if (!(
#line 4369 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11372; /* pred_ussubv1024si_scalar */

        case 54:
          if (!(
#line 4499 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11390; /* *pred_ussubrvvm8di_scalar */

        case 55:
          if (!(
#line 4499 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11392; /* *pred_ussubrvvm4di_scalar */

        case 56:
          if (!(
#line 4499 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11394; /* *pred_ussubrvvm2di_scalar */

        case 57:
          if (!(
#line 4499 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11396; /* *pred_ussubrvvm1di_scalar */

        case 58:
          if (!(
#line 4521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11398; /* *pred_ussubrvvm8di_extended_scalar */

        case 59:
          if (!(
#line 4521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11400; /* *pred_ussubrvvm4di_extended_scalar */

        case 60:
          if (!(
#line 4521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11402; /* *pred_ussubrvvm2di_extended_scalar */

        case 61:
          if (!(
#line 4521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11404; /* *pred_ussubrvvm1di_extended_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_917 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[4] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[5] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[6] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[7] = x10;
      return recog_881 (x1, insn, pnum_clobbers);

    case UNSPEC:
      if (XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 121)
        return -1;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XVECEXP (x5, 0, 0);
      operands[3] = x11;
      x12 = XVECEXP (x5, 0, 1);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[4] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8HFmode:
              if (pattern706 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15128; /* pred_ncopysignrvvm8hf */

            case E_RVVM4HFmode:
              if (pattern706 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15129; /* pred_ncopysignrvvm4hf */

            case E_RVVM2HFmode:
              if (pattern706 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15130; /* pred_ncopysignrvvm2hf */

            case E_RVVM1HFmode:
              if (pattern706 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15131; /* pred_ncopysignrvvm1hf */

            case E_RVVMF2HFmode:
              if (pattern706 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15132; /* pred_ncopysignrvvmf2hf */

            case E_RVVMF4HFmode:
              if (pattern706 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 15133; /* pred_ncopysignrvvmf4hf */

            case E_RVVM8SFmode:
              if (pattern706 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15134; /* pred_ncopysignrvvm8sf */

            case E_RVVM4SFmode:
              if (pattern706 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15135; /* pred_ncopysignrvvm4sf */

            case E_RVVM2SFmode:
              if (pattern706 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15136; /* pred_ncopysignrvvm2sf */

            case E_RVVM1SFmode:
              if (pattern706 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15137; /* pred_ncopysignrvvm1sf */

            case E_RVVMF2SFmode:
              if (pattern706 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 15138; /* pred_ncopysignrvvmf2sf */

            case E_RVVM8DFmode:
              if (pattern706 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15139; /* pred_ncopysignrvvm8df */

            case E_RVVM4DFmode:
              if (pattern706 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15140; /* pred_ncopysignrvvm4df */

            case E_RVVM2DFmode:
              if (pattern706 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15141; /* pred_ncopysignrvvm2df */

            case E_RVVM1DFmode:
              if (pattern706 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 6394 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15142; /* pred_ncopysignrvvm1df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8HFmode:
              if (pattern707 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15239; /* pred_ncopysignrvvm8hf_scalar */

            case E_RVVM4HFmode:
              if (pattern707 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15240; /* pred_ncopysignrvvm4hf_scalar */

            case E_RVVM2HFmode:
              if (pattern707 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15241; /* pred_ncopysignrvvm2hf_scalar */

            case E_RVVM1HFmode:
              if (pattern707 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15242; /* pred_ncopysignrvvm1hf_scalar */

            case E_RVVMF2HFmode:
              if (pattern707 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15243; /* pred_ncopysignrvvmf2hf_scalar */

            case E_RVVMF4HFmode:
              if (pattern707 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 15244; /* pred_ncopysignrvvmf4hf_scalar */

            case E_RVVM8SFmode:
              if (pattern707 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15245; /* pred_ncopysignrvvm8sf_scalar */

            case E_RVVM4SFmode:
              if (pattern707 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15246; /* pred_ncopysignrvvm4sf_scalar */

            case E_RVVM2SFmode:
              if (pattern707 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15247; /* pred_ncopysignrvvm2sf_scalar */

            case E_RVVM1SFmode:
              if (pattern707 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15248; /* pred_ncopysignrvvm1sf_scalar */

            case E_RVVMF2SFmode:
              if (pattern707 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 15249; /* pred_ncopysignrvvmf2sf_scalar */

            case E_RVVM8DFmode:
              if (pattern707 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15250; /* pred_ncopysignrvvm8df_scalar */

            case E_RVVM4DFmode:
              if (pattern707 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15251; /* pred_ncopysignrvvm4df_scalar */

            case E_RVVM2DFmode:
              if (pattern707 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15252; /* pred_ncopysignrvvm2df_scalar */

            case E_RVVM1DFmode:
              if (pattern707 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0
                  || !(
#line 6437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15253; /* pred_ncopysignrvvm1df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_921 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern469 (x2))
    {
    case 0:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 1255; /* *pred_mov_widthwrvvm8qi */

    case 1:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 1261; /* *pred_mov_widthwrvvm4qi */

    case 2:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 1267; /* *pred_mov_widthwrvvm2qi */

    case 3:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 1273; /* *pred_mov_widthwrvvm1qi */

    case 4:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 1279; /* *pred_mov_widthwrvvm8hi */

    case 5:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 1285; /* *pred_mov_widthwrvvm4hi */

    case 6:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 1291; /* *pred_mov_widthwrvvm2hi */

    case 7:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 1297; /* *pred_mov_widthwrvvm1hi */

    case 8:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 1303; /* *pred_mov_widthwrvvm8si */

    case 9:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 1309; /* *pred_mov_widthwrvvm4si */

    case 10:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 1315; /* *pred_mov_widthwrvvm2si */

    case 11:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 1321; /* *pred_mov_widthwrvvm1si */

    case 12:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1327; /* *pred_mov_widthwrvvm8di */

    case 13:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1333; /* *pred_mov_widthwrvvm4di */

    case 14:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1339; /* *pred_mov_widthwrvvm2di */

    case 15:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1345; /* *pred_mov_widthwrvvm1di */

    case 16:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1351; /* *pred_mov_widthwrvvmf2qi */

    case 17:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1357; /* *pred_mov_widthwrvvmf4qi */

    case 18:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1363; /* *pred_mov_widthwrvvmf8qi */

    case 19:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1369; /* *pred_mov_widthwrvvmf2hi */

    case 20:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1375; /* *pred_mov_widthwrvvmf4hi */

    case 21:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1381; /* *pred_mov_widthwrvvmf2si */

    case 22:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1387; /* *pred_mov_widthwrvvm8bf */

    case 23:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1393; /* *pred_mov_widthwrvvm4bf */

    case 24:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1399; /* *pred_mov_widthwrvvm2bf */

    case 25:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1405; /* *pred_mov_widthwrvvm1bf */

    case 26:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1411; /* *pred_mov_widthwrvvmf2bf */

    case 27:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1417; /* *pred_mov_widthwrvvmf4bf */

    case 28:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1423; /* *pred_mov_widthwrvvm8hf */

    case 29:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1429; /* *pred_mov_widthwrvvm4hf */

    case 30:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1435; /* *pred_mov_widthwrvvm2hf */

    case 31:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1441; /* *pred_mov_widthwrvvm1hf */

    case 32:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1447; /* *pred_mov_widthwrvvmf2hf */

    case 33:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1453; /* *pred_mov_widthwrvvmf4hf */

    case 34:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1459; /* *pred_mov_widthwrvvm8sf */

    case 35:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1465; /* *pred_mov_widthwrvvm4sf */

    case 36:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1471; /* *pred_mov_widthwrvvm2sf */

    case 37:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1477; /* *pred_mov_widthwrvvm1sf */

    case 38:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1483; /* *pred_mov_widthwrvvmf2sf */

    case 39:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1489; /* *pred_mov_widthwrvvm8df */

    case 40:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1495; /* *pred_mov_widthwrvvm4df */

    case 41:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1501; /* *pred_mov_widthwrvvm2df */

    case 42:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1507; /* *pred_mov_widthwrvvm1df */

    case 43:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 1513; /* *pred_mov_widthwv1qi */

    case 44:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 1519; /* *pred_mov_widthwv2qi */

    case 45:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 1525; /* *pred_mov_widthwv4qi */

    case 46:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 1531; /* *pred_mov_widthwv8qi */

    case 47:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 1537; /* *pred_mov_widthwv16qi */

    case 48:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 1543; /* *pred_mov_widthwv32qi */

    case 49:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1549; /* *pred_mov_widthwv64qi */

    case 50:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1555; /* *pred_mov_widthwv128qi */

    case 51:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1561; /* *pred_mov_widthwv256qi */

    case 52:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1567; /* *pred_mov_widthwv512qi */

    case 53:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1573; /* *pred_mov_widthwv1024qi */

    case 54:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1579; /* *pred_mov_widthwv2048qi */

    case 55:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1585; /* *pred_mov_widthwv4096qi */

    case 56:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 1591; /* *pred_mov_widthwv1hi */

    case 57:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 1597; /* *pred_mov_widthwv2hi */

    case 58:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 1603; /* *pred_mov_widthwv4hi */

    case 59:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 1609; /* *pred_mov_widthwv8hi */

    case 60:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 1615; /* *pred_mov_widthwv16hi */

    case 61:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1621; /* *pred_mov_widthwv32hi */

    case 62:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1627; /* *pred_mov_widthwv64hi */

    case 63:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1633; /* *pred_mov_widthwv128hi */

    case 64:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1639; /* *pred_mov_widthwv256hi */

    case 65:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1645; /* *pred_mov_widthwv512hi */

    case 66:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1651; /* *pred_mov_widthwv1024hi */

    case 67:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1657; /* *pred_mov_widthwv2048hi */

    case 68:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1663; /* *pred_mov_widthwv1si */

    case 69:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1669; /* *pred_mov_widthwv2si */

    case 70:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1675; /* *pred_mov_widthwv4si */

    case 71:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1681; /* *pred_mov_widthwv8si */

    case 72:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1687; /* *pred_mov_widthwv16si */

    case 73:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1693; /* *pred_mov_widthwv32si */

    case 74:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1699; /* *pred_mov_widthwv64si */

    case 75:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1705; /* *pred_mov_widthwv128si */

    case 76:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1711; /* *pred_mov_widthwv256si */

    case 77:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1717; /* *pred_mov_widthwv512si */

    case 78:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1723; /* *pred_mov_widthwv1024si */

    case 79:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1729; /* *pred_mov_widthwv1di */

    case 80:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1735; /* *pred_mov_widthwv2di */

    case 81:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1741; /* *pred_mov_widthwv4di */

    case 82:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1747; /* *pred_mov_widthwv8di */

    case 83:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1753; /* *pred_mov_widthwv16di */

    case 84:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1759; /* *pred_mov_widthwv32di */

    case 85:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1765; /* *pred_mov_widthwv64di */

    case 86:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1771; /* *pred_mov_widthwv128di */

    case 87:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1777; /* *pred_mov_widthwv256di */

    case 88:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1783; /* *pred_mov_widthwv512di */

    case 89:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1789; /* *pred_mov_widthwv1hf */

    case 90:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1795; /* *pred_mov_widthwv2hf */

    case 91:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1801; /* *pred_mov_widthwv4hf */

    case 92:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1807; /* *pred_mov_widthwv8hf */

    case 93:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1813; /* *pred_mov_widthwv16hf */

    case 94:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1819; /* *pred_mov_widthwv32hf */

    case 95:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1825; /* *pred_mov_widthwv64hf */

    case 96:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1831; /* *pred_mov_widthwv128hf */

    case 97:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1837; /* *pred_mov_widthwv256hf */

    case 98:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1843; /* *pred_mov_widthwv512hf */

    case 99:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1849; /* *pred_mov_widthwv1024hf */

    case 100:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1855; /* *pred_mov_widthwv2048hf */

    case 101:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1861; /* *pred_mov_widthwv1sf */

    case 102:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1867; /* *pred_mov_widthwv2sf */

    case 103:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1873; /* *pred_mov_widthwv4sf */

    case 104:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1879; /* *pred_mov_widthwv8sf */

    case 105:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1885; /* *pred_mov_widthwv16sf */

    case 106:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1891; /* *pred_mov_widthwv32sf */

    case 107:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1897; /* *pred_mov_widthwv64sf */

    case 108:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1903; /* *pred_mov_widthwv128sf */

    case 109:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1909; /* *pred_mov_widthwv256sf */

    case 110:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1915; /* *pred_mov_widthwv512sf */

    case 111:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1921; /* *pred_mov_widthwv1024sf */

    case 112:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1927; /* *pred_mov_widthwv1df */

    case 113:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1933; /* *pred_mov_widthwv2df */

    case 114:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1939; /* *pred_mov_widthwv4df */

    case 115:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1945; /* *pred_mov_widthwv8df */

    case 116:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1951; /* *pred_mov_widthwv16df */

    case 117:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1957; /* *pred_mov_widthwv32df */

    case 118:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1963; /* *pred_mov_widthwv64df */

    case 119:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1969; /* *pred_mov_widthwv128df */

    case 120:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1975; /* *pred_mov_widthwv256df */

    case 121:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1981; /* *pred_mov_widthwv512df */

    default:
      return -1;
    }
}

 int
recog_935 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern719 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[4], E_RVVM4QImode)
          && 
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12236; /* pred_narrow_clipurvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12332; /* pred_narrow_clipurvvm8hi_scalar */

    case 1:
      if (vector_shift_operand (operands[4], E_RVVM2QImode)
          && 
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12238; /* pred_narrow_clipurvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12334; /* pred_narrow_clipurvvm4hi_scalar */

    case 2:
      if (vector_shift_operand (operands[4], E_RVVM1QImode)
          && 
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12240; /* pred_narrow_clipurvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12336; /* pred_narrow_clipurvvm2hi_scalar */

    case 3:
      if (vector_shift_operand (operands[4], E_RVVMF2QImode)
          && 
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12242; /* pred_narrow_clipurvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12338; /* pred_narrow_clipurvvm1hi_scalar */

    case 4:
      if (vector_shift_operand (operands[4], E_RVVMF4QImode)
          && 
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12244; /* pred_narrow_clipurvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12340; /* pred_narrow_clipurvvmf2hi_scalar */

    case 5:
      if (vector_shift_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 12246; /* pred_narrow_clipurvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 12342; /* pred_narrow_clipurvvmf4hi_scalar */

    case 6:
      if (vector_shift_operand (operands[4], E_RVVM4HImode)
          && 
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12248; /* pred_narrow_clipurvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12344; /* pred_narrow_clipurvvm8si_scalar */

    case 7:
      if (vector_shift_operand (operands[4], E_RVVM2HImode)
          && 
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12250; /* pred_narrow_clipurvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12346; /* pred_narrow_clipurvvm4si_scalar */

    case 8:
      if (vector_shift_operand (operands[4], E_RVVM1HImode)
          && 
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12252; /* pred_narrow_clipurvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12348; /* pred_narrow_clipurvvm2si_scalar */

    case 9:
      if (vector_shift_operand (operands[4], E_RVVMF2HImode)
          && 
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12254; /* pred_narrow_clipurvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12350; /* pred_narrow_clipurvvm1si_scalar */

    case 10:
      if (vector_shift_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 12256; /* pred_narrow_clipurvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 12352; /* pred_narrow_clipurvvmf2si_scalar */

    case 11:
      if (vector_shift_operand (operands[4], E_RVVM4SImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12258; /* pred_narrow_clipurvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12354; /* pred_narrow_clipurvvm8di_scalar */

    case 12:
      if (vector_shift_operand (operands[4], E_RVVM2SImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12260; /* pred_narrow_clipurvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12356; /* pred_narrow_clipurvvm4di_scalar */

    case 13:
      if (vector_shift_operand (operands[4], E_RVVM1SImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12262; /* pred_narrow_clipurvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12358; /* pred_narrow_clipurvvm2di_scalar */

    case 14:
      if (vector_shift_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12264; /* pred_narrow_clipurvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12360; /* pred_narrow_clipurvvm1di_scalar */

    case 15:
      if (vector_shift_operand (operands[4], E_V1QImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 12266; /* pred_narrow_clipuv1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12362; /* pred_narrow_clipuv1hi_scalar */

    case 16:
      if (vector_shift_operand (operands[4], E_V2QImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 12268; /* pred_narrow_clipuv2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12364; /* pred_narrow_clipuv2hi_scalar */

    case 17:
      if (vector_shift_operand (operands[4], E_V4QImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12270; /* pred_narrow_clipuv4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12366; /* pred_narrow_clipuv4hi_scalar */

    case 18:
      if (vector_shift_operand (operands[4], E_V8QImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12272; /* pred_narrow_clipuv8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12368; /* pred_narrow_clipuv8hi_scalar */

    case 19:
      if (vector_shift_operand (operands[4], E_V16QImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 12274; /* pred_narrow_clipuv16hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12370; /* pred_narrow_clipuv16hi_scalar */

    case 20:
      if (vector_shift_operand (operands[4], E_V32QImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 12276; /* pred_narrow_clipuv32hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12372; /* pred_narrow_clipuv32hi_scalar */

    case 21:
      if (vector_shift_operand (operands[4], E_V64QImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 12278; /* pred_narrow_clipuv64hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12374; /* pred_narrow_clipuv64hi_scalar */

    case 22:
      if (vector_shift_operand (operands[4], E_V128QImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 12280; /* pred_narrow_clipuv128hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12376; /* pred_narrow_clipuv128hi_scalar */

    case 23:
      if (vector_shift_operand (operands[4], E_V256QImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 12282; /* pred_narrow_clipuv256hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12378; /* pred_narrow_clipuv256hi_scalar */

    case 24:
      if (vector_shift_operand (operands[4], E_V512QImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12284; /* pred_narrow_clipuv512hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12380; /* pred_narrow_clipuv512hi_scalar */

    case 25:
      if (vector_shift_operand (operands[4], E_V1024QImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 12286; /* pred_narrow_clipuv1024hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12382; /* pred_narrow_clipuv1024hi_scalar */

    case 26:
      if (vector_shift_operand (operands[4], E_V2048QImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 12288; /* pred_narrow_clipuv2048hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12384; /* pred_narrow_clipuv2048hi_scalar */

    case 27:
      if (vector_shift_operand (operands[4], E_V1HImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 12290; /* pred_narrow_clipuv1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12386; /* pred_narrow_clipuv1si_scalar */

    case 28:
      if (vector_shift_operand (operands[4], E_V2HImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 12292; /* pred_narrow_clipuv2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12388; /* pred_narrow_clipuv2si_scalar */

    case 29:
      if (vector_shift_operand (operands[4], E_V4HImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12294; /* pred_narrow_clipuv4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12390; /* pred_narrow_clipuv4si_scalar */

    case 30:
      if (vector_shift_operand (operands[4], E_V8HImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12296; /* pred_narrow_clipuv8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12392; /* pred_narrow_clipuv8si_scalar */

    case 31:
      if (vector_shift_operand (operands[4], E_V16HImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 12298; /* pred_narrow_clipuv16si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12394; /* pred_narrow_clipuv16si_scalar */

    case 32:
      if (vector_shift_operand (operands[4], E_V32HImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 12300; /* pred_narrow_clipuv32si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12396; /* pred_narrow_clipuv32si_scalar */

    case 33:
      if (vector_shift_operand (operands[4], E_V64HImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 12302; /* pred_narrow_clipuv64si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12398; /* pred_narrow_clipuv64si_scalar */

    case 34:
      if (vector_shift_operand (operands[4], E_V128HImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 12304; /* pred_narrow_clipuv128si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12400; /* pred_narrow_clipuv128si_scalar */

    case 35:
      if (vector_shift_operand (operands[4], E_V256HImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 12306; /* pred_narrow_clipuv256si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12402; /* pred_narrow_clipuv256si_scalar */

    case 36:
      if (vector_shift_operand (operands[4], E_V512HImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12308; /* pred_narrow_clipuv512si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12404; /* pred_narrow_clipuv512si_scalar */

    case 37:
      if (vector_shift_operand (operands[4], E_V1024HImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 12310; /* pred_narrow_clipuv1024si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12406; /* pred_narrow_clipuv1024si_scalar */

    case 38:
      if (vector_shift_operand (operands[4], E_V1SImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 12312; /* pred_narrow_clipuv1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12408; /* pred_narrow_clipuv1di_scalar */

    case 39:
      if (vector_shift_operand (operands[4], E_V2SImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 12314; /* pred_narrow_clipuv2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12410; /* pred_narrow_clipuv2di_scalar */

    case 40:
      if (vector_shift_operand (operands[4], E_V4SImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 12316; /* pred_narrow_clipuv4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12412; /* pred_narrow_clipuv4di_scalar */

    case 41:
      if (vector_shift_operand (operands[4], E_V8SImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 12318; /* pred_narrow_clipuv8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12414; /* pred_narrow_clipuv8di_scalar */

    case 42:
      if (vector_shift_operand (operands[4], E_V16SImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 12320; /* pred_narrow_clipuv16di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12416; /* pred_narrow_clipuv16di_scalar */

    case 43:
      if (vector_shift_operand (operands[4], E_V32SImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 12322; /* pred_narrow_clipuv32di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12418; /* pred_narrow_clipuv32di_scalar */

    case 44:
      if (vector_shift_operand (operands[4], E_V64SImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 12324; /* pred_narrow_clipuv64di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12420; /* pred_narrow_clipuv64di_scalar */

    case 45:
      if (vector_shift_operand (operands[4], E_V128SImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 12326; /* pred_narrow_clipuv128di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12422; /* pred_narrow_clipuv128di_scalar */

    case 46:
      if (vector_shift_operand (operands[4], E_V256SImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 12328; /* pred_narrow_clipuv256di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12424; /* pred_narrow_clipuv256di_scalar */

    case 47:
      if (vector_shift_operand (operands[4], E_V512SImode)
          && (
#line 4692 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 12330; /* pred_narrow_clipuv512di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12426; /* pred_narrow_clipuv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_1047 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF2HFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15742; /* *pred_mul_neg_addrvvmf2hf_undef */
}

 int
recog_1056 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2DFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15760; /* *pred_mul_neg_addrvvm2df_undef */
}

 int
recog_1065 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128HFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15778; /* *pred_mul_neg_addv128hf_undef */
}

 int
recog_1075 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V32SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V32SFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15798; /* *pred_mul_neg_addv32sf_undef */
}

 int
recog_1085 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16DFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15818; /* *pred_mul_neg_addv16df_undef */
}

 int
recog_1095 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1086 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V32DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 15916; /* *pred_nmsubv32df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 16012; /* *pred_nmsacv32df */
}

 int
recog_1105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1076 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 15896; /* *pred_nmsubv64sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15992; /* *pred_nmsacv64sf */
}

 int
recog_1115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1066 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return 15876; /* *pred_nmsubv256hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15972; /* *pred_nmsacv256hf */
}

 int
recog_1125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1056 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15856; /* *pred_nmsubrvvm2df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15952; /* *pred_nmsacrvvm2df */
}

 int
recog_1135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1046 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM1HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15836; /* *pred_nmsubrvvm1hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15932; /* *pred_nmsacrvvm1hf */
}

 int
recog_1145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1HFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15261; /* *pred_mul_subrvvm1hf_undef */
}

 int
recog_1152 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVMF2SFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15275; /* *pred_mul_subrvvmf2sf_undef */
}

 int
recog_1159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V4HFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15289; /* *pred_mul_subv4hf_undef */
}

 int
recog_1166 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512HFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15303; /* *pred_mul_subv512hf_undef */
}

 int
recog_1173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15317; /* *pred_mul_subv16sf_undef */
}

 int
recog_1180 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1DFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15331; /* *pred_mul_subv1df_undef */
}

 int
recog_1187 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V128DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V128DFmode)
      || !(
#line 6492 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15345; /* *pred_mul_subv128df_undef */
}

 int
recog_1194 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1185 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 15437; /* *pred_msubv32df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15533; /* *pred_msacv32df */
}

 int
recog_1201 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1178 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 15423; /* *pred_msubv512sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15519; /* *pred_msacv512sf */
}

 int
recog_1208 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1171 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15409; /* *pred_msubv4sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15505; /* *pred_msacv4sf */
}

 int
recog_1215 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1164 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return 15395; /* *pred_msubv128hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15491; /* *pred_msacv128hf */
}

 int
recog_1222 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1157 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return 15381; /* *pred_msubv1hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15477; /* *pred_msacv1hf */
}

 int
recog_1229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1150 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM2SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15367; /* *pred_msubrvvm2sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15463; /* *pred_msacrvvm2sf */
}

 int
recog_1236 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1143 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15353; /* *pred_msubrvvm4hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15449; /* *pred_msacrvvm4hf */
}

 int
recog_1244 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8SFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15747; /* *pred_mul_neg_subrvvm8sf_undef */
}

 int
recog_1251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2DFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15761; /* *pred_mul_neg_subrvvm2df_undef */
}

 int
recog_1258 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V32HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V32HFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15775; /* *pred_mul_neg_subv32hf_undef */
}

 int
recog_1265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1SFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15789; /* *pred_mul_neg_subv1sf_undef */
}

 int
recog_1272 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128SFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15803; /* *pred_mul_neg_subv128sf_undef */
}

 int
recog_1279 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8DFmode)
      || !(
#line 6705 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15817; /* *pred_mul_neg_subv8df_undef */
}

 int
recog_1286 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1285 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return 15925; /* *pred_nmaddv512df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 16021; /* *pred_nmaccv512df */
}

 int
recog_1293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1278 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15911; /* *pred_nmaddv4df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 16007; /* *pred_nmaccv4df */
}

 int
recog_1300 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1271 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 15897; /* *pred_nmaddv64sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15993; /* *pred_nmaccv64sf */
}

 int
recog_1307 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1264 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2048HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return 15883; /* *pred_nmaddv2048hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15979; /* *pred_nmaccv2048hf */
}

 int
recog_1315 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1256 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return 15867; /* *pred_nmaddv8hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15963; /* *pred_nmaccv8hf */
}

 int
recog_1323 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1248 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return 15851; /* *pred_nmaddrvvmf2sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15947; /* *pred_nmaccrvvmf2sf */
}

 int
recog_1331 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1240 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15835; /* *pred_nmaddrvvm2hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15931; /* *pred_nmaccrvvm2hf */
}

 int
recog_1339 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[9] = x8;
  x9 = XEXP (x2, 2);
  operands[2] = x9;
  x10 = XEXP (x2, 1);
  x11 = XEXP (x10, 0);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      operands[3] = x11;
      switch (pattern708 (x2))
        {
        case 0:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14499; /* pred_mulrvvm8hf */

        case 1:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14503; /* pred_mulrvvm4hf */

        case 2:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14507; /* pred_mulrvvm2hf */

        case 3:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14511; /* pred_mulrvvm1hf */

        case 4:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14515; /* pred_mulrvvmf2hf */

        case 5:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14519; /* pred_mulrvvmf4hf */

        case 6:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14523; /* pred_mulrvvm8sf */

        case 7:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14527; /* pred_mulrvvm4sf */

        case 8:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14531; /* pred_mulrvvm2sf */

        case 9:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14535; /* pred_mulrvvm1sf */

        case 10:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14539; /* pred_mulrvvmf2sf */

        case 11:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14543; /* pred_mulrvvm8df */

        case 12:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14547; /* pred_mulrvvm4df */

        case 13:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14551; /* pred_mulrvvm2df */

        case 14:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14555; /* pred_mulrvvm1df */

        case 15:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 14559; /* pred_mulv1hf */

        case 16:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 14563; /* pred_mulv2hf */

        case 17:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 14567; /* pred_mulv4hf */

        case 18:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 14571; /* pred_mulv8hf */

        case 19:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 14575; /* pred_mulv16hf */

        case 20:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14579; /* pred_mulv32hf */

        case 21:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14583; /* pred_mulv64hf */

        case 22:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14587; /* pred_mulv128hf */

        case 23:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14591; /* pred_mulv256hf */

        case 24:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14595; /* pred_mulv512hf */

        case 25:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14599; /* pred_mulv1024hf */

        case 26:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14603; /* pred_mulv2048hf */

        case 27:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14607; /* pred_mulv1sf */

        case 28:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14611; /* pred_mulv2sf */

        case 29:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14615; /* pred_mulv4sf */

        case 30:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14619; /* pred_mulv8sf */

        case 31:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14623; /* pred_mulv16sf */

        case 32:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14627; /* pred_mulv32sf */

        case 33:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14631; /* pred_mulv64sf */

        case 34:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14635; /* pred_mulv128sf */

        case 35:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14639; /* pred_mulv256sf */

        case 36:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14643; /* pred_mulv512sf */

        case 37:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14647; /* pred_mulv1024sf */

        case 38:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14651; /* pred_mulv1df */

        case 39:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14655; /* pred_mulv2df */

        case 40:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14659; /* pred_mulv4df */

        case 41:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14663; /* pred_mulv8df */

        case 42:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14667; /* pred_mulv16df */

        case 43:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14671; /* pred_mulv32df */

        case 44:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14675; /* pred_mulv64df */

        case 45:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14679; /* pred_mulv128df */

        case 46:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14683; /* pred_mulv256df */

        case 47:
          if (!(
#line 6192 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14687; /* pred_mulv512df */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern704 (x2))
        {
        case 0:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14883; /* pred_mulrvvm8hf_scalar */

        case 1:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14885; /* pred_mulrvvm4hf_scalar */

        case 2:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14887; /* pred_mulrvvm2hf_scalar */

        case 3:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14889; /* pred_mulrvvm1hf_scalar */

        case 4:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14891; /* pred_mulrvvmf2hf_scalar */

        case 5:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14893; /* pred_mulrvvmf4hf_scalar */

        case 6:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14895; /* pred_mulrvvm8sf_scalar */

        case 7:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14897; /* pred_mulrvvm4sf_scalar */

        case 8:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14899; /* pred_mulrvvm2sf_scalar */

        case 9:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14901; /* pred_mulrvvm1sf_scalar */

        case 10:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14903; /* pred_mulrvvmf2sf_scalar */

        case 11:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14905; /* pred_mulrvvm8df_scalar */

        case 12:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14907; /* pred_mulrvvm4df_scalar */

        case 13:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14909; /* pred_mulrvvm2df_scalar */

        case 14:
          if (!(
#line 6258 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14911; /* pred_mulrvvm1df_scalar */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x12 = XEXP (x10, 1);
      if (GET_CODE (x12) != FLOAT_EXTEND)
        return -1;
      x13 = XEXP (x11, 0);
      operands[3] = x13;
      switch (pattern722 (x2))
        {
        case 0:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16405; /* pred_dual_widen_mulrvvm8sf */

        case 1:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16408; /* pred_dual_widen_mulrvvm4sf */

        case 2:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16411; /* pred_dual_widen_mulrvvm2sf */

        case 3:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16414; /* pred_dual_widen_mulrvvm1sf */

        case 4:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16417; /* pred_dual_widen_mulrvvmf2sf */

        case 5:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16420; /* pred_dual_widen_mulrvvm8df */

        case 6:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16423; /* pred_dual_widen_mulrvvm4df */

        case 7:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16426; /* pred_dual_widen_mulrvvm2df */

        case 8:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16429; /* pred_dual_widen_mulrvvm1df */

        case 9:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16432; /* pred_dual_widen_mulv1sf */

        case 10:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16435; /* pred_dual_widen_mulv2sf */

        case 11:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16438; /* pred_dual_widen_mulv4sf */

        case 12:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16441; /* pred_dual_widen_mulv8sf */

        case 13:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16444; /* pred_dual_widen_mulv16sf */

        case 14:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16447; /* pred_dual_widen_mulv32sf */

        case 15:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16450; /* pred_dual_widen_mulv64sf */

        case 16:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16453; /* pred_dual_widen_mulv128sf */

        case 17:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16456; /* pred_dual_widen_mulv256sf */

        case 18:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16459; /* pred_dual_widen_mulv512sf */

        case 19:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16462; /* pred_dual_widen_mulv1024sf */

        case 20:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16465; /* pred_dual_widen_mulv1df */

        case 21:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16468; /* pred_dual_widen_mulv2df */

        case 22:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16471; /* pred_dual_widen_mulv4df */

        case 23:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16474; /* pred_dual_widen_mulv8df */

        case 24:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16477; /* pred_dual_widen_mulv16df */

        case 25:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16480; /* pred_dual_widen_mulv32df */

        case 26:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16483; /* pred_dual_widen_mulv64df */

        case 27:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16486; /* pred_dual_widen_mulv128df */

        case 28:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16489; /* pred_dual_widen_mulv256df */

        case 29:
          if (!(
#line 7028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16492; /* pred_dual_widen_mulv512df */

        case 30:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16495; /* pred_dual_widen_mulrvvm8sf_scalar */

        case 31:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16498; /* pred_dual_widen_mulrvvm4sf_scalar */

        case 32:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16501; /* pred_dual_widen_mulrvvm2sf_scalar */

        case 33:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16504; /* pred_dual_widen_mulrvvm1sf_scalar */

        case 34:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16507; /* pred_dual_widen_mulrvvmf2sf_scalar */

        case 35:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16510; /* pred_dual_widen_mulrvvm8df_scalar */

        case 36:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16513; /* pred_dual_widen_mulrvvm4df_scalar */

        case 37:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16516; /* pred_dual_widen_mulrvvm2df_scalar */

        case 38:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16519; /* pred_dual_widen_mulrvvm1df_scalar */

        case 39:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16522; /* pred_dual_widen_mulv1sf_scalar */

        case 40:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16525; /* pred_dual_widen_mulv2sf_scalar */

        case 41:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16528; /* pred_dual_widen_mulv4sf_scalar */

        case 42:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16531; /* pred_dual_widen_mulv8sf_scalar */

        case 43:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16534; /* pred_dual_widen_mulv16sf_scalar */

        case 44:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16537; /* pred_dual_widen_mulv32sf_scalar */

        case 45:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16540; /* pred_dual_widen_mulv64sf_scalar */

        case 46:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16543; /* pred_dual_widen_mulv128sf_scalar */

        case 47:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16546; /* pred_dual_widen_mulv256sf_scalar */

        case 48:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16549; /* pred_dual_widen_mulv512sf_scalar */

        case 49:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16552; /* pred_dual_widen_mulv1024sf_scalar */

        case 50:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16555; /* pred_dual_widen_mulv1df_scalar */

        case 51:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16558; /* pred_dual_widen_mulv2df_scalar */

        case 52:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16561; /* pred_dual_widen_mulv4df_scalar */

        case 53:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16564; /* pred_dual_widen_mulv8df_scalar */

        case 54:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16567; /* pred_dual_widen_mulv16df_scalar */

        case 55:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16570; /* pred_dual_widen_mulv32df_scalar */

        case 56:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16573; /* pred_dual_widen_mulv64df_scalar */

        case 57:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16576; /* pred_dual_widen_mulv128df_scalar */

        case 58:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16579; /* pred_dual_widen_mulv256df_scalar */

        case 59:
          if (!(
#line 7055 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16582; /* pred_dual_widen_mulv512df_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1353 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4QImode:
      if (!register_operand (operands[3], E_V4QImode)
          || !vector_arith_operand (operands[4], E_V4QImode)
          || !(
#line 4759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12451; /* *pred_cmpv4qi_merge_tie_mask */

    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode)
          || !vector_arith_operand (operands[4], E_V4HImode)
          || !(
#line 4759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12464; /* *pred_cmpv4hi_merge_tie_mask */

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode)
          || !vector_arith_operand (operands[4], E_V4SImode)
          || !(
#line 4759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12476; /* *pred_cmpv4si_merge_tie_mask */

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || !vector_arith_operand (operands[4], E_V4DImode)
          || !(
#line 4759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12487; /* *pred_cmpv4di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1358 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V128QImode:
      if (!register_operand (operands[3], E_V128QImode)
          || !vector_arith_operand (operands[4], E_V128QImode)
          || !(
#line 4759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12456; /* *pred_cmpv128qi_merge_tie_mask */

    case E_V128HImode:
      if (!register_operand (operands[3], E_V128HImode)
          || !vector_arith_operand (operands[4], E_V128HImode)
          || !(
#line 4759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12469; /* *pred_cmpv128hi_merge_tie_mask */

    case E_V128SImode:
      if (!register_operand (operands[3], E_V128SImode)
          || !vector_arith_operand (operands[4], E_V128SImode)
          || !(
#line 4759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12481; /* *pred_cmpv128si_merge_tie_mask */

    case E_V128DImode:
      if (!register_operand (operands[3], E_V128DImode)
          || !vector_arith_operand (operands[4], E_V128DImode)
          || !(
#line 4759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12492; /* *pred_cmpv128di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1364 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern531 (x2, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V256BImode))
    {
      res = recog_1359 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V256BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V256BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V256QImode:
      if (!register_operand (operands[4], E_V256QImode)
          || !vector_arith_operand (operands[5], E_V256QImode))
        return -1;
      if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256QImode)) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 12525; /* *pred_cmpv256qi */
      if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256QImode)) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12593; /* *pred_cmpv256qi_narrow */

    case E_V256HImode:
      if (!register_operand (operands[4], E_V256HImode)
          || !vector_arith_operand (operands[5], E_V256HImode))
        return -1;
      if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256HImode)) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 12538; /* *pred_cmpv256hi */
      if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256HImode)) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12606; /* *pred_cmpv256hi_narrow */

    case E_V256SImode:
      if (!register_operand (operands[4], E_V256SImode)
          || !vector_arith_operand (operands[5], E_V256SImode))
        return -1;
      if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256SImode)) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 12550; /* *pred_cmpv256si */
      if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256SImode)) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12618; /* *pred_cmpv256si_narrow */

    case E_V256DImode:
      if (!register_operand (operands[4], E_V256DImode)
          || !vector_arith_operand (operands[5], E_V256DImode))
        return -1;
      if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256DImode)) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 12561; /* *pred_cmpv256di */
      if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256DImode)) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12629; /* *pred_cmpv256di_narrow */

    default:
      return -1;
    }
}

 int
recog_1371 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1BImode:
      x2 = XEXP (x1, 1);
      if (pattern531 (x2, 
E_RVVM1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern586 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) == 0
          && 
#line 4759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12427; /* *pred_cmprvvm8qi_merge_tie_mask */
      operands[3] = x3;
      if (pattern587 (x2, 
E_RVVM1BImode, 
E_RVVM8QImode) != 0)
        return -1;
      if (
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8QImode)))
        return 12495; /* *pred_cmprvvm8qi */
      if (!
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8QImode)))
        return -1;
      return 12563; /* *pred_cmprvvm8qi_narrow */

    case E_RVVMF2BImode:
      x2 = XEXP (x1, 1);
      if (pattern531 (x2, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF2BImode))
        {
          res = recog_1345 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM4QImode:
          if (!register_operand (operands[4], E_RVVM4QImode)
              || !vector_arith_operand (operands[5], E_RVVM4QImode))
            return -1;
          if (
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4QImode)))
            return 12496; /* *pred_cmprvvm4qi */
          if (!
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4QImode)))
            return -1;
          return 12564; /* *pred_cmprvvm4qi_narrow */

        case E_RVVM8HImode:
          if (!register_operand (operands[4], E_RVVM8HImode)
              || !vector_arith_operand (operands[5], E_RVVM8HImode))
            return -1;
          if (
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8HImode)))
            return 12499; /* *pred_cmprvvm8hi */
          if (!
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8HImode)))
            return -1;
          return 12567; /* *pred_cmprvvm8hi_narrow */

        default:
          return -1;
        }

    case E_RVVMF4BImode:
      x2 = XEXP (x1, 1);
      if (pattern531 (x2, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF4BImode))
        {
          res = recog_1346 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM2QImode:
          if (!register_operand (operands[4], E_RVVM2QImode)
              || !vector_arith_operand (operands[5], E_RVVM2QImode))
            return -1;
          if (
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2QImode)))
            return 12497; /* *pred_cmprvvm2qi */
          if (!
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2QImode)))
            return -1;
          return 12565; /* *pred_cmprvvm2qi_narrow */

        case E_RVVM4HImode:
          if (!register_operand (operands[4], E_RVVM4HImode)
              || !vector_arith_operand (operands[5], E_RVVM4HImode))
            return -1;
          if (
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4HImode)))
            return 12500; /* *pred_cmprvvm4hi */
          if (!
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4HImode)))
            return -1;
          return 12568; /* *pred_cmprvvm4hi_narrow */

        case E_RVVM8SImode:
          if (!register_operand (operands[4], E_RVVM8SImode)
              || !vector_arith_operand (operands[5], E_RVVM8SImode))
            return -1;
          if (
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8SImode)))
            return 12503; /* *pred_cmprvvm8si */
          if (!
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8SImode)))
            return -1;
          return 12571; /* *pred_cmprvvm8si_narrow */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      x2 = XEXP (x1, 1);
      if (pattern531 (x2, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF8BImode))
        {
          res = recog_1347 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1QImode:
          if (!register_operand (operands[4], E_RVVM1QImode)
              || !vector_arith_operand (operands[5], E_RVVM1QImode))
            return -1;
          if (
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1QImode)))
            return 12498; /* *pred_cmprvvm1qi */
          if (!
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1QImode)))
            return -1;
          return 12566; /* *pred_cmprvvm1qi_narrow */

        case E_RVVM2HImode:
          if (!register_operand (operands[4], E_RVVM2HImode)
              || !vector_arith_operand (operands[5], E_RVVM2HImode))
            return -1;
          if (
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2HImode)))
            return 12501; /* *pred_cmprvvm2hi */
          if (!
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2HImode)))
            return -1;
          return 12569; /* *pred_cmprvvm2hi_narrow */

        case E_RVVM4SImode:
          if (!register_operand (operands[4], E_RVVM4SImode)
              || !vector_arith_operand (operands[5], E_RVVM4SImode))
            return -1;
          if (
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4SImode)))
            return 12504; /* *pred_cmprvvm4si */
          if (!
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4SImode)))
            return -1;
          return 12572; /* *pred_cmprvvm4si_narrow */

        case E_RVVM8DImode:
          if (!register_operand (operands[4], E_RVVM8DImode)
              || !vector_arith_operand (operands[5], E_RVVM8DImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DImode)) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12507; /* *pred_cmprvvm8di */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DImode)) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12575; /* *pred_cmprvvm8di_narrow */

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      x2 = XEXP (x1, 1);
      if (pattern531 (x2, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF16BImode))
        {
          res = recog_1348 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[4], E_RVVM1HImode)
              || !vector_arith_operand (operands[5], E_RVVM1HImode))
            return -1;
          if (
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1HImode)))
            return 12502; /* *pred_cmprvvm1hi */
          if (!
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1HImode)))
            return -1;
          return 12570; /* *pred_cmprvvm1hi_narrow */

        case E_RVVM2SImode:
          if (!register_operand (operands[4], E_RVVM2SImode)
              || !vector_arith_operand (operands[5], E_RVVM2SImode))
            return -1;
          if (
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2SImode)))
            return 12505; /* *pred_cmprvvm2si */
          if (!
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2SImode)))
            return -1;
          return 12573; /* *pred_cmprvvm2si_narrow */

        case E_RVVM4DImode:
          if (!register_operand (operands[4], E_RVVM4DImode)
              || !vector_arith_operand (operands[5], E_RVVM4DImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DImode)) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12508; /* *pred_cmprvvm4di */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DImode)) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12576; /* *pred_cmprvvm4di_narrow */

        case E_RVVMF2QImode:
          if (!register_operand (operands[4], E_RVVMF2QImode)
              || !vector_arith_operand (operands[5], E_RVVMF2QImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2QImode)) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12511; /* *pred_cmprvvmf2qi */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2QImode)) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12579; /* *pred_cmprvvmf2qi_narrow */

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      x2 = XEXP (x1, 1);
      if (pattern531 (x2, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF32BImode))
        {
          res = recog_1349 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[4], E_RVVM1SImode)
              || !vector_arith_operand (operands[5], E_RVVM1SImode))
            return -1;
          if (
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1SImode)))
            return 12506; /* *pred_cmprvvm1si */
          if (!
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1SImode)))
            return -1;
          return 12574; /* *pred_cmprvvm1si_narrow */

        case E_RVVM2DImode:
          if (!register_operand (operands[4], E_RVVM2DImode)
              || !vector_arith_operand (operands[5], E_RVVM2DImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DImode)) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12509; /* *pred_cmprvvm2di */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DImode)) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12577; /* *pred_cmprvvm2di_narrow */

        case E_RVVMF4QImode:
          if (!register_operand (operands[4], E_RVVMF4QImode)
              || !vector_arith_operand (operands[5], E_RVVMF4QImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4QImode)) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12512; /* *pred_cmprvvmf4qi */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4QImode)) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12580; /* *pred_cmprvvmf4qi_narrow */

        case E_RVVMF2HImode:
          if (!register_operand (operands[4], E_RVVMF2HImode)
              || !vector_arith_operand (operands[5], E_RVVMF2HImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2HImode)) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12514; /* *pred_cmprvvmf2hi */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2HImode)) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12582; /* *pred_cmprvvmf2hi_narrow */

        default:
          return -1;
        }

    case E_RVVMF64BImode:
      x2 = XEXP (x1, 1);
      if (pattern531 (x2, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF64BImode))
        {
          res = recog_1350 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1DImode:
          if (!register_operand (operands[4], E_RVVM1DImode)
              || !vector_arith_operand (operands[5], E_RVVM1DImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DImode)) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12510; /* *pred_cmprvvm1di */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DImode)) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12578; /* *pred_cmprvvm1di_narrow */

        case E_RVVMF8QImode:
          if (!register_operand (operands[4], E_RVVMF8QImode)
              || !vector_arith_operand (operands[5], E_RVVMF8QImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF8QImode)) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12513; /* *pred_cmprvvmf8qi */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF8QImode)) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12581; /* *pred_cmprvvmf8qi_narrow */

        case E_RVVMF4HImode:
          if (!register_operand (operands[4], E_RVVMF4HImode)
              || !vector_arith_operand (operands[5], E_RVVMF4HImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4HImode)) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12515; /* *pred_cmprvvmf4hi */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4HImode)) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12583; /* *pred_cmprvvmf4hi_narrow */

        case E_RVVMF2SImode:
          if (!register_operand (operands[4], E_RVVMF2SImode)
              || !vector_arith_operand (operands[5], E_RVVMF2SImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2SImode)) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12516; /* *pred_cmprvvmf2si */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2SImode)) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12584; /* *pred_cmprvvmf2si_narrow */

        default:
          return -1;
        }

    case E_V1BImode:
      x2 = XEXP (x1, 1);
      if (pattern531 (x2, 
E_V1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1BImode))
        {
          res = recog_1351 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V1BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1QImode:
          if (!register_operand (operands[4], E_V1QImode)
              || !vector_arith_operand (operands[5], E_V1QImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1QImode)) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return 12517; /* *pred_cmpv1qi */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1QImode)) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 12585; /* *pred_cmpv1qi_narrow */

        case E_V1HImode:
          if (!register_operand (operands[4], E_V1HImode)
              || !vector_arith_operand (operands[5], E_V1HImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1HImode)) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return 12530; /* *pred_cmpv1hi */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1HImode)) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 12598; /* *pred_cmpv1hi_narrow */

        case E_V1SImode:
          if (!register_operand (operands[4], E_V1SImode)
              || !vector_arith_operand (operands[5], E_V1SImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1SImode)) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return 12542; /* *pred_cmpv1si */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1SImode)) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 12610; /* *pred_cmpv1si_narrow */

        case E_V1DImode:
          if (!register_operand (operands[4], E_V1DImode)
              || !vector_arith_operand (operands[5], E_V1DImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1DImode)) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return 12553; /* *pred_cmpv1di */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1DImode)) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12621; /* *pred_cmpv1di_narrow */

        default:
          return -1;
        }

    case E_V2BImode:
      x2 = XEXP (x1, 1);
      if (pattern531 (x2, 
E_V2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2BImode))
        {
          res = recog_1352 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2QImode:
          if (!register_operand (operands[4], E_V2QImode)
              || !vector_arith_operand (operands[5], E_V2QImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2QImode)) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return 12518; /* *pred_cmpv2qi */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2QImode)) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 12586; /* *pred_cmpv2qi_narrow */

        case E_V2HImode:
          if (!register_operand (operands[4], E_V2HImode)
              || !vector_arith_operand (operands[5], E_V2HImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2HImode)) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return 12531; /* *pred_cmpv2hi */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2HImode)) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 12599; /* *pred_cmpv2hi_narrow */

        case E_V2SImode:
          if (!register_operand (operands[4], E_V2SImode)
              || !vector_arith_operand (operands[5], E_V2SImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2SImode)) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return 12543; /* *pred_cmpv2si */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2SImode)) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 12611; /* *pred_cmpv2si_narrow */

        case E_V2DImode:
          if (!register_operand (operands[4], E_V2DImode)
              || !vector_arith_operand (operands[5], E_V2DImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2DImode)) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return 12554; /* *pred_cmpv2di */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2DImode)) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12622; /* *pred_cmpv2di_narrow */

        default:
          return -1;
        }

    case E_V4BImode:
      return recog_1370 (x1, insn, pnum_clobbers);

    case E_V8BImode:
      return recog_1369 (x1, insn, pnum_clobbers);

    case E_V16BImode:
      return recog_1368 (x1, insn, pnum_clobbers);

    case E_V32BImode:
      return recog_1367 (x1, insn, pnum_clobbers);

    case E_V64BImode:
      return recog_1366 (x1, insn, pnum_clobbers);

    case E_V128BImode:
      return recog_1365 (x1, insn, pnum_clobbers);

    case E_V256BImode:
      return recog_1364 (x1, insn, pnum_clobbers);

    case E_V512BImode:
      return recog_1363 (x1, insn, pnum_clobbers);

    case E_V1024BImode:
      x2 = XEXP (x1, 1);
      if (pattern531 (x2, 
E_V1024BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1024BImode))
        {
          res = recog_1361 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1024QImode:
          if (!register_operand (operands[4], E_V1024QImode)
              || !vector_arith_operand (operands[5], E_V1024QImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024QImode)) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return 12527; /* *pred_cmpv1024qi */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024QImode)) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 12595; /* *pred_cmpv1024qi_narrow */

        case E_V1024HImode:
          if (!register_operand (operands[4], E_V1024HImode)
              || !vector_arith_operand (operands[5], E_V1024HImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024HImode)) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return 12540; /* *pred_cmpv1024hi */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024HImode)) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12608; /* *pred_cmpv1024hi_narrow */

        case E_V1024SImode:
          if (!register_operand (operands[4], E_V1024SImode)
              || !vector_arith_operand (operands[5], E_V1024SImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024SImode)) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return 12552; /* *pred_cmpv1024si */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024SImode)) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12620; /* *pred_cmpv1024si_narrow */

        default:
          return -1;
        }

    case E_V2048BImode:
      x2 = XEXP (x1, 1);
      if (pattern531 (x2, 
E_V2048BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2048BImode))
        {
          res = recog_1362 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2048BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V2048BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2048QImode:
          if (!register_operand (operands[4], E_V2048QImode)
              || !vector_arith_operand (operands[5], E_V2048QImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048QImode)) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return 12528; /* *pred_cmpv2048qi */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048QImode)) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12596; /* *pred_cmpv2048qi_narrow */

        case E_V2048HImode:
          if (!register_operand (operands[4], E_V2048HImode)
              || !vector_arith_operand (operands[5], E_V2048HImode))
            return -1;
          if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048HImode)) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return 12541; /* *pred_cmpv2048hi */
          if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048HImode)) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12609; /* *pred_cmpv2048hi_narrow */

        default:
          return -1;
        }

    case E_V4096BImode:
      x2 = XEXP (x1, 1);
      if (pattern531 (x2, 
E_V4096BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern586 (x2, 
E_V4096QImode, 
E_V4096BImode) == 0
          && (
#line 4759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12461; /* *pred_cmpv4096qi_merge_tie_mask */
      operands[3] = x3;
      if (pattern587 (x2, 
E_V4096BImode, 
E_V4096QImode) != 0)
        return -1;
      if ((
#line 4783 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4096QImode)) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12529; /* *pred_cmpv4096qi */
      if (!(
#line 4804 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4096QImode)) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12597; /* *pred_cmpv4096qi_narrow */

    default:
      return -1;
    }
}

 int
recog_1464 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern543 (x2, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V64BImode))
    {
      res = recog_1456 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V64BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V64BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[4], E_V64HFmode)
          || GET_MODE (x9) != E_V64HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7408 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64HFmode)) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return 17156; /* *pred_cmpv64hf_scalar */
      if (!(
#line 7430 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64HFmode)) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17204; /* *pred_cmpv64hf_scalar_narrow */

    case E_V64SFmode:
      if (!register_operand (operands[4], E_V64SFmode)
          || GET_MODE (x9) != E_V64SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7408 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64SFmode)) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return 17168; /* *pred_cmpv64sf_scalar */
      if (!(
#line 7430 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64SFmode)) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17216; /* *pred_cmpv64sf_scalar_narrow */

    case E_V64DFmode:
      if (!register_operand (operands[4], E_V64DFmode)
          || GET_MODE (x9) != E_V64DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7408 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64DFmode)) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return 17179; /* *pred_cmpv64df_scalar */
      if (!(
#line 7430 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64DFmode)) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17227; /* *pred_cmpv64df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1471 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (XINT (x3, 1) != 91)
    return -1;
  x4 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 7);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x3, 0, 8);
  if (GET_CODE (x6) != REG
      || pattern410 (x3) != 0)
    return -1;
  x7 = XVECEXP (x3, 0, 5);
  if (!const_int_operand (x7, E_VOIDmode)
      || GET_MODE (x6) != E_SImode)
    return -1;
  switch (REGNO (x6))
    {
    case 68:
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 2)
        return -1;
      x9 = XVECEXP (x3, 0, 1);
      operands[5] = x9;
      x10 = XVECEXP (x3, 0, 2);
      operands[6] = x10;
      x11 = XVECEXP (x3, 0, 3);
      operands[7] = x11;
      x12 = XVECEXP (x3, 0, 4);
      operands[8] = x12;
      operands[9] = x7;
      x13 = XVECEXP (x8, 0, 0);
      operands[3] = x13;
      x14 = XEXP (x2, 2);
      operands[2] = x14;
      switch (XINT (x8, 1))
        {
        case 109:
          return recog_933 (x1, insn, pnum_clobbers);

        case 110:
          return recog_932 (x1, insn, pnum_clobbers);

        case 111:
          return recog_931 (x1, insn, pnum_clobbers);

        case 112:
          return recog_930 (x1, insn, pnum_clobbers);

        case 113:
          return recog_929 (x1, insn, pnum_clobbers);

        case 107:
          switch (pattern718 (x2))
            {
            case 0:
              if (register_operand (operands[4], E_RVVM8QImode)
                  && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return 11410; /* pred_ssrlrvvm8qi */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 12151; /* pred_ssrlrvvm8qi_scalar */

            case 1:
              if (register_operand (operands[4], E_RVVM4QImode)
                  && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return 11417; /* pred_ssrlrvvm4qi */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 12153; /* pred_ssrlrvvm4qi_scalar */

            case 2:
              if (register_operand (operands[4], E_RVVM2QImode)
                  && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return 11424; /* pred_ssrlrvvm2qi */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 12155; /* pred_ssrlrvvm2qi_scalar */

            case 3:
              if (register_operand (operands[4], E_RVVM1QImode)
                  && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return 11431; /* pred_ssrlrvvm1qi */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 12157; /* pred_ssrlrvvm1qi_scalar */

            case 4:
              if (register_operand (operands[4], E_RVVM8HImode)
                  && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return 11438; /* pred_ssrlrvvm8hi */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 12159; /* pred_ssrlrvvm8hi_scalar */

            case 5:
              if (register_operand (operands[4], E_RVVM4HImode)
                  && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return 11445; /* pred_ssrlrvvm4hi */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 12161; /* pred_ssrlrvvm4hi_scalar */

            case 6:
              if (register_operand (operands[4], E_RVVM2HImode)
                  && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return 11452; /* pred_ssrlrvvm2hi */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 12163; /* pred_ssrlrvvm2hi_scalar */

            case 7:
              if (register_operand (operands[4], E_RVVM1HImode)
                  && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return 11459; /* pred_ssrlrvvm1hi */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 12165; /* pred_ssrlrvvm1hi_scalar */

            case 8:
              if (register_operand (operands[4], E_RVVM8SImode)
                  && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return 11466; /* pred_ssrlrvvm8si */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 12167; /* pred_ssrlrvvm8si_scalar */

            case 9:
              if (register_operand (operands[4], E_RVVM4SImode)
                  && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return 11473; /* pred_ssrlrvvm4si */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 12169; /* pred_ssrlrvvm4si_scalar */

            case 10:
              if (register_operand (operands[4], E_RVVM2SImode)
                  && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return 11480; /* pred_ssrlrvvm2si */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 12171; /* pred_ssrlrvvm2si_scalar */

            case 11:
              if (register_operand (operands[4], E_RVVM1SImode)
                  && 
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return 11487; /* pred_ssrlrvvm1si */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 12173; /* pred_ssrlrvvm1si_scalar */

            case 12:
              if (register_operand (operands[4], E_RVVM8DImode)
                  && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 11494; /* pred_ssrlrvvm8di */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 12175; /* pred_ssrlrvvm8di_scalar */

            case 13:
              if (register_operand (operands[4], E_RVVM4DImode)
                  && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 11501; /* pred_ssrlrvvm4di */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 12177; /* pred_ssrlrvvm4di_scalar */

            case 14:
              if (register_operand (operands[4], E_RVVM2DImode)
                  && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 11508; /* pred_ssrlrvvm2di */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 12179; /* pred_ssrlrvvm2di_scalar */

            case 15:
              if (register_operand (operands[4], E_RVVM1DImode)
                  && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 11515; /* pred_ssrlrvvm1di */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 12181; /* pred_ssrlrvvm1di_scalar */

            case 16:
              if (register_operand (operands[4], E_RVVMF2QImode)
                  && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return 11522; /* pred_ssrlrvvmf2qi */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 12183; /* pred_ssrlrvvmf2qi_scalar */

            case 17:
              if (register_operand (operands[4], E_RVVMF4QImode)
                  && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return 11529; /* pred_ssrlrvvmf4qi */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 12185; /* pred_ssrlrvvmf4qi_scalar */

            case 18:
              if (register_operand (operands[4], E_RVVMF8QImode)
                  && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return 11536; /* pred_ssrlrvvmf8qi */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 12187; /* pred_ssrlrvvmf8qi_scalar */

            case 19:
              if (register_operand (operands[4], E_RVVMF2HImode)
                  && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return 11543; /* pred_ssrlrvvmf2hi */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 12189; /* pred_ssrlrvvmf2hi_scalar */

            case 20:
              if (register_operand (operands[4], E_RVVMF4HImode)
                  && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return 11550; /* pred_ssrlrvvmf4hi */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 12191; /* pred_ssrlrvvmf4hi_scalar */

            case 21:
              if (register_operand (operands[4], E_RVVMF2SImode)
                  && (
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return 11557; /* pred_ssrlrvvmf2si */
              if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
                  || !(
#line 4588 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 12193; /* pred_ssrlrvvmf2si_scalar */

            case 22:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 11564; /* pred_ssrlv1qi */

            case 23:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 11571; /* pred_ssrlv2qi */

            case 24:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 11578; /* pred_ssrlv4qi */

            case 25:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 11585; /* pred_ssrlv8qi */

            case 26:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 11592; /* pred_ssrlv16qi */

            case 27:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 11599; /* pred_ssrlv32qi */

            case 28:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 11606; /* pred_ssrlv64qi */

            case 29:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 11613; /* pred_ssrlv128qi */

            case 30:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 11620; /* pred_ssrlv256qi */

            case 31:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 11627; /* pred_ssrlv512qi */

            case 32:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 11634; /* pred_ssrlv1024qi */

            case 33:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 11641; /* pred_ssrlv2048qi */

            case 34:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 11648; /* pred_ssrlv4096qi */

            case 35:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 11655; /* pred_ssrlv1hi */

            case 36:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 11662; /* pred_ssrlv2hi */

            case 37:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 11669; /* pred_ssrlv4hi */

            case 38:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 11676; /* pred_ssrlv8hi */

            case 39:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 11683; /* pred_ssrlv16hi */

            case 40:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 11690; /* pred_ssrlv32hi */

            case 41:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 11697; /* pred_ssrlv64hi */

            case 42:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 11704; /* pred_ssrlv128hi */

            case 43:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 11711; /* pred_ssrlv256hi */

            case 44:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 11718; /* pred_ssrlv512hi */

            case 45:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 11725; /* pred_ssrlv1024hi */

            case 46:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 11732; /* pred_ssrlv2048hi */

            case 47:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 11739; /* pred_ssrlv1si */

            case 48:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 11746; /* pred_ssrlv2si */

            case 49:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 11753; /* pred_ssrlv4si */

            case 50:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 11760; /* pred_ssrlv8si */

            case 51:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 11767; /* pred_ssrlv16si */

            case 52:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 11774; /* pred_ssrlv32si */

            case 53:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 11781; /* pred_ssrlv64si */

            case 54:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 11788; /* pred_ssrlv128si */

            case 55:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 11795; /* pred_ssrlv256si */

            case 56:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 11802; /* pred_ssrlv512si */

            case 57:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 11809; /* pred_ssrlv1024si */

            case 58:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 11816; /* pred_ssrlv1di */

            case 59:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 11823; /* pred_ssrlv2di */

            case 60:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 11830; /* pred_ssrlv4di */

            case 61:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 11837; /* pred_ssrlv8di */

            case 62:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 11844; /* pred_ssrlv16di */

            case 63:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 11851; /* pred_ssrlv32di */

            case 64:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 11858; /* pred_ssrlv64di */

            case 65:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 11865; /* pred_ssrlv128di */

            case 66:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 11872; /* pred_ssrlv256di */

            case 67:
              if (!(
#line 4543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 11879; /* pred_ssrlv512di */

            default:
              return -1;
            }

        case 108:
          return recog_936 (x1, insn, pnum_clobbers);

        case 105:
          return recog_934 (x1, insn, pnum_clobbers);

        case 106:
          return recog_935 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case 69:
      return recog_1344 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1478 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern101 (x1))
    {
    case 0:
      if (reg_or_0_operand (operands[1], E_SImode)
          && 
#line 2147 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return 170; /* floatunssisf2 */
      if (!reg_or_0_operand (operands[1], E_DImode)
          || !(
#line 2147 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 171; /* floatunsdisf2 */

    case 1:
      if (reg_or_0_operand (operands[1], E_SImode)
          && (
#line 2147 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return 172; /* floatunssidf2 */
      if (!reg_or_0_operand (operands[1], E_DImode)
          || !(
#line 2147 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 173; /* floatunsdidf2 */

    case 2:
      if (reg_or_0_operand (operands[1], E_SImode)
          && (
#line 2147 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return 174; /* floatunssihf2 */
      if (!reg_or_0_operand (operands[1], E_DImode)
          || !(
#line 2147 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 175; /* floatunsdihf2 */

    case 3:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26492; /* floatunsrvvm8hirvvm8hf2 */

    case 4:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26648; /* floatunsrvvm4qirvvm8hf2 */

    case 5:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26494; /* floatunsrvvm4hirvvm4hf2 */

    case 6:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26650; /* floatunsrvvm2qirvvm4hf2 */

    case 7:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26840; /* floatunsrvvm8sirvvm4hf2 */

    case 8:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26496; /* floatunsrvvm2hirvvm2hf2 */

    case 9:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26652; /* floatunsrvvm1qirvvm2hf2 */

    case 10:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26842; /* floatunsrvvm4sirvvm2hf2 */

    case 11:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26498; /* floatunsrvvm1hirvvm1hf2 */

    case 12:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26654; /* floatunsrvvmf2qirvvm1hf2 */

    case 13:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26844; /* floatunsrvvm2sirvvm1hf2 */

    case 14:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26500; /* floatunsrvvmf2hirvvmf2hf2 */

    case 15:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26656; /* floatunsrvvmf4qirvvmf2hf2 */

    case 16:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26846; /* floatunsrvvm1sirvvmf2hf2 */

    case 17:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26502; /* floatunsrvvmf4hirvvmf4hf2 */

    case 18:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26658; /* floatunsrvvmf8qirvvmf4hf2 */

    case 19:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26848; /* floatunsrvvmf2sirvvmf4hf2 */

    case 20:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26504; /* floatunsrvvm8sirvvm8sf2 */

    case 21:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26660; /* floatunsrvvm4hirvvm8sf2 */

    case 22:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26506; /* floatunsrvvm4sirvvm4sf2 */

    case 23:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26662; /* floatunsrvvm2hirvvm4sf2 */

    case 24:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26850; /* floatunsrvvm8dirvvm4sf2 */

    case 25:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26508; /* floatunsrvvm2sirvvm2sf2 */

    case 26:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26664; /* floatunsrvvm1hirvvm2sf2 */

    case 27:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26852; /* floatunsrvvm4dirvvm2sf2 */

    case 28:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26510; /* floatunsrvvm1sirvvm1sf2 */

    case 29:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26666; /* floatunsrvvmf2hirvvm1sf2 */

    case 30:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26854; /* floatunsrvvm2dirvvm1sf2 */

    case 31:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26512; /* floatunsrvvmf2sirvvmf2sf2 */

    case 32:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26668; /* floatunsrvvmf4hirvvmf2sf2 */

    case 33:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26856; /* floatunsrvvm1dirvvmf2sf2 */

    case 34:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26514; /* floatunsrvvm8dirvvm8df2 */

    case 35:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26670; /* floatunsrvvm4sirvvm8df2 */

    case 36:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26516; /* floatunsrvvm4dirvvm4df2 */

    case 37:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26672; /* floatunsrvvm2sirvvm4df2 */

    case 38:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26518; /* floatunsrvvm2dirvvm2df2 */

    case 39:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26674; /* floatunsrvvm1sirvvm2df2 */

    case 40:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26520; /* floatunsrvvm1dirvvm1df2 */

    case 41:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26676; /* floatunsrvvmf2sirvvm1df2 */

    case 42:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26522; /* floatunsv1hiv1hf2 */

    case 43:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26678; /* floatunsv1qiv1hf2 */

    case 44:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 26858; /* floatunsv1siv1hf2 */

    case 45:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26524; /* floatunsv2hiv2hf2 */

    case 46:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26680; /* floatunsv2qiv2hf2 */

    case 47:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 26860; /* floatunsv2siv2hf2 */

    case 48:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26526; /* floatunsv4hiv4hf2 */

    case 49:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26682; /* floatunsv4qiv4hf2 */

    case 50:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 26862; /* floatunsv4siv4hf2 */

    case 51:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26528; /* floatunsv8hiv8hf2 */

    case 52:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26684; /* floatunsv8qiv8hf2 */

    case 53:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 26864; /* floatunsv8siv8hf2 */

    case 54:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26530; /* floatunsv16hiv16hf2 */

    case 55:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26686; /* floatunsv16qiv16hf2 */

    case 56:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26866; /* floatunsv16siv16hf2 */

    case 57:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26532; /* floatunsv32hiv32hf2 */

    case 58:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26688; /* floatunsv32qiv32hf2 */

    case 59:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26868; /* floatunsv32siv32hf2 */

    case 60:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26534; /* floatunsv64hiv64hf2 */

    case 61:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26690; /* floatunsv64qiv64hf2 */

    case 62:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26870; /* floatunsv64siv64hf2 */

    case 63:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26536; /* floatunsv128hiv128hf2 */

    case 64:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26692; /* floatunsv128qiv128hf2 */

    case 65:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26872; /* floatunsv128siv128hf2 */

    case 66:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26538; /* floatunsv256hiv256hf2 */

    case 67:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26694; /* floatunsv256qiv256hf2 */

    case 68:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26874; /* floatunsv256siv256hf2 */

    case 69:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26540; /* floatunsv512hiv512hf2 */

    case 70:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26696; /* floatunsv512qiv512hf2 */

    case 71:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26876; /* floatunsv512siv512hf2 */

    case 72:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26542; /* floatunsv1024hiv1024hf2 */

    case 73:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26698; /* floatunsv1024qiv1024hf2 */

    case 74:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26878; /* floatunsv1024siv1024hf2 */

    case 75:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26544; /* floatunsv2048hiv2048hf2 */

    case 76:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26700; /* floatunsv2048qiv2048hf2 */

    case 77:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26546; /* floatunsv1siv1sf2 */

    case 78:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26702; /* floatunsv1hiv1sf2 */

    case 79:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26880; /* floatunsv1div1sf2 */

    case 80:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26548; /* floatunsv2siv2sf2 */

    case 81:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26704; /* floatunsv2hiv2sf2 */

    case 82:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26882; /* floatunsv2div2sf2 */

    case 83:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26550; /* floatunsv4siv4sf2 */

    case 84:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26706; /* floatunsv4hiv4sf2 */

    case 85:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26884; /* floatunsv4div4sf2 */

    case 86:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26552; /* floatunsv8siv8sf2 */

    case 87:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26708; /* floatunsv8hiv8sf2 */

    case 88:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26886; /* floatunsv8div8sf2 */

    case 89:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26554; /* floatunsv16siv16sf2 */

    case 90:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26710; /* floatunsv16hiv16sf2 */

    case 91:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26888; /* floatunsv16div16sf2 */

    case 92:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26556; /* floatunsv32siv32sf2 */

    case 93:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26712; /* floatunsv32hiv32sf2 */

    case 94:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26890; /* floatunsv32div32sf2 */

    case 95:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26558; /* floatunsv64siv64sf2 */

    case 96:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26714; /* floatunsv64hiv64sf2 */

    case 97:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26892; /* floatunsv64div64sf2 */

    case 98:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26560; /* floatunsv128siv128sf2 */

    case 99:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26716; /* floatunsv128hiv128sf2 */

    case 100:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26894; /* floatunsv128div128sf2 */

    case 101:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26562; /* floatunsv256siv256sf2 */

    case 102:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26718; /* floatunsv256hiv256sf2 */

    case 103:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26896; /* floatunsv256div256sf2 */

    case 104:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26564; /* floatunsv512siv512sf2 */

    case 105:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26720; /* floatunsv512hiv512sf2 */

    case 106:
      if (!(
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26898; /* floatunsv512div512sf2 */

    case 107:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26566; /* floatunsv1024siv1024sf2 */

    case 108:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26722; /* floatunsv1024hiv1024sf2 */

    case 109:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26568; /* floatunsv1div1df2 */

    case 110:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26724; /* floatunsv1siv1df2 */

    case 111:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26570; /* floatunsv2div2df2 */

    case 112:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26726; /* floatunsv2siv2df2 */

    case 113:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26572; /* floatunsv4div4df2 */

    case 114:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26728; /* floatunsv4siv4df2 */

    case 115:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26574; /* floatunsv8div8df2 */

    case 116:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26730; /* floatunsv8siv8df2 */

    case 117:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26576; /* floatunsv16div16df2 */

    case 118:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26732; /* floatunsv16siv16df2 */

    case 119:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26578; /* floatunsv32div32df2 */

    case 120:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26734; /* floatunsv32siv32df2 */

    case 121:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26580; /* floatunsv64div64df2 */

    case 122:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26736; /* floatunsv64siv64df2 */

    case 123:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26582; /* floatunsv128div128df2 */

    case 124:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26738; /* floatunsv128siv128df2 */

    case 125:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26584; /* floatunsv256div256df2 */

    case 126:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26740; /* floatunsv256siv256df2 */

    case 127:
      if (!(
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26586; /* floatunsv512div512df2 */

    case 128:
      if (!(
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26742; /* floatunsv512siv512df2 */

    default:
      return -1;
    }
}

 int
recog_1488 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 2:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 4092 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 463; /* riscv_frcsr */

        case 4:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 4105 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 465; /* riscv_frflags */

        case 23:
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !(
#line 4732 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 498; /* ssrdpsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !(
#line 4732 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 499; /* ssrdpdi */

            default:
              return -1;
            }

        case 26:
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 7)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[0] = x3;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!immediate_operand (operands[0], E_SImode)
                  || !
#line 4755 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICFILP))
                return -1;
              return 503; /* set_lplsi */

            case E_DImode:
              if (!immediate_operand (operands[0], E_DImode)
                  || !(
#line 4755 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICFILP) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 504; /* set_lpldi */

            default:
              return -1;
            }

        case 28:
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 7)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[0] = x3;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 4769 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICFILP))
                return -1;
              return 506; /* set_guardedsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !(
#line 4769 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICFILP) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 507; /* set_guardeddi */

            default:
              return -1;
            }

        case 31:
          if (pattern179 (x1, 
69) != 0
              || !register_operand (operands[0], E_SImode)
              || !
#line 1126 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 2724; /* fsrmsi_restore_volatile */

        case 231:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!move_operand (operands[1], E_SImode)
              || !
#line 862 "../../gcc/config/riscv/corev.md"
(TARGET_XCVELW && !TARGET_64BIT))
            return -1;
          return 33817; /* riscv_cv_elw_elw_si */

        default:
          return -1;
        }

    case 2:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (XINT (x2, 1))
        {
        case 82:
          x3 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x3))
            {
            case PLUS:
              switch (pattern362 (x2))
                {
                case 0:
                  if (!
#line 100 "../../gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 720; /* atomic_addqi */

                case 1:
                  if (!
#line 100 "../../gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 724; /* atomic_addhi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern362 (x2))
                {
                case 0:
                  if (!
#line 100 "../../gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 721; /* atomic_orqi */

                case 1:
                  if (!
#line 100 "../../gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 725; /* atomic_orhi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern362 (x2))
                {
                case 0:
                  if (!
#line 100 "../../gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 722; /* atomic_xorqi */

                case 1:
                  if (!
#line 100 "../../gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 726; /* atomic_xorhi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern362 (x2))
                {
                case 0:
                  if (!
#line 100 "../../gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 723; /* atomic_andqi */

                case 1:
                  if (!
#line 100 "../../gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 727; /* atomic_andhi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 80:
          x3 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x3))
            {
            case PLUS:
              switch (pattern363 (x2))
                {
                case 0:
                  if (
#line 127 "../../gcc/config/riscv/sync.md"
(TARGET_ZAAMO))
                    return 728; /* amo_atomic_addsi */
                  if (pnum_clobbers == NULL
                      || !
#line 140 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 736; /* lrsc_atomic_addsi */

                case 1:
                  if ((
#line 127 "../../gcc/config/riscv/sync.md"
(TARGET_ZAAMO) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 732; /* amo_atomic_adddi */
                  if (pnum_clobbers == NULL
                      || !(
#line 140 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 740; /* lrsc_atomic_adddi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern363 (x2))
                {
                case 0:
                  if (
#line 127 "../../gcc/config/riscv/sync.md"
(TARGET_ZAAMO))
                    return 729; /* amo_atomic_orsi */
                  if (pnum_clobbers == NULL
                      || !
#line 140 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 737; /* lrsc_atomic_orsi */

                case 1:
                  if ((
#line 127 "../../gcc/config/riscv/sync.md"
(TARGET_ZAAMO) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 733; /* amo_atomic_ordi */
                  if (pnum_clobbers == NULL
                      || !(
#line 140 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 741; /* lrsc_atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern363 (x2))
                {
                case 0:
                  if (
#line 127 "../../gcc/config/riscv/sync.md"
(TARGET_ZAAMO))
                    return 730; /* amo_atomic_xorsi */
                  if (pnum_clobbers == NULL
                      || !
#line 140 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 738; /* lrsc_atomic_xorsi */

                case 1:
                  if ((
#line 127 "../../gcc/config/riscv/sync.md"
(TARGET_ZAAMO) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 734; /* amo_atomic_xordi */
                  if (pnum_clobbers == NULL
                      || !(
#line 140 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 742; /* lrsc_atomic_xordi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern363 (x2))
                {
                case 0:
                  if (
#line 127 "../../gcc/config/riscv/sync.md"
(TARGET_ZAAMO))
                    return 731; /* amo_atomic_andsi */
                  if (pnum_clobbers == NULL
                      || !
#line 140 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 739; /* lrsc_atomic_andsi */

                case 1:
                  if ((
#line 127 "../../gcc/config/riscv/sync.md"
(TARGET_ZAAMO) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 735; /* amo_atomic_anddi */
                  if (pnum_clobbers == NULL
                      || !(
#line 140 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 743; /* lrsc_atomic_anddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 86:
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !memory_operand (operands[1], E_QImode))
                return -1;
              if (
#line 55 "../../gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 788; /* atomic_load_rvwmoqi */
              if (!
#line 49 "../../gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 797; /* atomic_load_ztsoqi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !memory_operand (operands[1], E_HImode))
                return -1;
              if (
#line 55 "../../gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 789; /* atomic_load_rvwmohi */
              if (!
#line 49 "../../gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 798; /* atomic_load_ztsohi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !memory_operand (operands[1], E_SImode))
                return -1;
              if (
#line 55 "../../gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 790; /* atomic_load_rvwmosi */
              if (!
#line 49 "../../gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 799; /* atomic_load_ztsosi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !memory_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 55 "../../gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 791; /* atomic_load_rvwmodi */
              if (!(
#line 49 "../../gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 800; /* atomic_load_ztsodi */

            default:
              return -1;
            }

        case 87:
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!memory_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !reg_or_0_operand (operands[1], E_QImode))
                return -1;
              if (
#line 84 "../../gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 792; /* atomic_store_rvwmoqi */
              if (!
#line 72 "../../gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 801; /* atomic_store_ztsoqi */

            case E_HImode:
              if (!memory_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !reg_or_0_operand (operands[1], E_HImode))
                return -1;
              if (
#line 84 "../../gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 793; /* atomic_store_rvwmohi */
              if (!
#line 72 "../../gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 802; /* atomic_store_ztsohi */

            case E_SImode:
              if (!memory_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !reg_or_0_operand (operands[1], E_SImode))
                return -1;
              if (
#line 84 "../../gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 794; /* atomic_store_rvwmosi */
              if (!
#line 72 "../../gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 803; /* atomic_store_ztsosi */

            case E_DImode:
              if (!memory_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !reg_or_0_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 84 "../../gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 795; /* atomic_store_rvwmodi */
              if (!(
#line 72 "../../gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 804; /* atomic_store_ztsodi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1492 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (reg_or_0_operand (operands[2], E_SImode)
          && (
#line 546 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 573; /* *umaxsi3 */
      if (!register_operand (operands[2], E_SImode)
          || !
#line 625 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 33802; /* riscv_cv_alu_maxu */

    case 1:
      if (!(
#line 546 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 577; /* *umaxdi3 */

    case 2:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24547; /* umaxrvvm8qi3 */

    case 3:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24561; /* umaxrvvm4qi3 */

    case 4:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24575; /* umaxrvvm2qi3 */

    case 5:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24589; /* umaxrvvm1qi3 */

    case 6:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24603; /* umaxrvvm8hi3 */

    case 7:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24617; /* umaxrvvm4hi3 */

    case 8:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24631; /* umaxrvvm2hi3 */

    case 9:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24645; /* umaxrvvm1hi3 */

    case 10:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24659; /* umaxrvvm8si3 */

    case 11:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24673; /* umaxrvvm4si3 */

    case 12:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24687; /* umaxrvvm2si3 */

    case 13:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24701; /* umaxrvvm1si3 */

    case 14:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24715; /* umaxrvvm8di3 */

    case 15:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24729; /* umaxrvvm4di3 */

    case 16:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24743; /* umaxrvvm2di3 */

    case 17:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24757; /* umaxrvvm1di3 */

    case 18:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24771; /* umaxrvvmf2qi3 */

    case 19:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24785; /* umaxrvvmf4qi3 */

    case 20:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24799; /* umaxrvvmf8qi3 */

    case 21:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24813; /* umaxrvvmf2hi3 */

    case 22:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24827; /* umaxrvvmf4hi3 */

    case 23:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24841; /* umaxrvvmf2si3 */

    case 24:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24855; /* umaxv1qi3 */

    case 25:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24869; /* umaxv2qi3 */

    case 26:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24883; /* umaxv4qi3 */

    case 27:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24897; /* umaxv8qi3 */

    case 28:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24911; /* umaxv16qi3 */

    case 29:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24925; /* umaxv32qi3 */

    case 30:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24939; /* umaxv64qi3 */

    case 31:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24953; /* umaxv128qi3 */

    case 32:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24967; /* umaxv256qi3 */

    case 33:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24981; /* umaxv512qi3 */

    case 34:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24995; /* umaxv1024qi3 */

    case 35:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25009; /* umaxv2048qi3 */

    case 36:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25023; /* umaxv4096qi3 */

    case 37:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25037; /* umaxv1hi3 */

    case 38:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25051; /* umaxv2hi3 */

    case 39:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25065; /* umaxv4hi3 */

    case 40:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25079; /* umaxv8hi3 */

    case 41:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25093; /* umaxv16hi3 */

    case 42:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25107; /* umaxv32hi3 */

    case 43:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25121; /* umaxv64hi3 */

    case 44:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25135; /* umaxv128hi3 */

    case 45:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25149; /* umaxv256hi3 */

    case 46:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25163; /* umaxv512hi3 */

    case 47:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25177; /* umaxv1024hi3 */

    case 48:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25191; /* umaxv2048hi3 */

    case 49:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25205; /* umaxv1si3 */

    case 50:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25219; /* umaxv2si3 */

    case 51:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25233; /* umaxv4si3 */

    case 52:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25247; /* umaxv8si3 */

    case 53:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25261; /* umaxv16si3 */

    case 54:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25275; /* umaxv32si3 */

    case 55:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25289; /* umaxv64si3 */

    case 56:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25303; /* umaxv128si3 */

    case 57:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25317; /* umaxv256si3 */

    case 58:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25331; /* umaxv512si3 */

    case 59:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25345; /* umaxv1024si3 */

    case 60:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25359; /* umaxv1di3 */

    case 61:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25373; /* umaxv2di3 */

    case 62:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25387; /* umaxv4di3 */

    case 63:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25401; /* umaxv8di3 */

    case 64:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25415; /* umaxv16di3 */

    case 65:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25429; /* umaxv32di3 */

    case 66:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25443; /* umaxv64di3 */

    case 67:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25457; /* umaxv128di3 */

    case 68:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25471; /* umaxv256di3 */

    case 69:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25485; /* umaxv512di3 */

    default:
      return -1;
    }
}

 int
recog_1501 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern118 (x3))
    {
    case 0:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27939; /* smulrvvm8qi3_highpart */

    case 1:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27941; /* smulrvvm4qi3_highpart */

    case 2:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27943; /* smulrvvm2qi3_highpart */

    case 3:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27945; /* smulrvvm1qi3_highpart */

    case 4:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27947; /* smulrvvmf2qi3_highpart */

    case 5:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27949; /* smulrvvmf4qi3_highpart */

    case 6:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27951; /* smulrvvmf8qi3_highpart */

    case 7:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27953; /* smulrvvm8hi3_highpart */

    case 8:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27955; /* smulrvvm4hi3_highpart */

    case 9:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27957; /* smulrvvm2hi3_highpart */

    case 10:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27959; /* smulrvvm1hi3_highpart */

    case 11:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27961; /* smulrvvmf2hi3_highpart */

    case 12:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27963; /* smulrvvmf4hi3_highpart */

    case 13:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27965; /* smulrvvm8si3_highpart */

    case 14:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27967; /* smulrvvm4si3_highpart */

    case 15:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27969; /* smulrvvm2si3_highpart */

    case 16:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27971; /* smulrvvm1si3_highpart */

    case 17:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27973; /* smulrvvmf2si3_highpart */

    case 18:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27975; /* smulrvvm8di3_highpart */

    case 19:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27977; /* smulrvvm4di3_highpart */

    case 20:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27979; /* smulrvvm2di3_highpart */

    case 21:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27981; /* smulrvvm1di3_highpart */

    case 22:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 27983; /* smulv1qi3_highpart */

    case 23:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 27985; /* smulv2qi3_highpart */

    case 24:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 27987; /* smulv4qi3_highpart */

    case 25:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 27989; /* smulv8qi3_highpart */

    case 26:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 27991; /* smulv16qi3_highpart */

    case 27:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 27993; /* smulv32qi3_highpart */

    case 28:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27995; /* smulv64qi3_highpart */

    case 29:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27997; /* smulv128qi3_highpart */

    case 30:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27999; /* smulv256qi3_highpart */

    case 31:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28001; /* smulv512qi3_highpart */

    case 32:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28003; /* smulv1024qi3_highpart */

    case 33:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28005; /* smulv2048qi3_highpart */

    case 34:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28007; /* smulv4096qi3_highpart */

    case 35:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28009; /* smulv1hi3_highpart */

    case 36:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28011; /* smulv2hi3_highpart */

    case 37:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28013; /* smulv4hi3_highpart */

    case 38:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28015; /* smulv8hi3_highpart */

    case 39:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28017; /* smulv16hi3_highpart */

    case 40:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28019; /* smulv32hi3_highpart */

    case 41:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28021; /* smulv64hi3_highpart */

    case 42:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28023; /* smulv128hi3_highpart */

    case 43:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28025; /* smulv256hi3_highpart */

    case 44:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28027; /* smulv512hi3_highpart */

    case 45:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28029; /* smulv1024hi3_highpart */

    case 46:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28031; /* smulv2048hi3_highpart */

    case 47:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28033; /* smulv1si3_highpart */

    case 48:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28035; /* smulv2si3_highpart */

    case 49:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28037; /* smulv4si3_highpart */

    case 50:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28039; /* smulv8si3_highpart */

    case 51:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28041; /* smulv16si3_highpart */

    case 52:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28043; /* smulv32si3_highpart */

    case 53:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28045; /* smulv64si3_highpart */

    case 54:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 542 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28047; /* smulv128si3_highpart */

    case 55:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 543 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28049; /* smulv256si3_highpart */

    case 56:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 544 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28051; /* smulv512si3_highpart */

    case 57:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 545 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28053; /* smulv1024si3_highpart */

    case 58:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 28055; /* smulv1di3_highpart */

    case 59:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 547 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 28057; /* smulv2di3_highpart */

    case 60:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 548 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 28059; /* smulv4di3_highpart */

    case 61:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 549 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28061; /* smulv8di3_highpart */

    case 62:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 550 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28063; /* smulv16di3_highpart */

    case 63:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 551 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28065; /* smulv32di3_highpart */

    case 64:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 552 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28067; /* smulv64di3_highpart */

    case 65:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 553 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28069; /* smulv128di3_highpart */

    case 66:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 554 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28071; /* smulv256di3_highpart */

    case 67:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 555 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28073; /* smulv512di3_highpart */

    default:
      return -1;
    }
}

 int
recog_1519 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_MODE (x7))
    {
    case E_SImode:
      if (!
#line 3778 "../../gcc/config/riscv/riscv.md"
(is_zicfilp_p ()))
        return -1;
      return 446; /* tablejump_cfisi */

    case E_DImode:
      if (!(
#line 3778 "../../gcc/config/riscv/riscv.md"
(is_zicfilp_p ()) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 447; /* tablejump_cfidi */

    default:
      return -1;
    }
}

 int
recog_1520 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (pattern325 (x3) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 2)
    return -1;
  x8 = XEXP (x5, 1);
  operands[0] = x8;
  if (!stack_push_up_to_ra_operand (operands[0], E_VOIDmode))
    return -1;
  x9 = XEXP (x3, 0);
  x10 = XEXP (x9, 1);
  switch (XWINT (x10, 0))
    {
    case -4L:
      if (pattern546 (x1, 
E_SImode) != 0
          || !(
#line 1111 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 33751; /* gpr_multi_push_up_to_ra_si */

    case -8L:
      if (pattern546 (x1, 
E_DImode) != 0
          || !(
#line 1111 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 33752; /* gpr_multi_push_up_to_ra_di */

    default:
      return -1;
    }
}

 int
recog_1521 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != LABEL_REF)
        return -1;
      x6 = XEXP (x3, 2);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x9 = XEXP (x8, 0);
      operands[4] = x9;
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
          res = recog_1510 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!fp_native_comparison (x4, E_VOIDmode))
        return -1;
      switch (pattern406 (x3))
        {
        case 0:
          if (!(
#line 3366 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            return -1;
          return 371; /* *cbranchsf4 */

        case 1:
          if (!(
#line 3366 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 372; /* *cbranchsf4 */

        case 2:
          if (!(
#line 3366 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            return -1;
          return 373; /* *cbranchdf4 */

        case 3:
          if (!(
#line 3366 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 374; /* *cbranchdf4 */

        case 4:
          if (!(
#line 3366 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            return -1;
          return 375; /* *cbranchhf4 */

        case 5:
          if (!(
#line 3366 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 376; /* *cbranchhf4 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 7
          || XINT (x4, 1) != 91)
        return -1;
      x10 = XVECEXP (x4, 0, 5);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 66
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XVECEXP (x4, 0, 6);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 67
          || GET_MODE (x11) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != UNSPEC
          || XINT (x5, 1) != 135)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x12 = XEXP (x8, 1);
      if (pattern370 (x12, 
136, 
1, 
UNSPEC) != 0)
        return -1;
      x13 = XVECEXP (x12, 0, 0);
      if (GET_CODE (x13) != IF_THEN_ELSE)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != UNSPEC
          || XVECLEN (x14, 0) != 7
          || XINT (x14, 1) != 91)
        return -1;
      x15 = XVECEXP (x14, 0, 5);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 66
          || GET_MODE (x15) != E_SImode)
        return -1;
      x16 = XVECEXP (x14, 0, 6);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 67
          || GET_MODE (x16) != E_SImode)
        return -1;
      x17 = XEXP (x13, 1);
      if (GET_CODE (x17) != UNSPEC
          || XINT (x17, 1) != 135)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 66
          || GET_MODE (x9) != E_SImode)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x18 = XVECEXP (x4, 0, 0);
      operands[1] = x18;
      x19 = XVECEXP (x4, 0, 1);
      operands[4] = x19;
      if (!vector_length_operand (operands[4], E_VOIDmode))
        return -1;
      x20 = XVECEXP (x4, 0, 2);
      operands[5] = x20;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return -1;
      x21 = XVECEXP (x4, 0, 3);
      operands[6] = x21;
      if (!const_int_operand (operands[6], E_VOIDmode))
        return -1;
      x22 = XVECEXP (x4, 0, 4);
      operands[7] = x22;
      if (!const_int_operand (operands[7], E_VOIDmode))
        return -1;
      x6 = XEXP (x3, 2);
      operands[2] = x6;
      x23 = XVECEXP (x14, 0, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      x24 = XVECEXP (x14, 0, 1);
      if (!rtx_equal_p (x24, operands[4]))
        return -1;
      x25 = XVECEXP (x14, 0, 2);
      if (!rtx_equal_p (x25, operands[5]))
        return -1;
      x26 = XVECEXP (x14, 0, 3);
      if (!rtx_equal_p (x26, operands[6]))
        return -1;
      x27 = XVECEXP (x14, 0, 4);
      if (!rtx_equal_p (x27, operands[7]))
        return -1;
      x28 = XEXP (x13, 2);
      if (!rtx_equal_p (x28, operands[2]))
        return -1;
      switch (XVECLEN (x5, 0))
        {
        case 1:
          if (XVECLEN (x17, 0) != 1)
            return -1;
          x29 = XVECEXP (x5, 0, 0);
          operands[3] = x29;
          x30 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x30, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8QImode:
              if (pattern746 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
                  || !
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21065; /* pred_fault_loadrvvm8qi */

            case E_RVVM4QImode:
              if (pattern746 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
                  || !
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21066; /* pred_fault_loadrvvm4qi */

            case E_RVVM2QImode:
              if (pattern746 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
                  || !
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21067; /* pred_fault_loadrvvm2qi */

            case E_RVVM1QImode:
              if (pattern746 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
                  || !
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21068; /* pred_fault_loadrvvm1qi */

            case E_RVVM8HImode:
              if (pattern746 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
                  || !
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21069; /* pred_fault_loadrvvm8hi */

            case E_RVVM4HImode:
              if (pattern746 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
                  || !
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21070; /* pred_fault_loadrvvm4hi */

            case E_RVVM2HImode:
              if (pattern746 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
                  || !
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21071; /* pred_fault_loadrvvm2hi */

            case E_RVVM1HImode:
              if (pattern746 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
                  || !
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21072; /* pred_fault_loadrvvm1hi */

            case E_RVVM8SImode:
              if (pattern746 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
                  || !
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21073; /* pred_fault_loadrvvm8si */

            case E_RVVM4SImode:
              if (pattern746 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
                  || !
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21074; /* pred_fault_loadrvvm4si */

            case E_RVVM2SImode:
              if (pattern746 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
                  || !
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21075; /* pred_fault_loadrvvm2si */

            case E_RVVM1SImode:
              if (pattern746 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
                  || !
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 21076; /* pred_fault_loadrvvm1si */

            case E_RVVM8DImode:
              if (pattern746 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 21077; /* pred_fault_loadrvvm8di */

            case E_RVVM4DImode:
              if (pattern746 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 21078; /* pred_fault_loadrvvm4di */

            case E_RVVM2DImode:
              if (pattern746 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 21079; /* pred_fault_loadrvvm2di */

            case E_RVVM1DImode:
              if (pattern746 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 21080; /* pred_fault_loadrvvm1di */

            case E_RVVMF2QImode:
              if (pattern746 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 21081; /* pred_fault_loadrvvmf2qi */

            case E_RVVMF4QImode:
              if (pattern746 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 21082; /* pred_fault_loadrvvmf4qi */

            case E_RVVMF8QImode:
              if (pattern746 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 21083; /* pred_fault_loadrvvmf8qi */

            case E_RVVMF2HImode:
              if (pattern746 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 21084; /* pred_fault_loadrvvmf2hi */

            case E_RVVMF4HImode:
              if (pattern746 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 21085; /* pred_fault_loadrvvmf4hi */

            case E_RVVMF2SImode:
              if (pattern746 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 21086; /* pred_fault_loadrvvmf2si */

            case E_RVVM8BFmode:
              if (pattern746 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 21087; /* pred_fault_loadrvvm8bf */

            case E_RVVM4BFmode:
              if (pattern746 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 21088; /* pred_fault_loadrvvm4bf */

            case E_RVVM2BFmode:
              if (pattern746 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 21089; /* pred_fault_loadrvvm2bf */

            case E_RVVM1BFmode:
              if (pattern746 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 21090; /* pred_fault_loadrvvm1bf */

            case E_RVVMF2BFmode:
              if (pattern746 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 21091; /* pred_fault_loadrvvmf2bf */

            case E_RVVMF4BFmode:
              if (pattern746 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 21092; /* pred_fault_loadrvvmf4bf */

            case E_RVVM8HFmode:
              if (pattern746 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 21093; /* pred_fault_loadrvvm8hf */

            case E_RVVM4HFmode:
              if (pattern746 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 21094; /* pred_fault_loadrvvm4hf */

            case E_RVVM2HFmode:
              if (pattern746 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 21095; /* pred_fault_loadrvvm2hf */

            case E_RVVM1HFmode:
              if (pattern746 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 21096; /* pred_fault_loadrvvm1hf */

            case E_RVVMF2HFmode:
              if (pattern746 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 21097; /* pred_fault_loadrvvmf2hf */

            case E_RVVMF4HFmode:
              if (pattern746 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 21098; /* pred_fault_loadrvvmf4hf */

            case E_RVVM8SFmode:
              if (pattern746 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 21099; /* pred_fault_loadrvvm8sf */

            case E_RVVM4SFmode:
              if (pattern746 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 21100; /* pred_fault_loadrvvm4sf */

            case E_RVVM2SFmode:
              if (pattern746 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 21101; /* pred_fault_loadrvvm2sf */

            case E_RVVM1SFmode:
              if (pattern746 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 21102; /* pred_fault_loadrvvm1sf */

            case E_RVVMF2SFmode:
              if (pattern746 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 21103; /* pred_fault_loadrvvmf2sf */

            case E_RVVM8DFmode:
              if (pattern746 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 21104; /* pred_fault_loadrvvm8df */

            case E_RVVM4DFmode:
              if (pattern746 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 21105; /* pred_fault_loadrvvm4df */

            case E_RVVM2DFmode:
              if (pattern746 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 21106; /* pred_fault_loadrvvm2df */

            case E_RVVM1DFmode:
              if (pattern746 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 21107; /* pred_fault_loadrvvm1df */

            default:
              return -1;
            }

        case 2:
          x31 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x31) != MEM
              || GET_MODE (x31) != E_BLKmode)
            return -1;
          x32 = XEXP (x31, 0);
          if (GET_CODE (x32) != SCRATCH
              || XVECLEN (x17, 0) != 2)
            return -1;
          x33 = XVECEXP (x17, 0, 1);
          if (GET_CODE (x33) != MEM
              || GET_MODE (x33) != E_BLKmode)
            return -1;
          x34 = XEXP (x33, 0);
          if (GET_CODE (x34) != SCRATCH)
            return -1;
          x29 = XVECEXP (x5, 0, 0);
          operands[3] = x29;
          if (!pmode_reg_or_0_operand (operands[3], E_VOIDmode))
            return -1;
          x30 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x30, operands[3]))
            return -1;
          return recog_1511 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1533 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  if (pattern113 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (pattern371 (x1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 4);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      switch (pattern725 (x1))
        {
        case 0:
          switch (pattern733 (x1, 
E_SImode, 
-28, 
-24, 
-20, 
-16))
            {
            case 0:
              if (!(
#line 157 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33691; /* gpr_multi_pop_up_to_s5_si */

            case 1:
              if (!(
#line 445 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33711; /* gpr_multi_popret_up_to_s3_si */

            case 2:
              if (!(
#line 764 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33731; /* gpr_multi_popretz_up_to_s1_si */

            default:
              return -1;
            }

        case 1:
          switch (pattern733 (x1, 
E_DImode, 
-56, 
-48, 
-40, 
-32))
            {
            case 0:
              if (!(
#line 157 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33692; /* gpr_multi_pop_up_to_s5_di */

            case 1:
              if (!(
#line 445 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33712; /* gpr_multi_popret_up_to_s3_di */

            case 2:
              if (!(
#line 764 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33732; /* gpr_multi_popretz_up_to_s1_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x3) != 21)
        return -1;
      x6 = XEXP (x2, 0);
      if (pattern325 (x6) != 0)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 20)
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != MEM)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 2)
        return -1;
      x12 = XEXP (x10, 1);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XVECEXP (x1, 0, 2);
      x14 = XEXP (x13, 1);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 19)
        return -1;
      x15 = XEXP (x13, 0);
      if (GET_CODE (x15) != MEM)
        return -1;
      x16 = XEXP (x15, 0);
      if (GET_CODE (x16) != PLUS)
        return -1;
      x17 = XEXP (x16, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 2)
        return -1;
      x18 = XEXP (x16, 1);
      if (GET_CODE (x18) != CONST_INT)
        return -1;
      x19 = XVECEXP (x1, 0, 3);
      x20 = XEXP (x19, 1);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 18)
        return -1;
      x21 = XEXP (x19, 0);
      if (GET_CODE (x21) != MEM)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != PLUS)
        return -1;
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != REG
          || REGNO (x23) != 2)
        return -1;
      x24 = XEXP (x22, 1);
      if (GET_CODE (x24) != CONST_INT
          || pattern732 (x1, 
9) != 0
          || pattern736 (x1, 
8) != 0)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      if (pattern535 (x25, 
1) != 0)
        return -1;
      x26 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x26) != SET)
        return -1;
      x27 = XEXP (x26, 1);
      if (GET_CODE (x27) != PLUS)
        return -1;
      x28 = XEXP (x27, 0);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 2)
        return -1;
      x29 = XEXP (x26, 0);
      if (GET_CODE (x29) != REG
          || REGNO (x29) != 2)
        return -1;
      x30 = XEXP (x27, 1);
      operands[0] = x30;
      if (!stack_push_up_to_s5_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern755 (x1))
        {
        case 0:
          if (pattern760 (x1, 
E_SImode) != 0
              || !(
#line 1240 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33763; /* gpr_multi_push_up_to_s5_si */

        case 1:
          if (pattern760 (x1, 
E_DImode) != 0
              || !(
#line 1240 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33764; /* gpr_multi_push_up_to_s5_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1536 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  if (pattern114 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x2) != SET)
    return -1;
  switch (pattern391 (x1, 
23, 
24))
    {
    case 0:
      x3 = XVECEXP (x1, 0, 6);
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != MEM)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 2)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG)
        return -1;
      x9 = XEXP (x2, 0);
      if (GET_CODE (x9) != REG)
        return -1;
      switch (pattern738 (x1))
        {
        case 0:
          if (XWINT (x7, 0) != -24L)
            return -1;
          switch (pattern750 (x1, 
-28, 
E_SImode, 
-32))
            {
            case 0:
              if (pattern774 (x1, 
9) != 0)
                return -1;
              x10 = XVECEXP (x1, 0, 9);
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 8
                  || GET_MODE (x11) != E_SImode)
                return -1;
              x12 = XVECEXP (x1, 0, 10);
              if (pattern786 (x12) != 0
                  || !(
#line 262 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33697; /* gpr_multi_pop_up_to_s8_si */

            case 1:
              if (!(
#line 538 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33717; /* gpr_multi_popret_up_to_s6_si */

            case 2:
              if (!(
#line 848 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33737; /* gpr_multi_popretz_up_to_s4_si */

            default:
              return -1;
            }

        case 1:
          if (XWINT (x7, 0) != -48L)
            return -1;
          switch (pattern750 (x1, 
-56, 
E_DImode, 
-64))
            {
            case 0:
              x13 = XVECEXP (x1, 0, 8);
              if (GET_CODE (x13) != SET)
                return -1;
              x14 = XEXP (x13, 1);
              if (GET_CODE (x14) != MEM
                  || GET_MODE (x14) != E_DImode)
                return -1;
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != PLUS
                  || GET_MODE (x15) != E_DImode)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 2
                  || GET_MODE (x16) != E_DImode)
                return -1;
              x17 = XEXP (x15, 1);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -64])
                return -1;
              x18 = XEXP (x13, 0);
              if (GET_CODE (x18) != REG
                  || REGNO (x18) != 9
                  || GET_MODE (x18) != E_DImode)
                return -1;
              x10 = XVECEXP (x1, 0, 9);
              if (GET_CODE (x10) != SET)
                return -1;
              x19 = XEXP (x10, 1);
              if (GET_CODE (x19) != MEM
                  || GET_MODE (x19) != E_DImode)
                return -1;
              x20 = XEXP (x19, 0);
              if (GET_CODE (x20) != PLUS
                  || GET_MODE (x20) != E_DImode)
                return -1;
              x21 = XEXP (x20, 0);
              if (GET_CODE (x21) != REG
                  || REGNO (x21) != 2
                  || GET_MODE (x21) != E_DImode)
                return -1;
              x22 = XEXP (x20, 1);
              if (GET_CODE (x22) != CONST_INT
                  || XWINT (x22, 0) != -72L)
                return -1;
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 8
                  || GET_MODE (x11) != E_DImode)
                return -1;
              x12 = XVECEXP (x1, 0, 10);
              if (pattern787 (x12) != 0
                  || !(
#line 262 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33698; /* gpr_multi_pop_up_to_s8_di */

            case 1:
              if (!(
#line 538 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33718; /* gpr_multi_popret_up_to_s6_di */

            case 2:
              if (!(
#line 848 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33738; /* gpr_multi_popretz_up_to_s4_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern536 (x1, 
18, 
19, 
20, 
21, 
22) != 0
          || pattern748 (x1, 
9) != 0
          || pattern758 (x1, 
1, 
8) != 0)
        return -1;
      x12 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x12) != SET)
        return -1;
      x23 = XEXP (x12, 1);
      if (GET_CODE (x23) != PLUS)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != REG
          || REGNO (x24) != 2)
        return -1;
      x25 = XEXP (x12, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2)
        return -1;
      x26 = XEXP (x23, 1);
      operands[0] = x26;
      if (!stack_push_up_to_s8_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern765 (x1))
        {
        case 0:
          x10 = XVECEXP (x1, 0, 9);
          x11 = XEXP (x10, 0);
          x27 = XEXP (x11, 0);
          x28 = XEXP (x27, 1);
          if (XWINT (x28, 0) != -40L
              || pattern772 (x1, 
E_SImode) != 0
              || !(
#line 1345 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33769; /* gpr_multi_push_up_to_s8_si */

        case 1:
          x10 = XVECEXP (x1, 0, 9);
          x11 = XEXP (x10, 0);
          x27 = XEXP (x11, 0);
          x28 = XEXP (x27, 1);
          if (XWINT (x28, 0) != -80L
              || pattern772 (x1, 
E_DImode) != 0
              || !(
#line 1345 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33770; /* gpr_multi_push_up_to_s8_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1540 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  if (pattern116 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 9);
  if (pattern754 (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XEXP (x3, 0);
  if (GET_CODE (x8) != REG)
    return -1;
  x9 = XVECEXP (x1, 0, 11);
  if (pattern762 (x9) != 0)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG)
    return -1;
  x11 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG)
    return -1;
  x13 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x13) != RETURN)
    return -1;
  x14 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x14) != USE)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 1
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 0);
  x17 = XEXP (x16, 1);
  x18 = XEXP (x17, 1);
  operands[0] = x18;
  switch (pattern770 (x1))
    {
    case 0:
      switch (pattern779 (x1, 
E_SImode))
        {
        case 0:
          x19 = XEXP (x11, 1);
          if (pattern797 (x19) != 0
              || REGNO (x12) != 8)
            return -1;
          x20 = XVECEXP (x1, 0, 13);
          if (pattern800 (x20) != 0
              || !(
#line 707 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33725; /* gpr_multi_popret_up_to_s11_si */

        case 1:
          if (!(
#line 1048 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33747; /* gpr_multi_popretz_up_to_s9_si */

        default:
          return -1;
        }

    case 1:
      switch (pattern779 (x1, 
E_DImode))
        {
        case 0:
          x19 = XEXP (x11, 1);
          if (pattern798 (x19) != 0
              || REGNO (x12) != 8)
            return -1;
          x20 = XVECEXP (x1, 0, 13);
          if (pattern801 (x20) != 0
              || !(
#line 707 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33726; /* gpr_multi_popret_up_to_s11_di */

        case 1:
          if (!(
#line 1048 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33748; /* gpr_multi_popretz_up_to_s9_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM8QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2587 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM4QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2601 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM2QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2615 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM1QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2629 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM8HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2643 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM4HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2657 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM2HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2671 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM1HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2685 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM8SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2699 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM4SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2713 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM2SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2727 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM1SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2741 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM8DImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2755 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM4DImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2769 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM2DImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2783 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM1DImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2797 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVMF2QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2811 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVMF4QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2825 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVMF8QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2839 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVMF2HImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2853 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVMF4HImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2867 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVMF2SImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2881 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V1QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2895 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V2QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2909 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V4QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2923 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V8QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2937 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V16QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2951 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V32QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2965 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V64QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2979 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V128QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2993 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V256QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3007 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V512QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3021 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V1024QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3035 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V2048QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3049 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V4096QImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3063 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V1HImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3077 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V2HImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3091 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V4HImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3105 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V8HImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3119 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V16HImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3133 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V32HImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3147 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V64HImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3161 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V128HImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3175 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V256HImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3189 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V512HImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3203 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V1024HImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3217 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V2048HImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3231 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V1SImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3245 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V2SImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3259 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V4SImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3273 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V8SImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3287 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V16SImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3301 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V32SImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3315 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V64SImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3329 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V128SImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3343 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V256SImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3357 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V512SImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3371 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V1024SImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3385 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V1DImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3399 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V2DImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3413 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V4DImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3427 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V8DImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3441 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V16DImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3455 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V32DImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3469 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V64DImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3483 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V128DImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3497 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V256DImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3511 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V512DImode) != 0
          || !((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3525 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5553 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5557 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5561 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5565 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5569 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5573 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5577 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5581 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5585 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5589 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5593 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5597 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5601 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5605 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5609 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5613 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5617 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5621 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5625 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5629 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5633 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5637 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5641 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5645 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5649 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5653 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5657 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5661 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5665 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5669 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5673 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5677 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5681 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5685 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5689 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5693 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5697 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5701 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5705 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5709 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5713 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5717 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5721 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5725 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5729 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5733 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5737 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5741 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4DFmode)
      && reg_or_mem_operand (operands[1], E_V4DFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_315 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4DFmode)
       || register_operand (operands[1], V4DFmode))) && 
#line 4336 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4DFmode)
       || !register_operand (operands[1], V4DFmode)))))
        return gen_split_1979 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4DFmode)
      || !register_operand (operands[1], E_V4DFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2162 (insn, operands);
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8SFmode)
      && reg_or_mem_operand (operands[1], E_V8SFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_305 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8SFmode)
       || register_operand (operands[1], V8SFmode))) && 
#line 4332 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8SFmode)
       || !register_operand (operands[1], V8SFmode)))))
        return gen_split_1975 (insn, operands);
    }
  if (!register_operand (operands[0], E_V8SFmode)
      || !register_operand (operands[1], E_V8SFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2152 (insn, operands);
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16HFmode)
      && reg_or_mem_operand (operands[1], E_V16HFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_294 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16HFmode)
       || register_operand (operands[1], V16HFmode))) && 
#line 4328 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16HFmode)
       || !register_operand (operands[1], V16HFmode)))))
        return gen_split_1971 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16HFmode)
      || !register_operand (operands[1], E_V16HFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2141 (insn, operands);
}

 rtx_insn *
split_24 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1HFmode)
      && reg_or_mem_operand (operands[1], E_V1HFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_290 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1HFmode)
       || register_operand (operands[1], V1HFmode))) && 
#line 4324 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1HFmode)
       || !register_operand (operands[1], V1HFmode)))))
        return gen_split_1967 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1HFmode)
      || !register_operand (operands[1], E_V1HFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2137 (insn, operands);
}

 rtx_insn *
split_29 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1DImode)
      && reg_or_mem_operand (operands[1], E_V1DImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return gen_split_280 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1DImode)
       || register_operand (operands[1], V1DImode))) && 
#line 4319 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1DImode)
       || !register_operand (operands[1], V1DImode)))))
        return gen_split_1962 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1DImode)
      || !register_operand (operands[1], E_V1DImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2127 (insn, operands);
}

 rtx_insn *
split_35 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16HImode)
      && reg_or_mem_operand (operands[1], E_V16HImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return gen_split_261 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16HImode)
       || register_operand (operands[1], V16HImode))) && 
#line 4313 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16HImode)
       || !register_operand (operands[1], V16HImode)))))
        return gen_split_1956 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16HImode)
      || !register_operand (operands[1], E_V16HImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2108 (insn, operands);
}

 rtx_insn *
split_41 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8QImode)
      && reg_or_mem_operand (operands[1], E_V8QImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return gen_split_247 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8QImode)
       || register_operand (operands[1], V8QImode))) && 
#line 4307 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8QImode)
       || !register_operand (operands[1], V8QImode)))))
        return gen_split_1950 (insn, operands);
    }
  if (!register_operand (operands[0], E_V8QImode)
      || !register_operand (operands[1], E_V8QImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2094 (insn, operands);
}

 rtx_insn *
split_47 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4BImode)
      && reg_or_mem_operand (operands[1], E_V4BImode)
      && ((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4BImode)
       || register_operand (operands[1], V4BImode))) && 
#line 4342 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4BImode)
       || !register_operand (operands[1], V4BImode)))))
    return gen_split_1984 (insn, operands);
  if (!register_operand (operands[0], E_V4BImode)
      || !register_operand (operands[1], E_V4BImode)
      || !((
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1532 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2172 (insn, operands);
}

 rtx_insn *
split_53 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64DFmode)
      && reg_or_mem_operand (operands[1], E_V64DFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return gen_split_319 (insn, operands);
  if (!register_operand (operands[0], E_V64DFmode)
      || !register_operand (operands[1], E_V64DFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2166 (insn, operands);
}

 rtx_insn *
split_59 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64SFmode)
      && reg_or_mem_operand (operands[1], E_V64SFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return gen_split_308 (insn, operands);
  if (!register_operand (operands[0], E_V64SFmode)
      || !register_operand (operands[1], E_V64SFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2155 (insn, operands);
}

 rtx_insn *
split_65 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128HFmode)
      && reg_or_mem_operand (operands[1], E_V128HFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return gen_split_297 (insn, operands);
  if (!register_operand (operands[0], E_V128HFmode)
      || !register_operand (operands[1], E_V128HFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2144 (insn, operands);
}

 rtx_insn *
split_71 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64DImode)
      && reg_or_mem_operand (operands[1], E_V64DImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return gen_split_286 (insn, operands);
  if (!register_operand (operands[0], E_V64DImode)
      || !register_operand (operands[1], E_V64DImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2133 (insn, operands);
}

 rtx_insn *
split_78 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32SImode)
      && reg_or_mem_operand (operands[1], E_V32SImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return gen_split_274 (insn, operands);
  if (!register_operand (operands[0], E_V32SImode)
      || !register_operand (operands[1], E_V32SImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2121 (insn, operands);
}

 rtx_insn *
split_85 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32HImode)
      && reg_or_mem_operand (operands[1], E_V32HImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return gen_split_262 (insn, operands);
  if (!register_operand (operands[0], E_V32HImode)
      || !register_operand (operands[1], E_V32HImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2109 (insn, operands);
}

 rtx_insn *
split_92 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64QImode)
      && reg_or_mem_operand (operands[1], E_V64QImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return gen_split_250 (insn, operands);
  if (!register_operand (operands[0], E_V64QImode)
      || !register_operand (operands[1], E_V64QImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2097 (insn, operands);
}

 rtx_insn *
split_99 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF32BImode)
      && reg_or_mem_operand (operands[1], E_RVVMF32BImode)
      && 
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_238 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF32BImode)
      || !register_operand (operands[1], E_RVVMF32BImode)
      || !(
#line 1294 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1296 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1575 (insn, operands);
}

 rtx_insn *
split_106 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF2SImode)
      && reg_or_mem_operand (operands[1], E_RVVMF2SImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return gen_split_215 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF2SImode)
      || !register_operand (operands[1], E_RVVMF2SImode)
      || !((
#line 1257 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1259 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1572 (insn, operands);
}

 rtx_insn *
split_113 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern271 (x2))
    {
    case 0:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3540 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3744 (insn, operands);

    case 1:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3543 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3747 (insn, operands);

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3546 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3750 (insn, operands);

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3549 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3753 (insn, operands);

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3552 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3756 (insn, operands);

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3555 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3759 (insn, operands);

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3558 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3762 (insn, operands);

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3561 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3765 (insn, operands);

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3564 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3768 (insn, operands);

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3567 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3771 (insn, operands);

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3570 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3774 (insn, operands);

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3573 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3777 (insn, operands);

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3576 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3780 (insn, operands);

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3579 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3783 (insn, operands);

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3582 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3786 (insn, operands);

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3585 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3789 (insn, operands);

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3588 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3792 (insn, operands);

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3591 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3795 (insn, operands);

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3594 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3798 (insn, operands);

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3597 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3801 (insn, operands);

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3600 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3804 (insn, operands);

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3603 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3807 (insn, operands);

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3606 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3810 (insn, operands);

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3609 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3813 (insn, operands);

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3612 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3816 (insn, operands);

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3615 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3819 (insn, operands);

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3618 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3822 (insn, operands);

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3621 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3825 (insn, operands);

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3624 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3828 (insn, operands);

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3627 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3831 (insn, operands);

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3630 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3834 (insn, operands);

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3633 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3837 (insn, operands);

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3636 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3840 (insn, operands);

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3639 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3843 (insn, operands);

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3642 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3846 (insn, operands);

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3645 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3849 (insn, operands);

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3648 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3852 (insn, operands);

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3651 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3855 (insn, operands);

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3654 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3858 (insn, operands);

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3657 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3861 (insn, operands);

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3660 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3864 (insn, operands);

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3663 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3867 (insn, operands);

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3666 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3870 (insn, operands);

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3669 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3873 (insn, operands);

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3672 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3876 (insn, operands);

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3675 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3879 (insn, operands);

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3678 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3882 (insn, operands);

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3681 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3885 (insn, operands);

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3684 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3888 (insn, operands);

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3687 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3891 (insn, operands);

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3690 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3894 (insn, operands);

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3693 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3897 (insn, operands);

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3696 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3900 (insn, operands);

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3699 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3903 (insn, operands);

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3702 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3906 (insn, operands);

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3705 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3909 (insn, operands);

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3708 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3912 (insn, operands);

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3711 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3915 (insn, operands);

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3714 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3918 (insn, operands);

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3717 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3921 (insn, operands);

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3720 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3924 (insn, operands);

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3723 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3927 (insn, operands);

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3726 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3930 (insn, operands);

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3729 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3933 (insn, operands);

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3732 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3936 (insn, operands);

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3735 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3939 (insn, operands);

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3738 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3942 (insn, operands);

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3741 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !((
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3945 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_122 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 141:
      return split_120 (x1, insn);

    case 144:
      switch (pattern246 (x2))
        {
        case 0:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6189 (insn, operands);

        case 1:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6190 (insn, operands);

        case 2:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6191 (insn, operands);

        case 3:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6192 (insn, operands);

        case 4:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6193 (insn, operands);

        case 5:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6194 (insn, operands);

        case 6:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6204 (insn, operands);

        case 7:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6205 (insn, operands);

        case 8:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6206 (insn, operands);

        case 9:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6207 (insn, operands);

        case 10:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6208 (insn, operands);

        case 11:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6209 (insn, operands);

        case 12:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6210 (insn, operands);

        case 13:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6211 (insn, operands);

        case 14:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6212 (insn, operands);

        case 15:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6213 (insn, operands);

        case 16:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6214 (insn, operands);

        case 17:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6215 (insn, operands);

        case 18:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6195 (insn, operands);

        case 19:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6196 (insn, operands);

        case 20:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6197 (insn, operands);

        case 21:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6198 (insn, operands);

        case 22:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6199 (insn, operands);

        case 23:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6216 (insn, operands);

        case 24:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6217 (insn, operands);

        case 25:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6218 (insn, operands);

        case 26:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6219 (insn, operands);

        case 27:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6220 (insn, operands);

        case 28:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6221 (insn, operands);

        case 29:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6222 (insn, operands);

        case 30:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6223 (insn, operands);

        case 31:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6224 (insn, operands);

        case 32:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6225 (insn, operands);

        case 33:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6226 (insn, operands);

        case 34:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6200 (insn, operands);

        case 35:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6201 (insn, operands);

        case 36:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6202 (insn, operands);

        case 37:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6203 (insn, operands);

        case 38:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6227 (insn, operands);

        case 39:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6228 (insn, operands);

        case 40:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6229 (insn, operands);

        case 41:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6230 (insn, operands);

        case 42:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6231 (insn, operands);

        case 43:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6232 (insn, operands);

        case 44:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6233 (insn, operands);

        case 45:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6234 (insn, operands);

        case 46:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6235 (insn, operands);

        case 47:
          if (!((
#line 2300 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 2302 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6236 (insn, operands);

        case 48:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9080 (insn, operands);

        case 49:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9081 (insn, operands);

        case 50:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9082 (insn, operands);

        case 51:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9083 (insn, operands);

        case 52:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9084 (insn, operands);

        case 53:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9089 (insn, operands);

        case 54:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9090 (insn, operands);

        case 55:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9091 (insn, operands);

        case 56:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9092 (insn, operands);

        case 57:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9093 (insn, operands);

        case 58:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9094 (insn, operands);

        case 59:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9095 (insn, operands);

        case 60:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9096 (insn, operands);

        case 61:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9097 (insn, operands);

        case 62:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9098 (insn, operands);

        case 63:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9099 (insn, operands);

        case 64:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9085 (insn, operands);

        case 65:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9086 (insn, operands);

        case 66:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9087 (insn, operands);

        case 67:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9088 (insn, operands);

        case 68:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9100 (insn, operands);

        case 69:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9101 (insn, operands);

        case 70:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9102 (insn, operands);

        case 71:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9103 (insn, operands);

        case 72:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9104 (insn, operands);

        case 73:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9105 (insn, operands);

        case 74:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9106 (insn, operands);

        case 75:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9107 (insn, operands);

        case 76:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9108 (insn, operands);

        case 77:
          if (!((
#line 828 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 830 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9109 (insn, operands);

        case 78:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9890 (insn, operands);

        case 79:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9891 (insn, operands);

        case 80:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9892 (insn, operands);

        case 81:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9893 (insn, operands);

        case 82:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9894 (insn, operands);

        case 83:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9899 (insn, operands);

        case 84:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9900 (insn, operands);

        case 85:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9901 (insn, operands);

        case 86:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9902 (insn, operands);

        case 87:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9903 (insn, operands);

        case 88:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9904 (insn, operands);

        case 89:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9905 (insn, operands);

        case 90:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9906 (insn, operands);

        case 91:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9907 (insn, operands);

        case 92:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9908 (insn, operands);

        case 93:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9909 (insn, operands);

        case 94:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9895 (insn, operands);

        case 95:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9896 (insn, operands);

        case 96:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9897 (insn, operands);

        case 97:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9898 (insn, operands);

        case 98:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9910 (insn, operands);

        case 99:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9911 (insn, operands);

        case 100:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9912 (insn, operands);

        case 101:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9913 (insn, operands);

        case 102:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9914 (insn, operands);

        case 103:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9915 (insn, operands);

        case 104:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9916 (insn, operands);

        case 105:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9917 (insn, operands);

        case 106:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9918 (insn, operands);

        case 107:
          if (!((
#line 1319 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1321 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9919 (insn, operands);

        case 108:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9920 (insn, operands);

        case 109:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9921 (insn, operands);

        case 110:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9922 (insn, operands);

        case 111:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9923 (insn, operands);

        case 112:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9924 (insn, operands);

        case 113:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9929 (insn, operands);

        case 114:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9930 (insn, operands);

        case 115:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9931 (insn, operands);

        case 116:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9932 (insn, operands);

        case 117:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9933 (insn, operands);

        case 118:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9934 (insn, operands);

        case 119:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9935 (insn, operands);

        case 120:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9936 (insn, operands);

        case 121:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9937 (insn, operands);

        case 122:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9938 (insn, operands);

        case 123:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9939 (insn, operands);

        case 124:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9925 (insn, operands);

        case 125:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9926 (insn, operands);

        case 126:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9927 (insn, operands);

        case 127:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9928 (insn, operands);

        case 128:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9940 (insn, operands);

        case 129:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9941 (insn, operands);

        case 130:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9942 (insn, operands);

        case 131:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9943 (insn, operands);

        case 132:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9944 (insn, operands);

        case 133:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9945 (insn, operands);

        case 134:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9946 (insn, operands);

        case 135:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9947 (insn, operands);

        case 136:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9948 (insn, operands);

        case 137:
          if (!((
#line 1376 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1378 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9949 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_130 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_804 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_810 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_816 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_822 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_828 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_834 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_840 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_846 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_852 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_858 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_864 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_870 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_876 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_882 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_888 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_894 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_900 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_906 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_912 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_918 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_924 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_930 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_936 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_942 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_948 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_954 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_960 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_966 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_972 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_978 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_984 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_990 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_996 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_1002 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_1008 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_1014 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_1020 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_1026 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_1032 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_1038 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_1044 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_1050 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_1056 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_1062 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_1068 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_1074 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_1080 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_1086 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_1092 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_1098 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_1104 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_1110 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_1116 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_1122 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_1128 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_1134 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_1140 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_1146 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_1152 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_1158 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_1164 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_1170 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_1176 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_1182 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_1188 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_1194 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_1200 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_1206 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_1212 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_1218 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_1224 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_1230 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_1236 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_1242 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_1248 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_1254 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_1260 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_1266 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_1272 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_1278 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_1284 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_1290 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_1296 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_1302 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_1308 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_1314 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_1320 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_1326 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_1332 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_1338 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_1344 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_1350 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_1356 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_1362 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_1368 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_1374 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_1380 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_1386 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_1392 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_1398 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_1404 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_1410 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_1416 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_1422 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_1428 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_1434 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_1440 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_1446 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_1452 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_1458 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_1464 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_1470 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_1476 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_1482 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_1488 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_1494 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_1500 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_1506 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_1512 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_1518 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_1524 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_1530 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_140 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF64BImode:
      if (!register_operand (operands[0], E_RVVMF64BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || !((
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4007 (insn, operands);

    case E_RVVMF32BImode:
      if (!register_operand (operands[0], E_RVVMF32BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4008 (insn, operands);

    case E_RVVMF16BImode:
      if (!register_operand (operands[0], E_RVVMF16BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4009 (insn, operands);

    case E_RVVMF8BImode:
      if (!register_operand (operands[0], E_RVVMF8BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4010 (insn, operands);

    case E_RVVMF4BImode:
      if (!register_operand (operands[0], E_RVVMF4BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4011 (insn, operands);

    case E_RVVMF2BImode:
      if (!register_operand (operands[0], E_RVVMF2BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2BImode
          || !register_operand (operands[1], E_RVVMF2BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4012 (insn, operands);

    case E_RVVM1BImode:
      if (!register_operand (operands[0], E_RVVM1BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1BImode
          || !register_operand (operands[1], E_RVVM1BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4013 (insn, operands);

    case E_V1BImode:
      if (!register_operand (operands[0], E_V1BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1BImode
          || !register_operand (operands[1], E_V1BImode)
          || !((
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4014 (insn, operands);

    case E_V2BImode:
      if (!register_operand (operands[0], E_V2BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2BImode
          || !register_operand (operands[1], E_V2BImode)
          || !((
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4015 (insn, operands);

    case E_V4BImode:
      if (!register_operand (operands[0], E_V4BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BImode
          || !register_operand (operands[1], E_V4BImode)
          || !((
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4016 (insn, operands);

    case E_V8BImode:
      if (!register_operand (operands[0], E_V8BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BImode
          || !register_operand (operands[1], E_V8BImode)
          || !((
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4017 (insn, operands);

    case E_V16BImode:
      if (!register_operand (operands[0], E_V16BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16BImode
          || !register_operand (operands[1], E_V16BImode)
          || !((
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4018 (insn, operands);

    case E_V32BImode:
      if (!register_operand (operands[0], E_V32BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32BImode
          || !register_operand (operands[1], E_V32BImode)
          || !((
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4019 (insn, operands);

    case E_V64BImode:
      if (!register_operand (operands[0], E_V64BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64BImode
          || !register_operand (operands[1], E_V64BImode)
          || !((
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4020 (insn, operands);

    case E_V128BImode:
      if (!register_operand (operands[0], E_V128BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128BImode
          || !register_operand (operands[1], E_V128BImode)
          || !((
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4021 (insn, operands);

    case E_V256BImode:
      if (!register_operand (operands[0], E_V256BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256BImode
          || !register_operand (operands[1], E_V256BImode)
          || !((
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4022 (insn, operands);

    case E_V512BImode:
      if (!register_operand (operands[0], E_V512BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512BImode
          || !register_operand (operands[1], E_V512BImode)
          || !((
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4023 (insn, operands);

    case E_V1024BImode:
      if (!register_operand (operands[0], E_V1024BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024BImode
          || !register_operand (operands[1], E_V1024BImode)
          || !((
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4024 (insn, operands);

    case E_V2048BImode:
      if (!register_operand (operands[0], E_V2048BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048BImode
          || !register_operand (operands[1], E_V2048BImode)
          || !((
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4025 (insn, operands);

    case E_V4096BImode:
      if (!register_operand (operands[0], E_V4096BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096BImode
          || !register_operand (operands[1], E_V4096BImode)
          || !((
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4026 (insn, operands);

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4946 (insn, operands);

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4948 (insn, operands);

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4950 (insn, operands);

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4952 (insn, operands);

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4954 (insn, operands);

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4956 (insn, operands);

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4958 (insn, operands);

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4960 (insn, operands);

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4962 (insn, operands);

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4964 (insn, operands);

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4966 (insn, operands);

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4968 (insn, operands);

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4970 (insn, operands);

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4972 (insn, operands);

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4974 (insn, operands);

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4976 (insn, operands);

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4978 (insn, operands);

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4980 (insn, operands);

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4982 (insn, operands);

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4984 (insn, operands);

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4986 (insn, operands);

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4988 (insn, operands);

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4990 (insn, operands);

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4992 (insn, operands);

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4994 (insn, operands);

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4996 (insn, operands);

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4998 (insn, operands);

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5000 (insn, operands);

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5002 (insn, operands);

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5004 (insn, operands);

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5006 (insn, operands);

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5008 (insn, operands);

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5010 (insn, operands);

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5012 (insn, operands);

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5014 (insn, operands);

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5016 (insn, operands);

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5018 (insn, operands);

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5020 (insn, operands);

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5022 (insn, operands);

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5024 (insn, operands);

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5026 (insn, operands);

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5028 (insn, operands);

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5030 (insn, operands);

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5032 (insn, operands);

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5034 (insn, operands);

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5036 (insn, operands);

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5038 (insn, operands);

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5040 (insn, operands);

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5042 (insn, operands);

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5044 (insn, operands);

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5046 (insn, operands);

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5048 (insn, operands);

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5050 (insn, operands);

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5052 (insn, operands);

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5054 (insn, operands);

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5056 (insn, operands);

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5058 (insn, operands);

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5060 (insn, operands);

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5062 (insn, operands);

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5064 (insn, operands);

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5066 (insn, operands);

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5068 (insn, operands);

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5070 (insn, operands);

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5072 (insn, operands);

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5074 (insn, operands);

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5076 (insn, operands);

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5078 (insn, operands);

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode)
          || !((
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5080 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_148 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern372 (x2, 
E_SImode) != 0
                  || !
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))
                return NULL;
              return gen_split_1 (insn, operands);

            case E_DImode:
              if (pattern372 (x2, 
E_DImode) != 0
                  || !
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))
                return NULL;
              return gen_split_2 (insn, operands);

            default:
              return NULL;
            }

        case CONST_VECTOR:
        case REG:
        case SUBREG:
          return split_1 (x1, insn);

        default:
          return NULL;
        }

    case PLUS:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != AND
          || GET_MODE (x5) != E_DImode)
        return NULL;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != ASHIFT
          || GET_MODE (x6) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return NULL;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!imm123_operand (operands[2], E_QImode))
        return NULL;
      x9 = XEXP (x5, 1);
      operands[3] = x9;
      if (!consecutive_bits32_operand (operands[3], E_VOIDmode))
        return NULL;
      x10 = XEXP (x3, 1);
      operands[4] = x10;
      if (!register_operand (operands[4], E_DImode))
        return NULL;
      x4 = XEXP (x2, 1);
      operands[5] = x4;
      if (!immediate_operand (operands[5], E_VOIDmode)
          || !
#line 197 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA))
        return NULL;
      return gen_split_111 (insn, operands);

    case MULT:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          x4 = XEXP (x2, 1);
          operands[3] = x4;
          return split_2 (x1, insn);

        case SIGN_EXTEND:
          return split_4 (x1, insn);

        case ZERO_EXTEND:
          return split_5 (x1, insn);

        case FLOAT_EXTEND:
          switch (pattern139 (x2))
            {
            case 0:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9458 (insn, operands);

            case 1:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9459 (insn, operands);

            case 2:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9460 (insn, operands);

            case 3:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9461 (insn, operands);

            case 4:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9462 (insn, operands);

            case 5:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9463 (insn, operands);

            case 6:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9464 (insn, operands);

            case 7:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9465 (insn, operands);

            case 8:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9466 (insn, operands);

            case 9:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9467 (insn, operands);

            case 10:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9468 (insn, operands);

            case 11:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9469 (insn, operands);

            case 12:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9470 (insn, operands);

            case 13:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9471 (insn, operands);

            case 14:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9472 (insn, operands);

            case 15:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9473 (insn, operands);

            case 16:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9474 (insn, operands);

            case 17:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9475 (insn, operands);

            case 18:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9476 (insn, operands);

            case 19:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9477 (insn, operands);

            case 20:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9478 (insn, operands);

            case 21:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9479 (insn, operands);

            case 22:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9480 (insn, operands);

            case 23:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9481 (insn, operands);

            case 24:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9482 (insn, operands);

            case 25:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9483 (insn, operands);

            case 26:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9484 (insn, operands);

            case 27:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9485 (insn, operands);

            case 28:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9486 (insn, operands);

            case 29:
              if (!((
#line 1004 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1006 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9487 (insn, operands);

            case 30:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9488 (insn, operands);

            case 31:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9489 (insn, operands);

            case 32:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9490 (insn, operands);

            case 33:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9491 (insn, operands);

            case 34:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9492 (insn, operands);

            case 35:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9493 (insn, operands);

            case 36:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9494 (insn, operands);

            case 37:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9495 (insn, operands);

            case 38:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9496 (insn, operands);

            case 39:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9497 (insn, operands);

            case 40:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9498 (insn, operands);

            case 41:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9499 (insn, operands);

            case 42:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9500 (insn, operands);

            case 43:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9501 (insn, operands);

            case 44:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9502 (insn, operands);

            case 45:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9503 (insn, operands);

            case 46:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9504 (insn, operands);

            case 47:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9505 (insn, operands);

            case 48:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9506 (insn, operands);

            case 49:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9507 (insn, operands);

            case 50:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9508 (insn, operands);

            case 51:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9509 (insn, operands);

            case 52:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9510 (insn, operands);

            case 53:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9511 (insn, operands);

            case 54:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9512 (insn, operands);

            case 55:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9513 (insn, operands);

            case 56:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9514 (insn, operands);

            case 57:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9515 (insn, operands);

            case 58:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9516 (insn, operands);

            case 59:
              if (!((
#line 1028 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1030 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9517 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      return split_7 (x1, insn);

    case ZERO_EXTEND:
      return split_6 (x1, insn);

    case FLOAT_EXTEND:
      switch (pattern131 (x2))
        {
        case 0:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8804 (insn, operands);

        case 1:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8807 (insn, operands);

        case 2:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8810 (insn, operands);

        case 3:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8813 (insn, operands);

        case 4:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8816 (insn, operands);

        case 5:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8819 (insn, operands);

        case 6:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8822 (insn, operands);

        case 7:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8825 (insn, operands);

        case 8:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8828 (insn, operands);

        case 9:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8831 (insn, operands);

        case 10:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8834 (insn, operands);

        case 11:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8837 (insn, operands);

        case 12:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8840 (insn, operands);

        case 13:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8843 (insn, operands);

        case 14:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8846 (insn, operands);

        case 15:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8849 (insn, operands);

        case 16:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8852 (insn, operands);

        case 17:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8855 (insn, operands);

        case 18:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8858 (insn, operands);

        case 19:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8861 (insn, operands);

        case 20:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8864 (insn, operands);

        case 21:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8867 (insn, operands);

        case 22:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8870 (insn, operands);

        case 23:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8873 (insn, operands);

        case 24:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8876 (insn, operands);

        case 25:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8879 (insn, operands);

        case 26:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8882 (insn, operands);

        case 27:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8885 (insn, operands);

        case 28:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8888 (insn, operands);

        case 29:
          if (!((
#line 729 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 731 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8891 (insn, operands);

        case 30:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8894 (insn, operands);

        case 31:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8895 (insn, operands);

        case 32:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8896 (insn, operands);

        case 33:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8897 (insn, operands);

        case 34:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8898 (insn, operands);

        case 35:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8899 (insn, operands);

        case 36:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8900 (insn, operands);

        case 37:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8901 (insn, operands);

        case 38:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8902 (insn, operands);

        case 39:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8903 (insn, operands);

        case 40:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8904 (insn, operands);

        case 41:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8905 (insn, operands);

        case 42:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8906 (insn, operands);

        case 43:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8907 (insn, operands);

        case 44:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8908 (insn, operands);

        case 45:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8909 (insn, operands);

        case 46:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8910 (insn, operands);

        case 47:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8911 (insn, operands);

        case 48:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8912 (insn, operands);

        case 49:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8913 (insn, operands);

        case 50:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8914 (insn, operands);

        case 51:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8915 (insn, operands);

        case 52:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8916 (insn, operands);

        case 53:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8917 (insn, operands);

        case 54:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8918 (insn, operands);

        case 55:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8919 (insn, operands);

        case 56:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8920 (insn, operands);

        case 57:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8921 (insn, operands);

        case 58:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8922 (insn, operands);

        case 59:
          if (!((
#line 746 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 748 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8923 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_157 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern123 (x2))
    {
    case 0:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2592 (insn, operands);

    case 1:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2606 (insn, operands);

    case 2:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2620 (insn, operands);

    case 3:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2634 (insn, operands);

    case 4:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2648 (insn, operands);

    case 5:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2662 (insn, operands);

    case 6:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2676 (insn, operands);

    case 7:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2690 (insn, operands);

    case 8:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2704 (insn, operands);

    case 9:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2718 (insn, operands);

    case 10:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2732 (insn, operands);

    case 11:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2746 (insn, operands);

    case 12:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2760 (insn, operands);

    case 13:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2774 (insn, operands);

    case 14:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2788 (insn, operands);

    case 15:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2802 (insn, operands);

    case 16:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2816 (insn, operands);

    case 17:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2830 (insn, operands);

    case 18:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2844 (insn, operands);

    case 19:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2858 (insn, operands);

    case 20:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2872 (insn, operands);

    case 21:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2886 (insn, operands);

    case 22:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2900 (insn, operands);

    case 23:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2914 (insn, operands);

    case 24:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2928 (insn, operands);

    case 25:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2942 (insn, operands);

    case 26:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2956 (insn, operands);

    case 27:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2970 (insn, operands);

    case 28:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2984 (insn, operands);

    case 29:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2998 (insn, operands);

    case 30:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3012 (insn, operands);

    case 31:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3026 (insn, operands);

    case 32:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3040 (insn, operands);

    case 33:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3054 (insn, operands);

    case 34:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3068 (insn, operands);

    case 35:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3082 (insn, operands);

    case 36:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3096 (insn, operands);

    case 37:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3110 (insn, operands);

    case 38:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3124 (insn, operands);

    case 39:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3138 (insn, operands);

    case 40:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3152 (insn, operands);

    case 41:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3166 (insn, operands);

    case 42:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3180 (insn, operands);

    case 43:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3194 (insn, operands);

    case 44:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3208 (insn, operands);

    case 45:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3222 (insn, operands);

    case 46:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3236 (insn, operands);

    case 47:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3250 (insn, operands);

    case 48:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3264 (insn, operands);

    case 49:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3278 (insn, operands);

    case 50:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3292 (insn, operands);

    case 51:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3306 (insn, operands);

    case 52:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3320 (insn, operands);

    case 53:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3334 (insn, operands);

    case 54:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3348 (insn, operands);

    case 55:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3362 (insn, operands);

    case 56:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3376 (insn, operands);

    case 57:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3390 (insn, operands);

    case 58:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3404 (insn, operands);

    case 59:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3418 (insn, operands);

    case 60:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3432 (insn, operands);

    case 61:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3446 (insn, operands);

    case 62:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3460 (insn, operands);

    case 63:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3474 (insn, operands);

    case 64:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3488 (insn, operands);

    case 65:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3502 (insn, operands);

    case 66:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3516 (insn, operands);

    case 67:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3530 (insn, operands);

    case 68:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5745 (insn, operands);

    case 69:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5747 (insn, operands);

    case 70:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5749 (insn, operands);

    case 71:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5751 (insn, operands);

    case 72:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5753 (insn, operands);

    case 73:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5755 (insn, operands);

    case 74:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5757 (insn, operands);

    case 75:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5759 (insn, operands);

    case 76:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5761 (insn, operands);

    case 77:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5763 (insn, operands);

    case 78:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5765 (insn, operands);

    case 79:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5767 (insn, operands);

    case 80:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5769 (insn, operands);

    case 81:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5771 (insn, operands);

    case 82:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5773 (insn, operands);

    case 83:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5775 (insn, operands);

    case 84:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5777 (insn, operands);

    case 85:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5779 (insn, operands);

    case 86:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5781 (insn, operands);

    case 87:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5783 (insn, operands);

    case 88:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5785 (insn, operands);

    case 89:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5787 (insn, operands);

    case 90:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5789 (insn, operands);

    case 91:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5791 (insn, operands);

    case 92:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5793 (insn, operands);

    case 93:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5795 (insn, operands);

    case 94:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5797 (insn, operands);

    case 95:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5799 (insn, operands);

    case 96:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5801 (insn, operands);

    case 97:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5803 (insn, operands);

    case 98:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5805 (insn, operands);

    case 99:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5807 (insn, operands);

    case 100:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5809 (insn, operands);

    case 101:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5811 (insn, operands);

    case 102:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5813 (insn, operands);

    case 103:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5815 (insn, operands);

    case 104:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5817 (insn, operands);

    case 105:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5819 (insn, operands);

    case 106:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5821 (insn, operands);

    case 107:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5823 (insn, operands);

    case 108:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5825 (insn, operands);

    case 109:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5827 (insn, operands);

    case 110:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5829 (insn, operands);

    case 111:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5831 (insn, operands);

    case 112:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5833 (insn, operands);

    case 113:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5835 (insn, operands);

    case 114:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5837 (insn, operands);

    case 115:
      if (!((
#line 1561 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1563 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5839 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_171 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern127 (x2))
    {
    case 0:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5177 (insn, operands);

    case 1:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5178 (insn, operands);

    case 2:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5179 (insn, operands);

    case 3:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5180 (insn, operands);

    case 4:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5181 (insn, operands);

    case 5:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5182 (insn, operands);

    case 6:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5183 (insn, operands);

    case 7:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5184 (insn, operands);

    case 8:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5185 (insn, operands);

    case 9:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5186 (insn, operands);

    case 10:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5187 (insn, operands);

    case 11:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5188 (insn, operands);

    case 12:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5189 (insn, operands);

    case 13:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5190 (insn, operands);

    case 14:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5191 (insn, operands);

    case 15:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5192 (insn, operands);

    case 16:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5193 (insn, operands);

    case 17:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5194 (insn, operands);

    case 18:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5195 (insn, operands);

    case 19:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5196 (insn, operands);

    case 20:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5197 (insn, operands);

    case 21:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5198 (insn, operands);

    case 22:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5199 (insn, operands);

    case 23:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5200 (insn, operands);

    case 24:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5201 (insn, operands);

    case 25:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5202 (insn, operands);

    case 26:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5203 (insn, operands);

    case 27:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5204 (insn, operands);

    case 28:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5205 (insn, operands);

    case 29:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5206 (insn, operands);

    case 30:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5207 (insn, operands);

    case 31:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5208 (insn, operands);

    case 32:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5209 (insn, operands);

    case 33:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5210 (insn, operands);

    case 34:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5211 (insn, operands);

    case 35:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5212 (insn, operands);

    case 36:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5213 (insn, operands);

    case 37:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5214 (insn, operands);

    case 38:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5215 (insn, operands);

    case 39:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5216 (insn, operands);

    case 40:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5217 (insn, operands);

    case 41:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5218 (insn, operands);

    case 42:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5219 (insn, operands);

    case 43:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5220 (insn, operands);

    case 44:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5221 (insn, operands);

    case 45:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5222 (insn, operands);

    case 46:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5223 (insn, operands);

    case 47:
      if (!((
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1132 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5224 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_178 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 2:
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != CLOBBER)
        return NULL;
      x3 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x3))
        {
        case SET:
          x4 = XEXP (x3, 1);
          switch (GET_CODE (x4))
            {
            case PLUS:
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) == AND)
                {
                  x6 = XEXP (x3, 0);
                  operands[0] = x6;
                  switch (pattern340 (x1))
                    {
                    case 0:
                      if (((
#line 883 "../../gcc/config/riscv/riscv.md"
((LUI_OPERAND (~INTVAL (operands[2]))
    && ((INTVAL (operands[2]) & (-INTVAL (operands[3])))
	== (-INTVAL (operands[3])))
    && riscv_const_insns (operands[3], false)
    && (riscv_const_insns (GEN_INT (~INTVAL (operands[2])
				    | -INTVAL (operands[3])), false)
	<= riscv_const_insns (operands[3], false)))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 891 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                        return gen_split_3 (insn, operands);
                      break;

                    case 1:
                      if (((
#line 883 "../../gcc/config/riscv/riscv.md"
((LUI_OPERAND (~INTVAL (operands[2]))
    && ((INTVAL (operands[2]) & (-INTVAL (operands[3])))
	== (-INTVAL (operands[3])))
    && riscv_const_insns (operands[3], false)
    && (riscv_const_insns (GEN_INT (~INTVAL (operands[2])
				    | -INTVAL (operands[3])), false)
	<= riscv_const_insns (operands[3], false)))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 891 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                        return gen_split_4 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            case CONST_INT:
              operands[1] = x4;
              x6 = XEXP (x3, 0);
              operands[0] = x6;
              x7 = XEXP (x2, 0);
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (register_operand (operands[0], E_SImode)
                      && splittable_const_int_operand (operands[1], E_SImode)
                      && register_operand (operands[2], E_SImode))
                    return gen_split_14 (insn, operands);
                  break;

                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && splittable_const_int_operand (operands[1], E_DImode)
                      && register_operand (operands[2], E_DImode)
                      && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                    return gen_split_15 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case IF_THEN_ELSE:
              res = split_173 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case SIGN_EXTEND:
              if (pattern273 (x1) == 0
                  && ((
#line 636 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 641 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_133 (insn, operands);
              break;

            case ZERO_EXTEND:
              if (pattern273 (x1) == 0
                  && ((
#line 636 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 641 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_134 (insn, operands);
              break;

            case IOR:
              switch (pattern276 (x1))
                {
                case 0:
                  if (((
#line 684 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 689 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_139 (insn, operands);
                  break;

                case 1:
                  if (((
#line 710 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 714 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_147 (insn, operands);
                  break;

                case 2:
                  if (((
#line 684 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 689 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_141 (insn, operands);
                  break;

                case 3:
                  if (((
#line 710 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 714 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_149 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case XOR:
              switch (pattern276 (x1))
                {
                case 0:
                  if (((
#line 684 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 689 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_140 (insn, operands);
                  break;

                case 1:
                  if (((
#line 710 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 714 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_148 (insn, operands);
                  break;

                case 2:
                  if (((
#line 684 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 689 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_142 (insn, operands);
                  break;

                case 3:
                  if (((
#line 710 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 714 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_150 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case AND:
              res = split_174 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case REG:
            case SUBREG:
            case MEM:
              res = split_176 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            default:
              break;
            }
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          operands[1] = x4;
          x7 = XEXP (x2, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && register_operand (operands[2], E_SImode)
                  && (
#line 2455 "../../gcc/config/riscv/riscv.md"
(riscv_split_symbol (operands[2], operands[1], MAX_MACHINE_MODE, NULL)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return gen_split_16 (insn, operands);
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && register_operand (operands[2], E_DImode)
                  && (
#line 2455 "../../gcc/config/riscv/riscv.md"
(riscv_split_symbol (operands[2], operands[1], MAX_MACHINE_MODE, NULL)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return gen_split_17 (insn, operands);
              break;

            default:
              break;
            }
          switch (GET_CODE (x4))
            {
            case SIGN_EXTRACT:
              switch (pattern218 (x1))
                {
                case 0:
                  if (!(
#line 3064 "../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 3072 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_46 (insn, operands);

                case 1:
                  if (!((
#line 3064 "../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3072 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_48 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTRACT:
              switch (pattern218 (x1))
                {
                case 0:
                  if (!(
#line 3064 "../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 3072 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_47 (insn, operands);

                case 1:
                  if (!((
#line 3064 "../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3072 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_49 (insn, operands);

                default:
                  return NULL;
                }

            case AND:
              return split_175 (x1, insn);

            case SIGN_EXTEND:
              if (GET_MODE (x4) != E_DImode
                  || !register_operand (operands[0], E_DImode))
                return NULL;
              x5 = XEXP (x4, 0);
              if (GET_MODE (x5) != E_SImode)
                return NULL;
              switch (GET_CODE (x5))
                {
                case PLUS:
                  switch (pattern404 (x1))
                    {
                    case 0:
                      if (!(
#line 4553 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT
   && (INTVAL (operands[3]) | ((1 << INTVAL (operands[2])) - 1)) == 0xffffffff) && 
#line 4556 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                        return NULL;
                      return gen_split_103 (insn, operands);

                    case 1:
                      if (!(
#line 4700 "../../gcc/config/riscv/riscv.md"
((TARGET_64BIT && riscv_const_insns (operands[3], false) == 1)) && 
#line 4702 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                        return NULL;
                      return gen_split_105 (insn, operands);

                    default:
                      return NULL;
                    }

                case DIV:
                  x8 = XEXP (x5, 0);
                  if (GET_CODE (x8) != PLUS
                      || GET_MODE (x8) != E_SImode)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  if (GET_CODE (x9) != ASHIFT
                      || GET_MODE (x9) != E_SImode)
                    return NULL;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != SUBREG
                      || maybe_ne (SUBREG_BYTE (x10), 0)
                      || GET_MODE (x10) != E_SImode)
                    return NULL;
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) != SUBREG
                      || maybe_ne (SUBREG_BYTE (x11), 0)
                      || GET_MODE (x11) != E_SImode)
                    return NULL;
                  x12 = XEXP (x10, 0);
                  operands[1] = x12;
                  if (!register_operand (operands[1], E_DImode))
                    return NULL;
                  x13 = XEXP (x9, 1);
                  operands[2] = x13;
                  if (!imm123_operand (operands[2], E_QImode))
                    return NULL;
                  x14 = XEXP (x11, 0);
                  operands[3] = x14;
                  if (!register_operand (operands[3], E_DImode))
                    return NULL;
                  x15 = XEXP (x5, 1);
                  operands[4] = x15;
                  if (!register_operand (operands[4], E_SImode))
                    return NULL;
                  operands[5] = x7;
                  if (!register_operand (operands[5], E_DImode)
                      || !
#line 55 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA))
                    return NULL;
                  return gen_split_106 (insn, operands);

                case ASHIFT:
                  if (pattern392 (x5) != 0)
                    return NULL;
                  x15 = XEXP (x5, 1);
                  x16 = XEXP (x15, 0);
                  x17 = XEXP (x16, 0);
                  x18 = XEXP (x17, 0);
                  operands[1] = x18;
                  if (!register_operand (operands[1], E_DImode))
                    return NULL;
                  x19 = XEXP (x16, 1);
                  operands[2] = x19;
                  if (!const_int_operand (operands[2], E_VOIDmode))
                    return NULL;
                  operands[3] = x7;
                  if (!scratch_operand (operands[3], E_DImode)
                      || !((
#line 636 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 641 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return NULL;
                  return gen_split_135 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              if (GET_MODE (x4) != E_DImode
                  || !register_operand (operands[0], E_DImode))
                return NULL;
              x5 = XEXP (x4, 0);
              if (GET_MODE (x5) != E_DImode)
                return NULL;
              switch (GET_CODE (x5))
                {
                case ASHIFT:
                  if (pattern403 (x1) != 0
                      || !(
#line 4684 "../../gcc/config/riscv/riscv.md"
((TARGET_64BIT && riscv_const_insns (operands[3], false) == 1)) && 
#line 4686 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_104 (insn, operands);

                case AND:
                  x8 = XEXP (x5, 0);
                  if (GET_CODE (x8) != ASHIFT
                      || GET_MODE (x8) != E_DImode)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  operands[1] = x9;
                  if (!register_operand (operands[1], E_DImode))
                    return NULL;
                  x11 = XEXP (x8, 1);
                  operands[2] = x11;
                  x15 = XEXP (x5, 1);
                  operands[3] = x15;
                  if (!consecutive_bits_operand (operands[3], E_DImode))
                    return NULL;
                  x20 = XEXP (x4, 1);
                  operands[4] = x20;
                  if (!register_operand (operands[4], E_DImode))
                    return NULL;
                  operands[5] = x7;
                  if (scratch_operand (operands[5], E_DImode)
                      && imm123_operand (operands[2], E_QImode)
                      && (
#line 96 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA
   && riscv_shamt_matches_mask_p (INTVAL (operands[2]), INTVAL (operands[3]))
   && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))) && 
#line 100 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_109 (insn, operands);
                  if (!register_operand (operands[5], E_DImode)
                      || !immediate_operand (operands[2], E_QImode)
                      || !
#line 136 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA))
                    return NULL;
                  return gen_split_110 (insn, operands);

                default:
                  return NULL;
                }

            case IOR:
              x5 = XEXP (x4, 0);
              switch (GET_CODE (x5))
                {
                case NOT:
                  x8 = XEXP (x5, 0);
                  operands[1] = x8;
                  switch (pattern368 (x1))
                    {
                    case 0:
                      if (!((
#line 240 "../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 243 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_113 (insn, operands);

                    case 1:
                      if (!((
#line 240 "../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 243 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_115 (insn, operands);

                    default:
                      return NULL;
                    }

                case SIGN_EXTEND:
                  if (pattern352 (x5) != 0)
                    return NULL;
                  x8 = XEXP (x5, 0);
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) != SUBREG
                      || maybe_ne (SUBREG_BYTE (x11), 0)
                      || GET_MODE (x11) != E_QImode)
                    return NULL;
                  x14 = XEXP (x11, 0);
                  if (GET_CODE (x14) != AND
                      || GET_MODE (x14) != E_DImode
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x4) != E_DImode)
                    return NULL;
                  switch (pattern444 (x1))
                    {
                    case 0:
                      if (!((
#line 684 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 689 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_143 (insn, operands);

                    case 1:
                      if (!((
#line 710 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 714 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_151 (insn, operands);

                    default:
                      return NULL;
                    }

                case ZERO_EXTEND:
                  if (pattern352 (x5) != 0
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x4) != E_DImode)
                    return NULL;
                  x8 = XEXP (x5, 0);
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) == SUBREG)
                    {
                      switch (pattern445 (x1))
                        {
                        case 0:
                          if (((
#line 684 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 689 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                            return gen_split_145 (insn, operands);
                          break;

                        case 1:
                          if (((
#line 710 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 714 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                            return gen_split_153 (insn, operands);
                          break;

                        default:
                          break;
                        }
                    }
                  operands[1] = x11;
                  if (!register_operand (operands[1], E_QImode))
                    return NULL;
                  x20 = XEXP (x4, 1);
                  operands[2] = x20;
                  if (!single_bit_mask_operand (operands[2], E_DImode))
                    return NULL;
                  operands[3] = x7;
                  if (!register_operand (operands[3], E_DImode)
                      || !
#line 801 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS))
                    return NULL;
                  return gen_split_163 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x4) != E_DImode)
                return NULL;
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != ASHIFT
                  || GET_MODE (x5) != E_SImode
                  || pattern392 (x5) != 0
                  || pattern272 (x1, 
E_DImode) != 0
                  || !((
#line 636 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 641 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_136 (insn, operands);

            case XOR:
              if (GET_MODE (x4) != E_DImode
                  || !register_operand (operands[0], E_DImode))
                return NULL;
              x5 = XEXP (x4, 0);
              if (GET_MODE (x5) != E_DImode)
                return NULL;
              switch (GET_CODE (x5))
                {
                case SIGN_EXTEND:
                  x8 = XEXP (x5, 0);
                  if (GET_CODE (x8) != ASHIFT
                      || GET_MODE (x8) != E_SImode)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return NULL;
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) != SUBREG)
                    return NULL;
                  switch (pattern445 (x1))
                    {
                    case 0:
                      if (!((
#line 684 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 689 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_144 (insn, operands);

                    case 1:
                      if (!((
#line 710 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 714 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_152 (insn, operands);

                    default:
                      return NULL;
                    }

                case ZERO_EXTEND:
                  x8 = XEXP (x5, 0);
                  if (GET_CODE (x8) != ASHIFT
                      || GET_MODE (x8) != E_SImode)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return NULL;
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) == SUBREG)
                    {
                      switch (pattern445 (x1))
                        {
                        case 0:
                          if (((
#line 684 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 689 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                            return gen_split_146 (insn, operands);
                          break;

                        case 1:
                          if (((
#line 710 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 714 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                            return gen_split_154 (insn, operands);
                          break;

                        default:
                          break;
                        }
                    }
                  operands[1] = x11;
                  if (!register_operand (operands[1], E_QImode))
                    return NULL;
                  x20 = XEXP (x4, 1);
                  operands[2] = x20;
                  if (!single_bit_mask_operand (operands[2], E_DImode))
                    return NULL;
                  operands[3] = x7;
                  if (!register_operand (operands[3], E_DImode)
                      || !
#line 801 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS))
                    return NULL;
                  return gen_split_164 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 0)
            return NULL;
          x21 = XVECEXP (x3, 0, 0);
          operands[0] = x21;
          if (!register_operand (operands[0], E_VOIDmode))
            return NULL;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          if (!scratch_operand (operands[1], E_VOIDmode)
              || !
#line 3890 "../../gcc/config/riscv/riscv.md"
(reload_completed))
            return NULL;
          return gen_split_101 (insn, operands);

        default:
          return NULL;
        }

    case 3:
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != SET)
        return NULL;
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != CLOBBER)
        return NULL;
      x22 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x22) != CLOBBER)
        return NULL;
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case IF_THEN_ELSE:
          if (pattern220 (x3) != 0)
            return NULL;
          x5 = XEXP (x4, 0);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          switch (pattern424 (x1))
            {
            case 0:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_61 (insn, operands);
              break;

            case 1:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_69 (insn, operands);
              break;

            case 2:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_63 (insn, operands);
              break;

            case 3:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_71 (insn, operands);
              break;

            case 4:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_65 (insn, operands);
              break;

            case 5:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_73 (insn, operands);
              break;

            case 6:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && ((((
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_67 (insn, operands);
              break;

            case 7:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_75 (insn, operands);
              break;

            case 8:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_62 (insn, operands);
              break;

            case 9:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_70 (insn, operands);
              break;

            case 10:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_64 (insn, operands);
              break;

            case 11:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_72 (insn, operands);
              break;

            case 12:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_66 (insn, operands);
              break;

            case 13:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_74 (insn, operands);
              break;

            case 14:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && ((((
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_68 (insn, operands);
              break;

            case 15:
              if (((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_76 (insn, operands);
              break;

            default:
              break;
            }
          operands[1] = x5;
          switch (pattern426 (x1))
            {
            case 0:
              if (!((
#line 1099 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 1101 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_183 (insn, operands);

            case 1:
              if (!((
#line 1099 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1101 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_184 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_DImode)
            return NULL;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_DImode))
            return NULL;
          x8 = XEXP (x5, 0);
          if (GET_MODE (x8) != E_DImode)
            return NULL;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (!register_operand (operands[3], E_DImode))
            return NULL;
          x23 = XEXP (x22, 0);
          operands[4] = x23;
          if (!register_operand (operands[4], E_DImode))
            return NULL;
          switch (GET_CODE (x8))
            {
            case SMIN:
              if (pattern504 (x8) != 0
                  || !
#line 561 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && sext_hwi (INTVAL (operands[2]), 32) >= 0))
                return NULL;
              return gen_split_129 (insn, operands);

            case UMIN:
              if (pattern504 (x8) != 0
                  || !
#line 561 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && sext_hwi (INTVAL (operands[2]), 32) >= 0))
                return NULL;
              return gen_split_130 (insn, operands);

            case SMAX:
              if (pattern504 (x8) != 0
                  || !
#line 561 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && sext_hwi (INTVAL (operands[2]), 32) >= 0))
                return NULL;
              return gen_split_131 (insn, operands);

            case UMAX:
              if (pattern504 (x8) != 0
                  || !
#line 561 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && sext_hwi (INTVAL (operands[2]), 32) >= 0))
                return NULL;
              return gen_split_132 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 4:
      if (pattern112 (x1, 
CLOBBER) != 0)
        return NULL;
      x3 = XVECEXP (x1, 0, 0);
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      x4 = XEXP (x3, 1);
      operands[1] = x4;
      return split_177 (x1, insn);

    default:
      return NULL;
    }
}
