/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode)
          || GET_MODE (x3) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVM8HFmode))
        return -1;
      return 3;

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM4HFmode))
        return -1;
      return 4;

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM2HFmode))
        return -1;
      return 5;

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM1HFmode))
        return -1;
      return 6;

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF2HFmode))
        return -1;
      return 7;

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF4HFmode))
        return -1;
      return 8;

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM8SFmode))
        return -1;
      return 9;

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 10;

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM2SFmode))
        return -1;
      return 11;

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM1SFmode))
        return -1;
      return 12;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 13;

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 14;

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM4DFmode))
        return -1;
      return 15;

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM2DFmode))
        return -1;
      return 16;

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 17;

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[1], E_V1HFmode))
        return -1;
      return 18;

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode))
        return -1;
      return 19;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 20;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 21;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode))
        return -1;
      return 22;

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode))
        return -1;
      return 23;

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode))
        return -1;
      return 24;

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[1], E_V128HFmode))
        return -1;
      return 25;

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[1], E_V256HFmode))
        return -1;
      return 26;

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[1], E_V512HFmode))
        return -1;
      return 27;

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024HFmode))
        return -1;
      return 28;

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || GET_MODE (x3) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048HFmode))
        return -1;
      return 29;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode))
        return -1;
      return 30;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 31;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 32;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 33;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode))
        return -1;
      return 34;

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode))
        return -1;
      return 35;

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode))
        return -1;
      return 36;

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[1], E_V128SFmode))
        return -1;
      return 37;

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[1], E_V256SFmode))
        return -1;
      return 38;

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[1], E_V512SFmode))
        return -1;
      return 39;

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024SFmode))
        return -1;
      return 40;

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode))
        return -1;
      return 41;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 42;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 43;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode))
        return -1;
      return 44;

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode))
        return -1;
      return 45;

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode))
        return -1;
      return 46;

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode))
        return -1;
      return 47;

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[1], E_V128DFmode))
        return -1;
      return 48;

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[1], E_V256DFmode))
        return -1;
      return 49;

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[1], E_V512DFmode))
        return -1;
      return 50;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1, rtx_code i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 5
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 6
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 7
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x12) != i1)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 10
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 11
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x16) != i1)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 12
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 13
      || GET_MODE (x19) != E_SImode)
    return -1;
  x20 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x20) != i1)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 14
      || GET_MODE (x21) != E_SImode)
    return -1;
  x22 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x22) != i1)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 15
      || GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 16
      || GET_MODE (x25) != E_SImode)
    return -1;
  x26 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x26) != i1)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 17
      || GET_MODE (x27) != E_SImode)
    return -1;
  x28 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 28
      || GET_MODE (x29) != E_SImode)
    return -1;
  x30 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x30) != i1)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 29
      || GET_MODE (x31) != E_SImode)
    return -1;
  x32 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x32) != i1)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 30
      || GET_MODE (x33) != E_SImode)
    return -1;
  x34 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != 31
      || GET_MODE (x35) != E_SImode)
    return -1;
  return 0;
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern0 (x1, 
E_RVVM8QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern0 (x1, 
E_RVVM4QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern0 (x1, 
E_RVVM2QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern0 (x1, 
E_RVVM1QImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern0 (x1, 
E_RVVM8HImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern0 (x1, 
E_RVVM4HImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern0 (x1, 
E_RVVM2HImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern0 (x1, 
E_RVVM1HImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern0 (x1, 
E_RVVM8SImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern0 (x1, 
E_RVVM4SImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern0 (x1, 
E_RVVM2SImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern0 (x1, 
E_RVVM1SImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern0 (x1, 
E_RVVM8DImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern0 (x1, 
E_RVVM4DImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern0 (x1, 
E_RVVM2DImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern0 (x1, 
E_RVVM1DImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern0 (x1, 
E_RVVMF2QImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern0 (x1, 
E_RVVMF4QImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern0 (x1, 
E_RVVMF8QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern0 (x1, 
E_RVVMF2HImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern0 (x1, 
E_RVVMF4HImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern0 (x1, 
E_RVVMF2SImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern0 (x1, 
E_V1QImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern0 (x1, 
E_V32QImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern0 (x1, 
E_V64QImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern0 (x1, 
E_V128QImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern0 (x1, 
E_V256QImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern0 (x1, 
E_V512QImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern0 (x1, 
E_V1024QImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern0 (x1, 
E_V2048QImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern0 (x1, 
E_V4096QImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern0 (x1, 
E_V16HImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern0 (x1, 
E_V32HImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern0 (x1, 
E_V64HImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern0 (x1, 
E_V128HImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern0 (x1, 
E_V256HImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern0 (x1, 
E_V512HImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern0 (x1, 
E_V1024HImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern0 (x1, 
E_V2048HImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern0 (x1, 
E_V8SImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern0 (x1, 
E_V16SImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern0 (x1, 
E_V32SImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern0 (x1, 
E_V64SImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern0 (x1, 
E_V128SImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern0 (x1, 
E_V256SImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern0 (x1, 
E_V512SImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern0 (x1, 
E_V1024SImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern0 (x1, 
E_V4DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern0 (x1, 
E_V8DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern0 (x1, 
E_V16DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern0 (x1, 
E_V32DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern0 (x1, 
E_V64DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern0 (x1, 
E_V128DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern0 (x1, 
E_V256DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern0 (x1, 
E_V512DImode) != 0)
        return -1;
      return 67;

    case E_RVVM8HFmode:
      if (pattern0 (x1, 
E_RVVM8HFmode) != 0)
        return -1;
      return 68;

    case E_RVVM4HFmode:
      if (pattern0 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 69;

    case E_RVVM2HFmode:
      if (pattern0 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 70;

    case E_RVVM1HFmode:
      if (pattern0 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 71;

    case E_RVVMF2HFmode:
      if (pattern0 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 72;

    case E_RVVMF4HFmode:
      if (pattern0 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM8SFmode:
      if (pattern0 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 74;

    case E_RVVM4SFmode:
      if (pattern0 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 75;

    case E_RVVM2SFmode:
      if (pattern0 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 76;

    case E_RVVM1SFmode:
      if (pattern0 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF2SFmode:
      if (pattern0 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8DFmode:
      if (pattern0 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4DFmode:
      if (pattern0 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2DFmode:
      if (pattern0 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1DFmode:
      if (pattern0 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 82;

    case E_V1HFmode:
      if (pattern0 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 83;

    case E_V2HFmode:
      if (pattern0 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 84;

    case E_V4HFmode:
      if (pattern0 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 85;

    case E_V8HFmode:
      if (pattern0 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 86;

    case E_V16HFmode:
      if (pattern0 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 87;

    case E_V32HFmode:
      if (pattern0 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 88;

    case E_V64HFmode:
      if (pattern0 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 89;

    case E_V128HFmode:
      if (pattern0 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 90;

    case E_V256HFmode:
      if (pattern0 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 91;

    case E_V512HFmode:
      if (pattern0 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 92;

    case E_V1024HFmode:
      if (pattern0 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 93;

    case E_V2048HFmode:
      if (pattern0 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 94;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 95;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 96;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 97;

    case E_V8SFmode:
      if (pattern0 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 98;

    case E_V16SFmode:
      if (pattern0 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 99;

    case E_V32SFmode:
      if (pattern0 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 100;

    case E_V64SFmode:
      if (pattern0 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 101;

    case E_V128SFmode:
      if (pattern0 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 102;

    case E_V256SFmode:
      if (pattern0 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 103;

    case E_V512SFmode:
      if (pattern0 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 104;

    case E_V1024SFmode:
      if (pattern0 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 105;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 106;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 107;

    case E_V4DFmode:
      if (pattern0 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 108;

    case E_V8DFmode:
      if (pattern0 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 109;

    case E_V16DFmode:
      if (pattern0 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 110;

    case E_V32DFmode:
      if (pattern0 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 111;

    case E_V64DFmode:
      if (pattern0 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 112;

    case E_V128DFmode:
      if (pattern0 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 113;

    case E_V256DFmode:
      if (pattern0 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 114;

    case E_V512DFmode:
      if (pattern0 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 115;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !csr_operand (operands[2], i3))
    return -1;
  return 0;
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      return pattern153 (x1); /* [-1, 47] */

    case ZERO_EXTEND:
      res = pattern153 (x1);
      if (res >= 0)
        return res + 48; /* [48, 95] */
      return -1;

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4QImode:
          if (pattern154 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_HImode) != 0)
            return -1;
          return 96;

        case E_RVVM2QImode:
          if (pattern154 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_HImode) != 0)
            return -1;
          return 97;

        case E_RVVM1QImode:
          if (pattern154 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_HImode) != 0)
            return -1;
          return 98;

        case E_RVVMF2QImode:
          if (pattern154 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_HImode) != 0)
            return -1;
          return 99;

        case E_RVVMF4QImode:
          if (pattern154 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_HImode) != 0)
            return -1;
          return 100;

        case E_RVVMF8QImode:
          if (pattern154 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_HImode) != 0)
            return -1;
          return 101;

        case E_RVVM4HImode:
          if (pattern154 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_SImode) != 0)
            return -1;
          return 102;

        case E_RVVM2HImode:
          if (pattern154 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_SImode) != 0)
            return -1;
          return 103;

        case E_RVVM1HImode:
          if (pattern154 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_SImode) != 0)
            return -1;
          return 104;

        case E_RVVMF2HImode:
          if (pattern154 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_SImode) != 0)
            return -1;
          return 105;

        case E_RVVMF4HImode:
          if (pattern154 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_SImode) != 0)
            return -1;
          return 106;

        case E_RVVM4SImode:
          if (pattern154 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_DImode) != 0)
            return -1;
          return 107;

        case E_RVVM2SImode:
          if (pattern154 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_DImode) != 0)
            return -1;
          return 108;

        case E_RVVM1SImode:
          if (pattern154 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_DImode) != 0)
            return -1;
          return 109;

        case E_RVVMF2SImode:
          if (pattern154 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_DImode) != 0)
            return -1;
          return 110;

        case E_V1QImode:
          if (pattern154 (x1, 
E_V1HImode, 
E_V1QImode, 
E_HImode) != 0)
            return -1;
          return 111;

        case E_V2QImode:
          if (pattern154 (x1, 
E_V2HImode, 
E_V2QImode, 
E_HImode) != 0)
            return -1;
          return 112;

        case E_V4QImode:
          if (pattern154 (x1, 
E_V4HImode, 
E_V4QImode, 
E_HImode) != 0)
            return -1;
          return 113;

        case E_V8QImode:
          if (pattern154 (x1, 
E_V8HImode, 
E_V8QImode, 
E_HImode) != 0)
            return -1;
          return 114;

        case E_V16QImode:
          if (pattern154 (x1, 
E_V16HImode, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 115;

        case E_V32QImode:
          if (pattern154 (x1, 
E_V32HImode, 
E_V32QImode, 
E_HImode) != 0)
            return -1;
          return 116;

        case E_V64QImode:
          if (pattern154 (x1, 
E_V64HImode, 
E_V64QImode, 
E_HImode) != 0)
            return -1;
          return 117;

        case E_V128QImode:
          if (pattern154 (x1, 
E_V128HImode, 
E_V128QImode, 
E_HImode) != 0)
            return -1;
          return 118;

        case E_V256QImode:
          if (pattern154 (x1, 
E_V256HImode, 
E_V256QImode, 
E_HImode) != 0)
            return -1;
          return 119;

        case E_V512QImode:
          if (pattern154 (x1, 
E_V512HImode, 
E_V512QImode, 
E_HImode) != 0)
            return -1;
          return 120;

        case E_V1024QImode:
          if (pattern154 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_HImode) != 0)
            return -1;
          return 121;

        case E_V2048QImode:
          if (pattern154 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_HImode) != 0)
            return -1;
          return 122;

        case E_V1HImode:
          if (pattern154 (x1, 
E_V1SImode, 
E_V1HImode, 
E_SImode) != 0)
            return -1;
          return 123;

        case E_V2HImode:
          if (pattern154 (x1, 
E_V2SImode, 
E_V2HImode, 
E_SImode) != 0)
            return -1;
          return 124;

        case E_V4HImode:
          if (pattern154 (x1, 
E_V4SImode, 
E_V4HImode, 
E_SImode) != 0)
            return -1;
          return 125;

        case E_V8HImode:
          if (pattern154 (x1, 
E_V8SImode, 
E_V8HImode, 
E_SImode) != 0)
            return -1;
          return 126;

        case E_V16HImode:
          if (pattern154 (x1, 
E_V16SImode, 
E_V16HImode, 
E_SImode) != 0)
            return -1;
          return 127;

        case E_V32HImode:
          if (pattern154 (x1, 
E_V32SImode, 
E_V32HImode, 
E_SImode) != 0)
            return -1;
          return 128;

        case E_V64HImode:
          if (pattern154 (x1, 
E_V64SImode, 
E_V64HImode, 
E_SImode) != 0)
            return -1;
          return 129;

        case E_V128HImode:
          if (pattern154 (x1, 
E_V128SImode, 
E_V128HImode, 
E_SImode) != 0)
            return -1;
          return 130;

        case E_V256HImode:
          if (pattern154 (x1, 
E_V256SImode, 
E_V256HImode, 
E_SImode) != 0)
            return -1;
          return 131;

        case E_V512HImode:
          if (pattern154 (x1, 
E_V512SImode, 
E_V512HImode, 
E_SImode) != 0)
            return -1;
          return 132;

        case E_V1024HImode:
          if (pattern154 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_SImode) != 0)
            return -1;
          return 133;

        case E_V1SImode:
          if (pattern154 (x1, 
E_V1DImode, 
E_V1SImode, 
E_DImode) != 0)
            return -1;
          return 134;

        case E_V2SImode:
          if (pattern154 (x1, 
E_V2DImode, 
E_V2SImode, 
E_DImode) != 0)
            return -1;
          return 135;

        case E_V4SImode:
          if (pattern154 (x1, 
E_V4DImode, 
E_V4SImode, 
E_DImode) != 0)
            return -1;
          return 136;

        case E_V8SImode:
          if (pattern154 (x1, 
E_V8DImode, 
E_V8SImode, 
E_DImode) != 0)
            return -1;
          return 137;

        case E_V16SImode:
          if (pattern154 (x1, 
E_V16DImode, 
E_V16SImode, 
E_DImode) != 0)
            return -1;
          return 138;

        case E_V32SImode:
          if (pattern154 (x1, 
E_V32DImode, 
E_V32SImode, 
E_DImode) != 0)
            return -1;
          return 139;

        case E_V64SImode:
          if (pattern154 (x1, 
E_V64DImode, 
E_V64SImode, 
E_DImode) != 0)
            return -1;
          return 140;

        case E_V128SImode:
          if (pattern154 (x1, 
E_V128DImode, 
E_V128SImode, 
E_DImode) != 0)
            return -1;
          return 141;

        case E_V256SImode:
          if (pattern154 (x1, 
E_V256DImode, 
E_V256SImode, 
E_DImode) != 0)
            return -1;
          return 142;

        case E_V512SImode:
          if (pattern154 (x1, 
E_V512DImode, 
E_V512SImode, 
E_DImode) != 0)
            return -1;
          return 143;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern184 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[3], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[3], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[3], E_RVVM8SImode))
        return -1;
      return 2;

    case E_RVVM4BFmode:
      if (!register_operand (operands[3], E_RVVM4BFmode))
        return -1;
      return 3;

    case E_RVVM4HFmode:
      if (!register_operand (operands[3], E_RVVM4HFmode))
        return -1;
      return 4;

    case E_RVVM8SFmode:
      if (!register_operand (operands[3], E_RVVM8SFmode))
        return -1;
      return 5;

    case E_RVVM2x2QImode:
      if (!register_operand (operands[3], E_RVVM2x2QImode))
        return -1;
      return 6;

    case E_RVVM2x3QImode:
      if (!register_operand (operands[3], E_RVVM2x3QImode))
        return -1;
      return 7;

    case E_RVVM2x4QImode:
      if (!register_operand (operands[3], E_RVVM2x4QImode))
        return -1;
      return 8;

    case E_RVVM4x2HImode:
      if (!register_operand (operands[3], E_RVVM4x2HImode))
        return -1;
      return 9;

    case E_RVVM4x2BFmode:
      if (!register_operand (operands[3], E_RVVM4x2BFmode))
        return -1;
      return 10;

    case E_RVVM4x2HFmode:
      if (!register_operand (operands[3], E_RVVM4x2HFmode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern189 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 7
      || XINT (x3, 1) != 91)
    return -1;
  x4 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 3);
  operands[7] = x10;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 4);
  operands[8] = x11;
  if (!const_int_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 1);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 2);
  operands[3] = x13;
  x14 = XVECEXP (x2, 0, 3);
  operands[4] = x14;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern191 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern191 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern191 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern191 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern191 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern191 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern191 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern191 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern191 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern191 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern191 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern191 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern191 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern191 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern191 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern191 (x2, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern191 (x2, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern191 (x2, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern191 (x2, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern191 (x2, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern191 (x2, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern191 (x2, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern191 (x2, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern191 (x2, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern191 (x2, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern191 (x2, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern191 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern191 (x2, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern191 (x2, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern191 (x2, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern191 (x2, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern191 (x2, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern191 (x2, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern191 (x2, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern191 (x2, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern191 (x2, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern191 (x2, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern191 (x2, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern191 (x2, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern191 (x2, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern191 (x2, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern191 (x2, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern191 (x2, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern191 (x2, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern191 (x2, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern191 (x2, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern191 (x2, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern191 (x2, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      x4 = XEXP (x1, 2);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern201 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern201 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern201 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern201 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVM8HImode:
          if (pattern201 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 4;

        case E_RVVM4HImode:
          if (pattern201 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 5;

        case E_RVVM2HImode:
          if (pattern201 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 6;

        case E_RVVM1HImode:
          if (pattern201 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 7;

        case E_RVVM8SImode:
          if (pattern201 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM4SImode:
          if (pattern201 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (pattern201 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVM1SImode:
          if (pattern201 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVM8DImode:
          if (pattern201 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 12;

        case E_RVVM4DImode:
          if (pattern201 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 13;

        case E_RVVM2DImode:
          if (pattern201 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 14;

        case E_RVVM1DImode:
          if (pattern201 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 15;

        case E_RVVMF2QImode:
          if (pattern201 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF4QImode:
          if (pattern201 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 17;

        case E_RVVMF8QImode:
          if (pattern201 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 18;

        case E_RVVMF2HImode:
          if (pattern201 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 19;

        case E_RVVMF4HImode:
          if (pattern201 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF2SImode:
          if (pattern201 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 21;

        case E_RVVM8BFmode:
          if (pattern201 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 22;

        case E_RVVM4BFmode:
          if (pattern201 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 23;

        case E_RVVM2BFmode:
          if (pattern201 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 24;

        case E_RVVM1BFmode:
          if (pattern201 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 25;

        case E_RVVMF2BFmode:
          if (pattern201 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 26;

        case E_RVVMF4BFmode:
          if (pattern201 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 27;

        case E_RVVM8HFmode:
          if (pattern201 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 28;

        case E_RVVM4HFmode:
          if (pattern201 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 29;

        case E_RVVM2HFmode:
          if (pattern201 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 30;

        case E_RVVM1HFmode:
          if (pattern201 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 31;

        case E_RVVMF2HFmode:
          if (pattern201 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 32;

        case E_RVVMF4HFmode:
          if (pattern201 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 33;

        case E_RVVM8SFmode:
          if (pattern201 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 34;

        case E_RVVM4SFmode:
          if (pattern201 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 35;

        case E_RVVM2SFmode:
          if (pattern201 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 36;

        case E_RVVM1SFmode:
          if (pattern201 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 37;

        case E_RVVMF2SFmode:
          if (pattern201 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 38;

        case E_RVVM8DFmode:
          if (pattern201 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 39;

        case E_RVVM4DFmode:
          if (pattern201 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 40;

        case E_RVVM2DFmode:
          if (pattern201 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 41;

        case E_RVVM1DFmode:
          if (pattern201 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 42;

        case E_V1QImode:
          if (pattern201 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 43;

        case E_V2QImode:
          if (pattern201 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 44;

        case E_V4QImode:
          if (pattern201 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 45;

        case E_V8QImode:
          if (pattern201 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 46;

        case E_V16QImode:
          if (pattern201 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 47;

        case E_V32QImode:
          if (pattern201 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 48;

        case E_V64QImode:
          if (pattern201 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 49;

        case E_V128QImode:
          if (pattern201 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 50;

        case E_V256QImode:
          if (pattern201 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 51;

        case E_V512QImode:
          if (pattern201 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 52;

        case E_V1024QImode:
          if (pattern201 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 53;

        case E_V2048QImode:
          if (pattern201 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 54;

        case E_V4096QImode:
          if (pattern201 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
            return -1;
          return 55;

        case E_V1HImode:
          if (pattern201 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 56;

        case E_V2HImode:
          if (pattern201 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 57;

        case E_V4HImode:
          if (pattern201 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 58;

        case E_V8HImode:
          if (pattern201 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 59;

        case E_V16HImode:
          if (pattern201 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 60;

        case E_V32HImode:
          if (pattern201 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 61;

        case E_V64HImode:
          if (pattern201 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 62;

        case E_V128HImode:
          if (pattern201 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 63;

        case E_V256HImode:
          if (pattern201 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 64;

        case E_V512HImode:
          if (pattern201 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 65;

        case E_V1024HImode:
          if (pattern201 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 66;

        case E_V2048HImode:
          if (pattern201 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
            return -1;
          return 67;

        case E_V1SImode:
          if (pattern201 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 68;

        case E_V2SImode:
          if (pattern201 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 69;

        case E_V4SImode:
          if (pattern201 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 70;

        case E_V8SImode:
          if (pattern201 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 71;

        case E_V16SImode:
          if (pattern201 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 72;

        case E_V32SImode:
          if (pattern201 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 73;

        case E_V64SImode:
          if (pattern201 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 74;

        case E_V128SImode:
          if (pattern201 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 75;

        case E_V256SImode:
          if (pattern201 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 76;

        case E_V512SImode:
          if (pattern201 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 77;

        case E_V1024SImode:
          if (pattern201 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
            return -1;
          return 78;

        case E_V1DImode:
          if (pattern201 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
            return -1;
          return 79;

        case E_V2DImode:
          if (pattern201 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
            return -1;
          return 80;

        case E_V4DImode:
          if (pattern201 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
            return -1;
          return 81;

        case E_V8DImode:
          if (pattern201 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
            return -1;
          return 82;

        case E_V16DImode:
          if (pattern201 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
            return -1;
          return 83;

        case E_V32DImode:
          if (pattern201 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
            return -1;
          return 84;

        case E_V64DImode:
          if (pattern201 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
            return -1;
          return 85;

        case E_V128DImode:
          if (pattern201 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
            return -1;
          return 86;

        case E_V256DImode:
          if (pattern201 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
            return -1;
          return 87;

        case E_V512DImode:
          if (pattern201 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
            return -1;
          return 88;

        case E_V1HFmode:
          if (pattern201 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 89;

        case E_V2HFmode:
          if (pattern201 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 90;

        case E_V4HFmode:
          if (pattern201 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 91;

        case E_V8HFmode:
          if (pattern201 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 92;

        case E_V16HFmode:
          if (pattern201 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 93;

        case E_V32HFmode:
          if (pattern201 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 94;

        case E_V64HFmode:
          if (pattern201 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 95;

        case E_V128HFmode:
          if (pattern201 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 96;

        case E_V256HFmode:
          if (pattern201 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 97;

        case E_V512HFmode:
          if (pattern201 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 98;

        case E_V1024HFmode:
          if (pattern201 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 99;

        case E_V2048HFmode:
          if (pattern201 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 100;

        case E_V1SFmode:
          if (pattern201 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 101;

        case E_V2SFmode:
          if (pattern201 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 102;

        case E_V4SFmode:
          if (pattern201 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 103;

        case E_V8SFmode:
          if (pattern201 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 104;

        case E_V16SFmode:
          if (pattern201 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 105;

        case E_V32SFmode:
          if (pattern201 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 106;

        case E_V64SFmode:
          if (pattern201 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 107;

        case E_V128SFmode:
          if (pattern201 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 108;

        case E_V256SFmode:
          if (pattern201 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 109;

        case E_V512SFmode:
          if (pattern201 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 110;

        case E_V1024SFmode:
          if (pattern201 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 111;

        case E_V1DFmode:
          if (pattern201 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 112;

        case E_V2DFmode:
          if (pattern201 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 113;

        case E_V4DFmode:
          if (pattern201 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 114;

        case E_V8DFmode:
          if (pattern201 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 115;

        case E_V16DFmode:
          if (pattern201 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 116;

        case E_V32DFmode:
          if (pattern201 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 117;

        case E_V64DFmode:
          if (pattern201 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 118;

        case E_V128DFmode:
          if (pattern201 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 119;

        case E_V256DFmode:
          if (pattern201 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 120;

        case E_V512DFmode:
          if (pattern201 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 121;

        default:
          return -1;
        }

    case ABS:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern202 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 122;

        case E_RVVM4HFmode:
          if (pattern202 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 123;

        case E_RVVM2HFmode:
          if (pattern202 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 124;

        case E_RVVM1HFmode:
          if (pattern202 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 125;

        case E_RVVMF2HFmode:
          if (pattern202 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 126;

        case E_RVVMF4HFmode:
          if (pattern202 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 127;

        case E_RVVM8SFmode:
          if (pattern202 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 128;

        case E_RVVM4SFmode:
          if (pattern202 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 129;

        case E_RVVM2SFmode:
          if (pattern202 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 130;

        case E_RVVM1SFmode:
          if (pattern202 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 131;

        case E_RVVMF2SFmode:
          if (pattern202 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 132;

        case E_RVVM8DFmode:
          if (pattern202 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 133;

        case E_RVVM4DFmode:
          if (pattern202 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 134;

        case E_RVVM2DFmode:
          if (pattern202 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 135;

        case E_RVVM1DFmode:
          if (pattern202 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 136;

        case E_V1HFmode:
          if (pattern202 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 137;

        case E_V2HFmode:
          if (pattern202 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 138;

        case E_V4HFmode:
          if (pattern202 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 139;

        case E_V8HFmode:
          if (pattern202 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 140;

        case E_V16HFmode:
          if (pattern202 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 141;

        case E_V32HFmode:
          if (pattern202 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 142;

        case E_V64HFmode:
          if (pattern202 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 143;

        case E_V128HFmode:
          if (pattern202 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 144;

        case E_V256HFmode:
          if (pattern202 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 145;

        case E_V512HFmode:
          if (pattern202 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 146;

        case E_V1024HFmode:
          if (pattern202 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 147;

        case E_V2048HFmode:
          if (pattern202 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 148;

        case E_V1SFmode:
          if (pattern202 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 149;

        case E_V2SFmode:
          if (pattern202 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 150;

        case E_V4SFmode:
          if (pattern202 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 151;

        case E_V8SFmode:
          if (pattern202 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 152;

        case E_V16SFmode:
          if (pattern202 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 153;

        case E_V32SFmode:
          if (pattern202 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 154;

        case E_V64SFmode:
          if (pattern202 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 155;

        case E_V128SFmode:
          if (pattern202 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 156;

        case E_V256SFmode:
          if (pattern202 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 157;

        case E_V512SFmode:
          if (pattern202 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 158;

        case E_V1024SFmode:
          if (pattern202 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 159;

        case E_V1DFmode:
          if (pattern202 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 160;

        case E_V2DFmode:
          if (pattern202 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 161;

        case E_V4DFmode:
          if (pattern202 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 162;

        case E_V8DFmode:
          if (pattern202 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 163;

        case E_V16DFmode:
          if (pattern202 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 164;

        case E_V32DFmode:
          if (pattern202 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 165;

        case E_V64DFmode:
          if (pattern202 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 166;

        case E_V128DFmode:
          if (pattern202 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 167;

        case E_V256DFmode:
          if (pattern202 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 168;

        case E_V512DFmode:
          if (pattern202 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 169;

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern203 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 170;

        case E_RVVM4HFmode:
          if (pattern203 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 171;

        case E_RVVM2HFmode:
          if (pattern203 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 172;

        case E_RVVM1HFmode:
          if (pattern203 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 173;

        case E_RVVMF2HFmode:
          if (pattern203 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 174;

        case E_RVVMF4HFmode:
          if (pattern203 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 175;

        case E_RVVM8SFmode:
          if (pattern203 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 176;

        case E_RVVM4SFmode:
          if (pattern203 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 177;

        case E_RVVM2SFmode:
          if (pattern203 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 178;

        case E_RVVM1SFmode:
          if (pattern203 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 179;

        case E_RVVMF2SFmode:
          if (pattern203 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 180;

        case E_RVVM8DFmode:
          if (pattern203 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 181;

        case E_RVVM4DFmode:
          if (pattern203 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 182;

        case E_RVVM2DFmode:
          if (pattern203 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 183;

        case E_RVVM1DFmode:
          if (pattern203 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 184;

        case E_V1HFmode:
          if (pattern203 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 185;

        case E_V2HFmode:
          if (pattern203 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 186;

        case E_V4HFmode:
          if (pattern203 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 187;

        case E_V8HFmode:
          if (pattern203 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 188;

        case E_V16HFmode:
          if (pattern203 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 189;

        case E_V32HFmode:
          if (pattern203 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 190;

        case E_V64HFmode:
          if (pattern203 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 191;

        case E_V128HFmode:
          if (pattern203 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 192;

        case E_V256HFmode:
          if (pattern203 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 193;

        case E_V512HFmode:
          if (pattern203 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 194;

        case E_V1024HFmode:
          if (pattern203 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 195;

        case E_V2048HFmode:
          if (pattern203 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 196;

        case E_V1SFmode:
          if (pattern203 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 197;

        case E_V2SFmode:
          if (pattern203 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 198;

        case E_V4SFmode:
          if (pattern203 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 199;

        case E_V8SFmode:
          if (pattern203 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 200;

        case E_V16SFmode:
          if (pattern203 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 201;

        case E_V32SFmode:
          if (pattern203 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 202;

        case E_V64SFmode:
          if (pattern203 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 203;

        case E_V128SFmode:
          if (pattern203 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 204;

        case E_V256SFmode:
          if (pattern203 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 205;

        case E_V512SFmode:
          if (pattern203 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 206;

        case E_V1024SFmode:
          if (pattern203 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 207;

        case E_V1DFmode:
          if (pattern203 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 208;

        case E_V2DFmode:
          if (pattern203 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 209;

        case E_V4DFmode:
          if (pattern203 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 210;

        case E_V8DFmode:
          if (pattern203 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 211;

        case E_V16DFmode:
          if (pattern203 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 212;

        case E_V32DFmode:
          if (pattern203 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 213;

        case E_V64DFmode:
          if (pattern203 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 214;

        case E_V128DFmode:
          if (pattern203 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 215;

        case E_V256DFmode:
          if (pattern203 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 216;

        case E_V512DFmode:
          if (pattern203 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 217;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern205 (x1);
      if (res >= 0)
        return res + 218; /* [218, 309] */
      return -1;

    case ZERO_EXTEND:
      res = pattern205 (x1);
      if (res >= 0)
        return res + 310; /* [310, 401] */
      return -1;

    case TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x4 = XEXP (x1, 2);
          operands[3] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM4QImode:
              if (pattern204 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
                return -1;
              return 402;

            case E_RVVM2QImode:
              if (pattern204 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 403;

            case E_RVVM1QImode:
              if (pattern204 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 404;

            case E_RVVMF2QImode:
              if (pattern204 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 405;

            case E_RVVMF4QImode:
              if (pattern204 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 406;

            case E_RVVMF8QImode:
              if (pattern204 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 407;

            case E_RVVM4HImode:
              if (pattern204 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 408;

            case E_RVVM2HImode:
              if (pattern204 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 409;

            case E_RVVM1HImode:
              if (pattern204 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 410;

            case E_RVVMF2HImode:
              if (pattern204 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 411;

            case E_RVVMF4HImode:
              if (pattern204 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 412;

            case E_RVVM4SImode:
              if (pattern204 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 413;

            case E_RVVM2SImode:
              if (pattern204 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 414;

            case E_RVVM1SImode:
              if (pattern204 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 415;

            case E_RVVMF2SImode:
              if (pattern204 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 416;

            case E_V1QImode:
              if (pattern204 (x1, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0)
                return -1;
              return 417;

            case E_V2QImode:
              if (pattern204 (x1, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0)
                return -1;
              return 418;

            case E_V4QImode:
              if (pattern204 (x1, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0)
                return -1;
              return 419;

            case E_V8QImode:
              if (pattern204 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0)
                return -1;
              return 420;

            case E_V16QImode:
              if (pattern204 (x1, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0)
                return -1;
              return 421;

            case E_V32QImode:
              if (pattern204 (x1, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0)
                return -1;
              return 422;

            case E_V64QImode:
              if (pattern204 (x1, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0)
                return -1;
              return 423;

            case E_V128QImode:
              if (pattern204 (x1, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0)
                return -1;
              return 424;

            case E_V256QImode:
              if (pattern204 (x1, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0)
                return -1;
              return 425;

            case E_V512QImode:
              if (pattern204 (x1, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0)
                return -1;
              return 426;

            case E_V1024QImode:
              if (pattern204 (x1, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
                return -1;
              return 427;

            case E_V2048QImode:
              if (pattern204 (x1, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0)
                return -1;
              return 428;

            case E_V1HImode:
              if (pattern204 (x1, 
E_V1HImode, 
E_V1SImode, 
E_V1BImode) != 0)
                return -1;
              return 429;

            case E_V2HImode:
              if (pattern204 (x1, 
E_V2HImode, 
E_V2SImode, 
E_V2BImode) != 0)
                return -1;
              return 430;

            case E_V4HImode:
              if (pattern204 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V4BImode) != 0)
                return -1;
              return 431;

            case E_V8HImode:
              if (pattern204 (x1, 
E_V8HImode, 
E_V8SImode, 
E_V8BImode) != 0)
                return -1;
              return 432;

            case E_V16HImode:
              if (pattern204 (x1, 
E_V16HImode, 
E_V16SImode, 
E_V16BImode) != 0)
                return -1;
              return 433;

            case E_V32HImode:
              if (pattern204 (x1, 
E_V32HImode, 
E_V32SImode, 
E_V32BImode) != 0)
                return -1;
              return 434;

            case E_V64HImode:
              if (pattern204 (x1, 
E_V64HImode, 
E_V64SImode, 
E_V64BImode) != 0)
                return -1;
              return 435;

            case E_V128HImode:
              if (pattern204 (x1, 
E_V128HImode, 
E_V128SImode, 
E_V128BImode) != 0)
                return -1;
              return 436;

            case E_V256HImode:
              if (pattern204 (x1, 
E_V256HImode, 
E_V256SImode, 
E_V256BImode) != 0)
                return -1;
              return 437;

            case E_V512HImode:
              if (pattern204 (x1, 
E_V512HImode, 
E_V512SImode, 
E_V512BImode) != 0)
                return -1;
              return 438;

            case E_V1024HImode:
              if (pattern204 (x1, 
E_V1024HImode, 
E_V1024SImode, 
E_V1024BImode) != 0)
                return -1;
              return 439;

            case E_V1SImode:
              if (pattern204 (x1, 
E_V1SImode, 
E_V1DImode, 
E_V1BImode) != 0)
                return -1;
              return 440;

            case E_V2SImode:
              if (pattern204 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V2BImode) != 0)
                return -1;
              return 441;

            case E_V4SImode:
              if (pattern204 (x1, 
E_V4SImode, 
E_V4DImode, 
E_V4BImode) != 0)
                return -1;
              return 442;

            case E_V8SImode:
              if (pattern204 (x1, 
E_V8SImode, 
E_V8DImode, 
E_V8BImode) != 0)
                return -1;
              return 443;

            case E_V16SImode:
              if (pattern204 (x1, 
E_V16SImode, 
E_V16DImode, 
E_V16BImode) != 0)
                return -1;
              return 444;

            case E_V32SImode:
              if (pattern204 (x1, 
E_V32SImode, 
E_V32DImode, 
E_V32BImode) != 0)
                return -1;
              return 445;

            case E_V64SImode:
              if (pattern204 (x1, 
E_V64SImode, 
E_V64DImode, 
E_V64BImode) != 0)
                return -1;
              return 446;

            case E_V128SImode:
              if (pattern204 (x1, 
E_V128SImode, 
E_V128DImode, 
E_V128BImode) != 0)
                return -1;
              return 447;

            case E_V256SImode:
              if (pattern204 (x1, 
E_V256SImode, 
E_V256DImode, 
E_V256BImode) != 0)
                return -1;
              return 448;

            case E_V512SImode:
              if (pattern204 (x1, 
E_V512SImode, 
E_V512DImode, 
E_V512BImode) != 0)
                return -1;
              return 449;

            default:
              return -1;
            }

        case ASHIFTRT:
          res = pattern209 (x1);
          if (res >= 0)
            return res + 450; /* [450, 593] */
          return -1;

        case LSHIFTRT:
          res = pattern209 (x1);
          if (res >= 0)
            return res + 594; /* [594, 737] */
          return -1;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern204 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 738;

        case E_RVVM4SFmode:
          if (pattern204 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 739;

        case E_RVVM2SFmode:
          if (pattern204 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 740;

        case E_RVVM1SFmode:
          if (pattern204 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 741;

        case E_RVVMF2SFmode:
          if (pattern204 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 742;

        case E_RVVM8DFmode:
          if (pattern204 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 743;

        case E_RVVM4DFmode:
          if (pattern204 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 744;

        case E_RVVM2DFmode:
          if (pattern204 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 745;

        case E_RVVM1DFmode:
          if (pattern204 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 746;

        case E_V1SFmode:
          if (pattern204 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 747;

        case E_V2SFmode:
          if (pattern204 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 748;

        case E_V4SFmode:
          if (pattern204 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 749;

        case E_V8SFmode:
          if (pattern204 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 750;

        case E_V16SFmode:
          if (pattern204 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 751;

        case E_V32SFmode:
          if (pattern204 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 752;

        case E_V64SFmode:
          if (pattern204 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 753;

        case E_V128SFmode:
          if (pattern204 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 754;

        case E_V256SFmode:
          if (pattern204 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 755;

        case E_V512SFmode:
          if (pattern204 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 756;

        case E_V1024SFmode:
          if (pattern204 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 757;

        case E_V1DFmode:
          if (pattern204 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 758;

        case E_V2DFmode:
          if (pattern204 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 759;

        case E_V4DFmode:
          if (pattern204 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 760;

        case E_V8DFmode:
          if (pattern204 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 761;

        case E_V16DFmode:
          if (pattern204 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 762;

        case E_V32DFmode:
          if (pattern204 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 763;

        case E_V64DFmode:
          if (pattern204 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 764;

        case E_V128DFmode:
          if (pattern204 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 765;

        case E_V256DFmode:
          if (pattern204 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 766;

        case E_V512DFmode:
          if (pattern204 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 767;

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HFmode:
          if (pattern204 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 768;

        case E_RVVM2HFmode:
          if (pattern204 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 769;

        case E_RVVM1HFmode:
          if (pattern204 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 770;

        case E_RVVMF2HFmode:
          if (pattern204 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 771;

        case E_RVVMF4HFmode:
          if (pattern204 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 772;

        case E_RVVM4SFmode:
          if (pattern204 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 773;

        case E_RVVM2SFmode:
          if (pattern204 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 774;

        case E_RVVM1SFmode:
          if (pattern204 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 775;

        case E_RVVMF2SFmode:
          if (pattern204 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 776;

        case E_V1HFmode:
          if (pattern204 (x1, 
E_V1HFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 777;

        case E_V2HFmode:
          if (pattern204 (x1, 
E_V2HFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 778;

        case E_V4HFmode:
          if (pattern204 (x1, 
E_V4HFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 779;

        case E_V8HFmode:
          if (pattern204 (x1, 
E_V8HFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 780;

        case E_V16HFmode:
          if (pattern204 (x1, 
E_V16HFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 781;

        case E_V32HFmode:
          if (pattern204 (x1, 
E_V32HFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 782;

        case E_V64HFmode:
          if (pattern204 (x1, 
E_V64HFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 783;

        case E_V128HFmode:
          if (pattern204 (x1, 
E_V128HFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 784;

        case E_V256HFmode:
          if (pattern204 (x1, 
E_V256HFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 785;

        case E_V512HFmode:
          if (pattern204 (x1, 
E_V512HFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 786;

        case E_V1024HFmode:
          if (pattern204 (x1, 
E_V1024HFmode, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 787;

        case E_V1SFmode:
          if (pattern204 (x1, 
E_V1SFmode, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 788;

        case E_V2SFmode:
          if (pattern204 (x1, 
E_V2SFmode, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 789;

        case E_V4SFmode:
          if (pattern204 (x1, 
E_V4SFmode, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 790;

        case E_V8SFmode:
          if (pattern204 (x1, 
E_V8SFmode, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 791;

        case E_V16SFmode:
          if (pattern204 (x1, 
E_V16SFmode, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 792;

        case E_V32SFmode:
          if (pattern204 (x1, 
E_V32SFmode, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 793;

        case E_V64SFmode:
          if (pattern204 (x1, 
E_V64SFmode, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 794;

        case E_V128SFmode:
          if (pattern204 (x1, 
E_V128SFmode, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 795;

        case E_V256SFmode:
          if (pattern204 (x1, 
E_V256SFmode, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 796;

        case E_V512SFmode:
          if (pattern204 (x1, 
E_V512SFmode, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 797;

        default:
          return -1;
        }

    case FIX:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 798; /* [798, 923] */
      return -1;

    case UNSIGNED_FIX:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 924; /* [924, 1049] */
      return -1;

    case FLOAT:
      res = pattern211 (x1);
      if (res >= 0)
        return res + 1050; /* [1050, 1175] */
      return -1;

    case UNSIGNED_FLOAT:
      res = pattern211 (x1);
      if (res >= 0)
        return res + 1176; /* [1176, 1301] */
      return -1;

    case SMUL_HIGHPART:
      res = pattern213 (x1);
      if (res >= 0)
        return res + 1302; /* [1302, 1369] */
      return -1;

    case UMUL_HIGHPART:
      res = pattern213 (x1);
      if (res >= 0)
        return res + 1370; /* [1370, 1437] */
      return -1;

    default:
      return -1;
    }
}

int
pattern432 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!vector_length_operand (operands[4], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[5] = x6;
  x7 = XVECEXP (x2, 0, 0);
  operands[2] = x7;
  if (!pmode_reg_or_0_operand (operands[2], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x2, 0, 1);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern431 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern431 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern431 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern431 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern431 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern431 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern431 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern431 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern431 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern431 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern431 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern431 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern431 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern431 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern431 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern431 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF8QImode:
      if (pattern431 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4HImode:
      if (pattern431 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2SImode:
      if (pattern431 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern451 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!autovec_length_operand (operands[4], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  operands[5] = x8;
  if (!const_0_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x2, 0, 1);
  operands[6] = x9;
  if (!autovec_length_operand (operands[6], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern450 (x1, 
E_SImode); /* [-1, 19] */

    case E_DImode:
      res = pattern450 (x1, 
E_DImode);
      if (res >= 0)
        return res + 20; /* [20, 39] */
      return -1;

    default:
      return -1;
    }
}

int
pattern463 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!vector_move_operand (operands[3], i1))
    return -1;
  x6 = XEXP (x1, 2);
  operands[2] = x6;
  if (!vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern468 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !reg_or_mem_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern472 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern475 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern478 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[6] = x5;
  x6 = XEXP (x1, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x9 = XEXP (x1, 2);
  operands[1] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SImode:
      return pattern477 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode); /* [-1, 0] */

    case E_RVVM4SImode:
      if (pattern477 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2SImode:
      if (pattern477 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1SImode:
      if (pattern477 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SImode:
      if (pattern477 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern481 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_arith_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern482 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[4] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern481 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern481 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern481 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern481 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern481 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern481 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern481 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern481 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern481 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern481 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern481 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern481 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern481 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern481 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern481 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern481 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern481 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern481 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern481 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern481 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern481 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern481 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern481 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern481 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern481 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern481 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern481 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern481 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern481 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern481 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern481 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern481 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern481 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern481 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern481 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern481 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern481 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern481 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern481 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern481 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern481 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern481 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern481 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern481 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern481 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern481 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern481 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern481 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern481 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern481 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern481 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern481 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern481 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern481 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern481 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern481 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern481 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern481 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern481 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern481 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern481 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern481 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern481 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern481 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern481 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern481 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern481 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern481 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern497 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern498 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  x10 = XEXP (x7, 1);
  switch (GET_CODE (x10))
    {
    case REG:
    case SUBREG:
      return pattern493 (x1); /* [-1, 67] */

    case VEC_DUPLICATE:
      x11 = XEXP (x10, 0);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          res = pattern496 (x1);
          if (res >= 0)
            return res + 68; /* [68, 135] */
          return -1;

        case SIGN_EXTEND:
          if (GET_MODE (x11) != E_DImode)
            return -1;
          x12 = XEXP (x11, 0);
          operands[4] = x12;
          if (!reg_or_0_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern497 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 136;

            case E_RVVM4DImode:
              if (pattern497 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 137;

            case E_RVVM2DImode:
              if (pattern497 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 138;

            case E_RVVM1DImode:
              if (pattern497 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 139;

            case E_V1DImode:
              if (pattern497 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
                return -1;
              return 140;

            case E_V2DImode:
              if (pattern497 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
                return -1;
              return 141;

            case E_V4DImode:
              if (pattern497 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
                return -1;
              return 142;

            case E_V8DImode:
              if (pattern497 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
                return -1;
              return 143;

            case E_V16DImode:
              if (pattern497 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
                return -1;
              return 144;

            case E_V32DImode:
              if (pattern497 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
                return -1;
              return 145;

            case E_V64DImode:
              if (pattern497 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
                return -1;
              return 146;

            case E_V128DImode:
              if (pattern497 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
                return -1;
              return 147;

            case E_V256DImode:
              if (pattern497 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
                return -1;
              return 148;

            case E_V512DImode:
              if (pattern497 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
                return -1;
              return 149;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern506 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM4QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM4QImode))
        return -1;
      return 0;

    case E_RVVM8HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern508 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern511 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVMF8QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern514 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V4QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 0;

    case E_V4HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V4SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern517 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V32QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 0;

    case E_V32HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern520 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V256QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V256QImode))
        return -1;
      return 0;

    case E_V256HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 1;

    case E_V256SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern524 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern526 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern530 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[5] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[6] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[7] = x7;
  x8 = XVECEXP (x4, 0, 4);
  operands[8] = x8;
  x9 = XEXP (x2, 0);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  x11 = XEXP (x1, 2);
  operands[2] = x11;
  return pattern529 (x1); /* [-1, 95] */
}

int
pattern533 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern535 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern536 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != i5)
    return -1;
  x9 = XEXP (x7, 0);
  if (GET_CODE (x9) != MEM)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != PLUS)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 2)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 3);
  x14 = XEXP (x13, 1);
  if (GET_CODE (x14) != REG
      || REGNO (x14) != i4)
    return -1;
  x15 = XEXP (x13, 0);
  if (GET_CODE (x15) != MEM)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != PLUS)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 2)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_CODE (x18) != CONST_INT)
    return -1;
  x19 = XVECEXP (x1, 0, 4);
  x20 = XEXP (x19, 1);
  if (GET_CODE (x20) != REG
      || REGNO (x20) != i3)
    return -1;
  x21 = XEXP (x19, 0);
  if (GET_CODE (x21) != MEM)
    return -1;
  x22 = XEXP (x21, 0);
  if (GET_CODE (x22) != PLUS)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 2)
    return -1;
  x24 = XEXP (x22, 1);
  if (GET_CODE (x24) != CONST_INT)
    return -1;
  x25 = XVECEXP (x1, 0, 5);
  x26 = XEXP (x25, 1);
  if (GET_CODE (x26) != REG
      || REGNO (x26) != i2)
    return -1;
  x27 = XEXP (x25, 0);
  if (GET_CODE (x27) != MEM)
    return -1;
  x28 = XEXP (x27, 0);
  if (GET_CODE (x28) != PLUS)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 2)
    return -1;
  x30 = XEXP (x28, 1);
  if (GET_CODE (x30) != CONST_INT)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  return pattern535 (x31, 
i1); /* [-1, 0] */
}

int
pattern540 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  x10 = XEXP (x7, 1);
  x11 = XEXP (x10, 0);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      operands[4] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          return pattern537 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

        case E_RVVM4HImode:
          if (pattern537 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HImode:
          if (pattern537 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HImode:
          if (pattern537 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HImode:
          if (pattern537 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HImode:
          if (pattern537 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 5;

        case E_RVVM8SImode:
          if (pattern537 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 6;

        case E_RVVM4SImode:
          if (pattern537 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 7;

        case E_RVVM2SImode:
          if (pattern537 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 8;

        case E_RVVM1SImode:
          if (pattern537 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SImode:
          if (pattern537 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 10;

        case E_RVVM8DImode:
          if (pattern537 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 11;

        case E_RVVM4DImode:
          if (pattern537 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 12;

        case E_RVVM2DImode:
          if (pattern537 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 13;

        case E_RVVM1DImode:
          if (pattern537 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 14;

        case E_V1HImode:
          if (pattern537 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 15;

        case E_V2HImode:
          if (pattern537 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 16;

        case E_V4HImode:
          if (pattern537 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 17;

        case E_V8HImode:
          if (pattern537 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 18;

        case E_V16HImode:
          if (pattern537 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 19;

        case E_V32HImode:
          if (pattern537 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 20;

        case E_V64HImode:
          if (pattern537 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 21;

        case E_V128HImode:
          if (pattern537 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 22;

        case E_V256HImode:
          if (pattern537 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 23;

        case E_V512HImode:
          if (pattern537 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 24;

        case E_V1024HImode:
          if (pattern537 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 25;

        case E_V2048HImode:
          if (pattern537 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 26;

        case E_V1SImode:
          if (pattern537 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 27;

        case E_V2SImode:
          if (pattern537 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 28;

        case E_V4SImode:
          if (pattern537 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 29;

        case E_V8SImode:
          if (pattern537 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 30;

        case E_V16SImode:
          if (pattern537 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 31;

        case E_V32SImode:
          if (pattern537 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 32;

        case E_V64SImode:
          if (pattern537 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 33;

        case E_V128SImode:
          if (pattern537 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 34;

        case E_V256SImode:
          if (pattern537 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 35;

        case E_V512SImode:
          if (pattern537 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 36;

        case E_V1024SImode:
          if (pattern537 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 37;

        case E_V1DImode:
          if (pattern537 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 38;

        case E_V2DImode:
          if (pattern537 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 39;

        case E_V4DImode:
          if (pattern537 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 40;

        case E_V8DImode:
          if (pattern537 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 41;

        case E_V16DImode:
          if (pattern537 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 42;

        case E_V32DImode:
          if (pattern537 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 43;

        case E_V64DImode:
          if (pattern537 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 44;

        case E_V128DImode:
          if (pattern537 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 45;

        case E_V256DImode:
          if (pattern537 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 46;

        case E_V512DImode:
          if (pattern537 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      res = pattern539 (x1);
      if (res >= 0)
        return res + 48; /* [48, 95] */
      return -1;

    default:
      return -1;
    }
}

int
pattern554 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern549 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern549 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern549 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern549 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern549 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern549 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern549 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern549 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern549 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern549 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern549 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern549 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern549 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern549 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern549 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern549 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern549 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern549 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern549 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern549 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern549 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern549 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern549 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern549 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern549 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern549 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern549 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern549 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern549 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern549 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern549 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern549 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern549 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern549 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern549 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern549 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern549 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern549 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern549 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern549 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern549 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern549 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern549 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern549 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern549 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern549 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern549 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern549 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern572 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case PLUS:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 0;

    case IOR:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 1;

    case XOR:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 2;

    case AND:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 3;

    case NOT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != AND
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern575 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1BImode)
      || GET_MODE (x1) != E_RVVM1BImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_RVVM8QImode
      || !register_operand (operands[1], E_RVVM8QImode)
      || !register_operand (operands[2], E_RVVM8QImode))
    return -1;
  return 0;
}

int
pattern577 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i3)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern578 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          return pattern565 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

        case E_RVVM4HFmode:
          if (pattern565 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HFmode:
          if (pattern565 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HFmode:
          if (pattern565 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HFmode:
          if (pattern565 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HFmode:
          if (pattern565 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 5;

        case E_RVVM8SFmode:
          if (pattern565 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 6;

        case E_RVVM4SFmode:
          if (pattern565 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 7;

        case E_RVVM2SFmode:
          if (pattern565 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 8;

        case E_RVVM1SFmode:
          if (pattern565 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (pattern565 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 10;

        case E_RVVM8DFmode:
          if (pattern565 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 11;

        case E_RVVM4DFmode:
          if (pattern565 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 12;

        case E_RVVM2DFmode:
          if (pattern565 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 13;

        case E_RVVM1DFmode:
          if (pattern565 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 14;

        case E_V1HFmode:
          if (pattern565 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 15;

        case E_V2HFmode:
          if (pattern565 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 16;

        case E_V4HFmode:
          if (pattern565 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 17;

        case E_V8HFmode:
          if (pattern565 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 18;

        case E_V16HFmode:
          if (pattern565 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 19;

        case E_V32HFmode:
          if (pattern565 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 20;

        case E_V64HFmode:
          if (pattern565 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 21;

        case E_V128HFmode:
          if (pattern565 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 22;

        case E_V256HFmode:
          if (pattern565 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 23;

        case E_V512HFmode:
          if (pattern565 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 24;

        case E_V1024HFmode:
          if (pattern565 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 25;

        case E_V2048HFmode:
          if (pattern565 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 26;

        case E_V1SFmode:
          if (pattern565 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 27;

        case E_V2SFmode:
          if (pattern565 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 28;

        case E_V4SFmode:
          if (pattern565 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 29;

        case E_V8SFmode:
          if (pattern565 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 30;

        case E_V16SFmode:
          if (pattern565 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 31;

        case E_V32SFmode:
          if (pattern565 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 32;

        case E_V64SFmode:
          if (pattern565 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 33;

        case E_V128SFmode:
          if (pattern565 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 34;

        case E_V256SFmode:
          if (pattern565 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 35;

        case E_V512SFmode:
          if (pattern565 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 36;

        case E_V1024SFmode:
          if (pattern565 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 37;

        case E_V1DFmode:
          if (pattern565 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 38;

        case E_V2DFmode:
          if (pattern565 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 39;

        case E_V4DFmode:
          if (pattern565 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 40;

        case E_V8DFmode:
          if (pattern565 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 41;

        case E_V16DFmode:
          if (pattern565 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 42;

        case E_V32DFmode:
          if (pattern565 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 43;

        case E_V64DFmode:
          if (pattern565 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 44;

        case E_V128DFmode:
          if (pattern565 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 45;

        case E_V256DFmode:
          if (pattern565 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 46;

        case E_V512DFmode:
          if (pattern565 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x1, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XVECEXP (x5, 0, 5);
      operands[9] = x10;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      x12 = XEXP (x3, 1);
      operands[3] = x12;
      x13 = XEXP (x2, 1);
      operands[4] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern577 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) != 0)
            return -1;
          return 48;

        case E_RVVM4HFmode:
          if (pattern577 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
            return -1;
          return 49;

        case E_RVVM2HFmode:
          if (pattern577 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
            return -1;
          return 50;

        case E_RVVM1HFmode:
          if (pattern577 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
            return -1;
          return 51;

        case E_RVVMF2HFmode:
          if (pattern577 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
            return -1;
          return 52;

        case E_RVVMF4HFmode:
          if (pattern577 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
            return -1;
          return 53;

        case E_RVVM8SFmode:
          if (pattern577 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
            return -1;
          return 54;

        case E_RVVM4SFmode:
          if (pattern577 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
            return -1;
          return 55;

        case E_RVVM2SFmode:
          if (pattern577 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
            return -1;
          return 56;

        case E_RVVM1SFmode:
          if (pattern577 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
            return -1;
          return 57;

        case E_RVVMF2SFmode:
          if (pattern577 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
            return -1;
          return 58;

        case E_RVVM8DFmode:
          if (pattern577 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
            return -1;
          return 59;

        case E_RVVM4DFmode:
          if (pattern577 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
            return -1;
          return 60;

        case E_RVVM2DFmode:
          if (pattern577 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
            return -1;
          return 61;

        case E_RVVM1DFmode:
          if (pattern577 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
            return -1;
          return 62;

        case E_V1HFmode:
          if (pattern577 (x1, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
            return -1;
          return 63;

        case E_V2HFmode:
          if (pattern577 (x1, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
            return -1;
          return 64;

        case E_V4HFmode:
          if (pattern577 (x1, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
            return -1;
          return 65;

        case E_V8HFmode:
          if (pattern577 (x1, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
            return -1;
          return 66;

        case E_V16HFmode:
          if (pattern577 (x1, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
            return -1;
          return 67;

        case E_V32HFmode:
          if (pattern577 (x1, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
            return -1;
          return 68;

        case E_V64HFmode:
          if (pattern577 (x1, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
            return -1;
          return 69;

        case E_V128HFmode:
          if (pattern577 (x1, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
            return -1;
          return 70;

        case E_V256HFmode:
          if (pattern577 (x1, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
            return -1;
          return 71;

        case E_V512HFmode:
          if (pattern577 (x1, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
            return -1;
          return 72;

        case E_V1024HFmode:
          if (pattern577 (x1, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
            return -1;
          return 73;

        case E_V2048HFmode:
          if (pattern577 (x1, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
            return -1;
          return 74;

        case E_V1SFmode:
          if (pattern577 (x1, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
            return -1;
          return 75;

        case E_V2SFmode:
          if (pattern577 (x1, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
            return -1;
          return 76;

        case E_V4SFmode:
          if (pattern577 (x1, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
            return -1;
          return 77;

        case E_V8SFmode:
          if (pattern577 (x1, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
            return -1;
          return 78;

        case E_V16SFmode:
          if (pattern577 (x1, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
            return -1;
          return 79;

        case E_V32SFmode:
          if (pattern577 (x1, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
            return -1;
          return 80;

        case E_V64SFmode:
          if (pattern577 (x1, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
            return -1;
          return 81;

        case E_V128SFmode:
          if (pattern577 (x1, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
            return -1;
          return 82;

        case E_V256SFmode:
          if (pattern577 (x1, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
            return -1;
          return 83;

        case E_V512SFmode:
          if (pattern577 (x1, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
            return -1;
          return 84;

        case E_V1024SFmode:
          if (pattern577 (x1, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0)
            return -1;
          return 85;

        case E_V1DFmode:
          if (pattern577 (x1, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0)
            return -1;
          return 86;

        case E_V2DFmode:
          if (pattern577 (x1, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0)
            return -1;
          return 87;

        case E_V4DFmode:
          if (pattern577 (x1, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0)
            return -1;
          return 88;

        case E_V8DFmode:
          if (pattern577 (x1, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0)
            return -1;
          return 89;

        case E_V16DFmode:
          if (pattern577 (x1, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0)
            return -1;
          return 90;

        case E_V32DFmode:
          if (pattern577 (x1, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0)
            return -1;
          return 91;

        case E_V64DFmode:
          if (pattern577 (x1, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0)
            return -1;
          return 92;

        case E_V128DFmode:
          if (pattern577 (x1, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0)
            return -1;
          return 93;

        case E_V256DFmode:
          if (pattern577 (x1, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0)
            return -1;
          return 94;

        case E_V512DFmode:
          if (pattern577 (x1, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0)
            return -1;
          return 95;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x12 = XEXP (x3, 1);
      if (GET_CODE (x12) != FLOAT_EXTEND)
        return -1;
      x5 = XEXP (x1, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XVECEXP (x5, 0, 5);
      operands[9] = x10;
      x14 = XEXP (x12, 0);
      operands[4] = x14;
      x13 = XEXP (x2, 1);
      operands[2] = x13;
      x15 = XEXP (x1, 2);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x11 = XEXP (x4, 0);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[3] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              return 96;

            case E_RVVM4SFmode:
              return 97;

            case E_RVVM2SFmode:
              return 98;

            case E_RVVM1SFmode:
              return 99;

            case E_RVVMF2SFmode:
              return 100;

            case E_RVVM8DFmode:
              return 101;

            case E_RVVM4DFmode:
              return 102;

            case E_RVVM2DFmode:
              return 103;

            case E_RVVM1DFmode:
              return 104;

            case E_V1SFmode:
              return 105;

            case E_V2SFmode:
              return 106;

            case E_V4SFmode:
              return 107;

            case E_V8SFmode:
              return 108;

            case E_V16SFmode:
              return 109;

            case E_V32SFmode:
              return 110;

            case E_V64SFmode:
              return 111;

            case E_V128SFmode:
              return 112;

            case E_V256SFmode:
              return 113;

            case E_V512SFmode:
              return 114;

            case E_V1024SFmode:
              return 115;

            case E_V1DFmode:
              return 116;

            case E_V2DFmode:
              return 117;

            case E_V4DFmode:
              return 118;

            case E_V8DFmode:
              return 119;

            case E_V16DFmode:
              return 120;

            case E_V32DFmode:
              return 121;

            case E_V64DFmode:
              return 122;

            case E_V128DFmode:
              return 123;

            case E_V256DFmode:
              return 124;

            case E_V512DFmode:
              return 125;

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x16 = XEXP (x11, 0);
          operands[3] = x16;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              return 126;

            case E_RVVM4SFmode:
              return 127;

            case E_RVVM2SFmode:
              return 128;

            case E_RVVM1SFmode:
              return 129;

            case E_RVVMF2SFmode:
              return 130;

            case E_RVVM8DFmode:
              return 131;

            case E_RVVM4DFmode:
              return 132;

            case E_RVVM2DFmode:
              return 133;

            case E_RVVM1DFmode:
              return 134;

            case E_V1SFmode:
              return 135;

            case E_V2SFmode:
              return 136;

            case E_V4SFmode:
              return 137;

            case E_V8SFmode:
              return 138;

            case E_V16SFmode:
              return 139;

            case E_V32SFmode:
              return 140;

            case E_V64SFmode:
              return 141;

            case E_V128SFmode:
              return 142;

            case E_V256SFmode:
              return 143;

            case E_V512SFmode:
              return 144;

            case E_V1024SFmode:
              return 145;

            case E_V1DFmode:
              return 146;

            case E_V2DFmode:
              return 147;

            case E_V4DFmode:
              return 148;

            case E_V8DFmode:
              return 149;

            case E_V16DFmode:
              return 150;

            case E_V32DFmode:
              return 151;

            case E_V64DFmode:
              return 152;

            case E_V128DFmode:
              return 153;

            case E_V256DFmode:
              return 154;

            case E_V512DFmode:
              return 155;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern664 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH
      || !pmode_reg_or_0_operand (operands[3], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern472 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      res = pattern642 (x1, 
E_RVVM4QImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_RVVM2QImode:
      res = pattern643 (x1, 
E_RVVM2QImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_RVVM1QImode:
      res = pattern644 (x1, 
E_RVVM1QImode);
      if (res >= 0)
        return res + 6; /* [6, 9] */
      return -1;

    case E_RVVMF2QImode:
      res = pattern645 (x1, 
E_RVVMF2QImode);
      if (res >= 0)
        return res + 10; /* [10, 13] */
      return -1;

    case E_RVVMF4QImode:
      res = pattern646 (x1, 
E_RVVMF4QImode);
      if (res >= 0)
        return res + 14; /* [14, 17] */
      return -1;

    case E_RVVMF8QImode:
      res = pattern647 (x1, 
E_RVVMF8QImode);
      if (res >= 0)
        return res + 18; /* [18, 21] */
      return -1;

    case E_RVVM8HImode:
      res = pattern648 (x1, 
E_RVVM8HImode);
      if (res >= 0)
        return res + 22; /* [22, 23] */
      return -1;

    case E_RVVM4HImode:
      res = pattern649 (x1, 
E_RVVM4HImode);
      if (res >= 0)
        return res + 24; /* [24, 26] */
      return -1;

    case E_RVVM2HImode:
      res = pattern650 (x1, 
E_RVVM2HImode);
      if (res >= 0)
        return res + 27; /* [27, 30] */
      return -1;

    case E_RVVM1HImode:
      res = pattern651 (x1, 
E_RVVM1HImode);
      if (res >= 0)
        return res + 31; /* [31, 34] */
      return -1;

    case E_RVVMF2HImode:
      res = pattern652 (x1, 
E_RVVMF2HImode);
      if (res >= 0)
        return res + 35; /* [35, 38] */
      return -1;

    case E_RVVMF4HImode:
      res = pattern653 (x1, 
E_RVVMF4HImode);
      if (res >= 0)
        return res + 39; /* [39, 42] */
      return -1;

    case E_RVVM8SImode:
      res = pattern654 (x1, 
E_RVVM8SImode);
      if (res >= 0)
        return res + 43; /* [43, 45] */
      return -1;

    case E_RVVM4SImode:
      res = pattern655 (x1, 
E_RVVM4SImode);
      if (res >= 0)
        return res + 46; /* [46, 49] */
      return -1;

    case E_RVVM2SImode:
      res = pattern656 (x1, 
E_RVVM2SImode);
      if (res >= 0)
        return res + 50; /* [50, 53] */
      return -1;

    case E_RVVM1SImode:
      res = pattern657 (x1, 
E_RVVM1SImode);
      if (res >= 0)
        return res + 54; /* [54, 57] */
      return -1;

    case E_RVVMF2SImode:
      res = pattern658 (x1, 
E_RVVMF2SImode);
      if (res >= 0)
        return res + 58; /* [58, 61] */
      return -1;

    case E_RVVM8DImode:
      res = pattern659 (x1, 
E_RVVM8DImode);
      if (res >= 0)
        return res + 62; /* [62, 65] */
      return -1;

    case E_RVVM4DImode:
      res = pattern660 (x1, 
E_RVVM4DImode);
      if (res >= 0)
        return res + 66; /* [66, 69] */
      return -1;

    case E_RVVM2DImode:
      res = pattern661 (x1, 
E_RVVM2DImode);
      if (res >= 0)
        return res + 70; /* [70, 73] */
      return -1;

    case E_RVVM1DImode:
      res = pattern662 (x1, 
E_RVVM1DImode);
      if (res >= 0)
        return res + 74; /* [74, 77] */
      return -1;

    case E_RVVM8BFmode:
      res = pattern648 (x1, 
E_RVVM8BFmode);
      if (res >= 0)
        return res + 78; /* [78, 79] */
      return -1;

    case E_RVVM4BFmode:
      res = pattern649 (x1, 
E_RVVM4BFmode);
      if (res >= 0)
        return res + 80; /* [80, 82] */
      return -1;

    case E_RVVM2BFmode:
      res = pattern650 (x1, 
E_RVVM2BFmode);
      if (res >= 0)
        return res + 83; /* [83, 86] */
      return -1;

    case E_RVVM1BFmode:
      res = pattern651 (x1, 
E_RVVM1BFmode);
      if (res >= 0)
        return res + 87; /* [87, 90] */
      return -1;

    case E_RVVMF2BFmode:
      res = pattern652 (x1, 
E_RVVMF2BFmode);
      if (res >= 0)
        return res + 91; /* [91, 94] */
      return -1;

    case E_RVVMF4BFmode:
      res = pattern653 (x1, 
E_RVVMF4BFmode);
      if (res >= 0)
        return res + 95; /* [95, 98] */
      return -1;

    case E_RVVM8HFmode:
      res = pattern648 (x1, 
E_RVVM8HFmode);
      if (res >= 0)
        return res + 99; /* [99, 100] */
      return -1;

    case E_RVVM4HFmode:
      res = pattern649 (x1, 
E_RVVM4HFmode);
      if (res >= 0)
        return res + 101; /* [101, 103] */
      return -1;

    case E_RVVM2HFmode:
      res = pattern650 (x1, 
E_RVVM2HFmode);
      if (res >= 0)
        return res + 104; /* [104, 107] */
      return -1;

    case E_RVVM1HFmode:
      res = pattern651 (x1, 
E_RVVM1HFmode);
      if (res >= 0)
        return res + 108; /* [108, 111] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern652 (x1, 
E_RVVMF2HFmode);
      if (res >= 0)
        return res + 112; /* [112, 115] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern653 (x1, 
E_RVVMF4HFmode);
      if (res >= 0)
        return res + 116; /* [116, 119] */
      return -1;

    case E_RVVM8SFmode:
      res = pattern654 (x1, 
E_RVVM8SFmode);
      if (res >= 0)
        return res + 120; /* [120, 122] */
      return -1;

    case E_RVVM4SFmode:
      res = pattern655 (x1, 
E_RVVM4SFmode);
      if (res >= 0)
        return res + 123; /* [123, 126] */
      return -1;

    case E_RVVM2SFmode:
      res = pattern656 (x1, 
E_RVVM2SFmode);
      if (res >= 0)
        return res + 127; /* [127, 130] */
      return -1;

    case E_RVVM1SFmode:
      res = pattern657 (x1, 
E_RVVM1SFmode);
      if (res >= 0)
        return res + 131; /* [131, 134] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern658 (x1, 
E_RVVMF2SFmode);
      if (res >= 0)
        return res + 135; /* [135, 138] */
      return -1;

    case E_RVVM8DFmode:
      res = pattern659 (x1, 
E_RVVM8DFmode);
      if (res >= 0)
        return res + 139; /* [139, 142] */
      return -1;

    case E_RVVM4DFmode:
      res = pattern660 (x1, 
E_RVVM4DFmode);
      if (res >= 0)
        return res + 143; /* [143, 146] */
      return -1;

    case E_RVVM2DFmode:
      res = pattern661 (x1, 
E_RVVM2DFmode);
      if (res >= 0)
        return res + 147; /* [147, 150] */
      return -1;

    case E_RVVM1DFmode:
      res = pattern662 (x1, 
E_RVVM1DFmode);
      if (res >= 0)
        return res + 151; /* [151, 154] */
      return -1;

    case E_V1QImode:
      if (pattern472 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 155;

    case E_V2QImode:
      if (pattern472 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 156;

    case E_V4QImode:
      if (pattern472 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 157;

    case E_V8QImode:
      if (pattern472 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 158;

    case E_V16QImode:
      if (pattern472 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 159;

    case E_V32QImode:
      if (pattern472 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 160;

    case E_V64QImode:
      if (pattern472 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 161;

    case E_V128QImode:
      if (pattern472 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 162;

    case E_V256QImode:
      if (pattern472 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 163;

    case E_V512QImode:
      if (pattern472 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 164;

    case E_V1024QImode:
      if (pattern472 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 165;

    case E_V2048QImode:
      if (pattern472 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 166;

    case E_V4096QImode:
      if (pattern472 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 167;

    case E_V1HImode:
      if (pattern472 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 168;

    case E_V2HImode:
      if (pattern472 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 169;

    case E_V4HImode:
      if (pattern472 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 170;

    case E_V8HImode:
      if (pattern472 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 171;

    case E_V16HImode:
      if (pattern472 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 172;

    case E_V32HImode:
      if (pattern472 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 173;

    case E_V64HImode:
      if (pattern472 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 174;

    case E_V128HImode:
      if (pattern472 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 175;

    case E_V256HImode:
      if (pattern472 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 176;

    case E_V512HImode:
      if (pattern472 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 177;

    case E_V1024HImode:
      if (pattern472 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 178;

    case E_V2048HImode:
      if (pattern472 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 179;

    case E_V1SImode:
      if (pattern472 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 180;

    case E_V2SImode:
      if (pattern472 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 181;

    case E_V4SImode:
      if (pattern472 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 182;

    case E_V8SImode:
      if (pattern472 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 183;

    case E_V16SImode:
      if (pattern472 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 184;

    case E_V32SImode:
      if (pattern472 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 185;

    case E_V64SImode:
      if (pattern472 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 186;

    case E_V128SImode:
      if (pattern472 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 187;

    case E_V256SImode:
      if (pattern472 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 188;

    case E_V512SImode:
      if (pattern472 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 189;

    case E_V1024SImode:
      if (pattern472 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 190;

    case E_V1DImode:
      if (pattern472 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 191;

    case E_V2DImode:
      if (pattern472 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 192;

    case E_V4DImode:
      if (pattern472 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 193;

    case E_V8DImode:
      if (pattern472 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 194;

    case E_V16DImode:
      if (pattern472 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 195;

    case E_V32DImode:
      if (pattern472 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 196;

    case E_V64DImode:
      if (pattern472 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 197;

    case E_V128DImode:
      if (pattern472 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 198;

    case E_V256DImode:
      if (pattern472 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 199;

    case E_V512DImode:
      if (pattern472 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 200;

    case E_V1HFmode:
      if (pattern663 (x1, 
E_V1HFmode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 201;

    case E_V2HFmode:
      if (pattern663 (x1, 
E_V2HFmode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 202;

    case E_V4HFmode:
      if (pattern663 (x1, 
E_V4HFmode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 203;

    case E_V8HFmode:
      if (pattern663 (x1, 
E_V8HFmode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 204;

    case E_V16HFmode:
      if (pattern663 (x1, 
E_V16HFmode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 205;

    case E_V32HFmode:
      if (pattern663 (x1, 
E_V32HFmode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 206;

    case E_V64HFmode:
      if (pattern663 (x1, 
E_V64HFmode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 207;

    case E_V128HFmode:
      if (pattern663 (x1, 
E_V128HFmode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 208;

    case E_V256HFmode:
      if (pattern663 (x1, 
E_V256HFmode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 209;

    case E_V512HFmode:
      if (pattern663 (x1, 
E_V512HFmode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 210;

    case E_V1024HFmode:
      if (pattern663 (x1, 
E_V1024HFmode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 211;

    case E_V2048HFmode:
      if (pattern663 (x1, 
E_V2048HFmode, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 212;

    case E_V1SFmode:
      if (pattern663 (x1, 
E_V1SFmode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 213;

    case E_V2SFmode:
      if (pattern663 (x1, 
E_V2SFmode, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 214;

    case E_V4SFmode:
      if (pattern663 (x1, 
E_V4SFmode, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 215;

    case E_V8SFmode:
      if (pattern663 (x1, 
E_V8SFmode, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 216;

    case E_V16SFmode:
      if (pattern663 (x1, 
E_V16SFmode, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 217;

    case E_V32SFmode:
      if (pattern663 (x1, 
E_V32SFmode, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 218;

    case E_V64SFmode:
      if (pattern663 (x1, 
E_V64SFmode, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 219;

    case E_V128SFmode:
      if (pattern663 (x1, 
E_V128SFmode, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 220;

    case E_V256SFmode:
      if (pattern663 (x1, 
E_V256SFmode, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 221;

    case E_V512SFmode:
      if (pattern663 (x1, 
E_V512SFmode, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 222;

    case E_V1024SFmode:
      if (pattern663 (x1, 
E_V1024SFmode, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 223;

    case E_V1DFmode:
      if (pattern663 (x1, 
E_V1DFmode, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 224;

    case E_V2DFmode:
      if (pattern663 (x1, 
E_V2DFmode, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 225;

    case E_V4DFmode:
      if (pattern663 (x1, 
E_V4DFmode, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 226;

    case E_V8DFmode:
      if (pattern663 (x1, 
E_V8DFmode, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 227;

    case E_V16DFmode:
      if (pattern663 (x1, 
E_V16DFmode, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 228;

    case E_V32DFmode:
      if (pattern663 (x1, 
E_V32DFmode, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 229;

    case E_V64DFmode:
      if (pattern663 (x1, 
E_V64DFmode, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 230;

    case E_V128DFmode:
      if (pattern663 (x1, 
E_V128DFmode, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 231;

    case E_V256DFmode:
      if (pattern663 (x1, 
E_V256DFmode, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 232;

    case E_V512DFmode:
      if (pattern663 (x1, 
E_V512DFmode, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 233;

    case E_RVVMF8x2QImode:
      res = pattern647 (x1, 
E_RVVMF8x2QImode);
      if (res >= 0)
        return res + 234; /* [234, 237] */
      return -1;

    case E_RVVMF8x3QImode:
      res = pattern647 (x1, 
E_RVVMF8x3QImode);
      if (res >= 0)
        return res + 238; /* [238, 241] */
      return -1;

    case E_RVVMF8x4QImode:
      res = pattern647 (x1, 
E_RVVMF8x4QImode);
      if (res >= 0)
        return res + 242; /* [242, 245] */
      return -1;

    case E_RVVMF8x5QImode:
      res = pattern647 (x1, 
E_RVVMF8x5QImode);
      if (res >= 0)
        return res + 246; /* [246, 249] */
      return -1;

    case E_RVVMF8x6QImode:
      res = pattern647 (x1, 
E_RVVMF8x6QImode);
      if (res >= 0)
        return res + 250; /* [250, 253] */
      return -1;

    case E_RVVMF8x7QImode:
      res = pattern647 (x1, 
E_RVVMF8x7QImode);
      if (res >= 0)
        return res + 254; /* [254, 257] */
      return -1;

    case E_RVVMF8x8QImode:
      res = pattern647 (x1, 
E_RVVMF8x8QImode);
      if (res >= 0)
        return res + 258; /* [258, 261] */
      return -1;

    case E_RVVMF4x2HImode:
      res = pattern647 (x1, 
E_RVVMF4x2HImode);
      if (res >= 0)
        return res + 262; /* [262, 265] */
      return -1;

    case E_RVVMF4x3HImode:
      res = pattern647 (x1, 
E_RVVMF4x3HImode);
      if (res >= 0)
        return res + 266; /* [266, 269] */
      return -1;

    case E_RVVMF4x4HImode:
      res = pattern647 (x1, 
E_RVVMF4x4HImode);
      if (res >= 0)
        return res + 270; /* [270, 273] */
      return -1;

    case E_RVVMF4x5HImode:
      res = pattern647 (x1, 
E_RVVMF4x5HImode);
      if (res >= 0)
        return res + 274; /* [274, 277] */
      return -1;

    case E_RVVMF4x6HImode:
      res = pattern647 (x1, 
E_RVVMF4x6HImode);
      if (res >= 0)
        return res + 278; /* [278, 281] */
      return -1;

    case E_RVVMF4x7HImode:
      res = pattern647 (x1, 
E_RVVMF4x7HImode);
      if (res >= 0)
        return res + 282; /* [282, 285] */
      return -1;

    case E_RVVMF4x8HImode:
      res = pattern647 (x1, 
E_RVVMF4x8HImode);
      if (res >= 0)
        return res + 286; /* [286, 289] */
      return -1;

    case E_RVVMF2x2SImode:
      res = pattern647 (x1, 
E_RVVMF2x2SImode);
      if (res >= 0)
        return res + 290; /* [290, 293] */
      return -1;

    case E_RVVMF2x3SImode:
      res = pattern647 (x1, 
E_RVVMF2x3SImode);
      if (res >= 0)
        return res + 294; /* [294, 297] */
      return -1;

    case E_RVVMF2x4SImode:
      res = pattern647 (x1, 
E_RVVMF2x4SImode);
      if (res >= 0)
        return res + 298; /* [298, 301] */
      return -1;

    case E_RVVMF2x5SImode:
      res = pattern647 (x1, 
E_RVVMF2x5SImode);
      if (res >= 0)
        return res + 302; /* [302, 305] */
      return -1;

    case E_RVVMF2x6SImode:
      res = pattern647 (x1, 
E_RVVMF2x6SImode);
      if (res >= 0)
        return res + 306; /* [306, 309] */
      return -1;

    case E_RVVMF2x7SImode:
      res = pattern647 (x1, 
E_RVVMF2x7SImode);
      if (res >= 0)
        return res + 310; /* [310, 313] */
      return -1;

    case E_RVVMF2x8SImode:
      res = pattern647 (x1, 
E_RVVMF2x8SImode);
      if (res >= 0)
        return res + 314; /* [314, 317] */
      return -1;

    case E_RVVM1x2DImode:
      res = pattern647 (x1, 
E_RVVM1x2DImode);
      if (res >= 0)
        return res + 318; /* [318, 321] */
      return -1;

    case E_RVVM1x3DImode:
      res = pattern647 (x1, 
E_RVVM1x3DImode);
      if (res >= 0)
        return res + 322; /* [322, 325] */
      return -1;

    case E_RVVM1x4DImode:
      res = pattern647 (x1, 
E_RVVM1x4DImode);
      if (res >= 0)
        return res + 326; /* [326, 329] */
      return -1;

    case E_RVVM1x5DImode:
      res = pattern647 (x1, 
E_RVVM1x5DImode);
      if (res >= 0)
        return res + 330; /* [330, 333] */
      return -1;

    case E_RVVM1x6DImode:
      res = pattern647 (x1, 
E_RVVM1x6DImode);
      if (res >= 0)
        return res + 334; /* [334, 337] */
      return -1;

    case E_RVVM1x7DImode:
      res = pattern647 (x1, 
E_RVVM1x7DImode);
      if (res >= 0)
        return res + 338; /* [338, 341] */
      return -1;

    case E_RVVM1x8DImode:
      res = pattern647 (x1, 
E_RVVM1x8DImode);
      if (res >= 0)
        return res + 342; /* [342, 345] */
      return -1;

    case E_RVVMF4x2BFmode:
      res = pattern647 (x1, 
E_RVVMF4x2BFmode);
      if (res >= 0)
        return res + 346; /* [346, 349] */
      return -1;

    case E_RVVMF4x3BFmode:
      res = pattern647 (x1, 
E_RVVMF4x3BFmode);
      if (res >= 0)
        return res + 350; /* [350, 353] */
      return -1;

    case E_RVVMF4x4BFmode:
      res = pattern647 (x1, 
E_RVVMF4x4BFmode);
      if (res >= 0)
        return res + 354; /* [354, 357] */
      return -1;

    case E_RVVMF4x5BFmode:
      res = pattern647 (x1, 
E_RVVMF4x5BFmode);
      if (res >= 0)
        return res + 358; /* [358, 361] */
      return -1;

    case E_RVVMF4x6BFmode:
      res = pattern647 (x1, 
E_RVVMF4x6BFmode);
      if (res >= 0)
        return res + 362; /* [362, 365] */
      return -1;

    case E_RVVMF4x7BFmode:
      res = pattern647 (x1, 
E_RVVMF4x7BFmode);
      if (res >= 0)
        return res + 366; /* [366, 369] */
      return -1;

    case E_RVVMF4x8BFmode:
      res = pattern647 (x1, 
E_RVVMF4x8BFmode);
      if (res >= 0)
        return res + 370; /* [370, 373] */
      return -1;

    case E_RVVMF4x2HFmode:
      res = pattern647 (x1, 
E_RVVMF4x2HFmode);
      if (res >= 0)
        return res + 374; /* [374, 377] */
      return -1;

    case E_RVVMF4x3HFmode:
      res = pattern647 (x1, 
E_RVVMF4x3HFmode);
      if (res >= 0)
        return res + 378; /* [378, 381] */
      return -1;

    case E_RVVMF4x4HFmode:
      res = pattern647 (x1, 
E_RVVMF4x4HFmode);
      if (res >= 0)
        return res + 382; /* [382, 385] */
      return -1;

    case E_RVVMF4x5HFmode:
      res = pattern647 (x1, 
E_RVVMF4x5HFmode);
      if (res >= 0)
        return res + 386; /* [386, 389] */
      return -1;

    case E_RVVMF4x6HFmode:
      res = pattern647 (x1, 
E_RVVMF4x6HFmode);
      if (res >= 0)
        return res + 390; /* [390, 393] */
      return -1;

    case E_RVVMF4x7HFmode:
      res = pattern647 (x1, 
E_RVVMF4x7HFmode);
      if (res >= 0)
        return res + 394; /* [394, 397] */
      return -1;

    case E_RVVMF4x8HFmode:
      res = pattern647 (x1, 
E_RVVMF4x8HFmode);
      if (res >= 0)
        return res + 398; /* [398, 401] */
      return -1;

    case E_RVVMF2x2SFmode:
      res = pattern647 (x1, 
E_RVVMF2x2SFmode);
      if (res >= 0)
        return res + 402; /* [402, 405] */
      return -1;

    case E_RVVMF2x3SFmode:
      res = pattern647 (x1, 
E_RVVMF2x3SFmode);
      if (res >= 0)
        return res + 406; /* [406, 409] */
      return -1;

    case E_RVVMF2x4SFmode:
      res = pattern647 (x1, 
E_RVVMF2x4SFmode);
      if (res >= 0)
        return res + 410; /* [410, 413] */
      return -1;

    case E_RVVMF2x5SFmode:
      res = pattern647 (x1, 
E_RVVMF2x5SFmode);
      if (res >= 0)
        return res + 414; /* [414, 417] */
      return -1;

    case E_RVVMF2x6SFmode:
      res = pattern647 (x1, 
E_RVVMF2x6SFmode);
      if (res >= 0)
        return res + 418; /* [418, 421] */
      return -1;

    case E_RVVMF2x7SFmode:
      res = pattern647 (x1, 
E_RVVMF2x7SFmode);
      if (res >= 0)
        return res + 422; /* [422, 425] */
      return -1;

    case E_RVVMF2x8SFmode:
      res = pattern647 (x1, 
E_RVVMF2x8SFmode);
      if (res >= 0)
        return res + 426; /* [426, 429] */
      return -1;

    case E_RVVM1x2DFmode:
      res = pattern647 (x1, 
E_RVVM1x2DFmode);
      if (res >= 0)
        return res + 430; /* [430, 433] */
      return -1;

    case E_RVVM1x3DFmode:
      res = pattern647 (x1, 
E_RVVM1x3DFmode);
      if (res >= 0)
        return res + 434; /* [434, 437] */
      return -1;

    case E_RVVM1x4DFmode:
      res = pattern647 (x1, 
E_RVVM1x4DFmode);
      if (res >= 0)
        return res + 438; /* [438, 441] */
      return -1;

    case E_RVVM1x5DFmode:
      res = pattern647 (x1, 
E_RVVM1x5DFmode);
      if (res >= 0)
        return res + 442; /* [442, 445] */
      return -1;

    case E_RVVM1x6DFmode:
      res = pattern647 (x1, 
E_RVVM1x6DFmode);
      if (res >= 0)
        return res + 446; /* [446, 449] */
      return -1;

    case E_RVVM1x7DFmode:
      res = pattern647 (x1, 
E_RVVM1x7DFmode);
      if (res >= 0)
        return res + 450; /* [450, 453] */
      return -1;

    case E_RVVM1x8DFmode:
      res = pattern647 (x1, 
E_RVVM1x8DFmode);
      if (res >= 0)
        return res + 454; /* [454, 457] */
      return -1;

    case E_RVVMF4x2QImode:
      res = pattern646 (x1, 
E_RVVMF4x2QImode);
      if (res >= 0)
        return res + 458; /* [458, 461] */
      return -1;

    case E_RVVMF4x3QImode:
      res = pattern646 (x1, 
E_RVVMF4x3QImode);
      if (res >= 0)
        return res + 462; /* [462, 465] */
      return -1;

    case E_RVVMF4x4QImode:
      res = pattern646 (x1, 
E_RVVMF4x4QImode);
      if (res >= 0)
        return res + 466; /* [466, 469] */
      return -1;

    case E_RVVMF4x5QImode:
      res = pattern646 (x1, 
E_RVVMF4x5QImode);
      if (res >= 0)
        return res + 470; /* [470, 473] */
      return -1;

    case E_RVVMF4x6QImode:
      res = pattern646 (x1, 
E_RVVMF4x6QImode);
      if (res >= 0)
        return res + 474; /* [474, 477] */
      return -1;

    case E_RVVMF4x7QImode:
      res = pattern646 (x1, 
E_RVVMF4x7QImode);
      if (res >= 0)
        return res + 478; /* [478, 481] */
      return -1;

    case E_RVVMF4x8QImode:
      res = pattern646 (x1, 
E_RVVMF4x8QImode);
      if (res >= 0)
        return res + 482; /* [482, 485] */
      return -1;

    case E_RVVMF2x2HImode:
      res = pattern646 (x1, 
E_RVVMF2x2HImode);
      if (res >= 0)
        return res + 486; /* [486, 489] */
      return -1;

    case E_RVVMF2x3HImode:
      res = pattern646 (x1, 
E_RVVMF2x3HImode);
      if (res >= 0)
        return res + 490; /* [490, 493] */
      return -1;

    case E_RVVMF2x4HImode:
      res = pattern646 (x1, 
E_RVVMF2x4HImode);
      if (res >= 0)
        return res + 494; /* [494, 497] */
      return -1;

    case E_RVVMF2x5HImode:
      res = pattern646 (x1, 
E_RVVMF2x5HImode);
      if (res >= 0)
        return res + 498; /* [498, 501] */
      return -1;

    case E_RVVMF2x6HImode:
      res = pattern646 (x1, 
E_RVVMF2x6HImode);
      if (res >= 0)
        return res + 502; /* [502, 505] */
      return -1;

    case E_RVVMF2x7HImode:
      res = pattern646 (x1, 
E_RVVMF2x7HImode);
      if (res >= 0)
        return res + 506; /* [506, 509] */
      return -1;

    case E_RVVMF2x8HImode:
      res = pattern646 (x1, 
E_RVVMF2x8HImode);
      if (res >= 0)
        return res + 510; /* [510, 513] */
      return -1;

    case E_RVVM1x2SImode:
      res = pattern646 (x1, 
E_RVVM1x2SImode);
      if (res >= 0)
        return res + 514; /* [514, 517] */
      return -1;

    case E_RVVM1x3SImode:
      res = pattern646 (x1, 
E_RVVM1x3SImode);
      if (res >= 0)
        return res + 518; /* [518, 521] */
      return -1;

    case E_RVVM1x4SImode:
      res = pattern646 (x1, 
E_RVVM1x4SImode);
      if (res >= 0)
        return res + 522; /* [522, 525] */
      return -1;

    case E_RVVM1x5SImode:
      res = pattern646 (x1, 
E_RVVM1x5SImode);
      if (res >= 0)
        return res + 526; /* [526, 529] */
      return -1;

    case E_RVVM1x6SImode:
      res = pattern646 (x1, 
E_RVVM1x6SImode);
      if (res >= 0)
        return res + 530; /* [530, 533] */
      return -1;

    case E_RVVM1x7SImode:
      res = pattern646 (x1, 
E_RVVM1x7SImode);
      if (res >= 0)
        return res + 534; /* [534, 537] */
      return -1;

    case E_RVVM1x8SImode:
      res = pattern646 (x1, 
E_RVVM1x8SImode);
      if (res >= 0)
        return res + 538; /* [538, 541] */
      return -1;

    case E_RVVM2x2DImode:
      res = pattern646 (x1, 
E_RVVM2x2DImode);
      if (res >= 0)
        return res + 542; /* [542, 545] */
      return -1;

    case E_RVVM2x3DImode:
      res = pattern646 (x1, 
E_RVVM2x3DImode);
      if (res >= 0)
        return res + 546; /* [546, 549] */
      return -1;

    case E_RVVM2x4DImode:
      res = pattern646 (x1, 
E_RVVM2x4DImode);
      if (res >= 0)
        return res + 550; /* [550, 553] */
      return -1;

    case E_RVVMF2x2BFmode:
      res = pattern646 (x1, 
E_RVVMF2x2BFmode);
      if (res >= 0)
        return res + 554; /* [554, 557] */
      return -1;

    case E_RVVMF2x3BFmode:
      res = pattern646 (x1, 
E_RVVMF2x3BFmode);
      if (res >= 0)
        return res + 558; /* [558, 561] */
      return -1;

    case E_RVVMF2x4BFmode:
      res = pattern646 (x1, 
E_RVVMF2x4BFmode);
      if (res >= 0)
        return res + 562; /* [562, 565] */
      return -1;

    case E_RVVMF2x5BFmode:
      res = pattern646 (x1, 
E_RVVMF2x5BFmode);
      if (res >= 0)
        return res + 566; /* [566, 569] */
      return -1;

    case E_RVVMF2x6BFmode:
      res = pattern646 (x1, 
E_RVVMF2x6BFmode);
      if (res >= 0)
        return res + 570; /* [570, 573] */
      return -1;

    case E_RVVMF2x7BFmode:
      res = pattern646 (x1, 
E_RVVMF2x7BFmode);
      if (res >= 0)
        return res + 574; /* [574, 577] */
      return -1;

    case E_RVVMF2x8BFmode:
      res = pattern646 (x1, 
E_RVVMF2x8BFmode);
      if (res >= 0)
        return res + 578; /* [578, 581] */
      return -1;

    case E_RVVMF2x2HFmode:
      res = pattern646 (x1, 
E_RVVMF2x2HFmode);
      if (res >= 0)
        return res + 582; /* [582, 585] */
      return -1;

    case E_RVVMF2x3HFmode:
      res = pattern646 (x1, 
E_RVVMF2x3HFmode);
      if (res >= 0)
        return res + 586; /* [586, 589] */
      return -1;

    case E_RVVMF2x4HFmode:
      res = pattern646 (x1, 
E_RVVMF2x4HFmode);
      if (res >= 0)
        return res + 590; /* [590, 593] */
      return -1;

    case E_RVVMF2x5HFmode:
      res = pattern646 (x1, 
E_RVVMF2x5HFmode);
      if (res >= 0)
        return res + 594; /* [594, 597] */
      return -1;

    case E_RVVMF2x6HFmode:
      res = pattern646 (x1, 
E_RVVMF2x6HFmode);
      if (res >= 0)
        return res + 598; /* [598, 601] */
      return -1;

    case E_RVVMF2x7HFmode:
      res = pattern646 (x1, 
E_RVVMF2x7HFmode);
      if (res >= 0)
        return res + 602; /* [602, 605] */
      return -1;

    case E_RVVMF2x8HFmode:
      res = pattern646 (x1, 
E_RVVMF2x8HFmode);
      if (res >= 0)
        return res + 606; /* [606, 609] */
      return -1;

    case E_RVVM1x2SFmode:
      res = pattern646 (x1, 
E_RVVM1x2SFmode);
      if (res >= 0)
        return res + 610; /* [610, 613] */
      return -1;

    case E_RVVM1x3SFmode:
      res = pattern646 (x1, 
E_RVVM1x3SFmode);
      if (res >= 0)
        return res + 614; /* [614, 617] */
      return -1;

    case E_RVVM1x4SFmode:
      res = pattern646 (x1, 
E_RVVM1x4SFmode);
      if (res >= 0)
        return res + 618; /* [618, 621] */
      return -1;

    case E_RVVM1x5SFmode:
      res = pattern646 (x1, 
E_RVVM1x5SFmode);
      if (res >= 0)
        return res + 622; /* [622, 625] */
      return -1;

    case E_RVVM1x6SFmode:
      res = pattern646 (x1, 
E_RVVM1x6SFmode);
      if (res >= 0)
        return res + 626; /* [626, 629] */
      return -1;

    case E_RVVM1x7SFmode:
      res = pattern646 (x1, 
E_RVVM1x7SFmode);
      if (res >= 0)
        return res + 630; /* [630, 633] */
      return -1;

    case E_RVVM1x8SFmode:
      res = pattern646 (x1, 
E_RVVM1x8SFmode);
      if (res >= 0)
        return res + 634; /* [634, 637] */
      return -1;

    case E_RVVM2x2DFmode:
      res = pattern646 (x1, 
E_RVVM2x2DFmode);
      if (res >= 0)
        return res + 638; /* [638, 641] */
      return -1;

    case E_RVVM2x3DFmode:
      res = pattern646 (x1, 
E_RVVM2x3DFmode);
      if (res >= 0)
        return res + 642; /* [642, 645] */
      return -1;

    case E_RVVM2x4DFmode:
      res = pattern646 (x1, 
E_RVVM2x4DFmode);
      if (res >= 0)
        return res + 646; /* [646, 649] */
      return -1;

    case E_RVVMF2x2QImode:
      res = pattern645 (x1, 
E_RVVMF2x2QImode);
      if (res >= 0)
        return res + 650; /* [650, 653] */
      return -1;

    case E_RVVMF2x3QImode:
      res = pattern645 (x1, 
E_RVVMF2x3QImode);
      if (res >= 0)
        return res + 654; /* [654, 657] */
      return -1;

    case E_RVVMF2x4QImode:
      res = pattern645 (x1, 
E_RVVMF2x4QImode);
      if (res >= 0)
        return res + 658; /* [658, 661] */
      return -1;

    case E_RVVMF2x5QImode:
      res = pattern645 (x1, 
E_RVVMF2x5QImode);
      if (res >= 0)
        return res + 662; /* [662, 665] */
      return -1;

    case E_RVVMF2x6QImode:
      res = pattern645 (x1, 
E_RVVMF2x6QImode);
      if (res >= 0)
        return res + 666; /* [666, 669] */
      return -1;

    case E_RVVMF2x7QImode:
      res = pattern645 (x1, 
E_RVVMF2x7QImode);
      if (res >= 0)
        return res + 670; /* [670, 673] */
      return -1;

    case E_RVVMF2x8QImode:
      res = pattern645 (x1, 
E_RVVMF2x8QImode);
      if (res >= 0)
        return res + 674; /* [674, 677] */
      return -1;

    case E_RVVM1x2HImode:
      res = pattern645 (x1, 
E_RVVM1x2HImode);
      if (res >= 0)
        return res + 678; /* [678, 681] */
      return -1;

    case E_RVVM1x3HImode:
      res = pattern645 (x1, 
E_RVVM1x3HImode);
      if (res >= 0)
        return res + 682; /* [682, 685] */
      return -1;

    case E_RVVM1x4HImode:
      res = pattern645 (x1, 
E_RVVM1x4HImode);
      if (res >= 0)
        return res + 686; /* [686, 689] */
      return -1;

    case E_RVVM1x5HImode:
      res = pattern645 (x1, 
E_RVVM1x5HImode);
      if (res >= 0)
        return res + 690; /* [690, 693] */
      return -1;

    case E_RVVM1x6HImode:
      res = pattern645 (x1, 
E_RVVM1x6HImode);
      if (res >= 0)
        return res + 694; /* [694, 697] */
      return -1;

    case E_RVVM1x7HImode:
      res = pattern645 (x1, 
E_RVVM1x7HImode);
      if (res >= 0)
        return res + 698; /* [698, 701] */
      return -1;

    case E_RVVM1x8HImode:
      res = pattern645 (x1, 
E_RVVM1x8HImode);
      if (res >= 0)
        return res + 702; /* [702, 705] */
      return -1;

    case E_RVVM2x2SImode:
      res = pattern645 (x1, 
E_RVVM2x2SImode);
      if (res >= 0)
        return res + 706; /* [706, 709] */
      return -1;

    case E_RVVM2x3SImode:
      res = pattern645 (x1, 
E_RVVM2x3SImode);
      if (res >= 0)
        return res + 710; /* [710, 713] */
      return -1;

    case E_RVVM2x4SImode:
      res = pattern645 (x1, 
E_RVVM2x4SImode);
      if (res >= 0)
        return res + 714; /* [714, 717] */
      return -1;

    case E_RVVM4x2DImode:
      res = pattern645 (x1, 
E_RVVM4x2DImode);
      if (res >= 0)
        return res + 718; /* [718, 721] */
      return -1;

    case E_RVVM1x2BFmode:
      res = pattern645 (x1, 
E_RVVM1x2BFmode);
      if (res >= 0)
        return res + 722; /* [722, 725] */
      return -1;

    case E_RVVM1x3BFmode:
      res = pattern645 (x1, 
E_RVVM1x3BFmode);
      if (res >= 0)
        return res + 726; /* [726, 729] */
      return -1;

    case E_RVVM1x4BFmode:
      res = pattern645 (x1, 
E_RVVM1x4BFmode);
      if (res >= 0)
        return res + 730; /* [730, 733] */
      return -1;

    case E_RVVM1x5BFmode:
      res = pattern645 (x1, 
E_RVVM1x5BFmode);
      if (res >= 0)
        return res + 734; /* [734, 737] */
      return -1;

    case E_RVVM1x6BFmode:
      res = pattern645 (x1, 
E_RVVM1x6BFmode);
      if (res >= 0)
        return res + 738; /* [738, 741] */
      return -1;

    case E_RVVM1x7BFmode:
      res = pattern645 (x1, 
E_RVVM1x7BFmode);
      if (res >= 0)
        return res + 742; /* [742, 745] */
      return -1;

    case E_RVVM1x8BFmode:
      res = pattern645 (x1, 
E_RVVM1x8BFmode);
      if (res >= 0)
        return res + 746; /* [746, 749] */
      return -1;

    case E_RVVM1x2HFmode:
      res = pattern645 (x1, 
E_RVVM1x2HFmode);
      if (res >= 0)
        return res + 750; /* [750, 753] */
      return -1;

    case E_RVVM1x3HFmode:
      res = pattern645 (x1, 
E_RVVM1x3HFmode);
      if (res >= 0)
        return res + 754; /* [754, 757] */
      return -1;

    case E_RVVM1x4HFmode:
      res = pattern645 (x1, 
E_RVVM1x4HFmode);
      if (res >= 0)
        return res + 758; /* [758, 761] */
      return -1;

    case E_RVVM1x5HFmode:
      res = pattern645 (x1, 
E_RVVM1x5HFmode);
      if (res >= 0)
        return res + 762; /* [762, 765] */
      return -1;

    case E_RVVM1x6HFmode:
      res = pattern645 (x1, 
E_RVVM1x6HFmode);
      if (res >= 0)
        return res + 766; /* [766, 769] */
      return -1;

    case E_RVVM1x7HFmode:
      res = pattern645 (x1, 
E_RVVM1x7HFmode);
      if (res >= 0)
        return res + 770; /* [770, 773] */
      return -1;

    case E_RVVM1x8HFmode:
      res = pattern645 (x1, 
E_RVVM1x8HFmode);
      if (res >= 0)
        return res + 774; /* [774, 777] */
      return -1;

    case E_RVVM2x2SFmode:
      res = pattern645 (x1, 
E_RVVM2x2SFmode);
      if (res >= 0)
        return res + 778; /* [778, 781] */
      return -1;

    case E_RVVM2x3SFmode:
      res = pattern645 (x1, 
E_RVVM2x3SFmode);
      if (res >= 0)
        return res + 782; /* [782, 785] */
      return -1;

    case E_RVVM2x4SFmode:
      res = pattern645 (x1, 
E_RVVM2x4SFmode);
      if (res >= 0)
        return res + 786; /* [786, 789] */
      return -1;

    case E_RVVM4x2DFmode:
      res = pattern645 (x1, 
E_RVVM4x2DFmode);
      if (res >= 0)
        return res + 790; /* [790, 793] */
      return -1;

    case E_RVVM1x2QImode:
      res = pattern644 (x1, 
E_RVVM1x2QImode);
      if (res >= 0)
        return res + 794; /* [794, 797] */
      return -1;

    case E_RVVM1x3QImode:
      res = pattern644 (x1, 
E_RVVM1x3QImode);
      if (res >= 0)
        return res + 798; /* [798, 801] */
      return -1;

    case E_RVVM1x4QImode:
      res = pattern644 (x1, 
E_RVVM1x4QImode);
      if (res >= 0)
        return res + 802; /* [802, 805] */
      return -1;

    case E_RVVM1x5QImode:
      res = pattern644 (x1, 
E_RVVM1x5QImode);
      if (res >= 0)
        return res + 806; /* [806, 809] */
      return -1;

    case E_RVVM1x6QImode:
      res = pattern644 (x1, 
E_RVVM1x6QImode);
      if (res >= 0)
        return res + 810; /* [810, 813] */
      return -1;

    case E_RVVM1x7QImode:
      res = pattern644 (x1, 
E_RVVM1x7QImode);
      if (res >= 0)
        return res + 814; /* [814, 817] */
      return -1;

    case E_RVVM1x8QImode:
      res = pattern644 (x1, 
E_RVVM1x8QImode);
      if (res >= 0)
        return res + 818; /* [818, 821] */
      return -1;

    case E_RVVM2x2HImode:
      res = pattern644 (x1, 
E_RVVM2x2HImode);
      if (res >= 0)
        return res + 822; /* [822, 825] */
      return -1;

    case E_RVVM2x3HImode:
      res = pattern644 (x1, 
E_RVVM2x3HImode);
      if (res >= 0)
        return res + 826; /* [826, 829] */
      return -1;

    case E_RVVM2x4HImode:
      res = pattern644 (x1, 
E_RVVM2x4HImode);
      if (res >= 0)
        return res + 830; /* [830, 833] */
      return -1;

    case E_RVVM4x2SImode:
      res = pattern644 (x1, 
E_RVVM4x2SImode);
      if (res >= 0)
        return res + 834; /* [834, 837] */
      return -1;

    case E_RVVM2x2BFmode:
      res = pattern644 (x1, 
E_RVVM2x2BFmode);
      if (res >= 0)
        return res + 838; /* [838, 841] */
      return -1;

    case E_RVVM2x3BFmode:
      res = pattern644 (x1, 
E_RVVM2x3BFmode);
      if (res >= 0)
        return res + 842; /* [842, 845] */
      return -1;

    case E_RVVM2x4BFmode:
      res = pattern644 (x1, 
E_RVVM2x4BFmode);
      if (res >= 0)
        return res + 846; /* [846, 849] */
      return -1;

    case E_RVVM2x2HFmode:
      res = pattern644 (x1, 
E_RVVM2x2HFmode);
      if (res >= 0)
        return res + 850; /* [850, 853] */
      return -1;

    case E_RVVM2x3HFmode:
      res = pattern644 (x1, 
E_RVVM2x3HFmode);
      if (res >= 0)
        return res + 854; /* [854, 857] */
      return -1;

    case E_RVVM2x4HFmode:
      res = pattern644 (x1, 
E_RVVM2x4HFmode);
      if (res >= 0)
        return res + 858; /* [858, 861] */
      return -1;

    case E_RVVM4x2SFmode:
      res = pattern644 (x1, 
E_RVVM4x2SFmode);
      if (res >= 0)
        return res + 862; /* [862, 865] */
      return -1;

    case E_RVVM2x2QImode:
      res = pattern643 (x1, 
E_RVVM2x2QImode);
      if (res >= 0)
        return res + 866; /* [866, 868] */
      return -1;

    case E_RVVM2x3QImode:
      res = pattern643 (x1, 
E_RVVM2x3QImode);
      if (res >= 0)
        return res + 869; /* [869, 871] */
      return -1;

    case E_RVVM2x4QImode:
      res = pattern643 (x1, 
E_RVVM2x4QImode);
      if (res >= 0)
        return res + 872; /* [872, 874] */
      return -1;

    case E_RVVM4x2HImode:
      res = pattern643 (x1, 
E_RVVM4x2HImode);
      if (res >= 0)
        return res + 875; /* [875, 877] */
      return -1;

    case E_RVVM4x2BFmode:
      res = pattern643 (x1, 
E_RVVM4x2BFmode);
      if (res >= 0)
        return res + 878; /* [878, 880] */
      return -1;

    case E_RVVM4x2HFmode:
      res = pattern643 (x1, 
E_RVVM4x2HFmode);
      if (res >= 0)
        return res + 881; /* [881, 883] */
      return -1;

    case E_RVVM4x2QImode:
      res = pattern642 (x1, 
E_RVVM4x2QImode);
      if (res >= 0)
        return res + 884; /* [884, 885] */
      return -1;

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!absolute_symbolic_operand (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!
#line 36 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 809; /* *local_pic_load_sqi */

        case E_HImode:
          if (!
#line 36 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 812; /* *local_pic_load_shi */

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!
#line 36 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 810; /* *local_pic_load_sqi */

        case E_HImode:
          if (!
#line 36 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 813; /* *local_pic_load_shi */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!(
#line 36 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 811; /* *local_pic_load_sqi */

        case E_HImode:
          if (!(
#line 36 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 814; /* *local_pic_load_shi */

        case E_SImode:
          if (!(
#line 36 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 817; /* *local_pic_load_ssi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SUBREG:
    case TRUNCATE:
      if (subreg_lowpart_operator (x3, E_SImode)
          && register_operand (operands[0], E_DImode))
        {
          res = recog_10 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_CODE (x3) == TRUNCATE)
        {
          switch (pattern197 (x2))
            {
            case 0:
              if (
#line 636 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
                return 33803; /* riscv_cv_alu_exths */
              break;

            case 1:
              if (
#line 658 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
                return 33805; /* riscv_cv_alu_extbs */
              break;

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode)
          || GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26103; /* extendrvvm4qirvvm8hi2 */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26105; /* extendrvvm2qirvvm4hi2 */

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26107; /* extendrvvm1qirvvm2hi2 */

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26109; /* extendrvvmf2qirvvm1hi2 */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26111; /* extendrvvmf4qirvvmf2hi2 */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 26113; /* extendrvvmf8qirvvmf4hi2 */

    case E_RVVM8SImode:
      switch (pattern291 (x2))
        {
        case 0:
          if (!
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26115; /* extendrvvm4hirvvm8si2 */

        case 1:
          if (!
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26199; /* extendrvvm2qirvvm8si2 */

        default:
          return -1;
        }

    case E_RVVM4SImode:
      switch (pattern292 (x2))
        {
        case 0:
          if (!
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26117; /* extendrvvm2hirvvm4si2 */

        case 1:
          if (!
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26201; /* extendrvvm1qirvvm4si2 */

        default:
          return -1;
        }

    case E_RVVM2SImode:
      switch (pattern293 (x2))
        {
        case 0:
          if (!
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26119; /* extendrvvm1hirvvm2si2 */

        case 1:
          if (!
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26203; /* extendrvvmf2qirvvm2si2 */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      switch (pattern294 (x2))
        {
        case 0:
          if (!
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26121; /* extendrvvmf2hirvvm1si2 */

        case 1:
          if (!
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26205; /* extendrvvmf4qirvvm1si2 */

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      switch (pattern295 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 26123; /* extendrvvmf4hirvvmf2si2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 26207; /* extendrvvmf8qirvvmf2si2 */

        default:
          return -1;
        }

    case E_RVVM8DImode:
      switch (pattern296 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26125; /* extendrvvm4sirvvm8di2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26209; /* extendrvvm2hirvvm8di2 */

        case 2:
          if (!(
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26259; /* extendrvvm1qirvvm8di2 */

        default:
          return -1;
        }

    case E_RVVM4DImode:
      switch (pattern297 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26127; /* extendrvvm2sirvvm4di2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26211; /* extendrvvm1hirvvm4di2 */

        case 2:
          if (!(
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26261; /* extendrvvmf2qirvvm4di2 */

        default:
          return -1;
        }

    case E_RVVM2DImode:
      switch (pattern298 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26129; /* extendrvvm1sirvvm2di2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26213; /* extendrvvmf2hirvvm2di2 */

        case 2:
          if (!(
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26263; /* extendrvvmf4qirvvm2di2 */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      switch (pattern299 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26131; /* extendrvvmf2sirvvm1di2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26215; /* extendrvvmf4hirvvm1di2 */

        case 2:
          if (!(
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26265; /* extendrvvmf8qirvvm1di2 */

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 26133; /* extendv1qiv1hi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 26135; /* extendv2qiv2hi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 26137; /* extendv4qiv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 26139; /* extendv8qiv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 26141; /* extendv16qiv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26143; /* extendv32qiv32hi2 */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26145; /* extendv64qiv64hi2 */

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26147; /* extendv128qiv128hi2 */

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26149; /* extendv256qiv256hi2 */

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26151; /* extendv512qiv512hi2 */

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26153; /* extendv1024qiv1024hi2 */

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode)
          || GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26155; /* extendv2048qiv2048hi2 */

    case E_V1SImode:
      switch (pattern300 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 26157; /* extendv1hiv1si2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 26217; /* extendv1qiv1si2 */

        default:
          return -1;
        }

    case E_V2SImode:
      switch (pattern301 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 26159; /* extendv2hiv2si2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 26219; /* extendv2qiv2si2 */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern302 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 26161; /* extendv4hiv4si2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 26221; /* extendv4qiv4si2 */

        default:
          return -1;
        }

    case E_V8SImode:
      switch (pattern303 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 26163; /* extendv8hiv8si2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 26223; /* extendv8qiv8si2 */

        default:
          return -1;
        }

    case E_V16SImode:
      switch (pattern304 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26165; /* extendv16hiv16si2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26225; /* extendv16qiv16si2 */

        default:
          return -1;
        }

    case E_V32SImode:
      switch (pattern305 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26167; /* extendv32hiv32si2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26227; /* extendv32qiv32si2 */

        default:
          return -1;
        }

    case E_V64SImode:
      switch (pattern306 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26169; /* extendv64hiv64si2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26229; /* extendv64qiv64si2 */

        default:
          return -1;
        }

    case E_V128SImode:
      switch (pattern307 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26171; /* extendv128hiv128si2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26231; /* extendv128qiv128si2 */

        default:
          return -1;
        }

    case E_V256SImode:
      switch (pattern308 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26173; /* extendv256hiv256si2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26233; /* extendv256qiv256si2 */

        default:
          return -1;
        }

    case E_V512SImode:
      switch (pattern309 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26175; /* extendv512hiv512si2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26235; /* extendv512qiv512si2 */

        default:
          return -1;
        }

    case E_V1024SImode:
      switch (pattern310 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26177; /* extendv1024hiv1024si2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26237; /* extendv1024qiv1024si2 */

        default:
          return -1;
        }

    case E_V1DImode:
      switch (pattern311 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26179; /* extendv1siv1di2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26239; /* extendv1hiv1di2 */

        case 2:
          if (!(
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26267; /* extendv1qiv1di2 */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern312 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26181; /* extendv2siv2di2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26241; /* extendv2hiv2di2 */

        case 2:
          if (!(
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26269; /* extendv2qiv2di2 */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern313 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26183; /* extendv4siv4di2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26243; /* extendv4hiv4di2 */

        case 2:
          if (!(
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26271; /* extendv4qiv4di2 */

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern314 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26185; /* extendv8siv8di2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26245; /* extendv8hiv8di2 */

        case 2:
          if (!(
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26273; /* extendv8qiv8di2 */

        default:
          return -1;
        }

    case E_V16DImode:
      switch (pattern315 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26187; /* extendv16siv16di2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26247; /* extendv16hiv16di2 */

        case 2:
          if (!(
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26275; /* extendv16qiv16di2 */

        default:
          return -1;
        }

    case E_V32DImode:
      switch (pattern316 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26189; /* extendv32siv32di2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26249; /* extendv32hiv32di2 */

        case 2:
          if (!(
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26277; /* extendv32qiv32di2 */

        default:
          return -1;
        }

    case E_V64DImode:
      switch (pattern317 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26191; /* extendv64siv64di2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26251; /* extendv64hiv64di2 */

        case 2:
          if (!(
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26279; /* extendv64qiv64di2 */

        default:
          return -1;
        }

    case E_V128DImode:
      switch (pattern318 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26193; /* extendv128siv128di2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26253; /* extendv128hiv128di2 */

        case 2:
          if (!(
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26281; /* extendv128qiv128di2 */

        default:
          return -1;
        }

    case E_V256DImode:
      switch (pattern319 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26195; /* extendv256siv256di2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26255; /* extendv256hiv256di2 */

        case 2:
          if (!(
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26283; /* extendv256qiv256di2 */

        default:
          return -1;
        }

    case E_V512DImode:
      switch (pattern320 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26197; /* extendv512siv512di2 */

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26257; /* extendv512hiv512di2 */

        case 2:
          if (!(
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26285; /* extendv512qiv512di2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case MULT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          switch (pattern378 (x2))
            {
            case 0:
              if (!
#line 1307 "../../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
                return -1;
              return 30; /* smuldi3_highpart */

            case 1:
              if (!
#line 1368 "../../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && !TARGET_64BIT))
                return -1;
              return 33; /* smulsi3_highpart */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case ZERO_EXTEND:
              switch (pattern378 (x2))
                {
                case 0:
                  if (!
#line 1307 "../../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
                    return -1;
                  return 31; /* umuldi3_highpart */

                case 1:
                  if (!
#line 1368 "../../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && !TARGET_64BIT))
                    return -1;
                  return 34; /* umulsi3_highpart */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern378 (x2))
                {
                case 0:
                  if (!
#line 1338 "../../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
                    return -1;
                  return 32; /* usmuldi3_highpart */

                case 1:
                  if (!
#line 1399 "../../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && !TARGET_64BIT))
                    return -1;
                  return 35; /* usmulsi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern155 (x2))
        {
        case 0:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29859; /* *narrow_lshrextendrvvm8hi */

        case 1:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29863; /* *narrow_lshrextendrvvm4hi */

        case 2:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29867; /* *narrow_lshrextendrvvm2hi */

        case 3:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29871; /* *narrow_lshrextendrvvm1hi */

        case 4:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29875; /* *narrow_lshrextendrvvmf2hi */

        case 5:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 29879; /* *narrow_lshrextendrvvmf4hi */

        case 6:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29883; /* *narrow_lshrextendrvvm8si */

        case 7:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29887; /* *narrow_lshrextendrvvm4si */

        case 8:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29891; /* *narrow_lshrextendrvvm2si */

        case 9:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29895; /* *narrow_lshrextendrvvm1si */

        case 10:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 29899; /* *narrow_lshrextendrvvmf2si */

        case 11:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29903; /* *narrow_lshrextendrvvm8di */

        case 12:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29907; /* *narrow_lshrextendrvvm4di */

        case 13:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29911; /* *narrow_lshrextendrvvm2di */

        case 14:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29915; /* *narrow_lshrextendrvvm1di */

        case 15:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 29919; /* *narrow_lshrextendv1hi */

        case 16:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 29923; /* *narrow_lshrextendv2hi */

        case 17:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 29927; /* *narrow_lshrextendv4hi */

        case 18:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 29931; /* *narrow_lshrextendv8hi */

        case 19:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 29935; /* *narrow_lshrextendv16hi */

        case 20:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 29939; /* *narrow_lshrextendv32hi */

        case 21:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 29943; /* *narrow_lshrextendv64hi */

        case 22:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 29947; /* *narrow_lshrextendv128hi */

        case 23:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 29951; /* *narrow_lshrextendv256hi */

        case 24:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 29955; /* *narrow_lshrextendv512hi */

        case 25:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 29959; /* *narrow_lshrextendv1024hi */

        case 26:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 29963; /* *narrow_lshrextendv2048hi */

        case 27:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 29967; /* *narrow_lshrextendv1si */

        case 28:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 29971; /* *narrow_lshrextendv2si */

        case 29:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 29975; /* *narrow_lshrextendv4si */

        case 30:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 29979; /* *narrow_lshrextendv8si */

        case 31:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 29983; /* *narrow_lshrextendv16si */

        case 32:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 29987; /* *narrow_lshrextendv32si */

        case 33:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 29991; /* *narrow_lshrextendv64si */

        case 34:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 29995; /* *narrow_lshrextendv128si */

        case 35:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 29999; /* *narrow_lshrextendv256si */

        case 36:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30003; /* *narrow_lshrextendv512si */

        case 37:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30007; /* *narrow_lshrextendv1024si */

        case 38:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30011; /* *narrow_lshrextendv1di */

        case 39:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30015; /* *narrow_lshrextendv2di */

        case 40:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30019; /* *narrow_lshrextendv4di */

        case 41:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30023; /* *narrow_lshrextendv8di */

        case 42:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30027; /* *narrow_lshrextendv16di */

        case 43:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30031; /* *narrow_lshrextendv32di */

        case 44:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30035; /* *narrow_lshrextendv64di */

        case 45:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30039; /* *narrow_lshrextendv128di */

        case 46:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30043; /* *narrow_lshrextendv256di */

        case 47:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30047; /* *narrow_lshrextendv512di */

        case 48:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29861; /* *narrow_lshrzero_extendrvvm8hi */

        case 49:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29865; /* *narrow_lshrzero_extendrvvm4hi */

        case 50:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29869; /* *narrow_lshrzero_extendrvvm2hi */

        case 51:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29873; /* *narrow_lshrzero_extendrvvm1hi */

        case 52:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29877; /* *narrow_lshrzero_extendrvvmf2hi */

        case 53:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 29881; /* *narrow_lshrzero_extendrvvmf4hi */

        case 54:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29885; /* *narrow_lshrzero_extendrvvm8si */

        case 55:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29889; /* *narrow_lshrzero_extendrvvm4si */

        case 56:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29893; /* *narrow_lshrzero_extendrvvm2si */

        case 57:
          if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 29897; /* *narrow_lshrzero_extendrvvm1si */

        case 58:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 29901; /* *narrow_lshrzero_extendrvvmf2si */

        case 59:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29905; /* *narrow_lshrzero_extendrvvm8di */

        case 60:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29909; /* *narrow_lshrzero_extendrvvm4di */

        case 61:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29913; /* *narrow_lshrzero_extendrvvm2di */

        case 62:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 29917; /* *narrow_lshrzero_extendrvvm1di */

        case 63:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 29921; /* *narrow_lshrzero_extendv1hi */

        case 64:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 29925; /* *narrow_lshrzero_extendv2hi */

        case 65:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 29929; /* *narrow_lshrzero_extendv4hi */

        case 66:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 29933; /* *narrow_lshrzero_extendv8hi */

        case 67:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 29937; /* *narrow_lshrzero_extendv16hi */

        case 68:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 29941; /* *narrow_lshrzero_extendv32hi */

        case 69:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 29945; /* *narrow_lshrzero_extendv64hi */

        case 70:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 29949; /* *narrow_lshrzero_extendv128hi */

        case 71:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 29953; /* *narrow_lshrzero_extendv256hi */

        case 72:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 29957; /* *narrow_lshrzero_extendv512hi */

        case 73:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 29961; /* *narrow_lshrzero_extendv1024hi */

        case 74:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 29965; /* *narrow_lshrzero_extendv2048hi */

        case 75:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 29969; /* *narrow_lshrzero_extendv1si */

        case 76:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 29973; /* *narrow_lshrzero_extendv2si */

        case 77:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 29977; /* *narrow_lshrzero_extendv4si */

        case 78:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 29981; /* *narrow_lshrzero_extendv8si */

        case 79:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 29985; /* *narrow_lshrzero_extendv16si */

        case 80:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 29989; /* *narrow_lshrzero_extendv32si */

        case 81:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 29993; /* *narrow_lshrzero_extendv64si */

        case 82:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 29997; /* *narrow_lshrzero_extendv128si */

        case 83:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30001; /* *narrow_lshrzero_extendv256si */

        case 84:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30005; /* *narrow_lshrzero_extendv512si */

        case 85:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30009; /* *narrow_lshrzero_extendv1024si */

        case 86:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30013; /* *narrow_lshrzero_extendv1di */

        case 87:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30017; /* *narrow_lshrzero_extendv2di */

        case 88:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30021; /* *narrow_lshrzero_extendv4di */

        case 89:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30025; /* *narrow_lshrzero_extendv8di */

        case 90:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30029; /* *narrow_lshrzero_extendv16di */

        case 91:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30033; /* *narrow_lshrzero_extendv32di */

        case 92:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30037; /* *narrow_lshrzero_extendv64di */

        case 93:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30041; /* *narrow_lshrzero_extendv128di */

        case 94:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30045; /* *narrow_lshrzero_extendv256di */

        case 95:
          if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30049; /* *narrow_lshrzero_extendv512di */

        case 96:
          if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30051; /* *narrow_lshrrvvm8hi_scalar */

        case 97:
          if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30053; /* *narrow_lshrrvvm4hi_scalar */

        case 98:
          if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30055; /* *narrow_lshrrvvm2hi_scalar */

        case 99:
          if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30057; /* *narrow_lshrrvvm1hi_scalar */

        case 100:
          if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30059; /* *narrow_lshrrvvmf2hi_scalar */

        case 101:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30061; /* *narrow_lshrrvvmf4hi_scalar */

        case 102:
          if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30063; /* *narrow_lshrrvvm8si_scalar */

        case 103:
          if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30065; /* *narrow_lshrrvvm4si_scalar */

        case 104:
          if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30067; /* *narrow_lshrrvvm2si_scalar */

        case 105:
          if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30069; /* *narrow_lshrrvvm1si_scalar */

        case 106:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30071; /* *narrow_lshrrvvmf2si_scalar */

        case 107:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30073; /* *narrow_lshrrvvm8di_scalar */

        case 108:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30075; /* *narrow_lshrrvvm4di_scalar */

        case 109:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30077; /* *narrow_lshrrvvm2di_scalar */

        case 110:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30079; /* *narrow_lshrrvvm1di_scalar */

        case 111:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 30081; /* *narrow_lshrv1hi_scalar */

        case 112:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 30083; /* *narrow_lshrv2hi_scalar */

        case 113:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 30085; /* *narrow_lshrv4hi_scalar */

        case 114:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 30087; /* *narrow_lshrv8hi_scalar */

        case 115:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 30089; /* *narrow_lshrv16hi_scalar */

        case 116:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30091; /* *narrow_lshrv32hi_scalar */

        case 117:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30093; /* *narrow_lshrv64hi_scalar */

        case 118:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30095; /* *narrow_lshrv128hi_scalar */

        case 119:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30097; /* *narrow_lshrv256hi_scalar */

        case 120:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30099; /* *narrow_lshrv512hi_scalar */

        case 121:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30101; /* *narrow_lshrv1024hi_scalar */

        case 122:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30103; /* *narrow_lshrv2048hi_scalar */

        case 123:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 30105; /* *narrow_lshrv1si_scalar */

        case 124:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 30107; /* *narrow_lshrv2si_scalar */

        case 125:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 30109; /* *narrow_lshrv4si_scalar */

        case 126:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 30111; /* *narrow_lshrv8si_scalar */

        case 127:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30113; /* *narrow_lshrv16si_scalar */

        case 128:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30115; /* *narrow_lshrv32si_scalar */

        case 129:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30117; /* *narrow_lshrv64si_scalar */

        case 130:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30119; /* *narrow_lshrv128si_scalar */

        case 131:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30121; /* *narrow_lshrv256si_scalar */

        case 132:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30123; /* *narrow_lshrv512si_scalar */

        case 133:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30125; /* *narrow_lshrv1024si_scalar */

        case 134:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30127; /* *narrow_lshrv1di_scalar */

        case 135:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30129; /* *narrow_lshrv2di_scalar */

        case 136:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30131; /* *narrow_lshrv4di_scalar */

        case 137:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30133; /* *narrow_lshrv8di_scalar */

        case 138:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30135; /* *narrow_lshrv16di_scalar */

        case 139:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30137; /* *narrow_lshrv32di_scalar */

        case 140:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30139; /* *narrow_lshrv64di_scalar */

        case 141:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30141; /* *narrow_lshrv128di_scalar */

        case 142:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30143; /* *narrow_lshrv256di_scalar */

        case 143:
          if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30145; /* *narrow_lshrv512di_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern236 (x3))
    {
    case 0:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27796; /* fminrvvm8hf3 */

    case 1:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27798; /* fminrvvm4hf3 */

    case 2:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27800; /* fminrvvm2hf3 */

    case 3:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27802; /* fminrvvm1hf3 */

    case 4:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27804; /* fminrvvmf2hf3 */

    case 5:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF4HFmode) && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27806; /* fminrvvmf4hf3 */

    case 6:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27808; /* fminrvvm8sf3 */

    case 7:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27810; /* fminrvvm4sf3 */

    case 8:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27812; /* fminrvvm2sf3 */

    case 9:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27814; /* fminrvvm1sf3 */

    case 10:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27816; /* fminrvvmf2sf3 */

    case 11:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27818; /* fminrvvm8df3 */

    case 12:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27820; /* fminrvvm4df3 */

    case 13:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27822; /* fminrvvm2df3 */

    case 14:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27824; /* fminrvvm1df3 */

    case 15:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1HFmode) && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27826; /* fminv1hf3 */

    case 16:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2HFmode) && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27828; /* fminv2hf3 */

    case 17:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4HFmode) && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27830; /* fminv4hf3 */

    case 18:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8HFmode) && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27832; /* fminv8hf3 */

    case 19:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16HFmode) && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27834; /* fminv16hf3 */

    case 20:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32HFmode) && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27836; /* fminv32hf3 */

    case 21:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64HFmode) && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27838; /* fminv64hf3 */

    case 22:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128HFmode) && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27840; /* fminv128hf3 */

    case 23:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256HFmode) && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27842; /* fminv256hf3 */

    case 24:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512HFmode) && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27844; /* fminv512hf3 */

    case 25:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024HFmode) && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27846; /* fminv1024hf3 */

    case 26:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2048HFmode) && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27848; /* fminv2048hf3 */

    case 27:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1SFmode) && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27850; /* fminv1sf3 */

    case 28:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2SFmode) && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27852; /* fminv2sf3 */

    case 29:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4SFmode) && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27854; /* fminv4sf3 */

    case 30:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8SFmode) && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27856; /* fminv8sf3 */

    case 31:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16SFmode) && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27858; /* fminv16sf3 */

    case 32:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32SFmode) && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27860; /* fminv32sf3 */

    case 33:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64SFmode) && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27862; /* fminv64sf3 */

    case 34:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128SFmode) && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27864; /* fminv128sf3 */

    case 35:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256SFmode) && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27866; /* fminv256sf3 */

    case 36:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512SFmode) && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27868; /* fminv512sf3 */

    case 37:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024SFmode) && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27870; /* fminv1024sf3 */

    case 38:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1DFmode) && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27872; /* fminv1df3 */

    case 39:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2DFmode) && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27874; /* fminv2df3 */

    case 40:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4DFmode) && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27876; /* fminv4df3 */

    case 41:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8DFmode) && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27878; /* fminv8df3 */

    case 42:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16DFmode) && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27880; /* fminv16df3 */

    case 43:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32DFmode) && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27882; /* fminv32df3 */

    case 44:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64DFmode) && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27884; /* fminv64df3 */

    case 45:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128DFmode) && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27886; /* fminv128df3 */

    case 46:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256DFmode) && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27888; /* fminv256df3 */

    case 47:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512DFmode) && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27890; /* fminv512df3 */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_QImode)
      || !
#line 1997 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
    return -1;
  return 33911; /* riscv_cv_simd_shuffle_sci_b_si */
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_int6_operand (operands[2], E_QImode)
      || !
#line 1975 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
    return -1;
  return 33909; /* riscv_cv_simd_shuffle_sci_h_si */
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern383 (x3, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 477; /* stack_protect_test_si */

    case E_DImode:
      if (pattern383 (x3, 
E_DImode) != 0
          || !
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 478; /* stack_protect_test_di */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern246 (x3))
    {
    case 0:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28143; /* reduc_plus_scal_rvvm8hf */

    case 1:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28144; /* reduc_plus_scal_rvvm4hf */

    case 2:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28145; /* reduc_plus_scal_rvvm2hf */

    case 3:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28146; /* reduc_plus_scal_rvvm1hf */

    case 4:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28147; /* reduc_plus_scal_rvvmf2hf */

    case 5:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28148; /* reduc_plus_scal_rvvmf4hf */

    case 6:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28158; /* reduc_plus_scal_v1hf */

    case 7:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28159; /* reduc_plus_scal_v2hf */

    case 8:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28160; /* reduc_plus_scal_v4hf */

    case 9:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28161; /* reduc_plus_scal_v8hf */

    case 10:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28162; /* reduc_plus_scal_v16hf */

    case 11:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28163; /* reduc_plus_scal_v32hf */

    case 12:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28164; /* reduc_plus_scal_v64hf */

    case 13:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28165; /* reduc_plus_scal_v128hf */

    case 14:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28166; /* reduc_plus_scal_v256hf */

    case 15:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28167; /* reduc_plus_scal_v512hf */

    case 16:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28168; /* reduc_plus_scal_v1024hf */

    case 17:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28169; /* reduc_plus_scal_v2048hf */

    case 18:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28149; /* reduc_plus_scal_rvvm8sf */

    case 19:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28150; /* reduc_plus_scal_rvvm4sf */

    case 20:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28151; /* reduc_plus_scal_rvvm2sf */

    case 21:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28152; /* reduc_plus_scal_rvvm1sf */

    case 22:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28153; /* reduc_plus_scal_rvvmf2sf */

    case 23:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28170; /* reduc_plus_scal_v1sf */

    case 24:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28171; /* reduc_plus_scal_v2sf */

    case 25:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28172; /* reduc_plus_scal_v4sf */

    case 26:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28173; /* reduc_plus_scal_v8sf */

    case 27:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28174; /* reduc_plus_scal_v16sf */

    case 28:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28175; /* reduc_plus_scal_v32sf */

    case 29:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28176; /* reduc_plus_scal_v64sf */

    case 30:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28177; /* reduc_plus_scal_v128sf */

    case 31:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28178; /* reduc_plus_scal_v256sf */

    case 32:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28179; /* reduc_plus_scal_v512sf */

    case 33:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28180; /* reduc_plus_scal_v1024sf */

    case 34:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28154; /* reduc_plus_scal_rvvm8df */

    case 35:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28155; /* reduc_plus_scal_rvvm4df */

    case 36:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28156; /* reduc_plus_scal_rvvm2df */

    case 37:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28157; /* reduc_plus_scal_rvvm1df */

    case 38:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28181; /* reduc_plus_scal_v1df */

    case 39:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28182; /* reduc_plus_scal_v2df */

    case 40:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28183; /* reduc_plus_scal_v4df */

    case 41:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28184; /* reduc_plus_scal_v8df */

    case 42:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28185; /* reduc_plus_scal_v16df */

    case 43:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28186; /* reduc_plus_scal_v32df */

    case 44:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28187; /* reduc_plus_scal_v64df */

    case 45:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28188; /* reduc_plus_scal_v128df */

    case 46:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28189; /* reduc_plus_scal_v256df */

    case 47:
      if (!(
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28190; /* reduc_plus_scal_v512df */

    case 48:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31094; /* *widen_reduc_plus_scal_rvvm4hf */

    case 49:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31095; /* *widen_reduc_plus_scal_rvvm2hf */

    case 50:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31096; /* *widen_reduc_plus_scal_rvvm1hf */

    case 51:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31097; /* *widen_reduc_plus_scal_rvvmf2hf */

    case 52:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 31098; /* *widen_reduc_plus_scal_rvvmf4hf */

    case 53:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 31103; /* *widen_reduc_plus_scal_v1hf */

    case 54:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 31104; /* *widen_reduc_plus_scal_v2hf */

    case 55:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 31105; /* *widen_reduc_plus_scal_v4hf */

    case 56:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 31106; /* *widen_reduc_plus_scal_v8hf */

    case 57:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 31107; /* *widen_reduc_plus_scal_v16hf */

    case 58:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31108; /* *widen_reduc_plus_scal_v32hf */

    case 59:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31109; /* *widen_reduc_plus_scal_v64hf */

    case 60:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31110; /* *widen_reduc_plus_scal_v128hf */

    case 61:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31111; /* *widen_reduc_plus_scal_v256hf */

    case 62:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31112; /* *widen_reduc_plus_scal_v512hf */

    case 63:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31113; /* *widen_reduc_plus_scal_v1024hf */

    case 64:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31099; /* *widen_reduc_plus_scal_rvvm4sf */

    case 65:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31100; /* *widen_reduc_plus_scal_rvvm2sf */

    case 66:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31101; /* *widen_reduc_plus_scal_rvvm1sf */

    case 67:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 31102; /* *widen_reduc_plus_scal_rvvmf2sf */

    case 68:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31114; /* *widen_reduc_plus_scal_v1sf */

    case 69:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31115; /* *widen_reduc_plus_scal_v2sf */

    case 70:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31116; /* *widen_reduc_plus_scal_v4sf */

    case 71:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31117; /* *widen_reduc_plus_scal_v8sf */

    case 72:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31118; /* *widen_reduc_plus_scal_v16sf */

    case 73:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31119; /* *widen_reduc_plus_scal_v32sf */

    case 74:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31120; /* *widen_reduc_plus_scal_v64sf */

    case 75:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31121; /* *widen_reduc_plus_scal_v128sf */

    case 76:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31122; /* *widen_reduc_plus_scal_v256sf */

    case 77:
      if (!(
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31123; /* *widen_reduc_plus_scal_v512sf */

    case 78:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31904; /* *cond_widen_reduc_plus_scal_rvvm4hf */

    case 79:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31905; /* *cond_widen_reduc_plus_scal_rvvm2hf */

    case 80:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31906; /* *cond_widen_reduc_plus_scal_rvvm1hf */

    case 81:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31907; /* *cond_widen_reduc_plus_scal_rvvmf2hf */

    case 82:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 31908; /* *cond_widen_reduc_plus_scal_rvvmf4hf */

    case 83:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 31913; /* *cond_widen_reduc_plus_scal_v1hf */

    case 84:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 31914; /* *cond_widen_reduc_plus_scal_v2hf */

    case 85:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 31915; /* *cond_widen_reduc_plus_scal_v4hf */

    case 86:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 31916; /* *cond_widen_reduc_plus_scal_v8hf */

    case 87:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 31917; /* *cond_widen_reduc_plus_scal_v16hf */

    case 88:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31918; /* *cond_widen_reduc_plus_scal_v32hf */

    case 89:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31919; /* *cond_widen_reduc_plus_scal_v64hf */

    case 90:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31920; /* *cond_widen_reduc_plus_scal_v128hf */

    case 91:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31921; /* *cond_widen_reduc_plus_scal_v256hf */

    case 92:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31922; /* *cond_widen_reduc_plus_scal_v512hf */

    case 93:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31923; /* *cond_widen_reduc_plus_scal_v1024hf */

    case 94:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31909; /* *cond_widen_reduc_plus_scal_rvvm4sf */

    case 95:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31910; /* *cond_widen_reduc_plus_scal_rvvm2sf */

    case 96:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31911; /* *cond_widen_reduc_plus_scal_rvvm1sf */

    case 97:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 31912; /* *cond_widen_reduc_plus_scal_rvvmf2sf */

    case 98:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31924; /* *cond_widen_reduc_plus_scal_v1sf */

    case 99:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31925; /* *cond_widen_reduc_plus_scal_v2sf */

    case 100:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31926; /* *cond_widen_reduc_plus_scal_v4sf */

    case 101:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31927; /* *cond_widen_reduc_plus_scal_v8sf */

    case 102:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31928; /* *cond_widen_reduc_plus_scal_v16sf */

    case 103:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31929; /* *cond_widen_reduc_plus_scal_v32sf */

    case 104:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31930; /* *cond_widen_reduc_plus_scal_v64sf */

    case 105:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31931; /* *cond_widen_reduc_plus_scal_v128sf */

    case 106:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31932; /* *cond_widen_reduc_plus_scal_v256sf */

    case 107:
      if (!(
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31933; /* *cond_widen_reduc_plus_scal_v512sf */

    case 108:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31934; /* *cond_len_widen_reduc_plus_scal_rvvm4hf */

    case 109:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31935; /* *cond_len_widen_reduc_plus_scal_rvvm2hf */

    case 110:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31936; /* *cond_len_widen_reduc_plus_scal_rvvm1hf */

    case 111:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31937; /* *cond_len_widen_reduc_plus_scal_rvvmf2hf */

    case 112:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 31938; /* *cond_len_widen_reduc_plus_scal_rvvmf4hf */

    case 113:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 31943; /* *cond_len_widen_reduc_plus_scal_v1hf */

    case 114:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 31944; /* *cond_len_widen_reduc_plus_scal_v2hf */

    case 115:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 31945; /* *cond_len_widen_reduc_plus_scal_v4hf */

    case 116:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 31946; /* *cond_len_widen_reduc_plus_scal_v8hf */

    case 117:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 31947; /* *cond_len_widen_reduc_plus_scal_v16hf */

    case 118:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31948; /* *cond_len_widen_reduc_plus_scal_v32hf */

    case 119:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31949; /* *cond_len_widen_reduc_plus_scal_v64hf */

    case 120:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31950; /* *cond_len_widen_reduc_plus_scal_v128hf */

    case 121:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31951; /* *cond_len_widen_reduc_plus_scal_v256hf */

    case 122:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31952; /* *cond_len_widen_reduc_plus_scal_v512hf */

    case 123:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31953; /* *cond_len_widen_reduc_plus_scal_v1024hf */

    case 124:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31939; /* *cond_len_widen_reduc_plus_scal_rvvm4sf */

    case 125:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31940; /* *cond_len_widen_reduc_plus_scal_rvvm2sf */

    case 126:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31941; /* *cond_len_widen_reduc_plus_scal_rvvm1sf */

    case 127:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 31942; /* *cond_len_widen_reduc_plus_scal_rvvmf2sf */

    case 128:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31954; /* *cond_len_widen_reduc_plus_scal_v1sf */

    case 129:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31955; /* *cond_len_widen_reduc_plus_scal_v2sf */

    case 130:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31956; /* *cond_len_widen_reduc_plus_scal_v4sf */

    case 131:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31957; /* *cond_len_widen_reduc_plus_scal_v8sf */

    case 132:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31958; /* *cond_len_widen_reduc_plus_scal_v16sf */

    case 133:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31959; /* *cond_len_widen_reduc_plus_scal_v32sf */

    case 134:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31960; /* *cond_len_widen_reduc_plus_scal_v64sf */

    case 135:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31961; /* *cond_len_widen_reduc_plus_scal_v128sf */

    case 136:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31962; /* *cond_len_widen_reduc_plus_scal_v256sf */

    case 137:
      if (!(
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31963; /* *cond_len_widen_reduc_plus_scal_v512sf */

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern672 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18126; /* pred_redmaxurvvm8qi */

        case 1:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18134; /* pred_redmaxurvvm4qi */

        case 2:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18142; /* pred_redmaxurvvm2qi */

        case 3:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18150; /* pred_redmaxurvvm1qi */

        case 4:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18254; /* pred_redmaxurvvmf2qi */

        case 5:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18262; /* pred_redmaxurvvmf4qi */

        case 6:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18270; /* pred_redmaxurvvmf8qi */

        case 7:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18302; /* pred_redmaxuv1qi */

        case 8:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18310; /* pred_redmaxuv2qi */

        case 9:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18318; /* pred_redmaxuv4qi */

        case 10:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18326; /* pred_redmaxuv8qi */

        case 11:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18334; /* pred_redmaxuv16qi */

        case 12:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18342; /* pred_redmaxuv32qi */

        case 13:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18350; /* pred_redmaxuv64qi */

        case 14:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18358; /* pred_redmaxuv128qi */

        case 15:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18366; /* pred_redmaxuv256qi */

        case 16:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18374; /* pred_redmaxuv512qi */

        case 17:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18382; /* pred_redmaxuv1024qi */

        case 18:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18390; /* pred_redmaxuv2048qi */

        case 19:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18398; /* pred_redmaxuv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern673 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18158; /* pred_redmaxurvvm8hi */

        case 1:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18166; /* pred_redmaxurvvm4hi */

        case 2:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18174; /* pred_redmaxurvvm2hi */

        case 3:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18182; /* pred_redmaxurvvm1hi */

        case 4:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18278; /* pred_redmaxurvvmf2hi */

        case 5:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18286; /* pred_redmaxurvvmf4hi */

        case 6:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18406; /* pred_redmaxuv1hi */

        case 7:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18414; /* pred_redmaxuv2hi */

        case 8:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18422; /* pred_redmaxuv4hi */

        case 9:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18430; /* pred_redmaxuv8hi */

        case 10:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18438; /* pred_redmaxuv16hi */

        case 11:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18446; /* pred_redmaxuv32hi */

        case 12:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18454; /* pred_redmaxuv64hi */

        case 13:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18462; /* pred_redmaxuv128hi */

        case 14:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18470; /* pred_redmaxuv256hi */

        case 15:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18478; /* pred_redmaxuv512hi */

        case 16:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18486; /* pred_redmaxuv1024hi */

        case 17:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18494; /* pred_redmaxuv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern674 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18190; /* pred_redmaxurvvm8si */

        case 1:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18198; /* pred_redmaxurvvm4si */

        case 2:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18206; /* pred_redmaxurvvm2si */

        case 3:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18214; /* pred_redmaxurvvm1si */

        case 4:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18294; /* pred_redmaxurvvmf2si */

        case 5:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18502; /* pred_redmaxuv1si */

        case 6:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18510; /* pred_redmaxuv2si */

        case 7:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18518; /* pred_redmaxuv4si */

        case 8:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18526; /* pred_redmaxuv8si */

        case 9:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18534; /* pred_redmaxuv16si */

        case 10:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18542; /* pred_redmaxuv32si */

        case 11:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18550; /* pred_redmaxuv64si */

        case 12:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18558; /* pred_redmaxuv128si */

        case 13:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18566; /* pred_redmaxuv256si */

        case 14:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18574; /* pred_redmaxuv512si */

        case 15:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18582; /* pred_redmaxuv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18222; /* pred_redmaxurvvm8di */

        case 1:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18230; /* pred_redmaxurvvm4di */

        case 2:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18238; /* pred_redmaxurvvm2di */

        case 3:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18246; /* pred_redmaxurvvm1di */

        case 4:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18590; /* pred_redmaxuv1di */

        case 5:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18598; /* pred_redmaxuv2di */

        case 6:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18606; /* pred_redmaxuv4di */

        case 7:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18614; /* pred_redmaxuv8di */

        case 8:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18622; /* pred_redmaxuv16di */

        case 9:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18630; /* pred_redmaxuv32di */

        case 10:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18638; /* pred_redmaxuv64di */

        case 11:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18646; /* pred_redmaxuv128di */

        case 12:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18654; /* pred_redmaxuv256di */

        case 13:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18662; /* pred_redmaxuv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XINT (x3, 1) != 91)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 2)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  operands[3] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  switch (XVECLEN (x3, 0))
    {
    case 6:
      return recog_82 (x1, insn, pnum_clobbers);

    case 8:
      x8 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 66
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 67
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 69
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XVECEXP (x3, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x3, 0, 1);
      operands[5] = x12;
      if (!vector_length_operand (operands[5], E_VOIDmode))
        return -1;
      x13 = XVECEXP (x3, 0, 2);
      operands[6] = x13;
      if (!const_int_operand (operands[6], E_VOIDmode))
        return -1;
      x14 = XVECEXP (x3, 0, 3);
      operands[7] = x14;
      if (!const_int_operand (operands[7], E_VOIDmode))
        return -1;
      x15 = XVECEXP (x3, 0, 4);
      operands[8] = x15;
      if (!const_int_operand (operands[8], E_VOIDmode))
        return -1;
      switch (XINT (x4, 1))
        {
        case 143:
          return recog_81 (x1, insn, pnum_clobbers);

        case 144:
          return recog_80 (x1, insn, pnum_clobbers);

        case 145:
          return recog_79 (x1, insn, pnum_clobbers);

        case 146:
          return recog_78 (x1, insn, pnum_clobbers);

        case 165:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern676 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19813; /* pred_wredosumrvvm8hf */

                case 1:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19815; /* pred_wredosumrvvm4hf */

                case 2:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19817; /* pred_wredosumrvvm2hf */

                case 3:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19819; /* pred_wredosumrvvm1hf */

                case 4:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19821; /* pred_wredosumrvvmf2hf */

                case 5:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19823; /* pred_wredosumrvvmf4hf */

                case 6:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19835; /* pred_wredosumv1hf */

                case 7:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19837; /* pred_wredosumv2hf */

                case 8:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19839; /* pred_wredosumv4hf */

                case 9:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19841; /* pred_wredosumv8hf */

                case 10:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19843; /* pred_wredosumv16hf */

                case 11:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19845; /* pred_wredosumv32hf */

                case 12:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19847; /* pred_wredosumv64hf */

                case 13:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19849; /* pred_wredosumv128hf */

                case 14:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19851; /* pred_wredosumv256hf */

                case 15:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19853; /* pred_wredosumv512hf */

                case 16:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19855; /* pred_wredosumv1024hf */

                case 17:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19857; /* pred_wredosumv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern677 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19825; /* pred_wredosumrvvm8sf */

                case 1:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19827; /* pred_wredosumrvvm4sf */

                case 2:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19829; /* pred_wredosumrvvm2sf */

                case 3:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19831; /* pred_wredosumrvvm1sf */

                case 4:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19833; /* pred_wredosumrvvmf2sf */

                case 5:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19859; /* pred_wredosumv1sf */

                case 6:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19861; /* pred_wredosumv2sf */

                case 7:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19863; /* pred_wredosumv4sf */

                case 8:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19865; /* pred_wredosumv8sf */

                case 9:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19867; /* pred_wredosumv16sf */

                case 10:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19869; /* pred_wredosumv32sf */

                case 11:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19871; /* pred_wredosumv64sf */

                case 12:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19873; /* pred_wredosumv128sf */

                case 13:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19875; /* pred_wredosumv256sf */

                case 14:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19877; /* pred_wredosumv512sf */

                case 15:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19879; /* pred_wredosumv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 166:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern676 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19814; /* pred_wredusumrvvm8hf */

                case 1:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19816; /* pred_wredusumrvvm4hf */

                case 2:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19818; /* pred_wredusumrvvm2hf */

                case 3:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19820; /* pred_wredusumrvvm1hf */

                case 4:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19822; /* pred_wredusumrvvmf2hf */

                case 5:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19824; /* pred_wredusumrvvmf4hf */

                case 6:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19836; /* pred_wredusumv1hf */

                case 7:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19838; /* pred_wredusumv2hf */

                case 8:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19840; /* pred_wredusumv4hf */

                case 9:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19842; /* pred_wredusumv8hf */

                case 10:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19844; /* pred_wredusumv16hf */

                case 11:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19846; /* pred_wredusumv32hf */

                case 12:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19848; /* pred_wredusumv64hf */

                case 13:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19850; /* pred_wredusumv128hf */

                case 14:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19852; /* pred_wredusumv256hf */

                case 15:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19854; /* pred_wredusumv512hf */

                case 16:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19856; /* pred_wredusumv1024hf */

                case 17:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19858; /* pred_wredusumv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern677 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19826; /* pred_wredusumrvvm8sf */

                case 1:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19828; /* pred_wredusumrvvm4sf */

                case 2:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19830; /* pred_wredusumrvvm2sf */

                case 3:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19832; /* pred_wredusumrvvm1sf */

                case 4:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19834; /* pred_wredusumrvvmf2sf */

                case 5:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19860; /* pred_wredusumv1sf */

                case 6:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19862; /* pred_wredusumv2sf */

                case 7:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19864; /* pred_wredusumv4sf */

                case 8:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19866; /* pred_wredusumv8sf */

                case 9:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19868; /* pred_wredusumv16sf */

                case 10:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19870; /* pred_wredusumv32sf */

                case 11:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19872; /* pred_wredusumv64sf */

                case 12:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19874; /* pred_wredusumv128sf */

                case 13:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19876; /* pred_wredusumv256sf */

                case 14:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19878; /* pred_wredusumv512sf */

                case 15:
                  if (!(
#line 7953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19880; /* pred_wredusumv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 167:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern676 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19881; /* pred_wredosum_vl0srvvm8hf */

                case 1:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19883; /* pred_wredosum_vl0srvvm4hf */

                case 2:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19885; /* pred_wredosum_vl0srvvm2hf */

                case 3:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19887; /* pred_wredosum_vl0srvvm1hf */

                case 4:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19889; /* pred_wredosum_vl0srvvmf2hf */

                case 5:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19891; /* pred_wredosum_vl0srvvmf4hf */

                case 6:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19903; /* pred_wredosum_vl0sv1hf */

                case 7:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19905; /* pred_wredosum_vl0sv2hf */

                case 8:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19907; /* pred_wredosum_vl0sv4hf */

                case 9:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19909; /* pred_wredosum_vl0sv8hf */

                case 10:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19911; /* pred_wredosum_vl0sv16hf */

                case 11:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19913; /* pred_wredosum_vl0sv32hf */

                case 12:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19915; /* pred_wredosum_vl0sv64hf */

                case 13:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19917; /* pred_wredosum_vl0sv128hf */

                case 14:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19919; /* pred_wredosum_vl0sv256hf */

                case 15:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19921; /* pred_wredosum_vl0sv512hf */

                case 16:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19923; /* pred_wredosum_vl0sv1024hf */

                case 17:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19925; /* pred_wredosum_vl0sv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern677 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19893; /* pred_wredosum_vl0srvvm8sf */

                case 1:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19895; /* pred_wredosum_vl0srvvm4sf */

                case 2:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19897; /* pred_wredosum_vl0srvvm2sf */

                case 3:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19899; /* pred_wredosum_vl0srvvm1sf */

                case 4:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19901; /* pred_wredosum_vl0srvvmf2sf */

                case 5:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19927; /* pred_wredosum_vl0sv1sf */

                case 6:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19929; /* pred_wredosum_vl0sv2sf */

                case 7:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19931; /* pred_wredosum_vl0sv4sf */

                case 8:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19933; /* pred_wredosum_vl0sv8sf */

                case 9:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19935; /* pred_wredosum_vl0sv16sf */

                case 10:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19937; /* pred_wredosum_vl0sv32sf */

                case 11:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19939; /* pred_wredosum_vl0sv64sf */

                case 12:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19941; /* pred_wredosum_vl0sv128sf */

                case 13:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19943; /* pred_wredosum_vl0sv256sf */

                case 14:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19945; /* pred_wredosum_vl0sv512sf */

                case 15:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19947; /* pred_wredosum_vl0sv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 168:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern676 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19882; /* pred_wredusum_vl0srvvm8hf */

                case 1:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19884; /* pred_wredusum_vl0srvvm4hf */

                case 2:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19886; /* pred_wredusum_vl0srvvm2hf */

                case 3:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19888; /* pred_wredusum_vl0srvvm1hf */

                case 4:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19890; /* pred_wredusum_vl0srvvmf2hf */

                case 5:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19892; /* pred_wredusum_vl0srvvmf4hf */

                case 6:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19904; /* pred_wredusum_vl0sv1hf */

                case 7:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19906; /* pred_wredusum_vl0sv2hf */

                case 8:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19908; /* pred_wredusum_vl0sv4hf */

                case 9:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19910; /* pred_wredusum_vl0sv8hf */

                case 10:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19912; /* pred_wredusum_vl0sv16hf */

                case 11:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19914; /* pred_wredusum_vl0sv32hf */

                case 12:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19916; /* pred_wredusum_vl0sv64hf */

                case 13:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19918; /* pred_wredusum_vl0sv128hf */

                case 14:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19920; /* pred_wredusum_vl0sv256hf */

                case 15:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19922; /* pred_wredusum_vl0sv512hf */

                case 16:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19924; /* pred_wredusum_vl0sv1024hf */

                case 17:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19926; /* pred_wredusum_vl0sv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern677 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19894; /* pred_wredusum_vl0srvvm8sf */

                case 1:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19896; /* pred_wredusum_vl0srvvm4sf */

                case 2:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19898; /* pred_wredusum_vl0srvvm2sf */

                case 3:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19900; /* pred_wredusum_vl0srvvm1sf */

                case 4:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19902; /* pred_wredusum_vl0srvvmf2sf */

                case 5:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19928; /* pred_wredusum_vl0sv1sf */

                case 6:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19930; /* pred_wredusum_vl0sv2sf */

                case 7:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19932; /* pred_wredusum_vl0sv4sf */

                case 8:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19934; /* pred_wredusum_vl0sv8sf */

                case 9:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19936; /* pred_wredusum_vl0sv16sf */

                case 10:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19938; /* pred_wredusum_vl0sv32sf */

                case 11:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19940; /* pred_wredusum_vl0sv64sf */

                case 12:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19942; /* pred_wredusum_vl0sv128sf */

                case 13:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19944; /* pred_wredusum_vl0sv256sf */

                case 14:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19946; /* pred_wredusum_vl0sv512sf */

                case 15:
                  if (!(
#line 7979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19948; /* pred_wredusum_vl0sv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern192 (x1))
    {
    case 0:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20487; /* pred_slide1uprvvm8hf */

    case 1:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20489; /* pred_slide1uprvvm4hf */

    case 2:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20491; /* pred_slide1uprvvm2hf */

    case 3:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20493; /* pred_slide1uprvvm1hf */

    case 4:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20495; /* pred_slide1uprvvmf2hf */

    case 5:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 20497; /* pred_slide1uprvvmf4hf */

    case 6:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20499; /* pred_slide1uprvvm8sf */

    case 7:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20501; /* pred_slide1uprvvm4sf */

    case 8:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20503; /* pred_slide1uprvvm2sf */

    case 9:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20505; /* pred_slide1uprvvm1sf */

    case 10:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 20507; /* pred_slide1uprvvmf2sf */

    case 11:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20509; /* pred_slide1uprvvm8df */

    case 12:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20511; /* pred_slide1uprvvm4df */

    case 13:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20513; /* pred_slide1uprvvm2df */

    case 14:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20515; /* pred_slide1uprvvm1df */

    case 15:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 20517; /* pred_slide1upv1hf */

    case 16:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 20519; /* pred_slide1upv2hf */

    case 17:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 20521; /* pred_slide1upv4hf */

    case 18:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 20523; /* pred_slide1upv8hf */

    case 19:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 20525; /* pred_slide1upv16hf */

    case 20:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20527; /* pred_slide1upv32hf */

    case 21:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20529; /* pred_slide1upv64hf */

    case 22:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20531; /* pred_slide1upv128hf */

    case 23:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20533; /* pred_slide1upv256hf */

    case 24:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20535; /* pred_slide1upv512hf */

    case 25:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20537; /* pred_slide1upv1024hf */

    case 26:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20539; /* pred_slide1upv2048hf */

    case 27:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20541; /* pred_slide1upv1sf */

    case 28:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20543; /* pred_slide1upv2sf */

    case 29:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20545; /* pred_slide1upv4sf */

    case 30:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20547; /* pred_slide1upv8sf */

    case 31:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20549; /* pred_slide1upv16sf */

    case 32:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20551; /* pred_slide1upv32sf */

    case 33:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20553; /* pred_slide1upv64sf */

    case 34:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20555; /* pred_slide1upv128sf */

    case 35:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20557; /* pred_slide1upv256sf */

    case 36:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20559; /* pred_slide1upv512sf */

    case 37:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20561; /* pred_slide1upv1024sf */

    case 38:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20563; /* pred_slide1upv1df */

    case 39:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20565; /* pred_slide1upv2df */

    case 40:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20567; /* pred_slide1upv4df */

    case 41:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20569; /* pred_slide1upv8df */

    case 42:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20571; /* pred_slide1upv16df */

    case 43:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20573; /* pred_slide1upv32df */

    case 44:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20575; /* pred_slide1upv64df */

    case 45:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20577; /* pred_slide1upv128df */

    case 46:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20579; /* pred_slide1upv256df */

    case 47:
      if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20581; /* pred_slide1upv512df */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 184:
      switch (pattern178 (x1, 
184))
        {
        case 0:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2325; /* pred_indexed_store_widthbrvvm8qi */

        case 1:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2331; /* pred_indexed_store_widthbrvvm4qi */

        case 2:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2349; /* pred_indexed_store_widthbrvvm8hi */

        case 3:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2337; /* pred_indexed_store_widthbrvvm2qi */

        case 4:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2355; /* pred_indexed_store_widthbrvvm4hi */

        case 5:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2373; /* pred_indexed_store_widthbrvvm8si */

        case 6:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2343; /* pred_indexed_store_widthbrvvm1qi */

        case 7:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2361; /* pred_indexed_store_widthbrvvm2hi */

        case 8:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2379; /* pred_indexed_store_widthbrvvm4si */

        case 9:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2397; /* pred_indexed_store_widthbrvvm8di */

        case 10:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2367; /* pred_indexed_store_widthbrvvm1hi */

        case 11:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2385; /* pred_indexed_store_widthbrvvm2si */

        case 12:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2403; /* pred_indexed_store_widthbrvvm4di */

        case 13:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2391; /* pred_indexed_store_widthbrvvm1si */

        case 14:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2409; /* pred_indexed_store_widthbrvvm2di */

        case 15:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2415; /* pred_indexed_store_widthbrvvm1di */

        case 16:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2421; /* pred_indexed_store_widthbrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2427; /* pred_indexed_store_widthbrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2433; /* pred_indexed_store_widthbrvvmf2si */

        default:
          return -1;
        }

    case 186:
      switch (pattern178 (x1, 
186))
        {
        case 0:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2326; /* pred_indexed_store_widthhrvvm8qi */

        case 1:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2332; /* pred_indexed_store_widthhrvvm4qi */

        case 2:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2350; /* pred_indexed_store_widthhrvvm8hi */

        case 3:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2338; /* pred_indexed_store_widthhrvvm2qi */

        case 4:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2356; /* pred_indexed_store_widthhrvvm4hi */

        case 5:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2374; /* pred_indexed_store_widthhrvvm8si */

        case 6:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2344; /* pred_indexed_store_widthhrvvm1qi */

        case 7:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2362; /* pred_indexed_store_widthhrvvm2hi */

        case 8:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2380; /* pred_indexed_store_widthhrvvm4si */

        case 9:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2398; /* pred_indexed_store_widthhrvvm8di */

        case 10:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2368; /* pred_indexed_store_widthhrvvm1hi */

        case 11:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2386; /* pred_indexed_store_widthhrvvm2si */

        case 12:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2404; /* pred_indexed_store_widthhrvvm4di */

        case 13:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2392; /* pred_indexed_store_widthhrvvm1si */

        case 14:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2410; /* pred_indexed_store_widthhrvvm2di */

        case 15:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2416; /* pred_indexed_store_widthhrvvm1di */

        case 16:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2422; /* pred_indexed_store_widthhrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2428; /* pred_indexed_store_widthhrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2434; /* pred_indexed_store_widthhrvvmf2si */

        default:
          return -1;
        }

    case 188:
      switch (pattern178 (x1, 
188))
        {
        case 0:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2327; /* pred_indexed_store_widthwrvvm8qi */

        case 1:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2333; /* pred_indexed_store_widthwrvvm4qi */

        case 2:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2351; /* pred_indexed_store_widthwrvvm8hi */

        case 3:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2339; /* pred_indexed_store_widthwrvvm2qi */

        case 4:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2357; /* pred_indexed_store_widthwrvvm4hi */

        case 5:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2375; /* pred_indexed_store_widthwrvvm8si */

        case 6:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2345; /* pred_indexed_store_widthwrvvm1qi */

        case 7:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2363; /* pred_indexed_store_widthwrvvm2hi */

        case 8:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2381; /* pred_indexed_store_widthwrvvm4si */

        case 9:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2399; /* pred_indexed_store_widthwrvvm8di */

        case 10:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2369; /* pred_indexed_store_widthwrvvm1hi */

        case 11:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2387; /* pred_indexed_store_widthwrvvm2si */

        case 12:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2405; /* pred_indexed_store_widthwrvvm4di */

        case 13:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2393; /* pred_indexed_store_widthwrvvm1si */

        case 14:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2411; /* pred_indexed_store_widthwrvvm2di */

        case 15:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2417; /* pred_indexed_store_widthwrvvm1di */

        case 16:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2423; /* pred_indexed_store_widthwrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2429; /* pred_indexed_store_widthwrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2435; /* pred_indexed_store_widthwrvvmf2si */

        default:
          return -1;
        }

    case 190:
      switch (pattern178 (x1, 
190))
        {
        case 0:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2328; /* pred_indexed_ustore_widthbrvvm8qi */

        case 1:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2334; /* pred_indexed_ustore_widthbrvvm4qi */

        case 2:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2352; /* pred_indexed_ustore_widthbrvvm8hi */

        case 3:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2340; /* pred_indexed_ustore_widthbrvvm2qi */

        case 4:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2358; /* pred_indexed_ustore_widthbrvvm4hi */

        case 5:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2376; /* pred_indexed_ustore_widthbrvvm8si */

        case 6:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2346; /* pred_indexed_ustore_widthbrvvm1qi */

        case 7:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2364; /* pred_indexed_ustore_widthbrvvm2hi */

        case 8:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2382; /* pred_indexed_ustore_widthbrvvm4si */

        case 9:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2400; /* pred_indexed_ustore_widthbrvvm8di */

        case 10:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2370; /* pred_indexed_ustore_widthbrvvm1hi */

        case 11:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2388; /* pred_indexed_ustore_widthbrvvm2si */

        case 12:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2406; /* pred_indexed_ustore_widthbrvvm4di */

        case 13:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2394; /* pred_indexed_ustore_widthbrvvm1si */

        case 14:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2412; /* pred_indexed_ustore_widthbrvvm2di */

        case 15:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2418; /* pred_indexed_ustore_widthbrvvm1di */

        case 16:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2424; /* pred_indexed_ustore_widthbrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2430; /* pred_indexed_ustore_widthbrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2436; /* pred_indexed_ustore_widthbrvvmf2si */

        default:
          return -1;
        }

    case 191:
      switch (pattern178 (x1, 
191))
        {
        case 0:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2329; /* pred_indexed_ustore_widthhrvvm8qi */

        case 1:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2335; /* pred_indexed_ustore_widthhrvvm4qi */

        case 2:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2353; /* pred_indexed_ustore_widthhrvvm8hi */

        case 3:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2341; /* pred_indexed_ustore_widthhrvvm2qi */

        case 4:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2359; /* pred_indexed_ustore_widthhrvvm4hi */

        case 5:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2377; /* pred_indexed_ustore_widthhrvvm8si */

        case 6:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2347; /* pred_indexed_ustore_widthhrvvm1qi */

        case 7:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2365; /* pred_indexed_ustore_widthhrvvm2hi */

        case 8:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2383; /* pred_indexed_ustore_widthhrvvm4si */

        case 9:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2401; /* pred_indexed_ustore_widthhrvvm8di */

        case 10:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2371; /* pred_indexed_ustore_widthhrvvm1hi */

        case 11:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2389; /* pred_indexed_ustore_widthhrvvm2si */

        case 12:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2407; /* pred_indexed_ustore_widthhrvvm4di */

        case 13:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2395; /* pred_indexed_ustore_widthhrvvm1si */

        case 14:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2413; /* pred_indexed_ustore_widthhrvvm2di */

        case 15:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2419; /* pred_indexed_ustore_widthhrvvm1di */

        case 16:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2425; /* pred_indexed_ustore_widthhrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2431; /* pred_indexed_ustore_widthhrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2437; /* pred_indexed_ustore_widthhrvvmf2si */

        default:
          return -1;
        }

    case 192:
      switch (pattern178 (x1, 
192))
        {
        case 0:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2330; /* pred_indexed_ustore_widthwrvvm8qi */

        case 1:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2336; /* pred_indexed_ustore_widthwrvvm4qi */

        case 2:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2354; /* pred_indexed_ustore_widthwrvvm8hi */

        case 3:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2342; /* pred_indexed_ustore_widthwrvvm2qi */

        case 4:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2360; /* pred_indexed_ustore_widthwrvvm4hi */

        case 5:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2378; /* pred_indexed_ustore_widthwrvvm8si */

        case 6:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2348; /* pred_indexed_ustore_widthwrvvm1qi */

        case 7:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2366; /* pred_indexed_ustore_widthwrvvm2hi */

        case 8:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2384; /* pred_indexed_ustore_widthwrvvm4si */

        case 9:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2402; /* pred_indexed_ustore_widthwrvvm8di */

        case 10:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2372; /* pred_indexed_ustore_widthwrvvm1hi */

        case 11:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2390; /* pred_indexed_ustore_widthwrvvm2si */

        case 12:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2408; /* pred_indexed_ustore_widthwrvvm4di */

        case 13:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2396; /* pred_indexed_ustore_widthwrvvm1si */

        case 14:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2414; /* pred_indexed_ustore_widthwrvvm2di */

        case 15:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2420; /* pred_indexed_ustore_widthwrvvm1di */

        case 16:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2426; /* pred_indexed_ustore_widthwrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2432; /* pred_indexed_ustore_widthwrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2438; /* pred_indexed_ustore_widthwrvvmf2si */

        default:
          return -1;
        }

    case 89:
      if (pattern179 (x1, 
67) != 0
          || !const_int_operand (operands[0], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      operands[1] = x3;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 2);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 3);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_VOIDmode)
          || !
#line 1743 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3644; /* vsetvl_vtype_change_only */

    case 94:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x3) != UNSPEC
          || XVECLEN (x3, 0) != 5
          || XINT (x3, 1) != 91)
        return -1;
      x6 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 66
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 67
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_BLKmode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != SCRATCH)
        return -1;
      x10 = XVECEXP (x2, 0, 0);
      operands[0] = x10;
      x11 = XVECEXP (x3, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x3, 0, 1);
      operands[4] = x12;
      if (!vector_length_operand (operands[4], E_VOIDmode))
        return -1;
      x13 = XVECEXP (x3, 0, 2);
      operands[5] = x13;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 2);
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 3);
      operands[3] = x5;
      return recog_91 (x1, insn, pnum_clobbers);

    case 95:
      return recog_95 (x1, insn, pnum_clobbers);

    case 96:
      return recog_94 (x1, insn, pnum_clobbers);

    case 126:
      return recog_98 (x1, insn, pnum_clobbers);

    case 127:
      return recog_97 (x1, insn, pnum_clobbers);

    case 128:
      return recog_99 (x1, insn, pnum_clobbers);

    case 129:
      return recog_100 (x1, insn, pnum_clobbers);

    case 130:
      return recog_101 (x1, insn, pnum_clobbers);

    case 131:
      switch (pattern192 (x1))
        {
        case 0:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20488; /* pred_slide1downrvvm8hf */

        case 1:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20490; /* pred_slide1downrvvm4hf */

        case 2:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20492; /* pred_slide1downrvvm2hf */

        case 3:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20494; /* pred_slide1downrvvm1hf */

        case 4:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20496; /* pred_slide1downrvvmf2hf */

        case 5:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 20498; /* pred_slide1downrvvmf4hf */

        case 6:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20500; /* pred_slide1downrvvm8sf */

        case 7:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20502; /* pred_slide1downrvvm4sf */

        case 8:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20504; /* pred_slide1downrvvm2sf */

        case 9:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20506; /* pred_slide1downrvvm1sf */

        case 10:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 20508; /* pred_slide1downrvvmf2sf */

        case 11:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20510; /* pred_slide1downrvvm8df */

        case 12:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20512; /* pred_slide1downrvvm4df */

        case 13:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20514; /* pred_slide1downrvvm2df */

        case 14:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20516; /* pred_slide1downrvvm1df */

        case 15:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 20518; /* pred_slide1downv1hf */

        case 16:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 20520; /* pred_slide1downv2hf */

        case 17:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 20522; /* pred_slide1downv4hf */

        case 18:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 20524; /* pred_slide1downv8hf */

        case 19:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 20526; /* pred_slide1downv16hf */

        case 20:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20528; /* pred_slide1downv32hf */

        case 21:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20530; /* pred_slide1downv64hf */

        case 22:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20532; /* pred_slide1downv128hf */

        case 23:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20534; /* pred_slide1downv256hf */

        case 24:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20536; /* pred_slide1downv512hf */

        case 25:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20538; /* pred_slide1downv1024hf */

        case 26:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20540; /* pred_slide1downv2048hf */

        case 27:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20542; /* pred_slide1downv1sf */

        case 28:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20544; /* pred_slide1downv2sf */

        case 29:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20546; /* pred_slide1downv4sf */

        case 30:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20548; /* pred_slide1downv8sf */

        case 31:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20550; /* pred_slide1downv16sf */

        case 32:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20552; /* pred_slide1downv32sf */

        case 33:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20554; /* pred_slide1downv64sf */

        case 34:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20556; /* pred_slide1downv128sf */

        case 35:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20558; /* pred_slide1downv256sf */

        case 36:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20560; /* pred_slide1downv512sf */

        case 37:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20562; /* pred_slide1downv1024sf */

        case 38:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20564; /* pred_slide1downv1df */

        case 39:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20566; /* pred_slide1downv2df */

        case 40:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20568; /* pred_slide1downv4df */

        case 41:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20570; /* pred_slide1downv8df */

        case 42:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20572; /* pred_slide1downv16df */

        case 43:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20574; /* pred_slide1downv32df */

        case 44:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20576; /* pred_slide1downv64df */

        case 45:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20578; /* pred_slide1downv128df */

        case 46:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20580; /* pred_slide1downv256df */

        case 47:
          if (!(
#line 8208 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20582; /* pred_slide1downv512df */

        default:
          return -1;
        }

    case 93:
      return recog_96 (x1, insn, pnum_clobbers);

    case 372:
      if (pattern193 (x1) != 0
          || !
#line 2566 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33958; /* riscv_cv_simd_cplxmul_r_si */

    case 373:
      if (pattern193 (x1) != 0
          || !
#line 2583 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33959; /* riscv_cv_simd_cplxmul_i_si */

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64SFmode)
      && reg_or_mem_operand (operands[1], E_V64SFmode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SFmode)
       || register_operand (operands[1], V64SFmode))) && (
#line 4382 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3300; /* *movv64sfsi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SFmode)
       || register_operand (operands[1], V64SFmode))) && (
#line 4382 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3301; /* *movv64sfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64SFmode)
      || !register_operand (operands[1], E_V64SFmode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 3400; /* *movv64sf_vls */
}

 int
recog_136 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V128HFmode)
      && reg_or_mem_operand (operands[1], E_V128HFmode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HFmode)
       || register_operand (operands[1], V128HFmode))) && (
#line 4376 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3288; /* *movv128hfsi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HFmode)
       || register_operand (operands[1], V128HFmode))) && (
#line 4376 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3289; /* *movv128hfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V128HFmode)
      || !register_operand (operands[1], E_V128HFmode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 3389; /* *movv128hf_vls */
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64DImode)
      && reg_or_mem_operand (operands[1], E_V64DImode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DImode)
       || register_operand (operands[1], V64DImode))) && (
#line 4370 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3276; /* *movv64disi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DImode)
       || register_operand (operands[1], V64DImode))) && (
#line 4370 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3277; /* *movv64didi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64DImode)
      || !register_operand (operands[1], E_V64DImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 3378; /* *movv64di_vls */
}

 int
recog_148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64SImode)
      && reg_or_mem_operand (operands[1], E_V64SImode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SImode)
       || register_operand (operands[1], V64SImode))) && (
#line 4364 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3264; /* *movv64sisi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SImode)
       || register_operand (operands[1], V64SImode))) && (
#line 4364 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3265; /* *movv64sidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64SImode)
      || !register_operand (operands[1], E_V64SImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 3367; /* *movv64si_vls */
}

 int
recog_154 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V128HImode)
      && reg_or_mem_operand (operands[1], E_V128HImode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HImode)
       || register_operand (operands[1], V128HImode))) && (
#line 4358 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3252; /* *movv128hisi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HImode)
       || register_operand (operands[1], V128HImode))) && (
#line 4358 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3253; /* *movv128hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V128HImode)
      || !register_operand (operands[1], E_V128HImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 3356; /* *movv128hi_vls */
}

 int
recog_160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512QImode)
      && reg_or_mem_operand (operands[1], E_V512QImode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512QImode)
       || register_operand (operands[1], V512QImode))) && (
#line 4352 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3240; /* *movv512qisi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512QImode)
       || register_operand (operands[1], V512QImode))) && (
#line 4352 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3241; /* *movv512qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512QImode)
      || !register_operand (operands[1], E_V512QImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 3345; /* *movv512qi_vls */
}

 int
recog_166 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2BImode)
      && register_operand (operands[1], E_RVVMF2BImode)
      && 
#line 1294 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
    return 2817; /* *movrvvmf2bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2BImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2BImode))
    return -1;
  if ((
#line 1354 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2858; /* *movrvvmf2bisi_lra */
    }
  if (!(
#line 1354 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2859; /* *movrvvmf2bidi_lra */
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2SFmode)
      && register_operand (operands[1], E_RVVMF2SFmode)
      && (
#line 1257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return 2800; /* *movrvvmf2sf_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2SFmode))
    return -1;
  if ((
#line 1332 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2836; /* *movrvvmf2sfsi_lra */
    }
  if (!(
#line 1332 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2847; /* *movrvvmf2sfdi_lra */
}

 int
recog_179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2HImode)
      && register_operand (operands[1], E_RVVMF2HImode)
      && 
#line 1257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return 2793; /* *movrvvmf2hi_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2HImode))
    return -1;
  if ((
#line 1332 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2829; /* *movrvvmf2hisi_lra */
    }
  if (!(
#line 1332 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2840; /* *movrvvmf2hidi_lra */
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_DImode)
      && splittable_const_int_operand (operands[1], E_DImode)
      && (
#line 2471 "../../../gcc/config/riscv/riscv.md"
(!ira_in_progress
   && !(p2m1_shift_operand (operands[1], DImode)
	|| high_mask_shift_operand (operands[1], DImode)
	|| exact_log2 (INTVAL (operands[1])) >= 0)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
    return 275; /* *mvconst_internal */
  if (!nonimmediate_operand (operands[0], E_DImode)
      || !move_operand (operands[1], E_DImode))
    return -1;
  if (
#line 2499 "../../../gcc/config/riscv/riscv.md"
(!TARGET_64BIT
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
    return 276; /* *movdi_32bit */
  if (!
#line 2511 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
    return -1;
  return 277; /* *movdi_64bit */
}

 int
recog_190 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8DFmode)
      && reg_or_mem_operand (operands[1], E_V8DFmode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8DFmode)
       || register_operand (operands[1], V8DFmode))) && 
#line 4337 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 3225; /* *movv8df */
  if (!register_operand (operands[0], E_V8DFmode)
      || !register_operand (operands[1], E_V8DFmode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3408; /* *movv8df_vls */
}

 int
recog_197 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2SFmode)
      && reg_or_mem_operand (operands[1], E_V2SFmode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[1], V2SFmode))) && 
#line 4330 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 3218; /* *movv2sf */
  if (!register_operand (operands[0], E_V2SFmode)
      || !register_operand (operands[1], E_V2SFmode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 3395; /* *movv2sf_vls */
}

 int
recog_203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1HFmode)
      && reg_or_mem_operand (operands[1], E_V1HFmode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1HFmode)
       || register_operand (operands[1], V1HFmode))) && 
#line 4324 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 3212; /* *movv1hf */
  if (!register_operand (operands[0], E_V1HFmode)
      || !register_operand (operands[1], E_V1HFmode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 3382; /* *movv1hf_vls */
}

 int
recog_209 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16SImode)
      && reg_or_mem_operand (operands[1], E_V16SImode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16SImode)
       || register_operand (operands[1], V16SImode))) && 
#line 4318 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 3206; /* *movv16si */
  if (!register_operand (operands[0], E_V16SImode)
      || !register_operand (operands[1], E_V16SImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3365; /* *movv16si_vls */
}

 int
recog_215 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8HImode)
      && reg_or_mem_operand (operands[1], E_V8HImode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[1], V8HImode))) && 
#line 4312 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return 3200; /* *movv8hi */
  if (!register_operand (operands[0], E_V8HImode)
      || !register_operand (operands[1], E_V8HImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return -1;
  return 3352; /* *movv8hi_vls */
}

 int
recog_222 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2QImode)
      && reg_or_mem_operand (operands[1], E_V2QImode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode))) && 
#line 4305 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return 3193; /* *movv2qi */
  if (!register_operand (operands[0], E_V2QImode)
      || !register_operand (operands[1], E_V2QImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return -1;
  return 3337; /* *movv2qi_vls */
}

 int
recog_229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x4QImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3182; /* *movrvvm2x4qi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3183; /* *movrvvm2x4qi_di */
}

 int
recog_234 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3HFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1331 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3172; /* *movrvvm2x3hf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1331 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3173; /* *movrvvm2x3hf_di */
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3HImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3158; /* *movrvvm2x3hi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3159; /* *movrvvm2x3hi_di */
}

 int
recog_248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3QImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3144; /* *movrvvm1x3qi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3145; /* *movrvvm1x3qi_di */
}

 int
recog_255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x7HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x7HFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1307 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3130; /* *movrvvm1x7hf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1307 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3131; /* *movrvvm1x7hf_di */
}

 int
recog_263 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6BFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1299 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3114; /* *movrvvm1x6bf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1299 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3115; /* *movrvvm1x6bf_di */
}

 int
recog_271 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2SImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3098; /* *movrvvm2x2si_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3099; /* *movrvvm2x2si_di */
}

 int
recog_277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3HImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3086; /* *movrvvm1x3hi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3087; /* *movrvvm1x3hi_di */
}

 int
recog_285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x2QImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3070; /* *movrvvmf2x2qi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3071; /* *movrvvmf2x2qi_di */
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4SFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1266 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3054; /* *movrvvm1x4sf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1266 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3055; /* *movrvvm1x4sf_di */
}

 int
recog_301 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3HFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3038; /* *movrvvmf2x3hf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3039; /* *movrvvmf2x3hf_di */
}

 int
recog_309 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x2BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x2BFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3022; /* *movrvvmf2x2bf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3023; /* *movrvvmf2x2bf_di */
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4SImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3006; /* *movrvvm1x4si_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3007; /* *movrvvm1x4si_di */
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3HImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2990; /* *movrvvmf2x3hi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2991; /* *movrvvmf2x3hi_di */
}

 int
recog_333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x2QImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2974; /* *movrvvmf4x2qi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2975; /* *movrvvmf4x2qi_di */
}

 int
recog_341 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8SFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1215 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2958; /* *movrvvmf2x8sf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1215 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2959; /* *movrvvmf2x8sf_di */
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x7HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x7HFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2942; /* *movrvvmf4x7hf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2943; /* *movrvvmf4x7hf_di */
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x6BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x6BFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2926; /* *movrvvmf4x6bf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2927; /* *movrvvmf4x6bf_di */
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5DImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2910; /* *movrvvm1x5di_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2911; /* *movrvvm1x5di_di */
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4SImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2894; /* *movrvvmf2x4si_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2895; /* *movrvvmf2x4si_di */
}

 int
recog_381 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 2);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if (
#line 3029 "../../../gcc/config/riscv/riscv.md"
((TARGET_64BIT && (INTVAL (operands[3]) > 0)
    && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))))
        return 331; /* *lshrsi3_extend_2 */
      if (pnum_clobbers == NULL
          || !(
#line 3064 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 336; /* *zero_extractdi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !
#line 3064 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))))
        return -1;
      *pnum_clobbers = 1;
      return 334; /* *zero_extractsi3 */

    default:
      return -1;
    }
}

 int
recog_383 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      operands[1] = x3;
      x9 = XEXP (x5, 0);
      operands[2] = x9;
      x10 = XEXP (x5, 1);
      operands[3] = x10;
      if (!shifted_const_arith_operand (operands[3], E_VOIDmode))
        return -1;
      switch (pattern447 (x2))
        {
        case 0:
          if ((
#line 3168 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 338; /* *branchqi_shiftedarith_equals_zero */
            }
          if (!(
#line 3168 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 341; /* *branchqi_shiftedarith_equals_zero */

        case 1:
          if ((
#line 3168 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 339; /* *branchhi_shiftedarith_equals_zero */
            }
          if (!(
#line 3168 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 342; /* *branchhi_shiftedarith_equals_zero */

        case 2:
          if ((
#line 3168 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 340; /* *branchsi_shiftedarith_equals_zero */
            }
          if (!(
#line 3168 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 343; /* *branchsi_shiftedarith_equals_zero */

        case 3:
          if (!(
#line 3168 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 344; /* *branchdi_shiftedarith_equals_zero */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x5, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XEXP (x5, 0);
      operands[2] = x9;
      if (XWINT (x10, 0) == 1L)
        {
          res = recog_382 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x11 = XEXP (x5, 2);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x3;
      operands[3] = x10;
      if (!branch_on_bit_operand (operands[3], E_VOIDmode))
        return -1;
      x12 = XEXP (x6, 0);
      operands[1] = x12;
      switch (GET_MODE (x5))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 385; /* *branch_on_bit_rangesi */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || !
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 386; /* *branch_on_bit_rangedi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x5;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      operands[4] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      x7 = XEXP (x2, 2);
      operands[3] = x7;
      switch (pattern333 (x2))
        {
        case 0:
          if (!reg_or_0_operand (operands[2], E_SImode)
              || !reg_or_0_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !(
#line 165 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 893; /* *th_cond_movsi */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !(
#line 165 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADCONDMOV) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 894; /* *th_cond_movsi */

            default:
              return -1;
            }

        case 1:
          if (!register_operand (operands[1], E_DImode)
              || !reg_or_0_operand (operands[2], E_DImode)
              || !reg_or_0_operand (operands[3], E_DImode)
              || !(
#line 165 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADCONDMOV) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 895; /* *th_cond_movdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_385 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!shifted_const_arith_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!shifted_const_arith_operand (operands[3], E_VOIDmode))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  switch (GET_CODE (x3))
    {
    case EQ:
      switch (pattern448 (x4))
        {
        case 0:
          if ((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 345; /* *branchqi_shiftedarith_eq_shifted */
            }
          if (!(
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 353; /* *branchqi_shiftedarith_eq_shifted */

        case 1:
          if ((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 347; /* *branchhi_shiftedarith_eq_shifted */
            }
          if (!(
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 355; /* *branchhi_shiftedarith_eq_shifted */

        case 2:
          if ((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 349; /* *branchsi_shiftedarith_eq_shifted */
            }
          if (!(
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 357; /* *branchsi_shiftedarith_eq_shifted */

        case 3:
          if ((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && ((((
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            {
              *pnum_clobbers = 2;
              return 351; /* *branchdi_shiftedarith_eq_shifted */
            }
          if (!(
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 359; /* *branchdi_shiftedarith_eq_shifted */

        default:
          return -1;
        }

    case NE:
      switch (pattern448 (x4))
        {
        case 0:
          if ((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 346; /* *branchqi_shiftedarith_ne_shifted */
            }
          if (!(
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 354; /* *branchqi_shiftedarith_ne_shifted */

        case 1:
          if ((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 348; /* *branchhi_shiftedarith_ne_shifted */
            }
          if (!(
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 356; /* *branchhi_shiftedarith_ne_shifted */

        case 2:
          if ((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 350; /* *branchsi_shiftedarith_ne_shifted */
            }
          if (!(
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 358; /* *branchsi_shiftedarith_ne_shifted */

        case 3:
          if ((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && ((((
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            {
              *pnum_clobbers = 2;
              return 352; /* *branchdi_shiftedarith_ne_shifted */
            }
          if (!(
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 360; /* *branchdi_shiftedarith_ne_shifted */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_396 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3965; /* pred_mergervvm8qi_scalar */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3966; /* pred_mergervvm4qi_scalar */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3967; /* pred_mergervvm2qi_scalar */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3968; /* pred_mergervvm1qi_scalar */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3969; /* pred_mergervvmf2qi_scalar */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3970; /* pred_mergervvmf4qi_scalar */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 3971; /* pred_mergervvmf8qi_scalar */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3972; /* pred_mergervvm8hi_scalar */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3973; /* pred_mergervvm4hi_scalar */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3974; /* pred_mergervvm2hi_scalar */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3975; /* pred_mergervvm1hi_scalar */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3976; /* pred_mergervvmf2hi_scalar */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 3977; /* pred_mergervvmf4hi_scalar */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3978; /* pred_mergervvm8si_scalar */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3979; /* pred_mergervvm4si_scalar */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3980; /* pred_mergervvm2si_scalar */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0
          || !
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3981; /* pred_mergervvm1si_scalar */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 3982; /* pred_mergervvmf2si_scalar */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 3983; /* pred_mergev1qi_scalar */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 3984; /* pred_mergev2qi_scalar */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 3985; /* pred_mergev4qi_scalar */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 3986; /* pred_mergev8qi_scalar */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 3987; /* pred_mergev16qi_scalar */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 3988; /* pred_mergev32qi_scalar */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3989; /* pred_mergev64qi_scalar */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3990; /* pred_mergev128qi_scalar */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3991; /* pred_mergev256qi_scalar */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3992; /* pred_mergev512qi_scalar */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3993; /* pred_mergev1024qi_scalar */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3994; /* pred_mergev2048qi_scalar */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3995; /* pred_mergev4096qi_scalar */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 3996; /* pred_mergev1hi_scalar */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 3997; /* pred_mergev2hi_scalar */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 3998; /* pred_mergev4hi_scalar */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 3999; /* pred_mergev8hi_scalar */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 4000; /* pred_mergev16hi_scalar */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4001; /* pred_mergev32hi_scalar */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4002; /* pred_mergev64hi_scalar */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4003; /* pred_mergev128hi_scalar */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4004; /* pred_mergev256hi_scalar */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4005; /* pred_mergev512hi_scalar */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4006; /* pred_mergev1024hi_scalar */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4007; /* pred_mergev2048hi_scalar */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 4008; /* pred_mergev1si_scalar */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 4009; /* pred_mergev2si_scalar */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 4010; /* pred_mergev4si_scalar */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 4011; /* pred_mergev8si_scalar */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4012; /* pred_mergev16si_scalar */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4013; /* pred_mergev32si_scalar */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4014; /* pred_mergev64si_scalar */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4015; /* pred_mergev128si_scalar */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4016; /* pred_mergev256si_scalar */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4017; /* pred_mergev512si_scalar */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0
          || !(
#line 2031 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4018; /* pred_mergev1024si_scalar */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4019; /* *pred_mergervvm8di_scalar */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4020; /* *pred_mergervvm4di_scalar */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4021; /* *pred_mergervvm2di_scalar */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4022; /* *pred_mergervvm1di_scalar */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4023; /* *pred_mergev1di_scalar */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4024; /* *pred_mergev2di_scalar */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4025; /* *pred_mergev4di_scalar */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4026; /* *pred_mergev8di_scalar */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4027; /* *pred_mergev16di_scalar */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4028; /* *pred_mergev32di_scalar */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4029; /* *pred_mergev64di_scalar */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4030; /* *pred_mergev128di_scalar */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4031; /* *pred_mergev256di_scalar */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0
          || !(
#line 2083 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4032; /* *pred_mergev512di_scalar */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17231; /* pred_mergervvm8hf_scalar */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17232; /* pred_mergervvm4hf_scalar */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17233; /* pred_mergervvm2hf_scalar */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17234; /* pred_mergervvm1hf_scalar */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17235; /* pred_mergervvmf2hf_scalar */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17236; /* pred_mergervvmf4hf_scalar */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17237; /* pred_mergervvm8sf_scalar */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17238; /* pred_mergervvm4sf_scalar */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17239; /* pred_mergervvm2sf_scalar */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17240; /* pred_mergervvm1sf_scalar */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17241; /* pred_mergervvmf2sf_scalar */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17242; /* pred_mergervvm8df_scalar */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17243; /* pred_mergervvm4df_scalar */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17244; /* pred_mergervvm2df_scalar */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17245; /* pred_mergervvm1df_scalar */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17246; /* pred_mergev1hf_scalar */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17247; /* pred_mergev2hf_scalar */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17248; /* pred_mergev4hf_scalar */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17249; /* pred_mergev8hf_scalar */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17250; /* pred_mergev16hf_scalar */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17251; /* pred_mergev32hf_scalar */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17252; /* pred_mergev64hf_scalar */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17253; /* pred_mergev128hf_scalar */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17254; /* pred_mergev256hf_scalar */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17255; /* pred_mergev512hf_scalar */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17256; /* pred_mergev1024hf_scalar */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17257; /* pred_mergev2048hf_scalar */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17258; /* pred_mergev1sf_scalar */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17259; /* pred_mergev2sf_scalar */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17260; /* pred_mergev4sf_scalar */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17261; /* pred_mergev8sf_scalar */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17262; /* pred_mergev16sf_scalar */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17263; /* pred_mergev32sf_scalar */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17264; /* pred_mergev64sf_scalar */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17265; /* pred_mergev128sf_scalar */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17266; /* pred_mergev256sf_scalar */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17267; /* pred_mergev512sf_scalar */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17268; /* pred_mergev1024sf_scalar */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17269; /* pred_mergev1df_scalar */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17270; /* pred_mergev2df_scalar */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17271; /* pred_mergev4df_scalar */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17272; /* pred_mergev8df_scalar */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17273; /* pred_mergev16df_scalar */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17274; /* pred_mergev32df_scalar */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17275; /* pred_mergev64df_scalar */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17276; /* pred_mergev128df_scalar */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17277; /* pred_mergev256df_scalar */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern640 (x2, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0
          || !(
#line 7458 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17278; /* pred_mergev512df_scalar */

    default:
      return -1;
    }
}

 int
recog_408 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  if (!vector_length_operand (x5, E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF64BImode:
      if (GET_MODE (x2) != E_RVVMF64BImode
          || GET_MODE (x3) != E_RVVMF64BImode
          || !vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_RVVMF64BImode))
        {
          res = recog_388 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!memory_operand (operands[0], E_RVVMF64BImode))
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_RVVMF64BImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !(
#line 1990 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 3836; /* pred_storervvmf64bi */

    case E_RVVMF32BImode:
      if (GET_MODE (x2) != E_RVVMF32BImode
          || GET_MODE (x3) != E_RVVMF32BImode
          || !vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_RVVMF32BImode))
        {
          res = recog_389 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!memory_operand (operands[0], E_RVVMF32BImode))
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_RVVMF32BImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !
#line 1990 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3837; /* pred_storervvmf32bi */

    case E_RVVMF16BImode:
      if (GET_MODE (x2) != E_RVVMF16BImode
          || GET_MODE (x3) != E_RVVMF16BImode
          || !vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_RVVMF16BImode))
        {
          res = recog_390 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!memory_operand (operands[0], E_RVVMF16BImode))
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_RVVMF16BImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !
#line 1990 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3838; /* pred_storervvmf16bi */

    case E_RVVMF8BImode:
      if (GET_MODE (x2) != E_RVVMF8BImode
          || GET_MODE (x3) != E_RVVMF8BImode
          || !vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_RVVMF8BImode))
        {
          res = recog_391 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!memory_operand (operands[0], E_RVVMF8BImode))
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_RVVMF8BImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !
#line 1990 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3839; /* pred_storervvmf8bi */

    case E_RVVMF4BImode:
      if (GET_MODE (x2) != E_RVVMF4BImode
          || GET_MODE (x3) != E_RVVMF4BImode
          || !vector_all_trues_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_RVVMF4BImode))
        {
          res = recog_392 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!memory_operand (operands[0], E_RVVMF4BImode))
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_RVVMF4BImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !
#line 1990 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3840; /* pred_storervvmf4bi */

    case E_RVVMF2BImode:
      if (GET_MODE (x2) != E_RVVMF2BImode
          || GET_MODE (x3) != E_RVVMF2BImode
          || !vector_all_trues_mask_operand (operands[1], E_RVVMF2BImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_RVVMF2BImode))
        {
          res = recog_393 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!memory_operand (operands[0], E_RVVMF2BImode))
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_RVVMF2BImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !
#line 1990 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3841; /* pred_storervvmf2bi */

    case E_RVVM1BImode:
      if (GET_MODE (x2) != E_RVVM1BImode
          || GET_MODE (x3) != E_RVVM1BImode
          || !vector_all_trues_mask_operand (operands[1], E_RVVM1BImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_RVVM1BImode))
        {
          res = recog_394 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!memory_operand (operands[0], E_RVVM1BImode))
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_RVVM1BImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !
#line 1990 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3842; /* pred_storervvm1bi */

    case E_V1BImode:
      if (pattern463 (x2, 
E_V1BImode) != 0)
        return -1;
      if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return 1238; /* *pred_th_movv1bi */
      if (!(
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return -1;
      return 3823; /* pred_movv1bi */

    case E_V2BImode:
      if (pattern463 (x2, 
E_V2BImode) != 0)
        return -1;
      if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return 1239; /* *pred_th_movv2bi */
      if (!(
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return -1;
      return 3824; /* pred_movv2bi */

    case E_V4BImode:
      if (pattern463 (x2, 
E_V4BImode) != 0)
        return -1;
      if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return 1240; /* *pred_th_movv4bi */
      if (!(
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return -1;
      return 3825; /* pred_movv4bi */

    case E_V8BImode:
      if (pattern463 (x2, 
E_V8BImode) != 0)
        return -1;
      if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return 1241; /* *pred_th_movv8bi */
      if (!(
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return -1;
      return 3826; /* pred_movv8bi */

    case E_V16BImode:
      if (pattern463 (x2, 
E_V16BImode) != 0)
        return -1;
      if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return 1242; /* *pred_th_movv16bi */
      if (!(
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return -1;
      return 3827; /* pred_movv16bi */

    case E_V32BImode:
      if (pattern463 (x2, 
E_V32BImode) != 0)
        return -1;
      if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return 1243; /* *pred_th_movv32bi */
      if (!(
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return -1;
      return 3828; /* pred_movv32bi */

    case E_V64BImode:
      if (pattern463 (x2, 
E_V64BImode) != 0)
        return -1;
      if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return 1244; /* *pred_th_movv64bi */
      if (!(
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3829; /* pred_movv64bi */

    case E_V128BImode:
      if (pattern463 (x2, 
E_V128BImode) != 0)
        return -1;
      if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return 1245; /* *pred_th_movv128bi */
      if (!(
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3830; /* pred_movv128bi */

    case E_V256BImode:
      if (pattern463 (x2, 
E_V256BImode) != 0)
        return -1;
      if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return 1246; /* *pred_th_movv256bi */
      if (!(
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3831; /* pred_movv256bi */

    case E_V512BImode:
      if (pattern463 (x2, 
E_V512BImode) != 0)
        return -1;
      if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return 1247; /* *pred_th_movv512bi */
      if (!(
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3832; /* pred_movv512bi */

    case E_V1024BImode:
      if (pattern463 (x2, 
E_V1024BImode) != 0)
        return -1;
      if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return 1248; /* *pred_th_movv1024bi */
      if (!(
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3833; /* pred_movv1024bi */

    case E_V2048BImode:
      if (pattern463 (x2, 
E_V2048BImode) != 0)
        return -1;
      if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return 1249; /* *pred_th_movv2048bi */
      if (!(
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3834; /* pred_movv2048bi */

    case E_V4096BImode:
      if (pattern463 (x2, 
E_V4096BImode) != 0)
        return -1;
      if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return 1250; /* *pred_th_movv4096bi */
      if (!(
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3835; /* pred_movv4096bi */

    case E_RVVM8QImode:
      if (pattern464 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3773; /* pred_storervvm8qi */

    case E_RVVM4QImode:
      if (pattern464 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3774; /* pred_storervvm4qi */

    case E_RVVM2QImode:
      if (pattern464 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3775; /* pred_storervvm2qi */

    case E_RVVM1QImode:
      if (pattern464 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3776; /* pred_storervvm1qi */

    case E_RVVM8HImode:
      if (pattern464 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3777; /* pred_storervvm8hi */

    case E_RVVM4HImode:
      if (pattern464 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3778; /* pred_storervvm4hi */

    case E_RVVM2HImode:
      if (pattern464 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3779; /* pred_storervvm2hi */

    case E_RVVM1HImode:
      if (pattern464 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3780; /* pred_storervvm1hi */

    case E_RVVM8SImode:
      if (pattern464 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3781; /* pred_storervvm8si */

    case E_RVVM4SImode:
      if (pattern464 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3782; /* pred_storervvm4si */

    case E_RVVM2SImode:
      if (pattern464 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3783; /* pred_storervvm2si */

    case E_RVVM1SImode:
      if (pattern464 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3784; /* pred_storervvm1si */

    case E_RVVM8DImode:
      if (pattern464 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3785; /* pred_storervvm8di */

    case E_RVVM4DImode:
      if (pattern464 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3786; /* pred_storervvm4di */

    case E_RVVM2DImode:
      if (pattern464 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3787; /* pred_storervvm2di */

    case E_RVVM1DImode:
      if (pattern464 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3788; /* pred_storervvm1di */

    case E_RVVMF2QImode:
      if (pattern464 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3789; /* pred_storervvmf2qi */

    case E_RVVMF4QImode:
      if (pattern464 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3790; /* pred_storervvmf4qi */

    case E_RVVMF8QImode:
      if (pattern464 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3791; /* pred_storervvmf8qi */

    case E_RVVMF2HImode:
      if (pattern464 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3792; /* pred_storervvmf2hi */

    case E_RVVMF4HImode:
      if (pattern464 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3793; /* pred_storervvmf4hi */

    case E_RVVMF2SImode:
      if (pattern464 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3794; /* pred_storervvmf2si */

    case E_RVVM8BFmode:
      if (pattern464 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3795; /* pred_storervvm8bf */

    case E_RVVM4BFmode:
      if (pattern464 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3796; /* pred_storervvm4bf */

    case E_RVVM2BFmode:
      if (pattern464 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3797; /* pred_storervvm2bf */

    case E_RVVM1BFmode:
      if (pattern464 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3798; /* pred_storervvm1bf */

    case E_RVVMF2BFmode:
      if (pattern464 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3799; /* pred_storervvmf2bf */

    case E_RVVMF4BFmode:
      if (pattern464 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3800; /* pred_storervvmf4bf */

    case E_RVVM8HFmode:
      if (pattern464 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3801; /* pred_storervvm8hf */

    case E_RVVM4HFmode:
      if (pattern464 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3802; /* pred_storervvm4hf */

    case E_RVVM2HFmode:
      if (pattern464 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3803; /* pred_storervvm2hf */

    case E_RVVM1HFmode:
      if (pattern464 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3804; /* pred_storervvm1hf */

    case E_RVVMF2HFmode:
      if (pattern464 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3805; /* pred_storervvmf2hf */

    case E_RVVMF4HFmode:
      if (pattern464 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3806; /* pred_storervvmf4hf */

    case E_RVVM8SFmode:
      if (pattern464 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3807; /* pred_storervvm8sf */

    case E_RVVM4SFmode:
      if (pattern464 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3808; /* pred_storervvm4sf */

    case E_RVVM2SFmode:
      if (pattern464 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3809; /* pred_storervvm2sf */

    case E_RVVM1SFmode:
      if (pattern464 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3810; /* pred_storervvm1sf */

    case E_RVVMF2SFmode:
      if (pattern464 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3811; /* pred_storervvmf2sf */

    case E_RVVM8DFmode:
      if (pattern464 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3812; /* pred_storervvm8df */

    case E_RVVM4DFmode:
      if (pattern464 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3813; /* pred_storervvm4df */

    case E_RVVM2DFmode:
      if (pattern464 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3814; /* pred_storervvm2df */

    case E_RVVM1DFmode:
      if (pattern464 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1941 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3815; /* pred_storervvm1df */

    default:
      return -1;
    }
}

 int
recog_417 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V32DFmode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32DFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 4348; /* *pred_broadcastv32df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32DFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4470; /* *pred_broadcastv32df_imm */
}

 int
recog_420 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V4DFmode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4DFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 4345; /* *pred_broadcastv4df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4DFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4467; /* *pred_broadcastv4df_imm */
}

 int
recog_424 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V512SFmode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512SFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 4341; /* *pred_broadcastv512sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512SFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4463; /* *pred_broadcastv512sf_imm */
}

 int
recog_428 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V32SFmode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32SFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return 4337; /* *pred_broadcastv32sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32SFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4459; /* *pred_broadcastv32sf_imm */
}

 int
recog_432 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V2SFmode, 
E_V2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2BImode)
      && vector_const_0_operand (operands[3], E_V2SFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 4333; /* *pred_broadcastv2sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2SFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4455; /* *pred_broadcastv2sf_imm */
}

 int
recog_436 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V512HFmode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512HFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return 4329; /* *pred_broadcastv512hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512HFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4451; /* *pred_broadcastv512hf_imm */
}

 int
recog_440 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V32HFmode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32HFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
    return 4325; /* *pred_broadcastv32hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32HFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4447; /* *pred_broadcastv32hf_imm */
}

 int
recog_444 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V2HFmode, 
E_V2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2BImode)
      && vector_const_0_operand (operands[3], E_V2HFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 4321; /* *pred_broadcastv2hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2HFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4443; /* *pred_broadcastv2hf_imm */
}

 int
recog_449 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64DImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 4316; /* *pred_broadcastv64di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64DImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4438; /* *pred_broadcastv64di_imm */
}

 int
recog_454 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2BImode)
      && vector_const_0_operand (operands[3], E_V2DImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 4311; /* *pred_broadcastv2di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2DImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 4433; /* *pred_broadcastv2di_imm */
}

 int
recog_460 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64SImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 4305; /* *pred_broadcastv64si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64SImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4427; /* *pred_broadcastv64si_imm */
}

 int
recog_466 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V1SImode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1SImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return 4299; /* *pred_broadcastv1si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1SImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return -1;
  return 4421; /* *pred_broadcastv1si_imm */
}

 int
recog_473 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V32HImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32HImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 4292; /* *pred_broadcastv32hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32HImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4414; /* *pred_broadcastv32hi_imm */
}

 int
recog_480 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2048BImode)
      && vector_const_0_operand (operands[3], E_V2048QImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return 4285; /* *pred_broadcastv2048qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2048BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2048QImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4407; /* *pred_broadcastv2048qi_imm */
}

 int
recog_487 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V16QImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16QImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return 4278; /* *pred_broadcastv16qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16QImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return -1;
  return 4400; /* *pred_broadcastv16qi_imm */
}

 int
recog_494 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
      && vector_const_0_operand (operands[3], E_RVVM4DFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 4271; /* *pred_broadcastrvvm4df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4DFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4393; /* *pred_broadcastrvvm4df_imm */
}

 int
recog_502 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
      && vector_const_0_operand (operands[3], E_RVVMF2HFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 4263; /* *pred_broadcastrvvmf2hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF2HFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4385; /* *pred_broadcastrvvmf2hf_imm */
}

 int
recog_510 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V512DFmode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512DImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return 20704; /* pred_gatherv512df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 20826; /* pred_gatherv512df_scalar */
}

 int
recog_515 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V16DFmode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16DImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return 20699; /* pred_gatherv16df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 20821; /* pred_gatherv16df_scalar */
}

 int
recog_520 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1024SImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 20694; /* pred_gatherv1024sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 20816; /* pred_gatherv1024sf_scalar */
}

 int
recog_525 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V32SFmode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32SImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return 20689; /* pred_gatherv32sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 20811; /* pred_gatherv32sf_scalar */
}

 int
recog_530 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1SFmode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1SImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 20684; /* pred_gatherv1sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 20806; /* pred_gatherv1sf_scalar */
}

 int
recog_535 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V128HFmode, 
E_V128BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V128HImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return 20679; /* pred_gatherv128hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20801; /* pred_gatherv128hf_scalar */
}

 int
recog_540 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V4HFmode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4HImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 20674; /* pred_gatherv4hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 20796; /* pred_gatherv4hf_scalar */
}

 int
recog_545 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V128DImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 20669; /* pred_gatherv128di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20791; /* pred_gatherv128di_scalar */
}

 int
recog_550 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4DImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 20664; /* pred_gatherv4di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 20786; /* pred_gatherv4di_scalar */
}

 int
recog_555 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256SImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 20659; /* pred_gatherv256si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20781; /* pred_gatherv256si_scalar */
}

 int
recog_560 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8SImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 20654; /* pred_gatherv8si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 20776; /* pred_gatherv8si_scalar */
}

 int
recog_565 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1024HImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 20649; /* pred_gatherv1024hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20771; /* pred_gatherv1024hi_scalar */
}

 int
recog_570 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V32HImode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32HImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 20644; /* pred_gatherv32hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20766; /* pred_gatherv32hi_scalar */
}

 int
recog_575 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1HImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 20639; /* pred_gatherv1hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 20761; /* pred_gatherv1hi_scalar */
}

 int
recog_580 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256QImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return 20634; /* pred_gatherv256qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20756; /* pred_gatherv256qi_scalar */
}

 int
recog_585 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8QImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return 20629; /* pred_gatherv8qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return -1;
  return 20751; /* pred_gatherv8qi_scalar */
}

 int
recog_590 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_RVVM2DImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 20624; /* pred_gatherrvvm2df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20746; /* pred_gatherrvvm2df_scalar */
}

 int
recog_595 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SCRATCH)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[4] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[5] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[6] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[7] = x10;
  x11 = XVECEXP (x3, 0, 0);
  operands[3] = x11;
  switch (pattern695 (x2))
    {
    case 0:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21108; /* pred_unit_strided_loadrvvmf8x2qi */

    case 1:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21109; /* pred_unit_strided_loadrvvmf8x3qi */

    case 2:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21110; /* pred_unit_strided_loadrvvmf8x4qi */

    case 3:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21111; /* pred_unit_strided_loadrvvmf8x5qi */

    case 4:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21112; /* pred_unit_strided_loadrvvmf8x6qi */

    case 5:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21113; /* pred_unit_strided_loadrvvmf8x7qi */

    case 6:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21114; /* pred_unit_strided_loadrvvmf8x8qi */

    case 7:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21115; /* pred_unit_strided_loadrvvmf4x2hi */

    case 8:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21116; /* pred_unit_strided_loadrvvmf4x3hi */

    case 9:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21117; /* pred_unit_strided_loadrvvmf4x4hi */

    case 10:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21118; /* pred_unit_strided_loadrvvmf4x5hi */

    case 11:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21119; /* pred_unit_strided_loadrvvmf4x6hi */

    case 12:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21120; /* pred_unit_strided_loadrvvmf4x7hi */

    case 13:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21121; /* pred_unit_strided_loadrvvmf4x8hi */

    case 14:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21122; /* pred_unit_strided_loadrvvmf2x2si */

    case 15:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21123; /* pred_unit_strided_loadrvvmf2x3si */

    case 16:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21124; /* pred_unit_strided_loadrvvmf2x4si */

    case 17:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21125; /* pred_unit_strided_loadrvvmf2x5si */

    case 18:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21126; /* pred_unit_strided_loadrvvmf2x6si */

    case 19:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21127; /* pred_unit_strided_loadrvvmf2x7si */

    case 20:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21128; /* pred_unit_strided_loadrvvmf2x8si */

    case 21:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21129; /* pred_unit_strided_loadrvvm1x2di */

    case 22:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21130; /* pred_unit_strided_loadrvvm1x3di */

    case 23:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21131; /* pred_unit_strided_loadrvvm1x4di */

    case 24:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21132; /* pred_unit_strided_loadrvvm1x5di */

    case 25:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21133; /* pred_unit_strided_loadrvvm1x6di */

    case 26:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21134; /* pred_unit_strided_loadrvvm1x7di */

    case 27:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21135; /* pred_unit_strided_loadrvvm1x8di */

    case 28:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21136; /* pred_unit_strided_loadrvvmf4x2bf */

    case 29:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21137; /* pred_unit_strided_loadrvvmf4x3bf */

    case 30:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21138; /* pred_unit_strided_loadrvvmf4x4bf */

    case 31:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21139; /* pred_unit_strided_loadrvvmf4x5bf */

    case 32:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21140; /* pred_unit_strided_loadrvvmf4x6bf */

    case 33:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21141; /* pred_unit_strided_loadrvvmf4x7bf */

    case 34:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21142; /* pred_unit_strided_loadrvvmf4x8bf */

    case 35:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21143; /* pred_unit_strided_loadrvvmf4x2hf */

    case 36:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21144; /* pred_unit_strided_loadrvvmf4x3hf */

    case 37:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21145; /* pred_unit_strided_loadrvvmf4x4hf */

    case 38:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21146; /* pred_unit_strided_loadrvvmf4x5hf */

    case 39:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21147; /* pred_unit_strided_loadrvvmf4x6hf */

    case 40:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21148; /* pred_unit_strided_loadrvvmf4x7hf */

    case 41:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21149; /* pred_unit_strided_loadrvvmf4x8hf */

    case 42:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1209 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21150; /* pred_unit_strided_loadrvvmf2x2sf */

    case 43:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1210 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21151; /* pred_unit_strided_loadrvvmf2x3sf */

    case 44:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1211 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21152; /* pred_unit_strided_loadrvvmf2x4sf */

    case 45:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1212 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21153; /* pred_unit_strided_loadrvvmf2x5sf */

    case 46:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1213 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21154; /* pred_unit_strided_loadrvvmf2x6sf */

    case 47:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1214 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21155; /* pred_unit_strided_loadrvvmf2x7sf */

    case 48:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1215 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21156; /* pred_unit_strided_loadrvvmf2x8sf */

    case 49:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1216 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21157; /* pred_unit_strided_loadrvvm1x2df */

    case 50:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1217 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21158; /* pred_unit_strided_loadrvvm1x3df */

    case 51:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1218 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21159; /* pred_unit_strided_loadrvvm1x4df */

    case 52:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1219 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21160; /* pred_unit_strided_loadrvvm1x5df */

    case 53:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1220 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21161; /* pred_unit_strided_loadrvvm1x6df */

    case 54:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1221 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21162; /* pred_unit_strided_loadrvvm1x7df */

    case 55:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1222 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21163; /* pred_unit_strided_loadrvvm1x8df */

    case 56:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21164; /* pred_unit_strided_loadrvvmf4x2qi */

    case 57:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21165; /* pred_unit_strided_loadrvvmf4x3qi */

    case 58:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21166; /* pred_unit_strided_loadrvvmf4x4qi */

    case 59:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21167; /* pred_unit_strided_loadrvvmf4x5qi */

    case 60:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21168; /* pred_unit_strided_loadrvvmf4x6qi */

    case 61:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21169; /* pred_unit_strided_loadrvvmf4x7qi */

    case 62:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21170; /* pred_unit_strided_loadrvvmf4x8qi */

    case 63:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21171; /* pred_unit_strided_loadrvvmf2x2hi */

    case 64:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21172; /* pred_unit_strided_loadrvvmf2x3hi */

    case 65:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21173; /* pred_unit_strided_loadrvvmf2x4hi */

    case 66:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21174; /* pred_unit_strided_loadrvvmf2x5hi */

    case 67:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21175; /* pred_unit_strided_loadrvvmf2x6hi */

    case 68:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21176; /* pred_unit_strided_loadrvvmf2x7hi */

    case 69:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21177; /* pred_unit_strided_loadrvvmf2x8hi */

    case 70:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21178; /* pred_unit_strided_loadrvvm1x2si */

    case 71:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21179; /* pred_unit_strided_loadrvvm1x3si */

    case 72:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21180; /* pred_unit_strided_loadrvvm1x4si */

    case 73:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21181; /* pred_unit_strided_loadrvvm1x5si */

    case 74:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21182; /* pred_unit_strided_loadrvvm1x6si */

    case 75:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21183; /* pred_unit_strided_loadrvvm1x7si */

    case 76:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21184; /* pred_unit_strided_loadrvvm1x8si */

    case 77:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21185; /* pred_unit_strided_loadrvvm2x2di */

    case 78:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21186; /* pred_unit_strided_loadrvvm2x3di */

    case 79:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21187; /* pred_unit_strided_loadrvvm2x4di */

    case 80:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21188; /* pred_unit_strided_loadrvvmf2x2bf */

    case 81:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21189; /* pred_unit_strided_loadrvvmf2x3bf */

    case 82:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21190; /* pred_unit_strided_loadrvvmf2x4bf */

    case 83:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21191; /* pred_unit_strided_loadrvvmf2x5bf */

    case 84:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21192; /* pred_unit_strided_loadrvvmf2x6bf */

    case 85:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21193; /* pred_unit_strided_loadrvvmf2x7bf */

    case 86:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21194; /* pred_unit_strided_loadrvvmf2x8bf */

    case 87:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21195; /* pred_unit_strided_loadrvvmf2x2hf */

    case 88:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21196; /* pred_unit_strided_loadrvvmf2x3hf */

    case 89:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21197; /* pred_unit_strided_loadrvvmf2x4hf */

    case 90:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21198; /* pred_unit_strided_loadrvvmf2x5hf */

    case 91:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21199; /* pred_unit_strided_loadrvvmf2x6hf */

    case 92:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21200; /* pred_unit_strided_loadrvvmf2x7hf */

    case 93:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21201; /* pred_unit_strided_loadrvvmf2x8hf */

    case 94:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21202; /* pred_unit_strided_loadrvvm1x2sf */

    case 95:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21203; /* pred_unit_strided_loadrvvm1x3sf */

    case 96:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21204; /* pred_unit_strided_loadrvvm1x4sf */

    case 97:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21205; /* pred_unit_strided_loadrvvm1x5sf */

    case 98:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21206; /* pred_unit_strided_loadrvvm1x6sf */

    case 99:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21207; /* pred_unit_strided_loadrvvm1x7sf */

    case 100:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21208; /* pred_unit_strided_loadrvvm1x8sf */

    case 101:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21209; /* pred_unit_strided_loadrvvm2x2df */

    case 102:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21210; /* pred_unit_strided_loadrvvm2x3df */

    case 103:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21211; /* pred_unit_strided_loadrvvm2x4df */

    case 104:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21212; /* pred_unit_strided_loadrvvmf2x2qi */

    case 105:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21213; /* pred_unit_strided_loadrvvmf2x3qi */

    case 106:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21214; /* pred_unit_strided_loadrvvmf2x4qi */

    case 107:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21215; /* pred_unit_strided_loadrvvmf2x5qi */

    case 108:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21216; /* pred_unit_strided_loadrvvmf2x6qi */

    case 109:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21217; /* pred_unit_strided_loadrvvmf2x7qi */

    case 110:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21218; /* pred_unit_strided_loadrvvmf2x8qi */

    case 111:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21219; /* pred_unit_strided_loadrvvm1x2hi */

    case 112:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21220; /* pred_unit_strided_loadrvvm1x3hi */

    case 113:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21221; /* pred_unit_strided_loadrvvm1x4hi */

    case 114:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21222; /* pred_unit_strided_loadrvvm1x5hi */

    case 115:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21223; /* pred_unit_strided_loadrvvm1x6hi */

    case 116:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21224; /* pred_unit_strided_loadrvvm1x7hi */

    case 117:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21225; /* pred_unit_strided_loadrvvm1x8hi */

    case 118:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21226; /* pred_unit_strided_loadrvvm2x2si */

    case 119:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21227; /* pred_unit_strided_loadrvvm2x3si */

    case 120:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21228; /* pred_unit_strided_loadrvvm2x4si */

    case 121:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21229; /* pred_unit_strided_loadrvvm4x2di */

    case 122:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21230; /* pred_unit_strided_loadrvvm1x2bf */

    case 123:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21231; /* pred_unit_strided_loadrvvm1x3bf */

    case 124:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21232; /* pred_unit_strided_loadrvvm1x4bf */

    case 125:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21233; /* pred_unit_strided_loadrvvm1x5bf */

    case 126:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21234; /* pred_unit_strided_loadrvvm1x6bf */

    case 127:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21235; /* pred_unit_strided_loadrvvm1x7bf */

    case 128:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21236; /* pred_unit_strided_loadrvvm1x8bf */

    case 129:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21237; /* pred_unit_strided_loadrvvm1x2hf */

    case 130:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21238; /* pred_unit_strided_loadrvvm1x3hf */

    case 131:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21239; /* pred_unit_strided_loadrvvm1x4hf */

    case 132:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21240; /* pred_unit_strided_loadrvvm1x5hf */

    case 133:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21241; /* pred_unit_strided_loadrvvm1x6hf */

    case 134:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21242; /* pred_unit_strided_loadrvvm1x7hf */

    case 135:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21243; /* pred_unit_strided_loadrvvm1x8hf */

    case 136:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21244; /* pred_unit_strided_loadrvvm2x2sf */

    case 137:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21245; /* pred_unit_strided_loadrvvm2x3sf */

    case 138:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21246; /* pred_unit_strided_loadrvvm2x4sf */

    case 139:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21247; /* pred_unit_strided_loadrvvm4x2df */

    case 140:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21248; /* pred_unit_strided_loadrvvm1x2qi */

    case 141:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21249; /* pred_unit_strided_loadrvvm1x3qi */

    case 142:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21250; /* pred_unit_strided_loadrvvm1x4qi */

    case 143:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21251; /* pred_unit_strided_loadrvvm1x5qi */

    case 144:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21252; /* pred_unit_strided_loadrvvm1x6qi */

    case 145:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21253; /* pred_unit_strided_loadrvvm1x7qi */

    case 146:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21254; /* pred_unit_strided_loadrvvm1x8qi */

    case 147:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21255; /* pred_unit_strided_loadrvvm2x2hi */

    case 148:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21256; /* pred_unit_strided_loadrvvm2x3hi */

    case 149:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21257; /* pred_unit_strided_loadrvvm2x4hi */

    case 150:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21258; /* pred_unit_strided_loadrvvm4x2si */

    case 151:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21259; /* pred_unit_strided_loadrvvm2x2bf */

    case 152:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21260; /* pred_unit_strided_loadrvvm2x3bf */

    case 153:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21261; /* pred_unit_strided_loadrvvm2x4bf */

    case 154:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21262; /* pred_unit_strided_loadrvvm2x2hf */

    case 155:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21263; /* pred_unit_strided_loadrvvm2x3hf */

    case 156:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21264; /* pred_unit_strided_loadrvvm2x4hf */

    case 157:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21265; /* pred_unit_strided_loadrvvm4x2sf */

    case 158:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21266; /* pred_unit_strided_loadrvvm2x2qi */

    case 159:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21267; /* pred_unit_strided_loadrvvm2x3qi */

    case 160:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21268; /* pred_unit_strided_loadrvvm2x4qi */

    case 161:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21269; /* pred_unit_strided_loadrvvm4x2hi */

    case 162:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21270; /* pred_unit_strided_loadrvvm4x2bf */

    case 163:
      if (!(
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21271; /* pred_unit_strided_loadrvvm4x2hf */

    case 164:
      if (!
#line 8369 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21272; /* pred_unit_strided_loadrvvm4x2qi */

    default:
      return -1;
    }
}

 int
recog_606 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8DImode:
      if (pattern685 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 7793; /* *pred_addrvvm8di_extended_scalar */
      if (!(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10283; /* pred_single_widen_addsrvvm8di_extended_scalar */

    case E_RVVM4DImode:
      if (pattern685 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 7802; /* *pred_addrvvm4di_extended_scalar */
      if (!(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10285; /* pred_single_widen_addsrvvm4di_extended_scalar */

    case E_RVVM2DImode:
      if (pattern685 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 7811; /* *pred_addrvvm2di_extended_scalar */
      if (!(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10287; /* pred_single_widen_addsrvvm2di_extended_scalar */

    case E_RVVM1DImode:
      if (pattern685 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 7820; /* *pred_addrvvm1di_extended_scalar */
      if (!(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10289; /* pred_single_widen_addsrvvm1di_extended_scalar */

    case E_V1DImode:
      if (pattern685 (x2, 
E_V1DImode, 
E_V1BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 7829; /* *pred_addv1di_extended_scalar */
      if (!(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10337; /* pred_single_widen_addsv1di_extended_scalar */

    case E_V2DImode:
      if (pattern685 (x2, 
E_V2DImode, 
E_V2BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 7838; /* *pred_addv2di_extended_scalar */
      if (!(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10339; /* pred_single_widen_addsv2di_extended_scalar */

    case E_V4DImode:
      if (pattern685 (x2, 
E_V4DImode, 
E_V4BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 7847; /* *pred_addv4di_extended_scalar */
      if (!(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10341; /* pred_single_widen_addsv4di_extended_scalar */

    case E_V8DImode:
      if (pattern685 (x2, 
E_V8DImode, 
E_V8BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 7856; /* *pred_addv8di_extended_scalar */
      if (!(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10343; /* pred_single_widen_addsv8di_extended_scalar */

    case E_V16DImode:
      if (pattern685 (x2, 
E_V16DImode, 
E_V16BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 7865; /* *pred_addv16di_extended_scalar */
      if (!(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10345; /* pred_single_widen_addsv16di_extended_scalar */

    case E_V32DImode:
      if (pattern685 (x2, 
E_V32DImode, 
E_V32BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 7874; /* *pred_addv32di_extended_scalar */
      if (!(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10347; /* pred_single_widen_addsv32di_extended_scalar */

    case E_V64DImode:
      if (pattern685 (x2, 
E_V64DImode, 
E_V64BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 7883; /* *pred_addv64di_extended_scalar */
      if (!(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10349; /* pred_single_widen_addsv64di_extended_scalar */

    case E_V128DImode:
      if (pattern685 (x2, 
E_V128DImode, 
E_V128BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 7892; /* *pred_addv128di_extended_scalar */
      if (!(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10351; /* pred_single_widen_addsv128di_extended_scalar */

    case E_V256DImode:
      if (pattern685 (x2, 
E_V256DImode, 
E_V256BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 7901; /* *pred_addv256di_extended_scalar */
      if (!(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10353; /* pred_single_widen_addsv256di_extended_scalar */

    case E_V512DImode:
      if (pattern685 (x2, 
E_V512DImode, 
E_V512BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 7910; /* *pred_addv512di_extended_scalar */
      if (!(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10355; /* pred_single_widen_addsv512di_extended_scalar */

    case E_RVVM8HImode:
      if (pattern685 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10261; /* pred_single_widen_addsrvvm8hi_extended_scalar */

    case E_RVVM4HImode:
      if (pattern685 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10263; /* pred_single_widen_addsrvvm4hi_extended_scalar */

    case E_RVVM2HImode:
      if (pattern685 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10265; /* pred_single_widen_addsrvvm2hi_extended_scalar */

    case E_RVVM1HImode:
      if (pattern685 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10267; /* pred_single_widen_addsrvvm1hi_extended_scalar */

    case E_RVVMF2HImode:
      if (pattern685 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10269; /* pred_single_widen_addsrvvmf2hi_extended_scalar */

    case E_RVVMF4HImode:
      if (pattern685 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 10271; /* pred_single_widen_addsrvvmf4hi_extended_scalar */

    case E_RVVM8SImode:
      if (pattern685 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_HImode, 
E_SImode) != 0
          || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10273; /* pred_single_widen_addsrvvm8si_extended_scalar */

    case E_RVVM4SImode:
      if (pattern685 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_HImode, 
E_SImode) != 0
          || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10275; /* pred_single_widen_addsrvvm4si_extended_scalar */

    case E_RVVM2SImode:
      if (pattern685 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_HImode, 
E_SImode) != 0
          || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10277; /* pred_single_widen_addsrvvm2si_extended_scalar */

    case E_RVVM1SImode:
      if (pattern685 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_HImode, 
E_SImode) != 0
          || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10279; /* pred_single_widen_addsrvvm1si_extended_scalar */

    case E_RVVMF2SImode:
      if (pattern685 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 10281; /* pred_single_widen_addsrvvmf2si_extended_scalar */

    case E_V1HImode:
      if (pattern685 (x2, 
E_V1HImode, 
E_V1BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 10291; /* pred_single_widen_addsv1hi_extended_scalar */

    case E_V2HImode:
      if (pattern685 (x2, 
E_V2HImode, 
E_V2BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 10293; /* pred_single_widen_addsv2hi_extended_scalar */

    case E_V4HImode:
      if (pattern685 (x2, 
E_V4HImode, 
E_V4BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 10295; /* pred_single_widen_addsv4hi_extended_scalar */

    case E_V8HImode:
      if (pattern685 (x2, 
E_V8HImode, 
E_V8BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 10297; /* pred_single_widen_addsv8hi_extended_scalar */

    case E_V16HImode:
      if (pattern685 (x2, 
E_V16HImode, 
E_V16BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 10299; /* pred_single_widen_addsv16hi_extended_scalar */

    case E_V32HImode:
      if (pattern685 (x2, 
E_V32HImode, 
E_V32BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10301; /* pred_single_widen_addsv32hi_extended_scalar */

    case E_V64HImode:
      if (pattern685 (x2, 
E_V64HImode, 
E_V64BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10303; /* pred_single_widen_addsv64hi_extended_scalar */

    case E_V128HImode:
      if (pattern685 (x2, 
E_V128HImode, 
E_V128BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10305; /* pred_single_widen_addsv128hi_extended_scalar */

    case E_V256HImode:
      if (pattern685 (x2, 
E_V256HImode, 
E_V256BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10307; /* pred_single_widen_addsv256hi_extended_scalar */

    case E_V512HImode:
      if (pattern685 (x2, 
E_V512HImode, 
E_V512BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10309; /* pred_single_widen_addsv512hi_extended_scalar */

    case E_V1024HImode:
      if (pattern685 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10311; /* pred_single_widen_addsv1024hi_extended_scalar */

    case E_V2048HImode:
      if (pattern685 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10313; /* pred_single_widen_addsv2048hi_extended_scalar */

    case E_V1SImode:
      if (pattern685 (x2, 
E_V1SImode, 
E_V1BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 10315; /* pred_single_widen_addsv1si_extended_scalar */

    case E_V2SImode:
      if (pattern685 (x2, 
E_V2SImode, 
E_V2BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 10317; /* pred_single_widen_addsv2si_extended_scalar */

    case E_V4SImode:
      if (pattern685 (x2, 
E_V4SImode, 
E_V4BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 10319; /* pred_single_widen_addsv4si_extended_scalar */

    case E_V8SImode:
      if (pattern685 (x2, 
E_V8SImode, 
E_V8BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 10321; /* pred_single_widen_addsv8si_extended_scalar */

    case E_V16SImode:
      if (pattern685 (x2, 
E_V16SImode, 
E_V16BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10323; /* pred_single_widen_addsv16si_extended_scalar */

    case E_V32SImode:
      if (pattern685 (x2, 
E_V32SImode, 
E_V32BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10325; /* pred_single_widen_addsv32si_extended_scalar */

    case E_V64SImode:
      if (pattern685 (x2, 
E_V64SImode, 
E_V64BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10327; /* pred_single_widen_addsv64si_extended_scalar */

    case E_V128SImode:
      if (pattern685 (x2, 
E_V128SImode, 
E_V128BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10329; /* pred_single_widen_addsv128si_extended_scalar */

    case E_V256SImode:
      if (pattern685 (x2, 
E_V256SImode, 
E_V256BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10331; /* pred_single_widen_addsv256si_extended_scalar */

    case E_V512SImode:
      if (pattern685 (x2, 
E_V512SImode, 
E_V512BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10333; /* pred_single_widen_addsv512si_extended_scalar */

    case E_V1024SImode:
      if (pattern685 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10335; /* pred_single_widen_addsv1024si_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_660 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V64SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V64SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V64SImode)
      || !(
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13134; /* *pred_mul_plusv64si_undef */
}

 int
recog_666 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2DImode)
      || !(
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13140; /* *pred_mul_plusv2di_undef */
}

 int
recog_672 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V128DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V128DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V128DImode)
      || !(
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13146; /* *pred_mul_plusv128di_undef */
}

 int
recog_678 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_671 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V64DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13213; /* *pred_maddv64di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13281; /* *pred_maccv64di */
}

 int
recog_684 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_665 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V1DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13207; /* *pred_maddv1di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13275; /* *pred_maccv1di */
}

 int
recog_691 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_658 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V16SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 13200; /* *pred_maddv16si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13268; /* *pred_maccv16si */
}

 int
recog_699 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_650 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V256HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13192; /* *pred_maddv256hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13260; /* *pred_maccv256hi */
}

 int
recog_706 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_643 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V2HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 13185; /* *pred_maddv2hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 13253; /* *pred_maccv2hi */
}

 int
recog_713 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_636 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V128QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return 13178; /* *pred_maddv128qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13246; /* *pred_maccv128qi */
}

 int
recog_720 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13347; /* *pred_maddv16di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13415; /* *pred_maccv16di_scalar */
}

 int
recog_727 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 13340; /* *pred_maddv256si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13408; /* *pred_maccv256si_scalar */
}

 int
recog_734 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13333; /* *pred_maddv2si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13401; /* *pred_maccv2si_scalar */
}

 int
recog_741 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 13326; /* *pred_maddv64hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13394; /* *pred_maccv64hi_scalar */
}

 int
recog_748 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      switch (pattern561 (x2))
        {
        case 0:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9302; /* pred_dual_widen_addurvvm8hi */

        case 1:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9308; /* pred_dual_widen_addurvvm4hi */

        case 2:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9314; /* pred_dual_widen_addurvvm2hi */

        case 3:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9320; /* pred_dual_widen_addurvvm1hi */

        case 4:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9326; /* pred_dual_widen_addurvvmf2hi */

        case 5:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9332; /* pred_dual_widen_addurvvmf4hi */

        case 6:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9338; /* pred_dual_widen_addurvvm8si */

        case 7:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9344; /* pred_dual_widen_addurvvm4si */

        case 8:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9350; /* pred_dual_widen_addurvvm2si */

        case 9:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9356; /* pred_dual_widen_addurvvm1si */

        case 10:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9362; /* pred_dual_widen_addurvvmf2si */

        case 11:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9368; /* pred_dual_widen_addurvvm8di */

        case 12:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9374; /* pred_dual_widen_addurvvm4di */

        case 13:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9380; /* pred_dual_widen_addurvvm2di */

        case 14:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9386; /* pred_dual_widen_addurvvm1di */

        case 15:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9392; /* pred_dual_widen_adduv1hi */

        case 16:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9398; /* pred_dual_widen_adduv2hi */

        case 17:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9404; /* pred_dual_widen_adduv4hi */

        case 18:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9410; /* pred_dual_widen_adduv8hi */

        case 19:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9416; /* pred_dual_widen_adduv16hi */

        case 20:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9422; /* pred_dual_widen_adduv32hi */

        case 21:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9428; /* pred_dual_widen_adduv64hi */

        case 22:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9434; /* pred_dual_widen_adduv128hi */

        case 23:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9440; /* pred_dual_widen_adduv256hi */

        case 24:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9446; /* pred_dual_widen_adduv512hi */

        case 25:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9452; /* pred_dual_widen_adduv1024hi */

        case 26:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9458; /* pred_dual_widen_adduv2048hi */

        case 27:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9464; /* pred_dual_widen_adduv1si */

        case 28:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9470; /* pred_dual_widen_adduv2si */

        case 29:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9476; /* pred_dual_widen_adduv4si */

        case 30:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9482; /* pred_dual_widen_adduv8si */

        case 31:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9488; /* pred_dual_widen_adduv16si */

        case 32:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9494; /* pred_dual_widen_adduv32si */

        case 33:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9500; /* pred_dual_widen_adduv64si */

        case 34:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9506; /* pred_dual_widen_adduv128si */

        case 35:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9512; /* pred_dual_widen_adduv256si */

        case 36:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9518; /* pred_dual_widen_adduv512si */

        case 37:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9524; /* pred_dual_widen_adduv1024si */

        case 38:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9530; /* pred_dual_widen_adduv1di */

        case 39:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9536; /* pred_dual_widen_adduv2di */

        case 40:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9542; /* pred_dual_widen_adduv4di */

        case 41:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9548; /* pred_dual_widen_adduv8di */

        case 42:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9554; /* pred_dual_widen_adduv16di */

        case 43:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9560; /* pred_dual_widen_adduv32di */

        case 44:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9566; /* pred_dual_widen_adduv64di */

        case 45:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9572; /* pred_dual_widen_adduv128di */

        case 46:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9578; /* pred_dual_widen_adduv256di */

        case 47:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9584; /* pred_dual_widen_adduv512di */

        case 48:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9590; /* pred_dual_widen_addurvvm8hi_scalar */

        case 49:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9596; /* pred_dual_widen_addurvvm4hi_scalar */

        case 50:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9602; /* pred_dual_widen_addurvvm2hi_scalar */

        case 51:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9608; /* pred_dual_widen_addurvvm1hi_scalar */

        case 52:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9614; /* pred_dual_widen_addurvvmf2hi_scalar */

        case 53:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9620; /* pred_dual_widen_addurvvmf4hi_scalar */

        case 54:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9626; /* pred_dual_widen_addurvvm8si_scalar */

        case 55:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9632; /* pred_dual_widen_addurvvm4si_scalar */

        case 56:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9638; /* pred_dual_widen_addurvvm2si_scalar */

        case 57:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9644; /* pred_dual_widen_addurvvm1si_scalar */

        case 58:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9650; /* pred_dual_widen_addurvvmf2si_scalar */

        case 59:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9656; /* pred_dual_widen_addurvvm8di_scalar */

        case 60:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9662; /* pred_dual_widen_addurvvm4di_scalar */

        case 61:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9668; /* pred_dual_widen_addurvvm2di_scalar */

        case 62:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9674; /* pred_dual_widen_addurvvm1di_scalar */

        case 63:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9680; /* pred_dual_widen_adduv1hi_scalar */

        case 64:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9686; /* pred_dual_widen_adduv2hi_scalar */

        case 65:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9692; /* pred_dual_widen_adduv4hi_scalar */

        case 66:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9698; /* pred_dual_widen_adduv8hi_scalar */

        case 67:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9704; /* pred_dual_widen_adduv16hi_scalar */

        case 68:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9710; /* pred_dual_widen_adduv32hi_scalar */

        case 69:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9716; /* pred_dual_widen_adduv64hi_scalar */

        case 70:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9722; /* pred_dual_widen_adduv128hi_scalar */

        case 71:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9728; /* pred_dual_widen_adduv256hi_scalar */

        case 72:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9734; /* pred_dual_widen_adduv512hi_scalar */

        case 73:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9740; /* pred_dual_widen_adduv1024hi_scalar */

        case 74:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9746; /* pred_dual_widen_adduv2048hi_scalar */

        case 75:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9752; /* pred_dual_widen_adduv1si_scalar */

        case 76:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9758; /* pred_dual_widen_adduv2si_scalar */

        case 77:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9764; /* pred_dual_widen_adduv4si_scalar */

        case 78:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9770; /* pred_dual_widen_adduv8si_scalar */

        case 79:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9776; /* pred_dual_widen_adduv16si_scalar */

        case 80:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9782; /* pred_dual_widen_adduv32si_scalar */

        case 81:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9788; /* pred_dual_widen_adduv64si_scalar */

        case 82:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9794; /* pred_dual_widen_adduv128si_scalar */

        case 83:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9800; /* pred_dual_widen_adduv256si_scalar */

        case 84:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9806; /* pred_dual_widen_adduv512si_scalar */

        case 85:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9812; /* pred_dual_widen_adduv1024si_scalar */

        case 86:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9818; /* pred_dual_widen_adduv1di_scalar */

        case 87:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9824; /* pred_dual_widen_adduv2di_scalar */

        case 88:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9830; /* pred_dual_widen_adduv4di_scalar */

        case 89:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9836; /* pred_dual_widen_adduv8di_scalar */

        case 90:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9842; /* pred_dual_widen_adduv16di_scalar */

        case 91:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9848; /* pred_dual_widen_adduv32di_scalar */

        case 92:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9854; /* pred_dual_widen_adduv64di_scalar */

        case 93:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9860; /* pred_dual_widen_adduv128di_scalar */

        case 94:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9866; /* pred_dual_widen_adduv256di_scalar */

        case 95:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9872; /* pred_dual_widen_adduv512di_scalar */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern562 (x2))
        {
        case 0:
          if (!
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9974; /* pred_single_widen_addurvvm8hi */

        case 1:
          if (!
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9976; /* pred_single_widen_addurvvm4hi */

        case 2:
          if (!
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9978; /* pred_single_widen_addurvvm2hi */

        case 3:
          if (!
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9980; /* pred_single_widen_addurvvm1hi */

        case 4:
          if (!
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9982; /* pred_single_widen_addurvvmf2hi */

        case 5:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9984; /* pred_single_widen_addurvvmf4hi */

        case 6:
          if (!
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9986; /* pred_single_widen_addurvvm8si */

        case 7:
          if (!
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9988; /* pred_single_widen_addurvvm4si */

        case 8:
          if (!
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9990; /* pred_single_widen_addurvvm2si */

        case 9:
          if (!
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9992; /* pred_single_widen_addurvvm1si */

        case 10:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9994; /* pred_single_widen_addurvvmf2si */

        case 11:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9996; /* pred_single_widen_addurvvm8di */

        case 12:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9998; /* pred_single_widen_addurvvm4di */

        case 13:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10000; /* pred_single_widen_addurvvm2di */

        case 14:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10002; /* pred_single_widen_addurvvm1di */

        case 15:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10004; /* pred_single_widen_adduv1hi */

        case 16:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10006; /* pred_single_widen_adduv2hi */

        case 17:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10008; /* pred_single_widen_adduv4hi */

        case 18:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10010; /* pred_single_widen_adduv8hi */

        case 19:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10012; /* pred_single_widen_adduv16hi */

        case 20:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10014; /* pred_single_widen_adduv32hi */

        case 21:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10016; /* pred_single_widen_adduv64hi */

        case 22:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10018; /* pred_single_widen_adduv128hi */

        case 23:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10020; /* pred_single_widen_adduv256hi */

        case 24:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10022; /* pred_single_widen_adduv512hi */

        case 25:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10024; /* pred_single_widen_adduv1024hi */

        case 26:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10026; /* pred_single_widen_adduv2048hi */

        case 27:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10028; /* pred_single_widen_adduv1si */

        case 28:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10030; /* pred_single_widen_adduv2si */

        case 29:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10032; /* pred_single_widen_adduv4si */

        case 30:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10034; /* pred_single_widen_adduv8si */

        case 31:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10036; /* pred_single_widen_adduv16si */

        case 32:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10038; /* pred_single_widen_adduv32si */

        case 33:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10040; /* pred_single_widen_adduv64si */

        case 34:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10042; /* pred_single_widen_adduv128si */

        case 35:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10044; /* pred_single_widen_adduv256si */

        case 36:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10046; /* pred_single_widen_adduv512si */

        case 37:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10048; /* pred_single_widen_adduv1024si */

        case 38:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10050; /* pred_single_widen_adduv1di */

        case 39:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10052; /* pred_single_widen_adduv2di */

        case 40:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10054; /* pred_single_widen_adduv4di */

        case 41:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10056; /* pred_single_widen_adduv8di */

        case 42:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10058; /* pred_single_widen_adduv16di */

        case 43:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10060; /* pred_single_widen_adduv32di */

        case 44:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10062; /* pred_single_widen_adduv64di */

        case 45:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10064; /* pred_single_widen_adduv128di */

        case 46:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10066; /* pred_single_widen_adduv256di */

        case 47:
          if (!(
#line 4067 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10068; /* pred_single_widen_adduv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern564 (x2))
        {
        case 0:
          if (!
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10550; /* pred_zero_extendrvvm8hi */

        case 1:
          if (!
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10552; /* pred_zero_extendrvvm4hi */

        case 2:
          if (!
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10554; /* pred_zero_extendrvvm2hi */

        case 3:
          if (!
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10556; /* pred_zero_extendrvvm1hi */

        case 4:
          if (!
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10558; /* pred_zero_extendrvvmf2hi */

        case 5:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10560; /* pred_zero_extendrvvmf4hi */

        case 6:
          if (!
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10562; /* pred_zero_extendrvvm8si */

        case 7:
          if (!
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10564; /* pred_zero_extendrvvm4si */

        case 8:
          if (!
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10566; /* pred_zero_extendrvvm2si */

        case 9:
          if (!
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10568; /* pred_zero_extendrvvm1si */

        case 10:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10570; /* pred_zero_extendrvvmf2si */

        case 11:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10572; /* pred_zero_extendrvvm8di */

        case 12:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10574; /* pred_zero_extendrvvm4di */

        case 13:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10576; /* pred_zero_extendrvvm2di */

        case 14:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10578; /* pred_zero_extendrvvm1di */

        case 15:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10580; /* pred_zero_extendv1hi */

        case 16:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10582; /* pred_zero_extendv2hi */

        case 17:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10584; /* pred_zero_extendv4hi */

        case 18:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10586; /* pred_zero_extendv8hi */

        case 19:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10588; /* pred_zero_extendv16hi */

        case 20:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10590; /* pred_zero_extendv32hi */

        case 21:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10592; /* pred_zero_extendv64hi */

        case 22:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10594; /* pred_zero_extendv128hi */

        case 23:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10596; /* pred_zero_extendv256hi */

        case 24:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10598; /* pred_zero_extendv512hi */

        case 25:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10600; /* pred_zero_extendv1024hi */

        case 26:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10602; /* pred_zero_extendv2048hi */

        case 27:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10604; /* pred_zero_extendv1si */

        case 28:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10606; /* pred_zero_extendv2si */

        case 29:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10608; /* pred_zero_extendv4si */

        case 30:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10610; /* pred_zero_extendv8si */

        case 31:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10612; /* pred_zero_extendv16si */

        case 32:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10614; /* pred_zero_extendv32si */

        case 33:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10616; /* pred_zero_extendv64si */

        case 34:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10618; /* pred_zero_extendv128si */

        case 35:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10620; /* pred_zero_extendv256si */

        case 36:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10622; /* pred_zero_extendv512si */

        case 37:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10624; /* pred_zero_extendv1024si */

        case 38:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10626; /* pred_zero_extendv1di */

        case 39:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10628; /* pred_zero_extendv2di */

        case 40:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10630; /* pred_zero_extendv4di */

        case 41:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10632; /* pred_zero_extendv8di */

        case 42:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10634; /* pred_zero_extendv16di */

        case 43:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10636; /* pred_zero_extendv32di */

        case 44:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10638; /* pred_zero_extendv64di */

        case 45:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10640; /* pred_zero_extendv128di */

        case 46:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10642; /* pred_zero_extendv256di */

        case 47:
          if (!(
#line 4203 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10644; /* pred_zero_extendv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_789 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V512QImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return 13480; /* *pred_minus_mulv512qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V512QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V512QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return 13548; /* *pred_nmsubv512qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13616; /* *pred_nmsacv512qi */
}

 int
recog_797 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V2QImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return 13472; /* *pred_minus_mulv2qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return 13540; /* *pred_nmsubv2qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return -1;
  return 13608; /* *pred_nmsacv2qi */
}

 int
recog_805 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13717; /* *pred_nmsubv64di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13785; /* *pred_nmsacv64di_scalar */
}

 int
recog_812 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 13710; /* *pred_nmsubv1024si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13778; /* *pred_nmsacv1024si_scalar */
}

 int
recog_820 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13702; /* *pred_nmsubv4si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 13770; /* *pred_nmsacv4si_scalar */
}

 int
recog_828 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 13694; /* *pred_nmsubv64hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13762; /* *pred_nmsacv64hi_scalar */
}

 int
recog_836 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      return recog_834 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_833 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_835 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      switch (pattern540 (x2))
        {
        case 0:
          if (!
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9878; /* pred_single_widen_suburvvm8hi */

        case 1:
          if (!
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9880; /* pred_single_widen_suburvvm4hi */

        case 2:
          if (!
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9882; /* pred_single_widen_suburvvm2hi */

        case 3:
          if (!
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9884; /* pred_single_widen_suburvvm1hi */

        case 4:
          if (!
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9886; /* pred_single_widen_suburvvmf2hi */

        case 5:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9888; /* pred_single_widen_suburvvmf4hi */

        case 6:
          if (!
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9890; /* pred_single_widen_suburvvm8si */

        case 7:
          if (!
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9892; /* pred_single_widen_suburvvm4si */

        case 8:
          if (!
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9894; /* pred_single_widen_suburvvm2si */

        case 9:
          if (!
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9896; /* pred_single_widen_suburvvm1si */

        case 10:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9898; /* pred_single_widen_suburvvmf2si */

        case 11:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9900; /* pred_single_widen_suburvvm8di */

        case 12:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9902; /* pred_single_widen_suburvvm4di */

        case 13:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9904; /* pred_single_widen_suburvvm2di */

        case 14:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9906; /* pred_single_widen_suburvvm1di */

        case 15:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9908; /* pred_single_widen_subuv1hi */

        case 16:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9910; /* pred_single_widen_subuv2hi */

        case 17:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9912; /* pred_single_widen_subuv4hi */

        case 18:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9914; /* pred_single_widen_subuv8hi */

        case 19:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9916; /* pred_single_widen_subuv16hi */

        case 20:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9918; /* pred_single_widen_subuv32hi */

        case 21:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9920; /* pred_single_widen_subuv64hi */

        case 22:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9922; /* pred_single_widen_subuv128hi */

        case 23:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9924; /* pred_single_widen_subuv256hi */

        case 24:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9926; /* pred_single_widen_subuv512hi */

        case 25:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9928; /* pred_single_widen_subuv1024hi */

        case 26:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9930; /* pred_single_widen_subuv2048hi */

        case 27:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9932; /* pred_single_widen_subuv1si */

        case 28:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9934; /* pred_single_widen_subuv2si */

        case 29:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9936; /* pred_single_widen_subuv4si */

        case 30:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9938; /* pred_single_widen_subuv8si */

        case 31:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9940; /* pred_single_widen_subuv16si */

        case 32:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9942; /* pred_single_widen_subuv32si */

        case 33:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9944; /* pred_single_widen_subuv64si */

        case 34:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9946; /* pred_single_widen_subuv128si */

        case 35:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9948; /* pred_single_widen_subuv256si */

        case 36:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9950; /* pred_single_widen_subuv512si */

        case 37:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9952; /* pred_single_widen_subuv1024si */

        case 38:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9954; /* pred_single_widen_subuv1di */

        case 39:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9956; /* pred_single_widen_subuv2di */

        case 40:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9958; /* pred_single_widen_subuv4di */

        case 41:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9960; /* pred_single_widen_subuv8di */

        case 42:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9962; /* pred_single_widen_subuv16di */

        case 43:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9964; /* pred_single_widen_subuv32di */

        case 44:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9966; /* pred_single_widen_subuv64di */

        case 45:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9968; /* pred_single_widen_subuv128di */

        case 46:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9970; /* pred_single_widen_subuv256di */

        case 47:
          if (!(
#line 4046 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9972; /* pred_single_widen_subuv512di */

        case 48:
          if (!
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10072; /* pred_single_widen_suburvvm8hi_scalar */

        case 49:
          if (!
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10076; /* pred_single_widen_suburvvm4hi_scalar */

        case 50:
          if (!
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10080; /* pred_single_widen_suburvvm2hi_scalar */

        case 51:
          if (!
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10084; /* pred_single_widen_suburvvm1hi_scalar */

        case 52:
          if (!
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10088; /* pred_single_widen_suburvvmf2hi_scalar */

        case 53:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10092; /* pred_single_widen_suburvvmf4hi_scalar */

        case 54:
          if (!
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10096; /* pred_single_widen_suburvvm8si_scalar */

        case 55:
          if (!
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10100; /* pred_single_widen_suburvvm4si_scalar */

        case 56:
          if (!
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10104; /* pred_single_widen_suburvvm2si_scalar */

        case 57:
          if (!
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10108; /* pred_single_widen_suburvvm1si_scalar */

        case 58:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10112; /* pred_single_widen_suburvvmf2si_scalar */

        case 59:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10116; /* pred_single_widen_suburvvm8di_scalar */

        case 60:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10120; /* pred_single_widen_suburvvm4di_scalar */

        case 61:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10124; /* pred_single_widen_suburvvm2di_scalar */

        case 62:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10128; /* pred_single_widen_suburvvm1di_scalar */

        case 63:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10132; /* pred_single_widen_subuv1hi_scalar */

        case 64:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10136; /* pred_single_widen_subuv2hi_scalar */

        case 65:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10140; /* pred_single_widen_subuv4hi_scalar */

        case 66:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10144; /* pred_single_widen_subuv8hi_scalar */

        case 67:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10148; /* pred_single_widen_subuv16hi_scalar */

        case 68:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10152; /* pred_single_widen_subuv32hi_scalar */

        case 69:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10156; /* pred_single_widen_subuv64hi_scalar */

        case 70:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10160; /* pred_single_widen_subuv128hi_scalar */

        case 71:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10164; /* pred_single_widen_subuv256hi_scalar */

        case 72:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10168; /* pred_single_widen_subuv512hi_scalar */

        case 73:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10172; /* pred_single_widen_subuv1024hi_scalar */

        case 74:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10176; /* pred_single_widen_subuv2048hi_scalar */

        case 75:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10180; /* pred_single_widen_subuv1si_scalar */

        case 76:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10184; /* pred_single_widen_subuv2si_scalar */

        case 77:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10188; /* pred_single_widen_subuv4si_scalar */

        case 78:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10192; /* pred_single_widen_subuv8si_scalar */

        case 79:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10196; /* pred_single_widen_subuv16si_scalar */

        case 80:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10200; /* pred_single_widen_subuv32si_scalar */

        case 81:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10204; /* pred_single_widen_subuv64si_scalar */

        case 82:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10208; /* pred_single_widen_subuv128si_scalar */

        case 83:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10212; /* pred_single_widen_subuv256si_scalar */

        case 84:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10216; /* pred_single_widen_subuv512si_scalar */

        case 85:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10220; /* pred_single_widen_subuv1024si_scalar */

        case 86:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10224; /* pred_single_widen_subuv1di_scalar */

        case 87:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10228; /* pred_single_widen_subuv2di_scalar */

        case 88:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10232; /* pred_single_widen_subuv4di_scalar */

        case 89:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10236; /* pred_single_widen_subuv8di_scalar */

        case 90:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10240; /* pred_single_widen_subuv16di_scalar */

        case 91:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10244; /* pred_single_widen_subuv32di_scalar */

        case 92:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10248; /* pred_single_widen_subuv64di_scalar */

        case 93:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10252; /* pred_single_widen_subuv128di_scalar */

        case 94:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10256; /* pred_single_widen_subuv256di_scalar */

        case 95:
          if (!(
#line 4089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10260; /* pred_single_widen_subuv512di_scalar */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          return recog_832 (x1, insn, pnum_clobbers);

        case VEC_DUPLICATE:
          x6 = XEXP (x2, 0);
          x7 = XVECEXP (x6, 0, 1);
          operands[5] = x7;
          x8 = XVECEXP (x6, 0, 2);
          operands[6] = x8;
          x9 = XVECEXP (x6, 0, 3);
          operands[7] = x9;
          x10 = XVECEXP (x6, 0, 4);
          operands[8] = x10;
          x11 = XEXP (x3, 0);
          operands[4] = x11;
          x12 = XEXP (x4, 1);
          operands[3] = x12;
          x13 = XEXP (x5, 0);
          switch (GET_CODE (x13))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
              return recog_831 (x1, insn, pnum_clobbers);

            case SIGN_EXTEND:
              if (GET_MODE (x13) != E_DImode)
                return -1;
              x14 = XEXP (x13, 0);
              operands[2] = x14;
              if (!reg_or_0_operand (operands[2], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_RVVM8DImode:
                  if (pattern727 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return 13789; /* *pred_nmsubrvvm8di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13803; /* *pred_nmsacrvvm8di_extended_scalar */

                case E_RVVM4DImode:
                  if (pattern727 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return 13790; /* *pred_nmsubrvvm4di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13804; /* *pred_nmsacrvvm4di_extended_scalar */

                case E_RVVM2DImode:
                  if (pattern727 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return 13791; /* *pred_nmsubrvvm2di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13805; /* *pred_nmsacrvvm2di_extended_scalar */

                case E_RVVM1DImode:
                  if (pattern727 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return 13792; /* *pred_nmsubrvvm1di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13806; /* *pred_nmsacrvvm1di_extended_scalar */

                case E_V1DImode:
                  if (pattern727 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                    return 13793; /* *pred_nmsubv1di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13807; /* *pred_nmsacv1di_extended_scalar */

                case E_V2DImode:
                  if (pattern727 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                    return 13794; /* *pred_nmsubv2di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13808; /* *pred_nmsacv2di_extended_scalar */

                case E_V4DImode:
                  if (pattern727 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                    return 13795; /* *pred_nmsubv4di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13809; /* *pred_nmsacv4di_extended_scalar */

                case E_V8DImode:
                  if (pattern727 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                    return 13796; /* *pred_nmsubv8di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13810; /* *pred_nmsacv8di_extended_scalar */

                case E_V16DImode:
                  if (pattern727 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                    return 13797; /* *pred_nmsubv16di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13811; /* *pred_nmsacv16di_extended_scalar */

                case E_V32DImode:
                  if (pattern727 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                    return 13798; /* *pred_nmsubv32di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13812; /* *pred_nmsacv32di_extended_scalar */

                case E_V64DImode:
                  if (pattern727 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                    return 13799; /* *pred_nmsubv64di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 13813; /* *pred_nmsacv64di_extended_scalar */

                case E_V128DImode:
                  if (pattern727 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                    return 13800; /* *pred_nmsubv128di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 13814; /* *pred_nmsacv128di_extended_scalar */

                case E_V256DImode:
                  if (pattern727 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                    return 13801; /* *pred_nmsubv256di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 13815; /* *pred_nmsacv256di_extended_scalar */

                case E_V512DImode:
                  if (pattern727 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5805 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                    return 13802; /* *pred_nmsubv512di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5836 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 13816; /* *pred_nmsacv512di_extended_scalar */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_884 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern668 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10886; /* pred_sssubrvvm8qi */

    case E_RVVM4QImode:
      if (pattern668 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10890; /* pred_sssubrvvm4qi */

    case E_RVVM2QImode:
      if (pattern668 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10894; /* pred_sssubrvvm2qi */

    case E_RVVM1QImode:
      if (pattern668 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10898; /* pred_sssubrvvm1qi */

    case E_RVVM8HImode:
      if (pattern668 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10902; /* pred_sssubrvvm8hi */

    case E_RVVM4HImode:
      if (pattern668 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10906; /* pred_sssubrvvm4hi */

    case E_RVVM2HImode:
      if (pattern668 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10910; /* pred_sssubrvvm2hi */

    case E_RVVM1HImode:
      if (pattern668 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10914; /* pred_sssubrvvm1hi */

    case E_RVVM8SImode:
      if (pattern668 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10918; /* pred_sssubrvvm8si */

    case E_RVVM4SImode:
      if (pattern668 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10922; /* pred_sssubrvvm4si */

    case E_RVVM2SImode:
      if (pattern668 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10926; /* pred_sssubrvvm2si */

    case E_RVVM1SImode:
      if (pattern668 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10930; /* pred_sssubrvvm1si */

    case E_RVVM8DImode:
      if (pattern668 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10934; /* pred_sssubrvvm8di */

    case E_RVVM4DImode:
      if (pattern668 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10938; /* pred_sssubrvvm4di */

    case E_RVVM2DImode:
      if (pattern668 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10942; /* pred_sssubrvvm2di */

    case E_RVVM1DImode:
      if (pattern668 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10946; /* pred_sssubrvvm1di */

    case E_RVVMF2QImode:
      if (pattern668 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10950; /* pred_sssubrvvmf2qi */

    case E_RVVMF4QImode:
      if (pattern668 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10954; /* pred_sssubrvvmf4qi */

    case E_RVVMF8QImode:
      if (pattern668 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10958; /* pred_sssubrvvmf8qi */

    case E_RVVMF2HImode:
      if (pattern668 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10962; /* pred_sssubrvvmf2hi */

    case E_RVVMF4HImode:
      if (pattern668 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10966; /* pred_sssubrvvmf4hi */

    case E_RVVMF2SImode:
      if (pattern668 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10970; /* pred_sssubrvvmf2si */

    case E_V1QImode:
      if (pattern668 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 10974; /* pred_sssubv1qi */

    case E_V2QImode:
      if (pattern668 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 10978; /* pred_sssubv2qi */

    case E_V4QImode:
      if (pattern668 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 10982; /* pred_sssubv4qi */

    case E_V8QImode:
      if (pattern668 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 10986; /* pred_sssubv8qi */

    case E_V16QImode:
      if (pattern668 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 10990; /* pred_sssubv16qi */

    case E_V32QImode:
      if (pattern668 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 10994; /* pred_sssubv32qi */

    case E_V64QImode:
      if (pattern668 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10998; /* pred_sssubv64qi */

    case E_V128QImode:
      if (pattern668 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11002; /* pred_sssubv128qi */

    case E_V256QImode:
      if (pattern668 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11006; /* pred_sssubv256qi */

    case E_V512QImode:
      if (pattern668 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11010; /* pred_sssubv512qi */

    case E_V1024QImode:
      if (pattern668 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11014; /* pred_sssubv1024qi */

    case E_V2048QImode:
      if (pattern668 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11018; /* pred_sssubv2048qi */

    case E_V4096QImode:
      if (pattern668 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11022; /* pred_sssubv4096qi */

    case E_V1HImode:
      if (pattern668 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 11026; /* pred_sssubv1hi */

    case E_V2HImode:
      if (pattern668 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 11030; /* pred_sssubv2hi */

    case E_V4HImode:
      if (pattern668 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 11034; /* pred_sssubv4hi */

    case E_V8HImode:
      if (pattern668 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 11038; /* pred_sssubv8hi */

    case E_V16HImode:
      if (pattern668 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 11042; /* pred_sssubv16hi */

    case E_V32HImode:
      if (pattern668 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11046; /* pred_sssubv32hi */

    case E_V64HImode:
      if (pattern668 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11050; /* pred_sssubv64hi */

    case E_V128HImode:
      if (pattern668 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11054; /* pred_sssubv128hi */

    case E_V256HImode:
      if (pattern668 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11058; /* pred_sssubv256hi */

    case E_V512HImode:
      if (pattern668 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11062; /* pred_sssubv512hi */

    case E_V1024HImode:
      if (pattern668 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11066; /* pred_sssubv1024hi */

    case E_V2048HImode:
      if (pattern668 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11070; /* pred_sssubv2048hi */

    case E_V1SImode:
      if (pattern668 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 11074; /* pred_sssubv1si */

    case E_V2SImode:
      if (pattern668 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 11078; /* pred_sssubv2si */

    case E_V4SImode:
      if (pattern668 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 11082; /* pred_sssubv4si */

    case E_V8SImode:
      if (pattern668 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 11086; /* pred_sssubv8si */

    case E_V16SImode:
      if (pattern668 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11090; /* pred_sssubv16si */

    case E_V32SImode:
      if (pattern668 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11094; /* pred_sssubv32si */

    case E_V64SImode:
      if (pattern668 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11098; /* pred_sssubv64si */

    case E_V128SImode:
      if (pattern668 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11102; /* pred_sssubv128si */

    case E_V256SImode:
      if (pattern668 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11106; /* pred_sssubv256si */

    case E_V512SImode:
      if (pattern668 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11110; /* pred_sssubv512si */

    case E_V1024SImode:
      if (pattern668 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11114; /* pred_sssubv1024si */

    case E_V1DImode:
      if (pattern668 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11118; /* pred_sssubv1di */

    case E_V2DImode:
      if (pattern668 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11122; /* pred_sssubv2di */

    case E_V4DImode:
      if (pattern668 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11126; /* pred_sssubv4di */

    case E_V8DImode:
      if (pattern668 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11130; /* pred_sssubv8di */

    case E_V16DImode:
      if (pattern668 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11134; /* pred_sssubv16di */

    case E_V32DImode:
      if (pattern668 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11138; /* pred_sssubv32di */

    case E_V64DImode:
      if (pattern668 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11142; /* pred_sssubv64di */

    case E_V128DImode:
      if (pattern668 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11146; /* pred_sssubv128di */

    case E_V256DImode:
      if (pattern668 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11150; /* pred_sssubv256di */

    case E_V512DImode:
      if (pattern668 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 4318 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11154; /* pred_sssubv512di */

    default:
      return -1;
    }
}

 int
recog_888 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern492 (x2))
    {
    case 0:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5507; /* pred_sminrvvm8qi */

    case 1:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5524; /* pred_sminrvvm4qi */

    case 2:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5541; /* pred_sminrvvm2qi */

    case 3:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5558; /* pred_sminrvvm1qi */

    case 4:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5575; /* pred_sminrvvm8hi */

    case 5:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5592; /* pred_sminrvvm4hi */

    case 6:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5609; /* pred_sminrvvm2hi */

    case 7:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5626; /* pred_sminrvvm1hi */

    case 8:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5643; /* pred_sminrvvm8si */

    case 9:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5660; /* pred_sminrvvm4si */

    case 10:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5677; /* pred_sminrvvm2si */

    case 11:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5694; /* pred_sminrvvm1si */

    case 12:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5711; /* pred_sminrvvm8di */

    case 13:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5728; /* pred_sminrvvm4di */

    case 14:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5745; /* pred_sminrvvm2di */

    case 15:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5762; /* pred_sminrvvm1di */

    case 16:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5779; /* pred_sminrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5796; /* pred_sminrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5813; /* pred_sminrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5830; /* pred_sminrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5847; /* pred_sminrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5864; /* pred_sminrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5881; /* pred_sminv1qi */

    case 23:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5898; /* pred_sminv2qi */

    case 24:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5915; /* pred_sminv4qi */

    case 25:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5932; /* pred_sminv8qi */

    case 26:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5949; /* pred_sminv16qi */

    case 27:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5966; /* pred_sminv32qi */

    case 28:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5983; /* pred_sminv64qi */

    case 29:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6000; /* pred_sminv128qi */

    case 30:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6017; /* pred_sminv256qi */

    case 31:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6034; /* pred_sminv512qi */

    case 32:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6051; /* pred_sminv1024qi */

    case 33:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6068; /* pred_sminv2048qi */

    case 34:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6085; /* pred_sminv4096qi */

    case 35:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6102; /* pred_sminv1hi */

    case 36:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6119; /* pred_sminv2hi */

    case 37:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6136; /* pred_sminv4hi */

    case 38:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6153; /* pred_sminv8hi */

    case 39:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6170; /* pred_sminv16hi */

    case 40:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6187; /* pred_sminv32hi */

    case 41:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6204; /* pred_sminv64hi */

    case 42:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6221; /* pred_sminv128hi */

    case 43:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6238; /* pred_sminv256hi */

    case 44:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6255; /* pred_sminv512hi */

    case 45:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6272; /* pred_sminv1024hi */

    case 46:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6289; /* pred_sminv2048hi */

    case 47:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6306; /* pred_sminv1si */

    case 48:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6323; /* pred_sminv2si */

    case 49:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6340; /* pred_sminv4si */

    case 50:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6357; /* pred_sminv8si */

    case 51:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6374; /* pred_sminv16si */

    case 52:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6391; /* pred_sminv32si */

    case 53:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6408; /* pred_sminv64si */

    case 54:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6425; /* pred_sminv128si */

    case 55:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6442; /* pred_sminv256si */

    case 56:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6459; /* pred_sminv512si */

    case 57:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6476; /* pred_sminv1024si */

    case 58:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6493; /* pred_sminv1di */

    case 59:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6510; /* pred_sminv2di */

    case 60:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6527; /* pred_sminv4di */

    case 61:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6544; /* pred_sminv8di */

    case 62:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6561; /* pred_sminv16di */

    case 63:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6578; /* pred_sminv32di */

    case 64:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6595; /* pred_sminv64di */

    case 65:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6612; /* pred_sminv128di */

    case 66:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6629; /* pred_sminv256di */

    case 67:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6646; /* pred_sminv512di */

    case 68:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14691; /* pred_sminrvvm8hf */

    case 69:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14693; /* pred_sminrvvm4hf */

    case 70:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14695; /* pred_sminrvvm2hf */

    case 71:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14697; /* pred_sminrvvm1hf */

    case 72:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14699; /* pred_sminrvvmf2hf */

    case 73:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14701; /* pred_sminrvvmf4hf */

    case 74:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14703; /* pred_sminrvvm8sf */

    case 75:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14705; /* pred_sminrvvm4sf */

    case 76:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14707; /* pred_sminrvvm2sf */

    case 77:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14709; /* pred_sminrvvm1sf */

    case 78:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14711; /* pred_sminrvvmf2sf */

    case 79:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14713; /* pred_sminrvvm8df */

    case 80:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14715; /* pred_sminrvvm4df */

    case 81:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14717; /* pred_sminrvvm2df */

    case 82:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14719; /* pred_sminrvvm1df */

    case 83:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 14721; /* pred_sminv1hf */

    case 84:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 14723; /* pred_sminv2hf */

    case 85:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 14725; /* pred_sminv4hf */

    case 86:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 14727; /* pred_sminv8hf */

    case 87:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 14729; /* pred_sminv16hf */

    case 88:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14731; /* pred_sminv32hf */

    case 89:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14733; /* pred_sminv64hf */

    case 90:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14735; /* pred_sminv128hf */

    case 91:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14737; /* pred_sminv256hf */

    case 92:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14739; /* pred_sminv512hf */

    case 93:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14741; /* pred_sminv1024hf */

    case 94:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14743; /* pred_sminv2048hf */

    case 95:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14745; /* pred_sminv1sf */

    case 96:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14747; /* pred_sminv2sf */

    case 97:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14749; /* pred_sminv4sf */

    case 98:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14751; /* pred_sminv8sf */

    case 99:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14753; /* pred_sminv16sf */

    case 100:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14755; /* pred_sminv32sf */

    case 101:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14757; /* pred_sminv64sf */

    case 102:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14759; /* pred_sminv128sf */

    case 103:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14761; /* pred_sminv256sf */

    case 104:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14763; /* pred_sminv512sf */

    case 105:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14765; /* pred_sminv1024sf */

    case 106:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14767; /* pred_sminv1df */

    case 107:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14769; /* pred_sminv2df */

    case 108:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14771; /* pred_sminv4df */

    case 109:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14773; /* pred_sminv8df */

    case 110:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14775; /* pred_sminv16df */

    case 111:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14777; /* pred_sminv32df */

    case 112:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14779; /* pred_sminv64df */

    case 113:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14781; /* pred_sminv128df */

    case 114:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14783; /* pred_sminv256df */

    case 115:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14785; /* pred_sminv512df */

    case 116:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6863; /* pred_sminrvvm8qi_scalar */

    case 117:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6872; /* pred_sminrvvm4qi_scalar */

    case 118:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6881; /* pred_sminrvvm2qi_scalar */

    case 119:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6890; /* pred_sminrvvm1qi_scalar */

    case 120:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6899; /* pred_sminrvvmf2qi_scalar */

    case 121:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6908; /* pred_sminrvvmf4qi_scalar */

    case 122:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6917; /* pred_sminrvvmf8qi_scalar */

    case 123:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6926; /* pred_sminrvvm8hi_scalar */

    case 124:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6935; /* pred_sminrvvm4hi_scalar */

    case 125:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6944; /* pred_sminrvvm2hi_scalar */

    case 126:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6953; /* pred_sminrvvm1hi_scalar */

    case 127:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6962; /* pred_sminrvvmf2hi_scalar */

    case 128:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6971; /* pred_sminrvvmf4hi_scalar */

    case 129:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6980; /* pred_sminrvvm8si_scalar */

    case 130:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6989; /* pred_sminrvvm4si_scalar */

    case 131:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6998; /* pred_sminrvvm2si_scalar */

    case 132:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7007; /* pred_sminrvvm1si_scalar */

    case 133:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7016; /* pred_sminrvvmf2si_scalar */

    case 134:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7025; /* pred_sminv1qi_scalar */

    case 135:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7034; /* pred_sminv2qi_scalar */

    case 136:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7043; /* pred_sminv4qi_scalar */

    case 137:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7052; /* pred_sminv8qi_scalar */

    case 138:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7061; /* pred_sminv16qi_scalar */

    case 139:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7070; /* pred_sminv32qi_scalar */

    case 140:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7079; /* pred_sminv64qi_scalar */

    case 141:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7088; /* pred_sminv128qi_scalar */

    case 142:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7097; /* pred_sminv256qi_scalar */

    case 143:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7106; /* pred_sminv512qi_scalar */

    case 144:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7115; /* pred_sminv1024qi_scalar */

    case 145:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7124; /* pred_sminv2048qi_scalar */

    case 146:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7133; /* pred_sminv4096qi_scalar */

    case 147:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7142; /* pred_sminv1hi_scalar */

    case 148:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7151; /* pred_sminv2hi_scalar */

    case 149:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7160; /* pred_sminv4hi_scalar */

    case 150:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7169; /* pred_sminv8hi_scalar */

    case 151:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7178; /* pred_sminv16hi_scalar */

    case 152:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7187; /* pred_sminv32hi_scalar */

    case 153:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7196; /* pred_sminv64hi_scalar */

    case 154:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7205; /* pred_sminv128hi_scalar */

    case 155:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7214; /* pred_sminv256hi_scalar */

    case 156:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7223; /* pred_sminv512hi_scalar */

    case 157:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7232; /* pred_sminv1024hi_scalar */

    case 158:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7241; /* pred_sminv2048hi_scalar */

    case 159:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7250; /* pred_sminv1si_scalar */

    case 160:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7259; /* pred_sminv2si_scalar */

    case 161:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7268; /* pred_sminv4si_scalar */

    case 162:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7277; /* pred_sminv8si_scalar */

    case 163:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7286; /* pred_sminv16si_scalar */

    case 164:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7295; /* pred_sminv32si_scalar */

    case 165:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7304; /* pred_sminv64si_scalar */

    case 166:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7313; /* pred_sminv128si_scalar */

    case 167:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7322; /* pred_sminv256si_scalar */

    case 168:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7331; /* pred_sminv512si_scalar */

    case 169:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7340; /* pred_sminv1024si_scalar */

    case 170:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7673; /* *pred_sminrvvm8di_scalar */

    case 171:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7682; /* *pred_sminrvvm4di_scalar */

    case 172:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7691; /* *pred_sminrvvm2di_scalar */

    case 173:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7700; /* *pred_sminrvvm1di_scalar */

    case 174:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7709; /* *pred_sminv1di_scalar */

    case 175:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7718; /* *pred_sminv2di_scalar */

    case 176:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7727; /* *pred_sminv4di_scalar */

    case 177:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7736; /* *pred_sminv8di_scalar */

    case 178:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7745; /* *pred_sminv16di_scalar */

    case 179:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7754; /* *pred_sminv32di_scalar */

    case 180:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7763; /* *pred_sminv64di_scalar */

    case 181:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7772; /* *pred_sminv128di_scalar */

    case 182:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7781; /* *pred_sminv256di_scalar */

    case 183:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7790; /* *pred_sminv512di_scalar */

    case 184:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14913; /* pred_sminrvvm8hf_scalar */

    case 185:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14915; /* pred_sminrvvm4hf_scalar */

    case 186:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14917; /* pred_sminrvvm2hf_scalar */

    case 187:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14919; /* pred_sminrvvm1hf_scalar */

    case 188:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14921; /* pred_sminrvvmf2hf_scalar */

    case 189:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14923; /* pred_sminrvvmf4hf_scalar */

    case 190:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14925; /* pred_sminrvvm8sf_scalar */

    case 191:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14927; /* pred_sminrvvm4sf_scalar */

    case 192:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14929; /* pred_sminrvvm2sf_scalar */

    case 193:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14931; /* pred_sminrvvm1sf_scalar */

    case 194:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14933; /* pred_sminrvvmf2sf_scalar */

    case 195:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14935; /* pred_sminrvvm8df_scalar */

    case 196:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14937; /* pred_sminrvvm4df_scalar */

    case 197:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14939; /* pred_sminrvvm2df_scalar */

    case 198:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14941; /* pred_sminrvvm1df_scalar */

    case 199:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7799; /* *pred_sminrvvm8di_extended_scalar */

    case 200:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7808; /* *pred_sminrvvm4di_extended_scalar */

    case 201:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7817; /* *pred_sminrvvm2di_extended_scalar */

    case 202:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7826; /* *pred_sminrvvm1di_extended_scalar */

    case 203:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7835; /* *pred_sminv1di_extended_scalar */

    case 204:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7844; /* *pred_sminv2di_extended_scalar */

    case 205:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7853; /* *pred_sminv4di_extended_scalar */

    case 206:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7862; /* *pred_sminv8di_extended_scalar */

    case 207:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7871; /* *pred_sminv16di_extended_scalar */

    case 208:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7880; /* *pred_sminv32di_extended_scalar */

    case 209:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7889; /* *pred_sminv64di_extended_scalar */

    case 210:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7898; /* *pred_sminv128di_extended_scalar */

    case 211:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7907; /* *pred_sminv256di_extended_scalar */

    case 212:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7916; /* *pred_sminv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_901 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern494 (x2))
    {
    case 0:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5508; /* pred_uminrvvm8qi */

    case 1:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5525; /* pred_uminrvvm4qi */

    case 2:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5542; /* pred_uminrvvm2qi */

    case 3:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5559; /* pred_uminrvvm1qi */

    case 4:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5576; /* pred_uminrvvm8hi */

    case 5:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5593; /* pred_uminrvvm4hi */

    case 6:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5610; /* pred_uminrvvm2hi */

    case 7:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5627; /* pred_uminrvvm1hi */

    case 8:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5644; /* pred_uminrvvm8si */

    case 9:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5661; /* pred_uminrvvm4si */

    case 10:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5678; /* pred_uminrvvm2si */

    case 11:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5695; /* pred_uminrvvm1si */

    case 12:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5712; /* pred_uminrvvm8di */

    case 13:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5729; /* pred_uminrvvm4di */

    case 14:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5746; /* pred_uminrvvm2di */

    case 15:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5763; /* pred_uminrvvm1di */

    case 16:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5780; /* pred_uminrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5797; /* pred_uminrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5814; /* pred_uminrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5831; /* pred_uminrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5848; /* pred_uminrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5865; /* pred_uminrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5882; /* pred_uminv1qi */

    case 23:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5899; /* pred_uminv2qi */

    case 24:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5916; /* pred_uminv4qi */

    case 25:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5933; /* pred_uminv8qi */

    case 26:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5950; /* pred_uminv16qi */

    case 27:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5967; /* pred_uminv32qi */

    case 28:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5984; /* pred_uminv64qi */

    case 29:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6001; /* pred_uminv128qi */

    case 30:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6018; /* pred_uminv256qi */

    case 31:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6035; /* pred_uminv512qi */

    case 32:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6052; /* pred_uminv1024qi */

    case 33:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6069; /* pred_uminv2048qi */

    case 34:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6086; /* pred_uminv4096qi */

    case 35:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6103; /* pred_uminv1hi */

    case 36:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6120; /* pred_uminv2hi */

    case 37:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6137; /* pred_uminv4hi */

    case 38:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6154; /* pred_uminv8hi */

    case 39:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6171; /* pred_uminv16hi */

    case 40:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6188; /* pred_uminv32hi */

    case 41:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6205; /* pred_uminv64hi */

    case 42:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6222; /* pred_uminv128hi */

    case 43:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6239; /* pred_uminv256hi */

    case 44:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6256; /* pred_uminv512hi */

    case 45:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6273; /* pred_uminv1024hi */

    case 46:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6290; /* pred_uminv2048hi */

    case 47:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6307; /* pred_uminv1si */

    case 48:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6324; /* pred_uminv2si */

    case 49:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6341; /* pred_uminv4si */

    case 50:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6358; /* pred_uminv8si */

    case 51:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6375; /* pred_uminv16si */

    case 52:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6392; /* pred_uminv32si */

    case 53:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6409; /* pred_uminv64si */

    case 54:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6426; /* pred_uminv128si */

    case 55:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6443; /* pred_uminv256si */

    case 56:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6460; /* pred_uminv512si */

    case 57:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6477; /* pred_uminv1024si */

    case 58:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6494; /* pred_uminv1di */

    case 59:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6511; /* pred_uminv2di */

    case 60:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6528; /* pred_uminv4di */

    case 61:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6545; /* pred_uminv8di */

    case 62:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6562; /* pred_uminv16di */

    case 63:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6579; /* pred_uminv32di */

    case 64:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6596; /* pred_uminv64di */

    case 65:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6613; /* pred_uminv128di */

    case 66:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6630; /* pred_uminv256di */

    case 67:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6647; /* pred_uminv512di */

    case 68:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6864; /* pred_uminrvvm8qi_scalar */

    case 69:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6873; /* pred_uminrvvm4qi_scalar */

    case 70:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6882; /* pred_uminrvvm2qi_scalar */

    case 71:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6891; /* pred_uminrvvm1qi_scalar */

    case 72:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6900; /* pred_uminrvvmf2qi_scalar */

    case 73:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6909; /* pred_uminrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6918; /* pred_uminrvvmf8qi_scalar */

    case 75:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6927; /* pred_uminrvvm8hi_scalar */

    case 76:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6936; /* pred_uminrvvm4hi_scalar */

    case 77:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6945; /* pred_uminrvvm2hi_scalar */

    case 78:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6954; /* pred_uminrvvm1hi_scalar */

    case 79:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6963; /* pred_uminrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6972; /* pred_uminrvvmf4hi_scalar */

    case 81:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6981; /* pred_uminrvvm8si_scalar */

    case 82:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6990; /* pred_uminrvvm4si_scalar */

    case 83:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6999; /* pred_uminrvvm2si_scalar */

    case 84:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7008; /* pred_uminrvvm1si_scalar */

    case 85:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7017; /* pred_uminrvvmf2si_scalar */

    case 86:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7026; /* pred_uminv1qi_scalar */

    case 87:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7035; /* pred_uminv2qi_scalar */

    case 88:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7044; /* pred_uminv4qi_scalar */

    case 89:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7053; /* pred_uminv8qi_scalar */

    case 90:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7062; /* pred_uminv16qi_scalar */

    case 91:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7071; /* pred_uminv32qi_scalar */

    case 92:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7080; /* pred_uminv64qi_scalar */

    case 93:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7089; /* pred_uminv128qi_scalar */

    case 94:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7098; /* pred_uminv256qi_scalar */

    case 95:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7107; /* pred_uminv512qi_scalar */

    case 96:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7116; /* pred_uminv1024qi_scalar */

    case 97:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7125; /* pred_uminv2048qi_scalar */

    case 98:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7134; /* pred_uminv4096qi_scalar */

    case 99:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7143; /* pred_uminv1hi_scalar */

    case 100:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7152; /* pred_uminv2hi_scalar */

    case 101:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7161; /* pred_uminv4hi_scalar */

    case 102:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7170; /* pred_uminv8hi_scalar */

    case 103:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7179; /* pred_uminv16hi_scalar */

    case 104:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7188; /* pred_uminv32hi_scalar */

    case 105:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7197; /* pred_uminv64hi_scalar */

    case 106:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7206; /* pred_uminv128hi_scalar */

    case 107:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7215; /* pred_uminv256hi_scalar */

    case 108:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7224; /* pred_uminv512hi_scalar */

    case 109:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7233; /* pred_uminv1024hi_scalar */

    case 110:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7242; /* pred_uminv2048hi_scalar */

    case 111:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7251; /* pred_uminv1si_scalar */

    case 112:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7260; /* pred_uminv2si_scalar */

    case 113:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7269; /* pred_uminv4si_scalar */

    case 114:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7278; /* pred_uminv8si_scalar */

    case 115:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7287; /* pred_uminv16si_scalar */

    case 116:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7296; /* pred_uminv32si_scalar */

    case 117:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7305; /* pred_uminv64si_scalar */

    case 118:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7314; /* pred_uminv128si_scalar */

    case 119:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7323; /* pred_uminv256si_scalar */

    case 120:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7332; /* pred_uminv512si_scalar */

    case 121:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7341; /* pred_uminv1024si_scalar */

    case 122:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7674; /* *pred_uminrvvm8di_scalar */

    case 123:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7683; /* *pred_uminrvvm4di_scalar */

    case 124:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7692; /* *pred_uminrvvm2di_scalar */

    case 125:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7701; /* *pred_uminrvvm1di_scalar */

    case 126:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7710; /* *pred_uminv1di_scalar */

    case 127:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7719; /* *pred_uminv2di_scalar */

    case 128:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7728; /* *pred_uminv4di_scalar */

    case 129:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7737; /* *pred_uminv8di_scalar */

    case 130:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7746; /* *pred_uminv16di_scalar */

    case 131:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7755; /* *pred_uminv32di_scalar */

    case 132:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7764; /* *pred_uminv64di_scalar */

    case 133:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7773; /* *pred_uminv128di_scalar */

    case 134:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7782; /* *pred_uminv256di_scalar */

    case 135:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7791; /* *pred_uminv512di_scalar */

    case 136:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7800; /* *pred_uminrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7809; /* *pred_uminrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7818; /* *pred_uminrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7827; /* *pred_uminrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7836; /* *pred_uminv1di_extended_scalar */

    case 141:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7845; /* *pred_uminv2di_extended_scalar */

    case 142:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7854; /* *pred_uminv4di_extended_scalar */

    case 143:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7863; /* *pred_uminv8di_extended_scalar */

    case 144:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7872; /* *pred_uminv16di_extended_scalar */

    case 145:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7881; /* *pred_uminv32di_extended_scalar */

    case 146:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7890; /* *pred_uminv64di_extended_scalar */

    case 147:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7899; /* *pred_uminv128di_extended_scalar */

    case 148:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7908; /* *pred_uminv256di_extended_scalar */

    case 149:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7917; /* *pred_uminv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_911 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern502 (x2))
    {
    case 0:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17376; /* pred_fixuns_truncrvvm8hf */

    case 1:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17378; /* pred_fixuns_truncrvvm4hf */

    case 2:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17922; /* pred_narrow_fixuns_truncrvvm8sf */

    case 3:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17380; /* pred_fixuns_truncrvvm2hf */

    case 4:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17924; /* pred_narrow_fixuns_truncrvvm4sf */

    case 5:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17382; /* pred_fixuns_truncrvvm1hf */

    case 6:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17926; /* pred_narrow_fixuns_truncrvvm2sf */

    case 7:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17384; /* pred_fixuns_truncrvvmf2hf */

    case 8:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17928; /* pred_narrow_fixuns_truncrvvm1sf */

    case 9:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17386; /* pred_fixuns_truncrvvmf4hf */

    case 10:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17930; /* pred_narrow_fixuns_truncrvvmf2sf */

    case 11:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17388; /* pred_fixuns_truncrvvm8sf */

    case 12:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17628; /* pred_widen_fixuns_truncrvvm8si */

    case 13:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17390; /* pred_fixuns_truncrvvm4sf */

    case 14:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17630; /* pred_widen_fixuns_truncrvvm4si */

    case 15:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17932; /* pred_narrow_fixuns_truncrvvm8df */

    case 16:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17392; /* pred_fixuns_truncrvvm2sf */

    case 17:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17632; /* pred_widen_fixuns_truncrvvm2si */

    case 18:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17934; /* pred_narrow_fixuns_truncrvvm4df */

    case 19:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17394; /* pred_fixuns_truncrvvm1sf */

    case 20:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17634; /* pred_widen_fixuns_truncrvvm1si */

    case 21:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17936; /* pred_narrow_fixuns_truncrvvm2df */

    case 22:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17396; /* pred_fixuns_truncrvvmf2sf */

    case 23:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17636; /* pred_widen_fixuns_truncrvvmf2si */

    case 24:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17938; /* pred_narrow_fixuns_truncrvvm1df */

    case 25:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17398; /* pred_fixuns_truncrvvm8df */

    case 26:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17638; /* pred_widen_fixuns_truncrvvm8di */

    case 27:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17400; /* pred_fixuns_truncrvvm4df */

    case 28:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17640; /* pred_widen_fixuns_truncrvvm4di */

    case 29:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17402; /* pred_fixuns_truncrvvm2df */

    case 30:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17642; /* pred_widen_fixuns_truncrvvm2di */

    case 31:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17404; /* pred_fixuns_truncrvvm1df */

    case 32:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17644; /* pred_widen_fixuns_truncrvvm1di */

    case 33:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17406; /* pred_fixuns_truncv1hf */

    case 34:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17964; /* pred_narrow_fixuns_truncv1sf */

    case 35:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17408; /* pred_fixuns_truncv2hf */

    case 36:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17966; /* pred_narrow_fixuns_truncv2sf */

    case 37:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17410; /* pred_fixuns_truncv4hf */

    case 38:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17968; /* pred_narrow_fixuns_truncv4sf */

    case 39:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17412; /* pred_fixuns_truncv8hf */

    case 40:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17970; /* pred_narrow_fixuns_truncv8sf */

    case 41:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17414; /* pred_fixuns_truncv16hf */

    case 42:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17972; /* pred_narrow_fixuns_truncv16sf */

    case 43:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17416; /* pred_fixuns_truncv32hf */

    case 44:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17974; /* pred_narrow_fixuns_truncv32sf */

    case 45:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17418; /* pred_fixuns_truncv64hf */

    case 46:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17976; /* pred_narrow_fixuns_truncv64sf */

    case 47:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17420; /* pred_fixuns_truncv128hf */

    case 48:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17978; /* pred_narrow_fixuns_truncv128sf */

    case 49:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17422; /* pred_fixuns_truncv256hf */

    case 50:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17980; /* pred_narrow_fixuns_truncv256sf */

    case 51:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17424; /* pred_fixuns_truncv512hf */

    case 52:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17982; /* pred_narrow_fixuns_truncv512sf */

    case 53:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17426; /* pred_fixuns_truncv1024hf */

    case 54:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17984; /* pred_narrow_fixuns_truncv1024sf */

    case 55:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17428; /* pred_fixuns_truncv2048hf */

    case 56:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17430; /* pred_fixuns_truncv1sf */

    case 57:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 17646; /* pred_widen_fixuns_truncv1si */

    case 58:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17986; /* pred_narrow_fixuns_truncv1df */

    case 59:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17432; /* pred_fixuns_truncv2sf */

    case 60:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 17648; /* pred_widen_fixuns_truncv2si */

    case 61:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17988; /* pred_narrow_fixuns_truncv2df */

    case 62:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17434; /* pred_fixuns_truncv4sf */

    case 63:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 17650; /* pred_widen_fixuns_truncv4si */

    case 64:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17990; /* pred_narrow_fixuns_truncv4df */

    case 65:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17436; /* pred_fixuns_truncv8sf */

    case 66:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 17652; /* pred_widen_fixuns_truncv8si */

    case 67:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17992; /* pred_narrow_fixuns_truncv8df */

    case 68:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17438; /* pred_fixuns_truncv16sf */

    case 69:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17654; /* pred_widen_fixuns_truncv16si */

    case 70:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17994; /* pred_narrow_fixuns_truncv16df */

    case 71:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17440; /* pred_fixuns_truncv32sf */

    case 72:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17656; /* pred_widen_fixuns_truncv32si */

    case 73:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17996; /* pred_narrow_fixuns_truncv32df */

    case 74:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17442; /* pred_fixuns_truncv64sf */

    case 75:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17658; /* pred_widen_fixuns_truncv64si */

    case 76:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17998; /* pred_narrow_fixuns_truncv64df */

    case 77:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17444; /* pred_fixuns_truncv128sf */

    case 78:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1071 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17660; /* pred_widen_fixuns_truncv128si */

    case 79:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 18000; /* pred_narrow_fixuns_truncv128df */

    case 80:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17446; /* pred_fixuns_truncv256sf */

    case 81:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1072 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17662; /* pred_widen_fixuns_truncv256si */

    case 82:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 18002; /* pred_narrow_fixuns_truncv256df */

    case 83:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17448; /* pred_fixuns_truncv512sf */

    case 84:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1073 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17664; /* pred_widen_fixuns_truncv512si */

    case 85:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 18004; /* pred_narrow_fixuns_truncv512df */

    case 86:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17450; /* pred_fixuns_truncv1024sf */

    case 87:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1074 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17666; /* pred_widen_fixuns_truncv1024si */

    case 88:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17452; /* pred_fixuns_truncv1df */

    case 89:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1075 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17668; /* pred_widen_fixuns_truncv1di */

    case 90:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17454; /* pred_fixuns_truncv2df */

    case 91:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1076 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17670; /* pred_widen_fixuns_truncv2di */

    case 92:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17456; /* pred_fixuns_truncv4df */

    case 93:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1077 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17672; /* pred_widen_fixuns_truncv4di */

    case 94:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17458; /* pred_fixuns_truncv8df */

    case 95:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1078 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17674; /* pred_widen_fixuns_truncv8di */

    case 96:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17460; /* pred_fixuns_truncv16df */

    case 97:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1079 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17676; /* pred_widen_fixuns_truncv16di */

    case 98:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17462; /* pred_fixuns_truncv32df */

    case 99:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1080 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17678; /* pred_widen_fixuns_truncv32di */

    case 100:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17464; /* pred_fixuns_truncv64df */

    case 101:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1081 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17680; /* pred_widen_fixuns_truncv64di */

    case 102:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17466; /* pred_fixuns_truncv128df */

    case 103:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1082 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17682; /* pred_widen_fixuns_truncv128di */

    case 104:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17468; /* pred_fixuns_truncv256df */

    case 105:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1083 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17684; /* pred_widen_fixuns_truncv256di */

    case 106:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17470; /* pred_fixuns_truncv512df */

    case 107:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1084 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17686; /* pred_widen_fixuns_truncv512di */

    case 108:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17910; /* pred_narrow_fixuns_truncrvvm8hf */

    case 109:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17912; /* pred_narrow_fixuns_truncrvvm4hf */

    case 110:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17914; /* pred_narrow_fixuns_truncrvvm2hf */

    case 111:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17916; /* pred_narrow_fixuns_truncrvvm1hf */

    case 112:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17918; /* pred_narrow_fixuns_truncrvvmf2hf */

    case 113:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17920; /* pred_narrow_fixuns_truncrvvmf4hf */

    case 114:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17940; /* pred_narrow_fixuns_truncv1hf */

    case 115:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17942; /* pred_narrow_fixuns_truncv2hf */

    case 116:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17944; /* pred_narrow_fixuns_truncv4hf */

    case 117:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17946; /* pred_narrow_fixuns_truncv8hf */

    case 118:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17948; /* pred_narrow_fixuns_truncv16hf */

    case 119:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17950; /* pred_narrow_fixuns_truncv32hf */

    case 120:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17952; /* pred_narrow_fixuns_truncv64hf */

    case 121:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17954; /* pred_narrow_fixuns_truncv128hf */

    case 122:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17956; /* pred_narrow_fixuns_truncv256hf */

    case 123:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17958; /* pred_narrow_fixuns_truncv512hf */

    case 124:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17960; /* pred_narrow_fixuns_truncv1024hf */

    case 125:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17962; /* pred_narrow_fixuns_truncv2048hf */

    default:
      return -1;
    }
}

 int
recog_928 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern473 (x2, 
187))
    {
    case 0:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2214; /* pred_indexed_load_widthhurvvm8qi */

    case 1:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2220; /* pred_indexed_load_widthhurvvm4qi */

    case 2:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2226; /* pred_indexed_load_widthhurvvm2qi */

    case 3:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2232; /* pred_indexed_load_widthhurvvm1qi */

    case 4:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2238; /* pred_indexed_load_widthhurvvm8hi */

    case 5:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2244; /* pred_indexed_load_widthhurvvm4hi */

    case 6:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2250; /* pred_indexed_load_widthhurvvm2hi */

    case 7:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2256; /* pred_indexed_load_widthhurvvm1hi */

    case 8:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2262; /* pred_indexed_load_widthhurvvm8si */

    case 9:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2268; /* pred_indexed_load_widthhurvvm4si */

    case 10:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2274; /* pred_indexed_load_widthhurvvm2si */

    case 11:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2280; /* pred_indexed_load_widthhurvvm1si */

    case 12:
      if (!(
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2286; /* pred_indexed_load_widthhurvvm8di */

    case 13:
      if (!(
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2292; /* pred_indexed_load_widthhurvvm4di */

    case 14:
      if (!(
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2298; /* pred_indexed_load_widthhurvvm2di */

    case 15:
      if (!(
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2304; /* pred_indexed_load_widthhurvvm1di */

    case 16:
      if (!(
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2310; /* pred_indexed_load_widthhurvvmf8qi */

    case 17:
      if (!(
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2316; /* pred_indexed_load_widthhurvvmf4hi */

    case 18:
      if (!(
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2322; /* pred_indexed_load_widthhurvvmf2si */

    default:
      return -1;
    }
}

 int
recog_931 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern717 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11407; /* pred_asuburvvm8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11883; /* pred_asuburvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11414; /* pred_asuburvvm4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11888; /* pred_asuburvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11421; /* pred_asuburvvm2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11893; /* pred_asuburvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11428; /* pred_asuburvvm1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11898; /* pred_asuburvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11435; /* pred_asuburvvm8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11918; /* pred_asuburvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11442; /* pred_asuburvvm4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11923; /* pred_asuburvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11449; /* pred_asuburvvm2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11928; /* pred_asuburvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11456; /* pred_asuburvvm1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11933; /* pred_asuburvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11463; /* pred_asuburvvm8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11948; /* pred_asuburvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11470; /* pred_asuburvvm4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11953; /* pred_asuburvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11477; /* pred_asuburvvm2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11958; /* pred_asuburvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11484; /* pred_asuburvvm1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11963; /* pred_asuburvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11491; /* pred_asuburvvm8di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4646 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12197; /* *pred_asuburvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11498; /* pred_asuburvvm4di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4646 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12202; /* *pred_asuburvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11505; /* pred_asuburvvm2di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4646 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12207; /* *pred_asuburvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11512; /* pred_asuburvvm1di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4646 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12212; /* *pred_asuburvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11519; /* pred_asuburvvmf2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11903; /* pred_asuburvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11526; /* pred_asuburvvmf4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11908; /* pred_asuburvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11533; /* pred_asuburvvmf8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11913; /* pred_asuburvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11540; /* pred_asuburvvmf2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11938; /* pred_asuburvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11547; /* pred_asuburvvmf4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11943; /* pred_asuburvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11554; /* pred_asuburvvmf2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11968; /* pred_asuburvvmf2si_scalar */

    case 22:
      if (register_operand (operands[4], E_V1QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 11561; /* pred_asubuv1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11973; /* pred_asubuv1qi_scalar */

    case 23:
      if (register_operand (operands[4], E_V2QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 11568; /* pred_asubuv2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11978; /* pred_asubuv2qi_scalar */

    case 24:
      if (register_operand (operands[4], E_V4QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 11575; /* pred_asubuv4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11983; /* pred_asubuv4qi_scalar */

    case 25:
      if (register_operand (operands[4], E_V8QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 11582; /* pred_asubuv8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11988; /* pred_asubuv8qi_scalar */

    case 26:
      if (register_operand (operands[4], E_V16QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 11589; /* pred_asubuv16qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11993; /* pred_asubuv16qi_scalar */

    case 27:
      if (register_operand (operands[4], E_V32QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 11596; /* pred_asubuv32qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 11998; /* pred_asubuv32qi_scalar */

    case 28:
      if (register_operand (operands[4], E_V64QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 11603; /* pred_asubuv64qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12003; /* pred_asubuv64qi_scalar */

    case 29:
      if (register_operand (operands[4], E_V128QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 11610; /* pred_asubuv128qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12008; /* pred_asubuv128qi_scalar */

    case 30:
      if (register_operand (operands[4], E_V256QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 11617; /* pred_asubuv256qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12013; /* pred_asubuv256qi_scalar */

    case 31:
      if (register_operand (operands[4], E_V512QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 11624; /* pred_asubuv512qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12018; /* pred_asubuv512qi_scalar */

    case 32:
      if (register_operand (operands[4], E_V1024QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 11631; /* pred_asubuv1024qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12023; /* pred_asubuv1024qi_scalar */

    case 33:
      if (register_operand (operands[4], E_V2048QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 11638; /* pred_asubuv2048qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12028; /* pred_asubuv2048qi_scalar */

    case 34:
      if (register_operand (operands[4], E_V4096QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 11645; /* pred_asubuv4096qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12033; /* pred_asubuv4096qi_scalar */

    case 35:
      if (register_operand (operands[4], E_V1HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 11652; /* pred_asubuv1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12038; /* pred_asubuv1hi_scalar */

    case 36:
      if (register_operand (operands[4], E_V2HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 11659; /* pred_asubuv2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12043; /* pred_asubuv2hi_scalar */

    case 37:
      if (register_operand (operands[4], E_V4HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 11666; /* pred_asubuv4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12048; /* pred_asubuv4hi_scalar */

    case 38:
      if (register_operand (operands[4], E_V8HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 11673; /* pred_asubuv8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12053; /* pred_asubuv8hi_scalar */

    case 39:
      if (register_operand (operands[4], E_V16HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 11680; /* pred_asubuv16hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12058; /* pred_asubuv16hi_scalar */

    case 40:
      if (register_operand (operands[4], E_V32HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 11687; /* pred_asubuv32hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12063; /* pred_asubuv32hi_scalar */

    case 41:
      if (register_operand (operands[4], E_V64HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 11694; /* pred_asubuv64hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12068; /* pred_asubuv64hi_scalar */

    case 42:
      if (register_operand (operands[4], E_V128HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 11701; /* pred_asubuv128hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12073; /* pred_asubuv128hi_scalar */

    case 43:
      if (register_operand (operands[4], E_V256HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 11708; /* pred_asubuv256hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12078; /* pred_asubuv256hi_scalar */

    case 44:
      if (register_operand (operands[4], E_V512HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 11715; /* pred_asubuv512hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12083; /* pred_asubuv512hi_scalar */

    case 45:
      if (register_operand (operands[4], E_V1024HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 11722; /* pred_asubuv1024hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12088; /* pred_asubuv1024hi_scalar */

    case 46:
      if (register_operand (operands[4], E_V2048HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 11729; /* pred_asubuv2048hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12093; /* pred_asubuv2048hi_scalar */

    case 47:
      if (register_operand (operands[4], E_V1SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 11736; /* pred_asubuv1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12098; /* pred_asubuv1si_scalar */

    case 48:
      if (register_operand (operands[4], E_V2SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 11743; /* pred_asubuv2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12103; /* pred_asubuv2si_scalar */

    case 49:
      if (register_operand (operands[4], E_V4SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 11750; /* pred_asubuv4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12108; /* pred_asubuv4si_scalar */

    case 50:
      if (register_operand (operands[4], E_V8SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 11757; /* pred_asubuv8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12113; /* pred_asubuv8si_scalar */

    case 51:
      if (register_operand (operands[4], E_V16SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 11764; /* pred_asubuv16si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12118; /* pred_asubuv16si_scalar */

    case 52:
      if (register_operand (operands[4], E_V32SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 11771; /* pred_asubuv32si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12123; /* pred_asubuv32si_scalar */

    case 53:
      if (register_operand (operands[4], E_V64SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 11778; /* pred_asubuv64si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12128; /* pred_asubuv64si_scalar */

    case 54:
      if (register_operand (operands[4], E_V128SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 11785; /* pred_asubuv128si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12133; /* pred_asubuv128si_scalar */

    case 55:
      if (register_operand (operands[4], E_V256SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 11792; /* pred_asubuv256si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12138; /* pred_asubuv256si_scalar */

    case 56:
      if (register_operand (operands[4], E_V512SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 11799; /* pred_asubuv512si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12143; /* pred_asubuv512si_scalar */

    case 57:
      if (register_operand (operands[4], E_V1024SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 11806; /* pred_asubuv1024si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12148; /* pred_asubuv1024si_scalar */

    case 58:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11813; /* pred_asubuv1di */

    case 59:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11820; /* pred_asubuv2di */

    case 60:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11827; /* pred_asubuv4di */

    case 61:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11834; /* pred_asubuv8di */

    case 62:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11841; /* pred_asubuv16di */

    case 63:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11848; /* pred_asubuv32di */

    case 64:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11855; /* pred_asubuv64di */

    case 65:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11862; /* pred_asubuv128di */

    case 66:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11869; /* pred_asubuv256di */

    case 67:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11876; /* pred_asubuv512di */

    case 68:
      if (!(
#line 4669 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12217; /* *pred_asuburvvm8di_extended_scalar */

    case 69:
      if (!(
#line 4669 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12222; /* *pred_asuburvvm4di_extended_scalar */

    case 70:
      if (!(
#line 4669 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12227; /* *pred_asuburvvm2di_extended_scalar */

    case 71:
      if (!(
#line 4669 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12232; /* *pred_asuburvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_938 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4HFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15256; /* *pred_mul_addrvvm4hf_undef */
}

 int
recog_941 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVMF2HFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15262; /* *pred_mul_addrvvmf2hf_undef */
}

 int
recog_946 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1SFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15272; /* *pred_mul_addrvvm1sf_undef */
}

 int
recog_951 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1DFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15282; /* *pred_mul_addrvvm1df_undef */
}

 int
recog_956 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16HFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15292; /* *pred_mul_addv16hf_undef */
}

 int
recog_961 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512HFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15302; /* *pred_mul_addv512hf_undef */
}

 int
recog_966 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V4SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V4SFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15312; /* *pred_mul_addv4sf_undef */
}

 int
recog_971 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V128SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V128SFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15322; /* *pred_mul_addv128sf_undef */
}

 int
recog_976 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2DFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15332; /* *pred_mul_addv2df_undef */
}

 int
recog_981 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64DFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15342; /* *pred_mul_addv64df_undef */
}

 int
recog_986 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern726 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[3], E_HFmode)
          || !register_operand (operands[4], E_RVVMF2HFmode)
          || !(
#line 7195 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16769; /* pred_widen_mul_addrvvm1sf_scalar */

    case E_RVVMF2BFmode:
      if (!register_operand (operands[3], E_BFmode)
          || !register_operand (operands[4], E_RVVMF2BFmode)
          || !(
#line 130 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 24 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 33654; /* pred_widen_bf16_mul_rvvm1sf_scalar */

    default:
      return -1;
    }
}

 int
recog_991 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern726 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[3], E_RVVMF2HFmode)
          || !register_operand (operands[4], E_RVVMF2HFmode)
          || !(
#line 7166 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16709; /* pred_widen_mul_addrvvm1sf */

    case E_RVVMF2BFmode:
      if (!register_operand (operands[3], E_RVVMF2BFmode)
          || !register_operand (operands[4], E_RVVMF2BFmode)
          || !(
#line 101 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 24 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 33649; /* pred_widen_bf16_mul_rvvm1sf */

    default:
      return -1;
    }
}

 int
recog_996 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_983 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return 15442; /* *pred_maddv256df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15538; /* *pred_maccv256df */
}

 int
recog_1001 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_978 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 15432; /* *pred_maddv8df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15528; /* *pred_maccv8df */
}

 int
recog_1006 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_973 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 15422; /* *pred_maddv512sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15518; /* *pred_maccv512sf */
}

 int
recog_1011 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_968 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 15412; /* *pred_maddv16sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15508; /* *pred_maccv16sf */
}

 int
recog_1016 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_963 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2048HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return 15402; /* *pred_maddv2048hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15498; /* *pred_maccv2048hf */
}

 int
recog_1021 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_958 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return 15392; /* *pred_maddv64hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15488; /* *pred_maccv64hf */
}

 int
recog_1026 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_953 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return 15382; /* *pred_maddv2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15478; /* *pred_maccv2hf */
}

 int
recog_1032 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_947 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return 15370; /* *pred_maddrvvmf2sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15466; /* *pred_maccrvvmf2sf */
}

 int
recog_1038 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_941 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15358; /* *pred_maddrvvmf2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15454; /* *pred_maccrvvmf2hf */
}

 int
recog_1045 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2HFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15738; /* *pred_mul_neg_addrvvm2hf_undef */
}

 int
recog_1053 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF2SFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15754; /* *pred_mul_neg_addrvvmf2sf_undef */
}

 int
recog_1061 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8HFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15770; /* *pred_mul_neg_addv8hf_undef */
}

 int
recog_1070 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1SFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15788; /* *pred_mul_neg_addv1sf_undef */
}

 int
recog_1080 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1024SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1024SFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15808; /* *pred_mul_neg_addv1024sf_undef */
}

 int
recog_1090 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512DFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15828; /* *pred_mul_neg_addv512df_undef */
}

 int
recog_1100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1081 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15906; /* *pred_nmsubv1df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 16002; /* *pred_nmsacv1df */
}

 int
recog_1110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1071 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15886; /* *pred_nmsubv2sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15982; /* *pred_nmsacv2sf */
}

 int
recog_1120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1061 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return 15866; /* *pred_nmsubv8hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15962; /* *pred_nmsacv8hf */
}

 int
recog_1130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1051 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM2SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15846; /* *pred_nmsubrvvm2sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15942; /* *pred_nmsacrvvm2sf */
}

 int
recog_1140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern583 (x2))
    {
    case 0:
      return recog_1138 (x1, insn, pnum_clobbers);

    case 1:
      return recog_1137 (x1, insn, pnum_clobbers);

    case 2:
      return recog_1136 (x1, insn, pnum_clobbers);

    case 3:
      return recog_1135 (x1, insn, pnum_clobbers);

    case 4:
      return recog_1134 (x1, insn, pnum_clobbers);

    case 5:
      return recog_1133 (x1, insn, pnum_clobbers);

    case 6:
      return recog_1132 (x1, insn, pnum_clobbers);

    case 7:
      return recog_1131 (x1, insn, pnum_clobbers);

    case 8:
      return recog_1130 (x1, insn, pnum_clobbers);

    case 9:
      return recog_1129 (x1, insn, pnum_clobbers);

    case 10:
      return recog_1128 (x1, insn, pnum_clobbers);

    case 11:
      return recog_1127 (x1, insn, pnum_clobbers);

    case 12:
      return recog_1126 (x1, insn, pnum_clobbers);

    case 13:
      return recog_1125 (x1, insn, pnum_clobbers);

    case 14:
      return recog_1124 (x1, insn, pnum_clobbers);

    case 15:
      return recog_1123 (x1, insn, pnum_clobbers);

    case 16:
      return recog_1122 (x1, insn, pnum_clobbers);

    case 17:
      return recog_1121 (x1, insn, pnum_clobbers);

    case 18:
      return recog_1120 (x1, insn, pnum_clobbers);

    case 19:
      return recog_1119 (x1, insn, pnum_clobbers);

    case 20:
      return recog_1118 (x1, insn, pnum_clobbers);

    case 21:
      return recog_1117 (x1, insn, pnum_clobbers);

    case 22:
      return recog_1116 (x1, insn, pnum_clobbers);

    case 23:
      return recog_1115 (x1, insn, pnum_clobbers);

    case 24:
      return recog_1114 (x1, insn, pnum_clobbers);

    case 25:
      return recog_1113 (x1, insn, pnum_clobbers);

    case 26:
      return recog_1112 (x1, insn, pnum_clobbers);

    case 27:
      return recog_1111 (x1, insn, pnum_clobbers);

    case 28:
      return recog_1110 (x1, insn, pnum_clobbers);

    case 29:
      return recog_1109 (x1, insn, pnum_clobbers);

    case 30:
      return recog_1108 (x1, insn, pnum_clobbers);

    case 31:
      return recog_1107 (x1, insn, pnum_clobbers);

    case 32:
      return recog_1106 (x1, insn, pnum_clobbers);

    case 33:
      return recog_1105 (x1, insn, pnum_clobbers);

    case 34:
      return recog_1104 (x1, insn, pnum_clobbers);

    case 35:
      return recog_1103 (x1, insn, pnum_clobbers);

    case 36:
      return recog_1102 (x1, insn, pnum_clobbers);

    case 37:
      return recog_1101 (x1, insn, pnum_clobbers);

    case 38:
      return recog_1100 (x1, insn, pnum_clobbers);

    case 39:
      return recog_1099 (x1, insn, pnum_clobbers);

    case 40:
      return recog_1098 (x1, insn, pnum_clobbers);

    case 41:
      return recog_1097 (x1, insn, pnum_clobbers);

    case 42:
      return recog_1096 (x1, insn, pnum_clobbers);

    case 43:
      return recog_1095 (x1, insn, pnum_clobbers);

    case 44:
      return recog_1094 (x1, insn, pnum_clobbers);

    case 45:
      return recog_1093 (x1, insn, pnum_clobbers);

    case 46:
      return recog_1092 (x1, insn, pnum_clobbers);

    case 47:
      return recog_1091 (x1, insn, pnum_clobbers);

    case 48:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16022; /* *pred_nmsubrvvm8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16118; /* *pred_nmsacrvvm8hf_scalar */

    case 49:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16024; /* *pred_nmsubrvvm4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16120; /* *pred_nmsacrvvm4hf_scalar */

    case 50:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16026; /* *pred_nmsubrvvm2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16122; /* *pred_nmsacrvvm2hf_scalar */

    case 51:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16028; /* *pred_nmsubrvvm1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16124; /* *pred_nmsacrvvm1hf_scalar */

    case 52:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16030; /* *pred_nmsubrvvmf2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16126; /* *pred_nmsacrvvmf2hf_scalar */

    case 53:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return 16032; /* *pred_nmsubrvvmf4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16128; /* *pred_nmsacrvvmf4hf_scalar */

    case 54:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16034; /* *pred_nmsubrvvm8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16130; /* *pred_nmsacrvvm8sf_scalar */

    case 55:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16036; /* *pred_nmsubrvvm4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16132; /* *pred_nmsacrvvm4sf_scalar */

    case 56:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16038; /* *pred_nmsubrvvm2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16134; /* *pred_nmsacrvvm2sf_scalar */

    case 57:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16040; /* *pred_nmsubrvvm1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16136; /* *pred_nmsacrvvm1sf_scalar */

    case 58:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return 16042; /* *pred_nmsubrvvmf2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16138; /* *pred_nmsacrvvmf2sf_scalar */

    case 59:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16044; /* *pred_nmsubrvvm8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16140; /* *pred_nmsacrvvm8df_scalar */

    case 60:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16046; /* *pred_nmsubrvvm4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16142; /* *pred_nmsacrvvm4df_scalar */

    case 61:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16048; /* *pred_nmsubrvvm2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16144; /* *pred_nmsacrvvm2df_scalar */

    case 62:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16050; /* *pred_nmsubrvvm1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16146; /* *pred_nmsacrvvm1df_scalar */

    case 63:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return 16052; /* *pred_nmsubv1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 16148; /* *pred_nmsacv1hf_scalar */

    case 64:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return 16054; /* *pred_nmsubv2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 16150; /* *pred_nmsacv2hf_scalar */

    case 65:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return 16056; /* *pred_nmsubv4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 16152; /* *pred_nmsacv4hf_scalar */

    case 66:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 16058; /* *pred_nmsubv8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 16154; /* *pred_nmsacv8hf_scalar */

    case 67:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 16060; /* *pred_nmsubv16hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 16156; /* *pred_nmsacv16hf_scalar */

    case 68:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 16062; /* *pred_nmsubv32hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16158; /* *pred_nmsacv32hf_scalar */

    case 69:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return 16064; /* *pred_nmsubv64hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16160; /* *pred_nmsacv64hf_scalar */

    case 70:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return 16066; /* *pred_nmsubv128hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16162; /* *pred_nmsacv128hf_scalar */

    case 71:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return 16068; /* *pred_nmsubv256hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16164; /* *pred_nmsacv256hf_scalar */

    case 72:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 16070; /* *pred_nmsubv512hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16166; /* *pred_nmsacv512hf_scalar */

    case 73:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return 16072; /* *pred_nmsubv1024hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16168; /* *pred_nmsacv1024hf_scalar */

    case 74:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 16074; /* *pred_nmsubv2048hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16170; /* *pred_nmsacv2048hf_scalar */

    case 75:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16076; /* *pred_nmsubv1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16172; /* *pred_nmsacv1sf_scalar */

    case 76:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16078; /* *pred_nmsubv2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16174; /* *pred_nmsacv2sf_scalar */

    case 77:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16080; /* *pred_nmsubv4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16176; /* *pred_nmsacv4sf_scalar */

    case 78:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16082; /* *pred_nmsubv8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16178; /* *pred_nmsacv8sf_scalar */

    case 79:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return 16084; /* *pred_nmsubv16sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16180; /* *pred_nmsacv16sf_scalar */

    case 80:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return 16086; /* *pred_nmsubv32sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16182; /* *pred_nmsacv32sf_scalar */

    case 81:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return 16088; /* *pred_nmsubv64sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16184; /* *pred_nmsacv64sf_scalar */

    case 82:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return 16090; /* *pred_nmsubv128sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16186; /* *pred_nmsacv128sf_scalar */

    case 83:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return 16092; /* *pred_nmsubv256sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16188; /* *pred_nmsacv256sf_scalar */

    case 84:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 16094; /* *pred_nmsubv512sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16190; /* *pred_nmsacv512sf_scalar */

    case 85:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return 16096; /* *pred_nmsubv1024sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16192; /* *pred_nmsacv1024sf_scalar */

    case 86:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16098; /* *pred_nmsubv1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16194; /* *pred_nmsacv1df_scalar */

    case 87:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16100; /* *pred_nmsubv2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16196; /* *pred_nmsacv2df_scalar */

    case 88:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16102; /* *pred_nmsubv4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16198; /* *pred_nmsacv4df_scalar */

    case 89:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return 16104; /* *pred_nmsubv8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16200; /* *pred_nmsacv8df_scalar */

    case 90:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return 16106; /* *pred_nmsubv16df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16202; /* *pred_nmsacv16df_scalar */

    case 91:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return 16108; /* *pred_nmsubv32df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16204; /* *pred_nmsacv32df_scalar */

    case 92:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return 16110; /* *pred_nmsubv64df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16206; /* *pred_nmsacv64df_scalar */

    case 93:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return 16112; /* *pred_nmsubv128df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16208; /* *pred_nmsacv128df_scalar */

    case 94:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return 16114; /* *pred_nmsubv256df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16210; /* *pred_nmsacv256df_scalar */

    case 95:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 16116; /* *pred_nmsubv512df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16212; /* *pred_nmsacv512df_scalar */

    case 96:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16823; /* pred_widen_mul_neg_addrvvm8sf */

    case 97:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16825; /* pred_widen_mul_neg_addrvvm4sf */

    case 98:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16827; /* pred_widen_mul_neg_addrvvm2sf */

    case 99:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16829; /* pred_widen_mul_neg_addrvvm1sf */

    case 100:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16831; /* pred_widen_mul_neg_addrvvmf2sf */

    case 101:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16833; /* pred_widen_mul_neg_addrvvm8df */

    case 102:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16835; /* pred_widen_mul_neg_addrvvm4df */

    case 103:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16837; /* pred_widen_mul_neg_addrvvm2df */

    case 104:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16839; /* pred_widen_mul_neg_addrvvm1df */

    case 105:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16841; /* pred_widen_mul_neg_addv1sf */

    case 106:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16843; /* pred_widen_mul_neg_addv2sf */

    case 107:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16845; /* pred_widen_mul_neg_addv4sf */

    case 108:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16847; /* pred_widen_mul_neg_addv8sf */

    case 109:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16849; /* pred_widen_mul_neg_addv16sf */

    case 110:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16851; /* pred_widen_mul_neg_addv32sf */

    case 111:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16853; /* pred_widen_mul_neg_addv64sf */

    case 112:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16855; /* pred_widen_mul_neg_addv128sf */

    case 113:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16857; /* pred_widen_mul_neg_addv256sf */

    case 114:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16859; /* pred_widen_mul_neg_addv512sf */

    case 115:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16861; /* pred_widen_mul_neg_addv1024sf */

    case 116:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16863; /* pred_widen_mul_neg_addv1df */

    case 117:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16865; /* pred_widen_mul_neg_addv2df */

    case 118:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16867; /* pred_widen_mul_neg_addv4df */

    case 119:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16869; /* pred_widen_mul_neg_addv8df */

    case 120:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16871; /* pred_widen_mul_neg_addv16df */

    case 121:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16873; /* pred_widen_mul_neg_addv32df */

    case 122:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16875; /* pred_widen_mul_neg_addv64df */

    case 123:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16877; /* pred_widen_mul_neg_addv128df */

    case 124:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16879; /* pred_widen_mul_neg_addv256df */

    case 125:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16881; /* pred_widen_mul_neg_addv512df */

    case 126:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16883; /* pred_widen_mul_neg_addrvvm8sf_scalar */

    case 127:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16885; /* pred_widen_mul_neg_addrvvm4sf_scalar */

    case 128:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16887; /* pred_widen_mul_neg_addrvvm2sf_scalar */

    case 129:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16889; /* pred_widen_mul_neg_addrvvm1sf_scalar */

    case 130:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16891; /* pred_widen_mul_neg_addrvvmf2sf_scalar */

    case 131:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16893; /* pred_widen_mul_neg_addrvvm8df_scalar */

    case 132:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16895; /* pred_widen_mul_neg_addrvvm4df_scalar */

    case 133:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16897; /* pred_widen_mul_neg_addrvvm2df_scalar */

    case 134:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16899; /* pred_widen_mul_neg_addrvvm1df_scalar */

    case 135:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16901; /* pred_widen_mul_neg_addv1sf_scalar */

    case 136:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16903; /* pred_widen_mul_neg_addv2sf_scalar */

    case 137:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16905; /* pred_widen_mul_neg_addv4sf_scalar */

    case 138:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16907; /* pred_widen_mul_neg_addv8sf_scalar */

    case 139:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16909; /* pred_widen_mul_neg_addv16sf_scalar */

    case 140:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16911; /* pred_widen_mul_neg_addv32sf_scalar */

    case 141:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16913; /* pred_widen_mul_neg_addv64sf_scalar */

    case 142:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16915; /* pred_widen_mul_neg_addv128sf_scalar */

    case 143:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16917; /* pred_widen_mul_neg_addv256sf_scalar */

    case 144:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16919; /* pred_widen_mul_neg_addv512sf_scalar */

    case 145:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16921; /* pred_widen_mul_neg_addv1024sf_scalar */

    case 146:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16923; /* pred_widen_mul_neg_addv1df_scalar */

    case 147:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16925; /* pred_widen_mul_neg_addv2df_scalar */

    case 148:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16927; /* pred_widen_mul_neg_addv4df_scalar */

    case 149:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16929; /* pred_widen_mul_neg_addv8df_scalar */

    case 150:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16931; /* pred_widen_mul_neg_addv16df_scalar */

    case 151:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16933; /* pred_widen_mul_neg_addv32df_scalar */

    case 152:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16935; /* pred_widen_mul_neg_addv64df_scalar */

    case 153:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16937; /* pred_widen_mul_neg_addv128df_scalar */

    case 154:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16939; /* pred_widen_mul_neg_addv256df_scalar */

    case 155:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16941; /* pred_widen_mul_neg_addv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_1342 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern571 (x2))
    {
    case 0:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17471; /* pred_floatrvvm8hf */

    case 1:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17473; /* pred_floatrvvm4hf */

    case 2:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18005; /* pred_narrow_floatrvvm8si */

    case 3:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17475; /* pred_floatrvvm2hf */

    case 4:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18007; /* pred_narrow_floatrvvm4si */

    case 5:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17477; /* pred_floatrvvm1hf */

    case 6:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18009; /* pred_narrow_floatrvvm2si */

    case 7:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17479; /* pred_floatrvvmf2hf */

    case 8:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18011; /* pred_narrow_floatrvvm1si */

    case 9:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17481; /* pred_floatrvvmf4hf */

    case 10:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18013; /* pred_narrow_floatrvvmf2si */

    case 11:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17483; /* pred_floatrvvm8sf */

    case 12:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17485; /* pred_floatrvvm4sf */

    case 13:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18015; /* pred_narrow_floatrvvm8di */

    case 14:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17487; /* pred_floatrvvm2sf */

    case 15:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18017; /* pred_narrow_floatrvvm4di */

    case 16:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17489; /* pred_floatrvvm1sf */

    case 17:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18019; /* pred_narrow_floatrvvm2di */

    case 18:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17491; /* pred_floatrvvmf2sf */

    case 19:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18021; /* pred_narrow_floatrvvm1di */

    case 20:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17493; /* pred_floatrvvm8df */

    case 21:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17495; /* pred_floatrvvm4df */

    case 22:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17497; /* pred_floatrvvm2df */

    case 23:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17499; /* pred_floatrvvm1df */

    case 24:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17501; /* pred_floatv1hf */

    case 25:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 18023; /* pred_narrow_floatv1si */

    case 26:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17503; /* pred_floatv2hf */

    case 27:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 18025; /* pred_narrow_floatv2si */

    case 28:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17505; /* pred_floatv4hf */

    case 29:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 18027; /* pred_narrow_floatv4si */

    case 30:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17507; /* pred_floatv8hf */

    case 31:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 18029; /* pred_narrow_floatv8si */

    case 32:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17509; /* pred_floatv16hf */

    case 33:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 18031; /* pred_narrow_floatv16si */

    case 34:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17511; /* pred_floatv32hf */

    case 35:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 18033; /* pred_narrow_floatv32si */

    case 36:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17513; /* pred_floatv64hf */

    case 37:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 18035; /* pred_narrow_floatv64si */

    case 38:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17515; /* pred_floatv128hf */

    case 39:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1071 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 18037; /* pred_narrow_floatv128si */

    case 40:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17517; /* pred_floatv256hf */

    case 41:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1072 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 18039; /* pred_narrow_floatv256si */

    case 42:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17519; /* pred_floatv512hf */

    case 43:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1073 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 18041; /* pred_narrow_floatv512si */

    case 44:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17521; /* pred_floatv1024hf */

    case 45:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1074 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 18043; /* pred_narrow_floatv1024si */

    case 46:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17523; /* pred_floatv2048hf */

    case 47:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17525; /* pred_floatv1sf */

    case 48:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1075 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18045; /* pred_narrow_floatv1di */

    case 49:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17527; /* pred_floatv2sf */

    case 50:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1076 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18047; /* pred_narrow_floatv2di */

    case 51:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17529; /* pred_floatv4sf */

    case 52:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1077 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18049; /* pred_narrow_floatv4di */

    case 53:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17531; /* pred_floatv8sf */

    case 54:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1078 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 18051; /* pred_narrow_floatv8di */

    case 55:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17533; /* pred_floatv16sf */

    case 56:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1079 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 18053; /* pred_narrow_floatv16di */

    case 57:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17535; /* pred_floatv32sf */

    case 58:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1080 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 18055; /* pred_narrow_floatv32di */

    case 59:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17537; /* pred_floatv64sf */

    case 60:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1081 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 18057; /* pred_narrow_floatv64di */

    case 61:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17539; /* pred_floatv128sf */

    case 62:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1082 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 18059; /* pred_narrow_floatv128di */

    case 63:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17541; /* pred_floatv256sf */

    case 64:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1083 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 18061; /* pred_narrow_floatv256di */

    case 65:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17543; /* pred_floatv512sf */

    case 66:
      if (!(
#line 7688 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1084 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 18063; /* pred_narrow_floatv512di */

    case 67:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17545; /* pred_floatv1024sf */

    case 68:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17547; /* pred_floatv1df */

    case 69:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17549; /* pred_floatv2df */

    case 70:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17551; /* pred_floatv4df */

    case 71:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17553; /* pred_floatv8df */

    case 72:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17555; /* pred_floatv16df */

    case 73:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17557; /* pred_floatv32df */

    case 74:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17559; /* pred_floatv64df */

    case 75:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17561; /* pred_floatv128df */

    case 76:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17563; /* pred_floatv256df */

    case 77:
      if (!(
#line 7528 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17565; /* pred_floatv512df */

    default:
      return -1;
    }
}

 int
recog_1351 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V1QImode:
      if (!register_operand (operands[3], E_V1QImode)
          || !vector_arith_operand (operands[4], E_V1QImode)
          || !(
#line 4759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 12449; /* *pred_cmpv1qi_merge_tie_mask */

    case E_V1HImode:
      if (!register_operand (operands[3], E_V1HImode)
          || !vector_arith_operand (operands[4], E_V1HImode)
          || !(
#line 4759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12462; /* *pred_cmpv1hi_merge_tie_mask */

    case E_V1SImode:
      if (!register_operand (operands[3], E_V1SImode)
          || !vector_arith_operand (operands[4], E_V1SImode)
          || !(
#line 4759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12474; /* *pred_cmpv1si_merge_tie_mask */

    case E_V1DImode:
      if (!register_operand (operands[3], E_V1DImode)
          || !vector_arith_operand (operands[4], E_V1DImode)
          || !(
#line 4759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12485; /* *pred_cmpv1di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1355 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode)
          || !vector_arith_operand (operands[4], E_V16QImode)
          || !(
#line 4759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 12453; /* *pred_cmpv16qi_merge_tie_mask */

    case E_V16HImode:
      if (!register_operand (operands[3], E_V16HImode)
          || !vector_arith_operand (operands[4], E_V16HImode)
          || !(
#line 4759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12466; /* *pred_cmpv16hi_merge_tie_mask */

    case E_V16SImode:
      if (!register_operand (operands[3], E_V16SImode)
          || !vector_arith_operand (operands[4], E_V16SImode)
          || !(
#line 4759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12478; /* *pred_cmpv16si_merge_tie_mask */

    case E_V16DImode:
      if (!register_operand (operands[3], E_V16DImode)
          || !vector_arith_operand (operands[4], E_V16DImode)
          || !(
#line 4759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12489; /* *pred_cmpv16di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1361 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V1024QImode:
      if (!register_operand (operands[3], E_V1024QImode)
          || !vector_arith_operand (operands[4], E_V1024QImode)
          || !(
#line 4759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12459; /* *pred_cmpv1024qi_merge_tie_mask */

    case E_V1024HImode:
      if (!register_operand (operands[3], E_V1024HImode)
          || !vector_arith_operand (operands[4], E_V1024HImode)
          || !(
#line 4759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12472; /* *pred_cmpv1024hi_merge_tie_mask */

    case E_V1024SImode:
      if (!register_operand (operands[3], E_V1024SImode)
          || !vector_arith_operand (operands[4], E_V1024SImode)
          || !(
#line 4759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12484; /* *pred_cmpv1024si_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1368 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern531 (x2, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V16BImode))
    {
      res = recog_1355 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16QImode:
      if (!register_operand (operands[4], E_V16QImode)
          || !vector_arith_operand (operands[5], E_V16QImode))
        return -1;
      if ((
#line 4783 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16QImode)) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 12521; /* *pred_cmpv16qi */
      if (!(
#line 4804 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16QImode)) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 12589; /* *pred_cmpv16qi_narrow */

    case E_V16HImode:
      if (!register_operand (operands[4], E_V16HImode)
          || !vector_arith_operand (operands[5], E_V16HImode))
        return -1;
      if ((
#line 4783 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16HImode)) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 12534; /* *pred_cmpv16hi */
      if (!(
#line 4804 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16HImode)) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12602; /* *pred_cmpv16hi_narrow */

    case E_V16SImode:
      if (!register_operand (operands[4], E_V16SImode)
          || !vector_arith_operand (operands[5], E_V16SImode))
        return -1;
      if ((
#line 4783 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16SImode)) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 12546; /* *pred_cmpv16si */
      if (!(
#line 4804 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16SImode)) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12614; /* *pred_cmpv16si_narrow */

    case E_V16DImode:
      if (!register_operand (operands[4], E_V16DImode)
          || !vector_arith_operand (operands[5], E_V16DImode))
        return -1;
      if ((
#line 4783 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16DImode)) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 12557; /* *pred_cmpv16di */
      if (!(
#line 4804 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16DImode)) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12625; /* *pred_cmpv16di_narrow */

    default:
      return -1;
    }
}

 int
recog_1375 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1HImode:
      if (!register_operand (operands[3], E_RVVM1HImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM1HImode)
          || !
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12638; /* *pred_ltgervvm1hi_merge_tie_mask */

    case E_RVVM2SImode:
      if (!register_operand (operands[3], E_RVVM2SImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM2SImode)
          || !
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12641; /* *pred_ltgervvm2si_merge_tie_mask */

    case E_RVVM4DImode:
      if (!register_operand (operands[3], E_RVVM4DImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM4DImode)
          || !(
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12644; /* *pred_ltgervvm4di_merge_tie_mask */

    case E_RVVMF2QImode:
      if (!register_operand (operands[3], E_RVVMF2QImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF2QImode)
          || !(
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12647; /* *pred_ltgervvmf2qi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1380 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4QImode:
      if (!register_operand (operands[3], E_V4QImode)
          || !vector_neg_arith_operand (operands[4], E_V4QImode)
          || !(
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12655; /* *pred_ltgev4qi_merge_tie_mask */

    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode)
          || !vector_neg_arith_operand (operands[4], E_V4HImode)
          || !(
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12668; /* *pred_ltgev4hi_merge_tie_mask */

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode)
          || !vector_neg_arith_operand (operands[4], E_V4SImode)
          || !(
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12680; /* *pred_ltgev4si_merge_tie_mask */

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || !vector_neg_arith_operand (operands[4], E_V4DImode)
          || !(
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12691; /* *pred_ltgev4di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1386 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V256QImode:
      if (!register_operand (operands[3], E_V256QImode)
          || !vector_neg_arith_operand (operands[4], E_V256QImode)
          || !(
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12661; /* *pred_ltgev256qi_merge_tie_mask */

    case E_V256HImode:
      if (!register_operand (operands[3], E_V256HImode)
          || !vector_neg_arith_operand (operands[4], E_V256HImode)
          || !(
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12674; /* *pred_ltgev256hi_merge_tie_mask */

    case E_V256SImode:
      if (!register_operand (operands[3], E_V256SImode)
          || !vector_neg_arith_operand (operands[4], E_V256SImode)
          || !(
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12686; /* *pred_ltgev256si_merge_tie_mask */

    case E_V256DImode:
      if (!register_operand (operands[3], E_V256DImode)
          || !vector_neg_arith_operand (operands[4], E_V256DImode)
          || !(
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12697; /* *pred_ltgev256di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1395 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern532 (x2, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V16BImode))
    {
      res = recog_1382 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16QImode:
      if (!register_operand (operands[4], E_V16QImode)
          || !vector_neg_arith_operand (operands[5], E_V16QImode))
        return -1;
      if ((
#line 4865 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16QImode)) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 12725; /* *pred_ltgev16qi */
      if (!(
#line 4886 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16QImode)) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 12793; /* *pred_ltgev16qi_narrow */

    case E_V16HImode:
      if (!register_operand (operands[4], E_V16HImode)
          || !vector_neg_arith_operand (operands[5], E_V16HImode))
        return -1;
      if ((
#line 4865 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16HImode)) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 12738; /* *pred_ltgev16hi */
      if (!(
#line 4886 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16HImode)) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12806; /* *pred_ltgev16hi_narrow */

    case E_V16SImode:
      if (!register_operand (operands[4], E_V16SImode)
          || !vector_neg_arith_operand (operands[5], E_V16SImode))
        return -1;
      if ((
#line 4865 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16SImode)) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 12750; /* *pred_ltgev16si */
      if (!(
#line 4886 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16SImode)) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12818; /* *pred_ltgev16si_narrow */

    case E_V16DImode:
      if (!register_operand (operands[4], E_V16DImode)
          || !vector_neg_arith_operand (operands[5], E_V16DImode))
        return -1;
      if ((
#line 4865 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16DImode)) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 12761; /* *pred_ltgev16di */
      if (!(
#line 4886 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16DImode)) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12829; /* *pred_ltgev16di_narrow */

    default:
      return -1;
    }
}

 int
recog_1403 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4QImode:
      if (!register_operand (operands[3], E_RVVMF4QImode)
          || GET_MODE (x9) != E_RVVMF4QImode
          || !register_operand (operands[4], E_QImode)
          || !
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12840; /* *pred_cmprvvmf4qi_scalar_merge_tie_mask */

    case E_RVVMF2HImode:
      if (!register_operand (operands[3], E_RVVMF2HImode)
          || GET_MODE (x9) != E_RVVMF2HImode
          || !register_operand (operands[4], E_HImode)
          || !
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12846; /* *pred_cmprvvmf2hi_scalar_merge_tie_mask */

    case E_RVVM1SImode:
      if (!register_operand (operands[3], E_RVVM1SImode)
          || GET_MODE (x9) != E_RVVM1SImode
          || !register_operand (operands[4], E_SImode)
          || !
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12851; /* *pred_cmprvvm1si_scalar_merge_tie_mask */

    case E_RVVM2DImode:
      if (!register_operand (operands[3], E_RVVM2DImode)
          || GET_MODE (x9) != E_RVVM2DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5035 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12999; /* *pred_cmprvvm2di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1410 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V32QImode:
      if (!register_operand (operands[3], E_V32QImode)
          || GET_MODE (x9) != E_V32QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12858; /* *pred_cmpv32qi_scalar_merge_tie_mask */

    case E_V32HImode:
      if (!register_operand (operands[3], E_V32HImode)
          || GET_MODE (x9) != E_V32HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12871; /* *pred_cmpv32hi_scalar_merge_tie_mask */

    case E_V32SImode:
      if (!register_operand (operands[3], E_V32SImode)
          || GET_MODE (x9) != E_V32SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12883; /* *pred_cmpv32si_scalar_merge_tie_mask */

    case E_V32DImode:
      if (!register_operand (operands[3], E_V32DImode)
          || GET_MODE (x9) != E_V32DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5035 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 13006; /* *pred_cmpv32di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1417 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V512BImode))
    {
      res = recog_1414 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V512BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V512BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V512QImode:
      if (!register_operand (operands[4], E_V512QImode)
          || GET_MODE (x9) != E_V512QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512QImode)) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 12916; /* *pred_cmpv512qi_scalar */
      if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512QImode)) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12970; /* *pred_cmpv512qi_scalar_narrow */

    case E_V512HImode:
      if (!register_operand (operands[4], E_V512HImode)
          || GET_MODE (x9) != E_V512HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HImode)) && 
#line 752 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12929; /* *pred_cmpv512hi_scalar */
      if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HImode)) && 
#line 752 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12983; /* *pred_cmpv512hi_scalar_narrow */

    case E_V512SImode:
      if (!register_operand (operands[4], E_V512SImode)
          || GET_MODE (x9) != E_V512SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SImode)) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12941; /* *pred_cmpv512si_scalar */
      if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SImode)) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12995; /* *pred_cmpv512si_scalar_narrow */

    case E_V512DImode:
      if (!register_operand (operands[4], E_V512DImode)
          || GET_MODE (x9) != E_V512DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5060 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DImode)) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 13024; /* *pred_cmpv512di_scalar */
      if (!(
#line 5082 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DImode)) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 13038; /* *pred_cmpv512di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1424 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V4BImode))
    {
      res = recog_1407 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V4BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4QImode:
      if (!register_operand (operands[4], E_V4QImode)
          || GET_MODE (x9) != E_V4QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4QImode)) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 12909; /* *pred_cmpv4qi_scalar */
      if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4QImode)) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12963; /* *pred_cmpv4qi_scalar_narrow */

    case E_V4HImode:
      if (!register_operand (operands[4], E_V4HImode)
          || GET_MODE (x9) != E_V4HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HImode)) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12922; /* *pred_cmpv4hi_scalar */
      if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HImode)) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12976; /* *pred_cmpv4hi_scalar_narrow */

    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode)
          || GET_MODE (x9) != E_V4SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SImode)) && 
#line 757 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12934; /* *pred_cmpv4si_scalar */
      if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SImode)) && 
#line 757 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12988; /* *pred_cmpv4si_scalar_narrow */

    case E_V4DImode:
      if (!register_operand (operands[4], E_V4DImode)
          || GET_MODE (x9) != E_V4DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5060 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DImode)) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 13017; /* *pred_cmpv4di_scalar */
      if (!(
#line 5082 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DImode)) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13031; /* *pred_cmpv4di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1433 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4HFmode:
      if (!register_operand (operands[3], E_RVVMF4HFmode)
          || !register_operand (operands[4], E_RVVMF4HFmode)
          || !(
#line 7320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16996; /* *pred_cmprvvmf4hf_narrow_merge_tie_mask */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[3], E_RVVMF2SFmode)
          || !register_operand (operands[4], E_RVVMF2SFmode)
          || !(
#line 7320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17001; /* *pred_cmprvvmf2sf_narrow_merge_tie_mask */

    case E_RVVM1DFmode:
      if (!register_operand (operands[3], E_RVVM1DFmode)
          || !register_operand (operands[4], E_RVVM1DFmode)
          || !(
#line 7320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17005; /* *pred_cmprvvm1df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1438 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[3], E_V16HFmode)
          || !register_operand (operands[4], E_V16HFmode)
          || !(
#line 7320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17010; /* *pred_cmpv16hf_narrow_merge_tie_mask */

    case E_V16SFmode:
      if (!register_operand (operands[3], E_V16SFmode)
          || !register_operand (operands[4], E_V16SFmode)
          || !(
#line 7320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17022; /* *pred_cmpv16sf_narrow_merge_tie_mask */

    case E_V16DFmode:
      if (!register_operand (operands[3], E_V16DFmode)
          || !register_operand (operands[4], E_V16DFmode)
          || !(
#line 7320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17033; /* *pred_cmpv16df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1443 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512HFmode:
      if (!register_operand (operands[3], E_V512HFmode)
          || !register_operand (operands[4], E_V512HFmode)
          || !(
#line 7320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17015; /* *pred_cmpv512hf_narrow_merge_tie_mask */

    case E_V512SFmode:
      if (!register_operand (operands[3], E_V512SFmode)
          || !register_operand (operands[4], E_V512SFmode)
          || !(
#line 7320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17027; /* *pred_cmpv512sf_narrow_merge_tie_mask */

    case E_V512DFmode:
      if (!register_operand (operands[3], E_V512DFmode)
          || !register_operand (operands[4], E_V512DFmode)
          || !(
#line 7320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17038; /* *pred_cmpv512df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1449 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4HFmode:
      if (!register_operand (operands[3], E_RVVMF4HFmode)
          || GET_MODE (x9) != E_RVVMF4HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7383 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17092; /* *pred_cmprvvmf4hf_scalar_merge_tie_mask */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[3], E_RVVMF2SFmode)
          || GET_MODE (x9) != E_RVVMF2SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7383 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17097; /* *pred_cmprvvmf2sf_scalar_merge_tie_mask */

    case E_RVVM1DFmode:
      if (!register_operand (operands[3], E_RVVM1DFmode)
          || GET_MODE (x9) != E_RVVM1DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7383 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17101; /* *pred_cmprvvm1df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1455 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[3], E_V32HFmode)
          || GET_MODE (x9) != E_V32HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7383 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17107; /* *pred_cmpv32hf_scalar_merge_tie_mask */

    case E_V32SFmode:
      if (!register_operand (operands[3], E_V32SFmode)
          || GET_MODE (x9) != E_V32SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7383 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17119; /* *pred_cmpv32sf_scalar_merge_tie_mask */

    case E_V32DFmode:
      if (!register_operand (operands[3], E_V32DFmode)
          || GET_MODE (x9) != E_V32DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7383 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17130; /* *pred_cmpv32df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1461 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern543 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V512BImode))
    {
      res = recog_1459 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V512BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V512BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V512HFmode:
      if (!register_operand (operands[4], E_V512HFmode)
          || GET_MODE (x9) != E_V512HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HFmode)) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 17159; /* *pred_cmpv512hf_scalar */
      if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HFmode)) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17207; /* *pred_cmpv512hf_scalar_narrow */

    case E_V512SFmode:
      if (!register_operand (operands[4], E_V512SFmode)
          || GET_MODE (x9) != E_V512SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SFmode)) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 17171; /* *pred_cmpv512sf_scalar */
      if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SFmode)) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17219; /* *pred_cmpv512sf_scalar_narrow */

    case E_V512DFmode:
      if (!register_operand (operands[4], E_V512DFmode)
          || GET_MODE (x9) != E_V512DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DFmode)) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 17182; /* *pred_cmpv512df_scalar */
      if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DFmode)) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17230; /* *pred_cmpv512df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1468 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF2BImode:
      x2 = XEXP (x1, 1);
      if (pattern543 (x2, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern620 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) == 0
          && (
#line 7383 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 17087; /* *pred_cmprvvm8hf_scalar_merge_tie_mask */
      operands[3] = x3;
      if (pattern621 (x2, 
E_RVVMF2BImode, 
E_RVVM8HFmode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8HFmode)) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 17135; /* *pred_cmprvvm8hf_scalar */
      if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8HFmode)) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17183; /* *pred_cmprvvm8hf_scalar_narrow */

    case E_RVVMF4BImode:
      x2 = XEXP (x1, 1);
      if (pattern543 (x2, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF4BImode))
        {
          res = recog_1445 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[4], E_RVVM4HFmode)
              || GET_MODE (x9) != E_RVVM4HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4HFmode)) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17136; /* *pred_cmprvvm4hf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4HFmode)) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17184; /* *pred_cmprvvm4hf_scalar_narrow */

        case E_RVVM8SFmode:
          if (!register_operand (operands[4], E_RVVM8SFmode)
              || GET_MODE (x9) != E_RVVM8SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8SFmode)) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17141; /* *pred_cmprvvm8sf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8SFmode)) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17189; /* *pred_cmprvvm8sf_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      x2 = XEXP (x1, 1);
      if (pattern543 (x2, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF8BImode))
        {
          res = recog_1446 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[4], E_RVVM2HFmode)
              || GET_MODE (x9) != E_RVVM2HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2HFmode)) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17137; /* *pred_cmprvvm2hf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2HFmode)) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17185; /* *pred_cmprvvm2hf_scalar_narrow */

        case E_RVVM4SFmode:
          if (!register_operand (operands[4], E_RVVM4SFmode)
              || GET_MODE (x9) != E_RVVM4SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4SFmode)) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17142; /* *pred_cmprvvm4sf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4SFmode)) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17190; /* *pred_cmprvvm4sf_scalar_narrow */

        case E_RVVM8DFmode:
          if (!register_operand (operands[4], E_RVVM8DFmode)
              || GET_MODE (x9) != E_RVVM8DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DFmode)) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17146; /* *pred_cmprvvm8df_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DFmode)) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17194; /* *pred_cmprvvm8df_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      x2 = XEXP (x1, 1);
      if (pattern543 (x2, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF16BImode))
        {
          res = recog_1447 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[4], E_RVVM1HFmode)
              || GET_MODE (x9) != E_RVVM1HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1HFmode)) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17138; /* *pred_cmprvvm1hf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1HFmode)) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17186; /* *pred_cmprvvm1hf_scalar_narrow */

        case E_RVVM2SFmode:
          if (!register_operand (operands[4], E_RVVM2SFmode)
              || GET_MODE (x9) != E_RVVM2SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2SFmode)) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17143; /* *pred_cmprvvm2sf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2SFmode)) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17191; /* *pred_cmprvvm2sf_scalar_narrow */

        case E_RVVM4DFmode:
          if (!register_operand (operands[4], E_RVVM4DFmode)
              || GET_MODE (x9) != E_RVVM4DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DFmode)) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17147; /* *pred_cmprvvm4df_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DFmode)) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17195; /* *pred_cmprvvm4df_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      x2 = XEXP (x1, 1);
      if (pattern543 (x2, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF32BImode))
        {
          res = recog_1448 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[4], E_RVVMF2HFmode)
              || GET_MODE (x9) != E_RVVMF2HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2HFmode)) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17139; /* *pred_cmprvvmf2hf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2HFmode)) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17187; /* *pred_cmprvvmf2hf_scalar_narrow */

        case E_RVVM1SFmode:
          if (!register_operand (operands[4], E_RVVM1SFmode)
              || GET_MODE (x9) != E_RVVM1SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1SFmode)) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17144; /* *pred_cmprvvm1sf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1SFmode)) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17192; /* *pred_cmprvvm1sf_scalar_narrow */

        case E_RVVM2DFmode:
          if (!register_operand (operands[4], E_RVVM2DFmode)
              || GET_MODE (x9) != E_RVVM2DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DFmode)) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17148; /* *pred_cmprvvm2df_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DFmode)) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17196; /* *pred_cmprvvm2df_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF64BImode:
      x2 = XEXP (x1, 1);
      if (pattern543 (x2, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF64BImode))
        {
          res = recog_1449 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[4], E_RVVMF4HFmode)
              || GET_MODE (x9) != E_RVVMF4HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4HFmode)) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return 17140; /* *pred_cmprvvmf4hf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4HFmode)) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 17188; /* *pred_cmprvvmf4hf_scalar_narrow */

        case E_RVVMF2SFmode:
          if (!register_operand (operands[4], E_RVVMF2SFmode)
              || GET_MODE (x9) != E_RVVMF2SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2SFmode)) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return 17145; /* *pred_cmprvvmf2sf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2SFmode)) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 17193; /* *pred_cmprvvmf2sf_scalar_narrow */

        case E_RVVM1DFmode:
          if (!register_operand (operands[4], E_RVVM1DFmode)
              || GET_MODE (x9) != E_RVVM1DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DFmode)) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17149; /* *pred_cmprvvm1df_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DFmode)) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17197; /* *pred_cmprvvm1df_scalar_narrow */

        default:
          return -1;
        }

    case E_V1BImode:
      x2 = XEXP (x1, 1);
      if (pattern543 (x2, 
E_V1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1BImode))
        {
          res = recog_1450 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V1BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1HFmode:
          if (!register_operand (operands[4], E_V1HFmode)
              || GET_MODE (x9) != E_V1HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1HFmode)) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return 17150; /* *pred_cmpv1hf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1HFmode)) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 17198; /* *pred_cmpv1hf_scalar_narrow */

        case E_V1SFmode:
          if (!register_operand (operands[4], E_V1SFmode)
              || GET_MODE (x9) != E_V1SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1SFmode)) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return 17162; /* *pred_cmpv1sf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1SFmode)) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17210; /* *pred_cmpv1sf_scalar_narrow */

        case E_V1DFmode:
          if (!register_operand (operands[4], E_V1DFmode)
              || GET_MODE (x9) != E_V1DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1DFmode)) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return 17173; /* *pred_cmpv1df_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1DFmode)) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17221; /* *pred_cmpv1df_scalar_narrow */

        default:
          return -1;
        }

    case E_V2BImode:
      x2 = XEXP (x1, 1);
      if (pattern543 (x2, 
E_V2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2BImode))
        {
          res = recog_1451 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[4], E_V2HFmode)
              || GET_MODE (x9) != E_V2HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2HFmode)) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return 17151; /* *pred_cmpv2hf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2HFmode)) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 17199; /* *pred_cmpv2hf_scalar_narrow */

        case E_V2SFmode:
          if (!register_operand (operands[4], E_V2SFmode)
              || GET_MODE (x9) != E_V2SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2SFmode)) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return 17163; /* *pred_cmpv2sf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2SFmode)) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17211; /* *pred_cmpv2sf_scalar_narrow */

        case E_V2DFmode:
          if (!register_operand (operands[4], E_V2DFmode)
              || GET_MODE (x9) != E_V2DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2DFmode)) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return 17174; /* *pred_cmpv2df_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2DFmode)) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17222; /* *pred_cmpv2df_scalar_narrow */

        default:
          return -1;
        }

    case E_V4BImode:
      x2 = XEXP (x1, 1);
      if (pattern543 (x2, 
E_V4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V4BImode))
        {
          res = recog_1452 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[4], E_V4HFmode)
              || GET_MODE (x9) != E_V4HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HFmode)) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return 17152; /* *pred_cmpv4hf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HFmode)) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 17200; /* *pred_cmpv4hf_scalar_narrow */

        case E_V4SFmode:
          if (!register_operand (operands[4], E_V4SFmode)
              || GET_MODE (x9) != E_V4SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SFmode)) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return 17164; /* *pred_cmpv4sf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SFmode)) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17212; /* *pred_cmpv4sf_scalar_narrow */

        case E_V4DFmode:
          if (!register_operand (operands[4], E_V4DFmode)
              || GET_MODE (x9) != E_V4DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DFmode)) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return 17175; /* *pred_cmpv4df_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DFmode)) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17223; /* *pred_cmpv4df_scalar_narrow */

        default:
          return -1;
        }

    case E_V8BImode:
      return recog_1467 (x1, insn, pnum_clobbers);

    case E_V16BImode:
      return recog_1466 (x1, insn, pnum_clobbers);

    case E_V32BImode:
      return recog_1465 (x1, insn, pnum_clobbers);

    case E_V64BImode:
      return recog_1464 (x1, insn, pnum_clobbers);

    case E_V128BImode:
      return recog_1462 (x1, insn, pnum_clobbers);

    case E_V256BImode:
      return recog_1463 (x1, insn, pnum_clobbers);

    case E_V512BImode:
      return recog_1461 (x1, insn, pnum_clobbers);

    case E_V1024BImode:
      x2 = XEXP (x1, 1);
      if (pattern543 (x2, 
E_V1024BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1024BImode))
        {
          res = recog_1460 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1024HFmode:
          if (!register_operand (operands[4], E_V1024HFmode)
              || GET_MODE (x9) != E_V1024HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024HFmode)) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return 17160; /* *pred_cmpv1024hf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024HFmode)) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17208; /* *pred_cmpv1024hf_scalar_narrow */

        case E_V1024SFmode:
          if (!register_operand (operands[4], E_V1024SFmode)
              || GET_MODE (x9) != E_V1024SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024SFmode)) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return 17172; /* *pred_cmpv1024sf_scalar */
          if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024SFmode)) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17220; /* *pred_cmpv1024sf_scalar_narrow */

        default:
          return -1;
        }

    case E_V2048BImode:
      x2 = XEXP (x1, 1);
      if (pattern543 (x2, 
E_V2048BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern620 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) == 0
          && (
#line 7383 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 17113; /* *pred_cmpv2048hf_scalar_merge_tie_mask */
      operands[3] = x3;
      if (pattern621 (x2, 
E_V2048BImode, 
E_V2048HFmode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048HFmode)) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 17161; /* *pred_cmpv2048hf_scalar */
      if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048HFmode)) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17209; /* *pred_cmpv2048hf_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1480 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 1803 "../../../gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))
        return -1;
      return 117; /* truncdfsf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 1812 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN))
            return -1;
          return 118; /* truncsfhf2 */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !
#line 1821 "../../../gcc/config/riscv/riscv.md"
((TARGET_ZFHMIN && TARGET_DOUBLE_FLOAT) ||
   (TARGET_ZHINXMIN && TARGET_ZDINX)))
            return -1;
          return 119; /* truncdfhf2 */

        default:
          return -1;
        }

    case E_BFmode:
      if (!register_operand (operands[0], E_BFmode)
          || GET_MODE (x3) != E_BFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 1831 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZFBFMIN))
        return -1;
      return 120; /* truncsfbf2 */

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM8SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26365; /* truncrvvm8sfrvvm4hf2 */

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26366; /* truncrvvm4sfrvvm2hf2 */

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26367; /* truncrvvm2sfrvvm1hf2 */

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26368; /* truncrvvm1sfrvvmf2hf2 */

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26369; /* truncrvvmf2sfrvvmf4hf2 */

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM8DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26370; /* truncrvvm8dfrvvm4sf2 */

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM4DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26371; /* truncrvvm4dfrvvm2sf2 */

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM2DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26372; /* truncrvvm2dfrvvm1sf2 */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVM1DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26373; /* truncrvvm1dfrvvmf2sf2 */

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26374; /* truncv1sfv1hf2 */

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26375; /* truncv2sfv2hf2 */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26376; /* truncv4sfv4hf2 */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26377; /* truncv8sfv8hf2 */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26378; /* truncv16sfv16hf2 */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26379; /* truncv32sfv32hf2 */

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26380; /* truncv64sfv64hf2 */

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26381; /* truncv128sfv128hf2 */

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26382; /* truncv256sfv256hf2 */

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26383; /* truncv512sfv512hf2 */

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26384; /* truncv1024sfv1024hf2 */

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26385; /* truncv1dfv1sf2 */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26386; /* truncv2dfv2sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26387; /* truncv4dfv4sf2 */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26388; /* truncv8dfv8sf2 */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26389; /* truncv16dfv16sf2 */

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26390; /* truncv32dfv32sf2 */

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26391; /* truncv64dfv64sf2 */

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[1], E_V128DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26392; /* truncv128dfv128sf2 */

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[1], E_V256DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26393; /* truncv256dfv256sf2 */

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[1], E_V512DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26394; /* truncv512dfv512sf2 */

    default:
      return -1;
    }
}

 int
recog_1483 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern52 (x1))
    {
    case 0:
      if (!
#line 2111 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 147; /* *fixuns_truncsfsi2 */

    case 1:
      if (!(
#line 2111 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 149; /* *fixuns_truncdfsi2 */

    case 2:
      if (!(
#line 2111 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 151; /* *fixuns_trunchfsi2 */

    case 3:
      if (!(
#line 2129 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 159; /* fixuns_truncsfdi2 */

    case 4:
      if (!(
#line 2129 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 161; /* fixuns_truncdfdi2 */

    case 5:
      if (!(
#line 2129 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 163; /* fixuns_trunchfdi2 */

    case 6:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26396; /* fixuns_truncrvvm8hfrvvm8hi2 */

    case 7:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26398; /* fixuns_truncrvvm4hfrvvm4hi2 */

    case 8:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26756; /* fixuns_truncrvvm8sfrvvm4hi2 */

    case 9:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26400; /* fixuns_truncrvvm2hfrvvm2hi2 */

    case 10:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26758; /* fixuns_truncrvvm4sfrvvm2hi2 */

    case 11:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26402; /* fixuns_truncrvvm1hfrvvm1hi2 */

    case 12:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26760; /* fixuns_truncrvvm2sfrvvm1hi2 */

    case 13:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26404; /* fixuns_truncrvvmf2hfrvvmf2hi2 */

    case 14:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26762; /* fixuns_truncrvvm1sfrvvmf2hi2 */

    case 15:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26406; /* fixuns_truncrvvmf4hfrvvmf4hi2 */

    case 16:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26764; /* fixuns_truncrvvmf2sfrvvmf4hi2 */

    case 17:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26408; /* fixuns_truncrvvm8sfrvvm8si2 */

    case 18:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26588; /* fixuns_truncrvvm4hfrvvm8si2 */

    case 19:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26410; /* fixuns_truncrvvm4sfrvvm4si2 */

    case 20:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26590; /* fixuns_truncrvvm2hfrvvm4si2 */

    case 21:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26766; /* fixuns_truncrvvm8dfrvvm4si2 */

    case 22:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26412; /* fixuns_truncrvvm2sfrvvm2si2 */

    case 23:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26592; /* fixuns_truncrvvm1hfrvvm2si2 */

    case 24:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26768; /* fixuns_truncrvvm4dfrvvm2si2 */

    case 25:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26414; /* fixuns_truncrvvm1sfrvvm1si2 */

    case 26:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26594; /* fixuns_truncrvvmf2hfrvvm1si2 */

    case 27:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26770; /* fixuns_truncrvvm2dfrvvm1si2 */

    case 28:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26416; /* fixuns_truncrvvmf2sfrvvmf2si2 */

    case 29:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26596; /* fixuns_truncrvvmf4hfrvvmf2si2 */

    case 30:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26772; /* fixuns_truncrvvm1dfrvvmf2si2 */

    case 31:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26418; /* fixuns_truncrvvm8dfrvvm8di2 */

    case 32:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26598; /* fixuns_truncrvvm4sfrvvm8di2 */

    case 33:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26420; /* fixuns_truncrvvm4dfrvvm4di2 */

    case 34:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26600; /* fixuns_truncrvvm2sfrvvm4di2 */

    case 35:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26422; /* fixuns_truncrvvm2dfrvvm2di2 */

    case 36:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26602; /* fixuns_truncrvvm1sfrvvm2di2 */

    case 37:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26424; /* fixuns_truncrvvm1dfrvvm1di2 */

    case 38:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26604; /* fixuns_truncrvvmf2sfrvvm1di2 */

    case 39:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26426; /* fixuns_truncv1hfv1hi2 */

    case 40:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26798; /* fixuns_truncv1sfv1hi2 */

    case 41:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26428; /* fixuns_truncv2hfv2hi2 */

    case 42:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26800; /* fixuns_truncv2sfv2hi2 */

    case 43:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26430; /* fixuns_truncv4hfv4hi2 */

    case 44:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26802; /* fixuns_truncv4sfv4hi2 */

    case 45:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26432; /* fixuns_truncv8hfv8hi2 */

    case 46:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26804; /* fixuns_truncv8sfv8hi2 */

    case 47:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26434; /* fixuns_truncv16hfv16hi2 */

    case 48:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26806; /* fixuns_truncv16sfv16hi2 */

    case 49:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26436; /* fixuns_truncv32hfv32hi2 */

    case 50:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26808; /* fixuns_truncv32sfv32hi2 */

    case 51:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26438; /* fixuns_truncv64hfv64hi2 */

    case 52:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26810; /* fixuns_truncv64sfv64hi2 */

    case 53:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26440; /* fixuns_truncv128hfv128hi2 */

    case 54:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26812; /* fixuns_truncv128sfv128hi2 */

    case 55:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26442; /* fixuns_truncv256hfv256hi2 */

    case 56:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26814; /* fixuns_truncv256sfv256hi2 */

    case 57:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26444; /* fixuns_truncv512hfv512hi2 */

    case 58:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26816; /* fixuns_truncv512sfv512hi2 */

    case 59:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26446; /* fixuns_truncv1024hfv1024hi2 */

    case 60:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26818; /* fixuns_truncv1024sfv1024hi2 */

    case 61:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26448; /* fixuns_truncv2048hfv2048hi2 */

    case 62:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26450; /* fixuns_truncv1sfv1si2 */

    case 63:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 26606; /* fixuns_truncv1hfv1si2 */

    case 64:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26820; /* fixuns_truncv1dfv1si2 */

    case 65:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26452; /* fixuns_truncv2sfv2si2 */

    case 66:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 26608; /* fixuns_truncv2hfv2si2 */

    case 67:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26822; /* fixuns_truncv2dfv2si2 */

    case 68:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26454; /* fixuns_truncv4sfv4si2 */

    case 69:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 26610; /* fixuns_truncv4hfv4si2 */

    case 70:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26824; /* fixuns_truncv4dfv4si2 */

    case 71:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26456; /* fixuns_truncv8sfv8si2 */

    case 72:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 26612; /* fixuns_truncv8hfv8si2 */

    case 73:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26826; /* fixuns_truncv8dfv8si2 */

    case 74:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26458; /* fixuns_truncv16sfv16si2 */

    case 75:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26614; /* fixuns_truncv16hfv16si2 */

    case 76:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26828; /* fixuns_truncv16dfv16si2 */

    case 77:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26460; /* fixuns_truncv32sfv32si2 */

    case 78:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26616; /* fixuns_truncv32hfv32si2 */

    case 79:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26830; /* fixuns_truncv32dfv32si2 */

    case 80:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26462; /* fixuns_truncv64sfv64si2 */

    case 81:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26618; /* fixuns_truncv64hfv64si2 */

    case 82:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26832; /* fixuns_truncv64dfv64si2 */

    case 83:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26464; /* fixuns_truncv128sfv128si2 */

    case 84:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26620; /* fixuns_truncv128hfv128si2 */

    case 85:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26834; /* fixuns_truncv128dfv128si2 */

    case 86:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26466; /* fixuns_truncv256sfv256si2 */

    case 87:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26622; /* fixuns_truncv256hfv256si2 */

    case 88:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26836; /* fixuns_truncv256dfv256si2 */

    case 89:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26468; /* fixuns_truncv512sfv512si2 */

    case 90:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26624; /* fixuns_truncv512hfv512si2 */

    case 91:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26838; /* fixuns_truncv512dfv512si2 */

    case 92:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26470; /* fixuns_truncv1024sfv1024si2 */

    case 93:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26626; /* fixuns_truncv1024hfv1024si2 */

    case 94:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26472; /* fixuns_truncv1dfv1di2 */

    case 95:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26628; /* fixuns_truncv1sfv1di2 */

    case 96:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26474; /* fixuns_truncv2dfv2di2 */

    case 97:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26630; /* fixuns_truncv2sfv2di2 */

    case 98:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26476; /* fixuns_truncv4dfv4di2 */

    case 99:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26632; /* fixuns_truncv4sfv4di2 */

    case 100:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26478; /* fixuns_truncv8dfv8di2 */

    case 101:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26634; /* fixuns_truncv8sfv8di2 */

    case 102:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26480; /* fixuns_truncv16dfv16di2 */

    case 103:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26636; /* fixuns_truncv16sfv16di2 */

    case 104:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26482; /* fixuns_truncv32dfv32di2 */

    case 105:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26638; /* fixuns_truncv32sfv32di2 */

    case 106:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26484; /* fixuns_truncv64dfv64di2 */

    case 107:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26640; /* fixuns_truncv64sfv64di2 */

    case 108:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26486; /* fixuns_truncv128dfv128di2 */

    case 109:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26642; /* fixuns_truncv128sfv128di2 */

    case 110:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26488; /* fixuns_truncv256dfv256di2 */

    case 111:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26644; /* fixuns_truncv256sfv256di2 */

    case 112:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26490; /* fixuns_truncv512dfv512di2 */

    case 113:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26646; /* fixuns_truncv512sfv512di2 */

    case 114:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26744; /* fixuns_truncrvvm8hfrvvm4qi2 */

    case 115:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26746; /* fixuns_truncrvvm4hfrvvm2qi2 */

    case 116:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26748; /* fixuns_truncrvvm2hfrvvm1qi2 */

    case 117:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26750; /* fixuns_truncrvvm1hfrvvmf2qi2 */

    case 118:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26752; /* fixuns_truncrvvmf2hfrvvmf4qi2 */

    case 119:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26754; /* fixuns_truncrvvmf4hfrvvmf8qi2 */

    case 120:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26774; /* fixuns_truncv1hfv1qi2 */

    case 121:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26776; /* fixuns_truncv2hfv2qi2 */

    case 122:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26778; /* fixuns_truncv4hfv4qi2 */

    case 123:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26780; /* fixuns_truncv8hfv8qi2 */

    case 124:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26782; /* fixuns_truncv16hfv16qi2 */

    case 125:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26784; /* fixuns_truncv32hfv32qi2 */

    case 126:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26786; /* fixuns_truncv64hfv64qi2 */

    case 127:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26788; /* fixuns_truncv128hfv128qi2 */

    case 128:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26790; /* fixuns_truncv256hfv256qi2 */

    case 129:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26792; /* fixuns_truncv512hfv512qi2 */

    case 130:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26794; /* fixuns_truncv1024hfv1024qi2 */

    case 131:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26796; /* fixuns_truncv2048hfv2048qi2 */

    default:
      return -1;
    }
}

 int
recog_1493 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (reg_or_0_operand (operands[2], E_SImode)
          && (
#line 546 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 571; /* *uminsi3 */
      if (!register_operand (operands[2], E_SImode)
          || !
#line 603 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 33800; /* riscv_cv_alu_minu */

    case 1:
      if (!(
#line 546 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 575; /* *umindi3 */

    case 2:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24549; /* uminrvvm8qi3 */

    case 3:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24563; /* uminrvvm4qi3 */

    case 4:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24577; /* uminrvvm2qi3 */

    case 5:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24591; /* uminrvvm1qi3 */

    case 6:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24605; /* uminrvvm8hi3 */

    case 7:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24619; /* uminrvvm4hi3 */

    case 8:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24633; /* uminrvvm2hi3 */

    case 9:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24647; /* uminrvvm1hi3 */

    case 10:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24661; /* uminrvvm8si3 */

    case 11:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24675; /* uminrvvm4si3 */

    case 12:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24689; /* uminrvvm2si3 */

    case 13:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24703; /* uminrvvm1si3 */

    case 14:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24717; /* uminrvvm8di3 */

    case 15:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24731; /* uminrvvm4di3 */

    case 16:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24745; /* uminrvvm2di3 */

    case 17:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24759; /* uminrvvm1di3 */

    case 18:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24773; /* uminrvvmf2qi3 */

    case 19:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24787; /* uminrvvmf4qi3 */

    case 20:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24801; /* uminrvvmf8qi3 */

    case 21:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24815; /* uminrvvmf2hi3 */

    case 22:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24829; /* uminrvvmf4hi3 */

    case 23:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24843; /* uminrvvmf2si3 */

    case 24:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24857; /* uminv1qi3 */

    case 25:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24871; /* uminv2qi3 */

    case 26:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24885; /* uminv4qi3 */

    case 27:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24899; /* uminv8qi3 */

    case 28:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24913; /* uminv16qi3 */

    case 29:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24927; /* uminv32qi3 */

    case 30:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24941; /* uminv64qi3 */

    case 31:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24955; /* uminv128qi3 */

    case 32:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24969; /* uminv256qi3 */

    case 33:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24983; /* uminv512qi3 */

    case 34:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24997; /* uminv1024qi3 */

    case 35:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25011; /* uminv2048qi3 */

    case 36:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25025; /* uminv4096qi3 */

    case 37:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25039; /* uminv1hi3 */

    case 38:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25053; /* uminv2hi3 */

    case 39:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25067; /* uminv4hi3 */

    case 40:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25081; /* uminv8hi3 */

    case 41:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25095; /* uminv16hi3 */

    case 42:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25109; /* uminv32hi3 */

    case 43:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25123; /* uminv64hi3 */

    case 44:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25137; /* uminv128hi3 */

    case 45:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25151; /* uminv256hi3 */

    case 46:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25165; /* uminv512hi3 */

    case 47:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25179; /* uminv1024hi3 */

    case 48:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25193; /* uminv2048hi3 */

    case 49:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25207; /* uminv1si3 */

    case 50:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25221; /* uminv2si3 */

    case 51:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25235; /* uminv4si3 */

    case 52:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25249; /* uminv8si3 */

    case 53:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25263; /* uminv16si3 */

    case 54:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25277; /* uminv32si3 */

    case 55:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25291; /* uminv64si3 */

    case 56:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25305; /* uminv128si3 */

    case 57:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25319; /* uminv256si3 */

    case 58:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25333; /* uminv512si3 */

    case 59:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25347; /* uminv1024si3 */

    case 60:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25361; /* uminv1di3 */

    case 61:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25375; /* uminv2di3 */

    case 62:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25389; /* uminv4di3 */

    case 63:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25403; /* uminv8di3 */

    case 64:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25417; /* uminv16di3 */

    case 65:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25431; /* uminv32di3 */

    case 66:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25445; /* uminv64di3 */

    case 67:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25459; /* uminv128di3 */

    case 68:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25473; /* uminv256di3 */

    case 69:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25487; /* uminv512di3 */

    default:
      return -1;
    }
}

 int
recog_1505 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern2 (x1))
    {
    case 0:
      if (!(
#line 1493 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 51; /* sqrtsf2 */

    case 1:
      if (!(
#line 1493 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 52; /* sqrtdf2 */

    case 2:
      if (!(
#line 1493 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 53; /* sqrthf2 */

    case 3:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27131; /* sqrtrvvm8hf2 */

    case 4:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27132; /* sqrtrvvm4hf2 */

    case 5:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27133; /* sqrtrvvm2hf2 */

    case 6:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27134; /* sqrtrvvm1hf2 */

    case 7:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27135; /* sqrtrvvmf2hf2 */

    case 8:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27136; /* sqrtrvvmf4hf2 */

    case 9:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27137; /* sqrtrvvm8sf2 */

    case 10:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27138; /* sqrtrvvm4sf2 */

    case 11:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27139; /* sqrtrvvm2sf2 */

    case 12:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27140; /* sqrtrvvm1sf2 */

    case 13:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27141; /* sqrtrvvmf2sf2 */

    case 14:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27142; /* sqrtrvvm8df2 */

    case 15:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27143; /* sqrtrvvm4df2 */

    case 16:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27144; /* sqrtrvvm2df2 */

    case 17:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27145; /* sqrtrvvm1df2 */

    case 18:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27146; /* sqrtv1hf2 */

    case 19:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27147; /* sqrtv2hf2 */

    case 20:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27148; /* sqrtv4hf2 */

    case 21:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27149; /* sqrtv8hf2 */

    case 22:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27150; /* sqrtv16hf2 */

    case 23:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27151; /* sqrtv32hf2 */

    case 24:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27152; /* sqrtv64hf2 */

    case 25:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27153; /* sqrtv128hf2 */

    case 26:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27154; /* sqrtv256hf2 */

    case 27:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27155; /* sqrtv512hf2 */

    case 28:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27156; /* sqrtv1024hf2 */

    case 29:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27157; /* sqrtv2048hf2 */

    case 30:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27158; /* sqrtv1sf2 */

    case 31:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27159; /* sqrtv2sf2 */

    case 32:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27160; /* sqrtv4sf2 */

    case 33:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27161; /* sqrtv8sf2 */

    case 34:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27162; /* sqrtv16sf2 */

    case 35:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27163; /* sqrtv32sf2 */

    case 36:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27164; /* sqrtv64sf2 */

    case 37:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27165; /* sqrtv128sf2 */

    case 38:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27166; /* sqrtv256sf2 */

    case 39:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27167; /* sqrtv512sf2 */

    case 40:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27168; /* sqrtv1024sf2 */

    case 41:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27169; /* sqrtv1df2 */

    case 42:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27170; /* sqrtv2df2 */

    case 43:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27171; /* sqrtv4df2 */

    case 44:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27172; /* sqrtv8df2 */

    case 45:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27173; /* sqrtv16df2 */

    case 46:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27174; /* sqrtv32df2 */

    case 47:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27175; /* sqrtv64df2 */

    case 48:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27176; /* sqrtv128df2 */

    case 49:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27177; /* sqrtv256df2 */

    case 50:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27178; /* sqrtv512df2 */

    default:
      return -1;
    }
}

 int
recog_1516 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern411 (
E_SImode) != 0
          || !
#line 424 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMPAIR && reload_completed
   && th_mempair_operands_p (operands, false, SImode)))
        return -1;
      return 915; /* *th_mempair_store_si2 */

    case E_DImode:
      if (pattern411 (
E_DImode) != 0
          || !(
#line 424 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMPAIR && reload_completed
   && th_mempair_operands_p (operands, false, DImode)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 916; /* *th_mempair_store_di2 */

    default:
      return -1;
    }
}

 int
recog_1518 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      res = recog_1514 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_1515 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) == SET)
    {
      res = recog_1516 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  switch (GET_CODE (x5))
    {
    case USE:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 67
          || GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8QImode)
              || !
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2758; /* *movrvvm8qi_reg_whole_vtype */

        case E_RVVM4QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4QImode)
              || !
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2759; /* *movrvvm4qi_reg_whole_vtype */

        case E_RVVM2QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2QImode)
              || !
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2760; /* *movrvvm2qi_reg_whole_vtype */

        case E_RVVM1QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1QImode)
              || !
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2761; /* *movrvvm1qi_reg_whole_vtype */

        case E_RVVM8HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8HImode)
              || !
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2762; /* *movrvvm8hi_reg_whole_vtype */

        case E_RVVM4HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4HImode)
              || !
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2763; /* *movrvvm4hi_reg_whole_vtype */

        case E_RVVM2HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2HImode)
              || !
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2764; /* *movrvvm2hi_reg_whole_vtype */

        case E_RVVM1HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1HImode)
              || !
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2765; /* *movrvvm1hi_reg_whole_vtype */

        case E_RVVM8BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8BFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 913 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2766; /* *movrvvm8bf_reg_whole_vtype */

        case E_RVVM4BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4BFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 913 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2767; /* *movrvvm4bf_reg_whole_vtype */

        case E_RVVM2BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2BFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 914 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2768; /* *movrvvm2bf_reg_whole_vtype */

        case E_RVVM1BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1BFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 914 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2769; /* *movrvvm1bf_reg_whole_vtype */

        case E_RVVM8HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8HFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 916 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2770; /* *movrvvm8hf_reg_whole_vtype */

        case E_RVVM4HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4HFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 916 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2771; /* *movrvvm4hf_reg_whole_vtype */

        case E_RVVM2HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2HFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 917 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2772; /* *movrvvm2hf_reg_whole_vtype */

        case E_RVVM1HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1HFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 917 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2773; /* *movrvvm1hf_reg_whole_vtype */

        case E_RVVM8SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8SImode)
              || !
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2774; /* *movrvvm8si_reg_whole_vtype */

        case E_RVVM4SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4SImode)
              || !
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2775; /* *movrvvm4si_reg_whole_vtype */

        case E_RVVM2SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2SImode)
              || !
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2776; /* *movrvvm2si_reg_whole_vtype */

        case E_RVVM1SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1SImode)
              || !
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2777; /* *movrvvm1si_reg_whole_vtype */

        case E_RVVM8SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8SFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 921 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2778; /* *movrvvm8sf_reg_whole_vtype */

        case E_RVVM4SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4SFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 921 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2779; /* *movrvvm4sf_reg_whole_vtype */

        case E_RVVM2SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2SFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 922 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2780; /* *movrvvm2sf_reg_whole_vtype */

        case E_RVVM1SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1SFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 922 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2781; /* *movrvvm1sf_reg_whole_vtype */

        case E_RVVM8DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8DImode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 924 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2782; /* *movrvvm8di_reg_whole_vtype */

        case E_RVVM4DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4DImode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 924 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2783; /* *movrvvm4di_reg_whole_vtype */

        case E_RVVM2DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2DImode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 925 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2784; /* *movrvvm2di_reg_whole_vtype */

        case E_RVVM1DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1DImode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 925 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2785; /* *movrvvm1di_reg_whole_vtype */

        case E_RVVM8DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8DFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 927 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2786; /* *movrvvm8df_reg_whole_vtype */

        case E_RVVM4DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4DFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 927 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2787; /* *movrvvm4df_reg_whole_vtype */

        case E_RVVM2DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2DFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 928 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2788; /* *movrvvm2df_reg_whole_vtype */

        case E_RVVM1DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1DFmode)
              || !(
#line 1249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 928 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2789; /* *movrvvm1df_reg_whole_vtype */

        default:
          return -1;
        }

    case CLOBBER:
      return recog_1517 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1528 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x4))
    {
    case SET:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC_VOLATILE
          || XVECLEN (x5, 0) != 2
          || !register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode)
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XVECEXP (x5, 0, 1);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      operands[4] = x7;
      x8 = XEXP (x4, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (XINT (x5, 1))
        {
        case 81:
          if (pnum_clobbers == NULL)
            return -1;
          x9 = XVECEXP (x5, 0, 0);
          if (GET_MODE (x9) != E_SImode
              || !register_operand (operands[4], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 3);
          operands[5] = x10;
          if (!register_operand (operands[5], E_SImode))
            return -1;
          switch (pattern572 (x9))
            {
            case 0:
              if (!
#line 217 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 760; /* subword_atomic_fetch_strong_add */

            case 1:
              if (!
#line 217 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 761; /* subword_atomic_fetch_strong_or */

            case 2:
              if (!
#line 217 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 762; /* subword_atomic_fetch_strong_xor */

            case 3:
              if (!
#line 217 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 763; /* subword_atomic_fetch_strong_and */

            case 4:
              if (!
#line 284 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 764; /* subword_atomic_fetch_strong_nand */

            default:
              return -1;
            }

        case 84:
          x10 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x9 = XVECEXP (x5, 0, 0);
          operands[2] = x9;
          if (!reg_or_0_operand (operands[2], E_SImode)
              || !reg_or_0_operand (operands[4], E_SImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[5] = x11;
          if (!scratch_operand (operands[5], E_SImode)
              || !
#line 493 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
            return -1;
          return 779; /* subword_atomic_exchange_strong */

        default:
          return -1;
        }

    case CLOBBER:
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x10) != CLOBBER)
        return -1;
      return recog_1527 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1529 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      res = recog_1528 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG
          || pattern221 (x1, 
9) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 8)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != MEM)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != PLUS)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 2)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x10) != SET
          || pattern548 (x10, 
1) != 0)
        return -1;
      x11 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x11) != SET)
        return -1;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != PLUS)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 2)
        return -1;
      x14 = XEXP (x11, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 2)
        return -1;
      x15 = XEXP (x12, 1);
      operands[0] = x15;
      if (!stack_push_up_to_s1_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern731 (x1))
        {
        case 0:
          if (pattern734 (x1, 
E_SImode) != 0
              || !(
#line 1142 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33755; /* gpr_multi_push_up_to_s1_si */

        case 1:
          if (pattern734 (x1, 
E_DImode) != 0
              || !(
#line 1142 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33756; /* gpr_multi_push_up_to_s1_di */

        default:
          return -1;
        }

    case PLUS:
      x16 = XEXP (x3, 0);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 2)
        return -1;
      x17 = XEXP (x2, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 2)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET
          || pattern389 (x4) != 0)
        return -1;
      x18 = XEXP (x3, 1);
      operands[0] = x18;
      x5 = XEXP (x4, 1);
      x19 = XEXP (x5, 0);
      x20 = XEXP (x19, 1);
      switch (XWINT (x20, 0))
        {
        case -4L:
          switch (pattern474 (x1, 
E_SImode, 
-12, 
-8))
            {
            case 0:
              if (!(
#line 59 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33683; /* gpr_multi_pop_up_to_s1_si */

            case 1:
              if (!(
#line 363 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33703; /* gpr_multi_popret_up_to_ra_si */

            default:
              return -1;
            }

        case -8L:
          switch (pattern474 (x1, 
E_DImode, 
-24, 
-16))
            {
            case 0:
              if (!(
#line 59 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33684; /* gpr_multi_pop_up_to_s1_di */

            case 1:
              if (!(
#line 363 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33704; /* gpr_multi_popret_up_to_ra_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1531 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case UNSPEC_VOLATILE:
      if (pattern119 (x1, 
CLOBBER, 
30) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 17);
      if (GET_CODE (x3) != RETURN
          || !
#line 277 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADINT && !TARGET_64BIT))
        return -1;
      return 900; /* th_int_pop */

    case SET:
      if (pattern120 (x1, 
23, 
24, 
25, 
26, 
27) != 0
          || pattern740 (x1, 
18, 
19, 
20, 
21, 
22) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 11);
      if (pattern762 (x4) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 9)
        return -1;
      x6 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != MEM)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 2)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 8)
        return -1;
      x12 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x12) != SET)
        return -1;
      x13 = XEXP (x12, 1);
      if (GET_CODE (x13) != MEM)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 2)
        return -1;
      x16 = XEXP (x14, 1);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XEXP (x12, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 1)
        return -1;
      x18 = XVECEXP (x1, 0, 14);
      if (GET_CODE (x18) != SET)
        return -1;
      x19 = XEXP (x18, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x20 = XEXP (x18, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 10)
        return -1;
      x21 = XVECEXP (x1, 0, 15);
      if (GET_CODE (x21) != USE)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 10)
        return -1;
      x23 = XVECEXP (x1, 0, 16);
      if (GET_CODE (x23) != RETURN)
        return -1;
      x3 = XVECEXP (x1, 0, 17);
      if (GET_CODE (x3) != USE)
        return -1;
      x24 = XEXP (x3, 0);
      if (GET_CODE (x24) != REG
          || REGNO (x24) != 1
          || GET_MODE (x24) != E_SImode)
        return -1;
      x25 = XEXP (x2, 1);
      x26 = XEXP (x25, 1);
      operands[0] = x26;
      if (!stack_pop_up_to_s11_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern770 (x1))
        {
        case 0:
          if (XWINT (x10, 0) != -48L
              || XWINT (x16, 0) != -52L
              || pattern793 (x1, 
E_SImode) != 0
              || !(
#line 1100 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33749; /* gpr_multi_popretz_up_to_s11_si */

        case 1:
          if (XWINT (x10, 0) != -96L
              || XWINT (x16, 0) != -104L
              || pattern793 (x1, 
E_DImode) != 0
              || !(
#line 1100 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33750; /* gpr_multi_popretz_up_to_s11_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1533 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  if (pattern113 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (pattern371 (x1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 4);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      switch (pattern725 (x1))
        {
        case 0:
          switch (pattern733 (x1, 
E_SImode, 
-28, 
-24, 
-20, 
-16))
            {
            case 0:
              if (!(
#line 157 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33691; /* gpr_multi_pop_up_to_s5_si */

            case 1:
              if (!(
#line 445 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33711; /* gpr_multi_popret_up_to_s3_si */

            case 2:
              if (!(
#line 764 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33731; /* gpr_multi_popretz_up_to_s1_si */

            default:
              return -1;
            }

        case 1:
          switch (pattern733 (x1, 
E_DImode, 
-56, 
-48, 
-40, 
-32))
            {
            case 0:
              if (!(
#line 157 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33692; /* gpr_multi_pop_up_to_s5_di */

            case 1:
              if (!(
#line 445 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33712; /* gpr_multi_popret_up_to_s3_di */

            case 2:
              if (!(
#line 764 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33732; /* gpr_multi_popretz_up_to_s1_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x3) != 21)
        return -1;
      x6 = XEXP (x2, 0);
      if (pattern325 (x6) != 0)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 20)
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != MEM)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 2)
        return -1;
      x12 = XEXP (x10, 1);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XVECEXP (x1, 0, 2);
      x14 = XEXP (x13, 1);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 19)
        return -1;
      x15 = XEXP (x13, 0);
      if (GET_CODE (x15) != MEM)
        return -1;
      x16 = XEXP (x15, 0);
      if (GET_CODE (x16) != PLUS)
        return -1;
      x17 = XEXP (x16, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 2)
        return -1;
      x18 = XEXP (x16, 1);
      if (GET_CODE (x18) != CONST_INT)
        return -1;
      x19 = XVECEXP (x1, 0, 3);
      x20 = XEXP (x19, 1);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 18)
        return -1;
      x21 = XEXP (x19, 0);
      if (GET_CODE (x21) != MEM)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != PLUS)
        return -1;
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != REG
          || REGNO (x23) != 2)
        return -1;
      x24 = XEXP (x22, 1);
      if (GET_CODE (x24) != CONST_INT
          || pattern732 (x1, 
9) != 0
          || pattern736 (x1, 
8) != 0)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      if (pattern535 (x25, 
1) != 0)
        return -1;
      x26 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x26) != SET)
        return -1;
      x27 = XEXP (x26, 1);
      if (GET_CODE (x27) != PLUS)
        return -1;
      x28 = XEXP (x27, 0);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 2)
        return -1;
      x29 = XEXP (x26, 0);
      if (GET_CODE (x29) != REG
          || REGNO (x29) != 2)
        return -1;
      x30 = XEXP (x27, 1);
      operands[0] = x30;
      if (!stack_push_up_to_s5_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern755 (x1))
        {
        case 0:
          if (pattern760 (x1, 
E_SImode) != 0
              || !(
#line 1240 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33763; /* gpr_multi_push_up_to_s5_si */

        case 1:
          if (pattern760 (x1, 
E_DImode) != 0
              || !(
#line 1240 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33764; /* gpr_multi_push_up_to_s5_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1536 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  if (pattern114 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x2) != SET)
    return -1;
  switch (pattern391 (x1, 
23, 
24))
    {
    case 0:
      x3 = XVECEXP (x1, 0, 6);
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != MEM)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 2)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG)
        return -1;
      x9 = XEXP (x2, 0);
      if (GET_CODE (x9) != REG)
        return -1;
      switch (pattern738 (x1))
        {
        case 0:
          if (XWINT (x7, 0) != -24L)
            return -1;
          switch (pattern750 (x1, 
-28, 
E_SImode, 
-32))
            {
            case 0:
              if (pattern774 (x1, 
9) != 0)
                return -1;
              x10 = XVECEXP (x1, 0, 9);
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 8
                  || GET_MODE (x11) != E_SImode)
                return -1;
              x12 = XVECEXP (x1, 0, 10);
              if (pattern786 (x12) != 0
                  || !(
#line 262 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33697; /* gpr_multi_pop_up_to_s8_si */

            case 1:
              if (!(
#line 538 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33717; /* gpr_multi_popret_up_to_s6_si */

            case 2:
              if (!(
#line 848 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33737; /* gpr_multi_popretz_up_to_s4_si */

            default:
              return -1;
            }

        case 1:
          if (XWINT (x7, 0) != -48L)
            return -1;
          switch (pattern750 (x1, 
-56, 
E_DImode, 
-64))
            {
            case 0:
              x13 = XVECEXP (x1, 0, 8);
              if (GET_CODE (x13) != SET)
                return -1;
              x14 = XEXP (x13, 1);
              if (GET_CODE (x14) != MEM
                  || GET_MODE (x14) != E_DImode)
                return -1;
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != PLUS
                  || GET_MODE (x15) != E_DImode)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 2
                  || GET_MODE (x16) != E_DImode)
                return -1;
              x17 = XEXP (x15, 1);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -64])
                return -1;
              x18 = XEXP (x13, 0);
              if (GET_CODE (x18) != REG
                  || REGNO (x18) != 9
                  || GET_MODE (x18) != E_DImode)
                return -1;
              x10 = XVECEXP (x1, 0, 9);
              if (GET_CODE (x10) != SET)
                return -1;
              x19 = XEXP (x10, 1);
              if (GET_CODE (x19) != MEM
                  || GET_MODE (x19) != E_DImode)
                return -1;
              x20 = XEXP (x19, 0);
              if (GET_CODE (x20) != PLUS
                  || GET_MODE (x20) != E_DImode)
                return -1;
              x21 = XEXP (x20, 0);
              if (GET_CODE (x21) != REG
                  || REGNO (x21) != 2
                  || GET_MODE (x21) != E_DImode)
                return -1;
              x22 = XEXP (x20, 1);
              if (GET_CODE (x22) != CONST_INT
                  || XWINT (x22, 0) != -72L)
                return -1;
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 8
                  || GET_MODE (x11) != E_DImode)
                return -1;
              x12 = XVECEXP (x1, 0, 10);
              if (pattern787 (x12) != 0
                  || !(
#line 262 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33698; /* gpr_multi_pop_up_to_s8_di */

            case 1:
              if (!(
#line 538 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33718; /* gpr_multi_popret_up_to_s6_di */

            case 2:
              if (!(
#line 848 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33738; /* gpr_multi_popretz_up_to_s4_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern536 (x1, 
18, 
19, 
20, 
21, 
22) != 0
          || pattern748 (x1, 
9) != 0
          || pattern758 (x1, 
1, 
8) != 0)
        return -1;
      x12 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x12) != SET)
        return -1;
      x23 = XEXP (x12, 1);
      if (GET_CODE (x23) != PLUS)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != REG
          || REGNO (x24) != 2)
        return -1;
      x25 = XEXP (x12, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2)
        return -1;
      x26 = XEXP (x23, 1);
      operands[0] = x26;
      if (!stack_push_up_to_s8_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern765 (x1))
        {
        case 0:
          x10 = XVECEXP (x1, 0, 9);
          x11 = XEXP (x10, 0);
          x27 = XEXP (x11, 0);
          x28 = XEXP (x27, 1);
          if (XWINT (x28, 0) != -40L
              || pattern772 (x1, 
E_SImode) != 0
              || !(
#line 1345 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33769; /* gpr_multi_push_up_to_s8_si */

        case 1:
          x10 = XVECEXP (x1, 0, 9);
          x11 = XEXP (x10, 0);
          x27 = XEXP (x11, 0);
          x28 = XEXP (x27, 1);
          if (XWINT (x28, 0) != -80L
              || pattern772 (x1, 
E_DImode) != 0
              || !(
#line 1345 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33770; /* gpr_multi_push_up_to_s8_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1540 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  if (pattern116 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 9);
  if (pattern754 (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XEXP (x3, 0);
  if (GET_CODE (x8) != REG)
    return -1;
  x9 = XVECEXP (x1, 0, 11);
  if (pattern762 (x9) != 0)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG)
    return -1;
  x11 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG)
    return -1;
  x13 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x13) != RETURN)
    return -1;
  x14 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x14) != USE)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 1
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 0);
  x17 = XEXP (x16, 1);
  x18 = XEXP (x17, 1);
  operands[0] = x18;
  switch (pattern770 (x1))
    {
    case 0:
      switch (pattern779 (x1, 
E_SImode))
        {
        case 0:
          x19 = XEXP (x11, 1);
          if (pattern797 (x19) != 0
              || REGNO (x12) != 8)
            return -1;
          x20 = XVECEXP (x1, 0, 13);
          if (pattern800 (x20) != 0
              || !(
#line 707 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33725; /* gpr_multi_popret_up_to_s11_si */

        case 1:
          if (!(
#line 1048 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33747; /* gpr_multi_popretz_up_to_s9_si */

        default:
          return -1;
        }

    case 1:
      switch (pattern779 (x1, 
E_DImode))
        {
        case 0:
          x19 = XEXP (x11, 1);
          if (pattern798 (x19) != 0
              || REGNO (x12) != 8)
            return -1;
          x20 = XVECEXP (x1, 0, 13);
          if (pattern801 (x20) != 0
              || !(
#line 707 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33726; /* gpr_multi_popret_up_to_s11_di */

        case 1:
          if (!(
#line 1048 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33748; /* gpr_multi_popretz_up_to_s9_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM8QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2587 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM4QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2601 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM2QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2615 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM1QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2629 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM8HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2643 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM4HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2657 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM2HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2671 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM1HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2685 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM8SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2699 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM4SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2713 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM2SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2727 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM1SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2741 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM8DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2755 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM4DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2769 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM2DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2783 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVM1DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2797 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVMF2QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2811 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVMF4QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2825 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVMF8QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2839 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVMF2HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2853 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVMF4HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2867 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_RVVMF2SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2881 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V1QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2895 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V2QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2909 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V4QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2923 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V8QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2937 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V16QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2951 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V32QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2965 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V64QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2979 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V128QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2993 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V256QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3007 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V512QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3021 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V1024QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3035 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V2048QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3049 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V4096QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3063 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V1HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3077 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V2HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3091 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V4HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3105 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V8HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3119 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V16HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3133 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V32HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3147 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V64HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3161 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V128HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3175 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V256HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3189 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V512HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3203 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V1024HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3217 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V2048HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3231 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V1SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3245 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V2SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3259 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V4SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3273 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V8SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3287 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V16SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3301 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V32SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3315 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V64SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3329 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V128SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3343 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V256SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3357 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V512SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3371 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V1024SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3385 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V1DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3399 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V2DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3413 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V4DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3427 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V8DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3441 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V16DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3455 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V32DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3469 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V64DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3483 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V128DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3497 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V256DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3511 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern228 (x2, 
E_V512DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3525 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5553 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5557 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5561 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5565 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5569 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5573 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5577 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5581 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5585 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5589 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5593 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5597 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5601 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5605 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5609 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5613 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5617 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5621 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5625 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5629 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5633 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5637 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5641 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5645 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5649 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5653 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5657 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5661 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5665 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5669 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5673 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5677 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5681 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5685 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5689 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5693 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5697 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5701 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5705 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5709 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5713 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5717 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5721 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5725 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5729 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5733 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5737 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5741 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4DFmode)
      && reg_or_mem_operand (operands[1], E_V4DFmode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_315 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4DFmode)
       || register_operand (operands[1], V4DFmode))) && 
#line 4336 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4DFmode)
       || !register_operand (operands[1], V4DFmode)))))
        return gen_split_1979 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4DFmode)
      || !register_operand (operands[1], E_V4DFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2162 (insn, operands);
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8SFmode)
      && reg_or_mem_operand (operands[1], E_V8SFmode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_305 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8SFmode)
       || register_operand (operands[1], V8SFmode))) && 
#line 4332 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8SFmode)
       || !register_operand (operands[1], V8SFmode)))))
        return gen_split_1975 (insn, operands);
    }
  if (!register_operand (operands[0], E_V8SFmode)
      || !register_operand (operands[1], E_V8SFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2152 (insn, operands);
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16HFmode)
      && reg_or_mem_operand (operands[1], E_V16HFmode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_294 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16HFmode)
       || register_operand (operands[1], V16HFmode))) && 
#line 4328 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16HFmode)
       || !register_operand (operands[1], V16HFmode)))))
        return gen_split_1971 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16HFmode)
      || !register_operand (operands[1], E_V16HFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2141 (insn, operands);
}

 rtx_insn *
split_24 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1HFmode)
      && reg_or_mem_operand (operands[1], E_V1HFmode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_290 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1HFmode)
       || register_operand (operands[1], V1HFmode))) && 
#line 4324 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1HFmode)
       || !register_operand (operands[1], V1HFmode)))))
        return gen_split_1967 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1HFmode)
      || !register_operand (operands[1], E_V1HFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2137 (insn, operands);
}

 rtx_insn *
split_29 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1DImode)
      && reg_or_mem_operand (operands[1], E_V1DImode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return gen_split_280 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1DImode)
       || register_operand (operands[1], V1DImode))) && 
#line 4319 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1DImode)
       || !register_operand (operands[1], V1DImode)))))
        return gen_split_1962 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1DImode)
      || !register_operand (operands[1], E_V1DImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2127 (insn, operands);
}

 rtx_insn *
split_34 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1SImode)
      && reg_or_mem_operand (operands[1], E_V1SImode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return gen_split_269 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1SImode)
       || register_operand (operands[1], V1SImode))) && 
#line 4314 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1SImode)
       || !register_operand (operands[1], V1SImode)))))
        return gen_split_1957 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1SImode)
      || !register_operand (operands[1], E_V1SImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2116 (insn, operands);
}

 rtx_insn *
split_40 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16QImode)
      && reg_or_mem_operand (operands[1], E_V16QImode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return gen_split_248 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[1], V16QImode))) && 
#line 4308 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16QImode)
       || !register_operand (operands[1], V16QImode)))))
        return gen_split_1951 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16QImode)
      || !register_operand (operands[1], E_V16QImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2095 (insn, operands);
}

 rtx_insn *
split_46 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8BImode)
      && reg_or_mem_operand (operands[1], E_V8BImode)
      && ((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode))) && 
#line 4343 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8BImode)
       || !register_operand (operands[1], V8BImode)))))
    return gen_split_1985 (insn, operands);
  if (!register_operand (operands[0], E_V8BImode)
      || !register_operand (operands[1], E_V8BImode)
      || !((
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1532 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2173 (insn, operands);
}

 rtx_insn *
split_52 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128DFmode)
      && reg_or_mem_operand (operands[1], E_V128DFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_320 (insn, operands);
  if (!register_operand (operands[0], E_V128DFmode)
      || !register_operand (operands[1], E_V128DFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2167 (insn, operands);
}

 rtx_insn *
split_58 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128SFmode)
      && reg_or_mem_operand (operands[1], E_V128SFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 291 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return gen_split_309 (insn, operands);
  if (!register_operand (operands[0], E_V128SFmode)
      || !register_operand (operands[1], E_V128SFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2156 (insn, operands);
}

 rtx_insn *
split_64 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256HFmode)
      && reg_or_mem_operand (operands[1], E_V256HFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return gen_split_298 (insn, operands);
  if (!register_operand (operands[0], E_V256HFmode)
      || !register_operand (operands[1], E_V256HFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2145 (insn, operands);
}

 rtx_insn *
split_70 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128DImode)
      && reg_or_mem_operand (operands[1], E_V128DImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_287 (insn, operands);
  if (!register_operand (operands[0], E_V128DImode)
      || !register_operand (operands[1], E_V128DImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2134 (insn, operands);
}

 rtx_insn *
split_76 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128SImode)
      && reg_or_mem_operand (operands[1], E_V128SImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return gen_split_276 (insn, operands);
  if (!register_operand (operands[0], E_V128SImode)
      || !register_operand (operands[1], E_V128SImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2123 (insn, operands);
}

 rtx_insn *
split_83 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128HImode)
      && reg_or_mem_operand (operands[1], E_V128HImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return gen_split_264 (insn, operands);
  if (!register_operand (operands[0], E_V128HImode)
      || !register_operand (operands[1], E_V128HImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2111 (insn, operands);
}

 rtx_insn *
split_90 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256QImode)
      && reg_or_mem_operand (operands[1], E_V256QImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return gen_split_252 (insn, operands);
  if (!register_operand (operands[0], E_V256QImode)
      || !register_operand (operands[1], E_V256QImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2099 (insn, operands);
}

 rtx_insn *
split_98 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF16BImode)
      && reg_or_mem_operand (operands[1], E_RVVMF16BImode)
      && 
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_239 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF16BImode)
      || !register_operand (operands[1], E_RVVMF16BImode)
      || !(
#line 1294 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1576 (insn, operands);
}

 rtx_insn *
split_105 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF2BFmode)
      && reg_or_mem_operand (operands[1], E_RVVMF2BFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
    return gen_split_220 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF2BFmode)
      || !register_operand (operands[1], E_RVVMF2BFmode)
      || !((
#line 1257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1259 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1568 (insn, operands);
}

 rtx_insn *
split_111 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern271 (x2))
    {
    case 0:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3539 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3743 (insn, operands);

    case 1:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3542 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3746 (insn, operands);

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3545 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3749 (insn, operands);

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3548 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3752 (insn, operands);

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3551 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3755 (insn, operands);

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3554 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3758 (insn, operands);

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3557 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3761 (insn, operands);

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3560 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3764 (insn, operands);

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3563 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3767 (insn, operands);

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3566 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3770 (insn, operands);

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3569 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3773 (insn, operands);

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3572 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3776 (insn, operands);

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3575 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3779 (insn, operands);

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3578 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3782 (insn, operands);

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3581 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3785 (insn, operands);

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3584 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3788 (insn, operands);

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3587 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3791 (insn, operands);

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3590 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3794 (insn, operands);

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3593 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3797 (insn, operands);

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3596 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3800 (insn, operands);

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3599 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3803 (insn, operands);

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3602 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3806 (insn, operands);

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3605 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3809 (insn, operands);

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3608 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3812 (insn, operands);

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3611 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3815 (insn, operands);

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3614 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3818 (insn, operands);

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3617 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3821 (insn, operands);

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3620 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3824 (insn, operands);

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3623 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3827 (insn, operands);

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3626 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3830 (insn, operands);

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3629 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3833 (insn, operands);

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3632 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3836 (insn, operands);

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3635 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3839 (insn, operands);

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3638 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3842 (insn, operands);

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3641 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3845 (insn, operands);

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3644 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3848 (insn, operands);

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3647 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3851 (insn, operands);

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3650 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3854 (insn, operands);

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3653 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3857 (insn, operands);

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3656 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3860 (insn, operands);

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3659 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3863 (insn, operands);

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3662 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3866 (insn, operands);

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3665 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3869 (insn, operands);

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3668 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3872 (insn, operands);

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3671 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3875 (insn, operands);

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3674 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3878 (insn, operands);

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3677 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3881 (insn, operands);

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3680 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3884 (insn, operands);

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3683 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3887 (insn, operands);

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3686 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3890 (insn, operands);

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3689 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3893 (insn, operands);

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3692 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3896 (insn, operands);

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3695 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3899 (insn, operands);

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3698 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3902 (insn, operands);

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3701 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3905 (insn, operands);

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3704 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3908 (insn, operands);

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3707 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3911 (insn, operands);

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3710 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3914 (insn, operands);

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3713 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3917 (insn, operands);

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3716 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3920 (insn, operands);

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3719 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3923 (insn, operands);

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3722 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3926 (insn, operands);

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3725 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3929 (insn, operands);

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3728 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3932 (insn, operands);

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3731 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3935 (insn, operands);

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3734 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3938 (insn, operands);

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3737 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3941 (insn, operands);

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3740 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3944 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_121 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 91:
      return split_118 (x1, insn);

    case 138:
      switch (pattern236 (x2))
        {
        case 0:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5841 (insn, operands);

        case 1:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5843 (insn, operands);

        case 2:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5845 (insn, operands);

        case 3:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5847 (insn, operands);

        case 4:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5849 (insn, operands);

        case 5:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF4HFmode) && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5851 (insn, operands);

        case 6:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5853 (insn, operands);

        case 7:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5855 (insn, operands);

        case 8:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5857 (insn, operands);

        case 9:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5859 (insn, operands);

        case 10:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5861 (insn, operands);

        case 11:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5863 (insn, operands);

        case 12:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5865 (insn, operands);

        case 13:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5867 (insn, operands);

        case 14:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5869 (insn, operands);

        case 15:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1HFmode) && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5871 (insn, operands);

        case 16:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2HFmode) && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5873 (insn, operands);

        case 17:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4HFmode) && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5875 (insn, operands);

        case 18:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8HFmode) && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5877 (insn, operands);

        case 19:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16HFmode) && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5879 (insn, operands);

        case 20:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32HFmode) && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5881 (insn, operands);

        case 21:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64HFmode) && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5883 (insn, operands);

        case 22:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128HFmode) && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5885 (insn, operands);

        case 23:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256HFmode) && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5887 (insn, operands);

        case 24:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512HFmode) && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5889 (insn, operands);

        case 25:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024HFmode) && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5891 (insn, operands);

        case 26:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2048HFmode) && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5893 (insn, operands);

        case 27:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1SFmode) && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5895 (insn, operands);

        case 28:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2SFmode) && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5897 (insn, operands);

        case 29:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4SFmode) && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5899 (insn, operands);

        case 30:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8SFmode) && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5901 (insn, operands);

        case 31:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16SFmode) && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5903 (insn, operands);

        case 32:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32SFmode) && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5905 (insn, operands);

        case 33:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64SFmode) && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5907 (insn, operands);

        case 34:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128SFmode) && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5909 (insn, operands);

        case 35:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256SFmode) && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5911 (insn, operands);

        case 36:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512SFmode) && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5913 (insn, operands);

        case 37:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024SFmode) && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5915 (insn, operands);

        case 38:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1DFmode) && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5917 (insn, operands);

        case 39:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2DFmode) && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5919 (insn, operands);

        case 40:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4DFmode) && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5921 (insn, operands);

        case 41:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8DFmode) && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5923 (insn, operands);

        case 42:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16DFmode) && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5925 (insn, operands);

        case 43:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32DFmode) && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5927 (insn, operands);

        case 44:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64DFmode) && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5929 (insn, operands);

        case 45:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128DFmode) && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5931 (insn, operands);

        case 46:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256DFmode) && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5933 (insn, operands);

        case 47:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512DFmode) && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5935 (insn, operands);

        default:
          return NULL;
        }

    case 139:
      switch (pattern236 (x2))
        {
        case 0:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5842 (insn, operands);

        case 1:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5844 (insn, operands);

        case 2:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5846 (insn, operands);

        case 3:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5848 (insn, operands);

        case 4:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5850 (insn, operands);

        case 5:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF4HFmode) && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5852 (insn, operands);

        case 6:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5854 (insn, operands);

        case 7:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5856 (insn, operands);

        case 8:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5858 (insn, operands);

        case 9:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5860 (insn, operands);

        case 10:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5862 (insn, operands);

        case 11:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5864 (insn, operands);

        case 12:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5866 (insn, operands);

        case 13:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5868 (insn, operands);

        case 14:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5870 (insn, operands);

        case 15:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1HFmode) && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5872 (insn, operands);

        case 16:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2HFmode) && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5874 (insn, operands);

        case 17:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4HFmode) && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5876 (insn, operands);

        case 18:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8HFmode) && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5878 (insn, operands);

        case 19:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16HFmode) && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5880 (insn, operands);

        case 20:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32HFmode) && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5882 (insn, operands);

        case 21:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64HFmode) && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5884 (insn, operands);

        case 22:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128HFmode) && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5886 (insn, operands);

        case 23:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256HFmode) && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5888 (insn, operands);

        case 24:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512HFmode) && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5890 (insn, operands);

        case 25:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024HFmode) && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5892 (insn, operands);

        case 26:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2048HFmode) && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5894 (insn, operands);

        case 27:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1SFmode) && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5896 (insn, operands);

        case 28:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2SFmode) && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5898 (insn, operands);

        case 29:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4SFmode) && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5900 (insn, operands);

        case 30:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8SFmode) && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5902 (insn, operands);

        case 31:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16SFmode) && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5904 (insn, operands);

        case 32:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32SFmode) && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5906 (insn, operands);

        case 33:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64SFmode) && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5908 (insn, operands);

        case 34:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128SFmode) && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5910 (insn, operands);

        case 35:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256SFmode) && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5912 (insn, operands);

        case 36:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512SFmode) && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5914 (insn, operands);

        case 37:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024SFmode) && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5916 (insn, operands);

        case 38:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1DFmode) && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5918 (insn, operands);

        case 39:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2DFmode) && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5920 (insn, operands);

        case 40:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4DFmode) && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5922 (insn, operands);

        case 41:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8DFmode) && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5924 (insn, operands);

        case 42:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16DFmode) && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5926 (insn, operands);

        case 43:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32DFmode) && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5928 (insn, operands);

        case 44:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64DFmode) && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5930 (insn, operands);

        case 45:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128DFmode) && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5932 (insn, operands);

        case 46:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256DFmode) && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5934 (insn, operands);

        case 47:
          if (!((
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512DFmode) && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1579 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5936 (insn, operands);

        default:
          return NULL;
        }

    case 121:
      switch (pattern236 (x2))
        {
        case 0:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5937 (insn, operands);

        case 1:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5938 (insn, operands);

        case 2:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5939 (insn, operands);

        case 3:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5940 (insn, operands);

        case 4:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5941 (insn, operands);

        case 5:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5942 (insn, operands);

        case 6:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5943 (insn, operands);

        case 7:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5944 (insn, operands);

        case 8:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5945 (insn, operands);

        case 9:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5946 (insn, operands);

        case 10:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5947 (insn, operands);

        case 11:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5948 (insn, operands);

        case 12:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5949 (insn, operands);

        case 13:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5950 (insn, operands);

        case 14:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5951 (insn, operands);

        case 15:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5952 (insn, operands);

        case 16:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5953 (insn, operands);

        case 17:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5954 (insn, operands);

        case 18:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5955 (insn, operands);

        case 19:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5956 (insn, operands);

        case 20:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5957 (insn, operands);

        case 21:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5958 (insn, operands);

        case 22:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5959 (insn, operands);

        case 23:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5960 (insn, operands);

        case 24:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5961 (insn, operands);

        case 25:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5962 (insn, operands);

        case 26:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5963 (insn, operands);

        case 27:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5964 (insn, operands);

        case 28:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5965 (insn, operands);

        case 29:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5966 (insn, operands);

        case 30:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5967 (insn, operands);

        case 31:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5968 (insn, operands);

        case 32:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5969 (insn, operands);

        case 33:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5970 (insn, operands);

        case 34:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5971 (insn, operands);

        case 35:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5972 (insn, operands);

        case 36:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5973 (insn, operands);

        case 37:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5974 (insn, operands);

        case 38:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5975 (insn, operands);

        case 39:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5976 (insn, operands);

        case 40:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5977 (insn, operands);

        case 41:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5978 (insn, operands);

        case 42:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5979 (insn, operands);

        case 43:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5980 (insn, operands);

        case 44:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5981 (insn, operands);

        case 45:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5982 (insn, operands);

        case 46:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5983 (insn, operands);

        case 47:
          if (!((
#line 1603 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1605 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5984 (insn, operands);

        default:
          return NULL;
        }

    case 143:
      return split_119 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_131 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8QImode)
        || register_operand (operands[3], RVVM8QImode)))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_2309 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4QImode)
        || register_operand (operands[3], RVVM4QImode)))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_2310 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2QImode)
        || register_operand (operands[3], RVVM2QImode)))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_2311 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1QImode)
        || register_operand (operands[3], RVVM1QImode)))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_2312 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8HImode)
        || register_operand (operands[3], RVVM8HImode)))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_2313 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4HImode)
        || register_operand (operands[3], RVVM4HImode)))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_2314 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2HImode)
        || register_operand (operands[3], RVVM2HImode)))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_2315 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1HImode)
        || register_operand (operands[3], RVVM1HImode)))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_2316 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8SImode)
        || register_operand (operands[3], RVVM8SImode)))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_2317 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4SImode)
        || register_operand (operands[3], RVVM4SImode)))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_2318 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2SImode)
        || register_operand (operands[3], RVVM2SImode)))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_2319 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1SImode)
        || register_operand (operands[3], RVVM1SImode)))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_2320 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8DImode)
        || register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_2321 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4DImode)
        || register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_2322 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2DImode)
        || register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_2323 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1DImode)
        || register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_2324 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2QImode)
        || register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_2325 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4QImode)
        || register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_2326 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF8QImode)
        || register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_2327 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2HImode)
        || register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_2328 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4HImode)
        || register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_2329 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2SImode)
        || register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_2330 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8BFmode)
        || register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_2331 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4BFmode)
        || register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_2332 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2BFmode)
        || register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_2333 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1BFmode)
        || register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_2334 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
        || register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_2335 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
        || register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_2336 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8HFmode)
        || register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_2337 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4HFmode)
        || register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_2338 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2HFmode)
        || register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_2339 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1HFmode)
        || register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_2340 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
        || register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_2341 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
        || register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_2342 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8SFmode)
        || register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_2343 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4SFmode)
        || register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_2344 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2SFmode)
        || register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_2345 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1SFmode)
        || register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_2346 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
        || register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_2347 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8DFmode)
        || register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_2348 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4DFmode)
        || register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_2349 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2DFmode)
        || register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_2350 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1DFmode)
        || register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_2351 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1QImode)
        || register_operand (operands[3], V1QImode)))) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_2352 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2QImode)
        || register_operand (operands[3], V2QImode)))) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_2353 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4QImode)
        || register_operand (operands[3], V4QImode)))) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_2354 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8QImode)
        || register_operand (operands[3], V8QImode)))) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_2355 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16QImode)
        || register_operand (operands[3], V16QImode)))) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_2356 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32QImode)
        || register_operand (operands[3], V32QImode)))) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_2357 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64QImode)
        || register_operand (operands[3], V64QImode)))) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_2358 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128QImode)
        || register_operand (operands[3], V128QImode)))) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_2359 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256QImode)
        || register_operand (operands[3], V256QImode)))) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_2360 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512QImode)
        || register_operand (operands[3], V512QImode)))) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_2361 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024QImode)
        || register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_2362 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048QImode)
        || register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_2363 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4096QImode)
        || register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_2364 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1HImode)
        || register_operand (operands[3], V1HImode)))) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_2365 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2HImode)
        || register_operand (operands[3], V2HImode)))) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_2366 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4HImode)
        || register_operand (operands[3], V4HImode)))) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_2367 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8HImode)
        || register_operand (operands[3], V8HImode)))) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_2368 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16HImode)
        || register_operand (operands[3], V16HImode)))) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_2369 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32HImode)
        || register_operand (operands[3], V32HImode)))) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_2370 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64HImode)
        || register_operand (operands[3], V64HImode)))) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_2371 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128HImode)
        || register_operand (operands[3], V128HImode)))) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_2372 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256HImode)
        || register_operand (operands[3], V256HImode)))) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_2373 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512HImode)
        || register_operand (operands[3], V512HImode)))) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_2374 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024HImode)
        || register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_2375 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048HImode)
        || register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_2376 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1SImode)
        || register_operand (operands[3], V1SImode)))) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_2377 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2SImode)
        || register_operand (operands[3], V2SImode)))) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_2378 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4SImode)
        || register_operand (operands[3], V4SImode)))) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_2379 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8SImode)
        || register_operand (operands[3], V8SImode)))) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_2380 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16SImode)
        || register_operand (operands[3], V16SImode)))) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_2381 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32SImode)
        || register_operand (operands[3], V32SImode)))) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_2382 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64SImode)
        || register_operand (operands[3], V64SImode)))) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_2383 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128SImode)
        || register_operand (operands[3], V128SImode)))) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_2384 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256SImode)
        || register_operand (operands[3], V256SImode)))) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_2385 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512SImode)
        || register_operand (operands[3], V512SImode)))) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_2386 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024SImode)
        || register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_2387 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1DImode)
        || register_operand (operands[3], V1DImode)))) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_2388 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2DImode)
        || register_operand (operands[3], V2DImode)))) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_2389 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4DImode)
        || register_operand (operands[3], V4DImode)))) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_2390 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8DImode)
        || register_operand (operands[3], V8DImode)))) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_2391 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16DImode)
        || register_operand (operands[3], V16DImode)))) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_2392 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32DImode)
        || register_operand (operands[3], V32DImode)))) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_2393 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64DImode)
        || register_operand (operands[3], V64DImode)))) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_2394 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128DImode)
        || register_operand (operands[3], V128DImode)))) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_2395 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256DImode)
        || register_operand (operands[3], V256DImode)))) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_2396 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512DImode)
        || register_operand (operands[3], V512DImode)))) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_2397 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1HFmode)
        || register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_2398 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2HFmode)
        || register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_2399 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4HFmode)
        || register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_2400 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8HFmode)
        || register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_2401 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16HFmode)
        || register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_2402 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32HFmode)
        || register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_2403 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64HFmode)
        || register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_2404 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128HFmode)
        || register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_2405 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256HFmode)
        || register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_2406 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512HFmode)
        || register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_2407 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024HFmode)
        || register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_2408 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048HFmode)
        || register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_2409 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1SFmode)
        || register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_2410 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2SFmode)
        || register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_2411 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4SFmode)
        || register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_2412 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8SFmode)
        || register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_2413 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16SFmode)
        || register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_2414 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32SFmode)
        || register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_2415 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64SFmode)
        || register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_2416 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128SFmode)
        || register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_2417 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256SFmode)
        || register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_2418 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512SFmode)
        || register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_2419 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024SFmode)
        || register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_2420 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1DFmode)
        || register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_2421 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2DFmode)
        || register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_2422 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4DFmode)
        || register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_2423 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8DFmode)
        || register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_2424 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16DFmode)
        || register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_2425 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32DFmode)
        || register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_2426 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64DFmode)
        || register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_2427 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128DFmode)
        || register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_2428 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256DFmode)
        || register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_2429 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512DFmode)
        || register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_2430 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_141 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern158 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[2], E_RVVM8SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10249 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10309 (insn, operands);

    case 1:
      if (vector_shift_operand (operands[2], E_RVVM4SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10250 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10310 (insn, operands);

    case 2:
      if (vector_shift_operand (operands[2], E_RVVM2SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10251 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10311 (insn, operands);

    case 3:
      if (vector_shift_operand (operands[2], E_RVVM1SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10252 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10312 (insn, operands);

    case 4:
      if (vector_shift_operand (operands[2], E_RVVMF2SImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10253 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10313 (insn, operands);

    case 5:
      if (vector_shift_operand (operands[2], E_RVVM8DImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10254 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10314 (insn, operands);

    case 6:
      if (vector_shift_operand (operands[2], E_RVVM4DImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10255 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10315 (insn, operands);

    case 7:
      if (vector_shift_operand (operands[2], E_RVVM2DImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10256 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10316 (insn, operands);

    case 8:
      if (vector_shift_operand (operands[2], E_RVVM1DImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10257 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10317 (insn, operands);

    case 9:
      if (vector_shift_operand (operands[2], E_V1SImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10258 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10318 (insn, operands);

    case 10:
      if (vector_shift_operand (operands[2], E_V2SImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10259 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10319 (insn, operands);

    case 11:
      if (vector_shift_operand (operands[2], E_V4SImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10260 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10320 (insn, operands);

    case 12:
      if (vector_shift_operand (operands[2], E_V8SImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10261 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10321 (insn, operands);

    case 13:
      if (vector_shift_operand (operands[2], E_V16SImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10262 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10322 (insn, operands);

    case 14:
      if (vector_shift_operand (operands[2], E_V32SImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10263 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10323 (insn, operands);

    case 15:
      if (vector_shift_operand (operands[2], E_V64SImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10264 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10324 (insn, operands);

    case 16:
      if (vector_shift_operand (operands[2], E_V128SImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10265 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10325 (insn, operands);

    case 17:
      if (vector_shift_operand (operands[2], E_V256SImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10266 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10326 (insn, operands);

    case 18:
      if (vector_shift_operand (operands[2], E_V512SImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10267 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10327 (insn, operands);

    case 19:
      if (vector_shift_operand (operands[2], E_V1024SImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10268 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10328 (insn, operands);

    case 20:
      if (vector_shift_operand (operands[2], E_V1DImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10269 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10329 (insn, operands);

    case 21:
      if (vector_shift_operand (operands[2], E_V2DImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10270 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10330 (insn, operands);

    case 22:
      if (vector_shift_operand (operands[2], E_V4DImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10271 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10331 (insn, operands);

    case 23:
      if (vector_shift_operand (operands[2], E_V8DImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10272 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10332 (insn, operands);

    case 24:
      if (vector_shift_operand (operands[2], E_V16DImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10273 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10333 (insn, operands);

    case 25:
      if (vector_shift_operand (operands[2], E_V32DImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10274 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10334 (insn, operands);

    case 26:
      if (vector_shift_operand (operands[2], E_V64DImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10275 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10335 (insn, operands);

    case 27:
      if (vector_shift_operand (operands[2], E_V128DImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10276 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10336 (insn, operands);

    case 28:
      if (vector_shift_operand (operands[2], E_V256DImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10277 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10337 (insn, operands);

    case 29:
      if (vector_shift_operand (operands[2], E_V512DImode)
          && ((
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1554 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10278 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1595 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10338 (insn, operands);

    case 30:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10279 (insn, operands);

    case 31:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10280 (insn, operands);

    case 32:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10281 (insn, operands);

    case 33:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10282 (insn, operands);

    case 34:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10283 (insn, operands);

    case 35:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10284 (insn, operands);

    case 36:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10285 (insn, operands);

    case 37:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10286 (insn, operands);

    case 38:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10287 (insn, operands);

    case 39:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10288 (insn, operands);

    case 40:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10289 (insn, operands);

    case 41:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10290 (insn, operands);

    case 42:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10291 (insn, operands);

    case 43:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10292 (insn, operands);

    case 44:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10293 (insn, operands);

    case 45:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10294 (insn, operands);

    case 46:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10295 (insn, operands);

    case 47:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10296 (insn, operands);

    case 48:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10297 (insn, operands);

    case 49:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10298 (insn, operands);

    case 50:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10299 (insn, operands);

    case 51:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10300 (insn, operands);

    case 52:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10301 (insn, operands);

    case 53:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10302 (insn, operands);

    case 54:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10303 (insn, operands);

    case 55:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10304 (insn, operands);

    case 56:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10305 (insn, operands);

    case 57:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10306 (insn, operands);

    case 58:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10307 (insn, operands);

    case 59:
      if (!((
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1577 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10308 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_145 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      return split_136 (x1, insn);

    case MULT:
      return split_137 (x1, insn);

    case NEG:
      switch (pattern144 (x2))
        {
        case 0:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5505 (insn, operands);

        case 1:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5506 (insn, operands);

        case 2:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5507 (insn, operands);

        case 3:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5508 (insn, operands);

        case 4:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5509 (insn, operands);

        case 5:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5510 (insn, operands);

        case 6:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5511 (insn, operands);

        case 7:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5512 (insn, operands);

        case 8:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5513 (insn, operands);

        case 9:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5514 (insn, operands);

        case 10:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5515 (insn, operands);

        case 11:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5516 (insn, operands);

        case 12:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5517 (insn, operands);

        case 13:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5518 (insn, operands);

        case 14:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5519 (insn, operands);

        case 15:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5520 (insn, operands);

        case 16:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5521 (insn, operands);

        case 17:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5522 (insn, operands);

        case 18:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5523 (insn, operands);

        case 19:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5524 (insn, operands);

        case 20:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5525 (insn, operands);

        case 21:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5526 (insn, operands);

        case 22:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5527 (insn, operands);

        case 23:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5528 (insn, operands);

        case 24:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5529 (insn, operands);

        case 25:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5530 (insn, operands);

        case 26:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5531 (insn, operands);

        case 27:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5532 (insn, operands);

        case 28:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5533 (insn, operands);

        case 29:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5534 (insn, operands);

        case 30:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5535 (insn, operands);

        case 31:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5536 (insn, operands);

        case 32:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5537 (insn, operands);

        case 33:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5538 (insn, operands);

        case 34:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5539 (insn, operands);

        case 35:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5540 (insn, operands);

        case 36:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5541 (insn, operands);

        case 37:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5542 (insn, operands);

        case 38:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5543 (insn, operands);

        case 39:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5544 (insn, operands);

        case 40:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5545 (insn, operands);

        case 41:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5546 (insn, operands);

        case 42:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5547 (insn, operands);

        case 43:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5548 (insn, operands);

        case 44:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5549 (insn, operands);

        case 45:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5550 (insn, operands);

        case 46:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5551 (insn, operands);

        case 47:
          if (!((
#line 1301 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1303 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5552 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != SIGN_EXTEND)
        return NULL;
      switch (pattern147 (x2))
        {
        case 0:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8134 (insn, operands);

        case 1:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8140 (insn, operands);

        case 2:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8146 (insn, operands);

        case 3:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8152 (insn, operands);

        case 4:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8158 (insn, operands);

        case 5:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8164 (insn, operands);

        case 6:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8170 (insn, operands);

        case 7:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8176 (insn, operands);

        case 8:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8182 (insn, operands);

        case 9:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8188 (insn, operands);

        case 10:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8194 (insn, operands);

        case 11:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8200 (insn, operands);

        case 12:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8206 (insn, operands);

        case 13:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8212 (insn, operands);

        case 14:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8218 (insn, operands);

        case 15:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8224 (insn, operands);

        case 16:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8230 (insn, operands);

        case 17:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8236 (insn, operands);

        case 18:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8242 (insn, operands);

        case 19:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8248 (insn, operands);

        case 20:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8254 (insn, operands);

        case 21:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8260 (insn, operands);

        case 22:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8266 (insn, operands);

        case 23:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8272 (insn, operands);

        case 24:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8278 (insn, operands);

        case 25:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8284 (insn, operands);

        case 26:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8290 (insn, operands);

        case 27:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8296 (insn, operands);

        case 28:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8302 (insn, operands);

        case 29:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8308 (insn, operands);

        case 30:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8314 (insn, operands);

        case 31:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8320 (insn, operands);

        case 32:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8326 (insn, operands);

        case 33:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8332 (insn, operands);

        case 34:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8338 (insn, operands);

        case 35:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8344 (insn, operands);

        case 36:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8350 (insn, operands);

        case 37:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8356 (insn, operands);

        case 38:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8362 (insn, operands);

        case 39:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8368 (insn, operands);

        case 40:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8374 (insn, operands);

        case 41:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8380 (insn, operands);

        case 42:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8386 (insn, operands);

        case 43:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8392 (insn, operands);

        case 44:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8398 (insn, operands);

        case 45:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8404 (insn, operands);

        case 46:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8410 (insn, operands);

        case 47:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8416 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ZERO_EXTEND)
        return NULL;
      switch (pattern147 (x2))
        {
        case 0:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8135 (insn, operands);

        case 1:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8141 (insn, operands);

        case 2:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8147 (insn, operands);

        case 3:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8153 (insn, operands);

        case 4:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8159 (insn, operands);

        case 5:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8165 (insn, operands);

        case 6:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8171 (insn, operands);

        case 7:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8177 (insn, operands);

        case 8:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8183 (insn, operands);

        case 9:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8189 (insn, operands);

        case 10:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8195 (insn, operands);

        case 11:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8201 (insn, operands);

        case 12:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8207 (insn, operands);

        case 13:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8213 (insn, operands);

        case 14:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8219 (insn, operands);

        case 15:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8225 (insn, operands);

        case 16:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8231 (insn, operands);

        case 17:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8237 (insn, operands);

        case 18:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8243 (insn, operands);

        case 19:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8249 (insn, operands);

        case 20:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8255 (insn, operands);

        case 21:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8261 (insn, operands);

        case 22:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8267 (insn, operands);

        case 23:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8273 (insn, operands);

        case 24:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8279 (insn, operands);

        case 25:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8285 (insn, operands);

        case 26:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8291 (insn, operands);

        case 27:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8297 (insn, operands);

        case 28:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8303 (insn, operands);

        case 29:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8309 (insn, operands);

        case 30:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8315 (insn, operands);

        case 31:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8321 (insn, operands);

        case 32:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8327 (insn, operands);

        case 33:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8333 (insn, operands);

        case 34:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8339 (insn, operands);

        case 35:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8345 (insn, operands);

        case 36:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8351 (insn, operands);

        case 37:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8357 (insn, operands);

        case 38:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8363 (insn, operands);

        case 39:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8369 (insn, operands);

        case 40:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8375 (insn, operands);

        case 41:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8381 (insn, operands);

        case 42:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8387 (insn, operands);

        case 43:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8393 (insn, operands);

        case 44:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8399 (insn, operands);

        case 45:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8405 (insn, operands);

        case 46:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8411 (insn, operands);

        case 47:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8417 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_EXTEND:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != FLOAT_EXTEND)
        return NULL;
      switch (pattern129 (x2))
        {
        case 0:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8805 (insn, operands);

        case 1:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8808 (insn, operands);

        case 2:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8811 (insn, operands);

        case 3:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8814 (insn, operands);

        case 4:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8817 (insn, operands);

        case 5:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8820 (insn, operands);

        case 6:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8823 (insn, operands);

        case 7:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8826 (insn, operands);

        case 8:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8829 (insn, operands);

        case 9:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8832 (insn, operands);

        case 10:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8835 (insn, operands);

        case 11:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8838 (insn, operands);

        case 12:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8841 (insn, operands);

        case 13:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8844 (insn, operands);

        case 14:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8847 (insn, operands);

        case 15:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8850 (insn, operands);

        case 16:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8853 (insn, operands);

        case 17:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8856 (insn, operands);

        case 18:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8859 (insn, operands);

        case 19:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8862 (insn, operands);

        case 20:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8865 (insn, operands);

        case 21:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8868 (insn, operands);

        case 22:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8871 (insn, operands);

        case 23:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8874 (insn, operands);

        case 24:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8877 (insn, operands);

        case 25:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8880 (insn, operands);

        case 26:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8883 (insn, operands);

        case 27:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8886 (insn, operands);

        case 28:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8889 (insn, operands);

        case 29:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8892 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_158 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern123 (x2))
    {
    case 0:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2594 (insn, operands);

    case 1:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2608 (insn, operands);

    case 2:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2622 (insn, operands);

    case 3:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2636 (insn, operands);

    case 4:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2650 (insn, operands);

    case 5:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2664 (insn, operands);

    case 6:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2678 (insn, operands);

    case 7:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2692 (insn, operands);

    case 8:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2706 (insn, operands);

    case 9:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2720 (insn, operands);

    case 10:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2734 (insn, operands);

    case 11:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2748 (insn, operands);

    case 12:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2762 (insn, operands);

    case 13:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2776 (insn, operands);

    case 14:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2790 (insn, operands);

    case 15:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2804 (insn, operands);

    case 16:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2818 (insn, operands);

    case 17:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2832 (insn, operands);

    case 18:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2846 (insn, operands);

    case 19:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2860 (insn, operands);

    case 20:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2874 (insn, operands);

    case 21:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2888 (insn, operands);

    case 22:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2902 (insn, operands);

    case 23:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2916 (insn, operands);

    case 24:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2930 (insn, operands);

    case 25:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2944 (insn, operands);

    case 26:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2958 (insn, operands);

    case 27:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2972 (insn, operands);

    case 28:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2986 (insn, operands);

    case 29:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3000 (insn, operands);

    case 30:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3014 (insn, operands);

    case 31:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3028 (insn, operands);

    case 32:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3042 (insn, operands);

    case 33:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3056 (insn, operands);

    case 34:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3070 (insn, operands);

    case 35:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3084 (insn, operands);

    case 36:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3098 (insn, operands);

    case 37:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3112 (insn, operands);

    case 38:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3126 (insn, operands);

    case 39:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3140 (insn, operands);

    case 40:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3154 (insn, operands);

    case 41:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3168 (insn, operands);

    case 42:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3182 (insn, operands);

    case 43:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3196 (insn, operands);

    case 44:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3210 (insn, operands);

    case 45:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3224 (insn, operands);

    case 46:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3238 (insn, operands);

    case 47:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3252 (insn, operands);

    case 48:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3266 (insn, operands);

    case 49:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3280 (insn, operands);

    case 50:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3294 (insn, operands);

    case 51:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3308 (insn, operands);

    case 52:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3322 (insn, operands);

    case 53:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3336 (insn, operands);

    case 54:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3350 (insn, operands);

    case 55:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3364 (insn, operands);

    case 56:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3378 (insn, operands);

    case 57:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3392 (insn, operands);

    case 58:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3406 (insn, operands);

    case 59:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3420 (insn, operands);

    case 60:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3434 (insn, operands);

    case 61:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3448 (insn, operands);

    case 62:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3462 (insn, operands);

    case 63:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3476 (insn, operands);

    case 64:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3490 (insn, operands);

    case 65:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3504 (insn, operands);

    case 66:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3518 (insn, operands);

    case 67:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3532 (insn, operands);

    case 68:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5746 (insn, operands);

    case 69:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5748 (insn, operands);

    case 70:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5750 (insn, operands);

    case 71:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5752 (insn, operands);

    case 72:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5754 (insn, operands);

    case 73:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5756 (insn, operands);

    case 74:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5758 (insn, operands);

    case 75:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5760 (insn, operands);

    case 76:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5762 (insn, operands);

    case 77:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5764 (insn, operands);

    case 78:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5766 (insn, operands);

    case 79:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5768 (insn, operands);

    case 80:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5770 (insn, operands);

    case 81:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5772 (insn, operands);

    case 82:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5774 (insn, operands);

    case 83:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5776 (insn, operands);

    case 84:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5778 (insn, operands);

    case 85:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5780 (insn, operands);

    case 86:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5782 (insn, operands);

    case 87:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5784 (insn, operands);

    case 88:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5786 (insn, operands);

    case 89:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5788 (insn, operands);

    case 90:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5790 (insn, operands);

    case 91:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5792 (insn, operands);

    case 92:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5794 (insn, operands);

    case 93:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5796 (insn, operands);

    case 94:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5798 (insn, operands);

    case 95:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5800 (insn, operands);

    case 96:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5802 (insn, operands);

    case 97:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5804 (insn, operands);

    case 98:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5806 (insn, operands);

    case 99:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5808 (insn, operands);

    case 100:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5810 (insn, operands);

    case 101:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5812 (insn, operands);

    case 102:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5814 (insn, operands);

    case 103:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5816 (insn, operands);

    case 104:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5818 (insn, operands);

    case 105:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5820 (insn, operands);

    case 106:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5822 (insn, operands);

    case 107:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5824 (insn, operands);

    case 108:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5826 (insn, operands);

    case 109:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5828 (insn, operands);

    case 110:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5830 (insn, operands);

    case 111:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5832 (insn, operands);

    case 112:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5834 (insn, operands);

    case 113:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5836 (insn, operands);

    case 114:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5838 (insn, operands);

    case 115:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5840 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_172 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (equality_operator (x4, E_VOIDmode))
    {
      switch (pattern414 (x3))
        {
        case 0:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3168 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3170 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_54 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3168 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3170 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_57 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3229 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_77 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3229 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_81 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case 1:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3168 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3170 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_55 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3168 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3170 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_58 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3229 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_78 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3229 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_82 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case 2:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3168 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3170 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_56 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3168 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3170 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_59 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3229 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_79 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3229 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_83 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case 3:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode)
              && scratch_operand (operands[4], E_DImode)
              && ((
#line 3168 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3170 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
            return gen_split_60 (insn, operands);
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && ((((
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3229 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_80 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3229 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_84 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case 4:
          x5 = XEXP (x4, 0);
          x6 = XEXP (x5, 1);
          if (XWINT (x6, 0) == 1L)
            {
              switch (pattern460 (x3))
                {
                case 0:
                  if ((
#line 3435 "../../../gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return gen_split_97 (insn, operands);
                  break;

                case 1:
                  if ((
#line 3435 "../../../gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return gen_split_98 (insn, operands);
                  break;

                case 2:
                  if (((
#line 1143 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 1145 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_185 (insn, operands);
                  break;

                case 3:
                  if (((
#line 1143 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1145 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_186 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          x7 = XEXP (x5, 2);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (pattern461 (x3))
                {
                case 0:
                  if ((
#line 3467 "../../../gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return gen_split_99 (insn, operands);
                  break;

                case 1:
                  if ((
#line 3467 "../../../gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return gen_split_100 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
    }
  if (!ne_operator (x4, E_VOIDmode))
    return NULL;
  switch (pattern406 (x3))
    {
    case 0:
      if (!((
#line 3398 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3400 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_91 (insn, operands);

    case 1:
      if (!((
#line 3398 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3400 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_92 (insn, operands);

    case 2:
      if (!((
#line 3398 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3400 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_93 (insn, operands);

    case 3:
      if (!((
#line 3398 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3400 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_94 (insn, operands);

    case 4:
      if (!((
#line 3398 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3400 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_95 (insn, operands);

    case 5:
      if (!((
#line 3398 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3400 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_96 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case PLUS:
          return split_148 (x1, insn);

        case ZERO_EXTEND:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
            case MEM:
              return split_8 (x1, insn);

            case PLUS:
              if (GET_MODE (x4) != E_SImode)
                return NULL;
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x5), 0)
                  || GET_MODE (x5) != E_SImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return NULL;
              x6 = XEXP (x4, 0);
              if (GET_MODE (x6) != E_SImode)
                return NULL;
              x7 = XEXP (x5, 0);
              if (!register_operand (x7, E_DImode))
                return NULL;
              switch (GET_CODE (x6))
                {
                case ASHIFT:
                  x8 = XEXP (x6, 0);
                  if (GET_CODE (x8) != SUBREG
                      || maybe_ne (SUBREG_BYTE (x8), 0)
                      || GET_MODE (x8) != E_SImode)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  operands[1] = x9;
                  if (!register_operand (operands[1], E_DImode))
                    return NULL;
                  x10 = XEXP (x6, 1);
                  operands[2] = x10;
                  if (!imm123_operand (operands[2], E_QImode))
                    return NULL;
                  operands[3] = x7;
                  if (!
#line 72 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA))
                    return NULL;
                  return gen_split_107 (insn, operands);

                case SUBREG:
                  if (maybe_ne (SUBREG_BYTE (x6), 0))
                    return NULL;
                  x8 = XEXP (x6, 0);
                  if (pattern415 (x8) != 0
                      || !imm123_operand (operands[2], E_QImode))
                    return NULL;
                  x11 = XEXP (x8, 1);
                  operands[3] = x11;
                  if (!consecutive_bits_operand (operands[3], E_DImode))
                    return NULL;
                  operands[4] = x7;
                  if (!
#line 82 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA
   && riscv_shamt_matches_mask_p (INTVAL (operands[2]), INTVAL (operands[3]))))
                    return NULL;
                  return gen_split_108 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFT:
              if (GET_MODE (x4) != E_SImode)
                return NULL;
              x6 = XEXP (x4, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x5 = XEXP (x4, 1);
              if (pattern326 (x5) != 0
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return NULL;
              x7 = XEXP (x5, 0);
              x12 = XEXP (x7, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_DImode))
                return NULL;
              x13 = XEXP (x7, 1);
              operands[2] = x13;
              if (!const_int_operand (operands[2], E_VOIDmode)
                  || !(
#line 659 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 663 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_138 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
            case MEM:
              return split_9 (x1, insn);

            case ASHIFT:
              switch (pattern135 (x3))
                {
                case 0:
                  x5 = XEXP (x4, 1);
                  if (!subreg_lowpart_operator (x5, E_VOIDmode))
                    return NULL;
                  switch (pattern396 (x5))
                    {
                    case 0:
                      if (!(
#line 2967 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 2969 "../../../gcc/config/riscv/riscv.md"
( 1)))
                        return NULL;
                      return gen_split_34 (insn, operands);

                    case 1:
                      if (!(
#line 2967 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 2969 "../../../gcc/config/riscv/riscv.md"
( 1)))
                        return NULL;
                      return gen_split_37 (insn, operands);

                    default:
                      return NULL;
                    }

                case 1:
                  x5 = XEXP (x4, 1);
                  if (pattern326 (x5) != 0)
                    return NULL;
                  x7 = XEXP (x5, 0);
                  x12 = XEXP (x7, 0);
                  operands[1] = x12;
                  if (!register_operand (operands[1], E_DImode))
                    return NULL;
                  x13 = XEXP (x7, 1);
                  operands[2] = x13;
                  if (!const_int_operand (operands[2], E_VOIDmode)
                      || !(
#line 659 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 663 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
                    return NULL;
                  return gen_split_137 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFTRT:
              switch (pattern223 (x3))
                {
                case 0:
                  if (!(
#line 2967 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 2969 "../../../gcc/config/riscv/riscv.md"
( 1)))
                    return NULL;
                  return gen_split_35 (insn, operands);

                case 1:
                  if (!(
#line 2967 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 2969 "../../../gcc/config/riscv/riscv.md"
( 1)))
                    return NULL;
                  return gen_split_38 (insn, operands);

                default:
                  return NULL;
                }

            case LSHIFTRT:
              switch (pattern223 (x3))
                {
                case 0:
                  if (!(
#line 2967 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 2969 "../../../gcc/config/riscv/riscv.md"
( 1)))
                    return NULL;
                  return gen_split_36 (insn, operands);

                case 1:
                  if (!(
#line 2967 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT) && 
#line 2969 "../../../gcc/config/riscv/riscv.md"
( 1)))
                    return NULL;
                  return gen_split_39 (insn, operands);

                default:
                  return NULL;
                }

            case ROTATE:
              switch (pattern223 (x3))
                {
                case 0:
                  if (!(
#line 450 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)) && 
#line 452 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
                    return NULL;
                  return gen_split_125 (insn, operands);

                case 1:
                  if (!((
#line 450 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 452 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
                    return NULL;
                  return gen_split_127 (insn, operands);

                default:
                  return NULL;
                }

            case ROTATERT:
              switch (pattern223 (x3))
                {
                case 0:
                  if (!(
#line 450 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)) && 
#line 452 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
                    return NULL;
                  return gen_split_126 (insn, operands);

                case 1:
                  if (!((
#line 450 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 452 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
                    return NULL;
                  return gen_split_128 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x3;
          return split_110 (x1, insn);

        case ASHIFT:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              x14 = XEXP (x3, 1);
              if (subreg_lowpart_operator (x14, E_VOIDmode))
                {
                  switch (pattern265 (x3))
                    {
                    case 0:
                      return gen_split_22 (insn, operands);

                    case 1:
                      if ((
#line 31 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../../gcc/config/riscv/riscv.md"
( 1)))
                        return gen_split_28 (insn, operands);
                      break;

                    case 2:
                      if ((
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../../gcc/config/riscv/riscv.md"
( 1)))
                        return gen_split_25 (insn, operands);
                      break;

                    case 3:
                      if ((
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../../gcc/config/riscv/riscv.md"
( 1)))
                        return gen_split_31 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              operands[2] = x14;
              return split_111 (x1, insn);

            case ZERO_EXTEND:
              return split_112 (x1, insn);

            default:
              return NULL;
            }

        case ASHIFTRT:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          x14 = XEXP (x3, 1);
          if (subreg_lowpart_operator (x14, E_VOIDmode))
            {
              switch (pattern265 (x3))
                {
                case 0:
                  return gen_split_23 (insn, operands);

                case 1:
                  if ((
#line 31 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../../gcc/config/riscv/riscv.md"
( 1)))
                    return gen_split_29 (insn, operands);
                  break;

                case 2:
                  if ((
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../../gcc/config/riscv/riscv.md"
( 1)))
                    return gen_split_26 (insn, operands);
                  break;

                case 3:
                  if ((
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../../gcc/config/riscv/riscv.md"
( 1)))
                    return gen_split_32 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          operands[2] = x14;
          return split_113 (x1, insn);

        case LSHIFTRT:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          x14 = XEXP (x3, 1);
          if (subreg_lowpart_operator (x14, E_VOIDmode))
            {
              switch (pattern265 (x3))
                {
                case 0:
                  return gen_split_24 (insn, operands);

                case 1:
                  if ((
#line 31 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../../gcc/config/riscv/riscv.md"
( 1)))
                    return gen_split_30 (insn, operands);
                  break;

                case 2:
                  if ((
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../../gcc/config/riscv/riscv.md"
( 1)))
                    return gen_split_27 (insn, operands);
                  break;

                case 3:
                  if ((
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 2935 "../../../gcc/config/riscv/riscv.md"
( 1)))
                    return gen_split_33 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          operands[2] = x14;
          return split_114 (x1, insn);

        case AND:
          return split_144 (x1, insn);

        case IOR:
          return split_147 (x1, insn);

        case XOR:
          return split_160 (x1, insn);

        case ROTATE:
          switch (pattern122 (x3))
            {
            case 0:
              if (!(
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 434 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_117 (insn, operands);

            case 1:
              if (!((
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 31 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 434 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_121 (insn, operands);

            case 2:
              if (!((
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 434 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_119 (insn, operands);

            case 3:
              if (!((
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 434 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_123 (insn, operands);

            default:
              return NULL;
            }

        case ROTATERT:
          switch (pattern122 (x3))
            {
            case 0:
              if (!(
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 434 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_118 (insn, operands);

            case 1:
              if (!((
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 31 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 434 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_122 (insn, operands);

            case 2:
              if (!((
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 434 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_120 (insn, operands);

            case 3:
              if (!((
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 434 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
                return NULL;
              return gen_split_124 (insn, operands);

            default:
              return NULL;
            }

        case NEG:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case EQ:
              x6 = XEXP (x4, 0);
              if (GET_CODE (x6) != ZERO_EXTRACT)
                return NULL;
              x10 = XEXP (x6, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x5 = XEXP (x4, 1);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x15 = XEXP (x6, 2);
              operands[2] = x15;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern256 (x3, 
E_SImode) != 0
                      || !
#line 1010 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS))
                    return NULL;
                  return gen_split_174 (insn, operands);

                case E_DImode:
                  if (pattern256 (x3, 
E_DImode) != 0
                      || !(
#line 1010 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return NULL;
                  return gen_split_175 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              operands[1] = x4;
              return split_116 (x1, insn);

            case UNSPEC:
              switch (pattern146 (x3))
                {
                case 0:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9950 (insn, operands);

                case 1:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9951 (insn, operands);

                case 2:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9952 (insn, operands);

                case 3:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9953 (insn, operands);

                case 4:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9954 (insn, operands);

                case 5:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9955 (insn, operands);

                case 6:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9956 (insn, operands);

                case 7:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9957 (insn, operands);

                case 8:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9958 (insn, operands);

                case 9:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9959 (insn, operands);

                case 10:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9960 (insn, operands);

                case 11:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9961 (insn, operands);

                case 12:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9962 (insn, operands);

                case 13:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9963 (insn, operands);

                case 14:
                  if (!((
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1404 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                    return NULL;
                  return gen_split_9964 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case UNSPEC:
          return split_169 (x1, insn);

        case IF_THEN_ELSE:
          return split_159 (x1, insn);

        case VEC_DUPLICATE:
          return split_153 (x1, insn);

        case MINUS:
          return split_145 (x1, insn);

        case SMAX:
          return split_157 (x1, insn);

        case UMAX:
          return split_167 (x1, insn);

        case SMIN:
          return split_158 (x1, insn);

        case UMIN:
          return split_166 (x1, insn);

        case MULT:
          return split_146 (x1, insn);

        case DIV:
          return split_156 (x1, insn);

        case UDIV:
          return split_165 (x1, insn);

        case MOD:
          return split_163 (x1, insn);

        case UMOD:
          return split_164 (x1, insn);

        case NOT:
          return split_168 (x1, insn);

        case TRUNCATE:
          return split_143 (x1, insn);

        case FLOAT_EXTEND:
          return split_155 (x1, insn);

        case FLOAT_TRUNCATE:
          return split_154 (x1, insn);

        case FIX:
          return split_152 (x1, insn);

        case UNSIGNED_FIX:
          return split_151 (x1, insn);

        case FLOAT:
          return split_150 (x1, insn);

        case UNSIGNED_FLOAT:
          return split_149 (x1, insn);

        case ABS:
          switch (pattern127 (x3))
            {
            case 0:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5082 (insn, operands);

            case 1:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5084 (insn, operands);

            case 2:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5086 (insn, operands);

            case 3:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5088 (insn, operands);

            case 4:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5090 (insn, operands);

            case 5:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5092 (insn, operands);

            case 6:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5094 (insn, operands);

            case 7:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5096 (insn, operands);

            case 8:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5098 (insn, operands);

            case 9:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5100 (insn, operands);

            case 10:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5102 (insn, operands);

            case 11:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5104 (insn, operands);

            case 12:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5106 (insn, operands);

            case 13:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5108 (insn, operands);

            case 14:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5110 (insn, operands);

            case 15:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5112 (insn, operands);

            case 16:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5114 (insn, operands);

            case 17:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5116 (insn, operands);

            case 18:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5118 (insn, operands);

            case 19:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5120 (insn, operands);

            case 20:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5122 (insn, operands);

            case 21:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5124 (insn, operands);

            case 22:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5126 (insn, operands);

            case 23:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5128 (insn, operands);

            case 24:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5130 (insn, operands);

            case 25:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5132 (insn, operands);

            case 26:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5134 (insn, operands);

            case 27:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5136 (insn, operands);

            case 28:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5138 (insn, operands);

            case 29:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5140 (insn, operands);

            case 30:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5142 (insn, operands);

            case 31:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5144 (insn, operands);

            case 32:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5146 (insn, operands);

            case 33:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5148 (insn, operands);

            case 34:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5150 (insn, operands);

            case 35:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5152 (insn, operands);

            case 36:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5154 (insn, operands);

            case 37:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5156 (insn, operands);

            case 38:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5158 (insn, operands);

            case 39:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5160 (insn, operands);

            case 40:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5162 (insn, operands);

            case 41:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5164 (insn, operands);

            case 42:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5166 (insn, operands);

            case 43:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5168 (insn, operands);

            case 44:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5170 (insn, operands);

            case 45:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5172 (insn, operands);

            case 46:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5174 (insn, operands);

            case 47:
              if (!((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_5176 (insn, operands);

            default:
              return NULL;
            }

        case SQRT:
          return split_171 (x1, insn);

        case SMUL_HIGHPART:
          return split_162 (x1, insn);

        case UMUL_HIGHPART:
          return split_161 (x1, insn);

        case POPCOUNT:
          return split_170 (x1, insn);

        default:
          return NULL;
        }

    case PARALLEL:
      return split_178 (x1, insn);

    case EH_RETURN:
      if (!
#line 3901 "../../../gcc/config/riscv/riscv.md"
(epilogue_completed))
        return NULL;
      return gen_split_102 (insn, operands);

    default:
      return NULL;
    }
}
