/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_HFmode:
      if (pattern0 (x3, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 4;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 5;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 6;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 7;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 8;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 9;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 10;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 11;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 16;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 17;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 18;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 19;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 22;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 23;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 24;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 26;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 27;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 28;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 29;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 30;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 31;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 32;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 33;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 34;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 35;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 36;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 37;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 38;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 39;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 40;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 41;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 42;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 43;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 44;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 45;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 46;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 47;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 48;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 49;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 50;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 51;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 52;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 53;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 54;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 55;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 56;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 57;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 58;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 59;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 60;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 61;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 62;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 63;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 64;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 65;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 66;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 67;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 68;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 69;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 70;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 71;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 72;

    case E_RVVM8HFmode:
      if (pattern0 (x3, 
E_RVVM8HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM4HFmode:
      if (pattern0 (x3, 
E_RVVM4HFmode) != 0)
        return -1;
      return 74;

    case E_RVVM2HFmode:
      if (pattern0 (x3, 
E_RVVM2HFmode) != 0)
        return -1;
      return 75;

    case E_RVVM1HFmode:
      if (pattern0 (x3, 
E_RVVM1HFmode) != 0)
        return -1;
      return 76;

    case E_RVVMF2HFmode:
      if (pattern0 (x3, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF4HFmode:
      if (pattern0 (x3, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8SFmode:
      if (pattern0 (x3, 
E_RVVM8SFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4SFmode:
      if (pattern0 (x3, 
E_RVVM4SFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2SFmode:
      if (pattern0 (x3, 
E_RVVM2SFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1SFmode:
      if (pattern0 (x3, 
E_RVVM1SFmode) != 0)
        return -1;
      return 82;

    case E_RVVMF2SFmode:
      if (pattern0 (x3, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 83;

    case E_RVVM8DFmode:
      if (pattern0 (x3, 
E_RVVM8DFmode) != 0)
        return -1;
      return 84;

    case E_RVVM4DFmode:
      if (pattern0 (x3, 
E_RVVM4DFmode) != 0)
        return -1;
      return 85;

    case E_RVVM2DFmode:
      if (pattern0 (x3, 
E_RVVM2DFmode) != 0)
        return -1;
      return 86;

    case E_RVVM1DFmode:
      if (pattern0 (x3, 
E_RVVM1DFmode) != 0)
        return -1;
      return 87;

    case E_V1HFmode:
      if (pattern0 (x3, 
E_V1HFmode) != 0)
        return -1;
      return 88;

    case E_V2HFmode:
      if (pattern0 (x3, 
E_V2HFmode) != 0)
        return -1;
      return 89;

    case E_V4HFmode:
      if (pattern0 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 90;

    case E_V8HFmode:
      if (pattern0 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 91;

    case E_V16HFmode:
      if (pattern0 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 92;

    case E_V32HFmode:
      if (pattern0 (x3, 
E_V32HFmode) != 0)
        return -1;
      return 93;

    case E_V64HFmode:
      if (pattern0 (x3, 
E_V64HFmode) != 0)
        return -1;
      return 94;

    case E_V128HFmode:
      if (pattern0 (x3, 
E_V128HFmode) != 0)
        return -1;
      return 95;

    case E_V256HFmode:
      if (pattern0 (x3, 
E_V256HFmode) != 0)
        return -1;
      return 96;

    case E_V512HFmode:
      if (pattern0 (x3, 
E_V512HFmode) != 0)
        return -1;
      return 97;

    case E_V1024HFmode:
      if (pattern0 (x3, 
E_V1024HFmode) != 0)
        return -1;
      return 98;

    case E_V2048HFmode:
      if (pattern0 (x3, 
E_V2048HFmode) != 0)
        return -1;
      return 99;

    case E_V1SFmode:
      if (pattern0 (x3, 
E_V1SFmode) != 0)
        return -1;
      return 100;

    case E_V2SFmode:
      if (pattern0 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 101;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 102;

    case E_V8SFmode:
      if (pattern0 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 103;

    case E_V16SFmode:
      if (pattern0 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 104;

    case E_V32SFmode:
      if (pattern0 (x3, 
E_V32SFmode) != 0)
        return -1;
      return 105;

    case E_V64SFmode:
      if (pattern0 (x3, 
E_V64SFmode) != 0)
        return -1;
      return 106;

    case E_V128SFmode:
      if (pattern0 (x3, 
E_V128SFmode) != 0)
        return -1;
      return 107;

    case E_V256SFmode:
      if (pattern0 (x3, 
E_V256SFmode) != 0)
        return -1;
      return 108;

    case E_V512SFmode:
      if (pattern0 (x3, 
E_V512SFmode) != 0)
        return -1;
      return 109;

    case E_V1024SFmode:
      if (pattern0 (x3, 
E_V1024SFmode) != 0)
        return -1;
      return 110;

    case E_V1DFmode:
      if (pattern0 (x3, 
E_V1DFmode) != 0)
        return -1;
      return 111;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 112;

    case E_V4DFmode:
      if (pattern0 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 113;

    case E_V8DFmode:
      if (pattern0 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 114;

    case E_V16DFmode:
      if (pattern0 (x3, 
E_V16DFmode) != 0)
        return -1;
      return 115;

    case E_V32DFmode:
      if (pattern0 (x3, 
E_V32DFmode) != 0)
        return -1;
      return 116;

    case E_V64DFmode:
      if (pattern0 (x3, 
E_V64DFmode) != 0)
        return -1;
      return 117;

    case E_V128DFmode:
      if (pattern0 (x3, 
E_V128DFmode) != 0)
        return -1;
      return 118;

    case E_V256DFmode:
      if (pattern0 (x3, 
E_V256DFmode) != 0)
        return -1;
      return 119;

    case E_V512DFmode:
      if (pattern0 (x3, 
E_V512DFmode) != 0)
        return -1;
      return 120;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 2)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XEXP (x6, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i5)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 2)
    return -1;
  x16 = XEXP (x14, 1);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XEXP (x12, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != i4)
    return -1;
  x18 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x18) != SET)
    return -1;
  x19 = XEXP (x18, 1);
  if (GET_CODE (x19) != MEM)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != PLUS)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 2)
    return -1;
  x22 = XEXP (x20, 1);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XEXP (x18, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != i3)
    return -1;
  x24 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x24) != SET)
    return -1;
  x25 = XEXP (x24, 1);
  if (GET_CODE (x25) != MEM)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != PLUS)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XEXP (x24, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != i2)
    return -1;
  x30 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x30) != SET)
    return -1;
  x31 = XEXP (x30, 1);
  if (GET_CODE (x31) != MEM)
    return -1;
  x32 = XEXP (x31, 0);
  if (GET_CODE (x32) != PLUS)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 2)
    return -1;
  x34 = XEXP (x32, 1);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XEXP (x30, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != i1)
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern53 (x1); /* [-1, 1] */

    case E_RVVM4HFmode:
      res = pattern54 (x1);
      if (res >= 0)
        return res + 2; /* [2, 4] */
      return -1;

    case E_RVVM2HFmode:
      res = pattern55 (x1);
      if (res >= 0)
        return res + 5; /* [5, 7] */
      return -1;

    case E_RVVM1HFmode:
      res = pattern56 (x1);
      if (res >= 0)
        return res + 8; /* [8, 10] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern57 (x1);
      if (res >= 0)
        return res + 11; /* [11, 13] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern58 (x1);
      if (res >= 0)
        return res + 14; /* [14, 16] */
      return -1;

    case E_RVVM8SFmode:
      res = pattern59 (x1);
      if (res >= 0)
        return res + 17; /* [17, 18] */
      return -1;

    case E_RVVM4SFmode:
      res = pattern60 (x1);
      if (res >= 0)
        return res + 19; /* [19, 21] */
      return -1;

    case E_RVVM2SFmode:
      res = pattern61 (x1);
      if (res >= 0)
        return res + 22; /* [22, 24] */
      return -1;

    case E_RVVM1SFmode:
      res = pattern62 (x1);
      if (res >= 0)
        return res + 25; /* [25, 27] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern63 (x1);
      if (res >= 0)
        return res + 28; /* [28, 30] */
      return -1;

    case E_RVVM8DFmode:
      res = pattern64 (x1);
      if (res >= 0)
        return res + 31; /* [31, 32] */
      return -1;

    case E_RVVM4DFmode:
      res = pattern65 (x1);
      if (res >= 0)
        return res + 33; /* [33, 34] */
      return -1;

    case E_RVVM2DFmode:
      res = pattern66 (x1);
      if (res >= 0)
        return res + 35; /* [35, 36] */
      return -1;

    case E_RVVM1DFmode:
      res = pattern67 (x1);
      if (res >= 0)
        return res + 37; /* [37, 38] */
      return -1;

    case E_V1HFmode:
      res = pattern68 (x1);
      if (res >= 0)
        return res + 39; /* [39, 41] */
      return -1;

    case E_V2HFmode:
      res = pattern69 (x1);
      if (res >= 0)
        return res + 42; /* [42, 44] */
      return -1;

    case E_V4HFmode:
      res = pattern70 (x1);
      if (res >= 0)
        return res + 45; /* [45, 47] */
      return -1;

    case E_V8HFmode:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 48; /* [48, 50] */
      return -1;

    case E_V16HFmode:
      res = pattern72 (x1);
      if (res >= 0)
        return res + 51; /* [51, 53] */
      return -1;

    case E_V32HFmode:
      res = pattern73 (x1);
      if (res >= 0)
        return res + 54; /* [54, 56] */
      return -1;

    case E_V64HFmode:
      res = pattern74 (x1);
      if (res >= 0)
        return res + 57; /* [57, 59] */
      return -1;

    case E_V128HFmode:
      res = pattern75 (x1);
      if (res >= 0)
        return res + 60; /* [60, 62] */
      return -1;

    case E_V256HFmode:
      res = pattern76 (x1);
      if (res >= 0)
        return res + 63; /* [63, 65] */
      return -1;

    case E_V512HFmode:
      res = pattern77 (x1);
      if (res >= 0)
        return res + 66; /* [66, 68] */
      return -1;

    case E_V1024HFmode:
      res = pattern78 (x1);
      if (res >= 0)
        return res + 69; /* [69, 71] */
      return -1;

    case E_V2048HFmode:
      res = pattern79 (x1);
      if (res >= 0)
        return res + 72; /* [72, 73] */
      return -1;

    case E_V1SFmode:
      res = pattern80 (x1);
      if (res >= 0)
        return res + 74; /* [74, 76] */
      return -1;

    case E_V2SFmode:
      res = pattern81 (x1);
      if (res >= 0)
        return res + 77; /* [77, 79] */
      return -1;

    case E_V4SFmode:
      res = pattern82 (x1);
      if (res >= 0)
        return res + 80; /* [80, 82] */
      return -1;

    case E_V8SFmode:
      res = pattern83 (x1);
      if (res >= 0)
        return res + 83; /* [83, 85] */
      return -1;

    case E_V16SFmode:
      res = pattern84 (x1);
      if (res >= 0)
        return res + 86; /* [86, 88] */
      return -1;

    case E_V32SFmode:
      res = pattern85 (x1);
      if (res >= 0)
        return res + 89; /* [89, 91] */
      return -1;

    case E_V64SFmode:
      res = pattern86 (x1);
      if (res >= 0)
        return res + 92; /* [92, 94] */
      return -1;

    case E_V128SFmode:
      res = pattern87 (x1);
      if (res >= 0)
        return res + 95; /* [95, 97] */
      return -1;

    case E_V256SFmode:
      res = pattern88 (x1);
      if (res >= 0)
        return res + 98; /* [98, 100] */
      return -1;

    case E_V512SFmode:
      res = pattern89 (x1);
      if (res >= 0)
        return res + 101; /* [101, 103] */
      return -1;

    case E_V1024SFmode:
      res = pattern90 (x1);
      if (res >= 0)
        return res + 104; /* [104, 105] */
      return -1;

    case E_V1DFmode:
      res = pattern91 (x1);
      if (res >= 0)
        return res + 106; /* [106, 107] */
      return -1;

    case E_V2DFmode:
      res = pattern92 (x1);
      if (res >= 0)
        return res + 108; /* [108, 109] */
      return -1;

    case E_V4DFmode:
      res = pattern93 (x1);
      if (res >= 0)
        return res + 110; /* [110, 111] */
      return -1;

    case E_V8DFmode:
      res = pattern94 (x1);
      if (res >= 0)
        return res + 112; /* [112, 113] */
      return -1;

    case E_V16DFmode:
      res = pattern95 (x1);
      if (res >= 0)
        return res + 114; /* [114, 115] */
      return -1;

    case E_V32DFmode:
      res = pattern96 (x1);
      if (res >= 0)
        return res + 116; /* [116, 117] */
      return -1;

    case E_V64DFmode:
      res = pattern97 (x1);
      if (res >= 0)
        return res + 118; /* [118, 119] */
      return -1;

    case E_V128DFmode:
      res = pattern98 (x1);
      if (res >= 0)
        return res + 120; /* [120, 121] */
      return -1;

    case E_V256DFmode:
      res = pattern99 (x1);
      if (res >= 0)
        return res + 122; /* [122, 123] */
      return -1;

    case E_V512DFmode:
      res = pattern100 (x1);
      if (res >= 0)
        return res + 124; /* [124, 125] */
      return -1;

    default:
      return -1;
    }
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern143 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern143 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern143 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern143 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern143 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern143 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern143 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern143 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern143 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern143 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern143 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern143 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern143 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern143 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern143 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern143 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern143 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern143 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern143 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern143 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern143 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern143 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern143 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern143 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern143 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern143 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern143 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern143 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern143 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern143 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern143 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern143 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern143 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern143 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern143 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern143 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern143 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern143 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern143 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern143 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern143 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern143 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern143 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern143 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern143 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern143 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern143 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern143 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern157 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !vector_shift_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTEND)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HImode:
          return pattern156 (x1, 
E_RVVM2QImode, 
E_RVVM8SImode, 
E_RVVM4HImode); /* [-1, 0] */

        case E_RVVM2HImode:
          if (pattern156 (x1, 
E_RVVM1QImode, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 1;

        case E_RVVM1HImode:
          if (pattern156 (x1, 
E_RVVMF2QImode, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 2;

        case E_RVVMF2HImode:
          if (pattern156 (x1, 
E_RVVMF4QImode, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 3;

        case E_RVVMF4HImode:
          if (pattern156 (x1, 
E_RVVMF8QImode, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 4;

        case E_RVVM4SImode:
          if (pattern156 (x1, 
E_RVVM2HImode, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 5;

        case E_RVVM2SImode:
          if (pattern156 (x1, 
E_RVVM1HImode, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 6;

        case E_RVVM1SImode:
          if (pattern156 (x1, 
E_RVVMF2HImode, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 7;

        case E_RVVMF2SImode:
          if (pattern156 (x1, 
E_RVVMF4HImode, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 8;

        case E_V1HImode:
          if (pattern156 (x1, 
E_V1QImode, 
E_V1SImode, 
E_V1HImode) != 0)
            return -1;
          return 9;

        case E_V2HImode:
          if (pattern156 (x1, 
E_V2QImode, 
E_V2SImode, 
E_V2HImode) != 0)
            return -1;
          return 10;

        case E_V4HImode:
          if (pattern156 (x1, 
E_V4QImode, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 11;

        case E_V8HImode:
          if (pattern156 (x1, 
E_V8QImode, 
E_V8SImode, 
E_V8HImode) != 0)
            return -1;
          return 12;

        case E_V16HImode:
          if (pattern156 (x1, 
E_V16QImode, 
E_V16SImode, 
E_V16HImode) != 0)
            return -1;
          return 13;

        case E_V32HImode:
          if (pattern156 (x1, 
E_V32QImode, 
E_V32SImode, 
E_V32HImode) != 0)
            return -1;
          return 14;

        case E_V64HImode:
          if (pattern156 (x1, 
E_V64QImode, 
E_V64SImode, 
E_V64HImode) != 0)
            return -1;
          return 15;

        case E_V128HImode:
          if (pattern156 (x1, 
E_V128QImode, 
E_V128SImode, 
E_V128HImode) != 0)
            return -1;
          return 16;

        case E_V256HImode:
          if (pattern156 (x1, 
E_V256QImode, 
E_V256SImode, 
E_V256HImode) != 0)
            return -1;
          return 17;

        case E_V512HImode:
          if (pattern156 (x1, 
E_V512QImode, 
E_V512SImode, 
E_V512HImode) != 0)
            return -1;
          return 18;

        case E_V1024HImode:
          if (pattern156 (x1, 
E_V1024QImode, 
E_V1024SImode, 
E_V1024HImode) != 0)
            return -1;
          return 19;

        case E_V1SImode:
          if (pattern156 (x1, 
E_V1HImode, 
E_V1DImode, 
E_V1SImode) != 0)
            return -1;
          return 20;

        case E_V2SImode:
          if (pattern156 (x1, 
E_V2HImode, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 21;

        case E_V4SImode:
          if (pattern156 (x1, 
E_V4HImode, 
E_V4DImode, 
E_V4SImode) != 0)
            return -1;
          return 22;

        case E_V8SImode:
          if (pattern156 (x1, 
E_V8HImode, 
E_V8DImode, 
E_V8SImode) != 0)
            return -1;
          return 23;

        case E_V16SImode:
          if (pattern156 (x1, 
E_V16HImode, 
E_V16DImode, 
E_V16SImode) != 0)
            return -1;
          return 24;

        case E_V32SImode:
          if (pattern156 (x1, 
E_V32HImode, 
E_V32DImode, 
E_V32SImode) != 0)
            return -1;
          return 25;

        case E_V64SImode:
          if (pattern156 (x1, 
E_V64HImode, 
E_V64DImode, 
E_V64SImode) != 0)
            return -1;
          return 26;

        case E_V128SImode:
          if (pattern156 (x1, 
E_V128HImode, 
E_V128DImode, 
E_V128SImode) != 0)
            return -1;
          return 27;

        case E_V256SImode:
          if (pattern156 (x1, 
E_V256HImode, 
E_V256DImode, 
E_V256SImode) != 0)
            return -1;
          return 28;

        case E_V512SImode:
          if (pattern156 (x1, 
E_V512HImode, 
E_V512DImode, 
E_V512SImode) != 0)
            return -1;
          return 29;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HImode:
          if (pattern157 (x1, 
E_RVVM2QImode, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0)
            return -1;
          return 30;

        case E_RVVM2HImode:
          if (pattern157 (x1, 
E_RVVM1QImode, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 31;

        case E_RVVM1HImode:
          if (pattern157 (x1, 
E_RVVMF2QImode, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 32;

        case E_RVVMF2HImode:
          if (pattern157 (x1, 
E_RVVMF4QImode, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 33;

        case E_RVVMF4HImode:
          if (pattern157 (x1, 
E_RVVMF8QImode, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 34;

        case E_RVVM4SImode:
          if (pattern157 (x1, 
E_RVVM2HImode, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 35;

        case E_RVVM2SImode:
          if (pattern157 (x1, 
E_RVVM1HImode, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 36;

        case E_RVVM1SImode:
          if (pattern157 (x1, 
E_RVVMF2HImode, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 37;

        case E_RVVMF2SImode:
          if (pattern157 (x1, 
E_RVVMF4HImode, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 38;

        case E_V1HImode:
          if (pattern157 (x1, 
E_V1QImode, 
E_V1SImode, 
E_V1HImode) != 0)
            return -1;
          return 39;

        case E_V2HImode:
          if (pattern157 (x1, 
E_V2QImode, 
E_V2SImode, 
E_V2HImode) != 0)
            return -1;
          return 40;

        case E_V4HImode:
          if (pattern157 (x1, 
E_V4QImode, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 41;

        case E_V8HImode:
          if (pattern157 (x1, 
E_V8QImode, 
E_V8SImode, 
E_V8HImode) != 0)
            return -1;
          return 42;

        case E_V16HImode:
          if (pattern157 (x1, 
E_V16QImode, 
E_V16SImode, 
E_V16HImode) != 0)
            return -1;
          return 43;

        case E_V32HImode:
          if (pattern157 (x1, 
E_V32QImode, 
E_V32SImode, 
E_V32HImode) != 0)
            return -1;
          return 44;

        case E_V64HImode:
          if (pattern157 (x1, 
E_V64QImode, 
E_V64SImode, 
E_V64HImode) != 0)
            return -1;
          return 45;

        case E_V128HImode:
          if (pattern157 (x1, 
E_V128QImode, 
E_V128SImode, 
E_V128HImode) != 0)
            return -1;
          return 46;

        case E_V256HImode:
          if (pattern157 (x1, 
E_V256QImode, 
E_V256SImode, 
E_V256HImode) != 0)
            return -1;
          return 47;

        case E_V512HImode:
          if (pattern157 (x1, 
E_V512QImode, 
E_V512SImode, 
E_V512HImode) != 0)
            return -1;
          return 48;

        case E_V1024HImode:
          if (pattern157 (x1, 
E_V1024QImode, 
E_V1024SImode, 
E_V1024HImode) != 0)
            return -1;
          return 49;

        case E_V1SImode:
          if (pattern157 (x1, 
E_V1HImode, 
E_V1DImode, 
E_V1SImode) != 0)
            return -1;
          return 50;

        case E_V2SImode:
          if (pattern157 (x1, 
E_V2HImode, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 51;

        case E_V4SImode:
          if (pattern157 (x1, 
E_V4HImode, 
E_V4DImode, 
E_V4SImode) != 0)
            return -1;
          return 52;

        case E_V8SImode:
          if (pattern157 (x1, 
E_V8HImode, 
E_V8DImode, 
E_V8SImode) != 0)
            return -1;
          return 53;

        case E_V16SImode:
          if (pattern157 (x1, 
E_V16HImode, 
E_V16DImode, 
E_V16SImode) != 0)
            return -1;
          return 54;

        case E_V32SImode:
          if (pattern157 (x1, 
E_V32HImode, 
E_V32DImode, 
E_V32SImode) != 0)
            return -1;
          return 55;

        case E_V64SImode:
          if (pattern157 (x1, 
E_V64HImode, 
E_V64DImode, 
E_V64SImode) != 0)
            return -1;
          return 56;

        case E_V128SImode:
          if (pattern157 (x1, 
E_V128HImode, 
E_V128DImode, 
E_V128SImode) != 0)
            return -1;
          return 57;

        case E_V256SImode:
          if (pattern157 (x1, 
E_V256HImode, 
E_V256DImode, 
E_V256SImode) != 0)
            return -1;
          return 58;

        case E_V512SImode:
          if (pattern157 (x1, 
E_V512HImode, 
E_V512DImode, 
E_V512SImode) != 0)
            return -1;
          return 59;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  if (!const_int2_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern198 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern199 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !vector_shift_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern203 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2
      || !vector_shift_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern204 (x1, 
E_RVVM8HImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM4HImode
          || !register_operand (operands[3], E_RVVM4HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[2], E_RVVM4HFmode))
            return -1;
          return 1;

        case E_RVVM8SFmode:
          if (!register_operand (operands[2], E_RVVM8SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM2HImode
          || !register_operand (operands[3], E_RVVM2HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[2], E_RVVM2HFmode))
            return -1;
          return 3;

        case E_RVVM4SFmode:
          if (!register_operand (operands[2], E_RVVM4SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM1HImode
          || !register_operand (operands[3], E_RVVM1HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[2], E_RVVM1HFmode))
            return -1;
          return 5;

        case E_RVVM2SFmode:
          if (!register_operand (operands[2], E_RVVM2SFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVMF2HImode
          || !register_operand (operands[3], E_RVVMF2HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[2], E_RVVMF2HFmode))
            return -1;
          return 7;

        case E_RVVM1SFmode:
          if (!register_operand (operands[2], E_RVVM1SFmode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF4HImode
          || !register_operand (operands[3], E_RVVMF4HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[2], E_RVVMF4HFmode))
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[2], E_RVVMF2SFmode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM8SImode
          || !register_operand (operands[3], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8SFmode:
          if (!register_operand (operands[2], E_RVVM8SFmode))
            return -1;
          return 11;

        case E_RVVM4HFmode:
          if (!register_operand (operands[2], E_RVVM4HFmode))
            return -1;
          return 12;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM4SImode
          || !register_operand (operands[3], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4SFmode:
          if (!register_operand (operands[2], E_RVVM4SFmode))
            return -1;
          return 13;

        case E_RVVM2HFmode:
          if (!register_operand (operands[2], E_RVVM2HFmode))
            return -1;
          return 14;

        case E_RVVM8DFmode:
          if (!register_operand (operands[2], E_RVVM8DFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM2SImode
          || !register_operand (operands[3], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2SFmode:
          if (!register_operand (operands[2], E_RVVM2SFmode))
            return -1;
          return 16;

        case E_RVVM1HFmode:
          if (!register_operand (operands[2], E_RVVM1HFmode))
            return -1;
          return 17;

        case E_RVVM4DFmode:
          if (!register_operand (operands[2], E_RVVM4DFmode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM1SImode
          || !register_operand (operands[3], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1SFmode:
          if (!register_operand (operands[2], E_RVVM1SFmode))
            return -1;
          return 19;

        case E_RVVMF2HFmode:
          if (!register_operand (operands[2], E_RVVMF2HFmode))
            return -1;
          return 20;

        case E_RVVM2DFmode:
          if (!register_operand (operands[2], E_RVVM2DFmode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF2SImode
          || !register_operand (operands[3], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2SFmode:
          if (!register_operand (operands[2], E_RVVMF2SFmode))
            return -1;
          return 22;

        case E_RVVMF4HFmode:
          if (!register_operand (operands[2], E_RVVMF4HFmode))
            return -1;
          return 23;

        case E_RVVM1DFmode:
          if (!register_operand (operands[2], E_RVVM1DFmode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM8DImode
          || !register_operand (operands[3], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8DFmode:
          if (!register_operand (operands[2], E_RVVM8DFmode))
            return -1;
          return 25;

        case E_RVVM4SFmode:
          if (!register_operand (operands[2], E_RVVM4SFmode))
            return -1;
          return 26;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM4DImode
          || !register_operand (operands[3], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4DFmode:
          if (!register_operand (operands[2], E_RVVM4DFmode))
            return -1;
          return 27;

        case E_RVVM2SFmode:
          if (!register_operand (operands[2], E_RVVM2SFmode))
            return -1;
          return 28;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM2DImode
          || !register_operand (operands[3], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2DFmode:
          if (!register_operand (operands[2], E_RVVM2DFmode))
            return -1;
          return 29;

        case E_RVVM1SFmode:
          if (!register_operand (operands[2], E_RVVM1SFmode))
            return -1;
          return 30;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVM1DImode
          || !register_operand (operands[3], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1DFmode:
          if (!register_operand (operands[2], E_RVVM1DFmode))
            return -1;
          return 31;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[2], E_RVVMF2SFmode))
            return -1;
          return 32;

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1HImode
          || !register_operand (operands[3], E_V1HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1HFmode:
          if (!register_operand (operands[2], E_V1HFmode))
            return -1;
          return 33;

        case E_V1SFmode:
          if (!register_operand (operands[2], E_V1SFmode))
            return -1;
          return 34;

        default:
          return -1;
        }

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[3], E_V2HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[2], E_V2HFmode))
            return -1;
          return 35;

        case E_V2SFmode:
          if (!register_operand (operands[2], E_V2SFmode))
            return -1;
          return 36;

        default:
          return -1;
        }

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[3], E_V4HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[2], E_V4HFmode))
            return -1;
          return 37;

        case E_V4SFmode:
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          return 38;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[3], E_V8HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[2], E_V8HFmode))
            return -1;
          return 39;

        case E_V8SFmode:
          if (!register_operand (operands[2], E_V8SFmode))
            return -1;
          return 40;

        default:
          return -1;
        }

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16HImode
          || !register_operand (operands[3], E_V16HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16HFmode:
          if (!register_operand (operands[2], E_V16HFmode))
            return -1;
          return 41;

        case E_V16SFmode:
          if (!register_operand (operands[2], E_V16SFmode))
            return -1;
          return 42;

        default:
          return -1;
        }

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32HImode
          || !register_operand (operands[3], E_V32HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[2], E_V32HFmode))
            return -1;
          return 43;

        case E_V32SFmode:
          if (!register_operand (operands[2], E_V32SFmode))
            return -1;
          return 44;

        default:
          return -1;
        }

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64HImode
          || !register_operand (operands[3], E_V64HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64HFmode:
          if (!register_operand (operands[2], E_V64HFmode))
            return -1;
          return 45;

        case E_V64SFmode:
          if (!register_operand (operands[2], E_V64SFmode))
            return -1;
          return 46;

        default:
          return -1;
        }

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128HImode
          || !register_operand (operands[3], E_V128HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128HFmode:
          if (!register_operand (operands[2], E_V128HFmode))
            return -1;
          return 47;

        case E_V128SFmode:
          if (!register_operand (operands[2], E_V128SFmode))
            return -1;
          return 48;

        default:
          return -1;
        }

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256HImode
          || !register_operand (operands[3], E_V256HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256HFmode:
          if (!register_operand (operands[2], E_V256HFmode))
            return -1;
          return 49;

        case E_V256SFmode:
          if (!register_operand (operands[2], E_V256SFmode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512HImode
          || !register_operand (operands[3], E_V512HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512HFmode:
          if (!register_operand (operands[2], E_V512HFmode))
            return -1;
          return 51;

        case E_V512SFmode:
          if (!register_operand (operands[2], E_V512SFmode))
            return -1;
          return 52;

        default:
          return -1;
        }

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024HImode
          || !register_operand (operands[3], E_V1024HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024HFmode:
          if (!register_operand (operands[2], E_V1024HFmode))
            return -1;
          return 53;

        case E_V1024SFmode:
          if (!register_operand (operands[2], E_V1024SFmode))
            return -1;
          return 54;

        default:
          return -1;
        }

    case E_V2048HImode:
      if (pattern204 (x1, 
E_V2048HImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 55;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1SImode
          || !register_operand (operands[3], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1SFmode:
          if (!register_operand (operands[2], E_V1SFmode))
            return -1;
          return 56;

        case E_V1HFmode:
          if (!register_operand (operands[2], E_V1HFmode))
            return -1;
          return 57;

        case E_V1DFmode:
          if (!register_operand (operands[2], E_V1DFmode))
            return -1;
          return 58;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[3], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[2], E_V2SFmode))
            return -1;
          return 59;

        case E_V2HFmode:
          if (!register_operand (operands[2], E_V2HFmode))
            return -1;
          return 60;

        case E_V2DFmode:
          if (!register_operand (operands[2], E_V2DFmode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[3], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          return 62;

        case E_V4HFmode:
          if (!register_operand (operands[2], E_V4HFmode))
            return -1;
          return 63;

        case E_V4DFmode:
          if (!register_operand (operands[2], E_V4DFmode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8SImode
          || !register_operand (operands[3], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[2], E_V8SFmode))
            return -1;
          return 65;

        case E_V8HFmode:
          if (!register_operand (operands[2], E_V8HFmode))
            return -1;
          return 66;

        case E_V8DFmode:
          if (!register_operand (operands[2], E_V8DFmode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16SImode
          || !register_operand (operands[3], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16SFmode:
          if (!register_operand (operands[2], E_V16SFmode))
            return -1;
          return 68;

        case E_V16HFmode:
          if (!register_operand (operands[2], E_V16HFmode))
            return -1;
          return 69;

        case E_V16DFmode:
          if (!register_operand (operands[2], E_V16DFmode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32SImode
          || !register_operand (operands[3], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32SFmode:
          if (!register_operand (operands[2], E_V32SFmode))
            return -1;
          return 71;

        case E_V32HFmode:
          if (!register_operand (operands[2], E_V32HFmode))
            return -1;
          return 72;

        case E_V32DFmode:
          if (!register_operand (operands[2], E_V32DFmode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64SImode
          || !register_operand (operands[3], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64SFmode:
          if (!register_operand (operands[2], E_V64SFmode))
            return -1;
          return 74;

        case E_V64HFmode:
          if (!register_operand (operands[2], E_V64HFmode))
            return -1;
          return 75;

        case E_V64DFmode:
          if (!register_operand (operands[2], E_V64DFmode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128SImode
          || !register_operand (operands[3], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128SFmode:
          if (!register_operand (operands[2], E_V128SFmode))
            return -1;
          return 77;

        case E_V128HFmode:
          if (!register_operand (operands[2], E_V128HFmode))
            return -1;
          return 78;

        case E_V128DFmode:
          if (!register_operand (operands[2], E_V128DFmode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256SImode
          || !register_operand (operands[3], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256SFmode:
          if (!register_operand (operands[2], E_V256SFmode))
            return -1;
          return 80;

        case E_V256HFmode:
          if (!register_operand (operands[2], E_V256HFmode))
            return -1;
          return 81;

        case E_V256DFmode:
          if (!register_operand (operands[2], E_V256DFmode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512SImode
          || !register_operand (operands[3], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512SFmode:
          if (!register_operand (operands[2], E_V512SFmode))
            return -1;
          return 83;

        case E_V512HFmode:
          if (!register_operand (operands[2], E_V512HFmode))
            return -1;
          return 84;

        case E_V512DFmode:
          if (!register_operand (operands[2], E_V512DFmode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024SImode
          || !register_operand (operands[3], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024SFmode:
          if (!register_operand (operands[2], E_V1024SFmode))
            return -1;
          return 86;

        case E_V1024HFmode:
          if (!register_operand (operands[2], E_V1024HFmode))
            return -1;
          return 87;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[3], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1DFmode:
          if (!register_operand (operands[2], E_V1DFmode))
            return -1;
          return 88;

        case E_V1SFmode:
          if (!register_operand (operands[2], E_V1SFmode))
            return -1;
          return 89;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[3], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[2], E_V2DFmode))
            return -1;
          return 90;

        case E_V2SFmode:
          if (!register_operand (operands[2], E_V2SFmode))
            return -1;
          return 91;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4DImode
          || !register_operand (operands[3], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4DFmode:
          if (!register_operand (operands[2], E_V4DFmode))
            return -1;
          return 92;

        case E_V4SFmode:
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          return 93;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8DImode
          || !register_operand (operands[3], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[2], E_V8DFmode))
            return -1;
          return 94;

        case E_V8SFmode:
          if (!register_operand (operands[2], E_V8SFmode))
            return -1;
          return 95;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16DImode
          || !register_operand (operands[3], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16DFmode:
          if (!register_operand (operands[2], E_V16DFmode))
            return -1;
          return 96;

        case E_V16SFmode:
          if (!register_operand (operands[2], E_V16SFmode))
            return -1;
          return 97;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32DImode
          || !register_operand (operands[3], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32DFmode:
          if (!register_operand (operands[2], E_V32DFmode))
            return -1;
          return 98;

        case E_V32SFmode:
          if (!register_operand (operands[2], E_V32SFmode))
            return -1;
          return 99;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64DImode
          || !register_operand (operands[3], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64DFmode:
          if (!register_operand (operands[2], E_V64DFmode))
            return -1;
          return 100;

        case E_V64SFmode:
          if (!register_operand (operands[2], E_V64SFmode))
            return -1;
          return 101;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128DImode
          || !register_operand (operands[3], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128DFmode:
          if (!register_operand (operands[2], E_V128DFmode))
            return -1;
          return 102;

        case E_V128SFmode:
          if (!register_operand (operands[2], E_V128SFmode))
            return -1;
          return 103;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256DImode
          || !register_operand (operands[3], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256DFmode:
          if (!register_operand (operands[2], E_V256DFmode))
            return -1;
          return 104;

        case E_V256SFmode:
          if (!register_operand (operands[2], E_V256SFmode))
            return -1;
          return 105;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512DImode
          || !register_operand (operands[3], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512DFmode:
          if (!register_operand (operands[2], E_V512DFmode))
            return -1;
          return 106;

        case E_V512SFmode:
          if (!register_operand (operands[2], E_V512SFmode))
            return -1;
          return 107;

        default:
          return -1;
        }

    case E_RVVM4QImode:
      if (pattern204 (x1, 
E_RVVM4QImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 108;

    case E_RVVM2QImode:
      if (pattern204 (x1, 
E_RVVM2QImode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 109;

    case E_RVVM1QImode:
      if (pattern204 (x1, 
E_RVVM1QImode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 110;

    case E_RVVMF2QImode:
      if (pattern204 (x1, 
E_RVVMF2QImode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 111;

    case E_RVVMF4QImode:
      if (pattern204 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 112;

    case E_RVVMF8QImode:
      if (pattern204 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 113;

    case E_V1QImode:
      if (pattern204 (x1, 
E_V1QImode, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 114;

    case E_V2QImode:
      if (pattern204 (x1, 
E_V2QImode, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 115;

    case E_V4QImode:
      if (pattern204 (x1, 
E_V4QImode, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 116;

    case E_V8QImode:
      if (pattern204 (x1, 
E_V8QImode, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 117;

    case E_V16QImode:
      if (pattern204 (x1, 
E_V16QImode, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 118;

    case E_V32QImode:
      if (pattern204 (x1, 
E_V32QImode, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 119;

    case E_V64QImode:
      if (pattern204 (x1, 
E_V64QImode, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 120;

    case E_V128QImode:
      if (pattern204 (x1, 
E_V128QImode, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 121;

    case E_V256QImode:
      if (pattern204 (x1, 
E_V256QImode, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 122;

    case E_V512QImode:
      if (pattern204 (x1, 
E_V512QImode, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 123;

    case E_V1024QImode:
      if (pattern204 (x1, 
E_V1024QImode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 124;

    case E_V2048QImode:
      if (pattern204 (x1, 
E_V2048QImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 125;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM4SImode)
      || GET_MODE (x1) != E_RVVM4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 0;

    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM4DImode)
      || GET_MODE (x1) != E_RVVM4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 0;

    case E_RVVM1HImode:
      if (!register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 1;

    case E_RVVMF2QImode:
      if (!register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 0;

    case E_V4QImode:
      if (!register_operand (operands[1], E_V4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V128SImode)
      || GET_MODE (x1) != E_V128SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V128HImode:
      if (!register_operand (operands[1], E_V128HImode))
        return -1;
      return 0;

    case E_V128QImode:
      if (!register_operand (operands[1], E_V128QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern312 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2QImode:
      if (!register_operand (operands[1], E_V2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64DImode)
      || GET_MODE (x1) != E_V64DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      return 0;

    case E_V64HImode:
      if (!register_operand (operands[1], E_V64HImode))
        return -1;
      return 1;

    case E_V64QImode:
      if (!register_operand (operands[1], E_V64QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern322 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern322 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode)
          || GET_MODE (x1) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode))
        return -1;
      return 2;

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode)
          || GET_MODE (x1) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode))
        return -1;
      return 3;

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode)
          || GET_MODE (x1) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode))
        return -1;
      return 4;

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode)
          || GET_MODE (x1) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 5;

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode)
          || GET_MODE (x1) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 6;

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 7;

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 8;

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 9;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 13;

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 14;

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 15;

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 16;

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 17;

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode)
          || GET_MODE (x1) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 18;

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode)
          || GET_MODE (x1) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode))
        return -1;
      return 19;

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode)
          || GET_MODE (x1) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 20;

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 21;

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 22;

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 23;

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 24;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 25;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 26;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 27;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 28;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 29;

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x1) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode))
        return -1;
      return 30;

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode)
          || GET_MODE (x1) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode))
        return -1;
      return 31;

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode)
          || GET_MODE (x1) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode))
        return -1;
      return 32;

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode)
          || GET_MODE (x1) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode))
        return -1;
      return 33;

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode)
          || GET_MODE (x1) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode))
        return -1;
      return 34;

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode)
          || GET_MODE (x1) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode))
        return -1;
      return 35;

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode)
          || GET_MODE (x1) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode))
        return -1;
      return 36;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 37;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 38;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 39;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 40;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 41;

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 42;

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode))
        return -1;
      return 43;

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode))
        return -1;
      return 44;

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 45;

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode))
        return -1;
      return 46;

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode))
        return -1;
      return 47;

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode)
          || GET_MODE (x1) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode))
        return -1;
      return 48;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 49;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 50;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 51;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 52;

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 53;

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 54;

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode))
        return -1;
      return 55;

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode))
        return -1;
      return 56;

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 57;

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode))
        return -1;
      return 58;

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode))
        return -1;
      return 59;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 60;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 61;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 62;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode))
        return -1;
      return 63;

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode))
        return -1;
      return 64;

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode))
        return -1;
      return 65;

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode))
        return -1;
      return 66;

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode))
        return -1;
      return 67;

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode))
        return -1;
      return 68;

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode))
        return -1;
      return 69;

    default:
      return -1;
    }
}

int
pattern435 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern440 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8HImode:
      if (!register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (!register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (!register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 5;

    case E_V1HImode:
      if (!register_operand (operands[1], E_V1HImode))
        return -1;
      return 6;

    case E_V2HImode:
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      return 7;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 8;

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 9;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 10;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode))
        return -1;
      return 11;

    case E_V64HImode:
      if (!register_operand (operands[1], E_V64HImode))
        return -1;
      return 12;

    case E_V128HImode:
      if (!register_operand (operands[1], E_V128HImode))
        return -1;
      return 13;

    case E_V256HImode:
      if (!register_operand (operands[1], E_V256HImode))
        return -1;
      return 14;

    case E_V512HImode:
      if (!register_operand (operands[1], E_V512HImode))
        return -1;
      return 15;

    case E_V1024HImode:
      if (!register_operand (operands[1], E_V1024HImode))
        return -1;
      return 16;

    case E_V2048HImode:
      if (!register_operand (operands[1], E_V2048HImode))
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern452 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern457 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern461 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!branch_on_bit_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern459 (x1); /* [-1, 1] */
}

int
pattern465 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i3)
      || !vector_merge_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern469 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  x8 = XEXP (x1, 2);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern468 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern468 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern468 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern468 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern468 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern468 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern468 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern468 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern468 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern468 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern468 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern468 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern468 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern468 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern468 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern468 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern468 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern468 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern468 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern468 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern468 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern468 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_RVVM8BFmode:
      if (pattern468 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 22;

    case E_RVVM4BFmode:
      if (pattern468 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 23;

    case E_RVVM2BFmode:
      if (pattern468 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 24;

    case E_RVVM1BFmode:
      if (pattern468 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2BFmode:
      if (pattern468 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 26;

    case E_RVVMF4BFmode:
      if (pattern468 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 27;

    case E_RVVM8HFmode:
      if (pattern468 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 28;

    case E_RVVM4HFmode:
      if (pattern468 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 29;

    case E_RVVM2HFmode:
      if (pattern468 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 30;

    case E_RVVM1HFmode:
      if (pattern468 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 31;

    case E_RVVMF2HFmode:
      if (pattern468 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 32;

    case E_RVVMF4HFmode:
      if (pattern468 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 33;

    case E_RVVM8SFmode:
      if (pattern468 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 34;

    case E_RVVM4SFmode:
      if (pattern468 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 35;

    case E_RVVM2SFmode:
      if (pattern468 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 36;

    case E_RVVM1SFmode:
      if (pattern468 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 37;

    case E_RVVMF2SFmode:
      if (pattern468 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 38;

    case E_RVVM8DFmode:
      if (pattern468 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 39;

    case E_RVVM4DFmode:
      if (pattern468 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 40;

    case E_RVVM2DFmode:
      if (pattern468 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 41;

    case E_RVVM1DFmode:
      if (pattern468 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 42;

    case E_V1QImode:
      if (pattern468 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 43;

    case E_V2QImode:
      if (pattern468 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 44;

    case E_V4QImode:
      if (pattern468 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 45;

    case E_V8QImode:
      if (pattern468 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 46;

    case E_V16QImode:
      if (pattern468 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 47;

    case E_V32QImode:
      if (pattern468 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 48;

    case E_V64QImode:
      if (pattern468 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 49;

    case E_V128QImode:
      if (pattern468 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 50;

    case E_V256QImode:
      if (pattern468 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 51;

    case E_V512QImode:
      if (pattern468 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 52;

    case E_V1024QImode:
      if (pattern468 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 53;

    case E_V2048QImode:
      if (pattern468 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 54;

    case E_V4096QImode:
      if (pattern468 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 55;

    case E_V1HImode:
      if (pattern468 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 56;

    case E_V2HImode:
      if (pattern468 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 57;

    case E_V4HImode:
      if (pattern468 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 58;

    case E_V8HImode:
      if (pattern468 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 59;

    case E_V16HImode:
      if (pattern468 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 60;

    case E_V32HImode:
      if (pattern468 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 61;

    case E_V64HImode:
      if (pattern468 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 62;

    case E_V128HImode:
      if (pattern468 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 63;

    case E_V256HImode:
      if (pattern468 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 64;

    case E_V512HImode:
      if (pattern468 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 65;

    case E_V1024HImode:
      if (pattern468 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 66;

    case E_V2048HImode:
      if (pattern468 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 67;

    case E_V1SImode:
      if (pattern468 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 68;

    case E_V2SImode:
      if (pattern468 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 69;

    case E_V4SImode:
      if (pattern468 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 70;

    case E_V8SImode:
      if (pattern468 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 71;

    case E_V16SImode:
      if (pattern468 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 72;

    case E_V32SImode:
      if (pattern468 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 73;

    case E_V64SImode:
      if (pattern468 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 74;

    case E_V128SImode:
      if (pattern468 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 75;

    case E_V256SImode:
      if (pattern468 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 76;

    case E_V512SImode:
      if (pattern468 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 77;

    case E_V1024SImode:
      if (pattern468 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 78;

    case E_V1DImode:
      if (pattern468 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 79;

    case E_V2DImode:
      if (pattern468 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 80;

    case E_V4DImode:
      if (pattern468 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 81;

    case E_V8DImode:
      if (pattern468 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 82;

    case E_V16DImode:
      if (pattern468 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 83;

    case E_V32DImode:
      if (pattern468 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 84;

    case E_V64DImode:
      if (pattern468 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 85;

    case E_V128DImode:
      if (pattern468 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 86;

    case E_V256DImode:
      if (pattern468 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 87;

    case E_V512DImode:
      if (pattern468 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 88;

    case E_V1HFmode:
      if (pattern468 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 89;

    case E_V2HFmode:
      if (pattern468 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 90;

    case E_V4HFmode:
      if (pattern468 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 91;

    case E_V8HFmode:
      if (pattern468 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 92;

    case E_V16HFmode:
      if (pattern468 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 93;

    case E_V32HFmode:
      if (pattern468 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 94;

    case E_V64HFmode:
      if (pattern468 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 95;

    case E_V128HFmode:
      if (pattern468 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 96;

    case E_V256HFmode:
      if (pattern468 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 97;

    case E_V512HFmode:
      if (pattern468 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 98;

    case E_V1024HFmode:
      if (pattern468 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 99;

    case E_V2048HFmode:
      if (pattern468 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 100;

    case E_V1SFmode:
      if (pattern468 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 101;

    case E_V2SFmode:
      if (pattern468 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 102;

    case E_V4SFmode:
      if (pattern468 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 103;

    case E_V8SFmode:
      if (pattern468 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 104;

    case E_V16SFmode:
      if (pattern468 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 105;

    case E_V32SFmode:
      if (pattern468 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 106;

    case E_V64SFmode:
      if (pattern468 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 107;

    case E_V128SFmode:
      if (pattern468 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 108;

    case E_V256SFmode:
      if (pattern468 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 109;

    case E_V512SFmode:
      if (pattern468 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 110;

    case E_V1024SFmode:
      if (pattern468 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 111;

    case E_V1DFmode:
      if (pattern468 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 112;

    case E_V2DFmode:
      if (pattern468 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 113;

    case E_V4DFmode:
      if (pattern468 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 114;

    case E_V8DFmode:
      if (pattern468 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 115;

    case E_V16DFmode:
      if (pattern468 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 116;

    case E_V32DFmode:
      if (pattern468 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 117;

    case E_V64DFmode:
      if (pattern468 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 118;

    case E_V128DFmode:
      if (pattern468 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 119;

    case E_V256DFmode:
      if (pattern468 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 120;

    case E_V512DFmode:
      if (pattern468 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 121;

    default:
      return -1;
    }
}

int
pattern504 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ZERO_EXTEND
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern505 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !reg_or_0_operand (operands[2], E_QImode)
      || !register_operand (operands[1], i2))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern507 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM2QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern509 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVMF2QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 0;

    case E_RVVM1HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 1;

    case E_RVVM2SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 2;

    case E_RVVM4DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern512 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V1QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 0;

    case E_V1HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 1;

    case E_V1SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern515 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V8QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V8SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern518 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V64QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V64QImode))
        return -1;
      return 0;

    case E_V64HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V64HImode))
        return -1;
      return 1;

    case E_V64SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V64SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern521 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V512QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V512QImode))
        return -1;
      return 0;

    case E_V512HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V512HImode))
        return -1;
      return 1;

    case E_V512SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V512SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern525 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1BImode:
          return 0;

        case E_RVVMF2BImode:
          return 1;

        case E_RVVMF4BImode:
          return 2;

        case E_RVVMF8BImode:
          return 3;

        case E_RVVMF16BImode:
          return 4;

        case E_RVVMF32BImode:
          return 5;

        case E_RVVMF64BImode:
          return 6;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1BImode:
              if (pattern505 (x1, 
E_RVVM1BImode, 
E_RVVM8QImode) != 0)
                return -1;
              return 7;

            case E_RVVMF2BImode:
              if (!register_operand (operands[0], E_RVVMF2BImode)
                  || GET_MODE (x1) != E_RVVMF2BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_RVVMF2BImode)
                return -1;
              res = pattern506 (x2);
              if (res >= 0)
                return res + 8; /* [8, 9] */
              return -1;

            case E_RVVMF4BImode:
              if (!register_operand (operands[0], E_RVVMF4BImode)
                  || GET_MODE (x1) != E_RVVMF4BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_RVVMF4BImode)
                return -1;
              res = pattern507 (x2);
              if (res >= 0)
                return res + 10; /* [10, 12] */
              return -1;

            case E_RVVMF8BImode:
              if (!register_operand (operands[0], E_RVVMF8BImode)
                  || GET_MODE (x1) != E_RVVMF8BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_RVVMF8BImode)
                return -1;
              res = pattern508 (x2);
              if (res >= 0)
                return res + 13; /* [13, 16] */
              return -1;

            case E_RVVMF16BImode:
              if (!register_operand (operands[0], E_RVVMF16BImode)
                  || GET_MODE (x1) != E_RVVMF16BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_RVVMF16BImode)
                return -1;
              res = pattern509 (x2);
              if (res >= 0)
                return res + 17; /* [17, 20] */
              return -1;

            case E_RVVMF32BImode:
              if (!register_operand (operands[0], E_RVVMF32BImode)
                  || GET_MODE (x1) != E_RVVMF32BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_RVVMF32BImode)
                return -1;
              res = pattern510 (x2);
              if (res >= 0)
                return res + 21; /* [21, 24] */
              return -1;

            case E_RVVMF64BImode:
              if (!register_operand (operands[0], E_RVVMF64BImode)
                  || GET_MODE (x1) != E_RVVMF64BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_RVVMF64BImode)
                return -1;
              res = pattern511 (x2);
              if (res >= 0)
                return res + 25; /* [25, 28] */
              return -1;

            case E_V1BImode:
              if (!register_operand (operands[0], E_V1BImode)
                  || GET_MODE (x1) != E_V1BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V1BImode)
                return -1;
              res = pattern512 (x2);
              if (res >= 0)
                return res + 29; /* [29, 31] */
              return -1;

            case E_V2BImode:
              if (!register_operand (operands[0], E_V2BImode)
                  || GET_MODE (x1) != E_V2BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V2BImode)
                return -1;
              res = pattern513 (x2);
              if (res >= 0)
                return res + 32; /* [32, 34] */
              return -1;

            case E_V4BImode:
              if (!register_operand (operands[0], E_V4BImode)
                  || GET_MODE (x1) != E_V4BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V4BImode)
                return -1;
              res = pattern514 (x2);
              if (res >= 0)
                return res + 35; /* [35, 37] */
              return -1;

            case E_V8BImode:
              if (!register_operand (operands[0], E_V8BImode)
                  || GET_MODE (x1) != E_V8BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V8BImode)
                return -1;
              res = pattern515 (x2);
              if (res >= 0)
                return res + 38; /* [38, 40] */
              return -1;

            case E_V16BImode:
              if (!register_operand (operands[0], E_V16BImode)
                  || GET_MODE (x1) != E_V16BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V16BImode)
                return -1;
              res = pattern516 (x2);
              if (res >= 0)
                return res + 41; /* [41, 43] */
              return -1;

            case E_V32BImode:
              if (!register_operand (operands[0], E_V32BImode)
                  || GET_MODE (x1) != E_V32BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V32BImode)
                return -1;
              res = pattern517 (x2);
              if (res >= 0)
                return res + 44; /* [44, 46] */
              return -1;

            case E_V64BImode:
              if (!register_operand (operands[0], E_V64BImode)
                  || GET_MODE (x1) != E_V64BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V64BImode)
                return -1;
              res = pattern518 (x2);
              if (res >= 0)
                return res + 47; /* [47, 49] */
              return -1;

            case E_V128BImode:
              if (!register_operand (operands[0], E_V128BImode)
                  || GET_MODE (x1) != E_V128BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V128BImode)
                return -1;
              res = pattern519 (x2);
              if (res >= 0)
                return res + 50; /* [50, 52] */
              return -1;

            case E_V256BImode:
              if (!register_operand (operands[0], E_V256BImode)
                  || GET_MODE (x1) != E_V256BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V256BImode)
                return -1;
              res = pattern520 (x2);
              if (res >= 0)
                return res + 53; /* [53, 55] */
              return -1;

            case E_V512BImode:
              if (!register_operand (operands[0], E_V512BImode)
                  || GET_MODE (x1) != E_V512BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V512BImode)
                return -1;
              res = pattern521 (x2);
              if (res >= 0)
                return res + 56; /* [56, 58] */
              return -1;

            case E_V1024BImode:
              if (!register_operand (operands[0], E_V1024BImode)
                  || GET_MODE (x1) != E_V1024BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V1024BImode)
                return -1;
              res = pattern522 (x2);
              if (res >= 0)
                return res + 59; /* [59, 61] */
              return -1;

            case E_V2048BImode:
              if (!register_operand (operands[0], E_V2048BImode)
                  || GET_MODE (x1) != E_V2048BImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_MODE (x6) != E_V2048BImode)
                return -1;
              res = pattern523 (x2);
              if (res >= 0)
                return res + 62; /* [62, 63] */
              return -1;

            case E_V4096BImode:
              if (pattern505 (x1, 
E_V4096BImode, 
E_V4096QImode) != 0)
                return -1;
              return 64;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!reg_or_0_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVMF8BImode:
              if (pattern524 (x1, 
E_RVVMF8BImode, 
E_RVVM8DImode) != 0)
                return -1;
              return 65;

            case E_RVVMF16BImode:
              if (pattern524 (x1, 
E_RVVMF16BImode, 
E_RVVM4DImode) != 0)
                return -1;
              return 66;

            case E_RVVMF32BImode:
              if (pattern524 (x1, 
E_RVVMF32BImode, 
E_RVVM2DImode) != 0)
                return -1;
              return 67;

            case E_RVVMF64BImode:
              if (pattern524 (x1, 
E_RVVMF64BImode, 
E_RVVM1DImode) != 0)
                return -1;
              return 68;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern545 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern546 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern547 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !scratch_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern548 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern550 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1
      || !reg_or_0_operand (operands[4], i3)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern552 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!reg_or_0_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8DImode:
      return pattern551 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode); /* [-1, 0] */

    case E_RVVM4DImode:
      if (pattern551 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2DImode:
      if (pattern551 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (pattern551 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern555 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i3)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern557 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[3] = x8;
  x9 = XVECEXP (x7, 0, 1);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      return pattern554 (x1); /* [-1, 47] */

    case VEC_DUPLICATE:
      x10 = XEXP (x9, 0);
      operands[4] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern555 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) != 0)
            return -1;
          return 48;

        case E_RVVM4HFmode:
          if (pattern555 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
            return -1;
          return 49;

        case E_RVVM2HFmode:
          if (pattern555 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
            return -1;
          return 50;

        case E_RVVM1HFmode:
          if (pattern555 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
            return -1;
          return 51;

        case E_RVVMF2HFmode:
          if (pattern555 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
            return -1;
          return 52;

        case E_RVVMF4HFmode:
          if (pattern555 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
            return -1;
          return 53;

        case E_RVVM8SFmode:
          if (pattern555 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
            return -1;
          return 54;

        case E_RVVM4SFmode:
          if (pattern555 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
            return -1;
          return 55;

        case E_RVVM2SFmode:
          if (pattern555 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
            return -1;
          return 56;

        case E_RVVM1SFmode:
          if (pattern555 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
            return -1;
          return 57;

        case E_RVVMF2SFmode:
          if (pattern555 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
            return -1;
          return 58;

        case E_RVVM8DFmode:
          if (pattern555 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
            return -1;
          return 59;

        case E_RVVM4DFmode:
          if (pattern555 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
            return -1;
          return 60;

        case E_RVVM2DFmode:
          if (pattern555 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
            return -1;
          return 61;

        case E_RVVM1DFmode:
          if (pattern555 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
            return -1;
          return 62;

        case E_V1HFmode:
          if (pattern555 (x1, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
            return -1;
          return 63;

        case E_V2HFmode:
          if (pattern555 (x1, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
            return -1;
          return 64;

        case E_V4HFmode:
          if (pattern555 (x1, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
            return -1;
          return 65;

        case E_V8HFmode:
          if (pattern555 (x1, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
            return -1;
          return 66;

        case E_V16HFmode:
          if (pattern555 (x1, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
            return -1;
          return 67;

        case E_V32HFmode:
          if (pattern555 (x1, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
            return -1;
          return 68;

        case E_V64HFmode:
          if (pattern555 (x1, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
            return -1;
          return 69;

        case E_V128HFmode:
          if (pattern555 (x1, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
            return -1;
          return 70;

        case E_V256HFmode:
          if (pattern555 (x1, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
            return -1;
          return 71;

        case E_V512HFmode:
          if (pattern555 (x1, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
            return -1;
          return 72;

        case E_V1024HFmode:
          if (pattern555 (x1, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
            return -1;
          return 73;

        case E_V2048HFmode:
          if (pattern555 (x1, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
            return -1;
          return 74;

        case E_V1SFmode:
          if (pattern555 (x1, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
            return -1;
          return 75;

        case E_V2SFmode:
          if (pattern555 (x1, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
            return -1;
          return 76;

        case E_V4SFmode:
          if (pattern555 (x1, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
            return -1;
          return 77;

        case E_V8SFmode:
          if (pattern555 (x1, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
            return -1;
          return 78;

        case E_V16SFmode:
          if (pattern555 (x1, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
            return -1;
          return 79;

        case E_V32SFmode:
          if (pattern555 (x1, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
            return -1;
          return 80;

        case E_V64SFmode:
          if (pattern555 (x1, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
            return -1;
          return 81;

        case E_V128SFmode:
          if (pattern555 (x1, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
            return -1;
          return 82;

        case E_V256SFmode:
          if (pattern555 (x1, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
            return -1;
          return 83;

        case E_V512SFmode:
          if (pattern555 (x1, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
            return -1;
          return 84;

        case E_V1024SFmode:
          if (pattern555 (x1, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0)
            return -1;
          return 85;

        case E_V1DFmode:
          if (pattern555 (x1, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0)
            return -1;
          return 86;

        case E_V2DFmode:
          if (pattern555 (x1, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0)
            return -1;
          return 87;

        case E_V4DFmode:
          if (pattern555 (x1, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0)
            return -1;
          return 88;

        case E_V8DFmode:
          if (pattern555 (x1, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0)
            return -1;
          return 89;

        case E_V16DFmode:
          if (pattern555 (x1, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0)
            return -1;
          return 90;

        case E_V32DFmode:
          if (pattern555 (x1, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0)
            return -1;
          return 91;

        case E_V64DFmode:
          if (pattern555 (x1, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0)
            return -1;
          return 92;

        case E_V128DFmode:
          if (pattern555 (x1, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0)
            return -1;
          return 93;

        case E_V256DFmode:
          if (pattern555 (x1, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0)
            return -1;
          return 94;

        case E_V512DFmode:
          if (pattern555 (x1, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0)
            return -1;
          return 95;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern579 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (!register_operand (x6, i1))
    return -1;
  return 0;
}

int
pattern580 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i3)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern583 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          return pattern579 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

        case E_RVVM4HFmode:
          if (pattern579 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HFmode:
          if (pattern579 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HFmode:
          if (pattern579 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HFmode:
          if (pattern579 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HFmode:
          if (pattern579 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 5;

        case E_RVVM8SFmode:
          if (pattern579 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 6;

        case E_RVVM4SFmode:
          if (pattern579 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 7;

        case E_RVVM2SFmode:
          if (pattern579 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 8;

        case E_RVVM1SFmode:
          if (pattern579 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (pattern579 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 10;

        case E_RVVM8DFmode:
          if (pattern579 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 11;

        case E_RVVM4DFmode:
          if (pattern579 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 12;

        case E_RVVM2DFmode:
          if (pattern579 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 13;

        case E_RVVM1DFmode:
          if (pattern579 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 14;

        case E_V1HFmode:
          if (pattern579 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 15;

        case E_V2HFmode:
          if (pattern579 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 16;

        case E_V4HFmode:
          if (pattern579 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 17;

        case E_V8HFmode:
          if (pattern579 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 18;

        case E_V16HFmode:
          if (pattern579 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 19;

        case E_V32HFmode:
          if (pattern579 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 20;

        case E_V64HFmode:
          if (pattern579 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 21;

        case E_V128HFmode:
          if (pattern579 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 22;

        case E_V256HFmode:
          if (pattern579 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 23;

        case E_V512HFmode:
          if (pattern579 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 24;

        case E_V1024HFmode:
          if (pattern579 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 25;

        case E_V2048HFmode:
          if (pattern579 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 26;

        case E_V1SFmode:
          if (pattern579 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 27;

        case E_V2SFmode:
          if (pattern579 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 28;

        case E_V4SFmode:
          if (pattern579 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 29;

        case E_V8SFmode:
          if (pattern579 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 30;

        case E_V16SFmode:
          if (pattern579 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 31;

        case E_V32SFmode:
          if (pattern579 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 32;

        case E_V64SFmode:
          if (pattern579 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 33;

        case E_V128SFmode:
          if (pattern579 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 34;

        case E_V256SFmode:
          if (pattern579 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 35;

        case E_V512SFmode:
          if (pattern579 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 36;

        case E_V1024SFmode:
          if (pattern579 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 37;

        case E_V1DFmode:
          if (pattern579 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 38;

        case E_V2DFmode:
          if (pattern579 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 39;

        case E_V4DFmode:
          if (pattern579 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 40;

        case E_V8DFmode:
          if (pattern579 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 41;

        case E_V16DFmode:
          if (pattern579 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 42;

        case E_V32DFmode:
          if (pattern579 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 43;

        case E_V64DFmode:
          if (pattern579 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 44;

        case E_V128DFmode:
          if (pattern579 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 45;

        case E_V256DFmode:
          if (pattern579 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 46;

        case E_V512DFmode:
          if (pattern579 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x6 = XEXP (x1, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XVECEXP (x6, 0, 5);
      operands[9] = x11;
      x12 = XEXP (x5, 0);
      operands[2] = x12;
      x13 = XEXP (x4, 1);
      operands[3] = x13;
      x14 = XEXP (x2, 1);
      operands[4] = x14;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern580 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) != 0)
            return -1;
          return 48;

        case E_RVVM4HFmode:
          if (pattern580 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
            return -1;
          return 49;

        case E_RVVM2HFmode:
          if (pattern580 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
            return -1;
          return 50;

        case E_RVVM1HFmode:
          if (pattern580 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
            return -1;
          return 51;

        case E_RVVMF2HFmode:
          if (pattern580 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
            return -1;
          return 52;

        case E_RVVMF4HFmode:
          if (pattern580 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
            return -1;
          return 53;

        case E_RVVM8SFmode:
          if (pattern580 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
            return -1;
          return 54;

        case E_RVVM4SFmode:
          if (pattern580 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
            return -1;
          return 55;

        case E_RVVM2SFmode:
          if (pattern580 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
            return -1;
          return 56;

        case E_RVVM1SFmode:
          if (pattern580 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
            return -1;
          return 57;

        case E_RVVMF2SFmode:
          if (pattern580 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
            return -1;
          return 58;

        case E_RVVM8DFmode:
          if (pattern580 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
            return -1;
          return 59;

        case E_RVVM4DFmode:
          if (pattern580 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
            return -1;
          return 60;

        case E_RVVM2DFmode:
          if (pattern580 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
            return -1;
          return 61;

        case E_RVVM1DFmode:
          if (pattern580 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
            return -1;
          return 62;

        case E_V1HFmode:
          if (pattern580 (x1, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
            return -1;
          return 63;

        case E_V2HFmode:
          if (pattern580 (x1, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
            return -1;
          return 64;

        case E_V4HFmode:
          if (pattern580 (x1, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
            return -1;
          return 65;

        case E_V8HFmode:
          if (pattern580 (x1, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
            return -1;
          return 66;

        case E_V16HFmode:
          if (pattern580 (x1, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
            return -1;
          return 67;

        case E_V32HFmode:
          if (pattern580 (x1, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
            return -1;
          return 68;

        case E_V64HFmode:
          if (pattern580 (x1, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
            return -1;
          return 69;

        case E_V128HFmode:
          if (pattern580 (x1, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
            return -1;
          return 70;

        case E_V256HFmode:
          if (pattern580 (x1, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
            return -1;
          return 71;

        case E_V512HFmode:
          if (pattern580 (x1, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
            return -1;
          return 72;

        case E_V1024HFmode:
          if (pattern580 (x1, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
            return -1;
          return 73;

        case E_V2048HFmode:
          if (pattern580 (x1, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
            return -1;
          return 74;

        case E_V1SFmode:
          if (pattern580 (x1, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
            return -1;
          return 75;

        case E_V2SFmode:
          if (pattern580 (x1, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
            return -1;
          return 76;

        case E_V4SFmode:
          if (pattern580 (x1, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
            return -1;
          return 77;

        case E_V8SFmode:
          if (pattern580 (x1, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
            return -1;
          return 78;

        case E_V16SFmode:
          if (pattern580 (x1, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
            return -1;
          return 79;

        case E_V32SFmode:
          if (pattern580 (x1, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
            return -1;
          return 80;

        case E_V64SFmode:
          if (pattern580 (x1, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
            return -1;
          return 81;

        case E_V128SFmode:
          if (pattern580 (x1, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
            return -1;
          return 82;

        case E_V256SFmode:
          if (pattern580 (x1, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
            return -1;
          return 83;

        case E_V512SFmode:
          if (pattern580 (x1, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
            return -1;
          return 84;

        case E_V1024SFmode:
          if (pattern580 (x1, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0)
            return -1;
          return 85;

        case E_V1DFmode:
          if (pattern580 (x1, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0)
            return -1;
          return 86;

        case E_V2DFmode:
          if (pattern580 (x1, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0)
            return -1;
          return 87;

        case E_V4DFmode:
          if (pattern580 (x1, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0)
            return -1;
          return 88;

        case E_V8DFmode:
          if (pattern580 (x1, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0)
            return -1;
          return 89;

        case E_V16DFmode:
          if (pattern580 (x1, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0)
            return -1;
          return 90;

        case E_V32DFmode:
          if (pattern580 (x1, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0)
            return -1;
          return 91;

        case E_V64DFmode:
          if (pattern580 (x1, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0)
            return -1;
          return 92;

        case E_V128DFmode:
          if (pattern580 (x1, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0)
            return -1;
          return 93;

        case E_V256DFmode:
          if (pattern580 (x1, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0)
            return -1;
          return 94;

        case E_V512DFmode:
          if (pattern580 (x1, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0)
            return -1;
          return 95;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x13 = XEXP (x4, 1);
      if (GET_CODE (x13) != FLOAT_EXTEND)
        return -1;
      x6 = XEXP (x1, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XVECEXP (x6, 0, 5);
      operands[9] = x11;
      x15 = XEXP (x13, 0);
      operands[4] = x15;
      x14 = XEXP (x2, 1);
      operands[2] = x14;
      x16 = XEXP (x1, 2);
      if (!rtx_equal_p (x16, operands[2]))
        return -1;
      x12 = XEXP (x5, 0);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[3] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern581 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 96;

            case E_RVVM4SFmode:
              if (pattern581 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 97;

            case E_RVVM2SFmode:
              if (pattern581 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 98;

            case E_RVVM1SFmode:
              if (pattern581 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 99;

            case E_RVVMF2SFmode:
              if (pattern581 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 100;

            case E_RVVM8DFmode:
              if (pattern581 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 101;

            case E_RVVM4DFmode:
              if (pattern581 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 102;

            case E_RVVM2DFmode:
              if (pattern581 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 103;

            case E_RVVM1DFmode:
              if (pattern581 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 104;

            case E_V1SFmode:
              if (pattern581 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0)
                return -1;
              return 105;

            case E_V2SFmode:
              if (pattern581 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0)
                return -1;
              return 106;

            case E_V4SFmode:
              if (pattern581 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0)
                return -1;
              return 107;

            case E_V8SFmode:
              if (pattern581 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0)
                return -1;
              return 108;

            case E_V16SFmode:
              if (pattern581 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0)
                return -1;
              return 109;

            case E_V32SFmode:
              if (pattern581 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0)
                return -1;
              return 110;

            case E_V64SFmode:
              if (pattern581 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0)
                return -1;
              return 111;

            case E_V128SFmode:
              if (pattern581 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0)
                return -1;
              return 112;

            case E_V256SFmode:
              if (pattern581 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0)
                return -1;
              return 113;

            case E_V512SFmode:
              if (pattern581 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0)
                return -1;
              return 114;

            case E_V1024SFmode:
              if (pattern581 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
                return -1;
              return 115;

            case E_V1DFmode:
              if (pattern581 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
                return -1;
              return 116;

            case E_V2DFmode:
              if (pattern581 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
                return -1;
              return 117;

            case E_V4DFmode:
              if (pattern581 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
                return -1;
              return 118;

            case E_V8DFmode:
              if (pattern581 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
                return -1;
              return 119;

            case E_V16DFmode:
              if (pattern581 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
                return -1;
              return 120;

            case E_V32DFmode:
              if (pattern581 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
                return -1;
              return 121;

            case E_V64DFmode:
              if (pattern581 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
                return -1;
              return 122;

            case E_V128DFmode:
              if (pattern581 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
                return -1;
              return 123;

            case E_V256DFmode:
              if (pattern581 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
                return -1;
              return 124;

            case E_V512DFmode:
              if (pattern581 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
                return -1;
              return 125;

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x17 = XEXP (x12, 0);
          operands[3] = x17;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern582 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
                return -1;
              return 126;

            case E_RVVM4SFmode:
              if (pattern582 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
                return -1;
              return 127;

            case E_RVVM2SFmode:
              if (pattern582 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
                return -1;
              return 128;

            case E_RVVM1SFmode:
              if (pattern582 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
                return -1;
              return 129;

            case E_RVVMF2SFmode:
              if (pattern582 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
                return -1;
              return 130;

            case E_RVVM8DFmode:
              if (pattern582 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
                return -1;
              return 131;

            case E_RVVM4DFmode:
              if (pattern582 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
                return -1;
              return 132;

            case E_RVVM2DFmode:
              if (pattern582 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
                return -1;
              return 133;

            case E_RVVM1DFmode:
              if (pattern582 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
                return -1;
              return 134;

            case E_V1SFmode:
              if (pattern582 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
                return -1;
              return 135;

            case E_V2SFmode:
              if (pattern582 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
                return -1;
              return 136;

            case E_V4SFmode:
              if (pattern582 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
                return -1;
              return 137;

            case E_V8SFmode:
              if (pattern582 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
                return -1;
              return 138;

            case E_V16SFmode:
              if (pattern582 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
                return -1;
              return 139;

            case E_V32SFmode:
              if (pattern582 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
                return -1;
              return 140;

            case E_V64SFmode:
              if (pattern582 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
                return -1;
              return 141;

            case E_V128SFmode:
              if (pattern582 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
                return -1;
              return 142;

            case E_V256SFmode:
              if (pattern582 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
                return -1;
              return 143;

            case E_V512SFmode:
              if (pattern582 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
                return -1;
              return 144;

            case E_V1024SFmode:
              if (pattern582 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
                return -1;
              return 145;

            case E_V1DFmode:
              if (pattern582 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
                return -1;
              return 146;

            case E_V2DFmode:
              if (pattern582 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
                return -1;
              return 147;

            case E_V4DFmode:
              if (pattern582 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
                return -1;
              return 148;

            case E_V8DFmode:
              if (pattern582 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
                return -1;
              return 149;

            case E_V16DFmode:
              if (pattern582 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
                return -1;
              return 150;

            case E_V32DFmode:
              if (pattern582 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
                return -1;
              return 151;

            case E_V64DFmode:
              if (pattern582 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
                return -1;
              return 152;

            case E_V128DFmode:
              if (pattern582 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
                return -1;
              return 153;

            case E_V256DFmode:
              if (pattern582 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
                return -1;
              return 154;

            case E_V512DFmode:
              if (pattern582 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
                return -1;
              return 155;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern715 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern720 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[4], i3)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern722 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          return pattern526 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode); /* [-1, 0] */

        case E_RVVM4SFmode:
          if (pattern526 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2SFmode:
          if (pattern526 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1SFmode:
          if (pattern526 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2SFmode:
          if (pattern526 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 4;

        case E_RVVM8DFmode:
          if (pattern526 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 5;

        case E_RVVM4DFmode:
          if (pattern526 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 6;

        case E_RVVM2DFmode:
          if (pattern526 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 7;

        case E_RVVM1DFmode:
          if (pattern526 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 8;

        case E_V1SFmode:
          if (pattern526 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 9;

        case E_V2SFmode:
          if (pattern526 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 10;

        case E_V4SFmode:
          if (pattern526 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 11;

        case E_V8SFmode:
          if (pattern526 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 12;

        case E_V16SFmode:
          if (pattern526 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 13;

        case E_V32SFmode:
          if (pattern526 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 14;

        case E_V64SFmode:
          if (pattern526 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 15;

        case E_V128SFmode:
          if (pattern526 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 16;

        case E_V256SFmode:
          if (pattern526 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 17;

        case E_V512SFmode:
          if (pattern526 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 18;

        case E_V1024SFmode:
          if (pattern526 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 19;

        case E_V1DFmode:
          if (pattern526 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 20;

        case E_V2DFmode:
          if (pattern526 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 21;

        case E_V4DFmode:
          if (pattern526 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 22;

        case E_V8DFmode:
          if (pattern526 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 23;

        case E_V16DFmode:
          if (pattern526 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 24;

        case E_V32DFmode:
          if (pattern526 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 25;

        case E_V64DFmode:
          if (pattern526 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 26;

        case E_V128DFmode:
          if (pattern526 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 27;

        case E_V256DFmode:
          if (pattern526 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 28;

        case E_V512DFmode:
          if (pattern526 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 29;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern721 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
            return -1;
          return 30;

        case E_RVVM4SFmode:
          if (pattern721 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
            return -1;
          return 31;

        case E_RVVM2SFmode:
          if (pattern721 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
            return -1;
          return 32;

        case E_RVVM1SFmode:
          if (pattern721 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
            return -1;
          return 33;

        case E_RVVMF2SFmode:
          if (pattern721 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
            return -1;
          return 34;

        case E_RVVM8DFmode:
          if (pattern721 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
            return -1;
          return 35;

        case E_RVVM4DFmode:
          if (pattern721 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
            return -1;
          return 36;

        case E_RVVM2DFmode:
          if (pattern721 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
            return -1;
          return 37;

        case E_RVVM1DFmode:
          if (pattern721 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
            return -1;
          return 38;

        case E_V1SFmode:
          if (pattern721 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
            return -1;
          return 39;

        case E_V2SFmode:
          if (pattern721 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
            return -1;
          return 40;

        case E_V4SFmode:
          if (pattern721 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
            return -1;
          return 41;

        case E_V8SFmode:
          if (pattern721 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
            return -1;
          return 42;

        case E_V16SFmode:
          if (pattern721 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
            return -1;
          return 43;

        case E_V32SFmode:
          if (pattern721 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
            return -1;
          return 44;

        case E_V64SFmode:
          if (pattern721 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
            return -1;
          return 45;

        case E_V128SFmode:
          if (pattern721 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
            return -1;
          return 46;

        case E_V256SFmode:
          if (pattern721 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
            return -1;
          return 47;

        case E_V512SFmode:
          if (pattern721 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
            return -1;
          return 48;

        case E_V1024SFmode:
          if (pattern721 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
            return -1;
          return 49;

        case E_V1DFmode:
          if (pattern721 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
            return -1;
          return 50;

        case E_V2DFmode:
          if (pattern721 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
            return -1;
          return 51;

        case E_V4DFmode:
          if (pattern721 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
            return -1;
          return 52;

        case E_V8DFmode:
          if (pattern721 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
            return -1;
          return 53;

        case E_V16DFmode:
          if (pattern721 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
            return -1;
          return 54;

        case E_V32DFmode:
          if (pattern721 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
            return -1;
          return 55;

        case E_V64DFmode:
          if (pattern721 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
            return -1;
          return 56;

        case E_V128DFmode:
          if (pattern721 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
            return -1;
          return 57;

        case E_V256DFmode:
          if (pattern721 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
            return -1;
          return 58;

        case E_V512DFmode:
          if (pattern721 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
            return -1;
          return 59;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern742 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 6);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern745 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vector_merge_operand (operands[2], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern746 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !memory_operand (operands[3], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XVECEXP (x7, 0, 0);
  return pattern745 (x8, 
i1, 
i2); /* [-1, 0] */
}

int
pattern748 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 7);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern750 (rtx x1, int i1, machine_mode i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i2)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i2)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i2)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i2)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i2)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i2)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i2)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i2)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i2)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i2)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i2)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i2)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i2)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i2)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i2)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i2)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i2)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i2)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i2)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i2)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i2)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i2)
    return -1;
  switch (REGNO (x7))
    {
    case 24:
      if (REGNO (x12) != 23
          || REGNO (x17) != 22
          || REGNO (x22) != 21
          || REGNO (x27) != 20
          || REGNO (x32) != 19)
        return -1;
      x38 = XEXP (x36, 1);
      if (GET_CODE (x38) != MEM
          || GET_MODE (x38) != i2)
        return -1;
      x39 = XEXP (x38, 0);
      if (GET_CODE (x39) != PLUS
          || GET_MODE (x39) != i2)
        return -1;
      x40 = XEXP (x39, 0);
      if (GET_CODE (x40) != REG
          || REGNO (x40) != 2
          || GET_MODE (x40) != i2)
        return -1;
      x41 = XEXP (x39, 1);
      if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
          || REGNO (x37) != 18)
        return -1;
      return 0;

    case 22:
      if (REGNO (x12) != 21
          || REGNO (x17) != 20
          || REGNO (x22) != 19
          || REGNO (x27) != 18
          || REGNO (x32) != 9)
        return -1;
      x38 = XEXP (x36, 1);
      if (GET_CODE (x38) != MEM
          || GET_MODE (x38) != i2)
        return -1;
      x39 = XEXP (x38, 0);
      if (GET_CODE (x39) != PLUS
          || GET_MODE (x39) != i2)
        return -1;
      x40 = XEXP (x39, 0);
      if (GET_CODE (x40) != REG
          || REGNO (x40) != 2
          || GET_MODE (x40) != i2)
        return -1;
      x41 = XEXP (x39, 1);
      if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
          || REGNO (x37) != 8)
        return -1;
      x42 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x42) != SET)
        return -1;
      x43 = XEXP (x42, 1);
      if (GET_CODE (x43) != MEM
          || GET_MODE (x43) != i2)
        return -1;
      x44 = XEXP (x43, 0);
      if (GET_CODE (x44) != PLUS
          || GET_MODE (x44) != i2)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 2
          || GET_MODE (x45) != i2)
        return -1;
      x46 = XEXP (x44, 1);
      if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x47 = XEXP (x42, 0);
      if (GET_CODE (x47) != REG
          || REGNO (x47) != 1
          || GET_MODE (x47) != i2)
        return -1;
      x48 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x48) != RETURN)
        return -1;
      x49 = XVECEXP (x1, 0, 10);
      if (pattern749 (x49, 
E_SImode, 
1) != 0)
        return -1;
      return 1;

    case 20:
      if (REGNO (x12) != 19
          || REGNO (x17) != 18
          || REGNO (x22) != 9
          || REGNO (x27) != 8
          || REGNO (x32) != 1)
        return -1;
      x38 = XEXP (x36, 1);
      if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x37) != 10)
        return -1;
      x42 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x42) != USE)
        return -1;
      x47 = XEXP (x42, 0);
      if (GET_CODE (x47) != REG
          || REGNO (x47) != 10
          || GET_MODE (x47) != i2)
        return -1;
      x48 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x48) != RETURN)
        return -1;
      x49 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x49) != USE)
        return -1;
      x50 = XEXP (x49, 0);
      if (GET_CODE (x50) != REG
          || REGNO (x50) != 1
          || GET_MODE (x50) != E_SImode
          || !stack_pop_up_to_s4_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern768 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  x43 = XEXP (x41, 1);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XVECEXP (x1, 0, 9);
  x47 = XEXP (x46, 0);
  if (GET_MODE (x47) != i1)
    return -1;
  x48 = XEXP (x46, 1);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XVECEXP (x1, 0, 10);
  x52 = XEXP (x51, 0);
  if (GET_MODE (x52) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 27:
      return pattern767 (x1, 
23, 
24, 
25, 
26); /* [-1, 0] */

    case 25:
      if (pattern767 (x1, 
21, 
22, 
23, 
24) != 0)
        return -1;
      return 1;

    case 23:
      if (REGNO (x12) != 22
          || REGNO (x17) != 21
          || REGNO (x22) != 20
          || REGNO (x27) != 19
          || REGNO (x32) != 18
          || REGNO (x37) != 9
          || REGNO (x42) != 8
          || REGNO (x47) != 1)
        return -1;
      x53 = XEXP (x51, 1);
      if (x53 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x52) != 10)
        return -1;
      x54 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x54) != USE)
        return -1;
      x55 = XEXP (x54, 0);
      if (GET_CODE (x55) != REG
          || REGNO (x55) != 10
          || GET_MODE (x55) != i1)
        return -1;
      x56 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x56) != RETURN)
        return -1;
      x57 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x57) != USE)
        return -1;
      x58 = XEXP (x57, 0);
      if (GET_CODE (x58) != REG
          || REGNO (x58) != 1
          || GET_MODE (x58) != E_SImode
          || !stack_pop_up_to_s7_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern788 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XEXP (x27, 1);
  if (GET_MODE (x31) != i1)
    return -1;
  x32 = XVECEXP (x1, 0, 6);
  x33 = XEXP (x32, 0);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XEXP (x32, 1);
  if (GET_MODE (x36) != i1)
    return -1;
  x37 = XVECEXP (x1, 0, 7);
  x38 = XEXP (x37, 0);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XEXP (x37, 1);
  if (GET_MODE (x41) != i1)
    return -1;
  x42 = XVECEXP (x1, 0, 8);
  x43 = XEXP (x42, 0);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XEXP (x42, 1);
  if (GET_MODE (x46) != i1)
    return -1;
  x47 = XVECEXP (x1, 0, 9);
  x48 = XEXP (x47, 0);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XEXP (x47, 1);
  if (GET_MODE (x51) != i1)
    return -1;
  x52 = XVECEXP (x1, 0, 10);
  x53 = XEXP (x52, 0);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x53, 0);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  x56 = XEXP (x52, 1);
  if (GET_MODE (x56) != i1)
    return -1;
  x57 = XVECEXP (x1, 0, 11);
  x58 = XEXP (x57, 0);
  if (GET_MODE (x58) != i1)
    return -1;
  x59 = XEXP (x58, 0);
  if (GET_MODE (x59) != i1)
    return -1;
  x60 = XEXP (x59, 0);
  if (GET_MODE (x60) != i1)
    return -1;
  x61 = XEXP (x57, 1);
  if (GET_MODE (x61) != i1)
    return -1;
  x62 = XVECEXP (x1, 0, 12);
  x63 = XEXP (x62, 0);
  if (GET_MODE (x63) != i1)
    return -1;
  x64 = XEXP (x63, 0);
  if (GET_MODE (x64) != i1)
    return -1;
  x65 = XEXP (x64, 0);
  if (GET_MODE (x65) != i1)
    return -1;
  x66 = XEXP (x62, 1);
  if (GET_MODE (x66) != i1)
    return -1;
  x67 = XVECEXP (x1, 0, 13);
  x68 = XEXP (x67, 0);
  if (GET_MODE (x68) != i1)
    return -1;
  x69 = XEXP (x67, 1);
  if (GET_MODE (x69) != i1)
    return -1;
  x70 = XEXP (x69, 0);
  if (GET_MODE (x70) != i1)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern147 (x2))
        {
        case 0:
          if (!
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30146; /* *dual_widen_addsrvvm8hi */

        case 1:
          if (!
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30152; /* *dual_widen_addsrvvm4hi */

        case 2:
          if (!
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30158; /* *dual_widen_addsrvvm2hi */

        case 3:
          if (!
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30164; /* *dual_widen_addsrvvm1hi */

        case 4:
          if (!
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30170; /* *dual_widen_addsrvvmf2hi */

        case 5:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30176; /* *dual_widen_addsrvvmf4hi */

        case 6:
          if (!
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30182; /* *dual_widen_addsrvvm8si */

        case 7:
          if (!
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30188; /* *dual_widen_addsrvvm4si */

        case 8:
          if (!
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30194; /* *dual_widen_addsrvvm2si */

        case 9:
          if (!
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30200; /* *dual_widen_addsrvvm1si */

        case 10:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30206; /* *dual_widen_addsrvvmf2si */

        case 11:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30212; /* *dual_widen_addsrvvm8di */

        case 12:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30218; /* *dual_widen_addsrvvm4di */

        case 13:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30224; /* *dual_widen_addsrvvm2di */

        case 14:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30230; /* *dual_widen_addsrvvm1di */

        case 15:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 30236; /* *dual_widen_addsv1hi */

        case 16:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 30242; /* *dual_widen_addsv2hi */

        case 17:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 30248; /* *dual_widen_addsv4hi */

        case 18:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 30254; /* *dual_widen_addsv8hi */

        case 19:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 30260; /* *dual_widen_addsv16hi */

        case 20:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30266; /* *dual_widen_addsv32hi */

        case 21:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30272; /* *dual_widen_addsv64hi */

        case 22:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30278; /* *dual_widen_addsv128hi */

        case 23:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30284; /* *dual_widen_addsv256hi */

        case 24:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30290; /* *dual_widen_addsv512hi */

        case 25:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30296; /* *dual_widen_addsv1024hi */

        case 26:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30302; /* *dual_widen_addsv2048hi */

        case 27:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 30308; /* *dual_widen_addsv1si */

        case 28:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 30314; /* *dual_widen_addsv2si */

        case 29:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 30320; /* *dual_widen_addsv4si */

        case 30:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 30326; /* *dual_widen_addsv8si */

        case 31:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30332; /* *dual_widen_addsv16si */

        case 32:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30338; /* *dual_widen_addsv32si */

        case 33:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30344; /* *dual_widen_addsv64si */

        case 34:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30350; /* *dual_widen_addsv128si */

        case 35:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30356; /* *dual_widen_addsv256si */

        case 36:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30362; /* *dual_widen_addsv512si */

        case 37:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30368; /* *dual_widen_addsv1024si */

        case 38:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30374; /* *dual_widen_addsv1di */

        case 39:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30380; /* *dual_widen_addsv2di */

        case 40:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30386; /* *dual_widen_addsv4di */

        case 41:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30392; /* *dual_widen_addsv8di */

        case 42:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30398; /* *dual_widen_addsv16di */

        case 43:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30404; /* *dual_widen_addsv32di */

        case 44:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30410; /* *dual_widen_addsv64di */

        case 45:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30416; /* *dual_widen_addsv128di */

        case 46:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30422; /* *dual_widen_addsv256di */

        case 47:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30428; /* *dual_widen_addsv512di */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern148 (x2))
        {
        case 0:
          if (!
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30530; /* *single_widen_addsrvvm8hi */

        case 1:
          if (!
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30532; /* *single_widen_addsrvvm4hi */

        case 2:
          if (!
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30534; /* *single_widen_addsrvvm2hi */

        case 3:
          if (!
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30536; /* *single_widen_addsrvvm1hi */

        case 4:
          if (!
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30538; /* *single_widen_addsrvvmf2hi */

        case 5:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30540; /* *single_widen_addsrvvmf4hi */

        case 6:
          if (!
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30542; /* *single_widen_addsrvvm8si */

        case 7:
          if (!
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30544; /* *single_widen_addsrvvm4si */

        case 8:
          if (!
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30546; /* *single_widen_addsrvvm2si */

        case 9:
          if (!
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30548; /* *single_widen_addsrvvm1si */

        case 10:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 30550; /* *single_widen_addsrvvmf2si */

        case 11:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30552; /* *single_widen_addsrvvm8di */

        case 12:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30554; /* *single_widen_addsrvvm4di */

        case 13:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30556; /* *single_widen_addsrvvm2di */

        case 14:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30558; /* *single_widen_addsrvvm1di */

        case 15:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 30560; /* *single_widen_addsv1hi */

        case 16:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 30562; /* *single_widen_addsv2hi */

        case 17:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 30564; /* *single_widen_addsv4hi */

        case 18:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 30566; /* *single_widen_addsv8hi */

        case 19:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 30568; /* *single_widen_addsv16hi */

        case 20:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30570; /* *single_widen_addsv32hi */

        case 21:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30572; /* *single_widen_addsv64hi */

        case 22:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30574; /* *single_widen_addsv128hi */

        case 23:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30576; /* *single_widen_addsv256hi */

        case 24:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30578; /* *single_widen_addsv512hi */

        case 25:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30580; /* *single_widen_addsv1024hi */

        case 26:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30582; /* *single_widen_addsv2048hi */

        case 27:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 30584; /* *single_widen_addsv1si */

        case 28:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 30586; /* *single_widen_addsv2si */

        case 29:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 30588; /* *single_widen_addsv4si */

        case 30:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 30590; /* *single_widen_addsv8si */

        case 31:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30592; /* *single_widen_addsv16si */

        case 32:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30594; /* *single_widen_addsv32si */

        case 33:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30596; /* *single_widen_addsv64si */

        case 34:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30598; /* *single_widen_addsv128si */

        case 35:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30600; /* *single_widen_addsv256si */

        case 36:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30602; /* *single_widen_addsv512si */

        case 37:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30604; /* *single_widen_addsv1024si */

        case 38:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30606; /* *single_widen_addsv1di */

        case 39:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30608; /* *single_widen_addsv2di */

        case 40:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30610; /* *single_widen_addsv4di */

        case 41:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30612; /* *single_widen_addsv8di */

        case 42:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30614; /* *single_widen_addsv16di */

        case 43:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30616; /* *single_widen_addsv32di */

        case 44:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30618; /* *single_widen_addsv64di */

        case 45:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30620; /* *single_widen_addsv128di */

        case 46:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30622; /* *single_widen_addsv256di */

        case 47:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30624; /* *single_widen_addsv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      return recog_18 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_HImode)
          || !
#line 384 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC))
        return -1;
      return 911; /* *th_msubhisi4 */

    case FLOAT_EXTEND:
      switch (pattern284 (x2))
        {
        case 0:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31532; /* *dual_widen_fnmarvvm8sf */

        case 1:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31533; /* *dual_widen_fnmarvvm4sf */

        case 2:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31534; /* *dual_widen_fnmarvvm2sf */

        case 3:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31535; /* *dual_widen_fnmarvvm1sf */

        case 4:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 31536; /* *dual_widen_fnmarvvmf2sf */

        case 5:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31537; /* *dual_widen_fnmarvvm8df */

        case 6:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31538; /* *dual_widen_fnmarvvm4df */

        case 7:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31539; /* *dual_widen_fnmarvvm2df */

        case 8:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31540; /* *dual_widen_fnmarvvm1df */

        case 9:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31541; /* *dual_widen_fnmav1sf */

        case 10:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31542; /* *dual_widen_fnmav2sf */

        case 11:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31543; /* *dual_widen_fnmav4sf */

        case 12:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31544; /* *dual_widen_fnmav8sf */

        case 13:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31545; /* *dual_widen_fnmav16sf */

        case 14:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31546; /* *dual_widen_fnmav32sf */

        case 15:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31547; /* *dual_widen_fnmav64sf */

        case 16:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31548; /* *dual_widen_fnmav128sf */

        case 17:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31549; /* *dual_widen_fnmav256sf */

        case 18:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31550; /* *dual_widen_fnmav512sf */

        case 19:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31551; /* *dual_widen_fnmav1024sf */

        case 20:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31552; /* *dual_widen_fnmav1df */

        case 21:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31553; /* *dual_widen_fnmav2df */

        case 22:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31554; /* *dual_widen_fnmav4df */

        case 23:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31555; /* *dual_widen_fnmav8df */

        case 24:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31556; /* *dual_widen_fnmav16df */

        case 25:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31557; /* *dual_widen_fnmav32df */

        case 26:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31558; /* *dual_widen_fnmav64df */

        case 27:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31559; /* *dual_widen_fnmav128df */

        case 28:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31560; /* *dual_widen_fnmav256df */

        case 29:
          if (!(
#line 1056 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31561; /* *dual_widen_fnmav512df */

        case 30:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31562; /* *single_widen_fnmarvvm8sf */

        case 31:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31563; /* *single_widen_fnmarvvm4sf */

        case 32:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31564; /* *single_widen_fnmarvvm2sf */

        case 33:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31565; /* *single_widen_fnmarvvm1sf */

        case 34:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 31566; /* *single_widen_fnmarvvmf2sf */

        case 35:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31567; /* *single_widen_fnmarvvm8df */

        case 36:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31568; /* *single_widen_fnmarvvm4df */

        case 37:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31569; /* *single_widen_fnmarvvm2df */

        case 38:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31570; /* *single_widen_fnmarvvm1df */

        case 39:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31571; /* *single_widen_fnmav1sf */

        case 40:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31572; /* *single_widen_fnmav2sf */

        case 41:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31573; /* *single_widen_fnmav4sf */

        case 42:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31574; /* *single_widen_fnmav8sf */

        case 43:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31575; /* *single_widen_fnmav16sf */

        case 44:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31576; /* *single_widen_fnmav32sf */

        case 45:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31577; /* *single_widen_fnmav64sf */

        case 46:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31578; /* *single_widen_fnmav128sf */

        case 47:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31579; /* *single_widen_fnmav256sf */

        case 48:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31580; /* *single_widen_fnmav512sf */

        case 49:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31581; /* *single_widen_fnmav1024sf */

        case 50:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31582; /* *single_widen_fnmav1df */

        case 51:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31583; /* *single_widen_fnmav2df */

        case 52:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31584; /* *single_widen_fnmav4df */

        case 53:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31585; /* *single_widen_fnmav8df */

        case 54:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31586; /* *single_widen_fnmav16df */

        case 55:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31587; /* *single_widen_fnmav32df */

        case 56:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31588; /* *single_widen_fnmav64df */

        case 57:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31589; /* *single_widen_fnmav128df */

        case 58:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31590; /* *single_widen_fnmav256df */

        case 59:
          if (!(
#line 1080 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31591; /* *single_widen_fnmav512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern158 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[2], E_RVVM8SImode)
          && 
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32263; /* *vwsll_zext1_trunc_rvvm8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32323; /* *vwsll_zext1_trunc_scalar_rvvm8si */

    case 1:
      if (vector_shift_operand (operands[2], E_RVVM4SImode)
          && 
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32264; /* *vwsll_zext1_trunc_rvvm4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32324; /* *vwsll_zext1_trunc_scalar_rvvm4si */

    case 2:
      if (vector_shift_operand (operands[2], E_RVVM2SImode)
          && 
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32265; /* *vwsll_zext1_trunc_rvvm2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32325; /* *vwsll_zext1_trunc_scalar_rvvm2si */

    case 3:
      if (vector_shift_operand (operands[2], E_RVVM1SImode)
          && 
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32266; /* *vwsll_zext1_trunc_rvvm1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32326; /* *vwsll_zext1_trunc_scalar_rvvm1si */

    case 4:
      if (vector_shift_operand (operands[2], E_RVVMF2SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32267; /* *vwsll_zext1_trunc_rvvmf2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32327; /* *vwsll_zext1_trunc_scalar_rvvmf2si */

    case 5:
      if (vector_shift_operand (operands[2], E_RVVM8DImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32268; /* *vwsll_zext1_trunc_rvvm8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32328; /* *vwsll_zext1_trunc_scalar_rvvm8di */

    case 6:
      if (vector_shift_operand (operands[2], E_RVVM4DImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32269; /* *vwsll_zext1_trunc_rvvm4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32329; /* *vwsll_zext1_trunc_scalar_rvvm4di */

    case 7:
      if (vector_shift_operand (operands[2], E_RVVM2DImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32270; /* *vwsll_zext1_trunc_rvvm2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32330; /* *vwsll_zext1_trunc_scalar_rvvm2di */

    case 8:
      if (vector_shift_operand (operands[2], E_RVVM1DImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32271; /* *vwsll_zext1_trunc_rvvm1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32331; /* *vwsll_zext1_trunc_scalar_rvvm1di */

    case 9:
      if (vector_shift_operand (operands[2], E_V1SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 32272; /* *vwsll_zext1_trunc_v1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32332; /* *vwsll_zext1_trunc_scalar_v1si */

    case 10:
      if (vector_shift_operand (operands[2], E_V2SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 32273; /* *vwsll_zext1_trunc_v2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32333; /* *vwsll_zext1_trunc_scalar_v2si */

    case 11:
      if (vector_shift_operand (operands[2], E_V4SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 32274; /* *vwsll_zext1_trunc_v4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32334; /* *vwsll_zext1_trunc_scalar_v4si */

    case 12:
      if (vector_shift_operand (operands[2], E_V8SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 32275; /* *vwsll_zext1_trunc_v8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32335; /* *vwsll_zext1_trunc_scalar_v8si */

    case 13:
      if (vector_shift_operand (operands[2], E_V16SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 32276; /* *vwsll_zext1_trunc_v16si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32336; /* *vwsll_zext1_trunc_scalar_v16si */

    case 14:
      if (vector_shift_operand (operands[2], E_V32SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 32277; /* *vwsll_zext1_trunc_v32si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32337; /* *vwsll_zext1_trunc_scalar_v32si */

    case 15:
      if (vector_shift_operand (operands[2], E_V64SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 32278; /* *vwsll_zext1_trunc_v64si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32338; /* *vwsll_zext1_trunc_scalar_v64si */

    case 16:
      if (vector_shift_operand (operands[2], E_V128SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 32279; /* *vwsll_zext1_trunc_v128si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32339; /* *vwsll_zext1_trunc_scalar_v128si */

    case 17:
      if (vector_shift_operand (operands[2], E_V256SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 32280; /* *vwsll_zext1_trunc_v256si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32340; /* *vwsll_zext1_trunc_scalar_v256si */

    case 18:
      if (vector_shift_operand (operands[2], E_V512SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 32281; /* *vwsll_zext1_trunc_v512si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32341; /* *vwsll_zext1_trunc_scalar_v512si */

    case 19:
      if (vector_shift_operand (operands[2], E_V1024SImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 32282; /* *vwsll_zext1_trunc_v1024si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32342; /* *vwsll_zext1_trunc_scalar_v1024si */

    case 20:
      if (vector_shift_operand (operands[2], E_V1DImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 32283; /* *vwsll_zext1_trunc_v1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32343; /* *vwsll_zext1_trunc_scalar_v1di */

    case 21:
      if (vector_shift_operand (operands[2], E_V2DImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 32284; /* *vwsll_zext1_trunc_v2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32344; /* *vwsll_zext1_trunc_scalar_v2di */

    case 22:
      if (vector_shift_operand (operands[2], E_V4DImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 32285; /* *vwsll_zext1_trunc_v4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32345; /* *vwsll_zext1_trunc_scalar_v4di */

    case 23:
      if (vector_shift_operand (operands[2], E_V8DImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 32286; /* *vwsll_zext1_trunc_v8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32346; /* *vwsll_zext1_trunc_scalar_v8di */

    case 24:
      if (vector_shift_operand (operands[2], E_V16DImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 32287; /* *vwsll_zext1_trunc_v16di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32347; /* *vwsll_zext1_trunc_scalar_v16di */

    case 25:
      if (vector_shift_operand (operands[2], E_V32DImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 32288; /* *vwsll_zext1_trunc_v32di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32348; /* *vwsll_zext1_trunc_scalar_v32di */

    case 26:
      if (vector_shift_operand (operands[2], E_V64DImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 32289; /* *vwsll_zext1_trunc_v64di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32349; /* *vwsll_zext1_trunc_scalar_v64di */

    case 27:
      if (vector_shift_operand (operands[2], E_V128DImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 32290; /* *vwsll_zext1_trunc_v128di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32350; /* *vwsll_zext1_trunc_scalar_v128di */

    case 28:
      if (vector_shift_operand (operands[2], E_V256DImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 32291; /* *vwsll_zext1_trunc_v256di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32351; /* *vwsll_zext1_trunc_scalar_v256di */

    case 29:
      if (vector_shift_operand (operands[2], E_V512DImode)
          && (
#line 1552 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 32292; /* *vwsll_zext1_trunc_v512di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1593 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32352; /* *vwsll_zext1_trunc_scalar_v512di */

    case 30:
      if (!
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32293; /* *vwsll_zext2_trunc_rvvm8si */

    case 31:
      if (!
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32294; /* *vwsll_zext2_trunc_rvvm4si */

    case 32:
      if (!
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32295; /* *vwsll_zext2_trunc_rvvm2si */

    case 33:
      if (!
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32296; /* *vwsll_zext2_trunc_rvvm1si */

    case 34:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32297; /* *vwsll_zext2_trunc_rvvmf2si */

    case 35:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32298; /* *vwsll_zext2_trunc_rvvm8di */

    case 36:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32299; /* *vwsll_zext2_trunc_rvvm4di */

    case 37:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32300; /* *vwsll_zext2_trunc_rvvm2di */

    case 38:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32301; /* *vwsll_zext2_trunc_rvvm1di */

    case 39:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32302; /* *vwsll_zext2_trunc_v1si */

    case 40:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32303; /* *vwsll_zext2_trunc_v2si */

    case 41:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32304; /* *vwsll_zext2_trunc_v4si */

    case 42:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32305; /* *vwsll_zext2_trunc_v8si */

    case 43:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32306; /* *vwsll_zext2_trunc_v16si */

    case 44:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32307; /* *vwsll_zext2_trunc_v32si */

    case 45:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32308; /* *vwsll_zext2_trunc_v64si */

    case 46:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32309; /* *vwsll_zext2_trunc_v128si */

    case 47:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32310; /* *vwsll_zext2_trunc_v256si */

    case 48:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32311; /* *vwsll_zext2_trunc_v512si */

    case 49:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32312; /* *vwsll_zext2_trunc_v1024si */

    case 50:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32313; /* *vwsll_zext2_trunc_v1di */

    case 51:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32314; /* *vwsll_zext2_trunc_v2di */

    case 52:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32315; /* *vwsll_zext2_trunc_v4di */

    case 53:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32316; /* *vwsll_zext2_trunc_v8di */

    case 54:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32317; /* *vwsll_zext2_trunc_v16di */

    case 55:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32318; /* *vwsll_zext2_trunc_v32di */

    case 56:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32319; /* *vwsll_zext2_trunc_v64di */

    case 57:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32320; /* *vwsll_zext2_trunc_v128di */

    case 58:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32321; /* *vwsll_zext2_trunc_v256di */

    case 59:
      if (!(
#line 1575 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32322; /* *vwsll_zext2_trunc_v512di */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern525 (x2))
    {
    case 0:
      if (pattern575 (x2) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVM1BImode
          || !
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8835; /* pred_msbcrvvm8qi_overflow */

    case 1:
      if (!register_operand (operands[0], E_RVVMF2BImode)
          || GET_MODE (x2) != E_RVVMF2BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF2BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern630 (x4))
        {
        case 0:
          if (!
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8836; /* pred_msbcrvvm4qi_overflow */

        case 1:
          if (!
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8839; /* pred_msbcrvvm8hi_overflow */

        default:
          return -1;
        }

    case 2:
      if (!register_operand (operands[0], E_RVVMF4BImode)
          || GET_MODE (x2) != E_RVVMF4BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF4BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern631 (x4))
        {
        case 0:
          if (!
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8837; /* pred_msbcrvvm2qi_overflow */

        case 1:
          if (!
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8840; /* pred_msbcrvvm4hi_overflow */

        case 2:
          if (!
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8843; /* pred_msbcrvvm8si_overflow */

        default:
          return -1;
        }

    case 3:
      if (!register_operand (operands[0], E_RVVMF8BImode)
          || GET_MODE (x2) != E_RVVMF8BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF8BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern632 (x4))
        {
        case 0:
          if (!
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8838; /* pred_msbcrvvm1qi_overflow */

        case 1:
          if (!
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8841; /* pred_msbcrvvm2hi_overflow */

        case 2:
          if (!
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8844; /* pred_msbcrvvm4si_overflow */

        case 3:
          if (!(
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8847; /* pred_msbcrvvm8di_overflow */

        default:
          return -1;
        }

    case 4:
      if (!register_operand (operands[0], E_RVVMF16BImode)
          || GET_MODE (x2) != E_RVVMF16BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF16BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern633 (x4))
        {
        case 0:
          if (!
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8842; /* pred_msbcrvvm1hi_overflow */

        case 1:
          if (!
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8845; /* pred_msbcrvvm2si_overflow */

        case 2:
          if (!(
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8848; /* pred_msbcrvvm4di_overflow */

        case 3:
          if (!(
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8851; /* pred_msbcrvvmf2qi_overflow */

        default:
          return -1;
        }

    case 5:
      if (!register_operand (operands[0], E_RVVMF32BImode)
          || GET_MODE (x2) != E_RVVMF32BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF32BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern634 (x4))
        {
        case 0:
          if (!
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8846; /* pred_msbcrvvm1si_overflow */

        case 1:
          if (!(
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8849; /* pred_msbcrvvm2di_overflow */

        case 2:
          if (!(
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8852; /* pred_msbcrvvmf4qi_overflow */

        case 3:
          if (!(
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8854; /* pred_msbcrvvmf2hi_overflow */

        default:
          return -1;
        }

    case 6:
      if (!register_operand (operands[0], E_RVVMF64BImode)
          || GET_MODE (x2) != E_RVVMF64BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF64BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern635 (x4))
        {
        case 0:
          if (!(
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8850; /* pred_msbcrvvm1di_overflow */

        case 1:
          if (!(
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8853; /* pred_msbcrvvmf8qi_overflow */

        case 2:
          if (!(
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8855; /* pred_msbcrvvmf4hi_overflow */

        case 3:
          if (!(
#line 3699 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8856; /* pred_msbcrvvmf2si_overflow */

        default:
          return -1;
        }

    case 7:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8911; /* pred_msbcrvvm8qi_overflow_scalar */

    case 8:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8912; /* pred_msbcrvvm4qi_overflow_scalar */

    case 9:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8918; /* pred_msbcrvvm8hi_overflow_scalar */

    case 10:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8913; /* pred_msbcrvvm2qi_overflow_scalar */

    case 11:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8919; /* pred_msbcrvvm4hi_overflow_scalar */

    case 12:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8924; /* pred_msbcrvvm8si_overflow_scalar */

    case 13:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8914; /* pred_msbcrvvm1qi_overflow_scalar */

    case 14:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8920; /* pred_msbcrvvm2hi_overflow_scalar */

    case 15:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8925; /* pred_msbcrvvm4si_overflow_scalar */

    case 16:
      if (!(
#line 3856 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8973; /* *pred_msbcrvvm8di_overflow_scalar */

    case 17:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8915; /* pred_msbcrvvmf2qi_overflow_scalar */

    case 18:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8921; /* pred_msbcrvvm1hi_overflow_scalar */

    case 19:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8926; /* pred_msbcrvvm2si_overflow_scalar */

    case 20:
      if (!(
#line 3856 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8974; /* *pred_msbcrvvm4di_overflow_scalar */

    case 21:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8916; /* pred_msbcrvvmf4qi_overflow_scalar */

    case 22:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8922; /* pred_msbcrvvmf2hi_overflow_scalar */

    case 23:
      if (!
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8927; /* pred_msbcrvvm1si_overflow_scalar */

    case 24:
      if (!(
#line 3856 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8975; /* *pred_msbcrvvm2di_overflow_scalar */

    case 25:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8917; /* pred_msbcrvvmf8qi_overflow_scalar */

    case 26:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8923; /* pred_msbcrvvmf4hi_overflow_scalar */

    case 27:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8928; /* pred_msbcrvvmf2si_overflow_scalar */

    case 28:
      if (!(
#line 3856 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8976; /* *pred_msbcrvvm1di_overflow_scalar */

    case 29:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8929; /* pred_msbcv1qi_overflow_scalar */

    case 30:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8942; /* pred_msbcv1hi_overflow_scalar */

    case 31:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8954; /* pred_msbcv1si_overflow_scalar */

    case 32:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8930; /* pred_msbcv2qi_overflow_scalar */

    case 33:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8943; /* pred_msbcv2hi_overflow_scalar */

    case 34:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8955; /* pred_msbcv2si_overflow_scalar */

    case 35:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8931; /* pred_msbcv4qi_overflow_scalar */

    case 36:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8944; /* pred_msbcv4hi_overflow_scalar */

    case 37:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8956; /* pred_msbcv4si_overflow_scalar */

    case 38:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8932; /* pred_msbcv8qi_overflow_scalar */

    case 39:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8945; /* pred_msbcv8hi_overflow_scalar */

    case 40:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8957; /* pred_msbcv8si_overflow_scalar */

    case 41:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8933; /* pred_msbcv16qi_overflow_scalar */

    case 42:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8946; /* pred_msbcv16hi_overflow_scalar */

    case 43:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8958; /* pred_msbcv16si_overflow_scalar */

    case 44:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8934; /* pred_msbcv32qi_overflow_scalar */

    case 45:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8947; /* pred_msbcv32hi_overflow_scalar */

    case 46:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8959; /* pred_msbcv32si_overflow_scalar */

    case 47:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8935; /* pred_msbcv64qi_overflow_scalar */

    case 48:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8948; /* pred_msbcv64hi_overflow_scalar */

    case 49:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8960; /* pred_msbcv64si_overflow_scalar */

    case 50:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8936; /* pred_msbcv128qi_overflow_scalar */

    case 51:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8949; /* pred_msbcv128hi_overflow_scalar */

    case 52:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8961; /* pred_msbcv128si_overflow_scalar */

    case 53:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8937; /* pred_msbcv256qi_overflow_scalar */

    case 54:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8950; /* pred_msbcv256hi_overflow_scalar */

    case 55:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8962; /* pred_msbcv256si_overflow_scalar */

    case 56:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8938; /* pred_msbcv512qi_overflow_scalar */

    case 57:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8951; /* pred_msbcv512hi_overflow_scalar */

    case 58:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8963; /* pred_msbcv512si_overflow_scalar */

    case 59:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8939; /* pred_msbcv1024qi_overflow_scalar */

    case 60:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8952; /* pred_msbcv1024hi_overflow_scalar */

    case 61:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8964; /* pred_msbcv1024si_overflow_scalar */

    case 62:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8940; /* pred_msbcv2048qi_overflow_scalar */

    case 63:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8953; /* pred_msbcv2048hi_overflow_scalar */

    case 64:
      if (!(
#line 3739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8941; /* pred_msbcv4096qi_overflow_scalar */

    case 65:
      if (!(
#line 3877 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8977; /* *pred_msbcrvvm8di_overflow_extended_scalar */

    case 66:
      if (!(
#line 3877 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8978; /* *pred_msbcrvvm4di_overflow_extended_scalar */

    case 67:
      if (!(
#line 3877 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8979; /* *pred_msbcrvvm2di_overflow_extended_scalar */

    case 68:
      if (!(
#line 3877 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8980; /* *pred_msbcrvvm1di_overflow_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (pattern163 (x3, 
E_SFmode) != 0
          || !
#line 1620 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 81; /* copysignsf3 */

    case E_DFmode:
      if (pattern163 (x3, 
E_DFmode) != 0
          || !(
#line 1620 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 82; /* copysigndf3 */

    case E_HFmode:
      if (pattern163 (x3, 
E_HFmode) != 0
          || !(
#line 1620 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 83; /* copysignhf3 */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (pattern333 (x3))
    {
    case 0:
      if (!(
#line 125 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 671; /* riscv_packh_si */

    case 1:
      if (!(
#line 125 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 672; /* riscv_packh_di */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern245 (x2))
    {
    case 0:
      if (!
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28075; /* reduc_plus_scal_rvvm8qi */

    case 1:
      if (!
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28076; /* reduc_plus_scal_rvvm4qi */

    case 2:
      if (!
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28077; /* reduc_plus_scal_rvvm2qi */

    case 3:
      if (!
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28078; /* reduc_plus_scal_rvvm1qi */

    case 4:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 28091; /* reduc_plus_scal_rvvmf2qi */

    case 5:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 28092; /* reduc_plus_scal_rvvmf4qi */

    case 6:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 28093; /* reduc_plus_scal_rvvmf8qi */

    case 7:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 28097; /* reduc_plus_scal_v1qi */

    case 8:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 28098; /* reduc_plus_scal_v2qi */

    case 9:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 28099; /* reduc_plus_scal_v4qi */

    case 10:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 28100; /* reduc_plus_scal_v8qi */

    case 11:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 28101; /* reduc_plus_scal_v16qi */

    case 12:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 28102; /* reduc_plus_scal_v32qi */

    case 13:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28103; /* reduc_plus_scal_v64qi */

    case 14:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28104; /* reduc_plus_scal_v128qi */

    case 15:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28105; /* reduc_plus_scal_v256qi */

    case 16:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28106; /* reduc_plus_scal_v512qi */

    case 17:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28107; /* reduc_plus_scal_v1024qi */

    case 18:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28108; /* reduc_plus_scal_v2048qi */

    case 19:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28109; /* reduc_plus_scal_v4096qi */

    case 20:
      if (!
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28079; /* reduc_plus_scal_rvvm8hi */

    case 21:
      if (!
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28080; /* reduc_plus_scal_rvvm4hi */

    case 22:
      if (!
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28081; /* reduc_plus_scal_rvvm2hi */

    case 23:
      if (!
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28082; /* reduc_plus_scal_rvvm1hi */

    case 24:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 28094; /* reduc_plus_scal_rvvmf2hi */

    case 25:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 28095; /* reduc_plus_scal_rvvmf4hi */

    case 26:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28110; /* reduc_plus_scal_v1hi */

    case 27:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28111; /* reduc_plus_scal_v2hi */

    case 28:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28112; /* reduc_plus_scal_v4hi */

    case 29:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28113; /* reduc_plus_scal_v8hi */

    case 30:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28114; /* reduc_plus_scal_v16hi */

    case 31:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28115; /* reduc_plus_scal_v32hi */

    case 32:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28116; /* reduc_plus_scal_v64hi */

    case 33:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28117; /* reduc_plus_scal_v128hi */

    case 34:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28118; /* reduc_plus_scal_v256hi */

    case 35:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28119; /* reduc_plus_scal_v512hi */

    case 36:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28120; /* reduc_plus_scal_v1024hi */

    case 37:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28121; /* reduc_plus_scal_v2048hi */

    case 38:
      if (!
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28083; /* reduc_plus_scal_rvvm8si */

    case 39:
      if (!
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28084; /* reduc_plus_scal_rvvm4si */

    case 40:
      if (!
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28085; /* reduc_plus_scal_rvvm2si */

    case 41:
      if (!
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28086; /* reduc_plus_scal_rvvm1si */

    case 42:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 28096; /* reduc_plus_scal_rvvmf2si */

    case 43:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28122; /* reduc_plus_scal_v1si */

    case 44:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28123; /* reduc_plus_scal_v2si */

    case 45:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28124; /* reduc_plus_scal_v4si */

    case 46:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28125; /* reduc_plus_scal_v8si */

    case 47:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28126; /* reduc_plus_scal_v16si */

    case 48:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28127; /* reduc_plus_scal_v32si */

    case 49:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28128; /* reduc_plus_scal_v64si */

    case 50:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28129; /* reduc_plus_scal_v128si */

    case 51:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28130; /* reduc_plus_scal_v256si */

    case 52:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28131; /* reduc_plus_scal_v512si */

    case 53:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28132; /* reduc_plus_scal_v1024si */

    case 54:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28087; /* reduc_plus_scal_rvvm8di */

    case 55:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28088; /* reduc_plus_scal_rvvm4di */

    case 56:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28089; /* reduc_plus_scal_rvvm2di */

    case 57:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28090; /* reduc_plus_scal_rvvm1di */

    case 58:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28133; /* reduc_plus_scal_v1di */

    case 59:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28134; /* reduc_plus_scal_v2di */

    case 60:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28135; /* reduc_plus_scal_v4di */

    case 61:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28136; /* reduc_plus_scal_v8di */

    case 62:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28137; /* reduc_plus_scal_v16di */

    case 63:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28138; /* reduc_plus_scal_v32di */

    case 64:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28139; /* reduc_plus_scal_v64di */

    case 65:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28140; /* reduc_plus_scal_v128di */

    case 66:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28141; /* reduc_plus_scal_v256di */

    case 67:
      if (!(
#line 2183 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28142; /* reduc_plus_scal_v512di */

    case 68:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30998; /* *widen_reduc_plus_scal_rvvm4qi */

    case 69:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31000; /* *widen_reduc_plus_scal_rvvm2qi */

    case 70:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31002; /* *widen_reduc_plus_scal_rvvm1qi */

    case 71:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31004; /* *widen_reduc_plus_scal_rvvmf2qi */

    case 72:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31006; /* *widen_reduc_plus_scal_rvvmf4qi */

    case 73:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31008; /* *widen_reduc_plus_scal_rvvmf8qi */

    case 74:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 31028; /* *widen_reduc_plus_scal_v1qi */

    case 75:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 31030; /* *widen_reduc_plus_scal_v2qi */

    case 76:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 31032; /* *widen_reduc_plus_scal_v4qi */

    case 77:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 31034; /* *widen_reduc_plus_scal_v8qi */

    case 78:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 31036; /* *widen_reduc_plus_scal_v16qi */

    case 79:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 31038; /* *widen_reduc_plus_scal_v32qi */

    case 80:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31040; /* *widen_reduc_plus_scal_v64qi */

    case 81:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31042; /* *widen_reduc_plus_scal_v128qi */

    case 82:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31044; /* *widen_reduc_plus_scal_v256qi */

    case 83:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31046; /* *widen_reduc_plus_scal_v512qi */

    case 84:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31048; /* *widen_reduc_plus_scal_v1024qi */

    case 85:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31050; /* *widen_reduc_plus_scal_v2048qi */

    case 86:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31010; /* *widen_reduc_plus_scal_rvvm4hi */

    case 87:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31012; /* *widen_reduc_plus_scal_rvvm2hi */

    case 88:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31014; /* *widen_reduc_plus_scal_rvvm1hi */

    case 89:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31016; /* *widen_reduc_plus_scal_rvvmf2hi */

    case 90:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31018; /* *widen_reduc_plus_scal_rvvmf4hi */

    case 91:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31052; /* *widen_reduc_plus_scal_v1hi */

    case 92:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31074; /* *widen_reduc_plus_scal_v1si */

    case 93:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31054; /* *widen_reduc_plus_scal_v2hi */

    case 94:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31076; /* *widen_reduc_plus_scal_v2si */

    case 95:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31056; /* *widen_reduc_plus_scal_v4hi */

    case 96:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31078; /* *widen_reduc_plus_scal_v4si */

    case 97:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31058; /* *widen_reduc_plus_scal_v8hi */

    case 98:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31080; /* *widen_reduc_plus_scal_v8si */

    case 99:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31060; /* *widen_reduc_plus_scal_v16hi */

    case 100:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31082; /* *widen_reduc_plus_scal_v16si */

    case 101:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31062; /* *widen_reduc_plus_scal_v32hi */

    case 102:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31084; /* *widen_reduc_plus_scal_v32si */

    case 103:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31064; /* *widen_reduc_plus_scal_v64hi */

    case 104:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31086; /* *widen_reduc_plus_scal_v64si */

    case 105:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31066; /* *widen_reduc_plus_scal_v128hi */

    case 106:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31088; /* *widen_reduc_plus_scal_v128si */

    case 107:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31068; /* *widen_reduc_plus_scal_v256hi */

    case 108:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31090; /* *widen_reduc_plus_scal_v256si */

    case 109:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31070; /* *widen_reduc_plus_scal_v512hi */

    case 110:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31092; /* *widen_reduc_plus_scal_v512si */

    case 111:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31072; /* *widen_reduc_plus_scal_v1024hi */

    case 112:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31020; /* *widen_reduc_plus_scal_rvvm4si */

    case 113:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31022; /* *widen_reduc_plus_scal_rvvm2si */

    case 114:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31024; /* *widen_reduc_plus_scal_rvvm1si */

    case 115:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31026; /* *widen_reduc_plus_scal_rvvmf2si */

    case 116:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30999; /* *widen_reduc_plus_scal_rvvm4qi */

    case 117:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31001; /* *widen_reduc_plus_scal_rvvm2qi */

    case 118:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31003; /* *widen_reduc_plus_scal_rvvm1qi */

    case 119:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31005; /* *widen_reduc_plus_scal_rvvmf2qi */

    case 120:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31007; /* *widen_reduc_plus_scal_rvvmf4qi */

    case 121:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31009; /* *widen_reduc_plus_scal_rvvmf8qi */

    case 122:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 31029; /* *widen_reduc_plus_scal_v1qi */

    case 123:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 31031; /* *widen_reduc_plus_scal_v2qi */

    case 124:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 31033; /* *widen_reduc_plus_scal_v4qi */

    case 125:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 31035; /* *widen_reduc_plus_scal_v8qi */

    case 126:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 31037; /* *widen_reduc_plus_scal_v16qi */

    case 127:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 31039; /* *widen_reduc_plus_scal_v32qi */

    case 128:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31041; /* *widen_reduc_plus_scal_v64qi */

    case 129:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31043; /* *widen_reduc_plus_scal_v128qi */

    case 130:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31045; /* *widen_reduc_plus_scal_v256qi */

    case 131:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31047; /* *widen_reduc_plus_scal_v512qi */

    case 132:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31049; /* *widen_reduc_plus_scal_v1024qi */

    case 133:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31051; /* *widen_reduc_plus_scal_v2048qi */

    case 134:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31011; /* *widen_reduc_plus_scal_rvvm4hi */

    case 135:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31013; /* *widen_reduc_plus_scal_rvvm2hi */

    case 136:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31015; /* *widen_reduc_plus_scal_rvvm1hi */

    case 137:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31017; /* *widen_reduc_plus_scal_rvvmf2hi */

    case 138:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31019; /* *widen_reduc_plus_scal_rvvmf4hi */

    case 139:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31053; /* *widen_reduc_plus_scal_v1hi */

    case 140:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31075; /* *widen_reduc_plus_scal_v1si */

    case 141:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31055; /* *widen_reduc_plus_scal_v2hi */

    case 142:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31077; /* *widen_reduc_plus_scal_v2si */

    case 143:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31057; /* *widen_reduc_plus_scal_v4hi */

    case 144:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31079; /* *widen_reduc_plus_scal_v4si */

    case 145:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31059; /* *widen_reduc_plus_scal_v8hi */

    case 146:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31081; /* *widen_reduc_plus_scal_v8si */

    case 147:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31061; /* *widen_reduc_plus_scal_v16hi */

    case 148:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31083; /* *widen_reduc_plus_scal_v16si */

    case 149:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31063; /* *widen_reduc_plus_scal_v32hi */

    case 150:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31085; /* *widen_reduc_plus_scal_v32si */

    case 151:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31065; /* *widen_reduc_plus_scal_v64hi */

    case 152:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31087; /* *widen_reduc_plus_scal_v64si */

    case 153:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31067; /* *widen_reduc_plus_scal_v128hi */

    case 154:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31089; /* *widen_reduc_plus_scal_v128si */

    case 155:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31069; /* *widen_reduc_plus_scal_v256hi */

    case 156:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31091; /* *widen_reduc_plus_scal_v256si */

    case 157:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31071; /* *widen_reduc_plus_scal_v512hi */

    case 158:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31093; /* *widen_reduc_plus_scal_v512si */

    case 159:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31073; /* *widen_reduc_plus_scal_v1024hi */

    case 160:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31021; /* *widen_reduc_plus_scal_rvvm4si */

    case 161:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31023; /* *widen_reduc_plus_scal_rvvm2si */

    case 162:
      if (!
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31025; /* *widen_reduc_plus_scal_rvvm1si */

    case 163:
      if (!(
#line 808 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31027; /* *widen_reduc_plus_scal_rvvmf2si */

    case 164:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31712; /* *cond_widen_reduc_plus_scal_rvvm4qi */

    case 165:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31714; /* *cond_widen_reduc_plus_scal_rvvm2qi */

    case 166:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31716; /* *cond_widen_reduc_plus_scal_rvvm1qi */

    case 167:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31718; /* *cond_widen_reduc_plus_scal_rvvmf2qi */

    case 168:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31720; /* *cond_widen_reduc_plus_scal_rvvmf4qi */

    case 169:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31722; /* *cond_widen_reduc_plus_scal_rvvmf8qi */

    case 170:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 31742; /* *cond_widen_reduc_plus_scal_v1qi */

    case 171:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 31744; /* *cond_widen_reduc_plus_scal_v2qi */

    case 172:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 31746; /* *cond_widen_reduc_plus_scal_v4qi */

    case 173:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 31748; /* *cond_widen_reduc_plus_scal_v8qi */

    case 174:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 31750; /* *cond_widen_reduc_plus_scal_v16qi */

    case 175:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 31752; /* *cond_widen_reduc_plus_scal_v32qi */

    case 176:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31754; /* *cond_widen_reduc_plus_scal_v64qi */

    case 177:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31756; /* *cond_widen_reduc_plus_scal_v128qi */

    case 178:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31758; /* *cond_widen_reduc_plus_scal_v256qi */

    case 179:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31760; /* *cond_widen_reduc_plus_scal_v512qi */

    case 180:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31762; /* *cond_widen_reduc_plus_scal_v1024qi */

    case 181:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31764; /* *cond_widen_reduc_plus_scal_v2048qi */

    case 182:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31724; /* *cond_widen_reduc_plus_scal_rvvm4hi */

    case 183:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31726; /* *cond_widen_reduc_plus_scal_rvvm2hi */

    case 184:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31728; /* *cond_widen_reduc_plus_scal_rvvm1hi */

    case 185:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31730; /* *cond_widen_reduc_plus_scal_rvvmf2hi */

    case 186:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31732; /* *cond_widen_reduc_plus_scal_rvvmf4hi */

    case 187:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31766; /* *cond_widen_reduc_plus_scal_v1hi */

    case 188:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31788; /* *cond_widen_reduc_plus_scal_v1si */

    case 189:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31768; /* *cond_widen_reduc_plus_scal_v2hi */

    case 190:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31790; /* *cond_widen_reduc_plus_scal_v2si */

    case 191:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31770; /* *cond_widen_reduc_plus_scal_v4hi */

    case 192:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31792; /* *cond_widen_reduc_plus_scal_v4si */

    case 193:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31772; /* *cond_widen_reduc_plus_scal_v8hi */

    case 194:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31794; /* *cond_widen_reduc_plus_scal_v8si */

    case 195:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31774; /* *cond_widen_reduc_plus_scal_v16hi */

    case 196:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31796; /* *cond_widen_reduc_plus_scal_v16si */

    case 197:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31776; /* *cond_widen_reduc_plus_scal_v32hi */

    case 198:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31798; /* *cond_widen_reduc_plus_scal_v32si */

    case 199:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31778; /* *cond_widen_reduc_plus_scal_v64hi */

    case 200:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31800; /* *cond_widen_reduc_plus_scal_v64si */

    case 201:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31780; /* *cond_widen_reduc_plus_scal_v128hi */

    case 202:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31802; /* *cond_widen_reduc_plus_scal_v128si */

    case 203:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31782; /* *cond_widen_reduc_plus_scal_v256hi */

    case 204:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31804; /* *cond_widen_reduc_plus_scal_v256si */

    case 205:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31784; /* *cond_widen_reduc_plus_scal_v512hi */

    case 206:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31806; /* *cond_widen_reduc_plus_scal_v512si */

    case 207:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31786; /* *cond_widen_reduc_plus_scal_v1024hi */

    case 208:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31734; /* *cond_widen_reduc_plus_scal_rvvm4si */

    case 209:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31736; /* *cond_widen_reduc_plus_scal_rvvm2si */

    case 210:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31738; /* *cond_widen_reduc_plus_scal_rvvm1si */

    case 211:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31740; /* *cond_widen_reduc_plus_scal_rvvmf2si */

    case 212:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31713; /* *cond_widen_reduc_plus_scal_rvvm4qi */

    case 213:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31715; /* *cond_widen_reduc_plus_scal_rvvm2qi */

    case 214:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31717; /* *cond_widen_reduc_plus_scal_rvvm1qi */

    case 215:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31719; /* *cond_widen_reduc_plus_scal_rvvmf2qi */

    case 216:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31721; /* *cond_widen_reduc_plus_scal_rvvmf4qi */

    case 217:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31723; /* *cond_widen_reduc_plus_scal_rvvmf8qi */

    case 218:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 31743; /* *cond_widen_reduc_plus_scal_v1qi */

    case 219:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 31745; /* *cond_widen_reduc_plus_scal_v2qi */

    case 220:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 31747; /* *cond_widen_reduc_plus_scal_v4qi */

    case 221:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 31749; /* *cond_widen_reduc_plus_scal_v8qi */

    case 222:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 31751; /* *cond_widen_reduc_plus_scal_v16qi */

    case 223:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 31753; /* *cond_widen_reduc_plus_scal_v32qi */

    case 224:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31755; /* *cond_widen_reduc_plus_scal_v64qi */

    case 225:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31757; /* *cond_widen_reduc_plus_scal_v128qi */

    case 226:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31759; /* *cond_widen_reduc_plus_scal_v256qi */

    case 227:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31761; /* *cond_widen_reduc_plus_scal_v512qi */

    case 228:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31763; /* *cond_widen_reduc_plus_scal_v1024qi */

    case 229:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31765; /* *cond_widen_reduc_plus_scal_v2048qi */

    case 230:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31725; /* *cond_widen_reduc_plus_scal_rvvm4hi */

    case 231:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31727; /* *cond_widen_reduc_plus_scal_rvvm2hi */

    case 232:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31729; /* *cond_widen_reduc_plus_scal_rvvm1hi */

    case 233:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31731; /* *cond_widen_reduc_plus_scal_rvvmf2hi */

    case 234:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31733; /* *cond_widen_reduc_plus_scal_rvvmf4hi */

    case 235:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31767; /* *cond_widen_reduc_plus_scal_v1hi */

    case 236:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31789; /* *cond_widen_reduc_plus_scal_v1si */

    case 237:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31769; /* *cond_widen_reduc_plus_scal_v2hi */

    case 238:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31791; /* *cond_widen_reduc_plus_scal_v2si */

    case 239:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31771; /* *cond_widen_reduc_plus_scal_v4hi */

    case 240:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31793; /* *cond_widen_reduc_plus_scal_v4si */

    case 241:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31773; /* *cond_widen_reduc_plus_scal_v8hi */

    case 242:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31795; /* *cond_widen_reduc_plus_scal_v8si */

    case 243:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31775; /* *cond_widen_reduc_plus_scal_v16hi */

    case 244:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31797; /* *cond_widen_reduc_plus_scal_v16si */

    case 245:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31777; /* *cond_widen_reduc_plus_scal_v32hi */

    case 246:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31799; /* *cond_widen_reduc_plus_scal_v32si */

    case 247:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31779; /* *cond_widen_reduc_plus_scal_v64hi */

    case 248:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31801; /* *cond_widen_reduc_plus_scal_v64si */

    case 249:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31781; /* *cond_widen_reduc_plus_scal_v128hi */

    case 250:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31803; /* *cond_widen_reduc_plus_scal_v128si */

    case 251:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31783; /* *cond_widen_reduc_plus_scal_v256hi */

    case 252:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31805; /* *cond_widen_reduc_plus_scal_v256si */

    case 253:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31785; /* *cond_widen_reduc_plus_scal_v512hi */

    case 254:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31807; /* *cond_widen_reduc_plus_scal_v512si */

    case 255:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31787; /* *cond_widen_reduc_plus_scal_v1024hi */

    case 256:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31735; /* *cond_widen_reduc_plus_scal_rvvm4si */

    case 257:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31737; /* *cond_widen_reduc_plus_scal_rvvm2si */

    case 258:
      if (!
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31739; /* *cond_widen_reduc_plus_scal_rvvm1si */

    case 259:
      if (!(
#line 1226 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31741; /* *cond_widen_reduc_plus_scal_rvvmf2si */

    case 260:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31808; /* *cond_len_widen_reduc_plus_scal_rvvm4qi */

    case 261:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31810; /* *cond_len_widen_reduc_plus_scal_rvvm2qi */

    case 262:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31812; /* *cond_len_widen_reduc_plus_scal_rvvm1qi */

    case 263:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31814; /* *cond_len_widen_reduc_plus_scal_rvvmf2qi */

    case 264:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31816; /* *cond_len_widen_reduc_plus_scal_rvvmf4qi */

    case 265:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31818; /* *cond_len_widen_reduc_plus_scal_rvvmf8qi */

    case 266:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 31838; /* *cond_len_widen_reduc_plus_scal_v1qi */

    case 267:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 31840; /* *cond_len_widen_reduc_plus_scal_v2qi */

    case 268:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 31842; /* *cond_len_widen_reduc_plus_scal_v4qi */

    case 269:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 31844; /* *cond_len_widen_reduc_plus_scal_v8qi */

    case 270:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 31846; /* *cond_len_widen_reduc_plus_scal_v16qi */

    case 271:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 31848; /* *cond_len_widen_reduc_plus_scal_v32qi */

    case 272:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31850; /* *cond_len_widen_reduc_plus_scal_v64qi */

    case 273:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31852; /* *cond_len_widen_reduc_plus_scal_v128qi */

    case 274:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31854; /* *cond_len_widen_reduc_plus_scal_v256qi */

    case 275:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31856; /* *cond_len_widen_reduc_plus_scal_v512qi */

    case 276:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31858; /* *cond_len_widen_reduc_plus_scal_v1024qi */

    case 277:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31860; /* *cond_len_widen_reduc_plus_scal_v2048qi */

    case 278:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31820; /* *cond_len_widen_reduc_plus_scal_rvvm4hi */

    case 279:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31822; /* *cond_len_widen_reduc_plus_scal_rvvm2hi */

    case 280:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31824; /* *cond_len_widen_reduc_plus_scal_rvvm1hi */

    case 281:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31826; /* *cond_len_widen_reduc_plus_scal_rvvmf2hi */

    case 282:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31828; /* *cond_len_widen_reduc_plus_scal_rvvmf4hi */

    case 283:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31862; /* *cond_len_widen_reduc_plus_scal_v1hi */

    case 284:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31884; /* *cond_len_widen_reduc_plus_scal_v1si */

    case 285:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31864; /* *cond_len_widen_reduc_plus_scal_v2hi */

    case 286:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31886; /* *cond_len_widen_reduc_plus_scal_v2si */

    case 287:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31866; /* *cond_len_widen_reduc_plus_scal_v4hi */

    case 288:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31888; /* *cond_len_widen_reduc_plus_scal_v4si */

    case 289:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31868; /* *cond_len_widen_reduc_plus_scal_v8hi */

    case 290:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31890; /* *cond_len_widen_reduc_plus_scal_v8si */

    case 291:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31870; /* *cond_len_widen_reduc_plus_scal_v16hi */

    case 292:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31892; /* *cond_len_widen_reduc_plus_scal_v16si */

    case 293:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31872; /* *cond_len_widen_reduc_plus_scal_v32hi */

    case 294:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31894; /* *cond_len_widen_reduc_plus_scal_v32si */

    case 295:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31874; /* *cond_len_widen_reduc_plus_scal_v64hi */

    case 296:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31896; /* *cond_len_widen_reduc_plus_scal_v64si */

    case 297:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31876; /* *cond_len_widen_reduc_plus_scal_v128hi */

    case 298:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31898; /* *cond_len_widen_reduc_plus_scal_v128si */

    case 299:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31878; /* *cond_len_widen_reduc_plus_scal_v256hi */

    case 300:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31900; /* *cond_len_widen_reduc_plus_scal_v256si */

    case 301:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31880; /* *cond_len_widen_reduc_plus_scal_v512hi */

    case 302:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31902; /* *cond_len_widen_reduc_plus_scal_v512si */

    case 303:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31882; /* *cond_len_widen_reduc_plus_scal_v1024hi */

    case 304:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31830; /* *cond_len_widen_reduc_plus_scal_rvvm4si */

    case 305:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31832; /* *cond_len_widen_reduc_plus_scal_rvvm2si */

    case 306:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31834; /* *cond_len_widen_reduc_plus_scal_rvvm1si */

    case 307:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31836; /* *cond_len_widen_reduc_plus_scal_rvvmf2si */

    case 308:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31809; /* *cond_len_widen_reduc_plus_scal_rvvm4qi */

    case 309:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31811; /* *cond_len_widen_reduc_plus_scal_rvvm2qi */

    case 310:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31813; /* *cond_len_widen_reduc_plus_scal_rvvm1qi */

    case 311:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31815; /* *cond_len_widen_reduc_plus_scal_rvvmf2qi */

    case 312:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31817; /* *cond_len_widen_reduc_plus_scal_rvvmf4qi */

    case 313:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 610 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31819; /* *cond_len_widen_reduc_plus_scal_rvvmf8qi */

    case 314:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 616 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 31839; /* *cond_len_widen_reduc_plus_scal_v1qi */

    case 315:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 617 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 31841; /* *cond_len_widen_reduc_plus_scal_v2qi */

    case 316:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 618 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 31843; /* *cond_len_widen_reduc_plus_scal_v4qi */

    case 317:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 619 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 31845; /* *cond_len_widen_reduc_plus_scal_v8qi */

    case 318:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 620 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 31847; /* *cond_len_widen_reduc_plus_scal_v16qi */

    case 319:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 621 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 31849; /* *cond_len_widen_reduc_plus_scal_v32qi */

    case 320:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 622 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31851; /* *cond_len_widen_reduc_plus_scal_v64qi */

    case 321:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 623 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31853; /* *cond_len_widen_reduc_plus_scal_v128qi */

    case 322:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 624 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31855; /* *cond_len_widen_reduc_plus_scal_v256qi */

    case 323:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 625 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31857; /* *cond_len_widen_reduc_plus_scal_v512qi */

    case 324:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 626 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31859; /* *cond_len_widen_reduc_plus_scal_v1024qi */

    case 325:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 627 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31861; /* *cond_len_widen_reduc_plus_scal_v2048qi */

    case 326:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31821; /* *cond_len_widen_reduc_plus_scal_rvvm4hi */

    case 327:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31823; /* *cond_len_widen_reduc_plus_scal_rvvm2hi */

    case 328:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31825; /* *cond_len_widen_reduc_plus_scal_rvvm1hi */

    case 329:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31827; /* *cond_len_widen_reduc_plus_scal_rvvmf2hi */

    case 330:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31829; /* *cond_len_widen_reduc_plus_scal_rvvmf4hi */

    case 331:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 628 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31863; /* *cond_len_widen_reduc_plus_scal_v1hi */

    case 332:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 639 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31885; /* *cond_len_widen_reduc_plus_scal_v1si */

    case 333:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 629 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31865; /* *cond_len_widen_reduc_plus_scal_v2hi */

    case 334:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 640 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31887; /* *cond_len_widen_reduc_plus_scal_v2si */

    case 335:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 630 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31867; /* *cond_len_widen_reduc_plus_scal_v4hi */

    case 336:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 641 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31889; /* *cond_len_widen_reduc_plus_scal_v4si */

    case 337:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31869; /* *cond_len_widen_reduc_plus_scal_v8hi */

    case 338:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 642 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31891; /* *cond_len_widen_reduc_plus_scal_v8si */

    case 339:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 632 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31871; /* *cond_len_widen_reduc_plus_scal_v16hi */

    case 340:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 643 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31893; /* *cond_len_widen_reduc_plus_scal_v16si */

    case 341:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 633 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31873; /* *cond_len_widen_reduc_plus_scal_v32hi */

    case 342:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 644 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31895; /* *cond_len_widen_reduc_plus_scal_v32si */

    case 343:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 634 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31875; /* *cond_len_widen_reduc_plus_scal_v64hi */

    case 344:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 645 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31897; /* *cond_len_widen_reduc_plus_scal_v64si */

    case 345:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 635 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31877; /* *cond_len_widen_reduc_plus_scal_v128hi */

    case 346:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 646 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31899; /* *cond_len_widen_reduc_plus_scal_v128si */

    case 347:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 636 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31879; /* *cond_len_widen_reduc_plus_scal_v256hi */

    case 348:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 647 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31901; /* *cond_len_widen_reduc_plus_scal_v256si */

    case 349:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 637 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31881; /* *cond_len_widen_reduc_plus_scal_v512hi */

    case 350:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 648 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31903; /* *cond_len_widen_reduc_plus_scal_v512si */

    case 351:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 638 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31883; /* *cond_len_widen_reduc_plus_scal_v1024hi */

    case 352:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31831; /* *cond_len_widen_reduc_plus_scal_rvvm4si */

    case 353:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31833; /* *cond_len_widen_reduc_plus_scal_rvvm2si */

    case 354:
      if (!
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31835; /* *cond_len_widen_reduc_plus_scal_rvvm1si */

    case 355:
      if (!(
#line 1283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 614 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31837; /* *cond_len_widen_reduc_plus_scal_rvvmf2si */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern177 (x2) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != SCRATCH)
    return -1;
  x7 = XVECEXP (x2, 0, 0);
  x8 = XVECEXP (x7, 0, 0);
  operands[0] = x8;
  x9 = XVECEXP (x7, 0, 1);
  operands[3] = x9;
  if (!vector_length_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x7, 0, 2);
  operands[4] = x10;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x2, 0, 1);
  operands[1] = x11;
  if (!pmode_reg_or_0_operand (operands[1], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 2);
  operands[2] = x12;
  switch (GET_MODE (x7))
    {
    case E_RVVMF64BImode:
      return recog_92 (x1, insn, pnum_clobbers);

    case E_RVVMF32BImode:
      return recog_93 (x1, insn, pnum_clobbers);

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2x2QImode:
          if (!register_operand (operands[2], E_RVVMF2x2QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21377; /* pred_unit_strided_storervvmf2x2qi */

        case E_RVVMF2x3QImode:
          if (!register_operand (operands[2], E_RVVMF2x3QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21378; /* pred_unit_strided_storervvmf2x3qi */

        case E_RVVMF2x4QImode:
          if (!register_operand (operands[2], E_RVVMF2x4QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21379; /* pred_unit_strided_storervvmf2x4qi */

        case E_RVVMF2x5QImode:
          if (!register_operand (operands[2], E_RVVMF2x5QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21380; /* pred_unit_strided_storervvmf2x5qi */

        case E_RVVMF2x6QImode:
          if (!register_operand (operands[2], E_RVVMF2x6QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21381; /* pred_unit_strided_storervvmf2x6qi */

        case E_RVVMF2x7QImode:
          if (!register_operand (operands[2], E_RVVMF2x7QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21382; /* pred_unit_strided_storervvmf2x7qi */

        case E_RVVMF2x8QImode:
          if (!register_operand (operands[2], E_RVVMF2x8QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21383; /* pred_unit_strided_storervvmf2x8qi */

        case E_RVVM1x2HImode:
          if (!register_operand (operands[2], E_RVVM1x2HImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21384; /* pred_unit_strided_storervvm1x2hi */

        case E_RVVM1x3HImode:
          if (!register_operand (operands[2], E_RVVM1x3HImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21385; /* pred_unit_strided_storervvm1x3hi */

        case E_RVVM1x4HImode:
          if (!register_operand (operands[2], E_RVVM1x4HImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21386; /* pred_unit_strided_storervvm1x4hi */

        case E_RVVM1x5HImode:
          if (!register_operand (operands[2], E_RVVM1x5HImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21387; /* pred_unit_strided_storervvm1x5hi */

        case E_RVVM1x6HImode:
          if (!register_operand (operands[2], E_RVVM1x6HImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21388; /* pred_unit_strided_storervvm1x6hi */

        case E_RVVM1x7HImode:
          if (!register_operand (operands[2], E_RVVM1x7HImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21389; /* pred_unit_strided_storervvm1x7hi */

        case E_RVVM1x8HImode:
          if (!register_operand (operands[2], E_RVVM1x8HImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21390; /* pred_unit_strided_storervvm1x8hi */

        case E_RVVM2x2SImode:
          if (!register_operand (operands[2], E_RVVM2x2SImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21391; /* pred_unit_strided_storervvm2x2si */

        case E_RVVM2x3SImode:
          if (!register_operand (operands[2], E_RVVM2x3SImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21392; /* pred_unit_strided_storervvm2x3si */

        case E_RVVM2x4SImode:
          if (!register_operand (operands[2], E_RVVM2x4SImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21393; /* pred_unit_strided_storervvm2x4si */

        case E_RVVM4x2DImode:
          if (!register_operand (operands[2], E_RVVM4x2DImode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 21394; /* pred_unit_strided_storervvm4x2di */

        case E_RVVM1x2BFmode:
          if (!register_operand (operands[2], E_RVVM1x2BFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21395; /* pred_unit_strided_storervvm1x2bf */

        case E_RVVM1x3BFmode:
          if (!register_operand (operands[2], E_RVVM1x3BFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21396; /* pred_unit_strided_storervvm1x3bf */

        case E_RVVM1x4BFmode:
          if (!register_operand (operands[2], E_RVVM1x4BFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21397; /* pred_unit_strided_storervvm1x4bf */

        case E_RVVM1x5BFmode:
          if (!register_operand (operands[2], E_RVVM1x5BFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21398; /* pred_unit_strided_storervvm1x5bf */

        case E_RVVM1x6BFmode:
          if (!register_operand (operands[2], E_RVVM1x6BFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21399; /* pred_unit_strided_storervvm1x6bf */

        case E_RVVM1x7BFmode:
          if (!register_operand (operands[2], E_RVVM1x7BFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21400; /* pred_unit_strided_storervvm1x7bf */

        case E_RVVM1x8BFmode:
          if (!register_operand (operands[2], E_RVVM1x8BFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21401; /* pred_unit_strided_storervvm1x8bf */

        case E_RVVM1x2HFmode:
          if (!register_operand (operands[2], E_RVVM1x2HFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21402; /* pred_unit_strided_storervvm1x2hf */

        case E_RVVM1x3HFmode:
          if (!register_operand (operands[2], E_RVVM1x3HFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21403; /* pred_unit_strided_storervvm1x3hf */

        case E_RVVM1x4HFmode:
          if (!register_operand (operands[2], E_RVVM1x4HFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21404; /* pred_unit_strided_storervvm1x4hf */

        case E_RVVM1x5HFmode:
          if (!register_operand (operands[2], E_RVVM1x5HFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21405; /* pred_unit_strided_storervvm1x5hf */

        case E_RVVM1x6HFmode:
          if (!register_operand (operands[2], E_RVVM1x6HFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21406; /* pred_unit_strided_storervvm1x6hf */

        case E_RVVM1x7HFmode:
          if (!register_operand (operands[2], E_RVVM1x7HFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21407; /* pred_unit_strided_storervvm1x7hf */

        case E_RVVM1x8HFmode:
          if (!register_operand (operands[2], E_RVVM1x8HFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21408; /* pred_unit_strided_storervvm1x8hf */

        case E_RVVM2x2SFmode:
          if (!register_operand (operands[2], E_RVVM2x2SFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 21409; /* pred_unit_strided_storervvm2x2sf */

        case E_RVVM2x3SFmode:
          if (!register_operand (operands[2], E_RVVM2x3SFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 21410; /* pred_unit_strided_storervvm2x3sf */

        case E_RVVM2x4SFmode:
          if (!register_operand (operands[2], E_RVVM2x4SFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 21411; /* pred_unit_strided_storervvm2x4sf */

        case E_RVVM4x2DFmode:
          if (!register_operand (operands[2], E_RVVM4x2DFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 21412; /* pred_unit_strided_storervvm4x2df */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1x2QImode:
          if (!register_operand (operands[2], E_RVVM1x2QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21413; /* pred_unit_strided_storervvm1x2qi */

        case E_RVVM1x3QImode:
          if (!register_operand (operands[2], E_RVVM1x3QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21414; /* pred_unit_strided_storervvm1x3qi */

        case E_RVVM1x4QImode:
          if (!register_operand (operands[2], E_RVVM1x4QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21415; /* pred_unit_strided_storervvm1x4qi */

        case E_RVVM1x5QImode:
          if (!register_operand (operands[2], E_RVVM1x5QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21416; /* pred_unit_strided_storervvm1x5qi */

        case E_RVVM1x6QImode:
          if (!register_operand (operands[2], E_RVVM1x6QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21417; /* pred_unit_strided_storervvm1x6qi */

        case E_RVVM1x7QImode:
          if (!register_operand (operands[2], E_RVVM1x7QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21418; /* pred_unit_strided_storervvm1x7qi */

        case E_RVVM1x8QImode:
          if (!register_operand (operands[2], E_RVVM1x8QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21419; /* pred_unit_strided_storervvm1x8qi */

        case E_RVVM2x2HImode:
          if (!register_operand (operands[2], E_RVVM2x2HImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21420; /* pred_unit_strided_storervvm2x2hi */

        case E_RVVM2x3HImode:
          if (!register_operand (operands[2], E_RVVM2x3HImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21421; /* pred_unit_strided_storervvm2x3hi */

        case E_RVVM2x4HImode:
          if (!register_operand (operands[2], E_RVVM2x4HImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21422; /* pred_unit_strided_storervvm2x4hi */

        case E_RVVM4x2SImode:
          if (!register_operand (operands[2], E_RVVM4x2SImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21423; /* pred_unit_strided_storervvm4x2si */

        case E_RVVM2x2BFmode:
          if (!register_operand (operands[2], E_RVVM2x2BFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21424; /* pred_unit_strided_storervvm2x2bf */

        case E_RVVM2x3BFmode:
          if (!register_operand (operands[2], E_RVVM2x3BFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21425; /* pred_unit_strided_storervvm2x3bf */

        case E_RVVM2x4BFmode:
          if (!register_operand (operands[2], E_RVVM2x4BFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21426; /* pred_unit_strided_storervvm2x4bf */

        case E_RVVM2x2HFmode:
          if (!register_operand (operands[2], E_RVVM2x2HFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21427; /* pred_unit_strided_storervvm2x2hf */

        case E_RVVM2x3HFmode:
          if (!register_operand (operands[2], E_RVVM2x3HFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21428; /* pred_unit_strided_storervvm2x3hf */

        case E_RVVM2x4HFmode:
          if (!register_operand (operands[2], E_RVVM2x4HFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21429; /* pred_unit_strided_storervvm2x4hf */

        case E_RVVM4x2SFmode:
          if (!register_operand (operands[2], E_RVVM4x2SFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 21430; /* pred_unit_strided_storervvm4x2sf */

        default:
          return -1;
        }

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2x2QImode:
          if (!register_operand (operands[2], E_RVVM2x2QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21431; /* pred_unit_strided_storervvm2x2qi */

        case E_RVVM2x3QImode:
          if (!register_operand (operands[2], E_RVVM2x3QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21432; /* pred_unit_strided_storervvm2x3qi */

        case E_RVVM2x4QImode:
          if (!register_operand (operands[2], E_RVVM2x4QImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21433; /* pred_unit_strided_storervvm2x4qi */

        case E_RVVM4x2HImode:
          if (!register_operand (operands[2], E_RVVM4x2HImode)
              || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21434; /* pred_unit_strided_storervvm4x2hi */

        case E_RVVM4x2BFmode:
          if (!register_operand (operands[2], E_RVVM4x2BFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 21435; /* pred_unit_strided_storervvm4x2bf */

        case E_RVVM4x2HFmode:
          if (!register_operand (operands[2], E_RVVM4x2HFmode)
              || !(
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 21436; /* pred_unit_strided_storervvm4x2hf */

        default:
          return -1;
        }

    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF2BImode)
          || !register_operand (operands[2], E_RVVM4x2QImode)
          || !
#line 8386 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21437; /* pred_unit_strided_storervvm4x2qi */

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 13:
      return recog_42 (x1, insn, pnum_clobbers);

    case 26:
      switch (pattern160 (x1))
        {
        case 0:
          if (!(
#line 1645 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 87; /* fminmsf3 */

        case 1:
          if (!(
#line 1645 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 88; /* fminmdf3 */

        case 2:
          if (!(
#line 1645 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 89; /* fminmhf3 */

        default:
          return -1;
        }

    case 27:
      switch (pattern160 (x1))
        {
        case 0:
          if (!(
#line 1655 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 90; /* fmaxmsf3 */

        case 1:
          if (!(
#line 1655 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 91; /* fmaxmdf3 */

        case 2:
          if (!(
#line 1655 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 92; /* fmaxmhf3 */

        default:
          return -1;
        }

    case 24:
      switch (pattern160 (x1))
        {
        case 0:
          if (!(
#line 1665 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SNANS (SFmode)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 93; /* fminsf3 */

        case 1:
          if (!(
#line 1665 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SNANS (DFmode)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 94; /* fmindf3 */

        case 2:
          if (!(
#line 1665 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SNANS (HFmode)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 95; /* fminhf3 */

        default:
          return -1;
        }

    case 25:
      switch (pattern160 (x1))
        {
        case 0:
          if (!(
#line 1675 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SNANS (SFmode)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 96; /* fmaxsf3 */

        case 1:
          if (!(
#line 1675 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SNANS (DFmode)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 97; /* fmaxdf3 */

        case 2:
          if (!(
#line 1675 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SNANS (HFmode)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 98; /* fmaxhf3 */

        default:
          return -1;
        }

    case 11:
      return recog_41 (x1, insn, pnum_clobbers);

    case 12:
      return recog_40 (x1, insn, pnum_clobbers);

    case 29:
      return recog_38 (x1, insn, pnum_clobbers);

    case 14:
      return recog_47 (x1, insn, pnum_clobbers);

    case 31:
      switch (pattern164 (x1))
        {
        case 0:
          if (!
#line 1161 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBKC || TARGET_ZBC))
            return -1;
          return 655; /* riscv_clmul_si */

        case 1:
          if (!(
#line 1161 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBKC || TARGET_ZBC) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 656; /* riscv_clmul_di */

        default:
          return -1;
        }

    case 32:
      switch (pattern164 (x1))
        {
        case 0:
          if (!(
#line 1170 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBKC || TARGET_ZBC) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 657; /* riscv_clmulh_si */

        case 1:
          if (!(
#line 1170 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBKC || TARGET_ZBC) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 658; /* riscv_clmulh_di */

        default:
          return -1;
        }

    case 33:
      switch (pattern164 (x1))
        {
        case 0:
          if (!(
#line 1180 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBC) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 659; /* riscv_clmulr_si */

        case 1:
          if (!(
#line 1180 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBC) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 660; /* riscv_clmulr_di */

        default:
          return -1;
        }

    case 44:
      return recog_39 (x1, insn, pnum_clobbers);

    case 45:
      return recog_45 (x1, insn, pnum_clobbers);

    case 46:
      if (pattern165 (x1, 
E_HImode) != 0
          || !
#line 157 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB && TARGET_64BIT))
        return -1;
      return 677; /* riscv_packw */

    case 48:
      switch (pattern164 (x1))
        {
        case 0:
          if (!(
#line 195 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZBKX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 679; /* riscv_xperm4_si */

        case 1:
          if (!(
#line 195 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZBKX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 680; /* riscv_xperm4_di */

        default:
          return -1;
        }

    case 47:
      switch (pattern164 (x1))
        {
        case 0:
          if (!(
#line 204 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZBKX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 681; /* riscv_xperm8_si */

        case 1:
          if (!(
#line 204 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZBKX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 682; /* riscv_xperm8_di */

        default:
          return -1;
        }

    case 51:
      if (pattern165 (x1, 
E_DImode) != 0
          || !
#line 235 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKND && TARGET_64BIT))
        return -1;
      return 685; /* riscv_aes64ds */

    case 52:
      if (pattern165 (x1, 
E_DImode) != 0
          || !
#line 244 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKND && TARGET_64BIT))
        return -1;
      return 686; /* riscv_aes64dsm */

    case 54:
      return recog_46 (x1, insn, pnum_clobbers);

    case 55:
      if (pattern165 (x1, 
E_DImode) != 0
          || !
#line 270 "../../../gcc/config/riscv/crypto.md"
((TARGET_ZKND || TARGET_ZKNE) && TARGET_64BIT))
        return -1;
      return 689; /* riscv_aes64ks2 */

    case 56:
      if (pattern165 (x1, 
E_DImode) != 0
          || !
#line 301 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKNE && TARGET_64BIT))
        return -1;
      return 692; /* riscv_aes64es */

    case 57:
      if (pattern165 (x1, 
E_DImode) != 0
          || !
#line 310 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKNE && TARGET_64BIT))
        return -1;
      return 693; /* riscv_aes64esm */

    case 65:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 366 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 702; /* riscv_sha512sig0h */

    case 66:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 375 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 703; /* riscv_sha512sig0l */

    case 68:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 384 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 704; /* riscv_sha512sig1h */

    case 69:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 393 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 705; /* riscv_sha512sig1l */

    case 71:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 402 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 706; /* riscv_sha512sum0r */

    case 73:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 411 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 707; /* riscv_sha512sum1r */

    case 37:
      if (pattern166 (x1, 
E_DFmode) != 0
          || !
#line 189 "../../../gcc/config/riscv/thead.md"
(!TARGET_64BIT && TARGET_XTHEADFMV))
        return -1;
      return 896; /* th_fmv_hw_w_x */

    case 91:
      return recog_33 (x1, insn, pnum_clobbers);

    case 104:
      return recog_32 (x1, insn, pnum_clobbers);

    case 138:
      return recog_37 (x1, insn, pnum_clobbers);

    case 139:
      return recog_36 (x1, insn, pnum_clobbers);

    case 121:
      return recog_35 (x1, insn, pnum_clobbers);

    case 143:
      return recog_34 (x1, insn, pnum_clobbers);

    case 227:
      if (pattern167 (x1) != 0
          || !
#line 680 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 33807; /* riscv_cv_alu_clip */

    case 229:
      if (pattern167 (x1) != 0
          || !
#line 693 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 33808; /* riscv_cv_alu_clipu */

    case 233:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 891 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33819; /* riscv_cv_simd_add_b_si */

    case 234:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 902 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33820; /* riscv_cv_simd_add_sc_h_si */

    case 235:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 915 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33821; /* riscv_cv_simd_add_sc_b_si */

    case 237:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 944 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33823; /* riscv_cv_simd_sub_b_si */

    case 238:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 955 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33824; /* riscv_cv_simd_sub_sc_h_si */

    case 239:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 968 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33825; /* riscv_cv_simd_sub_sc_b_si */

    case 240:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 981 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33826; /* riscv_cv_simd_avg_h_si */

    case 241:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 992 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33827; /* riscv_cv_simd_avg_b_si */

    case 242:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1003 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33828; /* riscv_cv_simd_avg_sc_h_si */

    case 243:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1016 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33829; /* riscv_cv_simd_avg_sc_b_si */

    case 244:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1029 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33830; /* riscv_cv_simd_avgu_h_si */

    case 245:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1040 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33831; /* riscv_cv_simd_avgu_b_si */

    case 246:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 1051 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33832; /* riscv_cv_simd_avgu_sc_h_si */

    case 247:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 1064 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33833; /* riscv_cv_simd_avgu_sc_b_si */

    case 248:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1077 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33834; /* riscv_cv_simd_min_h_si */

    case 249:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1088 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33835; /* riscv_cv_simd_min_b_si */

    case 250:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1099 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33836; /* riscv_cv_simd_min_sc_h_si */

    case 251:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1112 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33837; /* riscv_cv_simd_min_sc_b_si */

    case 252:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1125 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33838; /* riscv_cv_simd_minu_h_si */

    case 253:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1136 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33839; /* riscv_cv_simd_minu_b_si */

    case 254:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 1147 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33840; /* riscv_cv_simd_minu_sc_h_si */

    case 255:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 1160 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33841; /* riscv_cv_simd_minu_sc_b_si */

    case 256:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1173 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33842; /* riscv_cv_simd_max_h_si */

    case 257:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1184 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33843; /* riscv_cv_simd_max_b_si */

    case 258:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1195 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33844; /* riscv_cv_simd_max_sc_h_si */

    case 259:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1208 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33845; /* riscv_cv_simd_max_sc_b_si */

    case 260:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1221 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33846; /* riscv_cv_simd_maxu_h_si */

    case 261:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1232 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33847; /* riscv_cv_simd_maxu_b_si */

    case 262:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 1243 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33848; /* riscv_cv_simd_maxu_sc_h_si */

    case 263:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 1256 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33849; /* riscv_cv_simd_maxu_sc_b_si */

    case 264:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1269 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33850; /* riscv_cv_simd_srl_h_si */

    case 265:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1280 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33851; /* riscv_cv_simd_srl_b_si */

    case 266:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 1291 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33852; /* riscv_cv_simd_srl_sc_h_si */

    case 267:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 1304 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33853; /* riscv_cv_simd_srl_sc_b_si */

    case 268:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1317 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33854; /* riscv_cv_simd_sra_h_si */

    case 269:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1328 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33855; /* riscv_cv_simd_sra_b_si */

    case 270:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 1339 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33856; /* riscv_cv_simd_sra_sc_h_si */

    case 271:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 1352 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33857; /* riscv_cv_simd_sra_sc_b_si */

    case 272:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1365 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33858; /* riscv_cv_simd_sll_h_si */

    case 273:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1376 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33859; /* riscv_cv_simd_sll_b_si */

    case 274:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 1387 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33860; /* riscv_cv_simd_sll_sc_h_si */

    case 275:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 1400 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33861; /* riscv_cv_simd_sll_sc_b_si */

    case 276:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1413 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33862; /* riscv_cv_simd_or_h_si */

    case 277:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1424 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33863; /* riscv_cv_simd_or_b_si */

    case 278:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1435 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33864; /* riscv_cv_simd_or_sc_h_si */

    case 279:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1448 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33865; /* riscv_cv_simd_or_sc_b_si */

    case 280:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1461 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33866; /* riscv_cv_simd_xor_h_si */

    case 281:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1472 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33867; /* riscv_cv_simd_xor_b_si */

    case 282:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1483 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33868; /* riscv_cv_simd_xor_sc_h_si */

    case 283:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1496 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33869; /* riscv_cv_simd_xor_sc_b_si */

    case 284:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1509 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33870; /* riscv_cv_simd_and_h_si */

    case 285:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1520 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33871; /* riscv_cv_simd_and_b_si */

    case 286:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1531 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33872; /* riscv_cv_simd_and_sc_h_si */

    case 287:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1544 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33873; /* riscv_cv_simd_and_sc_b_si */

    case 292:
      if (pattern170 (x1) != 0
          || !
#line 1594 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33878; /* riscv_cv_simd_extract_h_si */

    case 293:
      if (pattern170 (x1) != 0
          || !
#line 1605 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33879; /* riscv_cv_simd_extract_b_si */

    case 294:
      if (pattern170 (x1) != 0
          || !
#line 1616 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33880; /* riscv_cv_simd_extractu_h_si */

    case 295:
      if (pattern170 (x1) != 0
          || !
#line 1627 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33881; /* riscv_cv_simd_extractu_b_si */

    case 298:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1663 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33884; /* riscv_cv_simd_dotup_h_si */

    case 299:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1674 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33885; /* riscv_cv_simd_dotup_b_si */

    case 300:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 1685 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33886; /* riscv_cv_simd_dotup_sc_h_si */

    case 301:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 1698 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33887; /* riscv_cv_simd_dotup_sc_b_si */

    case 302:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1711 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33888; /* riscv_cv_simd_dotusp_h_si */

    case 303:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1722 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33889; /* riscv_cv_simd_dotusp_b_si */

    case 304:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1733 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33890; /* riscv_cv_simd_dotusp_sc_h_si */

    case 305:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1746 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33891; /* riscv_cv_simd_dotusp_sc_b_si */

    case 306:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1759 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33892; /* riscv_cv_simd_dotsp_h_si */

    case 307:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1770 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33893; /* riscv_cv_simd_dotsp_b_si */

    case 308:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 1781 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33894; /* riscv_cv_simd_dotsp_sc_h_si */

    case 309:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 1794 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33895; /* riscv_cv_simd_dotsp_sc_b_si */

    case 322:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1964 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33908; /* riscv_cv_simd_shuffle_h_si */

    case 323:
      return recog_44 (x1, insn, pnum_clobbers);

    case 324:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 1986 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33910; /* riscv_cv_simd_shuffle_b_si */

    case 325:
      return recog_43 (x1, insn, pnum_clobbers);

    case 328:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2036 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33914; /* riscv_cv_simd_packhi_h_si */

    case 329:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2047 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33915; /* riscv_cv_simd_packlo_h_si */

    case 332:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2083 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33918; /* riscv_cv_simd_cmpeq_h_si */

    case 333:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2094 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33919; /* riscv_cv_simd_cmpeq_b_si */

    case 334:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 2105 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33920; /* riscv_cv_simd_cmpeq_sc_h_si */

    case 335:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 2118 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33921; /* riscv_cv_simd_cmpeq_sc_b_si */

    case 336:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2131 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33922; /* riscv_cv_simd_cmpne_h_si */

    case 337:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2142 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33923; /* riscv_cv_simd_cmpne_b_si */

    case 338:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 2153 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33924; /* riscv_cv_simd_cmpne_sc_h_si */

    case 339:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 2166 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33925; /* riscv_cv_simd_cmpne_sc_b_si */

    case 340:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2179 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33926; /* riscv_cv_simd_cmpgt_h_si */

    case 341:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2190 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33927; /* riscv_cv_simd_cmpgt_b_si */

    case 342:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 2201 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33928; /* riscv_cv_simd_cmpgt_sc_h_si */

    case 343:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 2214 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33929; /* riscv_cv_simd_cmpgt_sc_b_si */

    case 344:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2227 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33930; /* riscv_cv_simd_cmpge_h_si */

    case 345:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2238 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33931; /* riscv_cv_simd_cmpge_b_si */

    case 346:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 2249 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33932; /* riscv_cv_simd_cmpge_sc_h_si */

    case 347:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 2262 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33933; /* riscv_cv_simd_cmpge_sc_b_si */

    case 348:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2275 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33934; /* riscv_cv_simd_cmplt_h_si */

    case 349:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2286 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33935; /* riscv_cv_simd_cmplt_b_si */

    case 350:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 2297 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33936; /* riscv_cv_simd_cmplt_sc_h_si */

    case 351:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 2310 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33937; /* riscv_cv_simd_cmplt_sc_b_si */

    case 352:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2323 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33938; /* riscv_cv_simd_cmple_h_si */

    case 353:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2334 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33939; /* riscv_cv_simd_cmple_b_si */

    case 354:
      if (pattern168 (x1, 
E_HImode) != 0
          || !
#line 2345 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33940; /* riscv_cv_simd_cmple_sc_h_si */

    case 355:
      if (pattern168 (x1, 
E_QImode) != 0
          || !
#line 2358 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33941; /* riscv_cv_simd_cmple_sc_b_si */

    case 356:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2371 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33942; /* riscv_cv_simd_cmpgtu_h_si */

    case 357:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2382 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33943; /* riscv_cv_simd_cmpgtu_b_si */

    case 358:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 2393 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33944; /* riscv_cv_simd_cmpgtu_sc_h_si */

    case 359:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 2406 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33945; /* riscv_cv_simd_cmpgtu_sc_b_si */

    case 360:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2419 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33946; /* riscv_cv_simd_cmpgeu_h_si */

    case 361:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2430 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33947; /* riscv_cv_simd_cmpgeu_b_si */

    case 362:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 2441 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33948; /* riscv_cv_simd_cmpgeu_sc_h_si */

    case 363:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 2454 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33949; /* riscv_cv_simd_cmpgeu_sc_b_si */

    case 364:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2467 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33950; /* riscv_cv_simd_cmpltu_h_si */

    case 365:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2478 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33951; /* riscv_cv_simd_cmpltu_b_si */

    case 366:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 2489 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33952; /* riscv_cv_simd_cmpltu_sc_h_si */

    case 367:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 2502 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33953; /* riscv_cv_simd_cmpltu_sc_b_si */

    case 368:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2515 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33954; /* riscv_cv_simd_cmpleu_h_si */

    case 369:
      if (pattern166 (x1, 
E_SImode) != 0
          || !
#line 2526 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33955; /* riscv_cv_simd_cmpleu_b_si */

    case 370:
      if (pattern169 (x1, 
E_HImode) != 0
          || !
#line 2537 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33956; /* riscv_cv_simd_cmpleu_sc_h_si */

    case 371:
      if (pattern169 (x1, 
E_QImode) != 0
          || !
#line 2550 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33957; /* riscv_cv_simd_cmpleu_sc_b_si */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!absolute_symbolic_operand (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!
#line 44 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 818; /* *local_pic_load_uqi */

        case E_HImode:
          if (!
#line 44 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 821; /* *local_pic_load_uhi */

        case E_SImode:
          if (!(
#line 44 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 63 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 824; /* *local_pic_load_usi */

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!
#line 44 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 819; /* *local_pic_load_uqi */

        case E_HImode:
          if (!
#line 44 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 822; /* *local_pic_load_uhi */

        case E_SImode:
          if (!(
#line 44 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 63 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 825; /* *local_pic_load_usi */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!(
#line 44 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 820; /* *local_pic_load_uqi */

        case E_HImode:
          if (!(
#line 44 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 823; /* *local_pic_load_uhi */

        case E_SImode:
          if (!(
#line 44 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 826; /* *local_pic_load_usi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V2048BImode)
      && reg_or_mem_operand (operands[1], E_V2048BImode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4399 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3332; /* *movv2048bisi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4399 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3333; /* *movv2048bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V2048BImode)
      || !register_operand (operands[1], E_V2048BImode)
      || !(
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3505; /* *movv2048bi_vls */
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512BImode)
      && reg_or_mem_operand (operands[1], E_V512BImode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512BImode)
       || register_operand (operands[1], V512BImode))) && (
#line 4397 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3328; /* *movv512bisi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512BImode)
       || register_operand (operands[1], V512BImode))) && (
#line 4397 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3329; /* *movv512bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512BImode)
      || !register_operand (operands[1], E_V512BImode)
      || !(
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 3503; /* *movv512bi_vls */
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V128BImode)
      && reg_or_mem_operand (operands[1], E_V128BImode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4395 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3324; /* *movv128bisi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4395 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3325; /* *movv128bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V128BImode)
      || !register_operand (operands[1], E_V128BImode)
      || !(
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3501; /* *movv128bi_vls */
}

 int
recog_120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32BImode)
      && reg_or_mem_operand (operands[1], E_V32BImode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4393 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3320; /* *movv32bisi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4393 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3321; /* *movv32bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32BImode)
      || !register_operand (operands[1], E_V32BImode)
      || !(
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
    return -1;
  return 3499; /* *movv32bi_vls */
}

 int
recog_122 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V256DFmode)
      && reg_or_mem_operand (operands[1], E_V256DFmode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4390 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3316; /* *movv256dfsi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4390 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3317; /* *movv256dfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V256DFmode)
      || !register_operand (operands[1], E_V256DFmode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3413; /* *movv256df_vls */
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512SFmode)
      && reg_or_mem_operand (operands[1], E_V512SFmode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4385 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3306; /* *movv512sfsi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4385 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3307; /* *movv512sfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512SFmode)
      || !register_operand (operands[1], E_V512SFmode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3403; /* *movv512sf_vls */
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024HFmode)
      && reg_or_mem_operand (operands[1], E_V1024HFmode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3294; /* *movv1024hfsi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3295; /* *movv1024hfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024HFmode)
      || !register_operand (operands[1], E_V1024HFmode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3392; /* *movv1024hf_vls */
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512DImode)
      && reg_or_mem_operand (operands[1], E_V512DImode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3282; /* *movv512disi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3283; /* *movv512didi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512DImode)
      || !register_operand (operands[1], E_V512DImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3381; /* *movv512di_vls */
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512SImode)
      && reg_or_mem_operand (operands[1], E_V512SImode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3270; /* *movv512sisi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3271; /* *movv512sidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512SImode)
      || !register_operand (operands[1], E_V512SImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3370; /* *movv512si_vls */
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024HImode)
      && reg_or_mem_operand (operands[1], E_V1024HImode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3258; /* *movv1024hisi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3259; /* *movv1024hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024HImode)
      || !register_operand (operands[1], E_V1024HImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3359; /* *movv1024hi_vls */
}

 int
recog_157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V4096QImode)
      && reg_or_mem_operand (operands[1], E_V4096QImode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3246; /* *movv4096qisi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3247; /* *movv4096qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V4096QImode)
      || !register_operand (operands[1], E_V4096QImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3348; /* *movv4096qi_vls */
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64QImode)
      && reg_or_mem_operand (operands[1], E_V64QImode))
    {
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3234; /* *movv64qisi_lra */
        }
      if ((
#line 1478 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3235; /* *movv64qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64QImode)
      || !register_operand (operands[1], E_V64QImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3342; /* *movv64qi_vls */
}

 int
recog_171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF64BImode)
      && register_operand (operands[1], E_RVVMF64BImode)
      && (
#line 1294 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
    return 2812; /* *movrvvmf64bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF64BImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF64BImode))
    return -1;
  if ((
#line 1354 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2848; /* *movrvvmf64bisi_lra */
    }
  if (!(
#line 1354 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2849; /* *movrvvmf64bidi_lra */
}

 int
recog_177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2BFmode)
      && register_operand (operands[1], E_RVVMF2BFmode)
      && (
#line 1257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
    return 2795; /* *movrvvmf2bf_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2BFmode))
    return -1;
  if ((
#line 1332 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2831; /* *movrvvmf2bfsi_lra */
    }
  if (!(
#line 1332 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2842; /* *movrvvmf2bfdi_lra */
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16BImode)
      && reg_or_mem_operand (operands[1], E_V16BImode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode))) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
    return 3231; /* *movv16bi */
  if (!register_operand (operands[0], E_V16BImode)
      || !register_operand (operands[1], E_V16BImode)
      || !(
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
    return -1;
  return 3498; /* *movv16bi_vls */
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16DFmode)
      && reg_or_mem_operand (operands[1], E_V16DFmode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16DFmode)
       || register_operand (operands[1], V16DFmode))) && 
#line 4338 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return 3226; /* *movv16df */
  if (!register_operand (operands[0], E_V16DFmode)
      || !register_operand (operands[1], E_V16DFmode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3409; /* *movv16df_vls */
}

 int
recog_195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8SFmode)
      && reg_or_mem_operand (operands[1], E_V8SFmode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8SFmode)
       || register_operand (operands[1], V8SFmode))) && 
#line 4332 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 3220; /* *movv8sf */
  if (!register_operand (operands[0], E_V8SFmode)
      || !register_operand (operands[1], E_V8SFmode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 3397; /* *movv8sf_vls */
}

 int
recog_201 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4HFmode)
      && reg_or_mem_operand (operands[1], E_V4HFmode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4HFmode)
       || register_operand (operands[1], V4HFmode))) && 
#line 4326 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 3214; /* *movv4hf */
  if (!register_operand (operands[0], E_V4HFmode)
      || !register_operand (operands[1], E_V4HFmode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 3384; /* *movv4hf_vls */
}

 int
recog_207 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2DImode)
      && reg_or_mem_operand (operands[1], E_V2DImode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[1], V2DImode))) && 
#line 4320 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 3208; /* *movv2di */
  if (!register_operand (operands[0], E_V2DImode)
      || !register_operand (operands[1], E_V2DImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 3373; /* *movv2di_vls */
}

 int
recog_213 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1SImode)
      && reg_or_mem_operand (operands[1], E_V1SImode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1SImode)
       || register_operand (operands[1], V1SImode))) && 
#line 4314 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return 3202; /* *movv1si */
  if (!register_operand (operands[0], E_V1SImode)
      || !register_operand (operands[1], E_V1SImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return -1;
  return 3361; /* *movv1si_vls */
}

 int
recog_220 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8QImode)
      && reg_or_mem_operand (operands[1], E_V8QImode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8QImode)
       || register_operand (operands[1], V8QImode))) && 
#line 4307 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return 3195; /* *movv8qi */
  if (!register_operand (operands[0], E_V8QImode)
      || !register_operand (operands[1], E_V8QImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return -1;
  return 3339; /* *movv8qi_vls */
}

 int
recog_227 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2BFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1341 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3186; /* *movrvvm4x2bf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1341 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3187; /* *movrvvm4x2bf_di */
}

 int
recog_238 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2BFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3164; /* *movrvvm2x2bf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3165; /* *movrvvm2x2bf_di */
}

 int
recog_246 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5QImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3148; /* *movrvvm1x5qi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3149; /* *movrvvm1x5qi_di */
}

 int
recog_253 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2SFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1309 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3134; /* *movrvvm2x2sf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1309 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3135; /* *movrvvm2x2sf_di */
}

 int
recog_260 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2HFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1302 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3120; /* *movrvvm1x2hf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1302 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3121; /* *movrvvm1x2hf_di */
}

 int
recog_268 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2DImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3104; /* *movrvvm4x2di_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3105; /* *movrvvm4x2di_di */
}

 int
recog_280 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x7QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x7QImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3080; /* *movrvvmf2x7qi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3081; /* *movrvvmf2x7qi_di */
}

 int
recog_288 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2DFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1271 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3064; /* *movrvvm2x2df_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1271 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3065; /* *movrvvm2x2df_di */
}

 int
recog_296 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8HFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1263 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3048; /* *movrvvmf2x8hf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1263 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3049; /* *movrvvmf2x8hf_di */
}

 int
recog_304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x7BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x7BFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3032; /* *movrvvmf2x7bf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3033; /* *movrvvmf2x7bf_di */
}

 int
recog_312 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2DImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3016; /* *movrvvm2x2di_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3017; /* *movrvvm2x2di_di */
}

 int
recog_320 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8HImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3000; /* *movrvvmf2x8hi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3001; /* *movrvvmf2x8hi_di */
}

 int
recog_328 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x7QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x7QImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2984; /* *movrvvmf4x7qi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2985; /* *movrvvmf4x7qi_di */
}

 int
recog_336 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6DFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1220 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2968; /* *movrvvm1x6df_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1220 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2969; /* *movrvvm1x6df_di */
}

 int
recog_344 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x5SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x5SFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1212 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2952; /* *movrvvmf2x5sf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1212 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2953; /* *movrvvmf2x5sf_di */
}

 int
recog_352 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x4HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x4HFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2936; /* *movrvvmf4x4hf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2937; /* *movrvvmf4x4hf_di */
}

 int
recog_360 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x3BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x3BFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2920; /* *movrvvmf4x3bf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2921; /* *movrvvmf4x3bf_di */
}

 int
recog_368 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2DImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2904; /* *movrvvm1x2di_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2905; /* *movrvvm1x2di_di */
}

 int
recog_376 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x7 = XEXP (x1, 1);
  operands[2] = x7;
  if (!immediate_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode
          || !(
#line 815 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS
   && (operands[2] == CONST0_RTX (SImode)
       || operands[2] == CONST1_RTX (SImode))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 625; /* *bsetclr_zero_extract */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode
          || !(
#line 815 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS
   && (operands[2] == CONST0_RTX (DImode)
       || operands[2] == CONST1_RTX (DImode))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 626; /* *bsetclr_zero_extract */

    default:
      return -1;
    }
}

 int
recog_382 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 2);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      operands[3] = x5;
      if (!branch_on_bit_operand (operands[3], E_VOIDmode))
        return -1;
      operands[0] = x3;
      x6 = XEXP (x2, 1);
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 383; /* *branch_on_bitsi */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || !
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 384; /* *branch_on_bitdi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      operands[1] = x3;
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x2, 1);
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || GET_MODE (x5) != E_SImode
              || !(
#line 1143 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 653; /* *branchsi_bext */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || GET_MODE (x5) != E_DImode
              || !(
#line 1143 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 654; /* *branchdi_bext */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_384 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (equality_operator (x3, E_VOIDmode))
    {
      res = recog_383 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_CODE (x3))
    {
    case EQ:
      switch (pattern360 (x2))
        {
        case 0:
          if (!(
#line 34 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33656; /* *czero.nez.sisi */

        case 1:
          if (!(
#line 34 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33658; /* *czero.nez.sidi */

        case 2:
          if (!(
#line 34 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33660; /* *czero.nez.didi */

        case 3:
          if (!(
#line 69 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33668; /* *czero.eqz.sisi.opt1 */

        case 4:
          if (!(
#line 69 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33670; /* *czero.eqz.sidi.opt1 */

        case 5:
          if (!(
#line 69 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && (((
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 33669; /* *czero.eqz.disi.opt1 */

        case 6:
          if (!(
#line 69 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33671; /* *czero.eqz.didi.opt1 */

        case 7:
          if (!(
#line 51 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33662; /* *czero.eqz.sisi */

        case 8:
          if (!(
#line 51 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33664; /* *czero.eqz.sidi */

        case 9:
          if (!(
#line 51 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33666; /* *czero.eqz.didi */

        default:
          return -1;
        }

    case NE:
      switch (pattern360 (x2))
        {
        case 0:
          if (!(
#line 34 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33657; /* *czero.eqz.sisi */

        case 1:
          if (!(
#line 34 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33659; /* *czero.eqz.sidi */

        case 2:
          if (!(
#line 34 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33661; /* *czero.eqz.didi */

        case 3:
          if (!(
#line 86 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33672; /* *czero.nez.sisi.opt2 */

        case 4:
          if (!(
#line 86 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33674; /* *czero.nez.sidi.opt2 */

        case 5:
          if (!(
#line 86 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && (((
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 33673; /* *czero.nez.disi.opt2 */

        case 6:
          if (!(
#line 86 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33675; /* *czero.nez.didi.opt2 */

        case 7:
          if (!(
#line 51 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33663; /* *czero.nez.sisi */

        case 8:
          if (!(
#line 51 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33665; /* *czero.nez.sidi */

        case 9:
          if (!(
#line 51 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33667; /* *czero.nez.didi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_387 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      switch (pattern409 ())
        {
        case 0:
          if (!(
#line 3252 "../../../gcc/config/riscv/riscv.md"
(!TARGET_XCVBI) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 369; /* *branchsi */

        case 1:
          if (!(
#line 3252 "../../../gcc/config/riscv/riscv.md"
(!TARGET_XCVBI) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 370; /* *branchdi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[3] = x3;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x2, 0);
      operands[5] = x6;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      x4 = XEXP (x2, 2);
      operands[4] = x4;
      switch (pattern333 (x2))
        {
        case 0:
          if (!register_operand (operands[3], E_SImode)
              || !sfb_alu_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !reg_or_0_operand (operands[2], E_SImode)
                  || !(
#line 31 "../../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33676; /* *movsisicc */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !reg_or_0_operand (operands[2], E_DImode)
                  || !(
#line 31 "../../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33677; /* *movsidicc */

            default:
              return -1;
            }

        case 1:
          if (!register_operand (operands[1], E_DImode)
              || !reg_or_0_operand (operands[2], E_DImode)
              || !register_operand (operands[3], E_DImode)
              || !sfb_alu_operand (operands[4], E_DImode)
              || !(
#line 31 "../../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33678; /* *movdidicc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_388 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF64BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF64BImode))
    return -1;
  if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
    return 1231; /* *pred_th_movrvvmf64bi */
  if (!(
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
    return -1;
  return 3816; /* pred_movrvvmf64bi */
}

 int
recog_389 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF32BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF32BImode))
    return -1;
  if (
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1232; /* *pred_th_movrvvmf32bi */
  if (!
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3817; /* pred_movrvvmf32bi */
}

 int
recog_391 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF8BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF8BImode))
    return -1;
  if (
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1234; /* *pred_th_movrvvmf8bi */
  if (!
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3819; /* pred_movrvvmf8bi */
}

 int
recog_393 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF2BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF2BImode))
    return -1;
  if (
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1236; /* *pred_th_movrvvmf2bi */
  if (!
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3821; /* pred_movrvvmf2bi */
}

 int
recog_395 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3843; /* pred_mergervvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3844; /* pred_mergervvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3845; /* pred_mergervvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3846; /* pred_mergervvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3847; /* pred_mergervvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3848; /* pred_mergervvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3849; /* pred_mergervvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3850; /* pred_mergervvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3851; /* pred_mergervvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3852; /* pred_mergervvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3853; /* pred_mergervvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3854; /* pred_mergervvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3855; /* pred_mergervvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3856; /* pred_mergervvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3857; /* pred_mergervvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3858; /* pred_mergervvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3859; /* pred_mergervvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3860; /* pred_mergervvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3861; /* pred_mergervvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3862; /* pred_mergervvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3863; /* pred_mergervvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3864; /* pred_mergervvmf2si */

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3865; /* pred_mergervvm8bf */

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3866; /* pred_mergervvm4bf */

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3867; /* pred_mergervvm2bf */

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3868; /* pred_mergervvm1bf */

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3869; /* pred_mergervvmf2bf */

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3870; /* pred_mergervvmf4bf */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3871; /* pred_mergervvm8hf */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3872; /* pred_mergervvm4hf */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3873; /* pred_mergervvm2hf */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3874; /* pred_mergervvm1hf */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3875; /* pred_mergervvmf2hf */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3876; /* pred_mergervvmf4hf */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3877; /* pred_mergervvm8sf */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3878; /* pred_mergervvm4sf */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3879; /* pred_mergervvm2sf */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3880; /* pred_mergervvm1sf */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3881; /* pred_mergervvmf2sf */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3882; /* pred_mergervvm8df */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3883; /* pred_mergervvm4df */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3884; /* pred_mergervvm2df */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3885; /* pred_mergervvm1df */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 3886; /* pred_mergev1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 3887; /* pred_mergev2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 3888; /* pred_mergev4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 3889; /* pred_mergev8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 3890; /* pred_mergev16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 3891; /* pred_mergev32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3892; /* pred_mergev64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3893; /* pred_mergev128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3894; /* pred_mergev256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3895; /* pred_mergev512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3896; /* pred_mergev1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3897; /* pred_mergev2048qi */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3898; /* pred_mergev4096qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 3899; /* pred_mergev1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 3900; /* pred_mergev2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 3901; /* pred_mergev4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 3902; /* pred_mergev8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 3903; /* pred_mergev16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3904; /* pred_mergev32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3905; /* pred_mergev64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3906; /* pred_mergev128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3907; /* pred_mergev256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3908; /* pred_mergev512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3909; /* pred_mergev1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3910; /* pred_mergev2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 3911; /* pred_mergev1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 3912; /* pred_mergev2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 3913; /* pred_mergev4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 3914; /* pred_mergev8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3915; /* pred_mergev16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3916; /* pred_mergev32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3917; /* pred_mergev64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3918; /* pred_mergev128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3919; /* pred_mergev256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3920; /* pred_mergev512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3921; /* pred_mergev1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3922; /* pred_mergev1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3923; /* pred_mergev2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3924; /* pred_mergev4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3925; /* pred_mergev8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3926; /* pred_mergev16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3927; /* pred_mergev32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3928; /* pred_mergev64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3929; /* pred_mergev128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3930; /* pred_mergev256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3931; /* pred_mergev512di */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3932; /* pred_mergev1hf */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3933; /* pred_mergev2hf */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3934; /* pred_mergev4hf */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3935; /* pred_mergev8hf */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3936; /* pred_mergev16hf */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3937; /* pred_mergev32hf */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3938; /* pred_mergev64hf */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3939; /* pred_mergev128hf */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3940; /* pred_mergev256hf */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3941; /* pred_mergev512hf */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3942; /* pred_mergev1024hf */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3943; /* pred_mergev2048hf */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3944; /* pred_mergev1sf */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3945; /* pred_mergev2sf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3946; /* pred_mergev4sf */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3947; /* pred_mergev8sf */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3948; /* pred_mergev16sf */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3949; /* pred_mergev32sf */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3950; /* pred_mergev64sf */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3951; /* pred_mergev128sf */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3952; /* pred_mergev256sf */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3953; /* pred_mergev512sf */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3954; /* pred_mergev1024sf */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3955; /* pred_mergev1df */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3956; /* pred_mergev2df */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3957; /* pred_mergev4df */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3958; /* pred_mergev8df */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3959; /* pred_mergev16df */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3960; /* pred_mergev32df */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3961; /* pred_mergev64df */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3962; /* pred_mergev128df */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3963; /* pred_mergev256df */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern593 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !(
#line 2011 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3964; /* pred_mergev512df */

    default:
      return -1;
    }
}

 int
recog_409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  if (!vector_length_operand (x5, E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 2);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      switch (pattern480 (x2))
        {
        case 0:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14213; /* pred_nandrvvmf64bi */

        case 1:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14216; /* pred_nandrvvmf32bi */

        case 2:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14219; /* pred_nandrvvmf16bi */

        case 3:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14222; /* pred_nandrvvmf8bi */

        case 4:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14225; /* pred_nandrvvmf4bi */

        case 5:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14228; /* pred_nandrvvmf2bi */

        case 6:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14231; /* pred_nandrvvm1bi */

        case 7:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14234; /* pred_nandv1bi */

        case 8:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14237; /* pred_nandv2bi */

        case 9:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14240; /* pred_nandv4bi */

        case 10:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14243; /* pred_nandv8bi */

        case 11:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14246; /* pred_nandv16bi */

        case 12:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14249; /* pred_nandv32bi */

        case 13:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14252; /* pred_nandv64bi */

        case 14:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14255; /* pred_nandv128bi */

        case 15:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14258; /* pred_nandv256bi */

        case 16:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14261; /* pred_nandv512bi */

        case 17:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14264; /* pred_nandv1024bi */

        case 18:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14267; /* pred_nandv2048bi */

        case 19:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14270; /* pred_nandv4096bi */

        default:
          return -1;
        }

    case IOR:
      switch (pattern480 (x2))
        {
        case 0:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14214; /* pred_niorrvvmf64bi */

        case 1:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14217; /* pred_niorrvvmf32bi */

        case 2:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14220; /* pred_niorrvvmf16bi */

        case 3:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14223; /* pred_niorrvvmf8bi */

        case 4:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14226; /* pred_niorrvvmf4bi */

        case 5:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14229; /* pred_niorrvvmf2bi */

        case 6:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14232; /* pred_niorrvvm1bi */

        case 7:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14235; /* pred_niorv1bi */

        case 8:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14238; /* pred_niorv2bi */

        case 9:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14241; /* pred_niorv4bi */

        case 10:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14244; /* pred_niorv8bi */

        case 11:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14247; /* pred_niorv16bi */

        case 12:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14250; /* pred_niorv32bi */

        case 13:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14253; /* pred_niorv64bi */

        case 14:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14256; /* pred_niorv128bi */

        case 15:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14259; /* pred_niorv256bi */

        case 16:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14262; /* pred_niorv512bi */

        case 17:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14265; /* pred_niorv1024bi */

        case 18:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14268; /* pred_niorv2048bi */

        case 19:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14271; /* pred_niorv4096bi */

        default:
          return -1;
        }

    case XOR:
      switch (pattern480 (x2))
        {
        case 0:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14215; /* pred_nxorrvvmf64bi */

        case 1:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14218; /* pred_nxorrvvmf32bi */

        case 2:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14221; /* pred_nxorrvvmf16bi */

        case 3:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14224; /* pred_nxorrvvmf8bi */

        case 4:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14227; /* pred_nxorrvvmf4bi */

        case 5:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14230; /* pred_nxorrvvmf2bi */

        case 6:
          if (!
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14233; /* pred_nxorrvvm1bi */

        case 7:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14236; /* pred_nxorv1bi */

        case 8:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14239; /* pred_nxorv2bi */

        case 9:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14242; /* pred_nxorv4bi */

        case 10:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14245; /* pred_nxorv8bi */

        case 11:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14248; /* pred_nxorv16bi */

        case 12:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14251; /* pred_nxorv32bi */

        case 13:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14254; /* pred_nxorv64bi */

        case 14:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14257; /* pred_nxorv128bi */

        case 15:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14260; /* pred_nxorv256bi */

        case 16:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14263; /* pred_nxorv512bi */

        case 17:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14266; /* pred_nxorv1024bi */

        case 18:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14269; /* pred_nxorv2048bi */

        case 19:
          if (!(
#line 6029 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14272; /* pred_nxorv4096bi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[3] = x8;
      operands[4] = x5;
      x9 = XVECEXP (x3, 0, 2);
      operands[5] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          if (pattern568 (x2, 
E_RVVMF64BImode) != 0
              || !(
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14313; /* pred_notrvvmf64bi */

        case E_RVVMF32BImode:
          if (pattern568 (x2, 
E_RVVMF32BImode) != 0
              || !
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14314; /* pred_notrvvmf32bi */

        case E_RVVMF16BImode:
          if (pattern568 (x2, 
E_RVVMF16BImode) != 0
              || !
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14315; /* pred_notrvvmf16bi */

        case E_RVVMF8BImode:
          if (pattern568 (x2, 
E_RVVMF8BImode) != 0
              || !
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14316; /* pred_notrvvmf8bi */

        case E_RVVMF4BImode:
          if (pattern568 (x2, 
E_RVVMF4BImode) != 0
              || !
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14317; /* pred_notrvvmf4bi */

        case E_RVVMF2BImode:
          if (pattern568 (x2, 
E_RVVMF2BImode) != 0
              || !
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14318; /* pred_notrvvmf2bi */

        case E_RVVM1BImode:
          if (pattern568 (x2, 
E_RVVM1BImode) != 0
              || !
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14319; /* pred_notrvvm1bi */

        case E_V1BImode:
          if (pattern568 (x2, 
E_V1BImode) != 0
              || !(
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14320; /* pred_notv1bi */

        case E_V2BImode:
          if (pattern568 (x2, 
E_V2BImode) != 0
              || !(
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14321; /* pred_notv2bi */

        case E_V4BImode:
          if (pattern568 (x2, 
E_V4BImode) != 0
              || !(
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14322; /* pred_notv4bi */

        case E_V8BImode:
          if (pattern568 (x2, 
E_V8BImode) != 0
              || !(
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14323; /* pred_notv8bi */

        case E_V16BImode:
          if (pattern568 (x2, 
E_V16BImode) != 0
              || !(
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14324; /* pred_notv16bi */

        case E_V32BImode:
          if (pattern568 (x2, 
E_V32BImode) != 0
              || !(
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14325; /* pred_notv32bi */

        case E_V64BImode:
          if (pattern568 (x2, 
E_V64BImode) != 0
              || !(
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14326; /* pred_notv64bi */

        case E_V128BImode:
          if (pattern568 (x2, 
E_V128BImode) != 0
              || !(
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14327; /* pred_notv128bi */

        case E_V256BImode:
          if (pattern568 (x2, 
E_V256BImode) != 0
              || !(
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14328; /* pred_notv256bi */

        case E_V512BImode:
          if (pattern568 (x2, 
E_V512BImode) != 0
              || !(
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14329; /* pred_notv512bi */

        case E_V1024BImode:
          if (pattern568 (x2, 
E_V1024BImode) != 0
              || !(
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14330; /* pred_notv1024bi */

        case E_V2048BImode:
          if (pattern568 (x2, 
E_V2048BImode) != 0
              || !(
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14331; /* pred_notv2048bi */

        case E_V4096BImode:
          if (pattern568 (x2, 
E_V4096BImode) != 0
              || !(
#line 6069 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14332; /* pred_notv4096bi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_413 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V512DFmode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512DFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return 4352; /* *pred_broadcastv512df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512DFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4474; /* *pred_broadcastv512df_imm */
}

 int
recog_414 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V256DFmode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256DFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return 4351; /* *pred_broadcastv256df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256DFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4473; /* *pred_broadcastv256df_imm */
}

 int
recog_415 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V128DFmode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128DFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return 4350; /* *pred_broadcastv128df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128DFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4472; /* *pred_broadcastv128df_imm */
}

 int
recog_416 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V64DFmode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64DFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 4349; /* *pred_broadcastv64df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64DFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4471; /* *pred_broadcastv64df_imm */
}

 int
recog_418 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V16DFmode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16DFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return 4347; /* *pred_broadcastv16df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16DFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4469; /* *pred_broadcastv16df_imm */
}

 int
recog_421 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V2DFmode, 
E_V2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2BImode)
      && vector_const_0_operand (operands[3], E_V2DFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 4344; /* *pred_broadcastv2df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2DFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4466; /* *pred_broadcastv2df_imm */
}

 int
recog_425 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V256SFmode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256SFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return 4340; /* *pred_broadcastv256sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256SFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4462; /* *pred_broadcastv256sf_imm */
}

 int
recog_429 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V16SFmode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16SFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 4336; /* *pred_broadcastv16sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16SFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4458; /* *pred_broadcastv16sf_imm */
}

 int
recog_433 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V1SFmode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1SFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 4332; /* *pred_broadcastv1sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1SFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4454; /* *pred_broadcastv1sf_imm */
}

 int
recog_437 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V256HFmode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256HFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return 4328; /* *pred_broadcastv256hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256HFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4450; /* *pred_broadcastv256hf_imm */
}

 int
recog_441 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V16HFmode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16HFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 4324; /* *pred_broadcastv16hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16HFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4446; /* *pred_broadcastv16hf_imm */
}

 int
recog_445 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V1HFmode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1HFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 4320; /* *pred_broadcastv1hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1HFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4442; /* *pred_broadcastv1hf_imm */
}

 int
recog_450 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32DImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 4315; /* *pred_broadcastv32di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32DImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4437; /* *pred_broadcastv32di_imm */
}

 int
recog_455 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1DImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 4310; /* *pred_broadcastv1di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1DImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 4432; /* *pred_broadcastv1di_imm */
}

 int
recog_461 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32SImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 4304; /* *pred_broadcastv32si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32SImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4426; /* *pred_broadcastv32si_imm */
}

 int
recog_467 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2048BImode)
      && vector_const_0_operand (operands[3], E_V2048HImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 4298; /* *pred_broadcastv2048hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2048BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2048HImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4420; /* *pred_broadcastv2048hi_imm */
}

 int
recog_474 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16HImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 4291; /* *pred_broadcastv16hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16HImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 4413; /* *pred_broadcastv16hi_imm */
}

 int
recog_481 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024QImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return 4284; /* *pred_broadcastv1024qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024QImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4406; /* *pred_broadcastv1024qi_imm */
}

 int
recog_488 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8QImode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return 4277; /* *pred_broadcastv8qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8QImode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return -1;
  return 4399; /* *pred_broadcastv8qi_imm */
}

 int
recog_495 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
      && vector_const_0_operand (operands[3], E_RVVM8DFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 4270; /* *pred_broadcastrvvm8df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8DFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4392; /* *pred_broadcastrvvm8df_imm */
}

 int
recog_503 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern597 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
      && vector_const_0_operand (operands[3], E_RVVM1HFmode)
      && (
#line 2340 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 4262; /* *pred_broadcastrvvm1hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1HFmode)
      || !(
#line 2360 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4384; /* *pred_broadcastrvvm1hf_imm */
}

 int
recog_511 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V256DFmode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256DImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return 20703; /* pred_gatherv256df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20825; /* pred_gatherv256df_scalar */
}

 int
recog_516 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V8DFmode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8DImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 20698; /* pred_gatherv8df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20820; /* pred_gatherv8df_scalar */
}

 int
recog_521 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V512SFmode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512SImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 20693; /* pred_gatherv512sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20815; /* pred_gatherv512sf_scalar */
}

 int
recog_526 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V16SFmode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16SImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 20688; /* pred_gatherv16sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20810; /* pred_gatherv16sf_scalar */
}

 int
recog_532 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1024HImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
    return 20682; /* pred_gatherv1024hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20804; /* pred_gatherv1024hf_scalar */
}

 int
recog_537 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V32HFmode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32HImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
    return 20677; /* pred_gatherv32hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20799; /* pred_gatherv32hf_scalar */
}

 int
recog_542 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1HFmode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1HImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 20672; /* pred_gatherv1hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 20794; /* pred_gatherv1hf_scalar */
}

 int
recog_547 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32DImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 20667; /* pred_gatherv32di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20789; /* pred_gatherv32di_scalar */
}

 int
recog_552 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1DImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 20662; /* pred_gatherv1di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 20784; /* pred_gatherv1di_scalar */
}

 int
recog_557 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64SImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 20657; /* pred_gatherv64si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20779; /* pred_gatherv64si_scalar */
}

 int
recog_562 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2SImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 20652; /* pred_gatherv2si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 20774; /* pred_gatherv2si_scalar */
}

 int
recog_567 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256HImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 20647; /* pred_gatherv256hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 20769; /* pred_gatherv256hi_scalar */
}

 int
recog_572 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8HImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return 20642; /* pred_gatherv8hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return -1;
  return 20764; /* pred_gatherv8hi_scalar */
}

 int
recog_577 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2048QImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return 20637; /* pred_gatherv2048qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20759; /* pred_gatherv2048qi_scalar */
}

 int
recog_582 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64QImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 20632; /* pred_gatherv64qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20754; /* pred_gatherv64qi_scalar */
}

 int
recog_587 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2QImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return 20627; /* pred_gatherv2qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return -1;
  return 20749; /* pred_gatherv2qi_scalar */
}

 int
recog_592 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_RVVM8DImode)
      && (
#line 8229 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 20622; /* pred_gatherrvvm8df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8249 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20744; /* pred_gatherrvvm8df_scalar */
}

 int
recog_597 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern553 (x2))
    {
    case 0:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8088; /* pred_mulhurvvm8qi */

    case 1:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8091; /* pred_mulhurvvm4qi */

    case 2:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8094; /* pred_mulhurvvm2qi */

    case 3:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8097; /* pred_mulhurvvm1qi */

    case 4:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8100; /* pred_mulhurvvmf2qi */

    case 5:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8103; /* pred_mulhurvvmf4qi */

    case 6:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 502 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8106; /* pred_mulhurvvmf8qi */

    case 7:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8109; /* pred_mulhurvvm8hi */

    case 8:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8112; /* pred_mulhurvvm4hi */

    case 9:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8115; /* pred_mulhurvvm2hi */

    case 10:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8118; /* pred_mulhurvvm1hi */

    case 11:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8121; /* pred_mulhurvvmf2hi */

    case 12:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 504 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8124; /* pred_mulhurvvmf4hi */

    case 13:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8127; /* pred_mulhurvvm8si */

    case 14:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8130; /* pred_mulhurvvm4si */

    case 15:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8133; /* pred_mulhurvvm2si */

    case 16:
      if (!
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8136; /* pred_mulhurvvm1si */

    case 17:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 506 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8139; /* pred_mulhurvvmf2si */

    case 18:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8142; /* pred_mulhurvvm8di */

    case 19:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8145; /* pred_mulhurvvm4di */

    case 20:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8148; /* pred_mulhurvvm2di */

    case 21:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8151; /* pred_mulhurvvm1di */

    case 22:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8154; /* pred_mulhuv1qi */

    case 23:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8157; /* pred_mulhuv2qi */

    case 24:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8160; /* pred_mulhuv4qi */

    case 25:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8163; /* pred_mulhuv8qi */

    case 26:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8166; /* pred_mulhuv16qi */

    case 27:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8169; /* pred_mulhuv32qi */

    case 28:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8172; /* pred_mulhuv64qi */

    case 29:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 517 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8175; /* pred_mulhuv128qi */

    case 30:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8178; /* pred_mulhuv256qi */

    case 31:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8181; /* pred_mulhuv512qi */

    case 32:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8184; /* pred_mulhuv1024qi */

    case 33:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8187; /* pred_mulhuv2048qi */

    case 34:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8190; /* pred_mulhuv4096qi */

    case 35:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8193; /* pred_mulhuv1hi */

    case 36:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8196; /* pred_mulhuv2hi */

    case 37:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8199; /* pred_mulhuv4hi */

    case 38:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8202; /* pred_mulhuv8hi */

    case 39:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8205; /* pred_mulhuv16hi */

    case 40:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8208; /* pred_mulhuv32hi */

    case 41:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8211; /* pred_mulhuv64hi */

    case 42:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8214; /* pred_mulhuv128hi */

    case 43:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 531 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8217; /* pred_mulhuv256hi */

    case 44:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 532 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8220; /* pred_mulhuv512hi */

    case 45:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 533 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8223; /* pred_mulhuv1024hi */

    case 46:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 534 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8226; /* pred_mulhuv2048hi */

    case 47:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 535 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8229; /* pred_mulhuv1si */

    case 48:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 536 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8232; /* pred_mulhuv2si */

    case 49:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 537 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8235; /* pred_mulhuv4si */

    case 50:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 538 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8238; /* pred_mulhuv8si */

    case 51:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 539 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8241; /* pred_mulhuv16si */

    case 52:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 540 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8244; /* pred_mulhuv32si */

    case 53:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 541 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8247; /* pred_mulhuv64si */

    case 54:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 542 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8250; /* pred_mulhuv128si */

    case 55:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 543 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8253; /* pred_mulhuv256si */

    case 56:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 544 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8256; /* pred_mulhuv512si */

    case 57:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 545 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8259; /* pred_mulhuv1024si */

    case 58:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 546 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 8262; /* pred_mulhuv1di */

    case 59:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 547 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 8265; /* pred_mulhuv2di */

    case 60:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 548 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 8268; /* pred_mulhuv4di */

    case 61:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 549 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8271; /* pred_mulhuv8di */

    case 62:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 550 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8274; /* pred_mulhuv16di */

    case 63:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 551 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8277; /* pred_mulhuv32di */

    case 64:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 552 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8280; /* pred_mulhuv64di */

    case 65:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 553 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8283; /* pred_mulhuv128di */

    case 66:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 554 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8286; /* pred_mulhuv256di */

    case 67:
      if (!(
#line 3074 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 555 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8289; /* pred_mulhuv512di */

    case 68:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8292; /* pred_mulhurvvm8qi_scalar */

    case 69:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8295; /* pred_mulhurvvm4qi_scalar */

    case 70:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8298; /* pred_mulhurvvm2qi_scalar */

    case 71:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8301; /* pred_mulhurvvm1qi_scalar */

    case 72:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8304; /* pred_mulhurvvmf2qi_scalar */

    case 73:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8307; /* pred_mulhurvvmf4qi_scalar */

    case 74:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8310; /* pred_mulhurvvmf8qi_scalar */

    case 75:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8313; /* pred_mulhurvvm8hi_scalar */

    case 76:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8316; /* pred_mulhurvvm4hi_scalar */

    case 77:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8319; /* pred_mulhurvvm2hi_scalar */

    case 78:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8322; /* pred_mulhurvvm1hi_scalar */

    case 79:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8325; /* pred_mulhurvvmf2hi_scalar */

    case 80:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8328; /* pred_mulhurvvmf4hi_scalar */

    case 81:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8331; /* pred_mulhurvvm8si_scalar */

    case 82:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8334; /* pred_mulhurvvm4si_scalar */

    case 83:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8337; /* pred_mulhurvvm2si_scalar */

    case 84:
      if (!
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8340; /* pred_mulhurvvm1si_scalar */

    case 85:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8343; /* pred_mulhurvvmf2si_scalar */

    case 86:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8346; /* pred_mulhuv1qi_scalar */

    case 87:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8349; /* pred_mulhuv2qi_scalar */

    case 88:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8352; /* pred_mulhuv4qi_scalar */

    case 89:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8355; /* pred_mulhuv8qi_scalar */

    case 90:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8358; /* pred_mulhuv16qi_scalar */

    case 91:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8361; /* pred_mulhuv32qi_scalar */

    case 92:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8364; /* pred_mulhuv64qi_scalar */

    case 93:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8367; /* pred_mulhuv128qi_scalar */

    case 94:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8370; /* pred_mulhuv256qi_scalar */

    case 95:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8373; /* pred_mulhuv512qi_scalar */

    case 96:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8376; /* pred_mulhuv1024qi_scalar */

    case 97:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8379; /* pred_mulhuv2048qi_scalar */

    case 98:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8382; /* pred_mulhuv4096qi_scalar */

    case 99:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8385; /* pred_mulhuv1hi_scalar */

    case 100:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8388; /* pred_mulhuv2hi_scalar */

    case 101:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8391; /* pred_mulhuv4hi_scalar */

    case 102:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8394; /* pred_mulhuv8hi_scalar */

    case 103:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8397; /* pred_mulhuv16hi_scalar */

    case 104:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8400; /* pred_mulhuv32hi_scalar */

    case 105:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8403; /* pred_mulhuv64hi_scalar */

    case 106:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8406; /* pred_mulhuv128hi_scalar */

    case 107:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8409; /* pred_mulhuv256hi_scalar */

    case 108:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8412; /* pred_mulhuv512hi_scalar */

    case 109:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8415; /* pred_mulhuv1024hi_scalar */

    case 110:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8418; /* pred_mulhuv2048hi_scalar */

    case 111:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8421; /* pred_mulhuv1si_scalar */

    case 112:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8424; /* pred_mulhuv2si_scalar */

    case 113:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8427; /* pred_mulhuv4si_scalar */

    case 114:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8430; /* pred_mulhuv8si_scalar */

    case 115:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8433; /* pred_mulhuv16si_scalar */

    case 116:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8436; /* pred_mulhuv32si_scalar */

    case 117:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8439; /* pred_mulhuv64si_scalar */

    case 118:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8442; /* pred_mulhuv128si_scalar */

    case 119:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8445; /* pred_mulhuv256si_scalar */

    case 120:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8448; /* pred_mulhuv512si_scalar */

    case 121:
      if (!(
#line 3095 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8451; /* pred_mulhuv1024si_scalar */

    case 122:
      if (!(
#line 3149 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 790 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8454; /* *pred_mulhurvvm8di_scalar */

    case 123:
      if (!(
#line 3149 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 790 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8457; /* *pred_mulhurvvm4di_scalar */

    case 124:
      if (!(
#line 3149 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 791 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8460; /* *pred_mulhurvvm2di_scalar */

    case 125:
      if (!(
#line 3149 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 791 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8463; /* *pred_mulhurvvm1di_scalar */

    case 126:
      if (!(
#line 3171 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 790 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8466; /* *pred_mulhurvvm8di_extended_scalar */

    case 127:
      if (!(
#line 3171 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 790 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8469; /* *pred_mulhurvvm4di_extended_scalar */

    case 128:
      if (!(
#line 3171 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 791 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8472; /* *pred_mulhurvvm2di_extended_scalar */

    case 129:
      if (!(
#line 3171 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 791 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8475; /* *pred_mulhurvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_602 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern599 (x2))
    {
    case 0:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32820; /* pred_vbrev8rvvm8qi */

    case 1:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32823; /* pred_vbrev8rvvm4qi */

    case 2:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32826; /* pred_vbrev8rvvm2qi */

    case 3:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32829; /* pred_vbrev8rvvm1qi */

    case 4:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32832; /* pred_vbrev8rvvm8hi */

    case 5:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32835; /* pred_vbrev8rvvm4hi */

    case 6:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32838; /* pred_vbrev8rvvm2hi */

    case 7:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32841; /* pred_vbrev8rvvm1hi */

    case 8:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32844; /* pred_vbrev8rvvm8si */

    case 9:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32847; /* pred_vbrev8rvvm4si */

    case 10:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32850; /* pred_vbrev8rvvm2si */

    case 11:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32853; /* pred_vbrev8rvvm1si */

    case 12:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32856; /* pred_vbrev8rvvm8di */

    case 13:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32859; /* pred_vbrev8rvvm4di */

    case 14:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32862; /* pred_vbrev8rvvm2di */

    case 15:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32865; /* pred_vbrev8rvvm1di */

    case 16:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32868; /* pred_vbrev8rvvmf2qi */

    case 17:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32871; /* pred_vbrev8rvvmf4qi */

    case 18:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 32874; /* pred_vbrev8rvvmf8qi */

    case 19:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32877; /* pred_vbrev8rvvmf2hi */

    case 20:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 32880; /* pred_vbrev8rvvmf4hi */

    case 21:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 32883; /* pred_vbrev8rvvmf2si */

    case 22:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 32886; /* pred_vbrev8v1qi */

    case 23:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 32889; /* pred_vbrev8v2qi */

    case 24:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 32892; /* pred_vbrev8v4qi */

    case 25:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 32895; /* pred_vbrev8v8qi */

    case 26:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 32898; /* pred_vbrev8v16qi */

    case 27:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 32901; /* pred_vbrev8v32qi */

    case 28:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32904; /* pred_vbrev8v64qi */

    case 29:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32907; /* pred_vbrev8v128qi */

    case 30:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32910; /* pred_vbrev8v256qi */

    case 31:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32913; /* pred_vbrev8v512qi */

    case 32:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32916; /* pred_vbrev8v1024qi */

    case 33:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32919; /* pred_vbrev8v2048qi */

    case 34:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32922; /* pred_vbrev8v4096qi */

    case 35:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 32925; /* pred_vbrev8v1hi */

    case 36:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 32928; /* pred_vbrev8v2hi */

    case 37:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 32931; /* pred_vbrev8v4hi */

    case 38:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 32934; /* pred_vbrev8v8hi */

    case 39:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 32937; /* pred_vbrev8v16hi */

    case 40:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32940; /* pred_vbrev8v32hi */

    case 41:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32943; /* pred_vbrev8v64hi */

    case 42:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32946; /* pred_vbrev8v128hi */

    case 43:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32949; /* pred_vbrev8v256hi */

    case 44:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32952; /* pred_vbrev8v512hi */

    case 45:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32955; /* pred_vbrev8v1024hi */

    case 46:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32958; /* pred_vbrev8v2048hi */

    case 47:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32961; /* pred_vbrev8v1si */

    case 48:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32964; /* pred_vbrev8v2si */

    case 49:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32967; /* pred_vbrev8v4si */

    case 50:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32970; /* pred_vbrev8v8si */

    case 51:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32973; /* pred_vbrev8v16si */

    case 52:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32976; /* pred_vbrev8v32si */

    case 53:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32979; /* pred_vbrev8v64si */

    case 54:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32982; /* pred_vbrev8v128si */

    case 55:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32985; /* pred_vbrev8v256si */

    case 56:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32988; /* pred_vbrev8v512si */

    case 57:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32991; /* pred_vbrev8v1024si */

    case 58:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32994; /* pred_vbrev8v1di */

    case 59:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32997; /* pred_vbrev8v2di */

    case 60:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33000; /* pred_vbrev8v4di */

    case 61:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33003; /* pred_vbrev8v8di */

    case 62:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33006; /* pred_vbrev8v16di */

    case 63:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33009; /* pred_vbrev8v32di */

    case 64:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33012; /* pred_vbrev8v64di */

    case 65:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33015; /* pred_vbrev8v128di */

    case 66:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33018; /* pred_vbrev8v256di */

    case 67:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33021; /* pred_vbrev8v512di */

    default:
      return -1;
    }
}

 int
recog_618 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM1SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM1SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM1SImode)
      || !
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13092; /* *pred_mul_plusrvvm1si_undef */
}

 int
recog_622 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM1DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM1DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM1DImode)
      || !(
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13096; /* *pred_mul_plusrvvm1di_undef */
}

 int
recog_626 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVMF2HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVMF2HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVMF2HImode)
      || !(
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return -1;
  return 13100; /* *pred_mul_plusrvvmf2hi_undef */
}

 int
recog_630 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2QImode)
      || !(
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return -1;
  return 13104; /* *pred_mul_plusv2qi_undef */
}

 int
recog_634 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V32QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V32QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V32QImode)
      || !(
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return -1;
  return 13108; /* *pred_mul_plusv32qi_undef */
}

 int
recog_638 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V512QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V512QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V512QImode)
      || !(
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13112; /* *pred_mul_plusv512qi_undef */
}

 int
recog_643 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2HImode)
      || !(
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 13117; /* *pred_mul_plusv2hi_undef */
}

 int
recog_648 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V64HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V64HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V64HImode)
      || !(
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13122; /* *pred_mul_plusv64hi_undef */
}

 int
recog_653 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2048HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2048HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2048HImode)
      || !(
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13127; /* *pred_mul_plusv2048hi_undef */
}

 int
recog_658 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V16SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V16SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V16SImode)
      || !(
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13132; /* *pred_mul_plusv16si_undef */
}

 int
recog_664 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1024SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1024SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1024SImode)
      || !(
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13138; /* *pred_mul_plusv1024si_undef */
}

 int
recog_670 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V32DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V32DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V32DImode)
      || !(
#line 5321 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13144; /* *pred_mul_plusv32di_undef */
}

 int
recog_676 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_673 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V256DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 13215; /* *pred_maddv256di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13283; /* *pred_maccv256di */
}

 int
recog_682 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_667 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V4DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13209; /* *pred_maddv4di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13277; /* *pred_maccv4di */
}

 int
recog_689 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_660 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V64SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13202; /* *pred_maddv64si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13270; /* *pred_maccv64si */
}

 int
recog_696 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_653 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V2048HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2048HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 13195; /* *pred_maddv2048hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13263; /* *pred_maccv2048hi */
}

 int
recog_703 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_646 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V16HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 13188; /* *pred_maddv16hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 13256; /* *pred_maccv16hi */
}

 int
recog_710 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_639 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V1024QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return 13181; /* *pred_maddv1024qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13249; /* *pred_maccv1024qi */
}

 int
recog_717 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 13350; /* *pred_maddv128di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13418; /* *pred_maccv128di_scalar */
}

 int
recog_724 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13343; /* *pred_maddv1di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13411; /* *pred_maccv1di_scalar */
}

 int
recog_731 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 13336; /* *pred_maddv16si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13404; /* *pred_maccv16si_scalar */
}

 int
recog_738 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 13329; /* *pred_maddv512hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13397; /* *pred_maccv512hi_scalar */
}

 int
recog_745 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XEXP (x4, 1);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      switch (pattern698 (x2))
        {
        case 0:
          if (!
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13817; /* pred_widen_mul_plussrvvm8hi */

        case 1:
          if (!
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13819; /* pred_widen_mul_plussrvvm4hi */

        case 2:
          if (!
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13821; /* pred_widen_mul_plussrvvm2hi */

        case 3:
          if (!
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13823; /* pred_widen_mul_plussrvvm1hi */

        case 4:
          if (!
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13825; /* pred_widen_mul_plussrvvmf2hi */

        case 5:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 13827; /* pred_widen_mul_plussrvvmf4hi */

        case 6:
          if (!
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13829; /* pred_widen_mul_plussrvvm8si */

        case 7:
          if (!
#line 41 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32421; /* pred_matrix_mul_plusrvvm8si_qoq */

        case 8:
          if (!
#line 113 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32437; /* pred_matrix_mul_plusrvvm8si_dod */

        case 9:
          if (!
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13831; /* pred_widen_mul_plussrvvm4si */

        case 10:
          if (!
#line 41 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32423; /* pred_matrix_mul_plusrvvm4si_qoq */

        case 11:
          if (!
#line 113 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32439; /* pred_matrix_mul_plusrvvm4si_dod */

        case 12:
          if (!
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13833; /* pred_widen_mul_plussrvvm2si */

        case 13:
          if (!
#line 41 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32425; /* pred_matrix_mul_plusrvvm2si_qoq */

        case 14:
          if (!
#line 113 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32441; /* pred_matrix_mul_plusrvvm2si_dod */

        case 15:
          if (!
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13835; /* pred_widen_mul_plussrvvm1si */

        case 16:
          if (!
#line 41 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32427; /* pred_matrix_mul_plusrvvm1si_qoq */

        case 17:
          if (!
#line 113 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32443; /* pred_matrix_mul_plusrvvm1si_dod */

        case 18:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 13837; /* pred_widen_mul_plussrvvmf2si */

        case 19:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13839; /* pred_widen_mul_plussrvvm8di */

        case 20:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13841; /* pred_widen_mul_plussrvvm4di */

        case 21:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13843; /* pred_widen_mul_plussrvvm2di */

        case 22:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13845; /* pred_widen_mul_plussrvvm1di */

        case 23:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 13847; /* pred_widen_mul_plussv1hi */

        case 24:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 13849; /* pred_widen_mul_plussv2hi */

        case 25:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 13851; /* pred_widen_mul_plussv4hi */

        case 26:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 13853; /* pred_widen_mul_plussv8hi */

        case 27:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 13855; /* pred_widen_mul_plussv16hi */

        case 28:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 13857; /* pred_widen_mul_plussv32hi */

        case 29:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 13859; /* pred_widen_mul_plussv64hi */

        case 30:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 13861; /* pred_widen_mul_plussv128hi */

        case 31:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 13863; /* pred_widen_mul_plussv256hi */

        case 32:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 13865; /* pred_widen_mul_plussv512hi */

        case 33:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 13867; /* pred_widen_mul_plussv1024hi */

        case 34:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 13869; /* pred_widen_mul_plussv2048hi */

        case 35:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 13871; /* pred_widen_mul_plussv1si */

        case 36:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 13873; /* pred_widen_mul_plussv2si */

        case 37:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 13875; /* pred_widen_mul_plussv4si */

        case 38:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 13877; /* pred_widen_mul_plussv8si */

        case 39:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 13879; /* pred_widen_mul_plussv16si */

        case 40:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 13881; /* pred_widen_mul_plussv32si */

        case 41:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 13883; /* pred_widen_mul_plussv64si */

        case 42:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 13885; /* pred_widen_mul_plussv128si */

        case 43:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 13887; /* pred_widen_mul_plussv256si */

        case 44:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 13889; /* pred_widen_mul_plussv512si */

        case 45:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 13891; /* pred_widen_mul_plussv1024si */

        case 46:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13893; /* pred_widen_mul_plussv1di */

        case 47:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13895; /* pred_widen_mul_plussv2di */

        case 48:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13897; /* pred_widen_mul_plussv4di */

        case 49:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 13899; /* pred_widen_mul_plussv8di */

        case 50:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 13901; /* pred_widen_mul_plussv16di */

        case 51:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 13903; /* pred_widen_mul_plussv32di */

        case 52:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 13905; /* pred_widen_mul_plussv64di */

        case 53:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 13907; /* pred_widen_mul_plussv128di */

        case 54:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 13909; /* pred_widen_mul_plussv256di */

        case 55:
          if (!(
#line 5874 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 13911; /* pred_widen_mul_plussv512di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern698 (x2))
        {
        case 0:
          if (!
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14009; /* pred_widen_mul_plussurvvm8hi */

        case 1:
          if (!
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14010; /* pred_widen_mul_plussurvvm4hi */

        case 2:
          if (!
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14011; /* pred_widen_mul_plussurvvm2hi */

        case 3:
          if (!
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14012; /* pred_widen_mul_plussurvvm1hi */

        case 4:
          if (!
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14013; /* pred_widen_mul_plussurvvmf2hi */

        case 5:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14014; /* pred_widen_mul_plussurvvmf4hi */

        case 6:
          if (!
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14015; /* pred_widen_mul_plussurvvm8si */

        case 7:
          if (!
#line 65 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32429; /* pred_matrix_mul_plussurvvm8si_qoq */

        case 8:
          if (!
#line 137 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32445; /* pred_matrix_mul_plussurvvm8si_dod */

        case 9:
          if (!
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14016; /* pred_widen_mul_plussurvvm4si */

        case 10:
          if (!
#line 65 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32430; /* pred_matrix_mul_plussurvvm4si_qoq */

        case 11:
          if (!
#line 137 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32446; /* pred_matrix_mul_plussurvvm4si_dod */

        case 12:
          if (!
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14017; /* pred_widen_mul_plussurvvm2si */

        case 13:
          if (!
#line 65 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32431; /* pred_matrix_mul_plussurvvm2si_qoq */

        case 14:
          if (!
#line 137 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32447; /* pred_matrix_mul_plussurvvm2si_dod */

        case 15:
          if (!
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14018; /* pred_widen_mul_plussurvvm1si */

        case 16:
          if (!
#line 65 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32432; /* pred_matrix_mul_plussurvvm1si_qoq */

        case 17:
          if (!
#line 137 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32448; /* pred_matrix_mul_plussurvvm1si_dod */

        case 18:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14019; /* pred_widen_mul_plussurvvmf2si */

        case 19:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14020; /* pred_widen_mul_plussurvvm8di */

        case 20:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14021; /* pred_widen_mul_plussurvvm4di */

        case 21:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14022; /* pred_widen_mul_plussurvvm2di */

        case 22:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14023; /* pred_widen_mul_plussurvvm1di */

        case 23:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 14024; /* pred_widen_mul_plussuv1hi */

        case 24:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 14025; /* pred_widen_mul_plussuv2hi */

        case 25:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 14026; /* pred_widen_mul_plussuv4hi */

        case 26:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 14027; /* pred_widen_mul_plussuv8hi */

        case 27:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 14028; /* pred_widen_mul_plussuv16hi */

        case 28:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14029; /* pred_widen_mul_plussuv32hi */

        case 29:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14030; /* pred_widen_mul_plussuv64hi */

        case 30:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14031; /* pred_widen_mul_plussuv128hi */

        case 31:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14032; /* pred_widen_mul_plussuv256hi */

        case 32:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14033; /* pred_widen_mul_plussuv512hi */

        case 33:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14034; /* pred_widen_mul_plussuv1024hi */

        case 34:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14035; /* pred_widen_mul_plussuv2048hi */

        case 35:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 14036; /* pred_widen_mul_plussuv1si */

        case 36:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 14037; /* pred_widen_mul_plussuv2si */

        case 37:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 14038; /* pred_widen_mul_plussuv4si */

        case 38:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 14039; /* pred_widen_mul_plussuv8si */

        case 39:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14040; /* pred_widen_mul_plussuv16si */

        case 40:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14041; /* pred_widen_mul_plussuv32si */

        case 41:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14042; /* pred_widen_mul_plussuv64si */

        case 42:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14043; /* pred_widen_mul_plussuv128si */

        case 43:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14044; /* pred_widen_mul_plussuv256si */

        case 44:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14045; /* pred_widen_mul_plussuv512si */

        case 45:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14046; /* pred_widen_mul_plussuv1024si */

        case 46:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14047; /* pred_widen_mul_plussuv1di */

        case 47:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14048; /* pred_widen_mul_plussuv2di */

        case 48:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14049; /* pred_widen_mul_plussuv4di */

        case 49:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14050; /* pred_widen_mul_plussuv8di */

        case 50:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14051; /* pred_widen_mul_plussuv16di */

        case 51:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14052; /* pred_widen_mul_plussuv32di */

        case 52:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14053; /* pred_widen_mul_plussuv64di */

        case 53:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14054; /* pred_widen_mul_plussuv128di */

        case 54:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14055; /* pred_widen_mul_plussuv256di */

        case 55:
          if (!(
#line 5923 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14056; /* pred_widen_mul_plussuv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_753 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V512DImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 13516; /* *pred_minus_mulv512di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V512DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V512DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 13584; /* *pred_nmsubv512di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13652; /* *pred_nmsacv512di */
}

 int
recog_754 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V256DImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 13515; /* *pred_minus_mulv256di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V256DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V256DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 13583; /* *pred_nmsubv256di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13651; /* *pred_nmsacv256di */
}

 int
recog_755 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V128DImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 13514; /* *pred_minus_mulv128di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V128DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V128DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 13582; /* *pred_nmsubv128di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13650; /* *pred_nmsacv128di */
}

 int
recog_756 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V64DImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13513; /* *pred_minus_mulv64di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V64DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V64DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13581; /* *pred_nmsubv64di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13649; /* *pred_nmsacv64di */
}

 int
recog_757 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V32DImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 13512; /* *pred_minus_mulv32di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V32DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V32DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 13580; /* *pred_nmsubv32di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13648; /* *pred_nmsacv32di */
}

 int
recog_758 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V16DImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13511; /* *pred_minus_mulv16di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V16DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V16DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13579; /* *pred_nmsubv16di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13647; /* *pred_nmsacv16di */
}

 int
recog_760 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V4DImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13509; /* *pred_minus_mulv4di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13577; /* *pred_nmsubv4di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13645; /* *pred_nmsacv4di */
}

 int
recog_762 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V1DImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13507; /* *pred_minus_mulv1di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V1DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V1DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13575; /* *pred_nmsubv1di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13643; /* *pred_nmsacv1di */
}

 int
recog_764 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V512SImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13505; /* *pred_minus_mulv512si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V512SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V512SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13573; /* *pred_nmsubv512si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13641; /* *pred_nmsacv512si */
}

 int
recog_767 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V64SImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13502; /* *pred_minus_mulv64si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V64SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V64SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13570; /* *pred_nmsubv64si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13638; /* *pred_nmsacv64si */
}

 int
recog_771 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V4SImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13498; /* *pred_minus_mulv4si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13566; /* *pred_nmsubv4si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 13634; /* *pred_nmsacv4si */
}

 int
recog_777 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V256HImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13492; /* *pred_minus_mulv256hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V256HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V256HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13560; /* *pred_nmsubv256hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13628; /* *pred_nmsacv256hi */
}

 int
recog_783 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V4HImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 13486; /* *pred_minus_mulv4hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 13554; /* *pred_nmsubv4hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 13622; /* *pred_nmsacv4hi */
}

 int
recog_791 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V128QImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return 13478; /* *pred_minus_mulv128qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V128QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V128QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return 13546; /* *pred_nmsubv128qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13614; /* *pred_nmsacv128qi */
}

 int
recog_799 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_RVVMF2SImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return 13470; /* *pred_minus_mulrvvmf2si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_RVVMF2SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_RVVMF2SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return 13538; /* *pred_nmsubrvvmf2si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return -1;
  return 13606; /* *pred_nmsacrvvmf2si */
}

 int
recog_810 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 13712; /* *pred_nmsubv2di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13780; /* *pred_nmsacv2di_scalar */
}

 int
recog_816 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13706; /* *pred_nmsubv64si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13774; /* *pred_nmsacv64si_scalar */
}

 int
recog_824 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 13698; /* *pred_nmsubv1024hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13766; /* *pred_nmsacv1024hi_scalar */
}

 int
recog_832 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM8QImode) == 0
          && 
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13449; /* *pred_minus_mulrvvm8qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM8QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM8QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM8QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13517; /* *pred_nmsubrvvm8qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13585; /* *pred_nmsacrvvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM4QImode) == 0
          && 
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13450; /* *pred_minus_mulrvvm4qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM4QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM4QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM4QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13518; /* *pred_nmsubrvvm4qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13586; /* *pred_nmsacrvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM2QImode) == 0
          && 
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13451; /* *pred_minus_mulrvvm2qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM2QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM2QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM2QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13519; /* *pred_nmsubrvvm2qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13587; /* *pred_nmsacrvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM1QImode) == 0
          && 
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13452; /* *pred_minus_mulrvvm1qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM1QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM1QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM1QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13520; /* *pred_nmsubrvvm1qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13588; /* *pred_nmsacrvvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM8HImode) == 0
          && 
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13453; /* *pred_minus_mulrvvm8hi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM8HImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM8HImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM8HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13521; /* *pred_nmsubrvvm8hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13589; /* *pred_nmsacrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM4HImode) == 0
          && 
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13454; /* *pred_minus_mulrvvm4hi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM4HImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM4HImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM4HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13522; /* *pred_nmsubrvvm4hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13590; /* *pred_nmsacrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM2HImode) == 0
          && 
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13455; /* *pred_minus_mulrvvm2hi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM2HImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM2HImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM2HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13523; /* *pred_nmsubrvvm2hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13591; /* *pred_nmsacrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM1HImode) == 0
          && 
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13456; /* *pred_minus_mulrvvm1hi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM1HImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM1HImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM1HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13524; /* *pred_nmsubrvvm1hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13592; /* *pred_nmsacrvvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM8SImode) == 0
          && 
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13457; /* *pred_minus_mulrvvm8si_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM8SImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM8SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM8SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13525; /* *pred_nmsubrvvm8si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13593; /* *pred_nmsacrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM4SImode) == 0
          && 
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13458; /* *pred_minus_mulrvvm4si_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM4SImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM4SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM4SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13526; /* *pred_nmsubrvvm4si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13594; /* *pred_nmsacrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM2SImode) == 0
          && 
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13459; /* *pred_minus_mulrvvm2si_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM2SImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM2SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM2SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13527; /* *pred_nmsubrvvm2si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13595; /* *pred_nmsacrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM1SImode) == 0
          && 
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13460; /* *pred_minus_mulrvvm1si_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM1SImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM1SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM1SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13528; /* *pred_nmsubrvvm1si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13596; /* *pred_nmsacrvvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM8DImode) == 0
          && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13461; /* *pred_minus_mulrvvm8di_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM8DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM8DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM8DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13529; /* *pred_nmsubrvvm8di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13597; /* *pred_nmsacrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM4DImode) == 0
          && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13462; /* *pred_minus_mulrvvm4di_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM4DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM4DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM4DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13530; /* *pred_nmsubrvvm4di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13598; /* *pred_nmsacrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM2DImode) == 0
          && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13463; /* *pred_minus_mulrvvm2di_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM2DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM2DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM2DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13531; /* *pred_nmsubrvvm2di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13599; /* *pred_nmsacrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVM1DImode) == 0
          && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13464; /* *pred_minus_mulrvvm1di_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM1DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM1DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM1DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13532; /* *pred_nmsubrvvm1di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13600; /* *pred_nmsacrvvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVMF2QImode) == 0
          && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13465; /* *pred_minus_mulrvvmf2qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVMF2QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVMF2QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVMF2QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13533; /* *pred_nmsubrvvmf2qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13601; /* *pred_nmsacrvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVMF4QImode) == 0
          && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13466; /* *pred_minus_mulrvvmf4qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVMF4QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVMF4QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVMF4QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13534; /* *pred_nmsubrvvmf4qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13602; /* *pred_nmsacrvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern569 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern701 (x2, 
E_RVVMF8QImode) == 0
          && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13467; /* *pred_minus_mulrvvmf8qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVMF8QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVMF8QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVMF8QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13535; /* *pred_nmsubrvvmf8qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13603; /* *pred_nmsacrvvmf8qi */

    case E_RVVMF2HImode:
      return recog_801 (x1, insn, pnum_clobbers);

    case E_RVVMF4HImode:
      return recog_800 (x1, insn, pnum_clobbers);

    case E_RVVMF2SImode:
      return recog_799 (x1, insn, pnum_clobbers);

    case E_V1QImode:
      return recog_798 (x1, insn, pnum_clobbers);

    case E_V2QImode:
      return recog_797 (x1, insn, pnum_clobbers);

    case E_V4QImode:
      return recog_796 (x1, insn, pnum_clobbers);

    case E_V8QImode:
      return recog_795 (x1, insn, pnum_clobbers);

    case E_V16QImode:
      return recog_794 (x1, insn, pnum_clobbers);

    case E_V32QImode:
      return recog_793 (x1, insn, pnum_clobbers);

    case E_V64QImode:
      return recog_792 (x1, insn, pnum_clobbers);

    case E_V128QImode:
      return recog_791 (x1, insn, pnum_clobbers);

    case E_V256QImode:
      return recog_790 (x1, insn, pnum_clobbers);

    case E_V512QImode:
      return recog_789 (x1, insn, pnum_clobbers);

    case E_V1024QImode:
      return recog_788 (x1, insn, pnum_clobbers);

    case E_V2048QImode:
      return recog_787 (x1, insn, pnum_clobbers);

    case E_V4096QImode:
      return recog_786 (x1, insn, pnum_clobbers);

    case E_V1HImode:
      return recog_785 (x1, insn, pnum_clobbers);

    case E_V2HImode:
      return recog_784 (x1, insn, pnum_clobbers);

    case E_V4HImode:
      return recog_783 (x1, insn, pnum_clobbers);

    case E_V8HImode:
      return recog_782 (x1, insn, pnum_clobbers);

    case E_V16HImode:
      return recog_781 (x1, insn, pnum_clobbers);

    case E_V32HImode:
      return recog_780 (x1, insn, pnum_clobbers);

    case E_V64HImode:
      return recog_779 (x1, insn, pnum_clobbers);

    case E_V128HImode:
      return recog_778 (x1, insn, pnum_clobbers);

    case E_V256HImode:
      return recog_777 (x1, insn, pnum_clobbers);

    case E_V512HImode:
      return recog_776 (x1, insn, pnum_clobbers);

    case E_V1024HImode:
      return recog_775 (x1, insn, pnum_clobbers);

    case E_V2048HImode:
      return recog_774 (x1, insn, pnum_clobbers);

    case E_V1SImode:
      return recog_773 (x1, insn, pnum_clobbers);

    case E_V2SImode:
      return recog_772 (x1, insn, pnum_clobbers);

    case E_V4SImode:
      return recog_771 (x1, insn, pnum_clobbers);

    case E_V8SImode:
      return recog_770 (x1, insn, pnum_clobbers);

    case E_V16SImode:
      return recog_769 (x1, insn, pnum_clobbers);

    case E_V32SImode:
      return recog_768 (x1, insn, pnum_clobbers);

    case E_V64SImode:
      return recog_767 (x1, insn, pnum_clobbers);

    case E_V128SImode:
      return recog_766 (x1, insn, pnum_clobbers);

    case E_V256SImode:
      return recog_765 (x1, insn, pnum_clobbers);

    case E_V512SImode:
      return recog_764 (x1, insn, pnum_clobbers);

    case E_V1024SImode:
      return recog_763 (x1, insn, pnum_clobbers);

    case E_V1DImode:
      return recog_762 (x1, insn, pnum_clobbers);

    case E_V2DImode:
      return recog_761 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_760 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_759 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_758 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_757 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_756 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_755 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_754 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_753 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_858 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V4SImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 6335; /* pred_ashlv4si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 6800; /* pred_ashlv4si_scalar */
}

 int
recog_863 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V512HImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 6250; /* pred_ashlv512hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 6785; /* pred_ashlv512hi_scalar */
}

 int
recog_868 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V16HImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 6165; /* pred_ashlv16hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 6770; /* pred_ashlv16hi_scalar */
}

 int
recog_873 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern667 (x2, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V32SImode)
      && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 32766; /* pred_vwsllv32di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 32814; /* pred_vwsllv32di_scalar */
}

 int
recog_878 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      if (pattern667 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM4QImode)
          && 
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 32723; /* pred_vwsllrvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 32771; /* pred_vwsllrvvm8hi_scalar */

    case E_RVVM4HImode:
      if (pattern667 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM2QImode)
          && 
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 32724; /* pred_vwsllrvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 32772; /* pred_vwsllrvvm4hi_scalar */

    case E_RVVM2HImode:
      if (pattern667 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM1QImode)
          && 
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 32725; /* pred_vwsllrvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 32773; /* pred_vwsllrvvm2hi_scalar */

    case E_RVVM1HImode:
      if (pattern667 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVMF2QImode)
          && 
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 32726; /* pred_vwsllrvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 32774; /* pred_vwsllrvvm1hi_scalar */

    case E_RVVMF2HImode:
      if (pattern667 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVMF4QImode)
          && 
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 32727; /* pred_vwsllrvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 32775; /* pred_vwsllrvvmf2hi_scalar */

    case E_RVVMF4HImode:
      if (pattern667 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVMF8QImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32728; /* pred_vwsllrvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32776; /* pred_vwsllrvvmf4hi_scalar */

    case E_RVVM8SImode:
      if (pattern667 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM4HImode)
          && 
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 32729; /* pred_vwsllrvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 32777; /* pred_vwsllrvvm8si_scalar */

    case E_RVVM4SImode:
      if (pattern667 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM2HImode)
          && 
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 32730; /* pred_vwsllrvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 32778; /* pred_vwsllrvvm4si_scalar */

    case E_RVVM2SImode:
      if (pattern667 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM1HImode)
          && 
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 32731; /* pred_vwsllrvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 32779; /* pred_vwsllrvvm2si_scalar */

    case E_RVVM1SImode:
      if (pattern667 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVMF2HImode)
          && 
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 32732; /* pred_vwsllrvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 32780; /* pred_vwsllrvvm1si_scalar */

    case E_RVVMF2SImode:
      if (pattern667 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVMF4HImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32733; /* pred_vwsllrvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32781; /* pred_vwsllrvvmf2si_scalar */

    case E_RVVM8DImode:
      if (pattern667 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM4SImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32734; /* pred_vwsllrvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32782; /* pred_vwsllrvvm8di_scalar */

    case E_RVVM4DImode:
      if (pattern667 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM2SImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32735; /* pred_vwsllrvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32783; /* pred_vwsllrvvm4di_scalar */

    case E_RVVM2DImode:
      if (pattern667 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM1SImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32736; /* pred_vwsllrvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32784; /* pred_vwsllrvvm2di_scalar */

    case E_RVVM1DImode:
      if (pattern667 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVMF2SImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32737; /* pred_vwsllrvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32785; /* pred_vwsllrvvm1di_scalar */

    case E_V1HImode:
      if (pattern667 (x2, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V1QImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 32738; /* pred_vwsllv1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 32786; /* pred_vwsllv1hi_scalar */

    case E_V2HImode:
      if (pattern667 (x2, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V2QImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 32739; /* pred_vwsllv2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 32787; /* pred_vwsllv2hi_scalar */

    case E_V4HImode:
      if (pattern667 (x2, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V4QImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 32740; /* pred_vwsllv4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 32788; /* pred_vwsllv4hi_scalar */

    case E_V8HImode:
      if (pattern667 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V8QImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 32741; /* pred_vwsllv8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 32789; /* pred_vwsllv8hi_scalar */

    case E_V16HImode:
      if (pattern667 (x2, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V16QImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 32742; /* pred_vwsllv16hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 32790; /* pred_vwsllv16hi_scalar */

    case E_V32HImode:
      if (pattern667 (x2, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V32QImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 32743; /* pred_vwsllv32hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32791; /* pred_vwsllv32hi_scalar */

    case E_V64HImode:
      if (pattern667 (x2, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V64QImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 32744; /* pred_vwsllv64hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32792; /* pred_vwsllv64hi_scalar */

    case E_V128HImode:
      if (pattern667 (x2, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V128QImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 32745; /* pred_vwsllv128hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32793; /* pred_vwsllv128hi_scalar */

    case E_V256HImode:
      if (pattern667 (x2, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V256QImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 32746; /* pred_vwsllv256hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32794; /* pred_vwsllv256hi_scalar */

    case E_V512HImode:
      if (pattern667 (x2, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V512QImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 32747; /* pred_vwsllv512hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32795; /* pred_vwsllv512hi_scalar */

    case E_V1024HImode:
      if (pattern667 (x2, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V1024QImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 32748; /* pred_vwsllv1024hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32796; /* pred_vwsllv1024hi_scalar */

    case E_V2048HImode:
      if (pattern667 (x2, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V2048QImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 32749; /* pred_vwsllv2048hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32797; /* pred_vwsllv2048hi_scalar */

    case E_V1SImode:
      if (pattern667 (x2, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V1HImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 32750; /* pred_vwsllv1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32798; /* pred_vwsllv1si_scalar */

    case E_V2SImode:
      if (pattern667 (x2, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V2HImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 32751; /* pred_vwsllv2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32799; /* pred_vwsllv2si_scalar */

    case E_V4SImode:
      if (pattern667 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V4HImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 32752; /* pred_vwsllv4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32800; /* pred_vwsllv4si_scalar */

    case E_V8SImode:
      if (pattern667 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V8HImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 32753; /* pred_vwsllv8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32801; /* pred_vwsllv8si_scalar */

    case E_V16SImode:
      if (pattern667 (x2, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V16HImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 32754; /* pred_vwsllv16si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32802; /* pred_vwsllv16si_scalar */

    case E_V32SImode:
      if (pattern667 (x2, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V32HImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 32755; /* pred_vwsllv32si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32803; /* pred_vwsllv32si_scalar */

    case E_V64SImode:
      if (pattern667 (x2, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V64HImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 32756; /* pred_vwsllv64si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32804; /* pred_vwsllv64si_scalar */

    case E_V128SImode:
      if (pattern667 (x2, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V128HImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 32757; /* pred_vwsllv128si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32805; /* pred_vwsllv128si_scalar */

    case E_V256SImode:
      if (pattern667 (x2, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V256HImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 32758; /* pred_vwsllv256si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32806; /* pred_vwsllv256si_scalar */

    case E_V512SImode:
      if (pattern667 (x2, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V512HImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 32759; /* pred_vwsllv512si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32807; /* pred_vwsllv512si_scalar */

    case E_V1024SImode:
      if (pattern667 (x2, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V1024HImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 32760; /* pred_vwsllv1024si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32808; /* pred_vwsllv1024si_scalar */

    case E_V1DImode:
      if (pattern667 (x2, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V1SImode)
          && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 32761; /* pred_vwsllv1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32809; /* pred_vwsllv1di_scalar */

    case E_V2DImode:
      return recog_877 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_876 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_875 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_874 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_873 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_872 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_871 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_870 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_869 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_887 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern492 (x2))
    {
    case 0:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5505; /* pred_smaxrvvm8qi */

    case 1:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5522; /* pred_smaxrvvm4qi */

    case 2:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5539; /* pred_smaxrvvm2qi */

    case 3:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5556; /* pred_smaxrvvm1qi */

    case 4:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5573; /* pred_smaxrvvm8hi */

    case 5:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5590; /* pred_smaxrvvm4hi */

    case 6:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5607; /* pred_smaxrvvm2hi */

    case 7:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5624; /* pred_smaxrvvm1hi */

    case 8:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5641; /* pred_smaxrvvm8si */

    case 9:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5658; /* pred_smaxrvvm4si */

    case 10:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5675; /* pred_smaxrvvm2si */

    case 11:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5692; /* pred_smaxrvvm1si */

    case 12:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5709; /* pred_smaxrvvm8di */

    case 13:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5726; /* pred_smaxrvvm4di */

    case 14:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5743; /* pred_smaxrvvm2di */

    case 15:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5760; /* pred_smaxrvvm1di */

    case 16:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5777; /* pred_smaxrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5794; /* pred_smaxrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5811; /* pred_smaxrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5828; /* pred_smaxrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5845; /* pred_smaxrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5862; /* pred_smaxrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5879; /* pred_smaxv1qi */

    case 23:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5896; /* pred_smaxv2qi */

    case 24:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5913; /* pred_smaxv4qi */

    case 25:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5930; /* pred_smaxv8qi */

    case 26:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5947; /* pred_smaxv16qi */

    case 27:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5964; /* pred_smaxv32qi */

    case 28:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5981; /* pred_smaxv64qi */

    case 29:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5998; /* pred_smaxv128qi */

    case 30:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6015; /* pred_smaxv256qi */

    case 31:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6032; /* pred_smaxv512qi */

    case 32:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6049; /* pred_smaxv1024qi */

    case 33:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6066; /* pred_smaxv2048qi */

    case 34:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6083; /* pred_smaxv4096qi */

    case 35:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6100; /* pred_smaxv1hi */

    case 36:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6117; /* pred_smaxv2hi */

    case 37:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6134; /* pred_smaxv4hi */

    case 38:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6151; /* pred_smaxv8hi */

    case 39:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6168; /* pred_smaxv16hi */

    case 40:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6185; /* pred_smaxv32hi */

    case 41:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6202; /* pred_smaxv64hi */

    case 42:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6219; /* pred_smaxv128hi */

    case 43:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6236; /* pred_smaxv256hi */

    case 44:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6253; /* pred_smaxv512hi */

    case 45:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6270; /* pred_smaxv1024hi */

    case 46:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6287; /* pred_smaxv2048hi */

    case 47:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6304; /* pred_smaxv1si */

    case 48:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6321; /* pred_smaxv2si */

    case 49:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6338; /* pred_smaxv4si */

    case 50:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6355; /* pred_smaxv8si */

    case 51:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6372; /* pred_smaxv16si */

    case 52:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6389; /* pred_smaxv32si */

    case 53:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6406; /* pred_smaxv64si */

    case 54:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6423; /* pred_smaxv128si */

    case 55:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6440; /* pred_smaxv256si */

    case 56:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6457; /* pred_smaxv512si */

    case 57:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6474; /* pred_smaxv1024si */

    case 58:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6491; /* pred_smaxv1di */

    case 59:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6508; /* pred_smaxv2di */

    case 60:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6525; /* pred_smaxv4di */

    case 61:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6542; /* pred_smaxv8di */

    case 62:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6559; /* pred_smaxv16di */

    case 63:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6576; /* pred_smaxv32di */

    case 64:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6593; /* pred_smaxv64di */

    case 65:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6610; /* pred_smaxv128di */

    case 66:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6627; /* pred_smaxv256di */

    case 67:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6644; /* pred_smaxv512di */

    case 68:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14690; /* pred_smaxrvvm8hf */

    case 69:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14692; /* pred_smaxrvvm4hf */

    case 70:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14694; /* pred_smaxrvvm2hf */

    case 71:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14696; /* pred_smaxrvvm1hf */

    case 72:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14698; /* pred_smaxrvvmf2hf */

    case 73:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14700; /* pred_smaxrvvmf4hf */

    case 74:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14702; /* pred_smaxrvvm8sf */

    case 75:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14704; /* pred_smaxrvvm4sf */

    case 76:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14706; /* pred_smaxrvvm2sf */

    case 77:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14708; /* pred_smaxrvvm1sf */

    case 78:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14710; /* pred_smaxrvvmf2sf */

    case 79:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14712; /* pred_smaxrvvm8df */

    case 80:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14714; /* pred_smaxrvvm4df */

    case 81:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14716; /* pred_smaxrvvm2df */

    case 82:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14718; /* pred_smaxrvvm1df */

    case 83:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 14720; /* pred_smaxv1hf */

    case 84:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 14722; /* pred_smaxv2hf */

    case 85:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 14724; /* pred_smaxv4hf */

    case 86:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 14726; /* pred_smaxv8hf */

    case 87:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 14728; /* pred_smaxv16hf */

    case 88:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14730; /* pred_smaxv32hf */

    case 89:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14732; /* pred_smaxv64hf */

    case 90:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14734; /* pred_smaxv128hf */

    case 91:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14736; /* pred_smaxv256hf */

    case 92:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14738; /* pred_smaxv512hf */

    case 93:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14740; /* pred_smaxv1024hf */

    case 94:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14742; /* pred_smaxv2048hf */

    case 95:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14744; /* pred_smaxv1sf */

    case 96:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14746; /* pred_smaxv2sf */

    case 97:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14748; /* pred_smaxv4sf */

    case 98:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14750; /* pred_smaxv8sf */

    case 99:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14752; /* pred_smaxv16sf */

    case 100:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14754; /* pred_smaxv32sf */

    case 101:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14756; /* pred_smaxv64sf */

    case 102:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14758; /* pred_smaxv128sf */

    case 103:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14760; /* pred_smaxv256sf */

    case 104:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14762; /* pred_smaxv512sf */

    case 105:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14764; /* pred_smaxv1024sf */

    case 106:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14766; /* pred_smaxv1df */

    case 107:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14768; /* pred_smaxv2df */

    case 108:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14770; /* pred_smaxv4df */

    case 109:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14772; /* pred_smaxv8df */

    case 110:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14774; /* pred_smaxv16df */

    case 111:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14776; /* pred_smaxv32df */

    case 112:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14778; /* pred_smaxv64df */

    case 113:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14780; /* pred_smaxv128df */

    case 114:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14782; /* pred_smaxv256df */

    case 115:
      if (!(
#line 6214 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14784; /* pred_smaxv512df */

    case 116:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6861; /* pred_smaxrvvm8qi_scalar */

    case 117:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6870; /* pred_smaxrvvm4qi_scalar */

    case 118:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6879; /* pred_smaxrvvm2qi_scalar */

    case 119:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6888; /* pred_smaxrvvm1qi_scalar */

    case 120:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6897; /* pred_smaxrvvmf2qi_scalar */

    case 121:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6906; /* pred_smaxrvvmf4qi_scalar */

    case 122:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6915; /* pred_smaxrvvmf8qi_scalar */

    case 123:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6924; /* pred_smaxrvvm8hi_scalar */

    case 124:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6933; /* pred_smaxrvvm4hi_scalar */

    case 125:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6942; /* pred_smaxrvvm2hi_scalar */

    case 126:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6951; /* pred_smaxrvvm1hi_scalar */

    case 127:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6960; /* pred_smaxrvvmf2hi_scalar */

    case 128:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6969; /* pred_smaxrvvmf4hi_scalar */

    case 129:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6978; /* pred_smaxrvvm8si_scalar */

    case 130:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6987; /* pred_smaxrvvm4si_scalar */

    case 131:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6996; /* pred_smaxrvvm2si_scalar */

    case 132:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7005; /* pred_smaxrvvm1si_scalar */

    case 133:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7014; /* pred_smaxrvvmf2si_scalar */

    case 134:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7023; /* pred_smaxv1qi_scalar */

    case 135:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7032; /* pred_smaxv2qi_scalar */

    case 136:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7041; /* pred_smaxv4qi_scalar */

    case 137:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7050; /* pred_smaxv8qi_scalar */

    case 138:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7059; /* pred_smaxv16qi_scalar */

    case 139:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7068; /* pred_smaxv32qi_scalar */

    case 140:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7077; /* pred_smaxv64qi_scalar */

    case 141:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7086; /* pred_smaxv128qi_scalar */

    case 142:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7095; /* pred_smaxv256qi_scalar */

    case 143:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7104; /* pred_smaxv512qi_scalar */

    case 144:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7113; /* pred_smaxv1024qi_scalar */

    case 145:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7122; /* pred_smaxv2048qi_scalar */

    case 146:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7131; /* pred_smaxv4096qi_scalar */

    case 147:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7140; /* pred_smaxv1hi_scalar */

    case 148:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7149; /* pred_smaxv2hi_scalar */

    case 149:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7158; /* pred_smaxv4hi_scalar */

    case 150:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7167; /* pred_smaxv8hi_scalar */

    case 151:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7176; /* pred_smaxv16hi_scalar */

    case 152:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7185; /* pred_smaxv32hi_scalar */

    case 153:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7194; /* pred_smaxv64hi_scalar */

    case 154:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7203; /* pred_smaxv128hi_scalar */

    case 155:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7212; /* pred_smaxv256hi_scalar */

    case 156:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7221; /* pred_smaxv512hi_scalar */

    case 157:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7230; /* pred_smaxv1024hi_scalar */

    case 158:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7239; /* pred_smaxv2048hi_scalar */

    case 159:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7248; /* pred_smaxv1si_scalar */

    case 160:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7257; /* pred_smaxv2si_scalar */

    case 161:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7266; /* pred_smaxv4si_scalar */

    case 162:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7275; /* pred_smaxv8si_scalar */

    case 163:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7284; /* pred_smaxv16si_scalar */

    case 164:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7293; /* pred_smaxv32si_scalar */

    case 165:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7302; /* pred_smaxv64si_scalar */

    case 166:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7311; /* pred_smaxv128si_scalar */

    case 167:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7320; /* pred_smaxv256si_scalar */

    case 168:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7329; /* pred_smaxv512si_scalar */

    case 169:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7338; /* pred_smaxv1024si_scalar */

    case 170:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7671; /* *pred_smaxrvvm8di_scalar */

    case 171:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7680; /* *pred_smaxrvvm4di_scalar */

    case 172:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7689; /* *pred_smaxrvvm2di_scalar */

    case 173:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7698; /* *pred_smaxrvvm1di_scalar */

    case 174:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7707; /* *pred_smaxv1di_scalar */

    case 175:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7716; /* *pred_smaxv2di_scalar */

    case 176:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7725; /* *pred_smaxv4di_scalar */

    case 177:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7734; /* *pred_smaxv8di_scalar */

    case 178:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7743; /* *pred_smaxv16di_scalar */

    case 179:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7752; /* *pred_smaxv32di_scalar */

    case 180:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7761; /* *pred_smaxv64di_scalar */

    case 181:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7770; /* *pred_smaxv128di_scalar */

    case 182:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7779; /* *pred_smaxv256di_scalar */

    case 183:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7788; /* *pred_smaxv512di_scalar */

    case 184:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14912; /* pred_smaxrvvm8hf_scalar */

    case 185:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14914; /* pred_smaxrvvm4hf_scalar */

    case 186:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14916; /* pred_smaxrvvm2hf_scalar */

    case 187:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14918; /* pred_smaxrvvm1hf_scalar */

    case 188:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14920; /* pred_smaxrvvmf2hf_scalar */

    case 189:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14922; /* pred_smaxrvvmf4hf_scalar */

    case 190:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14924; /* pred_smaxrvvm8sf_scalar */

    case 191:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14926; /* pred_smaxrvvm4sf_scalar */

    case 192:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14928; /* pred_smaxrvvm2sf_scalar */

    case 193:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14930; /* pred_smaxrvvm1sf_scalar */

    case 194:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14932; /* pred_smaxrvvmf2sf_scalar */

    case 195:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14934; /* pred_smaxrvvm8df_scalar */

    case 196:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14936; /* pred_smaxrvvm4df_scalar */

    case 197:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14938; /* pred_smaxrvvm2df_scalar */

    case 198:
      if (!(
#line 6281 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14940; /* pred_smaxrvvm1df_scalar */

    case 199:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7797; /* *pred_smaxrvvm8di_extended_scalar */

    case 200:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7806; /* *pred_smaxrvvm4di_extended_scalar */

    case 201:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7815; /* *pred_smaxrvvm2di_extended_scalar */

    case 202:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7824; /* *pred_smaxrvvm1di_extended_scalar */

    case 203:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7833; /* *pred_smaxv1di_extended_scalar */

    case 204:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7842; /* *pred_smaxv2di_extended_scalar */

    case 205:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7851; /* *pred_smaxv4di_extended_scalar */

    case 206:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7860; /* *pred_smaxv8di_extended_scalar */

    case 207:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7869; /* *pred_smaxv16di_extended_scalar */

    case 208:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7878; /* *pred_smaxv32di_extended_scalar */

    case 209:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7887; /* *pred_smaxv64di_extended_scalar */

    case 210:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7896; /* *pred_smaxv128di_extended_scalar */

    case 211:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7905; /* *pred_smaxv256di_extended_scalar */

    case 212:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7914; /* *pred_smaxv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_900 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern498 (x2))
    {
    case 0:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5512; /* pred_modrvvm8qi */

    case 1:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5529; /* pred_modrvvm4qi */

    case 2:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5546; /* pred_modrvvm2qi */

    case 3:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5563; /* pred_modrvvm1qi */

    case 4:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5580; /* pred_modrvvm8hi */

    case 5:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5597; /* pred_modrvvm4hi */

    case 6:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5614; /* pred_modrvvm2hi */

    case 7:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5631; /* pred_modrvvm1hi */

    case 8:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5648; /* pred_modrvvm8si */

    case 9:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5665; /* pred_modrvvm4si */

    case 10:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5682; /* pred_modrvvm2si */

    case 11:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5699; /* pred_modrvvm1si */

    case 12:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5716; /* pred_modrvvm8di */

    case 13:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5733; /* pred_modrvvm4di */

    case 14:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5750; /* pred_modrvvm2di */

    case 15:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5767; /* pred_modrvvm1di */

    case 16:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5784; /* pred_modrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5801; /* pred_modrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5818; /* pred_modrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5835; /* pred_modrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5852; /* pred_modrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5869; /* pred_modrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5886; /* pred_modv1qi */

    case 23:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5903; /* pred_modv2qi */

    case 24:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5920; /* pred_modv4qi */

    case 25:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5937; /* pred_modv8qi */

    case 26:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5954; /* pred_modv16qi */

    case 27:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5971; /* pred_modv32qi */

    case 28:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5988; /* pred_modv64qi */

    case 29:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6005; /* pred_modv128qi */

    case 30:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6022; /* pred_modv256qi */

    case 31:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6039; /* pred_modv512qi */

    case 32:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6056; /* pred_modv1024qi */

    case 33:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6073; /* pred_modv2048qi */

    case 34:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6090; /* pred_modv4096qi */

    case 35:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6107; /* pred_modv1hi */

    case 36:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6124; /* pred_modv2hi */

    case 37:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6141; /* pred_modv4hi */

    case 38:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6158; /* pred_modv8hi */

    case 39:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6175; /* pred_modv16hi */

    case 40:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6192; /* pred_modv32hi */

    case 41:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6209; /* pred_modv64hi */

    case 42:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6226; /* pred_modv128hi */

    case 43:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6243; /* pred_modv256hi */

    case 44:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6260; /* pred_modv512hi */

    case 45:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6277; /* pred_modv1024hi */

    case 46:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6294; /* pred_modv2048hi */

    case 47:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6311; /* pred_modv1si */

    case 48:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6328; /* pred_modv2si */

    case 49:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6345; /* pred_modv4si */

    case 50:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6362; /* pred_modv8si */

    case 51:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6379; /* pred_modv16si */

    case 52:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6396; /* pred_modv32si */

    case 53:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6413; /* pred_modv64si */

    case 54:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6430; /* pred_modv128si */

    case 55:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6447; /* pred_modv256si */

    case 56:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6464; /* pred_modv512si */

    case 57:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6481; /* pred_modv1024si */

    case 58:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6498; /* pred_modv1di */

    case 59:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6515; /* pred_modv2di */

    case 60:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6532; /* pred_modv4di */

    case 61:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6549; /* pred_modv8di */

    case 62:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6566; /* pred_modv16di */

    case 63:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6583; /* pred_modv32di */

    case 64:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6600; /* pred_modv64di */

    case 65:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6617; /* pred_modv128di */

    case 66:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6634; /* pred_modv256di */

    case 67:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6651; /* pred_modv512di */

    case 68:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7346; /* pred_modrvvm8qi_scalar */

    case 69:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7351; /* pred_modrvvm4qi_scalar */

    case 70:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7356; /* pred_modrvvm2qi_scalar */

    case 71:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7361; /* pred_modrvvm1qi_scalar */

    case 72:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7366; /* pred_modrvvmf2qi_scalar */

    case 73:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7371; /* pred_modrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7376; /* pred_modrvvmf8qi_scalar */

    case 75:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7381; /* pred_modrvvm8hi_scalar */

    case 76:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7386; /* pred_modrvvm4hi_scalar */

    case 77:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7391; /* pred_modrvvm2hi_scalar */

    case 78:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7396; /* pred_modrvvm1hi_scalar */

    case 79:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7401; /* pred_modrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7406; /* pred_modrvvmf4hi_scalar */

    case 81:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7411; /* pred_modrvvm8si_scalar */

    case 82:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7416; /* pred_modrvvm4si_scalar */

    case 83:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7421; /* pred_modrvvm2si_scalar */

    case 84:
      if (!
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7426; /* pred_modrvvm1si_scalar */

    case 85:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7431; /* pred_modrvvmf2si_scalar */

    case 86:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7436; /* pred_modv1qi_scalar */

    case 87:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7441; /* pred_modv2qi_scalar */

    case 88:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7446; /* pred_modv4qi_scalar */

    case 89:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7451; /* pred_modv8qi_scalar */

    case 90:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7456; /* pred_modv16qi_scalar */

    case 91:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7461; /* pred_modv32qi_scalar */

    case 92:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7466; /* pred_modv64qi_scalar */

    case 93:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7471; /* pred_modv128qi_scalar */

    case 94:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7476; /* pred_modv256qi_scalar */

    case 95:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7481; /* pred_modv512qi_scalar */

    case 96:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7486; /* pred_modv1024qi_scalar */

    case 97:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7491; /* pred_modv2048qi_scalar */

    case 98:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7496; /* pred_modv4096qi_scalar */

    case 99:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7501; /* pred_modv1hi_scalar */

    case 100:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7506; /* pred_modv2hi_scalar */

    case 101:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7511; /* pred_modv4hi_scalar */

    case 102:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7516; /* pred_modv8hi_scalar */

    case 103:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7521; /* pred_modv16hi_scalar */

    case 104:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7526; /* pred_modv32hi_scalar */

    case 105:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7531; /* pred_modv64hi_scalar */

    case 106:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7536; /* pred_modv128hi_scalar */

    case 107:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7541; /* pred_modv256hi_scalar */

    case 108:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7546; /* pred_modv512hi_scalar */

    case 109:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7551; /* pred_modv1024hi_scalar */

    case 110:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7556; /* pred_modv2048hi_scalar */

    case 111:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7561; /* pred_modv1si_scalar */

    case 112:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7566; /* pred_modv2si_scalar */

    case 113:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7571; /* pred_modv4si_scalar */

    case 114:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7576; /* pred_modv8si_scalar */

    case 115:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7581; /* pred_modv16si_scalar */

    case 116:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7586; /* pred_modv32si_scalar */

    case 117:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7591; /* pred_modv64si_scalar */

    case 118:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7596; /* pred_modv128si_scalar */

    case 119:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7601; /* pred_modv256si_scalar */

    case 120:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7606; /* pred_modv512si_scalar */

    case 121:
      if (!(
#line 2802 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7611; /* pred_modv1024si_scalar */

    case 122:
      if (!(
#line 2955 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7922; /* *pred_modrvvm8di_scalar */

    case 123:
      if (!(
#line 2955 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7927; /* *pred_modrvvm4di_scalar */

    case 124:
      if (!(
#line 2955 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7932; /* *pred_modrvvm2di_scalar */

    case 125:
      if (!(
#line 2955 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7937; /* *pred_modrvvm1di_scalar */

    case 126:
      if (!(
#line 2955 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7942; /* *pred_modv1di_scalar */

    case 127:
      if (!(
#line 2955 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7947; /* *pred_modv2di_scalar */

    case 128:
      if (!(
#line 2955 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7952; /* *pred_modv4di_scalar */

    case 129:
      if (!(
#line 2955 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7957; /* *pred_modv8di_scalar */

    case 130:
      if (!(
#line 2955 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7962; /* *pred_modv16di_scalar */

    case 131:
      if (!(
#line 2955 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7967; /* *pred_modv32di_scalar */

    case 132:
      if (!(
#line 2955 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7972; /* *pred_modv64di_scalar */

    case 133:
      if (!(
#line 2955 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7977; /* *pred_modv128di_scalar */

    case 134:
      if (!(
#line 2955 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7982; /* *pred_modv256di_scalar */

    case 135:
      if (!(
#line 2955 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7987; /* *pred_modv512di_scalar */

    case 136:
      if (!(
#line 2977 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7992; /* *pred_modrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2977 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7997; /* *pred_modrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2977 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8002; /* *pred_modrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2977 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8007; /* *pred_modrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2977 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8012; /* *pred_modv1di_extended_scalar */

    case 141:
      if (!(
#line 2977 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8017; /* *pred_modv2di_extended_scalar */

    case 142:
      if (!(
#line 2977 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8022; /* *pred_modv4di_extended_scalar */

    case 143:
      if (!(
#line 2977 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8027; /* *pred_modv8di_extended_scalar */

    case 144:
      if (!(
#line 2977 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8032; /* *pred_modv16di_extended_scalar */

    case 145:
      if (!(
#line 2977 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8037; /* *pred_modv32di_extended_scalar */

    case 146:
      if (!(
#line 2977 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8042; /* *pred_modv64di_extended_scalar */

    case 147:
      if (!(
#line 2977 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8047; /* *pred_modv128di_extended_scalar */

    case 148:
      if (!(
#line 2977 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8052; /* *pred_modv256di_extended_scalar */

    case 149:
      if (!(
#line 2977 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8057; /* *pred_modv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_910 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern502 (x2))
    {
    case 0:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17375; /* pred_fix_truncrvvm8hf */

    case 1:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17377; /* pred_fix_truncrvvm4hf */

    case 2:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17921; /* pred_narrow_fix_truncrvvm8sf */

    case 3:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17379; /* pred_fix_truncrvvm2hf */

    case 4:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17923; /* pred_narrow_fix_truncrvvm4sf */

    case 5:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17381; /* pred_fix_truncrvvm1hf */

    case 6:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17925; /* pred_narrow_fix_truncrvvm2sf */

    case 7:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17383; /* pred_fix_truncrvvmf2hf */

    case 8:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17927; /* pred_narrow_fix_truncrvvm1sf */

    case 9:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17385; /* pred_fix_truncrvvmf4hf */

    case 10:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17929; /* pred_narrow_fix_truncrvvmf2sf */

    case 11:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17387; /* pred_fix_truncrvvm8sf */

    case 12:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17627; /* pred_widen_fix_truncrvvm8si */

    case 13:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17389; /* pred_fix_truncrvvm4sf */

    case 14:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17629; /* pred_widen_fix_truncrvvm4si */

    case 15:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17931; /* pred_narrow_fix_truncrvvm8df */

    case 16:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17391; /* pred_fix_truncrvvm2sf */

    case 17:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17631; /* pred_widen_fix_truncrvvm2si */

    case 18:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17933; /* pred_narrow_fix_truncrvvm4df */

    case 19:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17393; /* pred_fix_truncrvvm1sf */

    case 20:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17633; /* pred_widen_fix_truncrvvm1si */

    case 21:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17935; /* pred_narrow_fix_truncrvvm2df */

    case 22:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17395; /* pred_fix_truncrvvmf2sf */

    case 23:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17635; /* pred_widen_fix_truncrvvmf2si */

    case 24:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17937; /* pred_narrow_fix_truncrvvm1df */

    case 25:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17397; /* pred_fix_truncrvvm8df */

    case 26:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17637; /* pred_widen_fix_truncrvvm8di */

    case 27:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17399; /* pred_fix_truncrvvm4df */

    case 28:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17639; /* pred_widen_fix_truncrvvm4di */

    case 29:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17401; /* pred_fix_truncrvvm2df */

    case 30:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17641; /* pred_widen_fix_truncrvvm2di */

    case 31:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17403; /* pred_fix_truncrvvm1df */

    case 32:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17643; /* pred_widen_fix_truncrvvm1di */

    case 33:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17405; /* pred_fix_truncv1hf */

    case 34:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17963; /* pred_narrow_fix_truncv1sf */

    case 35:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17407; /* pred_fix_truncv2hf */

    case 36:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17965; /* pred_narrow_fix_truncv2sf */

    case 37:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17409; /* pred_fix_truncv4hf */

    case 38:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17967; /* pred_narrow_fix_truncv4sf */

    case 39:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17411; /* pred_fix_truncv8hf */

    case 40:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17969; /* pred_narrow_fix_truncv8sf */

    case 41:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17413; /* pred_fix_truncv16hf */

    case 42:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17971; /* pred_narrow_fix_truncv16sf */

    case 43:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17415; /* pred_fix_truncv32hf */

    case 44:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17973; /* pred_narrow_fix_truncv32sf */

    case 45:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17417; /* pred_fix_truncv64hf */

    case 46:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17975; /* pred_narrow_fix_truncv64sf */

    case 47:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17419; /* pred_fix_truncv128hf */

    case 48:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17977; /* pred_narrow_fix_truncv128sf */

    case 49:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17421; /* pred_fix_truncv256hf */

    case 50:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17979; /* pred_narrow_fix_truncv256sf */

    case 51:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17423; /* pred_fix_truncv512hf */

    case 52:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17981; /* pred_narrow_fix_truncv512sf */

    case 53:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17425; /* pred_fix_truncv1024hf */

    case 54:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17983; /* pred_narrow_fix_truncv1024sf */

    case 55:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17427; /* pred_fix_truncv2048hf */

    case 56:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17429; /* pred_fix_truncv1sf */

    case 57:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 17645; /* pred_widen_fix_truncv1si */

    case 58:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17985; /* pred_narrow_fix_truncv1df */

    case 59:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17431; /* pred_fix_truncv2sf */

    case 60:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 17647; /* pred_widen_fix_truncv2si */

    case 61:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17987; /* pred_narrow_fix_truncv2df */

    case 62:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17433; /* pred_fix_truncv4sf */

    case 63:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 17649; /* pred_widen_fix_truncv4si */

    case 64:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17989; /* pred_narrow_fix_truncv4df */

    case 65:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17435; /* pred_fix_truncv8sf */

    case 66:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 17651; /* pred_widen_fix_truncv8si */

    case 67:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17991; /* pred_narrow_fix_truncv8df */

    case 68:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17437; /* pred_fix_truncv16sf */

    case 69:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17653; /* pred_widen_fix_truncv16si */

    case 70:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17993; /* pred_narrow_fix_truncv16df */

    case 71:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17439; /* pred_fix_truncv32sf */

    case 72:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17655; /* pred_widen_fix_truncv32si */

    case 73:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17995; /* pred_narrow_fix_truncv32df */

    case 74:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17441; /* pred_fix_truncv64sf */

    case 75:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17657; /* pred_widen_fix_truncv64si */

    case 76:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17997; /* pred_narrow_fix_truncv64df */

    case 77:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17443; /* pred_fix_truncv128sf */

    case 78:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1071 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17659; /* pred_widen_fix_truncv128si */

    case 79:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17999; /* pred_narrow_fix_truncv128df */

    case 80:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17445; /* pred_fix_truncv256sf */

    case 81:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1072 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17661; /* pred_widen_fix_truncv256si */

    case 82:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 18001; /* pred_narrow_fix_truncv256df */

    case 83:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17447; /* pred_fix_truncv512sf */

    case 84:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1073 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17663; /* pred_widen_fix_truncv512si */

    case 85:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 18003; /* pred_narrow_fix_truncv512df */

    case 86:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17449; /* pred_fix_truncv1024sf */

    case 87:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1074 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17665; /* pred_widen_fix_truncv1024si */

    case 88:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17451; /* pred_fix_truncv1df */

    case 89:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1075 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17667; /* pred_widen_fix_truncv1di */

    case 90:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17453; /* pred_fix_truncv2df */

    case 91:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1076 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17669; /* pred_widen_fix_truncv2di */

    case 92:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17455; /* pred_fix_truncv4df */

    case 93:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1077 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17671; /* pred_widen_fix_truncv4di */

    case 94:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17457; /* pred_fix_truncv8df */

    case 95:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1078 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17673; /* pred_widen_fix_truncv8di */

    case 96:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17459; /* pred_fix_truncv16df */

    case 97:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1079 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17675; /* pred_widen_fix_truncv16di */

    case 98:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17461; /* pred_fix_truncv32df */

    case 99:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1080 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17677; /* pred_widen_fix_truncv32di */

    case 100:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17463; /* pred_fix_truncv64df */

    case 101:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1081 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17679; /* pred_widen_fix_truncv64di */

    case 102:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17465; /* pred_fix_truncv128df */

    case 103:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1082 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17681; /* pred_widen_fix_truncv128di */

    case 104:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17467; /* pred_fix_truncv256df */

    case 105:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1083 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17683; /* pred_widen_fix_truncv256di */

    case 106:
      if (!(
#line 7507 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17469; /* pred_fix_truncv512df */

    case 107:
      if (!(
#line 7579 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1084 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17685; /* pred_widen_fix_truncv512di */

    case 108:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17909; /* pred_narrow_fix_truncrvvm8hf */

    case 109:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17911; /* pred_narrow_fix_truncrvvm4hf */

    case 110:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17913; /* pred_narrow_fix_truncrvvm2hf */

    case 111:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17915; /* pred_narrow_fix_truncrvvm1hf */

    case 112:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17917; /* pred_narrow_fix_truncrvvmf2hf */

    case 113:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17919; /* pred_narrow_fix_truncrvvmf4hf */

    case 114:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17939; /* pred_narrow_fix_truncv1hf */

    case 115:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17941; /* pred_narrow_fix_truncv2hf */

    case 116:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17943; /* pred_narrow_fix_truncv4hf */

    case 117:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17945; /* pred_narrow_fix_truncv8hf */

    case 118:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17947; /* pred_narrow_fix_truncv16hf */

    case 119:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17949; /* pred_narrow_fix_truncv32hf */

    case 120:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17951; /* pred_narrow_fix_truncv64hf */

    case 121:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17953; /* pred_narrow_fix_truncv128hf */

    case 122:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17955; /* pred_narrow_fix_truncv256hf */

    case 123:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17957; /* pred_narrow_fix_truncv512hf */

    case 124:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17959; /* pred_narrow_fix_truncv1024hf */

    case 125:
      if (!(
#line 7667 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17961; /* pred_narrow_fix_truncv2048hf */

    default:
      return -1;
    }
}

 int
recog_926 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern473 (x2, 
189))
    {
    case 0:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2216; /* pred_indexed_load_widthwurvvm8qi */

    case 1:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2222; /* pred_indexed_load_widthwurvvm4qi */

    case 2:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2228; /* pred_indexed_load_widthwurvvm2qi */

    case 3:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2234; /* pred_indexed_load_widthwurvvm1qi */

    case 4:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2240; /* pred_indexed_load_widthwurvvm8hi */

    case 5:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2246; /* pred_indexed_load_widthwurvvm4hi */

    case 6:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2252; /* pred_indexed_load_widthwurvvm2hi */

    case 7:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2258; /* pred_indexed_load_widthwurvvm1hi */

    case 8:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2264; /* pred_indexed_load_widthwurvvm8si */

    case 9:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2270; /* pred_indexed_load_widthwurvvm4si */

    case 10:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2276; /* pred_indexed_load_widthwurvvm2si */

    case 11:
      if (!
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2282; /* pred_indexed_load_widthwurvvm1si */

    case 12:
      if (!(
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2288; /* pred_indexed_load_widthwurvvm8di */

    case 13:
      if (!(
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2294; /* pred_indexed_load_widthwurvvm4di */

    case 14:
      if (!(
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2300; /* pred_indexed_load_widthwurvvm2di */

    case 15:
      if (!(
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2306; /* pred_indexed_load_widthwurvvm1di */

    case 16:
      if (!(
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2312; /* pred_indexed_load_widthwurvvmf8qi */

    case 17:
      if (!(
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2318; /* pred_indexed_load_widthwurvvmf4hi */

    case 18:
      if (!(
#line 310 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2324; /* pred_indexed_load_widthwurvvmf2si */

    default:
      return -1;
    }
}

 int
recog_929 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern717 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11409; /* pred_smulrvvm8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11885; /* pred_smulrvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11416; /* pred_smulrvvm4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11890; /* pred_smulrvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11423; /* pred_smulrvvm2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11895; /* pred_smulrvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11430; /* pred_smulrvvm1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11900; /* pred_smulrvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11437; /* pred_smulrvvm8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11920; /* pred_smulrvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11444; /* pred_smulrvvm4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11925; /* pred_smulrvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11451; /* pred_smulrvvm2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11930; /* pred_smulrvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11458; /* pred_smulrvvm1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11935; /* pred_smulrvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11465; /* pred_smulrvvm8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11950; /* pred_smulrvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11472; /* pred_smulrvvm4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11955; /* pred_smulrvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11479; /* pred_smulrvvm2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11960; /* pred_smulrvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11486; /* pred_smulrvvm1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11965; /* pred_smulrvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11493; /* pred_smulrvvm8di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4646 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12199; /* *pred_smulrvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11500; /* pred_smulrvvm4di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4646 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12204; /* *pred_smulrvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11507; /* pred_smulrvvm2di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4646 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12209; /* *pred_smulrvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11514; /* pred_smulrvvm1di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4646 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12214; /* *pred_smulrvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11521; /* pred_smulrvvmf2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11905; /* pred_smulrvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11528; /* pred_smulrvvmf4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11910; /* pred_smulrvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11535; /* pred_smulrvvmf8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11915; /* pred_smulrvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11542; /* pred_smulrvvmf2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11940; /* pred_smulrvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11549; /* pred_smulrvvmf4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11945; /* pred_smulrvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11556; /* pred_smulrvvmf2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11970; /* pred_smulrvvmf2si_scalar */

    case 22:
      if (register_operand (operands[4], E_V1QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 11563; /* pred_smulv1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11975; /* pred_smulv1qi_scalar */

    case 23:
      if (register_operand (operands[4], E_V2QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 11570; /* pred_smulv2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11980; /* pred_smulv2qi_scalar */

    case 24:
      if (register_operand (operands[4], E_V4QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 11577; /* pred_smulv4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11985; /* pred_smulv4qi_scalar */

    case 25:
      if (register_operand (operands[4], E_V8QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 11584; /* pred_smulv8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11990; /* pred_smulv8qi_scalar */

    case 26:
      if (register_operand (operands[4], E_V16QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 11591; /* pred_smulv16qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11995; /* pred_smulv16qi_scalar */

    case 27:
      if (register_operand (operands[4], E_V32QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 11598; /* pred_smulv32qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12000; /* pred_smulv32qi_scalar */

    case 28:
      if (register_operand (operands[4], E_V64QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 11605; /* pred_smulv64qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12005; /* pred_smulv64qi_scalar */

    case 29:
      if (register_operand (operands[4], E_V128QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 11612; /* pred_smulv128qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12010; /* pred_smulv128qi_scalar */

    case 30:
      if (register_operand (operands[4], E_V256QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 11619; /* pred_smulv256qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12015; /* pred_smulv256qi_scalar */

    case 31:
      if (register_operand (operands[4], E_V512QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 11626; /* pred_smulv512qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12020; /* pred_smulv512qi_scalar */

    case 32:
      if (register_operand (operands[4], E_V1024QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 11633; /* pred_smulv1024qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12025; /* pred_smulv1024qi_scalar */

    case 33:
      if (register_operand (operands[4], E_V2048QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 11640; /* pred_smulv2048qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12030; /* pred_smulv2048qi_scalar */

    case 34:
      if (register_operand (operands[4], E_V4096QImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 11647; /* pred_smulv4096qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12035; /* pred_smulv4096qi_scalar */

    case 35:
      if (register_operand (operands[4], E_V1HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 11654; /* pred_smulv1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12040; /* pred_smulv1hi_scalar */

    case 36:
      if (register_operand (operands[4], E_V2HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 11661; /* pred_smulv2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12045; /* pred_smulv2hi_scalar */

    case 37:
      if (register_operand (operands[4], E_V4HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 11668; /* pred_smulv4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12050; /* pred_smulv4hi_scalar */

    case 38:
      if (register_operand (operands[4], E_V8HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 11675; /* pred_smulv8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12055; /* pred_smulv8hi_scalar */

    case 39:
      if (register_operand (operands[4], E_V16HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 11682; /* pred_smulv16hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12060; /* pred_smulv16hi_scalar */

    case 40:
      if (register_operand (operands[4], E_V32HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 11689; /* pred_smulv32hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12065; /* pred_smulv32hi_scalar */

    case 41:
      if (register_operand (operands[4], E_V64HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 11696; /* pred_smulv64hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12070; /* pred_smulv64hi_scalar */

    case 42:
      if (register_operand (operands[4], E_V128HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 11703; /* pred_smulv128hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12075; /* pred_smulv128hi_scalar */

    case 43:
      if (register_operand (operands[4], E_V256HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 11710; /* pred_smulv256hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12080; /* pred_smulv256hi_scalar */

    case 44:
      if (register_operand (operands[4], E_V512HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 11717; /* pred_smulv512hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12085; /* pred_smulv512hi_scalar */

    case 45:
      if (register_operand (operands[4], E_V1024HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 11724; /* pred_smulv1024hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12090; /* pred_smulv1024hi_scalar */

    case 46:
      if (register_operand (operands[4], E_V2048HImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 11731; /* pred_smulv2048hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12095; /* pred_smulv2048hi_scalar */

    case 47:
      if (register_operand (operands[4], E_V1SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 11738; /* pred_smulv1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12100; /* pred_smulv1si_scalar */

    case 48:
      if (register_operand (operands[4], E_V2SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 11745; /* pred_smulv2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12105; /* pred_smulv2si_scalar */

    case 49:
      if (register_operand (operands[4], E_V4SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 11752; /* pred_smulv4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12110; /* pred_smulv4si_scalar */

    case 50:
      if (register_operand (operands[4], E_V8SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 11759; /* pred_smulv8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12115; /* pred_smulv8si_scalar */

    case 51:
      if (register_operand (operands[4], E_V16SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 11766; /* pred_smulv16si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12120; /* pred_smulv16si_scalar */

    case 52:
      if (register_operand (operands[4], E_V32SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 11773; /* pred_smulv32si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12125; /* pred_smulv32si_scalar */

    case 53:
      if (register_operand (operands[4], E_V64SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 11780; /* pred_smulv64si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12130; /* pred_smulv64si_scalar */

    case 54:
      if (register_operand (operands[4], E_V128SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 11787; /* pred_smulv128si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12135; /* pred_smulv128si_scalar */

    case 55:
      if (register_operand (operands[4], E_V256SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 11794; /* pred_smulv256si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12140; /* pred_smulv256si_scalar */

    case 56:
      if (register_operand (operands[4], E_V512SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 11801; /* pred_smulv512si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12145; /* pred_smulv512si_scalar */

    case 57:
      if (register_operand (operands[4], E_V1024SImode)
          && (
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 11808; /* pred_smulv1024si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4566 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12150; /* pred_smulv1024si_scalar */

    case 58:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11815; /* pred_smulv1di */

    case 59:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11822; /* pred_smulv2di */

    case 60:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11829; /* pred_smulv4di */

    case 61:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11836; /* pred_smulv8di */

    case 62:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11843; /* pred_smulv16di */

    case 63:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11850; /* pred_smulv32di */

    case 64:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11857; /* pred_smulv64di */

    case 65:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11864; /* pred_smulv128di */

    case 66:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11871; /* pred_smulv256di */

    case 67:
      if (!(
#line 4543 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11878; /* pred_smulv512di */

    case 68:
      if (!(
#line 4669 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12219; /* *pred_smulrvvm8di_extended_scalar */

    case 69:
      if (!(
#line 4669 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12224; /* *pred_smulrvvm4di_extended_scalar */

    case 70:
      if (!(
#line 4669 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12229; /* *pred_smulrvvm2di_extended_scalar */

    case 71:
      if (!(
#line 4669 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12234; /* *pred_smulrvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_934 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern719 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[4], E_RVVM4QImode)
          && 
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12235; /* pred_narrow_cliprvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12331; /* pred_narrow_cliprvvm8hi_scalar */

    case 1:
      if (vector_shift_operand (operands[4], E_RVVM2QImode)
          && 
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12237; /* pred_narrow_cliprvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12333; /* pred_narrow_cliprvvm4hi_scalar */

    case 2:
      if (vector_shift_operand (operands[4], E_RVVM1QImode)
          && 
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12239; /* pred_narrow_cliprvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12335; /* pred_narrow_cliprvvm2hi_scalar */

    case 3:
      if (vector_shift_operand (operands[4], E_RVVMF2QImode)
          && 
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12241; /* pred_narrow_cliprvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12337; /* pred_narrow_cliprvvm1hi_scalar */

    case 4:
      if (vector_shift_operand (operands[4], E_RVVMF4QImode)
          && 
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12243; /* pred_narrow_cliprvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12339; /* pred_narrow_cliprvvmf2hi_scalar */

    case 5:
      if (vector_shift_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 12245; /* pred_narrow_cliprvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 12341; /* pred_narrow_cliprvvmf4hi_scalar */

    case 6:
      if (vector_shift_operand (operands[4], E_RVVM4HImode)
          && 
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12247; /* pred_narrow_cliprvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12343; /* pred_narrow_cliprvvm8si_scalar */

    case 7:
      if (vector_shift_operand (operands[4], E_RVVM2HImode)
          && 
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12249; /* pred_narrow_cliprvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12345; /* pred_narrow_cliprvvm4si_scalar */

    case 8:
      if (vector_shift_operand (operands[4], E_RVVM1HImode)
          && 
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12251; /* pred_narrow_cliprvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12347; /* pred_narrow_cliprvvm2si_scalar */

    case 9:
      if (vector_shift_operand (operands[4], E_RVVMF2HImode)
          && 
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12253; /* pred_narrow_cliprvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12349; /* pred_narrow_cliprvvm1si_scalar */

    case 10:
      if (vector_shift_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 12255; /* pred_narrow_cliprvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 12351; /* pred_narrow_cliprvvmf2si_scalar */

    case 11:
      if (vector_shift_operand (operands[4], E_RVVM4SImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12257; /* pred_narrow_cliprvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12353; /* pred_narrow_cliprvvm8di_scalar */

    case 12:
      if (vector_shift_operand (operands[4], E_RVVM2SImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12259; /* pred_narrow_cliprvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12355; /* pred_narrow_cliprvvm4di_scalar */

    case 13:
      if (vector_shift_operand (operands[4], E_RVVM1SImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12261; /* pred_narrow_cliprvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12357; /* pred_narrow_cliprvvm2di_scalar */

    case 14:
      if (vector_shift_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12263; /* pred_narrow_cliprvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12359; /* pred_narrow_cliprvvm1di_scalar */

    case 15:
      if (vector_shift_operand (operands[4], E_V1QImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 12265; /* pred_narrow_clipv1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12361; /* pred_narrow_clipv1hi_scalar */

    case 16:
      if (vector_shift_operand (operands[4], E_V2QImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 12267; /* pred_narrow_clipv2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12363; /* pred_narrow_clipv2hi_scalar */

    case 17:
      if (vector_shift_operand (operands[4], E_V4QImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12269; /* pred_narrow_clipv4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12365; /* pred_narrow_clipv4hi_scalar */

    case 18:
      if (vector_shift_operand (operands[4], E_V8QImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12271; /* pred_narrow_clipv8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12367; /* pred_narrow_clipv8hi_scalar */

    case 19:
      if (vector_shift_operand (operands[4], E_V16QImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 12273; /* pred_narrow_clipv16hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12369; /* pred_narrow_clipv16hi_scalar */

    case 20:
      if (vector_shift_operand (operands[4], E_V32QImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 12275; /* pred_narrow_clipv32hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12371; /* pred_narrow_clipv32hi_scalar */

    case 21:
      if (vector_shift_operand (operands[4], E_V64QImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 12277; /* pred_narrow_clipv64hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12373; /* pred_narrow_clipv64hi_scalar */

    case 22:
      if (vector_shift_operand (operands[4], E_V128QImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 12279; /* pred_narrow_clipv128hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12375; /* pred_narrow_clipv128hi_scalar */

    case 23:
      if (vector_shift_operand (operands[4], E_V256QImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 12281; /* pred_narrow_clipv256hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12377; /* pred_narrow_clipv256hi_scalar */

    case 24:
      if (vector_shift_operand (operands[4], E_V512QImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12283; /* pred_narrow_clipv512hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12379; /* pred_narrow_clipv512hi_scalar */

    case 25:
      if (vector_shift_operand (operands[4], E_V1024QImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 12285; /* pred_narrow_clipv1024hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12381; /* pred_narrow_clipv1024hi_scalar */

    case 26:
      if (vector_shift_operand (operands[4], E_V2048QImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 12287; /* pred_narrow_clipv2048hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12383; /* pred_narrow_clipv2048hi_scalar */

    case 27:
      if (vector_shift_operand (operands[4], E_V1HImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 12289; /* pred_narrow_clipv1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12385; /* pred_narrow_clipv1si_scalar */

    case 28:
      if (vector_shift_operand (operands[4], E_V2HImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 12291; /* pred_narrow_clipv2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12387; /* pred_narrow_clipv2si_scalar */

    case 29:
      if (vector_shift_operand (operands[4], E_V4HImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12293; /* pred_narrow_clipv4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12389; /* pred_narrow_clipv4si_scalar */

    case 30:
      if (vector_shift_operand (operands[4], E_V8HImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12295; /* pred_narrow_clipv8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12391; /* pred_narrow_clipv8si_scalar */

    case 31:
      if (vector_shift_operand (operands[4], E_V16HImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 12297; /* pred_narrow_clipv16si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12393; /* pred_narrow_clipv16si_scalar */

    case 32:
      if (vector_shift_operand (operands[4], E_V32HImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 12299; /* pred_narrow_clipv32si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12395; /* pred_narrow_clipv32si_scalar */

    case 33:
      if (vector_shift_operand (operands[4], E_V64HImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 12301; /* pred_narrow_clipv64si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12397; /* pred_narrow_clipv64si_scalar */

    case 34:
      if (vector_shift_operand (operands[4], E_V128HImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 12303; /* pred_narrow_clipv128si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12399; /* pred_narrow_clipv128si_scalar */

    case 35:
      if (vector_shift_operand (operands[4], E_V256HImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 12305; /* pred_narrow_clipv256si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12401; /* pred_narrow_clipv256si_scalar */

    case 36:
      if (vector_shift_operand (operands[4], E_V512HImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12307; /* pred_narrow_clipv512si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12403; /* pred_narrow_clipv512si_scalar */

    case 37:
      if (vector_shift_operand (operands[4], E_V1024HImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 12309; /* pred_narrow_clipv1024si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12405; /* pred_narrow_clipv1024si_scalar */

    case 38:
      if (vector_shift_operand (operands[4], E_V1SImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 12311; /* pred_narrow_clipv1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12407; /* pred_narrow_clipv1di_scalar */

    case 39:
      if (vector_shift_operand (operands[4], E_V2SImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 12313; /* pred_narrow_clipv2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12409; /* pred_narrow_clipv2di_scalar */

    case 40:
      if (vector_shift_operand (operands[4], E_V4SImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 12315; /* pred_narrow_clipv4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12411; /* pred_narrow_clipv4di_scalar */

    case 41:
      if (vector_shift_operand (operands[4], E_V8SImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 12317; /* pred_narrow_clipv8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12413; /* pred_narrow_clipv8di_scalar */

    case 42:
      if (vector_shift_operand (operands[4], E_V16SImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 12319; /* pred_narrow_clipv16di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12415; /* pred_narrow_clipv16di_scalar */

    case 43:
      if (vector_shift_operand (operands[4], E_V32SImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 12321; /* pred_narrow_clipv32di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12417; /* pred_narrow_clipv32di_scalar */

    case 44:
      if (vector_shift_operand (operands[4], E_V64SImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 12323; /* pred_narrow_clipv64di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12419; /* pred_narrow_clipv64di_scalar */

    case 45:
      if (vector_shift_operand (operands[4], E_V128SImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 12325; /* pred_narrow_clipv128di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12421; /* pred_narrow_clipv128di_scalar */

    case 46:
      if (vector_shift_operand (operands[4], E_V256SImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 12327; /* pred_narrow_clipv256di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12423; /* pred_narrow_clipv256di_scalar */

    case 47:
      if (vector_shift_operand (operands[4], E_V512SImode)
          && (
#line 4692 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 12329; /* pred_narrow_clipv512di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4715 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12425; /* pred_narrow_clipv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_1043 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8HFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15734; /* *pred_mul_neg_addrvvm8hf_undef */
}

 int
recog_1051 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2SFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15750; /* *pred_mul_neg_addrvvm2sf_undef */
}

 int
recog_1059 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2HFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15766; /* *pred_mul_neg_addv2hf_undef */
}

 int
recog_1068 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1024HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1024HFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15784; /* *pred_mul_neg_addv1024hf_undef */
}

 int
recog_1078 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V256SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V256SFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15804; /* *pred_mul_neg_addv256sf_undef */
}

 int
recog_1088 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128DFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15824; /* *pred_mul_neg_addv128df_undef */
}

 int
recog_1098 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1083 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15910; /* *pred_nmsubv4df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 16006; /* *pred_nmsacv4df */
}

 int
recog_1108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1073 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15890; /* *pred_nmsubv8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15986; /* *pred_nmsacv8sf */
}

 int
recog_1118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1063 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V32HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V32HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return 15870; /* *pred_nmsubv32hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15966; /* *pred_nmsacv32hf */
}

 int
recog_1128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1053 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return 15850; /* *pred_nmsubrvvmf2sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15946; /* *pred_nmsacrvvmf2sf */
}

 int
recog_1138 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1043 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15830; /* *pred_nmsubrvvm8hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15926; /* *pred_nmsacrvvm8hf */
}

 int
recog_1148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8SFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15267; /* *pred_mul_subrvvm8sf_undef */
}

 int
recog_1155 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM2DFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15281; /* *pred_mul_subrvvm2df_undef */
}

 int
recog_1162 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V32HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V32HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V32HFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15295; /* *pred_mul_subv32hf_undef */
}

 int
recog_1169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1SFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15309; /* *pred_mul_subv1sf_undef */
}

 int
recog_1176 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V128SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V128SFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15323; /* *pred_mul_subv128sf_undef */
}

 int
recog_1183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V8DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V8DFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15337; /* *pred_mul_subv8df_undef */
}

 int
recog_1190 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1189 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return 15445; /* *pred_msubv512df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15541; /* *pred_msacv512df */
}

 int
recog_1197 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1182 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15431; /* *pred_msubv4df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15527; /* *pred_msacv4df */
}

 int
recog_1204 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1175 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 15417; /* *pred_msubv64sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15513; /* *pred_msacv64sf */
}

 int
recog_1211 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1168 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2048HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return 15403; /* *pred_msubv2048hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15499; /* *pred_msacv2048hf */
}

 int
recog_1218 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1161 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return 15389; /* *pred_msubv16hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15485; /* *pred_msacv16hf */
}

 int
recog_1225 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1154 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15375; /* *pred_msubrvvm4df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15471; /* *pred_msacrvvm4df */
}

 int
recog_1232 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1147 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF4HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return 15361; /* *pred_msubrvvmf4hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15457; /* *pred_msacrvvmf4hf */
}

 int
recog_1239 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM4HFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15737; /* *pred_mul_neg_subrvvm4hf_undef */
}

 int
recog_1246 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2SFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15751; /* *pred_mul_neg_subrvvm2sf_undef */
}

 int
recog_1253 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1HFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15765; /* *pred_mul_neg_subv1hf_undef */
}

 int
recog_1260 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128HFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15779; /* *pred_mul_neg_subv128hf_undef */
}

 int
recog_1267 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4SFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15793; /* *pred_mul_neg_subv4sf_undef */
}

 int
recog_1274 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512SFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15807; /* *pred_mul_neg_subv512sf_undef */
}

 int
recog_1281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V32DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V32DFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15821; /* *pred_mul_neg_subv32df_undef */
}

 int
recog_1288 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1283 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return 15921; /* *pred_nmaddv128df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 16017; /* *pred_nmaccv128df */
}

 int
recog_1295 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1276 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15907; /* *pred_nmaddv1df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 16003; /* *pred_nmaccv1df */
}

 int
recog_1302 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1269 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V16SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 15893; /* *pred_nmaddv16sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15989; /* *pred_nmaccv16sf */
}

 int
recog_1309 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1262 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return 15879; /* *pred_nmaddv512hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15975; /* *pred_nmaccv512hf */
}

 int
recog_1317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1254 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return 15863; /* *pred_nmaddv2hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15959; /* *pred_nmaccv2hf */
}

 int
recog_1325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1246 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM2SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15847; /* *pred_nmaddrvvm2sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15943; /* *pred_nmaccrvvm2sf */
}

 int
recog_1333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1238 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15831; /* *pred_nmaddrvvm8hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15927; /* *pred_nmaccrvvm8hf */
}

 int
recog_1341 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[9] = x8;
  x9 = XEXP (x2, 2);
  operands[2] = x9;
  x10 = XEXP (x2, 1);
  x11 = XEXP (x10, 0);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      operands[3] = x11;
      x12 = XEXP (x10, 1);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          switch (pattern708 (x2))
            {
            case 0:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14501; /* pred_divrvvm8hf */

            case 1:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14505; /* pred_divrvvm4hf */

            case 2:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14509; /* pred_divrvvm2hf */

            case 3:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14513; /* pred_divrvvm1hf */

            case 4:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14517; /* pred_divrvvmf2hf */

            case 5:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14521; /* pred_divrvvmf4hf */

            case 6:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14525; /* pred_divrvvm8sf */

            case 7:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14529; /* pred_divrvvm4sf */

            case 8:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14533; /* pred_divrvvm2sf */

            case 9:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14537; /* pred_divrvvm1sf */

            case 10:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14541; /* pred_divrvvmf2sf */

            case 11:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14545; /* pred_divrvvm8df */

            case 12:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14549; /* pred_divrvvm4df */

            case 13:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14553; /* pred_divrvvm2df */

            case 14:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14557; /* pred_divrvvm1df */

            case 15:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                return -1;
              return 14561; /* pred_divv1hf */

            case 16:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                return -1;
              return 14565; /* pred_divv2hf */

            case 17:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                return -1;
              return 14569; /* pred_divv4hf */

            case 18:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                return -1;
              return 14573; /* pred_divv8hf */

            case 19:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                return -1;
              return 14577; /* pred_divv16hf */

            case 20:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14581; /* pred_divv32hf */

            case 21:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14585; /* pred_divv64hf */

            case 22:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14589; /* pred_divv128hf */

            case 23:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14593; /* pred_divv256hf */

            case 24:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14597; /* pred_divv512hf */

            case 25:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14601; /* pred_divv1024hf */

            case 26:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14605; /* pred_divv2048hf */

            case 27:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14609; /* pred_divv1sf */

            case 28:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14613; /* pred_divv2sf */

            case 29:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14617; /* pred_divv4sf */

            case 30:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14621; /* pred_divv8sf */

            case 31:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14625; /* pred_divv16sf */

            case 32:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14629; /* pred_divv32sf */

            case 33:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14633; /* pred_divv64sf */

            case 34:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14637; /* pred_divv128sf */

            case 35:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14641; /* pred_divv256sf */

            case 36:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14645; /* pred_divv512sf */

            case 37:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14649; /* pred_divv1024sf */

            case 38:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14653; /* pred_divv1df */

            case 39:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14657; /* pred_divv2df */

            case 40:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14661; /* pred_divv4df */

            case 41:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14665; /* pred_divv8df */

            case 42:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14669; /* pred_divv16df */

            case 43:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14673; /* pred_divv32df */

            case 44:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14677; /* pred_divv64df */

            case 45:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14681; /* pred_divv128df */

            case 46:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14685; /* pred_divv256df */

            case 47:
              if (!(
#line 6192 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14689; /* pred_divv512df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          switch (pattern723 (x2))
            {
            case 0:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14973; /* pred_divrvvm8hf_scalar */

            case 1:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14975; /* pred_divrvvm4hf_scalar */

            case 2:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14977; /* pred_divrvvm2hf_scalar */

            case 3:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14979; /* pred_divrvvm1hf_scalar */

            case 4:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14981; /* pred_divrvvmf2hf_scalar */

            case 5:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14983; /* pred_divrvvmf4hf_scalar */

            case 6:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14985; /* pred_divrvvm8sf_scalar */

            case 7:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14987; /* pred_divrvvm4sf_scalar */

            case 8:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14989; /* pred_divrvvm2sf_scalar */

            case 9:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14991; /* pred_divrvvm1sf_scalar */

            case 10:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14993; /* pred_divrvvmf2sf_scalar */

            case 11:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14995; /* pred_divrvvm8df_scalar */

            case 12:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14997; /* pred_divrvvm4df_scalar */

            case 13:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14999; /* pred_divrvvm2df_scalar */

            case 14:
              if (!(
#line 6326 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15001; /* pred_divrvvm1df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern704 (x2))
        {
        case 0:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 15003; /* pred_divrvvm8hf_reverse_scalar */

        case 1:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 15005; /* pred_divrvvm4hf_reverse_scalar */

        case 2:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 15007; /* pred_divrvvm2hf_reverse_scalar */

        case 3:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 15009; /* pred_divrvvm1hf_reverse_scalar */

        case 4:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 15011; /* pred_divrvvmf2hf_reverse_scalar */

        case 5:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 15013; /* pred_divrvvmf4hf_reverse_scalar */

        case 6:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 15015; /* pred_divrvvm8sf_reverse_scalar */

        case 7:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 15017; /* pred_divrvvm4sf_reverse_scalar */

        case 8:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 15019; /* pred_divrvvm2sf_reverse_scalar */

        case 9:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 15021; /* pred_divrvvm1sf_reverse_scalar */

        case 10:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 15023; /* pred_divrvvmf2sf_reverse_scalar */

        case 11:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 15025; /* pred_divrvvm8df_reverse_scalar */

        case 12:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 15027; /* pred_divrvvm4df_reverse_scalar */

        case 13:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 15029; /* pred_divrvvm2df_reverse_scalar */

        case 14:
          if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 15031; /* pred_divrvvm1df_reverse_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1344 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      return recog_1340 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_1339 (x1, insn, pnum_clobbers);

    case MINUS:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          return recog_1336 (x1, insn, pnum_clobbers);

        case VEC_DUPLICATE:
          switch (pattern576 (x2))
            {
            case 0:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15002; /* pred_subrvvm8hf_reverse_scalar */

            case 1:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15004; /* pred_subrvvm4hf_reverse_scalar */

            case 2:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15006; /* pred_subrvvm2hf_reverse_scalar */

            case 3:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15008; /* pred_subrvvm1hf_reverse_scalar */

            case 4:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 15010; /* pred_subrvvmf2hf_reverse_scalar */

            case 5:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 15012; /* pred_subrvvmf4hf_reverse_scalar */

            case 6:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15014; /* pred_subrvvm8sf_reverse_scalar */

            case 7:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15016; /* pred_subrvvm4sf_reverse_scalar */

            case 8:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15018; /* pred_subrvvm2sf_reverse_scalar */

            case 9:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 15020; /* pred_subrvvm1sf_reverse_scalar */

            case 10:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 15022; /* pred_subrvvmf2sf_reverse_scalar */

            case 11:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15024; /* pred_subrvvm8df_reverse_scalar */

            case 12:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15026; /* pred_subrvvm4df_reverse_scalar */

            case 13:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15028; /* pred_subrvvm2df_reverse_scalar */

            case 14:
              if (!(
#line 6351 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 15030; /* pred_subrvvm1df_reverse_scalar */

            default:
              return -1;
            }

        case MULT:
          return recog_1334 (x1, insn, pnum_clobbers);

        case NEG:
          return recog_1335 (x1, insn, pnum_clobbers);

        case FLOAT_EXTEND:
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != FLOAT_EXTEND)
            return -1;
          x6 = XEXP (x2, 0);
          x7 = XVECEXP (x6, 0, 1);
          operands[5] = x7;
          x8 = XVECEXP (x6, 0, 2);
          operands[6] = x8;
          x9 = XVECEXP (x6, 0, 3);
          operands[7] = x9;
          x10 = XVECEXP (x6, 0, 4);
          operands[8] = x10;
          x11 = XVECEXP (x6, 0, 5);
          operands[9] = x11;
          x12 = XEXP (x4, 0);
          operands[3] = x12;
          x13 = XEXP (x2, 2);
          operands[2] = x13;
          switch (pattern722 (x2))
            {
            case 0:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16404; /* pred_dual_widen_subrvvm8sf */

            case 1:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16407; /* pred_dual_widen_subrvvm4sf */

            case 2:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16410; /* pred_dual_widen_subrvvm2sf */

            case 3:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16413; /* pred_dual_widen_subrvvm1sf */

            case 4:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 16416; /* pred_dual_widen_subrvvmf2sf */

            case 5:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16419; /* pred_dual_widen_subrvvm8df */

            case 6:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16422; /* pred_dual_widen_subrvvm4df */

            case 7:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16425; /* pred_dual_widen_subrvvm2df */

            case 8:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16428; /* pred_dual_widen_subrvvm1df */

            case 9:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16431; /* pred_dual_widen_subv1sf */

            case 10:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16434; /* pred_dual_widen_subv2sf */

            case 11:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16437; /* pred_dual_widen_subv4sf */

            case 12:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16440; /* pred_dual_widen_subv8sf */

            case 13:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16443; /* pred_dual_widen_subv16sf */

            case 14:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16446; /* pred_dual_widen_subv32sf */

            case 15:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16449; /* pred_dual_widen_subv64sf */

            case 16:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16452; /* pred_dual_widen_subv128sf */

            case 17:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16455; /* pred_dual_widen_subv256sf */

            case 18:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16458; /* pred_dual_widen_subv512sf */

            case 19:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16461; /* pred_dual_widen_subv1024sf */

            case 20:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16464; /* pred_dual_widen_subv1df */

            case 21:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16467; /* pred_dual_widen_subv2df */

            case 22:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16470; /* pred_dual_widen_subv4df */

            case 23:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16473; /* pred_dual_widen_subv8df */

            case 24:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16476; /* pred_dual_widen_subv16df */

            case 25:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16479; /* pred_dual_widen_subv32df */

            case 26:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16482; /* pred_dual_widen_subv64df */

            case 27:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16485; /* pred_dual_widen_subv128df */

            case 28:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16488; /* pred_dual_widen_subv256df */

            case 29:
              if (!(
#line 7028 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16491; /* pred_dual_widen_subv512df */

            case 30:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16494; /* pred_dual_widen_subrvvm8sf_scalar */

            case 31:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16497; /* pred_dual_widen_subrvvm4sf_scalar */

            case 32:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16500; /* pred_dual_widen_subrvvm2sf_scalar */

            case 33:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16503; /* pred_dual_widen_subrvvm1sf_scalar */

            case 34:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 16506; /* pred_dual_widen_subrvvmf2sf_scalar */

            case 35:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16509; /* pred_dual_widen_subrvvm8df_scalar */

            case 36:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16512; /* pred_dual_widen_subrvvm4df_scalar */

            case 37:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16515; /* pred_dual_widen_subrvvm2df_scalar */

            case 38:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16518; /* pred_dual_widen_subrvvm1df_scalar */

            case 39:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16521; /* pred_dual_widen_subv1sf_scalar */

            case 40:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16524; /* pred_dual_widen_subv2sf_scalar */

            case 41:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16527; /* pred_dual_widen_subv4sf_scalar */

            case 42:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16530; /* pred_dual_widen_subv8sf_scalar */

            case 43:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16533; /* pred_dual_widen_subv16sf_scalar */

            case 44:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16536; /* pred_dual_widen_subv32sf_scalar */

            case 45:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16539; /* pred_dual_widen_subv64sf_scalar */

            case 46:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16542; /* pred_dual_widen_subv128sf_scalar */

            case 47:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16545; /* pred_dual_widen_subv256sf_scalar */

            case 48:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16548; /* pred_dual_widen_subv512sf_scalar */

            case 49:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16551; /* pred_dual_widen_subv1024sf_scalar */

            case 50:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16554; /* pred_dual_widen_subv1df_scalar */

            case 51:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16557; /* pred_dual_widen_subv2df_scalar */

            case 52:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16560; /* pred_dual_widen_subv4df_scalar */

            case 53:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16563; /* pred_dual_widen_subv8df_scalar */

            case 54:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16566; /* pred_dual_widen_subv16df_scalar */

            case 55:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16569; /* pred_dual_widen_subv32df_scalar */

            case 56:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16572; /* pred_dual_widen_subv64df_scalar */

            case 57:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16575; /* pred_dual_widen_subv128df_scalar */

            case 58:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16578; /* pred_dual_widen_subv256df_scalar */

            case 59:
              if (!(
#line 7055 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16581; /* pred_dual_widen_subv512df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      return recog_1341 (x1, insn, pnum_clobbers);

    case SQRT:
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[4] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[5] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[6] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[7] = x10;
      x11 = XVECEXP (x6, 0, 5);
      operands[8] = x11;
      switch (pattern570 (x2))
        {
        case 0:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16214; /* pred_sqrtrvvm8hf */

        case 1:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16215; /* pred_sqrtrvvm4hf */

        case 2:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16216; /* pred_sqrtrvvm2hf */

        case 3:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16217; /* pred_sqrtrvvm1hf */

        case 4:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16218; /* pred_sqrtrvvmf2hf */

        case 5:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16219; /* pred_sqrtrvvmf4hf */

        case 6:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16220; /* pred_sqrtrvvm8sf */

        case 7:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16221; /* pred_sqrtrvvm4sf */

        case 8:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16222; /* pred_sqrtrvvm2sf */

        case 9:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16223; /* pred_sqrtrvvm1sf */

        case 10:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16224; /* pred_sqrtrvvmf2sf */

        case 11:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16225; /* pred_sqrtrvvm8df */

        case 12:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16226; /* pred_sqrtrvvm4df */

        case 13:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16227; /* pred_sqrtrvvm2df */

        case 14:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16228; /* pred_sqrtrvvm1df */

        case 15:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 16229; /* pred_sqrtv1hf */

        case 16:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 16230; /* pred_sqrtv2hf */

        case 17:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 16231; /* pred_sqrtv4hf */

        case 18:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 16232; /* pred_sqrtv8hf */

        case 19:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 16233; /* pred_sqrtv16hf */

        case 20:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16234; /* pred_sqrtv32hf */

        case 21:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16235; /* pred_sqrtv64hf */

        case 22:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16236; /* pred_sqrtv128hf */

        case 23:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16237; /* pred_sqrtv256hf */

        case 24:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16238; /* pred_sqrtv512hf */

        case 25:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16239; /* pred_sqrtv1024hf */

        case 26:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16240; /* pred_sqrtv2048hf */

        case 27:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16241; /* pred_sqrtv1sf */

        case 28:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16242; /* pred_sqrtv2sf */

        case 29:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16243; /* pred_sqrtv4sf */

        case 30:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16244; /* pred_sqrtv8sf */

        case 31:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16245; /* pred_sqrtv16sf */

        case 32:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16246; /* pred_sqrtv32sf */

        case 33:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16247; /* pred_sqrtv64sf */

        case 34:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16248; /* pred_sqrtv128sf */

        case 35:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16249; /* pred_sqrtv256sf */

        case 36:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16250; /* pred_sqrtv512sf */

        case 37:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16251; /* pred_sqrtv1024sf */

        case 38:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16252; /* pred_sqrtv1df */

        case 39:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16253; /* pred_sqrtv2df */

        case 40:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16254; /* pred_sqrtv4df */

        case 41:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 16255; /* pred_sqrtv8df */

        case 42:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 16256; /* pred_sqrtv16df */

        case 43:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 16257; /* pred_sqrtv32df */

        case 44:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 16258; /* pred_sqrtv64df */

        case 45:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 16259; /* pred_sqrtv128df */

        case 46:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 16260; /* pred_sqrtv256df */

        case 47:
          if (!(
#line 6905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 16261; /* pred_sqrtv512df */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_1338 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_1342 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_1343 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[4] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[5] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[6] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[7] = x10;
      x11 = XVECEXP (x6, 0, 5);
      operands[8] = x11;
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      x13 = XEXP (x2, 2);
      operands[2] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HFmode:
          if (pattern499 (x2, 
E_RVVM4HFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 990 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18065; /* pred_truncrvvm8sf */

        case E_RVVM2HFmode:
          if (pattern499 (x2, 
E_RVVM2HFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 991 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18066; /* pred_truncrvvm4sf */

        case E_RVVM1HFmode:
          if (pattern499 (x2, 
E_RVVM1HFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 992 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18067; /* pred_truncrvvm2sf */

        case E_RVVMF2HFmode:
          if (pattern499 (x2, 
E_RVVMF2HFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 993 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18068; /* pred_truncrvvm1sf */

        case E_RVVMF4HFmode:
          if (pattern499 (x2, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 994 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 18069; /* pred_truncrvvmf2sf */

        case E_RVVM4SFmode:
          if (pattern499 (x2, 
E_RVVM4SFmode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18070; /* pred_truncrvvm8df */

        case E_RVVM2SFmode:
          if (pattern499 (x2, 
E_RVVM2SFmode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18071; /* pred_truncrvvm4df */

        case E_RVVM1SFmode:
          if (pattern499 (x2, 
E_RVVM1SFmode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18072; /* pred_truncrvvm2df */

        case E_RVVMF2SFmode:
          if (pattern499 (x2, 
E_RVVMF2SFmode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18073; /* pred_truncrvvm1df */

        case E_V1HFmode:
          if (pattern499 (x2, 
E_V1HFmode, 
E_V1SFmode, 
E_V1BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 999 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18074; /* pred_truncv1sf */

        case E_V2HFmode:
          if (pattern499 (x2, 
E_V2HFmode, 
E_V2SFmode, 
E_V2BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1000 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18075; /* pred_truncv2sf */

        case E_V4HFmode:
          if (pattern499 (x2, 
E_V4HFmode, 
E_V4SFmode, 
E_V4BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1001 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18076; /* pred_truncv4sf */

        case E_V8HFmode:
          if (pattern499 (x2, 
E_V8HFmode, 
E_V8SFmode, 
E_V8BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1002 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18077; /* pred_truncv8sf */

        case E_V16HFmode:
          if (pattern499 (x2, 
E_V16HFmode, 
E_V16SFmode, 
E_V16BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1003 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18078; /* pred_truncv16sf */

        case E_V32HFmode:
          if (pattern499 (x2, 
E_V32HFmode, 
E_V32SFmode, 
E_V32BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1004 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18079; /* pred_truncv32sf */

        case E_V64HFmode:
          if (pattern499 (x2, 
E_V64HFmode, 
E_V64SFmode, 
E_V64BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1005 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18080; /* pred_truncv64sf */

        case E_V128HFmode:
          if (pattern499 (x2, 
E_V128HFmode, 
E_V128SFmode, 
E_V128BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1006 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18081; /* pred_truncv128sf */

        case E_V256HFmode:
          if (pattern499 (x2, 
E_V256HFmode, 
E_V256SFmode, 
E_V256BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1007 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18082; /* pred_truncv256sf */

        case E_V512HFmode:
          if (pattern499 (x2, 
E_V512HFmode, 
E_V512SFmode, 
E_V512BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1008 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18083; /* pred_truncv512sf */

        case E_V1024HFmode:
          if (pattern499 (x2, 
E_V1024HFmode, 
E_V1024SFmode, 
E_V1024BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1009 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18084; /* pred_truncv1024sf */

        case E_V1SFmode:
          if (pattern499 (x2, 
E_V1SFmode, 
E_V1DFmode, 
E_V1BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1010 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18085; /* pred_truncv1df */

        case E_V2SFmode:
          if (pattern499 (x2, 
E_V2SFmode, 
E_V2DFmode, 
E_V2BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1011 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18086; /* pred_truncv2df */

        case E_V4SFmode:
          if (pattern499 (x2, 
E_V4SFmode, 
E_V4DFmode, 
E_V4BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1012 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18087; /* pred_truncv4df */

        case E_V8SFmode:
          if (pattern499 (x2, 
E_V8SFmode, 
E_V8DFmode, 
E_V8BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1013 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18088; /* pred_truncv8df */

        case E_V16SFmode:
          if (pattern499 (x2, 
E_V16SFmode, 
E_V16DFmode, 
E_V16BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1014 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18089; /* pred_truncv16df */

        case E_V32SFmode:
          if (pattern499 (x2, 
E_V32SFmode, 
E_V32DFmode, 
E_V32BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18090; /* pred_truncv32df */

        case E_V64SFmode:
          if (pattern499 (x2, 
E_V64SFmode, 
E_V64DFmode, 
E_V64BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18091; /* pred_truncv64df */

        case E_V128SFmode:
          if (pattern499 (x2, 
E_V128SFmode, 
E_V128DFmode, 
E_V128BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1017 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18092; /* pred_truncv128df */

        case E_V256SFmode:
          if (pattern499 (x2, 
E_V256SFmode, 
E_V256DFmode, 
E_V256BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1018 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18093; /* pred_truncv256df */

        case E_V512SFmode:
          if (pattern499 (x2, 
E_V512SFmode, 
E_V512DFmode, 
E_V512BImode) != 0
              || !(
#line 7712 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1019 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18094; /* pred_truncv512df */

        case E_RVVM4BFmode:
          if (pattern499 (x2, 
E_RVVM4BFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 53 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 21 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33636; /* pred_truncrvvm8sf_to_bf16 */

        case E_RVVM2BFmode:
          if (pattern499 (x2, 
E_RVVM2BFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 53 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 22 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33637; /* pred_truncrvvm4sf_to_bf16 */

        case E_RVVM1BFmode:
          if (pattern499 (x2, 
E_RVVM1BFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 53 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 23 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33638; /* pred_truncrvvm2sf_to_bf16 */

        case E_RVVMF2BFmode:
          if (pattern499 (x2, 
E_RVVMF2BFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 53 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 24 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33639; /* pred_truncrvvm1sf_to_bf16 */

        case E_RVVMF4BFmode:
          if (pattern499 (x2, 
E_RVVMF4BFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 53 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 25 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 33640; /* pred_truncrvvmf2sf_to_bf16 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1453 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[3], E_V8HFmode)
          || GET_MODE (x9) != E_V8HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7383 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17105; /* *pred_cmpv8hf_scalar_merge_tie_mask */

    case E_V8SFmode:
      if (!register_operand (operands[3], E_V8SFmode)
          || GET_MODE (x9) != E_V8SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7383 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17117; /* *pred_cmpv8sf_scalar_merge_tie_mask */

    case E_V8DFmode:
      if (!register_operand (operands[3], E_V8DFmode)
          || GET_MODE (x9) != E_V8DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7383 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17128; /* *pred_cmpv8df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1459 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512HFmode:
      if (!register_operand (operands[3], E_V512HFmode)
          || GET_MODE (x9) != E_V512HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7383 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17111; /* *pred_cmpv512hf_scalar_merge_tie_mask */

    case E_V512SFmode:
      if (!register_operand (operands[3], E_V512SFmode)
          || GET_MODE (x9) != E_V512SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7383 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17123; /* *pred_cmpv512sf_scalar_merge_tie_mask */

    case E_V512DFmode:
      if (!register_operand (operands[3], E_V512DFmode)
          || GET_MODE (x9) != E_V512DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7383 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17134; /* *pred_cmpv512df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1467 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern543 (x2, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V8BImode))
    {
      res = recog_1453 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[4], E_V8HFmode)
          || GET_MODE (x9) != E_V8HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8HFmode)) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 17153; /* *pred_cmpv8hf_scalar */
      if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8HFmode)) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17201; /* *pred_cmpv8hf_scalar_narrow */

    case E_V8SFmode:
      if (!register_operand (operands[4], E_V8SFmode)
          || GET_MODE (x9) != E_V8SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8SFmode)) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 17165; /* *pred_cmpv8sf_scalar */
      if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8SFmode)) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17213; /* *pred_cmpv8sf_scalar_narrow */

    case E_V8DFmode:
      if (!register_operand (operands[4], E_V8DFmode)
          || GET_MODE (x9) != E_V8DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DFmode)) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return 17176; /* *pred_cmpv8df_scalar */
      if (!(
#line 7430 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DFmode)) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17224; /* *pred_cmpv8df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1474 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
          res = recog_384 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL)
        {
          res = recog_386 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (ordered_comparison_operator (x3, E_VOIDmode))
        {
          res = recog_387 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != LABEL_REF)
        return -1;
      x5 = XEXP (x2, 2);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      operands[1] = x3;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      if (equality_operator (operands[1], E_VOIDmode))
        {
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (register_operand (operands[2], E_SImode)
                  && const_int5s_operand (operands[3], E_SImode)
                  && (
#line 2627 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVBI) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 33962; /* *cv_branchsi */
              break;

            case E_DImode:
              if (register_operand (operands[2], E_DImode)
                  && const_int5s_operand (operands[3], E_DImode)
                  && (
#line 2627 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVBI) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 33963; /* *cv_branchdi */
              break;

            default:
              break;
            }
        }
      if (!ordered_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      switch (pattern409 ())
        {
        case 0:
          if (!(
#line 2645 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVBI) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33964; /* *branchsi */

        case 1:
          if (!(
#line 2645 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVBI) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33965; /* *branchdi */

        default:
          return -1;
        }

    case UNSPEC:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      switch (XVECLEN (x3, 0))
        {
        case 5:
          if (pattern260 (x3) != 0)
            return -1;
          switch (XINT (x3, 1))
            {
            case 91:
              return recog_410 (x1, insn, pnum_clobbers);

            case 172:
              switch (pattern430 (x2))
                {
                case 0:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1983; /* pred_store_widthbrvvm8qi */

                case 1:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1986; /* pred_store_widthbrvvm4qi */

                case 2:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1989; /* pred_store_widthbrvvm2qi */

                case 3:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1992; /* pred_store_widthbrvvm1qi */

                case 4:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1995; /* pred_store_widthbrvvm8hi */

                case 5:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1998; /* pred_store_widthbrvvm4hi */

                case 6:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2001; /* pred_store_widthbrvvm2hi */

                case 7:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2004; /* pred_store_widthbrvvm1hi */

                case 8:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2007; /* pred_store_widthbrvvm8si */

                case 9:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2010; /* pred_store_widthbrvvm4si */

                case 10:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2013; /* pred_store_widthbrvvm2si */

                case 11:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2016; /* pred_store_widthbrvvm1si */

                case 12:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2019; /* pred_store_widthbrvvm8di */

                case 13:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2022; /* pred_store_widthbrvvm4di */

                case 14:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2025; /* pred_store_widthbrvvm2di */

                case 15:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2028; /* pred_store_widthbrvvm1di */

                case 16:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2031; /* pred_store_widthbrvvmf8qi */

                case 17:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2034; /* pred_store_widthbrvvmf4hi */

                case 18:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2037; /* pred_store_widthbrvvmf2si */

                default:
                  return -1;
                }

            case 174:
              switch (pattern430 (x2))
                {
                case 0:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1984; /* pred_store_widthhrvvm8qi */

                case 1:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1987; /* pred_store_widthhrvvm4qi */

                case 2:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1990; /* pred_store_widthhrvvm2qi */

                case 3:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1993; /* pred_store_widthhrvvm1qi */

                case 4:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1996; /* pred_store_widthhrvvm8hi */

                case 5:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1999; /* pred_store_widthhrvvm4hi */

                case 6:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2002; /* pred_store_widthhrvvm2hi */

                case 7:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2005; /* pred_store_widthhrvvm1hi */

                case 8:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2008; /* pred_store_widthhrvvm8si */

                case 9:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2011; /* pred_store_widthhrvvm4si */

                case 10:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2014; /* pred_store_widthhrvvm2si */

                case 11:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2017; /* pred_store_widthhrvvm1si */

                case 12:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2020; /* pred_store_widthhrvvm8di */

                case 13:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2023; /* pred_store_widthhrvvm4di */

                case 14:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2026; /* pred_store_widthhrvvm2di */

                case 15:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2029; /* pred_store_widthhrvvm1di */

                case 16:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2032; /* pred_store_widthhrvvmf8qi */

                case 17:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2035; /* pred_store_widthhrvvmf4hi */

                case 18:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2038; /* pred_store_widthhrvvmf2si */

                default:
                  return -1;
                }

            case 176:
              switch (pattern430 (x2))
                {
                case 0:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1985; /* pred_store_widthwrvvm8qi */

                case 1:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1988; /* pred_store_widthwrvvm4qi */

                case 2:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1991; /* pred_store_widthwrvvm2qi */

                case 3:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1994; /* pred_store_widthwrvvm1qi */

                case 4:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1997; /* pred_store_widthwrvvm8hi */

                case 5:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2000; /* pred_store_widthwrvvm4hi */

                case 6:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2003; /* pred_store_widthwrvvm2hi */

                case 7:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2006; /* pred_store_widthwrvvm1hi */

                case 8:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2009; /* pred_store_widthwrvvm8si */

                case 9:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2012; /* pred_store_widthwrvvm4si */

                case 10:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2015; /* pred_store_widthwrvvm2si */

                case 11:
                  if (!
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2018; /* pred_store_widthwrvvm1si */

                case 12:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2021; /* pred_store_widthwrvvm8di */

                case 13:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2024; /* pred_store_widthwrvvm4di */

                case 14:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2027; /* pred_store_widthwrvvm2di */

                case 15:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2030; /* pred_store_widthwrvvm1di */

                case 16:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2033; /* pred_store_widthwrvvmf8qi */

                case 17:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2036; /* pred_store_widthwrvvmf4hi */

                case 18:
                  if (!(
#line 248 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2039; /* pred_store_widthwrvvmf2si */

                default:
                  return -1;
                }

            case 178:
              switch (pattern432 (x2, 
178))
                {
                case 0:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2154; /* pred_strided_store_widthbrvvm8qi */

                case 1:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2157; /* pred_strided_store_widthbrvvm4qi */

                case 2:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2160; /* pred_strided_store_widthbrvvm2qi */

                case 3:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2163; /* pred_strided_store_widthbrvvm1qi */

                case 4:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2166; /* pred_strided_store_widthbrvvm8hi */

                case 5:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2169; /* pred_strided_store_widthbrvvm4hi */

                case 6:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2172; /* pred_strided_store_widthbrvvm2hi */

                case 7:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2175; /* pred_strided_store_widthbrvvm1hi */

                case 8:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2178; /* pred_strided_store_widthbrvvm8si */

                case 9:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2181; /* pred_strided_store_widthbrvvm4si */

                case 10:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2184; /* pred_strided_store_widthbrvvm2si */

                case 11:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2187; /* pred_strided_store_widthbrvvm1si */

                case 12:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2190; /* pred_strided_store_widthbrvvm8di */

                case 13:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2193; /* pred_strided_store_widthbrvvm4di */

                case 14:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2196; /* pred_strided_store_widthbrvvm2di */

                case 15:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2199; /* pred_strided_store_widthbrvvm1di */

                case 16:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2202; /* pred_strided_store_widthbrvvmf8qi */

                case 17:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2205; /* pred_strided_store_widthbrvvmf4hi */

                case 18:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2208; /* pred_strided_store_widthbrvvmf2si */

                default:
                  return -1;
                }

            case 180:
              switch (pattern432 (x2, 
180))
                {
                case 0:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2155; /* pred_strided_store_widthhrvvm8qi */

                case 1:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2158; /* pred_strided_store_widthhrvvm4qi */

                case 2:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2161; /* pred_strided_store_widthhrvvm2qi */

                case 3:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2164; /* pred_strided_store_widthhrvvm1qi */

                case 4:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2167; /* pred_strided_store_widthhrvvm8hi */

                case 5:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2170; /* pred_strided_store_widthhrvvm4hi */

                case 6:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2173; /* pred_strided_store_widthhrvvm2hi */

                case 7:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2176; /* pred_strided_store_widthhrvvm1hi */

                case 8:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2179; /* pred_strided_store_widthhrvvm8si */

                case 9:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2182; /* pred_strided_store_widthhrvvm4si */

                case 10:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2185; /* pred_strided_store_widthhrvvm2si */

                case 11:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2188; /* pred_strided_store_widthhrvvm1si */

                case 12:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2191; /* pred_strided_store_widthhrvvm8di */

                case 13:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2194; /* pred_strided_store_widthhrvvm4di */

                case 14:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2197; /* pred_strided_store_widthhrvvm2di */

                case 15:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2200; /* pred_strided_store_widthhrvvm1di */

                case 16:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2203; /* pred_strided_store_widthhrvvmf8qi */

                case 17:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2206; /* pred_strided_store_widthhrvvmf4hi */

                case 18:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2209; /* pred_strided_store_widthhrvvmf2si */

                default:
                  return -1;
                }

            case 182:
              switch (pattern432 (x2, 
182))
                {
                case 0:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2156; /* pred_strided_store_widthwrvvm8qi */

                case 1:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2159; /* pred_strided_store_widthwrvvm4qi */

                case 2:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2162; /* pred_strided_store_widthwrvvm2qi */

                case 3:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2165; /* pred_strided_store_widthwrvvm1qi */

                case 4:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2168; /* pred_strided_store_widthwrvvm8hi */

                case 5:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2171; /* pred_strided_store_widthwrvvm4hi */

                case 6:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2174; /* pred_strided_store_widthwrvvm2hi */

                case 7:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2177; /* pred_strided_store_widthwrvvm1hi */

                case 8:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2180; /* pred_strided_store_widthwrvvm8si */

                case 9:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2183; /* pred_strided_store_widthwrvvm4si */

                case 10:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2186; /* pred_strided_store_widthwrvvm2si */

                case 11:
                  if (!
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2189; /* pred_strided_store_widthwrvvm1si */

                case 12:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2192; /* pred_strided_store_widthwrvvm8di */

                case 13:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2195; /* pred_strided_store_widthwrvvm4di */

                case 14:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2198; /* pred_strided_store_widthwrvvm2di */

                case 15:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2201; /* pred_strided_store_widthwrvvm1di */

                case 16:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2204; /* pred_strided_store_widthwrvvmf8qi */

                case 17:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2207; /* pred_strided_store_widthwrvvmf4hi */

                case 18:
                  if (!(
#line 288 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2210; /* pred_strided_store_widthwrvvmf2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 7:
          return recog_1470 (x1, insn, pnum_clobbers);

        case 9:
          return recog_1471 (x1, insn, pnum_clobbers);

        case 6:
          if (pattern262 (x3) != 0)
            return -1;
          x10 = XVECEXP (x3, 0, 0);
          operands[1] = x10;
          x11 = XVECEXP (x3, 0, 1);
          if (!vector_length_operand (x11, E_VOIDmode))
            return -1;
          x12 = XVECEXP (x3, 0, 2);
          if (!const_int_operand (x12, E_VOIDmode))
            return -1;
          x13 = XVECEXP (x3, 0, 3);
          if (!const_int_operand (x13, E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
              return recog_1469 (x1, insn, pnum_clobbers);

            case UNSPEC:
              if (XVECLEN (x4, 0) != 1)
                return -1;
              operands[4] = x11;
              operands[5] = x12;
              operands[6] = x13;
              x14 = XVECEXP (x4, 0, 0);
              operands[3] = x14;
              x5 = XEXP (x2, 2);
              operands[2] = x5;
              switch (XINT (x4, 1))
                {
                case 114:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_RVVMF64BImode:
                      if (pattern622 (x2, 
E_RVVMF64BImode) != 0
                          || !(
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                        return -1;
                      return 14387; /* pred_sbfrvvmf64bi */

                    case E_RVVMF32BImode:
                      if (pattern622 (x2, 
E_RVVMF32BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14390; /* pred_sbfrvvmf32bi */

                    case E_RVVMF16BImode:
                      if (pattern622 (x2, 
E_RVVMF16BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14393; /* pred_sbfrvvmf16bi */

                    case E_RVVMF8BImode:
                      if (pattern622 (x2, 
E_RVVMF8BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14396; /* pred_sbfrvvmf8bi */

                    case E_RVVMF4BImode:
                      if (pattern622 (x2, 
E_RVVMF4BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14399; /* pred_sbfrvvmf4bi */

                    case E_RVVMF2BImode:
                      if (pattern622 (x2, 
E_RVVMF2BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14402; /* pred_sbfrvvmf2bi */

                    case E_RVVM1BImode:
                      if (pattern622 (x2, 
E_RVVM1BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14405; /* pred_sbfrvvm1bi */

                    default:
                      return -1;
                    }

                case 115:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_RVVMF64BImode:
                      if (pattern622 (x2, 
E_RVVMF64BImode) != 0
                          || !(
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                        return -1;
                      return 14388; /* pred_sifrvvmf64bi */

                    case E_RVVMF32BImode:
                      if (pattern622 (x2, 
E_RVVMF32BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14391; /* pred_sifrvvmf32bi */

                    case E_RVVMF16BImode:
                      if (pattern622 (x2, 
E_RVVMF16BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14394; /* pred_sifrvvmf16bi */

                    case E_RVVMF8BImode:
                      if (pattern622 (x2, 
E_RVVMF8BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14397; /* pred_sifrvvmf8bi */

                    case E_RVVMF4BImode:
                      if (pattern622 (x2, 
E_RVVMF4BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14400; /* pred_sifrvvmf4bi */

                    case E_RVVMF2BImode:
                      if (pattern622 (x2, 
E_RVVMF2BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14403; /* pred_sifrvvmf2bi */

                    case E_RVVM1BImode:
                      if (pattern622 (x2, 
E_RVVM1BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14406; /* pred_sifrvvm1bi */

                    default:
                      return -1;
                    }

                case 116:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_RVVMF64BImode:
                      if (pattern622 (x2, 
E_RVVMF64BImode) != 0
                          || !(
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                        return -1;
                      return 14389; /* pred_sofrvvmf64bi */

                    case E_RVVMF32BImode:
                      if (pattern622 (x2, 
E_RVVMF32BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14392; /* pred_sofrvvmf32bi */

                    case E_RVVMF16BImode:
                      if (pattern622 (x2, 
E_RVVMF16BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14395; /* pred_sofrvvmf16bi */

                    case E_RVVMF8BImode:
                      if (pattern622 (x2, 
E_RVVMF8BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14398; /* pred_sofrvvmf8bi */

                    case E_RVVMF4BImode:
                      if (pattern622 (x2, 
E_RVVMF4BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14401; /* pred_sofrvvmf4bi */

                    case E_RVVMF2BImode:
                      if (pattern622 (x2, 
E_RVVMF2BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14404; /* pred_sofrvvmf2bi */

                    case E_RVVM1BImode:
                      if (pattern622 (x2, 
E_RVVM1BImode) != 0
                          || !
#line 6123 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14407; /* pred_sofrvvm1bi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      return recog_1472 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1482 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      return recog_102 (x1, insn, pnum_clobbers);

    case 1:
      return recog_104 (x1, insn, pnum_clobbers);

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 6:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern384 (x2, 
E_SImode) != 0
                  || !
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))
                return -1;
              return 262; /* tls_add_tp_lesi */

            case E_DImode:
              if (pattern384 (x2, 
E_DImode) != 0
                  || !
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))
                return -1;
              return 263; /* tls_add_tp_ledi */

            default:
              return -1;
            }

        case 10:
          x6 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x6) != PC)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern385 (x2, 
E_SImode) != 0
                  || !
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))
                return -1;
              return 270; /* auipcsi */

            case E_DImode:
              if (pattern385 (x2, 
E_DImode) != 0
                  || !
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))
                return -1;
              return 271; /* auipcdi */

            default:
              return -1;
            }

        case 49:
          if (pattern247 (x2) != 0
              || !
#line 216 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKND && !TARGET_64BIT))
            return -1;
          return 683; /* riscv_aes32dsi */

        case 50:
          if (pattern247 (x2) != 0
              || !
#line 226 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKND && !TARGET_64BIT))
            return -1;
          return 684; /* riscv_aes32dsmi */

        case 58:
          if (pattern247 (x2) != 0
              || !
#line 282 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKNE && !TARGET_64BIT))
            return -1;
          return 690; /* riscv_aes32esi */

        case 59:
          if (pattern247 (x2) != 0
              || !
#line 292 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKNE && !TARGET_64BIT))
            return -1;
          return 691; /* riscv_aes32esmi */

        case 76:
          if (pattern247 (x2) != 0
              || !
#line 499 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKSED && !TARGET_64BIT))
            return -1;
          return 716; /* *riscv_sm4ed_si */

        case 77:
          if (pattern247 (x2) != 0
              || !
#line 499 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZKSED && !TARGET_64BIT))
            return -1;
          return 717; /* *riscv_sm4ks_si */

        case 102:
          return recog_84 (x1, insn, pnum_clobbers);

        case 103:
          return recog_86 (x1, insn, pnum_clobbers);

        case 140:
          return recog_85 (x1, insn, pnum_clobbers);

        case 134:
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != UNSPEC
              || XVECLEN (x4, 0) != 6
              || XINT (x4, 1) != 91
              || pattern356 (x4) != 0)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          operands[3] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[4] = x8;
          if (!vector_length_operand (operands[4], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x4, 0, 2);
          operands[5] = x9;
          if (!const_int_operand (operands[5], E_VOIDmode))
            return -1;
          x10 = XVECEXP (x4, 0, 3);
          operands[6] = x10;
          if (!const_int_operand (operands[6], E_VOIDmode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[1] = x6;
          return recog_83 (x1, insn, pnum_clobbers);

        case 232:
          if (pattern250 (x2) != 0
              || !
#line 876 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33818; /* riscv_cv_simd_add_h_si */

        case 236:
          if (pattern250 (x2) != 0
              || !
#line 929 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33822; /* riscv_cv_simd_sub_h_si */

        case 296:
          if (pattern251 (x2) != 0
              || !
#line 1639 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33882; /* riscv_cv_simd_insert_h_si */

        case 297:
          if (pattern251 (x2) != 0
              || !
#line 1651 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33883; /* riscv_cv_simd_insert_b_si */

        case 310:
          if (pattern252 (x2) != 0
              || !
#line 1808 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33896; /* riscv_cv_simd_sdotup_h_si */

        case 311:
          if (pattern252 (x2) != 0
              || !
#line 1820 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33897; /* riscv_cv_simd_sdotup_b_si */

        case 312:
          if (pattern253 (x2, 
E_HImode) != 0
              || !
#line 1832 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33898; /* riscv_cv_simd_sdotup_sc_h_si */

        case 313:
          if (pattern253 (x2, 
E_QImode) != 0
              || !
#line 1846 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33899; /* riscv_cv_simd_sdotup_sc_b_si */

        case 314:
          if (pattern252 (x2) != 0
              || !
#line 1860 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33900; /* riscv_cv_simd_sdotusp_h_si */

        case 315:
          if (pattern252 (x2) != 0
              || !
#line 1872 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33901; /* riscv_cv_simd_sdotusp_b_si */

        case 316:
          if (pattern254 (x2, 
E_HImode) != 0
              || !
#line 1884 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33902; /* riscv_cv_simd_sdotusp_sc_h_si */

        case 317:
          if (pattern254 (x2, 
E_QImode) != 0
              || !
#line 1898 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33903; /* riscv_cv_simd_sdotusp_sc_b_si */

        case 318:
          if (pattern252 (x2) != 0
              || !
#line 1912 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33904; /* riscv_cv_simd_sdotsp_h_si */

        case 319:
          if (pattern252 (x2) != 0
              || !
#line 1924 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33905; /* riscv_cv_simd_sdotsp_b_si */

        case 320:
          if (pattern254 (x2, 
E_HImode) != 0
              || !
#line 1936 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33906; /* riscv_cv_simd_sdotsp_sc_h_si */

        case 321:
          if (pattern254 (x2, 
E_QImode) != 0
              || !
#line 1950 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33907; /* riscv_cv_simd_sdotsp_sc_b_si */

        case 326:
          if (pattern252 (x2) != 0
              || !
#line 2013 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33912; /* riscv_cv_simd_shuffle2_h_si */

        case 327:
          if (pattern252 (x2) != 0
              || !
#line 2025 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33913; /* riscv_cv_simd_shuffle2_b_si */

        case 330:
          if (pattern252 (x2) != 0
              || !
#line 2059 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33916; /* riscv_cv_simd_packhi_b_si */

        case 331:
          if (pattern252 (x2) != 0
              || !
#line 2071 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33917; /* riscv_cv_simd_packlo_b_si */

        case 375:
          if (pattern250 (x2) != 0
              || !
#line 2609 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
            return -1;
          return 33961; /* riscv_cv_simd_subrotmj_si */

        default:
          return -1;
        }

    case 5:
      switch (XINT (x2, 1))
        {
        case 193:
          if (pattern176 (x2) != 0)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!vector_length_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          return recog_87 (x1, insn, pnum_clobbers);

        case 89:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (pattern386 (x2))
            {
            case 0:
              if (!(
#line 1784 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 3647; /* vsetvlsi_no_side_effects */

            case 1:
              if (!(
#line 1784 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 3648; /* vsetvldi_no_side_effects */

            default:
              return -1;
            }

        case 94:
          return recog_90 (x1, insn, pnum_clobbers);

        case 143:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x5 = XVECEXP (x2, 0, 1);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (pattern330 (x2))
            {
            case 0:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28239; /* mask_len_fold_left_plus_rvvm8hf */

            case 1:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28240; /* mask_len_fold_left_plus_rvvm4hf */

            case 2:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28241; /* mask_len_fold_left_plus_rvvm2hf */

            case 3:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28242; /* mask_len_fold_left_plus_rvvm1hf */

            case 4:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 28243; /* mask_len_fold_left_plus_rvvmf2hf */

            case 5:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 28244; /* mask_len_fold_left_plus_rvvmf4hf */

            case 6:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 28245; /* mask_len_fold_left_plus_rvvm8sf */

            case 7:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 28246; /* mask_len_fold_left_plus_rvvm4sf */

            case 8:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 28247; /* mask_len_fold_left_plus_rvvm2sf */

            case 9:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 28248; /* mask_len_fold_left_plus_rvvm1sf */

            case 10:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 28249; /* mask_len_fold_left_plus_rvvmf2sf */

            case 11:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 28250; /* mask_len_fold_left_plus_rvvm8df */

            case 12:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 28251; /* mask_len_fold_left_plus_rvvm4df */

            case 13:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 28252; /* mask_len_fold_left_plus_rvvm2df */

            case 14:
              if (!(
#line 2411 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 28253; /* mask_len_fold_left_plus_rvvm1df */

            case 15:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 31154; /* *mask_len_fold_left_widen_plus_rvvm4hf */

            case 16:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 31155; /* *mask_len_fold_left_widen_plus_rvvm2hf */

            case 17:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 31156; /* *mask_len_fold_left_widen_plus_rvvm1hf */

            case 18:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 31157; /* *mask_len_fold_left_widen_plus_rvvmf2hf */

            case 19:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 31158; /* *mask_len_fold_left_widen_plus_rvvmf4hf */

            case 20:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                return -1;
              return 31163; /* *mask_len_fold_left_widen_plus_v1hf */

            case 21:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                return -1;
              return 31164; /* *mask_len_fold_left_widen_plus_v2hf */

            case 22:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                return -1;
              return 31165; /* *mask_len_fold_left_widen_plus_v4hf */

            case 23:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                return -1;
              return 31166; /* *mask_len_fold_left_widen_plus_v8hf */

            case 24:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                return -1;
              return 31167; /* *mask_len_fold_left_widen_plus_v16hf */

            case 25:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 31168; /* *mask_len_fold_left_widen_plus_v32hf */

            case 26:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 31169; /* *mask_len_fold_left_widen_plus_v64hf */

            case 27:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 31170; /* *mask_len_fold_left_widen_plus_v128hf */

            case 28:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 31171; /* *mask_len_fold_left_widen_plus_v256hf */

            case 29:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 31172; /* *mask_len_fold_left_widen_plus_v512hf */

            case 30:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 31173; /* *mask_len_fold_left_widen_plus_v1024hf */

            case 31:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31159; /* *mask_len_fold_left_widen_plus_rvvm4sf */

            case 32:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31160; /* *mask_len_fold_left_widen_plus_rvvm2sf */

            case 33:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31161; /* *mask_len_fold_left_widen_plus_rvvm1sf */

            case 34:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 31162; /* *mask_len_fold_left_widen_plus_rvvmf2sf */

            case 35:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31174; /* *mask_len_fold_left_widen_plus_v1sf */

            case 36:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31175; /* *mask_len_fold_left_widen_plus_v2sf */

            case 37:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31176; /* *mask_len_fold_left_widen_plus_v4sf */

            case 38:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31177; /* *mask_len_fold_left_widen_plus_v8sf */

            case 39:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 31178; /* *mask_len_fold_left_widen_plus_v16sf */

            case 40:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 31179; /* *mask_len_fold_left_widen_plus_v32sf */

            case 41:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 31180; /* *mask_len_fold_left_widen_plus_v64sf */

            case 42:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 31181; /* *mask_len_fold_left_widen_plus_v128sf */

            case 43:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 31182; /* *mask_len_fold_left_widen_plus_v256sf */

            case 44:
              if (!(
#line 874 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 31183; /* *mask_len_fold_left_widen_plus_v512sf */

            default:
              return -1;
            }

        case 169:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (pattern358 (x2))
            {
            case 0:
              if (!(
#line 2866 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 28254; /* vcond_mask_len_rvvmf64bi */

            case 1:
              if (!
#line 2866 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()))
                return -1;
              return 28255; /* vcond_mask_len_rvvmf32bi */

            case 2:
              if (!
#line 2866 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()))
                return -1;
              return 28256; /* vcond_mask_len_rvvmf16bi */

            case 3:
              if (!
#line 2866 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()))
                return -1;
              return 28257; /* vcond_mask_len_rvvmf8bi */

            case 4:
              if (!
#line 2866 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()))
                return -1;
              return 28258; /* vcond_mask_len_rvvmf4bi */

            case 5:
              if (!
#line 2866 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()))
                return -1;
              return 28259; /* vcond_mask_len_rvvmf2bi */

            case 6:
              if (!
#line 2866 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()))
                return -1;
              return 28260; /* vcond_mask_len_rvvm1bi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      return recog_103 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1490 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return recog_110 (x1, insn, pnum_clobbers);

    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern195 (x3, 
E_SImode) != 0
              || !(
#line 266 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 523; /* *xor_notsi */

        case E_DImode:
          if (pattern195 (x3, 
E_DImode) != 0
              || !(
#line 266 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 524; /* *xor_notdi */

        case E_RVVMF64BImode:
          if (pattern195 (x3, 
E_RVVMF64BImode) != 0
              || !(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 32021; /* *nxorrvvmf64bi */

        case E_RVVMF32BImode:
          if (pattern195 (x3, 
E_RVVMF32BImode) != 0
              || !
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32024; /* *nxorrvvmf32bi */

        case E_RVVMF16BImode:
          if (pattern195 (x3, 
E_RVVMF16BImode) != 0
              || !
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32027; /* *nxorrvvmf16bi */

        case E_RVVMF8BImode:
          if (pattern195 (x3, 
E_RVVMF8BImode) != 0
              || !
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32030; /* *nxorrvvmf8bi */

        case E_RVVMF4BImode:
          if (pattern195 (x3, 
E_RVVMF4BImode) != 0
              || !
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32033; /* *nxorrvvmf4bi */

        case E_RVVMF2BImode:
          if (pattern195 (x3, 
E_RVVMF2BImode) != 0
              || !
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32036; /* *nxorrvvmf2bi */

        case E_RVVM1BImode:
          if (pattern195 (x3, 
E_RVVM1BImode) != 0
              || !
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32039; /* *nxorrvvm1bi */

        case E_V1BImode:
          if (pattern195 (x3, 
E_V1BImode) != 0
              || !(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 32042; /* *nxorv1bi */

        case E_V2BImode:
          if (pattern195 (x3, 
E_V2BImode) != 0
              || !(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 32045; /* *nxorv2bi */

        case E_V4BImode:
          if (pattern195 (x3, 
E_V4BImode) != 0
              || !(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 32048; /* *nxorv4bi */

        case E_V8BImode:
          if (pattern195 (x3, 
E_V8BImode) != 0
              || !(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 32051; /* *nxorv8bi */

        case E_V16BImode:
          if (pattern195 (x3, 
E_V16BImode) != 0
              || !(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 32054; /* *nxorv16bi */

        case E_V32BImode:
          if (pattern195 (x3, 
E_V32BImode) != 0
              || !(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 32057; /* *nxorv32bi */

        case E_V64BImode:
          if (pattern195 (x3, 
E_V64BImode) != 0
              || !(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32060; /* *nxorv64bi */

        case E_V128BImode:
          if (pattern195 (x3, 
E_V128BImode) != 0
              || !(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32063; /* *nxorv128bi */

        case E_V256BImode:
          if (pattern195 (x3, 
E_V256BImode) != 0
              || !(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32066; /* *nxorv256bi */

        case E_V512BImode:
          if (pattern195 (x3, 
E_V512BImode) != 0
              || !(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32069; /* *nxorv512bi */

        case E_V1024BImode:
          if (pattern195 (x3, 
E_V1024BImode) != 0
              || !(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32072; /* *nxorv1024bi */

        case E_V2048BImode:
          if (pattern195 (x3, 
E_V2048BImode) != 0
              || !(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32075; /* *nxorv2048bi */

        case E_V4096BImode:
          if (pattern195 (x3, 
E_V4096BImode) != 0
              || !(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32078; /* *nxorv4096bi */

        default:
          return -1;
        }

    case AND:
      switch (pattern196 (x3))
        {
        case 0:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 32019; /* *nandrvvmf64bi */

        case 1:
          if (!
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32022; /* *nandrvvmf32bi */

        case 2:
          if (!
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32025; /* *nandrvvmf16bi */

        case 3:
          if (!
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32028; /* *nandrvvmf8bi */

        case 4:
          if (!
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32031; /* *nandrvvmf4bi */

        case 5:
          if (!
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32034; /* *nandrvvmf2bi */

        case 6:
          if (!
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32037; /* *nandrvvm1bi */

        case 7:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 32040; /* *nandv1bi */

        case 8:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 32043; /* *nandv2bi */

        case 9:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 32046; /* *nandv4bi */

        case 10:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 32049; /* *nandv8bi */

        case 11:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 32052; /* *nandv16bi */

        case 12:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 32055; /* *nandv32bi */

        case 13:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32058; /* *nandv64bi */

        case 14:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32061; /* *nandv128bi */

        case 15:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32064; /* *nandv256bi */

        case 16:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32067; /* *nandv512bi */

        case 17:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32070; /* *nandv1024bi */

        case 18:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32073; /* *nandv2048bi */

        case 19:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32076; /* *nandv4096bi */

        default:
          return -1;
        }

    case IOR:
      switch (pattern196 (x3))
        {
        case 0:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 32020; /* *niorrvvmf64bi */

        case 1:
          if (!
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32023; /* *niorrvvmf32bi */

        case 2:
          if (!
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32026; /* *niorrvvmf16bi */

        case 3:
          if (!
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32029; /* *niorrvvmf8bi */

        case 4:
          if (!
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32032; /* *niorrvvmf4bi */

        case 5:
          if (!
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32035; /* *niorrvvmf2bi */

        case 6:
          if (!
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32038; /* *niorrvvm1bi */

        case 7:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 32041; /* *niorv1bi */

        case 8:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 32044; /* *niorv2bi */

        case 9:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 32047; /* *niorv4bi */

        case 10:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 32050; /* *niorv8bi */

        case 11:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 32053; /* *niorv16bi */

        case 12:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 32056; /* *niorv32bi */

        case 13:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32059; /* *niorv64bi */

        case 14:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32062; /* *niorv128bi */

        case 15:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32065; /* *niorv256bi */

        case 16:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32068; /* *niorv512bi */

        case 17:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32071; /* *niorv1024bi */

        case 18:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32074; /* *niorv2048bi */

        case 19:
          if (!(
#line 1437 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32077; /* *niorv4096bi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1497 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern1 (x1))
    {
    case 0:
      if (!
#line 1416 "../../../gcc/config/riscv/riscv.md"
(TARGET_DIV))
        return -1;
      return 38; /* *modsi3 */

    case 1:
      if (!
#line 1443 "../../../gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 42; /* moddi3 */

    case 2:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24553; /* modrvvm8qi3 */

    case 3:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24567; /* modrvvm4qi3 */

    case 4:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24581; /* modrvvm2qi3 */

    case 5:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24595; /* modrvvm1qi3 */

    case 6:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24609; /* modrvvm8hi3 */

    case 7:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24623; /* modrvvm4hi3 */

    case 8:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24637; /* modrvvm2hi3 */

    case 9:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24651; /* modrvvm1hi3 */

    case 10:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24665; /* modrvvm8si3 */

    case 11:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24679; /* modrvvm4si3 */

    case 12:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24693; /* modrvvm2si3 */

    case 13:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24707; /* modrvvm1si3 */

    case 14:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24721; /* modrvvm8di3 */

    case 15:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24735; /* modrvvm4di3 */

    case 16:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24749; /* modrvvm2di3 */

    case 17:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24763; /* modrvvm1di3 */

    case 18:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24777; /* modrvvmf2qi3 */

    case 19:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24791; /* modrvvmf4qi3 */

    case 20:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24805; /* modrvvmf8qi3 */

    case 21:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24819; /* modrvvmf2hi3 */

    case 22:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24833; /* modrvvmf4hi3 */

    case 23:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24847; /* modrvvmf2si3 */

    case 24:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24861; /* modv1qi3 */

    case 25:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24875; /* modv2qi3 */

    case 26:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24889; /* modv4qi3 */

    case 27:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24903; /* modv8qi3 */

    case 28:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24917; /* modv16qi3 */

    case 29:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24931; /* modv32qi3 */

    case 30:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24945; /* modv64qi3 */

    case 31:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24959; /* modv128qi3 */

    case 32:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24973; /* modv256qi3 */

    case 33:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24987; /* modv512qi3 */

    case 34:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25001; /* modv1024qi3 */

    case 35:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25015; /* modv2048qi3 */

    case 36:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25029; /* modv4096qi3 */

    case 37:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25043; /* modv1hi3 */

    case 38:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25057; /* modv2hi3 */

    case 39:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25071; /* modv4hi3 */

    case 40:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25085; /* modv8hi3 */

    case 41:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25099; /* modv16hi3 */

    case 42:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25113; /* modv32hi3 */

    case 43:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25127; /* modv64hi3 */

    case 44:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25141; /* modv128hi3 */

    case 45:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25155; /* modv256hi3 */

    case 46:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25169; /* modv512hi3 */

    case 47:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25183; /* modv1024hi3 */

    case 48:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25197; /* modv2048hi3 */

    case 49:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25211; /* modv1si3 */

    case 50:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25225; /* modv2si3 */

    case 51:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25239; /* modv4si3 */

    case 52:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25253; /* modv8si3 */

    case 53:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25267; /* modv16si3 */

    case 54:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25281; /* modv32si3 */

    case 55:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25295; /* modv64si3 */

    case 56:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25309; /* modv128si3 */

    case 57:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25323; /* modv256si3 */

    case 58:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25337; /* modv512si3 */

    case 59:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25351; /* modv1024si3 */

    case 60:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25365; /* modv1di3 */

    case 61:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25379; /* modv2di3 */

    case 62:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25393; /* modv4di3 */

    case 63:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25407; /* modv8di3 */

    case 64:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25421; /* modv16di3 */

    case 65:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25435; /* modv32di3 */

    case 66:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25449; /* modv64di3 */

    case 67:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25463; /* modv128di3 */

    case 68:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25477; /* modv256di3 */

    case 69:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25491; /* modv512di3 */

    default:
      return -1;
    }
}

 int
recog_1507 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return recog_22 (x1, insn, pnum_clobbers);

    case FMA:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case NEG:
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern398 (x3, 
E_SFmode) != 0
                      || !(
#line 1556 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                    return -1;
                  return 66; /* *fmasf4 */

                case E_DFmode:
                  if (pattern398 (x3, 
E_DFmode) != 0
                      || !(
#line 1556 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 67; /* *fmadf4 */

                case E_HFmode:
                  if (pattern398 (x3, 
E_HFmode) != 0
                      || !(
#line 1556 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (HFmode)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 68; /* *fmahf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern399 (x3, 
E_SFmode) != 0
                      || !(
#line 1569 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                    return -1;
                  return 69; /* *fmssf4 */

                case E_DFmode:
                  if (pattern399 (x3, 
E_DFmode) != 0
                      || !(
#line 1569 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 70; /* *fmsdf4 */

                case E_HFmode:
                  if (pattern399 (x3, 
E_HFmode) != 0
                      || !(
#line 1569 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (HFmode)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 71; /* *fmshf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern400 (x3, 
E_SFmode) != 0
                      || !(
#line 1582 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                    return -1;
                  return 72; /* *fnmssf4 */

                case E_DFmode:
                  if (pattern400 (x3, 
E_DFmode) != 0
                      || !(
#line 1582 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 73; /* *fnmsdf4 */

                case E_HFmode:
                  if (pattern400 (x3, 
E_HFmode) != 0
                      || !(
#line 1582 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (HFmode)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 74; /* *fnmshf4 */

                default:
                  return -1;
                }

            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern401 (x3, 
E_SFmode) != 0
                      || !(
#line 1595 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                    return -1;
                  return 75; /* *fnmasf4 */

                case E_DFmode:
                  if (pattern401 (x3, 
E_DFmode) != 0
                      || !(
#line 1595 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 76; /* *fnmadf4 */

                case E_HFmode:
                  if (pattern401 (x3, 
E_HFmode) != 0
                      || !(
#line 1595 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (HFmode)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 77; /* *fnmahf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      switch (pattern146 (x3))
        {
        case 0:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 31964; /* *copysignrvvm8hf_neg */

        case 1:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 31965; /* *copysignrvvm4hf_neg */

        case 2:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 31966; /* *copysignrvvm2hf_neg */

        case 3:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 31967; /* *copysignrvvm1hf_neg */

        case 4:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 31968; /* *copysignrvvmf2hf_neg */

        case 5:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 31969; /* *copysignrvvmf4hf_neg */

        case 6:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31970; /* *copysignrvvm8sf_neg */

        case 7:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31971; /* *copysignrvvm4sf_neg */

        case 8:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31972; /* *copysignrvvm2sf_neg */

        case 9:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31973; /* *copysignrvvm1sf_neg */

        case 10:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 31974; /* *copysignrvvmf2sf_neg */

        case 11:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31975; /* *copysignrvvm8df_neg */

        case 12:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31976; /* *copysignrvvm4df_neg */

        case 13:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31977; /* *copysignrvvm2df_neg */

        case 14:
          if (!(
#line 1402 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31978; /* *copysignrvvm1df_neg */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1512 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !
#line 3770 "../../../gcc/config/riscv/riscv.md"
(!is_zicfilp_p ()))
        return -1;
      return 444; /* tablejumpsi */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !(
#line 3770 "../../../gcc/config/riscv/riscv.md"
(!is_zicfilp_p ()) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 445; /* tablejumpdi */

    default:
      return -1;
    }
}

 int
recog_1515 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!absolute_symbolic_operand (operands[0], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      switch (pattern419 (
E_QImode))
        {
        case 0:
          if (!(
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            return -1;
          return 842; /* *local_pic_storeqi */

        case 1:
          if (!(
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          return 846; /* *local_pic_storeqi */

        default:
          return -1;
        }

    case E_HImode:
      switch (pattern419 (
E_HImode))
        {
        case 0:
          if (!(
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            return -1;
          return 843; /* *local_pic_storehi */

        case 1:
          if (!(
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          return 847; /* *local_pic_storehi */

        default:
          return -1;
        }

    case E_SImode:
      switch (pattern419 (
E_SImode))
        {
        case 0:
          if (!(
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            return -1;
          return 844; /* *local_pic_storesi */

        case 1:
          if (!(
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          return 848; /* *local_pic_storesi */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern419 (
E_DImode))
        {
        case 0:
          if (!(
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            return -1;
          return 845; /* *local_pic_storedi */

        case 1:
          if (!(
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          return 849; /* *local_pic_storedi */

        default:
          return -1;
        }

    case E_SFmode:
      switch (pattern420 (
E_SFmode))
        {
        case 0:
          if ((
#line 102 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 110 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            return 850; /* *local_pic_storesf */
          if (!(
#line 128 "../../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            return -1;
          return 862; /* *local_pic_store_sfsf */

        case 1:
          if ((
#line 102 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 110 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return 853; /* *local_pic_storesf */
          if (!(
#line 128 "../../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          return 865; /* *local_pic_store_sfsf */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern420 (
E_DFmode))
        {
        case 0:
          if ((
#line 102 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 111 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            return 851; /* *local_pic_storedf */
          if (!(
#line 128 "../../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            return -1;
          return 863; /* *local_pic_store_sfdf */

        case 1:
          if ((
#line 102 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 111 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return 854; /* *local_pic_storedf */
          if (!(
#line 128 "../../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          return 866; /* *local_pic_store_sfdf */

        default:
          return -1;
        }

    case E_HFmode:
      switch (pattern420 (
E_HFmode))
        {
        case 0:
          if ((
#line 102 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 112 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            return 852; /* *local_pic_storehf */
          if (!(
#line 128 "../../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            return -1;
          return 864; /* *local_pic_store_sfhf */

        case 1:
          if ((
#line 102 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 112 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return 855; /* *local_pic_storehf */
          if (!(
#line 128 "../../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          return 867; /* *local_pic_store_sfhf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1523 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case AND:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x7 = XEXP (x4, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              switch (pattern340 (x1))
                {
                case 0:
                  if (!(
#line 883 "../../../gcc/config/riscv/riscv.md"
((LUI_OPERAND (~INTVAL (operands[2]))
    && ((INTVAL (operands[2]) & (-INTVAL (operands[3])))
	== (-INTVAL (operands[3])))
    && riscv_const_insns (operands[3], false)
    && (riscv_const_insns (GEN_INT (~INTVAL (operands[2])
				    | -INTVAL (operands[3])), false)
	<= riscv_const_insns (operands[3], false)))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 10; /* *lui_constraintsi_and_to_or */

                case 1:
                  if (!(
#line 883 "../../../gcc/config/riscv/riscv.md"
((LUI_OPERAND (~INTVAL (operands[2]))
    && ((INTVAL (operands[2]) & (-INTVAL (operands[3])))
	== (-INTVAL (operands[3])))
    && riscv_const_insns (operands[3], false)
    && (riscv_const_insns (GEN_INT (~INTVAL (operands[2])
				    | -INTVAL (operands[3])), false)
	<= riscv_const_insns (operands[3], false)))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 11; /* *lui_constraintdi_and_to_or */

                default:
                  return -1;
                }

            case ASHIFT:
              if (GET_MODE (x7) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || GET_MODE (x4) != E_DImode)
                return -1;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x9 = XEXP (x7, 1);
              operands[2] = x9;
              if (!imm123_operand (operands[2], E_QImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[3] = x10;
              if (!consecutive_bits_operand (operands[3], E_DImode))
                return -1;
              x11 = XEXP (x3, 1);
              operands[4] = x11;
              if (!register_operand (operands[4], E_DImode))
                return -1;
              x12 = XEXP (x5, 0);
              operands[5] = x12;
              if (!scratch_operand (operands[5], E_DImode)
                  || !
#line 96 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA
   && riscv_shamt_matches_mask_p (INTVAL (operands[2]), INTVAL (operands[3]))
   && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))))
                return -1;
              return 511; /* *andi_add.uw */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || pattern403 (x1) != 0
              || !
#line 4684 "../../../gcc/config/riscv/riscv.md"
((TARGET_64BIT && riscv_const_insns (operands[3], false) == 1)))
            return -1;
          return 492; /* *riscv.md:4678 */

        case REG:
          if (pattern266 (x1, 
1) != 0)
            return -1;
          x11 = XEXP (x3, 1);
          operands[0] = x11;
          if (!stack_pop_up_to_ra_operand (operands[0], E_VOIDmode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          x13 = XEXP (x5, 1);
          x14 = XEXP (x13, 0);
          x15 = XEXP (x14, 1);
          switch (XWINT (x15, 0))
            {
            case -4L:
              if (pattern533 (x1, 
E_SImode) != 0
                  || !(
#line 28 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33679; /* gpr_multi_pop_up_to_ra_si */

            case -8L:
              if (pattern533 (x1, 
E_DImode) != 0
                  || !(
#line 28 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33680; /* gpr_multi_pop_up_to_ra_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_1522 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 3064 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))))
            return -1;
          return 333; /* *extractsi3 */

        case 1:
          if (!(
#line 3064 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 335; /* *extractdi3 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 3064 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))))
            return -1;
          return 334; /* *zero_extractsi3 */

        case 1:
          if (!(
#line 3064 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 336; /* *zero_extractdi3 */

        default:
          return -1;
        }

    case AND:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ASHIFT:
          if (pattern335 (x1) != 0
              || !
#line 3138 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_ZBA
   && ((INTVAL (operands[3]) >> INTVAL (operands[2])) == 0xffffffff)))
            return -1;
          return 337; /* zero_extendsidi2_shifted */

        case NOT:
          x7 = XEXP (x4, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              switch (pattern368 (x1))
                {
                case 0:
                  if (!(
#line 240 "../../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 519; /* *and_not_constsi */

                case 1:
                  if (!(
#line 240 "../../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 521; /* *and_not_constdi */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern364 (x1))
                {
                case 0:
                  if (!(
#line 734 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 611; /* *bitmanip.md:722 */

                case 1:
                  if (!(
#line 734 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 613; /* *bitmanip.md:722 */

                case 2:
                  if (!(
#line 762 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 615; /* *bitmanip.md:750 */

                case 3:
                  if (!(
#line 762 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 617; /* *bitmanip.md:750 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern364 (x1))
                {
                case 0:
                  if (!(
#line 734 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 612; /* *bitmanip.md:722 */

                case 1:
                  if (!(
#line 734 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 614; /* *bitmanip.md:722 */

                case 2:
                  if (!(
#line 762 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 616; /* *bitmanip.md:750 */

                case 3:
                  if (!(
#line 762 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 618; /* *bitmanip.md:750 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      return recog_1521 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      x6 = XEXP (x2, 0);
      switch (GET_CODE (x6))
        {
        case PC:
          res = recog_1512 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
        case MEM:
          res = recog_1518 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case REG:
          switch (REGNO (x3))
            {
            case 7:
              res = recog_1519 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case 69:
              if (GET_MODE (x3) == E_SImode)
                {
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) == SET)
                    {
                      x12 = XEXP (x5, 0);
                      if (GET_CODE (x12) == REG
                          && REGNO (x12) == 69
                          && GET_MODE (x12) == E_SImode)
                        {
                          operands[0] = x6;
                          if (register_operand (operands[0], E_SImode))
                            {
                              x13 = XEXP (x5, 1);
                              operands[1] = x13;
                              if (reg_or_int_operand (operands[1], E_SImode)
                                  && 
#line 1100 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                                return 2722; /* fsrmsi_backup */
                            }
                        }
                    }
                }
              break;

            case 1:
              res = recog_1520 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x3;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          operands[0] = x6;
          x12 = XEXP (x5, 0);
          operands[2] = x12;
          if (a0a1_reg_operand (operands[2], E_SImode)
              && a0a1_reg_operand (operands[0], E_SImode)
              && zcmp_mv_sreg_operand (operands[1], E_SImode))
            {
              x13 = XEXP (x5, 1);
              operands[3] = x13;
              if (zcmp_mv_sreg_operand (operands[3], E_SImode)
                  && (
#line 1443 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP
   && (REGNO (operands[2]) != REGNO (operands[0]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 33775; /* *mva01ssi */
            }
          if (!zcmp_mv_sreg_operand (operands[2], E_SImode)
              || !zcmp_mv_sreg_operand (operands[0], E_SImode)
              || !a0a1_reg_operand (operands[1], E_SImode))
            return -1;
          x13 = XEXP (x5, 1);
          operands[3] = x13;
          if (!a0a1_reg_operand (operands[3], E_SImode)
              || !(
#line 1454 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP
   && (REGNO (operands[0]) != REGNO (operands[2]))
   && (REGNO (operands[1]) != REGNO (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33777; /* *mvsa01si */

        case MEM:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          operands[0] = x6;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (!absolute_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          x12 = XEXP (x5, 0);
          operands[2] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              switch (pattern412 (x3, 
E_SFmode))
                {
                case 0:
                  if ((
#line 56 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 110 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                    return 827; /* *local_pic_loadsf */
                  if (!(
#line 72 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 110 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                    return -1;
                  return 833; /* *local_pic_load_32dsf */

                case 1:
                  if ((
#line 56 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 110 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                    return 830; /* *local_pic_loadsf */
                  if (!(
#line 72 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 110 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                    return -1;
                  return 836; /* *local_pic_load_32dsf */

                default:
                  return -1;
                }

            case E_DFmode:
              switch (pattern412 (x3, 
E_DFmode))
                {
                case 0:
                  if ((
#line 56 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 111 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                    return 828; /* *local_pic_loaddf */
                  if (!(
#line 72 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 111 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                    return -1;
                  return 834; /* *local_pic_load_32ddf */

                case 1:
                  if ((
#line 56 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 111 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                    return 831; /* *local_pic_loaddf */
                  if (!(
#line 72 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 111 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                    return -1;
                  return 837; /* *local_pic_load_32ddf */

                default:
                  return -1;
                }

            case E_HFmode:
              switch (pattern412 (x3, 
E_HFmode))
                {
                case 0:
                  if ((
#line 56 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 112 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                    return 829; /* *local_pic_loadhf */
                  if (!(
#line 72 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 112 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                    return -1;
                  return 835; /* *local_pic_load_32dhf */

                case 1:
                  if ((
#line 56 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 112 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                    return 832; /* *local_pic_loadhf */
                  if (!(
#line 72 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 112 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                    return -1;
                  return 838; /* *local_pic_load_32dhf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern267 (x5) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!call_insn_operand (operands[1], E_VOIDmode))
        return -1;
      x11 = XEXP (x3, 1);
      operands[2] = x11;
      x12 = XEXP (x5, 0);
      x16 = XVECEXP (x12, 0, 0);
      operands[3] = x16;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      if (
#line 3961 "../../../gcc/config/riscv/riscv.md"
(SIBLING_CALL_P (insn)))
        return 455; /* sibcall_value_internal */
      if (pnum_clobbers == NULL)
        return -1;
      *pnum_clobbers = 1;
      return 457; /* call_value_internal */

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          switch (pattern404 (x1))
            {
            case 0:
              if (!
#line 4553 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT
   && (INTVAL (operands[3]) | ((1 << INTVAL (operands[2])) - 1)) == 0xffffffff))
                return -1;
              return 491; /* *riscv.md:4543 */

            case 1:
              if (!
#line 4700 "../../../gcc/config/riscv/riscv.md"
((TARGET_64BIT && riscv_const_insns (operands[3], false) == 1)))
                return -1;
              return 493; /* *riscv.md:4693 */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern365 (x1))
            {
            case 0:
              if (!(
#line 636 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 589; /* *bitmanip.md:628 */

            case 1:
              if (!(
#line 636 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 591; /* *bitmanip.md:628 */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          if (pattern366 (x1, 
SIGN_EXTEND) != 0
              || !
#line 437 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMPAIR && TARGET_64BIT && reload_completed
   && th_mempair_operands_p (operands, true, SImode)))
            return -1;
          return 917; /* *th_mempair_load_extendsidi2 */

        default:
          return -1;
        }

    case IOR:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case NOT:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          switch (pattern368 (x1))
            {
            case 0:
              if (!(
#line 240 "../../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 520; /* *ior_not_constsi */

            case 1:
              if (!(
#line 240 "../../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 522; /* *ior_not_constdi */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern337 (x1))
            {
            case 0:
              if (!(
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 595; /* *bitmanip.md:673 */

            case 1:
              if (!(
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 599; /* *bitmanip.md:673 */

            case 2:
              if (!(
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 603; /* *bitmanip.md:699 */

            case 3:
              if (!(
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 607; /* *bitmanip.md:699 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern337 (x1))
            {
            case 0:
              if (!(
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 597; /* *bitmanip.md:673 */

            case 1:
              if (!(
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 601; /* *bitmanip.md:673 */

            case 2:
              if (!(
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 605; /* *bitmanip.md:699 */

            case 3:
              if (!(
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 609; /* *bitmanip.md:699 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ASHIFT:
          switch (pattern365 (x1))
            {
            case 0:
              if (!(
#line 636 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 590; /* *bitmanip.md:628 */

            case 1:
              if (!(
#line 636 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 592; /* *bitmanip.md:628 */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          if (pattern366 (x1, 
ZERO_EXTEND) != 0
              || !
#line 451 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMPAIR && TARGET_64BIT && reload_completed
   && th_mempair_operands_p (operands, true, SImode)))
            return -1;
          return 918; /* *th_mempair_load_zero_extendsidi2 */

        default:
          return -1;
        }

    case XOR:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x11 = XEXP (x3, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[4] = x12;
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          x7 = XEXP (x4, 0);
          switch (pattern434 (x7))
            {
            case 0:
              if (!(
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 596; /* *bitmanip.md:673 */

            case 1:
              if (!(
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 600; /* *bitmanip.md:673 */

            case 2:
              if (!(
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 604; /* *bitmanip.md:699 */

            case 3:
              if (!(
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 608; /* *bitmanip.md:699 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x7 = XEXP (x4, 0);
          switch (pattern434 (x7))
            {
            case 0:
              if (!(
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 598; /* *bitmanip.md:673 */

            case 1:
              if (!(
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 602; /* *bitmanip.md:673 */

            case 2:
              if (!(
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 606; /* *bitmanip.md:699 */

            case 3:
              if (!(
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 610; /* *bitmanip.md:699 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 2)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x17 = XVECEXP (x3, 0, 1);
      if (!const_int_operand (x17, E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 80:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          operands[2] = x17;
          x12 = XEXP (x5, 0);
          operands[3] = x12;
          x18 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x18))
            {
            case PLUS:
              switch (pattern422 (x3))
                {
                case 0:
                  if (!
#line 140 "../../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  return 736; /* lrsc_atomic_addsi */

                case 1:
                  if (!(
#line 140 "../../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 740; /* lrsc_atomic_adddi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern422 (x3))
                {
                case 0:
                  if (!
#line 140 "../../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  return 737; /* lrsc_atomic_orsi */

                case 1:
                  if (!(
#line 140 "../../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 741; /* lrsc_atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern422 (x3))
                {
                case 0:
                  if (!
#line 140 "../../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  return 738; /* lrsc_atomic_xorsi */

                case 1:
                  if (!(
#line 140 "../../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 742; /* lrsc_atomic_xordi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern422 (x3))
                {
                case 0:
                  if (!
#line 140 "../../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  return 739; /* lrsc_atomic_andsi */

                case 1:
                  if (!(
#line 140 "../../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 743; /* lrsc_atomic_anddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 83:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x18 = XVECEXP (x3, 0, 0);
          operands[1] = x18;
          operands[3] = x17;
          x13 = XEXP (x5, 1);
          operands[2] = x13;
          x12 = XEXP (x5, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern438 (x3, 
E_SImode) != 0)
                return -1;
              if (
#line 396 "../../../gcc/config/riscv/sync.md"
(TARGET_ZAAMO))
                return 773; /* amo_atomic_exchangesi */
              if (pnum_clobbers == NULL
                  || !
#line 410 "../../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                return -1;
              *pnum_clobbers = 1;
              return 775; /* lrsc_atomic_exchangesi */

            case E_DImode:
              if (pattern438 (x3, 
E_DImode) != 0)
                return -1;
              if ((
#line 396 "../../../gcc/config/riscv/sync.md"
(TARGET_ZAAMO) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 774; /* amo_atomic_exchangedi */
              if (pnum_clobbers == NULL
                  || !(
#line 410 "../../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 776; /* lrsc_atomic_exchangedi */

            default:
              return -1;
            }

        case 85:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x18 = XVECEXP (x3, 0, 0);
          operands[1] = x18;
          operands[3] = x17;
          x13 = XEXP (x5, 1);
          operands[2] = x13;
          x12 = XEXP (x5, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern438 (x3, 
E_QImode) != 0
                  || !
#line 445 "../../../gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                return -1;
              return 777; /* zabha_atomic_exchangeqi */

            case E_HImode:
              if (pattern438 (x3, 
E_HImode) != 0
                  || !
#line 445 "../../../gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                return -1;
              return 778; /* zabha_atomic_exchangehi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      if (pattern138 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode) != 0
          || !(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9362 (insn, operands);

    case E_RVVM4HImode:
      if (pattern138 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0
          || !(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9364 (insn, operands);

    case E_RVVM2HImode:
      if (pattern138 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0
          || !(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9366 (insn, operands);

    case E_RVVM1HImode:
      if (pattern138 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0
          || !(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9368 (insn, operands);

    case E_RVVMF2HImode:
      if (pattern138 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0
          || !(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9370 (insn, operands);

    case E_RVVMF4HImode:
      if (pattern138 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9372 (insn, operands);

    case E_RVVM8SImode:
      if (pattern138 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0
          || !(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9374 (insn, operands);

    case E_RVVM4SImode:
      if (pattern138 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0
          || !(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9376 (insn, operands);

    case E_RVVM2SImode:
      if (pattern138 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0
          || !(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9378 (insn, operands);

    case E_RVVM1SImode:
      if (pattern138 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0
          || !(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9380 (insn, operands);

    case E_RVVMF2SImode:
      if (pattern138 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9382 (insn, operands);

    case E_RVVM8DImode:
      if (pattern138 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9384 (insn, operands);

    case E_RVVM4DImode:
      if (pattern138 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9386 (insn, operands);

    case E_RVVM2DImode:
      if (pattern138 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9388 (insn, operands);

    case E_RVVM1DImode:
      if (pattern138 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9390 (insn, operands);

    case E_V1HImode:
      if (pattern138 (x2, 
E_V1HImode, 
E_V1QImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9392 (insn, operands);

    case E_V2HImode:
      if (pattern138 (x2, 
E_V2HImode, 
E_V2QImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9394 (insn, operands);

    case E_V4HImode:
      if (pattern138 (x2, 
E_V4HImode, 
E_V4QImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9396 (insn, operands);

    case E_V8HImode:
      if (pattern138 (x2, 
E_V8HImode, 
E_V8QImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9398 (insn, operands);

    case E_V16HImode:
      if (pattern138 (x2, 
E_V16HImode, 
E_V16QImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9400 (insn, operands);

    case E_V32HImode:
      if (pattern138 (x2, 
E_V32HImode, 
E_V32QImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9402 (insn, operands);

    case E_V64HImode:
      if (pattern138 (x2, 
E_V64HImode, 
E_V64QImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9404 (insn, operands);

    case E_V128HImode:
      if (pattern138 (x2, 
E_V128HImode, 
E_V128QImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9406 (insn, operands);

    case E_V256HImode:
      if (pattern138 (x2, 
E_V256HImode, 
E_V256QImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9408 (insn, operands);

    case E_V512HImode:
      if (pattern138 (x2, 
E_V512HImode, 
E_V512QImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9410 (insn, operands);

    case E_V1024HImode:
      if (pattern138 (x2, 
E_V1024HImode, 
E_V1024QImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9412 (insn, operands);

    case E_V2048HImode:
      if (pattern138 (x2, 
E_V2048HImode, 
E_V2048QImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9414 (insn, operands);

    case E_V1SImode:
      if (pattern138 (x2, 
E_V1SImode, 
E_V1HImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9416 (insn, operands);

    case E_V2SImode:
      if (pattern138 (x2, 
E_V2SImode, 
E_V2HImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9418 (insn, operands);

    case E_V4SImode:
      if (pattern138 (x2, 
E_V4SImode, 
E_V4HImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9420 (insn, operands);

    case E_V8SImode:
      if (pattern138 (x2, 
E_V8SImode, 
E_V8HImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9422 (insn, operands);

    case E_V16SImode:
      if (pattern138 (x2, 
E_V16SImode, 
E_V16HImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9424 (insn, operands);

    case E_V32SImode:
      if (pattern138 (x2, 
E_V32SImode, 
E_V32HImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9426 (insn, operands);

    case E_V64SImode:
      if (pattern138 (x2, 
E_V64SImode, 
E_V64HImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9428 (insn, operands);

    case E_V128SImode:
      if (pattern138 (x2, 
E_V128SImode, 
E_V128HImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9430 (insn, operands);

    case E_V256SImode:
      if (pattern138 (x2, 
E_V256SImode, 
E_V256HImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9432 (insn, operands);

    case E_V512SImode:
      if (pattern138 (x2, 
E_V512SImode, 
E_V512HImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9434 (insn, operands);

    case E_V1024SImode:
      if (pattern138 (x2, 
E_V1024SImode, 
E_V1024HImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9436 (insn, operands);

    case E_V1DImode:
      if (pattern138 (x2, 
E_V1DImode, 
E_V1SImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9438 (insn, operands);

    case E_V2DImode:
      if (pattern138 (x2, 
E_V2DImode, 
E_V2SImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9440 (insn, operands);

    case E_V4DImode:
      if (pattern138 (x2, 
E_V4DImode, 
E_V4SImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9442 (insn, operands);

    case E_V8DImode:
      if (pattern138 (x2, 
E_V8DImode, 
E_V8SImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9444 (insn, operands);

    case E_V16DImode:
      if (pattern138 (x2, 
E_V16DImode, 
E_V16SImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9446 (insn, operands);

    case E_V32DImode:
      if (pattern138 (x2, 
E_V32DImode, 
E_V32SImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9448 (insn, operands);

    case E_V64DImode:
      if (pattern138 (x2, 
E_V64DImode, 
E_V64SImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9450 (insn, operands);

    case E_V128DImode:
      if (pattern138 (x2, 
E_V128DImode, 
E_V128SImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9452 (insn, operands);

    case E_V256DImode:
      if (pattern138 (x2, 
E_V256DImode, 
E_V256SImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9454 (insn, operands);

    case E_V512DImode:
      if (pattern138 (x2, 
E_V512DImode, 
E_V512SImode) != 0
          || !((
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 977 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9456 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode))
            return NULL;
          if ((
#line 1878 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_ZBA && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX
   && !(REG_P (operands[1]) && VL_REG_P (REGNO (operands[1])))) && 
#line 1883 "../../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_5 (insn, operands);
          if (!(
#line 500 "../../../gcc/config/riscv/thead.md"
(TARGET_64BIT && TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 508 "../../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return NULL;
          return gen_split_188 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return NULL;
          if (((
#line 1905 "../../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1909 "../../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_7 (insn, operands);
          if (!((
#line 524 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 532 "../../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return NULL;
          return gen_split_190 (insn, operands);

        default:
          return NULL;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !nonimmediate_operand (operands[1], E_HImode))
        return NULL;
      if ((
#line 1905 "../../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 1909 "../../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
        return gen_split_6 (insn, operands);
      if (!(
#line 524 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 532 "../../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
        return NULL;
      return gen_split_189 (insn, operands);

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode)
          || GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4150 (insn, operands);

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4152 (insn, operands);

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4154 (insn, operands);

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4156 (insn, operands);

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4158 (insn, operands);

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4160 (insn, operands);

    case E_RVVM8SImode:
      switch (pattern291 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4162 (insn, operands);

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4246 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVM4SImode:
      switch (pattern292 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4164 (insn, operands);

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4248 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVM2SImode:
      switch (pattern293 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4166 (insn, operands);

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4250 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVM1SImode:
      switch (pattern294 (x2))
        {
        case 0:
          if (!(
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4168 (insn, operands);

        case 1:
          if (!(
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4252 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVMF2SImode:
      switch (pattern295 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4170 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4254 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVM8DImode:
      switch (pattern296 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4172 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4256 (insn, operands);

        case 2:
          if (!((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4306 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVM4DImode:
      switch (pattern297 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4174 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4258 (insn, operands);

        case 2:
          if (!((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4308 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVM2DImode:
      switch (pattern298 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4176 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4260 (insn, operands);

        case 2:
          if (!((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4310 (insn, operands);

        default:
          return NULL;
        }

    case E_RVVM1DImode:
      switch (pattern299 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4178 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4262 (insn, operands);

        case 2:
          if (!((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4312 (insn, operands);

        default:
          return NULL;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1QImode)
          || !((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4180 (insn, operands);

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2QImode)
          || !((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4182 (insn, operands);

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4QImode)
          || !((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4184 (insn, operands);

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8QImode)
          || !((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4186 (insn, operands);

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16QImode)
          || !((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4188 (insn, operands);

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32QImode)
          || !((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4190 (insn, operands);

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64QImode)
          || !((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4192 (insn, operands);

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128QImode)
          || !((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4194 (insn, operands);

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256QImode)
          || !((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4196 (insn, operands);

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512QImode)
          || !((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4198 (insn, operands);

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024QImode)
          || !((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4200 (insn, operands);

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode)
          || GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048QImode)
          || !((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4202 (insn, operands);

    case E_V1SImode:
      switch (pattern300 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4204 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4264 (insn, operands);

        default:
          return NULL;
        }

    case E_V2SImode:
      switch (pattern301 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4206 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4266 (insn, operands);

        default:
          return NULL;
        }

    case E_V4SImode:
      switch (pattern302 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4208 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4268 (insn, operands);

        default:
          return NULL;
        }

    case E_V8SImode:
      switch (pattern303 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4210 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4270 (insn, operands);

        default:
          return NULL;
        }

    case E_V16SImode:
      switch (pattern304 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4212 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4272 (insn, operands);

        default:
          return NULL;
        }

    case E_V32SImode:
      switch (pattern305 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4214 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4274 (insn, operands);

        default:
          return NULL;
        }

    case E_V64SImode:
      switch (pattern306 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4216 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4276 (insn, operands);

        default:
          return NULL;
        }

    case E_V128SImode:
      switch (pattern307 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4218 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4278 (insn, operands);

        default:
          return NULL;
        }

    case E_V256SImode:
      switch (pattern308 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4220 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4280 (insn, operands);

        default:
          return NULL;
        }

    case E_V512SImode:
      switch (pattern309 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4222 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4282 (insn, operands);

        default:
          return NULL;
        }

    case E_V1024SImode:
      switch (pattern310 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4224 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4284 (insn, operands);

        default:
          return NULL;
        }

    case E_V1DImode:
      switch (pattern311 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4226 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4286 (insn, operands);

        case 2:
          if (!((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4314 (insn, operands);

        default:
          return NULL;
        }

    case E_V2DImode:
      switch (pattern312 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4228 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4288 (insn, operands);

        case 2:
          if (!((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4316 (insn, operands);

        default:
          return NULL;
        }

    case E_V4DImode:
      switch (pattern313 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4230 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4290 (insn, operands);

        case 2:
          if (!((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4318 (insn, operands);

        default:
          return NULL;
        }

    case E_V8DImode:
      switch (pattern314 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4232 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4292 (insn, operands);

        case 2:
          if (!((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4320 (insn, operands);

        default:
          return NULL;
        }

    case E_V16DImode:
      switch (pattern315 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4234 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4294 (insn, operands);

        case 2:
          if (!((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4322 (insn, operands);

        default:
          return NULL;
        }

    case E_V32DImode:
      switch (pattern316 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4236 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4296 (insn, operands);

        case 2:
          if (!((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4324 (insn, operands);

        default:
          return NULL;
        }

    case E_V64DImode:
      switch (pattern317 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4238 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4298 (insn, operands);

        case 2:
          if (!((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4326 (insn, operands);

        default:
          return NULL;
        }

    case E_V128DImode:
      switch (pattern318 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4240 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4300 (insn, operands);

        case 2:
          if (!((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4328 (insn, operands);

        default:
          return NULL;
        }

    case E_V256DImode:
      switch (pattern319 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4242 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4302 (insn, operands);

        case 2:
          if (!((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4330 (insn, operands);

        default:
          return NULL;
        }

    case E_V512DImode:
      switch (pattern320 (x2))
        {
        case 0:
          if (!((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4244 (insn, operands);

        case 1:
          if (!((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4304 (insn, operands);

        case 2:
          if (!((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4332 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_77 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64SImode)
      && reg_or_mem_operand (operands[1], E_V64SImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return gen_split_275 (insn, operands);
  if (!register_operand (operands[0], E_V64SImode)
      || !register_operand (operands[1], E_V64SImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2122 (insn, operands);
}

 rtx_insn *
split_84 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64HImode)
      && reg_or_mem_operand (operands[1], E_V64HImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return gen_split_263 (insn, operands);
  if (!register_operand (operands[0], E_V64HImode)
      || !register_operand (operands[1], E_V64HImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2110 (insn, operands);
}

 rtx_insn *
split_91 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128QImode)
      && reg_or_mem_operand (operands[1], E_V128QImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return gen_split_251 (insn, operands);
  if (!register_operand (operands[0], E_V128QImode)
      || !register_operand (operands[1], E_V128QImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2098 (insn, operands);
}

 rtx_insn *
split_99 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF32BImode)
      && reg_or_mem_operand (operands[1], E_RVVMF32BImode)
      && 
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_238 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF32BImode)
      || !register_operand (operands[1], E_RVVMF32BImode)
      || !(
#line 1294 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1575 (insn, operands);
}

 rtx_insn *
split_106 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF2SImode)
      && reg_or_mem_operand (operands[1], E_RVVMF2SImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return gen_split_215 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF2SImode)
      || !register_operand (operands[1], E_RVVMF2SImode)
      || !((
#line 1257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1259 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1572 (insn, operands);
}

 rtx_insn *
split_113 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern271 (x2))
    {
    case 0:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3540 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3744 (insn, operands);

    case 1:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3543 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3747 (insn, operands);

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3546 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3750 (insn, operands);

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3549 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3753 (insn, operands);

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3552 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3756 (insn, operands);

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3555 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3759 (insn, operands);

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3558 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3762 (insn, operands);

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3561 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3765 (insn, operands);

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3564 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3768 (insn, operands);

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3567 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3771 (insn, operands);

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3570 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3774 (insn, operands);

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3573 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3777 (insn, operands);

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3576 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3780 (insn, operands);

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3579 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3783 (insn, operands);

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3582 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3786 (insn, operands);

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3585 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3789 (insn, operands);

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3588 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3792 (insn, operands);

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3591 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3795 (insn, operands);

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3594 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3798 (insn, operands);

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3597 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3801 (insn, operands);

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3600 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3804 (insn, operands);

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3603 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3807 (insn, operands);

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3606 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3810 (insn, operands);

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3609 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3813 (insn, operands);

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3612 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3816 (insn, operands);

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3615 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3819 (insn, operands);

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3618 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3822 (insn, operands);

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3621 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3825 (insn, operands);

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3624 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3828 (insn, operands);

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3627 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3831 (insn, operands);

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3630 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3834 (insn, operands);

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3633 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3837 (insn, operands);

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3636 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3840 (insn, operands);

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3639 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3843 (insn, operands);

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3642 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3846 (insn, operands);

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3645 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3849 (insn, operands);

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3648 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3852 (insn, operands);

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3651 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3855 (insn, operands);

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3654 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3858 (insn, operands);

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3657 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3861 (insn, operands);

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3660 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3864 (insn, operands);

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3663 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3867 (insn, operands);

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3666 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3870 (insn, operands);

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3669 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3873 (insn, operands);

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3672 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3876 (insn, operands);

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3675 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3879 (insn, operands);

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3678 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3882 (insn, operands);

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3681 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3885 (insn, operands);

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3684 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3888 (insn, operands);

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3687 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3891 (insn, operands);

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3690 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3894 (insn, operands);

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3693 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3897 (insn, operands);

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3696 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3900 (insn, operands);

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3699 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3903 (insn, operands);

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3702 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3906 (insn, operands);

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3705 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3909 (insn, operands);

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3708 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3912 (insn, operands);

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3711 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3915 (insn, operands);

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3714 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3918 (insn, operands);

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3717 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3921 (insn, operands);

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3720 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3924 (insn, operands);

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3723 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3927 (insn, operands);

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3726 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3930 (insn, operands);

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3729 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3933 (insn, operands);

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3732 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3936 (insn, operands);

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3735 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3939 (insn, operands);

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3738 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3942 (insn, operands);

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 490 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3741 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !((
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 515 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3945 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_122 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 141:
      return split_120 (x1, insn);

    case 144:
      switch (pattern246 (x2))
        {
        case 0:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6189 (insn, operands);

        case 1:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6190 (insn, operands);

        case 2:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6191 (insn, operands);

        case 3:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6192 (insn, operands);

        case 4:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6193 (insn, operands);

        case 5:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6194 (insn, operands);

        case 6:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6204 (insn, operands);

        case 7:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6205 (insn, operands);

        case 8:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6206 (insn, operands);

        case 9:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6207 (insn, operands);

        case 10:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6208 (insn, operands);

        case 11:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6209 (insn, operands);

        case 12:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6210 (insn, operands);

        case 13:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6211 (insn, operands);

        case 14:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6212 (insn, operands);

        case 15:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6213 (insn, operands);

        case 16:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6214 (insn, operands);

        case 17:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6215 (insn, operands);

        case 18:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6195 (insn, operands);

        case 19:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6196 (insn, operands);

        case 20:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6197 (insn, operands);

        case 21:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6198 (insn, operands);

        case 22:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6199 (insn, operands);

        case 23:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6216 (insn, operands);

        case 24:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6217 (insn, operands);

        case 25:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6218 (insn, operands);

        case 26:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6219 (insn, operands);

        case 27:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6220 (insn, operands);

        case 28:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6221 (insn, operands);

        case 29:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6222 (insn, operands);

        case 30:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6223 (insn, operands);

        case 31:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6224 (insn, operands);

        case 32:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6225 (insn, operands);

        case 33:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6226 (insn, operands);

        case 34:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6200 (insn, operands);

        case 35:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6201 (insn, operands);

        case 36:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6202 (insn, operands);

        case 37:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6203 (insn, operands);

        case 38:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6227 (insn, operands);

        case 39:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6228 (insn, operands);

        case 40:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6229 (insn, operands);

        case 41:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6230 (insn, operands);

        case 42:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6231 (insn, operands);

        case 43:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6232 (insn, operands);

        case 44:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6233 (insn, operands);

        case 45:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6234 (insn, operands);

        case 46:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6235 (insn, operands);

        case 47:
          if (!((
#line 2300 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 2302 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_6236 (insn, operands);

        case 48:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9080 (insn, operands);

        case 49:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9081 (insn, operands);

        case 50:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9082 (insn, operands);

        case 51:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9083 (insn, operands);

        case 52:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9084 (insn, operands);

        case 53:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9089 (insn, operands);

        case 54:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9090 (insn, operands);

        case 55:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9091 (insn, operands);

        case 56:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9092 (insn, operands);

        case 57:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9093 (insn, operands);

        case 58:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9094 (insn, operands);

        case 59:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9095 (insn, operands);

        case 60:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9096 (insn, operands);

        case 61:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9097 (insn, operands);

        case 62:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9098 (insn, operands);

        case 63:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9099 (insn, operands);

        case 64:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9085 (insn, operands);

        case 65:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9086 (insn, operands);

        case 66:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9087 (insn, operands);

        case 67:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9088 (insn, operands);

        case 68:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9100 (insn, operands);

        case 69:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9101 (insn, operands);

        case 70:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9102 (insn, operands);

        case 71:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9103 (insn, operands);

        case 72:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9104 (insn, operands);

        case 73:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9105 (insn, operands);

        case 74:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9106 (insn, operands);

        case 75:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9107 (insn, operands);

        case 76:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9108 (insn, operands);

        case 77:
          if (!((
#line 828 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 830 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9109 (insn, operands);

        case 78:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9890 (insn, operands);

        case 79:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9891 (insn, operands);

        case 80:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9892 (insn, operands);

        case 81:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9893 (insn, operands);

        case 82:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9894 (insn, operands);

        case 83:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9899 (insn, operands);

        case 84:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9900 (insn, operands);

        case 85:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9901 (insn, operands);

        case 86:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9902 (insn, operands);

        case 87:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9903 (insn, operands);

        case 88:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9904 (insn, operands);

        case 89:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9905 (insn, operands);

        case 90:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9906 (insn, operands);

        case 91:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9907 (insn, operands);

        case 92:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9908 (insn, operands);

        case 93:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9909 (insn, operands);

        case 94:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9895 (insn, operands);

        case 95:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9896 (insn, operands);

        case 96:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9897 (insn, operands);

        case 97:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9898 (insn, operands);

        case 98:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9910 (insn, operands);

        case 99:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9911 (insn, operands);

        case 100:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9912 (insn, operands);

        case 101:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9913 (insn, operands);

        case 102:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9914 (insn, operands);

        case 103:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9915 (insn, operands);

        case 104:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9916 (insn, operands);

        case 105:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9917 (insn, operands);

        case 106:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9918 (insn, operands);

        case 107:
          if (!((
#line 1319 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1321 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9919 (insn, operands);

        case 108:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9920 (insn, operands);

        case 109:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9921 (insn, operands);

        case 110:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9922 (insn, operands);

        case 111:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9923 (insn, operands);

        case 112:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9924 (insn, operands);

        case 113:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9929 (insn, operands);

        case 114:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9930 (insn, operands);

        case 115:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9931 (insn, operands);

        case 116:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9932 (insn, operands);

        case 117:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9933 (insn, operands);

        case 118:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9934 (insn, operands);

        case 119:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9935 (insn, operands);

        case 120:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9936 (insn, operands);

        case 121:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9937 (insn, operands);

        case 122:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9938 (insn, operands);

        case 123:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9939 (insn, operands);

        case 124:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9925 (insn, operands);

        case 125:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9926 (insn, operands);

        case 126:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9927 (insn, operands);

        case 127:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9928 (insn, operands);

        case 128:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9940 (insn, operands);

        case 129:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9941 (insn, operands);

        case 130:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9942 (insn, operands);

        case 131:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9943 (insn, operands);

        case 132:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9944 (insn, operands);

        case 133:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9945 (insn, operands);

        case 134:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9946 (insn, operands);

        case 135:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9947 (insn, operands);

        case 136:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9948 (insn, operands);

        case 137:
          if (!((
#line 1376 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1378 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9949 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_130 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_804 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_810 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_816 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_822 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_828 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_834 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_840 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_846 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_852 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_858 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_864 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_870 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_876 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_882 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_888 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_894 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_900 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_906 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_912 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_918 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_924 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_930 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_936 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_942 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_948 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_954 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_960 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_966 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_972 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_978 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_984 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_990 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_996 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_1002 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_1008 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_1014 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_1020 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_1026 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_1032 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_1038 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_1044 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_1050 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_1056 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_1062 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_1068 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_1074 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_1080 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_1086 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_1092 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_1098 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_1104 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_1110 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_1116 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_1122 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_1128 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_1134 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_1140 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_1146 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_1152 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_1158 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_1164 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_1170 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_1176 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_1182 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_1188 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_1194 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_1200 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_1206 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_1212 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_1218 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_1224 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_1230 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_1236 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_1242 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_1248 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_1254 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_1260 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_1266 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_1272 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_1278 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_1284 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_1290 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_1296 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_1302 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_1308 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_1314 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_1320 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_1326 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_1332 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_1338 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_1344 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_1350 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_1356 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_1362 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_1368 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_1374 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_1380 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_1386 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_1392 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_1398 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_1404 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_1410 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_1416 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_1422 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_1428 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_1434 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_1440 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_1446 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_1452 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_1458 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_1464 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_1470 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_1476 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_1482 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_1488 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_1494 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_1500 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_1506 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_1512 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_1518 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_1524 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_1530 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_140 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF64BImode:
      if (!register_operand (operands[0], E_RVVMF64BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || !((
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4007 (insn, operands);

    case E_RVVMF32BImode:
      if (!register_operand (operands[0], E_RVVMF32BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4008 (insn, operands);

    case E_RVVMF16BImode:
      if (!register_operand (operands[0], E_RVVMF16BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4009 (insn, operands);

    case E_RVVMF8BImode:
      if (!register_operand (operands[0], E_RVVMF8BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4010 (insn, operands);

    case E_RVVMF4BImode:
      if (!register_operand (operands[0], E_RVVMF4BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4011 (insn, operands);

    case E_RVVMF2BImode:
      if (!register_operand (operands[0], E_RVVMF2BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2BImode
          || !register_operand (operands[1], E_RVVMF2BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4012 (insn, operands);

    case E_RVVM1BImode:
      if (!register_operand (operands[0], E_RVVM1BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1BImode
          || !register_operand (operands[1], E_RVVM1BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4013 (insn, operands);

    case E_V1BImode:
      if (!register_operand (operands[0], E_V1BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1BImode
          || !register_operand (operands[1], E_V1BImode)
          || !((
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4014 (insn, operands);

    case E_V2BImode:
      if (!register_operand (operands[0], E_V2BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2BImode
          || !register_operand (operands[1], E_V2BImode)
          || !((
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4015 (insn, operands);

    case E_V4BImode:
      if (!register_operand (operands[0], E_V4BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BImode
          || !register_operand (operands[1], E_V4BImode)
          || !((
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4016 (insn, operands);

    case E_V8BImode:
      if (!register_operand (operands[0], E_V8BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BImode
          || !register_operand (operands[1], E_V8BImode)
          || !((
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4017 (insn, operands);

    case E_V16BImode:
      if (!register_operand (operands[0], E_V16BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16BImode
          || !register_operand (operands[1], E_V16BImode)
          || !((
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4018 (insn, operands);

    case E_V32BImode:
      if (!register_operand (operands[0], E_V32BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32BImode
          || !register_operand (operands[1], E_V32BImode)
          || !((
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4019 (insn, operands);

    case E_V64BImode:
      if (!register_operand (operands[0], E_V64BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64BImode
          || !register_operand (operands[1], E_V64BImode)
          || !((
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4020 (insn, operands);

    case E_V128BImode:
      if (!register_operand (operands[0], E_V128BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128BImode
          || !register_operand (operands[1], E_V128BImode)
          || !((
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4021 (insn, operands);

    case E_V256BImode:
      if (!register_operand (operands[0], E_V256BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256BImode
          || !register_operand (operands[1], E_V256BImode)
          || !((
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4022 (insn, operands);

    case E_V512BImode:
      if (!register_operand (operands[0], E_V512BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512BImode
          || !register_operand (operands[1], E_V512BImode)
          || !((
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4023 (insn, operands);

    case E_V1024BImode:
      if (!register_operand (operands[0], E_V1024BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024BImode
          || !register_operand (operands[1], E_V1024BImode)
          || !((
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4024 (insn, operands);

    case E_V2048BImode:
      if (!register_operand (operands[0], E_V2048BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048BImode
          || !register_operand (operands[1], E_V2048BImode)
          || !((
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4025 (insn, operands);

    case E_V4096BImode:
      if (!register_operand (operands[0], E_V4096BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096BImode
          || !register_operand (operands[1], E_V4096BImode)
          || !((
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 562 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4026 (insn, operands);

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4946 (insn, operands);

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4948 (insn, operands);

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4950 (insn, operands);

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4952 (insn, operands);

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4954 (insn, operands);

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4956 (insn, operands);

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4958 (insn, operands);

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4960 (insn, operands);

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4962 (insn, operands);

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4964 (insn, operands);

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4966 (insn, operands);

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4968 (insn, operands);

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4970 (insn, operands);

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4972 (insn, operands);

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4974 (insn, operands);

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4976 (insn, operands);

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4978 (insn, operands);

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4980 (insn, operands);

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4982 (insn, operands);

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4984 (insn, operands);

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4986 (insn, operands);

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4988 (insn, operands);

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4990 (insn, operands);

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4992 (insn, operands);

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4994 (insn, operands);

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4996 (insn, operands);

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4998 (insn, operands);

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5000 (insn, operands);

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5002 (insn, operands);

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5004 (insn, operands);

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5006 (insn, operands);

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5008 (insn, operands);

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5010 (insn, operands);

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5012 (insn, operands);

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5014 (insn, operands);

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5016 (insn, operands);

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5018 (insn, operands);

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5020 (insn, operands);

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5022 (insn, operands);

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5024 (insn, operands);

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5026 (insn, operands);

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5028 (insn, operands);

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5030 (insn, operands);

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5032 (insn, operands);

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5034 (insn, operands);

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5036 (insn, operands);

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5038 (insn, operands);

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5040 (insn, operands);

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5042 (insn, operands);

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5044 (insn, operands);

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5046 (insn, operands);

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5048 (insn, operands);

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5050 (insn, operands);

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5052 (insn, operands);

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5054 (insn, operands);

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5056 (insn, operands);

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5058 (insn, operands);

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5060 (insn, operands);

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5062 (insn, operands);

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5064 (insn, operands);

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5066 (insn, operands);

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5068 (insn, operands);

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5070 (insn, operands);

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5072 (insn, operands);

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5074 (insn, operands);

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5076 (insn, operands);

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5078 (insn, operands);

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5080 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_148 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern372 (x2, 
E_SImode) != 0
                  || !
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))
                return NULL;
              return gen_split_1 (insn, operands);

            case E_DImode:
              if (pattern372 (x2, 
E_DImode) != 0
                  || !
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))
                return NULL;
              return gen_split_2 (insn, operands);

            default:
              return NULL;
            }

        case CONST_VECTOR:
        case REG:
        case SUBREG:
          return split_1 (x1, insn);

        default:
          return NULL;
        }

    case PLUS:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != AND
          || GET_MODE (x5) != E_DImode)
        return NULL;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != ASHIFT
          || GET_MODE (x6) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return NULL;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!imm123_operand (operands[2], E_QImode))
        return NULL;
      x9 = XEXP (x5, 1);
      operands[3] = x9;
      if (!consecutive_bits32_operand (operands[3], E_VOIDmode))
        return NULL;
      x10 = XEXP (x3, 1);
      operands[4] = x10;
      if (!register_operand (operands[4], E_DImode))
        return NULL;
      x4 = XEXP (x2, 1);
      operands[5] = x4;
      if (!immediate_operand (operands[5], E_VOIDmode)
          || !
#line 197 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA))
        return NULL;
      return gen_split_111 (insn, operands);

    case MULT:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          x4 = XEXP (x2, 1);
          operands[3] = x4;
          return split_2 (x1, insn);

        case SIGN_EXTEND:
          return split_4 (x1, insn);

        case ZERO_EXTEND:
          return split_5 (x1, insn);

        case FLOAT_EXTEND:
          switch (pattern139 (x2))
            {
            case 0:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9458 (insn, operands);

            case 1:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9459 (insn, operands);

            case 2:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9460 (insn, operands);

            case 3:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9461 (insn, operands);

            case 4:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9462 (insn, operands);

            case 5:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9463 (insn, operands);

            case 6:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9464 (insn, operands);

            case 7:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9465 (insn, operands);

            case 8:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9466 (insn, operands);

            case 9:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9467 (insn, operands);

            case 10:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9468 (insn, operands);

            case 11:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9469 (insn, operands);

            case 12:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9470 (insn, operands);

            case 13:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9471 (insn, operands);

            case 14:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9472 (insn, operands);

            case 15:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9473 (insn, operands);

            case 16:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9474 (insn, operands);

            case 17:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9475 (insn, operands);

            case 18:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9476 (insn, operands);

            case 19:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9477 (insn, operands);

            case 20:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9478 (insn, operands);

            case 21:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9479 (insn, operands);

            case 22:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9480 (insn, operands);

            case 23:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9481 (insn, operands);

            case 24:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9482 (insn, operands);

            case 25:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9483 (insn, operands);

            case 26:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9484 (insn, operands);

            case 27:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9485 (insn, operands);

            case 28:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9486 (insn, operands);

            case 29:
              if (!((
#line 1004 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1006 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9487 (insn, operands);

            case 30:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9488 (insn, operands);

            case 31:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9489 (insn, operands);

            case 32:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9490 (insn, operands);

            case 33:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9491 (insn, operands);

            case 34:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9492 (insn, operands);

            case 35:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9493 (insn, operands);

            case 36:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9494 (insn, operands);

            case 37:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9495 (insn, operands);

            case 38:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9496 (insn, operands);

            case 39:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9497 (insn, operands);

            case 40:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9498 (insn, operands);

            case 41:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9499 (insn, operands);

            case 42:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9500 (insn, operands);

            case 43:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9501 (insn, operands);

            case 44:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9502 (insn, operands);

            case 45:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9503 (insn, operands);

            case 46:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9504 (insn, operands);

            case 47:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9505 (insn, operands);

            case 48:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9506 (insn, operands);

            case 49:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9507 (insn, operands);

            case 50:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9508 (insn, operands);

            case 51:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9509 (insn, operands);

            case 52:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9510 (insn, operands);

            case 53:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9511 (insn, operands);

            case 54:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9512 (insn, operands);

            case 55:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9513 (insn, operands);

            case 56:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9514 (insn, operands);

            case 57:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9515 (insn, operands);

            case 58:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9516 (insn, operands);

            case 59:
              if (!((
#line 1028 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1030 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9517 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      return split_7 (x1, insn);

    case ZERO_EXTEND:
      return split_6 (x1, insn);

    case FLOAT_EXTEND:
      switch (pattern131 (x2))
        {
        case 0:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8804 (insn, operands);

        case 1:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8807 (insn, operands);

        case 2:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8810 (insn, operands);

        case 3:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8813 (insn, operands);

        case 4:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8816 (insn, operands);

        case 5:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8819 (insn, operands);

        case 6:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8822 (insn, operands);

        case 7:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8825 (insn, operands);

        case 8:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8828 (insn, operands);

        case 9:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8831 (insn, operands);

        case 10:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8834 (insn, operands);

        case 11:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8837 (insn, operands);

        case 12:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8840 (insn, operands);

        case 13:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8843 (insn, operands);

        case 14:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8846 (insn, operands);

        case 15:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8849 (insn, operands);

        case 16:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8852 (insn, operands);

        case 17:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8855 (insn, operands);

        case 18:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8858 (insn, operands);

        case 19:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8861 (insn, operands);

        case 20:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8864 (insn, operands);

        case 21:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8867 (insn, operands);

        case 22:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8870 (insn, operands);

        case 23:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8873 (insn, operands);

        case 24:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8876 (insn, operands);

        case 25:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8879 (insn, operands);

        case 26:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8882 (insn, operands);

        case 27:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8885 (insn, operands);

        case 28:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8888 (insn, operands);

        case 29:
          if (!((
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 731 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8891 (insn, operands);

        case 30:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8894 (insn, operands);

        case 31:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8895 (insn, operands);

        case 32:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8896 (insn, operands);

        case 33:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8897 (insn, operands);

        case 34:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8898 (insn, operands);

        case 35:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8899 (insn, operands);

        case 36:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8900 (insn, operands);

        case 37:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8901 (insn, operands);

        case 38:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8902 (insn, operands);

        case 39:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8903 (insn, operands);

        case 40:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8904 (insn, operands);

        case 41:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8905 (insn, operands);

        case 42:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8906 (insn, operands);

        case 43:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8907 (insn, operands);

        case 44:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8908 (insn, operands);

        case 45:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8909 (insn, operands);

        case 46:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8910 (insn, operands);

        case 47:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8911 (insn, operands);

        case 48:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8912 (insn, operands);

        case 49:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8913 (insn, operands);

        case 50:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8914 (insn, operands);

        case 51:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8915 (insn, operands);

        case 52:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8916 (insn, operands);

        case 53:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8917 (insn, operands);

        case 54:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8918 (insn, operands);

        case 55:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8919 (insn, operands);

        case 56:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8920 (insn, operands);

        case 57:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8921 (insn, operands);

        case 58:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8922 (insn, operands);

        case 59:
          if (!((
#line 746 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 748 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8923 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_157 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern123 (x2))
    {
    case 0:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2592 (insn, operands);

    case 1:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2606 (insn, operands);

    case 2:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2620 (insn, operands);

    case 3:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2634 (insn, operands);

    case 4:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2648 (insn, operands);

    case 5:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2662 (insn, operands);

    case 6:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2676 (insn, operands);

    case 7:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2690 (insn, operands);

    case 8:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2704 (insn, operands);

    case 9:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2718 (insn, operands);

    case 10:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2732 (insn, operands);

    case 11:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2746 (insn, operands);

    case 12:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2760 (insn, operands);

    case 13:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2774 (insn, operands);

    case 14:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2788 (insn, operands);

    case 15:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2802 (insn, operands);

    case 16:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2816 (insn, operands);

    case 17:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2830 (insn, operands);

    case 18:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2844 (insn, operands);

    case 19:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2858 (insn, operands);

    case 20:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2872 (insn, operands);

    case 21:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2886 (insn, operands);

    case 22:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2900 (insn, operands);

    case 23:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2914 (insn, operands);

    case 24:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2928 (insn, operands);

    case 25:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2942 (insn, operands);

    case 26:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2956 (insn, operands);

    case 27:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2970 (insn, operands);

    case 28:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2984 (insn, operands);

    case 29:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2998 (insn, operands);

    case 30:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3012 (insn, operands);

    case 31:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3026 (insn, operands);

    case 32:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3040 (insn, operands);

    case 33:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3054 (insn, operands);

    case 34:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3068 (insn, operands);

    case 35:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3082 (insn, operands);

    case 36:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3096 (insn, operands);

    case 37:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3110 (insn, operands);

    case 38:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3124 (insn, operands);

    case 39:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3138 (insn, operands);

    case 40:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3152 (insn, operands);

    case 41:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3166 (insn, operands);

    case 42:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3180 (insn, operands);

    case 43:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3194 (insn, operands);

    case 44:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3208 (insn, operands);

    case 45:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3222 (insn, operands);

    case 46:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3236 (insn, operands);

    case 47:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3250 (insn, operands);

    case 48:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3264 (insn, operands);

    case 49:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3278 (insn, operands);

    case 50:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3292 (insn, operands);

    case 51:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3306 (insn, operands);

    case 52:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3320 (insn, operands);

    case 53:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3334 (insn, operands);

    case 54:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3348 (insn, operands);

    case 55:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3362 (insn, operands);

    case 56:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3376 (insn, operands);

    case 57:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3390 (insn, operands);

    case 58:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3404 (insn, operands);

    case 59:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3418 (insn, operands);

    case 60:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3432 (insn, operands);

    case 61:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3446 (insn, operands);

    case 62:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3460 (insn, operands);

    case 63:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3474 (insn, operands);

    case 64:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3488 (insn, operands);

    case 65:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3502 (insn, operands);

    case 66:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3516 (insn, operands);

    case 67:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3530 (insn, operands);

    case 68:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5745 (insn, operands);

    case 69:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5747 (insn, operands);

    case 70:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5749 (insn, operands);

    case 71:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5751 (insn, operands);

    case 72:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5753 (insn, operands);

    case 73:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5755 (insn, operands);

    case 74:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5757 (insn, operands);

    case 75:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5759 (insn, operands);

    case 76:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5761 (insn, operands);

    case 77:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5763 (insn, operands);

    case 78:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5765 (insn, operands);

    case 79:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5767 (insn, operands);

    case 80:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5769 (insn, operands);

    case 81:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5771 (insn, operands);

    case 82:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5773 (insn, operands);

    case 83:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5775 (insn, operands);

    case 84:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5777 (insn, operands);

    case 85:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5779 (insn, operands);

    case 86:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5781 (insn, operands);

    case 87:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5783 (insn, operands);

    case 88:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5785 (insn, operands);

    case 89:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5787 (insn, operands);

    case 90:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5789 (insn, operands);

    case 91:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5791 (insn, operands);

    case 92:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5793 (insn, operands);

    case 93:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5795 (insn, operands);

    case 94:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5797 (insn, operands);

    case 95:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5799 (insn, operands);

    case 96:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5801 (insn, operands);

    case 97:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5803 (insn, operands);

    case 98:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5805 (insn, operands);

    case 99:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5807 (insn, operands);

    case 100:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5809 (insn, operands);

    case 101:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5811 (insn, operands);

    case 102:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5813 (insn, operands);

    case 103:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5815 (insn, operands);

    case 104:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5817 (insn, operands);

    case 105:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5819 (insn, operands);

    case 106:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5821 (insn, operands);

    case 107:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5823 (insn, operands);

    case 108:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5825 (insn, operands);

    case 109:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5827 (insn, operands);

    case 110:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5829 (insn, operands);

    case 111:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5831 (insn, operands);

    case 112:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5833 (insn, operands);

    case 113:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5835 (insn, operands);

    case 114:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5837 (insn, operands);

    case 115:
      if (!((
#line 1561 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1563 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5839 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_170 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 5
      || XINT (x3, 1) != 91)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 5
      || XINT (x4, 1) != 169)
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || pattern324 (x3) != 0)
    return NULL;
  switch (pattern451 (x2))
    {
    case 0:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10065 (insn, operands);

    case 1:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10067 (insn, operands);

    case 2:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10069 (insn, operands);

    case 3:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10071 (insn, operands);

    case 4:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10073 (insn, operands);

    case 5:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10075 (insn, operands);

    case 6:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10077 (insn, operands);

    case 7:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10079 (insn, operands);

    case 8:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10081 (insn, operands);

    case 9:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10083 (insn, operands);

    case 10:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V8BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10085 (insn, operands);

    case 11:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V16BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10087 (insn, operands);

    case 12:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V32BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10089 (insn, operands);

    case 13:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V64BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10091 (insn, operands);

    case 14:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V128BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10093 (insn, operands);

    case 15:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V256BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10095 (insn, operands);

    case 16:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V512BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10097 (insn, operands);

    case 17:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1024BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10099 (insn, operands);

    case 18:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2048BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10101 (insn, operands);

    case 19:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4096BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10103 (insn, operands);

    case 20:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10066 (insn, operands);

    case 21:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10068 (insn, operands);

    case 22:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10070 (insn, operands);

    case 23:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10072 (insn, operands);

    case 24:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10074 (insn, operands);

    case 25:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10076 (insn, operands);

    case 26:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10078 (insn, operands);

    case 27:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10080 (insn, operands);

    case 28:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10082 (insn, operands);

    case 29:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10084 (insn, operands);

    case 30:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V8BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10086 (insn, operands);

    case 31:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V16BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10088 (insn, operands);

    case 32:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V32BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10090 (insn, operands);

    case 33:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V64BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10092 (insn, operands);

    case 34:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V128BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10094 (insn, operands);

    case 35:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V256BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10096 (insn, operands);

    case 36:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V512BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10098 (insn, operands);

    case 37:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1024BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10100 (insn, operands);

    case 38:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2048BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10102 (insn, operands);

    case 39:
      if (!((
#line 1465 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4096BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))) && 
#line 1469 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10104 (insn, operands);

    default:
      return NULL;
    }
}
